/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(W){for(var t=[],r=0,y=W.length;r<y;r++)t[r]=se[W[r]];return t};const He=this,Ge=typeof global=="object"?global:{};var be;(function(W){W.global=He;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(be||(be={}));var be;(function(W){class t{constructor(f,j,h){this.type=f,this.detail=j,this.timestamp=h}}W.LoaderEvent=t;class r{constructor(f){this._events=[new t(1,"",f)]}record(f,j){this._events.push(new t(f,j,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=r;class y{record(f,j){}getEvents(){return[]}}y.INSTANCE=new y,W.NullLoaderEventRecorder=y})(be||(be={}));var be;(function(W){class t{static fileUriToFilePath(y,M){if(M=decodeURI(M).replace(/%23/g,"#"),y){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(y,M){return y.length>=M.length&&y.substr(0,M.length)===M}static endsWith(y,M){return y.length>=M.length&&y.substr(y.length-M.length)===M}static containsQueryString(y){return/^[^\#]*\?/gi.test(y)}static isAbsolutePath(y){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(y)}static forEachProperty(y,M){if(y){let f;for(f in y)y.hasOwnProperty(f)&&M(f,y[f])}}static isEmpty(y){let M=!0;return t.forEachProperty(y,()=>{M=!1}),M}static recursiveClone(y){if(!y||typeof y!="object"||y instanceof RegExp||!Array.isArray(y)&&Object.getPrototypeOf(y)!==Object.prototype)return y;let M=Array.isArray(y)?[]:{};return t.forEachProperty(y,(f,j)=>{j&&typeof j=="object"?M[f]=t.recursiveClone(j):M[f]=j}),M}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(y){return t.startsWith(y,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(be||(be={}));var be;(function(W){function t(M){if(M instanceof Error)return M;const f=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(f.stack=M.stack),f}W.ensureError=t;class r{static validateConfigurationOptions(f){function j(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=j),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(W.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,j=null){let h=W.Utilities.recursiveClone(j||{});return W.Utilities.forEachProperty(f,(l,s)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):l==="paths"&&typeof h.paths<"u"?W.Utilities.forEachProperty(s,(c,L)=>h.paths[c]=L):l==="config"&&typeof h.config<"u"?W.Utilities.forEachProperty(s,(c,L)=>h.config[c]=L):h[l]=W.Utilities.recursiveClone(s)}),r.validateConfigurationOptions(h)}}W.ConfigurationOptionsUtil=r;class y{constructor(f,j){if(this._env=f,this.options=r.mergeConfigurationOptions(j),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(f,j)=>{Array.isArray(j)?this.sortedPathsRules.push({from:f,to:j}):this.sortedPathsRules.push({from:f,to:[j]})}),this.sortedPathsRules.sort((f,j)=>j.from.length-f.from.length)}cloneAndMerge(f){return new y(this._env,r.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let j;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(j=this.sortedPathsRules[h],W.Utilities.startsWith(f,j.from)){let s=[];for(let c=0,L=j.to.length;c<L;c++)s.push(j.to[c]+f.substr(j.from.length));return s}return[f]}_addUrlArgsToUrl(f){return W.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let j=0,h=f.length;j<h;j++)f[j]=this._addUrlArgsToUrl(f[j]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let j=f,h;if(!W.Utilities.endsWith(j,".js")&&!W.Utilities.isAbsolutePath(j)){h=this._applyPaths(j);for(let l=0,s=h.length;l<s;l++)this.isBuild()&&h[l]==="empty:"||(W.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!W.Utilities.endsWith(h[l],".js")&&!W.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!W.Utilities.endsWith(j,".js")&&!W.Utilities.containsQueryString(j)&&(j=j+".js"),h=[j];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let j=f;return W.Utilities.isAbsolutePath(j)||(j=this._applyPaths(j)[0],W.Utilities.isAbsolutePath(j)||(j=this.options.baseUrl+j)),this._addUrlArgsIfNecessaryToUrl(j)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}W.Configuration=y})(be||(be={}));var be;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,c,L,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new r:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new r;let m={callback:L,errorback:g};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(s,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(s){let c=this._callbackMap[s];delete this._callbackMap[s];for(let L=0;L<c.length;L++)c[L].callback()}triggerErrorback(s,c){let L=this._callbackMap[s];delete this._callbackMap[s];for(let g=0;g<L.length;g++)L[g].errorback(c)}}class r{attachListeners(s,c,L){let g=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=N=>{g(),c()},e=N=>{g(),L(N)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,c,L,g){if(/^node\|/.test(c)){let m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),N=c.split("|"),E=null;try{E=e(N[1])}catch(p){g(p);return}s.enqueueDefineAnonymousModule([],()=>E),L()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,L,g);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:N}=s.getConfig().getOptionsLiteral();N&&m.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(m)}}}function y(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=y(s)),this._cachedCanUseEval}load(s,c,L,g){if(/^node\|/.test(c)){const m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),N=c.split("|");let E=null;try{E=e(N[1])}catch(p){g(p);return}s.enqueueDefineAnonymousModule([],function(){return E}),L()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(c).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",N)):new Function(N)).call(self),L()}).then(void 0,g);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),L()}catch(N){g(N)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,c){const{nodeCachedData:L}=c.getConfig().getOptionsLiteral();if(!L||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=s("module");function e(N){const E=N.constructor;let p=function($){try{return N.require($)}finally{}};return p.resolve=function($,o){return E._resolveFilename($,N,!1,o)},p.resolve.paths=function($){return E._resolveLookupPaths($,N)},p.main=process.mainModule,p.extensions=E._extensions,p.cache=E._cache,p}m.prototype._compile=function(N,E){const p=m.wrap(N.replace(/^#!.*/,"")),w=c.getRecorder(),$=g._getCachedDataPath(L,E),o={filename:E};let u;try{const R=g._fs.readFileSync($);u=R.slice(0,16),o.cachedData=R.slice(16),w.record(60,$)}catch{w.record(61,$)}const i=new g._vm.Script(p,o),a=i.runInThisContext(o),b=g._path.dirname(E),d=e(this),v=[this.exports,d,this,E,b,process,Ge,Buffer],A=a.apply(this.exports,v);return g._handleCachedData(i,p,$,!o.cachedData,c),g._verifyCachedData(i,p,$,u,c),A}}load(s,c,L,g){const m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),N=m.nodeInstrumenter||function(p){return p};this._init(e),this._initNodeRequire(e,s);let E=s.getRecorder();if(/^node\|/.test(c)){let p=c.split("|"),w=null;try{w=e(p[1])}catch($){g($);return}s.enqueueDefineAnonymousModule([],()=>w),L()}else{c=W.Utilities.fileUriToFilePath(this._env.isWindows,c);const p=this._path.normalize(c),w=this._getElectronRendererScriptPathOrUri(p),$=!!m.nodeCachedData,o=$?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(p,o,E,(u,i,a,b)=>{if(u){g(u);return}let d;i.charCodeAt(0)===f._BOM?d=f._PREFIX+i.substring(1)+f._SUFFIX:d=f._PREFIX+i+f._SUFFIX,d=N(d,p);const v={filename:w,cachedData:a},A=this._createAndEvalScript(s,d,v,L,g);this._handleCachedData(A,d,o,$&&!a,s),this._verifyCachedData(A,d,o,b,s)})}}_createAndEvalScript(s,c,L,g,m){const e=s.getRecorder();e.record(31,L.filename);const N=new this._vm.Script(c,L),E=N.runInThisContext(L),p=s.getGlobalAMDDefineFunc();let w=!1;const $=function(){return w=!0,p.apply(null,arguments)};return $.amd=p.amd,E.call(W.global,s.getGlobalAMDRequireFunc(),$,L.filename,this._path.dirname(L.filename)),e.record(32,L.filename),w?g():m(new Error(`Didn't receive define call in ${L.filename}!`)),N}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let c=s.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,c){const L=this._crypto.createHash("md5").update(c,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(c).replace(/\.js$/,"");return this._path.join(s.path,`${g}-${L}.code`)}_handleCachedData(s,c,L,g,m){s.cachedDataRejected?this._fs.unlink(L,e=>{m.getRecorder().record(62,L),this._createAndWriteCachedData(s,c,L,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(s,c,L,m)}_createAndWriteCachedData(s,c,L,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,E;const p=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(c,"utf8").digest());const w=s.createCachedData();if(!(w.length===0||w.length===e||N>=5)){if(w.length<e){p();return}e=w.length,this._fs.writeFile(L,Buffer.concat([E,w]),$=>{$&&g.getConfig().onError($),g.getRecorder().record(63,L),p()})}},m*Math.pow(4,N++))};p()}_readSourceAndCachedData(s,c,L,g){if(!c)this._fs.readFile(s,{encoding:"utf8"},g);else{let m,e,N,E=2;const p=w=>{w?g(w):--E===0&&g(void 0,m,e,N)};this._fs.readFile(s,{encoding:"utf8"},(w,$)=>{m=$,p(w)}),this._fs.readFile(c,(w,$)=>{!w&&$&&$.length>0?(N=$.slice(0,16),e=$.slice(16),L.record(60,c)):L.record(61,c),p()})}}_verifyCachedData(s,c,L,g,m){g&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${L}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(L,N=>{N&&m.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function j(l,s){if(s.__$__isRecorded)return s;const c=function(g){l.record(33,g);try{return s(g)}finally{l.record(34,g)}};return c.__$__isRecorded=!0,c}W.ensureRecordedNodeRequire=j;function h(l){return new t(l)}W.createScriptLoader=h})(be||(be={}));var be;(function(W){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,c;for(c=/\/\.\//;c.test(s);)s=s.replace(c,"/");for(s=s.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(s);)s=s.replace(c,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class r{constructor(l,s,c,L,g,m){this.id=l,this.strId=s,this.dependencies=c,this._callback=L,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(W.global,s),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(l,s,c,L){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(c,L):{returnedValue:c.apply(W.global,L),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,c,L){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=r._invokeFactory(s,this.strId,this._callback,c);g=m.producedError,l.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=W.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=L(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}W.Module=r;class y{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class M{constructor(l){this.id=l}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),W.RegularDependency=M;class f{constructor(l,s,c){this.id=l,this.pluginId=s,this.pluginParam=c}}W.PluginDependency=f;class j{constructor(l,s,c,L,g=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=g,this._defineFunc=c,this._requireFunc=L,this._moduleIdProvider=new y,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new j(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let c=m=>m.replace(/\\/g,"/"),L=c(l),g=s.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],E=e[2],p=e[3],w=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(w),N=c(N),N===L){let $={line:parseInt(E,10),col:parseInt(p,10)};return $.line===1&&($.col-=53),$}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let c=0,L=this._modules2.length;c<L;c++){let g=this._modules2[c];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,N=this._buildInfoDependencies[g.id];l[s++]={id:g.strId,path:m,defineLocation:m&&e?j._findRelevantLocationInStack(m,e):null,dependencies:N,shim:null,exports:g.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:l,callback:s}}defineModule(l,s,c,L,g,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let N=new r(e,l,this._normalizeDependencies(s,m),c,L,m);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(N.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(N)}_normalizeDependency(l,s){if(l==="exports")return M.EXPORTS;if(l==="module")return M.MODULE;if(l==="require")return M.REQUIRE;let c=l.indexOf("!");if(c>=0){let L=s.resolveModule(l.substr(0,c)),g=s.resolveModule(l.substr(c+1)),m=this._moduleIdProvider.getModuleId(L+"!"+g),e=this._moduleIdProvider.getModuleId(L);return new f(m,e,g)}return new M(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let c=[],L=0;for(let g=0,m=l.length;g<m;g++)c[L++]=this._normalizeDependency(l[g],s);return c}_relativeRequire(l,s,c,L){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(W.Utilities.generateAnonymousModule(),s,c,L,null,l)}synchronousRequire(l,s=new t(l)){let c=this._normalizeDependency(l,s),L=this._modules2[c.id];if(!L)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!L.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(L.error)throw L.error;return L.exports}configure(l,s){let c=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let c=this._moduleIdProvider.getStrModuleId(l),L=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=W.ensureError(s);return g.phase="loading",g.moduleId=c,g.neededBy=L,g}_onLoadError(l,s){const c=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new r(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let L=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)L[e]=!1;let g=!1,m=[];for(m.push(l),L[l]=!0;m.length>0;){let e=m.shift(),N=this._modules2[e];N&&(g=N.onDependencyError(c)||g);let E=this._inverseDependencies2[e];if(E)for(let p=0,w=E.length;p<w;p++){let $=E[p];L[$]||(m.push($),L[$]=!0)}}g||this._config.onError(c)}_hasDependencyPath(l,s){let c=this._modules2[l];if(!c)return!1;let L=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)L[m]=!1;let g=[];for(g.push(c),L[l]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let N=0,E=e.length;N<E;N++){let p=e[N];if(p.id===s)return!0;let w=this._modules2[p.id];w&&!L[p.id]&&(L[p.id]=!0,g.push(w))}}return!1}_findCyclePath(l,s,c){if(l===s||c===50)return[l];let L=this._modules2[l];if(!L)return null;let g=L.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let N=this._findCyclePath(g[m].id,s,c+1);if(N!==null)return N.push(l),N}return null}_createRequire(l){let s=(c,L,g)=>this._relativeRequire(l,c,L,g);return s.toUrl=c=>this._config.requireToUrl(l.resolveModule(c)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(c,L=!1)=>{this.configure(c,L)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),c=this._config.moduleIdToPaths(s),L=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||L.test(s))&&c.push("node|"+s);let g=-1,m=e=>{if(g++,g>=c.length)this._onLoadError(l,e);else{let N=c[g],E=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[l]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}E.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=N),E.record(11,N),this._onLoad(l)},p=>{E.record(12,N),m(p)})}};m(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let c=L=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],L,null,null)};c.error=L=>{this._config.onError(this._createLoadError(s.id,L))},l.load(s.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let c=0,L=s.length;c<L;c++){let g=s[c];if(g===M.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(g===M.MODULE){l.unresolvedDependenciesCount--;continue}if(g===M.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,l.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(l.id),g instanceof f){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let N=this._inversePluginDependencies2.get(g.pluginId);N||(N=[],this._inversePluginDependencies2.set(g.pluginId,N)),N.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let c=l.dependencies,L=[];if(c)for(let N=0,E=c.length;N<E;N++){let p=c[N];if(p===M.EXPORTS){L[N]=l.exports;continue}if(p===M.MODULE){L[N]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(p===M.REQUIRE){L[N]=this._createRequire(l.moduleIdResolver);continue}let w=this._modules2[p.id];if(w){L[N]=w.exports;continue}L[N]=null}const g=N=>(this._inverseDependencies2[N]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));l.complete(s,this._config,L,g);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let N=0,E=m.length;N<E;N++){let p=m[N],w=this._modules2[p];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let N=0,E=e.length;N<E;N++)this._loadPluginDependency(l.exports,e[N])}}}W.ModuleManager=j})(be||(be={}));var ie,be;(function(W){const t=new W.Environment;let r=null;const y=function(h,l,s){typeof h!="string"&&(s=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),h?r.defineModule(h,l,s,null,null):r.enqueueDefineAnonymousModule(l,s)};y.amd={jQuery:!0};const M=function(h,l=!1){r.configure(h,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=M,f.getConfig=function(){return r.getConfig().getOptionsLiteral()},f.reset=function(){r=r.reset()},f.getBuildInfo=function(){return r.getBuildInfo()},f.getStats=function(){return r.getLoaderEvents()},f.define=y;function j(){if(typeof W.global.require<"u"||typeof require<"u"){const h=W.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=W.ensureRecordedNodeRequire(r.getRecorder(),h);W.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(W.global.define=y),W.global.require=f)}W.init=j,(typeof W.global.define!="function"||!W.global.define.amd)&&(r=new W.ModuleManager(t,W.createScriptLoader(t),y,f,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&f.config(W.global.require),ie=function(){return y.apply(null,arguments)},ie.amd=y.amd,typeof doNotInitLoader>"u"&&j())})(be||(be={})),ie(se[72],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=r;function r(h,l,s,c){if(c=c||{},(c["vs/css"]||{}).disabled){s({});return}const g=l.toUrl(h+".css");y(h,g,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+g+".")})}function y(h,l,s,c){if(M(h,l)){s();return}f(h,l,s,c)}function M(h,l){const s=window.document.getElementsByTagName("link");for(let c=0,L=s.length;c<L;c++){const g=s[c].getAttribute("data-name"),m=s[c].getAttribute("href");if(g===h||m===l)return!0}return!1}function f(h,l,s,c){const L=document.createElement("link");L.setAttribute("rel","stylesheet"),L.setAttribute("type","text/css"),L.setAttribute("data-name",h),j(h,L,s,c),L.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(L)}function j(h,l,s,c){const L=()=>{l.removeEventListener("load",g),l.removeEventListener("error",m)},g=e=>{L(),s()},m=e=>{L(),c(e)};l.addEventListener("load",g),l.addEventListener("error",m)}}),ie("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=L,t.getConfiguredDefaultLocale=g,t.setPseudoTranslation=m,t.create=e,t.load=N;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const y="i-default";function M(E,p){let w;return p.length===0?w=E:w=E.replace(/\{(\d+)\}/g,($,o)=>{const u=o[0],i=p[u];let a=$;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),r&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function f(E,p){let w=E[p];return w||(w=E["*"],w)?w:null}function j(E){return E.charAt(E.length-1)==="/"?E:E+"/"}async function h(E,p,w){const $=j(E)+j(p)+"vscode/"+j(w),o=await fetch($);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function l(E){return function(p,w){const $=Array.prototype.slice.call(arguments,2);return M(E[p],$)}}function s(E){return(p,w,...$)=>({value:M(E[p],$),original:M(w,$)})}function c(E,p,...w){return M(p,w)}function L(E,p,...w){const $=M(p,w);return{value:$,original:$}}function g(E){}function m(E){r=E}function e(E,p){return{localize:l(p[E]),localize2:s(p[E]),getConfiguredDefaultLocale:p.getConfiguredDefaultLocale??(w=>{})}}function N(E,p,w,$){const o=$["vs/nls"]??{};if(!E||E.length===0)return w({localize:c,localize2:L,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const u=o.availableLanguages?f(o.availableLanguages,E):null,i=u===null||u===y;let a=".nls";i||(a=a+"."+u);const b=d=>{Array.isArray(d)?(d.localize=l(d),d.localize2=s(d)):(d.localize=l(d[E]),d.localize2=s(d[E])),d.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],w(d)};typeof o.loadBundle=="function"?o.loadBundle(E,u,(d,v)=>{d?p([E+".nls"],b):b(v)}):o.translationServiceUrl&&!i?(async()=>{try{const d=await h(o.translationServiceUrl,u,E);return b(d)}catch(d){if(!u.includes("-"))return console.error(d),p([E+".nls"],b);try{const v=u.split("-")[0],A=await h(o.translationServiceUrl,v,E);return o.availableLanguages??={},o.availableLanguages["*"]=v,b(A)}catch(v){return console.error(v),p([E+".nls"],b)}}})():p([E+a],b,d=>{if(a===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,d),p([E+".nls"],b)})}}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function r(c,L){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(c,L)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(c,L)}catch(g){console.warn(g);return}}const y=r("amdLoader",{createScriptURL:c=>c,createScript:(c,...L)=>{const g=L.slice(0,-1).join(","),m=L.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function M(){try{return(y?globalThis.eval(y.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((c,L)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(y?globalThis.eval(y.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,L);return}y?importScripts(y.createScriptURL(g)):importScripts(g),c()})}function j(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function h(c){f().then(()=>{j(),require([c],function(L){setTimeout(function(){const g=L.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&j();let l=!0;const s=[];globalThis.onmessage=c=>{if(!l){s.push(c);return}l=!1,h(c.data)}}(),ie(se[9],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=r,t.$gb=y,t.$hb=M,t.$ib=f,t.$jb=j,t.$kb=h,t.$lb=l,t.$nb=c,t.$ob=L,t.$pb=g,t.$qb=m,t.$rb=e;function r(N,E){const p=y(N,E);if(p!==-1)return N[p]}function y(N,E,p=N.length-1){for(let w=p;w>=0;w--){const $=N[w];if(E($))return w}return-1}function M(N,E){const p=f(N,E);return p===-1?void 0:N[p]}function f(N,E,p=0,w=N.length){let $=p,o=w;for(;$<o;){const u=Math.floor(($+o)/2);E(N[u])?$=u+1:o=u}return $-1}function j(N,E){const p=h(N,E);return p===N.length?void 0:N[p]}function h(N,E,p=0,w=N.length){let $=p,o=w;for(;$<o;){const u=Math.floor(($+o)/2);E(N[u])?o=u:$=u+1}return $}function l(N,E,p=0,w=N.length){const $=h(N,E,p,w);return $===N.length?-1:$}class s{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(s.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const p=f(this.e,E,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}t.$mb=s;function c(N,E){if(N.length===0)return;let p=N[0];for(let w=1;w<N.length;w++){const $=N[w];E($,p)>0&&(p=$)}return p}function L(N,E){if(N.length===0)return;let p=N[0];for(let w=1;w<N.length;w++){const $=N[w];E($,p)>=0&&(p=$)}return p}function g(N,E){return c(N,(p,w)=>-E(p,w))}function m(N,E){if(N.length===0)return-1;let p=0;for(let w=1;w<N.length;w++){const $=N[w];E($,N[p])>0&&(p=w)}return p}function e(N,E){for(const p of N){const w=E(p);if(w!==void 0)return w}}}),ie(se[35],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=r,t.$L=y,t.$M=M,t.$N=f;function r(j,h){const l=Object.create(null);for(const s of j){const c=h(s);let L=l[c];L||(L=l[c]=[]),L.push(s)}return l}function y(j,h){const l=[],s=[];for(const c of j)h.has(c)||l.push(c);for(const c of h)j.has(c)||s.push(c);return{removed:l,added:s}}function M(j,h){const l=[],s=[];for(const[c,L]of j)h.has(c)||l.push(L);for(const[c,L]of h)j.has(c)||s.push(L);return{removed:l,added:s}}function f(j,h){const l=new Set;for(const s of h)j.has(s)&&l.add(s);return l}}),ie(se[36],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=t.$Et=t.$Dt=t.$Ct=void 0;function r(h,l){const s=Math.pow(10,l);return Math.round(h*s)/s}class y{constructor(l,s,c,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=r(Math.max(Math.min(1,L),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$Ct=y;class M{constructor(l,s,c,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,s),0),3),this.l=r(Math.max(Math.min(1,c),0),3),this.a=r(Math.max(Math.min(1,L),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,c=l.g/255,L=l.b/255,g=l.a,m=Math.max(s,c,L),e=Math.min(s,c,L);let N=0,E=0;const p=(e+m)/2,w=m-e;if(w>0){switch(E=Math.min(p<=.5?w/(2*p):w/(2-2*p),1),m){case s:N=(c-L)/w+(c<L?6:0);break;case c:N=(L-s)/w+2;break;case L:N=(s-c)/w+4;break}N*=60,N=Math.round(N)}return new M(N,E,p,g)}static i(l,s,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?l+(s-l)*6*c:c<1/2?s:c<2/3?l+(s-l)*(2/3-c)*6:l}static toRGBA(l){const s=l.h/360,{s:c,l:L,a:g}=l;let m,e,N;if(c===0)m=e=N=L;else{const E=L<.5?L*(1+c):L+c-L*c,p=2*L-E;m=M.i(p,E,s+1/3),e=M.i(p,E,s),N=M.i(p,E,s-1/3)}return new y(Math.round(m*255),Math.round(e*255),Math.round(N*255),g)}}t.$Dt=M;class f{constructor(l,s,c,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,s),0),3),this.v=r(Math.max(Math.min(1,c),0),3),this.a=r(Math.max(Math.min(1,L),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,c=l.g/255,L=l.b/255,g=Math.max(s,c,L),m=Math.min(s,c,L),e=g-m,N=g===0?0:e/g;let E;return e===0?E=0:g===s?E=((c-L)/e%6+6)%6:g===c?E=(L-s)/e+2:E=(s-c)/e+4,new f(Math.round(E*60),N,g,l.a)}static toRGBA(l){const{h:s,s:c,v:L,a:g}=l,m=L*c,e=m*(1-Math.abs(s/60%2-1)),N=L-m;let[E,p,w]=[0,0,0];return s<60?(E=m,p=e):s<120?(E=e,p=m):s<180?(p=m,w=e):s<240?(p=e,w=m):s<300?(E=e,w=m):s<=360&&(E=m,w=e),E=Math.round((E+N)*255),p=Math.round((p+N)*255),w=Math.round((w+N)*255),new y(E,p,w,g)}}t.$Et=f;class j{static fromHex(l){return j.Format.CSS.parseHex(l)||j.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:M.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof y)this.rgba=l;else if(l instanceof M)this.i=l,this.rgba=M.toRGBA(l);else if(l instanceof f)this.j=l,this.rgba=f.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&y.equals(this.rgba,l.rgba)&&M.equals(this.hsla,l.hsla)&&f.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=j.k(this.rgba.r),s=j.k(this.rgba.g),c=j.k(this.rgba.b),L=.2126*l+.7152*s+.0722*c;return r(L,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s>c?(s+.05)/(c+.05):(c+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s>c}isDarkerThan(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s<c}lighten(l){return new j(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new j(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g:c,b:L,a:g}=this.rgba;return new j(new y(s,c,L,g*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new y(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,c=this.rgba.a,L=s.a,g=c+L*(1-c);if(g<1e-6)return j.transparent;const m=this.rgba.r*c/g+s.r*L*(1-c)/g,e=this.rgba.g*c/g+s.g*L*(1-c)/g,N=this.rgba.b*c/g+s.b*L*(1-c)/g;return new j(new y(m,e,N,g))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g:c,b:L,a:g}=this.rgba;return new j(new y(l.rgba.r-g*(l.rgba.r-s),l.rgba.g-g*(l.rgba.g-c),l.rgba.b-g*(l.rgba.b-L),1))}flatten(...l){const s=l.reduceRight((c,L)=>j.o(L,c));return j.o(this,s)}static o(l,s){const c=1-l.rgba.a;return new j(new y(c*s.rgba.r+l.rgba.a*l.rgba.r,c*s.rgba.g+l.rgba.a*l.rgba.g,c*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(l,s,c){if(l.isLighterThan(s))return l;c=c||.5;const L=l.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(g-L)/g,l.lighten(c)}static getDarkerColor(l,s,c){if(l.isDarkerThan(s))return l;c=c||.5;const L=l.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(L-g)/L,l.darken(c)}static{this.white=new j(new y(255,255,255,1))}static{this.black=new j(new y(0,0,0,1))}static{this.red=new j(new y(255,0,0,1))}static{this.blue=new j(new y(0,0,255,1))}static{this.green=new j(new y(0,255,0,1))}static{this.cyan=new j(new y(0,255,255,1))}static{this.lightgrey=new j(new y(211,211,211,1))}static{this.transparent=new j(new y(0,0,0,0))}}t.$Ft=j,function(h){let l;(function(s){let c;(function(L){function g(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}L.formatRGB=g;function m(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}L.formatRGBA=m;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}L.formatHSL=e;function N(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}L.formatHSLA=N;function E(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function p(i){return`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}`}L.formatHex=p;function w(i,a=!1){return a&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}${E(Math.round(i.rgba.a*255))}`}L.formatHexA=w;function $(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}L.format=$;function o(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const b=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),d=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new h(new y(b,d,v,1))}if(a===9){const b=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),d=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),A=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new h(new y(b,d,v,A/255))}if(a===4){const b=u(i.charCodeAt(1)),d=u(i.charCodeAt(2)),v=u(i.charCodeAt(3));return new h(new y(16*b+b,16*d+d,16*v+v))}if(a===5){const b=u(i.charCodeAt(1)),d=u(i.charCodeAt(2)),v=u(i.charCodeAt(3)),A=u(i.charCodeAt(4));return new h(new y(16*b+b,16*d+d,16*v+v,(16*A+A)/255))}return null}L.parseHex=o;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=s.CSS||(s.CSS={}))})(l=h.Format||(h.Format={}))}(j||(t.$Ft=j={}))}),ie(se[37],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=void 0;class r{constructor(M,f,j,h){this.originalStart=M,this.originalLength=f,this.modifiedStart=j,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$nt=r}),ie(se[3],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=y,t.$Z=M,t.$1=f,t.$2=j,t.$3=h,t.$4=s,t.$6=L,t.$7=g,t.$8=m,t.$0=N;class r{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=r,t.$X=new r;function y(u){t.$X.setUnexpectedErrorHandler(u)}function M(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function f(u){s(u)||t.$X.onUnexpectedError(u)}function j(u){s(u)||t.$X.onUnexpectedExternalError(u)}function h(u){if(u instanceof Error){const{name:i,message:a}=u,b=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:b,noTelemetry:$.isErrorNoTelemetry(u)}}return u}const l="Canceled";function s(u){return u instanceof c?!0:u instanceof Error&&u.name===l&&u.message===l}class c extends Error{constructor(){super(l),this.name=this.message}}t.$5=c;function L(){const u=new Error(l);return u.name=u.message,u}function g(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function N(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=E;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=p;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=w;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const a=new $;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=$;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$cb=o}),ie(se[6],ue([0,1,3,9]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=M,t.$tb=f,t.$ub=j,t.$vb=h,t.$wb=l,t.$xb=s,t.$yb=c,t.$zb=L,t.$Ab=g,t.$Bb=m,t.$Cb=e,t.$Db=N,t.$Eb=E,t.top=p,t.$Gb=w,t.$Hb=o,t.$Ib=u,t.$Jb=i,t.$Kb=a,t.$Lb=b,t.$Mb=d,t.$Nb=v,t.$Ob=A,t.$Pb=R,t.$Qb=P,t.$Rb=D,t.$Sb=S,t.$Tb=I,t.$Ub=F,t.$Vb=q,t.$Wb=x,t.$Xb=z,t.$Yb=Y,t.$Zb=Z,t.$1b=X,t.$2b=G,t.$3b=k,t.$4b=V,t.$5b=ne,t.$6b=le,t.$7b=Ne,t.$8b=pe,t.$$b=Be;function M(O,C=0){return O[O.length-(1+C)]}function f(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}function j(O,C,K=(J,U)=>J===U){if(O===C)return!0;if(!O||!C||O.length!==C.length)return!1;for(let J=0,U=O.length;J<U;J++)if(!K(O[J],C[J]))return!1;return!0}function h(O,C){const K=O.length-1;C<K&&(O[C]=O[K]),O.pop()}function l(O,C,K){return s(O.length,J=>K(O[J],C))}function s(O,C){let K=0,J=O-1;for(;K<=J;){const U=(K+J)/2|0,fe=C(U);if(fe<0)K=U+1;else if(fe>0)J=U-1;else return U}return-(K+1)}function c(O,C,K){if(O=O|0,O>=C.length)throw new TypeError("invalid index");const J=C[Math.floor(C.length*Math.random())],U=[],fe=[],ge=[];for(const te of C){const _=K(te,J);_<0?U.push(te):_>0?fe.push(te):ge.push(te)}return O<U.length?c(O,U,K):O<U.length+ge.length?ge[0]:c(O-(U.length+ge.length),fe,K)}function L(O,C){const K=[];let J;for(const U of O.slice(0).sort(C))!J||C(J[0],U)!==0?(J=[U],K.push(J)):J.push(U);return K}function*g(O,C){let K,J;for(const U of O)J!==void 0&&C(J,U)?K.push(U):(K&&(yield K),K=[U]),J=U;K&&(yield K)}function m(O,C){for(let K=0;K<=O.length;K++)C(K===0?void 0:O[K-1],K===O.length?void 0:O[K])}function e(O,C){for(let K=0;K<O.length;K++)C(K===0?void 0:O[K-1],O[K],K+1===O.length?void 0:O[K+1])}function N(O,C,K){const J=[];function U(te,_,re){if(_===0&&re.length===0)return;const ee=J[J.length-1];ee&&ee.start+ee.deleteCount===te?(ee.deleteCount+=_,ee.toInsert.push(...re)):J.push({start:te,deleteCount:_,toInsert:re})}let fe=0,ge=0;for(;;){if(fe===O.length){U(fe,0,C.slice(ge));break}if(ge===C.length){U(fe,O.length-fe,[]);break}const te=O[fe],_=C[ge],re=K(te,_);re===0?(fe+=1,ge+=1):re<0?(U(fe,1,[]),fe+=1):re>0&&(U(fe,0,[_]),ge+=1)}return J}function E(O,C,K){const J=N(O,C,K),U=[],fe=[];for(const ge of J)U.push(...O.slice(ge.start,ge.start+ge.deleteCount)),fe.push(...ge.toInsert);return{removed:U,added:fe}}function p(O,C,K){if(K===0)return[];const J=O.slice(0,K).sort(C);return $(O,C,J,K,O.length),J}function w(O,C,K,J,U){return K===0?Promise.resolve([]):new Promise((fe,ge)=>{(async()=>{const te=O.length,_=O.slice(0,K).sort(C);for(let re=K,ee=Math.min(K+J,te);re<te;re=ee,ee=Math.min(ee+J,te)){if(re>K&&await new Promise(oe=>setTimeout(oe)),U&&U.isCancellationRequested)throw new r.$5;$(O,C,_,re,ee)}return _})().then(fe,ge)})}function $(O,C,K,J,U){for(const fe=K.length;J<U;J++){const ge=O[J];if(C(ge,K[fe-1])<0){K.pop();const te=(0,y.$kb)(K,_=>C(ge,_)<0);K.splice(te,0,ge)}}}function o(O){return O.filter(C=>!!C)}function u(O){let C=0;for(let K=0;K<O.length;K++)O[K]&&(O[C]=O[K],C+=1);O.length=C}function i(O,C,K){O.splice(K,0,O.splice(C,1)[0])}function a(O){return!Array.isArray(O)||O.length===0}function b(O){return Array.isArray(O)&&O.length>0}function d(O,C=K=>K){const K=new Set;return O.filter(J=>{const U=C(J);return K.has(U)?!1:(K.add(U),!0)})}function v(O){const C=new Set;return K=>{const J=O(K);return C.has(J)?!1:(C.add(J),!0)}}function A(O,C){return O.length>0?O[0]:C}function R(O,C){return O.length>0?O[O.length-1]:C}function P(O,C,K=(J,U)=>J===U){let J=0;for(let U=0,fe=Math.min(O.length,C.length);U<fe&&K(O[U],C[U]);U++)J++;return J}function D(O){return[].concat(...O)}function S(O,C){let K=typeof C=="number"?O:0;typeof C=="number"?K=O:(K=0,C=O);const J=[];if(K<=C)for(let U=K;U<C;U++)J.push(U);else for(let U=K;U>C;U--)J.push(U);return J}function I(O,C,K){return O.reduce((J,U)=>(J[C(U)]=K?K(U):U,J),Object.create(null))}function F(O,C){return O.push(C),()=>q(O,C)}function q(O,C){const K=O.indexOf(C);if(K>-1)return O.splice(K,1),C}function x(O,C,K){const J=O.slice(0,C),U=O.slice(C);return J.concat(K,U)}function z(O,C){let K;if(typeof C=="number"){let J=C;K=()=>{const U=Math.sin(J++)*179426549;return U-Math.floor(U)}}else K=Math.random;for(let J=O.length-1;J>0;J-=1){const U=Math.floor(K()*(J+1)),fe=O[J];O[J]=O[U],O[U]=fe}}function Y(O,C){const K=O.indexOf(C);K>-1&&(O.splice(K,1),O.unshift(C))}function Z(O,C){const K=O.indexOf(C);K>-1&&(O.splice(K,1),O.push(C))}function X(O,C){for(const K of C)O.push(K)}function G(O,C){return Array.isArray(O)?O.map(C):C(O)}function k(O){return Array.isArray(O)?O:[O]}function V(O){return O[Math.floor(Math.random()*O.length)]}function ne(O,C,K){const J=me(O,C),U=O.length,fe=K.length;O.length=U+fe;for(let ge=U-1;ge>=J;ge--)O[ge+fe]=O[ge];for(let ge=0;ge<fe;ge++)O[ge+J]=K[ge]}function le(O,C,K,J){const U=me(O,C);let fe=O.splice(U,K);return fe===void 0&&(fe=[]),ne(O,U,J),fe}function me(O,C){return C<0?Math.max(C+O.length,0):Math.min(C,O.length)}var n;(function(O){function C(fe){return fe<0}O.isLessThan=C;function K(fe){return fe<=0}O.isLessThanOrEqual=K;function J(fe){return fe>0}O.isGreaterThan=J;function U(fe){return fe===0}O.isNeitherLessOrGreaterThan=U,O.greaterThan=1,O.lessThan=-1,O.neitherLessOrGreaterThan=0})(n||(t.CompareResult=n={}));function Ne(O,C){return(K,J)=>C(O(K),O(J))}function pe(...O){return(C,K)=>{for(const J of O){const U=J(C,K);if(!n.isNeitherLessOrGreaterThan(U))return U}return n.neitherLessOrGreaterThan}}const Te=(O,C)=>O-C;t.$9b=Te;const Se=(O,C)=>(0,t.$9b)(O?1:0,C?1:0);t.$0b=Se;function Be(O){return(C,K)=>-O(C,K)}class Fe{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let K=this.c;for(;K<this.g.length&&C(this.g[K]);)K++;const J=K===this.c?null:this.g.slice(this.c,K);return this.c=K,J}takeFromEndWhile(C){let K=this.d;for(;K>=0&&C(this.g[K]);)K--;const J=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const K=this.g.slice(this.c,this.c+C);return this.c+=C,K}}t.$_b=Fe;class Me{static{this.empty=new Me(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(K=>(C(K),!0))}toArray(){const C=[];return this.iterate(K=>(C.push(K),!0)),C}filter(C){return new Me(K=>this.iterate(J=>C(J)?K(J):!0))}map(C){return new Me(K=>this.iterate(J=>K(C(J))))}some(C){let K=!1;return this.iterate(J=>(K=C(J),!K)),K}findFirst(C){let K;return this.iterate(J=>C(J)?(K=J,!1):!0),K}findLast(C){let K;return this.iterate(J=>(C(J)&&(K=J),!0)),K}findLastMaxBy(C){let K,J=!0;return this.iterate(U=>((J||n.isGreaterThan(C(U,K)))&&(J=!1,K=U),!0)),K}}t.$ac=Me;class De{constructor(C){this.c=C}static createSortPermutation(C,K){const J=Array.from(C.keys()).sort((U,fe)=>K(C[U],C[fe]));return new De(J)}apply(C){return C.map((K,J)=>C[this.c[J]])}inverse(){const C=this.c.slice();for(let K=0;K<this.c.length;K++)C[this.c[K]]=K;return new De(C)}}t.$bc=De}),ie(se[13],ue([0,1,3]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=y,t.$cd=M,t.$dd=f,t.$ed=j,t.$fd=h,t.$gd=l;function y(s,c){if(!s)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function M(s,c="Unreachable"){throw new Error(c)}function f(s){if(!s)throw new r.$cb("Assertion Failed")}function j(s){s||(0,r.$1)(new r.$cb("Soft Assertion Failed"))}function h(s){if(!s()){debugger;s(),(0,r.$1)(new r.$cb("Assertion Failed"))}}function l(s,c){let L=0;for(;L<s.length-1;){const g=s[L],m=s[L+1];if(!c(g,m))return!1;L++}return!0}}),ie(se[20],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=r;function r(y,M){const f=this;let j=!1,h;return function(){if(j)return h;if(j=!0,M)try{h=y.apply(f,arguments)}finally{M()}else h=y.apply(f,arguments);return h}}}),ie(se[21],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var r;(function(y){function M(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}y.is=M;const f=Object.freeze([]);function j(){return f}y.empty=j;function*h(i){yield i}y.single=h;function l(i){return M(i)?i:h(i)}y.wrap=l;function s(i){return i||f}y.from=s;function*c(i){for(let a=i.length-1;a>=0;a--)yield i[a]}y.reverse=c;function L(i){return!i||i[Symbol.iterator]().next().done===!0}y.isEmpty=L;function g(i){return i[Symbol.iterator]().next().value}y.first=g;function m(i,a){for(const b of i)if(a(b))return!0;return!1}y.some=m;function e(i,a){for(const b of i)if(a(b))return b}y.find=e;function*N(i,a){for(const b of i)a(b)&&(yield b)}y.filter=N;function*E(i,a){let b=0;for(const d of i)yield a(d,b++)}y.map=E;function*p(...i){for(const a of i)yield*a}y.concat=p;function w(i,a,b){let d=b;for(const v of i)d=a(d,v);return d}y.reduce=w;function*$(i,a,b=i.length){for(a<0&&(a+=i.length),b<0?b+=i.length:b>i.length&&(b=i.length);a<b;a++)yield i[a]}y.slice=$;function o(i,a=Number.POSITIVE_INFINITY){const b=[];if(a===0)return[b,i];const d=i[Symbol.iterator]();for(let v=0;v<a;v++){const A=d.next();if(A.done)return[b,y.empty()];b.push(A.value)}return[b,{[Symbol.iterator](){return d}}]}y.consume=o;async function u(i){const a=[];for await(const b of i)a.push(b);return Promise.resolve(a)}y.asyncToArray=u})(r||(t.Iterable=r={}))}),ie(se[38],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$vr=t.$ur=t.$tr=t.$sr=t.$rr=t.ScanCode=t.KeyCode=void 0,t.$wr=m;var r;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(r||(t.KeyCode=r={}));var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(y||(t.ScanCode=y={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,E){this._keyCodeToStr[N]=E,this._strToKeyCode[E.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const f=new M,j=new M,h=new M;t.$rr=new Array(230),t.$sr={};const l=[],s=Object.create(null),c=Object.create(null);t.$tr={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$ur=[],t.$vr=[];for(let e=0;e<=193;e++)t.$ur[e]=-1;for(let e=0;e<=132;e++)t.$vr[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],E=[],p=[];for(const w of N){const[$,o,u,i,a,b,d,v,A]=w;if(p[o]||(p[o]=!0,l[o]=u,s[u]=o,c[u.toLowerCase()]=o,$&&(t.$ur[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$vr[i]=o))),!E[i]){if(E[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);f.define(i,a),j.define(i,v||a),h.define(i,A||v||a)}b&&(t.$rr[b]=i),d&&(t.$sr[d]=i)}t.$vr[3]=46})();var L;(function(e){function N(u){return f.keyCodeToStr(u)}e.toString=N;function E(u){return f.strToKeyCode(u)}e.fromString=E;function p(u){return j.keyCodeToStr(u)}e.toUserSettingsUS=p;function w(u){return h.keyCodeToStr(u)}e.toUserSettingsGeneral=w;function $(u){return j.strToKeyCode(u)||h.strToKeyCode(u)}e.fromUserSettings=$;function o(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(u)}e.toElectronAccelerator=o})(L||(t.KeyCodeUtils=L={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,N){const E=(N&65535)<<16>>>0;return(e|E)>>>0}}),ie(se[39],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class r{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=r}),ie(se[22],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(f){this.element=f,this.next=r.Undefined,this.prev=r.Undefined}}class y{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let f=this.a;for(;f!==r.Undefined;){const j=f.next;f.prev=r.Undefined,f.next=r.Undefined,f=j}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,j){const h=new r(f);if(this.a===r.Undefined)this.a=h,this.b=h;else if(j){const s=this.b;this.b=h,h.prev=s,s.next=h}else{const s=this.a;this.a=h,h.next=s,s.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==r.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==r.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==r.Undefined&&f.next!==r.Undefined){const j=f.prev;j.next=f.next,f.next.prev=j}else f.prev===r.Undefined&&f.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):f.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):f.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==r.Undefined;)yield f.element,f=f.next}}t.$5c=y}),ie(se[14],ue([0,1]),function(W,t){"use strict";var r,y,M;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=f,t.$zc=j,t.$Ac=h,t.$Ic=w;function f($,o,u){let i=$.get(o);return i===void 0&&(i=u,$.set(o,i)),i}function j($){const o=[];return $.forEach((u,i)=>{o.push(`${i} => ${u}`)}),`Map(${$.size}) {${o.join(", ")}}`}function h($){const o=[];return $.forEach(u=>{o.push(u)}),`Set(${$.size}) {${o.join(", ")}}`}class l{constructor(o,u){this.uri=o,this.value=u}}function s($){return Array.isArray($)}class c{static{this.c=o=>o.toString()}constructor(o,u){if(this[r]="ResourceMap",o instanceof c)this.d=new Map(o.d),this.e=u??c.c;else if(s(o)){this.d=new Map,this.e=u??c.c;for(const[i,a]of o)this.set(i,a)}else this.d=new Map,this.e=o??c.c}set(o,u){return this.d.set(this.e(o),new l(o,u)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,u){typeof u<"u"&&(o=o.bind(u));for(const[i,a]of this.d)o(a.value,a.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}t.$Bc=c;class L{constructor(o,u){this[y]="ResourceSet",!o||typeof o=="function"?this.c=new c(o):(this.c=new c(u),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,u){this.c.forEach((i,a)=>o.call(u,a,a,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=L;var g;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,u=0){const i=this.c.get(o);if(i)return u!==0&&this.l(i,u),i.value}set(o,u,i=0){let a=this.c.get(o);if(a)a.value=u,i!==0&&this.l(a,i);else{switch(a={key:o,value:u,next:void 0,previous:void 0},i){case 0:this.j(a);break;case 1:this.i(a);break;case 2:this.j(a);break;default:this.j(a);break}this.c.set(o,a),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const u=this.c.get(o);if(u)return this.c.delete(o),this.k(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,u){const i=this.g;let a=this.d;for(;a;){if(u?o.bind(u)(a.value,a.key,this):o(a.value,a.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const o=this,u=this.g;let i=this.d;const a={[Symbol.iterator](){return a},next(){if(o.g!==u)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:i.key,done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return a}values(){const o=this,u=this.g;let i=this.d;const a={[Symbol.iterator](){return a},next(){if(o.g!==u)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:i.value,done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return a}entries(){const o=this,u=this.g;let i=this.d;const a={[Symbol.iterator](){return a},next(){if(o.g!==u)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:[i.key,i.value],done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return a}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let u=this.d,i=this.size;for(;u&&i>o;)this.c.delete(u.key),u=u.next,i--;this.d=u,this.f=i,u&&(u.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const u=o.next,i=o.previous;if(!u||!i)throw new Error("Invalid list");u.previous=i,i.next=u}o.next=void 0,o.previous=void 0,this.g++}l(o,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(o===this.d)return;const i=o.next,a=o.previous;o===this.e?(a.next=void 0,this.e=a):(i.previous=a,a.next=i),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(u===2){if(o===this.e)return;const i=o.next,a=o.previous;o===this.d?(i.previous=void 0,this.d=i):(i.previous=a,a.next=i),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((u,i)=>{o.push([i,u])}),o}fromJSON(o){this.clear();for(const[u,i]of o)this.set(u,i)}}t.$Dc=m;class e extends m{constructor(o,u=1){super(),this.m=o,this.n=Math.min(Math.max(0,u),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,u=2){return super.get(o,u)}peek(o){return super.get(o,0)}set(o,u){return super.set(o,u,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class N{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let u=this.c.get(o)||0;return u===0?!1:(u--,u===0?this.c.delete(o):this.c.set(o,u),!0)}has(o){return this.c.has(o)}}t.$Fc=N;class E{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[u,i]of o)this.set(u,i)}clear(){this.c.clear(),this.d.clear()}set(o,u){this.c.set(o,u),this.d.set(u,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const u=this.c.get(o);return u===void 0?!1:(this.c.delete(o),this.d.delete(u),!0)}forEach(o,u){this.c.forEach((i,a)=>{o.call(u,i,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=E;class p{constructor(){this.c=new Map}add(o,u){let i=this.c.get(o);i||(i=new Set,this.c.set(o,i)),i.add(u)}delete(o,u){const i=this.c.get(o);i&&(i.delete(u),i.size===0&&this.c.delete(o))}forEach(o,u){const i=this.c.get(o);i&&i.forEach(u)}get(o){const u=this.c.get(o);return u||new Set}}t.$Hc=p;function w($,o){if($===o)return!0;if($.size!==o.size)return!1;for(const[u,i]of $)if(!o.has(u)||o.get(u)!==i)return!1;for(const[u]of o)if(!$.has(u))return!1;return!0}}),ie(se[10],ue([0,1,6,35,14,20,21]),function(W,t,r,y,M,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=c,t.$Lc=L,t.$Mc=g,t.$Nc=N,t.$Oc=E,t.$Pc=p,t.$Qc=w,t.$Rc=$,t.$Sc=o,t.$3c=D;const h=!1;let l=null;class s{constructor(){this.b=new Map}static{this.a=0}c(F){let q=this.b.get(F);return q||(q={parent:null,source:null,isSingleton:!1,value:F,idx:s.a++},this.b.set(F,q)),q}trackDisposable(F){const q=this.c(F);q.source||(q.source=new Error().stack)}setParent(F,q){const x=this.c(F);x.parent=q}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,q){const x=q.get(F);if(x)return x;const z=F.parent?this.f(this.c(F.parent),q):F;return q.set(F,z),z}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,F).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(F=10,q){let x;if(q)x=q;else{const G=new Map,k=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,G).isSingleton);if(k.length===0)return;const V=new Set(k.map(ne=>ne.value));if(x=k.filter(ne=>!(ne.parent&&V.has(ne.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function z(G){function k(ne,le){for(;ne.length>0&&le.some(me=>typeof me=="string"?me===ne[0]:ne[0].match(me));)ne.shift()}const V=G.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return k(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const Y=new M.$Hc;for(const G of x){const k=z(G);for(let V=0;V<=k.length;V++)Y.add(k.slice(0,V).join(`
`),G)}x.sort((0,r.$7b)(G=>G.idx,r.$9b));let Z="",X=0;for(const G of x.slice(0,F)){X++;const k=z(G),V=[];for(let ne=0;ne<k.length;ne++){let le=k[ne];le=`(shared with ${Y.get(k.slice(0,ne+1).join(`
`)).size}/${x.length} leaks) at ${le}`;const n=Y.get(k.slice(0,ne).join(`
`)),Ne=(0,y.$K)([...n].map(pe=>z(pe)[ne]),pe=>pe);delete Ne[k[ne]];for(const[pe,Te]of Object.entries(Ne))V.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${pe}`);V.unshift(le)}Z+=`


==================== Leaking disposable ${X}/${x.length}: ${G.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return x.length>F&&(Z+=`


... and ${x.length-F} more leaking disposables

`),{leaks:x,details:Z}}}t.$Jc=s;function c(I){l=I}if(h){const I="__is_disposable_tracked__";c(new class{trackDisposable(F){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[I]||console.log(q)},3e3)}setParent(F,q){if(F&&F!==i.None)try{F[I]=!0}catch{}}markAsDisposed(F){if(F&&F!==i.None)try{F[I]=!0}catch{}}markAsSingleton(F){}})}function L(I){return l?.trackDisposable(I),I}function g(I){l?.markAsDisposed(I)}function m(I,F){l?.setParent(I,F)}function e(I,F){if(l)for(const q of I)l.setParent(q,F)}function N(I){return l?.markAsSingleton(I),I}function E(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function p(I){if(j.Iterable.is(I)){const F=[];for(const q of I)if(q)try{q.dispose()}catch(x){F.push(x)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function w(I){for(const F of I)E(F)&&F.dispose();return[]}function $(...I){const F=o(()=>p(I));return e(I,F),F}function o(I){const F=L({dispose:(0,f.$db)(()=>{g(F),I()})});return F}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return m(F,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),m(F,null))}}t.$Tc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,L(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Uc=i;class a{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&m(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&m(F,null),F}}t.$Vc=a;class b{constructor(F){this.a=new a,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=b;class d{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=d;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(F){let q=F;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,g(this))},this}}t.$Yc=v;class A{constructor(){this.a=new Map}acquire(F,...q){let x=this.a.get(F);x||(x={counter:0,object:this.b(F,...q)},this.a.set(F,x));const{object:z}=x,Y=(0,f.$db)(()=>{--x.counter===0&&(this.c(F,x.object),this.a.delete(F))});return x.counter++,{object:z,dispose:Y}}}t.$Zc=A;class R{constructor(F){this.a=F}async acquire(F,...q){const x=this.a.acquire(F,...q);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(z){throw x.dispose(),z}}}t.$1c=R;class P{constructor(F){this.object=F}dispose(){}}t.$2c=P;function D(I){const F=new u;try{I(F)}finally{F.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,q,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(F)?.dispose(),this.a.set(F,q)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=S}),ie(se[23],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class y{static create(f){return new y(f)}constructor(f){this.c=r&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$0d=y}),ie(se[11],ue([0,1,3,20,10,22,23]),function(W,t,r,y,M,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$_d=t.Event=void 0,t.$ae=m;const h=!1,l=!1,s=!1;var c;(function(q){q.None=()=>M.$Uc.None;function x(te){if(s){const{onDidAddListener:_}=te,re=N.create();let ee=0;te.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),_?.()}}}function z(te,_){return n(te,()=>{},0,void 0,!0,void 0,_)}q.defer=z;function Y(te){return(_,re=null,ee)=>{let oe=!1,he;return he=te(de=>{if(!oe)return he?he.dispose():oe=!0,_.call(re,de)},null,ee),oe&&he.dispose(),he}}q.once=Y;function Z(te,_,re){return le((ee,oe=null,he)=>te(de=>ee.call(oe,_(de)),null,he),re)}q.map=Z;function X(te,_,re){return le((ee,oe=null,he)=>te(de=>{_(de),ee.call(oe,de)},null,he),re)}q.forEach=X;function G(te,_,re){return le((ee,oe=null,he)=>te(de=>_(de)&&ee.call(oe,de),null,he),re)}q.filter=G;function k(te){return te}q.signal=k;function V(...te){return(_,re=null,ee)=>{const oe=(0,M.$Rc)(...te.map(he=>he(de=>_.call(re,de))));return me(oe,ee)}}q.any=V;function ne(te,_,re,ee){let oe=re;return Z(te,he=>(oe=_(oe,he),oe),ee)}q.reduce=ne;function le(te,_){let re;const ee={onWillAddFirstListener(){re=te(oe.fire,oe)},onDidRemoveLastListener(){re?.dispose()}};_||x(ee);const oe=new u(ee);return _?.add(oe),oe.event}function me(te,_){return _ instanceof Array?_.push(te):_&&_.add(te),te}function n(te,_,re=100,ee=!1,oe=!1,he,de){let $e,ve,Pe,je=0,xe;const Ve={leakWarningThreshold:he,onWillAddFirstListener(){$e=te(Ce=>{je++,ve=_(ve,Ce),ee&&!Pe&&(Ie.fire(ve),ve=void 0),xe=()=>{const We=ve;ve=void 0,Pe=void 0,(!ee||je>1)&&Ie.fire(We),je=0},typeof re=="number"?(clearTimeout(Pe),Pe=setTimeout(xe,re)):Pe===void 0&&(Pe=0,queueMicrotask(xe))})},onWillRemoveListener(){oe&&je>0&&xe?.()},onDidRemoveLastListener(){xe=void 0,$e.dispose()}};de||x(Ve);const Ie=new u(Ve);return de?.add(Ie),Ie.event}q.debounce=n;function Ne(te,_=0,re){return q.debounce(te,(ee,oe)=>ee?(ee.push(oe),ee):[oe],_,void 0,!0,void 0,re)}q.accumulate=Ne;function pe(te,_=(ee,oe)=>ee===oe,re){let ee=!0,oe;return G(te,he=>{const de=ee||!_(he,oe);return ee=!1,oe=he,de},re)}q.latch=pe;function Te(te,_,re){return[q.filter(te,_,re),q.filter(te,ee=>!_(ee),re)]}q.split=Te;function Se(te,_=!1,re=[],ee){let oe=re.slice(),he=te(ve=>{oe?oe.push(ve):$e.fire(ve)});ee&&ee.add(he);const de=()=>{oe?.forEach(ve=>$e.fire(ve)),oe=null},$e=new u({onWillAddFirstListener(){he||(he=te(ve=>$e.fire(ve)),ee&&ee.add(he))},onDidAddFirstListener(){oe&&(_?setTimeout(de):de())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return ee&&ee.add($e),$e.event}q.buffer=Se;function Be(te,_){return(ee,oe,he)=>{const de=_(new Me);return te(function($e){const ve=de.evaluate($e);ve!==Fe&&ee.call(oe,ve)},void 0,he)}}q.chain=Be;const Fe=Symbol("HaltChainable");class Me{constructor(){this.f=[]}map(_){return this.f.push(_),this}forEach(_){return this.f.push(re=>(_(re),re)),this}filter(_){return this.f.push(re=>_(re)?re:Fe),this}reduce(_,re){let ee=re;return this.f.push(oe=>(ee=_(ee,oe),ee)),this}latch(_=(re,ee)=>re===ee){let re=!0,ee;return this.f.push(oe=>{const he=re||!_(oe,ee);return re=!1,ee=oe,he?oe:Fe}),this}evaluate(_){for(const re of this.f)if(_=re(_),_===Fe)break;return _}}function De(te,_,re=ee=>ee){const ee=(...$e)=>de.fire(re(...$e)),oe=()=>te.on(_,ee),he=()=>te.removeListener(_,ee),de=new u({onWillAddFirstListener:oe,onDidRemoveLastListener:he});return de.event}q.fromNodeEventEmitter=De;function O(te,_,re=ee=>ee){const ee=(...$e)=>de.fire(re(...$e)),oe=()=>te.addEventListener(_,ee),he=()=>te.removeEventListener(_,ee),de=new u({onWillAddFirstListener:oe,onDidRemoveLastListener:he});return de.event}q.fromDOMEventEmitter=O;function C(te){return new Promise(_=>Y(te)(_))}q.toPromise=C;function K(te){const _=new u;return te.then(re=>{_.fire(re)},()=>{_.fire(void 0)}).finally(()=>{_.dispose()}),_.event}q.fromPromise=K;function J(te,_,re){return _(re),te(ee=>_(ee))}q.runAndSubscribe=J;class U{constructor(_,re){this._observable=_,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{_.addObserver(this)},onDidRemoveLastListener:()=>{_.removeObserver(this)}};re||x(ee),this.emitter=new u(ee),re&&re.add(this.emitter)}beginUpdate(_){this.f++}handlePossibleChange(_){}handleChange(_,re){this.g=!0}endUpdate(_){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function fe(te,_){return new U(te,_).emitter.event}q.fromObservable=fe;function ge(te){return(_,re,ee)=>{let oe=0,he=!1;const de={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(te.reportChanges(),he&&(he=!1,_.call(re)))},handlePossibleChange(){},handleChange(){he=!0}};te.addObserver(de),te.reportChanges();const $e={dispose(){te.removeObserver(de)}};return ee instanceof M.$Tc?ee.add($e):Array.isArray(ee)&&ee.push($e),$e}}q.fromObservableLight=ge})(c||(t.Event=c={}));class L{static{this.all=new Set}static{this.f=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${L.f++}`,L.all.add(this)}start(x){this.g=new j.$0d,this.listenerCount=x}stop(){if(this.g){const x=this.g.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this.g=void 0}}}t.$_d=L;let g=-1;function m(q){const x=g;return g=q,{dispose(){g=x}}}class e{constructor(x,z=Math.random().toString(18).slice(2,5)){this.threshold=x,this.name=z,this.g=0}dispose(){this.f?.clear()}check(x,z){const Y=this.threshold;if(Y<=0||z<Y)return;this.f||(this.f=new Map);const Z=this.f.get(x.value)||0;if(this.f.set(x.value,Z+1),this.g-=1,this.g<=0){this.g=Y*.5;let X,G=0;for(const[k,V]of this.f)(!X||G<V)&&(X=k,G=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${G}):`),console.warn(X)}return()=>{const X=this.f.get(x.value)||0;this.f.set(x.value,X-1)}}}class N{static create(){return new N(new Error().stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class p{constructor(x){this.value=x,this.id=E++}}const w=2,$=(q,x)=>{if(q instanceof p)x(q);else for(let z=0;z<q.length;z++){const Y=q[z];Y&&x(Y)}},o=h?new FinalizationRegistry(q=>{typeof q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(q))}):void 0;class u{constructor(x){this.w=0,this.f=x,this.g=g>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(l){const x=this.t;queueMicrotask(()=>{$(x,z=>z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(x,z,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Uc.None;if(this.m)return M.$Uc.None;z&&(x=x.bind(z));const Z=new p(x);let X,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Z.stack=N.create(),X=this.g.check(Z.stack,this.w+1)),l&&(Z.stack=G??N.create()),this.t?this.t instanceof p?(this.u??=new a,this.t=[this.t,Z]):this.t.push(Z):(this.f?.onWillAddFirstListener?.(this),this.t=Z,this.f?.onDidAddFirstListener?.(this)),this.w++;const k=(0,M.$Sc)(()=>{o?.unregister(k),X?.(),this.x(Z)});if(Y instanceof M.$Tc?Y.add(k):Array.isArray(Y)&&Y.push(k),o){const V=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register(k,V,k)}return k},this.q}x(x){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const z=this.t,Y=z.indexOf(x);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,z[Y]=void 0;const Z=this.u.current===this;if(this.w*w<=z.length){let X=0;for(let G=0;G<z.length;G++)z[G]?z[X++]=z[G]:Z&&(this.u.end--,X<this.u.i&&this.u.i--);z.length=X}}y(x,z){if(!x)return;const Y=this.f?.onListenerError||r.$1;if(!Y){x.value(z);return}try{x.value(z)}catch(Z){Y(Z)}}z(x){const z=x.current.t;for(;x.i<x.end;)this.y(z[x.i++],x.value);x.reset()}fire(x){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,x);else{const z=this.u;z.enqueue(this,x,this.t.length),this.z(z)}this.j?.stop()}hasListeners(){return this.w>0}}t.$be=u;const i=()=>new a;t.$ce=i;class a{constructor(){this.i=-1,this.end=0}enqueue(x,z,Y){this.i=0,this.end=Y,this.current=x,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class b extends u{async fireAsync(x,z,Y){if(this.t)for(this.h||(this.h=new f.$5c),$(this.t,Z=>this.h.push([Z.value,x]));this.h.size>0&&!z.isCancellationRequested;){const[Z,X]=this.h.shift(),G=[],k={...X,token:z,waitUntil:V=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");Y&&(V=Y(V,Z)),G.push(V)}};try{Z(k)}catch(V){(0,r.$1)(V);continue}Object.freeze(G),await Promise.allSettled(G).then(V=>{for(const ne of V)ne.status==="rejected"&&(0,r.$1)(ne.reason)})}}}t.$de=b;class d extends u{get isPaused(){return this.h!==0}constructor(x){super(x),this.h=0,this.s=new f.$5c,this.A=x?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const x=Array.from(this.s);this.s.clear(),super.fire(this.A(x))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(x){this.w&&(this.h!==0?this.s.push(x):super.fire(x))}}t.$ee=d;class v extends d{constructor(x){super(x),this.k=x.delay??100}fire(x){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(x)}}t.$fe=v;class A extends u{constructor(x){super(x),this.h=[],this.k=x?.merge}fire(x){this.hasListeners()&&(this.h.push(x),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}t.$ge=A;class R{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(x){const z={event:x,listener:null};this.h.push(z),this.g&&this.m(z);const Y=()=>{this.g&&this.o(z);const Z=this.h.indexOf(z);this.h.splice(Z,1)};return(0,M.$Sc)((0,y.$db)(Y))}j(){this.g=!0,this.h.forEach(x=>this.m(x))}k(){this.g=!1,this.h.forEach(x=>this.o(x))}m(x){x.listener=x.event(z=>this.f.fire(z))}o(x){x.listener?.dispose(),x.listener=null}dispose(){this.f.dispose();for(const x of this.h)x.listener?.dispose();this.h=[]}}t.$he=R;class P{constructor(x,z,Y,Z){this.f=new M.$Tc;const X=this.f.add(new R),G=this.f.add(new M.$4c);function k(V){G.set(V,X.add(Z(V)))}for(const V of x)k(V);this.f.add(z(V=>{k(V)})),this.f.add(Y(V=>{G.deleteAndDispose(V)})),this.event=X.event}dispose(){this.f.dispose()}}t.$ie=P;class D{constructor(){this.f=[]}wrapEvent(x){return(z,Y,Z)=>x(X=>{const G=this.f[this.f.length-1];G?G.push(()=>z.call(Y,X)):z.call(Y,X)},void 0,Z)}bufferEvents(x){const z=[];this.f.push(z);const Y=x();return this.f.pop(),z.forEach(Z=>Z()),Y}}t.$je=D;class S{constructor(){this.f=!1,this.g=c.None,this.h=M.$Uc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(x){this.g=x,this.f&&(this.h.dispose(),this.h=x(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ke=S;class I{static const(x){return new F(x)}constructor(x){this.g=x,this.f=new u,this.onDidChange=this.f.event}get value(){return this.g}set value(x){x!==this.g&&(this.g=x,this.f.fire(void 0))}}t.$le=I;class F{constructor(x){this.value=x,this.onDidChange=c.None}}}),ie(se[24],ue([0,1,11]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$me=t.CancellationToken=void 0;const y=Object.freeze(function(h,l){const s=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(s)}}});var M;(function(h){function l(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(M||(t.CancellationToken=M={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?y:(this.b||(this.b=new r.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=M.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=M.None}}t.$me=j}),ie(se[40],ue([0,1,24]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ze=t.$Ye=t.$Xe=void 0;class y{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new r.$me,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Xe=y;class M{constructor(h,l=JSON.stringify){this.c=h,this.d=l,this.a=void 0,this.b=void 0}get(h){const l=this.d(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}t.$Ye=M;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}t.$Ze=f}),ie(se[7],ue([0,1,40,39]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3f=t.$2f=t.$1f=t.GraphemeBreakType=t.$Qf=t.$Jf=t.$Cf=t.$Bf=void 0,t.$3e=M,t.$4e=j,t.$5e=l,t.$6e=s,t.$7e=c,t.$8e=L,t.$9e=g,t.$0e=m,t.$$e=e,t.$_e=N,t.$af=E,t.$bf=p,t.$cf=w,t.$df=$,t.$ef=o,t.$ff=u,t.$gf=i,t.$hf=a,t.$if=b,t.$jf=d,t.$kf=v,t.$lf=A,t.$mf=R,t.$nf=P,t.$of=D,t.$pf=S,t.$qf=I,t.$rf=F,t.$sf=q,t.$tf=x,t.$uf=z,t.$vf=Y,t.$wf=Z,t.$xf=X,t.$yf=G,t.$zf=k,t.$Af=V,t.$Df=n,t.$Ef=Ne,t.$Ff=pe,t.$Gf=Te,t.$Hf=Fe,t.$If=De,t.$Kf=O,t.$Lf=C,t.$Mf=K,t.$Nf=J,t.$Of=fe,t.$Pf=ge,t.$Rf=te,t.$Sf=_,t.$Tf=re,t.$Uf=ee,t.$Vf=oe,t.$Wf=he,t.$Xf=de,t.$Yf=$e,t.$Zf=Ve;function M(T){return!T||typeof T!="string"?!0:T.trim().length===0}const f=/{(\d+)}/g;function j(T,...B){return B.length===0?T:T.replace(f,function(H,Q){const ae=parseInt(Q,10);return isNaN(ae)||ae<0||ae>=B.length?H:B[ae]})}const h=/{([^}]+)}/g;function l(T,B){return Object.keys(B).length===0?T:T.replace(h,(H,Q)=>B[Q]??H)}function s(T){return T.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function c(T){return T.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function L(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function g(T,B){let H=0;const Q=B.charCodeAt(0);for(let ae=T.length-1;ae>=0;ae--)T.charCodeAt(ae)===Q&&H++;return H}function m(T,B,H="\u2026"){return T.length<=B?T:`${T.substr(0,B)}${H}`}function e(T,B,H="\u2026"){if(T.length<=B)return T;const Q=Math.ceil(B/2)-H.length/2,ae=Math.floor(B/2)-H.length/2;return`${T.substr(0,Q)}${H}${T.substr(T.length-ae)}`}function N(T,B=" "){const H=E(T,B);return p(H,B)}function E(T,B){if(!T||!B)return T;const H=B.length;if(H===0||T.length===0)return T;let Q=0;for(;T.indexOf(B,Q)===Q;)Q=Q+H;return T.substring(Q)}function p(T,B){if(!T||!B)return T;const H=B.length,Q=T.length;if(H===0||Q===0)return T;let ae=Q,ce=-1;for(;ce=T.lastIndexOf(B,ae-1),!(ce===-1||ce+H!==ae);){if(ce===0)return"";ae=ce}return T.substring(0,ae)}function w(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function $(T){return T.replace(/\*/g,"")}function o(T,B,H={}){if(!T)throw new Error("Cannot create regex from empty string");B||(T=L(T)),H.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return H.global&&(Q+="g"),H.matchCase||(Q+="i"),H.multiline&&(Q+="m"),H.unicode&&(Q+="u"),new RegExp(T,Q)}function u(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function i(T){return T.split(/\r\n|\r|\n/)}function a(T){const B=[],H=T.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(H.length/2);Q++)B.push(H[2*Q]+(H[2*Q+1]??""));return B}function b(T){for(let B=0,H=T.length;B<H;B++){const Q=T.charCodeAt(B);if(Q!==32&&Q!==9)return B}return-1}function d(T,B=0,H=T.length){for(let Q=B;Q<H;Q++){const ae=T.charCodeAt(Q);if(ae!==32&&ae!==9)return T.substring(B,Q)}return T.substring(B,H)}function v(T,B=T.length-1){for(let H=B;H>=0;H--){const Q=T.charCodeAt(H);if(Q!==32&&Q!==9)return H}return-1}function A(T,B,H){const Q=[];let ae=0;for(const ce of T.matchAll(B)){if(Q.push(T.slice(ae,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ae=ce.index+ce[0].length,Q.push(H(ce[0],...ce.slice(1),ce.index,T,ce.groups))}return Q.push(T.slice(ae)),Promise.all(Q).then(ce=>ce.join(""))}function R(T,B){return T<B?-1:T>B?1:0}function P(T,B,H=0,Q=T.length,ae=0,ce=B.length){for(;H<Q&&ae<ce;H++,ae++){const Ee=T.charCodeAt(H),Ae=B.charCodeAt(ae);if(Ee<Ae)return-1;if(Ee>Ae)return 1}const we=Q-H,ye=ce-ae;return we<ye?-1:we>ye?1:0}function D(T,B){return S(T,B,0,T.length,0,B.length)}function S(T,B,H=0,Q=T.length,ae=0,ce=B.length){for(;H<Q&&ae<ce;H++,ae++){let Ee=T.charCodeAt(H),Ae=B.charCodeAt(ae);if(Ee===Ae)continue;if(Ee>=128||Ae>=128)return P(T.toLowerCase(),B.toLowerCase(),H,Q,ae,ce);F(Ee)&&(Ee-=32),F(Ae)&&(Ae-=32);const Le=Ee-Ae;if(Le!==0)return Le}const we=Q-H,ye=ce-ae;return we<ye?-1:we>ye?1:0}function I(T){return T>=48&&T<=57}function F(T){return T>=97&&T<=122}function q(T){return T>=65&&T<=90}function x(T,B){return T.length===B.length&&S(T,B)===0}function z(T,B){const H=B.length;return B.length>T.length?!1:S(T,B,0,H)===0}function Y(T,B){const H=Math.min(T.length,B.length);let Q;for(Q=0;Q<H;Q++)if(T.charCodeAt(Q)!==B.charCodeAt(Q))return Q;return H}function Z(T,B){const H=Math.min(T.length,B.length);let Q;const ae=T.length-1,ce=B.length-1;for(Q=0;Q<H;Q++)if(T.charCodeAt(ae-Q)!==B.charCodeAt(ce-Q))return Q;return H}function X(T){return 55296<=T&&T<=56319}function G(T){return 56320<=T&&T<=57343}function k(T,B){return(T-55296<<10)+(B-56320)+65536}function V(T,B,H){const Q=T.charCodeAt(H);if(X(Q)&&H+1<B){const ae=T.charCodeAt(H+1);if(G(ae))return k(Q,ae)}return Q}function ne(T,B){const H=T.charCodeAt(B-1);if(G(H)&&B>1){const Q=T.charCodeAt(B-2);if(X(Q))return k(Q,H)}return H}class le{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=ne(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=V(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$Bf=le;class me{get offset(){return this.c.offset}constructor(B,H=0){this.c=new le(B,H)}nextGraphemeLength(){const B=je.getInstance(),H=this.c,Q=H.offset;let ae=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ce=H.offset,we=B.getGraphemeBreakType(H.nextCodePoint());if(ve(ae,we)){H.setOffset(ce);break}ae=we}return H.offset-Q}prevGraphemeLength(){const B=je.getInstance(),H=this.c,Q=H.offset;let ae=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ce=H.offset,we=B.getGraphemeBreakType(H.prevCodePoint());if(ve(we,ae)){H.setOffset(ce);break}ae=we}return Q-H.offset}eol(){return this.c.eol()}}t.$Cf=me;function n(T,B){return new me(T,B).nextGraphemeLength()}function Ne(T,B){return new me(T,B).prevGraphemeLength()}function pe(T,B){B>0&&G(T.charCodeAt(B))&&B--;const H=B+n(T,B);return[H-Ne(T,H),H]}function Te(T){const B=new me(T);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}let Se;function Be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(T){return Se||(Se=Be()),Se.test(T)}const Me=/^[\t\n\r\x20-\x7E]*$/;function De(T){return Me.test(T)}t.$Jf=/[\u2028\u2029]/;function O(T){return t.$Jf.test(T)}function C(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function K(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function J(T,B,H=""){const Q=T.trimStart();if(Q.length<B)return Q;const ae=/\b/g;let ce=0;for(;ae.test(Q)&&!(Q.length-ae.lastIndex<B);)ce=ae.lastIndex,ae.lastIndex+=1;return ce===0?Q:H+Q.substring(ce).trimStart()}const U=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(T){let B=0;for(const H of T.matchAll(U))B!==H.index&&(yield{isCode:!1,str:T.substring(B,H.index)}),yield{isCode:!0,str:H[0]},B=H.index+H[0].length;B!==T.length&&(yield{isCode:!1,str:T.substring(B)})}function ge(T){return T&&(T=T.replace(U,"")),T}t.$Qf="\uFEFF";function te(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function _(T){return te(T)?T.substr(1):T}function re(T,B){if(!T||!B||T.length<B.length)return!1;const H=B.length,Q=T.toLowerCase();let ae=0,ce=-1;for(;ae<H;){const we=Q.indexOf(B[ae],ce+1);if(we<0)return!1;ce=we,ae++}return!0}function ee(T,B=!1){return T?(B&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function oe(T){return T.charAt(0).toUpperCase()+T.slice(1)}function he(T,B=1){if(B===0)return"";let H=-1;do H=T.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?T:(T[H-1]==="\r"&&H--,T.substr(0,H))}function de(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function $e(T){return je.getInstance().getGraphemeBreakType(T)}function ve(T,B){return T===0?B!==5&&B!==7:T===2&&B===3?!1:T===4||T===2||T===3||B===4||B===2||B===3?!0:!(T===8&&(B===8||B===9||B===11||B===12)||(T===11||T===9)&&(B===9||B===10)||(T===12||T===10)&&B===10||B===5||B===13||B===7||T===1||T===13&&B===14||T===6&&B===6)}var Pe;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class je{static{this.c=null}static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=xe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,Q=H.length/3;let ae=1;for(;ae<=Q;)if(B<H[3*ae])ae=2*ae;else if(B>H[3*ae+1])ae=2*ae+1;else return H[3*ae+2];return 0}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(T,B){if(T===0)return 0;const H=Ie(T,B);if(H!==void 0)return H;const Q=new le(B,T);return Q.prevCodePoint(),Q.offset}function Ie(T,B){const H=new le(B,T);let Q=H.prevCodePoint();for(;Ce(Q)||Q===65039||Q===8419;){if(H.offset===0)return;Q=H.prevCodePoint()}if(!K(Q))return;let ae=H.offset;return ae>0&&H.prevCodePoint()===8205&&(ae=H.offset),ae}function Ce(T){return 127995<=T&&T<=127999}var We;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$1f="\xA0";class qe{static{this.c=new y.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$Ye(B=>{function H(Le){const ke=new Map;for(let Re=0;Re<Le.length;Re+=2)ke.set(Le[Re],Le[Re+1]);return ke}function Q(Le,ke){const Re=new Map(Le);for(const[Ke,ze]of ke)Re.set(Ke,ze);return Re}function ae(Le,ke){if(!Le)return ke;const Re=new Map;for(const[Ke,ze]of Le)ke.has(Ke)&&Re.set(Ke,ze);return Re}const ce=this.c.value;let we=B.filter(Le=>!Le.startsWith("_")&&Le in ce);we.length===0&&(we=["_default"]);let ye;for(const Le of we){const ke=H(ce[Le]);ye=ae(ye,ke)}const Ee=H(ce._common),Ae=Q(Ee,ye);return new qe(Ae)})}static getInstance(B){return qe.d.get(Array.from(B))}static{this.e=new y.$V(()=>Object.keys(qe.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return qe.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$2f=qe;class Oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Oe.c())),this.d}static isInvisibleCharacter(B){return Oe.e().has(B)}static get codePoints(){return Oe.e()}}t.$3f=Oe}),ie(se[41],ue([0,1,7]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kj=t.$ij=void 0,t.$ej=y,t.$fj=M,t.$gj=f,t.$hj=h,t.$jj=N;function y(p){return M(p,0)}function M(p,w){switch(typeof p){case"object":return p===null?f(349,w):Array.isArray(p)?l(p,w):s(p,w);case"string":return h(p,w);case"boolean":return j(p,w);case"number":return f(p,w);case"undefined":return f(937,w);default:return f(617,w)}}function f(p,w){return(w<<5)-w+p|0}function j(p,w){return f(p?433:863,w)}function h(p,w){w=f(149417,w);for(let $=0,o=p.length;$<o;$++)w=f(p.charCodeAt($),w);return w}function l(p,w){return w=f(104579,w),p.reduce(($,o)=>M(o,$),w)}function s(p,w){return w=f(181387,w),Object.keys(p).sort().reduce(($,o)=>($=h(o,$),M(p[o],$)),w)}class c{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=M(w,this.g),this.g}}t.$ij=c;var L;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function g(p,w,$=32){const o=$-w,u=~((1<<o)-1);return(p<<w|(u&p)>>>o)>>>0}function m(p,w=0,$=p.byteLength,o=0){for(let u=0;u<$;u++)p[w+u]=o}function e(p,w,$="0"){for(;p.length<w;)p=$+p;return p}function N(p,w=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map($=>$.toString(16).padStart(2,"0")).join(""):e((p>>>0).toString(16),w/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const $=w.length;if($===0)return;const o=this.p;let u=this.r,i=this.u,a,b;for(i!==0?(a=i,b=-1,i=0):(a=w.charCodeAt(0),b=0);;){let d=a;if(r.$xf(a))if(b+1<$){const v=w.charCodeAt(b+1);r.$yf(v)?(b++,d=r.$zf(a,v)):d=65533}else{i=a;break}else r.$yf(a)&&(d=65533);if(u=this.w(o,u,d),b++,b<$)a=w.charCodeAt(b);else break}this.r=u,this.u=i}w(w,$,o){return o<128?w[$++]=o:o<2048?(w[$++]=192|(o&1984)>>>6,w[$++]=128|(o&63)>>>0):o<65536?(w[$++]=224|(o&61440)>>>12,w[$++]=128|(o&4032)>>>6,w[$++]=128|(o&63)>>>0):(w[$++]=240|(o&1835008)>>>18,w[$++]=128|(o&258048)>>>12,w[$++]=128|(o&4032)>>>6,w[$++]=128|(o&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,w[0]=w[64],w[1]=w[65],w[2]=w[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=E.g,$=this.q;for(let R=0;R<64;R+=4)w.setUint32(R,$.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)w.setUint32(R,g(w.getUint32(R-12,!1)^w.getUint32(R-32,!1)^w.getUint32(R-56,!1)^w.getUint32(R-64,!1),1),!1);let o=this.h,u=this.l,i=this.m,a=this.n,b=this.o,d,v,A;for(let R=0;R<80;R++)R<20?(d=u&i|~u&a,v=1518500249):R<40?(d=u^i^a,v=1859775393):R<60?(d=u&i|u&a|i&a,v=2400959708):(d=u^i^a,v=3395469782),A=g(o,5)+d+b+v+w.getUint32(R*4,!1)&4294967295,b=a,a=i,i=g(u,30),u=o,o=A;this.h=this.h+o&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+b&4294967295}}t.$kj=E}),ie(se[25],ue([0,1,37,41]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qt=t.$ot=void 0,t.$pt=f;class M{constructor(g){this.a=g}getElements(){const g=this.a,m=new Int32Array(g.length);for(let e=0,N=g.length;e<N;e++)m[e]=g.charCodeAt(e);return m}}t.$ot=M;function f(L,g,m){return new c(new M(L),new M(g)).ComputeDiff(m).changes}class j{static Assert(g,m){if(!g)throw new Error(m)}}class h{static Copy(g,m,e,N,E){for(let p=0;p<E;p++)e[N+p]=g[m+p]}static Copy2(g,m,e,N,E){for(let p=0;p<E;p++)e[N+p]=g[m+p]}}var l;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new r.$nt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(g,m,e=null){this.a=e,this.b=g,this.c=m;const[N,E,p]=c.o(g),[w,$,o]=c.o(m);this.d=p&&o,this.e=N,this.f=E,this.g=w,this.h=$,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const m=g.getElements();if(c.n(m)){const e=new Int32Array(m.length);for(let N=0,E=m.length;N<E;N++)e[N]=(0,y.$hj)(m[N],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(g,m){return this.f[g]!==this.h[m]?!1:this.d?this.e[g]===this.g[m]:!0}q(g,m){if(!this.p(g,m))return!1;const e=c.r(this.b,g),N=c.r(this.c,m);return e===N}static r(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}s(g,m){return this.f[g]!==this.f[m]?!1:this.d?this.e[g]===this.e[m]:!0}u(g,m){return this.h[g]!==this.h[m]?!1:this.d?this.g[g]===this.g[m]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,m,e,N,E){const p=[!1];let w=this.w(g,m,e,N,p);return E&&(w=this.z(w)),{quitEarly:p[0],changes:w}}w(g,m,e,N,E){for(E[0]=!1;g<=m&&e<=N&&this.p(g,e);)g++,e++;for(;m>=g&&N>=e&&this.p(m,N);)m--,N--;if(g>m||e>N){let i;return e<=N?(j.Assert(g===m+1,"originalStart should only be one more than originalEnd"),i=[new r.$nt(g,0,e,N-e+1)]):g<=m?(j.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),i=[new r.$nt(g,m-g+1,e,0)]):(j.Assert(g===m+1,"originalStart should only be one more than originalEnd"),j.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const p=[0],w=[0],$=this.y(g,m,e,N,p,w,E),o=p[0],u=w[0];if($!==null)return $;if(!E[0]){const i=this.w(g,o,e,u,E);let a=[];return E[0]?a=[new r.$nt(o+1,m-(o+1)+1,u+1,N-(u+1)+1)]:a=this.w(o+1,m,u+1,N,E),this.H(i,a)}return[new r.$nt(g,m-g+1,e,N-e+1)]}x(g,m,e,N,E,p,w,$,o,u,i,a,b,d,v,A,R,P){let D=null,S=null,I=new s,F=m,q=e,x=b[0]-A[0]-N,z=-1073741824,Y=this.k.length-1;do{const Z=x+g;Z===F||Z<q&&o[Z-1]<o[Z+1]?(i=o[Z+1],d=i-x-N,i<z&&I.MarkNextChange(),z=i,I.AddModifiedElement(i+1,d),x=Z+1-g):(i=o[Z-1]+1,d=i-x-N,i<z&&I.MarkNextChange(),z=i-1,I.AddOriginalElement(i,d+1),x=Z-1-g),Y>=0&&(o=this.k[Y],g=o[0],F=1,q=o.length-1)}while(--Y>=-1);if(D=I.getReverseChanges(),P[0]){let Z=b[0]+1,X=A[0]+1;if(D!==null&&D.length>0){const G=D[D.length-1];Z=Math.max(Z,G.getOriginalEnd()),X=Math.max(X,G.getModifiedEnd())}S=[new r.$nt(Z,a-Z+1,X,v-X+1)]}else{I=new s,F=p,q=w,x=b[0]-A[0]-$,z=1073741824,Y=R?this.m.length-1:this.m.length-2;do{const Z=x+E;Z===F||Z<q&&u[Z-1]>=u[Z+1]?(i=u[Z+1]-1,d=i-x-$,i>z&&I.MarkNextChange(),z=i+1,I.AddOriginalElement(i+1,d+1),x=Z+1-E):(i=u[Z-1],d=i-x-$,i>z&&I.MarkNextChange(),z=i,I.AddModifiedElement(i+1,d+1),x=Z-1-E),Y>=0&&(u=this.m[Y],E=u[0],F=1,q=u.length-1)}while(--Y>=-1);S=I.getChanges()}return this.H(D,S)}y(g,m,e,N,E,p,w){let $=0,o=0,u=0,i=0,a=0,b=0;g--,e--,E[0]=0,p[0]=0,this.k=[],this.m=[];const d=m-g+(N-e),v=d+1,A=new Int32Array(v),R=new Int32Array(v),P=N-e,D=m-g,S=g-e,I=m-N,q=(D-P)%2===0;A[P]=g,R[D]=m,w[0]=!1;for(let x=1;x<=d/2+1;x++){let z=0,Y=0;u=this.J(P-x,x,P,v),i=this.J(P+x,x,P,v);for(let X=u;X<=i;X+=2){X===u||X<i&&A[X-1]<A[X+1]?$=A[X+1]:$=A[X-1]+1,o=$-(X-P)-S;const G=$;for(;$<m&&o<N&&this.p($+1,o+1);)$++,o++;if(A[X]=$,$+o>z+Y&&(z=$,Y=o),!q&&Math.abs(X-D)<=x-1&&$>=R[X])return E[0]=$,p[0]=o,G<=R[X]&&1447>0&&x<=1448?this.x(P,u,i,S,D,a,b,I,A,R,$,m,E,o,N,p,q,w):null}const Z=(z-g+(Y-e)-x)/2;if(this.a!==null&&!this.a(z,Z))return w[0]=!0,E[0]=z,p[0]=Y,Z>0&&1447>0&&x<=1448?this.x(P,u,i,S,D,a,b,I,A,R,$,m,E,o,N,p,q,w):(g++,e++,[new r.$nt(g,m-g+1,e,N-e+1)]);a=this.J(D-x,x,D,v),b=this.J(D+x,x,D,v);for(let X=a;X<=b;X+=2){X===a||X<b&&R[X-1]>=R[X+1]?$=R[X+1]-1:$=R[X-1],o=$-(X-D)-I;const G=$;for(;$>g&&o>e&&this.p($,o);)$--,o--;if(R[X]=$,q&&Math.abs(X-P)<=x&&$<=A[X])return E[0]=$,p[0]=o,G>=A[X]&&1447>0&&x<=1448?this.x(P,u,i,S,D,a,b,I,A,R,$,m,E,o,N,p,q,w):null}if(x<=1447){let X=new Int32Array(i-u+2);X[0]=P-u+1,h.Copy2(A,u,X,1,i-u+1),this.k.push(X),X=new Int32Array(b-a+2),X[0]=D-a+1,h.Copy2(R,a,X,1,b-a+1),this.m.push(X)}}return this.x(P,u,i,S,D,a,b,I,A,R,$,m,E,o,N,p,q,w)}z(g){for(let m=0;m<g.length;m++){const e=g[m],N=m<g.length-1?g[m+1].originalStart:this.f.length,E=m<g.length-1?g[m+1].modifiedStart:this.h.length,p=e.originalLength>0,w=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<E&&(!p||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!w||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const $=[null];if(m<g.length-1&&this.I(g[m],g[m+1],$)){g[m]=$[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let N=0,E=0;if(m>0){const i=g[m-1];N=i.originalStart+i.originalLength,E=i.modifiedStart+i.modifiedLength}const p=e.originalLength>0,w=e.modifiedLength>0;let $=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,b=e.modifiedStart-i;if(a<N||b<E||p&&!this.s(a,a+e.originalLength)||w&&!this.u(b,b+e.modifiedLength))break;const v=(a===N&&b===E?5:0)+this.G(a,e.originalLength,b,e.modifiedLength);v>o&&(o=v,$=i)}e.originalStart-=$,e.modifiedStart-=$;const u=[null];if(m>0&&this.I(g[m-1],g[m],u)){g[m-1]=u[0],g.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=g.length;m<e;m++){const N=g[m-1],E=g[m],p=E.originalStart-N.originalStart-N.originalLength,w=N.originalStart,$=E.originalStart+E.originalLength,o=$-w,u=N.modifiedStart,i=E.modifiedStart+E.modifiedLength,a=i-u;if(p<5&&o<20&&a<20){const b=this.A(w,o,u,a,p);if(b){const[d,v]=b;(d!==N.originalStart+N.originalLength||v!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=d-N.originalStart,N.modifiedLength=v-N.modifiedStart,E.originalStart=d+p,E.modifiedStart=v+p,E.originalLength=$-E.originalStart,E.modifiedLength=i-E.modifiedStart)}}}return g}A(g,m,e,N,E){if(m<E||N<E)return null;const p=g+m-E+1,w=e+N-E+1;let $=0,o=0,u=0;for(let i=g;i<p;i++)for(let a=e;a<w;a++){const b=this.B(i,a,E);b>0&&b>$&&($=b,o=i,u=a)}return $>0?[o,u]:null}B(g,m,e){let N=0;for(let E=0;E<e;E++){if(!this.p(g+E,m+E))return 0;N+=this.e[g+E].length}return N}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,m){if(this.C(g)||this.C(g-1))return!0;if(m>0){const e=g+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,m){if(this.E(g)||this.E(g-1))return!0;if(m>0){const e=g+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(g,m,e,N){const E=this.D(g,m)?1:0,p=this.F(e,N)?1:0;return E+p}H(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.I(g[g.length-1],m[0],e)){const N=new Array(g.length+m.length-1);return h.Copy(g,0,N,0,g.length-1),N[g.length-1]=e[0],h.Copy(m,1,N,g.length,m.length-1),N}else{const N=new Array(g.length+m.length);return h.Copy(g,0,N,0,g.length),h.Copy(m,0,N,g.length,m.length),N}}I(g,m,e){if(j.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),j.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const N=g.originalStart;let E=g.originalLength;const p=g.modifiedStart;let w=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(E=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&(w=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new r.$nt(N,E,p,w),!0}else return e[0]=null,!1}J(g,m,e,N){if(g>=0&&g<N)return g;const E=e,p=N-e-1,w=m%2===0;if(g<0){const $=E%2===0;return w===$?0:1}else{const $=p%2===0;return w===$?N-1:N-2}}}t.$qt=c}),ie(se[26],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4f=r,t.$5f=y,t.$6f=M,t.$7f=f,t.$8f=j,t.$9f=h,t.$0f=l,t.$$f=s,t.$_f=c,t.$ag=L,t.$bg=g,t.$cg=m,t.$dg=e,t.$eg=E,t.$fg=p,t.$gg=w,t.$hg=$,t.$ig=o;function r(u){return typeof u=="string"}function y(u){return Array.isArray(u)&&u.every(i=>r(i))}function M(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function f(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}function j(u){return typeof u=="number"&&!isNaN(u)}function h(u){return!!u&&typeof u[Symbol.iterator]=="function"}function l(u){return u===!0||u===!1}function s(u){return typeof u>"u"}function c(u){return!L(u)}function L(u){return s(u)||u===null}function g(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function m(u){if(L(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function e(...u){const i=[];for(let a=0;a<u.length;a++){const b=u[a];if(L(b))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(b)}return i}const N=Object.prototype.hasOwnProperty;function E(u){if(!M(u))return!1;for(const i in u)if(N.call(u,i))return!1;return!0}function p(u){return typeof u=="function"}function w(...u){return u.length>0&&u.every(p)}function $(u,i){const a=Math.min(u.length,i.length);for(let b=0;b<a;b++)o(u[b],i[b])}function o(u,i){if(r(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(u instanceof i)return}catch{}if(!L(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ie(se[27],ue([0,1,26]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kj=M,t.$Lj=f;const y=Object.create(null);function M(j,h){if((0,r.$4f)(h)){const l=y[h];if(l===void 0)throw new Error(`${j} references an unknown codicon: ${h}`);h=l}return y[j]=h,{id:j}}function f(){return y}}),ie(se[42],ue([0,1,27]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mj=void 0,t.$Mj={add:(0,r.$Kj)("add",6e4),plus:(0,r.$Kj)("plus",6e4),gistNew:(0,r.$Kj)("gist-new",6e4),repoCreate:(0,r.$Kj)("repo-create",6e4),lightbulb:(0,r.$Kj)("lightbulb",60001),lightBulb:(0,r.$Kj)("light-bulb",60001),repo:(0,r.$Kj)("repo",60002),repoDelete:(0,r.$Kj)("repo-delete",60002),gistFork:(0,r.$Kj)("gist-fork",60003),repoForked:(0,r.$Kj)("repo-forked",60003),gitPullRequest:(0,r.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Kj)("record-keys",60005),keyboard:(0,r.$Kj)("keyboard",60005),tag:(0,r.$Kj)("tag",60006),gitPullRequestLabel:(0,r.$Kj)("git-pull-request-label",60006),tagAdd:(0,r.$Kj)("tag-add",60006),tagRemove:(0,r.$Kj)("tag-remove",60006),person:(0,r.$Kj)("person",60007),personFollow:(0,r.$Kj)("person-follow",60007),personOutline:(0,r.$Kj)("person-outline",60007),personFilled:(0,r.$Kj)("person-filled",60007),gitBranch:(0,r.$Kj)("git-branch",60008),gitBranchCreate:(0,r.$Kj)("git-branch-create",60008),gitBranchDelete:(0,r.$Kj)("git-branch-delete",60008),sourceControl:(0,r.$Kj)("source-control",60008),mirror:(0,r.$Kj)("mirror",60009),mirrorPublic:(0,r.$Kj)("mirror-public",60009),star:(0,r.$Kj)("star",60010),starAdd:(0,r.$Kj)("star-add",60010),starDelete:(0,r.$Kj)("star-delete",60010),starEmpty:(0,r.$Kj)("star-empty",60010),comment:(0,r.$Kj)("comment",60011),commentAdd:(0,r.$Kj)("comment-add",60011),alert:(0,r.$Kj)("alert",60012),warning:(0,r.$Kj)("warning",60012),search:(0,r.$Kj)("search",60013),searchSave:(0,r.$Kj)("search-save",60013),logOut:(0,r.$Kj)("log-out",60014),signOut:(0,r.$Kj)("sign-out",60014),logIn:(0,r.$Kj)("log-in",60015),signIn:(0,r.$Kj)("sign-in",60015),eye:(0,r.$Kj)("eye",60016),eyeUnwatch:(0,r.$Kj)("eye-unwatch",60016),eyeWatch:(0,r.$Kj)("eye-watch",60016),circleFilled:(0,r.$Kj)("circle-filled",60017),primitiveDot:(0,r.$Kj)("primitive-dot",60017),closeDirty:(0,r.$Kj)("close-dirty",60017),debugBreakpoint:(0,r.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Kj)("primitive-square",60018),edit:(0,r.$Kj)("edit",60019),pencil:(0,r.$Kj)("pencil",60019),info:(0,r.$Kj)("info",60020),issueOpened:(0,r.$Kj)("issue-opened",60020),gistPrivate:(0,r.$Kj)("gist-private",60021),gitForkPrivate:(0,r.$Kj)("git-fork-private",60021),lock:(0,r.$Kj)("lock",60021),mirrorPrivate:(0,r.$Kj)("mirror-private",60021),close:(0,r.$Kj)("close",60022),removeClose:(0,r.$Kj)("remove-close",60022),x:(0,r.$Kj)("x",60022),repoSync:(0,r.$Kj)("repo-sync",60023),sync:(0,r.$Kj)("sync",60023),clone:(0,r.$Kj)("clone",60024),desktopDownload:(0,r.$Kj)("desktop-download",60024),beaker:(0,r.$Kj)("beaker",60025),microscope:(0,r.$Kj)("microscope",60025),vm:(0,r.$Kj)("vm",60026),deviceDesktop:(0,r.$Kj)("device-desktop",60026),file:(0,r.$Kj)("file",60027),fileText:(0,r.$Kj)("file-text",60027),more:(0,r.$Kj)("more",60028),ellipsis:(0,r.$Kj)("ellipsis",60028),kebabHorizontal:(0,r.$Kj)("kebab-horizontal",60028),mailReply:(0,r.$Kj)("mail-reply",60029),reply:(0,r.$Kj)("reply",60029),organization:(0,r.$Kj)("organization",60030),organizationFilled:(0,r.$Kj)("organization-filled",60030),organizationOutline:(0,r.$Kj)("organization-outline",60030),newFile:(0,r.$Kj)("new-file",60031),fileAdd:(0,r.$Kj)("file-add",60031),newFolder:(0,r.$Kj)("new-folder",60032),fileDirectoryCreate:(0,r.$Kj)("file-directory-create",60032),trash:(0,r.$Kj)("trash",60033),trashcan:(0,r.$Kj)("trashcan",60033),history:(0,r.$Kj)("history",60034),clock:(0,r.$Kj)("clock",60034),folder:(0,r.$Kj)("folder",60035),fileDirectory:(0,r.$Kj)("file-directory",60035),symbolFolder:(0,r.$Kj)("symbol-folder",60035),logoGithub:(0,r.$Kj)("logo-github",60036),markGithub:(0,r.$Kj)("mark-github",60036),github:(0,r.$Kj)("github",60036),terminal:(0,r.$Kj)("terminal",60037),console:(0,r.$Kj)("console",60037),repl:(0,r.$Kj)("repl",60037),zap:(0,r.$Kj)("zap",60038),symbolEvent:(0,r.$Kj)("symbol-event",60038),error:(0,r.$Kj)("error",60039),stop:(0,r.$Kj)("stop",60039),variable:(0,r.$Kj)("variable",60040),symbolVariable:(0,r.$Kj)("symbol-variable",60040),array:(0,r.$Kj)("array",60042),symbolArray:(0,r.$Kj)("symbol-array",60042),symbolModule:(0,r.$Kj)("symbol-module",60043),symbolPackage:(0,r.$Kj)("symbol-package",60043),symbolNamespace:(0,r.$Kj)("symbol-namespace",60043),symbolObject:(0,r.$Kj)("symbol-object",60043),symbolMethod:(0,r.$Kj)("symbol-method",60044),symbolFunction:(0,r.$Kj)("symbol-function",60044),symbolConstructor:(0,r.$Kj)("symbol-constructor",60044),symbolBoolean:(0,r.$Kj)("symbol-boolean",60047),symbolNull:(0,r.$Kj)("symbol-null",60047),symbolNumeric:(0,r.$Kj)("symbol-numeric",60048),symbolNumber:(0,r.$Kj)("symbol-number",60048),symbolStructure:(0,r.$Kj)("symbol-structure",60049),symbolStruct:(0,r.$Kj)("symbol-struct",60049),symbolParameter:(0,r.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Kj)("symbol-type-parameter",60050),symbolKey:(0,r.$Kj)("symbol-key",60051),symbolText:(0,r.$Kj)("symbol-text",60051),symbolReference:(0,r.$Kj)("symbol-reference",60052),goToFile:(0,r.$Kj)("go-to-file",60052),symbolEnum:(0,r.$Kj)("symbol-enum",60053),symbolValue:(0,r.$Kj)("symbol-value",60053),symbolRuler:(0,r.$Kj)("symbol-ruler",60054),symbolUnit:(0,r.$Kj)("symbol-unit",60054),activateBreakpoints:(0,r.$Kj)("activate-breakpoints",60055),archive:(0,r.$Kj)("archive",60056),arrowBoth:(0,r.$Kj)("arrow-both",60057),arrowDown:(0,r.$Kj)("arrow-down",60058),arrowLeft:(0,r.$Kj)("arrow-left",60059),arrowRight:(0,r.$Kj)("arrow-right",60060),arrowSmallDown:(0,r.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Kj)("arrow-small-up",60064),arrowUp:(0,r.$Kj)("arrow-up",60065),bell:(0,r.$Kj)("bell",60066),bold:(0,r.$Kj)("bold",60067),book:(0,r.$Kj)("book",60068),bookmark:(0,r.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Kj)("briefcase",60076),broadcast:(0,r.$Kj)("broadcast",60077),browser:(0,r.$Kj)("browser",60078),bug:(0,r.$Kj)("bug",60079),calendar:(0,r.$Kj)("calendar",60080),caseSensitive:(0,r.$Kj)("case-sensitive",60081),check:(0,r.$Kj)("check",60082),checklist:(0,r.$Kj)("checklist",60083),chevronDown:(0,r.$Kj)("chevron-down",60084),chevronLeft:(0,r.$Kj)("chevron-left",60085),chevronRight:(0,r.$Kj)("chevron-right",60086),chevronUp:(0,r.$Kj)("chevron-up",60087),chromeClose:(0,r.$Kj)("chrome-close",60088),chromeMaximize:(0,r.$Kj)("chrome-maximize",60089),chromeMinimize:(0,r.$Kj)("chrome-minimize",60090),chromeRestore:(0,r.$Kj)("chrome-restore",60091),circleOutline:(0,r.$Kj)("circle-outline",60092),circle:(0,r.$Kj)("circle",60092),debugBreakpointUnverified:(0,r.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Kj)("circle-slash",60093),circuitBoard:(0,r.$Kj)("circuit-board",60094),clearAll:(0,r.$Kj)("clear-all",60095),clippy:(0,r.$Kj)("clippy",60096),closeAll:(0,r.$Kj)("close-all",60097),cloudDownload:(0,r.$Kj)("cloud-download",60098),cloudUpload:(0,r.$Kj)("cloud-upload",60099),code:(0,r.$Kj)("code",60100),collapseAll:(0,r.$Kj)("collapse-all",60101),colorMode:(0,r.$Kj)("color-mode",60102),commentDiscussion:(0,r.$Kj)("comment-discussion",60103),creditCard:(0,r.$Kj)("credit-card",60105),dash:(0,r.$Kj)("dash",60108),dashboard:(0,r.$Kj)("dashboard",60109),database:(0,r.$Kj)("database",60110),debugContinue:(0,r.$Kj)("debug-continue",60111),debugDisconnect:(0,r.$Kj)("debug-disconnect",60112),debugPause:(0,r.$Kj)("debug-pause",60113),debugRestart:(0,r.$Kj)("debug-restart",60114),debugStart:(0,r.$Kj)("debug-start",60115),debugStepInto:(0,r.$Kj)("debug-step-into",60116),debugStepOut:(0,r.$Kj)("debug-step-out",60117),debugStepOver:(0,r.$Kj)("debug-step-over",60118),debugStop:(0,r.$Kj)("debug-stop",60119),debug:(0,r.$Kj)("debug",60120),deviceCameraVideo:(0,r.$Kj)("device-camera-video",60121),deviceCamera:(0,r.$Kj)("device-camera",60122),deviceMobile:(0,r.$Kj)("device-mobile",60123),diffAdded:(0,r.$Kj)("diff-added",60124),diffIgnored:(0,r.$Kj)("diff-ignored",60125),diffModified:(0,r.$Kj)("diff-modified",60126),diffRemoved:(0,r.$Kj)("diff-removed",60127),diffRenamed:(0,r.$Kj)("diff-renamed",60128),diff:(0,r.$Kj)("diff",60129),diffSidebyside:(0,r.$Kj)("diff-sidebyside",60129),discard:(0,r.$Kj)("discard",60130),editorLayout:(0,r.$Kj)("editor-layout",60131),emptyWindow:(0,r.$Kj)("empty-window",60132),exclude:(0,r.$Kj)("exclude",60133),extensions:(0,r.$Kj)("extensions",60134),eyeClosed:(0,r.$Kj)("eye-closed",60135),fileBinary:(0,r.$Kj)("file-binary",60136),fileCode:(0,r.$Kj)("file-code",60137),fileMedia:(0,r.$Kj)("file-media",60138),filePdf:(0,r.$Kj)("file-pdf",60139),fileSubmodule:(0,r.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Kj)("file-symlink-file",60142),fileZip:(0,r.$Kj)("file-zip",60143),files:(0,r.$Kj)("files",60144),filter:(0,r.$Kj)("filter",60145),flame:(0,r.$Kj)("flame",60146),foldDown:(0,r.$Kj)("fold-down",60147),foldUp:(0,r.$Kj)("fold-up",60148),fold:(0,r.$Kj)("fold",60149),folderActive:(0,r.$Kj)("folder-active",60150),folderOpened:(0,r.$Kj)("folder-opened",60151),gear:(0,r.$Kj)("gear",60152),gift:(0,r.$Kj)("gift",60153),gistSecret:(0,r.$Kj)("gist-secret",60154),gist:(0,r.$Kj)("gist",60155),gitCommit:(0,r.$Kj)("git-commit",60156),gitCompare:(0,r.$Kj)("git-compare",60157),compareChanges:(0,r.$Kj)("compare-changes",60157),gitMerge:(0,r.$Kj)("git-merge",60158),githubAction:(0,r.$Kj)("github-action",60159),githubAlt:(0,r.$Kj)("github-alt",60160),globe:(0,r.$Kj)("globe",60161),grabber:(0,r.$Kj)("grabber",60162),graph:(0,r.$Kj)("graph",60163),gripper:(0,r.$Kj)("gripper",60164),heart:(0,r.$Kj)("heart",60165),home:(0,r.$Kj)("home",60166),horizontalRule:(0,r.$Kj)("horizontal-rule",60167),hubot:(0,r.$Kj)("hubot",60168),inbox:(0,r.$Kj)("inbox",60169),issueReopened:(0,r.$Kj)("issue-reopened",60171),issues:(0,r.$Kj)("issues",60172),italic:(0,r.$Kj)("italic",60173),jersey:(0,r.$Kj)("jersey",60174),json:(0,r.$Kj)("json",60175),kebabVertical:(0,r.$Kj)("kebab-vertical",60176),key:(0,r.$Kj)("key",60177),law:(0,r.$Kj)("law",60178),lightbulbAutofix:(0,r.$Kj)("lightbulb-autofix",60179),linkExternal:(0,r.$Kj)("link-external",60180),link:(0,r.$Kj)("link",60181),listOrdered:(0,r.$Kj)("list-ordered",60182),listUnordered:(0,r.$Kj)("list-unordered",60183),liveShare:(0,r.$Kj)("live-share",60184),loading:(0,r.$Kj)("loading",60185),location:(0,r.$Kj)("location",60186),mailRead:(0,r.$Kj)("mail-read",60187),mail:(0,r.$Kj)("mail",60188),markdown:(0,r.$Kj)("markdown",60189),megaphone:(0,r.$Kj)("megaphone",60190),mention:(0,r.$Kj)("mention",60191),milestone:(0,r.$Kj)("milestone",60192),gitPullRequestMilestone:(0,r.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Kj)("mortar-board",60193),move:(0,r.$Kj)("move",60194),multipleWindows:(0,r.$Kj)("multiple-windows",60195),mute:(0,r.$Kj)("mute",60196),noNewline:(0,r.$Kj)("no-newline",60197),note:(0,r.$Kj)("note",60198),octoface:(0,r.$Kj)("octoface",60199),openPreview:(0,r.$Kj)("open-preview",60200),package:(0,r.$Kj)("package",60201),paintcan:(0,r.$Kj)("paintcan",60202),pin:(0,r.$Kj)("pin",60203),play:(0,r.$Kj)("play",60204),run:(0,r.$Kj)("run",60204),plug:(0,r.$Kj)("plug",60205),preserveCase:(0,r.$Kj)("preserve-case",60206),preview:(0,r.$Kj)("preview",60207),project:(0,r.$Kj)("project",60208),pulse:(0,r.$Kj)("pulse",60209),question:(0,r.$Kj)("question",60210),quote:(0,r.$Kj)("quote",60211),radioTower:(0,r.$Kj)("radio-tower",60212),reactions:(0,r.$Kj)("reactions",60213),references:(0,r.$Kj)("references",60214),refresh:(0,r.$Kj)("refresh",60215),regex:(0,r.$Kj)("regex",60216),remoteExplorer:(0,r.$Kj)("remote-explorer",60217),remote:(0,r.$Kj)("remote",60218),remove:(0,r.$Kj)("remove",60219),replaceAll:(0,r.$Kj)("replace-all",60220),replace:(0,r.$Kj)("replace",60221),repoClone:(0,r.$Kj)("repo-clone",60222),repoForcePush:(0,r.$Kj)("repo-force-push",60223),repoPull:(0,r.$Kj)("repo-pull",60224),repoPush:(0,r.$Kj)("repo-push",60225),report:(0,r.$Kj)("report",60226),requestChanges:(0,r.$Kj)("request-changes",60227),rocket:(0,r.$Kj)("rocket",60228),rootFolderOpened:(0,r.$Kj)("root-folder-opened",60229),rootFolder:(0,r.$Kj)("root-folder",60230),rss:(0,r.$Kj)("rss",60231),ruby:(0,r.$Kj)("ruby",60232),saveAll:(0,r.$Kj)("save-all",60233),saveAs:(0,r.$Kj)("save-as",60234),save:(0,r.$Kj)("save",60235),screenFull:(0,r.$Kj)("screen-full",60236),screenNormal:(0,r.$Kj)("screen-normal",60237),searchStop:(0,r.$Kj)("search-stop",60238),server:(0,r.$Kj)("server",60240),settingsGear:(0,r.$Kj)("settings-gear",60241),settings:(0,r.$Kj)("settings",60242),shield:(0,r.$Kj)("shield",60243),smiley:(0,r.$Kj)("smiley",60244),sortPrecedence:(0,r.$Kj)("sort-precedence",60245),splitHorizontal:(0,r.$Kj)("split-horizontal",60246),splitVertical:(0,r.$Kj)("split-vertical",60247),squirrel:(0,r.$Kj)("squirrel",60248),starFull:(0,r.$Kj)("star-full",60249),starHalf:(0,r.$Kj)("star-half",60250),symbolClass:(0,r.$Kj)("symbol-class",60251),symbolColor:(0,r.$Kj)("symbol-color",60252),symbolConstant:(0,r.$Kj)("symbol-constant",60253),symbolEnumMember:(0,r.$Kj)("symbol-enum-member",60254),symbolField:(0,r.$Kj)("symbol-field",60255),symbolFile:(0,r.$Kj)("symbol-file",60256),symbolInterface:(0,r.$Kj)("symbol-interface",60257),symbolKeyword:(0,r.$Kj)("symbol-keyword",60258),symbolMisc:(0,r.$Kj)("symbol-misc",60259),symbolOperator:(0,r.$Kj)("symbol-operator",60260),symbolProperty:(0,r.$Kj)("symbol-property",60261),wrench:(0,r.$Kj)("wrench",60261),wrenchSubaction:(0,r.$Kj)("wrench-subaction",60261),symbolSnippet:(0,r.$Kj)("symbol-snippet",60262),tasklist:(0,r.$Kj)("tasklist",60263),telescope:(0,r.$Kj)("telescope",60264),textSize:(0,r.$Kj)("text-size",60265),threeBars:(0,r.$Kj)("three-bars",60266),thumbsdown:(0,r.$Kj)("thumbsdown",60267),thumbsup:(0,r.$Kj)("thumbsup",60268),tools:(0,r.$Kj)("tools",60269),triangleDown:(0,r.$Kj)("triangle-down",60270),triangleLeft:(0,r.$Kj)("triangle-left",60271),triangleRight:(0,r.$Kj)("triangle-right",60272),triangleUp:(0,r.$Kj)("triangle-up",60273),twitter:(0,r.$Kj)("twitter",60274),unfold:(0,r.$Kj)("unfold",60275),unlock:(0,r.$Kj)("unlock",60276),unmute:(0,r.$Kj)("unmute",60277),unverified:(0,r.$Kj)("unverified",60278),verified:(0,r.$Kj)("verified",60279),versions:(0,r.$Kj)("versions",60280),vmActive:(0,r.$Kj)("vm-active",60281),vmOutline:(0,r.$Kj)("vm-outline",60282),vmRunning:(0,r.$Kj)("vm-running",60283),watch:(0,r.$Kj)("watch",60284),whitespace:(0,r.$Kj)("whitespace",60285),wholeWord:(0,r.$Kj)("whole-word",60286),window:(0,r.$Kj)("window",60287),wordWrap:(0,r.$Kj)("word-wrap",60288),zoomIn:(0,r.$Kj)("zoom-in",60289),zoomOut:(0,r.$Kj)("zoom-out",60290),listFilter:(0,r.$Kj)("list-filter",60291),listFlat:(0,r.$Kj)("list-flat",60292),listSelection:(0,r.$Kj)("list-selection",60293),selection:(0,r.$Kj)("selection",60293),listTree:(0,r.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Kj)("symbol-string",60301),debugReverseContinue:(0,r.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Kj)("debug-step-back",60303),debugRestartFrame:(0,r.$Kj)("debug-restart-frame",60304),debugAlt:(0,r.$Kj)("debug-alt",60305),callIncoming:(0,r.$Kj)("call-incoming",60306),callOutgoing:(0,r.$Kj)("call-outgoing",60307),menu:(0,r.$Kj)("menu",60308),expandAll:(0,r.$Kj)("expand-all",60309),feedback:(0,r.$Kj)("feedback",60310),gitPullRequestReviewer:(0,r.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Kj)("ungroup-by-ref-type",60312),account:(0,r.$Kj)("account",60313),gitPullRequestAssignee:(0,r.$Kj)("git-pull-request-assignee",60313),bellDot:(0,r.$Kj)("bell-dot",60314),debugConsole:(0,r.$Kj)("debug-console",60315),library:(0,r.$Kj)("library",60316),output:(0,r.$Kj)("output",60317),runAll:(0,r.$Kj)("run-all",60318),syncIgnored:(0,r.$Kj)("sync-ignored",60319),pinned:(0,r.$Kj)("pinned",60320),githubInverted:(0,r.$Kj)("github-inverted",60321),serverProcess:(0,r.$Kj)("server-process",60322),serverEnvironment:(0,r.$Kj)("server-environment",60323),pass:(0,r.$Kj)("pass",60324),issueClosed:(0,r.$Kj)("issue-closed",60324),stopCircle:(0,r.$Kj)("stop-circle",60325),playCircle:(0,r.$Kj)("play-circle",60326),record:(0,r.$Kj)("record",60327),debugAltSmall:(0,r.$Kj)("debug-alt-small",60328),vmConnect:(0,r.$Kj)("vm-connect",60329),cloud:(0,r.$Kj)("cloud",60330),merge:(0,r.$Kj)("merge",60331),export:(0,r.$Kj)("export",60332),graphLeft:(0,r.$Kj)("graph-left",60333),magnet:(0,r.$Kj)("magnet",60334),notebook:(0,r.$Kj)("notebook",60335),redo:(0,r.$Kj)("redo",60336),checkAll:(0,r.$Kj)("check-all",60337),pinnedDirty:(0,r.$Kj)("pinned-dirty",60338),passFilled:(0,r.$Kj)("pass-filled",60339),circleLargeFilled:(0,r.$Kj)("circle-large-filled",60340),circleLarge:(0,r.$Kj)("circle-large",60341),circleLargeOutline:(0,r.$Kj)("circle-large-outline",60341),combine:(0,r.$Kj)("combine",60342),gather:(0,r.$Kj)("gather",60342),table:(0,r.$Kj)("table",60343),variableGroup:(0,r.$Kj)("variable-group",60344),typeHierarchy:(0,r.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Kj)("git-pull-request-create",60348),runAbove:(0,r.$Kj)("run-above",60349),runBelow:(0,r.$Kj)("run-below",60350),notebookTemplate:(0,r.$Kj)("notebook-template",60351),debugRerun:(0,r.$Kj)("debug-rerun",60352),workspaceTrusted:(0,r.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Kj)("workspace-unknown",60355),terminalCmd:(0,r.$Kj)("terminal-cmd",60356),terminalDebian:(0,r.$Kj)("terminal-debian",60357),terminalLinux:(0,r.$Kj)("terminal-linux",60358),terminalPowershell:(0,r.$Kj)("terminal-powershell",60359),terminalTmux:(0,r.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Kj)("terminal-ubuntu",60361),terminalBash:(0,r.$Kj)("terminal-bash",60362),arrowSwap:(0,r.$Kj)("arrow-swap",60363),copy:(0,r.$Kj)("copy",60364),personAdd:(0,r.$Kj)("person-add",60365),filterFilled:(0,r.$Kj)("filter-filled",60366),wand:(0,r.$Kj)("wand",60367),debugLineByLine:(0,r.$Kj)("debug-line-by-line",60368),inspect:(0,r.$Kj)("inspect",60369),layers:(0,r.$Kj)("layers",60370),layersDot:(0,r.$Kj)("layers-dot",60371),layersActive:(0,r.$Kj)("layers-active",60372),compass:(0,r.$Kj)("compass",60373),compassDot:(0,r.$Kj)("compass-dot",60374),compassActive:(0,r.$Kj)("compass-active",60375),azure:(0,r.$Kj)("azure",60376),issueDraft:(0,r.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Kj)("git-pull-request-draft",60379),debugAll:(0,r.$Kj)("debug-all",60380),debugCoverage:(0,r.$Kj)("debug-coverage",60381),runErrors:(0,r.$Kj)("run-errors",60382),folderLibrary:(0,r.$Kj)("folder-library",60383),debugContinueSmall:(0,r.$Kj)("debug-continue-small",60384),beakerStop:(0,r.$Kj)("beaker-stop",60385),graphLine:(0,r.$Kj)("graph-line",60386),graphScatter:(0,r.$Kj)("graph-scatter",60387),pieChart:(0,r.$Kj)("pie-chart",60388),bracket:(0,r.$Kj)("bracket",60175),bracketDot:(0,r.$Kj)("bracket-dot",60389),bracketError:(0,r.$Kj)("bracket-error",60390),lockSmall:(0,r.$Kj)("lock-small",60391),azureDevops:(0,r.$Kj)("azure-devops",60392),verifiedFilled:(0,r.$Kj)("verified-filled",60393),newline:(0,r.$Kj)("newline",60394),layout:(0,r.$Kj)("layout",60395),layoutActivitybarLeft:(0,r.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Kj)("layout-panel-right",60401),layoutPanel:(0,r.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Kj)("layout-statusbar",60405),layoutMenubar:(0,r.$Kj)("layout-menubar",60406),layoutCentered:(0,r.$Kj)("layout-centered",60407),target:(0,r.$Kj)("target",60408),indent:(0,r.$Kj)("indent",60409),recordSmall:(0,r.$Kj)("record-small",60410),errorSmall:(0,r.$Kj)("error-small",60411),terminalDecorationError:(0,r.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Kj)("layout-sidebar-left-off",60418),blank:(0,r.$Kj)("blank",60419),heartFilled:(0,r.$Kj)("heart-filled",60420),map:(0,r.$Kj)("map",60421),mapHorizontal:(0,r.$Kj)("map-horizontal",60421),foldHorizontal:(0,r.$Kj)("fold-horizontal",60421),mapFilled:(0,r.$Kj)("map-filled",60422),mapHorizontalFilled:(0,r.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Kj)("circle-small",60423),bellSlash:(0,r.$Kj)("bell-slash",60424),bellSlashDot:(0,r.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Kj)("search-fuzzy",60429),commentDraft:(0,r.$Kj)("comment-draft",60430),send:(0,r.$Kj)("send",60431),sparkle:(0,r.$Kj)("sparkle",60432),insert:(0,r.$Kj)("insert",60433),mic:(0,r.$Kj)("mic",60434),thumbsdownFilled:(0,r.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Kj)("thumbsup-filled",60436),coffee:(0,r.$Kj)("coffee",60437),snake:(0,r.$Kj)("snake",60438),game:(0,r.$Kj)("game",60439),vr:(0,r.$Kj)("vr",60440),chip:(0,r.$Kj)("chip",60441),piano:(0,r.$Kj)("piano",60442),music:(0,r.$Kj)("music",60443),micFilled:(0,r.$Kj)("mic-filled",60444),repoFetch:(0,r.$Kj)("repo-fetch",60445),copilot:(0,r.$Kj)("copilot",60446),lightbulbSparkle:(0,r.$Kj)("lightbulb-sparkle",60447),robot:(0,r.$Kj)("robot",60448),sparkleFilled:(0,r.$Kj)("sparkle-filled",60449),diffSingle:(0,r.$Kj)("diff-single",60450),diffMultiple:(0,r.$Kj)("diff-multiple",60451),surroundWith:(0,r.$Kj)("surround-with",60452),share:(0,r.$Kj)("share",60453),gitStash:(0,r.$Kj)("git-stash",60454),gitStashApply:(0,r.$Kj)("git-stash-apply",60455),gitStashPop:(0,r.$Kj)("git-stash-pop",60456),vscode:(0,r.$Kj)("vscode",60457),vscodeInsiders:(0,r.$Kj)("vscode-insiders",60458),codeOss:(0,r.$Kj)("code-oss",60459),runCoverage:(0,r.$Kj)("run-coverage",60460),runAllCoverage:(0,r.$Kj)("run-all-coverage",60461),coverage:(0,r.$Kj)("coverage",60462),githubProject:(0,r.$Kj)("github-project",60463),mapVertical:(0,r.$Kj)("map-vertical",60464),foldVertical:(0,r.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Kj)("fold-vertical-filled",60465),goToSearch:(0,r.$Kj)("go-to-search",60466),percentage:(0,r.$Kj)("percentage",60467),sortPercentage:(0,r.$Kj)("sort-percentage",60467)}}),ie(se[43],ue([0,1,27,42]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=t.$Oj=void 0,t.$Nj=M;function M(){return Object.values(t.$Pj)}t.$Oj={dialogError:(0,r.$Kj)("dialog-error","error"),dialogWarning:(0,r.$Kj)("dialog-warning","warning"),dialogInfo:(0,r.$Kj)("dialog-info","info"),dialogClose:(0,r.$Kj)("dialog-close","close"),treeItemExpanded:(0,r.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Kj)("tree-item-loading","loading"),menuSelection:(0,r.$Kj)("menu-selection","check"),menuSubmenu:(0,r.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Kj)("toolbar-more","more"),quickInputBack:(0,r.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Kj)("drop-down-button",60084),symbolCustomColor:(0,r.$Kj)("symbol-customcolor",60252),exportIcon:(0,r.$Kj)("export",60332),workspaceUnspecified:(0,r.$Kj)("workspace-unspecified",60355),newLine:(0,r.$Kj)("newline",60394),thumbsDownFilled:(0,r.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Kj)("thumbsup-filled",60436),gitFetch:(0,r.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Kj)("debug-breakpoint-pending",60377)},t.$Pj={...y.$Mj,...t.$Oj}}),ie(se[15],ue([0,1,26]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wn=y,t.$Xn=M,t.$Yn=j,t.$Zn=l,t.$1n=s,t.$2n=c,t.$3n=L,t.$4n=g,t.$5n=m,t.$6n=e,t.$7n=N,t.$8n=E;function y(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const w=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([$,o])=>{w[$]=o&&typeof o=="object"?y(o):o}),w}function M(p){if(!p||typeof p!="object")return p;const w=[p];for(;w.length>0;){const $=w.shift();Object.freeze($);for(const o in $)if(f.call($,o)){const u=$[o];typeof u=="object"&&!Object.isFrozen(u)&&!(0,r.$7f)(u)&&w.push(u)}}return p}const f=Object.prototype.hasOwnProperty;function j(p,w){return h(p,w,new Set)}function h(p,w,$){if((0,r.$ag)(p))return p;const o=w(p);if(typeof o<"u")return o;if(Array.isArray(p)){const u=[];for(const i of p)u.push(h(i,w,$));return u}if((0,r.$6f)(p)){if($.has(p))throw new Error("Cannot clone recursive data-structure");$.add(p);const u={};for(const i in p)f.call(p,i)&&(u[i]=h(p[i],w,$));return $.delete(p),u}return p}function l(p,w,$=!0){return(0,r.$6f)(p)?((0,r.$6f)(w)&&Object.keys(w).forEach(o=>{o in p?$&&((0,r.$6f)(p[o])&&(0,r.$6f)(w[o])?l(p[o],w[o],$):p[o]=w[o]):p[o]=w[o]}),p):w}function s(p,w){if(p===w)return!0;if(p==null||w===null||w===void 0||typeof p!=typeof w||typeof p!="object"||Array.isArray(p)!==Array.isArray(w))return!1;let $,o;if(Array.isArray(p)){if(p.length!==w.length)return!1;for($=0;$<p.length;$++)if(!s(p[$],w[$]))return!1}else{const u=[];for(o in p)u.push(o);u.sort();const i=[];for(o in w)i.push(o);if(i.sort(),!s(u,i))return!1;for($=0;$<u.length;$++)if(!s(p[u[$]],w[u[$]]))return!1}return!0}function c(p){const w=new Set;return JSON.stringify(p,($,o)=>{if((0,r.$6f)(o)||Array.isArray(o)){if(w.has(o))return"[Circular]";w.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function L(p,w){const $=Object.create(null);return!p||!w||Object.keys(w).forEach(u=>{const i=p[u],a=w[u];s(i,a)||($[u]=a)}),$}function g(p,w){const $=w.toLowerCase(),o=Object.keys(p).find(u=>u.toLowerCase()===$);return o?p[o]:p[w]}function m(p,w){const $=Object.create(null);for(const[o,u]of Object.entries(p))w(o,u)&&($[o]=u);return $}function e(p){let w=[];for(;Object.prototype!==p;)w=w.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return w}function N(p){const w=[];for(const $ of e(p))typeof p[$]=="function"&&w.push($);return w}function E(p,w){const $=u=>function(){const i=Array.prototype.slice.call(arguments,0);return w(u,i)},o={};for(const u of p)o[u]=$(u);return o}}),ie(se[28],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$1e=y,t.$2e=M;var r;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(t.Constants=r={}));function y(f){return f<0?0:f>255?255:f|0}function M(f){return f<0?0:f>4294967295?4294967295:f|0}}),ie(se[29],ue([0,1,28]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=t.$yt=void 0;class y{constructor(h){const l=(0,r.$1e)(h);this.c=l,this.a=y.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const s=(0,r.$1e)(l);h>=0&&h<256?this.a[h]=s:this.b.set(h,s)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$yt=y;var M;(function(j){j[j.False=0]="False",j[j.True=1]="True"})(M||(M={}));class f{constructor(){this.a=new y(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$zt=f}),ie(se[4],ue([0,1,3]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$st=t.$rt=void 0;class y{static addRange(j,h){let l=0;for(;l<h.length&&h[l].endExclusive<j.start;)l++;let s=l;for(;s<h.length&&h[s].start<=j.endExclusive;)s++;if(l===s)h.splice(l,0,j);else{const c=Math.min(j.start,h[l].start),L=Math.max(j.endExclusive,h[s-1].endExclusive);h.splice(l,s-l,new y(c,L))}}static tryCreate(j,h){if(!(j>h))return new y(j,h)}static ofLength(j){return new y(0,j)}static ofStartAndLength(j,h){return new y(j,j+h)}constructor(j,h){if(this.start=j,this.endExclusive=h,j>h)throw new r.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(j){return new y(this.start+j,this.endExclusive+j)}deltaStart(j){return new y(this.start+j,this.endExclusive)}deltaEnd(j){return new y(this.start,this.endExclusive+j)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(j){return this.start===j.start&&this.endExclusive===j.endExclusive}containsRange(j){return this.start<=j.start&&j.endExclusive<=this.endExclusive}contains(j){return this.start<=j&&j<this.endExclusive}join(j){return new y(Math.min(this.start,j.start),Math.max(this.endExclusive,j.endExclusive))}intersect(j){const h=Math.max(this.start,j.start),l=Math.min(this.endExclusive,j.endExclusive);if(h<=l)return new y(h,l)}intersects(j){const h=Math.max(this.start,j.start),l=Math.min(this.endExclusive,j.endExclusive);return h<l}intersectsOrTouches(j){const h=Math.max(this.start,j.start),l=Math.min(this.endExclusive,j.endExclusive);return h<=l}isBefore(j){return this.endExclusive<=j.start}isAfter(j){return this.start>=j.endExclusive}slice(j){return j.slice(this.start,this.endExclusive)}substring(j){return j.substring(this.start,this.endExclusive)}clip(j){if(this.isEmpty)throw new r.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,j))}clipCyclic(j){if(this.isEmpty)throw new r.$cb(`Invalid clipping range: ${this.toString()}`);return j<this.start?this.endExclusive-(this.start-j)%this.length:j>=this.endExclusive?this.start+(j-this.start)%this.length:j}map(j){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(j(l));return h}forEach(j){for(let h=this.start;h<this.endExclusive;h++)j(h)}}t.$rt=y;class M{constructor(){this.a=[]}addRange(j){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<j.start;)h++;let l=h;for(;l<this.a.length&&this.a[l].start<=j.endExclusive;)l++;if(h===l)this.a.splice(h,0,j);else{const s=Math.min(j.start,this.a[h].start),c=Math.max(j.endExclusive,this.a[l-1].endExclusive);this.a.splice(h,l-h,new y(s,c))}}toString(){return this.a.map(j=>j.toString()).join(", ")}intersectsStrict(j){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=j.start;)h++;return h<this.a.length&&this.a[h].start<j.endExclusive}intersectWithRange(j){const h=new M;for(const l of this.a){const s=l.intersect(j);s&&h.addRange(s)}return h}intersectWithRangeLength(j){return this.intersectWithRange(j).length}get length(){return this.a.reduce((j,h)=>j+h.length,0)}}t.$st=M}),ie(se[5],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jt=void 0;class r{constructor(M,f){this.lineNumber=M,this.column=f}with(M=this.lineNumber,f=this.column){return M===this.lineNumber&&f===this.column?this:new r(M,f)}delta(M=0,f=0){return this.with(this.lineNumber+M,this.column+f)}equals(M){return r.equals(this,M)}static equals(M,f){return!M&&!f?!0:!!M&&!!f&&M.lineNumber===f.lineNumber&&M.column===f.column}isBefore(M){return r.isBefore(this,M)}static isBefore(M,f){return M.lineNumber<f.lineNumber?!0:f.lineNumber<M.lineNumber?!1:M.column<f.column}isBeforeOrEqual(M){return r.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,f){return M.lineNumber<f.lineNumber?!0:f.lineNumber<M.lineNumber?!1:M.column<=f.column}static compare(M,f){const j=M.lineNumber|0,h=f.lineNumber|0;if(j===h){const l=M.column|0,s=f.column|0;return l-s}return j-h}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new r(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$jt=r}),ie(se[2],ue([0,1,5]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=void 0;class y{constructor(f,j,h,l){f>h||f===h&&j>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=f,this.endColumn=j):(this.startLineNumber=f,this.startColumn=j,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return y.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return y.containsPosition(this,f)}static containsPosition(f,j){return!(j.lineNumber<f.startLineNumber||j.lineNumber>f.endLineNumber||j.lineNumber===f.startLineNumber&&j.column<f.startColumn||j.lineNumber===f.endLineNumber&&j.column>f.endColumn)}static strictContainsPosition(f,j){return!(j.lineNumber<f.startLineNumber||j.lineNumber>f.endLineNumber||j.lineNumber===f.startLineNumber&&j.column<=f.startColumn||j.lineNumber===f.endLineNumber&&j.column>=f.endColumn)}containsRange(f){return y.containsRange(this,f)}static containsRange(f,j){return!(j.startLineNumber<f.startLineNumber||j.endLineNumber<f.startLineNumber||j.startLineNumber>f.endLineNumber||j.endLineNumber>f.endLineNumber||j.startLineNumber===f.startLineNumber&&j.startColumn<f.startColumn||j.endLineNumber===f.endLineNumber&&j.endColumn>f.endColumn)}strictContainsRange(f){return y.strictContainsRange(this,f)}static strictContainsRange(f,j){return!(j.startLineNumber<f.startLineNumber||j.endLineNumber<f.startLineNumber||j.startLineNumber>f.endLineNumber||j.endLineNumber>f.endLineNumber||j.startLineNumber===f.startLineNumber&&j.startColumn<=f.startColumn||j.endLineNumber===f.endLineNumber&&j.endColumn>=f.endColumn)}plusRange(f){return y.plusRange(this,f)}static plusRange(f,j){let h,l,s,c;return j.startLineNumber<f.startLineNumber?(h=j.startLineNumber,l=j.startColumn):j.startLineNumber===f.startLineNumber?(h=j.startLineNumber,l=Math.min(j.startColumn,f.startColumn)):(h=f.startLineNumber,l=f.startColumn),j.endLineNumber>f.endLineNumber?(s=j.endLineNumber,c=j.endColumn):j.endLineNumber===f.endLineNumber?(s=j.endLineNumber,c=Math.max(j.endColumn,f.endColumn)):(s=f.endLineNumber,c=f.endColumn),new y(h,l,s,c)}intersectRanges(f){return y.intersectRanges(this,f)}static intersectRanges(f,j){let h=f.startLineNumber,l=f.startColumn,s=f.endLineNumber,c=f.endColumn;const L=j.startLineNumber,g=j.startColumn,m=j.endLineNumber,e=j.endColumn;return h<L?(h=L,l=g):h===L&&(l=Math.max(l,g)),s>m?(s=m,c=e):s===m&&(c=Math.min(c,e)),h>s||h===s&&l>c?null:new y(h,l,s,c)}equalsRange(f){return y.equalsRange(this,f)}static equalsRange(f,j){return!f&&!j?!0:!!f&&!!j&&f.startLineNumber===j.startLineNumber&&f.startColumn===j.startColumn&&f.endLineNumber===j.endLineNumber&&f.endColumn===j.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(f){return new r.$jt(f.endLineNumber,f.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(f){return new r.$jt(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,j){return new y(this.startLineNumber,this.startColumn,f,j)}setStartPosition(f,j){return new y(f,j,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(f){return new y(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return y.collapseToEnd(this)}static collapseToEnd(f){return new y(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new y(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,j=f){return new y(f.lineNumber,f.column,j.lineNumber,j.column)}static lift(f){return f?new y(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,j){return!(f.endLineNumber<j.startLineNumber||f.endLineNumber===j.startLineNumber&&f.endColumn<j.startColumn||j.endLineNumber<f.startLineNumber||j.endLineNumber===f.startLineNumber&&j.endColumn<f.startColumn)}static areIntersecting(f,j){return!(f.endLineNumber<j.startLineNumber||f.endLineNumber===j.startLineNumber&&f.endColumn<=j.startColumn||j.endLineNumber<f.startLineNumber||j.endLineNumber===f.startLineNumber&&j.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,j){if(f&&j){const s=f.startLineNumber|0,c=j.startLineNumber|0;if(s===c){const L=f.startColumn|0,g=j.startColumn|0;if(L===g){const m=f.endLineNumber|0,e=j.endLineNumber|0;if(m===e){const N=f.endColumn|0,E=j.endColumn|0;return N-E}return m-e}return L-g}return s-c}return(f?1:0)-(j?1:0)}static compareRangesUsingEnds(f,j){return f.endLineNumber===j.endLineNumber?f.endColumn===j.endColumn?f.startLineNumber===j.startLineNumber?f.startColumn-j.startColumn:f.startLineNumber-j.startLineNumber:f.endColumn-j.endColumn:f.endLineNumber-j.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$kt=y}),ie(se[44],ue([0,1,2]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=void 0;class y{static insert(f,j){return{range:new r.$kt(f.lineNumber,f.column,f.lineNumber,f.column),text:j,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,j){return{range:f,text:j}}static replaceMove(f,j){return{range:f,text:j,forceMoveMarkers:!0}}}t.$lt=y}),ie(se[12],ue([0,1,3,4,2,9]),function(W,t,r,y,M,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cv=t.$Bv=void 0;class j{static fromRange(s){return new j(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new j(s.startLineNumber,s.endLineNumber+1)}static subtract(s,c){return c?s.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<s.endLineNumberExclusive?[new j(s.startLineNumber,c.startLineNumber),new j(c.endLineNumberExclusive,s.endLineNumberExclusive)]:c.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<s.endLineNumberExclusive?[new j(Math.max(c.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new j(s.startLineNumber,Math.min(c.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let c=new h(s[0].slice());for(let L=1;L<s.length;L++)c=c.getUnion(new h(s[L].slice()));return c.ranges}static join(s){if(s.length===0)throw new r.$cb("lineRanges cannot be empty");let c=s[0].startLineNumber,L=s[0].endLineNumberExclusive;for(let g=1;g<s.length;g++)c=Math.min(c,s[g].startLineNumber),L=Math.max(L,s[g].endLineNumberExclusive);return new j(c,L)}static ofLength(s,c){return new j(s,s+c)}static deserialize(s){return new j(s[0],s[1])}static invert(s,c){if(s.isEmpty)return[];const L=[];return s.startLineNumber>1&&L.push(new j(1,s.startLineNumber)),s.endLineNumberExclusive<c.getLineCount()+1&&L.push(new j(s.endLineNumberExclusive,c.getLineCount()+1)),L.filter(g=>!g.isEmpty)}static asRange(s,c){return s.isEmpty?new M.$kt(s.startLineNumber,1,s.startLineNumber,c.getLineLength(s.startLineNumber)):new M.$kt(s.startLineNumber,1,s.endLineNumberExclusive-1,c.getLineLength(s.endLineNumberExclusive-1))}constructor(s,c){if(s>c)throw new r.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=s,this.endLineNumberExclusive=c}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new j(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new j(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new j(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const c=Math.max(this.startLineNumber,s.startLineNumber),L=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(c<=L)return new j(c,L)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.$kt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.$kt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const c=[];for(let L=this.startLineNumber;L<this.endLineNumberExclusive;L++)c.push(s(L));return c}forEach(s){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)s(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new y.$rt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Bv=j;class h{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const c=(0,f.$kb)(this.c,g=>g.endLineNumberExclusive>=s.startLineNumber),L=(0,f.$ib)(this.c,g=>g.startLineNumber<=s.endLineNumberExclusive)+1;if(c===L)this.c.splice(c,0,s);else if(c===L-1){const g=this.c[c];this.c[c]=g.join(s)}else{const g=this.c[c].join(this.c[L-1]).join(s);this.c.splice(c,L-c,g)}}contains(s){const c=(0,f.$hb)(this.c,L=>L.startLineNumber<=s);return!!c&&c.endLineNumberExclusive>s}intersects(s){const c=(0,f.$hb)(this.c,L=>L.startLineNumber<s.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const c=[];let L=0,g=0,m=null;for(;L<this.c.length||g<s.c.length;){let e=null;if(L<this.c.length&&g<s.c.length){const N=this.c[L],E=s.c[g];N.startLineNumber<E.startLineNumber?(e=N,L++):(e=E,g++)}else L<this.c.length?(e=this.c[L],L++):(e=s.c[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new j(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new h(c)}subtractFrom(s){const c=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),L=(0,f.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(c===L)return new h([s]);const g=[];let m=s.startLineNumber;for(let e=c;e<L;e++){const N=this.c[e];N.startLineNumber>m&&g.push(new j(m,N.startLineNumber)),m=N.endLineNumberExclusive}return m<s.endLineNumberExclusive&&g.push(new j(m,s.endLineNumberExclusive)),new h(g)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const c=[];let L=0,g=0;for(;L<this.c.length&&g<s.c.length;){const m=this.c[L],e=s.c[g],N=m.intersect(e);N&&!N.isEmpty&&c.push(N),m.endLineNumberExclusive<e.endLineNumberExclusive?L++:g++}return new h(c)}getWithDelta(s){return new h(this.c.map(c=>c.delta(s)))}}t.$Cv=h}),ie(se[45],ue([0,1,5,2]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mt=t.SelectionDirection=void 0;var M;(function(j){j[j.LTR=0]="LTR",j[j.RTL=1]="RTL"})(M||(t.SelectionDirection=M={}));class f extends y.$kt{constructor(h,l,s,c){super(h,l,s,c),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,l):new f(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new r.$jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new f(h,l,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new f(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let s=0,c=h.length;s<c;s++)if(!this.selectionsEqual(h[s],l[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,s,c,L){return L===0?new f(h,l,s,c):new f(s,c,h,l)}}t.$mt=f}),ie(se[46],ue([0,1,14,29]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.WordCharacterClass=void 0,t.$Bt=h;var M;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(M||(t.WordCharacterClass=M={}));class f extends y.$yt{constructor(s,c){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=c,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let L=0,g=s.length;L<g;L++)this.set(s.charCodeAt(L),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(s,c){let L=null;for(const g of this.h(s)){if(g.index>c)break;L=g}return L}findNextIntlWordAtOrAfterOffset(s,c){for(const L of this.h(s))if(!(L.index<c))return L;return null}h(s){return this.e?this.f===s?this.g:(this.f=s,this.g=this.j(this.e.segment(s)),this.g):[]}j(s){const c=[];for(const L of s)this.k(L)&&c.push(L);return c}k(s){return!!s.isWordLike}}t.$At=f;const j=new r.$Ec(10);function h(l,s){const c=`${l}/${s.join(",")}`;let L=j.get(c);return L||(L=new f(l,s),j.set(c,L)),L}}),ie(se[30],ue([0,1,21,10,22]),function(W,t,r,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=t.$Vs=void 0,t.$Xs=j,t.$Ys=l,t.$Zs=s,t.$Vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(L=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Vs)L.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.$Ws=f();function j(L){let g=t.$Ws;if(L&&L instanceof RegExp)if(L.global)g=L;else{let m="g";L.ignoreCase&&(m+="i"),L.multiline&&(m+="m"),L.unicode&&(m+="u"),g=new RegExp(L.source,m)}return g.lastIndex=0,g}const h=new M.$5c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(L){const g=h.unshift(L);return(0,y.$Sc)(g)}function s(L,g,m,e,N){if(g=j(g),N||(N=r.Iterable.first(h)),m.length>N.maxLen){let o=L-N.maxLen/2;return o<0?o=0:e+=o,m=m.substring(o,L+N.maxLen/2),s(L,g,m,e,N)}const E=Date.now(),p=L-1-e;let w=-1,$=null;for(let o=1;!(Date.now()-E>=N.timeBudget);o++){const u=p-N.windowSize*o;g.lastIndex=Math.max(0,u);const i=c(g,m,p,w);if(!i&&$||($=i,u<=0))break;w=u}if($){const o={word:$[0],startColumn:e+1+$.index,endColumn:e+1+$.index+$[0].length};return g.lastIndex=0,o}return null}function c(L,g,m,e){let N;for(;N=L.exec(g);){const E=N.index||0;if(E<=m&&L.lastIndex>=m)return N;if(e>0&&E>e)return null}return null}}),ie(se[8],ue([0,1,6,3,4]),function(W,t,r,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a3=t.$_2=t.$$2=t.$02=t.$92=void 0;class f{static trivial(L,g){return new f([new j(M.$rt.ofLength(L.length),M.$rt.ofLength(g.length))],!1)}static trivialTimedOut(L,g){return new f([new j(M.$rt.ofLength(L.length),M.$rt.ofLength(g.length))],!0)}constructor(L,g){this.diffs=L,this.hitTimeout=g}}t.$92=f;class j{static invert(L,g){const m=[];return(0,r.$Bb)(L,(e,N)=>{m.push(j.fromOffsetPairs(e?e.getEndExclusives():h.zero,N?N.getStarts():new h(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(L,g){return new j(new M.$rt(L.offset1,g.offset1),new M.$rt(L.offset2,g.offset2))}constructor(L,g){this.seq1Range=L,this.seq2Range=g}swap(){return new j(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(L){return new j(this.seq1Range.join(L.seq1Range),this.seq2Range.join(L.seq2Range))}delta(L){return L===0?this:new j(this.seq1Range.delta(L),this.seq2Range.delta(L))}deltaStart(L){return L===0?this:new j(this.seq1Range.deltaStart(L),this.seq2Range.deltaStart(L))}deltaEnd(L){return L===0?this:new j(this.seq1Range.deltaEnd(L),this.seq2Range.deltaEnd(L))}intersectsOrTouches(L){return this.seq1Range.intersectsOrTouches(L.seq1Range)||this.seq2Range.intersectsOrTouches(L.seq2Range)}intersect(L){const g=this.seq1Range.intersect(L.seq1Range),m=this.seq2Range.intersect(L.seq2Range);if(!(!g||!m))return new j(g,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$02=j;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(L,g){this.offset1=L,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(L){return L===0?this:new h(this.offset1+L,this.offset2+L)}equals(L){return this.offset1===L.offset1&&this.offset2===L.offset2}}t.$$2=h;class l{static{this.instance=new l}isValid(){return!0}}t.$_2=l;class s{constructor(L){if(this.e=L,this.c=Date.now(),this.d=!0,L<=0)throw new y.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$a3=s}),ie(se[31],ue([0,1,4,8]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f3=void 0;class M{compute(s,c,L=y.$_2.instance){if(s.length===0||c.length===0)return y.$92.trivial(s,c);const g=s,m=c;function e(a,b){for(;a<g.length&&b<m.length&&g.getElement(a)===m.getElement(b);)a++,b++;return a}let N=0;const E=new j;E.set(0,e(0,0));const p=new h;p.set(0,E.get(0)===0?null:new f(null,0,0,E.get(0)));let w=0;e:for(;;){if(N++,!L.isValid())return y.$92.trivialTimedOut(g,m);const a=-Math.min(N,m.length+N%2),b=Math.min(N,g.length+N%2);for(w=a;w<=b;w+=2){let d=0;const v=w===b?-1:E.get(w+1),A=w===a?-1:E.get(w-1)+1;d++;const R=Math.min(Math.max(v,A),g.length),P=R-w;if(d++,R>g.length||P>m.length)continue;const D=e(R,P);E.set(w,D);const S=R===v?p.get(w+1):p.get(w-1);if(p.set(w,D!==R?new f(S,R,P,D-R):S),E.get(w)===g.length&&E.get(w)-w===m.length)break e}}let $=p.get(w);const o=[];let u=g.length,i=m.length;for(;;){const a=$?$.x+$.length:0,b=$?$.y+$.length:0;if((a!==u||b!==i)&&o.push(new y.$02(new r.$rt(a,u),new r.$rt(b,i))),!$)break;u=$.x,i=$.y,$=$.prev}return o.reverse(),new y.$92(o,!1)}}t.$f3=M;class f{constructor(s,c,L,g){this.prev=s,this.x=c,this.y=L,this.length=g}}class j{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){if(s<0){if(s=-s-1,s>=this.b.length){const L=this.b;this.b=new Int32Array(L.length*2),this.b.set(L)}this.b[s]=c}else{if(s>=this.a.length){const L=this.a;this.a=new Int32Array(L.length*2),this.a.set(L)}this.a[s]=c}}}class h{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){s<0?(s=-s-1,this.b[s]=c):this.a[s]=c}}}),ie(se[47],ue([0,1,6,4,8]),function(W,t,r,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j3=f,t.$k3=s,t.$l3=c,t.$m3=g,t.$n3=m;function f(e,N,E){let p=E;return p=j(e,N,p),p=j(e,N,p),p=h(e,N,p),p}function j(e,N,E){if(E.length===0)return E;const p=[];p.push(E[0]);for(let $=1;$<E.length;$++){const o=p[p.length-1];let u=E[$];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-o.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(u.seq1Range.start-a)!==e.getElement(u.seq1Range.endExclusive-a)||N.getElement(u.seq2Range.start-a)!==N.getElement(u.seq2Range.endExclusive-a));a++);if(a--,a===i){p[p.length-1]=new M.$02(new y.$rt(o.seq1Range.start,u.seq1Range.endExclusive-i),new y.$rt(o.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-a)}p.push(u)}const w=[];for(let $=0;$<p.length-1;$++){const o=p[$+1];let u=p[$];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=o.seq1Range.start-u.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!e.isStronglyEqual(u.seq1Range.start+a,u.seq1Range.endExclusive+a)||!N.isStronglyEqual(u.seq2Range.start+a,u.seq2Range.endExclusive+a));a++);if(a===i){p[$+1]=new M.$02(new y.$rt(u.seq1Range.start+i,o.seq1Range.endExclusive),new y.$rt(u.seq2Range.start+i,o.seq2Range.endExclusive));continue}a>0&&(u=u.delta(a))}w.push(u)}return p.length>0&&w.push(p[p.length-1]),w}function h(e,N,E){if(!e.getBoundaryScore||!N.getBoundaryScore)return E;for(let p=0;p<E.length;p++){const w=p>0?E[p-1]:void 0,$=E[p],o=p+1<E.length?E[p+1]:void 0,u=new y.$rt(w?w.seq1Range.endExclusive+1:0,o?o.seq1Range.start-1:e.length),i=new y.$rt(w?w.seq2Range.endExclusive+1:0,o?o.seq2Range.start-1:N.length);$.seq1Range.isEmpty?E[p]=l($,e,N,u,i):$.seq2Range.isEmpty&&(E[p]=l($.swap(),N,e,i,u).swap())}return E}function l(e,N,E,p,w){let o=1;for(;e.seq1Range.start-o>=p.start&&e.seq2Range.start-o>=w.start&&E.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let u=0;for(;e.seq1Range.start+u<p.endExclusive&&e.seq2Range.endExclusive+u<w.endExclusive&&E.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(o===0&&u===0)return e;let i=0,a=-1;for(let b=-o;b<=u;b++){const d=e.seq2Range.start+b,v=e.seq2Range.endExclusive+b,A=e.seq1Range.start+b,R=N.getBoundaryScore(A)+E.getBoundaryScore(d)+E.getBoundaryScore(v);R>a&&(a=R,i=b)}return e.delta(i)}function s(e,N,E){const p=[];for(const w of E){const $=p[p.length-1];if(!$){p.push(w);continue}w.seq1Range.start-$.seq1Range.endExclusive<=2||w.seq2Range.start-$.seq2Range.endExclusive<=2?p[p.length-1]=new M.$02($.seq1Range.join(w.seq1Range),$.seq2Range.join(w.seq2Range)):p.push(w)}return p}function c(e,N,E){const p=M.$02.invert(E,e.length),w=[];let $=new M.$$2(0,0);function o(i,a){if(i.offset1<$.offset1||i.offset2<$.offset2)return;const b=e.findWordContaining(i.offset1),d=N.findWordContaining(i.offset2);if(!b||!d)return;let v=new M.$02(b,d);const A=v.intersect(a);let R=A.seq1Range.length,P=A.seq2Range.length;for(;p.length>0;){const D=p[0];if(!(D.seq1Range.intersects(v.seq1Range)||D.seq2Range.intersects(v.seq2Range)))break;const I=e.findWordContaining(D.seq1Range.start),F=N.findWordContaining(D.seq2Range.start),q=new M.$02(I,F),x=q.intersect(D);if(R+=x.seq1Range.length,P+=x.seq2Range.length,v=v.join(q),v.seq1Range.endExclusive>=D.seq1Range.endExclusive)p.shift();else break}R+P<(v.seq1Range.length+v.seq2Range.length)*2/3&&w.push(v),$=v.getEndExclusives()}for(;p.length>0;){const i=p.shift();i.seq1Range.isEmpty||(o(i.getStarts(),i),o(i.getEndExclusives().delta(-1),i))}return L(E,w)}function L(e,N){const E=[];for(;e.length>0||N.length>0;){const p=e[0],w=N[0];let $;p&&(!w||p.seq1Range.start<w.seq1Range.start)?$=e.shift():$=N.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=$.seq1Range.start?E[E.length-1]=E[E.length-1].join($):E.push($)}return E}function g(e,N,E){let p=E;if(p.length===0)return p;let w=0,$;do{$=!1;const o=[p[0]];for(let u=1;u<p.length;u++){let b=function(v,A){const R=new y.$rt(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const i=p[u],a=o[o.length-1];b(a,i)?($=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}p=o}while(w++<10&&$);return p}function m(e,N,E){let p=E;if(p.length===0)return p;let w=0,$;do{$=!1;const u=[p[0]];for(let i=1;i<p.length;i++){let d=function(A,R){const P=new y.$rt(b.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const S=e.getText(P).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(A.seq1Range),F=A.seq1Range.length,q=N.countLinesIn(A.seq2Range),x=A.seq2Range.length,z=e.countLinesIn(R.seq1Range),Y=R.seq1Range.length,Z=N.countLinesIn(R.seq2Range),X=R.seq2Range.length,G=2*40+50;function k(V){return Math.min(V,G)}return Math.pow(Math.pow(k(I*40+F),1.5)+Math.pow(k(q*40+x),1.5),1.5)+Math.pow(Math.pow(k(z*40+Y),1.5)+Math.pow(k(Z*40+X),1.5),1.5)>(G**1.5)**1.5*1.3};const a=p[i],b=u[u.length-1];d(b,a)?($=!0,u[u.length-1]=u[u.length-1].join(a)):u.push(a)}p=u}while(w++<10&&$);const o=[];return(0,r.$Cb)(p,(u,i,a)=>{let b=i;function d(S){return S.length>0&&S.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),A=e.getText(new y.$rt(v.start,i.seq1Range.start));d(A)&&(b=b.deltaStart(-A.length));const R=e.getText(new y.$rt(i.seq1Range.endExclusive,v.endExclusive));d(R)&&(b=b.deltaEnd(R.length));const P=M.$02.fromOffsetPairs(u?u.getEndExclusives():M.$$2.zero,a?a.getStarts():M.$$2.max),D=b.intersect(P);o.length>0&&D.getStarts().equals(o[o.length-1].getEndExclusives())?o[o.length-1]=o[o.length-1].join(D):o.push(D)}),o}}),ie(se[48],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i3=void 0;class r{constructor(f,j){this.a=f,this.b=j}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const j=f===0?0:y(this.b[f-1]),h=f===this.b.length?0:y(this.b[f]);return 1e3-(j+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,j){return this.b[f]===this.b[j]}}t.$i3=r;function y(M){let f=0;for(;f<M.length&&(M.charCodeAt(f)===32||M.charCodeAt(f)===9);)f++;return f}}),ie(se[16],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d3=t.$b3=void 0,t.$c3=y;class r{constructor(j,h){this.width=j,this.height=h,this.a=[],this.a=new Array(j*h)}get(j,h){return this.a[j+h*this.width]}set(j,h,l){this.a[j+h*this.width]=l}}t.$b3=r;function y(f){return f===32||f===9}class M{static{this.a=new Map}static b(j){let h=this.a.get(j);return h===void 0&&(h=this.a.size,this.a.set(j,h)),h}constructor(j,h,l){this.range=j,this.lines=h,this.source=l,this.d=[];let s=0;for(let c=j.startLineNumber-1;c<j.endLineNumberExclusive-1;c++){const L=h[c];for(let m=0;m<L.length;m++){s++;const e=L[m],N=M.b(e);this.d[N]=(this.d[N]||0)+1}s++;const g=M.b(`
`);this.d[g]=(this.d[g]||0)+1}this.c=s}computeSimilarity(j){let h=0;const l=Math.max(this.d.length,j.d.length);for(let s=0;s<l;s++)h+=Math.abs((this.d[s]??0)-(j.d[s]??0));return 1-h/(this.c+j.c)}}t.$d3=M}),ie(se[49],ue([0,1,4,8,16]),function(W,t,r,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e3=void 0;class f{compute(h,l,s=y.$_2.instance,c){if(h.length===0||l.length===0)return y.$92.trivial(h,l);const L=new M.$b3(h.length,l.length),g=new M.$b3(h.length,l.length),m=new M.$b3(h.length,l.length);for(let o=0;o<h.length;o++)for(let u=0;u<l.length;u++){if(!s.isValid())return y.$92.trivialTimedOut(h,l);const i=o===0?0:L.get(o-1,u),a=u===0?0:L.get(o,u-1);let b;h.getElement(o)===l.getElement(u)?(o===0||u===0?b=0:b=L.get(o-1,u-1),o>0&&u>0&&g.get(o-1,u-1)===3&&(b+=m.get(o-1,u-1)),b+=c?c(o,u):1):b=-1;const d=Math.max(i,a,b);if(d===b){const v=o>0&&u>0?m.get(o-1,u-1):0;m.set(o,u,v+1),g.set(o,u,3)}else d===i?(m.set(o,u,0),g.set(o,u,1)):d===a&&(m.set(o,u,0),g.set(o,u,2));L.set(o,u,d)}const e=[];let N=h.length,E=l.length;function p(o,u){(o+1!==N||u+1!==E)&&e.push(new y.$02(new r.$rt(o+1,N),new r.$rt(u+1,E))),N=o,E=u}let w=h.length-1,$=l.length-1;for(;w>=0&&$>=0;)g.get(w,$)===3?(p(w,$),w--,$--):g.get(w,$)===1?w--:$--;return p(-1,-1),e.reverse(),new y.$92(e,!1)}}t.$e3=f}),ie(se[32],ue([0,1,9,4,5,2,16]),function(W,t,r,y,M,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$g3=void 0;class h{constructor(e,N,E){this.lines=e,this.considerWhitespaceChanges=E,this.b=[],this.c=[],this.d=[];let p=!1;N.start>0&&N.endExclusive>=e.length&&(N=new y.$rt(N.start-1,N.endExclusive),p=!0),this.lineRange=N,this.c[0]=0;for(let w=this.lineRange.start;w<this.lineRange.endExclusive;w++){let $=e[w],o=0;if(p)o=$.length,$="",p=!1;else if(!E){const u=$.trimStart();o=$.length-u.length,$=u.trimEnd()}this.d.push(o);for(let u=0;u<$.length;u++)this.b.push($.charCodeAt(u));w<e.length-1&&(this.b.push(10),this.c[w-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new y.$rt(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(N=>String.fromCharCode(N)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const N=g(e>0?this.b[e-1]:-1),E=g(e<this.b.length?this.b[e]:-1);if(N===7&&E===8)return 0;if(N===8)return 150;let p=0;return N!==E&&(p+=10,N===0&&E===1&&(p+=1)),p+=L(N),p+=L(E),p}translateOffset(e){if(this.lineRange.isEmpty)return new M.$jt(this.lineRange.start+1,1);const N=(0,r.$ib)(this.c,E=>E<=e);return new M.$jt(this.lineRange.start+N+1,e-this.c[N]+this.d[N]+1)}translateRange(e){return f.$kt.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let N=e;for(;N>0&&l(this.b[N-1]);)N--;let E=e;for(;E<this.b.length&&l(this.b[E]);)E++;return new y.$rt(N,E)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,N){return this.b[e]===this.b[N]}extendToFullLines(e){const N=(0,r.$hb)(this.c,p=>p<=e.start)??0,E=(0,r.$jb)(this.c,p=>e.endExclusive<=p)??this.b.length;return new y.$rt(N,E)}}t.$g3=h;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function L(m){return c[m]}function g(m){return m===10?8:m===13?7:(0,j.$c3)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ie(se[33],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hv=t.$Gv=void 0;class r{constructor(f,j,h){this.changes=f,this.moves=j,this.hitTimeout=h}}t.$Gv=r;class y{constructor(f,j){this.lineRangeMapping=f,this.changes=j}flip(){return new y(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$Hv=y}),ie(se[17],ue([0,1,12]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fv=t.$Ev=t.$Dv=void 0;class y{static inverse(h,l,s){const c=[];let L=1,g=1;for(const e of h){const N=new y(new r.$Bv(L,e.original.startLineNumber),new r.$Bv(g,e.modified.startLineNumber));N.modified.isEmpty||c.push(N),L=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new y(new r.$Bv(L,l+1),new r.$Bv(g,s+1));return m.modified.isEmpty||c.push(m),c}static clip(h,l,s){const c=[];for(const L of h){const g=L.original.intersect(l),m=L.modified.intersect(s);g&&!g.isEmpty&&m&&!m.isEmpty&&c.push(new y(g,m))}return c}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new y(this.modified,this.original)}join(h){return new y(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Dv=y;class M extends y{static fromRangeMappings(h){const l=r.$Bv.join(h.map(c=>r.$Bv.fromRangeInclusive(c.originalRange))),s=r.$Bv.join(h.map(c=>r.$Bv.fromRangeInclusive(c.modifiedRange)));return new M(l,s,h)}constructor(h,l,s){super(h,l),this.innerChanges=s}flip(){return new M(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}withInnerChangesFromLineRanges(){return new M(this.original,this.modified,[new f(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}t.$Ev=M;class f{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$Fv=f}),ie(se[50],ue([0,1,8,17,6,9,14,12,4,32,16,31]),function(W,t,r,y,M,f,j,h,l,s,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$h3=g;function g($,o,u,i,a,b){let{moves:d,excludedChanges:v}=e($,o,u,b);if(!b.isValid())return[];const A=$.filter(P=>!v.has(P)),R=N(A,i,a,o,u,b);return(0,M.$1b)(d,R),d=p(d),d=d.filter(P=>{const D=P.original.toOffsetRange().slice(o).map(I=>I.trim());return D.join(`
`).length>=15&&m(D,I=>I.length>=2)>=2}),d=w($,d),d}function m($,o){let u=0;for(const i of $)o(i)&&u++;return u}function e($,o,u,i){const a=[],b=$.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new c.$d3(A.original,o,A)),d=new Set($.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new c.$d3(A.modified,u,A))),v=new Set;for(const A of b){let R=-1,P;for(const D of d){const S=A.computeSimilarity(D);S>R&&(R=S,P=D)}if(R>.9&&P&&(d.delete(P),a.push(new y.$Dv(A.range,P.range)),v.add(A.source),v.add(P.source)),!i.isValid())return{moves:a,excludedChanges:v}}return{moves:a,excludedChanges:v}}function N($,o,u,i,a,b){const d=[],v=new j.$Hc;for(const S of $)for(let I=S.original.startLineNumber;I<S.original.endLineNumberExclusive-2;I++){const F=`${o[I-1]}:${o[I+1-1]}:${o[I+2-1]}`;v.add(F,{range:new h.$Bv(I,I+3)})}const A=[];$.sort((0,M.$7b)(S=>S.modified.startLineNumber,M.$9b));for(const S of $){let I=[];for(let F=S.modified.startLineNumber;F<S.modified.endLineNumberExclusive-2;F++){const q=`${u[F-1]}:${u[F+1-1]}:${u[F+2-1]}`,x=new h.$Bv(F,F+3),z=[];v.forEach(q,({range:Y})=>{for(const X of I)if(X.originalLineRange.endLineNumberExclusive+1===Y.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive){X.originalLineRange=new h.$Bv(X.originalLineRange.startLineNumber,Y.endLineNumberExclusive),X.modifiedLineRange=new h.$Bv(X.modifiedLineRange.startLineNumber,x.endLineNumberExclusive),z.push(X);return}const Z={modifiedLineRange:x,originalLineRange:Y};A.push(Z),z.push(Z)}),I=z}if(!b.isValid())return[]}A.sort((0,M.$$b)((0,M.$7b)(S=>S.modifiedLineRange.length,M.$9b)));const R=new h.$Cv,P=new h.$Cv;for(const S of A){const I=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,F=R.subtractFrom(S.modifiedLineRange),q=P.subtractFrom(S.originalLineRange).getWithDelta(I),x=F.getIntersection(q);for(const z of x.ranges){if(z.length<3)continue;const Y=z,Z=z.delta(-I);d.push(new y.$Dv(Z,Y)),R.addRange(Y),P.addRange(Z)}}d.sort((0,M.$7b)(S=>S.original.startLineNumber,M.$9b));const D=new f.$mb($);for(let S=0;S<d.length;S++){const I=d[S],F=D.findLastMonotonous(k=>k.original.startLineNumber<=I.original.startLineNumber),q=(0,f.$hb)($,k=>k.modified.startLineNumber<=I.modified.startLineNumber),x=Math.max(I.original.startLineNumber-F.original.startLineNumber,I.modified.startLineNumber-q.modified.startLineNumber),z=D.findLastMonotonous(k=>k.original.startLineNumber<I.original.endLineNumberExclusive),Y=(0,f.$hb)($,k=>k.modified.startLineNumber<I.modified.endLineNumberExclusive),Z=Math.max(z.original.endLineNumberExclusive-I.original.endLineNumberExclusive,Y.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let X;for(X=0;X<x;X++){const k=I.original.startLineNumber-X-1,V=I.modified.startLineNumber-X-1;if(k>i.length||V>a.length||R.contains(V)||P.contains(k)||!E(i[k-1],a[V-1],b))break}X>0&&(P.addRange(new h.$Bv(I.original.startLineNumber-X,I.original.startLineNumber)),R.addRange(new h.$Bv(I.modified.startLineNumber-X,I.modified.startLineNumber)));let G;for(G=0;G<Z;G++){const k=I.original.endLineNumberExclusive+G,V=I.modified.endLineNumberExclusive+G;if(k>i.length||V>a.length||R.contains(V)||P.contains(k)||!E(i[k-1],a[V-1],b))break}G>0&&(P.addRange(new h.$Bv(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+G)),R.addRange(new h.$Bv(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+G))),(X>0||G>0)&&(d[S]=new y.$Dv(new h.$Bv(I.original.startLineNumber-X,I.original.endLineNumberExclusive+G),new h.$Bv(I.modified.startLineNumber-X,I.modified.endLineNumberExclusive+G)))}return d}function E($,o,u){if($.trim()===o.trim())return!0;if($.length>300&&o.length>300)return!1;const a=new L.$f3().compute(new s.$g3([$],new l.$rt(0,1),!1),new s.$g3([o],new l.$rt(0,1),!1),u);let b=0;const d=r.$02.invert(a.diffs,$.length);for(const P of d)P.seq1Range.forEach(D=>{(0,c.$c3)($.charCodeAt(D))||b++});function v(P){let D=0;for(let S=0;S<$.length;S++)(0,c.$c3)(P.charCodeAt(S))||D++;return D}const A=v($.length>o.length?$:o);return b/A>.6&&A>10}function p($){if($.length===0)return $;$.sort((0,M.$7b)(u=>u.original.startLineNumber,M.$9b));const o=[$[0]];for(let u=1;u<$.length;u++){const i=o[o.length-1],a=$[u],b=a.original.startLineNumber-i.original.endLineNumberExclusive,d=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(b>=0&&d>=0&&b+d<=2){o[o.length-1]=i.join(a);continue}o.push(a)}return o}function w($,o){const u=new f.$mb($);return o=o.filter(i=>{const a=u.findLastMonotonous(v=>v.original.startLineNumber<i.original.endLineNumberExclusive)||new y.$Dv(new h.$Bv(1,1),new h.$Bv(1,1)),b=(0,f.$hb)($,v=>v.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==b}),o}}),ie(se[51],ue([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,17]),function(W,t,r,y,M,f,j,h,l,s,c,L,g,m,e,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o3=void 0,t.$p3=p,t.$q3=w;class E{constructor(){this.e=new l.$e3,this.f=new s.$f3}computeDiff(o,u,i){if(o.length<=1&&(0,r.$ub)(o,u,(G,k)=>G===k))return new e.$Gv([],[],!1);if(o.length===1&&o[0].length===0||u.length===1&&u[0].length===0)return new e.$Gv([new N.$Ev(new M.$Bv(1,o.length+1),new M.$Bv(1,u.length+1),[new N.$Fv(new j.$kt(1,1,o.length,o[0].length+1),new j.$kt(1,1,u.length,u[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?h.$_2.instance:new h.$a3(i.maxComputationTimeMs),b=!i.ignoreTrimWhitespace,d=new Map;function v(G){let k=d.get(G);return k===void 0&&(k=d.size,d.set(G,k)),k}const A=o.map(G=>v(G.trim())),R=u.map(G=>v(G.trim())),P=new g.$i3(A,o),D=new g.$i3(R,u),S=P.length+D.length<1700?this.e.compute(P,D,a,(G,k)=>o[G]===u[k]?u[k].length===0?.1:1+Math.log(1+u[k].length):.99):this.f.compute(P,D);let I=S.diffs,F=S.hitTimeout;I=(0,L.$j3)(P,D,I),I=(0,L.$m3)(P,D,I);const q=[],x=G=>{if(b)for(let k=0;k<G;k++){const V=z+k,ne=Y+k;if(o[V]!==u[ne]){const le=this.j(o,u,new h.$02(new f.$rt(V,V+1),new f.$rt(ne,ne+1)),a,b);for(const me of le.mappings)q.push(me);le.hitTimeout&&(F=!0)}}};let z=0,Y=0;for(const G of I){(0,y.$fd)(()=>G.seq1Range.start-z===G.seq2Range.start-Y);const k=G.seq1Range.start-z;x(k),z=G.seq1Range.endExclusive,Y=G.seq2Range.endExclusive;const V=this.j(o,u,G,a,b);V.hitTimeout&&(F=!0);for(const ne of V.mappings)q.push(ne)}x(o.length-z);const Z=p(q,o,u);let X=[];return i.computeMoves&&(X=this.h(Z,o,u,A,R,a,b)),(0,y.$fd)(()=>{function G(V,ne){if(V.lineNumber<1||V.lineNumber>ne.length)return!1;const le=ne[V.lineNumber-1];return!(V.column<1||V.column>le.length+1)}function k(V,ne){return!(V.startLineNumber<1||V.startLineNumber>ne.length+1||V.endLineNumberExclusive<1||V.endLineNumberExclusive>ne.length+1)}for(const V of Z){if(!V.innerChanges)return!1;for(const ne of V.innerChanges)if(!(G(ne.modifiedRange.getStartPosition(),u)&&G(ne.modifiedRange.getEndPosition(),u)&&G(ne.originalRange.getStartPosition(),o)&&G(ne.originalRange.getEndPosition(),o)))return!1;if(!k(V.modified,u)||!k(V.original,o))return!1}return!0}),new e.$Gv(Z,X,F)}h(o,u,i,a,b,d,v){return(0,c.$h3)(o,u,i,a,b,d).map(P=>{const D=this.j(u,i,new h.$02(P.original.toOffsetRange(),P.modified.toOffsetRange()),d,v),S=p(D.mappings,u,i,!0);return new e.$Hv(P,S)})}j(o,u,i,a,b){const d=new m.$g3(o,i.seq1Range,b),v=new m.$g3(u,i.seq2Range,b),A=d.length+v.length<500?this.e.compute(d,v,a):this.f.compute(d,v,a);let R=A.diffs;return R=(0,L.$j3)(d,v,R),R=(0,L.$l3)(d,v,R),R=(0,L.$k3)(d,v,R),R=(0,L.$n3)(d,v,R),{mappings:R.map(D=>new N.$Fv(d.translateRange(D.seq1Range),v.translateRange(D.seq2Range))),hitTimeout:A.hitTimeout}}}t.$o3=E;function p($,o,u,i=!1){const a=[];for(const b of(0,r.$Ab)($.map(d=>w(d,o,u)),(d,v)=>d.original.overlapOrTouch(v.original)||d.modified.overlapOrTouch(v.modified))){const d=b[0],v=b[b.length-1];a.push(new N.$Ev(d.original.join(v.original),d.modified.join(v.modified),b.map(A=>A.innerChanges[0])))}return(0,y.$fd)(()=>!i&&a.length>0&&(a[0].modified.startLineNumber!==a[0].original.startLineNumber||u.length-a[a.length-1].modified.endLineNumberExclusive!==o.length-a[a.length-1].original.endLineNumberExclusive)?!1:(0,y.$gd)(a,(b,d)=>d.original.startLineNumber-b.original.endLineNumberExclusive===d.modified.startLineNumber-b.modified.endLineNumberExclusive&&b.original.endLineNumberExclusive<d.original.startLineNumber&&b.modified.endLineNumberExclusive<d.modified.startLineNumber)),a}function w($,o,u){let i=0,a=0;$.modifiedRange.endColumn===1&&$.originalRange.endColumn===1&&$.originalRange.startLineNumber+i<=$.originalRange.endLineNumber&&$.modifiedRange.startLineNumber+i<=$.modifiedRange.endLineNumber&&(a=-1),$.modifiedRange.startColumn-1>=u[$.modifiedRange.startLineNumber-1].length&&$.originalRange.startColumn-1>=o[$.originalRange.startLineNumber-1].length&&$.originalRange.startLineNumber<=$.originalRange.endLineNumber+a&&$.modifiedRange.startLineNumber<=$.modifiedRange.endLineNumber+a&&(i=1);const b=new M.$Bv($.originalRange.startLineNumber+i,$.originalRange.endLineNumber+1+a),d=new M.$Bv($.modifiedRange.startLineNumber+i,$.modifiedRange.endLineNumber+1+a);return new N.$Ev(b,d,[$])}}),ie(se[34],ue([0,1,25,33,17,7,2,13,12]),function(W,t,r,y,M,f,j,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jv=t.$Iv=void 0;const s=3;class c{computeDiff(i,a,b){const v=new p(i,a,{maxComputationTime:b.maxComputationTimeMs,shouldIgnoreTrimWhitespace:b.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let R=null;for(const P of v.changes){let D;P.originalEndLineNumber===0?D=new l.$Bv(P.originalStartLineNumber+1,P.originalStartLineNumber+1):D=new l.$Bv(P.originalStartLineNumber,P.originalEndLineNumber+1);let S;P.modifiedEndLineNumber===0?S=new l.$Bv(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):S=new l.$Bv(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let I=new M.$Ev(D,S,P.charChanges?.map(F=>new M.$Fv(new j.$kt(F.originalStartLineNumber,F.originalStartColumn,F.originalEndLineNumber,F.originalEndColumn),new j.$kt(F.modifiedStartLineNumber,F.modifiedStartColumn,F.modifiedEndLineNumber,F.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new M.$Ev(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),A.pop()),A.push(I),R=I}return(0,h.$fd)(()=>(0,h.$gd)(A,(P,D)=>D.original.startLineNumber-P.original.endLineNumberExclusive===D.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<D.original.startLineNumber&&P.modified.endLineNumberExclusive<D.modified.startLineNumber)),new y.$Gv(A,[],v.quitEarly)}}t.$Iv=c;function L(u,i,a,b){return new r.$qt(u,i,a).ComputeDiff(b)}class g{constructor(i){const a=[],b=[];for(let d=0,v=i.length;d<v;d++)a[d]=w(i[d],1),b[d]=$(i[d],1);this.lines=i,this.a=a,this.b=b}getElements(){const i=[];for(let a=0,b=this.lines.length;a<b;a++)i[a]=this.lines[a].substring(this.a[a]-1,this.b[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,b){const d=[],v=[],A=[];let R=0;for(let P=a;P<=b;P++){const D=this.lines[P],S=i?this.a[P]:1,I=i?this.b[P]:D.length+1;for(let F=S;F<I;F++)d[R]=D.charCodeAt(F-1),v[R]=P+1,A[R]=F,R++;!i&&P<b&&(d[R]=10,v[R]=P+1,A[R]=D.length+1,R++)}return new m(d,v,A)}}class m{constructor(i,a,b){this.a=i,this.b=a,this.d=b}toString(){return"["+this.a.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[a]},${this.d[a]})`).join(", ")+"]"}e(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,a,b,d,v,A,R,P){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=b,this.originalEndColumn=d,this.modifiedStartLineNumber=v,this.modifiedStartColumn=A,this.modifiedEndLineNumber=R,this.modifiedEndColumn=P}static createFromDiffChange(i,a,b){const d=a.getStartLineNumber(i.originalStart),v=a.getStartColumn(i.originalStart),A=a.getEndLineNumber(i.originalStart+i.originalLength-1),R=a.getEndColumn(i.originalStart+i.originalLength-1),P=b.getStartLineNumber(i.modifiedStart),D=b.getStartColumn(i.modifiedStart),S=b.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),I=b.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,v,A,R,P,D,S,I)}}function N(u){if(u.length<=1)return u;const i=[u[0]];let a=i[0];for(let b=1,d=u.length;b<d;b++){const v=u[b],A=v.originalStart-(a.originalStart+a.originalLength),R=v.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(A,R)<s?(a.originalLength=v.originalStart+v.originalLength-a.originalStart,a.modifiedLength=v.modifiedStart+v.modifiedLength-a.modifiedStart):(i.push(v),a=v)}return i}class E{constructor(i,a,b,d,v){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=b,this.modifiedEndLineNumber=d,this.charChanges=v}static createFromDiffResult(i,a,b,d,v,A,R){let P,D,S,I,F;if(a.originalLength===0?(P=b.getStartLineNumber(a.originalStart)-1,D=0):(P=b.getStartLineNumber(a.originalStart),D=b.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(S=d.getStartLineNumber(a.modifiedStart)-1,I=0):(S=d.getStartLineNumber(a.modifiedStart),I=d.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),A&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&v()){const q=b.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),x=d.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(q.getElements().length>0&&x.getElements().length>0){let z=L(q,x,v,!0).changes;R&&(z=N(z)),F=[];for(let Y=0,Z=z.length;Y<Z;Y++)F.push(e.createFromDiffChange(z[Y],q,x))}}return new E(P,D,S,I,F)}}class p{constructor(i,a,b){this.a=b.shouldComputeCharChanges,this.b=b.shouldPostProcessCharChanges,this.d=b.shouldIgnoreTrimWhitespace,this.e=b.shouldMakePrettyDiff,this.f=i,this.g=a,this.h=new g(i),this.j=new g(a),this.k=o(b.maxComputationTime),this.l=o(b.maxComputationTime===0?0:Math.min(b.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=L(this.h,this.j,this.k,this.e),a=i.changes,b=i.quitEarly;if(this.d){const R=[];for(let P=0,D=a.length;P<D;P++)R.push(E.createFromDiffResult(this.d,a[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:b,changes:R}}const d=[];let v=0,A=0;for(let R=-1,P=a.length;R<P;R++){const D=R+1<P?a[R+1]:null,S=D?D.originalStart:this.f.length,I=D?D.modifiedStart:this.g.length;for(;v<S&&A<I;){const F=this.f[v],q=this.g[A];if(F!==q){{let x=w(F,1),z=w(q,1);for(;x>1&&z>1;){const Y=F.charCodeAt(x-2),Z=q.charCodeAt(z-2);if(Y!==Z)break;x--,z--}(x>1||z>1)&&this.m(d,v+1,1,x,A+1,1,z)}{let x=$(F,1),z=$(q,1);const Y=F.length+1,Z=q.length+1;for(;x<Y&&z<Z;){const X=F.charCodeAt(x-1),G=F.charCodeAt(z-1);if(X!==G)break;x++,z++}(x<Y||z<Z)&&this.m(d,v+1,x,Y,A+1,z,Z)}}v++,A++}D&&(d.push(E.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),v+=D.originalLength,A+=D.modifiedLength)}return{quitEarly:b,changes:d}}m(i,a,b,d,v,A,R){if(this.n(i,a,b,d,v,A,R))return;let P;this.a&&(P=[new e(a,b,a,d,v,A,v,R)]),i.push(new E(a,a,v,v,P))}n(i,a,b,d,v,A,R){const P=i.length;if(P===0)return!1;const D=i[P-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===a&&D.modifiedEndLineNumber===v?(this.a&&D.charChanges&&D.charChanges.push(new e(a,b,a,d,v,A,v,R)),!0):D.originalEndLineNumber+1===a&&D.modifiedEndLineNumber+1===v?(D.originalEndLineNumber=a,D.modifiedEndLineNumber=v,this.a&&D.charChanges&&D.charChanges.push(new e(a,b,a,d,v,A,v,R)),!0):!1}}t.$Jv=p;function w(u,i){const a=f.$if(u);return a===-1?i:a+1}function $(u,i){const a=f.$kf(u);return a===-1?i:a+2}function o(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),ie(se[52],ue([0,1,34,51]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r3=void 0,t.$r3={getLegacy:()=>new r.$Iv,getDefault:()=>new y.$o3}}),ie(se[53],ue([0,1,36]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$s3=L;function y(g){const m=[];for(const e of g){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&m.push(N)}return m}function M(g,m,e,N){return{red:g/255,blue:e/255,green:m/255,alpha:N}}function f(g,m){const e=m.index,N=m[0].length;if(!e)return;const E=g.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+N}}function j(g,m){if(!g)return;const e=r.$Ft.Format.CSS.parseHex(m);if(e)return{range:g,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),p=y(E);return{range:g,color:M(p[0],p[1],p[2],e?p[3]:1)}}function l(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),p=y(E),w=new r.$Ft(new r.$Dt(p[0],p[1]/100,p[2]/100,e?p[3]:1));return{range:g,color:M(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function s(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function c(g){const m=[],N=s(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const E of N){const p=E.filter(u=>u!==void 0),w=p[1],$=p[2];if(!$)continue;let o;if(w==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f(g,E),s($,u),!1)}else if(w==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f(g,E),s($,u),!0)}else if(w==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=l(f(g,E),s($,u),!1)}else if(w==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=l(f(g,E),s($,u),!0)}else w==="#"&&(o=j(f(g,E),w+$));o&&m.push(o)}return m}function L(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:c(g)}}),ie(se[54],ue([0,1,29]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$42=t.$32=t.State=void 0,t.$52=g;var y;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(y||(t.State=y={}));class M{constructor(e,N,E){const p=new Uint8Array(e*N);for(let w=0,$=e*N;w<$;w++)p[w]=E;this.a=p,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,E){this.a[e*this.cols+N]=E}}class f{constructor(e){let N=0,E=0;for(let w=0,$=e.length;w<$;w++){const[o,u,i]=e[w];u>N&&(N=u),o>E&&(E=o),i>E&&(E=i)}N++,E++;const p=new M(E,N,0);for(let w=0,$=e.length;w<$;w++){const[o,u,i]=e[w];p.set(o,u,i)}this.a=p,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$32=f;let j=null;function h(){return j===null&&(j=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),j}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function c(){if(s===null){s=new r.$yt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<m.length;N++)s.set(m.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)s.set(e.charCodeAt(N),2)}return s}class L{static a(e,N,E,p,w){let $=w-1;do{const o=N.charCodeAt($);if(e.get(o)!==2)break;$--}while($>p);if(p>0){const o=N.charCodeAt(p-1),u=N.charCodeAt($);(o===40&&u===41||o===91&&u===93||o===123&&u===125)&&$--}return{range:{startLineNumber:E,startColumn:p+1,endLineNumber:E,endColumn:$+2},url:N.substring(p,$+1)}}static computeLinks(e,N=h()){const E=c(),p=[];for(let w=1,$=e.getLineCount();w<=$;w++){const o=e.getLineContent(w),u=o.length;let i=0,a=0,b=0,d=1,v=!1,A=!1,R=!1,P=!1;for(;i<u;){let D=!1;const S=o.charCodeAt(i);if(d===13){let I;switch(S){case 40:v=!0,I=0;break;case 41:I=v?0:1;break;case 91:R=!0,A=!0,I=0;break;case 93:R=!1,I=A?0:1;break;case 123:P=!0,I=0;break;case 125:I=P?0:1;break;case 39:case 34:case 96:b===S?I=1:b===39||b===34||b===96?I=0:I=1;break;case 42:I=b===42?1:0;break;case 124:I=b===124?1:0;break;case 32:I=R?0:1;break;default:I=E.get(S)}I===1&&(p.push(L.a(E,o,w,a,i)),D=!0)}else if(d===12){let I;S===91?(A=!0,I=0):I=E.get(S),I===1?D=!0:d=13}else d=N.nextState(d,S),d===0&&(D=!0);D&&(d=1,v=!1,A=!1,P=!1,a=i+1,b=S),i++}d===13&&p.push(L.a(E,o,w,a,u))}return p}}t.$42=L;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:L.computeLinks(m)}}),ie(se[55],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$62=void 0;class r{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new r}navigateValueSet(M,f,j,h,l){if(M&&f){const s=this.a(f,l);if(s)return{range:M,value:s}}if(j&&h){const s=this.a(h,l);if(s)return{range:j,value:s}}return null}a(M,f){const j=this.b(M,f);return j!==null?j:this.d(M,f)}b(M,f){const j=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let h=Number(M);const l=parseFloat(M);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!f?null:(h=Math.floor(h*j),h+=f?j:-j,String(h/j)):null}d(M,f){return this.e(this.c,M,f)}e(M,f,j){let h=null;for(let l=0,s=M.length;h===null&&l<s;l++)h=this.f(M[l],f,j);return h}f(M,f,j){let h=M.indexOf(f);return h>=0?(h+=j?1:-1,h<0?h=M.length-1:h%=M.length,M[h]):null}}t.$62=r}),ie(se[56],ue([0,1,15]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zv=t.$yv=t.$xv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$vv=t.$uv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$wv=e,t.$Av=o;var y;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var M;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(M||(t.GlyphMarginLane=M={}));var f;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var j;(function(u){u[u.Normal=1]="Normal",u[u.Underlined=2]="Underlined"})(j||(t.MinimapSectionHeaderStyle=j={}));var h;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(h||(t.InjectedTextCursorStops=h={}));var l;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(l||(t.EndOfLinePreference=l={}));var s;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var c;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(c||(t.EndOfLineSequence=c={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,i.indentSize|0),this.a=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.a===i.a&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,r.$1n)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}t.$uv=L;class g{constructor(i,a){this._findMatchBrand=void 0,this.range=i,this.matches=a}}t.$vv=g;var m;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function e(u){return u&&typeof u.read=="function"}var N;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(N||(t.PositionAffinity=N={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class p{constructor(i,a,b,d,v,A){this.identifier=i,this.range=a,this.text=b,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=v,this._isTracked=A}}t.$xv=p;class w{constructor(i,a,b){this.regex=i,this.wordSeparators=a,this.simpleSearch=b}}t.$yv=w;class ${constructor(i,a,b){this.reverseEdits=i,this.changes=a,this.trimAutoWhitespaceLineNumbers=b}}t.$zv=$;function o(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}}),ie(se[57],ue([0,1,6,28]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ov=t.$Nv=t.$Mv=void 0;class M{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,y.$2e)(l);const c=this.a,L=this.b,g=s.length;return g===0?!1:(this.a=new Uint32Array(c.length+g),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l),l+g),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(L.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,y.$2e)(l),s=(0,y.$2e)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,y.$2e)(l),s=(0,y.$2e)(s);const c=this.a,L=this.b;if(l>=c.length)return!1;const g=c.length-l;return s>=g&&(s=g),s===0?!1:(this.a=new Uint32Array(c.length-s),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(L.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,y.$2e)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let c=s;c<=l;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,c=this.a.length-1,L=0,g=0,m=0;for(;s<=c;)if(L=s+(c-s)/2|0,g=this.b[L],m=g-this.a[L],l<m)c=L-1;else if(l>=g)s=L+1;else break;return new j(L,l-m)}}t.$Mv=M;class f{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],c=s>0?this.d[s-1]:0;return new j(s,l-c)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,r.$Wb)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const c=this.a[l],L=l>0?this.d[l-1]:0;this.d[l]=L+c;for(let g=0;g<c;g++)this.e[L+g]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$Nv=f;class j{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$Ov=j}),ie(se[58],ue([0,1,7,5,57]),function(W,t,r,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pv=void 0;class f{constructor(h,l,s,c){this.d=h,this.f=l,this.g=s,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const l=h.changes;for(const s of l)this.o(s.range),this.p(new y.$jt(s.range.startLineNumber,s.range.startColumn),s.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let c=0;c<l;c++)s[c]=this.f[c].length+h;this.j=new M.$Mv(s)}}n(h,l){this.f[h]=l,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,l){if(l.length===0)return;const s=(0,r.$gf)(l);if(s.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]+this.f[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]);const c=new Uint32Array(s.length-1);for(let L=1;L<s.length;L++)this.f.splice(h.lineNumber+L-1,0,s[L]),c[L-1]=s[L].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,c)}}t.$Pv=f}),ie(se[59],ue([0,1,7,46,5,2,56]),function(W,t,r,y,M,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EC=t.$CC=t.$zC=void 0,t.$AC=s,t.$BC=c,t.$DC=N;const h=999;class l{constructor(w,$,o,u){this.searchString=w,this.isRegex=$,this.matchCase=o,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=s(this.searchString):w=this.searchString.indexOf(`
`)>=0;let $=null;try{$=r.$ef(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!$)return null;let o=!this.isRegex&&!w;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new j.$yv($,this.wordSeparators?(0,y.$Bt)(this.wordSeparators,[]):null,o?this.searchString:null)}}t.$zC=l;function s(p){if(!p||p.length===0)return!1;for(let w=0,$=p.length;w<$;w++){const o=p.charCodeAt(w);if(o===10)return!0;if(o===92){if(w++,w>=$)break;const u=p.charCodeAt(w);if(u===110||u===114||u===87)return!0}}return!1}function c(p,w,$){if(!$)return new j.$vv(p,null);const o=[];for(let u=0,i=w.length;u<i;u++)o[u]=w[u];return new j.$vv(p,o)}class L{constructor(w){const $=[];let o=0;for(let u=0,i=w.length;u<i;u++)w.charCodeAt(u)===10&&($[o++]=u);this.a=$}findLineFeedCountBeforeOffset(w){const $=this.a;let o=0,u=$.length-1;if(u===-1||w<=$[0])return 0;for(;o<u;){const i=o+((u-o)/2>>0);$[i]>=w?u=i-1:$[i+1]>=w?(o=i,u=i):o=i+1}return o+1}}class g{static findMatches(w,$,o,u,i){const a=$.parseSearchRequest();return a?a.regex.multiline?this.b(w,o,new E(a.wordSeparators,a.regex),u,i):this.c(w,o,a,u,i):[]}static a(w,$,o,u,i,a){let b,d=0;u?(d=u.findLineFeedCountBeforeOffset(i),b=$+i+d):b=$+i;let v;if(u){const D=u.findLineFeedCountBeforeOffset(i+a.length)-d;v=b+a.length+D}else v=b+a.length;const A=w.getPositionAt(b),R=w.getPositionAt(v);return new f.$kt(A.lineNumber,A.column,R.lineNumber,R.column)}static b(w,$,o,u,i){const a=w.getOffsetAt($.getStartPosition()),b=w.getValueInRange($,1),d=w.getEOL()===`\r
`?new L(b):null,v=[];let A=0,R;for(o.reset(0);R=o.next(b);)if(v[A++]=c(this.a(w,a,b,d,R.index,R[0]),R,u),A>=i)return v;return v}static c(w,$,o,u,i){const a=[];let b=0;if($.startLineNumber===$.endLineNumber){const v=w.getLineContent($.startLineNumber).substring($.startColumn-1,$.endColumn-1);return b=this.d(o,v,$.startLineNumber,$.startColumn-1,b,a,u,i),a}const d=w.getLineContent($.startLineNumber).substring($.startColumn-1);b=this.d(o,d,$.startLineNumber,$.startColumn-1,b,a,u,i);for(let v=$.startLineNumber+1;v<$.endLineNumber&&b<i;v++)b=this.d(o,w.getLineContent(v),v,0,b,a,u,i);if(b<i){const v=w.getLineContent($.endLineNumber).substring(0,$.endColumn-1);b=this.d(o,v,$.endLineNumber,0,b,a,u,i)}return a}static d(w,$,o,u,i,a,b,d){const v=w.wordSeparators;if(!b&&w.simpleSearch){const P=w.simpleSearch,D=P.length,S=$.length;let I=-D;for(;(I=$.indexOf(P,I+D))!==-1;)if((!v||N(v,$,S,I,D))&&(a[i++]=new j.$vv(new f.$kt(o,I+1+u,o,I+1+D+u),null),i>=d))return i;return i}const A=new E(w.wordSeparators,w.regex);let R;A.reset(0);do if(R=A.next($),R&&(a[i++]=c(new f.$kt(o,R.index+1+u,o,R.index+1+R[0].length+u),R,b),i>=d))return i;while(R);return i}static findNextMatch(w,$,o,u){const i=$.parseSearchRequest();if(!i)return null;const a=new E(i.wordSeparators,i.regex);return i.regex.multiline?this.e(w,o,a,u):this.f(w,o,a,u)}static e(w,$,o,u){const i=new M.$jt($.lineNumber,1),a=w.getOffsetAt(i),b=w.getLineCount(),d=w.getValueInRange(new f.$kt(i.lineNumber,i.column,b,w.getLineMaxColumn(b)),1),v=w.getEOL()===`\r
`?new L(d):null;o.reset($.column-1);const A=o.next(d);return A?c(this.a(w,a,d,v,A.index,A[0]),A,u):$.lineNumber!==1||$.column!==1?this.e(w,new M.$jt(1,1),o,u):null}static f(w,$,o,u){const i=w.getLineCount(),a=$.lineNumber,b=w.getLineContent(a),d=this.g(o,b,a,$.column,u);if(d)return d;for(let v=1;v<=i;v++){const A=(a+v-1)%i,R=w.getLineContent(A+1),P=this.g(o,R,A+1,1,u);if(P)return P}return null}static g(w,$,o,u,i){w.reset(u-1);const a=w.next($);return a?c(new f.$kt(o,a.index+1,o,a.index+1+a[0].length),a,i):null}static findPreviousMatch(w,$,o,u){const i=$.parseSearchRequest();if(!i)return null;const a=new E(i.wordSeparators,i.regex);return i.regex.multiline?this.h(w,o,a,u):this.j(w,o,a,u)}static h(w,$,o,u){const i=this.b(w,new f.$kt(1,1,$.lineNumber,$.column),o,u,10*h);if(i.length>0)return i[i.length-1];const a=w.getLineCount();return $.lineNumber!==a||$.column!==w.getLineMaxColumn(a)?this.h(w,new M.$jt(a,w.getLineMaxColumn(a)),o,u):null}static j(w,$,o,u){const i=w.getLineCount(),a=$.lineNumber,b=w.getLineContent(a).substring(0,$.column-1),d=this.k(o,b,a,u);if(d)return d;for(let v=1;v<=i;v++){const A=(i+a-v-1)%i,R=w.getLineContent(A+1),P=this.k(o,R,A+1,u);if(P)return P}return null}static k(w,$,o,u){let i=null,a;for(w.reset(0);a=w.next($);)i=c(new f.$kt(o,a.index+1,o,a.index+1+a[0].length),a,u);return i}}t.$CC=g;function m(p,w,$,o,u){if(o===0)return!0;const i=w.charCodeAt(o-1);if(p.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=w.charCodeAt(o);if(p.get(a)!==0)return!0}return!1}function e(p,w,$,o,u){if(o+u===$)return!0;const i=w.charCodeAt(o+u);if(p.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=w.charCodeAt(o+u-1);if(p.get(a)!==0)return!0}return!1}function N(p,w,$,o,u){return m(p,w,$,o,u)&&e(p,w,$,o,u)}class E{constructor(w,$){this._wordSeparators=w,this.a=$,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const $=w.length;let o;do{if(this.b+this.c===$||(o=this.a.exec(w),!o))return null;const u=o.index,i=o[0].length;if(u===this.b&&i===this.c){if(i===0){r.$Af(w,$,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||N(this._wordSeparators,w,$,u,i))return o}while(o);return null}}t.$EC=E}),ie(se[60],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$t3=M;const r=/\bMARK:\s*(.*)$/d,y=/^-+|-+$/g;function M(s,c){let L=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const g=f(s,c);L=L.concat(g)}if(c.findMarkSectionHeaders){const g=j(s);L=L.concat(g)}return L}function f(s,c){const L=[],g=s.getLineCount();for(let m=1;m<=g;m++){const e=s.getLineContent(m),N=e.match(c.foldingRules.markers.start);if(N){const E={startLineNumber:m,startColumn:N[0].length+1,endLineNumber:m,endColumn:e.length+1};if(E.endColumn>E.startColumn){const p={range:E,...l(e.substring(N[0].length)),shouldBeInComments:!1};(p.text||p.hasSeparatorLine)&&L.push(p)}}}return L}function j(s){const c=[],L=s.getLineCount();for(let g=1;g<=L;g++){const m=s.getLineContent(g);h(m,g,c)}return c}function h(s,c,L){r.lastIndex=0;const g=r.exec(s);if(g){const m=g.indices[1][0]+1,e=g.indices[1][1]+1,N={startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:e};if(N.endColumn>N.startColumn){const E={range:N,...l(g[1]),shouldBeInComments:!0};(E.text||E.hasSeparatorLine)&&L.push(E)}}}function l(s){s=s.trim();const c=s.startsWith("-");return s=s.replace(y,""),{text:s,hasSeparatorLine:c}}}),ie(se[61],ue([0,1,2,59,7,13,30]),function(W,t,r,y,M,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$22=void 0;class h{static computeUnicodeHighlights(e,N,E){const p=E?E.startLineNumber:1,w=E?E.endLineNumber:e.getLineCount(),$=new c(N),o=$.getCandidateCodePoints();let u;o==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${l(Array.from(o))}`,"g");const i=new y.$EC(null,u),a=[];let b=!1,d,v=0,A=0,R=0;e:for(let P=p,D=w;P<=D;P++){const S=e.getLineContent(P),I=S.length;i.reset(0);do if(d=i.next(S),d){let F=d.index,q=d.index+d[0].length;if(F>0){const Z=S.charCodeAt(F-1);M.$xf(Z)&&F--}if(q+1<I){const Z=S.charCodeAt(q-1);M.$xf(Z)&&q++}const x=S.substring(F,q);let z=(0,j.$Zs)(F+1,j.$Ws,S,0);z&&z.endColumn<=F+1&&(z=null);const Y=$.shouldHighlightNonBasicASCII(x,z?z.word:null);if(Y!==0){if(Y===3?v++:Y===2?A++:Y===1?R++:(0,f.$cd)(Y),a.length>=1e3){b=!0;break e}a.push(new r.$kt(P,F+1,P,q+1))}}while(d)}return{ranges:a,hasMore:b,ambiguousCharacterCount:v,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,N){const E=new c(N);switch(E.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const w=e.codePointAt(0),$=E.ambiguousCharacters.getPrimaryConfusable(w),o=M.$2f.getLocales().filter(u=>!M.$2f.getInstance(new Set([...N.allowedLocales,u])).isAmbiguous(w));return{kind:0,confusableWith:String.fromCodePoint($),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.$22=h;function l(m,e){return`[${M.$8e(m.map(E=>String.fromCodePoint(E)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.$2f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of M.$3f.codePoints)L(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const E=e.codePointAt(0);if(this.a.has(E))return 0;if(this.b.nonBasicASCII)return 1;let p=!1,w=!1;if(N)for(const $ of N){const o=$.codePointAt(0),u=M.$If($);p=p||u,!u&&!this.ambiguousCharacters.isAmbiguous(o)&&!M.$3f.isInvisibleCharacter(o)&&(w=!0)}return!p&&w?0:this.b.invisibleCharacters&&!L(e)&&M.$3f.isInvisibleCharacter(E)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?3:0}}function L(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),ie(se[62],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var r;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(r||(t.AccessibilitySupport=r={}));var y;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var M;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(M||(t.CompletionItemInsertTextRule=M={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var j;(function(n){n[n.Deprecated=1]="Deprecated"})(j||(t.CompletionItemTag=j={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var c;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var L;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(L||(t.DocumentHighlightKind=L={}));var g;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.inlineEdit=63]="inlineEdit",n[n.letterSpacing=64]="letterSpacing",n[n.lightbulb=65]="lightbulb",n[n.lineDecorationsWidth=66]="lineDecorationsWidth",n[n.lineHeight=67]="lineHeight",n[n.lineNumbers=68]="lineNumbers",n[n.lineNumbersMinChars=69]="lineNumbersMinChars",n[n.linkedEditing=70]="linkedEditing",n[n.links=71]="links",n[n.matchBrackets=72]="matchBrackets",n[n.minimap=73]="minimap",n[n.mouseStyle=74]="mouseStyle",n[n.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=76]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",n[n.multiCursorModifier=78]="multiCursorModifier",n[n.multiCursorPaste=79]="multiCursorPaste",n[n.multiCursorLimit=80]="multiCursorLimit",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSegmenterLocales=130]="wordSegmenterLocales",n[n.wordSeparators=131]="wordSeparators",n[n.wordWrap=132]="wordWrap",n[n.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=135]="wordWrapColumn",n[n.wordWrapOverride1=136]="wordWrapOverride1",n[n.wordWrapOverride2=137]="wordWrapOverride2",n[n.wrappingIndent=138]="wrappingIndent",n[n.wrappingStrategy=139]="wrappingStrategy",n[n.showDeprecated=140]="showDeprecated",n[n.inlayHints=141]="inlayHints",n[n.editorClassName=142]="editorClassName",n[n.pixelRatio=143]="pixelRatio",n[n.tabFocusMode=144]="tabFocusMode",n[n.layoutInfo=145]="layoutInfo",n[n.wrappingInfo=146]="wrappingInfo",n[n.defaultColorDecorators=147]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var E;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(E||(t.GlyphMarginLane=E={}));var p;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(p||(t.IndentAction=p={}));var w;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var $;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})($||(t.InlayHintKind=$={}));var o;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var u;(function(n){n[n.Invoke=0]="Invoke",n[n.Automatic=1]="Automatic"})(u||(t.InlineEditTriggerKind=u={}));var i;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var a;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(a||(t.MarkerSeverity=a={}));var b;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(b||(t.MarkerTag=b={}));var d;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var v;(function(n){n[n.Normal=1]="Normal",n[n.Underlined=2]="Underlined"})(v||(t.MinimapSectionHeaderStyle=v={}));var A;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(A||(t.MouseTargetType=A={}));var R;(function(n){n[n.AIGenerated=1]="AIGenerated"})(R||(t.NewSymbolNameTag=R={}));var P;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(P||(t.OverlayWidgetPositionPreference=P={}));var D;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var S;(function(n){n[n.Word=0]="Word",n[n.Line=1]="Line",n[n.Suggest=2]="Suggest"})(S||(t.PartialAcceptTriggerKind=S={}));var I;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(I||(t.PositionAffinity=I={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var q;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(q||(t.RenderMinimap=q={}));var x;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(x||(t.ScrollType=x={}));var z;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(z||(t.ScrollbarVisibility=z={}));var Y;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(Y||(t.SelectionDirection=Y={}));var Z;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(Z||(t.ShowLightbulbIconMode=Z={}));var X;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(X||(t.SignatureHelpTriggerKind=X={}));var G;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(G||(t.SymbolKind=G={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k||(t.SymbolTag=k={}));var V;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(V||(t.TextEditorCursorBlinkingStyle=V={}));var ne;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(ne||(t.TextEditorCursorStyle=ne={}));var le;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(le||(t.TrackedRangeStickiness=le={}));var me;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(me||(t.WrappingIndent=me={}))}),ie(se[63],ue([0,1,11,10]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$be,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.handleChange([h]),(0,y.$Sc)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,l){this.b.get(h)?.dispose();const s=new f(this,h,l);return this.b.set(h,s),(0,y.$Sc)(()=>{const c=this.b.get(h);!c||c!==s||(this.b.delete(h),c.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const s=this.b.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this.b.get(h);return!!(!s||s.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Mt=M;class f extends y.$Uc{get isResolved(){return this.c}constructor(h,l,s){super(),this.f=h,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ie(se[64],ue([65,66]),function(W,t){return W.create("vs/base/common/platform",t)}),ie(se[18],ue([0,1,64]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=a,t.$D=P,t.$J=D,t.$g="en";let y=!1,M=!1,f=!1,j=!1,h=!1,l=!1,s=!1,c=!1,L=!1,g=!1,m,e=t.$g,N=t.$g,E,p;const w=globalThis;let $;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?$=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const o=typeof $?.versions?.electron=="string",u=o&&$?.type==="renderer";if(typeof $=="object"){y=$.platform==="win32",M=$.platform==="darwin",f=$.platform==="linux",j=f&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,s=o,L=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const S=$.env.VSCODE_NLS_CONFIG;if(S)try{const I=JSON.parse(S),F=I.availableLanguages["*"];m=I.locale,N=I.osLocale,e=F||t.$g,E=I._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!u?(p=navigator.userAgent,y=p.indexOf("Windows")>=0,M=p.indexOf("Macintosh")>=0,c=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=p.indexOf("Linux")>=0,g=p?.indexOf("Mobi")>=0,l=!0,m=r.getConfiguredDefaultLocale(r.localize(0,null))||t.$g,e=m,N=navigator.language):console.error("Unable to resolve platform.");var i;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(i||(t.Platform=i={}));function a(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let b=0;M?b=1:y?b=3:f&&(b=2),t.$i=y,t.$j=M,t.$k=f,t.$l=j,t.$m=h,t.$n=s,t.$o=l,t.$p=l&&typeof w.importScripts=="function",t.$q=t.$p?w.origin:void 0,t.$r=c,t.$s=g,t.$t=L,t.$u=b,t.$v=p,t.$w=e;var d;(function(S){function I(){return t.$w}S.value=I;function F(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=F;function q(){return t.$w==="en"}S.isDefault=q})(d||(t.Language=d={})),t.$x=m,t.$y=N,t.$z=E,t.$A=typeof w.postMessage=="function"&&!w.importScripts,t.$B=(()=>{if(t.$A){const S=[];w.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let q=0,x=S.length;q<x;q++){const z=S[q];if(z.id===F.data.vscodeScheduleAsyncWork){S.splice(q,1),z.callback();return}}});let I=0;return F=>{const q=++I;S.push({id:q,callback:F}),w.postMessage({vscodeScheduleAsyncWork:q},"*")}}return S=>setTimeout(S)})();var v;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(v||(t.OperatingSystem=v={})),t.OS=M||c?2:y?1:3;let A=!0,R=!1;function P(){if(!R){R=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,A=new Uint16Array(S.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function D(S){return parseFloat(S)>=20}}),ie(se[67],ue([0,1,18]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let y;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const f=M.process;y={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?y={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:y={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=y.cwd,t.env=y.env,t.$ec=y.platform,t.$fc=y.arch}),ie(se[68],ue([0,1,67]),function(W,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const y=65,M=97,f=90,j=122,h=46,l=47,s=92,c=58,L=63;class g extends Error{constructor(a,b,d){let v;typeof b=="string"&&b.indexOf("not ")===0?(v="must not be",b=b.replace(/^not /,"")):v="must be";const A=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${A} ${v} of type ${b}`;R+=`. Received type ${typeof d}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(i,a){if(i===null||typeof i!="object")throw new g(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new g(a,"string",i)}const N=r.$ec==="win32";function E(i){return i===l||i===s}function p(i){return i===l}function w(i){return i>=y&&i<=f||i>=M&&i<=j}function $(i,a,b,d){let v="",A=0,R=-1,P=0,D=0;for(let S=0;S<=i.length;++S){if(S<i.length)D=i.charCodeAt(S);else{if(d(D))break;D=l}if(d(D)){if(!(R===S-1||P===1))if(P===2){if(v.length<2||A!==2||v.charCodeAt(v.length-1)!==h||v.charCodeAt(v.length-2)!==h){if(v.length>2){const I=v.lastIndexOf(b);I===-1?(v="",A=0):(v=v.slice(0,I),A=v.length-1-v.lastIndexOf(b)),R=S,P=0;continue}else if(v.length!==0){v="",A=0,R=S,P=0;continue}}a&&(v+=v.length>0?`${b}..`:"..",A=2)}else v.length>0?v+=`${b}${i.slice(R+1,S)}`:v=i.slice(R+1,S),A=S-R-1;R=S,P=0}else D===h&&P!==-1?++P:P=-1}return v}function o(i,a){m(a,"pathObject");const b=a.dir||a.root,d=a.base||`${a.name||""}${a.ext||""}`;return b?b===a.root?`${b}${d}`:`${b}${i}${d}`:d}t.$gc={resolve(...i){let a="",b="",d=!1;for(let v=i.length-1;v>=-1;v--){let A;if(v>=0){if(A=i[v],e(A,"path"),A.length===0)continue}else a.length===0?A=r.cwd():(A=r.env[`=${a}`]||r.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==a.toLowerCase()&&A.charCodeAt(2)===s)&&(A=`${a}\\`));const R=A.length;let P=0,D="",S=!1;const I=A.charCodeAt(0);if(R===1)E(I)&&(P=1,S=!0);else if(E(I))if(S=!0,E(A.charCodeAt(1))){let F=2,q=F;for(;F<R&&!E(A.charCodeAt(F));)F++;if(F<R&&F!==q){const x=A.slice(q,F);for(q=F;F<R&&E(A.charCodeAt(F));)F++;if(F<R&&F!==q){for(q=F;F<R&&!E(A.charCodeAt(F));)F++;(F===R||F!==q)&&(D=`\\\\${x}\\${A.slice(q,F)}`,P=F)}}}else P=1;else w(I)&&A.charCodeAt(1)===c&&(D=A.slice(0,2),P=2,R>2&&E(A.charCodeAt(2))&&(S=!0,P=3));if(D.length>0)if(a.length>0){if(D.toLowerCase()!==a.toLowerCase())continue}else a=D;if(d){if(a.length>0)break}else if(b=`${A.slice(P)}\\${b}`,d=S,S&&a.length>0)break}return b=$(b,!d,"\\",E),d?`${a}\\${b}`:`${a}${b}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let b=0,d,v=!1;const A=i.charCodeAt(0);if(a===1)return p(A)?"\\":i;if(E(A))if(v=!0,E(i.charCodeAt(1))){let P=2,D=P;for(;P<a&&!E(i.charCodeAt(P));)P++;if(P<a&&P!==D){const S=i.slice(D,P);for(D=P;P<a&&E(i.charCodeAt(P));)P++;if(P<a&&P!==D){for(D=P;P<a&&!E(i.charCodeAt(P));)P++;if(P===a)return`\\\\${S}\\${i.slice(D)}\\`;P!==D&&(d=`\\\\${S}\\${i.slice(D,P)}`,b=P)}}}else b=1;else w(A)&&i.charCodeAt(1)===c&&(d=i.slice(0,2),b=2,a>2&&E(i.charCodeAt(2))&&(v=!0,b=3));let R=b<a?$(i.slice(b),!v,"\\",E):"";return R.length===0&&!v&&(R="."),R.length>0&&E(i.charCodeAt(a-1))&&(R+="\\"),d===void 0?v?`\\${R}`:R:v?`${d}\\${R}`:`${d}${R}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const b=i.charCodeAt(0);return E(b)||a>2&&w(b)&&i.charCodeAt(1)===c&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,b;for(let A=0;A<i.length;++A){const R=i[A];e(R,"path"),R.length>0&&(a===void 0?a=b=R:a+=`\\${R}`)}if(a===void 0)return".";let d=!0,v=0;if(typeof b=="string"&&E(b.charCodeAt(0))){++v;const A=b.length;A>1&&E(b.charCodeAt(1))&&(++v,A>2&&(E(b.charCodeAt(2))?++v:d=!1))}if(d){for(;v<a.length&&E(a.charCodeAt(v));)v++;v>=2&&(a=`\\${a.slice(v)}`)}return t.$gc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const b=t.$gc.resolve(i),d=t.$gc.resolve(a);if(b===d||(i=b.toLowerCase(),a=d.toLowerCase(),i===a))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===s;)v++;let A=i.length;for(;A-1>v&&i.charCodeAt(A-1)===s;)A--;const R=A-v;let P=0;for(;P<a.length&&a.charCodeAt(P)===s;)P++;let D=a.length;for(;D-1>P&&a.charCodeAt(D-1)===s;)D--;const S=D-P,I=R<S?R:S;let F=-1,q=0;for(;q<I;q++){const z=i.charCodeAt(v+q);if(z!==a.charCodeAt(P+q))break;z===s&&(F=q)}if(q!==I){if(F===-1)return d}else{if(S>I){if(a.charCodeAt(P+q)===s)return d.slice(P+q+1);if(q===2)return d.slice(P+q)}R>I&&(i.charCodeAt(v+q)===s?F=q:q===2&&(F=3)),F===-1&&(F=0)}let x="";for(q=v+F+1;q<=A;++q)(q===A||i.charCodeAt(q)===s)&&(x+=x.length===0?"..":"\\..");return P+=F,x.length>0?`${x}${d.slice(P,D)}`:(d.charCodeAt(P)===s&&++P,d.slice(P,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.$gc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const b=a.charCodeAt(2);if(b!==L&&b!==h)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(w(a.charCodeAt(0))&&a.charCodeAt(1)===c&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let b=-1,d=0;const v=i.charCodeAt(0);if(a===1)return E(v)?i:".";if(E(v)){if(b=d=1,E(i.charCodeAt(1))){let P=2,D=P;for(;P<a&&!E(i.charCodeAt(P));)P++;if(P<a&&P!==D){for(D=P;P<a&&E(i.charCodeAt(P));)P++;if(P<a&&P!==D){for(D=P;P<a&&!E(i.charCodeAt(P));)P++;if(P===a)return i;P!==D&&(b=d=P+1)}}}}else w(v)&&i.charCodeAt(1)===c&&(b=a>2&&E(i.charCodeAt(2))?3:2,d=b);let A=-1,R=!0;for(let P=a-1;P>=d;--P)if(E(i.charCodeAt(P))){if(!R){A=P;break}}else R=!1;if(A===-1){if(b===-1)return".";A=b}return i.slice(0,A)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let b=0,d=-1,v=!0,A;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===c&&(b=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,P=-1;for(A=i.length-1;A>=b;--A){const D=i.charCodeAt(A);if(E(D)){if(!v){b=A+1;break}}else P===-1&&(v=!1,P=A+1),R>=0&&(D===a.charCodeAt(R)?--R===-1&&(d=A):(R=-1,d=P))}return b===d?d=P:d===-1&&(d=i.length),i.slice(b,d)}for(A=i.length-1;A>=b;--A)if(E(i.charCodeAt(A))){if(!v){b=A+1;break}}else d===-1&&(v=!1,d=A+1);return d===-1?"":i.slice(b,d)},extname(i){e(i,"path");let a=0,b=-1,d=0,v=-1,A=!0,R=0;i.length>=2&&i.charCodeAt(1)===c&&w(i.charCodeAt(0))&&(a=d=2);for(let P=i.length-1;P>=a;--P){const D=i.charCodeAt(P);if(E(D)){if(!A){d=P+1;break}continue}v===-1&&(A=!1,v=P+1),D===h?b===-1?b=P:R!==1&&(R=1):b!==-1&&(R=-1)}return b===-1||v===-1||R===0||R===1&&b===v-1&&b===d+1?"":i.slice(b,v)},format:o.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const b=i.length;let d=0,v=i.charCodeAt(0);if(b===1)return E(v)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(E(v)){if(d=1,E(i.charCodeAt(1))){let F=2,q=F;for(;F<b&&!E(i.charCodeAt(F));)F++;if(F<b&&F!==q){for(q=F;F<b&&E(i.charCodeAt(F));)F++;if(F<b&&F!==q){for(q=F;F<b&&!E(i.charCodeAt(F));)F++;F===b?d=F:F!==q&&(d=F+1)}}}}else if(w(v)&&i.charCodeAt(1)===c){if(b<=2)return a.root=a.dir=i,a;if(d=2,E(i.charCodeAt(2))){if(b===3)return a.root=a.dir=i,a;d=3}}d>0&&(a.root=i.slice(0,d));let A=-1,R=d,P=-1,D=!0,S=i.length-1,I=0;for(;S>=d;--S){if(v=i.charCodeAt(S),E(v)){if(!D){R=S+1;break}continue}P===-1&&(D=!1,P=S+1),v===h?A===-1?A=S:I!==1&&(I=1):A!==-1&&(I=-1)}return P!==-1&&(A===-1||I===0||I===1&&A===P-1&&A===R+1?a.base=a.name=i.slice(R,P):(a.name=i.slice(R,A),a.base=i.slice(R,P),a.ext=i.slice(A,P))),R>0&&R!==d?a.dir=i.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(N){const i=/\\/g;return()=>{const a=r.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>r.cwd()})();t.$hc={resolve(...i){let a="",b=!1;for(let d=i.length-1;d>=-1&&!b;d--){const v=d>=0?i[d]:u();e(v,"path"),v.length!==0&&(a=`${v}/${a}`,b=v.charCodeAt(0)===l)}return a=$(a,!b,"/",p),b?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l,b=i.charCodeAt(i.length-1)===l;return i=$(i,!a,"/",p),i.length===0?a?"/":b?"./":".":(b&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let a;for(let b=0;b<i.length;++b){const d=i[b];e(d,"path"),d.length>0&&(a===void 0?a=d:a+=`/${d}`)}return a===void 0?".":t.$hc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.$hc.resolve(i),a=t.$hc.resolve(a),i===a))return"";const b=1,d=i.length,v=d-b,A=1,R=a.length-A,P=v<R?v:R;let D=-1,S=0;for(;S<P;S++){const F=i.charCodeAt(b+S);if(F!==a.charCodeAt(A+S))break;F===l&&(D=S)}if(S===P)if(R>P){if(a.charCodeAt(A+S)===l)return a.slice(A+S+1);if(S===0)return a.slice(A+S)}else v>P&&(i.charCodeAt(b+S)===l?D=S:S===0&&(D=0));let I="";for(S=b+D+1;S<=d;++S)(S===d||i.charCodeAt(S)===l)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(A+D)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l;let b=-1,d=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===l){if(!d){b=v;break}}else d=!1;return b===-1?a?"/":".":a&&b===1?"//":i.slice(0,b)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let b=0,d=-1,v=!0,A;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,P=-1;for(A=i.length-1;A>=0;--A){const D=i.charCodeAt(A);if(D===l){if(!v){b=A+1;break}}else P===-1&&(v=!1,P=A+1),R>=0&&(D===a.charCodeAt(R)?--R===-1&&(d=A):(R=-1,d=P))}return b===d?d=P:d===-1&&(d=i.length),i.slice(b,d)}for(A=i.length-1;A>=0;--A)if(i.charCodeAt(A)===l){if(!v){b=A+1;break}}else d===-1&&(v=!1,d=A+1);return d===-1?"":i.slice(b,d)},extname(i){e(i,"path");let a=-1,b=0,d=-1,v=!0,A=0;for(let R=i.length-1;R>=0;--R){const P=i.charCodeAt(R);if(P===l){if(!v){b=R+1;break}continue}d===-1&&(v=!1,d=R+1),P===h?a===-1?a=R:A!==1&&(A=1):a!==-1&&(A=-1)}return a===-1||d===-1||A===0||A===1&&a===d-1&&a===b+1?"":i.slice(a,d)},format:o.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const b=i.charCodeAt(0)===l;let d;b?(a.root="/",d=1):d=0;let v=-1,A=0,R=-1,P=!0,D=i.length-1,S=0;for(;D>=d;--D){const I=i.charCodeAt(D);if(I===l){if(!P){A=D+1;break}continue}R===-1&&(P=!1,R=D+1),I===h?v===-1?v=D:S!==1&&(S=1):v!==-1&&(S=-1)}if(R!==-1){const I=A===0&&b?1:A;v===-1||S===0||S===1&&v===R-1&&v===A+1?a.base=a.name=i.slice(I,R):(a.name=i.slice(I,v),a.base=i.slice(I,R),a.ext=i.slice(v,R))}return A>0?a.dir=i.slice(0,A-1):b&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=N?t.$gc.normalize:t.$hc.normalize,t.$jc=N?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=N?t.$gc.join:t.$hc.join,t.$lc=N?t.$gc.resolve:t.$hc.resolve,t.$mc=N?t.$gc.relative:t.$hc.relative,t.$nc=N?t.$gc.dirname:t.$hc.dirname,t.$oc=N?t.$gc.basename:t.$hc.basename,t.$pc=N?t.$gc.extname:t.$hc.extname,t.$qc=N?t.$gc.format:t.$hc.format,t.$rc=N?t.$gc.parse:t.$hc.parse,t.$sc=N?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=N?t.$gc.sep:t.$hc.sep,t.$uc=N?t.$gc.delimiter:t.$hc.delimiter}),ie(se[19],ue([0,1,68,18]),function(W,t,r,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=o;const M=/^\w[\w\d+.-]*$/,f=/^\//,j=/^\/\//;function h(d,v){if(!d.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!M.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(d,v){return!d&&!v?"file":d}function s(d,v){switch(d){case"https":case"http":case"file":v?v[0]!==L&&(v=L+v):v=L;break}return v}const c="",L="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(v){return v instanceof m?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,A,R,P,D,S=!1){typeof v=="object"?(this.scheme=v.scheme||c,this.authority=v.authority||c,this.path=v.path||c,this.query=v.query||c,this.fragment=v.fragment||c):(this.scheme=l(v,S),this.authority=A||c,this.path=s(this.scheme,R||c),this.query=P||c,this.fragment=D||c,h(this,S))}get fsPath(){return o(this,!1)}with(v){if(!v)return this;let{scheme:A,authority:R,path:P,query:D,fragment:S}=v;return A===void 0?A=this.scheme:A===null&&(A=c),R===void 0?R=this.authority:R===null&&(R=c),P===void 0?P=this.path:P===null&&(P=c),D===void 0?D=this.query:D===null&&(D=c),S===void 0?S=this.fragment:S===null&&(S=c),A===this.scheme&&R===this.authority&&P===this.path&&D===this.query&&S===this.fragment?this:new E(A,R,P,D,S)}static parse(v,A=!1){const R=g.exec(v);return R?new E(R[2]||c,b(R[4]||c),b(R[5]||c),b(R[7]||c),b(R[9]||c),A):new E(c,c,c,c,c)}static file(v){let A=c;if(y.$i&&(v=v.replace(/\\/g,L)),v[0]===L&&v[1]===L){const R=v.indexOf(L,2);R===-1?(A=v.substring(2),v=L):(A=v.substring(2,R),v=v.substring(R)||L)}return new E("file",A,v,c,c)}static from(v,A){return new E(v.scheme,v.authority,v.path,v.query,v.fragment,A)}static joinPath(v,...A){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return y.$i&&v.scheme==="file"?R=m.file(r.$gc.join(o(v,!0),...A)).path:R=r.$hc.join(v.path,...A),v.with({path:R})}toString(v=!1){return u(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof m)return v;{const A=new E(v);return A._formatted=v.external??null,A._fsPath=v._sep===N?v.fsPath??null:null,A}}else return v}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const N=y.$i?1:void 0;class E extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(v=!1){return v?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=N),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const p={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function w(d,v,A){let R,P=-1;for(let D=0;D<d.length;D++){const S=d.charCodeAt(D);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||v&&S===47||A&&S===91||A&&S===93||A&&S===58)P!==-1&&(R+=encodeURIComponent(d.substring(P,D)),P=-1),R!==void 0&&(R+=d.charAt(D));else{R===void 0&&(R=d.substr(0,D));const I=p[S];I!==void 0?(P!==-1&&(R+=encodeURIComponent(d.substring(P,D)),P=-1),R+=I):P===-1&&(P=D)}}return P!==-1&&(R+=encodeURIComponent(d.substring(P))),R!==void 0?R:d}function $(d){let v;for(let A=0;A<d.length;A++){const R=d.charCodeAt(A);R===35||R===63?(v===void 0&&(v=d.substr(0,A)),v+=p[R]):v!==void 0&&(v+=d[A])}return v!==void 0?v:d}function o(d,v){let A;return d.authority&&d.path.length>1&&d.scheme==="file"?A=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?v?A=d.path.substr(1):A=d.path[1].toLowerCase()+d.path.substr(2):A=d.path,y.$i&&(A=A.replace(/\//g,"\\")),A}function u(d,v){const A=v?$:w;let R="",{scheme:P,authority:D,path:S,query:I,fragment:F}=d;if(P&&(R+=P,R+=":"),(D||P==="file")&&(R+=L,R+=L),D){let q=D.indexOf("@");if(q!==-1){const x=D.substr(0,q);D=D.substr(q+1),q=x.lastIndexOf(":"),q===-1?R+=A(x,!1,!1):(R+=A(x.substr(0,q),!1,!1),R+=":",R+=A(x.substr(q+1),!1,!0)),R+="@"}D=D.toLowerCase(),q=D.lastIndexOf(":"),q===-1?R+=A(D,!1,!0):(R+=A(D.substr(0,q),!1,!0),R+=D.substr(q))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const q=S.charCodeAt(1);q>=65&&q<=90&&(S=`/${String.fromCharCode(q+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const q=S.charCodeAt(0);q>=65&&q<=90&&(S=`${String.fromCharCode(q+32)}:${S.substr(2)}`)}R+=A(S,!0,!1)}return I&&(R+="?",R+=A(I,!1,!1)),F&&(R+="#",R+=v?F:w(F,!1,!1)),R}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(d){return d.match(a)?d.replace(a,v=>i(v)):d}}),ie(se[73],ue([0,1,3,11,10,15,18,7]),function(W,t,r,y,M,f,j,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=a;const l="$initialize";let s=!1;function c(b){j.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(b.message))}var L;(function(b){b[b.Request=0]="Request",b[b.Reply=1]="Reply",b[b.SubscribeEvent=2]="SubscribeEvent",b[b.Event=3]="Event",b[b.UnsubscribeEvent=4]="UnsubscribeEvent"})(L||(L={}));class g{constructor(d,v,A,R){this.vsWorker=d,this.req=v,this.method=A,this.args=R,this.type=0}}class m{constructor(d,v,A,R){this.vsWorker=d,this.seq=v,this.res=A,this.err=R,this.type=1}}class e{constructor(d,v,A,R){this.vsWorker=d,this.req=v,this.eventName=A,this.arg=R,this.type=2}}class N{constructor(d,v,A){this.vsWorker=d,this.req=v,this.event=A,this.type=3}}class E{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class p{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,v){const A=String(++this.b);return new Promise((R,P)=>{this.c[A]={resolve:R,reject:P},this.o(new g(this.a,A,d,v))})}listen(d,v){let A=null;const R=new y.$be({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,R),this.o(new e(this.a,A,d,v))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new E(this.a,A)),A=null}});return R.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[d.seq];if(delete this.c[d.seq],d.err){let A=d.err;d.err.$isError&&(A=new Error,A.name=d.err.name,A.message=d.err.message,A.stack=d.err.stack),v.reject(A);return}v.resolve(d.res)}k(d){const v=d.req;this.g.handleMessage(d.method,d.args).then(R=>{this.o(new m(this.a,v,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,r.$3)(R.detail)),this.o(new m(this.a,v,void 0,(0,r.$3)(R)))})}l(d){const v=d.req,A=this.g.handleEvent(d.eventName,d.arg)(R=>{this.o(new N(this.a,v,R))});this.f.set(v,A)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const v=[];if(d.type===0)for(let A=0;A<d.args.length;A++)d.args[A]instanceof ArrayBuffer&&v.push(d.args[A]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this.g.sendMessage(d,v)}}class w extends M.$Uc{constructor(d,v,A){super();let R=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{R?.(q)})),this.c=new p({sendMessage:(q,x)=>{this.a.postMessage(q,x)},handleMessage:(q,x)=>{if(typeof A[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(A[q].apply(A,x))}catch(z){return Promise.reject(z)}},handleEvent:(q,x)=>{if(o(q)){const z=A[q].call(A,x);if(typeof z!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return z}if($(q)){const z=A[q];if(typeof z!="function")throw new Error(`Missing event ${q} on main thread host.`);return z}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const D=globalThis.require;typeof D<"u"&&typeof D.getConfig=="function"?P=D.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const S=(0,f.$7n)(A);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(P)),v,S]);const I=(q,x)=>this.g(q,x),F=(q,x)=>this.c.listen(q,x);this.f=new Promise((q,x)=>{R=x,this.b.then(z=>{q(u(z,I,F))},z=>{x(z),this.h("Worker failed to load "+v,z)})})}getProxyObject(){return this.f}g(d,v){return new Promise((A,R)=>{this.b.then(()=>{this.c.sendMessage(d,v).then(A,R)},R)})}h(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=w;function $(b){return b[0]==="o"&&b[1]==="n"&&h.$sf(b.charCodeAt(2))}function o(b){return/^onDynamic/.test(b)&&h.$sf(b.charCodeAt(9))}function u(b,d,v){const A=D=>function(){const S=Array.prototype.slice.call(arguments,0);return d(D,S)},R=D=>function(S){return v(D,S)},P={};for(const D of b){if(o(D)){P[D]=R(D);continue}if($(D)){P[D]=v(D,void 0);continue}P[D]=A(D)}return P}class i{constructor(d,v){this.a=v,this.b=null,this.c=new p({sendMessage:(A,R)=>{d(A,R)},handleMessage:(A,R)=>this.d(A,R),handleEvent:(A,R)=>this.f(A,R)})}onmessage(d){this.c.handleMessage(d)}d(d,v){if(d===l)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,v))}catch(A){return Promise.reject(A)}}f(d,v){if(!this.b)throw new Error("Missing requestHandler");if(o(d)){const A=this.b[d].call(this.b,v);if(typeof A!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return A}if($(d)){const A=this.b[d];if(typeof A!="function")throw new Error(`Missing event ${d} on request handler.`);return A}throw new Error(`Malformed event name ${d}`)}g(d,v,A,R){this.c.setWorkerId(d);const S=u(R,(I,F)=>this.c.sendMessage(I,F),(I,F)=>this.c.listen(I,F));return this.a?(this.b=this.a(S),Promise.resolve((0,f.$7n)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy<"u"&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((I,F)=>{(globalThis.require||W)([A],x=>{if(this.b=x.create(S),!this.b){F(new Error("No RequestHandler!"));return}I((0,f.$7n)(this.b))},F)}))}}t.SimpleWorkerServer=i;function a(b){return new i(b,null)}}),ie(se[69],ue([65,66]),function(W,t){return W.create("vs/editor/common/languages",t)}),ie(se[70],ue([0,1,43,19,44,2,63,69]),function(W,t,r,y,M,f,j,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$8t=t.$7t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$6t=t.$5t=t.SymbolKinds=t.SymbolTag=t.$3t=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$1t=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Zt=t.$Yt=t.$Xt=void 0,t.$2t=a,t.$4t=d;class l{constructor(V,ne,le){this.offset=V,this.type=ne,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Xt=l;class s{constructor(V,ne){this.tokens=V,this.endState=ne,this._tokenizationResultBrand=void 0}}t.$Yt=s;class c{constructor(V,ne){this.tokens=V,this.endState=ne,this._encodedTokenizationResultBrand=void 0}}t.$Zt=c;var L;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(L||(t.CompletionItemKind=L={}));var g;(function(k){const V=new Map;V.set(0,r.$Pj.symbolMethod),V.set(1,r.$Pj.symbolFunction),V.set(2,r.$Pj.symbolConstructor),V.set(3,r.$Pj.symbolField),V.set(4,r.$Pj.symbolVariable),V.set(5,r.$Pj.symbolClass),V.set(6,r.$Pj.symbolStruct),V.set(7,r.$Pj.symbolInterface),V.set(8,r.$Pj.symbolModule),V.set(9,r.$Pj.symbolProperty),V.set(10,r.$Pj.symbolEvent),V.set(11,r.$Pj.symbolOperator),V.set(12,r.$Pj.symbolUnit),V.set(13,r.$Pj.symbolValue),V.set(15,r.$Pj.symbolEnum),V.set(14,r.$Pj.symbolConstant),V.set(15,r.$Pj.symbolEnum),V.set(16,r.$Pj.symbolEnumMember),V.set(17,r.$Pj.symbolKeyword),V.set(27,r.$Pj.symbolSnippet),V.set(18,r.$Pj.symbolText),V.set(19,r.$Pj.symbolColor),V.set(20,r.$Pj.symbolFile),V.set(21,r.$Pj.symbolReference),V.set(22,r.$Pj.symbolCustomColor),V.set(23,r.$Pj.symbolFolder),V.set(24,r.$Pj.symbolTypeParameter),V.set(25,r.$Pj.account),V.set(26,r.$Pj.issues);function ne(n){let Ne=V.get(n);return Ne||(console.info("No codicon found for CompletionItemKind "+n),Ne=r.$Pj.symbolProperty),Ne}k.toIcon=ne;const le=new Map;le.set("method",0),le.set("function",1),le.set("constructor",2),le.set("field",3),le.set("variable",4),le.set("class",5),le.set("struct",6),le.set("interface",7),le.set("module",8),le.set("property",9),le.set("event",10),le.set("operator",11),le.set("unit",12),le.set("value",13),le.set("constant",14),le.set("enum",15),le.set("enum-member",16),le.set("enumMember",16),le.set("keyword",17),le.set("snippet",27),le.set("text",18),le.set("color",19),le.set("file",20),le.set("reference",21),le.set("customcolor",22),le.set("folder",23),le.set("type-parameter",24),le.set("typeParameter",24),le.set("account",25),le.set("issue",26);function me(n,Ne){let pe=le.get(n);return typeof pe>"u"&&!Ne&&(pe=9),pe}k.fromString=me})(g||(t.CompletionItemKinds=g={}));var m;(function(k){k[k.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(N||(t.PartialAcceptTriggerKind=N={}));var E;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var p;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(p||(t.InlineCompletionTriggerKind=p={}));class w{constructor(V,ne,le,me){this.range=V,this.text=ne,this.completionKind=le,this.isSnippetText=me}equals(V){return f.$kt.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}t.$1t=w;var $;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var o;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(o||(t.DocumentPasteTriggerKind=o={}));var u;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(u||(t.SignatureHelpTriggerKind=u={}));var i;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(i||(t.DocumentHighlightKind=i={}));function a(k){return k&&y.URI.isUri(k.uri)&&f.$kt.isIRange(k.range)&&(f.$kt.isIRange(k.originSelectionRange)||f.$kt.isIRange(k.targetSelectionRange))}var b;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(b||(t.SymbolKind=b={})),t.$3t={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function d(k,V){return(0,h.localize)(26,null,k,t.$3t[V])}var v;(function(k){k[k.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var A;(function(k){const V=new Map;V.set(0,r.$Pj.symbolFile),V.set(1,r.$Pj.symbolModule),V.set(2,r.$Pj.symbolNamespace),V.set(3,r.$Pj.symbolPackage),V.set(4,r.$Pj.symbolClass),V.set(5,r.$Pj.symbolMethod),V.set(6,r.$Pj.symbolProperty),V.set(7,r.$Pj.symbolField),V.set(8,r.$Pj.symbolConstructor),V.set(9,r.$Pj.symbolEnum),V.set(10,r.$Pj.symbolInterface),V.set(11,r.$Pj.symbolFunction),V.set(12,r.$Pj.symbolVariable),V.set(13,r.$Pj.symbolConstant),V.set(14,r.$Pj.symbolString),V.set(15,r.$Pj.symbolNumber),V.set(16,r.$Pj.symbolBoolean),V.set(17,r.$Pj.symbolArray),V.set(18,r.$Pj.symbolObject),V.set(19,r.$Pj.symbolKey),V.set(20,r.$Pj.symbolNull),V.set(21,r.$Pj.symbolEnumMember),V.set(22,r.$Pj.symbolStruct),V.set(23,r.$Pj.symbolEvent),V.set(24,r.$Pj.symbolOperator),V.set(25,r.$Pj.symbolTypeParameter);function ne(le){let me=V.get(le);return me||(console.info("No codicon found for SymbolKind "+le),me=r.$Pj.symbolProperty),me}k.toIcon=ne})(A||(t.SymbolKinds=A={}));class R{static asEditOperation(V){return M.$lt.replace(f.$kt.lift(V.range),V.text)}}t.$5t=R;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(V){switch(V){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(V)}constructor(V){this.value=V}}t.$6t=P;var D;(function(k){k[k.AIGenerated=1]="AIGenerated"})(D||(t.NewSymbolNameTag=D={}));var S;(function(k){function V(ne){return!ne||typeof ne!="object"?!1:typeof ne.id=="string"&&typeof ne.title=="string"}k.is=V})(S||(t.Command=S={}));var I;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(I||(t.CommentThreadCollapsibleState=I={}));var F;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(F||(t.CommentThreadState=F={}));var q;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(q||(t.CommentThreadApplicability=q={}));var x;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(x||(t.CommentMode=x={}));var z;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(z||(t.CommentState=z={}));var Y;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(Y||(t.InlayHintKind=Y={}));class Z{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$7t=Z,t.$8t=new j.$Mt;var X;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}));var G;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(G||(t.InlineEditTriggerKind=G={}))}),ie(se[71],ue([0,1,24,11,38,19,5,2,45,70,62]),function(W,t,r,y,M,f,j,h,l,s,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$72=void 0,t.$82=g;class L{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,N){return(0,M.$wr)(e,N)}}t.$72=L;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.$me,Emitter:y.$be,KeyCode:c.KeyCode,KeyMod:L,Position:j.$jt,Range:h.$kt,Selection:l.$mt,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:f.URI,Token:s.$Xt}}}),ie(se[74],ue([0,1,25,19,5,2,58,30,54,55,71,23,61,34,52,15,3,53,60]),function(W,t,r,y,M,f,j,h,l,s,c,L,g,m,e,N,E,p,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=u;class $ extends j.$Pv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(a){const b=[];for(let d=0;d<this.f.length;d++){const v=this.f[d],A=this.offsetAt(new M.$jt(d+1,1)),R=v.matchAll(a);for(const P of R)(P.index||P.index===0)&&(P.index=P.index+A),b.push(P)}return b}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(a){return this.f[a-1]}getWordAtPosition(a,b){const d=(0,h.$Zs)(a.column,(0,h.$Xs)(b),this.f[a.lineNumber-1],0);return d?new f.$kt(a.lineNumber,d.startColumn,a.lineNumber,d.endColumn):null}getWordUntilPosition(a,b){const d=this.getWordAtPosition(a,b);return d?{word:this.f[a.lineNumber-1].substring(d.startColumn-1,a.column-1),startColumn:d.startColumn,endColumn:a.column}:{word:"",startColumn:a.column,endColumn:a.column}}words(a){const b=this.f,d=this.q.bind(this);let v=0,A="",R=0,P=[];return{*[Symbol.iterator](){for(;;)if(R<P.length){const D=A.substring(P[R].start,P[R].end);R+=1,yield D}else if(v<b.length)A=b[v],P=d(A,a),R=0,v+=1;else break}}}getLineWords(a,b){const d=this.f[a-1],v=this.q(d,b),A=[];for(const R of v)A.push({word:d.substring(R.start,R.end),startColumn:R.start+1,endColumn:R.end+1});return A}q(a,b){const d=[];let v;for(b.lastIndex=0;(v=b.exec(a))&&v[0].length!==0;)d.push({start:v.index,end:v.index+v[0].length});return d}getValueInRange(a){if(a=this.r(a),a.startLineNumber===a.endLineNumber)return this.f[a.startLineNumber-1].substring(a.startColumn-1,a.endColumn-1);const b=this.g,d=a.startLineNumber-1,v=a.endLineNumber-1,A=[];A.push(this.f[d].substring(a.startColumn-1));for(let R=d+1;R<v;R++)A.push(this.f[R]);return A.push(this.f[v].substring(0,a.endColumn-1)),A.join(b)}offsetAt(a){return a=this.s(a),this.l(),this.j.getPrefixSum(a.lineNumber-2)+(a.column-1)}positionAt(a){a=Math.floor(a),a=Math.max(0,a),this.l();const b=this.j.getIndexOf(a),d=this.f[b.index].length;return{lineNumber:1+b.index,column:1+Math.min(b.remainder,d)}}r(a){const b=this.s({lineNumber:a.startLineNumber,column:a.startColumn}),d=this.s({lineNumber:a.endLineNumber,column:a.endColumn});return b.lineNumber!==a.startLineNumber||b.column!==a.startColumn||d.lineNumber!==a.endLineNumber||d.column!==a.endColumn?{startLineNumber:b.lineNumber,startColumn:b.column,endLineNumber:d.lineNumber,endColumn:d.column}:a}s(a){if(!M.$jt.isIPosition(a))throw new Error("bad position");let{lineNumber:b,column:d}=a,v=!1;if(b<1)b=1,d=1,v=!0;else if(b>this.f.length)b=this.f.length,d=this.f[b-1].length+1,v=!0;else{const A=this.f[b-1].length+1;d<1?(d=1,v=!0):d>A&&(d=A,v=!0)}return v?{lineNumber:b,column:d}:a}}class o{constructor(a,b){this.d=a,this.f=Object.create(null),this.g=b,this.h=null}dispose(){this.f=Object.create(null)}j(a){return this.f[a]}k(){const a=[];return Object.keys(this.f).forEach(b=>a.push(this.f[b])),a}acceptNewModel(a){this.f[a.url]=new $(y.URI.parse(a.url),a.lines,a.EOL,a.versionId)}acceptModelChanged(a,b){if(!this.f[a])return;this.f[a].onEvents(b)}acceptRemovedModel(a){this.f[a]&&delete this.f[a]}async computeUnicodeHighlights(a,b,d){const v=this.j(a);return v?g.$22.computeUnicodeHighlights(v,b,d):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(a,b){const d=this.j(a);return d?(0,w.$t3)(d,b):[]}async computeDiff(a,b,d,v){const A=this.j(a),R=this.j(b);return!A||!R?null:o.l(A,R,d,v)}static l(a,b,d,v){const A=v==="advanced"?e.$r3.getDefault():e.$r3.getLegacy(),R=a.getLinesContent(),P=b.getLinesContent(),D=A.computeDiff(R,P,d),S=D.changes.length>0?!1:this.n(a,b);function I(F){return F.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:S,quitEarly:D.hitTimeout,changes:I(D.changes),moves:D.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,I(F.changes)])}}static n(a,b){const d=a.getLineCount(),v=b.getLineCount();if(d!==v)return!1;for(let A=1;A<=d;A++){const R=a.getLineContent(A),P=b.getLineContent(A);if(R!==P)return!1}return!0}async computeDirtyDiff(a,b,d){const v=this.j(a),A=this.j(b);if(!v||!A)return null;const R=v.getLinesContent(),P=A.getLinesContent();return new m.$Jv(R,P,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:d,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(a,b,d){const v=this.j(a);if(!v)return b;const A=[];let R;b=b.slice(0).sort((D,S)=>{if(D.range&&S.range)return f.$kt.compareRangesUsingStarts(D.range,S.range);const I=D.range?0:1,F=S.range?0:1;return I-F});let P=0;for(let D=1;D<b.length;D++)f.$kt.getEndPosition(b[P].range).equals(f.$kt.getStartPosition(b[D].range))?(b[P].range=f.$kt.fromPositions(f.$kt.getStartPosition(b[P].range),f.$kt.getEndPosition(b[D].range)),b[P].text+=b[D].text):(P++,b[P]=b[D]);b.length=P+1;for(let{range:D,text:S,eol:I}of b){if(typeof I=="number"&&(R=I),f.$kt.isEmpty(D)&&!S)continue;const F=v.getValueInRange(D);if(S=S.replace(/\r\n|\n|\r/g,v.eol),F===S)continue;if(Math.max(S.length,F.length)>o.o){A.push({range:D,text:S});continue}const q=(0,r.$pt)(F,S,d),x=v.offsetAt(f.$kt.lift(D).getStartPosition());for(const z of q){const Y=v.positionAt(x+z.originalStart),Z=v.positionAt(x+z.originalStart+z.originalLength),X={text:S.substr(z.modifiedStart,z.modifiedLength),range:{startLineNumber:Y.lineNumber,startColumn:Y.column,endLineNumber:Z.lineNumber,endColumn:Z.column}};v.getValueInRange(X.range)!==X.text&&A.push(X)}}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}computeHumanReadableDiff(a,b,d){const v=this.j(a);if(!v)return b;const A=[];let R;b=b.slice(0).sort((P,D)=>{if(P.range&&D.range)return f.$kt.compareRangesUsingStarts(P.range,D.range);const S=P.range?0:1,I=D.range?0:1;return S-I});for(let{range:P,text:D,eol:S}of b){let Y=function(X,G){return new M.$jt(X.lineNumber+G.lineNumber-1,G.lineNumber===1?X.column+G.column-1:G.column)},Z=function(X,G){const k=[];for(let V=G.startLineNumber;V<=G.endLineNumber;V++){const ne=X[V-1];V===G.startLineNumber&&V===G.endLineNumber?k.push(ne.substring(G.startColumn-1,G.endColumn-1)):V===G.startLineNumber?k.push(ne.substring(G.startColumn-1)):V===G.endLineNumber?k.push(ne.substring(0,G.endColumn-1)):k.push(ne)}return k};if(typeof S=="number"&&(R=S),f.$kt.isEmpty(P)&&!D)continue;const I=v.getValueInRange(P);if(D=D.replace(/\r\n|\n|\r/g,v.eol),I===D)continue;if(Math.max(D.length,I.length)>o.o){A.push({range:P,text:D});continue}const F=I.split(/\r\n|\n|\r/),q=D.split(/\r\n|\n|\r/),x=e.$r3.getDefault().computeDiff(F,q,d),z=f.$kt.lift(P).getStartPosition();for(const X of x.changes)if(X.innerChanges)for(const G of X.innerChanges)A.push({range:f.$kt.fromPositions(Y(z,G.originalRange.getStartPosition()),Y(z,G.originalRange.getEndPosition())),text:Z(q,G.modifiedRange).join(v.eol)});else throw new E.$cb("The experimental diff algorithm always produces inner changes")}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}async computeLinks(a){const b=this.j(a);return b?(0,l.$52)(b):null}async computeDefaultDocumentColors(a){const b=this.j(a);return b?(0,p.$s3)(b):null}static{this.p=1e4}async textualSuggest(a,b,d,v){const A=new L.$0d,R=new RegExp(d,v),P=new Set;e:for(const D of a){const S=this.j(D);if(S){for(const I of S.words(R))if(!(I===b||!isNaN(Number(I)))&&(P.add(I),P.size>o.p))break e}}return{words:Array.from(P),duration:A.elapsed()}}async computeWordRanges(a,b,d,v){const A=this.j(a);if(!A)return Object.create(null);const R=new RegExp(d,v),P=Object.create(null);for(let D=b.startLineNumber;D<b.endLineNumber;D++){const S=A.getLineWords(D,R);for(const I of S){if(!isNaN(Number(I.word)))continue;let F=P[I.word];F||(F=[],P[I.word]=F),F.push({startLineNumber:D,startColumn:I.startColumn,endLineNumber:D,endColumn:I.endColumn})}}return P}async navigateValueSet(a,b,d,v,A){const R=this.j(a);if(!R)return null;const P=new RegExp(v,A);b.startColumn===b.endColumn&&(b={startLineNumber:b.startLineNumber,startColumn:b.startColumn,endLineNumber:b.endLineNumber,endColumn:b.endColumn+1});const D=R.getValueInRange(b),S=R.getWordAtPosition({lineNumber:b.startLineNumber,column:b.startColumn},P);if(!S)return null;const I=R.getValueInRange(S);return s.$62.INSTANCE.navigateValueSet(b,D,S,I,d)}loadForeignModule(a,b,d){const v=(P,D)=>this.d.fhr(P,D),R={host:(0,N.$8n)(d,v),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(R,b),Promise.resolve((0,N.$7n)(this.h))):new Promise((P,D)=>{W([a],S=>{this.h=S.create(R,b),P((0,N.$7n)(this.h))},D)})}fmr(a,b){if(!this.h||typeof this.h[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this.h[a].apply(this.h,b))}catch(d){return Promise.reject(d)}}}t.EditorSimpleWorker=o;function u(i){return new o(i,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$82)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d30cf1447b6442215404fcba71ea59588d94908/core/vs/base/worker/workerMain.js.map
