/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Z){for(var e=[],i=0,D=Z.length;i<D;i++)e[i]=re[Z[i]];return e};define(re[136],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=i,e.$gb=D,e.$hb=S,e.$ib=R,e.$jb=P,e.$kb=E,e.$lb=h,e.$nb=g,e.$ob=y,e.$pb=k,e.$qb=$,e.$rb=d;function i(v,p){const m=D(v,p);if(m!==-1)return v[m]}function D(v,p,m=v.length-1){for(let f=m;f>=0;f--){const l=v[f];if(p(l))return f}return-1}function S(v,p){const m=R(v,p);return m===-1?void 0:v[m]}function R(v,p,m=0,f=v.length){let l=m,w=f;for(;l<w;){const a=Math.floor((l+w)/2);p(v[a])?l=a+1:w=a}return l-1}function P(v,p){const m=E(v,p);return m===v.length?void 0:v[m]}function E(v,p,m=0,f=v.length){let l=m,w=f;for(;l<w;){const a=Math.floor((l+w)/2);p(v[a])?w=a:l=a+1}return l}function h(v,p,m=0,f=v.length){const l=E(v,p,m,f);return l===v.length?-1:l}class u{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(u.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const m=R(this.e,p,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=u;function g(v,p){if(v.length===0)return;let m=v[0];for(let f=1;f<v.length;f++){const l=v[f];p(l,m)>0&&(m=l)}return m}function y(v,p){if(v.length===0)return;let m=v[0];for(let f=1;f<v.length;f++){const l=v[f];p(l,m)>=0&&(m=l)}return m}function k(v,p){return g(v,(m,f)=>-p(m,f))}function $(v,p){if(v.length===0)return-1;let m=0;for(let f=1;f<v.length;f++){const l=v[f];p(l,v[m])>0&&(m=f)}return m}function d(v,p){for(const m of v){const f=p(m);if(f!==void 0)return f}}}),define(re[137],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=D,e.$M=S,e.$N=R;function i(P,E){const h=Object.create(null);for(const u of P){const g=E(u);let y=h[g];y||(y=h[g]=[]),y.push(u)}return h}function D(P,E){const h=[],u=[];for(const g of P)E.has(g)||h.push(g);for(const g of E)P.has(g)||u.push(g);return{removed:h,added:u}}function S(P,E){const h=[],u=[];for(const[g,y]of P)E.has(g)||h.push(y);for(const[g,y]of E)P.has(g)||u.push(y);return{removed:h,added:u}}function R(P,E){const h=new Set;for(const u of E)P.has(u)&&h.add(u);return h}}),define(re[138],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.$Dt=e.$Ct=void 0;function i(E,h){const u=Math.pow(10,h);return Math.round(E*u)/u}class D{constructor(h,u,g,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.r===u.r&&h.g===u.g&&h.b===u.b&&h.a===u.a}}e.$Ct=D;class S{constructor(h,u,g,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.h===u.h&&h.s===u.s&&h.l===u.l&&h.a===u.a}static fromRGBA(h){const u=h.r/255,g=h.g/255,y=h.b/255,k=h.a,$=Math.max(u,g,y),d=Math.min(u,g,y);let v=0,p=0;const m=(d+$)/2,f=$-d;if(f>0){switch(p=Math.min(m<=.5?f/(2*m):f/(2-2*m),1),$){case u:v=(g-y)/f+(g<y?6:0);break;case g:v=(y-u)/f+2;break;case y:v=(u-g)/f+4;break}v*=60,v=Math.round(v)}return new S(v,p,m,k)}static i(h,u,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?h+(u-h)*6*g:g<1/2?u:g<2/3?h+(u-h)*(2/3-g)*6:h}static toRGBA(h){const u=h.h/360,{s:g,l:y,a:k}=h;let $,d,v;if(g===0)$=d=v=y;else{const p=y<.5?y*(1+g):y+g-y*g,m=2*y-p;$=S.i(m,p,u+1/3),d=S.i(m,p,u),v=S.i(m,p,u-1/3)}return new D(Math.round($*255),Math.round(d*255),Math.round(v*255),k)}}e.$Dt=S;class R{constructor(h,u,g,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,g),0),3),this.a=i(Math.max(Math.min(1,y),0),3)}static equals(h,u){return h.h===u.h&&h.s===u.s&&h.v===u.v&&h.a===u.a}static fromRGBA(h){const u=h.r/255,g=h.g/255,y=h.b/255,k=Math.max(u,g,y),$=Math.min(u,g,y),d=k-$,v=k===0?0:d/k;let p;return d===0?p=0:k===u?p=((g-y)/d%6+6)%6:k===g?p=(y-u)/d+2:p=(u-g)/d+4,new R(Math.round(p*60),v,k,h.a)}static toRGBA(h){const{h:u,s:g,v:y,a:k}=h,$=y*g,d=$*(1-Math.abs(u/60%2-1)),v=y-$;let[p,m,f]=[0,0,0];return u<60?(p=$,m=d):u<120?(p=d,m=$):u<180?(m=$,f=d):u<240?(m=d,f=$):u<300?(p=d,f=$):u<=360&&(p=$,f=d),p=Math.round((p+v)*255),m=Math.round((m+v)*255),f=Math.round((f+v)*255),new D(p,m,f,k)}}e.$Et=R;class P{static fromHex(h){return P.Format.CSS.parseHex(h)||P.red}static equals(h,u){return!h&&!u?!0:!h||!u?!1:h.equals(u)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof D)this.rgba=h;else if(h instanceof S)this.i=h,this.rgba=S.toRGBA(h);else if(h instanceof R)this.j=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&D.equals(this.rgba,h.rgba)&&S.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=P.k(this.rgba.r),u=P.k(this.rgba.g),g=P.k(this.rgba.b),y=.2126*h+.7152*u+.0722*g;return i(y,4)}static k(h){const u=h/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u>g?(u+.05)/(g+.05):(g+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u>g}isDarkerThan(h){const u=this.getRelativeLuminance(),g=h.getRelativeLuminance();return u<g}lighten(h){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new P(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:u,g,b:y,a:k}=this.rgba;return new P(new D(u,g,y,k*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new P(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const u=h.rgba,g=this.rgba.a,y=u.a,k=g+y*(1-g);if(k<1e-6)return P.transparent;const $=this.rgba.r*g/k+u.r*y*(1-g)/k,d=this.rgba.g*g/k+u.g*y*(1-g)/k,v=this.rgba.b*g/k+u.b*y*(1-g)/k;return new P(new D($,d,v,k))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:u,g,b:y,a:k}=this.rgba;return new P(new D(h.rgba.r-k*(h.rgba.r-u),h.rgba.g-k*(h.rgba.g-g),h.rgba.b-k*(h.rgba.b-y),1))}flatten(...h){const u=h.reduceRight((g,y)=>P.o(y,g));return P.o(this,u)}static o(h,u){const g=1-h.rgba.a;return new P(new D(g*u.rgba.r+h.rgba.a*h.rgba.r,g*u.rgba.g+h.rgba.a*h.rgba.g,g*u.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=P.Format.CSS.format(this)),this.u}static getLighterColor(h,u,g){if(h.isLighterThan(u))return h;g=g||.5;const y=h.getRelativeLuminance(),k=u.getRelativeLuminance();return g=g*(k-y)/k,h.lighten(g)}static getDarkerColor(h,u,g){if(h.isDarkerThan(u))return h;g=g||.5;const y=h.getRelativeLuminance(),k=u.getRelativeLuminance();return g=g*(y-k)/y,h.darken(g)}static{this.white=new P(new D(255,255,255,1))}static{this.black=new P(new D(0,0,0,1))}static{this.red=new P(new D(255,0,0,1))}static{this.blue=new P(new D(0,0,255,1))}static{this.green=new P(new D(0,255,0,1))}static{this.cyan=new P(new D(0,255,255,1))}static{this.lightgrey=new P(new D(211,211,211,1))}static{this.transparent=new P(new D(0,0,0,0))}}e.$Ft=P,function(E){let h;(function(u){let g;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function $(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=$;function d(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=d;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function p(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function m(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}y.formatHex=m;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function l(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=l;function w(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new D(s,n,r,1))}if(o===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),n=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new D(s,n,r,c/255))}if(o===4){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),r=a(t.charCodeAt(3));return new E(new D(16*s+s,16*n+n,16*r+r))}if(o===5){const s=a(t.charCodeAt(1)),n=a(t.charCodeAt(2)),r=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new E(new D(16*s+s,16*n+n,16*r+r,(16*c+c)/255))}return null}y.parseHex=w;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=u.CSS||(u.CSS={}))})(h=E.Format||(E.Format={}))}(P||(e.$Ft=P={}))}),define(re[51],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=D,e.$Vh=S,e.$Wh=R;function i(P){return(E,h,u)=>{let g=null,y=null;if(typeof u.value=="function"?(g="value",y=u.value):typeof u.get=="function"&&(g="get",y=u.get),!y)throw new Error("not supported");u[g]=P(y,h)}}function D(P,E,h){let u=null,g=null;if(typeof h.value=="function"?(u="value",g=h.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",g=h.get),!g)throw new Error("not supported");const y=`$memoize$${E}`;h[u]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,k)}),this[y]}}function S(P,E,h){return i((u,g)=>{const y=`$debounce$${g}`,k=`$debounce$result$${g}`;return function(...$){this[k]||(this[k]=h?h():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...$),$=[this[k]]),this[y]=setTimeout(()=>{u.apply(this,$),this[k]=h?h():void 0},P)}})}function R(P,E,h){return i((u,g)=>{const y=`$throttle$timer$${g}`,k=`$throttle$result$${g}`,$=`$throttle$lastRun$${g}`,d=`$throttle$pending$${g}`;return function(...v){if(this[k]||(this[k]=h?h():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[d])return;const p=this[$]+P;p<=Date.now()?(this[$]=Date.now(),u.apply(this,[this[k]]),this[k]=h?h():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[$]=Date.now(),u.apply(this,[this[k]]),this[k]=h?h():void 0},p-Date.now()))}})}}),define(re[15],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=D,e.$Z=S,e.$1=R,e.$2=P,e.$3=E,e.$4=u,e.$6=y,e.$7=k,e.$8=$,e.$0=v;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?l.isErrorNoTelemetry(t)?new l(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=i,e.$X=new i;function D(a){e.$X.setUnexpectedErrorHandler(a)}function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){u(a)||e.$X.onUnexpectedError(a)}function P(a){u(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:l.isErrorNoTelemetry(a)}}return a}const h="Canceled";function u(a){return a instanceof g?!0:a instanceof Error&&a.name===h&&a.message===h}class g extends Error{constructor(){super(h),this.name=this.message}}e.$5=g;function y(){const a=new Error(h);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function $(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=m;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class l extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof l)return t;const o=new l;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=l;class w extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$cb=w}),define(re[22],ae([0,1,15,136]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=R,e.$ub=P,e.$vb=E,e.$wb=h,e.$xb=u,e.$yb=g,e.$zb=y,e.$Ab=k,e.$Bb=$,e.$Cb=d,e.$Db=v,e.$Eb=p,e.top=m,e.$Gb=f,e.$Hb=w,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=s,e.$Mb=n,e.$Nb=r,e.$Ob=c,e.$Pb=b,e.$Qb=j,e.$Rb=C,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=F,e.$Wb=L,e.$Xb=T,e.$Yb=U,e.$Zb=le,e.$1b=ee,e.$2b=ce,e.$3b=Q,e.$4b=G,e.$5b=q,e.$6b=W,e.$7b=B,e.$8b=oe,e.$$b=A;function S(X,H=0){return X[X.length-(1+H)]}function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}function P(X,H,x=(K,se)=>K===se){if(X===H)return!0;if(!X||!H||X.length!==H.length)return!1;for(let K=0,se=X.length;K<se;K++)if(!x(X[K],H[K]))return!1;return!0}function E(X,H){const x=X.length-1;H<x&&(X[H]=X[x]),X.pop()}function h(X,H,x){return u(X.length,K=>x(X[K],H))}function u(X,H){let x=0,K=X-1;for(;x<=K;){const se=(x+K)/2|0,ue=H(se);if(ue<0)x=se+1;else if(ue>0)K=se-1;else return se}return-(x+1)}function g(X,H,x){if(X=X|0,X>=H.length)throw new TypeError("invalid index");const K=H[Math.floor(H.length*Math.random())],se=[],ue=[],me=[];for(const $e of H){const ye=x($e,K);ye<0?se.push($e):ye>0?ue.push($e):me.push($e)}return X<se.length?g(X,se,x):X<se.length+me.length?me[0]:g(X-(se.length+me.length),ue,x)}function y(X,H){const x=[];let K;for(const se of X.slice(0).sort(H))!K||H(K[0],se)!==0?(K=[se],x.push(K)):K.push(se);return x}function*k(X,H){let x,K;for(const se of X)K!==void 0&&H(K,se)?x.push(se):(x&&(yield x),x=[se]),K=se;x&&(yield x)}function $(X,H){for(let x=0;x<=X.length;x++)H(x===0?void 0:X[x-1],x===X.length?void 0:X[x])}function d(X,H){for(let x=0;x<X.length;x++)H(x===0?void 0:X[x-1],X[x],x+1===X.length?void 0:X[x+1])}function v(X,H,x){const K=[];function se($e,ye,ke){if(ye===0&&ke.length===0)return;const Ee=K[K.length-1];Ee&&Ee.start+Ee.deleteCount===$e?(Ee.deleteCount+=ye,Ee.toInsert.push(...ke)):K.push({start:$e,deleteCount:ye,toInsert:ke})}let ue=0,me=0;for(;;){if(ue===X.length){se(ue,0,H.slice(me));break}if(me===H.length){se(ue,X.length-ue,[]);break}const $e=X[ue],ye=H[me],ke=x($e,ye);ke===0?(ue+=1,me+=1):ke<0?(se(ue,1,[]),ue+=1):ke>0&&(se(ue,0,[ye]),me+=1)}return K}function p(X,H,x){const K=v(X,H,x),se=[],ue=[];for(const me of K)se.push(...X.slice(me.start,me.start+me.deleteCount)),ue.push(...me.toInsert);return{removed:se,added:ue}}function m(X,H,x){if(x===0)return[];const K=X.slice(0,x).sort(H);return l(X,H,K,x,X.length),K}function f(X,H,x,K,se){return x===0?Promise.resolve([]):new Promise((ue,me)=>{(async()=>{const $e=X.length,ye=X.slice(0,x).sort(H);for(let ke=x,Ee=Math.min(x+K,$e);ke<$e;ke=Ee,Ee=Math.min(Ee+K,$e)){if(ke>x&&await new Promise(Oe=>setTimeout(Oe)),se&&se.isCancellationRequested)throw new i.$5;l(X,H,ye,ke,Ee)}return ye})().then(ue,me)})}function l(X,H,x,K,se){for(const ue=x.length;K<se;K++){const me=X[K];if(H(me,x[ue-1])<0){x.pop();const $e=(0,D.$kb)(x,ye=>H(me,ye)<0);x.splice($e,0,me)}}}function w(X){return X.filter(H=>!!H)}function a(X){let H=0;for(let x=0;x<X.length;x++)X[x]&&(X[H]=X[x],H+=1);X.length=H}function t(X,H,x){X.splice(x,0,X.splice(H,1)[0])}function o(X){return!Array.isArray(X)||X.length===0}function s(X){return Array.isArray(X)&&X.length>0}function n(X,H=x=>x){const x=new Set;return X.filter(K=>{const se=H(K);return x.has(se)?!1:(x.add(se),!0)})}function r(X){const H=new Set;return x=>{const K=X(x);return H.has(K)?!1:(H.add(K),!0)}}function c(X,H){return X.length>0?X[0]:H}function b(X,H){return X.length>0?X[X.length-1]:H}function j(X,H,x=(K,se)=>K===se){let K=0;for(let se=0,ue=Math.min(X.length,H.length);se<ue&&x(X[se],H[se]);se++)K++;return K}function C(X){return[].concat(...X)}function I(X,H){let x=typeof H=="number"?X:0;typeof H=="number"?x=X:(x=0,H=X);const K=[];if(x<=H)for(let se=x;se<H;se++)K.push(se);else for(let se=x;se>H;se--)K.push(se);return K}function O(X,H,x){return X.reduce((K,se)=>(K[H(se)]=x?x(se):se,K),Object.create(null))}function M(X,H){return X.push(H),()=>F(X,H)}function F(X,H){const x=X.indexOf(H);if(x>-1)return X.splice(x,1),H}function L(X,H,x){const K=X.slice(0,H),se=X.slice(H);return K.concat(x,se)}function T(X,H){let x;if(typeof H=="number"){let K=H;x=()=>{const se=Math.sin(K++)*179426549;return se-Math.floor(se)}}else x=Math.random;for(let K=X.length-1;K>0;K-=1){const se=Math.floor(x()*(K+1)),ue=X[K];X[K]=X[se],X[se]=ue}}function U(X,H){const x=X.indexOf(H);x>-1&&(X.splice(x,1),X.unshift(H))}function le(X,H){const x=X.indexOf(H);x>-1&&(X.splice(x,1),X.push(H))}function ee(X,H){for(const x of H)X.push(x)}function ce(X,H){return Array.isArray(X)?X.map(H):H(X)}function Q(X){return Array.isArray(X)?X:[X]}function G(X){return X[Math.floor(Math.random()*X.length)]}function q(X,H,x){const K=z(X,H),se=X.length,ue=x.length;X.length=se+ue;for(let me=se-1;me>=K;me--)X[me+ue]=X[me];for(let me=0;me<ue;me++)X[me+K]=x[me]}function W(X,H,x,K){const se=z(X,H);let ue=X.splice(se,x);return ue===void 0&&(ue=[]),q(X,se,K),ue}function z(X,H){return H<0?Math.max(H+X.length,0):Math.min(H,X.length)}var V;(function(X){function H(ue){return ue<0}X.isLessThan=H;function x(ue){return ue<=0}X.isLessThanOrEqual=x;function K(ue){return ue>0}X.isGreaterThan=K;function se(ue){return ue===0}X.isNeitherLessOrGreaterThan=se,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function B(X,H){return(x,K)=>H(X(x),X(K))}function oe(...X){return(H,x)=>{for(const K of X){const se=K(H,x);if(!V.isNeitherLessOrGreaterThan(se))return se}return V.neitherLessOrGreaterThan}}const he=(X,H)=>X-H;e.$9b=he;const J=(X,H)=>(0,e.$9b)(X?1:0,H?1:0);e.$0b=J;function A(X){return(H,x)=>-X(H,x)}class N{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let x=this.c;for(;x<this.g.length&&H(this.g[x]);)x++;const K=x===this.c?null:this.g.slice(this.c,x);return this.c=x,K}takeFromEndWhile(H){let x=this.d;for(;x>=0&&H(this.g[x]);)x--;const K=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const x=this.g.slice(this.c,this.c+H);return this.c+=H,x}}e.$_b=N;class _{static{this.empty=new _(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(x=>(H(x),!0))}toArray(){const H=[];return this.iterate(x=>(H.push(x),!0)),H}filter(H){return new _(x=>this.iterate(K=>H(K)?x(K):!0))}map(H){return new _(x=>this.iterate(K=>x(H(K))))}some(H){let x=!1;return this.iterate(K=>(x=H(K),!x)),x}findFirst(H){let x;return this.iterate(K=>H(K)?(x=K,!1):!0),x}findLast(H){let x;return this.iterate(K=>(H(K)&&(x=K),!0)),x}findLastMaxBy(H){let x,K=!0;return this.iterate(se=>((K||V.isGreaterThan(H(se,x)))&&(K=!1,x=se),!0)),x}}e.$ac=_;class ne{constructor(H){this.c=H}static createSortPermutation(H,x){const K=Array.from(H.keys()).sort((se,ue)=>x(H[se],H[ue]));return new ne(K)}apply(H){return H.map((x,K)=>H[this.c[K]])}inverse(){const H=this.c.slice();for(let x=0;x<this.c.length;x++)H[this.c[x]]=x;return new ne(H)}}e.$bc=ne}),define(re[139],ae([0,1,15]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.$cd=S,e.$dd=R,e.$ed=P,e.$fd=E,e.$gd=h;function D(u,g){if(!u)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function S(u,g="Unreachable"){throw new Error(g)}function R(u){if(!u)throw new i.$cb("Assertion Failed")}function P(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function E(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function h(u,g){let y=0;for(;y<u.length-1;){const k=u[y],$=u[y+1];if(!g(k,$))return!1;y++}return!0}}),define(re[86],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=i;function i(D,S){const R=this;let P=!1,E;return function(){if(P)return E;if(P=!0,S)try{E=D.apply(R,arguments)}finally{S()}else E=D.apply(R,arguments);return E}}}),define(re[71],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(D){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=S;const R=Object.freeze([]);function P(){return R}D.empty=P;function*E(t){yield t}D.single=E;function h(t){return S(t)?t:E(t)}D.wrap=h;function u(t){return t||R}D.from=u;function*g(t){for(let o=t.length-1;o>=0;o--)yield t[o]}D.reverse=g;function y(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}D.first=k;function $(t,o){for(const s of t)if(o(s))return!0;return!1}D.some=$;function d(t,o){for(const s of t)if(o(s))return s}D.find=d;function*v(t,o){for(const s of t)o(s)&&(yield s)}D.filter=v;function*p(t,o){let s=0;for(const n of t)yield o(n,s++)}D.map=p;function*m(...t){for(const o of t)yield*o}D.concat=m;function f(t,o,s){let n=s;for(const r of t)n=o(n,r);return n}D.reduce=f;function*l(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}D.slice=l;function w(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const n=t[Symbol.iterator]();for(let r=0;r<o;r++){const c=n.next();if(c.done)return[s,D.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}D.consume=w;async function a(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}D.asyncToArray=a})(i||(e.Iterable=i={}))}),define(re[42],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=P,e.$Cn=y,e.$Dn=k,e.$En=$,e.$Fn=d,e.$Gn=v,e.$Hn=p,e.$In=m,e.$Jn=f,e.$Kn=l,e.$Ln=w,e.$Mn=a;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function P(t,o=!1){let s=0;const n=t.length;let r="",c=0,b=16,j=0;function C(U){let le=0,ee=0;for(;le<U;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)ee=ee*16+ce-48;else if(ce>=65&&ce<=70)ee=ee*16+ce-65+10;else if(ce>=97&&ce<=102)ee=ee*16+ce-97+10;else break;s++,le++}return le<U&&(ee=-1),ee}function I(U){s=U,r="",c=0,b=16,j=0}function O(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&u(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&u(t.charCodeAt(s)))for(s++;s<t.length&&u(t.charCodeAt(s));)s++;else return j=3,t.substring(U,s);let le=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&u(t.charCodeAt(s))){for(s++;s<t.length&&u(t.charCodeAt(s));)s++;le=s}else j=3;return t.substring(U,le)}function M(){let U="",le=s;for(;;){if(s>=n){U+=t.substring(le,s),j=2;break}const ee=t.charCodeAt(s);if(ee===34){U+=t.substring(le,s),s++;break}if(ee===92){if(U+=t.substring(le,s),s++,s>=n){j=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const Q=C(4);Q>=0?U+=String.fromCharCode(Q):j=4;break}default:j=5}le=s;continue}if(ee>=0&&ee<=31)if(h(ee)){U+=t.substring(le,s),j=2;break}else j=6;s++}return U}function F(){if(r="",j=0,c=s,s>=n)return c=n,b=17;let U=t.charCodeAt(s);if(E(U)){do s++,r+=String.fromCharCode(U),U=t.charCodeAt(s);while(E(U));return b=15}if(h(U))return s++,r+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),b=14;switch(U){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,r=M(),b=10;case 47:{const le=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!h(t.charCodeAt(s));)s++;return r=t.substring(le,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const ee=n-1;let ce=!1;for(;s<ee;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,j=1),r=t.substring(le,s),b=13}return r+=String.fromCharCode(U),s++,b=16}case 45:if(r+=String.fromCharCode(U),s++,s===n||!u(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),b=11;default:for(;s<n&&L(U);)s++,U=t.charCodeAt(s);if(c!==s){switch(r=t.substring(c,s),r){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return r+=String.fromCharCode(U),s++,b=16}}function L(U){if(E(U)||h(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>s,scan:o?T:F,getToken:()=>b,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>j}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function y(t,o){const s=[],n=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function j(C,I,O,M){c.value=C,c.offset=I,c.length=O,c.type=M,c.colonOffset=void 0,r=c}try{l(t,{onObjectBegin:(C,I)=>{if(o<=C)throw n;r=void 0,b=o>C,s.push("")},onObjectProperty:(C,I,O)=>{if(o<I||(j(C,I,O,"property"),s[s.length-1]=C,o<=I+O))throw n},onObjectEnd:(C,I)=>{if(o<=C)throw n;r=void 0,s.pop()},onArrayBegin:(C,I)=>{if(o<=C)throw n;r=void 0,s.push(0)},onArrayEnd:(C,I)=>{if(o<=C)throw n;r=void 0,s.pop()},onLiteralValue:(C,I,O)=>{if(o<I||(j(C,I,O,a(C)),o<=I+O))throw n},onSeparator:(C,I,O)=>{if(o<=I)throw n;if(C===":"&&r&&r.type==="property")r.colonOffset=I,b=!1,r=void 0;else if(C===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(b=!0,s[s.length-1]=""),r=void 0}}})}catch(C){if(C!==n)throw C}return{path:s,previousNode:r,isAtPropertyKey:b,matches:C=>{let I=0;for(let O=0;I<C.length&&O<s.length;O++)if(C[I]===s[O]||C[I]==="*")I++;else if(C[I]!=="**")return!1;return I===C.length}}}function k(t,o=[],s=R.DEFAULT){let n=null,r=[];const c=[];function b(C){Array.isArray(r)?r.push(C):n!==null&&(r[n]=C)}return l(t,{onObjectBegin:()=>{const C={};b(C),c.push(r),r=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const C=[];b(C),c.push(r),r=C,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:b,onError:(C,I,O)=>{o.push({error:C,offset:I,length:O})}},s),r[0]}function $(t,o=[],s=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function c(C){return n.children.push(C),C}l(t,{onObjectBegin:C=>{n=c({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,I,O)=>{n=c({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:I,length:O,parent:n})},onObjectEnd:(C,I)=>{n.length=C+I-n.offset,n=n.parent,r(C+I)},onArrayBegin:(C,I)=>{n=c({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,I)=>{n.length=C+I-n.offset,n=n.parent,r(C+I)},onLiteralValue:(C,I,O)=>{c({type:a(C),offset:I,length:O,parent:n,value:C}),r(I+O)},onSeparator:(C,I,O)=>{n.type==="property"&&(C===":"?n.colonOffset=I:C===","&&r(I))},onError:(C,I,O)=>{o.push({error:C,offset:I,length:O})}},s);const j=n.children[0];return j&&delete j.parent,j}function d(t,o){if(!t)return;let s=t;for(const n of o)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===n){s=c.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const o=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(o[s.children[0].value]=p(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function m(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}function f(t,o,s=!1){if(m(t,o,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=o;r++){const c=f(n[r],o,s);if(c)return c}return t}}function l(t,o,s=R.DEFAULT){const n=P(t,!1);function r(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(B){return B?oe=>B(oe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const b=r(o.onObjectBegin),j=c(o.onObjectProperty),C=r(o.onObjectEnd),I=r(o.onArrayBegin),O=r(o.onArrayEnd),M=c(o.onLiteralValue),F=c(o.onSeparator),L=r(o.onComment),T=c(o.onError),U=s&&s.disallowComments,le=s&&s.allowTrailingComma;function ee(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:U||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(B){case 12:case 13:U?ce(10):L();break;case 16:ce(1);break;case 15:case 14:break;default:return B}}}function ce(B,oe=[],he=[]){if(T(B),oe.length+he.length>0){let J=n.getToken();for(;J!==17;){if(oe.indexOf(J)!==-1){ee();break}else if(he.indexOf(J)!==-1)break;J=ee()}}}function Q(B){const oe=n.getTokenValue();return B?M(oe):j(oe),ee(),!0}function G(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(ce(2),B=0)}catch{ce(2)}M(B);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ee(),!0}function q(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(Q(!1),n.getToken()===6?(F(":"),ee(),V()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function W(){b(),ee();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||ce(4,[],[]),F(","),ee(),n.getToken()===2&&le)break}else B&&ce(6,[],[]);q()||ce(4,[],[2,5]),B=!0}return C(),n.getToken()!==2?ce(7,[2],[]):ee(),!0}function z(){I(),ee();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||ce(4,[],[]),F(","),ee(),n.getToken()===4&&le)break}else B&&ce(6,[],[]);V()||ce(4,[],[4,5]),B=!0}return O(),n.getToken()!==4?ce(8,[4],[]):ee(),!0}function V(){switch(n.getToken()){case 3:return z();case 1:return W();case 10:return Q(!0);default:return G()}}return ee(),n.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):V()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function w(t,o){const s=P(t),n=[];let r,c=0,b;do switch(b=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:c!==b&&n.push(t.substring(c,b)),o!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,o)),c=s.getPosition();break}while(r!==17);return n.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[140],ae([0,1,42]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=D,e.$On=S,e.$Pn=E,e.$Qn=h;function D(u,g,y){let k,$,d,v,p;if(g){for(v=g.offset,p=v+g.length,d=v;d>0&&!h(u,d-1);)d--;let b=p;for(;b<u.length&&!h(u,b);)b++;$=u.substring(d,b),k=P($,y)}else $=u,k=0,d=0,v=0,p=u.length;const m=E(y,u);let f=!1,l=0,w;y.insertSpaces?w=R(" ",y.tabSize||4):w="	";const a=(0,i.$Bn)($,!1);let t=!1;function o(){return m+R(w,k+l)}function s(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const n=[];function r(b,j,C){!t&&j<p&&C>v&&u.substring(j,C)!==b&&n.push({offset:j,length:C-j,content:b})}let c=s();if(c!==17){const b=a.getTokenOffset()+d,j=R(w,k);r(j,d,b)}for(;c!==17;){let b=a.getTokenOffset()+a.getTokenLength()+d,j=s(),C="";for(;!f&&(j===12||j===13);){const O=a.getTokenOffset()+d;r(" ",b,O),b=a.getTokenOffset()+a.getTokenLength()+d,C=j===12?o():"",j=s()}if(j===2)c!==1&&(l--,C=o());else if(j===4)c!==3&&(l--,C=o());else{switch(c){case 3:case 1:l++,C=o();break;case 5:case 12:C=o();break;case 13:f?C=o():C=" ";break;case 6:C=" ";break;case 10:if(j===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:j===12||j===13?C=" ":j!==5&&j!==17&&(t=!0);break;case 16:t=!0;break}f&&(j===12||j===13)&&(C=o())}const I=a.getTokenOffset()+d;r(C,b,I),c=j}return n}function S(u,g){const y=JSON.stringify(u,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?y.replace(/\r\n|\r|\n/g,g.eol):y}function R(u,g){let y="";for(let k=0;k<g;k++)y+=u;return y}function P(u,g){let y=0,k=0;const $=g.tabSize||4;for(;y<u.length;){const d=u.charAt(y);if(d===" ")k++;else if(d==="	")k+=$;else break;y++}return Math.floor(k/$)}function E(u,g){for(let y=0;y<g.length;y++){const k=g.charAt(y);if(k==="\r")return y+1<g.length&&g.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return u&&u.eol||`
`}function h(u,g){return`\r
`.indexOf(u.charAt(g))!==-1}}),define(re[103],ae([0,1,42,140]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=S,e.$Sn=R,e.$Tn=P,e.$Un=E,e.$Vn=h;function S(u,g,y){return R(u,g,void 0,y)}function R(u,g,y,k,$){const d=g.slice(),v=[],p=(0,i.$En)(u,v);let m,f;for(;d.length>0&&(f=d.pop(),m=(0,i.$Fn)(p,d),m===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if(m)if(m.type==="object"&&typeof f=="string"&&Array.isArray(m.children)){const l=(0,i.$Fn)(m,[f]);if(l!==void 0)if(y===void 0){if(!l.parent)throw new Error("Malformed AST");const w=m.children.indexOf(l.parent);let a,t=l.parent.offset+l.parent.length;if(w>0){const o=m.children[w-1];a=o.offset+o.length}else a=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return P(u,{offset:a,length:t-a,content:""},k)}else return P(u,{offset:l.offset,length:l.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const w=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=$?$(m.children.map(o=>o.children[0].value)):m.children.length;let t;if(a>0){const o=m.children[a-1];t={offset:o.offset+o.length,length:0,content:","+w}}else m.children.length===0?t={offset:m.offset+1,length:0,content:w}:t={offset:m.offset+1,length:0,content:w+","};return P(u,t,k)}}else if(m.type==="array"&&typeof f=="number"&&Array.isArray(m.children))if(y!==void 0){const l=`${JSON.stringify(y)}`;let w;if(m.children.length===0||f===0)w={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const a=f===-1||f>m.children.length?m.children.length:f,t=m.children[a-1];w={offset:t.offset+t.length,length:0,content:","+l}}return P(u,w,k)}else{const l=f,w=m.children[l];let a;if(m.children.length===1)a={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const t=m.children[l-1],o=t.offset+t.length,s=m.offset+m.length;a={offset:o,length:s-2-o,content:""}}else a={offset:w.offset,length:m.children[l+1].offset-w.offset,content:""};return P(u,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${m.type}`);else return y===void 0?[]:P(u,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(y)},k)}function P(u,g,y){let k=E(u,g),$=g.offset,d=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;$>0&&!(0,D.$Qn)(k,$-1);)$--;for(;d<k.length&&!(0,D.$Qn)(k,d);)d++}const v=(0,D.$Nn)(k,{offset:$,length:d-$},y);for(let m=v.length-1;m>=0;m--){const f=v[m];k=E(k,f),$=Math.min($,f.offset),d=Math.max(d,f.offset+f.length),d+=f.content.length-f.length}const p=u.length-(k.length-d)-$;return[{offset:$,length:p,content:k.substring($,d)}]}function E(u,g){return u.substring(0,g.offset)+g.content+u.substring(g.offset+g.length)}function h(u,g){const y=g.slice(0).sort(($,d)=>{const v=$.offset-d.offset;return v===0?$.length-d.length:v});let k=u.length;for(let $=y.length-1;$>=0;$--){const d=y[$];if(d.offset+d.length<=k)u=E(u,d);else throw new Error("Overlapping edit");k=d.offset}return u}}),define(re[62],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(re[104],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(R){this.element=R,this.next=i.Undefined,this.prev=i.Undefined}}class D{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let R=this.a;for(;R!==i.Undefined;){const P=R.next;R.prev=i.Undefined,R.next=i.Undefined,R=P}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,P){const E=new i(R);if(this.a===i.Undefined)this.a=E,this.b=E;else if(P){const u=this.b;this.b=E,E.prev=u,u.next=E}else{const u=this.a;this.a=E,E.next=u,u.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==i.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==i.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==i.Undefined&&R.next!==i.Undefined){const P=R.prev;P.next=R.next,R.next.prev=P}else R.prev===i.Undefined&&R.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):R.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):R.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==i.Undefined;)yield R.element,R=R.next}}e.$5c=D}),define(re[31],ae([0,1]),function(Z,e){"use strict";var i,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=P,e.$Ac=E,e.$Ic=f;function R(l,w,a){let t=l.get(w);return t===void 0&&(t=a,l.set(w,t)),t}function P(l){const w=[];return l.forEach((a,t)=>{w.push(`${t} => ${a}`)}),`Map(${l.size}) {${w.join(", ")}}`}function E(l){const w=[];return l.forEach(a=>{w.push(a)}),`Set(${l.size}) {${w.join(", ")}}`}class h{constructor(w,a){this.uri=w,this.value=a}}function u(l){return Array.isArray(l)}class g{static{this.c=w=>w.toString()}constructor(w,a){if(this[i]="ResourceMap",w instanceof g)this.d=new Map(w.d),this.e=a??g.c;else if(u(w)){this.d=new Map,this.e=a??g.c;for(const[t,o]of w)this.set(t,o)}else this.d=new Map,this.e=w??g.c}set(w,a){return this.d.set(this.e(w),new h(w,a)),this}get(w){return this.d.get(this.e(w))?.value}has(w){return this.d.has(this.e(w))}get size(){return this.d.size}clear(){this.d.clear()}delete(w){return this.d.delete(this.e(w))}forEach(w,a){typeof a<"u"&&(w=w.bind(a));for(const[t,o]of this.d)w(o.value,o.uri,this)}*values(){for(const w of this.d.values())yield w.value}*keys(){for(const w of this.d.values())yield w.uri}*entries(){for(const w of this.d.values())yield[w.uri,w.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.d)yield[w.uri,w.value]}}e.$Bc=g;class y{constructor(w,a){this[D]="ResourceSet",!w||typeof w=="function"?this.c=new g(w):(this.c=new g(a),w.forEach(this.add,this))}get size(){return this.c.size}add(w){return this.c.set(w,w),this}clear(){this.c.clear()}delete(w){return this.c.delete(w)}forEach(w,a){this.c.forEach((t,o)=>w.call(a,o,o,this))}has(w){return this.c.has(w)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var k;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class ${constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(w){return this.c.has(w)}get(w,a=0){const t=this.c.get(w);if(t)return a!==0&&this.l(t,a),t.value}set(w,a,t=0){let o=this.c.get(w);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:w,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(w,o),this.f++}return this}delete(w){return!!this.remove(w)}remove(w){const a=this.c.get(w);if(a)return this.c.delete(w),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const w=this.d;return this.c.delete(w.key),this.k(w),this.f--,w.value}forEach(w,a){const t=this.g;let o=this.d;for(;o;){if(a?w.bind(a)(o.value,o.key,this):w(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const w=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}values(){const w=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}entries(){const w=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(w){if(w>=this.size)return;if(w===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>w;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(w){if(!this.d&&!this.e)this.e=w;else if(this.d)w.next=this.d,this.d.previous=w;else throw new Error("Invalid list");this.d=w,this.g++}j(w){if(!this.d&&!this.e)this.d=w;else if(this.e)w.previous=this.e,this.e.next=w;else throw new Error("Invalid list");this.e=w,this.g++}k(w){if(w===this.d&&w===this.e)this.d=void 0,this.e=void 0;else if(w===this.d){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.d=w.next}else if(w===this.e){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.e=w.previous}else{const a=w.next,t=w.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}w.next=void 0,w.previous=void 0,this.g++}l(w,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(w===this.d)return;const t=w.next,o=w.previous;w===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),w.previous=void 0,w.next=this.d,this.d.previous=w,this.d=w,this.g++}else if(a===2){if(w===this.e)return;const t=w.next,o=w.previous;w===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),w.next=void 0,w.previous=this.e,this.e.next=w,this.e=w,this.g++}}}toJSON(){const w=[];return this.forEach((a,t)=>{w.push([t,a])}),w}fromJSON(w){this.clear();for(const[a,t]of w)this.set(a,t)}}e.$Dc=$;class d extends ${constructor(w,a=1){super(),this.m=w,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(w){this.m=w,this.o()}get ratio(){return this.n}set ratio(w){this.n=Math.min(Math.max(0,w),1),this.o()}get(w,a=2){return super.get(w,a)}peek(w){return super.get(w,0)}set(w,a){return super.set(w,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=d;class v{constructor(){this.c=new Map}add(w){return this.c.set(w,(this.c.get(w)||0)+1),this}delete(w){let a=this.c.get(w)||0;return a===0?!1:(a--,a===0?this.c.delete(w):this.c.set(w,a),!0)}has(w){return this.c.has(w)}}e.$Fc=v;class p{constructor(w){if(this.c=new Map,this.d=new Map,w)for(const[a,t]of w)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(w,a){this.c.set(w,a),this.d.set(a,w)}get(w){return this.c.get(w)}getKey(w){return this.d.get(w)}delete(w){const a=this.c.get(w);return a===void 0?!1:(this.c.delete(w),this.d.delete(a),!0)}forEach(w,a){this.c.forEach((t,o)=>{w.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class m{constructor(){this.c=new Map}add(w,a){let t=this.c.get(w);t||(t=new Set,this.c.set(w,t)),t.add(a)}delete(w,a){const t=this.c.get(w);t&&(t.delete(a),t.size===0&&this.c.delete(w))}forEach(w,a){const t=this.c.get(w);t&&t.forEach(a)}get(w){const a=this.c.get(w);return a||new Set}}e.$Hc=m;function f(l,w){if(l===w)return!0;if(l.size!==w.size)return!1;for(const[a,t]of l)if(!w.has(a)||w.get(a)!==t)return!1;for(const[a]of w)if(!l.has(a))return!1;return!0}}),define(re[2],ae([0,1,22,137,31,86,71]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=g,e.$Lc=y,e.$Mc=k,e.$Nc=v,e.$Oc=p,e.$Pc=m,e.$Qc=f,e.$Rc=l,e.$Sc=w,e.$3c=C;const E=!1;let h=null;class u{constructor(){this.b=new Map}static{this.a=0}c(M){let F=this.b.get(M);return F||(F={parent:null,source:null,isSingleton:!1,value:M,idx:u.a++},this.b.set(M,F)),F}trackDisposable(M){const F=this.c(M);F.source||(F.source=new Error().stack)}setParent(M,F){const L=this.c(M);L.parent=F}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,F){const L=F.get(M);if(L)return L;const T=M.parent?this.f(this.c(M.parent),F):M;return F.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,M).isSingleton).flatMap(([L])=>L)}computeLeakingDisposables(M=10,F){let L;if(F)L=F;else{const ce=new Map,Q=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ce).isSingleton);if(Q.length===0)return;const G=new Set(Q.map(q=>q.value));if(L=Q.filter(q=>!(q.parent&&G.has(q.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function T(ce){function Q(q,W){for(;q.length>0&&W.some(z=>typeof z=="string"?z===q[0]:q[0].match(z));)q.shift()}const G=ce.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Q(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const U=new S.$Hc;for(const ce of L){const Q=T(ce);for(let G=0;G<=Q.length;G++)U.add(Q.slice(0,G).join(`
`),ce)}L.sort((0,i.$7b)(ce=>ce.idx,i.$9b));let le="",ee=0;for(const ce of L.slice(0,M)){ee++;const Q=T(ce),G=[];for(let q=0;q<Q.length;q++){let W=Q[q];W=`(shared with ${U.get(Q.slice(0,q+1).join(`
`)).size}/${L.length} leaks) at ${W}`;const V=U.get(Q.slice(0,q).join(`
`)),B=(0,D.$K)([...V].map(oe=>T(oe)[q]),oe=>oe);delete B[Q[q]];for(const[oe,he]of Object.entries(B))G.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);G.unshift(W)}le+=`


==================== Leaking disposable ${ee}/${L.length}: ${ce.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return L.length>M&&(le+=`


... and ${L.length-M} more leaking disposables

`),{leaks:L,details:le}}}e.$Jc=u;function g(O){h=O}if(E){const O="__is_disposable_tracked__";g(new class{trackDisposable(M){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(F)},3e3)}setParent(M,F){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function y(O){return h?.trackDisposable(O),O}function k(O){h?.markAsDisposed(O)}function $(O,M){h?.setParent(O,M)}function d(O,M){if(h)for(const F of O)h.setParent(F,M)}function v(O){return h?.markAsSingleton(O),O}function p(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function m(O){if(P.Iterable.is(O)){const M=[];for(const F of O)if(F)try{F.dispose()}catch(L){M.push(L)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function f(O){for(const M of O)p(M)&&M.dispose();return[]}function l(...O){const M=w(()=>m(O));return d(O,M),M}function w(O){const M=y({dispose:(0,R.$db)(()=>{k(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return $(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),$(M,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),$(this.q,this)}dispose(){k(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&$(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&$(M,null),M}}e.$Vc=o;class s{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class n{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(M){let F=M;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,k(this))},this}}e.$Yc=r;class c{constructor(){this.a=new Map}acquire(M,...F){let L=this.a.get(M);L||(L={counter:0,object:this.b(M,...F)},this.a.set(M,L));const{object:T}=L,U=(0,R.$db)(()=>{--L.counter===0&&(this.c(M,L.object),this.a.delete(M))});return L.counter++,{object:T,dispose:U}}}e.$Zc=c;class b{constructor(M){this.a=M}async acquire(M,...F){const L=this.a.acquire(M,...F);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(T){throw L.dispose(),T}}}e.$1c=b;class j{constructor(M){this.object=M}dispose(){}}e.$2c=j;function C(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,F,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(M)?.dispose(),this.a.set(M,F)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=I}),define(re[72],ae([0,1,31]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=S,e.$9l=P;const D=new i.$Ec(1e4);function S(u){return h(u,"NFC",D)}const R=new i.$Ec(1e4);function P(u){return h(u,"NFD",R)}const E=/[^\u0000-\u0080]/;function h(u,g,y){if(!u)return u;const k=y.get(u);if(k)return k;let $;return E.test(u)?$=u.normalize(g):$=u,y.set(u,$),$}e.$0l=function(){const u=/[\u0300-\u036f]/g;return function(g){return P(g).replace(u,"")}}()}),define(re[141],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=i,e.rot=D;function i(E,h,u){return Math.min(Math.max(E,h),u)}function D(E,h){return(h+E%h)%h}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=S;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=R;class P{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const u=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=P}),function(){function Z(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function P(h){R.push(h,Date.now())}function E(){const h=[];for(let u=0;u<R.length;u+=2)h.push({name:R[u],startTime:R[u+1]});return h}return{mark:P,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const P of performance.getEntriesByType("mark"))R.push({name:P.name,startTime:Math.round(S+P.startTime)});return R}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=i(D))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var D in i)(typeof exports=="object"?exports:Z)[D]=i[D]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function i(D){if(e[D])return e[D].exports;var S=e[D]={i:D,l:!1,exports:{}};return Z[D].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=Z,i.c=e,i.d=function(D,S,R){i.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:R})},i.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},i.t=function(D,S){if(1&S&&(D=i(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(i.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var P in D)i.d(R,P,function(E){return D[E]}.bind(null,P));return R},i.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return i.d(S,"a",S),S},i.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},i.p="",i(i.s=0)}([function(Z,e,i){(function(D){var S;e=Z.exports=he,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],u=0,g=u++;h[g]="0|[1-9]\\d*";var y=u++;h[y]="[0-9]+";var k=u++;h[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=u++;h[$]="("+h[g]+")\\.("+h[g]+")\\.("+h[g]+")";var d=u++;h[d]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var v=u++;h[v]="(?:"+h[g]+"|"+h[k]+")";var p=u++;h[p]="(?:"+h[y]+"|"+h[k]+")";var m=u++;h[m]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var f=u++;h[f]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var l=u++;h[l]="[0-9A-Za-z-]+";var w=u++;h[w]="(?:\\+("+h[l]+"(?:\\."+h[l]+")*))";var a=u++,t="v?"+h[$]+h[m]+"?"+h[w]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[d]+h[f]+"?"+h[w]+"?",s=u++;h[s]="^"+o+"$";var n=u++;h[n]="((?:<|>)?=?)";var r=u++;h[r]=h[y]+"|x|X|\\*";var c=u++;h[c]=h[g]+"|x|X|\\*";var b=u++;h[b]="[v=\\s]*("+h[c]+")(?:\\.("+h[c]+")(?:\\.("+h[c]+")(?:"+h[m]+")?"+h[w]+"?)?)?";var j=u++;h[j]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[f]+")?"+h[w]+"?)?)?";var C=u++;h[C]="^"+h[n]+"\\s*"+h[b]+"$";var I=u++;h[I]="^"+h[n]+"\\s*"+h[j]+"$";var O=u++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=u++;h[M]="(?:~>?)";var F=u++;h[F]="(\\s*)"+h[M]+"\\s+",E[F]=new RegExp(h[F],"g");var L=u++;h[L]="^"+h[M]+h[b]+"$";var T=u++;h[T]="^"+h[M]+h[j]+"$";var U=u++;h[U]="(?:\\^)";var le=u++;h[le]="(\\s*)"+h[U]+"\\s+",E[le]=new RegExp(h[le],"g");var ee=u++;h[ee]="^"+h[U]+h[b]+"$";var ce=u++;h[ce]="^"+h[U]+h[j]+"$";var Q=u++;h[Q]="^"+h[n]+"\\s*("+o+")$|^$";var G=u++;h[G]="^"+h[n]+"\\s*("+t+")$|^$";var q=u++;h[q]="(\\s*)"+h[n]+"\\s*("+o+"|"+h[b]+")",E[q]=new RegExp(h[q],"g");var W=u++;h[W]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var z=u++;h[z]="^\\s*("+h[j]+")\\s+-\\s+("+h[j]+")\\s*$";var V=u++;h[V]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)S(B,h[B]),E[B]||(E[B]=new RegExp(h[B]));function oe(Y,fe){if(Y instanceof he)return Y;if(typeof Y!="string"||Y.length>R||!(fe?E[s]:E[a]).test(Y))return null;try{return new he(Y,fe)}catch{return null}}function he(Y,fe){if(Y instanceof he){if(Y.loose===fe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof he))return new he(Y,fe);S("SemVer",Y,fe),this.loose=fe;var ge=Y.trim().match(fe?E[s]:E[a]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Re=+je;if(Re>=0&&Re<P)return Re}return je}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=oe,e.valid=function(Y,fe){var ge=oe(Y,fe);return ge?ge.version:null},e.clean=function(Y,fe){var ge=oe(Y.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof he||(Y=new he(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},he.prototype.compareMain=function(Y){return Y instanceof he||(Y=new he(Y,this.loose)),A(this.major,Y.major)||A(this.minor,Y.minor)||A(this.patch,Y.patch)},he.prototype.comparePre=function(Y){if(Y instanceof he||(Y=new he(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],je=Y.prerelease[fe];if(S("prerelease compare",fe,ge,je),ge===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ge===void 0)return-1;if(ge!==je)return A(ge,je)}while(++fe)},he.prototype.inc=function(Y,fe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,fe,ge,je){typeof ge=="string"&&(je=ge,ge=void 0);try{return new he(Y,ge).inc(fe,je).version}catch{return null}},e.diff=function(Y,fe){if(X(Y,fe))return null;var ge=oe(Y),je=oe(fe);if(ge.prerelease.length||je.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return Re},e.compareIdentifiers=A;var J=/^[0-9]+$/;function A(Y,fe){var ge=J.test(Y),je=J.test(fe);return ge&&je&&(Y=+Y,fe=+fe),ge&&!je?-1:je&&!ge?1:Y<fe?-1:Y>fe?1:0}function N(Y,fe,ge){return new he(Y,ge).compare(new he(fe,ge))}function _(Y,fe,ge){return N(Y,fe,ge)>0}function ne(Y,fe,ge){return N(Y,fe,ge)<0}function X(Y,fe,ge){return N(Y,fe,ge)===0}function H(Y,fe,ge){return N(Y,fe,ge)!==0}function x(Y,fe,ge){return N(Y,fe,ge)>=0}function K(Y,fe,ge){return N(Y,fe,ge)<=0}function se(Y,fe,ge,je){var Re;switch(fe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y!==ge;break;case"":case"=":case"==":Re=X(Y,ge,je);break;case"!=":Re=H(Y,ge,je);break;case">":Re=_(Y,ge,je);break;case">=":Re=x(Y,ge,je);break;case"<":Re=ne(Y,ge,je);break;case"<=":Re=K(Y,ge,je);break;default:throw new TypeError("Invalid operator: "+fe)}return Re}function ue(Y,fe){if(Y instanceof ue){if(Y.loose===fe)return Y;Y=Y.value}if(!(this instanceof ue))return new ue(Y,fe);S("comparator",Y,fe),this.loose=fe,this.parse(Y),this.semver===me?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,fe){return A(fe,Y)},e.major=function(Y,fe){return new he(Y,fe).major},e.minor=function(Y,fe){return new he(Y,fe).minor},e.patch=function(Y,fe){return new he(Y,fe).patch},e.compare=N,e.compareLoose=function(Y,fe){return N(Y,fe,!0)},e.rcompare=function(Y,fe,ge){return N(fe,Y,ge)},e.sort=function(Y,fe){return Y.sort(function(ge,je){return e.compare(ge,je,fe)})},e.rsort=function(Y,fe){return Y.sort(function(ge,je){return e.rcompare(ge,je,fe)})},e.gt=_,e.lt=ne,e.eq=X,e.neq=H,e.gte=x,e.lte=K,e.cmp=se,e.Comparator=ue;var me={};function $e(Y,fe){if(Y instanceof $e)return Y.loose===fe?Y:new $e(Y.raw,fe);if(Y instanceof ue)return new $e(Y.value,fe);if(!(this instanceof $e))return new $e(Y,fe);if(this.loose=fe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ye(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,fe,ge,je,Re,Be,We,Le,Ue,He,Xe,Te,te){return((fe=ye(ge)?"":ye(je)?">="+ge+".0.0":ye(Re)?">="+ge+"."+je+".0":">="+fe)+" "+(Le=ye(Ue)?"":ye(He)?"<"+(+Ue+1)+".0.0":ye(Xe)?"<"+Ue+"."+(+He+1)+".0":Te?"<="+Ue+"."+He+"."+Xe+"-"+Te:"<="+Le)).trim()}function Ee(Y,fe){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Y.length;ge++)if(S(Y[ge].semver),Y[ge].semver!==me&&Y[ge].semver.prerelease.length>0){var je=Y[ge].semver;if(je.major===fe.major&&je.minor===fe.minor&&je.patch===fe.patch)return!0}return!1}return!0}function Oe(Y,fe,ge){try{fe=new $e(fe,ge)}catch{return!1}return fe.test(Y)}function we(Y,fe,ge,je){var Re,Be,We,Le,Ue;switch(Y=new he(Y,je),fe=new $e(fe,je),ge){case">":Re=_,Be=K,We=ne,Le=">",Ue=">=";break;case"<":Re=ne,Be=x,We=_,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(Y,fe,je))return!1;for(var He=0;He<fe.set.length;++He){var Xe=fe.set[He],Te=null,te=null;if(Xe.forEach(function(de){de.semver===me&&(de=new ue(">=0.0.0")),Te=Te||de,te=te||de,Re(de.semver,Te.semver,je)?Te=de:We(de.semver,te.semver,je)&&(te=de)}),Te.operator===Le||Te.operator===Ue||(!te.operator||te.operator===Le)&&Be(Y,te.semver)||te.operator===Ue&&We(Y,te.semver))return!1}return!0}ue.prototype.parse=function(Y){var fe=this.loose?E[Q]:E[G],ge=Y.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===me||(typeof Y=="string"&&(Y=new he(Y,this.loose)),se(Y,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(Y,fe){if(!(Y instanceof ue))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new $e(Y.value,fe),Oe(this.value,ge,fe);if(Y.operator==="")return ge=new $e(this.value,fe),Oe(Y.semver,ge,fe);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Be=this.semver.version===Y.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Le=se(this.semver,"<",Y.semver,fe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ue=se(this.semver,">",Y.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||Re||Be&&We||Le||Ue},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(Y){var fe=this.loose;Y=Y.trim(),S("range",Y,fe);var ge=fe?E[z]:E[W];Y=Y.replace(ge,ke),S("hyphen replace",Y),Y=Y.replace(E[q],"$1$2$3"),S("comparator trim",Y,E[q]),Y=(Y=(Y=Y.replace(E[F],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var je=fe?E[Q]:E[G],Re=Y.split(" ").map(function(Be){return function(We,Le){return S("comp",We),We=function(Ue,He){return Ue.trim().split(/\s+/).map(function(Xe){return function(Te,te){S("caret",Te,te);var de=te?E[ce]:E[ee];return Te.replace(de,function(pe,ve,Pe,Me,ze){var Ge;return S("caret",Te,pe,ve,Pe,Me,ze),ye(ve)?Ge="":ye(Pe)?Ge=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Ge=ve==="0"?">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+".0 <"+(+ve+1)+".0.0":ze?(S("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+Pe+"."+(+Me+1):">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Me+ze+" <"+(+ve+1)+".0.0"):(S("no pr"),Ge=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Me+" <"+ve+"."+Pe+"."+(+Me+1):">="+ve+"."+Pe+"."+Me+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Me+" <"+(+ve+1)+".0.0"),S("caret return",Ge),Ge})}(Xe,He)}).join(" ")}(We,Le),S("caret",We),We=function(Ue,He){return Ue.trim().split(/\s+/).map(function(Xe){return function(Te,te){var de=te?E[T]:E[L];return Te.replace(de,function(pe,ve,Pe,Me,ze){var Ge;return S("tilde",Te,pe,ve,Pe,Me,ze),ye(ve)?Ge="":ye(Pe)?Ge=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Ge=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":ze?(S("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+(+Pe+1)+".0"):Ge=">="+ve+"."+Pe+"."+Me+" <"+ve+"."+(+Pe+1)+".0",S("tilde return",Ge),Ge})}(Xe,He)}).join(" ")}(We,Le),S("tildes",We),We=function(Ue,He){return S("replaceXRanges",Ue,He),Ue.split(/\s+/).map(function(Xe){return function(Te,te){Te=Te.trim();var de=te?E[I]:E[C];return Te.replace(de,function(pe,ve,Pe,Me,ze,Ge){S("xRange",Te,pe,ve,Pe,Me,ze,Ge);var Ye=ye(Pe),Ze=Ye||ye(Me),Qe=Ze||ye(ze);return ve==="="&&Qe&&(ve=""),Ye?pe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Qe?(Ze&&(Me=0),Qe&&(ze=0),ve===">"?(ve=">=",Ze?(Pe=+Pe+1,Me=0,ze=0):Qe&&(Me=+Me+1,ze=0)):ve==="<="&&(ve="<",Ze?Pe=+Pe+1:Me=+Me+1),pe=ve+Pe+"."+Me+"."+ze):Ze?pe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Qe&&(pe=">="+Pe+"."+Me+".0 <"+Pe+"."+(+Me+1)+".0"),S("xRange return",pe),pe})}(Xe,He)}).join(" ")}(We,Le),S("xrange",We),We=function(Ue,He){return S("replaceStars",Ue,He),Ue.trim().replace(E[V],"")}(We,Le),S("stars",We),We}(Be,fe)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Be){return!!Be.match(je)})),Re=Re.map(function(Be){return new ue(Be,fe)})},$e.prototype.intersects=function(Y,fe){if(!(Y instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(je){return Y.set.some(function(Re){return Re.every(function(Be){return je.intersects(Be,fe)})})})})},e.toComparators=function(Y,fe){return new $e(Y,fe).set.map(function(ge){return ge.map(function(je){return je.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new he(Y,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ee(this.set[fe],Y))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(Y,fe,ge){var je=null,Re=null;try{var Be=new $e(fe,ge)}catch{return null}return Y.forEach(function(We){Be.test(We)&&(je&&Re.compare(We)!==-1||(Re=new he(je=We,ge)))}),je},e.minSatisfying=function(Y,fe,ge){var je=null,Re=null;try{var Be=new $e(fe,ge)}catch{return null}return Y.forEach(function(We){Be.test(We)&&(je&&Re.compare(We)!==1||(Re=new he(je=We,ge)))}),je},e.validRange=function(Y,fe){try{return new $e(Y,fe).range||"*"}catch{return null}},e.ltr=function(Y,fe,ge){return we(Y,fe,"<",ge)},e.gtr=function(Y,fe,ge){return we(Y,fe,">",ge)},e.outside=we,e.prerelease=function(Y,fe){var ge=oe(Y,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,fe,ge){return Y=new $e(Y,ge),fe=new $e(fe,ge),Y.intersects(fe)},e.coerce=function(Y){if(Y instanceof he)return Y;if(typeof Y!="string")return null;var fe=Y.match(E[O]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,i(1))},function(Z,e){var i,D,S=Z.exports={};function R(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function E(p){if(i===setTimeout)return setTimeout(p,0);if((i===R||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:R}catch{i=R}try{D=typeof clearTimeout=="function"?clearTimeout:P}catch{D=P}})();var h,u=[],g=!1,y=-1;function k(){g&&h&&(g=!1,h.length?u=h.concat(u):y=-1,u.length&&$())}function $(){if(!g){var p=E(k);g=!0;for(var m=u.length;m;){for(h=u,u=[];++y<m;)h&&h[y].run();y=-1,m=u.length}h=null,g=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===P||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}(p)}}function d(p,m){this.fun=p,this.array=m}function v(){}S.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)m[f-1]=arguments[f];u.push(new d(p,m)),u.length!==1||g||E($)},d.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=v,S.addListener=v,S.once=v,S.off=v,S.removeListener=v,S.removeAllListeners=v,S.emit=v,S.prependListener=v,S.prependOnceListener=v,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(re[142],ae([0,1]),function(Z,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class D{constructor(E,h,u){this.level=E,this.key=h,this.value=u,this.forward=[]}}const S=void 0;class R{constructor(E,h=2**16){this.comparator=E,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,S,S)}get size(){return this.f}clear(){this.e=new D(this.c,S,S),this.f=0}has(E){return!!R.g(this,E,this.comparator)}get(E){return R.g(this,E,this.comparator)?.value}set(E,h){return R.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=R.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let u=this.e.forward[0];for(;u;)E.call(h,u.value,u.key,this),u=u.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,u){let g=E.e;for(let y=E.d-1;y>=0;y--)for(;g.forward[y]&&u(g.forward[y].key,h)<0;)g=g.forward[y];if(g=g.forward[0],g&&u(g.key,h)===0)return g}static h(E,h,u,g){const y=[];let k=E.e;for(let $=E.d-1;$>=0;$--){for(;k.forward[$]&&g(k.forward[$].key,h)<0;)k=k.forward[$];y[$]=k}if(k=k.forward[0],k&&g(k.key,h)===0)return k.value=u,!1;{const $=R.j(E);if($>E.d){for(let d=E.d;d<$;d++)y[d]=E.e;E.d=$}k=new D($,h,u);for(let d=0;d<$;d++)k.forward[d]=y[d].forward[d],y[d].forward[d]=k;return!0}}static j(E,h=.5){let u=1;for(;Math.random()<h&&u<E.c;)u+=1;return u}static k(E,h,u){const g=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&u(y.forward[k].key,h)<0;)y=y.forward[k];g[k]=y}if(y=y.forward[0],!y||u(y.key,h)!==0)return!1;for(let k=0;k<E.d&&g[k].forward[k]===y;k++)g[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===S;)E.d-=1;return!0}}e.$qs=R}),define(re[73],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(R){return new D(R)}constructor(R){this.c=i&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=D}),define(re[3],ae([0,1,15,86,2,104,73]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=$;const E=!1,h=!1,u=!1;var g;(function(F){F.None=()=>S.$Uc.None;function L($e){if(u){const{onDidAddListener:ye}=$e,ke=v.create();let Ee=0;$e.onDidAddListener=()=>{++Ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),ye?.()}}}function T($e,ye){return V($e,()=>{},0,void 0,!0,void 0,ye)}F.defer=T;function U($e){return(ye,ke=null,Ee)=>{let Oe=!1,we;return we=$e(Y=>{if(!Oe)return we?we.dispose():Oe=!0,ye.call(ke,Y)},null,Ee),Oe&&we.dispose(),we}}F.once=U;function le($e,ye,ke){return W((Ee,Oe=null,we)=>$e(Y=>Ee.call(Oe,ye(Y)),null,we),ke)}F.map=le;function ee($e,ye,ke){return W((Ee,Oe=null,we)=>$e(Y=>{ye(Y),Ee.call(Oe,Y)},null,we),ke)}F.forEach=ee;function ce($e,ye,ke){return W((Ee,Oe=null,we)=>$e(Y=>ye(Y)&&Ee.call(Oe,Y),null,we),ke)}F.filter=ce;function Q($e){return $e}F.signal=Q;function G(...$e){return(ye,ke=null,Ee)=>{const Oe=(0,S.$Rc)(...$e.map(we=>we(Y=>ye.call(ke,Y))));return z(Oe,Ee)}}F.any=G;function q($e,ye,ke,Ee){let Oe=ke;return le($e,we=>(Oe=ye(Oe,we),Oe),Ee)}F.reduce=q;function W($e,ye){let ke;const Ee={onWillAddFirstListener(){ke=$e(Oe.fire,Oe)},onDidRemoveLastListener(){ke?.dispose()}};ye||L(Ee);const Oe=new a(Ee);return ye?.add(Oe),Oe.event}function z($e,ye){return ye instanceof Array?ye.push($e):ye&&ye.add($e),$e}function V($e,ye,ke=100,Ee=!1,Oe=!1,we,Y){let fe,ge,je,Re=0,Be;const We={leakWarningThreshold:we,onWillAddFirstListener(){fe=$e(Ue=>{Re++,ge=ye(ge,Ue),Ee&&!je&&(Le.fire(ge),ge=void 0),Be=()=>{const He=ge;ge=void 0,je=void 0,(!Ee||Re>1)&&Le.fire(He),Re=0},typeof ke=="number"?(clearTimeout(je),je=setTimeout(Be,ke)):je===void 0&&(je=0,queueMicrotask(Be))})},onWillRemoveListener(){Oe&&Re>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,fe.dispose()}};Y||L(We);const Le=new a(We);return Y?.add(Le),Le.event}F.debounce=V;function B($e,ye=0,ke){return F.debounce($e,(Ee,Oe)=>Ee?(Ee.push(Oe),Ee):[Oe],ye,void 0,!0,void 0,ke)}F.accumulate=B;function oe($e,ye=(Ee,Oe)=>Ee===Oe,ke){let Ee=!0,Oe;return ce($e,we=>{const Y=Ee||!ye(we,Oe);return Ee=!1,Oe=we,Y},ke)}F.latch=oe;function he($e,ye,ke){return[F.filter($e,ye,ke),F.filter($e,Ee=>!ye(Ee),ke)]}F.split=he;function J($e,ye=!1,ke=[],Ee){let Oe=ke.slice(),we=$e(ge=>{Oe?Oe.push(ge):fe.fire(ge)});Ee&&Ee.add(we);const Y=()=>{Oe?.forEach(ge=>fe.fire(ge)),Oe=null},fe=new a({onWillAddFirstListener(){we||(we=$e(ge=>fe.fire(ge)),Ee&&Ee.add(we))},onDidAddFirstListener(){Oe&&(ye?setTimeout(Y):Y())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return Ee&&Ee.add(fe),fe.event}F.buffer=J;function A($e,ye){return(Ee,Oe,we)=>{const Y=ye(new _);return $e(function(fe){const ge=Y.evaluate(fe);ge!==N&&Ee.call(Oe,ge)},void 0,we)}}F.chain=A;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(ke=>(ye(ke),ke)),this}filter(ye){return this.f.push(ke=>ye(ke)?ke:N),this}reduce(ye,ke){let Ee=ke;return this.f.push(Oe=>(Ee=ye(Ee,Oe),Ee)),this}latch(ye=(ke,Ee)=>ke===Ee){let ke=!0,Ee;return this.f.push(Oe=>{const we=ke||!ye(Oe,Ee);return ke=!1,Ee=Oe,we?Oe:N}),this}evaluate(ye){for(const ke of this.f)if(ye=ke(ye),ye===N)break;return ye}}function ne($e,ye,ke=Ee=>Ee){const Ee=(...fe)=>Y.fire(ke(...fe)),Oe=()=>$e.on(ye,Ee),we=()=>$e.removeListener(ye,Ee),Y=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Y.event}F.fromNodeEventEmitter=ne;function X($e,ye,ke=Ee=>Ee){const Ee=(...fe)=>Y.fire(ke(...fe)),Oe=()=>$e.addEventListener(ye,Ee),we=()=>$e.removeEventListener(ye,Ee),Y=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Y.event}F.fromDOMEventEmitter=X;function H($e){return new Promise(ye=>U($e)(ye))}F.toPromise=H;function x($e){const ye=new a;return $e.then(ke=>{ye.fire(ke)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}F.fromPromise=x;function K($e,ye,ke){return ye(ke),$e(Ee=>ye(Ee))}F.runAndSubscribe=K;class se{constructor(ye,ke){this._observable=ye,this.f=0,this.g=!1;const Ee={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};ke||L(Ee),this.emitter=new a(Ee),ke&&ke.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,ke){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue($e,ye){return new se($e,ye).emitter.event}F.fromObservable=ue;function me($e){return(ye,ke,Ee)=>{let Oe=0,we=!1;const Y={beginUpdate(){Oe++},endUpdate(){Oe--,Oe===0&&($e.reportChanges(),we&&(we=!1,ye.call(ke)))},handlePossibleChange(){},handleChange(){we=!0}};$e.addObserver(Y),$e.reportChanges();const fe={dispose(){$e.removeObserver(Y)}};return Ee instanceof S.$Tc?Ee.add(fe):Array.isArray(Ee)&&Ee.push(fe),fe}}F.fromObservableLight=me})(g||(e.Event=g={}));class y{static{this.all=new Set}static{this.f=0}constructor(L){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${L}_${y.f++}`,y.all.add(this)}start(L){this.g=new P.$0d,this.listenerCount=L}stop(){if(this.g){const L=this.g.elapsed();this.durations.push(L),this.elapsedOverall+=L,this.invocationCount+=1,this.g=void 0}}}e.$_d=y;let k=-1;function $(F){const L=k;return k=F,{dispose(){k=L}}}class d{constructor(L,T=Math.random().toString(18).slice(2,5)){this.threshold=L,this.name=T,this.g=0}dispose(){this.f?.clear()}check(L,T){const U=this.threshold;if(U<=0||T<U)return;this.f||(this.f=new Map);const le=this.f.get(L.value)||0;if(this.f.set(L.value,le+1),this.g-=1,this.g<=0){this.g=U*.5;let ee,ce=0;for(const[Q,G]of this.f)(!ee||ce<G)&&(ee=Q,ce=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(ee)}return()=>{const ee=this.f.get(L.value)||0;this.f.set(L.value,ee-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(L){this.value=L}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class m{constructor(L){this.value=L,this.id=p++}}const f=2,l=(F,L)=>{if(F instanceof m)L(F);else for(let T=0;T<F.length;T++){const U=F[T];U&&L(U)}},w=E?new FinalizationRegistry(F=>{typeof F=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(F))}):void 0;class a{constructor(L){this.w=0,this.f=L,this.g=k>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const L=this.t;queueMicrotask(()=>{l(L,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(L,T,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Uc.None;if(this.m)return S.$Uc.None;T&&(L=L.bind(T));const le=new m(L);let ee,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(le.stack=v.create(),ee=this.g.check(le.stack,this.w+1)),h&&(le.stack=ce??v.create()),this.t?this.t instanceof m?(this.u??=new o,this.t=[this.t,le]):this.t.push(le):(this.f?.onWillAddFirstListener?.(this),this.t=le,this.f?.onDidAddFirstListener?.(this)),this.w++;const Q=(0,S.$Sc)(()=>{w?.unregister(Q),ee?.(),this.x(le)});if(U instanceof S.$Tc?U.add(Q):Array.isArray(U)&&U.push(Q),w){const G=new Error().stack.split(`
`).slice(2).join(`
`).trim();w.register(Q,G,Q)}return Q},this.q}x(L){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,U=T.indexOf(L);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[U]=void 0;const le=this.u.current===this;if(this.w*f<=T.length){let ee=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[ee++]=T[ce]:le&&(this.u.end--,ee<this.u.i&&this.u.i--);T.length=ee}}y(L,T){if(!L)return;const U=this.f?.onListenerError||i.$1;if(!U){L.value(T);return}try{L.value(T)}catch(le){U(le)}}z(L){const T=L.current.t;for(;L.i<L.end;)this.y(T[L.i++],L.value);L.reset()}fire(L){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,L);else{const T=this.u;T.enqueue(this,L,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=a;const t=()=>new o;e.$ce=t;class o{constructor(){this.i=-1,this.end=0}enqueue(L,T,U){this.i=0,this.end=U,this.current=L,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(L,T,U){if(this.t)for(this.h||(this.h=new R.$5c),l(this.t,le=>this.h.push([le.value,L]));this.h.size>0&&!T.isCancellationRequested;){const[le,ee]=this.h.shift(),ce=[],Q={...ee,token:T,waitUntil:G=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");U&&(G=U(G,le)),ce.push(G)}};try{le(Q)}catch(G){(0,i.$1)(G);continue}Object.freeze(ce),await Promise.allSettled(ce).then(G=>{for(const q of G)q.status==="rejected"&&(0,i.$1)(q.reason)})}}}e.$de=s;class n extends a{get isPaused(){return this.h!==0}constructor(L){super(L),this.h=0,this.s=new R.$5c,this.A=L?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const L=Array.from(this.s);this.s.clear(),super.fire(this.A(L))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(L){this.w&&(this.h!==0?this.s.push(L):super.fire(L))}}e.$ee=n;class r extends n{constructor(L){super(L),this.k=L.delay??100}fire(L){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(L)}}e.$fe=r;class c extends a{constructor(L){super(L),this.h=[],this.k=L?.merge}fire(L){this.hasListeners()&&(this.h.push(L),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ge=c;class b{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(L){const T={event:L,listener:null};this.h.push(T),this.g&&this.m(T);const U=()=>{this.g&&this.o(T);const le=this.h.indexOf(T);this.h.splice(le,1)};return(0,S.$Sc)((0,D.$db)(U))}j(){this.g=!0,this.h.forEach(L=>this.m(L))}k(){this.g=!1,this.h.forEach(L=>this.o(L))}m(L){L.listener=L.event(T=>this.f.fire(T))}o(L){L.listener?.dispose(),L.listener=null}dispose(){this.f.dispose();for(const L of this.h)L.listener?.dispose();this.h=[]}}e.$he=b;class j{constructor(L,T,U,le){this.f=new S.$Tc;const ee=this.f.add(new b),ce=this.f.add(new S.$4c);function Q(G){ce.set(G,ee.add(le(G)))}for(const G of L)Q(G);this.f.add(T(G=>{Q(G)})),this.f.add(U(G=>{ce.deleteAndDispose(G)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$ie=j;class C{constructor(){this.f=[]}wrapEvent(L){return(T,U,le)=>L(ee=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>T.call(U,ee)):T.call(U,ee)},void 0,le)}bufferEvents(L){const T=[];this.f.push(T);const U=L();return this.f.pop(),T.forEach(le=>le()),U}}e.$je=C;class I{constructor(){this.f=!1,this.g=g.None,this.h=S.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(L){this.g=L,this.f&&(this.h.dispose(),this.h=L(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=I;class O{static const(L){return new M(L)}constructor(L){this.g=L,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(L){L!==this.g&&(this.g=L,this.f.fire(void 0))}}e.$le=O;class M{constructor(L){this.value=L,this.onDidChange=g.None}}}),define(re[23],ae([0,1,3]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const D=Object.freeze(function(E,h){const u=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(u)}}});var S;(function(E){function h(u){return u===E.None||u===E.Cancelled||u instanceof R?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(S||(e.CancellationToken=S={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new i.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class P{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=S.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=S.None}}e.$me=P}),define(re[143],ae([0,1,23]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class D{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new i.$me,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Xe=D;class S{constructor(E,h=JSON.stringify){this.c=E,this.d=h,this.a=void 0,this.b=void 0}get(E){const h=this.d(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Ye=S;class R{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$Ze=R}),define(re[63],ae([0,1,15,2]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=S,e.$oe=R,e.$pe=P,e.$qe=E,e.$re=u,e.$se=g,e.$te=y,e.$ue=k,e.$ve=$,e.$we=d,e.$xe=v,e.$ye=p,e.$ze=m,e.$Ae=f,e.$Be=l;function S(w){const a=w;return a?typeof a.read=="function":!1}function R(w){const a=w;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function P(w){const a=w;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(w,a){return new h(w,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,i.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(w,a){const t=[];let o;for(;(o=w.read())!==null;)t.push(o);return a(t)}function g(w,a,t){const o=[];let s;for(;(s=w.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return w.read()}}}function y(w,a){return new Promise((t,o)=>{const s=[];k(w,{onData:n=>{a&&s.push(n)},onError:n=>{a?o(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function k(w,a,t){w.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),w.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),w.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function $(w,a){return new Promise((t,o)=>{const s=new D.$Tc,n=[],r=j=>{if(n.push(j),n.length>a)return s.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},c=j=>(s.dispose(),o(j)),b=()=>(s.dispose(),t({stream:w,buffer:n,ended:!0}));s.add((0,D.$Sc)(()=>w.removeListener("error",c))),w.on("error",c),s.add((0,D.$Sc)(()=>w.removeListener("end",b))),w.on("end",b),s.add((0,D.$Sc)(()=>w.removeListener("data",r))),w.on("data",r)})}function d(w,a){const t=E(a);return t.end(w),t}function v(){const w=E(()=>{throw new Error("not supported")});return w.end(),w}function p(w){let a=!1;return{read:()=>a?null:(a=!0,w)}}function m(w,a,t){const o=E(t);return k(w,{onData:s=>o.write(a.data(s)),onError:s=>o.error(a.error?a.error(s):s),onEnd:()=>o.end()}),o}function f(w,a,t){let o=!1;return{read:()=>{const s=a.read();return o?s:(o=!0,s!==null?t([w,s]):w)}}}function l(w,a,t){let o=!1;const s=E(t);return k(a,{onData:n=>o?s.write(n):(o=!0,s.write(t([w,n]))),onError:n=>s.error(n),onEnd:()=>{o||(o=!0,s.write(w)),s.end()}}),s}}),define(re[17],ae([0,1,62,63]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=u,e.$Ee=g,e.$Fe=y,e.$Ge=k,e.$He=$,e.$Ie=d,e.$Je=v,e.$Ke=p,e.$Le=m,e.$Me=f,e.$Ne=l,e.$Oe=w,e.$Pe=a,e.$Qe=t,e.$Re=o,e.$Se=s,e.$Te=n,e.$Ue=r,e.$Ve=c,e.$We=C;const S=typeof Buffer<"u",R=new i.$V(()=>new Uint8Array(256));let P,E;class h{static alloc(O){return S?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&S?new h(Buffer.from(O)):(P||(P=new TextEncoder),new h(P.encode(O)))}static fromByteArray(O){const M=h.alloc(O.length);for(let F=0,L=O.length;F<L;F++)M.buffer[F]=O[F];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,U=O.length;T<U;T++)M+=O[T].byteLength}const F=h.alloc(M);let L=0;for(let T=0,U=O.length;T<U;T++){const le=O[T];F.set(le,L),L+=le.byteLength}return F}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,M){return new h(this.buffer.subarray(O,M))}set(O,M){if(O instanceof h)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return k(this.buffer,O)}writeUInt32BE(O,M){$(this.buffer,O,M)}readUInt32LE(O){return d(this.buffer,O)}writeUInt32LE(O,M){v(this.buffer,O,M)}readUInt8(O){return p(this.buffer,O)}writeUInt8(O,M){m(this.buffer,O,M)}indexOf(O,M=0){return u(this.buffer,O instanceof h?O.buffer:O,M)}}e.$Ce=h;function u(I,O,M=0){const F=O.byteLength,L=I.byteLength;if(F===0)return 0;if(F===1)return I.indexOf(O[0]);if(F>L-M)return-1;const T=R.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let U=M+O.length-1,le=U,ee=-1;for(;U<L;)if(I[U]===O[le]){if(le===0){ee=U;break}U--,le--}else U+=Math.max(O.length-le,T[I[U]]),le=O.length-1;return ee}function g(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function k(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function $(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function v(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function p(I,O){return I[O]}function m(I,O,M){I[M]=O}function f(I){return D.$re(I,O=>h.concat(O))}function l(I){return D.$ye(I)}function w(I){return D.$te(I,O=>h.concat(O))}async function a(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await w(I.stream)])}function t(I){return D.$we(I,O=>h.concat(O))}function o(I){return D.$ze(I,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function s(I){return D.$qe(O=>h.concat(O),I)}function n(I,O){return D.$Ae(I,O,M=>h.concat(M))}function r(I,O){return D.$Be(I,O,M=>h.concat(M))}function c(I){let O=0,M=0,F=0;const L=new Uint8Array(Math.floor(I.length/4*3)),T=le=>{switch(M){case 3:L[F++]=O|le,M=0;break;case 2:L[F++]=O|le>>>2,O=le<<6,M=3;break;case 1:L[F++]=O|le>>>4,O=le<<4,M=2;break;default:O=le<<2,M=1}};for(let le=0;le<I.length;le++){const ee=I.charCodeAt(le);if(ee>=65&&ee<=90)T(ee-65);else if(ee>=97&&ee<=122)T(ee-97+26);else if(ee>=48&&ee<=57)T(ee-48+52);else if(ee===43||ee===45)T(62);else if(ee===47||ee===95)T(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${I[le]}`)}}const U=F;for(;M>0;)T(0);return h.wrap(L).slice(0,U)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:I},O=!0,M=!1){const F=M?j:b;let L="";const T=I.byteLength%3;let U=0;for(;U<I.byteLength-T;U+=3){const le=I[U+0],ee=I[U+1],ce=I[U+2];L+=F[le>>>2],L+=F[(le<<4|ee>>>4)&63],L+=F[(ee<<2|ce>>>6)&63],L+=F[ce&63]}if(T===1){const le=I[U+0];L+=F[le>>>2],L+=F[le<<4&63],O&&(L+="==")}else if(T===2){const le=I[U+0],ee=I[U+1];L+=F[le>>>2],L+=F[(le<<4|ee>>>4)&63],L+=F[ee<<2&63],O&&(L+="=")}return L}}),define(re[25],ae([0,1,143,62]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=S,e.$4e=P,e.$5e=h,e.$6e=u,e.$7e=g,e.$8e=y,e.$9e=k,e.$0e=$,e.$$e=d,e.$_e=v,e.$af=p,e.$bf=m,e.$cf=f,e.$df=l,e.$ef=w,e.$ff=a,e.$gf=t,e.$hf=o,e.$if=s,e.$jf=n,e.$kf=r,e.$lf=c,e.$mf=b,e.$nf=j,e.$of=C,e.$pf=I,e.$qf=O,e.$rf=M,e.$sf=F,e.$tf=L,e.$uf=T,e.$vf=U,e.$wf=le,e.$xf=ee,e.$yf=ce,e.$zf=Q,e.$Af=G,e.$Df=V,e.$Ef=B,e.$Ff=oe,e.$Gf=he,e.$Hf=N,e.$If=ne,e.$Kf=X,e.$Lf=H,e.$Mf=x,e.$Nf=K,e.$Of=ue,e.$Pf=me,e.$Rf=$e,e.$Sf=ye,e.$Tf=ke,e.$Uf=Ee,e.$Vf=Oe,e.$Wf=we,e.$Xf=Y,e.$Yf=fe,e.$Zf=We;function S(te){return!te||typeof te!="string"?!0:te.trim().length===0}const R=/{(\d+)}/g;function P(te,...de){return de.length===0?te:te.replace(R,function(pe,ve){const Pe=parseInt(ve,10);return isNaN(Pe)||Pe<0||Pe>=de.length?pe:de[Pe]})}const E=/{([^}]+)}/g;function h(te,de){return Object.keys(de).length===0?te:te.replace(E,(pe,ve)=>de[ve]??pe)}function u(te){return te.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function g(te){return te.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function y(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(te,de){let pe=0;const ve=de.charCodeAt(0);for(let Pe=te.length-1;Pe>=0;Pe--)te.charCodeAt(Pe)===ve&&pe++;return pe}function $(te,de,pe="\u2026"){return te.length<=de?te:`${te.substr(0,de)}${pe}`}function d(te,de,pe="\u2026"){if(te.length<=de)return te;const ve=Math.ceil(de/2)-pe.length/2,Pe=Math.floor(de/2)-pe.length/2;return`${te.substr(0,ve)}${pe}${te.substr(te.length-Pe)}`}function v(te,de=" "){const pe=p(te,de);return m(pe,de)}function p(te,de){if(!te||!de)return te;const pe=de.length;if(pe===0||te.length===0)return te;let ve=0;for(;te.indexOf(de,ve)===ve;)ve=ve+pe;return te.substring(ve)}function m(te,de){if(!te||!de)return te;const pe=de.length,ve=te.length;if(pe===0||ve===0)return te;let Pe=ve,Me=-1;for(;Me=te.lastIndexOf(de,Pe-1),!(Me===-1||Me+pe!==Pe);){if(Me===0)return"";Pe=Me}return te.substring(0,Pe)}function f(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(te){return te.replace(/\*/g,"")}function w(te,de,pe={}){if(!te)throw new Error("Cannot create regex from empty string");de||(te=y(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(te,ve)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function o(te){const de=[],pe=te.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)de.push(pe[2*ve]+(pe[2*ve+1]??""));return de}function s(te){for(let de=0,pe=te.length;de<pe;de++){const ve=te.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function n(te,de=0,pe=te.length){for(let ve=de;ve<pe;ve++){const Pe=te.charCodeAt(ve);if(Pe!==32&&Pe!==9)return te.substring(de,ve)}return te.substring(de,pe)}function r(te,de=te.length-1){for(let pe=de;pe>=0;pe--){const ve=te.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}function c(te,de,pe){const ve=[];let Pe=0;for(const Me of te.matchAll(de)){if(ve.push(te.slice(Pe,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Pe=Me.index+Me[0].length,ve.push(pe(Me[0],...Me.slice(1),Me.index,te,Me.groups))}return ve.push(te.slice(Pe)),Promise.all(ve).then(Me=>Me.join(""))}function b(te,de){return te<de?-1:te>de?1:0}function j(te,de,pe=0,ve=te.length,Pe=0,Me=de.length){for(;pe<ve&&Pe<Me;pe++,Pe++){const Ye=te.charCodeAt(pe),Ze=de.charCodeAt(Pe);if(Ye<Ze)return-1;if(Ye>Ze)return 1}const ze=ve-pe,Ge=Me-Pe;return ze<Ge?-1:ze>Ge?1:0}function C(te,de){return I(te,de,0,te.length,0,de.length)}function I(te,de,pe=0,ve=te.length,Pe=0,Me=de.length){for(;pe<ve&&Pe<Me;pe++,Pe++){let Ye=te.charCodeAt(pe),Ze=de.charCodeAt(Pe);if(Ye===Ze)continue;if(Ye>=128||Ze>=128)return j(te.toLowerCase(),de.toLowerCase(),pe,ve,Pe,Me);M(Ye)&&(Ye-=32),M(Ze)&&(Ze-=32);const Qe=Ye-Ze;if(Qe!==0)return Qe}const ze=ve-pe,Ge=Me-Pe;return ze<Ge?-1:ze>Ge?1:0}function O(te){return te>=48&&te<=57}function M(te){return te>=97&&te<=122}function F(te){return te>=65&&te<=90}function L(te,de){return te.length===de.length&&I(te,de)===0}function T(te,de){const pe=de.length;return de.length>te.length?!1:I(te,de,0,pe)===0}function U(te,de){const pe=Math.min(te.length,de.length);let ve;for(ve=0;ve<pe;ve++)if(te.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return pe}function le(te,de){const pe=Math.min(te.length,de.length);let ve;const Pe=te.length-1,Me=de.length-1;for(ve=0;ve<pe;ve++)if(te.charCodeAt(Pe-ve)!==de.charCodeAt(Me-ve))return ve;return pe}function ee(te){return 55296<=te&&te<=56319}function ce(te){return 56320<=te&&te<=57343}function Q(te,de){return(te-55296<<10)+(de-56320)+65536}function G(te,de,pe){const ve=te.charCodeAt(pe);if(ee(ve)&&pe+1<de){const Pe=te.charCodeAt(pe+1);if(ce(Pe))return Q(ve,Pe)}return ve}function q(te,de){const pe=te.charCodeAt(de-1);if(ce(pe)&&de>1){const ve=te.charCodeAt(de-2);if(ee(ve))return Q(ve,pe)}return pe}class W{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=q(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=G(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Bf=W;class z{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new W(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.nextCodePoint());if(ge(Pe,ze)){pe.setOffset(Me);break}Pe=ze}return pe.offset-ve}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.prevCodePoint());if(ge(ze,Pe)){pe.setOffset(Me);break}Pe=ze}return ve-pe.offset}eol(){return this.c.eol()}}e.$Cf=z;function V(te,de){return new z(te,de).nextGraphemeLength()}function B(te,de){return new z(te,de).prevGraphemeLength()}function oe(te,de){de>0&&ce(te.charCodeAt(de))&&de--;const pe=de+V(te,de);return[pe-B(te,pe),pe]}function he(te){const de=new z(te);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let J;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(te){return J||(J=A()),J.test(te)}const _=/^[\t\n\r\x20-\x7E]*$/;function ne(te){return _.test(te)}e.$Jf=/[\u2028\u2029]/;function X(te){return e.$Jf.test(te)}function H(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function x(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function K(te,de,pe=""){const ve=te.trimStart();if(ve.length<de)return ve;const Pe=/\b/g;let Me=0;for(;Pe.test(ve)&&!(ve.length-Pe.lastIndex<de);)Me=Pe.lastIndex,Pe.lastIndex+=1;return Me===0?ve:pe+ve.substring(Me).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(te){let de=0;for(const pe of te.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:te.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==te.length&&(yield{isCode:!1,str:te.substring(de)})}function me(te){return te&&(te=te.replace(se,"")),te}e.$Qf="\uFEFF";function $e(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ye(te){return $e(te)?te.substr(1):te}function ke(te,de){if(!te||!de||te.length<de.length)return!1;const pe=de.length,ve=te.toLowerCase();let Pe=0,Me=-1;for(;Pe<pe;){const ze=ve.indexOf(de[Pe],Me+1);if(ze<0)return!1;Me=ze,Pe++}return!0}function Ee(te,de=!1){return te?(de&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function Oe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function we(te,de=1){if(de===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Y(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function fe(te){return Re.getInstance().getGraphemeBreakType(te)}function ge(te,de){return te===0?de!==5&&de!==7:te===2&&de===3?!1:te===4||te===2||te===3||de===4||de===2||de===3?!0:!(te===8&&(de===8||de===9||de===11||de===12)||(te===11||te===9)&&(de===9||de===10)||(te===12||te===10)&&de===10||de===5||de===13||de===7||te===1||te===13&&de===14||te===6&&de===6)}var je;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Be()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,ve=pe.length/3;let Pe=1;for(;Pe<=ve;)if(de<pe[3*Pe])Pe=2*Pe;else if(de>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(te,de){if(te===0)return 0;const pe=Le(te,de);if(pe!==void 0)return pe;const ve=new W(de,te);return ve.prevCodePoint(),ve.offset}function Le(te,de){const pe=new W(de,te);let ve=pe.prevCodePoint();for(;Ue(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!x(ve))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===8205&&(Pe=pe.offset),Pe}function Ue(te){return 127995<=te&&te<=127999}var He;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$1f="\xA0";class Xe{static{this.c=new D.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Ye(de=>{function pe(Qe){const st=new Map;for(let it=0;it<Qe.length;it+=2)st.set(Qe[it],Qe[it+1]);return st}function ve(Qe,st){const it=new Map(Qe);for(const[ot,at]of st)it.set(ot,at);return it}function Pe(Qe,st){if(!Qe)return st;const it=new Map;for(const[ot,at]of Qe)st.has(ot)&&it.set(ot,at);return it}const Me=this.c.value;let ze=de.filter(Qe=>!Qe.startsWith("_")&&Qe in Me);ze.length===0&&(ze=["_default"]);let Ge;for(const Qe of ze){const st=pe(Me[Qe]);Ge=Pe(Ge,st)}const Ye=pe(Me._common),Ze=ve(Ye,Ge);return new Xe(Ze)})}static getInstance(de){return Xe.d.get(Array.from(de))}static{this.e=new D.$V(()=>Object.keys(Xe.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=Xe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(de){return Te.e().has(de)}static get codePoints(){return Te.e()}}e.$3f=Te}),define(re[46],ae([0,1,25]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=D,e.$fj=S,e.$gj=R,e.$hj=E,e.$jj=v;function D(m){return S(m,0)}function S(m,f){switch(typeof m){case"object":return m===null?R(349,f):Array.isArray(m)?h(m,f):u(m,f);case"string":return E(m,f);case"boolean":return P(m,f);case"number":return R(m,f);case"undefined":return R(937,f);default:return R(617,f)}}function R(m,f){return(f<<5)-f+m|0}function P(m,f){return R(m?433:863,f)}function E(m,f){f=R(149417,f);for(let l=0,w=m.length;l<w;l++)f=R(m.charCodeAt(l),f);return f}function h(m,f){return f=R(104579,f),m.reduce((l,w)=>S(w,l),f)}function u(m,f){return f=R(181387,f),Object.keys(m).sort().reduce((l,w)=>(l=E(w,l),S(m[w],l)),f)}class g{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=S(f,this.g),this.g}}e.$ij=g;var y;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k(m,f,l=32){const w=l-f,a=~((1<<w)-1);return(m<<f|(a&m)>>>w)>>>0}function $(m,f=0,l=m.byteLength,w=0){for(let a=0;a<l;a++)m[f+a]=w}function d(m,f,l="0"){for(;m.length<f;)m=l+m;return m}function v(m,f=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),f/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const l=f.length;if(l===0)return;const w=this.p;let a=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let n=o;if(i.$xf(o))if(s+1<l){const r=f.charCodeAt(s+1);i.$yf(r)?(s++,n=i.$zf(o,r)):n=65533}else{t=o;break}else i.$yf(o)&&(n=65533);if(a=this.w(w,a,n),s++,s<l)o=f.charCodeAt(s);else break}this.r=a,this.u=t}w(f,l,w){return w<128?f[l++]=w:w<2048?(f[l++]=192|(w&1984)>>>6,f[l++]=128|(w&63)>>>0):w<65536?(f[l++]=224|(w&61440)>>>12,f[l++]=128|(w&4032)>>>6,f[l++]=128|(w&63)>>>0):(f[l++]=240|(w&1835008)>>>18,f[l++]=128|(w&258048)>>>12,f[l++]=128|(w&4032)>>>6,f[l++]=128|(w&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,l=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let w=this.h,a=this.l,t=this.m,o=this.n,s=this.o,n,r,c;for(let b=0;b<80;b++)b<20?(n=a&t|~a&o,r=1518500249):b<40?(n=a^t^o,r=1859775393):b<60?(n=a&t|a&o|t&o,r=2400959708):(n=a^t^o,r=3395469782),c=k(w,5)+n+s+r+f.getUint32(b*4,!1)&4294967295,s=o,o=t,t=k(a,30),a=w,w=c;this.h=this.h+w&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$kj=p}),define(re[74],ae([0,1,25]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(D||(D={})),function(S){const R="error",P="warning",E="warn",h="info",u="ignore";function g(k){return k?i.$tf(R,k)?S.Error:i.$tf(P,k)||i.$tf(E,k)?S.Warning:i.$tf(h,k)?S.Info:S.Ignore:S.Ignore}S.fromValue=g;function y(k){switch(k){case S.Error:return R;case S.Warning:return P;case S.Info:return h;default:return u}}S.toString=y}(D||(D={})),e.default=D}),define(re[144],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(re[59],ae([0,1,22,25]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class S{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const d=$.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$si=S;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,D.$nf)($,this.b,0,$.length,this.c,this.d):(0,D.$pf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=R;class P{constructor($=!0,d=!0){this.f=$,this.g=d}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let d=$.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,D.$nf)($,this.b,0,$.length,this.d,this.e):(0,D.$pf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=P;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor($,d){this.f=$,this.g=d,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,D.$of)($,this.c.scheme);if(this.d[this.e]===2)return(0,D.$of)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,D.$mf)($,this.c.query);if(this.d[this.e]===5)return(0,D.$mf)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=h;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(g||(g={}));class y{static forUris($=()=>!1,d=()=>!1){return new y(new h($,d))}static forPaths($=!1){return new y(new P(void 0,!$))}static forStrings(){return new y(new S)}static forConfigKeys(){return new y(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,d){if(d){const v=d.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p,$)}else{const v=$.slice(0);(0,i.$Xb)(v);for(const p of v)this.set(p[0],p[1])}}set($,d){const v=this.b.reset($);let p;this.c||(this.c=new u,this.c.segment=v.value());const m=[];for(p=this.c;;){const l=v.cmp(p.segment);if(l>0)p.left||(p.left=new u,p.left.segment=v.value()),m.push([-1,p]),p=p.left;else if(l<0)p.right||(p.right=new u,p.right.segment=v.value()),m.push([1,p]),p=p.right;else if(v.hasNext())v.next(),p.mid||(p.mid=new u,p.mid.segment=v.value()),m.push([0,p]),p=p.mid;else break}const f=p.value;p.value=d,p.key=$;for(let l=m.length-1;l>=0;l--){const w=m[l][1];w.updateHeight();const a=w.balanceFactor();if(a<-1||a>1){const t=m[l][0],o=m[l+1][0];if(t===1&&o===1)m[l][1]=w.rotateLeft();else if(t===-1&&o===-1)m[l][1]=w.rotateRight();else if(t===1&&o===-1)w.right=m[l+1][1]=m[l+1][1].rotateRight(),m[l][1]=w.rotateLeft();else if(t===-1&&o===1)w.left=m[l+1][1]=m[l+1][1].rotateLeft(),m[l][1]=w.rotateRight();else throw new Error;if(l>0)switch(m[l-1][0]){case-1:m[l-1][1].left=m[l][1];break;case 1:m[l-1][1].right=m[l][1];break;case 0:m[l-1][1].mid=m[l][1];break}else this.c=m[0][1]}}return f}get($){return this.d($)?.value}d($){const d=this.b.reset($);let v=this.c;for(;v;){const p=d.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has($){const d=this.d($);return!(d?.value===void 0&&d?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,d){const v=this.b.reset($),p=[];let m=this.c;for(;m;){const f=v.cmp(m.segment);if(f>0)p.push([-1,m]),m=m.left;else if(f<0)p.push([1,m]),m=m.right;else if(v.hasNext())v.next(),p.push([0,m]),m=m.mid;else break}if(m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this.f(m.right);if(f.key){const{key:l,value:w,segment:a}=f;this.e(f.key,!1),m.key=l,m.value=w,m.segment=a}}else{const f=m.left??m.right;if(p.length>0){const[l,w]=p[p.length-1];switch(l){case-1:w.left=f;break;case 0:w.mid=f;break;case 1:w.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const l=p[f][1];l.updateHeight();const w=l.balanceFactor();if(w>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),p[f][1]=l.rotateLeft()):w<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),p[f][1]=l.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const d=this.b.reset($);let v=this.c,p;for(;v;){const m=d.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(d.hasNext())d.next(),p=v.value||p,v=v.mid;else break}return v&&v.value||p}findSuperstr($){return this.g($,!1)}g($,d){const v=this.b.reset($);let p=this.c;for(;p;){const m=v.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(v.hasNext())v.next(),p=p.mid;else return p.mid?this.h(p.mid):d?p.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[d,v]of this)$(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const d=[];return this.j($,d),d[Symbol.iterator]()}j($,d){$&&($.left&&this.j($.left,d),$.value&&d.push([$.key,$.value]),$.mid&&this.j($.mid,d),$.right&&this.j($.right,d))}_isBalanced(){const $=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:$(d.left)&&$(d.right)};return $(this.c)}}e.$wi=y}),define(re[12],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=i,e.$5f=D,e.$6f=S,e.$7f=R,e.$8f=P,e.$9f=E,e.$0f=h,e.$$f=u,e.$_f=g,e.$ag=y,e.$bg=k,e.$cg=$,e.$dg=d,e.$eg=p,e.$fg=m,e.$gg=f,e.$hg=l,e.$ig=w;function i(a){return typeof a=="string"}function D(a){return Array.isArray(a)&&a.every(t=>i(t))}function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function P(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function u(a){return typeof a>"u"}function g(a){return!y(a)}function y(a){return u(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function d(...a){const t=[];for(let o=0;o<a.length;o++){const s=a[o];if(y(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}const v=Object.prototype.hasOwnProperty;function p(a){if(!S(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function m(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every(m)}function l(a,t){const o=Math.min(a.length,t.length);for(let s=0;s<o;s++)w(a[s],t[s])}function w(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(re[105],ae([0,1,12]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=S,e.$Lj=R;const D=Object.create(null);function S(P,E){if((0,i.$4f)(E)){const h=D[E];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${E}`);E=h}return D[P]=E,{id:P}}function R(){return D}}),define(re[145],ae([0,1,105]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0,e.$Mj={add:(0,i.$Kj)("add",6e4),plus:(0,i.$Kj)("plus",6e4),gistNew:(0,i.$Kj)("gist-new",6e4),repoCreate:(0,i.$Kj)("repo-create",6e4),lightbulb:(0,i.$Kj)("lightbulb",60001),lightBulb:(0,i.$Kj)("light-bulb",60001),repo:(0,i.$Kj)("repo",60002),repoDelete:(0,i.$Kj)("repo-delete",60002),gistFork:(0,i.$Kj)("gist-fork",60003),repoForked:(0,i.$Kj)("repo-forked",60003),gitPullRequest:(0,i.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Kj)("record-keys",60005),keyboard:(0,i.$Kj)("keyboard",60005),tag:(0,i.$Kj)("tag",60006),gitPullRequestLabel:(0,i.$Kj)("git-pull-request-label",60006),tagAdd:(0,i.$Kj)("tag-add",60006),tagRemove:(0,i.$Kj)("tag-remove",60006),person:(0,i.$Kj)("person",60007),personFollow:(0,i.$Kj)("person-follow",60007),personOutline:(0,i.$Kj)("person-outline",60007),personFilled:(0,i.$Kj)("person-filled",60007),gitBranch:(0,i.$Kj)("git-branch",60008),gitBranchCreate:(0,i.$Kj)("git-branch-create",60008),gitBranchDelete:(0,i.$Kj)("git-branch-delete",60008),sourceControl:(0,i.$Kj)("source-control",60008),mirror:(0,i.$Kj)("mirror",60009),mirrorPublic:(0,i.$Kj)("mirror-public",60009),star:(0,i.$Kj)("star",60010),starAdd:(0,i.$Kj)("star-add",60010),starDelete:(0,i.$Kj)("star-delete",60010),starEmpty:(0,i.$Kj)("star-empty",60010),comment:(0,i.$Kj)("comment",60011),commentAdd:(0,i.$Kj)("comment-add",60011),alert:(0,i.$Kj)("alert",60012),warning:(0,i.$Kj)("warning",60012),search:(0,i.$Kj)("search",60013),searchSave:(0,i.$Kj)("search-save",60013),logOut:(0,i.$Kj)("log-out",60014),signOut:(0,i.$Kj)("sign-out",60014),logIn:(0,i.$Kj)("log-in",60015),signIn:(0,i.$Kj)("sign-in",60015),eye:(0,i.$Kj)("eye",60016),eyeUnwatch:(0,i.$Kj)("eye-unwatch",60016),eyeWatch:(0,i.$Kj)("eye-watch",60016),circleFilled:(0,i.$Kj)("circle-filled",60017),primitiveDot:(0,i.$Kj)("primitive-dot",60017),closeDirty:(0,i.$Kj)("close-dirty",60017),debugBreakpoint:(0,i.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Kj)("primitive-square",60018),edit:(0,i.$Kj)("edit",60019),pencil:(0,i.$Kj)("pencil",60019),info:(0,i.$Kj)("info",60020),issueOpened:(0,i.$Kj)("issue-opened",60020),gistPrivate:(0,i.$Kj)("gist-private",60021),gitForkPrivate:(0,i.$Kj)("git-fork-private",60021),lock:(0,i.$Kj)("lock",60021),mirrorPrivate:(0,i.$Kj)("mirror-private",60021),close:(0,i.$Kj)("close",60022),removeClose:(0,i.$Kj)("remove-close",60022),x:(0,i.$Kj)("x",60022),repoSync:(0,i.$Kj)("repo-sync",60023),sync:(0,i.$Kj)("sync",60023),clone:(0,i.$Kj)("clone",60024),desktopDownload:(0,i.$Kj)("desktop-download",60024),beaker:(0,i.$Kj)("beaker",60025),microscope:(0,i.$Kj)("microscope",60025),vm:(0,i.$Kj)("vm",60026),deviceDesktop:(0,i.$Kj)("device-desktop",60026),file:(0,i.$Kj)("file",60027),fileText:(0,i.$Kj)("file-text",60027),more:(0,i.$Kj)("more",60028),ellipsis:(0,i.$Kj)("ellipsis",60028),kebabHorizontal:(0,i.$Kj)("kebab-horizontal",60028),mailReply:(0,i.$Kj)("mail-reply",60029),reply:(0,i.$Kj)("reply",60029),organization:(0,i.$Kj)("organization",60030),organizationFilled:(0,i.$Kj)("organization-filled",60030),organizationOutline:(0,i.$Kj)("organization-outline",60030),newFile:(0,i.$Kj)("new-file",60031),fileAdd:(0,i.$Kj)("file-add",60031),newFolder:(0,i.$Kj)("new-folder",60032),fileDirectoryCreate:(0,i.$Kj)("file-directory-create",60032),trash:(0,i.$Kj)("trash",60033),trashcan:(0,i.$Kj)("trashcan",60033),history:(0,i.$Kj)("history",60034),clock:(0,i.$Kj)("clock",60034),folder:(0,i.$Kj)("folder",60035),fileDirectory:(0,i.$Kj)("file-directory",60035),symbolFolder:(0,i.$Kj)("symbol-folder",60035),logoGithub:(0,i.$Kj)("logo-github",60036),markGithub:(0,i.$Kj)("mark-github",60036),github:(0,i.$Kj)("github",60036),terminal:(0,i.$Kj)("terminal",60037),console:(0,i.$Kj)("console",60037),repl:(0,i.$Kj)("repl",60037),zap:(0,i.$Kj)("zap",60038),symbolEvent:(0,i.$Kj)("symbol-event",60038),error:(0,i.$Kj)("error",60039),stop:(0,i.$Kj)("stop",60039),variable:(0,i.$Kj)("variable",60040),symbolVariable:(0,i.$Kj)("symbol-variable",60040),array:(0,i.$Kj)("array",60042),symbolArray:(0,i.$Kj)("symbol-array",60042),symbolModule:(0,i.$Kj)("symbol-module",60043),symbolPackage:(0,i.$Kj)("symbol-package",60043),symbolNamespace:(0,i.$Kj)("symbol-namespace",60043),symbolObject:(0,i.$Kj)("symbol-object",60043),symbolMethod:(0,i.$Kj)("symbol-method",60044),symbolFunction:(0,i.$Kj)("symbol-function",60044),symbolConstructor:(0,i.$Kj)("symbol-constructor",60044),symbolBoolean:(0,i.$Kj)("symbol-boolean",60047),symbolNull:(0,i.$Kj)("symbol-null",60047),symbolNumeric:(0,i.$Kj)("symbol-numeric",60048),symbolNumber:(0,i.$Kj)("symbol-number",60048),symbolStructure:(0,i.$Kj)("symbol-structure",60049),symbolStruct:(0,i.$Kj)("symbol-struct",60049),symbolParameter:(0,i.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Kj)("symbol-type-parameter",60050),symbolKey:(0,i.$Kj)("symbol-key",60051),symbolText:(0,i.$Kj)("symbol-text",60051),symbolReference:(0,i.$Kj)("symbol-reference",60052),goToFile:(0,i.$Kj)("go-to-file",60052),symbolEnum:(0,i.$Kj)("symbol-enum",60053),symbolValue:(0,i.$Kj)("symbol-value",60053),symbolRuler:(0,i.$Kj)("symbol-ruler",60054),symbolUnit:(0,i.$Kj)("symbol-unit",60054),activateBreakpoints:(0,i.$Kj)("activate-breakpoints",60055),archive:(0,i.$Kj)("archive",60056),arrowBoth:(0,i.$Kj)("arrow-both",60057),arrowDown:(0,i.$Kj)("arrow-down",60058),arrowLeft:(0,i.$Kj)("arrow-left",60059),arrowRight:(0,i.$Kj)("arrow-right",60060),arrowSmallDown:(0,i.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Kj)("arrow-small-up",60064),arrowUp:(0,i.$Kj)("arrow-up",60065),bell:(0,i.$Kj)("bell",60066),bold:(0,i.$Kj)("bold",60067),book:(0,i.$Kj)("book",60068),bookmark:(0,i.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Kj)("briefcase",60076),broadcast:(0,i.$Kj)("broadcast",60077),browser:(0,i.$Kj)("browser",60078),bug:(0,i.$Kj)("bug",60079),calendar:(0,i.$Kj)("calendar",60080),caseSensitive:(0,i.$Kj)("case-sensitive",60081),check:(0,i.$Kj)("check",60082),checklist:(0,i.$Kj)("checklist",60083),chevronDown:(0,i.$Kj)("chevron-down",60084),chevronLeft:(0,i.$Kj)("chevron-left",60085),chevronRight:(0,i.$Kj)("chevron-right",60086),chevronUp:(0,i.$Kj)("chevron-up",60087),chromeClose:(0,i.$Kj)("chrome-close",60088),chromeMaximize:(0,i.$Kj)("chrome-maximize",60089),chromeMinimize:(0,i.$Kj)("chrome-minimize",60090),chromeRestore:(0,i.$Kj)("chrome-restore",60091),circleOutline:(0,i.$Kj)("circle-outline",60092),circle:(0,i.$Kj)("circle",60092),debugBreakpointUnverified:(0,i.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Kj)("circle-slash",60093),circuitBoard:(0,i.$Kj)("circuit-board",60094),clearAll:(0,i.$Kj)("clear-all",60095),clippy:(0,i.$Kj)("clippy",60096),closeAll:(0,i.$Kj)("close-all",60097),cloudDownload:(0,i.$Kj)("cloud-download",60098),cloudUpload:(0,i.$Kj)("cloud-upload",60099),code:(0,i.$Kj)("code",60100),collapseAll:(0,i.$Kj)("collapse-all",60101),colorMode:(0,i.$Kj)("color-mode",60102),commentDiscussion:(0,i.$Kj)("comment-discussion",60103),creditCard:(0,i.$Kj)("credit-card",60105),dash:(0,i.$Kj)("dash",60108),dashboard:(0,i.$Kj)("dashboard",60109),database:(0,i.$Kj)("database",60110),debugContinue:(0,i.$Kj)("debug-continue",60111),debugDisconnect:(0,i.$Kj)("debug-disconnect",60112),debugPause:(0,i.$Kj)("debug-pause",60113),debugRestart:(0,i.$Kj)("debug-restart",60114),debugStart:(0,i.$Kj)("debug-start",60115),debugStepInto:(0,i.$Kj)("debug-step-into",60116),debugStepOut:(0,i.$Kj)("debug-step-out",60117),debugStepOver:(0,i.$Kj)("debug-step-over",60118),debugStop:(0,i.$Kj)("debug-stop",60119),debug:(0,i.$Kj)("debug",60120),deviceCameraVideo:(0,i.$Kj)("device-camera-video",60121),deviceCamera:(0,i.$Kj)("device-camera",60122),deviceMobile:(0,i.$Kj)("device-mobile",60123),diffAdded:(0,i.$Kj)("diff-added",60124),diffIgnored:(0,i.$Kj)("diff-ignored",60125),diffModified:(0,i.$Kj)("diff-modified",60126),diffRemoved:(0,i.$Kj)("diff-removed",60127),diffRenamed:(0,i.$Kj)("diff-renamed",60128),diff:(0,i.$Kj)("diff",60129),diffSidebyside:(0,i.$Kj)("diff-sidebyside",60129),discard:(0,i.$Kj)("discard",60130),editorLayout:(0,i.$Kj)("editor-layout",60131),emptyWindow:(0,i.$Kj)("empty-window",60132),exclude:(0,i.$Kj)("exclude",60133),extensions:(0,i.$Kj)("extensions",60134),eyeClosed:(0,i.$Kj)("eye-closed",60135),fileBinary:(0,i.$Kj)("file-binary",60136),fileCode:(0,i.$Kj)("file-code",60137),fileMedia:(0,i.$Kj)("file-media",60138),filePdf:(0,i.$Kj)("file-pdf",60139),fileSubmodule:(0,i.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Kj)("file-symlink-file",60142),fileZip:(0,i.$Kj)("file-zip",60143),files:(0,i.$Kj)("files",60144),filter:(0,i.$Kj)("filter",60145),flame:(0,i.$Kj)("flame",60146),foldDown:(0,i.$Kj)("fold-down",60147),foldUp:(0,i.$Kj)("fold-up",60148),fold:(0,i.$Kj)("fold",60149),folderActive:(0,i.$Kj)("folder-active",60150),folderOpened:(0,i.$Kj)("folder-opened",60151),gear:(0,i.$Kj)("gear",60152),gift:(0,i.$Kj)("gift",60153),gistSecret:(0,i.$Kj)("gist-secret",60154),gist:(0,i.$Kj)("gist",60155),gitCommit:(0,i.$Kj)("git-commit",60156),gitCompare:(0,i.$Kj)("git-compare",60157),compareChanges:(0,i.$Kj)("compare-changes",60157),gitMerge:(0,i.$Kj)("git-merge",60158),githubAction:(0,i.$Kj)("github-action",60159),githubAlt:(0,i.$Kj)("github-alt",60160),globe:(0,i.$Kj)("globe",60161),grabber:(0,i.$Kj)("grabber",60162),graph:(0,i.$Kj)("graph",60163),gripper:(0,i.$Kj)("gripper",60164),heart:(0,i.$Kj)("heart",60165),home:(0,i.$Kj)("home",60166),horizontalRule:(0,i.$Kj)("horizontal-rule",60167),hubot:(0,i.$Kj)("hubot",60168),inbox:(0,i.$Kj)("inbox",60169),issueReopened:(0,i.$Kj)("issue-reopened",60171),issues:(0,i.$Kj)("issues",60172),italic:(0,i.$Kj)("italic",60173),jersey:(0,i.$Kj)("jersey",60174),json:(0,i.$Kj)("json",60175),kebabVertical:(0,i.$Kj)("kebab-vertical",60176),key:(0,i.$Kj)("key",60177),law:(0,i.$Kj)("law",60178),lightbulbAutofix:(0,i.$Kj)("lightbulb-autofix",60179),linkExternal:(0,i.$Kj)("link-external",60180),link:(0,i.$Kj)("link",60181),listOrdered:(0,i.$Kj)("list-ordered",60182),listUnordered:(0,i.$Kj)("list-unordered",60183),liveShare:(0,i.$Kj)("live-share",60184),loading:(0,i.$Kj)("loading",60185),location:(0,i.$Kj)("location",60186),mailRead:(0,i.$Kj)("mail-read",60187),mail:(0,i.$Kj)("mail",60188),markdown:(0,i.$Kj)("markdown",60189),megaphone:(0,i.$Kj)("megaphone",60190),mention:(0,i.$Kj)("mention",60191),milestone:(0,i.$Kj)("milestone",60192),gitPullRequestMilestone:(0,i.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Kj)("mortar-board",60193),move:(0,i.$Kj)("move",60194),multipleWindows:(0,i.$Kj)("multiple-windows",60195),mute:(0,i.$Kj)("mute",60196),noNewline:(0,i.$Kj)("no-newline",60197),note:(0,i.$Kj)("note",60198),octoface:(0,i.$Kj)("octoface",60199),openPreview:(0,i.$Kj)("open-preview",60200),package:(0,i.$Kj)("package",60201),paintcan:(0,i.$Kj)("paintcan",60202),pin:(0,i.$Kj)("pin",60203),play:(0,i.$Kj)("play",60204),run:(0,i.$Kj)("run",60204),plug:(0,i.$Kj)("plug",60205),preserveCase:(0,i.$Kj)("preserve-case",60206),preview:(0,i.$Kj)("preview",60207),project:(0,i.$Kj)("project",60208),pulse:(0,i.$Kj)("pulse",60209),question:(0,i.$Kj)("question",60210),quote:(0,i.$Kj)("quote",60211),radioTower:(0,i.$Kj)("radio-tower",60212),reactions:(0,i.$Kj)("reactions",60213),references:(0,i.$Kj)("references",60214),refresh:(0,i.$Kj)("refresh",60215),regex:(0,i.$Kj)("regex",60216),remoteExplorer:(0,i.$Kj)("remote-explorer",60217),remote:(0,i.$Kj)("remote",60218),remove:(0,i.$Kj)("remove",60219),replaceAll:(0,i.$Kj)("replace-all",60220),replace:(0,i.$Kj)("replace",60221),repoClone:(0,i.$Kj)("repo-clone",60222),repoForcePush:(0,i.$Kj)("repo-force-push",60223),repoPull:(0,i.$Kj)("repo-pull",60224),repoPush:(0,i.$Kj)("repo-push",60225),report:(0,i.$Kj)("report",60226),requestChanges:(0,i.$Kj)("request-changes",60227),rocket:(0,i.$Kj)("rocket",60228),rootFolderOpened:(0,i.$Kj)("root-folder-opened",60229),rootFolder:(0,i.$Kj)("root-folder",60230),rss:(0,i.$Kj)("rss",60231),ruby:(0,i.$Kj)("ruby",60232),saveAll:(0,i.$Kj)("save-all",60233),saveAs:(0,i.$Kj)("save-as",60234),save:(0,i.$Kj)("save",60235),screenFull:(0,i.$Kj)("screen-full",60236),screenNormal:(0,i.$Kj)("screen-normal",60237),searchStop:(0,i.$Kj)("search-stop",60238),server:(0,i.$Kj)("server",60240),settingsGear:(0,i.$Kj)("settings-gear",60241),settings:(0,i.$Kj)("settings",60242),shield:(0,i.$Kj)("shield",60243),smiley:(0,i.$Kj)("smiley",60244),sortPrecedence:(0,i.$Kj)("sort-precedence",60245),splitHorizontal:(0,i.$Kj)("split-horizontal",60246),splitVertical:(0,i.$Kj)("split-vertical",60247),squirrel:(0,i.$Kj)("squirrel",60248),starFull:(0,i.$Kj)("star-full",60249),starHalf:(0,i.$Kj)("star-half",60250),symbolClass:(0,i.$Kj)("symbol-class",60251),symbolColor:(0,i.$Kj)("symbol-color",60252),symbolConstant:(0,i.$Kj)("symbol-constant",60253),symbolEnumMember:(0,i.$Kj)("symbol-enum-member",60254),symbolField:(0,i.$Kj)("symbol-field",60255),symbolFile:(0,i.$Kj)("symbol-file",60256),symbolInterface:(0,i.$Kj)("symbol-interface",60257),symbolKeyword:(0,i.$Kj)("symbol-keyword",60258),symbolMisc:(0,i.$Kj)("symbol-misc",60259),symbolOperator:(0,i.$Kj)("symbol-operator",60260),symbolProperty:(0,i.$Kj)("symbol-property",60261),wrench:(0,i.$Kj)("wrench",60261),wrenchSubaction:(0,i.$Kj)("wrench-subaction",60261),symbolSnippet:(0,i.$Kj)("symbol-snippet",60262),tasklist:(0,i.$Kj)("tasklist",60263),telescope:(0,i.$Kj)("telescope",60264),textSize:(0,i.$Kj)("text-size",60265),threeBars:(0,i.$Kj)("three-bars",60266),thumbsdown:(0,i.$Kj)("thumbsdown",60267),thumbsup:(0,i.$Kj)("thumbsup",60268),tools:(0,i.$Kj)("tools",60269),triangleDown:(0,i.$Kj)("triangle-down",60270),triangleLeft:(0,i.$Kj)("triangle-left",60271),triangleRight:(0,i.$Kj)("triangle-right",60272),triangleUp:(0,i.$Kj)("triangle-up",60273),twitter:(0,i.$Kj)("twitter",60274),unfold:(0,i.$Kj)("unfold",60275),unlock:(0,i.$Kj)("unlock",60276),unmute:(0,i.$Kj)("unmute",60277),unverified:(0,i.$Kj)("unverified",60278),verified:(0,i.$Kj)("verified",60279),versions:(0,i.$Kj)("versions",60280),vmActive:(0,i.$Kj)("vm-active",60281),vmOutline:(0,i.$Kj)("vm-outline",60282),vmRunning:(0,i.$Kj)("vm-running",60283),watch:(0,i.$Kj)("watch",60284),whitespace:(0,i.$Kj)("whitespace",60285),wholeWord:(0,i.$Kj)("whole-word",60286),window:(0,i.$Kj)("window",60287),wordWrap:(0,i.$Kj)("word-wrap",60288),zoomIn:(0,i.$Kj)("zoom-in",60289),zoomOut:(0,i.$Kj)("zoom-out",60290),listFilter:(0,i.$Kj)("list-filter",60291),listFlat:(0,i.$Kj)("list-flat",60292),listSelection:(0,i.$Kj)("list-selection",60293),selection:(0,i.$Kj)("selection",60293),listTree:(0,i.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Kj)("symbol-string",60301),debugReverseContinue:(0,i.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Kj)("debug-step-back",60303),debugRestartFrame:(0,i.$Kj)("debug-restart-frame",60304),debugAlt:(0,i.$Kj)("debug-alt",60305),callIncoming:(0,i.$Kj)("call-incoming",60306),callOutgoing:(0,i.$Kj)("call-outgoing",60307),menu:(0,i.$Kj)("menu",60308),expandAll:(0,i.$Kj)("expand-all",60309),feedback:(0,i.$Kj)("feedback",60310),gitPullRequestReviewer:(0,i.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Kj)("ungroup-by-ref-type",60312),account:(0,i.$Kj)("account",60313),gitPullRequestAssignee:(0,i.$Kj)("git-pull-request-assignee",60313),bellDot:(0,i.$Kj)("bell-dot",60314),debugConsole:(0,i.$Kj)("debug-console",60315),library:(0,i.$Kj)("library",60316),output:(0,i.$Kj)("output",60317),runAll:(0,i.$Kj)("run-all",60318),syncIgnored:(0,i.$Kj)("sync-ignored",60319),pinned:(0,i.$Kj)("pinned",60320),githubInverted:(0,i.$Kj)("github-inverted",60321),serverProcess:(0,i.$Kj)("server-process",60322),serverEnvironment:(0,i.$Kj)("server-environment",60323),pass:(0,i.$Kj)("pass",60324),issueClosed:(0,i.$Kj)("issue-closed",60324),stopCircle:(0,i.$Kj)("stop-circle",60325),playCircle:(0,i.$Kj)("play-circle",60326),record:(0,i.$Kj)("record",60327),debugAltSmall:(0,i.$Kj)("debug-alt-small",60328),vmConnect:(0,i.$Kj)("vm-connect",60329),cloud:(0,i.$Kj)("cloud",60330),merge:(0,i.$Kj)("merge",60331),export:(0,i.$Kj)("export",60332),graphLeft:(0,i.$Kj)("graph-left",60333),magnet:(0,i.$Kj)("magnet",60334),notebook:(0,i.$Kj)("notebook",60335),redo:(0,i.$Kj)("redo",60336),checkAll:(0,i.$Kj)("check-all",60337),pinnedDirty:(0,i.$Kj)("pinned-dirty",60338),passFilled:(0,i.$Kj)("pass-filled",60339),circleLargeFilled:(0,i.$Kj)("circle-large-filled",60340),circleLarge:(0,i.$Kj)("circle-large",60341),circleLargeOutline:(0,i.$Kj)("circle-large-outline",60341),combine:(0,i.$Kj)("combine",60342),gather:(0,i.$Kj)("gather",60342),table:(0,i.$Kj)("table",60343),variableGroup:(0,i.$Kj)("variable-group",60344),typeHierarchy:(0,i.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Kj)("git-pull-request-create",60348),runAbove:(0,i.$Kj)("run-above",60349),runBelow:(0,i.$Kj)("run-below",60350),notebookTemplate:(0,i.$Kj)("notebook-template",60351),debugRerun:(0,i.$Kj)("debug-rerun",60352),workspaceTrusted:(0,i.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Kj)("workspace-unknown",60355),terminalCmd:(0,i.$Kj)("terminal-cmd",60356),terminalDebian:(0,i.$Kj)("terminal-debian",60357),terminalLinux:(0,i.$Kj)("terminal-linux",60358),terminalPowershell:(0,i.$Kj)("terminal-powershell",60359),terminalTmux:(0,i.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Kj)("terminal-ubuntu",60361),terminalBash:(0,i.$Kj)("terminal-bash",60362),arrowSwap:(0,i.$Kj)("arrow-swap",60363),copy:(0,i.$Kj)("copy",60364),personAdd:(0,i.$Kj)("person-add",60365),filterFilled:(0,i.$Kj)("filter-filled",60366),wand:(0,i.$Kj)("wand",60367),debugLineByLine:(0,i.$Kj)("debug-line-by-line",60368),inspect:(0,i.$Kj)("inspect",60369),layers:(0,i.$Kj)("layers",60370),layersDot:(0,i.$Kj)("layers-dot",60371),layersActive:(0,i.$Kj)("layers-active",60372),compass:(0,i.$Kj)("compass",60373),compassDot:(0,i.$Kj)("compass-dot",60374),compassActive:(0,i.$Kj)("compass-active",60375),azure:(0,i.$Kj)("azure",60376),issueDraft:(0,i.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Kj)("git-pull-request-draft",60379),debugAll:(0,i.$Kj)("debug-all",60380),debugCoverage:(0,i.$Kj)("debug-coverage",60381),runErrors:(0,i.$Kj)("run-errors",60382),folderLibrary:(0,i.$Kj)("folder-library",60383),debugContinueSmall:(0,i.$Kj)("debug-continue-small",60384),beakerStop:(0,i.$Kj)("beaker-stop",60385),graphLine:(0,i.$Kj)("graph-line",60386),graphScatter:(0,i.$Kj)("graph-scatter",60387),pieChart:(0,i.$Kj)("pie-chart",60388),bracket:(0,i.$Kj)("bracket",60175),bracketDot:(0,i.$Kj)("bracket-dot",60389),bracketError:(0,i.$Kj)("bracket-error",60390),lockSmall:(0,i.$Kj)("lock-small",60391),azureDevops:(0,i.$Kj)("azure-devops",60392),verifiedFilled:(0,i.$Kj)("verified-filled",60393),newline:(0,i.$Kj)("newline",60394),layout:(0,i.$Kj)("layout",60395),layoutActivitybarLeft:(0,i.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Kj)("layout-panel-right",60401),layoutPanel:(0,i.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Kj)("layout-statusbar",60405),layoutMenubar:(0,i.$Kj)("layout-menubar",60406),layoutCentered:(0,i.$Kj)("layout-centered",60407),target:(0,i.$Kj)("target",60408),indent:(0,i.$Kj)("indent",60409),recordSmall:(0,i.$Kj)("record-small",60410),errorSmall:(0,i.$Kj)("error-small",60411),terminalDecorationError:(0,i.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Kj)("layout-sidebar-left-off",60418),blank:(0,i.$Kj)("blank",60419),heartFilled:(0,i.$Kj)("heart-filled",60420),map:(0,i.$Kj)("map",60421),mapHorizontal:(0,i.$Kj)("map-horizontal",60421),foldHorizontal:(0,i.$Kj)("fold-horizontal",60421),mapFilled:(0,i.$Kj)("map-filled",60422),mapHorizontalFilled:(0,i.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Kj)("circle-small",60423),bellSlash:(0,i.$Kj)("bell-slash",60424),bellSlashDot:(0,i.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Kj)("search-fuzzy",60429),commentDraft:(0,i.$Kj)("comment-draft",60430),send:(0,i.$Kj)("send",60431),sparkle:(0,i.$Kj)("sparkle",60432),insert:(0,i.$Kj)("insert",60433),mic:(0,i.$Kj)("mic",60434),thumbsdownFilled:(0,i.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Kj)("thumbsup-filled",60436),coffee:(0,i.$Kj)("coffee",60437),snake:(0,i.$Kj)("snake",60438),game:(0,i.$Kj)("game",60439),vr:(0,i.$Kj)("vr",60440),chip:(0,i.$Kj)("chip",60441),piano:(0,i.$Kj)("piano",60442),music:(0,i.$Kj)("music",60443),micFilled:(0,i.$Kj)("mic-filled",60444),repoFetch:(0,i.$Kj)("repo-fetch",60445),copilot:(0,i.$Kj)("copilot",60446),lightbulbSparkle:(0,i.$Kj)("lightbulb-sparkle",60447),robot:(0,i.$Kj)("robot",60448),sparkleFilled:(0,i.$Kj)("sparkle-filled",60449),diffSingle:(0,i.$Kj)("diff-single",60450),diffMultiple:(0,i.$Kj)("diff-multiple",60451),surroundWith:(0,i.$Kj)("surround-with",60452),share:(0,i.$Kj)("share",60453),gitStash:(0,i.$Kj)("git-stash",60454),gitStashApply:(0,i.$Kj)("git-stash-apply",60455),gitStashPop:(0,i.$Kj)("git-stash-pop",60456),vscode:(0,i.$Kj)("vscode",60457),vscodeInsiders:(0,i.$Kj)("vscode-insiders",60458),codeOss:(0,i.$Kj)("code-oss",60459),runCoverage:(0,i.$Kj)("run-coverage",60460),runAllCoverage:(0,i.$Kj)("run-all-coverage",60461),coverage:(0,i.$Kj)("coverage",60462),githubProject:(0,i.$Kj)("github-project",60463),mapVertical:(0,i.$Kj)("map-vertical",60464),foldVertical:(0,i.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Kj)("fold-vertical-filled",60465),goToSearch:(0,i.$Kj)("go-to-search",60466),percentage:(0,i.$Kj)("percentage",60467),sortPercentage:(0,i.$Kj)("sort-percentage",60467)}}),define(re[75],ae([0,1,105,145]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Nj=S;function S(){return Object.values(e.$Pj)}e.$Oj={dialogError:(0,i.$Kj)("dialog-error","error"),dialogWarning:(0,i.$Kj)("dialog-warning","warning"),dialogInfo:(0,i.$Kj)("dialog-info","info"),dialogClose:(0,i.$Kj)("dialog-close","close"),treeItemExpanded:(0,i.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Kj)("tree-item-loading","loading"),menuSelection:(0,i.$Kj)("menu-selection","check"),menuSubmenu:(0,i.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Kj)("toolbar-more","more"),quickInputBack:(0,i.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Kj)("drop-down-button",60084),symbolCustomColor:(0,i.$Kj)("symbol-customcolor",60252),exportIcon:(0,i.$Kj)("export",60332),workspaceUnspecified:(0,i.$Kj)("workspace-unspecified",60355),newLine:(0,i.$Kj)("newline",60394),thumbsDownFilled:(0,i.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Kj)("thumbsup-filled",60436),gitFetch:(0,i.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Kj)("debug-breakpoint-pending",60377)},e.$Pj={...D.$Mj,...e.$Oj}}),define(re[35],ae([0,1,12]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=D,e.$Xn=S,e.$Yn=P,e.$Zn=h,e.$1n=u,e.$2n=g,e.$3n=y,e.$4n=k,e.$5n=$,e.$6n=d,e.$7n=v,e.$8n=p;function D(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const f=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([l,w])=>{f[l]=w&&typeof w=="object"?D(w):w}),f}function S(m){if(!m||typeof m!="object")return m;const f=[m];for(;f.length>0;){const l=f.shift();Object.freeze(l);for(const w in l)if(R.call(l,w)){const a=l[w];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$7f)(a)&&f.push(a)}}return m}const R=Object.prototype.hasOwnProperty;function P(m,f){return E(m,f,new Set)}function E(m,f,l){if((0,i.$ag)(m))return m;const w=f(m);if(typeof w<"u")return w;if(Array.isArray(m)){const a=[];for(const t of m)a.push(E(t,f,l));return a}if((0,i.$6f)(m)){if(l.has(m))throw new Error("Cannot clone recursive data-structure");l.add(m);const a={};for(const t in m)R.call(m,t)&&(a[t]=E(m[t],f,l));return l.delete(m),a}return m}function h(m,f,l=!0){return(0,i.$6f)(m)?((0,i.$6f)(f)&&Object.keys(f).forEach(w=>{w in m?l&&((0,i.$6f)(m[w])&&(0,i.$6f)(f[w])?h(m[w],f[w],l):m[w]=f[w]):m[w]=f[w]}),m):f}function u(m,f){if(m===f)return!0;if(m==null||f===null||f===void 0||typeof m!=typeof f||typeof m!="object"||Array.isArray(m)!==Array.isArray(f))return!1;let l,w;if(Array.isArray(m)){if(m.length!==f.length)return!1;for(l=0;l<m.length;l++)if(!u(m[l],f[l]))return!1}else{const a=[];for(w in m)a.push(w);a.sort();const t=[];for(w in f)t.push(w);if(t.sort(),!u(a,t))return!1;for(l=0;l<a.length;l++)if(!u(m[a[l]],f[a[l]]))return!1}return!0}function g(m){const f=new Set;return JSON.stringify(m,(l,w)=>{if((0,i.$6f)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return typeof w=="bigint"?`[BigInt ${w.toString()}]`:w})}function y(m,f){const l=Object.create(null);return!m||!f||Object.keys(f).forEach(a=>{const t=m[a],o=f[a];u(t,o)||(l[a]=o)}),l}function k(m,f){const l=f.toLowerCase(),w=Object.keys(m).find(a=>a.toLowerCase()===l);return w?m[w]:m[f]}function $(m,f){const l=Object.create(null);for(const[w,a]of Object.entries(m))f(w,a)&&(l[w]=a);return l}function d(m){let f=[];for(;Object.prototype!==m;)f=f.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return f}function v(m){const f=[];for(const l of d(m))typeof m[l]=="function"&&f.push(l);return f}function p(m,f){const l=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},w={};for(const a of m)w[a]=l(a);return w}}),define(re[106],ae([0,1,75]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=S;var D;(function(P){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}P.isThemeColor=E})(D||(e.ThemeColor=D={}));function S(P){return{id:P}}var R;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function h(f){const l=E.exec(f.id);if(!l)return h(i.$Pj.error);const[,w,a]=l,t=["codicon","codicon-"+w];return a&&t.push("codicon-modifier-"+a.substring(1)),t}P.asClassNameArray=h;function u(f){return h(f).join(" ")}P.asClassName=u;function g(f){return"."+h(f).join(".")}P.asCSSSelector=g;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||D.isThemeColor(f.color))}P.isThemeIcon=y;const k=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function $(f){const l=k.exec(f);if(!l)return;const[,w]=l;return{id:w}}P.fromString=$;function d(f){return{id:f}}P.fromId=d;function v(f,l){let w=f.id;const a=w.lastIndexOf("~");return a!==-1&&(w=w.substring(0,a)),l&&(w=`${w}~${l}`),{id:w}}P.modify=v;function p(f){const l=f.id.lastIndexOf("~");if(l!==-1)return f.id.substring(l+1)}P.getModifier=p;function m(f,l){return f.id===l.id&&f.color?.id===l.color?.id}P.isEqual=m})(R||(e.ThemeIcon=R={}))}),define(re[33],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=D;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return i.test(S)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),P=[];for(let E=0;E<256;E++)P.push(E.toString(16).padStart(2,"0"));return function(){S(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,u="";return u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u+="-",u+=P[R[h++]],u+=P[R[h++]],u+="-",u+=P[R[h++]],u+=P[R[h++]],u+="-",u+=P[R[h++]],u+=P[R[h++]],u+="-",u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u+=P[R[h++]],u}}()}),define(re[146],ae([0,1,87,43,86]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wW=R;async function R(P,E){if(await new Promise((g,y)=>{const k=D.createReadStream(P),$=i.createHash("sha256");k.pipe($);const d=(0,S.$db)((v,p)=>{k.removeAllListeners(),$.removeAllListeners(),v?y(v):g(p)});k.once("error",d),k.once("end",d),$.once("error",d),$.once("data",v=>d(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(re[147],ae([0,1,26]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=R;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(P){const E=P.replace(/\-/g,":").toLowerCase();return!D.has(E)}function R(){const P=(0,i.networkInterfaces)();for(const E in P){const h=P[E];if(h){for(const{mac:u}of h)if(S(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[107],ae([0,1,88]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=D,e.$Qg=R;function D(E,h,u,g=1){let y=!1;return new Promise(k=>{const $=setTimeout(()=>{if(!y)return y=!0,k(0)},u);S(E,h,g,d=>{if(!y)return y=!0,clearTimeout($),k(d)})})}function S(E,h,u,g){if(h===0)return g(0);const y=new i.Socket;y.once("connect",()=>(P(y),S(E+u,h-1,u,g))),y.once("data",()=>{}),y.once("error",k=>(P(y),k.code!=="ECONNREFUSED"?S(E+u,h-1,u,g):g(E))),y.connect(E,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,h,u,g="127.0.0.1"){let y=!1,k,$=1;const d=i.createServer({pauseOnConnect:!0});function v(p,m){y||(y=!0,d.removeAllListeners(),d.close(),k&&clearTimeout(k),m(p))}return new Promise(p=>{k=setTimeout(()=>{v(0,p)},u),d.on("listening",()=>{v(E,p)}),d.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&$<h?(E++,$++,d.listen(E,g)):v(0,p)}),d.on("close",()=>{v(0,p)}),d.listen(E,g)})}function P(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function Z(){function e(){return process.uncHostAllowlist}function i(h){const u=new Set;if(Array.isArray(h))for(const g of h)typeof g=="string"&&u.add(g);return Array.from(u)}function D(){const h=e();return h?Array.from(h):[]}function S(h){if(process.platform!=="win32")return;const u=e();if(u)if(typeof h=="string")u.add(h.toLowerCase());else for(const g of i(h))S(g)}function R(h){if(typeof h!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const y of u){if(h.indexOf(y)!==0)continue;const $=h.indexOf("\\",y.length);if($===-1)continue;const d=h.substring(y.length,$);if(d){g=d;break}}return g}function P(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:S,getUNCHost:R,disableUNCAccessRestrictions:P,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Z()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Z():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[148],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CW=e.$BW=void 0,e.$BW="vscode:contextmenu",e.$CW="vscode:onCloseContextMenu"}),define(re[149],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JW=void 0;class i{constructor(S,R){this.a=S,this.onMessage=R}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$JW=i}),define(re[150],ae([11,10]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(re[151],ae([0,1,150]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=u,e.$Wm=g,e.$Xm=y;const D=60,S=D*60,R=S*24,P=R*7,E=R*30,h=R*365;function u(k,$,d,v){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,i.localize)(0,null,u(new Date().getTime()+p*1e3,!1));if(!v&&p<30)return(0,i.localize)(1,null);let m;return p<D?(m=p,$?m===1?d?(0,i.localize)(2,null,m):(0,i.localize)(3,null,m):d?(0,i.localize)(4,null,m):(0,i.localize)(5,null,m):m===1?d?(0,i.localize)(6,null,m):(0,i.localize)(7,null,m):d?(0,i.localize)(8,null,m):(0,i.localize)(9,null,m)):p<S?(m=Math.floor(p/D),$?m===1?d?(0,i.localize)(10,null,m):(0,i.localize)(11,null,m):d?(0,i.localize)(12,null,m):(0,i.localize)(13,null,m):m===1?d?(0,i.localize)(14,null,m):(0,i.localize)(15,null,m):d?(0,i.localize)(16,null,m):(0,i.localize)(17,null,m)):p<R?(m=Math.floor(p/S),$?m===1?d?(0,i.localize)(18,null,m):(0,i.localize)(19,null,m):d?(0,i.localize)(20,null,m):(0,i.localize)(21,null,m):m===1?d?(0,i.localize)(22,null,m):(0,i.localize)(23,null,m):d?(0,i.localize)(24,null,m):(0,i.localize)(25,null,m)):p<P?(m=Math.floor(p/R),$?m===1?(0,i.localize)(26,null,m):(0,i.localize)(27,null,m):m===1?(0,i.localize)(28,null,m):(0,i.localize)(29,null,m)):p<E?(m=Math.floor(p/P),$?m===1?d?(0,i.localize)(30,null,m):(0,i.localize)(31,null,m):d?(0,i.localize)(32,null,m):(0,i.localize)(33,null,m):m===1?d?(0,i.localize)(34,null,m):(0,i.localize)(35,null,m):d?(0,i.localize)(36,null,m):(0,i.localize)(37,null,m)):p<h?(m=Math.floor(p/E),$?m===1?d?(0,i.localize)(38,null,m):(0,i.localize)(39,null,m):d?(0,i.localize)(40,null,m):(0,i.localize)(41,null,m):m===1?d?(0,i.localize)(42,null,m):(0,i.localize)(43,null,m):d?(0,i.localize)(44,null,m):(0,i.localize)(45,null,m)):(m=Math.floor(p/h),$?m===1?d?(0,i.localize)(46,null,m):(0,i.localize)(47,null,m):d?(0,i.localize)(48,null,m):(0,i.localize)(49,null,m):m===1?d?(0,i.localize)(50,null,m):(0,i.localize)(51,null,m):d?(0,i.localize)(52,null,m):(0,i.localize)(53,null,m))}function g(k,$){const d=Math.abs(k/1e3);return d<1?$?(0,i.localize)(54,null,k):(0,i.localize)(55,null,k):d<D?$?(0,i.localize)(56,null,Math.round(k)/1e3):(0,i.localize)(57,null,Math.round(k)/1e3):d<S?$?(0,i.localize)(58,null,Math.round(k/(1e3*D))):(0,i.localize)(59,null,Math.round(k/(1e3*D))):d<R?$?(0,i.localize)(60,null,Math.round(k/(1e3*S))):(0,i.localize)(61,null,Math.round(k/(1e3*S))):(0,i.localize)(62,null,Math.round(k/(1e3*R)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[152],ae([11,10]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(re[47],ae([0,1,22,12,152]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=h,e.$cj=u,e.$dj=g;function R(y,k){return k&&(y.stack||y.stacktrace)?S.localize(0,null,E(y),P(y.stack)||P(y.stacktrace)):E(y)}function P(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function h(y=null,k=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const $=i.$Hb(y),d=h($[0],k);return $.length>1?S.localize(4,null,d,$.length):d}if(D.$4f(y))return y;if(y.detail){const $=y.detail;if($.error)return R($.error,k);if($.exception)return R($.exception,k)}return y.stack?R(y,k):y.message?y.message:S.localize(5,null)}function u(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function g(y,k){let $;return typeof y=="string"?$=new Error(y):$=y,$.actions=k,$}}),define(re[153],ae([11,10]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(re[154],ae([0,1,153]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=D;function D(S){switch(S){case 1:return(0,i.localize)(0,null);case 2:return(0,i.localize)(1,null);case 3:return(0,i.localize)(2,null);case 4:return(0,i.localize)(3,null);case 5:return(0,i.localize)(4,null);case 6:return(0,i.localize)(5,null);case 7:return(0,i.localize)(6,null);case 8:return(0,i.localize)(7,null);case 9:return(0,i.localize)(8,null);default:return""}}}),define(re[155],ae([11,10]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(re[4],ae([0,1,155]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=j,e.$J=C,e.$g="en";let D=!1,S=!1,R=!1,P=!1,E=!1,h=!1,u=!1,g=!1,y=!1,k=!1,$,d=e.$g,v=e.$g,p,m;const f=globalThis;let l;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?l=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const w=typeof l?.versions?.electron=="string",a=w&&l?.type==="renderer";if(typeof l=="object"){D=l.platform==="win32",S=l.platform==="darwin",R=l.platform==="linux",P=R&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,u=w,y=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,d=e.$g;const I=l.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];$=O.locale,v=O.osLocale,d=M||e.$g,p=O._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(m=navigator.userAgent,D=m.indexOf("Windows")>=0,S=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=m.indexOf("Linux")>=0,k=m?.indexOf("Mobi")>=0,h=!0,$=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,d=$,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;S?s=1:D?s=3:R&&(s=2),e.$i=D,e.$j=S,e.$k=R,e.$l=P,e.$m=E,e.$n=u,e.$o=h,e.$p=h&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=g,e.$s=k,e.$t=y,e.$u=s,e.$v=m,e.$w=d;var n;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function F(){return e.$w==="en"}I.isDefault=F})(n||(e.Language=n={})),e.$x=$,e.$y=v,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const I=[];f.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let F=0,L=I.length;F<L;F++){const T=I[F];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(F,1),T.callback();return}}});let O=0;return M=>{const F=++O;I.push({id:F,callback:M}),f.postMessage({vscodeScheduleAsyncWork:F},"*")}}return I=>setTimeout(I)})();var r;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=S||g?2:D?1:3;let c=!0,b=!1;function j(){if(!b){b=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,c=new Uint16Array(I.buffer)[0]===513}return c}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(I){return parseFloat(I)>=20}}),define(re[36],ae([0,1,4]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const R=S.process;D={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$ec=D.platform,e.$fc=D.arch}),define(re[9],ae([0,1,36]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const D=65,S=97,R=90,P=122,E=46,h=47,u=92,g=58,y=63;class k extends Error{constructor(o,s,n){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const c=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${c} ${r} of type ${s}`;b+=`. Received type ${typeof n}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function d(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=i.$ec==="win32";function p(t){return t===h||t===u}function m(t){return t===h}function f(t){return t>=D&&t<=R||t>=S&&t<=P}function l(t,o,s,n){let r="",c=0,b=-1,j=0,C=0;for(let I=0;I<=t.length;++I){if(I<t.length)C=t.charCodeAt(I);else{if(n(C))break;C=h}if(n(C)){if(!(b===I-1||j===1))if(j===2){if(r.length<2||c!==2||r.charCodeAt(r.length-1)!==E||r.charCodeAt(r.length-2)!==E){if(r.length>2){const O=r.lastIndexOf(s);O===-1?(r="",c=0):(r=r.slice(0,O),c=r.length-1-r.lastIndexOf(s)),b=I,j=0;continue}else if(r.length!==0){r="",c=0,b=I,j=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",c=2)}else r.length>0?r+=`${s}${t.slice(b+1,I)}`:r=t.slice(b+1,I),c=I-b-1;b=I,j=0}else C===E&&j!==-1?++j:j=-1}return r}function w(t,o){$(o,"pathObject");const s=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${n}`:`${s}${t}${n}`:n}e.$gc={resolve(...t){let o="",s="",n=!1;for(let r=t.length-1;r>=-1;r--){let c;if(r>=0){if(c=t[r],d(c,"path"),c.length===0)continue}else o.length===0?c=i.cwd():(c=i.env[`=${o}`]||i.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const b=c.length;let j=0,C="",I=!1;const O=c.charCodeAt(0);if(b===1)p(O)&&(j=1,I=!0);else if(p(O))if(I=!0,p(c.charCodeAt(1))){let M=2,F=M;for(;M<b&&!p(c.charCodeAt(M));)M++;if(M<b&&M!==F){const L=c.slice(F,M);for(F=M;M<b&&p(c.charCodeAt(M));)M++;if(M<b&&M!==F){for(F=M;M<b&&!p(c.charCodeAt(M));)M++;(M===b||M!==F)&&(C=`\\\\${L}\\${c.slice(F,M)}`,j=M)}}}else j=1;else f(O)&&c.charCodeAt(1)===g&&(C=c.slice(0,2),j=2,b>2&&p(c.charCodeAt(2))&&(I=!0,j=3));if(C.length>0)if(o.length>0){if(C.toLowerCase()!==o.toLowerCase())continue}else o=C;if(n){if(o.length>0)break}else if(s=`${c.slice(j)}\\${s}`,n=I,I&&o.length>0)break}return s=l(s,!n,"\\",p),n?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){d(t,"path");const o=t.length;if(o===0)return".";let s=0,n,r=!1;const c=t.charCodeAt(0);if(o===1)return m(c)?"\\":t;if(p(c))if(r=!0,p(t.charCodeAt(1))){let j=2,C=j;for(;j<o&&!p(t.charCodeAt(j));)j++;if(j<o&&j!==C){const I=t.slice(C,j);for(C=j;j<o&&p(t.charCodeAt(j));)j++;if(j<o&&j!==C){for(C=j;j<o&&!p(t.charCodeAt(j));)j++;if(j===o)return`\\\\${I}\\${t.slice(C)}\\`;j!==C&&(n=`\\\\${I}\\${t.slice(C,j)}`,s=j)}}}else s=1;else f(c)&&t.charCodeAt(1)===g&&(n=t.slice(0,2),s=2,o>2&&p(t.charCodeAt(2))&&(r=!0,s=3));let b=s<o?l(t.slice(s),!r,"\\",p):"";return b.length===0&&!r&&(b="."),b.length>0&&p(t.charCodeAt(o-1))&&(b+="\\"),n===void 0?r?`\\${b}`:b:r?`${n}\\${b}`:`${n}${b}`},isAbsolute(t){d(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return p(s)||o>2&&f(s)&&t.charCodeAt(1)===g&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let c=0;c<t.length;++c){const b=t[c];d(b,"path"),b.length>0&&(o===void 0?o=s=b:o+=`\\${b}`)}if(o===void 0)return".";let n=!0,r=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++r;const c=s.length;c>1&&p(s.charCodeAt(1))&&(++r,c>2&&(p(s.charCodeAt(2))?++r:n=!1))}if(n){for(;r<o.length&&p(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.$gc.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o)return"";const s=e.$gc.resolve(t),n=e.$gc.resolve(o);if(s===n||(t=s.toLowerCase(),o=n.toLowerCase(),t===o))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===u;)r++;let c=t.length;for(;c-1>r&&t.charCodeAt(c-1)===u;)c--;const b=c-r;let j=0;for(;j<o.length&&o.charCodeAt(j)===u;)j++;let C=o.length;for(;C-1>j&&o.charCodeAt(C-1)===u;)C--;const I=C-j,O=b<I?b:I;let M=-1,F=0;for(;F<O;F++){const T=t.charCodeAt(r+F);if(T!==o.charCodeAt(j+F))break;T===u&&(M=F)}if(F!==O){if(M===-1)return n}else{if(I>O){if(o.charCodeAt(j+F)===u)return n.slice(j+F+1);if(F===2)return n.slice(j+F)}b>O&&(t.charCodeAt(r+F)===u?M=F:F===2&&(M=3)),M===-1&&(M=0)}let L="";for(F=r+M+1;F<=c;++F)(F===c||t.charCodeAt(F)===u)&&(L+=L.length===0?"..":"\\..");return j+=M,L.length>0?`${L}${n.slice(j,C)}`:(n.charCodeAt(j)===u&&++j,n.slice(j,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const s=o.charCodeAt(2);if(s!==y&&s!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return t},dirname(t){d(t,"path");const o=t.length;if(o===0)return".";let s=-1,n=0;const r=t.charCodeAt(0);if(o===1)return p(r)?t:".";if(p(r)){if(s=n=1,p(t.charCodeAt(1))){let j=2,C=j;for(;j<o&&!p(t.charCodeAt(j));)j++;if(j<o&&j!==C){for(C=j;j<o&&p(t.charCodeAt(j));)j++;if(j<o&&j!==C){for(C=j;j<o&&!p(t.charCodeAt(j));)j++;if(j===o)return t;j!==C&&(s=n=j+1)}}}}else f(r)&&t.charCodeAt(1)===g&&(s=o>2&&p(t.charCodeAt(2))?3:2,n=s);let c=-1,b=!0;for(let j=o-1;j>=n;--j)if(p(t.charCodeAt(j))){if(!b){c=j;break}}else b=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let s=0,n=-1,r=!0,c;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,j=-1;for(c=t.length-1;c>=s;--c){const C=t.charCodeAt(c);if(p(C)){if(!r){s=c+1;break}}else j===-1&&(r=!1,j=c+1),b>=0&&(C===o.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=j))}return s===n?n=j:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=s;--c)if(p(t.charCodeAt(c))){if(!r){s=c+1;break}}else n===-1&&(r=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let o=0,s=-1,n=0,r=-1,c=!0,b=0;t.length>=2&&t.charCodeAt(1)===g&&f(t.charCodeAt(0))&&(o=n=2);for(let j=t.length-1;j>=o;--j){const C=t.charCodeAt(j);if(p(C)){if(!c){n=j+1;break}continue}r===-1&&(c=!1,r=j+1),C===E?s===-1?s=j:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||r===-1||b===0||b===1&&s===r-1&&s===n+1?"":t.slice(s,r)},format:w.bind(null,"\\"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let n=0,r=t.charCodeAt(0);if(s===1)return p(r)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(p(r)){if(n=1,p(t.charCodeAt(1))){let M=2,F=M;for(;M<s&&!p(t.charCodeAt(M));)M++;if(M<s&&M!==F){for(F=M;M<s&&p(t.charCodeAt(M));)M++;if(M<s&&M!==F){for(F=M;M<s&&!p(t.charCodeAt(M));)M++;M===s?n=M:M!==F&&(n=M+1)}}}}else if(f(r)&&t.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=t,o;if(n=2,p(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let c=-1,b=n,j=-1,C=!0,I=t.length-1,O=0;for(;I>=n;--I){if(r=t.charCodeAt(I),p(r)){if(!C){b=I+1;break}continue}j===-1&&(C=!1,j=I+1),r===E?c===-1?c=I:O!==1&&(O=1):c!==-1&&(O=-1)}return j!==-1&&(c===-1||O===0||O===1&&c===j-1&&c===b+1?o.base=o.name=t.slice(b,j):(o.name=t.slice(b,c),o.base=t.slice(b,j),o.ext=t.slice(c,j))),b>0&&b!==n?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.$hc={resolve(...t){let o="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const r=n>=0?t[n]:a();d(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===h)}return o=l(o,!s,"/",m),s?`/${o}`:o.length>0?o:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=l(t,!o,"/",m),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const n=t[s];d(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const s=1,n=t.length,r=n-s,c=1,b=o.length-c,j=r<b?r:b;let C=-1,I=0;for(;I<j;I++){const M=t.charCodeAt(s+I);if(M!==o.charCodeAt(c+I))break;M===h&&(C=I)}if(I===j)if(b>j){if(o.charCodeAt(c+I)===h)return o.slice(c+I+1);if(I===0)return o.slice(c+I)}else r>j&&(t.charCodeAt(s+I)===h?C=I:I===0&&(C=0));let O="";for(I=s+C+1;I<=n;++I)(I===n||t.charCodeAt(I)===h)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(c+C)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let s=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===h){if(!n){s=r;break}}else n=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let s=0,n=-1,r=!0,c;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,j=-1;for(c=t.length-1;c>=0;--c){const C=t.charCodeAt(c);if(C===h){if(!r){s=c+1;break}}else j===-1&&(r=!1,j=c+1),b>=0&&(C===o.charCodeAt(b)?--b===-1&&(n=c):(b=-1,n=j))}return s===n?n=j:n===-1&&(n=t.length),t.slice(s,n)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===h){if(!r){s=c+1;break}}else n===-1&&(r=!1,n=c+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let o=-1,s=0,n=-1,r=!0,c=0;for(let b=t.length-1;b>=0;--b){const j=t.charCodeAt(b);if(j===h){if(!r){s=b+1;break}continue}n===-1&&(r=!1,n=b+1),j===E?o===-1?o=b:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||n===-1||c===0||c===1&&o===n-1&&o===s+1?"":t.slice(o,n)},format:w.bind(null,"/"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===h;let n;s?(o.root="/",n=1):n=0;let r=-1,c=0,b=-1,j=!0,C=t.length-1,I=0;for(;C>=n;--C){const O=t.charCodeAt(C);if(O===h){if(!j){c=C+1;break}continue}b===-1&&(j=!1,b=C+1),O===E?r===-1?r=C:I!==1&&(I=1):r!==-1&&(I=-1)}if(b!==-1){const O=c===0&&s?1:c;r===-1||I===0||I===1&&r===b-1&&r===c+1?o.base=o.name=t.slice(O,b):(o.name=t.slice(O,r),o.base=t.slice(O,b),o.ext=t.slice(r,b))}return c>0?o.dir=t.slice(0,c-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(re[32],ae([0,1,9,4,25,12]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=P,e.$kg=E,e.$lg=h,e.$mg=u,e.$ng=g,e.$og=d,e.$pg=v,e.$qg=p,e.$rg=m,e.$sg=f,e.$tg=l,e.$ug=w,e.$vg=a,e.$wg=t,e.$xg=o,e.$yg=r;function P(c){return c===47||c===92}function E(c){return c.replace(/[\\/]/g,i.$hc.sep)}function h(c){return c.indexOf("/")===-1&&(c=E(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}function u(c,b=i.$hc.sep){if(!c)return"";const j=c.length,C=c.charCodeAt(0);if(P(C)){if(P(c.charCodeAt(1))&&!P(c.charCodeAt(2))){let O=3;const M=O;for(;O<j&&!P(c.charCodeAt(O));O++);if(M!==O&&!P(c.charCodeAt(O+1))){for(O+=1;O<j;O++)if(P(c.charCodeAt(O)))return c.slice(0,O+1).replace(/[\\/]/g,b)}}return b}else if(m(C)&&c.charCodeAt(1)===58)return P(c.charCodeAt(2))?c.slice(0,2)+b:c.slice(0,2);let I=c.indexOf("://");if(I!==-1){for(I+=3;I<j;I++)if(P(c.charCodeAt(I)))return c.slice(0,I+1)}return""}function g(c){if(!D.$i||!c||c.length<5)return!1;let b=c.charCodeAt(0);if(b!==92||(b=c.charCodeAt(1),b!==92))return!1;let j=2;const C=j;for(;j<c.length&&(b=c.charCodeAt(j),b!==92);j++);return!(C===j||(b=c.charCodeAt(j+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(c,b=D.$i){const j=b?y:k;return!(!c||c.length===0||/^\s+$/.test(c)||(j.lastIndex=0,j.test(c))||b&&$.test(c)||c==="."||c===".."||b&&c[c.length-1]==="."||b&&c.length!==c.trim().length||c.length>255)}function v(c,b,j){const C=c===b;return!j||C?C:!c||!b?!1:(0,S.$tf)(c,b)}function p(c,b,j,C=i.sep){if(c===b)return!0;if(!c||!b||b.length>c.length)return!1;if(j){if(!(0,S.$uf)(c,b))return!1;if(b.length===c.length)return!0;let O=b.length;return b.charAt(b.length-1)===C&&O--,c.charAt(O)===C}return b.charAt(b.length-1)!==C&&(b+=C),c.indexOf(b)===0}function m(c){return c>=65&&c<=90||c>=97&&c<=122}function f(c,b){return D.$i&&c.endsWith(":")&&(c+=i.sep),(0,i.$jc)(c)||(c=(0,i.$kc)(b,c)),c=(0,i.$ic)(c),D.$i?(c=(0,S.$bf)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,S.$bf)(c,i.sep),c||(c=i.sep)),c}function l(c){const b=(0,i.$ic)(c);return D.$i?c.length>3?!1:w(b)&&(c.length===2||b.charCodeAt(2)===92):b===i.$hc.sep}function w(c,b=D.$i){return b?m(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}function a(c,b=D.$i){return w(c,b)?c[0]:void 0}function t(c,b,j){return b.length>c.length?-1:c===b?0:(j&&(c=c.toLowerCase(),b=b.toLowerCase()),c.indexOf(b))}function o(c){const b=c.split(":");let j,C,I;for(const O of b){const M=Number(O);(0,R.$8f)(M)?C===void 0?C=M:I===void 0&&(I=M):j=j?[j,O].join(":"):O}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:C!==void 0?C:void 0,column:I!==void 0?I:C!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(c,b,j=8){let C="";for(let O=0;O<j;O++){let M;O===0&&D.$i&&!b&&(j===3||j===4)?M=n:M=s,C+=M.charAt(Math.floor(Math.random()*M.length))}let I;return b?I=`${b}-${C}`:I=C,c?(0,i.$kc)(c,I):I}}),define(re[76],ae([0,1,4]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=R,e.$hm=P;var D;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(D||(e.Source=D={}));var S;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function R(E,...h){const u=h.reduce((k,$)=>(k[$]=!0,k),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!u[k]).forEach(k=>{for(let $=0;$<g.length;$++)if(k.search(g[$])!==-1){delete E[k];break}})}function P(E){E&&(delete E.DEBUG,i.$j&&delete E.DYLD_LIBRARY_PATH,i.$k&&delete E.LD_PRELOAD)}}),define(re[7],ae([0,1,9,4]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=d,e.$xc=w;const S=/^\w[\w\d+.-]*$/,R=/^\//,P=/^\/\//;function E(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!S.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(n,r){return!n&&!r?"file":n}function u(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const g="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(r){return r instanceof $?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,c,b,j,C,I=!1){typeof r=="object"?(this.scheme=r.scheme||g,this.authority=r.authority||g,this.path=r.path||g,this.query=r.query||g,this.fragment=r.fragment||g):(this.scheme=h(r,I),this.authority=c||g,this.path=u(this.scheme,b||g),this.query=j||g,this.fragment=C||g,E(this,I))}get fsPath(){return w(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:b,path:j,query:C,fragment:I}=r;return c===void 0?c=this.scheme:c===null&&(c=g),b===void 0?b=this.authority:b===null&&(b=g),j===void 0?j=this.path:j===null&&(j=g),C===void 0?C=this.query:C===null&&(C=g),I===void 0?I=this.fragment:I===null&&(I=g),c===this.scheme&&b===this.authority&&j===this.path&&C===this.query&&I===this.fragment?this:new p(c,b,j,C,I)}static parse(r,c=!1){const b=k.exec(r);return b?new p(b[2]||g,s(b[4]||g),s(b[5]||g),s(b[7]||g),s(b[9]||g),c):new p(g,g,g,g,g)}static file(r){let c=g;if(D.$i&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const b=r.indexOf(y,2);b===-1?(c=r.substring(2),r=y):(c=r.substring(2,b),r=r.substring(b)||y)}return new p("file",c,r,g,g)}static from(r,c){return new p(r.scheme,r.authority,r.path,r.query,r.fragment,c)}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.$i&&r.scheme==="file"?b=$.file(i.$gc.join(w(r,!0),...c)).path:b=i.$hc.join(r.path,...c),r.with({path:b})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof $)return r;{const c=new p(r);return c._formatted=r.external??null,c._fsPath=r._sep===v?r.fsPath??null:null,c}}else return r}}e.URI=$;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}const v=D.$i?1:void 0;class p extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=v),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(n,r,c){let b,j=-1;for(let C=0;C<n.length;C++){const I=n.charCodeAt(C);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||r&&I===47||c&&I===91||c&&I===93||c&&I===58)j!==-1&&(b+=encodeURIComponent(n.substring(j,C)),j=-1),b!==void 0&&(b+=n.charAt(C));else{b===void 0&&(b=n.substr(0,C));const O=m[I];O!==void 0?(j!==-1&&(b+=encodeURIComponent(n.substring(j,C)),j=-1),b+=O):j===-1&&(j=C)}}return j!==-1&&(b+=encodeURIComponent(n.substring(j))),b!==void 0?b:n}function l(n){let r;for(let c=0;c<n.length;c++){const b=n.charCodeAt(c);b===35||b===63?(r===void 0&&(r=n.substr(0,c)),r+=m[b]):r!==void 0&&(r+=n[c])}return r!==void 0?r:n}function w(n,r){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,D.$i&&(c=c.replace(/\//g,"\\")),c}function a(n,r){const c=r?l:f;let b="",{scheme:j,authority:C,path:I,query:O,fragment:M}=n;if(j&&(b+=j,b+=":"),(C||j==="file")&&(b+=y,b+=y),C){let F=C.indexOf("@");if(F!==-1){const L=C.substr(0,F);C=C.substr(F+1),F=L.lastIndexOf(":"),F===-1?b+=c(L,!1,!1):(b+=c(L.substr(0,F),!1,!1),b+=":",b+=c(L.substr(F+1),!1,!0)),b+="@"}C=C.toLowerCase(),F=C.lastIndexOf(":"),F===-1?b+=c(C,!1,!0):(b+=c(C.substr(0,F),!1,!0),b+=C.substr(F))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const F=I.charCodeAt(1);F>=65&&F<=90&&(I=`/${String.fromCharCode(F+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const F=I.charCodeAt(0);F>=65&&F<=90&&(I=`${String.fromCharCode(F+32)}:${I.substr(2)}`)}b+=c(I,!0,!1)}return O&&(b+="?",b+=c(O,!1,!1)),M&&(b+="#",b+=r?M:f(M,!1,!1)),b}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,r=>t(r)):n}}),define(re[156],ae([0,1,7]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=D,e.$Oq=S,e.$Pq=R,e.log=E;function D(u){const g=u;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function S(u){const g=[];let y;try{const k=JSON.parse(u.arguments),$=k[k.length-1];$&&$.__$stack&&(k.pop(),y=$.__$stack),g.push(...k)}catch{g.push("Unable to log remote console arguments",u.arguments)}return{args:g,stack:y}}function R(u){if(typeof u!="string")return R(S(u).stack);const g=u;if(g){const y=P(g),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:i.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function P(u){if(!u)return u;const g=u.indexOf(`
`);return g===-1?u:u.substring(0,g)}function E(u,g){const{args:y,stack:k}=S(u),$=typeof y[0]=="string"&&y.length===1;let d=P(k);d&&(d=`(${d.trim()})`);let v=[];if(typeof y[0]=="string"?d&&$?v=[`%c[${g}] %c${y[0]} %c${d}`,h("blue"),h(""),h("grey")]:v=[`%c[${g}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:v=[`%c[${g}]%`,h("blue"),...y],d&&!$&&v.push(d),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,v)}function h(u){return`color: ${u}`}}),define(re[77],ae([0,1,17,7]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=S,e.$Yh=R,e.$Zh=E;function S(h){return JSON.stringify(h,P)}function R(h){let u=JSON.parse(h);return u=E(u),u}function P(h,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function E(h,u=0){if(!h||u>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof i.$Ce||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let g=0;g<h.length;++g)h[g]=E(h[g],u+1);else for(const g in h)Object.hasOwnProperty.call(h,g)&&(h[g]=E(h[g],u+1))}return h}}),define(re[13],ae([0,1,15,4,25,7,9]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=h,e.$Ag=u,e.$Eg=y;var E;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(d,v){return R.URI.isUri(d)?(0,S.$tf)(d.scheme,v):(0,S.$uf)(d,v+":")}function u(d,...v){return v.some(p=>h(d,p))}e.$Bg="vscode-tkn",e.$Cg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,p){this.f=y(v,p)}getServerRootPath(){return this.f}get g(){return P.$hc.join(this.f,E.vscodeRemoteResource)}set(v,p,m){this.a[v]=p,this.b[v]=m}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return i.$1(a),v}const p=v.authority;let m=this.a[p];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this.b[p],l=this.c[p];let w=`path=${encodeURIComponent(v.path)}`;return typeof l=="string"&&(w+=`&${e.$Cg}=${encodeURIComponent(l)}`),R.URI.from({scheme:D.$o?this.d:E.vscodeRemoteResource,authority:`${m}:${f}`,path:this.g,query:w})}}e.$Dg=new g;function y(d,v){return P.$hc.join(v??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class k{static{this.a=e.$Jg}asBrowserUri(v){const p=this.b(v,Z);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$Dg.rewrite(v):v.scheme===E.file&&(D.$m||D.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,Z);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return R.URI.isUri(v)?v:R.URI.parse(p.toUrl(v))}}e.$Kg=new k;var $;(function(d){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function m(l){let w;typeof l=="string"?w=new URL(l).searchParams:l instanceof URL?w=l.searchParams:R.URI.isUri(l)&&(w=new URL(l.toString(!0)).searchParams);const a=w?.get(p);if(a)return v.get(a)}d.getHeadersFromQuery=m;function f(l,w,a){if(!globalThis.crossOriginIsolated)return;const t=w&&a?"3":a?"2":"1";l instanceof URLSearchParams?l.set(p,t):l[p]=t}d.addSearchParam=f})($||(e.COI=$={}))}),define(re[19],ae([0,1,32,13,9,4,25,7]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=h,e.$ah=g,e.$bh=k;function h($){return(0,E.$xc)($,!0)}class u{constructor(d){this.a=d}compare(d,v,p=!1){return d===v?0:(0,P.$mf)(this.getComparisonKey(d,p),this.getComparisonKey(v,p))}isEqual(d,v,p=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,p)===this.getComparisonKey(v,p)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,p=!1){if(d.scheme===v.scheme){if(d.scheme===D.Schemas.file)return i.$qg(h(d),h(v),this.a(d))&&d.query===v.query&&(p||d.fragment===v.fragment);if((0,e.$9g)(d.authority,v.authority))return i.$qg(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(p||d.fragment===v.fragment)}return!1}joinPath(d,...v){return E.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$1g)(d)||d.authority}basename(d){return S.$hc.basename(d.path)}extname(d){return S.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===D.Schemas.file?v=E.URI.file(S.$nc(h(d))).path:(v=S.$hc.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===D.Schemas.file?v=E.URI.file(S.$ic(h(d))).path:v=S.$hc.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$9g)(d.authority,v.authority))return;if(d.scheme===D.Schemas.file){const f=S.$mc(h(d),h(v));return R.$i?i.$kg(f):f}let p=d.path||"/";const m=v.path||"/";if(this.a(d)){let f=0;for(const l=Math.min(p.length,m.length);f<l&&!(p.charCodeAt(f)!==m.charCodeAt(f)&&p.charAt(f).toLowerCase()!==m.charAt(f).toLowerCase());f++);p=m.substr(0,f)+p.substr(f)}return S.$hc.relative(p,m)}resolvePath(d,v){if(d.scheme===D.Schemas.file){const p=E.URI.file(S.$lc(h(d),v));return d.with({authority:p.authority,path:p.path})}return v=i.$lg(v),d.with({path:S.$hc.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,P.$tf)(d,v)}hasTrailingPathSeparator(d,v=S.sep){if(d.scheme===D.Schemas.file){const p=h(d);return p.length>i.$mg(p).length&&p[p.length-1]===v}else{const p=d.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=S.sep){return(0,e.$0g)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=S.sep){let p=!1;if(d.scheme===D.Schemas.file){const m=h(d);p=m!==void 0&&m.length===i.$mg(m).length&&m[m.length-1]===v}else{v="/";const m=d.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.$0g)(d,v)?d.with({path:d.path+"/"}):d}}e.$Sg=u,e.$Tg=new u(()=>!1),e.$Ug=new u($=>$.scheme===D.Schemas.file?!R.$k:!0),e.$Vg=new u($=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function g($,d){const v=[];for(let p=0;p<$.length;p++){const m=d($[p]);$.some((f,l)=>l===p?!1:(0,e.$Xg)(m,d(f)))||v.push($[p])}return v}var y;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function d(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[w,a]=l.split(":");w&&a&&p.set(w,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&p.set($.META_DATA_MIME,f),p}$.parseMetaData=d})(y||(e.DataUri=y={}));function k($,d,v){if(d){let p=$.path;return p&&p[0]!==S.$hc.sep&&(p=S.$hc.sep+p),$.with({scheme:v,authority:d,path:p})}return $.with({scheme:v})}}),define(re[8],ae([0,1,23,15,3,2,19,4,144,62]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=g,e.$dh=y,e.$eh=k,e.$fh=$,e.$gh=d,e.$hh=v,e.$ih=p,e.$jh=m,e.$rh=c,e.$sh=b,e.$th=j,e.$uh=C,e.$vh=I,e.$Kh=W,e.$Sh=X;function g(x){return!!x&&typeof x.then=="function"}function y(x){const K=new i.$me,se=x(K.token),ue=new Promise((me,$e)=>{const ye=K.token.onCancellationRequested(()=>{ye.dispose(),$e(new D.$5)});Promise.resolve(se).then(ke=>{ye.dispose(),K.dispose(),me(ke)},ke=>{ye.dispose(),K.dispose(),$e(ke)})});return new class{cancel(){K.cancel(),K.dispose()}then(me,$e){return ue.then(me,$e)}catch(me){return this.then(void 0,me)}finally(me){return ue.finally(me)}}}function k(x,K,se){return new Promise((ue,me)=>{const $e=K.onCancellationRequested(()=>{$e.dispose(),ue(se)});x.then(ue,me).finally(()=>$e.dispose())})}function $(x,K){return new Promise((se,ue)=>{const me=K.onCancellationRequested(()=>{me.dispose(),ue(new D.$5)});x.then(se,ue).finally(()=>me.dispose())})}async function d(x){let K=-1;const se=x.map((ue,me)=>ue.then($e=>(K=me,$e)));try{return await Promise.race(se)}finally{x.forEach((ue,me)=>{me!==K&&ue.cancel()})}}function v(x,K,se){let ue;const me=setTimeout(()=>{ue?.(void 0),se?.()},K);return Promise.race([x.finally(()=>clearTimeout(me)),new Promise($e=>ue=$e)])}function p(x){return new Promise((K,se)=>{const ue=x();g(ue)?ue.then(K,se):K(ue)})}function m(){let x,K;return{promise:new Promise((ue,me)=>{x=ue,K=me}),resolve:x,reject:K}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=K(),new Promise((se,ue)=>{this.a.then(me=>{this.a=null,se(me)},me=>{this.a=null,ue(me)})})}dispose(){this.f=!0}}e.$kh=f;class l{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$lh=l;class w{constructor(){this.a=new Map}queue(K,se){const me=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(K)===me&&this.a.delete(K)});return this.a.set(K,me),me}}e.$mh=w;const a=(x,K)=>{let se=!0;const ue=setTimeout(()=>{se=!1,K()},x);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},t=x=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,x())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class o{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,se=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((me,$e)=>{this.d=me,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===h.$$d?t(ue):a(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=o;class s{constructor(K){this.a=new o(K),this.b=new f}trigger(K,se){return this.a.trigger(()=>this.b.queue(K),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=s;class n{constructor(){this.a=!1,this.b=new Promise((K,se)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=n;class r extends n{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$qh=r;function c(x,K){return K?new Promise((se,ue)=>{const me=setTimeout(()=>{$e.dispose(),se()},x),$e=K.onCancellationRequested(()=>{clearTimeout(me),$e.dispose(),ue(new D.$5)})}):y(se=>c(x,se))}function b(x,K=0,se){const ue=setTimeout(()=>{x(),se&&me.dispose()},K),me=(0,R.$Sc)(()=>{clearTimeout(ue),se?.deleteAndLeak(me)});return se?.add(me),me}function j(x){const K=[];let se=0;const ue=x.length;function me(){return se<ue?x[se++]():null}function $e(ye){ye!=null&&K.push(ye);const ke=me();return ke?ke.then($e):Promise.resolve(K)}return Promise.resolve(null).then($e)}function C(x,K=ue=>!!ue,se=null){let ue=0;const me=x.length,$e=()=>{if(ue>=me)return Promise.resolve(se);const ye=x[ue++];return Promise.resolve(ye()).then(Ee=>K(Ee)?Promise.resolve(Ee):$e())};return $e()}function I(x,K=ue=>!!ue,se=null){if(x.length===0)return Promise.resolve(se);let ue=x.length;const me=()=>{ue=-1;for(const $e of x)$e.cancel?.()};return new Promise(($e,ye)=>{for(const ke of x)ke.then(Ee=>{--ue>=0&&K(Ee)?(me(),$e(Ee)):ue===0&&$e(se)}).catch(Ee=>{--ue>=0&&(me(),ye(Ee))})})}class O{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new S.$be}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:K,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const se=K.factory();se.then(K.c,K.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=O;class M extends O{constructor(){super(1)}}e.$xh=M;class F{constructor(){this.a=new z,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$yh=F;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new oe;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,se=P.$Tg){const ue=se.getComparisonKey(K);return this.a.get(ue)?.size??0}queueFor(K,se,ue=P.$Tg){const me=ue.getComparisonKey(K);let $e=this.a.get(me);if(!$e){$e=new M;const ye=this.f++,ke=S.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ye,ke),this.a.set(me,$e)}return $e.queue(se)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=L;class T{constructor(K,se){this.a=-1,typeof K=="function"&&typeof se=="number"&&this.setIfNotSet(K,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},se)}setIfNotSet(K,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},se))}}e.$Ah=T;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,se,ue=globalThis){this.cancel();const me=ue.setInterval(()=>{K()},se);this.d=(0,R.$Sc)(()=>{ue.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=U;class le{constructor(K,se){this.b=-1,this.a=K,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=le;class ee{constructor(K,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=K,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=ee;class ce extends le{constructor(K,se){super(K,se),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Eh=ce;class Q extends R.$Uc{constructor(K,se){super(),this.g=K,this.h=se,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of K)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(x,K)=>{(0,E.$B)(()=>{if(se)return;const ue=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Hh=(x,K,se)=>{const ue=x.requestIdleCallback(K,typeof se=="number"?{timeout:se}:void 0);let me=!1;return{dispose(){me||(me=!0,x.cancelIdleCallback(ue))}}},e.$Gh=x=>(0,e.$Hh)(globalThis,x)}();class G{constructor(K,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Hh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=G;class q extends G{constructor(K){super(globalThis,K)}}e.$Jh=q;async function W(x,K,se){let ue;for(let me=0;me<se;me++)try{return await x()}catch($e){ue=$e,await c(K)}throw ue}class z{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,se,ue){return this.a={taskId:K,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(K),()=>this.d(K)),se}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:se,resolve:ue,reject:me}=m();this.b={run:K,promise:se,promiseResolve:ue,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=z;class V{constructor(K,se=()=>Date.now()){this.d=K,this.f=se,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Mh=V;var B;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(B||(B={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,se)=>{this.a=K,this.b=se})}complete(K){return new Promise(se=>{this.a(K),this.d={outcome:0,value:K},se()})}error(K){return new Promise(se=>{this.b(K),this.d={outcome:1,value:K},se()})}cancel(){return this.error(new D.$5)}}e.$Nh=oe;var he;(function(x){async function K(ue){let me;const $e=await Promise.all(ue.map(ye=>ye.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return $e}x.settled=K;function se(ue){return new Promise(async(me,$e)=>{try{await ue(me,$e)}catch(ye){$e(ye)}})}x.withAsyncBody=se})(he||(e.Promises=he={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new D.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=J;class A{constructor(K){this.b=K,this.a=new u.$V(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=A;var N;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(K){return new _(se=>{se.emitMany(K)})}static fromPromise(K){return new _(async se=>{se.emitMany(await K)})}static fromPromises(K){return new _(async se=>{await Promise.all(K.map(async ue=>se.emitOne(await ue)))})}static merge(K){return new _(async se=>{await Promise.all(K.map(async ue=>{for await(const me of ue)se.emitOne(me)}))})}static{this.EMPTY=_.fromArray([])}constructor(K,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new S.$be,queueMicrotask(async()=>{const ue={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(K(ue)),this.k()}catch(me){this.l(me)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,se){return new _(async ue=>{for await(const me of K)ue.emitOne(se(me))})}map(K){return _.map(this,K)}static filter(K,se){return new _(async ue=>{for await(const me of K)se(me)&&ue.emitOne(me)})}filter(K){return _.filter(this,K)}static coalesce(K){return _.filter(K,se=>!!se)}coalesce(){return _.coalesce(this)}static async toPromise(K){const se=[];for await(const ue of K)se.push(ue);return se}toPromise(){return _.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Qh=_;class ne extends _{constructor(K,se){super(se),this.m=K}cancel(){this.m.cancel()}}e.$Rh=ne;function X(x){const K=new i.$me,se=x(K.token);return new ne(K,async ue=>{const me=K.token.onCancellationRequested(()=>{me.dispose(),K.dispose(),ue.reject(new D.$5)});try{for await(const $e of se){if(K.token.isCancellationRequested)return;ue.emitOne($e)}me.dispose(),K.dispose()}catch($e){me.dispose(),K.dispose(),ue.reject($e)}})}class H{constructor(K){this.a=new oe,this.b=new _(me=>{if(se){me.reject(se);return}return ue&&me.emitMany(ue),this.d=$e=>me.reject($e),this.f=$e=>me.emitOne($e),this.a.p},K);let se,ue;this.f=me=>{ue||(ue=[]),ue.push(me)},this.d=me=>{se||(se=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Th=H}),define(re[108],ae([0,1,22,8,32,31,9,4,25]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=u,e.$ik=d,e.$jk=M,e.$kk=F,e.$lk=L,e.$mk=T,e.$nk=U,e.$ok=Q;function u(){return Object.create(null)}e.$gk="**",e.$hk="/";const g="[/\\\\]",y="[^/\\\\]",k=/\//g;function $(G,q){switch(G){case 0:return"";case 1:return`${y}*?`;default:return`(?:${g}|${y}+${g}${q?`|${g}${y}+`:""})*?`}}function d(G,q){if(!G)return[];const W=[];let z=!1,V=!1,B="";for(const oe of G){switch(oe){case q:if(!z&&!V){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":V=!0;break;case"]":V=!1;break}B+=oe}return B&&W.push(B),W}function v(G){if(!G)return"";let q="";const W=d(G,e.$hk);if(W.every(z=>z===e.$gk))q=".*";else{let z=!1;W.forEach((V,B)=>{if(V===e.$gk){if(z)return;q+=$(2,B===W.length-1)}else{let oe=!1,he="",J=!1,A="";for(const N of V){if(N!=="}"&&oe){he+=N;continue}if(J&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$hk?_="":_=(0,h.$8e)(N),A+=_;continue}switch(N){case"{":oe=!0;continue;case"[":J=!0;continue;case"}":{const ne=`(?:${d(he,",").map(X=>v(X)).join("|")})`;q+=ne,oe=!1,he="";break}case"]":{q+="["+A+"]",J=!1,A="";break}case"?":q+=y;continue;case"*":q+=$(1);continue;default:q+=(0,h.$8e)(N)}}B<W.length-1&&(W[B+1]!==e.$gk||B+2<W.length)&&(q+=g)}z=V===e.$gk})}return q}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),o=function(){return!1},s=function(){return null};function n(G,q){if(!G)return s;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const z=`${W}_${!!q.trimForExclusions}`;let V=t.get(z);if(V)return r(V,G);let B;return p.test(W)?V=b(W.substr(4),W):(B=m.exec(c(W,q)))?V=j(B[1],W):(q.trimForExclusions?l:f).test(W)?V=C(W,q):(B=w.exec(c(W,q)))?V=I(B[1].substr(1),W,!0):(B=a.exec(c(W,q)))?V=I(B[1],W,!1):V=O(W),t.set(z,V),r(V,G)}function r(G,q){if(typeof q=="string")return G;const W=function(z,V){return(0,S.$qg)(z,q.base,!E.$k)?G((0,h.$af)(z.substr(q.base.length),P.sep),V):null};return W.allBasenames=G.allBasenames,W.allPaths=G.allPaths,W.basenames=G.basenames,W.patterns=G.patterns,W}function c(G,q){return q.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function b(G,q){return function(W,z){return typeof W=="string"&&W.endsWith(G)?q:null}}function j(G,q){const W=`/${G}`,z=`\\${G}`,V=function(oe,he){return typeof oe!="string"?null:he?he===G?q:null:oe===G||oe.endsWith(W)||oe.endsWith(z)?q:null},B=[G];return V.basenames=B,V.patterns=[q],V.allBasenames=B,V}function C(G,q){const W=ce(G.slice(1,-1).split(",").map(he=>n(he,q)).filter(he=>he!==s),G),z=W.length;if(!z)return s;if(z===1)return W[0];const V=function(he,J){for(let A=0,N=W.length;A<N;A++)if(W[A](he,J))return G;return null},B=W.find(he=>!!he.allBasenames);B&&(V.allBasenames=B.allBasenames);const oe=W.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return oe.length&&(V.allPaths=oe),V}function I(G,q,W){const z=P.sep===P.$hc.sep,V=z?G:G.replace(k,P.sep),B=P.sep+V,oe=P.$hc.sep+G;let he;return W?he=function(J,A){return typeof J=="string"&&(J===V||J.endsWith(B)||!z&&(J===G||J.endsWith(oe)))?q:null}:he=function(J,A){return typeof J=="string"&&(J===V||!z&&J===G)?q:null},he.allPaths=[(W?"*/":"./")+G],he}function O(G){try{const q=new RegExp(`^${v(G)}$`);return function(W){return q.lastIndex=0,typeof W=="string"&&q.test(W)?G:null}}catch{return s}}function M(G,q,W){return!G||typeof q!="string"?!1:F(G)(q,void 0,W)}function F(G,q={}){if(!G)return o;if(typeof G=="string"||L(G)){const W=n(G,q);if(W===s)return o;const z=function(V,B){return!!W(V,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return le(G,q)}function L(G){const q=G;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(G){return G.allBasenames||[]}function U(G){return G.allPaths||[]}function le(G,q){const W=ce(Object.getOwnPropertyNames(G).map(he=>ee(he,G[he],q)).filter(he=>he!==s)),z=W.length;if(!z)return s;if(!W.some(he=>!!he.requiresSiblings)){if(z===1)return W[0];const he=function(N,_){let ne;for(let X=0,H=W.length;X<H;X++){const x=W[X](N,_);if(typeof x=="string")return x;(0,D.$ch)(x)&&(ne||(ne=[]),ne.push(x))}return ne?(async()=>{for(const X of ne){const H=await X;if(typeof H=="string")return H}return null})():null},J=W.find(N=>!!N.allBasenames);J&&(he.allBasenames=J.allBasenames);const A=W.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(he.allPaths=A),he}const V=function(he,J,A){let N,_;for(let ne=0,X=W.length;ne<X;ne++){const H=W[ne];H.requiresSiblings&&A&&(J||(J=(0,P.$oc)(he)),N||(N=J.substr(0,J.length-(0,P.$pc)(he).length)));const x=H(he,J,N,A);if(typeof x=="string")return x;(0,D.$ch)(x)&&(_||(_=[]),_.push(x))}return _?(async()=>{for(const ne of _){const X=await ne;if(typeof X=="string")return X}return null})():null},B=W.find(he=>!!he.allBasenames);B&&(V.allBasenames=B.allBasenames);const oe=W.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return oe.length&&(V.allPaths=oe),V}function ee(G,q,W){if(q===!1)return s;const z=n(G,W);if(z===s)return s;if(typeof q=="boolean")return z;if(q){const V=q.when;if(typeof V=="string"){const B=(oe,he,J,A)=>{if(!A||!z(oe,he))return null;const N=V.replace("$(basename)",()=>J),_=A(N);return(0,D.$ch)(_)?_.then(ne=>ne?G:null):_?G:null};return B.requiresSiblings=!0,B}}return z}function ce(G,q){const W=G.filter(he=>!!he.basenames);if(W.length<2)return G;const z=W.reduce((he,J)=>{const A=J.basenames;return A?he.concat(A):he},[]);let V;if(q){V=[];for(let he=0,J=z.length;he<J;he++)V.push(q)}else V=W.reduce((he,J)=>{const A=J.patterns;return A?he.concat(A):he},[]);const B=function(he,J){if(typeof he!="string")return null;if(!J){let N;for(N=he.length;N>0;N--){const _=he.charCodeAt(N-1);if(_===47||_===92)break}J=he.substr(N)}const A=z.indexOf(J);return A!==-1?V[A]:null};B.basenames=z,B.patterns=V,B.allBasenames=z;const oe=G.filter(he=>!he.basenames);return oe.push(B),oe}function Q(G,q){return(0,i.$ub)(G,q,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}}),define(re[48],ae([0,1,22,32,9,4,19,25]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=h,e.$ow=g,e.$pw=k,e.$qw=$,e.$rw=m,e.$sw=l,e.$tw=w,e.$uw=a,e.$vw=t,e.$ww=o;function h(n,r){const{os:c,tildify:b,relative:j}=r;if(j){const O=u(n,j,c);if(typeof O=="string")return O}let C=n.fsPath;if(c===1&&!R.$i?C=C.replace(/\//g,"\\"):c!==1&&R.$i&&(C=C.replace(/\\/g,"/")),c!==1&&b?.userHome){const O=b.userHome.fsPath;let M;n.scheme!==b.userHome.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep?M=b.userHome.with({path:n.path}).fsPath:M=C,C=k(M,O,c)}return(c===1?S.$gc:S.$hc).normalize(g(C,c===1))}function u(n,r,c){const b=c===1?S.$gc:S.$hc,j=c===3?P.$Tg:P.$Vg,C=r.getWorkspace(),I=(0,i.$Ob)(C.folders);if(!I)return;n.scheme!==I.uri.scheme&&n.path[0]===S.$hc.sep&&n.path[1]!==S.$hc.sep&&(n=I.uri.with({path:n.path}));const O=r.getWorkspaceFolder(n);if(!O)return;let M;if(j.isEqual(O.uri,n)?M="":M=j.relativePath(O.uri,n)??"",M&&(M=b.normalize(M)),C.folders.length>1&&!r.noPrefix){const F=O.name?O.name:j.basenameOrAuthority(O.uri);M=M?`${F} \u2022 ${M}`:F}return M}function g(n,r=R.$i){return(0,D.$ug)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}let y=Object.create(null);function k(n,r,c=R.OS){if(c===1||!n||!r)return n;let b=y.original===r?y.normalized:void 0;b||(b=r,R.$i&&(b=(0,D.$kg)(b)),b=`${(0,E.$bf)(b,S.$hc.sep)}${S.$hc.sep}`,y={original:r,normalized:b});let j=n;return R.$i&&(j=(0,D.$kg)(j)),(c===3?j.startsWith(b):(0,E.$uf)(j,b))?`~/${j.substr(b.length)}`:n}function $(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}const d="\u2026",v="\\\\",p="~";function m(n,r=S.sep){const c=new Array(n.length);let b=!1;for(let j=0;j<n.length;j++){const C=n[j];if(C===""){c[j]=`.${r}`;continue}if(!C){c[j]=C;continue}b=!0;let I="",O=C;O.indexOf(v)===0?(I=O.substr(0,O.indexOf(v)+v.length),O=O.substr(O.indexOf(v)+v.length)):O.indexOf(r)===0?(I=O.substr(0,O.indexOf(r)+r.length),O=O.substr(O.indexOf(r)+r.length)):O.indexOf(p)===0&&(I=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const M=O.split(r);for(let F=1;b&&F<=M.length;F++)for(let L=M.length-F;b&&L>=0;L--){b=!1;let T=M.slice(L,L+F).join(r);for(let U=0;!b&&U<n.length;U++)if(U!==j&&n[U]&&n[U].indexOf(T)>-1){const le=L+F===M.length,ee=L>0&&n[U].indexOf(r)>-1?r+T:T,ce=n[U].endsWith(ee);b=!le||ce}if(!b){let U="";(M[0].endsWith(":")||I!=="")&&(L===1&&(L=0,F++,T=M[0]+r+T),L>0&&(U=M[0]+r),U=I+U),L>0&&(U=U+d+r),U=U+T,L+F<M.length&&(U=U+r+d),c[j]=U}}b&&(c[j]=C)}return c}var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(n,r=Object.create(null)){const c=[];let b=!1,j="";for(const C of n)if(C==="$"||b&&C==="{")j&&c.push({value:j,type:f.TEXT}),j="",b=!0;else if(C==="}"&&b){const I=r[j];if(typeof I=="string")I.length&&c.push({value:I,type:f.VARIABLE});else if(I){const O=c[c.length-1];(!O||O.type!==f.SEPARATOR)&&c.push({value:I.label,type:f.SEPARATOR})}j="",b=!1}else j+=C;return j&&!b&&c.push({value:j,type:f.TEXT}),c.filter((C,I)=>{if(C.type===f.SEPARATOR){const O=c[I-1],M=c[I+1];return[O,M].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(C=>C.value).join("")}function w(n,r){return R.$j||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):n.replace(/&&|&/g,c=>c==="&"?"&&":"&")}function a(n,r){return R.$j||r?n.replace(/\(&&\w\)|&&/g,""):R.$i?n.replace(/&&|&/g,c=>c==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function o(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const c=s(n.substring(0,r)),b=n.substring(r);return{name:c.name+b,parentPath:c.parentPath}}}return s(n)}function s(n){const r=n.indexOf("/")!==-1?S.$hc:S.$gc,c=r.basename(n),b=r.dirname(n);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}}),define(re[157],ae([0,1,17,7]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=E,e.$vn=u,e.$wn=g;function S(y){return y.toJSON()}class R{constructor(k){this.a=k}transformIncoming(k){const $=this.a.transformIncoming(k);return $===k?k:S(D.URI.from($))}transformOutgoing(k){const $=this.a.transformOutgoing(k);return $===k?k:S(D.URI.from($))}transformOutgoingURI(k){const $=this.a.transformOutgoing(k);return $===k?k:D.URI.from($)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$sn=R,e.$tn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function P(y,k,$){if(!y||$>200)return null;if(typeof y=="object"){if(y instanceof D.URI)return k.transformOutgoing(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const v=P(y[d],k,$+1);v!==null&&(y[d]=v)}}return null}function E(y,k){const $=P(y,k,0);return $===null?y:$}function h(y,k,$,d){if(!y||d>200)return null;if(typeof y=="object"){if(y.$mid===1)return $?D.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof i.$Ce)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const p=h(y[v],k,$,d+1);p!==null&&(y[v]=p)}}return null}function u(y,k){const $=h(y,k,!1,0);return $===null?y:$}function g(y,k){const $=h(y,k,!0,0);return $===null?y:$}}),define(re[89],ae([0,1,26,59,33,147,4]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0,e.$zn=h,e.$An=y,e.$yn=new class{c(k){return this.a||(this.a=D.$wi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,$=0;const d=(0,i.networkInterfaces)();for(const v in d){const p=d[v];if(p)for(const{mac:m,internal:f}of p)f||($+=1,this.c(m.toUpperCase())&&(k+=1))}this.b=$>0?k/$:0}return this.b}};let E;async function h(k){return E||(E=(async()=>await u(k)||S.$Mg())()),E}async function u(k){try{const $=await new Promise((v,p)=>{Z(["crypto"],v,p)}),d=(0,R.$xn)();return $.createHash("sha256").update(d,"utf8").digest("hex")}catch($){k($);return}}const g="Software\\Microsoft\\SQMClient";async function y(k){if(P.$i){const $=await new Promise((d,v)=>{Z(["@vscode/windows-registry"],d,v)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return k(d),""}}return""}}),define(re[21],ae([0,1,43,26,158,8,32,72,9,4,19,7]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=l,e.whenDeleted=t,e.configureFlushOnWrite=c,e.writeFileSync=j;var k;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function $(ee,ce=k.UNLINK,Q){if((0,P.$tg)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ce===k.UNLINK?v(ee):d(ee,Q)}async function d(ee,ce=(0,P.$yg)((0,D.tmpdir)())){try{try{await i.promises.rename(ee,ce)}catch(Q){return Q.code==="ENOENT"?void 0:v(ee)}v(ce).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function v(ee){return(0,S.promisify)(i.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function p(ee){if((0,P.$tg)(ee))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}async function m(ee,ce){return w(await(ce?f(ee):(0,S.promisify)(i.readdir)(ee)))}async function f(ee){try{return await(0,S.promisify)(i.readdir)(ee,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ce=[],Q=await m(ee);for(const G of Q){let q=!1,W=!1,z=!1;try{const V=await e.Promises.lstat((0,h.$kc)(ee,G));q=V.isFile(),W=V.isDirectory(),z=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ce.push({name:G,isFile:()=>q,isDirectory:()=>W,isSymbolicLink:()=>z})}return ce}function l(ee){return w(i.readdirSync(ee))}function w(ee){return ee.map(ce=>typeof ce=="string"?u.$j?(0,E.$8l)(ce):ce:(ce.name=u.$j?(0,E.$8l)(ce.name):ce.name,ce))}async function a(ee){const ce=await m(ee),Q=[];for(const G of ce)await o.existsDirectory((0,h.$kc)(ee,G))&&Q.push(G);return Q}function t(ee,ce=1e3){return new Promise(Q=>{let G=!1;const q=setInterval(()=>{G||(G=!0,i.access(ee,W=>{G=!1,W&&(clearInterval(q),Q(void 0))}))},ce)})}var o;(function(ee){async function ce(q){let W;try{if(W=await e.Promises.lstat(q),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(u.$i&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw V}throw z}}ee.stat=ce;async function Q(q){try{const{stat:W,symbolicLink:z}=await ee.stat(q);return W.isFile()&&z?.dangling!==!0}catch{}return!1}ee.existsFile=Q;async function G(q){try{const{stat:W,symbolicLink:z}=await ee.stat(q);return W.isDirectory()&&z?.dangling!==!0}catch{}return!1}ee.existsDirectory=G})(o||(e.SymlinkSupport=o={}));const s=new R.$zh;function n(ee,ce,Q){return s.queueFor(y.URI.file(ee),()=>{const G=C(Q);return new Promise((q,W)=>b(ee,ce,G,z=>z?W(z):q()))},g.$Ug)}let r=!0;function c(ee){r=ee}function b(ee,ce,Q,G){if(!r)return i.writeFile(ee,ce,{mode:Q.mode,flag:Q.flag},G);i.open(ee,Q.flag,Q.mode,(q,W)=>{if(q)return G(q);i.writeFile(W,ce,z=>{if(z)return i.close(W,()=>G(z));i.fdatasync(W,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),c(!1)),i.close(W,B=>G(B))))})})}function j(ee,ce,Q){const G=C(Q);if(!r)return i.writeFileSync(ee,ce,{mode:G.mode,flag:G.flag});const q=i.openSync(ee,G.flag,G.mode);try{i.writeFileSync(q,ce);try{i.fdatasyncSync(q)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{i.closeSync(q)}}function C(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function I(ee,ce,Q=6e4){if(ee!==ce)try{u.$i&&typeof Q=="number"?await O(ee,ce,Date.now(),Q):await(0,S.promisify)(i.rename)(ee,ce)}catch(G){if(ee.toLowerCase()!==ce.toLowerCase()&&G.code==="EXDEV"||ee.endsWith("."))await M(ee,ce,{preserveSymlinks:!1}),await $(ee,k.MOVE);else throw G}}async function O(ee,ce,Q,G,q=0){try{return await(0,S.promisify)(i.rename)(ee,ce)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-Q>=G)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${W}`),W;if(q===0){let z=!1;try{const{stat:V}=await o.stat(ce);V.isFile()||(z=!0)}catch{}if(z)throw W}return await(0,R.$rh)(Math.min(100,q*10)),O(ee,ce,Q,G,q+1)}}async function M(ee,ce,Q){return L(ee,ce,{root:{source:ee,target:ce},options:Q,handledSourcePaths:new Set})}const F=511;async function L(ee,ce,Q){if(Q.handledSourcePaths.has(ee))return;Q.handledSourcePaths.add(ee);const{stat:G,symbolicLink:q}=await o.stat(ee);if(q){if(Q.options.preserveSymlinks)try{return await le(ee,ce,Q)}catch{}if(q.dangling)return}return G.isDirectory()?T(ee,ce,G.mode&F,Q):U(ee,ce,G.mode&F)}async function T(ee,ce,Q,G){await e.Promises.mkdir(ce,{recursive:!0,mode:Q});const q=await m(ee);for(const W of q)await L((0,h.$kc)(ee,W),(0,h.$kc)(ce,W),G)}async function U(ee,ce,Q){await e.Promises.copyFile(ee,ce),await e.Promises.chmod(ce,Q)}async function le(ee,ce,Q){let G=await e.Promises.readlink(ee);(0,P.$qg)(G,Q.root.source,!u.$k)&&(G=(0,h.$kc)(Q.root.target,G.substr(Q.root.source.length+1))),await e.Promises.symlink(G,ce)}e.Promises=new class{get access(){return(0,S.promisify)(i.access)}get stat(){return(0,S.promisify)(i.stat)}get lstat(){return(0,S.promisify)(i.lstat)}get utimes(){return(0,S.promisify)(i.utimes)}get read(){return(ee,ce,Q,G,q)=>new Promise((W,z)=>{i.read(ee,ce,Q,G,q,(V,B,oe)=>V?z(V):W({bytesRead:B,buffer:oe}))})}get readFile(){return(0,S.promisify)(i.readFile)}get write(){return(ee,ce,Q,G,q)=>new Promise((W,z)=>{i.write(ee,ce,Q,G,q,(V,B,oe)=>V?z(V):W({bytesWritten:B,buffer:oe}))})}get appendFile(){return(0,S.promisify)(i.appendFile)}get fdatasync(){return(0,S.promisify)(i.fdatasync)}get truncate(){return(0,S.promisify)(i.truncate)}get copyFile(){return(0,S.promisify)(i.copyFile)}get open(){return(0,S.promisify)(i.open)}get close(){return(0,S.promisify)(i.close)}get symlink(){return(0,S.promisify)(i.symlink)}get readlink(){return(0,S.promisify)(i.readlink)}get chmod(){return(0,S.promisify)(i.chmod)}get mkdir(){return(0,S.promisify)(i.mkdir)}get unlink(){return(0,S.promisify)(i.unlink)}get rmdir(){return(0,S.promisify)(i.rmdir)}get realpath(){return(0,S.promisify)(i.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return $}get rename(){return I}get copy(){return M}}}),define(re[109],ae([0,1,43,9,4,25,21]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=E,e.$Wq=h,e.$Xq=u,e.$Yq=g;function E(k){if(S.$k)return k;const $=(0,D.$nc)(k);if(k===$)return k;const d=((0,D.$oc)(k)||k).toLowerCase();try{const p=(0,P.readdirSync)($).filter(m=>m.toLowerCase()===d);if(p.length===1){const m=E($);if(m)return(0,D.$kc)(m,p[0])}else if(p.length>1){const m=p.indexOf(d);if(m>=0){const f=E($);if(f)return(0,D.$kc)(f,p[m])}}}catch{}return null}async function h(k,$){if(S.$k)return k;const d=(0,D.$nc)(k);if(k===d)return k;const v=((0,D.$oc)(k)||k).toLowerCase();try{if($?.isCancellationRequested)return null;const m=(await P.Promises.readdir(d)).filter(f=>f.toLowerCase()===v);if(m.length===1){const f=await h(d,$);if(f)return(0,D.$kc)(f,m[0])}else if(m.length>1){const f=m.indexOf(v);if(f>=0){const l=await h(d,$);if(l)return(0,D.$kc)(l,m[f])}}}catch{}return null}async function u(k){try{return await P.Promises.realpath(k)}catch{const d=y(k);return await P.Promises.access(d,i.constants.R_OK),d}}function g(k){try{return i.realpathSync(k)}catch{const d=y(k);return i.accessSync(d,i.constants.R_OK),d}}function y(k){return(0,R.$bf)((0,D.$ic)(k),D.sep)}}),define(re[110],ae([0,1,26,9,21]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=f,e.$fm=l;const R=/^\d+$/,P=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:w=!1}={}){return w?u===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:w=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:w});if(!t)return null;const o=D.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let s=-1,n=null;for(const b of await S.Promises.readdir(o)){let j=-1;if(a){const I=b.indexOf("-");if(I<0)continue;const O=b.substring(0,I);if(!R.test(O)||b.substring(I+1)!=="preview")continue;j=parseInt(O,10)}else{if(!R.test(b))continue;j=parseInt(b,10)}if(j<=s)continue;const C=D.$kc(o,b,"pwsh.exe");await S.SymlinkSupport.existsFile(C)&&(n=C,s=j)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new y(n,`PowerShell${c}${r}`,!0)}async function d({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=w?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await S.Promises.readdir(a))if(t.test(s)){const n=D.$kc(a,s,"pwsh.exe");return new y(n,o)}return null}function v(){const w=D.$kc(i.homedir(),".dotnet","tools","pwsh.exe");return new y(w,".NET Core PowerShell Global Tool")}function p(){const w=D.$kc(process.env.windir,u===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(w,"Windows PowerShell",!0)}async function*m(){let w=await $();w&&(yield w),w=await $({useAlternateBitness:!0}),w&&(yield w),w=await d(),w&&(yield w),w=v(),w&&(yield w),w=await $({findPreview:!0}),w&&(yield w),w=await d({findPreview:!0}),w&&(yield w),w=await $({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=p(),w&&(yield w)}async function*f(){for await(const w of m())await w.exists()&&(yield w)}async function l(){for await(const w of f())return w;return null}}),define(re[90],ae([0,1,9,4,36,76,12,21]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=h,e.$jm=u,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(y=S.env){return y.comspec||"cmd.exe"}function u(y){let k=[],$=!1;const d=function(v){if($){k.push(v);return}(!y.send(v,m=>{if(m&&console.error(m),$=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(l=>d(l))}})||D.$i)&&($=!0)};return{send:d}}var g;(function(y){async function k($,d,v){if(i.$jc($))return $;if(d===void 0&&(d=S.cwd()),i.$nc($)!=="."||(v===void 0&&P.$4f(S.env.PATH)&&(v=S.env.PATH.split(i.$uc)),v===void 0||v.length===0))return i.$kc(d,$);async function m(f){if(await E.Promises.exists(f)){let l;try{l=await E.Promises.stat(f)}catch(w){w.message.startsWith("EACCES")&&(l=await E.Promises.lstat(f))}return l?!l.isDirectory():!1}return!1}for(const f of v){let l;if(i.$jc(f)?l=i.$kc(f,$):l=i.$kc(d,f,$),await m(l))return l;let w=l+".com";if(await m(w)||(w=l+".exe",await m(w)))return w}return i.$kc(d,$)}y.findExecutable=k})(g||(e.win32=g={}))}),define(re[111],ae([0,1,49,13]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=S;function S(P){return new Promise((E,h)=>{let u;const g=new Map;function y($,d,v,p,m){const f=g.get(d);if($===P||f){const l={name:k(v),cmd:v,pid:$,ppid:d,load:p,mem:m};g.set($,l),$===P&&(u=l),f&&(f.children||(f.children=[]),f.children.push(l),f.children.length>1&&(f.children=f.children.sort((w,a)=>w.pid-a.pid)))}}function k($){const d=/--utility-sub-type=network/i,v=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,m=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec($))return"electron-crash-reporter";if(p.exec($))return"winpty-agent";if(m.exec($))return"conpty-agent";let l=f.exec($);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?d.exec($)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const w=/[a-zA-Z-]+\.js/g;let a="";do l=w.exec($),l&&(a+=l+" ");while(l);return a&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${a})`:$}if(process.platform==="win32"){const $=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,v)=>{Z(["@vscode/windows-process-tree"],d,v)}).then(d=>{d.getProcessList(P,v=>{if(!v){h(new Error(`Root process ${P} not found`));return}d.getProcessCpuUsage(v,p=>{const m=new Map;p.forEach(f=>{const l=$(f.commandLine||"");m.set(f.pid,{name:k(l),cmd:l,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),u=m.get(P),u?(m.forEach(f=>{const l=m.get(f.ppid);l&&(l.children||(l.children=[]),l.children.push(f))}),m.forEach(f=>{f.children&&(f.children=f.children.sort((l,w)=>l.pid-w.pid))}),E(u)):h(new Error(`Root process ${P} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let $=function(){let d=[u];const v=[];for(;d.length;){const m=d.shift();m&&(v.push(m.pid),m.children&&(d=d.concat(m.children)))}let p=JSON.stringify(D.$Kg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+v.join(" "),(0,i.exec)(p,{},(m,f,l)=>{if(m||l)h(m||new Error(l.toString()));else{const w=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=g.get(v[a]);t.load=parseFloat(w[a])}if(!u){h(new Error(`Root process ${P} not found`));return}E(u)}})};(0,i.exec)("which ps",{},(d,v,p)=>{if(d||p)if(process.platform!=="linux")h(d||new Error(p.toString()));else{const m=JSON.stringify(D.$Kg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(m,{},(f,l,w)=>{f||w?h(f||new Error(w.toString())):(R(l,y),$())})}else{const m=v.toString().trim();(0,i.exec)(`${m} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,w,a)=>{l||a&&!a.includes("screen size is bogus")?h(l||new Error(a.toString())):(R(w,y),process.platform==="linux"?$():u?E(u):h(new Error(`Root process ${P} not found`)))})}})}})}function R(P,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=P.toString().split(`
`);for(const g of u){const y=h.exec(g.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(re[112],ae([0,1,26,4,110,90]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=P;async function P(y,k){return y===1?D.$i?g():R.$im(k):h(y,k)}let E=null;function h(y,k){if(D.$k&&y===2||D.$j&&y===3)return"/bin/bash";if(!E){let $;if(D.$i)$="/bin/bash";else{if($=k.SHELL,!$)try{$=(0,i.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}E=$}return E}let u=null;async function g(){return u||(u=(await(0,S.$fm)()).exePath),u}});var Se=this&&this.__decorate||function(Z,e,i,D){var S=arguments.length,R=S<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,i):D,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(Z,e,i,D);else for(var E=Z.length-1;E>=0;E--)(P=Z[E])&&(R=(S<3?P(R):S>3?P(e,i,R):P(e,i))||R);return S>3&&R&&Object.defineProperty(e,i,R),R};define(re[44],ae([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=c,e.$4h=b,e.$9h=F,e.$0h=L;var $;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})($||($={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(v||(v={}));function p(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));function f(q){let W=0;for(let z=0;;z+=7){const V=q.read(1);if(W|=(V.buffer[0]&127)<<z,!(V.buffer[0]&128))return W}}const l=s(0);function w(q,W){if(W===0){q.write(l);return}let z=0;for(let B=W;B!==0;B=B>>>7)z++;const V=S.$Ce.alloc(z);for(let B=0;W!==0;B++)V.buffer[B]=W&127,W=W>>>7,W>0&&(V.buffer[B]|=128);q.write(V)}class a{constructor(W){this.b=W,this.a=0}read(W){const z=this.b.slice(this.a,this.a+W);return this.a+=z.byteLength,z}}e.$1h=a;class t{constructor(){this.a=[]}get buffer(){return S.$Ce.concat(this.a)}write(W){this.a.push(W)}}e.$2h=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function s(q){const W=S.$Ce.alloc(1);return W.writeUInt8(q,0),W}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function c(q,W){if(typeof W>"u")q.write(n.Undefined);else if(typeof W=="string"){const z=S.$Ce.fromString(W);q.write(n.String),w(q,z.byteLength),q.write(z)}else if(r&&Buffer.isBuffer(W)){const z=S.$Ce.wrap(W);q.write(n.Buffer),w(q,z.byteLength),q.write(z)}else if(W instanceof S.$Ce)q.write(n.VSBuffer),w(q,W.byteLength),q.write(W);else if(Array.isArray(W)){q.write(n.Array),w(q,W.length);for(const z of W)c(q,z)}else if(typeof W=="number"&&(W|0)===W)q.write(n.Uint),w(q,W);else{const z=S.$Ce.fromString(JSON.stringify(W));q.write(n.Object),w(q,z.byteLength),q.write(z)}}function b(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(f(q)).toString();case o.Buffer:return q.read(f(q)).buffer;case o.VSBuffer:return q.read(f(q));case o.Array:{const z=f(q),V=[];for(let B=0;B<z;B++)V.push(b(q));return V}case o.Object:return JSON.parse(q.read(f(q)).toString());case o.Int:return f(q)}}class j{constructor(W,z,V=null,B=1e3){this.h=W,this.j=z,this.k=V,this.l=B,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(W,z){this.b.set(W,z),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const z=this.o([W.type]);this.k?.logOutgoing(z,0,1,p(W.type));return}case 201:case 202:case 204:case 203:{const z=this.o([W.type,W.id],W.data);this.k?.logOutgoing(z,W.id,1,p(W.type),W.data);return}}}o(W,z=void 0){const V=new t;return c(V,W),c(V,z),this.p(V.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const z=new a(W),V=b(z),B=b(z),oe=V[0];switch(oe){case 100:return this.k?.logIncoming(W.byteLength,V[1],1,`${d(oe)}: ${V[2]}.${V[3]}`,B),this.s({type:oe,id:V[1],channelName:V[2],name:V[3],arg:B});case 102:return this.k?.logIncoming(W.byteLength,V[1],1,`${d(oe)}: ${V[2]}.${V[3]}`,B),this.t({type:oe,id:V[1],channelName:V[2],name:V[3],arg:B});case 101:return this.k?.logIncoming(W.byteLength,V[1],1,`${d(oe)}`),this.u({type:oe,id:V[1]});case 103:return this.k?.logIncoming(W.byteLength,V[1],1,`${d(oe)}`),this.u({type:oe,id:V[1]})}}s(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const V=new R.$me;let B;try{B=z.call(this.j,W.name,W.arg,V.token)}catch(J){B=Promise.reject(J)}const oe=W.id;B.then(J=>{this.m({id:oe,data:J,type:201})},J=>{J instanceof Error?this.m({id:oe,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:oe,data:J,type:203})}).finally(()=>{he.dispose(),this.d.delete(W.id)});const he=(0,u.$Sc)(()=>V.cancel());this.d.set(W.id,he)}t(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const V=W.id,oe=z.listen(this.j,W.name,W.arg)(he=>this.m({id:V,data:he,type:204}));this.d.set(W.id,oe)}u(W){const z=this.d.get(W.id);z&&(z.dispose(),this.d.delete(W.id))}v(W){let z=this.g.get(W.channelName);z||(z=[],this.g.set(W.channelName,z));const V=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:W,timeoutTimer:V})}w(W){const z=this.g.get(W);if(z){for(const V of z)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Pc)(this.d.values()),this.d.clear()}}e.$5h=j;var C;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class I{constructor(W,z=null){this.l=W,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=z}getChannel(W){const z=this;return{call(V,B,oe){return z.a?Promise.reject(new E.$5):z.m(W,V,B,oe)},listen(V,B){return z.a?h.Event.None:z.o(W,V,B)}}}m(W,z,V,B=R.CancellationToken.None){const oe=this.g++,J={id:oe,type:100,channelName:W,name:z,arg:V};if(B.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,ne)=>{if(B.isCancellationRequested)return ne(new E.$5);const X=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(oe),_(ue.data);break;case 202:{this.f.delete(oe);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,ne(me);break}case 203:this.f.delete(oe),ne(ue.data);break}};this.f.set(oe,se),this.p(J)};let H=null;this.b===m.Idle?X():(H=(0,D.$dh)(se=>this.u()),H.then(()=>{H=null,X()}));const x=()=>{H?(H.cancel(),H=null):this.p({id:oe,type:101}),ne(new E.$5)},K=B.onCancellationRequested(x);A=(0,u.$Rc)((0,u.$Sc)(x),K),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(W,z,V){const B=this.g++,he={id:B,type:102,channelName:W,name:z,arg:V};let J=null;const A=new h.$be({onWillAddFirstListener:()=>{J=(0,D.$dh)(_=>this.u()),J.then(()=>{J=null,this.d.add(A),this.p(he)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(A),this.p({id:B,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(B,N),A.event}p(W){switch(W.type){case 100:case 102:{const z=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(z,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.q([W.type,W.id]);this.j?.logOutgoing(z,W.id,0,d(W.type));return}}}q(W,z=void 0){const V=new t;return c(V,W),c(V,z),this.r(V.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const z=new a(W),V=b(z),B=b(z),oe=V[0];switch(oe){case 200:return this.j?.logIncoming(W.byteLength,0,0,p(oe)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,V[1],0,p(oe),B),this.t({type:V[0],id:V[1],data:B})}}t(W){if(W.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Pc)(this.d.values()),this.d.clear()}}e.$6h=I,Se([P.$Uh],I.prototype,"onDidInitializePromise",null);class O{get connections(){const W=[];return this.f.forEach(z=>W.push(z)),W}constructor(W,z,V){this.a=new Map,this.f=new Set,this.g=new h.$be,this.onDidAddConnection=this.g.event,this.h=new h.$be,this.onDidRemoveConnection=this.h.event,this.j=new u.$Tc,this.j.add(W(({protocol:B,onDidClientDisconnect:oe})=>{const he=h.Event.once(B.onMessage);this.j.add(he(J=>{const A=new a(J),N=b(A),_=new j(B,N,z,V),ne=new I(B,z);this.a.forEach((H,x)=>_.registerChannel(x,H));const X={channelServer:_,channelClient:ne,ctx:N};this.f.add(X),this.g.fire(X),this.j.add(oe(()=>{_.dispose(),ne.dispose(),this.f.delete(X),this.h.fire(X)}))}))}))}getChannel(W,z){const V=this;return{call(B,oe,he){let J;if((0,k.$fg)(z)){const N=(0,i.$4b)(V.connections.filter(z));J=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,z))}else J=z.routeCall(V,B,oe);const A=J.then(N=>N.channelClient.getChannel(W));return F(A).call(B,oe,he)},listen(B,oe){if((0,k.$fg)(z))return V.k(W,z,B,oe);const he=z.routeEvent(V,B,oe).then(J=>J.channelClient.getChannel(W));return F(he).listen(B,oe)}}}k(W,z,V,B){const oe=this;let he;const J=new h.$be({onWillAddFirstListener:()=>{he=new u.$Tc;const A=new h.$he,N=new Map,_=X=>{const x=X.channelClient.getChannel(W).listen(V,B),K=A.add(x);N.set(X,K)},ne=X=>{const H=N.get(X);H&&(H.dispose(),N.delete(X))};oe.connections.filter(z).forEach(_),h.Event.filter(oe.onDidAddConnection,z)(_,void 0,he),oe.onDidRemoveConnection(ne,void 0,he),A.event(J.fire,J,he),he.add(A)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return J.event}registerChannel(W,z){this.a.set(W,z);for(const V of this.f)V.channelServer.registerChannel(W,z)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=O;class M{constructor(W,z,V=null){const B=new t;c(B,z),W.send(B.buffer),this.a=new I(W,V),this.d=new j(W,z,V)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,z){this.d.registerChannel(W,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=M;function F(q){return{call(W,z,V){return q.then(B=>B.call(W,z,V))},listen(W,z){const V=new h.$ke;return q.then(B=>V.input=B.listen(W,z)),V.event}}}function L(q){let W=!1;return{call(z,V,B){return W?q.call(z,V,B):(0,D.$rh)(0).then(()=>W=!0).then(()=>q.call(z,V,B))},listen(z,V){if(W)return q.listen(z,V);const B=new h.$ke;return(0,D.$rh)(0).then(()=>W=!0).then(()=>B.input=q.listen(z,V)),B.event}}}class T{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const z of W.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await h.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$$h=T;var U;(function(q){function W(oe,he,J){const A=oe,N=J&&J.disableMarshalling,_=new Map;for(const ne in A)V(ne)&&_.set(ne,h.Event.buffer(A[ne],!0,void 0,he));return new class{listen(ne,X,H){const x=_.get(X);if(x)return x;const K=A[X];if(typeof K=="function"){if(B(X))return K.call(A,H);if(V(X))return _.set(X,h.Event.buffer(A[X],!0,void 0,he)),_.get(X)}throw new E.$bb(`Event not found: ${X}`)}call(ne,X,H){const x=A[X];if(typeof x=="function"){if(!N&&Array.isArray(H))for(let se=0;se<H.length;se++)H[se]=(0,g.$Zh)(H[se]);let K=x.apply(A,H);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new E.$bb(`Method not found: ${X}`)}}}q.fromService=W;function z(oe,he){const J=he&&he.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return he?.properties?.has(N)?he.properties.get(N):B(N)?function(_){return oe.listen(N,_)}:V(N)?oe.listen(N):async function(..._){let ne;he&&!(0,k.$ag)(he.context)?ne=[he.context,..._]:ne=_;const X=await oe.call(N,ne);return J?X:(0,g.$Zh)(X)};throw new E.$bb(`Property not found: ${String(N)}`)}})}q.toService=z;function V(oe){return oe[0]==="o"&&oe[1]==="n"&&y.$sf(oe.charCodeAt(2))}function B(oe){return/^onDynamic/.test(oe)&&y.$sf(oe.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const W=q.toString();if(W!=="[object Object]")return W}return q}function ce(q){return Array.isArray(q)?q.map(ee):ee(q)}function Q(q,W,z,V,B,oe,he){he=ce(he);const J=le[B],A=J[V%J.length];let N=[`%c[${q}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(oe)?(N=N.concat(he),N.push(")")):N.push(he),console.log.apply(console,N)}class G{constructor(W,z){this.d=W,this.f=z,this.a=0,this.b=0}logOutgoing(W,z,V,B,oe){this.b+=W,Q(this.d,this.b,W,z,V,B,oe)}logIncoming(W,z,V,B,oe){this.a+=W,Q(this.f,this.a,W,z,V,B,oe)}}e.$_h=G}),define(re[159],ae([0,1,17,3,44]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HW=e.$GW=void 0;class R{constructor(h){this.a=h,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",u=>u.data?i.$Ce.wrap(u.data):i.$Ce.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$GW=R;class P extends S.$8h{constructor(h,u){const g=new R(h);super(g,u),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$HW=P}),define(re[113],ae([0,1,17,3,2,44]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var E;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let c=0;function b(C,I){if(!r.has(C)){const O=String(++c);r.set(C,O)}return r.get(C)}function j(C,I,O,M){if(!n.enableDiagnostics)return;const F=b(C,I);if(M instanceof i.$Ce||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const L=i.$Ce.alloc(M.byteLength);L.set(M),n.records.push({timestamp:Date.now(),id:F,label:I,type:O,buff:L})}else n.records.push({timestamp:Date.now(),id:F,label:I,type:O,data:M})}n.traceSocketEvent=j})(E||(e.SocketDiagnostics=E={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let u=null;function g(){return u||(u=i.$Ce.alloc(0)),u}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return g();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const I=this.a[0];return c&&(this.a.shift(),this.b-=r),I}if(this.a[0].byteLength>r){const I=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),I}const b=i.$Ce.alloc(r);let j=0,C=0;for(;r>0;){const I=this.a[C];if(I.byteLength>r){const O=I.slice(0,r);b.set(O,j),j+=r,c&&(this.a[C]=I.slice(r),this.b-=r),r-=r}else b.set(I,j),j+=I.byteLength,c?(this.a.shift(),this.b-=I.byteLength):C++,r-=I.byteLength}return b}}e.$ai=y;var k;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(k||(k={}));function $(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class v{constructor(r,c,b,j){this.type=r,this.id=c,this.ack=b,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Uc{constructor(r){super(),this.f=this.B(new D.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new y,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,j=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new v(b,j,C,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=i.$Ce.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:$(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const b=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,b}h(){const r=i.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class f extends S.$Uc{constructor(r){super(),this.f=new D.$be,this.onMessage=this.f.event,this.g=new D.$be,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new m(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new v(1,0,0,r))}}e.$bi=f;class l extends R.$8h{static fromSocket(r,c){return new l(new f(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,b=null){super(r,c,b),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$ci=l;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$di=w;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,b=this.a;for(;b;)r[c++]=b.data,b=b.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new a(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<o.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+o.a)*1e3;let b=0;for(let j=0;j<o.a;j++)r-this.c[j]<=c&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??o.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=r.socket,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new v(5,0,0,g());this.p.write(r),this.p.flush()}sendPause(){const r=new v(7,0,0,g());this.p.write(r)}sendResume(){const r=new v(8,0,0,g());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new v(3,0,this.h,g());this.p.write(r);const c=this.b.toArray();for(let b=0,j=c.length;b<j;b++)this.p.write(c[b]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new v(6,0,0,g())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let b=0,j=c.length;b<j;b++)this.p.write(c[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const b=new v(1,c,this.h,r);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(r){const c=new v(2,0,0,r);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,b=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(c>=2e4&&b>=2e4&&j>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:b});return}const C=Math.max(2e4-c,2e4-b,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new v(3,0,this.h,g());this.p.write(r)}D(){this.h=this.g;const r=new v(9,0,this.h,g());this.p.write(r)}}e.$ei=s}),define(re[37],ae([0,1,14,15,13]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DW=void 0;class R{constructor(){this.a=new WeakMap}on(E,h){const u=(g,...y)=>{this.b(E,g)&&h(g,...y)};return this.a.set(h,u),i.ipcMain.on(E,u),this}once(E,h){return i.ipcMain.once(E,(u,...g)=>{this.b(E,u)&&h(u,...g)}),this}handle(E,h){return i.ipcMain.handle(E,(u,...g)=>this.b(E,u)?h(u,...g):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return i.ipcMain.removeHandler(E),this}removeListener(E,h){const u=this.a.get(h);return u&&(i.ipcMain.removeListener(E,u),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,D.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const u=h.senderFrame,g=u.url;if(!g||g==="about:blank")return!0;let y="unknown";try{y=new URL(g).host}catch{return(0,D.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${g}'.`),!1}return y!==S.$Jg?((0,D.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):u.parent!==null?((0,D.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$DW=new R}),define(re[160],ae([0,1,14,37,148]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EW=R;function R(){D.$DW.on(S.$BW,(E,h,u,g,y)=>{const k=P(E,g,u);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(S.$CW,h)}})})}function P(E,h,u){const g=new i.Menu;return u.forEach(y=>{let k;y.type==="separator"?k=new i.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new i.MenuItem({submenu:P(E,h,y.submenu),label:y.label}):k=new i.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:($,d,v)=>E.sender.send(h,y.id,v)}),g.append(k)}),g}}),define(re[161],ae([0,1,37,17,3,2,44,149]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KW=void 0;function h(g,y){const k=S.Event.fromNodeEventEmitter(i.$DW,y,(d,v)=>({event:d,message:v})),$=S.Event.filter(k,({event:d})=>d.sender.id===g);return S.Event.map($,({message:d})=>d&&D.$Ce.wrap(d))}class u extends P.$7h{static{this.b=new Map}static d(){const y=S.Event.fromNodeEventEmitter(i.$DW,"vscode:hello",({sender:k})=>k);return S.Event.map(y,k=>{const $=k.id;u.b.get($)?.dispose();const v=new S.$be;u.b.set($,(0,R.$Sc)(()=>v.fire()));const p=h($,"vscode:message"),m=S.Event.any(S.Event.signal(h($,"vscode:disconnect")),v.event);return{protocol:new E.$JW(k,p),onDidClientDisconnect:m}})}constructor(){super(u.d())}}e.$KW=u}),define(re[114],ae([0,1,37,3,33,159]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LW=void 0,e.$MW=E;class P extends R.$HW{constructor(u,g){super({addEventListener:(y,k)=>u.addListener(y,k),removeEventListener:(y,k)=>u.removeListener(y,k),postMessage:y=>u.postMessage(y),start:()=>u.start(),close:()=>u.close()},g)}}e.$LW=P;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,S.$Mg)();h.webContents.send("vscode:createMessageChannel",u);const g=D.Event.fromNodeEventEmitter(i.$DW,"vscode:createMessageChannelResult",(k,$)=>({nonce:$,port:k.ports[0]})),{port:y}=await D.Event.toPromise(D.Event.once(D.Event.filter(g,k=>k.nonce===u)));return y}}),define(re[162],ae([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class d extends $.$5h{constructor(m){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>S.$Ce.wrap(Buffer.from(f,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$Rq=d;class v{constructor(m,f){this.i=m,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.$be,this.onDidProcessExit=this.h.event;const l=f&&f.timeout?f.timeout:6e4;this.b=new D.$nh(l),this.d=null,this.f=null}getChannel(m){const f=this;return{call(l,w,a){return f.k(m,l,w,a)},listen(l,w){return f.l(m,l,w)}}}k(m,f,l,w=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n(m),t=(0,D.$dh)(n=>a.call(f,l,n)),o=w.onCancellationRequested(()=>t.cancel()),s=(0,u.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(m,f,l){if(!this.b)return h.Event.None;this.b.cancel();let w;const a=new h.$be({onWillAddFirstListener:()=>{w=this.n(m).listen(f,l)(a.fire,a),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,g.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,k.$hm)(f.env),this.d=(0,i.fork)(this.i,m,f);const l=new h.$be,a=h.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,P.$Nq)(c)){(0,P.log)(c,`IPC Library: ${this.j.serverName}`);return}l.fire(S.$Ce.wrap(Buffer.from(c,"base64")))}),t=this.j.useQueue?(0,y.$jm)(this.d):this.d,o=c=>this.d&&this.d.connected&&t.send(c.buffer.toString("base64")),s=l.event,n={send:o,onMessage:s};this.f=new $.$6h(n);const r=()=>this.o();process.once("exit",r),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,b)=>{process.removeListener("exit",r),a.dispose(),this.c.forEach(j=>(0,u.$Pc)(j)),this.c.clear(),c!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:b})})}return this.f}n(m){let f=this.g.get(m);return f||(f=this.m.getChannel(m),this.g.set(m,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=v}),define(re[115],ae([0,1,8,3,2,77,12]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=h;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(k){const $=k;return $?.changed instanceof Map||$?.deleted instanceof Set}var u;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(u||(e.StorageState=u={}));class g extends S.$Uc{static{this.a=100}constructor($,d=Object.create(null)){super(),this.r=$,this.s=d,this.b=this.B(new D.$ee),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new i.$oh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((d,v)=>this.w(v,d)),$.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w($,d){if(this.c===u.Closed)return;let v=!1;(0,P.$ag)(d)?v=this.f.delete($):this.f.get($)!==d&&(this.f.set($,d),v=!0),v&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,d){const v=this.f.get($);return(0,P.$ag)(v)?d:v}getBoolean($,d){const v=this.get($);return(0,P.$ag)(v)?d:v==="true"}getNumber($,d){const v=this.get($);return(0,P.$ag)(v)?d:parseInt(v,10)}getObject($,d){const v=this.get($);return(0,P.$ag)(v)?d:(0,R.$Yh)(v)}async set($,d,v=!1){if(this.c===u.Closed)return;if((0,P.$ag)(d))return this.delete($,v);const p=(0,P.$6f)(d)||Array.isArray(d)?(0,R.$Xh)(d):String(d);if(this.f.get($)!==p)return this.f.set($,p),this.j.set($,p),this.h.delete($),this.b.fire({key:$,external:v}),this.D()}async delete($,d=!1){if(!(this.c===u.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:d}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Qp=g;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((d,v)=>this.a.set(v,d)),$.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Rp=y}),define(re[163],ae([0,1,8,3,31,9,21]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9W=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,y=Object.create(null)){this.g=g,this.h=y,this.c=(0,R.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,y=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach($=>y.set($.key,$.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(g){const y=await this.f;return this.j(y,g)}j(g,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,S.$zc)(y.insert):"0"}), delete(${y.delete?(0,S.$Ac)(y.delete):"0"})`),this.t(g,()=>{const k=y.insert,$=y.delete;if(k&&k.size>0){const d=[];d.push([]);let v=0;k.forEach((p,m)=>{let f=d[v];f.length>E.b&&(v++,f=[],d.push(f)),f.push(m,p)}),d.forEach(p=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,m=>m.run(p),()=>{const m=[];let f=0;return k.forEach((l,w)=>{m.push(w),f+=l.length}),`Keys: ${m.join(", ")} Length: ${f}`})})}if($&&$.size){const d=[];d.push([]);let v=0;$.forEach(p=>{let m=d[v];m.length>E.b&&(v++,m=[],d.push(m)),m.push(p)}),d.forEach(p=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,m=>m.run(p),()=>{const m=[];return $.forEach(f=>{m.push(f)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,g)}k(g,y){return new Promise((k,$)=>{g.db.close(d=>(d&&this.o(g,`[storage ${this.c}] close(): ${d}`),this.g===E.IN_MEMORY_PATH?k():!g.isErroneous&&!g.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?P.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const p=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>p(),m=>(p(),Promise.reject(m)))})).then(k,$):$(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return P.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const y=await this.f,k=await this.r(y,g?"PRAGMA integrity_check":"PRAGMA quick_check"),$=g?k.integrity_check:k.quick_check;return y.isErroneous?`${$} (last error: ${y.lastError})`:y.isInMemory?`${$} (in-memory!)`:$}async n(g,y=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${y})`);try{return await this.p(g)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,i.$rh)(E.a),this.n(g,!1);try{await P.Promises.unlink(g);try{await P.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch($){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${$}`),this.p(E.IN_MEMORY_PATH)}}}o(g,y){g.isErroneous=!0,g.lastError=y,this.d.error(y)}p(g){return new Promise((y,k)=>{new Promise(($,d)=>{Z(["@vscode/sqlite3"],$,d)}).then($=>{const d={db:new(this.d.isTracing?$.verbose().Database:$.Database)(g,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>k(v)):k(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(d),p=>d.db.close(()=>k(p)))),isInMemory:g===E.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(g,y){return new Promise((k,$)=>{g.db.exec(y,d=>d?(this.o(g,`[storage ${this.c}] exec(): ${d}`),$(d)):k())})}r(g,y){return new Promise((k,$)=>{g.db.get(y,(d,v)=>d?(this.o(g,`[storage ${this.c}] get(): ${d}`),$(d)):k(v))})}s(g,y){return new Promise((k,$)=>{g.db.all(y,(d,v)=>d?(this.o(g,`[storage ${this.c}] all(): ${d}`),$(d)):k(v))})}t(g,y){return new Promise((k,$)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),y(),g.db.run("END TRANSACTION",d=>d?(this.o(g,`[storage ${this.c}] transaction(): ${d}`),$(d)):k())})})}u(g,y,k,$){const d=g.db.prepare(y),v=p=>{this.o(g,`[storage ${this.c}] prepare(): ${p} (${y}). Details: ${$()}`)};d.on("error",v),k(d),d.finalize(p=>{p&&v(p),d.removeListener("error",v)})}}e.$9W=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[h.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(re[164],ae([11,10]),function(Z,e){return Z.create("vs/code/electron-main/app",e)}),define(re[165],ae([11,10]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[166],ae([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/contextkey",e)}),define(re[167],ae([11,10]),function(Z,e){return Z.create("vs/platform/contextkey/common/scanner",e)}),define(re[168],ae([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/common/dialogs",e)}),define(re[169],ae([11,10]),function(Z,e){return Z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[170],ae([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(re[171],ae([11,10]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(re[172],ae([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[173],ae([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[174],ae([11,10]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[175],ae([11,10]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[176],ae([11,10]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[177],ae([11,10]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(re[178],ae([11,10]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(re[179],ae([11,10]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(re[180],ae([11,10]),function(Z,e){return Z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[181],ae([11,10]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[182],ae([11,10]),function(Z,e){return Z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[183],ae([11,10]),function(Z,e){return Z.create("vs/platform/log/common/log",e)}),define(re[184],ae([11,10]),function(Z,e){return Z.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[185],ae([11,10]),function(Z,e){return Z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[186],ae([11,10]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(re[187],ae([11,10]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(re[188],ae([11,10]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[189],ae([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[190],ae([11,10]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[191],ae([11,10]),function(Z,e){return Z.create("vs/platform/update/common/update.config.contribution",e)}),define(re[192],ae([11,10]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[193],ae([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[194],ae([11,10]),function(Z,e){return Z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[195],ae([11,10]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(re[196],ae([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[197],ae([11,10]),function(Z,e){return Z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[198],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfb=i,e.$Tfb=D;function i(S){return S&&S.hasOwnProperty("folderUri")}function D(S){return S&&S.hasOwnProperty("workspace")}}),define(re[199],ae([0,1,7]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=D,e.$Zac=S,e.$1ac=R;function D(P){return typeof P?.backupFolder=="string"}function S(P){let E=[];try{Array.isArray(P.workspaces)&&(E=P.workspaces.map(h=>({workspace:{id:h.id,configPath:i.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function R(P){let E=[];try{Array.isArray(P.folders)&&(E=P.folders.map(h=>({folderUri:i.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(re[200],ae([0,1,15,167]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var S;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(S||(e.TokenType=S={}));function R(...u){switch(u.length){case 1:return(0,D.localize)(0,null,u[0]);case 2:return(0,D.localize)(1,null,u[0],u[1]);case 3:return(0,D.localize)(2,null,u[0],u[1],u[2]);default:return}}const P=(0,D.localize)(3,null),E=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,i.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const y=this.d,k=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:g}),this.f.push($)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const y=this.c.substring(this.d,this.e),k=h.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,y=!1,k=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(E);return}const d=this.c.charCodeAt(g);if(y)y=!1;else if(d===47&&!k){g++;break}else d===91?k=!0:d===92?y=!0:d===93&&(k=!1);g++}for(;g<this.c.length&&h.a.has(this.c.charCodeAt(g));)g++;this.e=g;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=h}),define(re[201],ae([0,1,3,2]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=void 0;class S{constructor(){this.a=new i.$be,this.b=new i.$be,this.c=new i.$be,this.d=new i.$be}static{this.ChannelName="extensionhostdebugservice"}call(E,h,u){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(E,h,u){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Co=S;class R extends D.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,u){this.b.call("attach",[E,h,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$Do=R}),define(re[202],ae([0,1,151,51,13,9,36,19,7]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$1m=g,e.$2m=y,e.$Ym=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,R.$nc)(S.$Kg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$4g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$4g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,i.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$kc)(this.userDataPath,"logs",$)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$4g)(h.URI.file((0,R.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$4g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$4g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$4g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=P.env.VSCODE_PORTABLE;return $?h.URI.file((0,R.$kc)($,"argv.json")):(0,E.$4g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,R.$lc)($):(0,R.$ic)((0,R.$kc)(S.$Kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?h.URI.file((0,R.$lc)($)):h.URI.file((0,R.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,R.$lc)($);const d=P.env.VSCODE_EXTENSIONS;if(d)return d;const v=P.env.VSCODE_PORTABLE;return v?(0,R.$kc)(v,"extensions"):(0,E.$4g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(d=>/^[^:/?#]+?:\/\//.test(d)?h.URI.parse(d):h.URI.file((0,R.$ic)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?h.URI.parse($):h.URI.file((0,R.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Ym.test($))}get extensionLogLevel(){const $=[];for(const d of this.args.log||[]){const v=e.$Ym.exec(d);v&&v[1]&&v[2]&&$.push([v[1],v[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,E.$4g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=P.env.VSCODE_PORTABLE;return $?h.URI.file((0,R.$kc)($,"policy.json")):(0,E.$4g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,d,v){this.a=$,this.b=d,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Zm=u,Se([D.$Uh],u.prototype,"appRoot",null),Se([D.$Uh],u.prototype,"userHome",null),Se([D.$Uh],u.prototype,"userDataPath",null),Se([D.$Uh],u.prototype,"appSettingsHome",null),Se([D.$Uh],u.prototype,"tmpDir",null),Se([D.$Uh],u.prototype,"cacheHome",null),Se([D.$Uh],u.prototype,"stateResource",null),Se([D.$Uh],u.prototype,"userRoamingDataHome",null),Se([D.$Uh],u.prototype,"userDataSyncHome",null),Se([D.$Uh],u.prototype,"sync",null),Se([D.$Uh],u.prototype,"machineSettingsResource",null),Se([D.$Uh],u.prototype,"workspaceStorageHome",null),Se([D.$Uh],u.prototype,"localHistoryHome",null),Se([D.$Uh],u.prototype,"keyboardLayoutResource",null),Se([D.$Uh],u.prototype,"argvResource",null),Se([D.$Uh],u.prototype,"isExtensionDevelopment",null),Se([D.$Uh],u.prototype,"untitledWorkspacesHome",null),Se([D.$Uh],u.prototype,"builtinExtensionsPath",null),Se([D.$Uh],u.prototype,"extensionsPath",null),Se([D.$Uh],u.prototype,"extensionDevelopmentLocationURI",null),Se([D.$Uh],u.prototype,"extensionDevelopmentKind",null),Se([D.$Uh],u.prototype,"extensionTestsLocationURI",null),Se([D.$Uh],u.prototype,"debugExtensionHost",null),Se([D.$Uh],u.prototype,"logLevel",null),Se([D.$Uh],u.prototype,"extensionLogLevel",null),Se([D.$Uh],u.prototype,"serviceMachineIdResource",null),Se([D.$Uh],u.prototype,"disableTelemetry",null),Se([D.$Uh],u.prototype,"disableWorkspaceTrust",null),Se([D.$Uh],u.prototype,"useInMemorySecretStorage",null),Se([D.$Uh],u.prototype,"policyFile",null);function g(k,$){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,$,k.debugId,k.extensionEnvironment)}function y(k,$,d,v,p,m){const l=Number($||k)||(v?null:d),w=l?!!$:!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:l,break:w,debugId:p,env:a}}}),define(re[116],ae([0,1,313,4,170]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0,e.$nm=E,e.$om=u,e.$pm=$,e.$qm=d;const R={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$lm=["tunnel","serve-web"],e.$mm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,p,m=P){const f=v.find(c=>c.length>0&&c[0]!=="-"),l={},w=["_"],a=[],t={};let o;for(const c in p){const b=p[c];b.type==="subcommand"?c===f&&(o=b):(b.alias&&(l[c]=b.alias),b.type==="string"||b.type==="string[]"?(w.push(c),b.deprecates&&w.push(...b.deprecates)):b.type==="boolean"&&(a.push(c),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[c]=b))}if(o&&f){const c=t;for(const I in o.options)c[I]=o.options[I];const b=v.filter(I=>I!==f),j=m.getSubcommandReporter?m.getSubcommandReporter(f):void 0,C=E(b,c,j);return{[f]:C,_:[]}}const s=i(v,{string:w,boolean:a,alias:l}),n={},r=s;n._=s._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in p){const b=p[c];if(b.type==="subcommand")continue;b.alias&&delete r[b.alias];let j=r[c];if(b.deprecates)for(const C of b.deprecates)r.hasOwnProperty(C)&&(j||(j=r[C],j&&m.onDeprecatedOption(C,b.deprecationMessage||(0,S.localize)(38,null,c))),delete r[C]);if(typeof j<"u"){if(b.type==="string[]"){if(Array.isArray(j)||(j=[j]),!b.allowEmptyValue){const C=j.filter(I=>I.length>0);C.length!==j.length&&(m.onEmptyValue(c),j=C.length>0?C:void 0)}}else b.type==="string"&&(Array.isArray(j)?(j=j.pop(),m.onMultipleValues(c,j)):!j&&!b.allowEmptyValue&&(m.onEmptyValue(c),j=void 0));n[c]=j,b.deprecationMessage&&m.onDeprecatedOption(c,b.deprecationMessage)}delete r[c]}for(const c in r)m.onUnknownOption(c);return n}function h(v,p){let m="";return p.args&&(Array.isArray(p.args)?m=` <${p.args.join("> <")}>`:m=` <${p.args}>`),p.alias?`-${p.alias} --${v}${m}`:`--${v}${m}`}function u(v,p){const m=[];for(const f in v){const l=v[f],w=h(f,l);m.push([w,l.description])}return g(m,p)}function g(v,p){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const l=p-f-1,w=[];for(const a of v){const t=a[0],o=k(a[1],l),s=y(f-t.length-2);w.push("  "+t+s+o[0]);for(let n=1;n<o.length;n++)w.push(y(f)+o[n])}return w}function y(v){return" ".repeat(v)}function k(v,p){const m=[];for(;v.length;){const f=v.length<p?v.length:v.lastIndexOf(" ",p),l=v.slice(0,f).trim();v=v.slice(f),m.push(l)}return m}function $(v,p,m,f,l){const w=process.stdout.isTTY&&process.stdout.columns||80,a=l?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${v} ${m}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${p} [${(0,S.localize)(41,null)}]${a}`),t.push(""),l?.noPipe!==!0&&(D.$i?t.push((0,S.localize)(42,null,p)):t.push((0,S.localize)(43,null,p)),t.push(""));const o={},s=[];for(const n in f){const r=f[n];if(r.type==="subcommand")r.description&&s.push({command:n,description:r.description});else if(r.description&&r.cat){let c=o[r.cat];c||(o[r.cat]=c={}),c[n]=r}}for(const n in o){const r=n,c=o[r];c&&(t.push(R[r]),t.push(...u(c,w)),t.push(""))}return s.length&&(t.push((0,S.localize)(44,null)),t.push(...g(s.map(n=>[n.command,n.description]),w)),t.push("")),t.join(`
`)}function d(v,p){return`${v||(0,S.localize)(45,null)}
${p||(0,S.localize)(46,null)}
${process.arch}`}}),define(re[203],ae([0,1,88,201,116]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class R extends D.$Co{constructor(E){super(),this.f=E}call(E,h,u){return h==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(E,h,u)}async g(E,h){const u=(0,S.$nm)(E,S.$mm);u.debugRenderer=h;const g=u.extensionDevelopmentPath;if(!g)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!h)return{success:!0};const k=y.win;if(!k)return{success:!0};const $=k.webContents.debugger;let d=$.isAttached()?1/0:0;const v=(0,i.createServer)(p=>{d++===0&&$.attach();let m=!1;const f=a=>{m||p.write(JSON.stringify(a)+"\0")},l=(a,t,o,s)=>f({method:t,params:o,sessionId:s});k.on("close",()=>{$.removeListener("message",l),p.end(),m=!0}),$.addListener("message",l);let w=Buffer.alloc(0);p.on("data",a=>{w=Buffer.concat([w,a]);for(let t=w.indexOf(0);t!==-1;t=w.indexOf(0)){let o;try{const s=w.slice(0,t).toString("utf8");w=w.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}$.sendCommand(o.method,o.params,o.sessionId).then(s=>f({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{m=!0,--d===0&&$.detach()})});return await new Promise(p=>v.listen(0,p)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$Abc=R}),define(re[64],ae([0,1,314,171,116]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=E,e.$sm=h,e.$tm=u,e.$um=g;function R(y,k){const $=(l,w)=>{console.warn((0,D.localize)(0,null,l,w))},d=l=>{console.warn((0,D.localize)(1,null,l))},v=(l,w)=>{console.warn((0,D.localize)(2,null,l,w))},p=l=>({onUnknownOption:w=>{S.$lm.includes(l)||console.warn((0,D.localize)(3,null,w,l))},onMultipleValues:$,onEmptyValue:d,onDeprecatedOption:v,getSubcommandReporter:S.$lm.includes(l)?p:void 0}),m={onUnknownOption:l=>{console.warn((0,D.localize)(4,null,l))},onMultipleValues:$,onEmptyValue:d,onDeprecatedOption:v,getSubcommandReporter:p},f=(0,S.$nm)(y,S.$mm,k?m:void 0);return f.goto&&f._.forEach(l=>i(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,D.localize)(5,null))),f}function P(y){const k=y.findIndex($=>!/^-/.test($));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=P(k)||[]);const $=!g(process.env);return R(k,$)}function h(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=P(k)||[]),R(k,!0)}function u(y,...k){const $=y.indexOf("--");return $===-1?y.push(...k):y.splice($,0,...k),y}function g(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function Z(e,i,D){function S(P,E){const h=R(P,E),u=[h];return e.isAbsolute(h)||u.unshift(D),e.resolve(...u)}function R(P,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,E);const g=P["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(i.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,E)}return{getUserDataPath:S}}if(typeof define=="function")define(re[204],ae([117,26,36]),function(e,i,D){return Z(e,i,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=Z(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[91],ae([0,1,26,202,204]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=void 0,e.$4m=P,e.$5m=E;class R extends D.$Zm{constructor(u,g){super(u,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,S.getUserDataPath)(u,g.nameShort)},g)}}e.$3m=R;function P(h,u){return(0,D.$2m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,u,h.extensionEnvironment)}function E(h,u){return(0,D.$2m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,u,h.extensionEnvironment)}}),define(re[205],ae([0,1,43,26,32]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=R;function R(P){const E=(0,S.$yg)((0,D.tmpdir)());try{return(0,i.writeFileSync)(E,""),P&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){P&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(re[206],ae([0,1,12,173]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=S;function S(P,E,h,u){try{R(P,E,h,u)}catch(g){P.error(g?.message??g)}return E}function R(P,E,h,u){const g=(y,k,$)=>{const d=y[k];if((0,i.$4f)(d)){const v=d,p=v.length;if(p>1&&v[0]==="%"&&v[p-1]==="%"){const m=v.substr(1,p-2);let f=h[m];f===void 0&&u&&(f=u[m]);const l=typeof f=="string"?f:f?.message,w=u?.[m],a=typeof w=="string"?w:w?.message;if(!l){a||P.warn(`[${E.name}]: ${(0,D.localize)(0,null,m)}`);return}if($&&(k==="title"||k==="category")&&a&&a!==l){const t={value:l,original:a};y[k]=t}else y[k]=l}}else if((0,i.$6f)(d))for(const v in d)d.hasOwnProperty(v)&&(v==="commands"?g(d,v,!0):g(d,v,$));else if(Array.isArray(d))for(let v=0;v<d.length;v++)g(d,v,$)};for(const y in E)E.hasOwnProperty(y)&&g(E,y)}}),define(re[207],ae([0,1,19,74,175,208]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=h,e.$Bp=u,e.$Cp=g,e.$Dp=y,e.$Ep=k,e.$Fp=$,e.$Gp=d;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h(m){return m=m.trim(),m==="*"||P.test(m)}function u(m){if(!h(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=m.match(P);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function g(m){if(!m)return null;const f=m.majorBase,l=m.majorMustEqual,w=m.minorBase;let a=m.minorMustEqual;const t=m.patchBase;let o=m.patchMustEqual;m.hasCaret&&(f===0||(a=!1),o=!1);let s=0;if(m.preRelease){const n=E.exec(m.preRelease);if(n){const[,r,c,b]=n;s=Date.UTC(Number(r),Number(c)-1,Number(b))}}return{majorBase:f,majorMustEqual:l,minorBase:w,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:m.hasGreaterEquals,notBefore:s}}function y(m,f,l){let w;typeof m=="string"?w=g(u(m)):w=m;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof l=="string"?t=g(u(l)):t=l,!w||!t)return!1;const o=w.majorBase,s=w.minorBase,n=w.patchBase;let r=t.majorBase,c=t.minorBase,b=t.patchBase;const j=t.notBefore;let C=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:s>c?!0:s<c||a&&a<j?!1:n>=b:(o===1&&r===0&&(!C||!I||!O)&&(r=1,c=0,b=0,C=!0,I=!1,O=!1),o<r?!1:o>r?!C:s<c?!1:s>c?!I:n<b?!1:n>b?!O:!(a&&a<j))}function k(m,f,l,w,a){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([D.default.Error,S.localize(0,null)]),t;if(typeof w.name!="string")return t.push([D.default.Error,S.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([D.default.Error,S.localize(2,null,"version")]),t;if(!w.engines)return t.push([D.default.Error,S.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([D.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!p(w.extensionDependencies))return t.push([D.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!p(w.activationEvents))return t.push([D.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([D.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([D.default.Warning,S.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([D.default.Error,S.localize(9,null,"main")]),t;{const n=(0,i.$4g)(l,w.main);(0,i.$Xg)(n,l)||t.push([D.default.Warning,S.localize(10,null,n.path,l.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([D.default.Error,S.localize(11,null,"browser")]),t;{const n=(0,i.$4g)(l,w.browser);(0,i.$Xg)(n,l)||t.push([D.default.Warning,S.localize(12,null,n.path,l.path)])}}if(!R.valid(w.version))return t.push([D.default.Error,S.localize(13,null)]),t;const o=[];if(!$(m,f,w,a,o))for(const n of o)t.push([D.default.Error,n]);return t}function $(m,f,l,w,a){return w||typeof l.main>"u"&&typeof l.browser>"u"?!0:v(m,f,l.engines.vscode,a)}function d(m,f,l){return m==="*"||v(f,l,m)}function v(m,f,l,w=[]){const a=g(u(l));if(!a)return w.push(S.localize(14,null,l)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return w.push(S.localize(15,null,l)),!1}else if(!a.majorMustEqual)return w.push(S.localize(16,null,l)),!1;return y(m,f,a)?!0:(w.push(S.localize(17,null,m,l)),!1)}function p(m){if(!Array.isArray(m))return!1;for(let f=0,l=m.length;f<l;f++)if(typeof m[f]!="string")return!1;return!0}}),define(re[209],ae([0,1,17,33]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=S;async function S(R,P,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const g=(await P.readFile(R.serviceMachineIdResource)).value.toString();h=(0,D.$Lg)(g)?g:null}catch{h=null}if(!h){h=(0,D.$Mg)();try{await P.writeFile(R.serviceMachineIdResource,i.$Ce.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(re[78],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class i{constructor(S,R=[],P=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=P}}e.$ni=i}),define(re[210],ae([0,1,78]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=R,e.$ps=P;const D=[];var S;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function R(E,h,u){h instanceof i.$ni||(h=new i.$ni(h,[],!!u)),D.push([E,h])}function P(){return D}}),define(re[211],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class i{constructor(R,P){this.key=R,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$5q=i;class D{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const P of this.a.values())P.outgoing.size===0&&R.push(P);return R}insertEdge(R,P){const E=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(P);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(R){const P=this.b(R);this.a.delete(P);for(const E of this.a.values())E.outgoing.delete(P),E.incoming.delete(P)}lookupOrInsertNode(R){const P=this.b(R);let E=this.a.get(P);return E||(E=new i(P,R),this.a.set(P,E)),E}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[P,E]of this.a)R.push(`${P}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,P]of this.a){const E=new Set([R]),h=this.c(P,E);if(h)return h}}c(R,P){for(const[E,h]of R.outgoing){if(P.has(E))return[...P,E].join(" -> ");P.add(E);const u=this.c(h,P);if(u)return u;P.delete(E)}}}e.$6q=D}),define(re[6],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=S,e.$ri=R;var i;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=E})(i||(e._util=i={})),e.$pi=S("instantiationService");function D(P,E,h){E[i.DI_TARGET]===E?E[i.DI_DEPENDENCIES].push({id:P,index:h}):(E[i.DI_DEPENDENCIES]=[{id:P,index:h}],E[i.DI_TARGET]=E)}function S(P){if(i.serviceIds.has(P))return i.serviceIds.get(P);const E=function(h,u,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(E,h,g)};return E.toString=()=>P,i.serviceIds.set(P,E),E}function R(P){return P}}),define(re[79],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0,e.$Sbc=(0,i.$qi)("auxiliaryWindowsMainService")}),define(re[65],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0,e.$2ac=(0,i.$qi)("backupMainService")}),define(re[18],ae([0,1,12,7,6]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=R,e.$Yi=P,e.$Zi=h,e.$1i=u,e.$2i=g,e.$3i=y,e.$4i=k,e.$5i=d,e.$6i=v,e.$7i=p,e.$Wi=(0,S.$qi)("configurationService");function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof D.URI)}function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof D.URI)}var E;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function u(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}function g(m,f){const l=Object.create(null);for(const w in m)y(l,w,m[w],f);return l}function y(m,f,l,w){const a=f.split("."),t=a.pop();let o=m;for(let s=0;s<a.length;s++){const n=a[s];let r=o[n];switch(typeof r){case"undefined":r=o[n]=Object.create(null);break;case"object":if(r===null){w(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:w(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[t]=l}catch{w(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k(m,f){const l=f.split(".");$(m,l)}function $(m,f){const l=f.shift();if(f.length===0){delete m[l];return}if(Object.keys(m).indexOf(l)!==-1){const w=m[l];typeof w=="object"&&!Array.isArray(w)&&($(w,f),Object.keys(w).length===0&&delete m[l])}}function d(m,f,l){function w(o,s){let n=o;for(const r of s){if(typeof n!="object"||n===null)return;n=n[r]}return n}const a=f.split("."),t=w(m,a);return typeof t>"u"?l:t}function v(m,f,l){Object.keys(f).forEach(w=>{w!=="__proto__"&&(w in m?i.$6f(m[w])&&i.$6f(f[w])?v(m[w],f[w],l):l&&(m[w]=f[w]):m[w]=f[w])})}function p(m){return m.replace(/[\[\]]/g,"")}}),define(re[118],ae([0,1,4,25,200,6,166,15]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=u,e.$pj=o,e.$qj=s,e.$Jj=B;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",i.$j),h.set("isLinux",i.$k),h.set("isWindows",i.$i),h.set("isWeb",i.$o),h.set("isMacNative",i.$j&&!i.$o),h.set("isEdge",i.$H),h.set("isFirefox",i.$F),h.set("isChrome",i.$E),h.set("isSafari",i.$G);function u(J,A){if(h.get(J)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(J,A)}const g=Object.prototype.hasOwnProperty;var y;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},$=(0,P.localize)(0,null),d=(0,P.localize)(1,null),v=(0,P.localize)(2,null),p=(0,P.localize)(3,null),m=(0,P.localize)(4,null),f=(0,P.localize)(5,null),l=(0,P.localize)(6,null),w=(0,P.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=k){this.k=A,this.d=new S.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),ne=_.type===17?f:void 0;throw this.h.push({message:m,offset:_.offset,lexeme:S.$lj.getLexeme(_),additionalInfo:ne}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,p),N?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,p),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const X=ne.lexeme,H=X.lastIndexOf("/"),x=H===X.length-1?void 0:this.w(X.substring(H+1));let K;try{K=new RegExp(X.substring(1,H),x)}catch{throw this.B("REGEX",ne)}return ee.create(N,K)}switch(ne.type){case 10:case 19:{const X=[ne.lexeme];this.z();let H=this.D(),x=0;for(let $e=0;$e<ne.lexeme.length;$e++)ne.lexeme.charCodeAt($e)===40?x++:ne.lexeme.charCodeAt($e)===41&&x--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let $e=0;$e<H.lexeme.length;$e++)H.lexeme.charCodeAt($e)===40?x++:ne.lexeme.charCodeAt($e)===41&&x--}if(x<0)break;X.push(S.$lj.getLexeme(H)),this.z(),H=this.D()}const K=X.join(""),se=K.lastIndexOf("/"),ue=se===K.length-1?void 0:this.w(K.substring(se+1));let me;try{me=new RegExp(K.substring(1,se),ue)}catch{throw this.B("REGEX",ne)}return t.regex(N,me)}case 18:{const X=ne.lexeme;this.z();let H=null;if(!(0,D.$3e)(X)){const x=X.indexOf("/"),K=X.lastIndexOf("/");if(x!==K&&x>=0){const se=X.slice(x+1,K),ue=X[K+1]==="i"?"i":"";try{H=new RegExp(se,ue)}catch{throw this.B("REGEX",ne)}}}if(H===null)throw this.B("REGEX",ne);return ee.create(N,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),U.create(N,this.u());case 6:return this.z(),le.create(N,this.u());case 7:return this.z(),L.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:l,offset:A.offset,lexeme:"",additionalInfo:w}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const ne=(0,P.localize)(8,null,A,S.$lj.getLexeme(N)),X=N.offset,H=S.$lj.getLexeme(N);return this.h.push({message:ne,offset:X,lexeme:H,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=a;class t{static false(){return r.INSTANCE}static true(){return c.INSTANCE}static has(A){return b.create(A)}static equals(A,N){return j.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return ee.create(A,N)}static in(A,N){return C.create(A,N)}static notIn(A,N){return I.create(A,N)}static not(A){return M.create(A)}static and(...A){return G.create(A,null,!0)}static or(...A){return q.create(A,null,!0)}static greater(A,N){return L.create(A,N)}static greaterEquals(A,N){return T.create(A,N)}static smaller(A,N){return U.create(A,N)}static smallerEquals(A,N){return le.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$oj=t;function o(J){const A=new a({regexParsingWithErrorRecovery:!1});return J.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,P.localize)(9,null,_.additionalInfo):(0,P.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(J,A){const N=J?J.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function n(J,A){return J.cmp(A)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return c.INSTANCE}}e.$rj=r;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return r.INSTANCE}}e.$sj=c;class b{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?c.INSTANCE:r.INSTANCE:new b(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:z(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?c.INSTANCE:r.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$tj=b;class j{static create(A,N,_=null){if(typeof N=="boolean")return N?b.create(A,_):M.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?c.INSTANCE:r.INSTANCE:new j(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?c.INSTANCE:r.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$uj=j;class C{static create(A,N){return new C(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:V(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?g.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$vj=C;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=C.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=I;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?M.create(A,_):b.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?r.INSTANCE:c.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?r.INSTANCE:c.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$xj=O;class M{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?r.INSTANCE:c.INSTANCE:new M(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:z(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=h.get(this.c);return typeof A=="boolean"?A?r.INSTANCE:c.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$yj=M;function F(J,A){if(typeof J=="string"){const N=parseFloat(J);isNaN(N)||(J=N)}return typeof J=="string"||typeof J=="number"?A(J):r.INSTANCE}class L{static create(A,N,_=null){return F(N,ne=>new L(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$zj=L;class T{static create(A,N,_=null){return F(N,ne=>new T(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Aj=T;class U{static create(A,N,_=null){return F(N,ne=>new U(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Bj=U;class le{static create(A,N,_=null){return F(N,ne=>new le(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:V(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Cj=le;class ee{static create(A,N){return new ee(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Dj=ee;class ce{static create(A){return new ce(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ce(this.c.map(A))}negate(){return this.c}}e.$Ej=ce;function Q(J){let A=null;for(let N=0,_=J.length;N<_;N++){const ne=J[N].substituteConstants();if(J[N]!==ne&&A===null){A=[];for(let X=0;X<N;X++)A[X]=J[X]}A!==null&&(A[N]=ne)}return A===null?J:A}class G{static create(A,N,_){return G.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=n(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:G.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const ne=[];let X=!1;for(const H of A)if(H){if(H.type===1){X=!0;continue}if(H.type===0)return r.INSTANCE;if(H.type===6){ne.push(...H.expr);continue}ne.push(H)}if(ne.length===0&&X)return c.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(n);for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];for(;ne.length>1;){const H=ne[ne.length-1];if(H.type!==9)break;ne.pop();const x=ne.pop(),K=ne.length===0,se=q.create(H.expr.map(ue=>G.create([ue,x],null,_)),null,K);se&&(ne.push(se),ne.sort(n))}if(ne.length===1)return ne[0];if(_){for(let H=0;H<ne.length;H++)for(let x=H+1;x<ne.length;x++)if(ne[H].negate().equals(ne[x]))return r.INSTANCE;if(ne.length===1)return ne[0]}return new G(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new G(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=q.create(A,this,!0)}return this.c}}e.$Fj=G;class q{static create(A,N,_){return q.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=n(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:q.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let ne=[],X=!1;if(A){for(let H=0,x=A.length;H<x;H++){const K=A[H];if(K){if(K.type===0){X=!0;continue}if(K.type===1)return c.INSTANCE;if(K.type===9){ne=ne.concat(K.expr);continue}ne.push(K)}}if(ne.length===0&&X)return r.INSTANCE;ne.sort(n)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];if(_){for(let H=0;H<ne.length;H++)for(let x=H+1;x<ne.length;x++)if(ne[H].negate().equals(ne[x]))return c.INSTANCE;if(ne.length===1)return ne[0]}return new q(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new q(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),ne=[];for(const X of he(N))for(const H of he(_))ne.push(G.create([X,H],null,!1));A.unshift(q.create(ne,null,!1))}this.c=q.create(A,this,!0)}return this.c}}e.$Gj=q;class W extends b{static{this.d=[]}static all(){return W.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?W.d.push({..._,key:A}):_!==!0&&W.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return j.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Hj=W,e.$Ij=(0,R.$qi)("contextKeyService");function z(J,A){return J<A?-1:J>A?1:0}function V(J,A,N,_){return J<N?-1:J>N?1:A<_?-1:A>_?1:0}function B(J,A){if(J.type===0||A.type===1)return!0;if(J.type===9)return A.type===9?oe(J.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(B(J,N))return!0;return!1}if(J.type===6){if(A.type===6)return oe(A.expr,J.expr);for(const N of J.expr)if(B(N,A))return!0;return!1}return J.equals(A)}function oe(J,A){let N=0,_=0;for(;N<J.length&&_<A.length;){const ne=J[N].cmp(A[_]);if(ne<0)return!1;ne===0&&N++,_++}return N===J.length}function he(J){return J.type===9?J.expr:[J]}}),define(re[92],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$0m=e.ID=void 0,e.$$m=D,e.ID="diagnosticsService",e.$0m=(0,i.$qi)(e.ID);function D(R){return!!R.hostName&&!!R.errorMessage}class S{async getPerformanceInfo(P,E){return{}}async getSystemInfo(P,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(P,E){return""}async getWorkspaceFileExtensions(P){return{extensions:[]}}async reportWorkspaceStats(P){}}e.$_m=S}),define(re[119],ae([0,1,19,74,168,6,48,4,35]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$zw=e.$yw=e.$xw=void 0,e.$Aw=$,e.$Bw=d,e.$xw=(0,R.$qi)("dialogService");var u;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(u||(u={}));class g{a(p){return this.d(p,u.Confirmation)}b(p){return this.d(p,u.Prompt)}c(p){return this.d(p,u.Input)}d(p,m){const f=[];switch(m){case u.Confirmation:{const l=p;l.primaryButton?f.push(l.primaryButton):f.push((0,S.localize)(0,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,S.localize)(1,null));break}case u.Prompt:{const l=p;Array.isArray(l.buttons)&&l.buttons.length>0&&f.push(...l.buttons.map(w=>w.label)),l.cancelButton&&(l.cancelButton===!0?f.push((0,S.localize)(2,null)):typeof l.cancelButton=="string"?f.push(l.cancelButton):l.cancelButton.label?f.push(l.cancelButton.label):f.push((0,S.localize)(3,null))),f.length===0&&f.push((0,S.localize)(4,null));break}case u.Input:{const l=p;l.primaryButton?f.push(l.primaryButton):f.push((0,S.localize)(5,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,S.localize)(6,null));break}}return f}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===D.default.Info?"info":p===D.default.Error?"error":p===D.default.Warning?"warning":"none"}f(p,m,f){const l=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&l.push(p.cancelButton);let w=l[m]?.run({checkboxChecked:f});return w instanceof Promise||(w=Promise.resolve(w)),{result:w,checkboxChecked:f}}}e.$yw=g,e.$zw=(0,R.$qi)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function $(v){const p=[];return p.push(...v.slice(0,k).map(m=>typeof m=="string"?m:(0,i.$1g)(m))),v.length>k&&(v.length-k===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,v.length-k))),p.push(""),p.join(`
`)}function d(v,p){const m=(0,h.$Wn)(v);let f=(m.buttons??[]).map(t=>(0,P.$uw)(t)),l=(v.buttons||[]).map((t,o)=>o),w=0,a=m.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=l[a];l.splice(a,1),l.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),l=l.reverse(),w=f.length-1,typeof t=="string"&&(a=w-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=l[a];l.splice(a,1),l.push(o),a=f.length-1}}return m.buttons=f,m.defaultId=w,m.cancelId=a,m.noLink=!0,m.title=m.title||p.nameLong,{options:m,buttonIndeces:l}}}),define(re[120],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$mX=e.$lX=void 0,e.$nX=R,e.$oX=P,e.$lX=(0,i.$qi)("encryptionService"),e.$mX=(0,i.$qi)("encryptionMainService");var D;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var S;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function R(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function P(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(re[38],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,i.$qi)("environmentService"),e.$yi=(0,i.$ri)(e.$xi)}),define(re[121],ae([0,1,172,6]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=S,e.$Uo=R,e.$Vo=P,e.$Wo=E,e.$Xo=h,e.$Yo=u,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function S(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(l,w){switch(l){case 3:return w==="x64"?"win32-x64":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(l,w){return w==="web"&&!l.includes("web")}function h(l,w,a){return E(w,a)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===a}function u(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var g;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(l){l.Install="install",l.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var $;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Zo=(0,D.$qi)("extensionGalleryService");var d;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class p extends Error{constructor(w,a){super(w),this.code=a,this.name=a}}e.$1o=p;var m;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(m||(e.ExtensionGalleryErrorCode=m={}));class f extends Error{constructor(w,a){super(w),this.code=a,this.name=a}}e.$2o=f,e.$3o=(0,D.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,D.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,D.$qi)("IExtensionTipsService"),e.$8o=(0,i.localize2)(0,"Extensions"),e.$9o=(0,i.localize2)(1,"Preferences")}),define(re[212],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0,e.$Hbc=(0,i.$qi)("extensionHostStarter"),e.$Ibc="extensionHostStarter"}),define(re[213],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=void 0,e.$D6b=(0,i.$qi)("externalTerminal"),e.$E6b="Terminal.app"}),define(re[214],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0,e.$Kbc=(0,i.$qi)("externalTerminal")}),define(re[215],ae([0,1,49,51,13,9,4,76,21,90,176,213]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=e.$Lbc=void 0;const k=g.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends ${static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(i,a,u.$im(),t)}spawnTerminal(a,t,o,s){const n=t.windowsExec||d.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const r=R.$oc(n,".exe").toLowerCase();if(r==="cmder")return a.spawn(n,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return n.indexOf(" ")>=0&&c.push('""'),c.push(n),r==="wt"&&c.push("-d ."),new Promise((b,j)=>{const C=m(process),I=a.spawn(o,c,{cwd:s,env:C,detached:!0});I.on("error",j),I.on("exit",()=>b())})}async runInTerminal(a,t,o,s,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:d.getDefaultTerminalWindows(),c=await d.f();return new Promise((b,j)=>{const C=`"${t} - ${k}"`,I=`"${o.join('" "')}" & pause`,O=Object.assign({},m(process),s);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let F,L;R.$oc(r,".exe")==="wt"?(F=r,L=["-d",".",d.b,"/c",I]):c?(F=c,L=["-d",".",r,"/c",I]):(F=d.b,L=["/c","start",C,"/wait",r,"/c",`"${I}"`]),i.spawn(F,L,M).on("error",U=>{j(f(U))}),b(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return d.d}static async f(){try{const a=await u.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$Lbc=d,Se([D.$Uh],d,"f",null);class v extends ${static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,o,s,n){const r=n.osxExec||y.$E6b;return new Promise((c,b)=>{if(r===y.$E6b||r==="iTerm.app"){const j=r===y.$E6b?"TerminalHelper":"iTermHelper",I=[S.$Kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${j}.scpt`).fsPath,"-t",a||k,"-w",t];for(const F of o)I.push("-a"),I.push(F);if(s){const F=Object.assign({},m(process),s);for(const L in F){const T=F[L];T===null?(I.push("-u"),I.push(L)):(I.push("-e"),I.push(`${L}=${T}`))}}let O="";const M=i.spawn(v.b,I);M.on("error",F=>{b(f(F))}),M.stderr.on("data",F=>{O+=F.toString()}),M.on("exit",F=>{if(F===0)c(void 0);else if(O){const L=O.split(`
`,1);b(new Error(L[0]))}else b(new Error(g.localize(1,null,j,F)))})}else b(new Error(g.localize(2,null,r)))})}spawnTerminal(a,t,o){const s=t.osxExec||y.$E6b;return new Promise((n,r)=>{const c=["-a",s];o&&c.push(o);const b=m(process),j=a.spawn("/usr/bin/open",c,{cwd:o,env:b});j.on("error",r),j.on("exit",()=>n())})}}e.$Mbc=v;class p extends ${static{this.b=g.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(i,a,t)}runInTerminal(a,t,o,s,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,b)=>{const j=[];r.then(C=>{C.indexOf("gnome-terminal")>=0?j.push("-x"):j.push("-e"),j.push("bash"),j.push("-c");const I=`${l(o)}; echo; read -p "${p.b}" -n1;`;j.push(`''${I}''`);const O=Object.assign({},m(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let F="";const L=i.spawn(C,j,M);L.on("error",T=>{b(f(T))}),L.stderr.on("data",T=>{F+=T.toString()}),L.on("exit",T=>{if(T===0)c(void 0);else if(F){const U=F.split(`
`,1);b(new Error(U[0]))}else b(new Error(g.localize(4,null,C,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!P.$k)p.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,o){const s=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{s.then(c=>{const b=m(process),j=a.spawn(c,[],{cwd:o,env:b});j.on("error",r),j.on("exit",()=>n())})})}}e.$Nbc=p;function m(w){const a={...w.env};return(0,E.$gm)(a),a}function f(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(g.localize(5,null,w.path)):w}function l(w){let a="";for(const t of w)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(re[16],ae([0,1,59,9,25,12,7,178,6,4,13,62]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=k,e.$Yk=v,e.$Zk=m,e.$1k=f,e.$2k=l,e.$3k=w,e.$4k=a,e.$5k=t,e.$6k=o,e.$7k=s,e.$8k=n,e.$0k=b,e.$$k=j,e.$_k=C,e.$al=I,e.$bl=O,e.$el=U,e.$ql=q,e.$rl=W,e.$tl=V,e.$Wk=(0,h.$qi)("fileService");function k(B){return B.create===!0}var $;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var d;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function v(B){const oe=B;return!!oe&&typeof oe.onDidChange=="function"}var p;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function m(B){return!!(B.capabilities&2)}function f(B){return!!(B.capabilities&8)}function l(B){return!!(B.capabilities&131072)}function w(B){return!!(B.capabilities&4)}function a(B){return!!(B.capabilities&16)}function t(B){return m(B)?!!(B.capabilities&16384):!1}function o(B){return m(B)?!!(B.capabilities&32768):!1}function s(B){return!!(B.capabilities&65536)}function n(B){return!!(B.capabilities&2048)}var r;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class c extends Error{static create(oe,he){const J=new c(oe.toString(),he);return C(J,he),J}constructor(oe,he){super(oe),this.code=he}}e.$9k=c;function b(B,oe){return c.create(B,oe)}function j(B){return B||b((0,E.localize)(0,null),r.Unknown)}function C(B,oe){return B.name=oe?`${oe} (FileSystemError)`:"FileSystemError",B}function I(B){if(!B)return r.Unknown;if(B instanceof c)return B.code;const oe=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!oe)return r.Unknown;switch(oe[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function O(B){if(B instanceof le)return B.fileOperationResult;switch(I(B)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var M;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class F{constructor(oe,he,J){this.resource=oe,this.operation=he,this.target=J}isOperation(oe){return this.operation===oe}}e.$cl=F;var L;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class T{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const J=i.$wi.forUris(()=>this.c);return J.fill(this.rawAdded.map(A=>[A,!0])),J}),this.f=new y.$V(()=>{const J=i.$wi.forUris(()=>this.c);return J.fill(this.rawUpdated.map(A=>[A,!0])),J}),this.g=new y.$V(()=>{const J=i.$wi.forUris(()=>this.c);return J.fill(this.rawDeleted.map(A=>[A,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of oe){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==T.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...J){if(!oe)return!1;const A=J.length>0;return!!((!A||J.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!A||J.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!A||J.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$dl=T;function U(B,oe,he){return!B||!oe||B===oe||oe.length>B.length?!1:(oe.charAt(oe.length-1)!==D.sep&&(oe+=D.sep),he?(0,S.$uf)(B,oe):B.indexOf(oe)===0)}class le extends Error{constructor(oe,he,J){super(oe),this.fileOperationResult=he,this.options=J}}e.$fl=le;class ee extends le{constructor(oe,he,J,A){super(oe,he,A),this.fileOperationResult=he,this.size=J}}e.$gl=ee;class ce extends le{constructor(oe,he,J){super(oe,2,J),this.stat=he}}e.$hl=ce;var Q;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var G;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.$pl="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}async function W(B,oe){if(!oe.hasProvider(P.URI.from({scheme:B.scheme})))return new Promise(he=>{const J=oe.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===B.scheme&&A.added&&(J.dispose(),he())})})}class z{static{this.KB=1024}static{this.MB=z.KB*z.KB}static{this.GB=z.MB*z.KB}static{this.TB=z.GB*z.KB}static formatSize(oe){return(0,R.$8f)(oe)||(oe=0),oe<z.KB?(0,E.localize)(1,null,oe.toFixed(0)):oe<z.MB?(0,E.localize)(2,null,(oe/z.KB).toFixed(2)):oe<z.GB?(0,E.localize)(3,null,(oe/z.MB).toFixed(2)):oe<z.TB?(0,E.localize)(4,null,(oe/z.GB).toFixed(2)):(0,E.localize)(5,null,(oe/z.TB).toFixed(2))}}e.$sl=z;function V(B){const oe=typeof B=="string"||B?.scheme===g.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===g.Schemas.file?1024*z.MB:oe?10*z.MB:u.$o?50*z.MB:1024*z.MB}}),define(re[122],ae([0,1,17,15,179,16]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=P;async function P(g,y,k,$,d,v){let p;try{await E(g,y,k,$,d,v)}catch(m){p=m}finally{p&&d.errorTransformer&&(p=d.errorTransformer(p)),typeof p<"u"&&k.error(p),k.end()}}async function E(g,y,k,$,d,v){h(v);const p=await g.open(y,{create:!1});try{h(v);let m=0,f=0,l=d&&typeof d.length=="number"?d.length:void 0,w=i.$Ce.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,t=0;do f=await g.read(p,a,w.buffer,t,w.byteLength-t),a+=f,t+=f,m+=f,typeof l=="number"&&(l-=f),t===w.byteLength&&(await k.write($(w)),w=i.$Ce.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),t=0);while(f>0&&(typeof l!="number"||l>0)&&h(v)&&u(m,d));if(t>0){let o=t;typeof l=="number"&&(o=Math.min(t,l)),k.write($(w.slice(0,o)))}}catch(m){throw(0,R.$$k)(m)}finally{await g.close(p)}}function h(g){if(g.isCancellationRequested)throw(0,D.$6)();return!0}function u(g,y){if(typeof y?.limits?.size=="number"&&g>y.limits.size)throw(0,R.$0k)((0,S.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[60],ae([0,1,108,2,9,4,7,16]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=h,e.$Eq=u,e.$Iq=$,e.$Jq=d,e.$Kq=v,e.$Lq=p;function h(f){return typeof f.correlationId=="number"}function u(f){return f.recursive===!0}class g extends D.$Uc{static{this.a=5}constructor(l,w,a,t){super(),this.h=l,this.j=w,this.m=a,this.n=t,this.c=this.B(new D.$Vc),this.f=void 0,this.g=0}s(){const l=new D.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(w=>this.h(w))),l.add(this.b.onDidLogMessage(w=>this.j(w))),l.add(this.b.onDidError(w=>this.t(w)))}t(l){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=g;class y extends g{constructor(l,w,a){super(l,w,a,{type:"node.js",restartOnError:!1})}}e.$Gq=y;class k extends g{constructor(l,w,a){super(l,w,a,{type:"universal",restartOnError:!0})}}e.$Hq=k;function $(f){return f.map(l=>({type:l.type,resource:P.URI.revive(l.resource),cId:l.cId}))}function d(f){const l=new m;for(const w of f)l.processEvent(w);return l.coalesce()}function v(f,l){return typeof l=="string"&&!l.startsWith(i.$gk)&&!(0,S.$jc)(l)?{base:f,pattern:l}:l}function p(f,l){const w=[];for(const a of l)w.push((0,i.$kk)(v(f,a)));return w}class m{constructor(){this.a=new Set,this.b=new Map}c(l){return R.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const w=this.b.get(this.c(l));let a=!1;if(w){const t=w.type,o=l.type;w.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?a=!0:t===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(w)):t===2&&o===1?w.type=0:t===1&&o===0||(w.type=o)}else a=!0;a&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],w=[];return Array.from(this.a).filter(a=>a.type!==2?(l.push(a),!1):!0).sort((a,t)=>a.resource.fsPath.length-t.resource.fsPath.length).filter(a=>w.some(t=>(0,E.$el)(a.resource.fsPath,t,!R.$k))?!1:(w.push(a.resource.fsPath),!0)).concat(l)}}}),define(re[216],ae([0,1,17,47,15,3,2,63,33,16,60]),function(Z,e,i,D,S,R,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$iQ=void 0,e.$iQ="localFilesystem";class y extends P.$Uc{constructor($,d){super(),this.a=$,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$be),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.h=(0,h.$Mg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,d){const{buffer:v}=await this.a.call("readFile",[$,d]);return v}readFileStream($,d,v){const p=(0,E.$qe)(f=>i.$Ce.concat(f.map(l=>i.$Ce.wrap(l))).buffer),m=new P.$Tc;return m.add(this.a.listen("readFileStream",[$,d])(f=>{if(f instanceof i.$Ce)p.write(f.buffer);else{if(f==="end")p.end();else{let l;if(f instanceof Error)l=f;else{const w=f;l=(0,u.$0k)(w.message??(0,D.$bj)(w),w.code??u.FileSystemProviderErrorCode.Unknown)}p.error(l),p.end()}m.dispose()}})),m.add(v.onCancellationRequested(()=>{p.error((0,S.$6)()),p.end(),m.dispose()})),p}writeFile($,d,v){return this.a.call("writeFile",[$,i.$Ce.wrap(d),v])}open($,d){return this.a.call("open",[$,d])}close($){return this.a.call("close",[$])}async read($,d,v,p,m){const[f,l]=await this.a.call("read",[$,d,m]);return v.set(f.buffer.slice(0,l),p),l}write($,d,v,p,m){return this.a.call("write",[$,d,i.$Ce.wrap(v),p,m])}mkdir($){return this.a.call("mkdir",[$])}delete($,d){return this.a.call("delete",[$,d])}rename($,d,v){return this.a.call("rename",[$,d,v])}copy($,d,v){return this.a.call("copy",[$,d,v])}cloneFile($,d){return this.a.call("cloneFile",[$,d])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const d=$;this.f.fire((0,g.$Iq)(d))}else{const d=$;this.g.fire(d)}}))}watch($,d){const v=(0,h.$Mg)();return this.a.call("watch",[this.h,v,$,d]),(0,P.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$jQ=y}),define(re[217],ae([0,1,43,2,60,3,7,8]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class h extends D.$Uc{constructor(){super(),this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new D.$4c),this.m=new Set,this.n=5007,this.r=new E.$Nh,this.B(this.f(g=>this.s(g)))}s(g){this.t(g)&&this.w(g)}t(g){return(0,S.$Dq)(g)}async watch(g){this.r.isSettled||this.r.complete(),this.r=new E.$Nh;try{this.h.clear(),this.g.clear();for(const y of g)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))])}isSuspended(g){return typeof g.correlationId!="number"?!1:this.m.has(g.correlationId)?"polling":this.j.has(g.correlationId)}async w(g){if(this.j.has(g.correlationId))return;const y=new D.$Tc;this.j.set(g.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(g,y),this.u())}y(g){this.j.deleteAndDispose(g.correlationId),this.m.delete(g.correlationId),this.u()}z(g,y){this.C(g,y)?(this.M(`reusing an existing recursive watcher to monitor ${g.path}`),this.m.delete(g.correlationId)):(this.D(g,y),this.m.add(g.correlationId))}C(g,y){const k=this.L?.subscribe(g.path,($,d)=>{y.isDisposed||($?this.z(g,y):d?.type===1&&this.F(g))});return k?(y.add(k),!0):!1}D(g,y){let k=!1;const $=(d,v)=>{if(y.isDisposed)return;const p=this.G(d),m=this.G(v),f=k;k=p,!p&&(m||f)&&this.F(g)};this.M(`starting fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,i.watchFile)(g.path,{persistent:!1,interval:this.n},$)}catch(d){this.N(`fs.watchFile() failed with error ${d} on path ${g.path} (correlationId: ${g.correlationId})`)}y.add((0,D.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,i.unwatchFile)(g.path,$)}catch(d){this.N(`fs.unwatchFile() failed with error ${d} on path ${g.path} (correlationId: ${g.correlationId})`)}}))}F(g){this.M(`detected ${g.path} exists again, resuming watcher (correlationId: ${g.correlationId})`);const y={resource:P.URI.file(g.path),type:1,cId:g.correlationId};this.a.fire([y]),this.H(y,g),this.y(g)}G(g){return g.ctimeMs===0&&g.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(g,y){const k=` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`;this.M(typeof y.correlationId=="number"?`${k} (correlationId: ${y.correlationId})`:k)}I(g){return`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`}}e.$Uq=h}),define(re[218],ae([0,1,43,8,23,32,2,72,9,4,19,7,109,21,60]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=p;class v extends P.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(f,l,w,a,t,o){super(),this.r=f,this.s=l,this.t=w,this.u=a,this.w=t,this.y=o,this.c=this.B(new D.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.t(s))),this.f=this.B(new D.$Eh(s=>this.L(s),v.b)),this.g=(0,d.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,d.$Lq)(this.r.path,this.r.includes):void 0,this.j=new S.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const f=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const l=await $.Promises.stat(f);if(this.j.token.isCancellationRequested)return;this.B(await this.F(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.N(f):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${f})`),this.C()}}C(){this.n=!0,this.u?.()}async D(f){let l=f.path;try{l=await $.Promises.realpath(f.path),f.path===l&&(l=await(0,k.$Wq)(f.path,this.j.token)??f.path),f.path!==l&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async F(f,l){const w=new P.$Tc;return this.G(f,l,w)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(f,l,w)),w}G(f,l,w){if(l)return!1;const a=y.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(o,s)=>{if(!w.isDisposed)if(o){const n=await this.F(f,l);w.isDisposed?n.dispose():w.add(n)}else s&&(typeof s.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:a,type:s.type,cId:this.r.correlationId}])});return t?(w.add(t),!0):!1}async H(f,l,w){if(u.$j&&(0,R.$qg)(f,"/Volumes/",!0)){this.N(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new S.$me(this.j.token);w.add((0,P.$Sc)(()=>a.dispose(!0)));const t=new P.$Tc;w.add(t);try{const o=y.URI.file(this.r.path),s=(0,h.$oc)(f),n=(0,i.watch)(f);t.add((0,P.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.P(`Started watching: '${f}'`);const r=new Set;if(l)try{for(const b of await $.Promises.readdir(f))r.add(b)}catch(b){this.N(b)}if(a.token.isCancellationRequested)return;const c=new Map;t.add((0,P.$Sc)(()=>{for(const[,b]of c)b.dispose();c.clear()})),n.on("error",(b,j)=>{a.token.isCancellationRequested||(this.N(`Failed to watch ${f} for changes using fs.watch() (${b}, ${j})`),this.C())}),n.on("change",(b,j)=>{if(a.token.isCancellationRequested)return;this.P(`[raw] ["${b}"] ${j}`);let C="";if(j&&(C=j.toString(),u.$j&&(C=(0,E.$8l)(C))),!(!C||b!=="change"&&b!=="rename"))if(l)if(b==="rename"){c.get(C)?.dispose();const I=setTimeout(async()=>{if(c.delete(C),C===s&&!await $.Promises.exists(f)){this.I(o);return}if(a.token.isCancellationRequested)return;const O=await this.M((0,h.$kc)(f,C));if(a.token.isCancellationRequested)return;let M;O?r.has(C)?M=0:(M=1,r.add(C)):(r.delete(C),M=2),this.J({resource:(0,g.$4g)(o,C),type:M,cId:this.r.correlationId})},v.a);c.set(C,(0,P.$Sc)(()=>clearTimeout(I)))}else{let I;r.has(C)?I=0:(I=1,r.add(C)),this.J({resource:(0,g.$4g)(o,C),type:I,cId:this.r.correlationId})}else if(b==="rename"||C!==s){const I=setTimeout(async()=>{const O=await $.Promises.exists(f);a.token.isCancellationRequested||(O?(this.J({resource:o,type:0,cId:this.r.correlationId},!0),t.add(await this.F(f,!1))):this.I(o))},v.a);t.clear(),t.add((0,P.$Sc)(()=>clearTimeout(I)))}else this.J({resource:o,type:0,cId:this.r.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.N(`Failed to watch ${f} for changes using fs.watch() (${o.toString()})`),this.C()}}I(f){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:f,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(f,l=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!l&&this.g.some(w=>w(f.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${f.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(w=>w(f.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}L(f){const l=(0,d.$Jq)(f);if(l.length>0){if(this.y)for(const a of l)this.P(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(f){if(u.$k)return $.Promises.exists(f);try{const l=(0,h.$oc)(f);return(await $.Promises.readdir((0,h.$nc)(f))).some(a=>a===l)}catch(l){return this.P(l),!1}}setVerboseLogging(f){this.y=f}N(f){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}O(f){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}P(f){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=v;async function p(m,f,l,w,a=512){const t=await $.Promises.open(m,"r"),o=Buffer.allocUnsafe(a),s=new S.$me(w);let n,r=!1;const c={path:m,excludes:[],recursive:!1},b=new v(c,void 0,j=>{(async()=>{for(const{type:C}of j)if(C===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await $.Promises.read(t,o,0,a,null);if(!I||s.token.isCancellationRequested)break;f(o.slice(0,I))}}catch(I){n=new Error(I),s.dispose(!0)}finally{r=!1}}})()});return await b.ready,l(),new Promise((j,C)=>{s.token.onCancellationRequested(async()=>{b.dispose();try{await $.Promises.close(t)}catch(I){n=new Error(I)}n?C(n):j()})})}}),define(re[219],ae([0,1,3,108,217,4,218,32]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class h extends S.$Uq{constructor(g){super(),this.L=g,this.onDidError=i.Event.None,this.watchers=new Set,this.O=!1}async J(g){g=this.W(g);const y=[],k=new Set(Array.from(this.watchers));for(const $ of g){const d=this.R($);d&&(0,D.$ok)(d.request.excludes,$.excludes)&&(0,D.$ok)(d.request.includes,$.includes)?k.delete(d):y.push($)}y.length&&this.M(`Request to start watching: ${y.map($=>this.I($)).join(",")}`),k.size&&this.M(`Request to stop watching: ${Array.from(k).map($=>this.I($.request)).join(",")}`);for(const $ of k)this.U($);for(const $ of y)this.S($)}R(g){for(const y of this.watchers)if(typeof g.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===g.correlationId)return y}else if((0,E.$pg)(y.request.path,g.path,!R.$k))return y}S(g){const y=new P.$Zq(g,this.L,$=>this.a.fire($),()=>this.c.fire(g),$=>this.b.fire($),this.O),k={request:g,instance:y};this.watchers.add(k)}async stop(){await super.stop();for(const g of this.watchers)this.U(g)}U(g){this.M("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}W(g){const y=new Map;for(const k of g){const $=R.$k?k.path:k.path.toLowerCase();let d=y.get(k.correlationId);d||(d=new Map,y.set(k.correlationId,d)),d.has($)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(k)}`),d.set($,k)}return Array.from(y.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(g){this.O=g;for(const y of this.watchers)y.instance.setVerboseLogging(g)}M(g,y){this.O&&this.b.fire({type:"trace",message:this.Z(g,y)})}N(g){this.b.fire({type:"warn",message:this.Z(g)})}Z(g,y){return y?`[File Watcher (node.js)] ${g} (${this.I(y.request)})`:`[File Watcher (node.js)] ${g}`}}e.$2q=h}),define(re[220],ae([0,1,60,219]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class S extends i.$Gq{constructor(P,E,h){super(P,E,h),this.s()}r(P){return P.add(new D.$2q(void 0))}}e.$3q=S}),define(re[221],ae([0,1,13,44,162,60]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class P extends R.$Hq{constructor(h,u,g){super(h,u,g),this.s()}r(h){const u=h.add(new S.$Sq(i.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(u.onDidProcessExit(({code:g,signal:y})=>this.t(`terminated by itself with code ${g}, signal: ${y}`))),D.ProxyChannel.toService((0,D.$0h)(u.getChannel("watcher")))}}e.$Tq=P}),define(re[93],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class i{constructor(...S){this.a=new Map;for(const[R,P]of S)this.set(R,P)}set(S,R){const P=this.a.get(S);return this.a.set(S,R),P}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$oi=i}),define(re[222],ae([0,1,8,15,2,78,211,6,93,104]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const g=!1;class y extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class k{constructor(p=new h.$oi,m=!1,f,l=g){this.i=p,this.j=m,this.k=f,this.l=l,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$pi,this),this._globalGraph=l?f?._globalGraph??new P.$6q(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const p of this.g)(0,S.$Oc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const m=new class extends k{dispose(){this.h.delete(m),super.dispose()}}(p,this.j,this,this.l);return this.h.add(m),m}invokeFunction(p,...m){this.m();const f=d.traceInvocation(this.l,p);let l=!1;try{return p({get:a=>{if(l)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...m)}finally{l=!0,f.stop()}}createInstance(p,...m){this.m();let f,l;return p instanceof R.$ni?(f=d.traceCreation(this.l,p.ctor),l=this.o(p.ctor,p.staticArguments.concat(m),f)):(f=d.traceCreation(this.l,p),l=this.o(p,m,f)),f.stop(),l}o(p,m=[],f){const l=E._util.getServiceDependencies(p).sort((t,o)=>t.index-o.index),w=[];for(const t of l){const o=this.s(t.id,f);o||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(o)}const a=l.length>0?l[0].index:m.length;if(m.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${m.length} static arguments`);const t=a-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,a)}return Reflect.construct(p,m.concat(w))}q(p,m){if(this.i.get(p)instanceof R.$ni)this.i.set(p,m);else if(this.k)this.k.q(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const m=this.i.get(p);return!m&&this.k?this.k.r(p):m}s(p,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.r(p);return f instanceof R.$ni?this.u(p,f,m.branch(p,!0)):(m.branch(p,!1),f)}u(p,m,f){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,m,f)}finally{this.t.delete(p)}}v(p,m,f){const l=new P.$6q(t=>t.id.toString());let w=0;const a=[{id:p,desc:m,_trace:f}];for(;a.length;){const t=a.pop();if(l.lookupOrInsertNode(t),w++>1e3)throw new y(l);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof R.$ni){const n={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};l.insertEdge(t,n),a.push(n)}}}for(;;){const t=l.roots();if(t.length===0){if(!l.isEmpty())throw new y(l);break}for(const{data:o}of t){if(this.r(o.id)instanceof R.$ni){const n=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,n)}l.removeNode(o)}}return this.r(p)}w(p,m,f=[],l,w){if(this.i.get(p)instanceof R.$ni)return this.x(p,m,f,l,w,this.g);if(this.k)return this.k.w(p,m,f,l,w);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}x(p,m,f=[],l,w,a){if(l){const t=new k(void 0,this.j,this,this.l);t.c=String(p);const o=new Map,s=new i.$Jh(()=>{const n=t.o(m,f,w);for(const[r,c]of o){const b=n[r];if(typeof b=="function")for(const j of c)j.disposable=b.apply(n,j.listener)}return o.clear(),a.add(n),n});return new Proxy(Object.create(null),{get(n,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let j=o.get(r);return j||(j=new u.$5c,o.set(r,j)),(I,O,M)=>{if(s.isInitialized)return s.value[r](I,O,M);{const F={listener:[I,O,M],disposable:void 0},L=j.push(F);return(0,S.$Sc)(()=>{L(),F.disposable?.dispose()})}}}if(r in n)return n[r];const c=s.value;let b=c[r];return typeof b!="function"||(b=b.bind(c),n[r]=b),b},set(n,r,c){return s.value[r]=c,!0},getPrototypeOf(n){return m.prototype}})}else{const t=this.o(m,f,w);return a.add(t),t}}y(p,m){if(m&&console.warn(p),this.j)throw new Error(p)}}e.$7q=k;var $;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})($||($={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,m){return p?new d(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(p,m){return p?new d(1,m.name):d.c}static{this.f=0}constructor(p,m){this.type=p,this.name=m,this.g=Date.now(),this.h=[]}branch(p,m){const f=new d(3,p.toString());return this.h.push([p,m,f]),f}stop(){const p=Date.now()-this.g;d.f+=p;let m=!1;function f(w,a){const t=[],o=new Array(w+1).join("	");for(const[s,n,r]of a.h)if(n&&r){m=!0,t.push(`${o}CREATES -> ${s}`);const c=f(w+1,r);c&&t.push(c)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(p>2||m)&&d.all.add(l.join(`
`))}}e.$8q=d}),define(re[223],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJb=e.IssueSource=e.IssueType=void 0;var D;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={}));var S;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$rJb=(0,i.$qi)("issueService")}),define(re[5],ae([0,1,183,47,3,46,2,31,4,19,12,7,118,6]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=v,e.log=m,e.$$j=b,e.$_j=j,e.$ak=C,e.$bk=I,e.$Wj=(0,$.$qi)("logService"),e.$Xj=(0,$.$qi)("loggerService");function d(){return new Date().toISOString()}function v(O){return(0,g.$8f)(O)}var p;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Zj=p.Info;function m(O,M,F){switch(M){case p.Trace:O.trace(F);break;case p.Debug:O.debug(F);break;case p.Info:O.info(F);break;case p.Warning:O.warn(F);break;case p.Error:O.error(F);break;case p.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function f(O,M=!1){let F="";for(let L=0;L<O.length;L++){let T=O[L];if(T instanceof Error&&(T=(0,D.$bj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}F+=(L>0?" ":"")+T}return F}class l extends P.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new S.$be),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==p.Off&&this.b<=M}}e.$2j=l;class w extends l{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...F){this.f(p.Trace)&&this.g(p.Trace,f([M,...F],!0))}debug(M,...F){this.f(p.Debug)&&this.g(p.Debug,f([M,...F]))}info(M,...F){this.f(p.Info)&&this.g(p.Info,f([M,...F]))}warn(M,...F){this.f(p.Warning)&&this.g(p.Warning,f([M,...F]))}error(M,...F){if(this.f(p.Error))if(M instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=M.stack,this.g(p.Error,f(L))}else this.g(p.Error,f([M,...F]))}flush(){}}e.$3j=w;class a extends l{constructor(M=e.$Zj){super(),this.setLevel(M),this.g=!h.$i}trace(M,...F){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...F):console.log(`[main ${d()}]`,M,...F))}debug(M,...F){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...F):console.log(`[main ${d()}]`,M,...F))}info(M,...F){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...F):console.log(`[main ${d()}]`,M,...F))}warn(M,...F){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,M,...F):console.warn(`[main ${d()}]`,M,...F))}error(M,...F){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,M,...F):console.error(`[main ${d()}]`,M,...F))}flush(){}}e.$4j=a;class t extends l{constructor(M=e.$Zj,F=!0){super(),this.g=F,this.setLevel(M)}trace(M,...F){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...F):console.log(M,...F))}debug(M,...F){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...F):console.log(M,...F))}info(M,...F){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...F):console.log(M,...F))}warn(M,...F){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...F):console.log(M,...F))}error(M,...F){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...F):console.error(M,...F))}flush(){}}e.$5j=t;class o extends l{constructor(M,F=e.$Zj){super(),this.g=M,this.setLevel(F)}trace(M,...F){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(M),...F])}debug(M,...F){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(M),...F])}info(M,...F){this.f(p.Info)&&this.g.log(p.Info,[this.h(M),...F])}warn(M,...F){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(M),...F])}error(M,...F){this.f(p.Error)&&this.g.log(p.Error,[this.h(M),...F])}h(M){return typeof M=="string"?M:(0,D.$bj)(M,this.f(p.Trace))}flush(){}}e.$6j=o;class s extends l{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const F of this.g)F.setLevel(M);super.setLevel(M)}trace(M,...F){for(const L of this.g)L.trace(M,...F)}debug(M,...F){for(const L of this.g)L.debug(M,...F)}info(M,...F){for(const L of this.g)L.info(M,...F)}warn(M,...F){for(const L of this.g)L.warn(M,...F)}error(M,...F){for(const L of this.g)L.error(M,...F)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$7j=s;class n extends P.$Uc{constructor(M,F,L){if(super(),this.h=M,this.j=F,this.b=new E.$Bc,this.c=this.B(new S.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$be),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,g.$4f)(M)?[...this.b.values()].find(F=>F.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,F){const L=this.n(M),T=(0,g.$4f)(M)?M:F?.id??(0,R.$ej)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const le=F?.logLevel==="always"?p.Trace:F?.logLevel;U||(U=this.s(L,le??this.getLogLevel(L)??this.h,{...F,id:T}));const ee={logger:U,info:{resource:L,id:T,logLevel:le,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(ee.info),this.b.set(L,ee),U}n(M){return(0,g.$4f)(M)?(0,u.$4g)(this.j,`${M}.log`):M}setLogLevel(M,F){if(y.URI.isUri(M)){const L=M,T=F,U=this.b.get(L);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([L,T]))}else{this.h=M;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,F){const L=this.m(M);L&&F!==!L.info.hidden&&(L.info.hidden=!F,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,F]))}getLogLevel(M){let F;return M&&(F=this.b.get(M)?.info.logLevel),F??this.h}registerLogger(M){const F=this.b.get(M.resource);F?F.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const F=this.b.get(M);F&&(F.logger&&F.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=n;class r{constructor(){this.onDidChangeLogLevel=new S.$be().event}setLevel(M){}getLevel(){return p.Info}trace(M,...F){}debug(M,...F){}info(M,...F){}warn(M,...F){}error(M,...F){}critical(M,...F){}dispose(){}flush(){}}e.$9j=r;class c extends r{}e.$0j=c;function b(O){if(O.verbose)return p.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$Zj}function j(O){switch(O){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function C(O){switch(O){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function I(O){switch(O){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$ck=new k.$Hj("logLevel",j(p.Info))});var ie=this&&this.__param||function(Z,e){return function(i,D){e(i,D,Z)}};define(re[224],ae([0,1,14,4,5]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;const R=i.safeStorage;let P=class{constructor(h){this.a=h,i.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(R.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(h){let u;try{if(u=JSON.parse(h),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const g=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=R.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$i)return Promise.resolve("dpapi");if(D.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const h=R.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$Gbc=P,e.$Gbc=P=Se([ie(0,S.$Wj)],P)}),define(re[225],ae([0,1,22,8,15,3,2,9,60,5]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class g extends P.$Uc{constructor(k,$){super(),this.a=k,this.b=$,this.c=this.B(new R.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$oh(0)),this.w=[],this.y=this.B(new D.$oh(0))}watch(k,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(k,$):this.z(k,$)}n(k,$){const d={path:this.I(k),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},v=(0,i.$Ub)(this.j,d);return this.r(),(0,P.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,S.$1)(k))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,h.$Iq)($)),$=>this.G($),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const $ of this.j)(0,h.$Eq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const $ of this.j)(0,h.$Eq)($)&&k.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,$){const d={path:this.I(k),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},v=(0,i.$Ub)(this.w,d);return this.C(),(0,P.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,S.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,h.$Iq)(k)),k=>this.G(k),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,E.$ic)(k.fsPath)}}e.$Mq=g}),define(re[226],ae([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let a=class extends u.$Uc{static{w=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new P.$be),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new P.$be),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new P.$be),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new P.$be),this.onDidRunOperation=this.r.event,this.X=this.B(new P.$be),this.Y=this.B(new P.$be),this.onDidFilesChange=this.Y.event,this.Z=this.B(new P.$be),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$zh)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const n=new u.$Tc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),n.add(s.onDidChangeFile(r=>{const c=new p.$dl(r,!this.S(s));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof s.onDidWatchError=="function"&&n.add(s.onDidWatchError(r=>this.Z.fire(new Error(r)))),n.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,u.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,u.$Pc)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(n){s.push(n)}}),!this.h.has(o)&&await D.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&s)}listCapabilities(){return h.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,$.$8g)(o))throw new p.$fl((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const n=new l.$bb;throw n.message=(0,v.localize)(1,null,o.toString()),n}return s}async m(o){const s=await this.j(o);if((0,p.$3k)(s)||(0,p.$Zk)(s)||(0,p.$4k)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,p.$3k)(s)||(0,p.$Zk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(n){throw(0,p.$al)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.$fl((0,v.localize)(2,null,this.sb(o)),1):(0,p.$$k)(n)}}async s(o,s){const n=await this.j(o),r=this.S(n),c=s?.resolveTo,b=s?.resolveSingleChildDescendants,j=s?.resolveMetadata,C=await n.stat(o);let I;return this.t(n,o,C,void 0,!!j,(O,M)=>(I||(I=g.$wi.forUris(()=>!r),I.set(o,!0),c&&I.fill(!0,c)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&b?M===1:!1))}async t(o,s,n,r,c,b){const{providerExtUri:j}=this.R(o),C={resource:s,name:j.basename(s),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.$ql)({mtime:n.mtime,size:n.size}),children:void 0};if(C.isDirectory&&b(C,r)){try{const I=await o.readdir(s),O=await D.Promises.settled(I.map(async([M,F])=>{try{const L=j.joinPath(s,M),T=c?await o.stat(L):{type:F};return await this.t(o,L,T,I.length,c,b)}catch(L){return this.b.trace(L),null}}));C.children=(0,i.$Hb)(O)}catch(I){this.b.trace(I),C.children=[]}return C}return C}async resolveAll(o){return D.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),n=await s.stat(o);return this.t(s,o,n,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(n){return n}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new p.$fl((0,v.localize)(3,null,this.sb(o)),3,s)}async createFile(o,s=S.$Ce.fromString(""),n){await this.u(o,n);const r=await this.writeFile(o,s);return this.r.fire(new p.$cl(o,0,r)),r}async writeFile(o,s,n){const r=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(r);let b=n;if((0,p.$6k)(r)&&!b?.atomic){const j=r.enforceAtomicWriteFile?.(o);j&&(b={...n,atomic:j})}try{await this.w(r,o,b)||await this.U(r,c.dirname(o));let C;if((0,p.$Zk)(r)&&!(s instanceof S.$Ce))if((0,d.$oe)(s)){const I=await(0,d.$ve)(s,3);I.ended?C=S.$Ce.concat(I.buffer):C=I}else C=(0,d.$se)(s,I=>S.$Ce.concat(I),3);else C=s;!(0,p.$3k)(r)||(0,p.$Zk)(r)&&C instanceof S.$Ce||(0,p.$Zk)(r)&&(0,p.$6k)(r)&&b?.atomic?await this.hb(r,o,b,C):await this.db(r,o,b,C instanceof S.$Ce?(0,S.$Ne)(C):C),this.r.fire(new p.$cl(o,4))}catch(j){throw new p.$fl((0,v.localize)(4,null,this.sb(o),(0,p.$$k)(j).toString()),(0,p.$bl)(j),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,n){const r=!!n?.unlock;if(r&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(s)));if(!!n?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(s)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(s)));if(r)throw new Error((0,v.localize)(8,null,this.sb(s)))}let b;try{b=await o.stat(s)}catch{return}if(b.type&p.FileType.Directory)throw new p.$fl((0,v.localize)(9,null,this.sb(s)),0,n);if(this.rb(s,b),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.$pl&&typeof b.mtime=="number"&&typeof b.size=="number"&&n.mtime<b.mtime&&n.etag!==(0,p.$ql)({mtime:n.mtime,size:b.size}))throw new p.$fl((0,v.localize)(10,null),3,n);return b}async readFile(o,s,n){const r=await this.m(o);return s?.atomic?this.z(r,o,s,n):this.C(r,o,s,n)}async z(o,s,n,r){return new Promise((c,b)=>{this.cb.queueFor(s,async()=>{try{const j=await this.C(o,s,n,r);c(j)}catch(j){b(j)}},this.R(o).providerExtUri)})}async C(o,s,n,r){const c=await this.D(o,s,{...n,preferUnbuffered:!0},r);return{...c,value:await(0,S.$Oe)(c.value)}}async readFileStream(o,s,n){const r=await this.m(o);return this.D(r,o,s,n)}async D(o,s,n,r){const c=new R.$me(r);let b=n;(0,p.$5k)(o)&&o.enforceAtomicReadFile?.(s)&&(b={...n,atomic:!0});const j=this.J(s,b).then(I=>I,I=>{throw c.dispose(!0),I});let C;try{return typeof b?.etag=="string"&&b.etag!==p.$pl&&await j,b?.atomic&&(0,p.$5k)(o)||!((0,p.$3k)(o)||(0,p.$4k)(o))||(0,p.$Zk)(o)&&b?.preferUnbuffered?C=this.I(o,s,b):(0,p.$4k)(o)?C=this.G(o,s,c.token,b):C=this.H(o,s,c.token,b),C.on("end",()=>c.dispose()),C.on("error",()=>c.dispose()),{...await j,value:C}}catch(I){throw C&&await(0,d.$te)(C),this.F(I,s,b)}}F(o,s,n){const r=(0,v.localize)(11,null,this.sb(s),(0,p.$$k)(o).toString());return o instanceof p.$hl?new p.$hl(r,o.stat,n):o instanceof p.$gl?new p.$gl(r,o.fileOperationResult,o.size,o.options):new p.$fl(r,(0,p.$bl)(o),n)}G(o,s,n,r=Object.create(null)){const c=o.readFileStream(s,r,n);return(0,d.$ze)(c,{data:b=>b instanceof S.$Ce?b:S.$Ce.wrap(b),error:b=>this.F(b,s,r)},b=>S.$Ce.concat(b))}H(o,s,n,r=Object.create(null)){const c=(0,S.$Se)();return(0,m.$Bq)(o,s,c,b=>b,{...r,bufferSize:this.a,errorTransformer:b=>this.F(b,s,r)},n),c}I(o,s,n){const r=(0,d.$qe)(c=>S.$Ce.concat(c));return(async()=>{try{let c;n?.atomic&&(0,p.$5k)(o)?c=await o.readFile(s,{atomic:!0}):c=await o.readFile(s),typeof n?.position=="number"&&(c=c.slice(n.position)),typeof n?.length=="number"&&(c=c.slice(0,n.length)),this.L(s,c.byteLength,n),r.end(S.$Ce.wrap(c))}catch(c){r.error(c),r.end()}})(),r}async J(o,s){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new p.$fl((0,v.localize)(12,null,this.sb(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.$pl&&s.etag===n.etag)throw new p.$hl((0,v.localize)(13,null),n,s);return this.L(o,n.size,s),n}L(o,s,n){if(typeof n?.limits?.size=="number"&&s>n.limits.size)throw new p.$gl((0,v.localize)(14,null,this.sb(o)),7,s,n)}async canMove(o,s,n){return this.M(o,s,"move",n)}async canCopy(o,s,n){return this.M(o,s,"copy",n)}async M(o,s,n,r){if(o.toString()!==s.toString())try{const c=n==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(s),s);await this.Q(c,o,b,s,n,r)}catch(c){return c}return!0}async move(o,s,n){const r=this.qb(await this.n(o),o),c=this.qb(await this.n(s),s),b=await this.N(r,o,c,s,"move",!!n),j=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$cl(o,b==="move"?2:3,j)),j}async copy(o,s,n){const r=await this.m(o),c=this.qb(await this.n(s),s),b=await this.N(r,o,c,s,"copy",!!n),j=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$cl(o,b==="copy"?3:2,j)),j}async N(o,s,n,r,c,b){if(s.toString()===r.toString())return c;const{exists:j,isSameResourceWithDifferentPathCase:C}=await this.Q(o,s,n,r,c,b);if(j&&!C&&b&&await this.del(r,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(r)),c==="copy"){if(o===n&&(0,p.$1k)(o))await o.copy(s,r,{overwrite:b});else{const I=await this.resolve(s);I.isDirectory?await this.P(o,I,n,r):await this.O(o,s,n,r)}return c}else return o===n?(await o.rename(s,r,{overwrite:b}),c):(await this.N(o,s,n,r,"copy",b),await this.del(s,{recursive:!0}),"copy")}async O(o,s,n,r){if((0,p.$3k)(o)&&(0,p.$3k)(n))return this.jb(o,s,n,r);if((0,p.$3k)(o)&&(0,p.$Zk)(n))return this.pb(o,s,n,r);if((0,p.$Zk)(o)&&(0,p.$3k)(n))return this.nb(o,s,n,r);if((0,p.$Zk)(o)&&(0,p.$Zk)(n))return this.lb(o,s,n,r)}async P(o,s,n,r){await n.mkdir(r),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async c=>{const b=this.R(n).providerExtUri.joinPath(r,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),n,b):this.O(o,c.resource,n,b)}))}async Q(o,s,n,r,c,b){let j=!1;if(o===n){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(o);if(O||(j=I.isEqual(s,r)),j&&c==="copy")throw new Error((0,v.localize)(15,null,this.sb(s),this.sb(r)));if(!j&&I.isEqualOrParent(r,s))throw new Error((0,v.localize)(16,null,this.sb(s),this.sb(r)))}const C=await this.exists(r);if(C&&!j){if(!b)throw new p.$fl((0,v.localize)(17,null,this.sb(s),this.sb(r)),4);if(o===n){const{providerExtUri:I}=this.R(o);if(I.isEqualOrParent(s,r))throw new Error((0,v.localize)(18,null,this.sb(s),this.sb(r)))}}return{exists:C,isSameResourceWithDifferentPathCase:j}}R(o){const s=this.S(o);return{providerExtUri:s?$.$Tg:$.$Vg,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$cl(o,0,n)),n}async U(o,s){const n=[],{providerExtUri:r}=this.R(o);for(;!r.isEqual(s,r.dirname(s));)try{if(!((await o.stat(s)).type&p.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(s)));break}catch(c){if((0,p.$al)(c)!==p.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(s)),s=r.dirname(s)}for(let c=n.length-1;c>=0;c--){s=r.joinPath(s,n[c]);try{await o.mkdir(s)}catch(b){if((0,p.$al)(b)!==p.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,s){try{await this.W(o,s)}catch(n){return n}return!0}async W(o,s){const n=this.qb(await this.j(o),o),r=!!s?.useTrash;if(r&&!(n.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const c=s?.atomic;if(c&&!(n.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(r&&c)throw new Error((0,v.localize)(22,null,this.sb(o)));let b;try{b=await n.stat(o)}catch{}if(b)this.rb(o,b);else throw new p.$fl((0,v.localize)(23,null,this.sb(o)),1);if(!!!s?.recursive){const C=await this.resolve(o);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return n}async del(o,s){const n=await this.W(o,s);let r=s;if((0,p.$7k)(n)&&!r?.atomic){const C=n.enforceAtomicDelete?.(o);C&&(r={...s,atomic:C})}const c=!!r?.useTrash,b=!!r?.recursive,j=r?.atomic??!1;await n.delete(o,{recursive:b,useTrash:c,atomic:j}),this.r.fire(new p.$cl(o,1))}async cloneFile(o,s){const n=await this.j(o),r=this.qb(await this.n(s),s);if(!(n===r&&this.R(n).providerExtUri.isEqual(o,s)))return n===r&&(0,p.$2k)(n)?n.cloneFile(o,s):(await this.U(r,this.R(r).providerExtUri.dirname(s)),n===r&&(0,p.$1k)(n)?this.cb.queueFor(o,()=>n.copy(o,s,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(o,()=>this.O(n,o,r,s),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:w.ab++})}watch(o,s={recursive:!1,excludes:[]}){const n=new u.$Tc;let r=!1,c=()=>{r=!0};n.add((0,u.$Sc)(()=>c())),(async()=>{try{const j=await this.bb(o,s);r?(0,u.$Pc)(j):c=()=>(0,u.$Pc)(j)}catch(j){this.b.error(j)}})();const b=s.correlationId;if(typeof b=="number"){const j=n.add(new P.$be);return n.add(this.X.event(I=>{I.correlates(b)&&j.fire(I)})),{onDidChange:j.event,dispose:()=>n.dispose()}}return n}async bb(o,s){const n=await this.j(o),r=(0,E.$ej)([this.R(n).providerExtUri.getComparisonKey(o),s]);let c=this.$.get(r);return c||(c={count:0,disposable:n.watch(o,s)},this.$.set(r,c)),c.count+=1,(0,u.$Sc)(()=>{c&&(c.count--,c.count===0&&((0,u.$Pc)(c.disposable),this.$.delete(r)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,u.$Pc)(o.disposable);this.$.clear()}async db(o,s,n,r){return this.cb.queueFor(s,async()=>{const c=await o.open(s,{create:!0,unlock:n?.unlock??!1});try{(0,d.$oe)(r)||(0,d.$pe)(r)?await this.eb(o,c,r):await this.fb(o,c,r)}catch(b){throw(0,p.$$k)(b)}finally{await o.close(c)}},this.R(o).providerExtUri)}async eb(o,s,n){let r=0,c;if((0,d.$pe)(n)){if(n.buffer.length>0){const b=S.$Ce.concat(n.buffer);await this.gb(o,s,b,b.byteLength,r,0),r+=b.byteLength}if(n.ended)return;c=n.stream}else c=n;return new Promise((b,j)=>{(0,d.$ue)(c,{onData:async C=>{c.pause();try{await this.gb(o,s,C,C.byteLength,r,0)}catch(I){return j(I)}r+=C.byteLength,setTimeout(()=>c.resume())},onError:C=>j(C),onEnd:()=>b()})})}async fb(o,s,n){let r=0,c;for(;(c=n.read())!==null;)await this.gb(o,s,c,c.byteLength,r,0),r+=c.byteLength}async gb(o,s,n,r,c,b){let j=0;for(;j<r;){const C=await o.write(s,c+j,n.buffer,b+j,r-j);j+=C}}async hb(o,s,n,r){return this.cb.queueFor(s,()=>this.ib(o,s,n,r),this.R(o).providerExtUri)}async ib(o,s,n,r){let c;r instanceof S.$Ce?c=r:(0,d.$oe)(r)?c=await(0,S.$Oe)(r):(0,d.$pe)(r)?c=await(0,S.$Pe)(r):c=(0,S.$Me)(r),await o.writeFile(s,c.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(o,s,n,r){return this.cb.queueFor(r,()=>this.kb(o,s,n,r),this.R(n).providerExtUri)}async kb(o,s,n,r){let c,b;try{c=await o.open(s,{create:!1}),b=await n.open(r,{create:!0,unlock:!1});const j=S.$Ce.alloc(this.a);let C=0,I=0,O=0;do O=await o.read(c,C,j.buffer,I,j.byteLength-I),await this.gb(n,b,j,O,C,I),C+=O,I+=O,I===j.byteLength&&(I=0);while(O>0)}catch(j){throw(0,p.$$k)(j)}finally{await D.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof b=="number"?n.close(b):Promise.resolve()])}}async lb(o,s,n,r){return this.cb.queueFor(r,()=>this.mb(o,s,n,r),this.R(n).providerExtUri)}async mb(o,s,n,r){return n.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,n,r){return this.cb.queueFor(r,()=>this.ob(o,s,n,r),this.R(n).providerExtUri)}async ob(o,s,n,r){const c=await n.open(r,{create:!0,unlock:!1});try{const b=await o.readFile(s);await this.gb(n,c,S.$Ce.wrap(b),b.byteLength,0,0)}catch(b){throw(0,p.$$k)(b)}finally{await n.close(c)}}async pb(o,s,n,r){const c=await(0,S.$Oe)(this.H(o,s,R.CancellationToken.None));await this.hb(n,r,void 0,c)}qb(o,s){if(o.capabilities&2048)throw new p.$fl((0,v.localize)(25,null,this.sb(s)),6);return o}rb(o,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.$fl((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$Cq=a,e.$Cq=a=w=Se([ie(0,f.$Wj)],a)}),define(re[94],ae([0,1,43,315,8,31,17,3,32,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,D.gracefulify)(i)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$bj)(o)}`)}})();class t extends f.$Mq{static{this.J=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=E.Event.None,this.O=new R.$Bc(r=>k.$Ug.getComparisonKey(r)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,y.$k&&(this.L|=1024)),this.L}async stat(s){try{const{stat:n,symbolicLink:r}=await d.SymlinkSupport.stat(this.I(s));return{type:this.N(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.gb(n)}}async M(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await d.Promises.readdir(this.I(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async c=>{try{let b;c.isSymbolicLink()?b=(await this.stat((0,k.$4g)(s,c.name))).type:b=this.N(c),r.push([c.name,b])}catch(b){this.a.trace(b)}})),r}catch(n){throw this.gb(n)}}N(s,n){let r;return n?.dangling?r=p.FileType.Unknown:s.isFile()?r=p.FileType.File:s.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,n&&(r|=p.FileType.SymbolicLink),r}async P(s){const n=this.I(s);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.O.get(s);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const c=new S.$ph;return this.O.set(s,c),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.O.get(s)===c&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.O.delete(s)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),r=await this.P(s));const c=this.I(s);return await d.Promises.readFile(c)}catch(c){throw this.gb(c)}finally{r?.dispose()}}Q(s){t.J&&this.a.trace(s)}readFileStream(s,n,r){const c=(0,$.$qe)(b=>P.$Ce.concat(b.map(j=>P.$Ce.wrap(j))).buffer);return(0,m.$Bq)(this,s,c,b=>b.buffer,{...n,bufferSize:256*1024},r),c}async writeFile(s,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.R(s)?this.S(s,(0,k.$4g)((0,k.$3g)(s),`${(0,k.$1g)(s)}${r.atomic.postfix}`),n,r):this.U(s,n,r)}async R(s){try{const n=this.I(s),{symbolicLink:r}=await d.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async S(s,n,r,c){const b=new u.$Tc;try{b.add(await this.P(s)),b.add(await this.P(n)),await this.U(n,r,c,!0);try{await this.rename(n,s,{overwrite:!0})}catch(j){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw j}}finally{b.dispose()}}async U(s,n,r,c){let b;try{const j=this.I(s);if(!r.create||!r.overwrite){if(await d.Promises.exists(j)){if(!r.overwrite)throw(0,p.$0k)((0,v.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.$0k)((0,v.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(s,{create:!0,unlock:r.unlock},c),await this.write(b,0,n,0,n.byteLength)}catch(j){throw await this.hb(s,j)}finally{typeof b=="number"&&await this.close(b)}}static{this.Z=!0}static configureFlushOnWrite(s){t.Z=s}async open(s,n,r){const c=this.I(s);let b;(0,p.$Xk)(n)&&!r&&(b=await this.P(s));let j;try{if((0,p.$Xk)(n)&&n.unlock)try{const{stat:I}=await d.SymlinkSupport.stat(c);I.mode&128||await d.Promises.chmod(c,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let C;if((0,p.$Xk)(n)){if(y.$i)try{await d.Promises.truncate(c,0),C="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}C||(C="w")}else C="r";j=await d.Promises.open(c,C)}catch(C){throw b?.dispose(),(0,p.$Xk)(n)?await this.hb(s,C):this.gb(C)}if(this.W.set(j,0),(0,p.$Xk)(n)&&this.Y.set(j,s),b){const C=this.X.get(j);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${j} (${c})`),this.X.set(j,b),C&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${j} (${c})`),C.dispose())}return j}async close(s){const n=this.X.get(s);try{if(this.W.delete(s),this.Y.delete(s)&&t.Z)try{await d.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await d.Promises.close(s)}catch(r){throw this.gb(r)}finally{n&&(this.X.get(s)===n&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.X.delete(s)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,c,b){const j=this.$(s,n);let C=null;try{C=(await d.Promises.read(s,r,c,b,j)).bytesRead}catch(I){throw this.gb(I)}finally{this.ab(s,j,C)}return C}$(s,n){return n===this.W.get(s)?null:n}ab(s,n,r){const c=this.W.get(s);typeof c=="number"&&(typeof n=="number"||(typeof r=="number"?this.W.set(s,c+r):this.W.delete(s)))}async write(s,n,r,c,b){return(0,S.$Kh)(()=>this.bb(s,n,r,c,b),100,3)}async bb(s,n,r,c,b){const j=this.$(s,n);let C=null;try{C=(await d.Promises.write(s,r,c,b,j)).bytesWritten}catch(I){throw await this.hb(this.Y.get(s),I)}finally{this.ab(s,j,C)}return C}async mkdir(s){try{await d.Promises.mkdir(this.I(s))}catch(n){throw this.gb(n)}}async delete(s,n){try{const r=this.I(s);if(n.recursive){let c;n?.atomic!==!1&&n.atomic.postfix&&(c=(0,g.$kc)((0,g.$nc)(r),`${(0,g.$oc)(r)}${n.atomic.postfix}`)),await d.Promises.rm(r,d.RimRafMode.MOVE,c)}else try{await d.Promises.unlink(r)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let b=!1;try{const{stat:j,symbolicLink:C}=await d.SymlinkSupport.stat(r);b=j.isDirectory()&&!C}catch{}if(b)await d.Promises.rmdir(r);else throw c}else throw c}}catch(r){throw this.gb(r)}}async rename(s,n,r){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"move",r.overwrite),await d.Promises.rename(c,b)}catch(j){throw(j.code==="EINVAL"||j.code==="EBUSY"||j.code==="ENAMETOOLONG")&&(j=new Error((0,v.localize)(2,null,(0,g.$oc)(c),(0,g.$oc)((0,g.$nc)(b)),j.toString()))),this.gb(j)}}async copy(s,n,r){const c=this.I(s),b=this.I(n);if(c!==b)try{await this.cb(s,n,"copy",r.overwrite),await d.Promises.copy(c,b,{preserveSymlinks:!0})}catch(j){throw(j.code==="EINVAL"||j.code==="EBUSY"||j.code==="ENAMETOOLONG")&&(j=new Error((0,v.localize)(3,null,(0,g.$oc)(c),(0,g.$oc)((0,g.$nc)(b)),j.toString()))),this.gb(j)}}async cb(s,n,r,c){const b=this.I(s),j=this.I(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,h.$pg)(b,j,!0)),C){if(r==="copy")throw(0,p.$0k)((0,v.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const O=await this.M(s);if(!O)throw(0,p.$0k)((0,v.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const M=await this.M(n);if(M){if(!c)throw(0,p.$0k)((0,v.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);O.type&p.FileType.File&&M.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.db(s,n,!1)}async db(s,n,r){const c=this.I(s),b=this.I(n),j=!!(this.capabilities&1024);if((0,h.$pg)(c,b,!j))return;const C=new u.$Tc;try{C.add(await this.P(s)),C.add(await this.P(n)),r&&await d.Promises.mkdir((0,g.$nc)(b),{recursive:!0}),await d.Promises.copyFile(c,b)}catch(I){if(I.code==="ENOENT"&&!r)return this.db(s,n,!0);throw this.gb(I)}finally{C.dispose()}}t(s,n,r){return new w.$Tq(c=>s(c),c=>n(c),r)}F(s,n,r){return new a.$3q(c=>s(c),c=>n(c),r)}gb(s){if(s instanceof p.$9k)return s;let n=s,r;switch(s.code){case"ENOENT":r=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=p.FileSystemProviderErrorCode.Unknown;break;default:r=p.FileSystemProviderErrorCode.Unknown}return(0,p.$0k)(n,r)}async hb(s,n){let r=this.gb(n);if(s&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.I(s));c.mode&128||(r=(0,p.$0k)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.$4q=t}),define(re[227],ae([0,1,3,94,2,17,63,23]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.$As=void 0;class h extends S.$Uc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,$){const d=this.c(y);switch(k){case"stat":return this.g(d,$[0]);case"readdir":return this.h(d,$[0]);case"open":return this.r(d,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(d,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(d,$[0],$[1],$[2]);case"rename":return this.z(d,$[0],$[1],$[2]);case"copy":return this.C(d,$[0],$[1],$[2]);case"cloneFile":return this.D(d,$[0],$[1]);case"mkdir":return this.w(d,$[0]);case"delete":return this.y(d,$[0],$[1]);case"watch":return this.I(d,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,$){const d=this.c(y);switch(k){case"fileChange":return this.H(d,$[0]);case"readFileStream":return this.m(d,$[0],$[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const $=this.f(y,k,!0);return this.a.stat($)}h(y,k){const $=this.f(y,k);return this.a.readdir($)}async j(y,k,$){const d=this.f(y,k,!0),v=await this.a.readFile(d,$);return R.$Ce.wrap(v)}m(y,k,$){const d=this.f(y,k,!0),v=new E.$me,p=new i.$be({onDidRemoveLastListener:()=>{v.cancel()}}),m=this.a.readFileStream(d,$,v.token);return(0,P.$ue)(m,{onData:f=>p.fire(R.$Ce.wrap(f)),onError:f=>p.fire(f),onEnd:()=>{p.fire("end"),p.dispose(),v.dispose()}}),p.event}n(y,k,$,d){const v=this.f(y,k);return this.a.writeFile(v,$.buffer,d)}r(y,k,$){const d=this.f(y,k,!0);return this.a.open(d,$)}s(y){return this.a.close(y)}async t(y,k,$){const d=R.$Ce.alloc($),p=await this.a.read(y,k,d.buffer,0,$);return[d,p]}u(y,k,$,d,v){return this.a.write(y,k,$.buffer,d,v)}w(y,k){const $=this.f(y,k);return this.a.mkdir($)}y(y,k,$){const d=this.f(y,k);return this.a.delete(d,$)}z(y,k,$,d){const v=this.f(y,k),p=this.f(y,$);return this.a.rename(v,p,d)}C(y,k,$,d){const v=this.f(y,k),p=this.f(y,$);return this.a.copy(v,p,d)}D(y,k,$){const d=this.f(y,k),v=this.f(y,$);return this.a.cloneFile(d,v)}H(y,k){const $=new i.$be({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,$))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(k)),this.F.delete(k)}});return $.event}async I(y,k,$,d,v){const p=this.F.get(k);if(p){const m=this.f(y,d),f=p.watch($,m,v);this.G.set(k+$,f)}}async J(y,k){const $=y+k,d=this.G.get($);d&&((0,S.$Pc)(d),this.G.delete($))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$As=h;class u extends S.$Uc{constructor(y,k,$,d){super(),this.c=y,this.f=$,this.g=d,this.a=new Map,this.b=this.B(new D.$4q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new i.$be);this.B(k.event($=>{y.fire($.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile($=>k.fire($))),this.B(this.b.onDidWatchError($=>y.fire($)))}j(y){}m(y){}watch(y,k,$){const d=this.m(this.g);return Array.isArray(d)&&($.excludes=[...$.excludes,...d]),this.a.set(y,this.b.watch(k,$)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$Bs=u}),define(re[228],ae([0,1,14,180,4,7,16,9,227,157,47]),function(Z,e,i,D,S,R,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class y extends h.$As{constructor(d,v,p){super(d,v),this.M=p}c(d){return u.$tn}f(d,v){return R.URI.revive(v)}async y(d,v,p){if(!p.useTrash)return super.y(d,v,p);const m=this.f(d,v),f=(0,E.$ic)(m.fsPath);try{await i.shell.trashItem(f)}catch(l){throw(0,P.$0k)(S.$i?(0,D.localize)(0,null,(0,E.$oc)(f),(0,g.$bj)(l)):(0,D.localize)(1,null,(0,E.$oc)(f),(0,g.$bj)(l)),P.FileSystemProviderErrorCode.Unknown)}}L(d,v){return new k(d,v,this.b,this.M)}}e.$Obc=y;class k extends h.$Bs{watch(d,v,p){if(p.recursive)throw(0,P.$0k)("Recursive file watching is not supported from main process for performance reasons.",P.FileSystemProviderErrorCode.Unavailable);return super.watch(d,v,p)}}}),define(re[229],ae([0,1,5]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;class D extends i.$3j{constructor(R=i.$Zj){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(P=>{this.n?.setLevel(P)}))}set logger(R){this.n=R;for(const{level:P,message:E}of this.m)(0,i.log)(R,P,E);this.m=[]}g(R,P){this.n?(0,i.log)(this.n,R,P):this.getLevel()<=R&&this.m.push({level:R,message:P})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$C$b=D}),define(re[230],ae([0,1,7,3,5,2]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=void 0;class P extends S.$8j{constructor(y,k,$,d,v){super(k,$,d),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(p=>{(0,S.$Yj)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this.B(v.listen("onDidChangeVisibility",y)(([p,m])=>super.setVisibility(i.URI.revive(p),m))),this.B(v.listen("onDidChangeLoggers",y)(({added:p,removed:m})=>{for(const f of p)super.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of m)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new S.$6j({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,$){return new E(this.t,y,k,$,this.r)}static setLogLevel(y,k,$){return y.call("setLogLevel",[k,$])}}e.$3r=P;class E extends S.$3j{constructor(y,k,$,d,v){super(d?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[k,d,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const $=[[y,k]];this.m?this.u($):this.n.push(...$)}u(y){this.r.call("log",[this.s,y])}}class h{constructor(y,k){this.a=y,this.b=k}listen(y,k){const $=this.b(y);switch(k){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(v=>this.c(v,$)),removed:[...d.removed].map(v=>this.c(v,$))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,d=>[$.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,d=>(0,S.$Yj)(d)?d:[$.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,$){const d=this.b(y);switch(k){case"setLogLevel":return(0,S.$Yj)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(i.URI.revive(d.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,d)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$4r=h;class u extends R.$Uc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel($=>k.call("setLogLevel",[$]))),k.call("getRegisteredLoggers").then($=>{for(const d of $)y.registerLogger({...d,resource:i.URI.revive(d.resource)})}),this.B(k.listen("onDidChangeVisibility")(([$,d])=>y.setVisibility(i.URI.revive($),d))),this.B(k.listen("onDidChangeLoggers")(({added:$,removed:d})=>{for(const v of $)y.registerLogger({...v,resource:i.URI.revive(v.resource)});for(const v of d)y.deregisterLogger(v.resource)}))}}e.$5r=u}),define(re[231],ae([0,1,2,5]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class S extends i.$Uc{constructor(P,E=[]){super(),this.a=new D.$7j([P,...E]),this.B(P.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...E){this.a.trace(P,...E)}debug(P,...E){this.a.debug(P,...E)}info(P,...E){this.a.info(P,...E)}warn(P,...E){this.a.warn(P,...E)}error(P,...E){this.a.error(P,...E)}flush(){this.a.flush()}}e.$AQ=S}),define(re[232],ae([0,1,31,7,5]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class R{constructor(E){this.b=E,this.a=new i.$Bc}listen(E,h,u){switch(h){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,u){switch(h){case"createLogger":this.c(D.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(D.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,S.$Yj)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(D.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:D.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(u[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,u){this.a.set(E,this.b.createLogger(E,h,u))}d(E,h){let u=console.log;switch(E){case S.LogLevel.Error:u=console.error;break;case S.LogLevel.Warning:u=console.warn;break;case S.LogLevel.Info:u=console.info;break}u.call(console,...h)}e(E,h){const u=this.a.get(E);if(!u)throw new Error("Create the logger before logging");for(const[g,y]of h)(0,S.log)(u,g,y)}}e.$Jcc=R}),define(re[233],ae([0,1,16,5]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=void 0;var S;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(S||(S={}));async function R(u,g,y,k,$){try{const d=await new Promise((p,m)=>{Z(["@vscode/spdlog"],p,m)});d.setFlushOn(S.Trace);const v=await d.createAsyncRotatingLogger(u,g,y,k);return $?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function P(u,g,y){switch(g){case D.LogLevel.Trace:u.trace(y);break;case D.LogLevel.Debug:u.debug(y);break;case D.LogLevel.Info:u.info(y);break;case D.LogLevel.Warning:u.warn(y);break;case D.LogLevel.Error:u.error(y);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function E(u,g){switch(g){case D.LogLevel.Trace:u.setLevel(S.Trace);break;case D.LogLevel.Debug:u.setLevel(S.Debug);break;case D.LogLevel.Info:u.setLevel(S.Info);break;case D.LogLevel.Warning:u.setLevel(S.Warning);break;case D.LogLevel.Error:u.setLevel(S.Error);break;case D.LogLevel.Off:u.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class h extends D.$3j{constructor(g,y,k,$,d){super(),this.m=[],this.setLevel(d),this.n=this.s(g,y,k,$),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(g,y,k,$){const d=k?6:1,v=30/d*i.$sl.MB,p=await R(g,y,v,d,$);if(p){this.r=p,E(this.r,this.getLevel());for(const{level:m,message:f}of this.m)P(this.r,m,f);this.m=[]}}g(g,y){this.r?P(this.r,g,y):this.getLevel()<=g&&this.m.push({level:g,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pQ=h}),define(re[234],ae([0,1,33,5,233]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;class R extends D.$8j{s(E,h,u){return new S.$pQ((0,i.$Mg)(),E.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,h)}}e.$qQ=R}),define(re[67],ae([0,1,31,3,6,5,234]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=void 0,e.$jbc=(0,S.$ri)(R.$Xj);class E extends P.$qQ{constructor(){super(...arguments),this.u=new i.$Bc}createLogger(u,g,y){y!==void 0&&this.u.set(this.n(u),y);try{return super.createLogger(u,g)}catch(k){throw this.u.delete(this.n(u)),k}}registerLogger(u,g){g!==void 0&&this.u.set(u.resource,g),super.registerLogger(u)}deregisterLogger(u){this.u.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const g=[];for(const y of super.getRegisteredLoggers())u===this.u.get(y.resource)&&g.push(y);return g}getOnDidChangeLogLevelEvent(u){return D.Event.filter(this.onDidChangeLogLevel,g=>(0,R.$Yj)(g)||this.w(g[0],u))}getOnDidChangeVisibilityEvent(u){return D.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,u))}getOnDidChangeLoggersEvent(u){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(k=>this.w(k.resource,u)),removed:[...g.removed].filter(k=>this.w(k.resource,u))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(u){for(const[g,y]of this.u)y===u&&this.deregisterLogger(g)}w(u,g){const y=this.u.get(u);return y===void 0||y===g}dispose(){super.dispose(),this.u.clear()}}e.$kbc=E}),define(re[235],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=i,e.$3bc=D,e.$4bc=S,e.$5bc=R;function i(P){return P.submenu!==void 0}function D(P){return P.id==="vscode.menubar.separator"}function S(P){return P.uri!==void 0}function R(P){return!i(P)&&!D(P)&&!S(P)}}),define(re[39],ae([0,1,3,71,2,6]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=void 0,e.$$n=(0,R.$qi)("policy");class P extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$be),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const g=Object.keys(this.f).length;return this.f={...u,...this.f},g!==Object.keys(this.f).length&&await this.j(u),D.Iterable.reduce(this.g.entries(),(y,[k,$])=>({...y,[k]:$}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(u,[g,y])=>({...u,[g]:{definition:y,value:this.g.get(g)}}),{})}}e.$_n=P;class E{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ao=E}),define(re[236],ae([0,1,8,3,71,12,16,5,39]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;function u(y,k){const $=[];for(const d of new Set(S.Iterable.concat(y.keys(),k.keys())))y.get(d)!==k.get(d)&&$.push(d);return $}let g=class extends h.$_n{constructor(k,$,d){super(),this.m=k,this.n=$,this.s=d,this.c=this.B(new i.$oh(500));const v=D.Event.filter($.onDidFilesChange,p=>p.affects(k));this.B($.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const $=await this.n.readFile(this.m),d=JSON.parse($.value.toString());if(!(0,R.$6f)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.f[v]&&k.set(v,d[v])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return k}async w(){const k=await this.u(),$=u(this.g,k);this.g=k,$.length>0&&this.h.fire($)}};e.$3cc=g,e.$3cc=g=Se([ie(1,P.$Wk),ie(2,E.$Wj)],g)}),define(re[237],ae([0,1,3,2,39]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=void 0;class R{constructor(h){this.b=h,this.a=new D.$Tc}listen(h,u){switch(u){case"onDidChange":return i.Event.map(this.b.onDidChange,g=>g.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(h,u,g){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$Acc=R;class P extends S.$_n{constructor(h,u){super(),this.a=u;for(const g in h){const{definition:y,value:k}=h[g];this.f[g]=y,k!==void 0&&this.g.set(g,k)}this.a.listen("onDidChange")(g=>{for(const y in g){const k=g[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(g))})}async j(h){const u=await this.a.call("updatePolicyDefinitions",h);for(const g in u)this.g.set(g,u[g])}}e.$Bcc=P}),define(re[238],ae([0,1,39,8,2,5]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let P=class extends i.$_n{constructor(h,u){super(),this.m=h,this.n=u,this.a=new D.$kh,this.b=this.B(new S.$Vc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:u}=await new Promise((g,y)=>{Z(["@vscode/policy-watcher"],g,y)});await this.a.queue(()=>new Promise((g,y)=>{try{this.b.value=u(this.n,h,k=>{this.t(k),g()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const u in h){const g=h[u];g===void 0?this.g.delete(u):this.g.set(u,g)}this.h.fire(Object.keys(h))}};e.$2cc=P,e.$2cc=P=Se([ie(0,R.$Wj)],P)}),define(re[80],ae([0,1,36]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const R=S.context.configuration();if(R)D=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:R.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(re[27],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,i.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"}),define(re[239],ae([0,1,8,5]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;let S=class{constructor(P,E,h){this.a=P,this.b=E,this.c=h}async inspect(P){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$rh)(P);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const P=this.a.webContents.debugger;P.attach(),await P.sendCommand("Profiler.enable")}async e(){const P=this.a.webContents.debugger;await P.sendCommand("Profiler.disable"),P.detach()}};e.$Rbc=S,e.$Rbc=S=Se([ie(2,D.$Wj)],S)}),define(re[81],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0,e.$5ac=(0,i.$qi)("protocolMainService")}),define(re[45],ae([0,1,139,12]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class S{constructor(){this.a=new Map}add(P,E){i.ok(D.$4f(P)),i.ok(D.$6f(E)),i.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,E)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$9n=new S}),define(re[240],ae([0,1,3,45]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function S(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this.b=new i.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,u){this.a[S(h)]=u,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const P=new R;D.$9n.add(e.$0n.JSONContribution,P)}),define(re[52],ae([0,1,22,3,12,165,18,240,45]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=v,e.$no=p,e.$oo=m,e.$po=l,e.$qo=w;var u;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$bo={Configuration:"base.contributions.configuration"};var g;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const y=h.$9n.as(E.$0n.JSONContribution);class k{constructor(){this.h=new Set,this.i=new D.$be,this.onDidSchemaChange=this.i.event,this.j=new D.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:n,source:r}of t)for(const c in n)if(o.add(c),e.$lo.test(c)){const b=this.a.get(c),j=b?.valuesSources??new Map;if(r)for(const M of Object.keys(n[c]))j.set(M,r);const C={...b?.value||{},...n[c]};this.a.set(c,{source:r,value:C,valuesSources:j});const I=(0,P.$7i)(c),O={type:"object",default:C,description:R.localize(1,null,I),$ref:e.$io,defaultDefaultValue:C,source:S.$4f(r)?void 0:r,defaultValueSource:r};s.push(...v(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:n[c],source:r});const b=this.d[c];b&&(this.w(c,b),this.r(c,b))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:n}of t)for(const r in s){const c=this.a.get(r),b=S.$4f(n)?n:n?.id,j=S.$4f(c?.source)?c?.source:c?.source?.id;if(b===j)if(o.add(r),this.a.delete(r),e.$lo.test(r))delete this.d[r],delete this.b.properties[r];else{const C=this.d[r];C&&(this.w(r,C),this.r(r,C))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,o){const s=n=>{if(n.properties)for(const r in n.properties){o.add(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>s(r))};for(const n of t){s(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,o=!0,s,n,r=3,c){r=S.$ag(t.scope)?r:t.scope;const b=t.properties;if(b)for(const C in b){const I=b[C];if(o&&l(C,I)){delete b[C];continue}if(I.source=s,I.defaultDefaultValue=b[C].default,this.w(C,I),e.$lo.test(C)?I.scope=void 0:(I.scope=S.$ag(I.scope)?r:I.scope,I.restricted=S.$ag(I.restricted)?!!n?.includes(C):I.restricted),b[C].hasOwnProperty("included")&&!b[C].included){this.f[C]=b[C],delete b[C];continue}else this.d[C]=b[C],b[C].policy?.name&&this.e.set(b[C].policy.name,C);!b[C].deprecationMessage&&b[C].markdownDeprecationMessage&&(b[C].deprecationMessage=b[C].markdownDeprecationMessage),c.add(C)}const j=t.allOf;if(j)for(const C of j)this.p(C,o,s,n,r,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const n=s.properties;if(n)for(const c in n)this.r(c,n[c]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$co.properties[t]=o,o.scope){case 1:e.$do.properties[t]=o;break;case 2:e.$eo.properties[t]=o;break;case 6:e.$fo.properties[t]=o;break;case 3:e.$go.properties[t]=o;break;case 4:e.$ho.properties[t]=o;break;case 5:e.$ho.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$co.properties[t],o.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$io};this.w(o,s),e.$co.properties[o]=s,e.$do.properties[o]=s,e.$eo.properties[o]=s,e.$fo.properties[o]=s,e.$go.properties[o]=s,e.$ho.properties[o]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let n=s?.value,r=s?.source;S.$$f(n)&&(n=o.defaultDefaultValue,r=void 0),S.$$f(n)&&(n=m(o.type)),o.default=n,o.defaultValueSource=r}}const $="\\[([^\\]]+)\\]",d=new RegExp($,"g");e.$ko=`^(${$})+$`,e.$lo=new RegExp(e.$ko);function v(a){const t=[];if(e.$lo.test(a)){let o=d.exec(a);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=d.exec(a)}}return(0,i.$Mb)(t)}function p(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function m(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;h.$9n.add(e.$bo.Configuration,f);function l(a,t){return a.trim()?e.$lo.test(a)?R.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function w(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(re[123],ae([0,1,22,3,42,2,31,35,12,7,18,52,45]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=l;function $(o){return Object.isFrozen(o)?o:E.$Xn(o)}class d{static createEmptyModel(s){return new d({},[],[],void 0,s)}constructor(s,n,r,c,b){this.b=s,this.c=n,this.d=r,this.raw=c,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof d)return n;const r=new v("",this.f);return r.parseRaw(n),r.configurationModel});this.g=s.reduce((n,r)=>r===n?r:n.merge(r),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$5i)(this.contents,s):this.contents}inspect(s,n){const r=this;return{get value(){return $(r.rawConfiguration.getValue(s))},get override(){return n?$(r.rawConfiguration.getOverrideValue(s,n)):void 0},get merged(){return $(n?r.rawConfiguration.override(n).getValue(s):r.rawConfiguration.getValue(s))},get overrides(){const c=[];for(const{contents:b,identifiers:j,keys:C}of r.rawConfiguration.overrides){const I=new d(b,C,[],void 0,r.f).getValue(s);I!==void 0&&c.push({identifiers:j,value:I})}return c.length?$(c):void 0}}}getOverrideValue(s,n){const r=this.j(n);return r?s?(0,g.$5i)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return i.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return i.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.h(s),this.a.set(s,n)),n}merge(...s){const n=E.$Wn(this.contents),r=E.$Wn(this.overrides),c=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const j of s)if(b.push(...j.raw?.length?j.raw:[j]),!j.isEmpty()){this.i(n,j.contents);for(const C of j.overrides){const[I]=r.filter(O=>i.$ub(O.identifiers,C.identifiers));I?(this.i(I.contents,C.contents),I.keys.push(...C.keys),I.keys=i.$Mb(I.keys)):r.push(E.$Wn(C))}for(const C of j.keys)c.indexOf(C)===-1&&c.push(C)}return new d(n,c,r,b.every(j=>j instanceof d)?void 0:b,this.f)}h(s){const n=this.j(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const c of i.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let b=this.contents[c];const j=n[c];j&&(typeof b=="object"&&typeof j=="object"?(b=E.$Wn(b),this.i(b,j)):b=j),r[c]=b}return new d(r,this.keys,this.overrides,void 0,this.f)}i(s,n){for(const r of Object.keys(n)){if(r in s&&h.$6f(s[r])&&h.$6f(n[r])){this.i(s[r],n[r]);continue}s[r]=E.$Wn(n[r])}}j(s){let n=null,r=null;const c=b=>{b&&(r?this.i(r,b):r=E.$Wn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===s?n=b.contents:b.identifiers.includes(s)&&c(b.contents);return c(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.k(s,n,!0)}setValue(s,n){this.k(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,g.$4i)(this.contents,s),y.$lo.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>i.$ub(r.identifiers,(0,y.$mo)(s))),1))}k(s,n,r){(0,g.$3i)(this.contents,s,n,c=>this.f.error(c)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),y.$lo.test(s)&&this.overrides.push({identifiers:(0,y.$mo)(s),keys:Object.keys(this.contents[s]),contents:(0,g.$2i)(this.contents[s],c=>this.f.error(c))})}}e.$ro=d;class v{constructor(s,n){this.f=s,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!h.$ag(s)){const r=this.h(s);this.parseRaw(r,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:r,keys:c,overrides:b,restricted:j,hasExcludedProperties:C}=this.i(s,n);this.b=new d(r,c,b,C?[s]:void 0,this.g),this.c=j||[]}h(s){let n={},r=null,c=[];const b=[],j=[];function C(O){Array.isArray(c)?c.push(O):r!==null&&(c[r]=O)}const I={onObjectBegin:()=>{const O={};C(O),b.push(c),c=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{c=b.pop()},onArrayBegin:()=>{const O=[];C(O),b.push(c),c=O,r=null},onArrayEnd:()=>{c=b.pop()},onLiteralValue:C,onError:(O,M,F)=>{j.push({error:O,offset:M,length:F})}};if(s)try{S.$Kn(s,I),n=c[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}i(s,n){const r=k.$9n.as(y.$bo.Configuration).getConfigurationProperties(),c=this.j(s,r,!0,n);s=c.raw;const b=(0,g.$2i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),j=Object.keys(s),C=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:b,keys:j,overrides:C,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(s,n,r,c){let b=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:b};const j={},C=[];for(const I in s)if(y.$lo.test(I)&&r){const O=this.j(s[I],n,!1,c);j[I]=O.raw,b=b||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=n[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(I),!c.exclude?.includes(I)&&(c.include?.includes(I)||(M===void 0||c.scopes===void 0||c.scopes.includes(M))&&!(c.skipRestricted&&O?.restricted))?j[I]=s[I]:b=!0}return{raw:j,restricted:C,hasExcludedProperties:b}}l(s,n){const r=[];for(const c of Object.keys(s))if(y.$lo.test(c)){const b={};for(const j in s[c])b[j]=s[c][j];r.push({identifiers:(0,y.$mo)(c),keys:Object.keys(b),contents:(0,g.$2i)(b,n)})}return r}}e.$so=v;class p extends R.$Uc{constructor(s,n,r,c,b){super(),this.c=s,this.f=n,this.g=c,this.h=b,this.b=this.B(new D.$be),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),b),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,j=>j.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,j=>(j.isOperation(0)||j.isOperation(3)||j.isOperation(1)||j.isOperation(4))&&r.isEqual(j.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=p;class m{constructor(s,n,r,c,b,j,C,I,O,M,F,L,T){this.a=s,this.b=n,this.c=r,this.overrideIdentifiers=c,this.d=b,this.f=j,this.g=C,this.h=I,this.i=O,this.j=M,this.k=F,this.l=L,this.m=T}get value(){return $(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(s,n,r,c,b,j,C,I,O,M){this.j=s,this.l=n,this.m=r,this.n=c,this.p=b,this.q=j,this.r=C,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new P.$Bc,this.v=null}getValue(s,n,r){return this.w(s,n,r).getValue(s)}updateValue(s,n,r={}){let c;r.resource?(c=this.t.get(r.resource),c||(c=d.createEmptyModel(this.u),this.t.set(r.resource,c))):c=this.s,n===void 0?c.removeValue(s):c.setValue(s,n),r.resource||(this.h=null)}inspect(s,n,r){const c=this.w(s,n,r),b=this.A(n.resource,r),j=n.resource?this.t.get(n.resource)||this.s:this.s,C=new Set;for(const I of c.overrides)for(const O of I.identifiers)c.getOverrideValue(s,O)!==void 0&&C.add(O);return new m(s,n,c.getValue(s),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,b||void 0,j)}keys(s){const n=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,n){this.r.set(s,n),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:c,updated:b,removed:j}=a(this.j,s);n=[...c,...b,...j]}for(const c of n)for(const b of(0,y.$mo)(c)){const j=this.j.getKeysForOverrideIdentifier(b),C=s.getKeysForOverrideIdentifier(b),I=[...C.filter(O=>j.indexOf(O)===-1),...j.filter(O=>C.indexOf(O)===-1),...j.filter(O=>!E.$1n(this.j.override(b).getValue(O),s.override(b).getValue(O)))];r.push([b,I])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:r,removed:c}=a(this.l,s),b=[...n,...r,...c];return b.length&&this.updatePolicyConfiguration(s),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.applicationConfiguration,s),j=[...n,...r,...c];return j.length&&this.updateApplicationConfiguration(s),{keys:j,overrides:b}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.localUserConfiguration,s),j=[...n,...r,...c];return j.length&&this.updateLocalUserConfiguration(s),{keys:j,overrides:b}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.remoteUserConfiguration,s),j=[...n,...r,...c];return j.length&&this.updateRemoteUserConfiguration(s),{keys:j,overrides:b}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:c,overrides:b}=a(this.workspaceConfiguration,s),j=[...n,...r,...c];return j.length&&this.updateWorkspaceConfiguration(s),{keys:j,overrides:b}}compareAndUpdateFolderConfiguration(s,n){const r=this.folderConfigurations.get(s),{added:c,updated:b,removed:j,overrides:C}=a(r,n),I=[...c,...b,...j];return(I.length||!r)&&this.updateFolderConfiguration(s,n),{keys:I,overrides:C}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:c,removed:b,overrides:j}=a(n,void 0);return{keys:[...r,...c,...b],overrides:j}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,n,r){let c=this.x(n,r);return n.overrideIdentifier&&(c=c.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(c=c.merge(this.l)),c}x({resource:s},n){let r=this.y();if(n&&s){const c=n.getFolder(s);c&&(r=this.z(c.uri)||r);const b=this.t.get(s);b&&(r=r.merge(b))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let n=this.i.get(s);if(!n){const r=this.y(),c=this.r.get(s);c?(n=r.merge(c),this.i.set(s,n)):n=r}return n}A(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,n)=>{const{contents:r,overrides:c,keys:b}=this.r.get(n);return s.push([n,{contents:r,overrides:c,keys:b}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.q.keys.forEach(n=>s.add(n)),this.r.forEach(n=>n.keys.forEach(r=>s.add(r))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}D(s){const n=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(c=>n.add(c))),[...n.values()]}static parse(s,n){const r=this.E(s.defaults,n),c=this.E(s.policy,n),b=this.E(s.application,n),j=this.E(s.user,n),C=this.E(s.workspace,n),I=s.folders.reduce((O,M)=>(O.set(u.URI.revive(M[0]),this.E(M[1],n)),O),new P.$Bc);return new f(r,c,b,j,d.createEmptyModel(n),C,I,d.createEmptyModel(n),new P.$Bc,n)}static E(s,n){return new d(s.contents,s.keys,s.overrides,void 0,n)}}e.$uo=f;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const c of o)c.keys.forEach(b=>s.add(b)),c.overrides.forEach(([b,j])=>{const C=(0,P.$yc)(n,b,new Set);j.forEach(I=>C.add(I))});const r=[];return n.forEach((c,b)=>r.push([b,[...c.values()]])),{keys:[...s.values()],overrides:r}}class w{constructor(s,n,r,c,b){this.change=s,this.f=n,this.g=r,this.h=c,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const j of s.keys)this.affectedKeys.add(j);for(const[,j]of s.overrides)for(const C of j)this.affectedKeys.add(C);this.d=this.a;for(const j of this.affectedKeys)this.d+=j+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=f.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,n){const r=this.a+s,c=this.d.indexOf(r);if(c<0)return!1;const b=c+r.length;if(b>=this.d.length)return!1;const j=this.d.charCodeAt(b);if(j!==this.b&&j!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,I=this.g.getValue(s,n,this.h);return!E.$1n(C,I)}return!0}}e.$wo=w;function a(o,s){const{added:n,removed:r,updated:c}=t(s?.rawConfiguration,o?.rawConfiguration),b=[],j=o?.getAllOverrideIdentifiers()||[],C=s?.getAllOverrideIdentifiers()||[];if(s){const I=C.filter(O=>!j.includes(O));for(const O of I)b.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const I=j.filter(O=>!C.includes(O));for(const O of I)b.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const I of j)if(C.includes(I)){const O=t({contents:o.getOverrideValue(void 0,I)||{},keys:o.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});b.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:r,updated:c,overrides:b}}function t(o,s){const n=o?s?o.keys.filter(b=>s.keys.indexOf(b)===-1):[...o.keys]:[],r=s?o?s.keys.filter(b=>o.keys.indexOf(b)===-1):[...s.keys]:[],c=[];if(o&&s){for(const b of s.keys)if(o.keys.indexOf(b)!==-1){const j=(0,g.$5i)(s.contents,b),C=(0,g.$5i)(o.contents,b);E.$1n(j,C)||c.push(b)}}return{added:n,removed:r,updated:c}}}),define(re[241],ae([0,1,22,3,2,35,12,123,52,5,39,45]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0;class k extends S.$Uc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new D.$be),this.onDidChangeConfiguration=this.a.event,this.b=E.$ro.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$9n.as(h.$bo.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:m})=>this.f(Array.from(p),m))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,m){this.j(p,y.$9n.as(h.$bo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=E.$ro.createEmptyModel(this.c);const p=y.$9n.as(h.$bo.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,m){const f=this.g();for(const l of p){const w=f[l],a=m[l];w!==void 0?this.b.addValue(l,w):a?this.b.addValue(l,a.default):this.b.removeValue(l)}}}e.$xo=k;class ${constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=E.$ro.createEmptyModel(new u.$0j)}async initialize(){return this.configurationModel}}e.$yo=$;let d=class extends S.$Uc{get configurationModel(){return this.b}constructor(p,m,f){super(),this.c=p,this.f=m,this.g=f,this.a=this.B(new D.$be),this.onDidChangeConfiguration=this.a.event,this.b=E.$ro.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const m={},f=[],l=y.$9n.as(h.$bo.Configuration).getConfigurationProperties();for(const w of p){const a=l[w];if(!a){f.push(w);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(w),m[a.policy.name]={type:a.type}}}return(0,P.$eg)(m)||await this.f.updatePolicyDefinitions(m),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const m=y.$9n.as(h.$bo.Configuration).getPolicyConfigurations(),f=(0,i.$Hb)(p.map(l=>m.get(l)));this.m(f,!0)}m(p,m){this.g.trace("PolicyConfiguration#update",p);const f=y.$9n.as(h.$bo.Configuration).getConfigurationProperties(),l=[],w=this.b.isEmpty();for(const a of p){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(w?o!==void 0:!(0,R.$1n)(this.b.getValue(a),o))&&l.push([a,o])}else this.b.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const a=this.b;this.b=E.$ro.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of l)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);m&&this.a.fire(this.b)}}};e.$zo=d,e.$zo=d=Se([ie(1,g.$$n),ie(2,u.$Wj)],d)}),define(re[242],ae([0,1,22,8,17,3,42,103,2,31,35,4,19,18,123,52,241,39]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0;class f extends h.$Uc{constructor(a,t,o,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$be),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$xo(s)),this.c=o instanceof m.$ao?new p.$yo:this.B(new p.$zo(this.b,o,s)),this.f=this.B(new d.$to(this.m,{},k.$Ug,t,s)),this.a=new d.$uo(this.b.configurationModel,this.c.configurationModel,d.$ro.createEmptyModel(s),d.$ro.createEmptyModel(s),d.$ro.createEmptyModel(s),d.$ro.createEmptyModel(s),new u.$Bc,d.$ro.createEmptyModel(s),new u.$Bc,s),this.j=new l(a,t,this),this.g=this.B(new D.$Ch(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$uo(a,t,d.$ro.createEmptyModel(this.n),o,d.$ro.createEmptyModel(this.n),d.$ro.createEmptyModel(this.n),new u.$Bc,d.$ro.createEmptyModel(this.n),new u.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const o=typeof a=="string"?a:void 0,s=(0,$.$Xi)(a)?a:(0,$.$Xi)(t)?t:{};return this.a.getValue(o,s,void 0)}async updateValue(a,t,o,s,n){const r=(0,$.$Yi)(o)?o:(0,$.$Xi)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,c=r?s:o;if(c!==void 0&&c!==3&&c!==2)throw new Error(`Unable to write ${a} to target ${c}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,i.$Mb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const b=this.inspect(a,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(b.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,g.$1n)(t,b.defaultValue)&&(t=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const C=r.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,i.$ub)([...O.identifiers].sort(),C));I&&(r.overrideIdentifiers=I.identifiers)}const j=r?.overrideIdentifiers?.length?[(0,v.$no)(r.overrideIdentifiers),a]:[a];await this.j.write(j,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(o,t,2)}s(a,t){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,o,7)}t(a){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(a);this.u(o,t,7)}u(a,t,o){const s=new d.$wo(a,{data:t},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Ao=f;class l{constructor(a,t,o){this.b=a,this.c=t,this.d=o,this.a=new D.$xh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===1)o="{}";else throw r}const s=[];if((0,P.$Dn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(o,a,t);o=(0,E.$Vn)(o,n),await this.c.writeFile(this.b,S.$Ce.fromString(o))}f(a,t,o){const{tabSize:s,insertSpaces:n,eol:r}=this.h;if(!t.length){const c=JSON.stringify(o,null,n?" ".repeat(s):"	");return[{content:c,length:c.length,offset:0}]}return(0,E.$Sn)(a,t,o,{tabSize:s,insertSpaces:n,eol:r})}get h(){if(!this.g){let a=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[243],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=e.$Occ=void 0,e.$Occ="request",e.$Pcc="remoteResourceHandler";class i{async routeCall(S,R,P){if(R!==e.$Occ)throw new Error(`Call not found: ${R}`);const E=P[0];if(E?.authority){const h=S.connections.find(u=>u.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(S,R){throw new Error(`Event not found: ${R}`)}}e.$Qcc=i}),define(re[244],ae([0,1,15,6]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=u,e.$Bl=(0,D.$qi)("remoteAuthorityResolverService");var S;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class R{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=R;class P{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=P;var E;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends i.$bb{static isNotAvailable(y){return y instanceof h&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,k=E.Unknown,$){super(y),this._message=y,this._code=k,this._detail=$,this.isHandled=k===E.NotAvailable&&$===!0,Object.setPrototypeOf(this,h.prototype)}}e.$El=h;function u(g){const y=g.indexOf("+");return y===-1?g:g.substring(0,y)}}),define(re[245],ae([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=j,e.$Ll=C,e.$Ml=O;const d=30*1e3;var v;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function p(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(J){const A=new S.$me;return setTimeout(()=>A.cancel(),J),A.token}function f(J,A){if(J.isCancellationRequested||A.isCancellationRequested)return S.CancellationToken.Cancelled;const N=new S.$me;return J.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class l{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$jh)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function w(J,A){const N=new l(A);return N.registerDisposable(J.onControlMessage(_=>{const ne=JSON.parse(_.toString()),X=W(ne);X?N.reject(X):N.resolve(ne)})),N.promise}function a(J,A,N,_,ne,X,H,x){const K=new l(x),se=g.$0d.create(!1);return J.info(`Creating a socket (${H})...`),u.mark(`code/willCreateSocket/${X}`),A.connect(N,_,ne,H).then(ue=>{K.didTimeout?(u.mark(`code/didCreateSocketError/${X}`),J.info(`Creating a socket (${H}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(u.mark(`code/didCreateSocketOK/${X}`),J.info(`Creating a socket (${H}) was successful after ${se.elapsed()} ms.`),K.resolve(ue))},ue=>{u.mark(`code/didCreateSocketError/${X}`),J.info(`Creating a socket (${H}) returned an error after ${se.elapsed()} ms.`),J.error(ue),K.reject(ue)}),K.promise}function t(J,A){const N=new l(A);return J.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function o(J,A,N,_){const ne=oe(J,A);J.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let X;try{X=await a(J.logService,J.remoteSocketFactoryService,J.connectTo,h.$Dg.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,p(A),`renderer-${p(A)}-${J.reconnectionToken}`,_)}catch(ue){throw J.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let H,x;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(X,null),H=J.reconnectionProtocol,x=!1):(H=new k.$ei({socket:X}),x=!0),J.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const K=await t(J.signService.createNewMessage((0,y.$Mg)()),_),se={type:"auth",auth:J.connectionToken||"00000000000000000000",data:K.data};H.sendControl(D.$Ce.fromString(JSON.stringify(se)));try{const ue=await w(H,f(_,m(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(J.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(J.signService.validate(K,ue.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const $e=await t(J.signService.sign(ue.data),_),ye={type:"connectionType",commit:J.commit,signedData:$e,desiredConnectionType:A};return N&&(ye.args=N),J.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(D.$Ce.fromString(JSON.stringify(ye))),{protocol:H,ownsProtocol:x}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${ne} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${ne} received error control message when negotiating connection. Error:`),J.logService.error(ue)),x&&q(H),ue}}async function s(J,A,N,_){const ne=Date.now(),X=oe(J,A),{protocol:H,ownsProtocol:x}=await o(J,A,N,_),K=new l(_);return K.registerDisposable(H.onControlMessage(se=>{const ue=JSON.parse(se.toString()),me=W(ue);me?(J.logService.error(`${X} received error control message when negotiating connection. Error:`),J.logService.error(me),x&&q(H),K.reject(me)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${he(ne)}!`),K.resolve({protocol:H,firstMessage:ue}))})),K.promise}async function n(J,A){const{protocol:N}=await s(J,1,void 0,A);return{protocol:N}}async function r(J,A,N){const{protocol:_,firstMessage:ne}=await s(J,2,A,N),X=ne&&ne.debugPort;return{protocol:_,debugPort:X}}async function c(J,A,N){const _=Date.now(),ne=oe(J,3),{protocol:X}=await o(J,3,A,N);return J.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${he(_)}!`),X}async function b(J,A,N){const{connectTo:_,connectionToken:ne}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:_,connectionToken:ne,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function j(J,A,N){return I(J,async _=>{const{protocol:ne}=await n(_,S.CancellationToken.None);return new Q(J,A,N,_.reconnectionToken,ne)})}async function C(J,A){return I(J,async N=>{const{protocol:_,debugPort:ne}=await r(N,A,S.CancellationToken.None);return new G(J,A,N.reconnectionToken,_,ne)})}async function I(J,A){for(let _=1;;_++)try{const ne=(0,y.$Mg)(),X=await b(J,ne,null);return await A(X)}catch(ne){if(_<5)J.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(ne);else throw J.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(ne),ce.triggerPermanentFailure(0,0,$.$El.isHandled(ne)),ne}}async function O(J,A,N){const _=await b(J,(0,y.$Mg)(),null);return await c(_,{host:A,port:N},S.CancellationToken.None)}function M(J){return(0,i.$dh)(A=>new Promise((N,_)=>{const ne=setTimeout(N,J*1e3);A.onCancellationRequested(()=>{clearTimeout(ne),N()})}))}var F;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class L{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Nl=L;class T{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=T;class U{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Pl=U;class le{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Ql=le;class ee{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=ne,this.type=3}}e.$Rl=ee;class ce extends E.$Uc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(A,N,_,ne,X){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=ne,this.w=X,this.m=this.B(new P.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(H=>{const x=B(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(H=>{const x=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,E.$Sc)(()=>{const H=ce.j.indexOf(this);H>=0&&ce.j.splice(H,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const ne=_<N.length?N[_]:N[N.length-1];try{if(ne>0){const H=M(ne);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,H)),this.u.logService.info(`${A} waiting for ${ne} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const X=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${X.connectTo}...`),await this.G(X,m(d)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if($.$El.isTemporarilyNotAvailable(X)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,R.$4)(X)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof $.$El){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,$.$El.isHandled(X));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ce.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new ee(this.reconnectionToken,A,N,_)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=ce;class Q extends ce{constructor(A,N,_,ne,X){super(1,A,ne,X,!0),this.client=this.B(new k.$ci(X,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await n(A,N)}}e.$Tl=Q;class G extends ce{constructor(A,N,_,ne,X){super(2,A,_,ne,!1),this.H=N,this.debugPort=X}async G(A,N){await r(A,this.H,N)}}e.$Ul=G;function q(J){try{J.acceptDisconnect();const A=J.getSocket();J.dispose(),A.dispose()}catch(A){(0,R.$1)(A)}}function W(J){if(J&&J.type==="error"){const A=new Error(`Connection error: ${J.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(J,A){for(;J.length<A;)J+=" ";return J}function V(J,A){return`[remote-connection][${z(p(J),13)}][${A.substr(0,5)}\u2026]`}function B(J,A,N){return`${V(J,A)}[${N?"reconnect":"initial"}]`}function oe(J,A){return`${B(A,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function he(J){return`${Date.now()-J} ms`}}),define(re[68],ae([0,1,13]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=D,e.$Cm=S,e.$Dm=R,e.$Em=P;function D(h){return h.scheme===i.Schemas.vscodeRemote?h.authority:void 0}function S(h){if(!h)return;const u=h.indexOf("+");return u<0?h:h.substr(0,u)}function R(h){const{host:u,port:g}=E(h);if(typeof g>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:u,port:g}}function P(h,u){let{host:g,port:y}=E(h);return typeof y>"u"&&(y=u),{host:g,port:y}}function E(h){const u=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(u)return{host:u[1],port:parseInt(u[2],10)};const g=h.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(re[124],ae([0,1,25,6,68]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=R,e.$Om=y,e.$Pm=k,e.$Qm=$,e.$Rm=d,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P||(e.ExtensionType=P={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p>"u"||p===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){const f=typeof p=="string"?p:p.value,l=typeof m=="string"?m:m.value;return i.$tf(f,l)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Lm=h;class u{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const m of p)this.add(m)}add(p){this.c.add(h.toKey(p))}delete(p){return this.c.delete(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}}e.$Mm=u;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(h.toKey(p))}get(p){return this.c.get(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}set(p,m){this.c.set(h.toKey(p),m)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=g;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function $(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function d(v,p){if(p){const m=`onResolveRemoteAuthority:${(0,S.$Cm)(p)}`;return!!v.activationEvents?.includes(m)}return!1}e.$Sm=(0,D.$qi)("IBuiltinExtensionsScannerService")}),define(re[246],ae([0,1,2,6]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,D.$qi)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(P,E){return this.a[P]??=[],this.a[P].push(E),(0,i.$Sc)(()=>{const h=this.a[P]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[P]?.splice(h,1)})}b(P){return(this.a[P.type]||[]).find(h=>h.supports(P))}connect(P,E,h,u){const g=this.b(P);if(!g)throw new Error(`No socket factory found for ${P}`);return g.connect(P,E,h,u)}}e.$Hl=S}),define(re[247],ae([0,1,26,49,21,117]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=E;let P;async function E($=!1){return(P===void 0||$)&&(P=h()),P}async function h(){const $=u();if($===void 0)return!1;if($>=22e3){const d=y();if(d)return new Promise(v=>{D.execFile(d,["--status"],p=>v(!p))})}else{const d=k();if(d)try{if((await S.Promises.stat(d)).isFile())return!0}catch{}}return!1}function u(){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if($)return parseInt($[3])}function g($){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,v?"Sysnative":"System32",$)}}function y(){return g("wsl.exe")}function k(){return g("lxss\\LxssManager.dll")}}),define(re[53],ae([0,1,17,15,2,186,52,6,5,45]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Jp=k,e.$Kp=$,e.$Lp=d,e.$Mp=v,e.$Np=p,e.$Op=m,e.$Hp=(0,E.$qi)("requestService");class g{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends S.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:h.$ck.isEqualTo((0,h.$_j)(h.LogLevel.Trace)).serialize()})}async c(a,t,o){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new g(t.headers??{}));try{const n=await o();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,D.$0)(n)),n}}}e.$Ip=y;function k(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function $(w){return w.res.statusCode===204}async function d(w){return $(w)?null:(await(0,i.$Oe)(w.stream)).toString()}async function v(w){if(!k(w))throw new Error("Server returned "+w.res.statusCode);return d(w)}async function p(w){if(!k(w))throw new Error("Server returned "+w.res.statusCode);if($(w))return null;const t=(await(0,i.$Oe)(w.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function m(w){l(w)}let f;function l(w){const a=u.$9n.as(P.$bo.Configuration),t=f;f={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}l(1)}),define(re[248],ae([0,1,17,23]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0;class S{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,u,g=D.CancellationToken.None){switch(h){case"request":return this.a.request(u[0],g).then(async({res:y,stream:k})=>{const $=await(0,i.$Oe)(k);return[{statusCode:y.statusCode,headers:y.headers},$]});case"resolveProxy":return this.a.resolveProxy(u[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Mr=S;class R{constructor(E){this.a=E}async request(E,h){const[u,g]=await this.a.call("request",[E],h);return{res:u,stream:(0,i.$Qe)(g)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Nr=R}),define(re[249],ae([0,1,250,12]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=R;function S(P,E){return P.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:P.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(P,E,h={}){const u=(0,i.parse)(P),g=h.proxyUrl||S(u,E);if(!g)return null;const y=(0,i.parse)(g);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,D.$0f)(h.strictSSL)?h.strictSSL:!0};return u.protocol==="http:"?new(await new Promise(($,d)=>{Z(["http-proxy-agent"],$,d)})).HttpProxyAgent(g,k):new(await new Promise(($,d)=>{Z(["https-proxy-agent"],$,d)})).HttpsProxyAgent(g,k)}}),define(re[251],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=e.$$bc=void 0,e.$$bc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$_bc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$acc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[95],ae([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=v;let d;async function v(m,f,l,w){return l["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$um)(w)&&!l["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$um)(w)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=k.Promises.withAsyncBody(async(a,t)=>{const o=new R.$me;let s=1e4;const n=m.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(s=(0,$.$vm)(n,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,S.localize)(0,null)))},s);try{a(await p(f,o.token))}catch(c){!(0,E.$4)(c)&&!o.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,P.$bj)(c)))):a({})}finally{clearTimeout(r),o.dispose()}})),d)}async function p(m,f){const l=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",l);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",w);const a=(0,u.$Mg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",o);const s=await(0,g.$km)(h.OS,o);return m.trace("getUnixShellEnvironment#shell",s),new Promise((n,r)=>{if(f.isCancellationRequested)return r(new E.$5);const c=(0,D.$oc)(s);let b,j;const C="";/^pwsh(-preview)?$/.test(c)?(b=`& '${process.execPath}' ${C} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,j=["-Login","-Command"]):c==="nu"?(b=`^'${process.execPath}' ${C} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,j=["-i","-l","-c"]):c==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,j=["-i","-l","-c"]):(b=`'${process.execPath}' ${C} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?j=["-ic"]:j=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(j),b);const I=(0,i.spawn)(s,[...j,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(I.kill(),r(new E.$5))),I.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,P.$bj)(F)),r(F)});const O=[];I.stdout.on("data",F=>O.push(F));const M=[];I.stderr.on("data",F=>M.push(F)),I.on("close",(F,L)=>{const T=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(M).toString("utf8");if(U.trim()&&m.trace("getUnixShellEnvironment#stderr",U),F||L)return r(new Error((0,S.localize)(2,null,F,L)));const le=t.exec(T),ee=le?le[1]:"{}";try{const ce=JSON.parse(ee);l?ce.ELECTRON_RUN_AS_NODE=l:delete ce.ELECTRON_RUN_AS_NODE,w?ce.ELECTRON_NO_ATTACH_CONSOLE=w:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){m.error("getUnixShellEnvironment#errorCaught",(0,P.$bj)(ce)),r(ce)}})})}}),define(re[252],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const R=await this.c();if(R){const P=String(i.a++);return this.b.set(P,R),{id:P,data:R.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,R){if(!S.id)return!0;const P=this.b.get(S.id);if(!P)return!1;this.b.delete(S.id);try{return P.validate(R)==="ok"}catch{return!1}finally{P.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$50b=i}),define(re[96],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,i.$qi)(e.$Il)}),define(re[253],ae([0,1,252]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class D extends i.$50b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(P=>new P.signer().sign(R))}h(){return new Promise((R,P)=>Z(["vsda"],R,P))}}e.$1cc=D}),define(re[34],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,e.$rQ=(0,i.$qi)("stateReadService"),e.$sQ=(0,i.$qi)("stateService")}),define(re[125],ae([0,1,8,17,2,12,38,16,5]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=e.$tQ=e.SaveStrategy=void 0;var u;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class g extends S.$Uc{constructor(d,v,p,m){super(),this.h=d,this.j=v,this.m=p,this.n=m,this.a=Object.create(null),this.b="",this.c=this.B(new i.$oh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.m.error(d)}}getItem(d,v){const p=this.a[d];return(0,R.$ag)(p)?v:p}setItem(d,v){this.setItems([{key:d,data:v}])}setItems(d){let v=!1;for(const{key:p,data:m}of d)this.a[p]!==m&&((0,R.$ag)(m)?(0,R.$$f)(this.a[p])||(this.a[p]=void 0,v=!0):(this.a[p]=m,v=!0));v&&this.s()}removeItem(d){(0,R.$$f)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,D.$Ce.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$tQ=g;let y=class extends S.$Uc{constructor(d,v,p,m){super(),this.a=this.B(new g(v.stateResource,d,p,m))}async init(){await this.a.init()}getItem(d,v){return this.a.getItem(d,v)}};e.$uQ=y,e.$uQ=y=Se([ie(1,P.$xi),ie(2,h.$Wj),ie(3,E.$Wk)],y);class k extends y{setItem(d,v){this.a.setItem(d,v)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$vQ=k}),define(re[126],ae([0,1,4,36,33]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=P,e.$$o=E;function R(h){if(i.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function P(h,u,g,y,k,$,d,v,p){const m=Object.create(null);m["common.machineId"]=$,m["common.sqmId"]=d,m.sessionID=(0,S.$Mg)()+Date.now(),m.commitHash=y,m.version=k,m["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,i.$h)(i.$u),m["common.nodePlatform"]=D.$ec,m["common.nodeArch"]=g,m["common.product"]=p||"desktop",v&&(m["common.msftInternal"]=v);let f=0;const l=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),i.$l&&(m["common.snap"]="true");const w=R(u);return w&&(m["common.platformDetail"]=w),m}function E(h){const u=D.env.USERDNSDOMAIN;if(!u)return!1;const g=u.toLowerCase();return h.some(y=>g===y)}}),define(re[28],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,i.$qi)("telemetryService"),e.$Wl=(0,i.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(re[254],ae([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0,e.$vs=m,e.$ws=l,e.$xs=w;const p=new Map;async function m(t,o){const s=`${t}::${o.join(":")}`,n=p.get(s);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,b=new Map,j=2e4;function C(O,M,F,L){const T=M.substring(O.length+1);return D.Promises.withAsyncBody(async U=>{let le;try{le=await g.Promises.readdir(M,{withFileTypes:!0})}catch{U();return}if(L.count>=j){L.count+=le.length,L.maxReached=!0,U();return}let ee=le.length;if(ee===0){U();return}let ce=le;L.count+le.length>j&&(L.maxReached=!0,ee=j-L.count,ce=le.slice(0,ee)),L.count+=le.length;for(const Q of ce)if(Q.isDirectory()){if(F.includes(Q.name)||await C(O,(0,P.$kc)(M,Q.name),F,L),--ee===0){U();return}}else{const G=Q.name.lastIndexOf(".");if(G>=0){const q=Q.name.substring(G+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(T)!==!1&&q.filePattern.test(Q.name)&&b.set(q.tag,(b.get(q.tag)??0)+1);if(--ee===0){U();return}}})}const I=D.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await C(t,t,o,M);const F=await w(t);O({configFiles:f(b),fileTypes:f(c),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:F})});return p.set(s,I),I}function f(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function l(){const t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/$.$sl.GB).toFixed(2)}GB (${(i.freemem()/$.$sl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$yn.value()*100)}%`},o=i.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function w(t){try{const o=new Map,s=(0,P.$kc)(t,".vscode","launch.json"),n=await g.Promises.readFile(s),r=[],c=(0,S.$Dn)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$Mn)(c)==="object"&&c.configurations)for(const b of c.configurations){const j=b.type;j&&(o.has(j)?o.set(j,o.get(j)+1):o.set(j,1))}return f(o)}catch{return[]}}let a=class{constructor(o,s){this.c=o,this.d=s}f(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}g(o){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/$.$sl.GB).toFixed(2)}GB (${(i.freemem()/$.$sl.GB).toFixed(2)}GB free)`),E.$i||s.push(`Load (avg):       ${i.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(u.$yn.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,y.$us)(o.mainPID),this.k(o)]).then(async n=>{let[r,c]=n,b=this.m(o,r);return s.forEach(j=>{if((0,k.$$m)(j))b+=`
${j.errorMessage}`,c+=`
${j.errorMessage}`;else if(b+=`

Remote: ${j.hostName}`,j.processes&&(b+=`
${this.m(o,j.processes)}`),j.workspaceMetadata){c+=`
|  Remote: ${j.hostName}`;for(const C of Object.keys(j.workspaceMetadata)){const I=j.workspaceMetadata[C];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${C}): ${O}`,c+=this.h(I)}}}),{processInfo:b,workspaceInfo:c}})}async getSystemInfo(o,s){const{memory:n,vmHint:r,os:c,cpus:b}=l(),j={os:c,memory:n,cpus:b,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return E.$i||(j.load=`${i.loadavg().map(C=>Math.round(C)).join(", ")}`),E.$k&&(j.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(j)}async getDiagnostics(o,s){const n=[];return(0,y.$us)(o.mainPID).then(async r=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,r)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),s.forEach(c=>{if((0,k.$$m)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.f(c.machineInfo)),c.processes&&n.push(this.m(o,c.processes)),c.workspaceMetadata)for(const b of Object.keys(c.workspaceMetadata)){const j=c.workspaceMetadata[b];let C=`${j.fileCount} files`;j.maxFilesReached&&(C=`more than ${C}`),n.push(`Folder (${b}): ${C}`),n.push(this.h(j))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const s=[];let r=0;const c=(I,O)=>{const M=` ${I}(${O})`;r+M.length>60?(s.push(b),b="|                 ",r=b.length):r+=M.length,b+=M};let b="|      File types:";const j=10,C=o.fileTypes.length>j?j:o.fileTypes.length;for(let I=0;I<C;I++){const O=o.fileTypes[I];c(O.name,O.count)}if(s.push(b),o.configFiles.length>=0&&(b="|      Conf files:",r=0,o.configFiles.forEach(I=>{c(I.name,I.count)}),s.push(b)),o.launchConfigFiles.length>0){let I="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(o){const s=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const s=[],n=[];return o.windows.forEach(r=>{r.folderURIs.length===0||r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const b=h.URI.revive(c);if(b.scheme===R.Schemas.file){const j=b.fsPath;n.push(m(j,["node_modules",".git"]).then(C=>{let I=`${C.fileCount} files`;C.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,P.$oc)(j)}): ${I}`),s.push(this.h(C))}).catch(C=>{s.push(`|      Error: Unable to collect workspace stats for folder ${j} (${C.toString()})`)}))}else s.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(o,s){const n=new Map;o.windows.forEach(c=>n.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:b})=>n.set(c,b));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.n(o.mainPID,n,r,s,0),r.join(`
`)}n(o,s,n,r,c){const b=c===0;let j;b?j=r.pid===o?`${this.d.applicationName} main`:"remote agent":s.has(r.pid)?j=s.get(r.pid):j=`${"  ".repeat(c)} ${r.name}`;const C=process.platform==="win32"?r.mem:i.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(C/$.$sl.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${j}`),Array.isArray(r.children)&&r.children.forEach(I=>this.n(o,s,n,I,c+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:n}of o.folders){const r=h.URI.revive(n);if(r.scheme!==R.Schemas.file)continue;const c=r.fsPath;try{(await m(c,["node_modules",".git"])).fileTypes.forEach(j=>s.add(j.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const n=h.URI.revive(s);if(n.scheme!==R.Schemas.file)continue;const r=n.fsPath;try{const c=await m(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$ys=a,e.$ys=a=Se([ie(0,v.$Vl),ie(1,d.$dk)],a)}),define(re[255],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class i{constructor(R){this.b=R}listen(R,P){throw new Error(`Event not found: ${P}`)}call(R,P,{eventName:E,data:h}){return this.b.forEach(u=>u.log(E,h)),Promise.resolve(null)}}e.$dcc=i;class D{constructor(R){this.b=R}log(R,P){return this.b.call("log",{eventName:R,data:P}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ecc=D}),define(re[54],ae([0,1,35,12,68,126,28]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=g,e.$hp=y,e.$ip=k,e.$jp=$,e.$kp=v,e.$lp=m,e.$mp=f,e.$np=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$_o=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=h,e.$bp=new h;class u{async publicLog(o,s,n){}async publicLogError(o,s,n){}}e.$cp=u,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function g(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(P.$4l),s=t.getValue(P.$5l);if(t.getValue(P.$6l)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(t){const o={},s={},n={};p(t,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const c=n[r];typeof c=="number"?s[r]=c:typeof c=="boolean"?s[r]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${c.length}`),o[r]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(o[r]=c)}return{properties:o,measurements:s}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,S.$Cm)(t);return d.has(o)?o:"other"}function p(t,o,s=0,n){if(t)for(const r of Object.getOwnPropertyNames(t)){const c=t[r],b=n?n+r:r;Array.isArray(c)?o[b]=(0,i.$2n)(c):c instanceof Date?o[b]=c.toISOString():(0,D.$6f)(c)?s<2?p(c,o,s+1,b+"."):o[b]=(0,i.$2n)(c):o[b]=c}}function m(t,o){const s=t.msftInternalDomains||[],n=o.getValue("telemetry.internalTesting");return(0,R.$$o)(s)||n}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function l(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const n=[];for(const j of o)for(;;){const C=j.exec(t);if(!C)break;n.push([C.index,j.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(s="";;){const j=c.exec(t);if(!j)break;const C=n.some(([I,O])=>j.index<O&&I<c.lastIndex);!r.test(j[0])&&!C&&(s+=t.substring(b,j.index)+"<REDACTED: user-file-path>",b=c.lastIndex)}return b<t.length&&(s+=t.substr(b)),s}function w(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,o){return(0,i.$Yn)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let n=s.replaceAll("%20"," ");n=l(n,o);for(const r of o)n=n.replace(r,"");return n=w(n),n}})}}),define(re[127],ae([0,1,25,121,124,4,7,15,36,54]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=g,e.$qp=d,e.$rp=v,e.$sp=p,e.$tp=m,e.$up=f,e.$vp=l,e.$wp=w,e.$yp=a,e.$zp=o;function g(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,i.$of)(s.id,n.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(n){const r=n.manifest?n.manifest.version:n.version,c=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new k(n.identifier,r,c)}static parse(n){const r=y.exec(n);return r&&r[1]&&r[2]?new k({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,c="undefined"){this.version=r,this.targetPlatform=c,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof k?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$pp=k;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const n=$.exec(s);return n&&n[1]?[p(n[1]),n[2]]:[p(s),void 0]}function v(s,n){return`${s}.${n}`}function p(s){return s.toLowerCase()}function m(s,n){return p(v(s??S.$Hm,n))}function f(s,n){const r=[],c=b=>{for(const j of r)if(j.some(C=>g(n(C),n(b))))return j;return null};for(const b of s){const j=c(b);j?j.push(b):r.push([b])}return r}function l(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function w(s){return{id:new u.$_o(s.identifier.id),name:new u.$_o(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$xp=new S.$Lm("pprice.better-merge");function a(s,n){const r=[],c=n.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const b=c.shift();if(b&&r.every(j=>!g(j.identifier,{id:b}))){const j=s.filter(C=>g(C.identifier,{id:b}));j.length===1&&(r.push(j[0]),c.push(...j[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(s,n){if(!R.$k)return!1;let r;try{r=(await s.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){n.debug("Error while getting the os-release file.",(0,E.$0)(b))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,n){const r=await t(s,n),c=(0,D.$Vo)(r?"alpine":R.$u,h.$fc);return n.debug("ComputeTargetPlatform:",c),c}}),define(re[256],ae([0,1,209,54]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=S;async function S(R,P,E,h,u,g,y){const k={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${P.nameShort})`};if((0,D.$gp)(P,E)&&(0,D.$ip)(h)===3){const $=await(0,i.$1p)(E,u,g);k["X-Market-User-Id"]=$,k["VSCode-SessionId"]=y.machineId||$}return k}}),define(re[257],ae([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,f,l){this.k=f,this.l=l,this.d={},this.i=new i.$Tc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=3,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,R.$8e)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$8e)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(k.$4l)||w.affectsConfiguration(k.$6l)||w.affectsConfiguration(k.$5l))&&this.m()}))}setExperimentProperty(m,f){this.d[m]=f}m(){let m=(0,$.$ip)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const l=f.usage?3:f.error?2:0;m=Math.min(m,l)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,f,l){this.g<f||(l=(0,D.$Zn)(l,this.d),l=(0,$.$np)(l,this.j),l=(0,D.$Zn)(l,this.c),this.b.forEach(w=>w.log(m,l)))}publicLog(m,f){this.n(m,3,f)}publicLog2(m,f){this.publicLog(m,f)}publicLogError(m,f){this.h&&this.n(m,2,f)}publicLogError2(m,f){this.publicLogError(m,f)}};e.$Rr=d,e.$Rr=d=Se([ie(1,E.$Wi),ie(2,g.$dk)],d);function v(){const p=(0,P.localize)(0,null,u.default.nameLong),m=u.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=S.$o?"":(0,P.localize)(3,null),l=(0,P.localize)(4,null),w=(0,P.localize)(5,null),a=(0,P.localize)(6,null),t=(0,P.localize)(7,null),o=`
|       | ${l} | ${w} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,P.localize)(8,null);return`
${p} ${m} ${f}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}y.$9n.as(h.$bo.Configuration).registerConfiguration({id:k.$3l,order:1,type:"object",title:(0,P.localize)(9,null),properties:{[k.$4l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$9n.as(h.$bo.Configuration).registerConfiguration({id:k.$3l,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[k.$6l]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,P.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,P.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${k.$4l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[258],ae([0,1,4,89,28]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=R,e.$Gcc=P;async function R(E,h){let u=E.getItem(S.$1l);return(typeof u!="string"||i.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$zn)(h.error.bind(h))),u}async function P(E,h){let u=E.getItem(S.$2l);return typeof u!="string"&&(u=await(0,D.$An)(h.error.bind(h))),u}}),define(re[259],ae([0,1,28,258]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=S,e.$Icc=R;async function S(P,E){const h=await(0,D.$Fcc)(P,E);return P.setItem(i.$1l,h),h}async function R(P,E){const h=await(0,D.$Gcc)(P,E);return P.setItem(i.$2l,h),h}}),define(re[128],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(re[260],ae([0,1,4,128]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;const S=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((y,k)=>{this.d(y,k);const $=y.map.entries();let d=$.next();for(;!d.done;){const v=d.value[1],p=d.value[0];let m=this.a.get(p);if(m||(m=[],this.a.set(p,m)),m.length>0&&m[0].type===D.EnvironmentVariableMutatorType.Replace){d=$.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,m.unshift(f),d=$.next()}})}async applyToProcessEnvironment(g,y,k){let $;i.$i&&($={},Object.keys(g).forEach(d=>$[d.toLowerCase()]=d));for(const[d,v]of this.getVariableMap(y)){const p=i.$i&&$[d.toLowerCase()]||d;for(const m of v){const f=k?await k(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case D.EnvironmentVariableMutatorType.Append:g[p]=(g[p]||"")+f;break;case D.EnvironmentVariableMutatorType.Prepend:g[p]=f+(g[p]||"");break;case D.EnvironmentVariableMutatorType.Replace:g[p]=f;break}if(m.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${S.get(m.type)}`;g[l]=(g[l]?g[l]+":":"")+d+"="+this.c(f)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,y){const k=new Map,$=new Map,d=new Map;if(g.getVariableMap(y).forEach((v,p)=>{const m=this.getVariableMap(y).get(p),f=E(v,m);f&&k.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const m=g.getVariableMap(y).get(p),f=E(v,m);f&&d.set(p,f)}),this.getVariableMap(y).forEach((v,p)=>{const m=g.getVariableMap(y).get(p),f=h(v,m);f&&$.set(p,f)}),!(k.size===0&&$.size===0&&d.size===0))return{added:k,changed:$,removed:d}}getVariableMap(g){const y=new Map;for(const k of this.a.values()){const $=k.filter(d=>P(d,g));$.length>0&&y.set($[0].variable,$)}return y}getDescriptionMap(g){const y=new Map;for(const k of this.b.values()){const $=k.filter(d=>P(d,g,!0));for(const d of $)y.set(d.extensionIdentifier,d.description)}return y}d(g,y){if(!g.descriptionMap)return;const k=g.descriptionMap.entries();let $=k.next();for(;!$.done;){const d=$.value[1],v=$.value[0];let p=this.b.get(v);p||(p=[],this.b.set(v,p));const m={extensionIdentifier:y,scope:d.scope,description:d.description};m.scope||delete m.scope,p.push(m),$=k.next()}}}e.$is=R;function P(u,g,y=!1){return u.scope?!!(u.scope.workspaceFolder&&g?.workspaceFolder&&u.scope.workspaceFolder.index===g.workspaceFolder.index):y?g===u.scope:!0}function E(u,g){if(!g)return u;const y=new Set;g.forEach($=>y.add($.extensionIdentifier));const k=[];return u.forEach($=>{y.has($.extensionIdentifier)||k.push($)}),k.length===0?void 0:k}function h(u,g){if(!g)return;const y=new Map;g.forEach($=>y.set($.extensionIdentifier,$));const k=[];return u.forEach($=>{const d=y.get($.extensionIdentifier);d&&($.type!==d.type||$.value!==d.value||$.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&k.push(d)}),k.length===0?void 0:k}}),define(re[261],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=i,e.$ds=D,e.$es=S,e.$fs=R,e.$gs=P,e.$hs=E;function i(h){return[...h.entries()]}function D(h){return h?[...h.entries()]:[]}function S(h){return new Map(h)}function R(h){return new Map(h??[])}function P(h){return Array.from(h.entries()).map(u=>[u[0],i(u[1].map),D(u[1].descriptionMap)])}function E(h){return new Map(h.map(u=>[u[0],{map:S(u[1]),descriptionMap:R(u[2])}]))}}),define(re[262],ae([0,1,8,23,3,2,5]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;let E=class extends R.$Uc{constructor(u,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$be),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,R.$Sc)(()=>{for(const y of this.f.values())(0,R.$Pc)(y)}))}createRequest(u){return new Promise((g,y)=>{const k=++this.a;this.c.set(k,g),this.g.fire({requestId:k,...u});const $=new D.$me;(0,i.$rh)(this.b,$.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,R.$Sc)(()=>$.cancel())])})}acceptReply(u,g){const y=this.c.get(u);y?(this.c.delete(u),(0,R.$Pc)(this.f.get(u)||[]),this.f.delete(u),y(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$6r=E,e.$6r=E=Se([ie(1,P.$Wj)],E)}),define(re[129],ae([0,1,6,118,45]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Yr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Xr=void 0,e.$Xr=new D.$Hj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var P;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(P||(e.TerminalSettingId=P={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var u;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var g;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Yr=(0,i.$qi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var $;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var d;(function(a){a.TerminalView="view",a.Editor="editor"})(d||(e.TerminalLocationString=d={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var m;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var l;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$Zr={Backend:"workbench.contributions.terminal.processBackend"};class w{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$9n.add(e.$Zr.Backend,new w),e.$1r=(0,i.$qi)("localPtyService"),e.$2r=(0,i.$qi)("terminalLogService")}),define(re[263],ae([0,1,75,7,190,106]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=P,e.$8r=u,e.$9r=g,e.$0r=y;function P(k,$){const d=[{name:null,description:(0,S.localize)(0,null)}];return d.push(...k.map(v=>({name:v.profileName,description:E(v)}))),$&&d.push(...$.map(v=>({name:v.title,description:h(v)}))),{values:d.map(v=>v.name),markdownDescriptions:d.map(v=>v.description)}}function E(k){let $=`$(${R.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:i.$Pj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?$+=`
- args: "${k.args}"`:$+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&($+=`
- overrideName: ${k.overrideName}`),k.color&&($+=`
- color: ${k.color}`),k.env&&($+=`
- env: ${JSON.stringify(k.env)}`),$}function h(k){return`$(${R.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:i.$Pj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function u(k,$){if(!k&&!$)return!0;if(typeof k=="string"&&typeof $=="string")return k===$;if(Array.isArray(k)&&Array.isArray($)){if(k.length!==$.length)return!1;for(let d=0;d<k.length;d++)if(k[d]!==$[d])return!1;return!0}return!1}function g(k,$){if(!k&&!$)return!0;if(!k||!$)return!1;if(R.ThemeIcon.isThemeIcon(k)&&R.ThemeIcon.isThemeIcon($))return k.id===$.id&&k.color===$.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof $=="object"&&"light"in $&&"dark"in $){const d=k,v=$;if((D.URI.isUri(d.light)||y(d.light))&&(D.URI.isUri(d.dark)||y(d.dark))&&(D.URI.isUri(v.light)||y(v.light))&&(D.URI.isUri(v.dark)||y(v.dark)))return d.light.path===v.light.path&&d.dark.path===v.dark.path}if(D.URI.isUri(k)&&D.URI.isUri($)||y(k)||y($)){const d=k,v=$;return d.path===v.path&&d.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(re[264],ae([0,1,75,4,189,52,45,263]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0,e.$as=$,e.$bs=v,e.$$r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$_r={type:"string",enum:Array.from((0,i.$Nj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,i.$Nj)(),p=>`$(${p.id})`)};const h={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$_r},color:{description:(0,S.localize)(3,null),...e.$$r},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},g={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(p){const m=p===2?"linux":p===1?"osx":"windows";return(0,S.localize)(7,null,(0,D.$h)(p),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...h}},{type:"null"},u]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function $(){P.$9n.as(R.$bo.Configuration).registerConfiguration(k),v()}let d;function v(p,m){const f=P.$9n.as(R.$bo.Configuration);let l;p&&(l=(0,E.$7r)(p?.profiles,m));const w=d;d={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?l?.values:void 0,markdownEnumDescriptions:p?.os===3?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?l?.values:void 0,markdownEnumDescriptions:p?.os===2?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?l?.values:void 0,markdownEnumDescriptions:p?.os===1?l?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[d],remove:w?[w]:[]})}}),define(re[265],ae([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=d,e.$ks=v,e.$ls=p;function d(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let b=0;return c&&c.length===4&&(b=parseInt(c[3])),b}async function v(c,b,j,C=E.env,I=g.Promises.exists){if(R.$jc(c))return await I(c)?c:void 0;if(b===void 0&&(b=E.cwd()),R.$nc(c)!=="."){const L=R.$kc(b,c);return await I(L)?L:void 0}const M=(0,S.$4n)(C,"PATH");if(j===void 0&&(0,u.$4f)(M)&&(j=M.split(R.$uc)),j===void 0||j.length===0){const L=R.$kc(b,c);return await I(L)?L:void 0}for(const L of j){let T;if(R.$jc(L)?T=R.$kc(L,c):T=R.$kc(b,L,c),await I(T))return T;if(P.$i){let U=T+".com";if(await I(U)||(U=T+".exe",await I(U)))return U}}const F=R.$kc(b,c);return await I(F)?F:void 0}function p(c,b,j,C,I){const O=P.$i&&(!b.windowsEnableConpty||d()<18309);if(!b.shellIntegration.enabled||!c.executable||c.isFeatureTerminal&&!c.forceShellIntegration||c.ignoreShellIntegration||O)return;const M=c.args,F=E.$ec==="win32"?R.$oc(c.executable).toLowerCase():R.$oc(c.executable),L=R.$nc(D.$Kg.asFileUri("").fsPath);let T;const U={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(U.VSCODE_NONCE=b.shellIntegration.nonce),P.$i){if(F==="pwsh.exe"||F==="powershell.exe")return!M||n(M)?T=l.get(f.WindowsPwsh):s(M)&&(T=l.get(f.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$4e)(T[T.length-1],L,""),b.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:U}):void 0;if(F==="bash.exe")return!M||M.length===0?T=l.get(f.Bash):r(M)&&(U.VSCODE_SHELL_LOGIN="1",m(b,U),T=l.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$4e)(T[T.length-1],L),{newArgs:T,envMixin:U}):void 0;C.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args);return}switch(F){case"bash":return!M||M.length===0?T=l.get(f.Bash):r(M)&&(U.VSCODE_SHELL_LOGIN="1",m(b,U),T=l.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$4e)(T[T.length-1],L),{newArgs:T,envMixin:U}):void 0;case"fish":{const le=j?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=R.$kc(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${le}:${ee}`,m(b,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!M||n(M)?T=l.get(f.Pwsh):s(M)&&(T=l.get(f.PwshLogin)),T?(b.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,h.$4e)(T[T.length-1],L,""),{newArgs:T,envMixin:U}):void 0;case"zsh":{if(!M||M.length===0?T=l.get(f.Zsh):r(M)?(T=l.get(f.ZshLogin),m(b,U)):(M===l.get(f.Zsh)||M===l.get(f.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,h.$4e)(T[T.length-1],L);let le;try{le=i.userInfo().username}catch{le="unknown"}const ee=R.$kc(i.tmpdir(),`${le}-${I.applicationName}-zsh`);U.ZDOTDIR=ee;const ce=j?.ZDOTDIR??i.homedir()??"~";U.USER_ZDOTDIR=ce;const Q=[];return Q.push({source:R.$kc(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$kc(ee,".zshrc")}),Q.push({source:R.$kc(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$kc(ee,".zprofile")}),Q.push({source:R.$kc(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$kc(ee,".zshenv")}),Q.push({source:R.$kc(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$kc(ee,".zlogin")}),{newArgs:T,envMixin:U,filesToCopy:Q}}}C.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args)}function m(c,b){if(P.$j&&c.environmentVariableCollections){const j=(0,k.$hs)(c.environmentVariableCollections),I=new $.$is(j).getVariableMap({workspaceFolder:c.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===y.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&(b.VSCODE_PATH_PREFIX=O.join(""))}}var f;(function(c){c.WindowsPwsh="windows-pwsh",c.WindowsPwshLogin="windows-pwsh-login",c.Pwsh="pwsh",c.PwshLogin="pwsh-login",c.Zsh="zsh",c.ZshLogin="zsh-login",c.Bash="bash"})(f||(f={}));const l=new Map;l.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(f.Zsh,["-i"]),l.set(f.ZshLogin,["-il"]),l.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function s(c){return typeof c=="string"?w.includes(c.toLowerCase()):c.length===1&&w.includes(c[0].toLowerCase())||c.length===2&&(w.includes(c[0].toLowerCase())||w.includes(c[1].toLowerCase()))&&(o.includes(c[0].toLowerCase())||o.includes(c[1].toLowerCase()))}function n(c){return typeof c=="string"?o.includes(c.toLowerCase()):c.length===0||c?.length===1&&o.includes(c[0].toLowerCase())}function r(c){return typeof c!="string"&&(c=c.filter(b=>!t.includes(b.toLowerCase()))),c==="string"&&a.includes(c.toLowerCase())||typeof c!="string"&&c.length===1&&a.includes(c[0].toLowerCase())}}),define(re[266],ae([0,1,49,75,9,4,12,21,110,265,117]),function(Z,e,i,D,S,R,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=d;var y;(function(c){c.UnixShellsPath="/etc/shells"})(y||(y={}));let k,$=!0;function d(c,b,j,C,I=process.env,O,M,F,L){return O=O||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},R.$i?v(j,O,I,M,C.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:C.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:C.getValue("terminal.integrated.defaultProfile.windows"),L,F):s(O,M,j,c&&typeof c=="object"?{...c}:C.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:C.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),L,F,I)}async function v(c,b,j,C,I,O,M,F,L){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let le=!1;(0,u.$js)()>=16299&&(le=!0),await l(F);const ee=new Map;if(c){ee.set("PowerShell",{source:"PowerShell",icon:D.$Pj.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$Pj.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:D.$Pj.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:D.$Pj.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}n(O,ee);const ce=await p(ee.entries(),M,b,j,C,L);if(c&&I)try{const Q=await t(`${U}\\${le?"wsl":"bash"}.exe`,M);for(const G of Q)(!O||!(G.profileName in O))&&ce.push(G)}catch{$&&(C?.trace("WSL is not installed, so could not detect WSL profiles"),$=!1)}return ce}async function p(c,b,j,C=process.env,I,O){const M=[];for(const[F,L]of c)M.push(m(F,L,b,j,C,I,O));return(await Promise.all(M)).filter(F=>!!F)}async function m(c,b,j,C,I=process.env,O,M){if(b===null)return;let F,L,T;if("source"in b&&!("path"in b)){const ce=k?.get(b.source);if(!ce)return;F=ce.paths,L=b.args||ce.args,b.icon?T=f(b.icon):ce.icon&&(T=ce.icon)}else F=Array.isArray(b.path)?b.path:[b.path],L=R.$i||Array.isArray(b.args)?b.args:void 0,T=f(b.icon);let U;if(M){const ce=F.map(G=>typeof G=="string"?G:G.path),Q=await M(ce);U=new Array(F.length);for(let G=0;G<F.length;G++)typeof F[G]=="string"?U[G]=Q[G]:U[G]={path:Q[G],isUnsafe:!0}}else U=F.slice();let le;if(b.requiresPath){let ce;if((0,P.$4f)(b.requiresPath)?ce=b.requiresPath:(ce=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ce)),!await C.existsFile(ce))return}const ee=await r(c,j,U,C,I,L,b.env,b.overrideName,b.isAutoDetected,le);if(!ee){O?.debug("Terminal profile not validated",c,F);return}return ee.isAutoDetected=b.isAutoDetected,ee.icon=T,ee.color=b.color,ee}function f(c){return typeof c=="string"?{id:c}:c}async function l(c){if(k&&!c)return;const[b,j]=await Promise.all([w(),c||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:j,icon:D.$Pj.terminalPowershell})}async function w(){const c=new Set,b=await(0,u.$ks)("git.exe");if(b){const I=(0,g.dirname)(b);c.add((0,g.resolve)(I,"../.."))}function j(I,O){O&&I.add(O)}j(c,process.env.ProgramW6432),j(c,process.env.ProgramFiles),j(c,process.env["ProgramFiles(X86)"]),j(c,`${process.env.LocalAppData}\\Program`);const C=[];for(const I of c)C.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function a(){const c=[];for await(const b of(0,h.$em)())c.push(b.exePath);return c}async function t(c,b){const j=[],C=await new Promise((M,F)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(L,T)=>{if(L)return F("Problem occurred when getting wsl distros");M(T)})});if(!C)return[];const I=new RegExp(/[\r?\n]/),O=C.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const F=`${M} (WSL)`,L={profileName:F,path:c,args:["-d",`${M}`],isDefault:F===b,icon:o(M),isAutoDetected:!1};j.push(L)}return j}function o(c){return c.includes("Ubuntu")?D.$Pj.terminalUbuntu:c.includes("Debian")?D.$Pj.terminalDebian:D.$Pj.terminalLinux}async function s(c,b,j,C,I,O,M,F){const L=new Map;if(j&&await c.existsFile("/etc/shells")){const T=(await c.readFile("/etc/shells")).toString(),U=(O||T.split(`
`)).map(ee=>{const ce=ee.indexOf("#");return ce===-1?ee:ee.substring(0,ce)}).filter(ee=>ee.trim().length>0),le=new Map;for(const ee of U){let ce=(0,S.$oc)(ee),Q=le.get(ce)||0;Q++,Q>1&&(ce=`${ce} (${Q})`),le.set(ce,Q),L.set(ce,{path:ee,isAutoDetected:!0})}}return n(C,L),await p(L.entries(),I,c,F,b,M)}function n(c,b){if(c)for(const[j,C]of Object.entries(c))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?b.delete(j):(C.icon=C.icon||b.get(j)?.icon,b.set(j,C))}async function r(c,b,j,C,I,O,M,F,L,T){if(j.length===0)return Promise.resolve(void 0);const U=j.shift();if(U==="")return r(c,b,j,C,I,O,M,F,L);const le=typeof U!="string"&&U.isUnsafe,ee=typeof U=="string"?U:U.path,ce={profileName:c,path:ee,args:O,env:M,overrideName:F,isAutoDetected:L,isDefault:c===b,isUnsafePath:le,requiresUnsafePath:T};if((0,S.$oc)(ee)===ee){const G=I.PATH?I.PATH.split(S.$uc):void 0,q=await(0,u.$ks)(ee,void 0,G,void 0,C.existsFile);return q?(ce.path=q,ce.isFromPath=!0,ce):r(c,b,j,C,I,O)}return await C.existsFile((0,S.$ic)(ee))?ce:r(c,b,j,C,I,O,M,F,L)}}),define(re[267],ae([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;var p;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let m=class extends D.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,w,a,t){super(),this.M=l,this.N=w,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$be),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$be),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$be),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$be),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$be),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$be),this.onProcessData=this.D.event,this.F=this.B(new i.$be),this.onProcessReady=this.F.event,this.G=this.B(new i.$be),this.onProcessReplay=this.G.event,this.H=this.B(new i.$be),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$be),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$be),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$be),this.onProcessExit=this.L.event,(0,k.$as)(),this.B(this.M),this.B((0,D.$Sc)(()=>this.W())),this.j=this.B(new g.$6r(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&i.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,u.$Am)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),w=l.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=R.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new h.$5r(this.P,w.getChannel(y.TerminalIpcChannels.Logger))),this.a=l,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,t]}async createProcess(l,w,a,t,o,s,n,r,c,b,j){const C=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(l,w,a,t,o,s,n,r,c,b,j);return clearTimeout(C),I}updateTitle(l,w,a){return this.f.updateTitle(l,w,a)}updateIcon(l,w,a,t){return this.f.updateIcon(l,w,a,t)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,w){return this.f.detachFromProcess(l,w)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,w){return this.f.shutdown(l,w)}input(l,w){return this.f.input(l,w)}processBinary(l,w){return this.f.processBinary(l,w)}resize(l,w,a){return this.f.resize(l,w,a)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,w){return this.f.acknowledgeDataEvent(l,w)}setUnicodeVersion(l,w){return this.f.setUnicodeVersion(l,w)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new v.$0d,w=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...w]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,w){return this.f.installAutoReply(l,w)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,d.$km)(l??S.OS,process.env)}async getProfiles(l,w,a,t=!1){const o=await this.S();return(0,$.$ms)(w,a,t,this.N,o,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,w){return this.f.getWslPath(l,w)}getRevivedPtyNewId(l,w){return this.f.getRevivedPtyNewId(l,w)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,w){return this.f.requestDetachInstance(l,w)}async acceptDetachInstanceReply(l,w){return this.f.acceptDetachInstanceReply(l,w)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,w,a){return this.f.reviveTerminalProcesses(l,w,a)}async refreshProperty(l,w){return this.f.refreshProperty(l,w)}async updateProperty(l,w,a){return this.f.updateProperty(l,w,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,w){return this.j.createRequest({workspaceId:l,originalText:w})}async acceptPtyHostResolvedVariables(l,w){this.j.acceptReply(l,w)}};e.$ns=m,e.$ns=m=Se([ie(1,P.$Wi),ie(2,E.$Wj),ie(3,E.$Xj)],m)}),define(re[69],ae([0,1,14,3,2,4,18,6,34]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=e.$6ac=void 0;const u="#FFFFFF",g="#1E1E1E",y="#000000",k="#FFFFFF",$="theme",d="themeBackground",v="windowSplash";e.$6ac=(0,E.$qi)("themeMainService");let p=class extends S.$Uc{constructor(f,l){super(),this.b=f,this.c=l,this.a=this.B(new D.$be),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(w=>{w.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(D.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let l=this.b.getItem(d,null);if(!l)switch(this.g()){case"vs":l=u;break;case"hc-black":l=y;break;case"hc-light":l=k;break;default:l=g}return R.$j&&l.toUpperCase()===g&&(l="#171717"),l}g(){switch(this.b.getItem($,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,l){this.b.setItems([{key:$,data:l.baseTheme},{key:d,data:l.colorInfo.background},{key:v,data:l}]),typeof f=="number"&&this.h(f,l),this.f()}h(f,l){for(const w of i.BrowserWindow.getAllWindows())if(w.id===f){w.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$7ac=p,e.$7ac=p=Se([ie(0,h.$sQ),ie(1,P.$Wi)],p)}),define(re[130],ae([0,1,3,7,18,6,5]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=u,e.$8v=y,e.$9v=k,e.$$v=$,e.$aw=d,e.$bw=v,e.$5v=(0,R.$qi)("tunnelService"),e.$6v=(0,R.$qi)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(h||(e.TunnelPrivacyId=h={}));function u(f){return!!f.forwardPort}var g;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(l)return{address:l[1],port:+l[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const l=f.query.split("&");for(const w of l){const a=w.split("=")[1];if(/^https?:/.exec(a)){const t=y(D.URI.parse(a));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(f){return e.$0v.indexOf(f)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(f){return e.$_v.indexOf(f)>=0}function v(f,l,w,a){if(w===1)return!1;if(w===2&&d(l)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class p{constructor(l,w,a){this.remoteAddress=l,this.localAddress=w,this.b=a,this.a=new i.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=p;let m=class{constructor(l,w){this.k=l,this.l=w,this.a=new i.$be,this.onTunnelOpened=this.a.event,this.b=new i.$be,this.onTunnelClosed=this.b.event,this.c=new i.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],w=Array.from(this.e.values());for(const a of w){const t=Array.from(a.values());for(const o of t){const s=await o.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:w}of l.values())await w.then(a=>typeof a!="string"?a?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,w,a,t,o){this.q(l,w,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:w,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,w){(d(l)||$(l))&&(l=e.$0v[0]);const a=this.s(l,w);if(a)return++a.refcount,a.value}openTunnel(l,w,a,t,o,s=!1,n,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${a} on local port ${o}.`);const c=this.f??l;if(!c)return;if(w||(w="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(c,w,a,t,o,s,n,r);return b?b.then(j=>{if(j){if(typeof j=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(w,a),j}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(w,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.o(j);return(j.tunnelRemoteHost!==w||j.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&j.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(C),C}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const w=this.e.get(l.tunnelRemoteHost);if(w){const a=w.get(l.tunnelRemotePort);a&&(a.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,a))}}}}async p(l,w,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${w}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(w),t}}async closeTunnel(l,w){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${w} `);const a=this.e.get(l);if(a&&a.has(w)){const t=a.get(w);t.refcount=0,await this.p(l,w,t)}}q(l,w,a){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(w,{refcount:1,value:a})}async r(l,w){const a=this.e.get(l);if(a){const t=a.get(w),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(w),a.size===0&&this.e.delete(l)}}s(l,w){const a=[l];$(l)?(a.push(...e.$0v),a.push(...e.$_v)):d(l)&&a.push(...e.$_v);const t=a.map(o=>this.e.get(o));for(const o of t){const s=o?.get(w);if(s)return s}}canTunnel(l){return!!y(l)}u(l,w,a,t,o,s,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${a} on local port ${t}.`);const r=a;this.j.add(r);const c=t===void 0?a:t,b={elevationRequired:o?this.isPortPrivileged(c):!1},j={remoteAddress:{host:w,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:n},C=l.forwardPort(j,b);return C?(this.q(w,a,C),C.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),C}};e.$dw=m,e.$dw=m=Se([ie(0,P.$Wj),ie(1,S.$Wi)],m)}),define(re[50],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CX=e.$BX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(P){P.Uninitialized="uninitialized",P.Idle="idle",P.Disabled="disabled",P.CheckingForUpdates="checking for updates",P.AvailableForDownload="available for download",P.Downloading="downloading",P.Downloaded="downloaded",P.Updating="updating",P.Ready="ready"})(D||(e.StateType=D={}));var S;(function(P){P[P.Setup=0]="Setup",P[P.Archive=1]="Archive",P[P.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var R;(function(P){P[P.NotBuilt=0]="NotBuilt",P[P.DisabledByEnvironment=1]="DisabledByEnvironment",P[P.ManuallyDisabled=2]="ManuallyDisabled",P[P.MissingConfiguration=3]="MissingConfiguration",P[P.InvalidConfiguration=4]="InvalidConfiguration",P[P.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$BX={Uninitialized:{type:"uninitialized"},Disabled:P=>({type:"disabled",reason:P}),Idle:(P,E)=>({type:"idle",updateType:P,error:E}),CheckingForUpdates:P=>({type:"checking for updates",explicit:P}),AvailableForDownload:P=>({type:"available for download",update:P}),Downloading:{type:"downloading"},Downloaded:P=>({type:"downloaded",update:P}),Updating:P=>({type:"updating",update:P}),Ready:P=>({type:"ready",update:P})},e.$CX=(0,i.$qi)("updateService")}),define(re[268],ae([0,1,4,191,52,45]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$9n.as(S.$bo.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[269],ae([0,1,3,50]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0;class S{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,u){switch(h){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${h}`)}}e.$fcc=S;class R{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new i.$be,this.onStateChange=this.a.event,this.b=D.$BX.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$gcc=R}),define(re[40],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,i.$qi)("IUriIdentityService")}),define(re[270],ae([0,1,40,210,16,19,142,3,2]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class u{static{this._clock=0}constructor(k){this.uri=k,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let g=class{constructor(k){this.g=k,this.c=new h.$Tc,this.f=2**16;const $=new Map,d=v=>{let p=$.get(v.scheme);return p===void 0&&(p=k.hasProvider(v)&&!this.g.hasCapability(v,1024),$.set(v.scheme,p)),p};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{$.delete(v.scheme)})),this.extUri=new R.$Sg(d),this.d=new P.$qs((v,p)=>this.extUri.compare(v,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,R.$5g)(k));const $=this.d.get(k);return $?$.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new u(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((d,v)=>d[1].time<v[1].time?1:d[1].time>v[1].time?-1:0);u._clock=0,this.d.clear();const $=this.f*.5;for(let d=0;d<$;d++)this.d.set(k[d][0],k[d][1].touch())}};e.$rs=g,e.$rs=g=Se([ie(0,S.$Wk)],g),(0,D.$os)(i.$ul,g,1)}),define(re[131],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sX=void 0,e.$sX=(0,i.$qi)("urlService")}),define(re[271],ae([0,1,7]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=e.$ncc=void 0;class D{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,u){switch(h){case"handleURL":return this.a.handleURL(i.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${h}`)}}e.$ncc=D;class S{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$occ=S;class R{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,u,g){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(u)&&u.length>0){const y=i.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const $=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${$}"`,y.toString(!0));const d=new RegExp(`window:${$}`),v=E.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),d.test(p.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,u,g)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$pcc=R}),define(re[272],ae([0,1,8,2,7,27]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uX=e.$tX=void 0;class P extends D.$Uc{constructor(){super(...arguments),this.a=new Set}open(u,g){const y=[...this.a.values()];return(0,i.$uh)(y.map(k=>()=>k.handleURL(u,g)),void 0,!1).then(k=>k||!1)}registerHandler(u){return this.a.add(u),(0,D.$Sc)(()=>this.a.delete(u))}}e.$tX=P;let E=class extends P{constructor(u){super(),this.b=u}create(u){let{authority:g,path:y,query:k,fragment:$}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&y&&y.indexOf("/")!==0&&(y=`/${y}`),S.URI.from({scheme:this.b.urlProtocol,authority:g,path:y,query:k,fragment:$})}};e.$uX=E,e.$uX=E=Se([ie(0,R.$dk)],E)}),define(re[273],ae([0,1,14,8,3,2,4,7]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class h extends R.$Uc{constructor(g,y,k,$,d,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,g&&(v.trace("ElectronURLListener initialUrisToHandle:",g.map(f=>f.originalUrl)),this.a=g),P.$i){const f=$.isBuilt?[]:[`"${$.appRoot}"`];f.push("--open-url","--"),i.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,f)}const p=S.Event.map(S.Event.fromNodeEventEmitter(i.app,"open-url",(f,l)=>({event:f,url:l})),({event:f,url:l})=>(f.preventDefault(),l));this.B(p(f=>{const l=this.g(f);l&&this.c.open(l,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return E.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),g.push(y));g.length!==0&&(this.a=g,(0,D.$sh)(()=>this.h(),500,this.q))}}e.$qcc=h}),define(re[274],ae([0,1,3,2,16,59,31]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class E extends D.$Uc{constructor(u,g,y,k,$,d){super(),this.f=u,this.g=g,this.h=y,this.j=k,this.m=$,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$be),this.onDidChangeFile=this.a.event,this.b=R.$wi.forUris(()=>!(this.capabilities&1024)),this.c=new P.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,g){return this.g.open(this.t(u),g)}close(u){return this.g.close(u)}read(u,g,y,k,$){return this.g.read(u,g,y,k,$)}write(u,g,y,k,$){return this.g.write(u,g,y,k,$)}watch(u,g){this.b.set(u,u);const y=this.g.watch(this.t(u),g);return(0,D.$Sc)(()=>{this.b.delete(u),y.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,g,y){return this.g.rename(this.t(u),this.t(g),y)}readFile(u,g){return this.g.readFile(this.t(u),g)}readFileStream(u,g,y){return this.g.readFileStream(this.t(u),g,y)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,g,y){return this.g.writeFile(this.t(u),g,y)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,g){return this.g.delete(this.t(u),g)}copy(u,g,y){if((0,S.$1k)(this.g))return this.g.copy(this.t(u),this.t(g),y);throw new Error("copy not supported")}cloneFile(u,g){if((0,S.$2k)(this.g))return this.g.cloneFile(this.t(u),this.t(g));throw new Error("clone not supported")}s(u){const g=[];for(const y of u){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&g.push({resource:k,type:y.type,cId:y.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$4cc=E}),define(re[275],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0,e.$Kcc="utilityProcessWorker"}),define(re[276],ae([0,1,6]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0,e.$rcc=(0,i.$qi)("webviewManagerService")}),define(re[277],ae([0,1,14,2,13,7]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class P extends D.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);i.protocol.registerFileProtocol(S.Schemas.vscodeWebview,h)}b(h,u){try{const g=R.URI.parse(h.url),y=P.a.get(g.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,$=S.$Kg.asFileUri(k);return u({path:$.fsPath,headers:{...S.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$scc=P}),define(re[55],ae([0,1,4]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$kD=void 0,e.$lD=D,e.$mD=S,e.$nD=R,e.$oD=P,e.$pD=E,e.$qD=y,e.$rD=k,e.$sD=$,e.$tD=d,e.$uD=v,e.$vD=p,e.$kD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(m){return typeof m.parentId=="number"}function S(m){return!!m.workspaceUri}function R(m){return!!m.folderUri}function P(m){return!!m.fileUri}function E(m){const f=k(m),l=m.getValue("window.menuBarVisibility");return l==="default"||f&&l==="compact"||i.$j&&i.$m?"classic":l}var h;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var u;(function(m){m.NATIVE="native",m.CUSTOM="custom"})(u||(e.TitlebarStyle=u={}));var g;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function y(m,f){return!0}function k(m,f){return f||(f=$(m)),f==="native"}function $(m){if(i.$o)return"custom";const f=m.getValue("window");if(f){if(i.$j&&f.nativeTabs===!0||i.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return i.$k?"native":"custom"}function d(m){return!(!i.$i||i.$o||k(m))}function v(m){const f=m.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function p(m=0){return Math.pow(1.2,m)}}),define(re[82],ae([0,1,14]),function(Z,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Vac=e.$Uac=e.UnloadReason=e.LoadReason=void 0;var D;(function(u){u[u.INITIAL=1]="INITIAL",u[u.LOAD=2]="LOAD",u[u.RELOAD=3]="RELOAD"})(D||(e.LoadReason=D={}));var S;(function(u){u[u.CLOSE=1]="CLOSE",u[u.QUIT=2]="QUIT",u[u.RELOAD=3]="RELOAD",u[u.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const R=function(u=1){return{width:1024,height:768,mode:u}};e.$Uac=R;const P=function(){const y=i.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),$=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:$,width:800,height:600,mode:1}};e.$Vac=P;var E;(function(u){u[u.Maximized=0]="Maximized",u[u.Normal=1]="Normal",u[u.Minimized=2]="Minimized",u[u.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(u){u[u.UNRESPONSIVE=1]="UNRESPONSIVE",u[u.PROCESS_GONE=2]="PROCESS_GONE",u[u.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(re[278],ae([0,1,8,3,2]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class R extends S.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:u}){super(),this.a=this.B(new S.$Tc),D.Event.latch(D.Event.any(E,h))(this.f,this,this.a),this.b=(0,i.$dh)(()=>u()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$ycc=R}),define(re[30],ae([0,1,195,9,59,19,7,6,13]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=u,e.$Bi=g,e.$Ei=y,e.$Fi=k,e.$Gi=$,e.$Hi=v,e.$Ii=p,e.$Li=l,e.$Qi=w,e.$Ri=a,e.$Ti=t,e.$Ui=o,e.$Vi=s,e.$zi=(0,E.$qi)("contextService");function u(n){const r=n;return typeof r?.id=="string"&&P.URI.isUri(r.uri)}function g(n){return typeof n?.id=="string"&&!u(n)&&!k(n)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function y(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$oc)(n)}:r?e.$Ci:e.$Di;const c=n;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}function k(n){const r=n;return typeof r?.id=="string"&&P.URI.isUri(r.configPath)}function $(n){const r=n;if(r?.uri)return{id:r.id,uri:P.URI.revive(r.uri)};const c=n;if(c?.configPath)return{id:c.id,configPath:P.URI.revive(c.configPath)};if(n?.id)return{id:n.id}}var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function v(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function p(n){const r=n;return!!(r&&typeof r=="object"&&P.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class m{constructor(r,c,b,j,C){this.h=r,this.j=b,this.k=j,this.l=C,this.c=S.$wi.forUris(this.l,()=>!0),this.folders=c}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=S.$wi.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=m;class f{constructor(r,c){this.raw=c,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.$4g)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=f;function l(n){return new f({uri:n,index:0,name:(0,R.$Zg)(n)},{uri:n.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,i.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function w(n,r){return R.$Ug.isEqualOrParent(n,r.untitledWorkspacesHome)}function a(n){let r;return P.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===h.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Si}function o(n,r){return!w(n,r)&&!a(n)}function s(n){return(typeof n=="string"?(0,D.$pc)(n):(0,R.$2g)(n))===e.$Ni}}),define(re[56],ae([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$3ac=(0,k.$qi)("dialogMainService");let p=class{constructor(f,l){this.d=f,this.e=l,this.a=new Map,this.b=new Map,this.c=new D.$xh}pickFileFolder(f,l){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},l)}pickFolder(f,l){return this.f({...f,pickFolders:!0,title:(0,g.localize)(1,null)},l)}pickFile(f,l){return this.f({...f,pickFiles:!0,title:(0,g.localize)(2,null)},l)}pickWorkspace(f,l){const w=(0,g.localize)(3,null),a=(0,R.$uw)((0,g.localize)(4,null)),t=v.$Oi;return this.f({...f,pickFiles:!0,title:w,filters:t,buttonLabel:a},l)}async f(f,l){const w={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(w.properties=void 0,f.pickFiles&&f.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&w.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(w,(l||i.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let l=this.b.get(f.id);return l||(l=new D.$xh,this.b.set(f.id,l)),l}else return this.c}showMessageBox(f,l){return this.g(l).queue(async()=>{const{options:w,buttonIndeces:a}=(0,y.$Bw)(f,this.e);let t;return l?t=await i.dialog.showMessageBox(l,w):t=await i.dialog.showMessageBox(w),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,l){const w=this.j(f,l);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let a;return l?a=await i.dialog.showSaveDialog(l,f):a=await i.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,P.$Pc)(w)}}h(f){return f&&h.$j&&(f=(0,E.$8l)(f)),f}i(f){return f.map(l=>this.h(l))}async showOpenDialog(f,l){f.defaultPath&&(await u.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const w=this.j(f,l);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let a;return l?a=await i.dialog.showOpenDialog(l,f):a=await i.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,P.$Pc)(w)}}j(f,l){if(!l)return P.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let w=this.a.get(l.id);w||(w=new Set,this.a.set(l.id,w));const a=(0,S.$ej)(f);if(!w.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),w.add(a),(0,P.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),w?.delete(a),w?.size===0&&this.a.delete(l.id)})}};e.$4ac=p,e.$4ac=p=Se([ie(0,$.$Wj),ie(1,d.$dk)],p)}),define(re[279],ae([0,1,3,2,77,30]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;class P extends D.$Uc{static{this.a=100}constructor(h,u){super(),this.f=h,this.g=u,this.b=this.B(new i.$be),this.c=new Map,this.h(u.applicationStorage,this.b)}h(h,u){this.B(i.Event.debounce(h.onDidChangeStorage,(g,y)=>(g?g.push(y):g=[y],g),P.a)(g=>{g.length&&u.fire(this.j(g,h))}))}j(h,u){const g=new Map,y=new Set;return h.forEach(k=>{const $=u.get(k.key);typeof $=="string"?g.set(k.key,$):y.add(k.key)}),{changed:Array.from(g.entries()),deleted:Array.from(y.values())}}listen(h,u,g){switch(u){case"onDidChangeStorage":{const y=g.profile?(0,S.$Zh)(g.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new i.$be),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${u}`)}async call(h,u,g){const y=g.profile?(0,S.$Zh)(g.profile):void 0,k=(0,R.$Gi)(g.workspace),$=await this.m(y,k);switch(u){case"getItems":return Array.from($.items.entries());case"updateItems":{const d=g;if(d.insert)for(const[v,p]of d.insert)$.set(v,p);d.delete?.forEach(v=>$.delete(v));break}case"optimize":return $.optimize();case"isUsed":{const d=g.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${u}`)}}async m(h,u){let g;u?g=this.g.workspaceStorage(u):h?g=this.g.profileStorage(h):g=this.g.applicationStorage;try{await g.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":h?"profile":"application"} storage due to ${y}`)}return g}}e.$ccc=P}),define(re[41],ae([0,1,46,3,2,19,7,192,38,16,6,5,30,31,40,8,33,25,12]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=w,e.$xl=a,e.$yl=t;var l;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function w(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&P.URI.isUri(r.location)&&P.URI.isUri(r.globalStorageHome)&&P.URI.isUri(r.settingsResource)&&P.URI.isUri(r.keybindingsResource)&&P.URI.isUri(r.tasksResource)&&P.URI.isUri(r.snippetsHome)&&P.URI.isUri(r.extensionsResource))}e.$wl=(0,g.$qi)("IUserDataProfilesService");function a(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:P.URI.revive(n.location).with({scheme:r}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:P.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:P.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,r,c,b,j,C){return{id:n,name:r,location:c,isDefault:!1,shortName:j?.shortName,icon:j?.icon,globalStorageHome:C&&j?.useDefaultFlags?.globalState?C.globalStorageHome:(0,R.$4g)(c,"globalStorage"),settingsResource:C&&j?.useDefaultFlags?.settings?C.settingsResource:(0,R.$4g)(c,"settings.json"),keybindingsResource:C&&j?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,R.$4g)(c,"keybindings.json"),tasksResource:C&&j?.useDefaultFlags?.tasks?C.tasksResource:(0,R.$4g)(c,"tasks.json"),snippetsHome:C&&j?.useDefaultFlags?.snippets?C.snippetsHome:(0,R.$4g)(c,"snippets"),extensionsResource:C&&j?.useDefaultFlags?.extensions?C.extensionsResource:(0,R.$4g)(c,"extensions.json"),cacheHome:(0,R.$4g)(b,n),useDefaultFlags:j?.useDefaultFlags,isTransient:j?.transient}}let o=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,c,b,j){super(),this.t=r,this.u=c,this.w=b,this.y=j,this.f=!0,this.h=this.B(new D.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),c=[r];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,f.$4f)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}c.push(t((0,R.$1g)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},r))}}catch(C){this.y.error(C)}const b=new $.$Bc,j=new Map;if(c.length)try{const C=this.Q();if(C.workspaces)for(const[I,O]of Object.entries(C.workspaces)){const M=P.URI.parse(I),F=c.find(L=>L.id===O);F&&b.set(M,F)}if(C.emptyWindows)for(const[I,O]of Object.entries(C.emptyWindows)){const M=c.find(F=>F.id===O);M&&j.set(I,M)}}catch(C){this.y.error(C)}this.z={profiles:c,workspaces:b,emptyWindows:j}}return this.z}D(){const r=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const c="Temp",b=new RegExp(`${(0,m.$8e)(c)}\\s(\\d+)`);let j=0;for(const I of this.profiles){const O=b.exec(I.name),M=O?parseInt(O[1]):0;j=M>j?M:j}const C=`${c} ${j+1}`;return this.createProfile((0,i.$ej)((0,p.$Mg)()).toString(16),C,{transient:!0},r)}async createNamedProfile(r,c,b){return this.createProfile((0,i.$ej)((0,p.$Mg)()).toString(16),r,c,b)}async createProfile(r,c,b,j){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(r,c,b);return j&&await this.setProfileForWorkspace(j,C),C}async F(r,c,b){if(!(0,f.$4f)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let j=this.r.get(c);return j||(j=(async()=>{try{if(this.profiles.find(M=>M.name===c||M.id===r))throw new Error(`Profile with ${c} name already exists`);const I=t(r,c,(0,R.$4g)(this.profilesHome,r),this.g,b,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await v.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(c)}})(),this.r.set(c,j)),j}async updateProfile(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(j=>j.id===r.id);if(!b)throw new Error(`Profile '${r.name}' does not exist`);return b=t(b.id,c.name??b.name,b.location,this.g,{shortName:c.shortName??b.shortName,icon:c.icon===null?void 0:c.icon??b.icon,transient:c.transient??b.isTransient,useDefaultFlags:c.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(j=>j.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);const b=[];this.m.fire({profile:c,join(j){b.push(j)}});try{await Promise.allSettled(b)}catch(j){this.y.error(j)}for(const j of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(j)?.id&&this.C.emptyWindows.delete(j);for(const j of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(j)?.id&&this.C.workspaces.delete(j);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(j){(0,u.$bl)(j)!==1&&this.y.error(j)}}async setProfileForWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(j=>j.id===c.id);if(!b)throw new Error(`Profile '${c.name}' does not exist`);this.L(r,b)}unsetWorkspace(r,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(c=>c.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(r.map(c=>this.removeProfile(c)))}getProfileForWorkspace(r){const c=this.G(r);return P.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(r){return(0,k.$Ai)(r)?r.uri:(0,k.$Fi)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,r.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,r.location)))}I(r,c,b){const j=[...this.profiles,...r],C=[];this.s.profiles=[];for(let I of j)I.isDefault||c.some(O=>I.id===O.id)||(I=b.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):C.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(C),this.z=void 0,this.J(r,c,b)}J(r,c,b){this.h.fire({added:r,removed:c,updated:b,all:this.profiles})}L(r,c,b){b=c?.isTransient?!0:b,b||this.L(r,void 0,!0);const j=this.G(r),C=b?this.s:this.C;P.URI.isUri(j)?(C.workspaces.delete(j),c&&C.workspaces.set(j,c)):(C.emptyWindows.delete(j),c&&C.emptyWindows.set(j,c)),b||this.M()}M(){const r={};for(const[b,j]of this.C.workspaces.entries())r[b.toString()]=j.id;const c={};for(const[b,j]of this.C.emptyWindows.entries())c[b.toString()]=j.id;this.R({workspaces:r,emptyWindows:c}),this.z=void 0}N(r){const c={},b=this.D();if(r.workspaces)for(const[C,I]of Object.entries(r.workspaces)){const O=P.URI.parse(I);c[C]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}const j={};if(r.emptyWindows)for(const[C,I]of Object.entries(r.emptyWindows)){const O=P.URI.parse(I);j[C]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}return{workspaces:c,emptyWindows:j}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$zl=o,e.$zl=o=Se([ie(0,h.$xi),ie(1,u.$Wk),ie(2,d.$ul),ie(3,y.$Wj)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Al=s}),define(re[83],ae([0,1,8,17,2,3,31,7,121,127,16,6,5,41,40,12,15,28]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class l extends Error{constructor(s,n){super(s),this.code=n}}e.$iq=l,e.$jq=(0,y.$qi)("IExtensionsProfileScannerService");let w=class extends S.$Uc{constructor(s,n,r,c,b,j){super(),this.j=s,this.m=n,this.n=r,this.r=c,this.s=b,this.t=j,this.b=this.B(new R.$be),this.onAddExtensions=this.b.event,this.c=this.B(new R.$be),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$be),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$be),this.onDidRemoveExtensions=this.g.event,this.h=new P.$Bc}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n,r){const c=[],b=[];try{return await this.u(n,j=>{const C=[];if(r)C.push(...j);else for(const I of j)s.some(([O])=>(0,u.$op)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?c.push(I):C.push(I);for(const[I,O]of s){const M=C.findIndex(L=>(0,u.$op)(L.identifier,I.identifier)&&L.version===I.manifest.version),F={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?(b.push(F),C.push(F)):C.splice(M,1,F)}return b.length&&this.b.fire({extensions:b,profileLocation:n}),c.length&&this.f.fire({extensions:c,profileLocation:n}),C}),b.length&&this.c.fire({extensions:b,profileLocation:n}),c.length&&this.g.fire({extensions:c,profileLocation:n}),b}catch(j){throw b.length&&this.c.fire({extensions:b,error:j,profileLocation:n}),c.length&&this.g.fire({extensions:c,error:j,profileLocation:n}),j}}async updateMetadata(s,n){const r=[];return await this.u(n,c=>{const b=[];for(const j of c){const C=s.find(([I])=>(0,u.$op)(I.identifier,j.identifier)&&I.manifest.version===j.version);C&&(j.metadata={...j.metadata,...C[1]},r.push(j)),b.push(j)}return b}),r}async removeExtensionFromProfile(s,n){const r=[];try{await this.u(n,c=>{const b=[];for(const j of c)(0,u.$op)(j.identifier,s.identifier)?r.push(j):b.push(j);return r.length&&this.f.fire({extensions:r,profileLocation:n}),b}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(c){throw r.length&&this.g.fire({extensions:r,error:c,profileLocation:n}),c}}async u(s,n,r){return this.F(s).queue(async()=>{let c=[],b;try{const j=await this.m.readFile(s);b=JSON.parse(j.value.toString().trim()||"[]")}catch(j){if((0,g.$bl)(j)!==1)throw j;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&r?.bailOutWhenFileNotFound)throw new l((0,p.$0)(j),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(s);let j=!1;for(const C of b){a(C)||this.w(s);let I;if((0,v.$4f)(C.relativeLocation)&&C.relativeLocation)I=this.z(C.relativeLocation);else if((0,v.$4f)(C.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${C.location}`);continue}else{I=E.URI.revive(C.location);const O=this.y(I);O&&(j=!0,C.relativeLocation=O)}(0,v.$$f)(C.metadata?.hasPreReleaseVersion)&&C.metadata?.preRelease&&(j=!0,C.metadata.hasPreReleaseVersion=!0),c.push({identifier:C.identifier,location:I,version:C.version,metadata:C.metadata})}j&&await this.m.writeFile(s,D.$Ce.fromString(JSON.stringify(b)))}if(n){c=n(c);const j=c.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(s,D.$Ce.fromString(JSON.stringify(j)))}return c})}w(s){const n=new l(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let r;try{r=(await this.m.readFile(s)).value.toString()}catch(b){if((0,g.$bl)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",s.toString());let c;try{const b=JSON.parse(r);Array.isArray(b)&&b.every(j=>a(j))?c=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$Ce.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,g.$bl)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(s)}catch(b){(0,g.$bl)(b)!==1&&this.t.error(b)}try{await this.m.del(n)}catch(b){(0,g.$bl)(b)!==1&&this.t.error(b)}return c})()),this.C}F(s){let n=this.h.get(s);return n||(n=new i.$xh,this.h.set(s,n)),n}};e.$kq=w,e.$kq=w=Se([ie(1,g.$Wk),ie(2,$.$wl),ie(3,d.$ul),ie(4,m.$Vl),ie(5,k.$Wj)],w);function a(o){return(0,v.$6f)(o)&&(0,h.$Yo)(o.identifier)&&(t(o.location)||(0,v.$4f)(o.location)&&o.location)&&((0,v.$$f)(o.relativeLocation)||(0,v.$4f)(o.relativeLocation))&&o.version&&(0,v.$4f)(o.version)}function t(o){return o?(0,v.$4f)(o.path)&&(0,v.$4f)(o.scheme):!1}}),define(re[132],ae([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=e.$oq=e.$nq=e.Translations=void 0,e.$qq=le;var M;(function(ce){function Q(G,q){if(G===q)return!0;const W=Object.keys(G),z=new Set;for(const V of Object.keys(q))z.add(V);if(W.length!==z.size)return!1;for(const V of W){if(G[V]!==q[V])return!1;z.delete(V)}return z.size===0}ce.equals=Q})(M||(e.Translations=M={})),e.$nq=(0,s.$qi)("IExtensionsScannerService");let F=class extends u.$Uc{constructor(Q,G,q,W,z,V,B,oe,he,J,A,N){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=G,this.r=q,this.s=W,this.t=z,this.u=V,this.w=B,this.y=oe,this.z=he,this.C=J,this.D=A,this.F=N,this.g=this.B(new c.$be),this.onDidChangeCache=this.g.event,this.h=(0,$.$4g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,w.$zp)(this.w,this.y)),this.G}async scanAllExtensions(Q,G,q){const[W,z]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(G)]),V=q?await this.scanExtensionsUnderDevelopment(Q,[...W,...z]):[];return this.L(W,z,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const G=[];G.push(this.M(!!Q.useCache,Q.language)),G.push(this.N(Q.language,!!Q.checkControlFile));const[q,W]=await Promise.all(G);return this.J([...q,...W],0,Q,!1)}async scanUserExtensions(Q){const G=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const q=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(G,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,q,Q.productVersion??this.R()),z=Q.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let V;try{V=await z.scanExtensions(W)}catch(B){if(B instanceof j.$iq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await z.scanExtensions(W);else throw B}return V=await this.J(V,1,Q,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(Q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===g.Schemas.file).map(async W=>{const z=await this.P(W,!1,1,!0,Q.language,!1,void 0,Q.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(z)).map(B=>(B.type=G.find(oe=>(0,w.$op)(oe.identifier,B.identifier))?.type??B.type,this.n.validate(B,z)))}))).flat();return this.J(q,"development",Q,!0)}return[]}async scanExistingExtension(Q,G,q){const W=await this.P(Q,!1,G,!0,q.language,!0,void 0,q.productVersion??this.R()),z=await this.n.scanExtension(W);return!z||!q.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(Q,G,q){const W=await this.P(Q,!1,G,!0,q.language,!0,void 0,q.productVersion??this.R()),z=await this.n.scanOneOrMultipleExtensions(W);return this.J(z,G,q,!0)}async scanMultipleExtensions(Q,G,q){const W=[];return await Promise.all(Q.map(async z=>{const V=await this.scanOneOrMultipleExtensions(z,G,q);W.push(...V)})),this.J(W,G,q,!0)}async scanMetadata(Q){const G=(0,$.$4g)(Q,"package.json"),q=(await this.w.readFile(G)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Q,G){const q=(0,$.$4g)(Q,"package.json"),W=(await this.w.readFile(q)).value.toString(),z=JSON.parse(W);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,z.__metadata={...z.__metadata,...G},await this.w.writeFile((0,$.$4g)(Q,"package.json"),R.$Ce.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof j.$iq&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Ce.fromString(JSON.stringify([])))}catch(G){(0,o.$bl)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,P.$0)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,G,q,W){return q.includeAllVersions||(Q=this.L(G===0?Q:void 0,G===1?Q:void 0,G==="development"?Q:void 0,await this.getTargetPlatform(),W)),q.includeInvalid||(Q=Q.filter(z=>z.isValid)),Q.sort((z,V)=>{const B=y.$oc(z.location.fsPath),oe=y.$oc(V.location.fsPath);return B<oe?-1:B>oe?1:0})}L(Q,G,q,W,z){const V=(oe,he,J)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(z&&d.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(d.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===W)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},B=new a.$Nm;return Q?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||V(he,oe,!1))&&B.set(oe.identifier.id,oe)}),G?.forEach(oe=>{const he=B.get(oe.identifier.id);if(!he&&Q&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||V(he,oe,!1))&&B.set(oe.identifier.id,oe)}),q?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||V(he,oe,!0))&&B.set(oe.identifier.id,oe),B.set(oe.identifier.id,oe)}),[...B.values()]}async M(Q,G){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0,this.R()),z=await(Q&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",z.length),z}async N(Q,G){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const W=G?await this.O():{},z=[],V=m.URI.file(y.$ic(y.$kc(g.$Kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of q){const he=W[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":z.push((0,$.$4g)(V,oe.name));break;default:z.push(m.URI.file(he));break}}const B=await Promise.all(z.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Q,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",B.length),(0,i.$Hb)(B)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,G,q,W,z,V,B,oe){const he=await this.f(z??k.$w),J=await this.Q(Q),A=G&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new L(Q,J,A,N,G,B,q,W,V,oe.version,oe.date,this.C.commit,!this.z.isBuilt,z,he)}async Q(Q){try{const G=await this.w.stat(Q);if(typeof G.mtime=="number")return G.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$oq=F,e.$oq=F=Se([ie(4,C.$wl),ie(5,j.$jq),ie(6,o.$Wk),ie(7,n.$Wj),ie(8,l.$xi),ie(9,r.$dk),ie(10,I.$ul),ie(11,s.$pi)],F);class L{constructor(Q,G,q,W,z,V,B,oe,he,J,A,N,_,ne,X){this.location=Q,this.mtime=G,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=W,this.profile=z,this.profileScanOptions=V,this.type=B,this.excludeObsolete=oe,this.validate=he,this.productVersion=J,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=ne,this.translations=X}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,G){return(0,$.$Wg)(Q.location,G.location)&&Q.mtime===G.mtime&&(0,$.$Wg)(Q.applicationExtensionslocation,G.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&Q.profile===G.profile&&S.$1n(Q.profileScanOptions,G.profileScanOptions)&&Q.type===G.type&&Q.excludeObsolete===G.excludeObsolete&&Q.validate===G.validate&&Q.productVersion===G.productVersion&&Q.productDate===G.productDate&&Q.productCommit===G.productCommit&&Q.devMode===G.devMode&&Q.language===G.language&&M.equals(Q.translations,G.translations)}}e.$pq=L;let T=class extends u.$Uc{constructor(Q,G,q,W,z){super(),this.f=Q,this.g=G,this.h=q,this.j=W,this.m=z}async scanExtensions(Q){const G=Q.profile?await this.r(Q):await this.n(Q);let q={};if(Q.excludeObsolete&&Q.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(W)}catch{}return(0,p.$eg)(q)?G:G.filter(W=>!q[w.$pp.create(W).toString()])}async n(Q){const G=await this.j.resolve(Q.location);if(!G.children?.length)return[];const q=await Promise.all(G.children.map(async W=>{if(!W.isDirectory||Q.type===1&&(0,$.$1g)(W.resource).indexOf(".")===0)return null;const z=new L(W.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(z)}));return(0,i.$Hb)(q).sort((W,z)=>W.location.path<z.location.path?-1:1)}async r(Q){let G=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){G=G.filter(W=>!W.metadata?.isApplicationScoped);const q=await this.s(Q.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,Q);G.push(...q)}return G}async s(Q,G,q){const W=await this.g.scanProfileExtensions(Q,q.profileScanOptions);if(!W.length)return[];const z=await Promise.all(W.map(async V=>{if(G(V)){const B=new L(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B,V.metadata)}return null}));return(0,i.$Hb)(z)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,$.$4g)(Q.location,"package.json"))){const G=await this.scanExtension(Q);return G?[G]:[]}else return await this.scanExtensions(Q)}catch(G){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,P.$0)(G)),[]}}async scanExtension(Q,G){try{let q=await this.scanExtensionManifest(Q.location);if(q){q.publisher||(q.publisher=a.$Hm),G=G??q.__metadata,delete q.__metadata;const W=(0,w.$tp)(q.publisher,q.name),z=G?.id?{id:W,uuid:G.id}:{id:W},V=G?.isSystem?0:Q.type,B=V===0||!!G?.isBuiltin;q=await this.t(Q.location,q,L.createNlsConfiguration(Q));const oe={type:V,identifier:z,manifest:q,location:Q.location,isBuiltin:B,targetPlatform:G?.targetPlatform??"undefined",publisherDisplayName:G?.publisherDisplayName,metadata:G,isValid:!0,validations:[]};return Q.validate?this.validate(oe,Q):oe}}catch(q){Q.type!==0&&this.m.error(q)}return null}validate(Q,G){let q=!0;const W=(0,t.$Ep)(G.productVersion,G.productDate,G.location,Q.manifest,Q.isBuiltin);for(const[z,V]of W)z===v.default.Error&&(q=!1,this.m.error(this.z(G.location,V)));return Q.isValid=q,Q.validations=W,Q}async scanExtensionManifest(Q){const G=(0,$.$4g)(Q,"package.json");let q;try{q=(await this.j.readFile(G)).value.toString()}catch(z){return(0,o.$bl)(z)!==1&&this.m.error(this.z(Q,(0,f.localize)(0,null,G.path,z.message))),null}let W;try{W=JSON.parse(q)}catch{const V=[];(0,E.$Dn)(q,V);for(const B of V)this.m.error(this.z(Q,(0,f.localize)(1,null,G.path,B.offset,B.length,(0,h.$lq)(B.error))));return null}return(0,E.$Mn)(W)!=="object"?(this.m.error(this.z(Q,(0,f.localize)(2,null,G.path))),null):W}async t(Q,G,q){const W=await this.u(Q,G,q);if(W)try{const z=[],V=await this.w(W.default,z);if(z.length>0)return z.forEach(oe=>{this.m.error(this.z(Q,(0,f.localize)(3,null,W.default?.path,(0,h.$lq)(oe.error))))}),G;if((0,E.$Mn)(W)!=="object")return this.m.error(this.z(Q,(0,f.localize)(4,null,W.default?.path))),G;const B=W.values||Object.create(null);return(0,O.$mq)(this.m,G,B,V)}catch{}return G}async u(Q,G,q){const W=(0,$.$4g)(Q,"package.nls.json"),z=(he,J)=>{J.forEach(A=>{this.m.error(this.z(Q,(0,f.localize)(5,null,he?.path,(0,h.$lq)(A.error))))})},V=he=>{this.m.error(this.z(Q,(0,f.localize)(6,null,he?.path)))},B=`${G.publisher}.${G.name}`,oe=q.translations[B];if(oe)try{const he=m.URI.file(oe),J=(await this.j.readFile(he)).value.toString(),A=[],N=(0,E.$Dn)(J,A);return A.length>0?(z(he,A),{values:void 0,default:W}):(0,E.$Mn)(N)!=="object"?(V(he),{values:void 0,default:W}):{values:N.contents?N.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let J;try{J=await this.y(Q,q)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const A=(await this.j.readFile(J.localized)).value.toString(),N=[],_=(0,E.$Dn)(A,N);return N.length>0?(z(J.localized,N),{values:void 0,default:J.original}):(0,E.$Mn)(_)!=="object"?(V(J.localized),{values:void 0,default:J.original}):{values:_,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(Q,G){if(Q)try{const q=(await this.j.readFile(Q)).value.toString();return(0,E.$Dn)(q,G)}catch{}}y(Q,G){return new Promise((q,W)=>{const z=V=>{const B=(0,$.$4g)(Q,`package.nls.${V}.json`);this.j.exists(B).then(oe=>{oe&&q({localized:B,original:(0,$.$4g)(Q,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?q({localized:(0,$.$4g)(Q,"package.nls.json"),original:null}):(V=V.substring(0,he),z(V))})};if(G.devMode||G.pseudo||!G.language)return q({localized:(0,$.$4g)(Q,"package.nls.json"),original:null});z(G.language)})}z(Q,G){return`[${Q.path}]: ${G}`}};T=Se([ie(1,j.$jq),ie(2,I.$ul),ie(3,o.$Wk),ie(4,n.$Wj)],T);let U=class extends T{constructor(Q,G,q,W,z,V,B){super(G,W,z,V,B),this.G=Q,this.H=q,this.D=this.B(new D.$oh(3e3)),this.F=this.B(new c.$be),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const G=this.M(Q),q=await this.I(G);if(this.C=Q,q&&q.input&&L.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),q.result.map(z=>(z.location=m.URI.revive(z.location),z));const W=await super.scanExtensions(Q);return await this.J(G,{input:Q,result:W}),W}async I(Q){try{const G=await this.j.readFile(Q),q=JSON.parse(G.value.toString());return{result:q.result,input:(0,b.$Zh)(q.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",Q.path,(0,P.$0)(G))}return null}async J(Q,G){try{await this.j.writeFile(Q,R.$Ce.fromString(JSON.stringify(G)))}catch(q){this.m.debug("Error while writing the extension cache file:",Q.path,(0,P.$0)(q))}}async L(){if(!this.C)return;const Q=this.M(this.C),G=await this.I(Q);if(!G)return;const q=G.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$1n(W,q))try{this.m.info("Invalidating Cache",q,W),await this.j.del(Q),this.F.fire()}catch(z){this.m.error(z)}}M(Q){const G=this.N(Q);return this.h.extUri.joinPath(G.cacheHome,Q.type===0?a.$Gm:a.$Fm)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(Q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};U=Se([ie(2,C.$wl),ie(3,j.$jq),ie(4,I.$ul),ie(5,o.$Wk),ie(6,n.$Wj)],U);function le(ce,Q){const G=(0,w.$rp)(ce.manifest.publisher,ce.manifest.name);return{id:G,identifier:new a.$Lm(G),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Q,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class ee extends F{constructor(Q,G,q,W,z,V,B,oe,he,J,A,N){super(Q,G,(0,$.$4g)(q,".vscode-oss-dev","extensions","control.json"),W,z,V,B,oe,he,J,A,N),this.S=(async()=>{if(k.$z)try{const _=await this.w.readFile(m.URI.file(k.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.S}}e.$rq=ee}),define(re[280],ae([0,1,5,41,40,28,83,16,38,7]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;let g=class extends P.$kq{constructor(k,$,d,v,p,m){super(u.URI.file(k.extensionsPath),$,d,v,p,m)}};e.$zQ=g,e.$zQ=g=Se([ie(0,h.$yi),ie(1,E.$Wk),ie(2,D.$wl),ie(3,S.$ul),ie(4,R.$Vl),ie(5,i.$Wj)],g)}),define(re[281],ae([0,1,7,38,83,132,16,6,5,27,40,41]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let k=class extends R.$rq{constructor(d,v,p,m,f,l,w,a){super(i.URI.file(f.builtinExtensionsPath),i.URI.file(f.extensionsPath),f.userHome,d.defaultProfile,d,v,p,m,f,l,w,a)}};e.$Ccc=k,e.$Ccc=k=Se([ie(0,y.$wl),ie(1,S.$jq),ie(2,P.$Wk),ie(3,h.$Wj),ie(4,D.$yi),ie(5,u.$dk),ie(6,g.$ul),ie(7,E.$pi)],k)}),define(re[282],ae([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let d=class extends D.$Uc{constructor(p,m,f){super(),this.c=p,this.f=f,this.a=E.$wi.forPaths(!P.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,(m,f)=>this.j(m,f)),p.protocol.interceptFileProtocol(S.Schemas.file,(m,f)=>this.h(m,f)),this.B((0,D.$Sc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const m=(0,R.$ic)(p);return this.a.get(m)?D.$Uc.None:(this.a.set(m,!0),(0,D.$Sc)(()=>this.a.delete(m)))}h(p,m){const f=h.URI.parse(p.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),m({error:-3})}j(p,m){const f=this.m(p);let l;return this.c.crossOriginIsolated&&((0,R.$oc)(f)==="workbench.html"||(0,R.$oc)(f)==="workbench-dev.html"?l=S.COI.CoopAndCoep:l=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(f)?m({path:f,headers:l}):this.b.has((0,R.$pc)(f).toLowerCase())?m({path:f}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),m({error:-3}))}m(p){const m=h.URI.parse(p.url),f=S.$Kg.uriToFileUri(m);return(0,R.$ic)(f.fsPath)}createIPCObjectUrl(){let p;const m=h.URI.from({scheme:"vscode",path:(0,u.$Mg)()}),f=m.toString(),l=async()=>p;return g.$DW.handle(f,l),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:m,update:w=>p=w,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),g.$DW.removeHandler(f)}}}};e.$Ucc=d,e.$Ucc=d=Se([ie(0,y.$yi),ie(1,$.$wl),ie(2,k.$Wj)],d)}),define(re[97],ae([0,1,8,3,2,66,12,115,6,41]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=$,e.$Xp=v,e.$Zp=m,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,h.$qi)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function $(f){const l=f.get(e.$Tp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class d extends S.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:d.a}){super(),this.m=l,this.b=this.B(new D.$ee),this.c=this.B(new D.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$be),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,w,a){return D.Event.filter(this.b.event,t=>t.scope===l&&(w===void 0||t.key===w),a)}n(){this.j.value=(0,i.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,w){const{key:a,external:t}=w;if(a===e.$Tp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:a,target:this.J(l)[a],external:t})}w(l){this.f.fire({reason:l})}get(l,w,a){return this.P(w)?.get(l,a)}getBoolean(l,w,a){return this.P(w)?.getBoolean(l,a)}getNumber(l,w,a){return this.P(w)?.getNumber(l,a)}getObject(l,w,a){return this.P(w)?.getObject(l,a)}storeAll(l,w){this.y(()=>{for(const a of l)this.store(a.key,a.value,a.scope,a.target,w)})}store(l,w,a,t,o=!1){if((0,P.$ag)(w)){this.remove(l,a,o);return}this.y(()=>{this.z(l,a,t),this.P(a)?.set(l,w,o)})}remove(l,w,a=!1){this.y(()=>{this.z(l,w,void 0),this.P(w)?.delete(l,a)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,w){const a=[],t=this.J(l);for(const o of Object.keys(t))t[o]===w&&a.push(o);return a}z(l,w,a,t=!1){const o=this.J(w);typeof a=="number"?o[l]!==a&&(o[l]=a,this.P(w)?.set(e.$Tp,JSON.stringify(o),t)):typeof o[l]=="number"&&(delete o[l],this.P(w)?.set(e.$Tp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const w=this.P(l);return w?$(w):Object.create(null)}isNew(l){return this.getBoolean(e.$Sp,l)===!0}async flush(l=g.NONE){this.f.fire({reason:l});const w=this.P(-1),a=this.P(0),t=this.P(1);switch(l){case g.NONE:await i.Promises.settled([w?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await i.Promises.settled([w?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,w=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return m(l,w,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,w){return this.w(g.NONE),(0,u.$vl)(l)?this.R(l,w):this.S(l,w)}M(l,w){return!(l.id===w.id||v(w)&&v(l))}N(l,w,a){this.y(()=>{const t=new Set;for(const[o,s]of l)t.add(o),w.get(o)!==s&&this.u(a,{key:o,external:!0});for(const[o]of w.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Wp=d;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class p extends d{constructor(){super(),this.U=this.B(new E.$Qp(new E.$Rp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Qp(new E.$Rp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Qp(new E.$Rp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Yp=p;async function m(f,l,w,a,t,o){const s=M=>{try{return JSON.parse(M)}catch{return M}},n=new Map,r=new Map;f.forEach((M,F)=>{n.set(F,M),r.set(F,s(M))});const c=new Map,b=new Map;l.forEach((M,F)=>{c.set(F,M),b.set(F,s(M))});const j=new Map,C=new Map;w.forEach((M,F)=>{j.set(F,M),C.set(F,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(n.forEach((M,F)=>{I.push({key:F,value:M})}),console.table(I),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];c.forEach((F,L)=>{M.push({key:L,value:F})}),console.table(M),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const O=[];j.forEach((M,F)=>{O.push({key:F,value:M})}),console.table(O),console.groupEnd(),console.log(C)}}),define(re[283],ae([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=e.$rbc=e.$qbc=void 0;class m extends R.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,n){super(),this.m=s,this.n=n,this.b=this.B(new S.$be),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$be),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$Qp(new g.$Rp,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$Nh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(r=>this.b.fire(r))),await this.s(s);const n=s.getBoolean($.$Sp);n===void 0?s.set($.$Sp,!0):n&&s.set($.$Sp,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,n){return this.f.get(s,n)}set(s,n){return this.f.set(s,n)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new E.$0d(!1);await this.w(),s.stop(),s.elapsed()>m.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const n=(0,i.top)(Array.from(this.f.items.entries()).map(([c,b])=>({key:c,length:b.length})),(c,b)=>b.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),r=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class f extends m{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,P.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,f.y)}constructor(s,n,r,c){super(r,c),this.z=s,this.C=n}async t(){return new g.$Qp(new y.$9W(this.path??y.$9W.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class l extends f{constructor(s,n,r,c){super(s,n,r,c)}}e.$qbc=l;class w extends f{constructor(s,n,r,c){super(n.defaultProfile,s,r,c)}async s(s){await super.s(s),this.G(s)}G(s){s.get(d.$Yl,void 0)===void 0&&s.set(d.$Yl,new Date().toUTCString());const r=s.get(d.$Xl,void 0),c=new Date().toUTCString();s.set(d.$Zl,typeof r>"u"?null:r),s.set(d.$Xl,c)}}e.$rbc=w;class a extends m{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,n,r,c,b){super(r,b),this.C=s,this.D=n,this.F=c}async t(){const{storageFilePath:s,wasCreated:n}=await this.H();return new g.$Qp(new y.$9W(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:n?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$9W.IN_MEMORY_PATH,wasCreated:!0};const s=(0,P.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),n=(0,P.$kc)(s,a.y);return await u.Promises.exists(s)?{storageFilePath:n,wasCreated:!1}:(await u.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:n,wasCreated:!0})}async I(s){let n;if((0,v.$Ai)(this.C)?n={folder:this.C.uri.toString()}:(0,v.$Fi)(this.C)&&(n={workspace:this.C.configPath.toString()}),n)try{const r=(0,P.$kc)(s,a.z);await u.Promises.exists(r)||await u.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.$sbc=a;class t extends m{get path(){}async t(){return new g.$Qp(new g.$Rp,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$tbc=t}),define(re[284],ae([0,1,3,2,97]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class R extends D.$Uc{constructor(E,h,u){super(),this.b=E,this.c=h,this.f=u;const g=this.B(new D.$Vc);this.a=this.B(new i.$be({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new D.$Tc;return E.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,u)=>(h?h.push(u.key):h=[u.key],h),100)(h=>this.h(h))),E.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(h,u)=>{h||(h=new Map);let g=h.get(u.profile.id);return g||h.set(u.profile.id,g={profile:u.profile,keys:[],storage:u.storage}),g.keys.push(u.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(S.$Tp)?[this.c.defaultProfile]:[],u=[];if(E=E.filter(g=>g!==S.$Tp),E.length){const g=(0,S.$Vp)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:g[y]}))})}this.m(h,u)}j(E){const h=[],u=new Map;for(const[g,y]of E.entries()){y.keys.includes(S.$Tp)&&h.push(y.profile);const k=y.keys.filter($=>$!==S.$Tp);if(k.length){const $=(0,S.$Vp)(y.storage.storage);u.set(g,{profile:y.profile,changes:k.map(d=>({key:d,scope:0,target:$[d]}))})}}this.m(h,[...u.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,u){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$Ecc=R}),define(re[285],ae([0,1,7,38,16,5,34,40,41,12,125]),function(Z,e,i,D,S,R,P,E,h,u,g){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=e.$xQ=e.$wQ=void 0;let $=class extends h.$zl{static{y=this}static{this.a="profileAssociationsMigration"}constructor(m,f,l,w,a){super(l,w,f,a),this.U=m,this.W=l}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,u.$4f)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):i.URI.revive(f.location)}))}Q(){const m=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?m:this.N(m)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$wQ=$,e.$wQ=$=y=Se([ie(0,P.$rQ),ie(1,E.$ul),ie(2,D.$yi),ie(3,S.$Wk),ie(4,R.$Wj)],$);let d=k=class extends ${constructor(m,f,l,w,a){super(m,f,l,w,a),this.$=m}P(m){m.length?this.$.setItem(k.b,m.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const m=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(m),this.$.setItem("userDataProfilesMigration",!0)),m}R(m){m.emptyWindows||m.workspaces?this.$.setItem(k.c,m):this.$.removeItem(k.c)}Q(){const m="workspaceAndProfileInfo",f=this.$.getItem(m,void 0);if(f){this.$.removeItem(m);const w=f.reduce((a,{workspace:t,profile:o})=>(a[i.URI.revive(t).toString()]=i.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:w})}const l=super.Q();return this.$.getItem(k.a,!1)||(this.R(l),this.$.setItem(k.a,!0)),l}};e.$xQ=d,e.$xQ=d=k=Se([ie(0,P.$sQ),ie(1,E.$ul),ie(2,D.$yi),ie(3,S.$Wk),ie(4,R.$Wj)],d);let v=class extends d{constructor(m,f,l,w){super(new g.$vQ(0,f,w,l),m,f,l,w)}async init(){return await this.$.init(),super.init()}};e.$yQ=v,e.$yQ=v=Se([ie(0,E.$ul),ie(1,D.$yi),ie(2,S.$Wk),ie(3,R.$Wj)],v)}),define(re[57],ae([0,1,38,16,6,5,40,41,285,34]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=void 0,e.$$ac=(0,S.$ri)(E.$wl);let g=class extends h.$xQ{constructor(k,$,d,v,p){super(k,$,d,v,p)}getAssociatedEmptyWindows(){const k=[];for(const $ of this.C.emptyWindows.keys())k.push({id:$});return k}};e.$_ac=g,e.$_ac=g=Se([ie(0,u.$sQ),ie(1,P.$ul),ie(2,i.$yi),ie(3,D.$Wk),ie(4,R.$Wj)],g)}),define(re[133],ae([0,1,19,7,30]),function(Z,e,i,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=R,e.$bbc=P,e.$cbc=E;async function R(h,u,g){for(const k of h){const $=k.openedWorkspace;if((0,S.$Fi)($)){const d=await g($);if(d){if(d.folders.some(v=>i.$Ug.isEqualOrParent(u,v.uri)))return k}else if(i.$Ug.isEqualOrParent(u,$.configPath))return k}}const y=h.filter(k=>(0,S.$Ai)(k.openedWorkspace)&&i.$Ug.isEqualOrParent(u,k.openedWorkspace.uri));if(y.length)return y.sort((k,$)=>-(k.openedWorkspace.uri.path.length-$.openedWorkspace.uri.path.length))[0]}function P(h,u){for(const g of h)if((0,S.$Fi)(g.openedWorkspace)&&i.$Ug.isEqual(g.openedWorkspace.configPath,u)||(0,S.$Ai)(g.openedWorkspace)&&i.$Ug.isEqual(g.openedWorkspace.uri,u))return g}function E(h,u){const g=y=>u.some(k=>i.$Ug.isEqual(D.URI.file(k),D.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(k=>g(k)))return y}}),define(re[98],ae([0,1,32,42,103,48,13,9,4,19,7,6,68,30]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufb=void 0,e.$Vfb=d,e.$Wfb=v,e.$Xfb=p,e.$Yfb=m,e.$Zfb=w,e.$1fb=t,e.$2fb=o,e.$3fb=b,e.$4fb=j,e.$Ufb=(0,y.$qi)("workspacesService");function d(C){return C.hasOwnProperty("workspace")}function v(C){return C.hasOwnProperty("folderUri")}function p(C){return C.hasOwnProperty("fileUri")}function m(C){return f(C)||l(C)}function f(C){const I=C;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function l(C){const I=C;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function w(C,I,O,M,F){if(C.scheme!==M.scheme)return{name:O,uri:C.toString(!0)};let L=I?void 0:F.relativePath(M,C);if(L!==void 0)L.length===0?L=".":h.$i&&(L=a(L));else if(C.scheme===P.Schemas.file)L=C.fsPath,h.$i&&(L=a(L));else if(F.isEqualAuthority(C.authority,M.authority))L=C.path;else return{name:O,uri:C.toString(!0)};return{name:O,path:L}}function a(C){return C=(0,R.$ow)(C),(0,i.$ng)(C)||(C=(0,i.$kg)(C)),C}function t(C,I,O){const M=[],F=new Set,L=O.dirname(I);for(const T of C){let U;if(f(T))T.path&&(U=O.resolvePath(L,T.path));else if(l(T))try{U=g.URI.parse(T.uri),U.path[0]!==E.$hc.sep&&(U=U.with({path:E.$hc.sep+U.path}))}catch(le){console.warn(le)}if(U){const le=O.getComparisonKey(U);if(!F.has(le)){F.add(le);const ee=T.name||O.basenameOrAuthority(U);M.push(new $.$Ki({uri:U,name:ee,index:M.length},T))}}}return M}function o(C,I,O,M,F){const L=s(I,C),T=F.dirname(I),U=F.dirname(M),le=[];for(const G of L.folders){const q=f(G)?F.resolvePath(T,G.path):g.URI.parse(G.uri);let W;O?W=!1:W=!f(G)||(0,E.$jc)(G.path),le.push(w(q,W,G.name,U,F))}const ee={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ce=S.$Sn(C,["folders"],le,ee);let Q=S.$Vn(C,ce);return(0,u.$9g)(L.remoteAuthority,(0,k.$Bm)(M))&&(Q=S.$Vn(Q,S.$Rn(Q,["remoteAuthority"],ee))),Q}function s(C,I){const O=D.$Dn(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>m(M));else throw new Error(`${C} looks like an invalid workspace file.`);return O}function n(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function r(C){return typeof C.folderUri=="string"}function c(C){return typeof C.fileUri=="string"}function b(C,I){const O={workspaces:[],files:[]};if(C){const M=function(L,T){for(let U=0;U<L.length;U++)try{T(L[U],U)}catch(le){I.warn(`Error restoring recent entry ${JSON.stringify(L[U])}: ${le.toString()}. Skip entry.`)}},F=C;Array.isArray(F.entries)&&M(F.entries,L=>{const T=L.label,U=L.remoteAuthority;n(L)?O.workspaces.push({label:T,remoteAuthority:U,workspace:{id:L.workspace.id,configPath:g.URI.parse(L.workspace.configPath)}}):r(L)?O.workspaces.push({label:T,remoteAuthority:U,folderUri:g.URI.parse(L.folderUri)}):c(L)&&O.files.push({label:T,remoteAuthority:U,fileUri:g.URI.parse(L.fileUri)})})}return O}function j(C){const I={entries:[]};for(const O of C.workspaces)v(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of C.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(re[99],ae([0,1,87,13,4,19]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0,e.$ebc=P,e.$fbc=E,e.$gbc=h,e.$dbc=128/4;function P(u){function g(){let y=u.scheme===D.Schemas.file?(0,R.$Rg)(u):u.toString();return S.$k||(y=y.toLowerCase()),(0,i.createHash)("md5").update(y).digest("hex")}return{id:g(),configPath:u}}function E(u,g){function y(){if(u.scheme!==D.Schemas.file)return(0,i.createHash)("md5").update(u.toString()).digest("hex");if(!g)return;let $;return S.$k?$=g.ino:S.$j?$=g.birthtime.getTime():S.$i&&(typeof g.birthtimeMs=="number"?$=Math.floor(g.birthtimeMs):$=g.birthtime.getTime()),(0,i.createHash)("md5").update(u.fsPath).update($?String($):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:u}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(re[100],ae([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=s,e.$ji=n,e.$li=b,e.$mi=j;class v{traceSocketEvent(I,O){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(P.$Ce.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$fi=v;var p;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var m;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(m||(m={}));class f extends u.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,F){super(),this.f=this.B(new h.$be),this.g=this.B(new h.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new l(this,O,M,F,this.f,(L,T)=>this.m(L,T))),this.B(this.a.onError(L=>{console.error(L),(0,E.$1)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new d.$ai,this.B(this.socket.onData(L=>this.n(L))),this.B(this.socket.onClose(async L=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(L)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let F=2;I.byteLength<126?F+=0:I.byteLength<2**16?F+=2:F+=8;const L=P.$Ce.alloc(F),T=O?64:0,U=M&15;if(L.writeUInt8(128|T|U,0),I.byteLength<126)L.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){L.writeUInt8(126,1);let le=1;L.writeUInt8(I.byteLength>>>8&255,++le),L.writeUInt8(I.byteLength>>>0&255,++le)}else{L.writeUInt8(127,1);let le=1;L.writeUInt8(0,++le),L.writeUInt8(0,++le),L.writeUInt8(0,++le),L.writeUInt8(0,++le),L.writeUInt8(I.byteLength>>>24&255,++le),L.writeUInt8(I.byteLength>>>16&255,++le),L.writeUInt8(I.byteLength>>>8&255,++le),L.writeUInt8(I.byteLength>>>0&255,++le)}this.socket.write(P.$Ce.concat([L,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),F=(M&128)>>>7,L=(M&64)>>>6,T=M&15,U=O.readUInt8(1),le=(U&128)>>>7,ee=U&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!L),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),F=(M&128)>>>7;let L=M&127,T=1;L===126?L=O.readUInt8(++T)*2**8+O.readUInt8(++T):L===127&&(L=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let U=0;F&&(U=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=L,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=f;class l extends u.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.$Ce.alloc(0)}constructor(I,O,M,F,L,T){super(),this.n=I,this.r=L,this.s=T,this.a=this.B(new h.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new w(this.n,F,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,F)=>{I.write(O),I.flush(L=>M(L))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((F,L)=>{I.write(O),M&&I.write(P.$Ce.fromByteArray([0,0,255,255])),I.flush(T=>F(T))})}}class w extends u.$Uc{get recordedInflateBytes(){return this.j?P.$Ce.concat(this.f):P.$Ce.alloc(0)}constructor(I,O,M,F){super(),this.h=I,this.j=O,this.a=this.B(new h.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(F),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(P.$Ce.wrap(L))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=P.$Ce.concat(this.g);this.g.length=0,I(O)})}}class a extends u.$Uc{constructor(I,O){super(),this.g=I,this.a=this.B(new h.$be),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(P.$Ce.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=P.$Ce.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(C,I){if(I===0)return;const O=C.byteLength>>>2;for(let le=0;le<O;le++){const ee=C.readUInt32BE(le*4);C.writeUInt32BE(ee^I,le*4)}const M=O*4,F=C.byteLength-M,L=I>>>24&255,T=I>>>16&255,U=I>>>8&255;F>=1&&C.writeUInt8(C.readUInt8(M)^L,M),F>=2&&C.writeUInt8(C.readUInt8(M+1)^T,M+1),F>=3&&C.writeUInt8(C.readUInt8(M+2)^U,M+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function s(){const C=(0,k.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const I=process.platform!=="darwin"&&e.$hi?e.$hi:(0,S.tmpdir)(),O=(0,g.$kc)(I,`vscode-ipc-${C}.sock`);return r(O),O}function n(C,I,O){const F=(0,i.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${O}-${I}-sock`;const L=O.substr(0,4),T=I.substr(0,6);let U;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?U=(0,g.$kc)(e.$hi,`vscode-${F}-${L}-${T}.sock`):U=(0,g.$kc)(C,`${L}-${T}.sock`),r(U),U}function r(C){const I=o[y.$u];typeof I=="number"&&C.length>=I&&console.warn(`WARNING: IPC handle "${C}" is longer than ${I} chars, try a shorter --user-data-dir`)}class c extends $.$7h{static b(I){const O=h.Event.fromNodeEventEmitter(I,"connection");return h.Event.map(O,M=>({protocol:new d.$bi(new v(M,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(c.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=c;function b(C){return new Promise((I,O)=>{const M=(0,D.createServer)();M.on("error",O),M.listen(C,()=>{M.removeListener("error",O),I(new c(M))})})}function j(C,I){return new Promise((O,M)=>{const F=(0,D.createConnection)(C,()=>{F.removeListener("error",M),O(d.$ci.fromSocket(new v(F,`ipc-client${I}`),I))});F.once("error",M)})}}),define(re[24],ae([0,1,51,9,4,100,38,91,6]),function(Z,e,i,D,S,R,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=void 0,e.$Wac=(0,h.$ri)(P.$xi);class u extends E.$3m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,D.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$ji)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(S.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$Xac=u,Se([i.$Uh],u.prototype,"cachedLanguagesPath",null),Se([i.$Uh],u.prototype,"backupHome",null),Se([i.$Uh],u.prototype,"mainIPCHandle",null),Se([i.$Uh],u.prototype,"mainLockfile",null),Se([i.$Uh],u.prototype,"disableUpdates",null),Se([i.$Uh],u.prototype,"crossOriginIsolated",null),Se([i.$Uh],u.prototype,"codeCachePath",null),Se([i.$Uh],u.prototype,"useCodeCache",null)}),define(re[287],ae([0,1,87,32,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;let l=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,s){this.j=a,this.k=t,this.l=o,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Ug,this.i={isEqual:(n,r)=>(0,D.$pg)(n,r,!P.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,u.$Zac)(a)),this.e=await this.v((0,u.$1ac)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==$.$jl.OFF}q(){return this.s()===$.$jl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||$.$jl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const o=(0,R.$kc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const s of a){const n=s.workspace;if(!(0,p.$Fi)(n))return[];if(!t.has(n.id)){t.add(n.id);const r=(0,R.$kc)(this.c,n.id);await this.B(r)?n.configPath.scheme!==S.Schemas.file||await h.Promises.exists(n.configPath.fsPath)?o.push(s):await this.z(r):await this.x(r)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const n=s.folderUri,r=this.h.getComparisonKey(n);if(!o.has(r)){o.add(r);const c=(0,R.$kc)(this.c,this.D(s));await this.B(c)?n.scheme!==S.Schemas.file||await h.Promises.exists(n.fsPath)?t.push(s):await this.z(c):await this.x(c)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const n=s.backupFolder;if(typeof n!="string")return[];if(!o.has(n)){o.add(n);const r=(0,R.$kc)(this.c,n);await this.B(r)?t.push(s):await this.x(r)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,m.$gbc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,m.$gbc)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,R.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,u.$Yac)(a)?t=(0,R.$kc)(this.c,a.backupFolder):(0,v.$Sfb)(a)?t=(0,R.$kc)(this.c,this.D(a)):t=(0,R.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,R.$kc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const s={folderUri:t.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const s={backupFolder:t};return o&&(s.remoteAuthority=o),s})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===S.Schemas.file?o=P.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,i.createHash)("md5").update(o).digest("hex")}};e.$zbc=l,e.$zbc=l=f=Se([ie(0,y.$Wac),ie(1,g.$Wi),ie(2,d.$Wj),ie(3,k.$sQ)],l)}),define(re[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.LifecycleMainPhase=e.ShutdownReason=e.$obc=void 0,e.$obc=(0,g.$qi)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var p;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let m=class extends P.$Uc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,w,a){super(),this.F=l,this.G=w,this.H=a,this.c=this.B(new R.$be),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$be),this.onWillShutdown=this.f.event,this.g=this.B(new R.$be),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$be),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};i.app.addListener("before-quit",l);const w=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&i.app.quit()};i.app.addListener("window-all-closed",w),i.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",l),i.app.removeListener("window-all-closed",w),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(l){if(this.y)return this.y;const w=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:l,join(t,o){w.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{w.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const w=this.C.get(this.n);w&&(w.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let w=this.C.get(l);w||(w=new S.$ph,this.C.set(l,w)),await w.wait()}registerWindow(l){const w=new P.$Tc;this.t++,w.add(l.onWillLoad(t=>this.g.fire({window:l,workspace:t.workspace,reason:t.reason})));const a=(0,u.$cg)(l.win);w.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const o=l.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),t.preventDefault(),this.unload(l,1).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(l),l.close()})})),w.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,w.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)}))}registerAuxWindow(l){const w=(0,u.$cg)(l.win),a=new P.$Tc;a.add(R.Event.fromNodeEventEmitter(w,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${l.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(w,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${l.id}`),a.dispose()}))}async reload(l,w){await this.unload(l,3)||l.reload(w)}unload(l,w){const a=this.z.get(l.id);if(a)return a;const t=this.M(l,w).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,t),t}async M(l,w){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const a=this.j?2:w,t=await this.P(l,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(t)):(await this.Q(l,a),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,w){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;D.$DW.once(o,()=>{a(!1)}),D.$DW.once(s,()=>{a(!0)}),l.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:w})})}Q(l,w){return new Promise(a=>{const o=`vscode:reply${this.s++}`;D.$DW.once(o,()=>a()),l.send("vscode:onWillUnload",{replyChannel:o,reason:w})})}quit(l){return this.R(l).then(w=>{if(!w&&l)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return w})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(d.b,!0),this.u=new Promise(w=>{this.w=w,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const w=process.argv.slice(1);if(l?.addArgs&&w.push(...l.addArgs),l?.removeArgs)for(const o of l.removeArgs){const s=w.indexOf(o);s>=0&&w.splice(s,1)}const a=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:w}))};i.app.once("quit",a),await this.quit(!0)&&i.app.removeListener("quit",a)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$rh)(1e3),(async()=>{for(const w of i.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let a;w.webContents&&!w.webContents.isDestroyed()?a=new Promise(t=>w.once("closed",t)):a=Promise.resolve(),w.destroy(),await a}})()]),i.app.exit(l)}};e.$pbc=m,e.$pbc=m=d=Se([ie(0,y.$Wj),ie(1,k.$sQ),ie(2,$.$Wac)],m)}),define(re[288],ae([0,1,4,3,2,6,20]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,R.$qi)("keyboardLayoutMainService");let E=class extends S.$Uc{constructor(g){super(),this.a=this.B(new D.$be),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((y,k)=>{Z(["native-keymap"],y,k)});this.c=h(g),i.$t||g.onDidChangeKeyboardLayout(()=>{this.c=h(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Xbc=E,e.$Xbc=E=Se([ie(0,P.$obc)],E);function h(u){const g=u.getKeyMap(),y=u.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:y}}}),define(re[289],ae([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0,e.$Qr=p;let d=class extends y.$Ip{constructor(f,l,w,a){super(a),this.m=f,this.n=l,this.r=w,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,l){const{f:w,g:a}=this;let t;try{t=await(0,u.$Am)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(n)))}const o={...process.env,...t},s=f.agent?f.agent:await(0,k.$Or)(f.url||"",o,{proxyUrl:w,strictSSL:a});return f.agent=s,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>p(f,l))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((l,w)=>{Z(["@vscode/proxy-agent"],l,w)})).loadSystemCertificates({log:this.r})}};e.$Pr=d,e.$Pr=d=Se([ie(0,E.$Wi),ie(1,h.$yi),ie(2,g.$Wj),ie(3,g.$Xj)],d);async function v(m){return((0,i.parse)(m.url).protocol==="https:"?await new Promise((w,a)=>{Z(["https"],w,a)}):await new Promise((w,a)=>{Z(["http"],w,a)})).request}async function p(m,f){return D.Promises.withAsyncBody(async(l,w)=>{const a=(0,i.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await v(m),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,P.$0f)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(o.auth=m.user+":"+m.password);const s=t(o,n=>{const r=(0,P.$8f)(m.followRedirects)?m.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)p({...m,url:n.headers.location,followRedirects:r-1},f).then(l,w);else{let c=n;!m.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(c=n.pipe((0,$.createGunzip)())),l({res:n,stream:(0,S.$Re)(c)})}});s.on("error",w),m.timeout&&s.setTimeout(m.timeout),m.isChromiumNetwork&&s.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&s.write(m.data),s.end(),f.onCancellationRequested(()=>{s.abort(),w(new R.$5)})})}}),define(re[290],ae([0,1,14,289]),function(Z,e,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;function S(P){return i.net.request}class R extends D.$Pr{request(E,h){return super.request({...E||{},getRawRequest:S,isChromiumNetwork:!0},h)}}e.$Zcc=R}),define(re[84],ae([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=e.$vbc=e.$ubc=void 0,e.$ubc=(0,E.$qi)("storageMainService");let p=class extends S.$Uc{constructor(l,w,a,t,o,s){super(),this.c=l,this.f=w,this.g=a,this.h=t,this.j=o,this.m=s,this.a=void 0,this.b=this.B(new D.$be),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,w]of this.t)l.join("profileStorage",w.close());for(const[,w]of this.w)l.join("workspaceStorage",w.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const w=this.t.get(l.profile.id);w&&l.join(w.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new y.$rbc(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,g.$Xp)(l))return this.applicationStorage;let w=this.t.get(l.id);if(!w){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),w=this.B(this.u(l)),this.t.set(l.id,w);const a=this.B(w.onDidChangeStorage(t=>this.b.fire({...t,storage:w,profile:l})));this.B(D.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),a.dispose()}))}return w}u(l){return this.a===2?new y.$tbc(this.c,this.j):new y.$qbc(l,this.n(),this.c,this.j)}workspaceStorage(l){let w=this.w.get(l.id);return w||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),w=this.B(this.y(l)),this.w.set(l.id,w),this.B(D.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),w}y(l){return this.a===2?new y.$tbc(this.c,this.j):new y.$sbc(l,this.n(),this.c,this.f,this.j)}isUsed(l){const w=i.URI.file(l);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(i.URI.file(a.path),w))return!0;return!1}};e.$vbc=p,e.$vbc=p=Se([ie(0,u.$Wj),ie(1,R.$xi),ie(2,$.$$ac),ie(3,h.$obc),ie(4,P.$Wk),ie(5,d.$ul)],p),e.$wbc=(0,E.$qi)("applicationStorageMainService");let m=class extends g.$Wp{constructor(l,w){super(),this.s=l,this.U=w,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$xbc=m,e.$xbc=m=Se([ie(0,k.$wl),ie(1,e.$ubc)],m)}),define(re[291],ae([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;async function m(t,o,s,n,r){let c;for(let b=3;b&&(c?.dispose(),c=await new f(t,o,s,n,r).waitForReady(),!(r&&S.$Pg[r]||!S.$Pg[c.tunnelLocalPort]));b--);return c}class f extends E.$Uc{constructor(o,s,n,r,c){super(),this.m=s,this.n=c,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=i.createServer(),this.c=new P.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,s=(0,v.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,S.$Qg)(o,2,1e3,s),r=null;return this.b.listen(n,this.m),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(o){o.pause();const s=(0,v.$$v)(this.tunnelRemoteHost)||(0,v.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,k.$Ml)(this.a,s,this.tunnelRemotePort),r=n.getSocket(),c=n.readEntireBuffer();n.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),r.end()}),o.on("close",()=>r.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),r instanceof R.$fi?r.socket.destroy():r.end()}),r instanceof R.$fi?this.t(o,r):this.s(o,r),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),r.end()})}s(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(n=>o.write(n.buffer)),o.on("data",n=>s.write(p.$Ce.wrap(n))),o.resume()}t(o,s){const n=s.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$Vcc=f;let l=class extends v.$dw{constructor(o,s,n,r,c){super(s,c),this.v=o,this.w=n,this.y=r}isPortPrivileged(o){return(0,v.$bw)(o,this.m,h.OS,D.release())}t(o,s,n,r,c,b,j,C){const I=this.s(s,n);if(I)return++I.refcount,I.value;if((0,v.$7v)(o))return this.u(o,s,n,c,b,j,C);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${c}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=m(O,r,s,n,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,n,M),M}}};e.$Wcc=l,e.$Wcc=l=Se([ie(0,$.$Gl),ie(1,g.$Wj),ie(2,d.$Jl),ie(3,y.$dk),ie(4,u.$Wi)],l);let w=class extends l{constructor(o,s,n,r,c){super(o,s,n,r,c)}};e.$Xcc=w,e.$Xcc=w=Se([ie(0,$.$Gl),ie(1,g.$Wj),ie(2,d.$Jl),ie(3,y.$dk),ie(4,u.$Wi)],w);let a=class extends E.$Uc{constructor(o,s,n,r,c){super(),this.b=o,this.c=s,this.f=n,this.g=r,this.h=c,this.a=new Map}async openTunnel(o,s,n,r,c,b,j,C,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${b}.`),!this.a.has(o)){const O=new w(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(o,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(s,n,r,c,b,j,C,I)}};e.$Ycc=a,e.$Ycc=a=Se([ie(0,$.$Gl),ie(1,g.$Wj),ie(2,y.$dk),ie(3,d.$Jl),ie(4,u.$Wi)],a)}),define(re[101],ae([0,1,8,23,3,18,24,20,5,27,53,50]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0,e.$hcc=k;function k(d,v,p){return`${p.updateUrl}/api/update/${d}/${v}/${p.commit}`}let $=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,p,m,f,l,w){this.f=v,this.g=p,this.h=m,this.i=f,this.j=l,this.k=w,this.b=y.$BX.Uninitialized,this.c=new S.$be,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$BX.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$BX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$BX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),p=this.m(v);if(!p){this.d(y.$BX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(y.$BX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const m=new URL(this.a);m.searchParams.set("prss","true"),this.a=m.toString()}if(this.d(y.$BX.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,m=>this.j.error(m))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,i.$rh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$icc=$,e.$icc=$=Se([ie(0,E.$obc),ie(1,R.$Wi),ie(2,P.$Wac),ie(3,g.$Hp),ie(4,h.$Wj),ie(5,u.$dk)],$)}),define(re[292],ae([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;let p=class extends v.$icc{get v(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"error",(f,l)=>l)}get w(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(f,l,w,a)=>({version:w,productVersion:w,timestamp:a}))}constructor(f,l,w,a,t,o,s){super(f,l,a,t,o,s),this.z=w,this.u=new P.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,R.$ej)(String(f)))}),this.j.error("UpdateService error:",f);const l=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(d.$BX.Idle(1,l))}s(f){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,v.$hcc)(l,f,this.k);try{i.autoUpdater.setFeedURL({url:w})}catch(a){this.j.error("Failed to set update feed URL",a);return}return w}t(f){this.d(d.$BX.CheckingForUpdates(f)),i.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(d.$BX.Downloading)}F(f){this.state.type==="downloading"&&(this.d(d.$BX.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(d.$BX.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$BX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$jcc=p,Se([D.$Uh],p.prototype,"v",null),Se([D.$Uh],p.prototype,"w",null),Se([D.$Uh],p.prototype,"x",null),Se([D.$Uh],p.prototype,"y",null),e.$jcc=p=Se([ie(0,u.$obc),ie(1,E.$Wi),ie(2,$.$Vl),ie(3,h.$Wac),ie(4,k.$Hp),ie(5,g.$Wj),ie(6,y.$dk)],p)}),define(re[293],ae([0,1,49,43,8,3,9,24,20,5,28,50]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,p,m){if(this.f=v,this.g=m,this.a=y.$BX.Uninitialized,this.b=new R.$be,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$BX.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,S.$rh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=Se([ie(0,h.$obc),ie(1,E.$Wac),ie(2,u.$Wj)],k);let $=class extends k{constructor(v,p,m,f,l,w){super(m,f,l),this.o=v,this.p=p,this.q=w;const a=(0,D.watch)(P.$nc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(r,c)=>c),o=R.Event.filter(t,r=>r==="current"),n=R.Event.debounce(o,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{n.dispose(),a.close()})}m(){this.d(y.$BX.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$BX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$BX.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$BX.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+P.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((m,f)=>(0,D.realpath)(`${P.$nc(this.o)}/current`,(l,w)=>l?f(l):m(w))),p=P.$oc(v);return this.p!==p}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$lcc=$,e.$lcc=$=Se([ie(2,h.$obc),ie(3,E.$Wac),ie(4,u.$Wj),ie(5,g.$Vl)],$)}),define(re[29],ae([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$8ac=void 0,e.$9ac=d,e.$0ac=v,e.$8ac=(0,S.$qi)("windowsMainService");var $;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})($||(e.OpenContext=$={}));function d(m,f,l){const w=m.get(E.$6ac),a=m.get(h.$dk),t=m.get(u.$Wi),o=m.get(g.$Wac),s=t.getValue("window"),n={backgroundColor:w.getBackgroundColor(),minWidth:P.$kD.WIDTH,minHeight:P.$kD.HEIGHT,title:a.nameLong,show:f.mode!==0&&f.mode!==3,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{...l,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.$vD)(f.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(D.$k?n.icon=(0,y.$kc)(o.appRoot,"resources/linux/code.png"):D.$i&&!o.isBuilt&&(n.icon=(0,y.$kc)(o.appRoot,"resources/win32/code_150x150.png")),D.$j&&(n.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(n.acceptFirstMouse=!1)),D.$j&&!(0,P.$uD)(t)&&(n.fullscreenable=!1),D.$j&&s?.nativeTabs===!0&&(n.tabbingIdentifier=a.nameShort),!(0,P.$rD)(t)&&(n.titleBarStyle="hidden",D.$j||(n.frame=!1),(0,P.$tD)(t))){const b=w.getWindowSplash()?.colorInfo.titleBarBackground??w.getBackgroundColor(),j=k.$Ft.fromHex(b).isDarker()?"#FFFFFF":"#000000";n.titleBarOverlay={height:29,color:b,symbolColor:j}}return n}function v(m){let f,l=Number.MIN_VALUE;for(const w of m)w.lastFocusTime>l&&(l=w.lastFocusTime,f=w);return f}var p;(function(m){function f(w,a,t=i.screen.getAllDisplays()){if(w.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){w.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){w.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const n=l(t[0]);if(w.trace("window#validateWindowState: single monitor working area",n),n){let r=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!n||(a.x<n.x&&(a.x=n.x),a.y<n.y&&(a.y=n.y))};r(),a.width>n.width&&(a.width=n.width),a.height>n.height&&(a.height=n.height),a.x>n.x+n.width-128&&(a.x=n.x+n.width-a.width),a.y>n.y+n.height-128&&(a.y=n.y+n.height-a.height),r()}return a}if(a.display&&a.mode===3){const n=t.find(r=>r.id===a.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){w.trace("window#validateWindowState: restoring fullscreen to previous display");const r=(0,R.$Uac)(3);return r.x=n.bounds.x,r.y=n.bounds.y,r}}let o,s;try{o=i.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=l(o),w.trace("window#validateWindowState: multi-monitor working area",s)}catch(n){w.error("window#validateWindowState: error finding display for window state",n)}if(o&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;w.trace("window#validateWindowState: state is outside of the multi-monitor working area")}m.validateWindowState=f;function l(w){if(w.workArea.width>0&&w.workArea.height>0)return w.workArea;if(w.bounds.width>0&&w.bounds.height>0)return w.bounds}})(p||(e.WindowStateValidator=p={}))}),define(re[294],ae([0,1,14,23,3,46,2,33,120,5,84,29]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;var k;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let $=class extends P.$Uc{constructor(v,p,m,f){super(),this.g=v,this.h=p,this.j=m,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=S.Event.fromNodeEventEmitter(i.app,"login",(p,m,f,l,w)=>({event:p,webContents:m,req:f,authInfo:l,callback:w}));this.B(v(this.r,this))}async r({event:v,authInfo:p,req:m,callback:f}){if(!p.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{l=await this.b}finally{this.b=void 0}}f(l?.username,l?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(v);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const p=String((0,R.$ej)({scheme:v.scheme,host:v.host,port:v.port}));let m,f;try{const t=this.m.get(this.a+p,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));m=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof m=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:m,password:f};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const w={authInfo:v,username:this.f?.username??m,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Mg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,w),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(s,n,r)=>{if(n===w.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",o),r){const c={username:r.username,password:r.password};try{if(r.remember){const b=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+p,b,-1,1)}else this.m.remove(this.a+p,-1)}catch(b){this.g.error(b)}t({username:c.username,password:c.password})}else t(void 0)};l.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$ybc=$,e.$ybc=$=Se([ie(0,u.$Wj),ie(1,y.$8ac),ie(2,h.$mX),ie(3,g.$wbc)],$)}),define(re[295],ae([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=e.ID=void 0,e.ID="launchMainService",e.$Zbc=(0,u.$qi)(e.ID);let $=class{constructor(v,p,m,f){this.a=v,this.b=p,this.c=m,this.d=f}async start(v,p){this.a.trace("Received data from other instance: ",v,p),S.$j&&i.app.focus({steal:!0});const m=this.e(v);if(m.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,D.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(f=l.ready())}f.then(()=>{for(const{uri:l,originalUrl:w}of m)this.c.open(l,{originalUrl:w})})}else return this.f(v,p)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,D.$Hb)(v._urls.map(p=>{try{return{uri:R.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(v,p){const m=(0,h.$um)(p)?0:4;let f=[];const l=v.wait&&v.waitMarkerFilePath?R.URI.file(v.waitMarkerFilePath):void 0,w=v.remote||void 0,a={context:m,cli:v,userEnv:v["preserve-env"]||m===0?p:void 0,waitMarkerFileURI:l,remoteAuthority:w,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(l&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,P.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$1bc=$,e.$1bc=$=Se([ie(0,g.$Wj),ie(1,k.$8ac),ie(2,y.$sX),ie(3,E.$Wi)],$)}),define(re[296],ae([0,1,2,20,57,30,8,29]),function(Z,e,i,D,S,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;let h=class extends i.$Uc{constructor(g,y,k){super(),this.a=y,this.b=k,this.B(g.onWillLoadWindow($=>{$.reason===2&&this.c($.window)})),this.B(g.onBeforeCloseWindow($=>this.c($))),this.B(new P.$Ch(()=>this.g(),30*1e3)).schedule()}async c(g){const y=this.f(g),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,R.$Ei)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of g)y.some($=>$.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$Dcc=h,e.$Dcc=h=Se([ie(0,D.$obc),ie(1,S.$$ac),ie(2,E.$8ac)],h)}),define(re[61],ae([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0;function f(a){return typeof a.responseWindowId=="number"}let l=class extends D.$Uc{static{m=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(m.b.values())}constructor(t,o,s){super(),this.u=t,this.w=o,this.y=s,this.c=String(++m.a),this.f=this.B(new S.$be),this.onStdout=this.f.event,this.g=this.B(new S.$be),this.onStderr=this.g.event,this.h=this.B(new S.$be),this.onMessage=this.h.event,this.j=this.B(new S.$be),this.onSpawn=this.j.event,this.m=this.B(new S.$be),this.onExit=this.m.event,this.n=this.B(new S.$be),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case g.default.Error:this.u.error(s);break;case g.default.Warning:this.u.warn(s);break;case g.default.Info:this.u.trace(s);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",g.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,s=h.$Kg.asFileUri("bootstrap-fork.js").fsPath,n=this.t.args??[],r=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,j="pipe",C=this.F(t);return this.z("creating new...",g.default.Info),this.r=i.utilityProcess.fork(s,n,{serviceName:o,env:C,execArgv:r,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:b,stdio:j}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,d.$Wn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,$.$hm)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}G(t,o,s){if(t.stdout){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(r=>this.f.fire(typeof r=="string"?r:n.write(r))))}if(t.stderr){const n=new P.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(r=>this.g.fire(typeof r=="string"?r:n.write(r))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(n=>this.h.fire(n))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&m.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",g.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(n=>{this.z(`received exit event with code ${n}`,g.default.Info),this.m.fire({pid:this.s,code:n,signal:"unknown"}),this.H()})),this.B(S.Event.fromNodeEventEmitter(i.app,"child-process-gone",(n,r)=>({event:n,details:r}))(({details:n})=>{n.type==="Utility"&&n.name===s&&(this.z(`crashed with code ${n.exitCode} and reason '${n.reason}'`,g.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:n.reason,code:n.exitCode}),this.n.fire({pid:this.s,code:n.exitCode,reason:n.reason}),this.H())}))}once(t,o){const s=this.B(this.h.event(n=>{n===t&&(s.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:s}=new i.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",g.default.Info),this.r.kill()?(this.z("successfully killed the process",g.default.Info),this.H()):this.z("unable to kill the process",g.default.Warning)}H(){typeof this.s=="number"&&m.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",g.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,E.$rh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$Bbc=l,e.$Bbc=l=m=Se([ie(0,R.$Wj),ie(1,y.$Vl),ie(2,k.$obc)],l);let w=class extends l{constructor(t,o,s,n){super(t,s,n),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const n=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[n]),!0}J(t,o){o.windowLifecycleBound&&(this.B(S.Event.filter(this.y.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Cbc=w,e.$Cbc=w=Se([ie(0,R.$Wj),ie(1,u.$8ac),ie(2,y.$Vl),ie(3,k.$obc)],w)}),define(re[297],ae([0,1,15,3,5,20,8,61,29,28]),function(Z,e,i,D,S,R,P,E,h,u){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;let y=class{static{g=this}static{this.a=0}constructor($,d,v,p){this.d=$,this.f=d,this.g=v,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i($){const d=this.b.get($);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout($){return this.i($).onStdout}onDynamicStderr($){return this.i($).onStderr}onDynamicMessage($){return this.i($).onMessage}onDynamicExit($){return this.i($).onExit}async createExtensionHost(){if(this.c)throw(0,i.$6)();const $=String(++g.a),d=new E.$Cbc(this.d,this.g,this.h,this.f);return this.b.set($,d),d.onExit(({pid:v,code:p,signal:m})=>{this.d.info(`Extension host with pid ${v} exited with code: ${p}, signal: ${m}.`),setTimeout(()=>{d.dispose(),this.b.delete($)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:$}}async start($,d){if(this.c)throw(0,i.$6)();const v=this.i($);return v.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:$}),{pid:await D.Event.toPromise(v.onSpawn)}}async enableInspectPort($){if(this.c)throw(0,i.$6)();const d=this.b.get($);return d?d.enableInspectPort():!1}async kill($){if(this.c)throw(0,i.$6)();const d=this.b.get($);d&&d.kill()}async _killAllNow(){for(const[,$]of this.b)$.kill()}async _waitForAllExit($){const d=[];for(const[,v]of this.b)d.push(v.waitForExit($));return P.Promises.settled(d).then(()=>{})}};e.$Jbc=y,e.$Jbc=y=g=Se([ie(0,S.$Wj),ie(1,R.$obc),ie(2,h.$8ac),ie(3,u.$Vl)],y)}),define(re[298],ae([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;let p=class extends S.$Uc{constructor(f,l,w,a,t,o,s,n){super(),this.f=f,this.g=l,this.h=w,this.j=a,this.m=t,this.n=o,this.r=s,this.s=n,this.a=new D.$ph,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){i.$DW.on(v.$_bc.request,(f,l)=>this.u(f,l,v.$_bc.response)),i.$DW.on(v.$acc.request,(f,l)=>this.u(f,l,v.$acc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,l,w){this.n.trace(`[SharedProcess] onWindowConnection for: ${w}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(w);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(w,l,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$$bc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new D.$Nh;this.b?.once(v.$$bc.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new D.$Nh;this.b?.once(v.$$bc.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$Bbc(this.n,k.$bp,this.m)),this.c=this.b.onMessage(w=>{typeof w.warning=="string"?this.n.warn(w.warning):typeof w.error=="string"&&this.n.error(w.error)});const f=(0,$.$5m)(this.h.args,this.h.isBuilt);let l;f.port&&(l=["--nolazy"],f.break?l.push(`--inspect-brk=${f.port}`):l.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:l})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,d.$cg)(this.b).connect(f)}};e.$bcc=p,e.$bcc=p=Se([ie(2,R.$Wac),ie(3,h.$wl),ie(4,P.$obc),ie(5,E.$Wj),ie(6,g.$jbc),ie(7,u.$$n)],p)}),define(re[299],ae([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;let v=class extends g.$Uc{constructor(m,f,l,w,a){super(),this.f=m,this.g=f,this.h=l,this.j=w,this.m=a,this.a=void 0,this.b=new y.$be,this.onRequestConnection=this.b.event,this.c=new y.$be,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),u.$DW.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,g.$Sc)(()=>{u.$DW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$Bbc(this.m,P.$bp,this.j);const m=(0,D.$4m)(this.h.args,this.h.isBuilt),f=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),w=new h.$LW(l,"ptyHost"),a=new g.$Tc;return a.add(w),a.add((0,g.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:w,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,k.$Wn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(m.VSCODE_LATENCY=String(f));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(m.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),m}r(m,f){this.b.fire();const l=this.a.connect();if(m.sender.isDestroyed()){l.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[l])}};e.$Ncc=v,e.$Ncc=v=Se([ie(1,$.$Wi),ie(2,i.$Wac),ie(3,S.$obc),ie(4,R.$Wj)],v)}),define(re[300],ae([0,1,2,6,5,29,61,28,46,3,8,20]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0,e.$Lcc=(0,D.$qi)("utilityProcessWorker");let k=class extends i.$Uc{constructor(v,p,m,f){super(),this.b=v,this.c=p,this.f=m,this.g=f,this.a=new Map}async createWorker(v){const p=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const m=this.h(v);this.a.has(m)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(v));const f=new $(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(m,f);const l=new g.$Nh;return u.Event.once(f.onDidTerminate)(w=>{w.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${w.code}, signal: ${w.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${w.code}, signal: ${w.signal}`),this.a.delete(m),l.complete({reason:w})}),l.p}h(v){return(0,h.$ej)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const p=this.h(v),m=this.a.get(p);m&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),m.kill(),this.a.delete(p))}};e.$Mcc=k,e.$Mcc=k=Se([ie(0,S.$Wj),ie(1,R.$8ac),ie(2,E.$Vl),ie(3,y.$obc)],k);let $=class extends i.$Uc{constructor(v,p,m,f,l){super(),this.c=v,this.f=p,this.g=m,this.h=f,this.j=l,this.a=this.B(new u.$be),this.onDidTerminate=this.a.event,this.b=new P.$Cbc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};$=Se([ie(0,S.$Wj),ie(1,R.$8ac),ie(2,E.$Vl),ie(3,y.$obc)],$)}),define(re[301],ae([0,1,14,3,2,277,29]),function(Z,e,i,D,S,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;let E=class extends S.$Uc{constructor(u){super(),this.b=u,this.a=this.B(new D.$be),this.onFoundInFrame=this.a.event,this.B(new R.$scc)}async setIgnoreMenuShortcuts(u,g){let y;if(typeof u.windowId=="number"){const{windowId:k}=u,$=this.b.getWindowById(k);if(!$?.win)throw new Error(`Invalid windowId: ${k}`);y=$.win.webContents}else{const{webContentsId:k}=u;if(y=i.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(g)}async findInFrame(u,g,y,k){const d=this.c(u,g);if(typeof d.findInFrame=="function"){d.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(p,m)=>{m.finalUpdate&&(this.a.fire(m),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(u,g,y){const $=this.c(u,g);typeof $.stopFindInFrame=="function"&&$.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(u,g){const y=this.b.getWindowById(u.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${u}`);const k=y.win.webContents.mainFrame.framesInSubtree.find($=>$.name===g);if(!k)throw new Error(`Unknown frame: ${g}`);return k}};e.$tcc=E,e.$tcc=E=Se([ie(0,P.$8ac)],E)}),define(re[302],ae([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0,e.$vcc=p,e.$wcc=f;let v=class extends D.$Uc{static{d=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,s,n){super(),this.g=a,this.h=t,this.j=o,this.m=s,this.n=n,this.b=p(this.h.getItem(d.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(t.lastActiveWindow=this.w(n),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.w(n);return r.uiState.mode===3&&(a.has(r.uiState.display)?S.$j&&r.windowId!==t.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):a.add(r.uiState.display)),r}));const s=f(t);this.h.setItem(d.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const s=(0,$.$Fi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,n=(0,$.$Ai)(a.openedWorkspace)&&o.folderUri&&R.$Ug.isEqual(o.folderUri,a.openedWorkspace.uri);(s||n)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,$.$Fi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,$.$Ai)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||o?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,$.$Fi)(b)){const C=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===b.id).map(I=>I.uiState);if(C.length)return C[0]}if((0,$.$Ai)(b)){const C=this.state.openedWindows.filter(I=>I.folderUri&&R.$Ug.isEqual(I.folderUri,b.uri)).map(I=>I.uiState);if(C.length)return C[0]}else if(a.backupPath){const C=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(C.length)return C[0]}const j=this.c||this.state.lastActiveWindow;if(!t&&j)return j.uiState}let o;const s=i.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(S.$j){const b=i.screen.getCursorScreenPoint();o=i.screen.getDisplayNearestPoint(b)}!o&&t&&(o=i.screen.getDisplayMatching(t.getBounds())),o||(o=i.screen.getPrimaryDisplay()||s[0])}let n=(0,k.$Uac)();n.x=Math.round(o.bounds.x+o.bounds.width/2-n.width/2),n.y=Math.round(o.bounds.y+o.bounds.height/2-n.height/2);const r=this.n.getValue("window");let c=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,c=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,c=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?n.mode=3:n={...b,zoomLevel:void 0},c=n.mode!==3&&r.newWindowDimensions==="offset"}}return c&&(n=this.C(n)),n.hasDefaultState=!0,n}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$ucc=v,e.$ucc=v=d=Se([ie(0,y.$8ac),ie(1,g.$sQ),ie(2,h.$obc),ie(3,u.$Wj),ie(4,E.$Wi)],v);function p(w){const a={openedWindows:[]},t=w||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>m(o))),a}function m(w){const a={uiState:w.uiState};return w.backupPath&&(a.backupPath=w.backupPath),w.remoteAuthority&&(a.remoteAuthority=w.remoteAuthority),w.folder&&(a.folderUri=P.URI.parse(w.folder)),w.workspaceIdentifier&&(a.workspace={id:w.workspaceIdentifier.id,configPath:P.URI.parse(w.workspaceIdentifier.configURIPath)}),a}function f(w){return{lastActiveWindow:w.lastActiveWindow&&l(w.lastActiveWindow),lastPluginDevelopmentHostWindow:w.lastPluginDevelopmentHostWindow&&l(w.lastPluginDevelopmentHostWindow),openedWindows:w.openedWindows.map(a=>l(a))}}function l(w){return{workspaceIdentifier:w.workspace&&{id:w.workspace.id,configURIPath:w.workspace.configPath.toString()},folder:w.folderUri&&w.folderUri.toString(),backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.uiState}}}),define(re[58],ae([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=void 0,e.$hbc=(0,d.$qi)("workspacesManagementMainService");let a=class extends R.$Uc{constructor(o,s,n,r,c){super(),this.g=o,this.h=s,this.j=n,this.m=r,this.n=c,this.a=this.B(new D.$be),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$be),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await u.Promises.readdir(this.c.with({scheme:P.Schemas.file}).fsPath)).map(s=>(0,h.$4g)(this.c,s,f.$Pi));for(const s of o){const n=(0,w.$ebc)(s),r=await this.resolveLocalWorkspace(s);r?this.f.push({workspace:n,remoteAuthority:r.remoteAuthority}):await this.deleteUntitledWorkspace(n)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>u.Promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===P.Schemas.file)try{const n=s(o.fsPath);return n instanceof Promise?n.then(r=>this.t(o,r),r=>{}):this.t(o,n)}catch{return}}s(o){return(0,f.$Qi)(o,this.g)||(0,f.$Vi)(o)}t(o,s){try{const n=this.u(o,s),r=(0,w.$ebc)(o);return{id:r.id,configPath:r.configPath,folders:(0,l.$1fb)(n.folders,r.configPath,h.$Ug),remoteAuthority:n.remoteAuthority,transient:n.transient}}catch(n){this.h.warn(n.toString())}}u(o,s){const n=(0,S.$Dn)(s);if(n&&Array.isArray(n.folders))n.folders=n.folders.filter(r=>(0,l.$Yfb)(r));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return n}async createUntitledWorkspace(o,s){const{workspace:n,storedWorkspace:r}=this.w(o,s),c=n.configPath.fsPath;return await u.Promises.mkdir((0,E.$nc)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(r,null,"	")),this.f.push({workspace:n,remoteAuthority:s}),n}w(o=[],s){const n=(Date.now()+Math.round(Math.random()*1e3)).toString(),r=(0,h.$4g)(this.c,n),c=(0,h.$4g)(r,f.$Pi),b=[];for(const j of o)b.push((0,l.$Zfb)(j.uri,!0,j.name,r,h.$Ug));return{workspace:(0,w.$ebc)(c),storedWorkspace:{folders:b,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,w.$ebc)(o)}isUntitledWorkspace(o){return(0,f.$Qi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,h.$Rg)(o.configPath);try{await u.Promises.rm((0,E.$nc)(s));const n=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath,o.id);await u.Promises.exists(n)&&await u.Promises.writeFile((0,E.$kc)(n,"obsolete"),""),this.f=this.f.filter(r=>r.workspace.id!==o.id)}catch(n){this.h.warn(`Unable to delete untitled workspace ${s} (${n}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,n){if(!o||!o.win||!o.isReady||!await this.z(o,s,n))return;const c=await this.C(o,(0,w.$ebc)(n));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,s,n){return n?(0,f.$Fi)(o.openedWorkspace)&&h.$Ug.isEqual(o.openedWorkspace.configPath,n)?!1:(0,m.$bbc)(s,n)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,h.$1g)(n)),detail:(0,g.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let n;return o.config.extensionDevelopmentPath||(o.config.backupPath?n=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):n=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,f.$Fi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=n,{workspace:s,backupPath:n}}};e.$ibc=a,e.$ibc=a=Se([ie(0,$.$Wac),ie(1,v.$Wj),ie(2,p.$$ac),ie(3,y.$2ac),ie(4,k.$3ac)],a)}),define(re[134],ae([0,1,14,37,23,6,29,30,58,12,5,61]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Ebc=(0,R.$qi)(e.ID);let k=class{constructor(d,v,p){this.a=d,this.b=v,this.c=p}async getRemoteDiagnostics(d){const v=this.a.getWindows();return(await Promise.all(v.map(async m=>{const f=m.remoteAuthority;if(!f)return;const l=`vscode:getDiagnosticInfoResponse${m.id}`,w={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.f(m):void 0};return new Promise(a=>{m.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:l,args:w}),D.$DW.once(l,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const d=[];for(const p of i.BrowserWindow.getAllWindows()){const m=this.a.getWindowById(p.id);m?d.push(await this.d(m)):d.push(this.e(p))}const v=[];for(const{pid:p,name:m}of y.$Bbc.getAll())v.push({pid:p,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:v,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(d){const v=await this.f(d),p=(0,u.$cg)(d.win);return this.e(p,v,d.remoteAuthority)}e(d,v=[],p){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:v,remoteAuthority:p}}async f(d){const v=[],p=d.openedWorkspace;if((0,E.$Ai)(p))v.push(p.uri);else if((0,E.$Fi)(p)){const m=await this.b.resolveLocalWorkspace(p.configPath);m&&m.folders.forEach(l=>{v.push(l.uri)})}return v}};e.$Fbc=k,e.$Fbc=k=Se([ie(0,P.$8ac),ie(1,h.$hbc),ie(2,g.$Wj)],k)}),define(re[70],ae([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0,e.$Tbc=(0,w.$qi)("nativeHostMainService");let M=class extends h.$Uc{constructor(L,T,U,le,ee,ce,Q,G,q){super(),this.a=L,this.b=T,this.c=U,this.f=le,this.g=ee,this.h=ce,this.j=Q,this.m=G,this.n=q,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,W=>W.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:W,x:z,y:V})=>({windowId:W.id,x:z,y:V})),E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:W,x:z,y:V})=>({windowId:W.id,x:z,y:V}))),this.onDidMaximizeWindow=E.Event.any(E.Event.map(this.a.onDidMaximizeWindow,W=>W.id),E.Event.map(this.b.onDidMaximizeWindow,W=>W.id)),this.onDidUnmaximizeWindow=E.Event.any(E.Event.map(this.a.onDidUnmaximizeWindow,W=>W.id),E.Event.map(this.b.onDidUnmaximizeWindow,W=>W.id)),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,W=>({windowId:W.window.id,fullscreen:W.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,W=>({windowId:W.window.id,fullscreen:W.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(W,z)=>z.id),W=>!!this.a.getWindowById(W)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),W=>!!W),W=>W.id),E.Event.filter(E.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(W,z)=>z.id),W=>!!this.a.getWindowById(W))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(W,z)=>this.b.getWindowByWebContents(z.webContents)),W=>!!W),W=>W.id)),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(W,z)=>this.b.getWindowByWebContents(z.webContents)),W=>!!W),W=>W.id)),this.onDidResumeOS=E.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$be),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(W,z,V)=>V),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),E.Event.fromNodeEventEmitter(D.screen,"display-added"),E.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(L,T){const U=this.a.getWindows().map(ee=>({id:ee.id,workspace:ee.openedWorkspace??(0,r.$Ei)(ee.backupPath,ee.isExtensionDevelopmentHost),title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename(),dirty:ee.isDocumentEdited()})),le=[];return T.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(ee=>({id:ee.id,parentId:ee.parentId,title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename()}))),[...U,...le]}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(L,T,U){return Array.isArray(T)?this.s(L,T,U):this.t(L,T)}async s(L,T,U=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:T,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async t(L,T){await this.a.openEmptyWindow({context:5,contextWindowId:L},T)}async toggleFullScreen(L,T){this.C(T?.targetWindowId,L)?.toggleFullScreen()}async handleTitleDoubleClick(L,T){this.C(T?.targetWindowId,L)?.handleTitleDoubleClick()}async getCursorScreenPoint(L){const T=D.screen.getCursorScreenPoint(),U=D.screen.getDisplayNearestPoint(T);return{point:T,display:U.bounds}}async isMaximized(L,T){return this.C(T?.targetWindowId,L)?.win?.isMaximized()??!1}async maximizeWindow(L,T){this.C(T?.targetWindowId,L)?.win?.maximize()}async unmaximizeWindow(L,T){this.C(T?.targetWindowId,L)?.win?.unmaximize()}async minimizeWindow(L,T){this.C(T?.targetWindowId,L)?.win?.minimize()}async moveWindowTop(L,T){this.C(T?.targetWindowId,L)?.win?.moveTop()}async positionWindow(L,T,U){const le=this.C(U?.targetWindowId,L);if(le?.win){if(le.win.isFullScreen()){const ee=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await ee}le.win.setBounds(T)}}async updateWindowControls(L,T){this.C(T?.targetWindowId,L)?.updateWindowControls(T)}async focusWindow(L,T){this.C(T?.targetWindowId,L)?.focus({force:T?.force??!1})}async setMinimumSize(L,T,U){const le=this.D(L);if(le?.win){const[ee,ce]=le.win.getSize(),[Q,G]=le.win.getMinimumSize(),[q,W]=[T??Q,U??G],[z,V]=[Math.max(ee,q),Math.max(ce,W)];(Q!==q||G!==W)&&le.win.setMinimumSize(q,W),(ee!==z||ce!==V)&&le.win.setSize(z,V)}}async saveWindowSplash(L,T){this.m.saveWindowSplash(L,T)}async installShellCommand(L){const{source:T,target:U}=await this.u();try{const{symbolicLink:le}=await v.SymlinkSupport.stat(T);if(le&&!le.dangling){const ee=await(0,$.$Xq)(T);if(U===ee)return}await v.Promises.unlink(T)}catch(le){if(le.code!=="ENOENT")throw le}try{await v.Promises.symlink(U,T)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:ee}=await this.showMessageBox(L,{type:"info",message:(0,m.localize)(0,null,this.j.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(ee===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(i.exec)(ce)}catch{throw new Error((0,m.localize)(3,null,T))}}}async uninstallShellCommand(L){const{source:T}=await this.u();try{await v.Promises.unlink(T)}catch(U){switch(U.code){case"EACCES":{const{response:le}=await this.showMessageBox(L,{type:"info",message:(0,m.localize)(4,null,this.j.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(le===1)throw new O.$5;try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(i.exec)(ee)}catch{throw new Error((0,m.localize)(7,null,T))}break}case"ENOENT":break;default:throw U}}}async u(){const L=(0,g.$lc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(L))throw new Error((0,m.localize)(8,null,L));return{source:T,target:L}}async showMessageBox(L,T){const U=this.C(T?.targetWindowId,L);return this.c.showMessageBox(T,U?.win??void 0)}async showSaveDialog(L,T){const U=this.C(T?.targetWindowId,L);return this.c.showSaveDialog(T,U?.win??void 0)}async showOpenDialog(L,T){const U=this.C(T?.targetWindowId,L);return this.c.showOpenDialog(T,U?.win??void 0)}async pickFileFolderAndOpen(L,T){const U=await this.c.pickFileFolder(T);U&&await this.w(await Promise.all(U.map(async le=>await v.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),T,L)}async pickFolderAndOpen(L,T){const U=await this.c.pickFolder(T);U&&await this.w(U.map(le=>({folderUri:k.URI.file(le)})),T,L)}async pickFileAndOpen(L,T){const U=await this.c.pickFile(T);U&&await this.w(U.map(le=>({fileUri:k.URI.file(le)})),T,L)}async pickWorkspaceAndOpen(L,T){const U=await this.c.pickWorkspace(T);U&&await this.w(U.map(le=>({workspaceUri:k.URI.file(le)})),T,L)}async w(L,T,U){await this.a.open({context:3,contextWindowId:U,cli:this.g.args,urisToOpen:L,forceNewWindow:T.forceNewWindow})}async showItemInFolder(L,T){D.shell.showItemInFolder(T)}async setRepresentedFilename(L,T,U){this.C(U?.targetWindowId,L)?.setRepresentedFilename(T)}async setDocumentEdited(L,T,U){this.C(U?.targetWindowId,L)?.setDocumentEdited(T)}async openExternal(L,T){return this.g.unsetSnapExportedVariables(),D.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(L,T){return D.shell.trashItem(T)}async isAdmin(){let L;return y.$i?L=(await new Promise((T,U)=>{Z(["native-is-elevated"],T,U)}))():L=process.getuid?.()===0,L}async writeElevated(L,T,U,le){const ee=await new Promise((ce,Q)=>{Z(["@vscode/sudo-prompt"],ce,Q)});return new Promise((ce,Q)=>{const G=[`"${this.z}"`];le?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${T.fsPath}"`,`"${U.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,g.$kc)((0,g.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ee.exec(G.join(" "),q,(W,z,V)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),W?Q(W):ce(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:D.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,g.$kc)((0,g.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,g.$kc)((0,g.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$kc)(this.g.appRoot,"bin","code"):(0,g.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return d.$yn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,j.$Qbc)()}async killProcess(L,T,U){process.kill(T,U)}async readClipboardText(L,T){return D.clipboard.readText(T)}async writeClipboardText(L,T,U){return D.clipboard.writeText(T,U)}async readClipboardFindText(L){return D.clipboard.readFindText()}async writeClipboardFindText(L,T){return D.clipboard.writeFindText(T)}async writeClipboardBuffer(L,T,U,le){return D.clipboard.writeBuffer(T,Buffer.from(U.buffer),le)}async readClipboardBuffer(L,T){return b.$Ce.wrap(D.clipboard.readBuffer(T))}async hasClipboard(L,T,U){return D.clipboard.has(T,U)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,T){this.D(L)?.updateTouchBar(T)}async notifyReady(L){this.D(L)?.setReady()}async relaunch(L,T){return this.f.relaunch(T)}async reload(L,T){const U=this.D(L);if(U){if((0,r.$Fi)(U.openedWorkspace)){const le=U.openedWorkspace.configPath;if(le.scheme===u.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(L,T){return this.C(T?.targetWindowId,L)?.win?.close()}async quit(L){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(L,T){await this.f.kill(T)}async resolveProxy(L,T){return this.D(L)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(L){return(await new Promise((U,le)=>{Z(["@vscode/proxy-agent"],U,le)})).loadSystemCertificates({log:this.h})}findFreePort(L,T,U,le,ee=1){return(0,p.$Og)(T,U,le,ee)}async openDevTools(L,T){this.C(T?.targetWindowId,L)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(L,T){this.C(T?.targetWindowId,L)?.win?.webContents.toggleDevTools()}async profileRenderer(L,T,U){const le=this.D(L);if(!le||!le.win)throw new Error;return await new C.$Rbc(le.win,T,this.h).inspect(U)}async windowsGetStringRegKey(L,T,U,le){if(!y.$i)return;const ee=await new Promise((ce,Q)=>{Z(["@vscode/windows-registry"],ce,Q)});try{return ee.GetStringRegKey(T,U,le)}catch{return}}C(L,T){return this.D(L)??this.F(L)??this.D(T)}D(L){if(typeof L=="number")return this.a.getWindowById(L)}F(L){if(typeof L!="number")return;const T=D.webContents.fromId(L);if(T)return this.b.getWindowByWebContents(T)}};e.$Ubc=M,Se([P.$Uh],M.prototype,"z",null),e.$Ubc=M=Se([ie(0,n.$8ac),ie(1,I.$Sbc),ie(2,f.$3ac),ie(3,a.$obc),ie(4,l.$Wac),ie(5,t.$Wj),ie(6,o.$dk),ie(7,s.$6ac),ie(8,c.$hbc)],M)}),define(re[303],ae([0,1,14,26,8,23,32,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;const c="issue.processExplorerWindowState";let b=class{static{r=this}static{this.a="#1E1E1E"}constructor(I,O,M,F,L,T,U,le,ee,ce,Q){this.g=I,this.h=O,this.i=M,this.j=F,this.k=L,this.l=T,this.m=U,this.n=le,this.o=ee,this.p=ce,this.q=Q,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$DW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,k.localize)(0,null),rootProcess:await(0,g.$us)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,$.$$m)(F)?O.push({name:F.hostName,rootProcess:F}):F.processes&&O.push({name:F.hostName,rootProcess:F.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),y.$DW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:F,args:L}=O;let T;switch(F){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}T?.webContents.send("vscode:runAction",{id:M,from:F,args:L})}),y.$DW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),y.$DW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const F of O.windows)M.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:L}of o.$Bbc.getAll())M.push([F,L]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,M,{backgroundColor:I.styles.backgroundColor,title:(0,k.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:l.default}),this.b.loadURL(h.$Kg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),F=this.p.getItem(c,void 0),L=j(F)?F:this.v(this.f,800,500);this.d=this.u(L,M,{backgroundColor:I.styles.backgroundColor,title:(0,k.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:l.default}),this.d.loadURL(h.$Kg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const U=this.d.getSize(),le=this.d.getPosition();if(!U||!le)return;const ee={width:U[0],height:U[1],x:le[0],y:le[1]};this.p.setItem(c,ee)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await i.contentTracing.stopRecording(`${(0,P.$yg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null,I),buttons:[(0,k.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,k.localize)(6,null),buttons:[(0,k.localize)(7,null),(0,k.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,k.localize)(9,null),buttons:[(0,k.localize)(10,null),(0,k.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",L=new R.$me;return M.sendWhenReady(F,L.token,{replyChannel:F,extensionId:I,extensionName:O}),await(0,S.$hh)(new Promise(U=>y.$DW.once(`vscode:triggerReporterMenuResponse:${I}`,(le,ee)=>U(ee))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),L.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,F){const L=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||r.a,webPreferences:{preload:h.$Kg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$vD)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}v(I,O,M){let F;const L=i.screen.getAllDisplays();if(L.length===1)F=L[0];else{if(u.$j){const le=i.screen.getCursorScreenPoint();F=i.screen.getDisplayNearestPoint(le)}!F&&I&&(F=i.screen.getDisplayMatching(I.getBounds())),F||(F=i.screen.getPrimaryDisplay()||L[0])}const T=F.bounds,U={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(U.x<T.x&&(U.x=T.x),U.y<T.y&&(U.y=T.y),U.x>T.x+T.width&&(U.x=T.x),U.y>T.y+T.height&&(U.y=T.y),U.width>T.width&&(U.width=T.width),U.height>T.height&&(U.height=T.height)),U}};e.$Vbc=b,e.$Vbc=b=r=Se([ie(1,p.$Wac),ie(2,m.$Wj),ie(3,$.$0m),ie(4,d.$Ebc),ie(5,v.$3ac),ie(6,f.$Tbc),ie(7,a.$5ac),ie(8,w.$dk),ie(9,t.$sQ),ie(10,n.$8ac)],b);function j(C){return typeof C!="object"||C===null?!1:"x"in C&&"y"in C&&"width"in C&&"height"in C}}),define(re[304],ae([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;let $=class extends k.$icc{constructor(v,p,m,f,l,w,a,t){super(v,p,f,l,w,t),this.e=m,this.u=a}s(v){return(0,k.$hcc)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$BX.CheckingForUpdates(v)),this.i.request({url:this.a},i.CancellationToken.None).then(u.$Np).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$BX.Idle(1))):this.d(y.$BX.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const m=v?p.message||p:void 0;this.d(y.$BX.Idle(1,m))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$BX.Idle(1))}};e.$kcc=$,e.$kcc=$=Se([ie(0,R.$obc),ie(1,D.$Wi),ie(2,g.$Vl),ie(3,S.$Wac),ie(4,u.$Hp),ie(5,P.$Wj),ie(6,E.$Tbc),ie(7,h.$dk)],$)}),define(re[305],ae([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;async function s(b,j=1e3){for(;!b();)await(0,R.$rh)(j)}let n;function r(){return typeof n>"u"&&(n=D.existsSync(u.$kc(u.$nc(process.execPath),"unins000.exe"))?0:1),n}let c=class extends o.$icc{get cachePath(){const j=u.$kc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(j,{recursive:!0}).then(()=>j)}constructor(j,C,I,O,M,F,L,T,U){super(j,C,O,M,F,U),this.u=I,this.v=L,this.w=T,j.setRelaunchHandler(this)}handleRelaunch(j){return j?.addArgs||j?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$BX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(j){let C=`win32-${process.arch}`;return r()===1?C+="-archive":this.k.target==="user"&&(C+="-user"),(0,o.$hcc)(C,j,this.k)}t(j){this.a&&(this.d(t.$BX.CheckingForUpdates(j)),this.i.request({url:this.a},P.CancellationToken.None).then(w.$Np).then(C=>{const I=r();return!C||!C.url||!C.version||!C.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!j}),this.d(t.$BX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$BX.AvailableForDownload(C)),Promise.resolve(null)):(this.d(t.$BX.Downloading),this.C(C.version).then(()=>this.B(C.version).then(O=>k.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const F=`${O}.tmp`;return this.i.request({url:C.url},P.CancellationToken.None).then(L=>this.v.writeFile(g.URI.file(F),L.stream)).then(C.sha256hash?()=>(0,y.$wW)(F,C.sha256hash):()=>{}).then(()=>k.Promises.rename(F,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$BX.Downloaded(C)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$BX.Ready(C))})))}).then(void 0,C=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$ej)(String(C)))}),this.j.error(C);const I=j?C.message||C:void 0;this.d(t.$BX.Idle(r(),I))}))}async o(j){j.update.url&&this.w.openExternal(void 0,j.update.url),this.d(t.$BX.Idle(r()))}async B(j){const C=await this.cachePath;return u.$kc(C,`CodeSetup-${this.k.quality}-${j}.exe`)}async C(j=null){const C=j?F=>!new RegExp(`${this.k.quality}-${j}\\.exe$`).test(F):()=>!0,I=await this.cachePath,M=(await k.Promises.readdir(I)).filter(C).map(async F=>{try{await k.Promises.unlink(u.$kc(I,F))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const j=this.state.update;this.d(t.$BX.Updating(j));const C=await this.cachePath;this.e.updateFilePath=u.$kc(C,`CodeSetup-${this.k.quality}-${j.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$BX.Idle(r()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((F,L)=>{Z(["@vscode/windows-mutex"],F,L)});s(()=>M.isActive(O)).then(()=>this.d(t.$BX.Ready(j)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return r()}async _applySpecificUpdate(j){if(this.state.type!=="idle")return;const C=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$BX.Downloading),this.e={packagePath:j},this.d(t.$BX.Downloaded(I)),C?this.k.target==="user"&&this.p():this.d(t.$BX.Ready(I))}};e.$mcc=c,Se([E.$Uh],c.prototype,"cachePath",null),e.$mcc=c=Se([ie(0,p.$obc),ie(1,$.$Wi),ie(2,a.$Vl),ie(3,d.$Wac),ie(4,w.$Hp),ie(5,m.$Wj),ie(6,v.$Wk),ie(7,f.$Tbc),ie(8,l.$dk)],c)}),define(re[135],ae([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O,M,F,L,T,U,le,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0;var ce;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ce||(ce={}));class Q extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(W){this.m=W,this.B(P.Event.fromNodeEventEmitter(W,"maximize")(()=>this.b.fire())),this.B(P.Event.fromNodeEventEmitter(W,"unmaximize")(()=>this.c.fire())),this.B(P.Event.fromNodeEventEmitter(W,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(P.Event.fromNodeEventEmitter(W,"focus")(()=>{this.j=Date.now()})),this.B(P.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(P.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const z=!(0,j.$rD)(this.r);if(g.$j&&z&&W.setSheetOffset((0,g.$J)((0,$.release)())?28:22),z&&(g.$i&&(0,j.$tD)(this.r)||g.$j)){const V=this.s.getItem(Q.D);V&&this.updateWindowControls({height:V})}g.$i&&z&&W.hookWindowMessage(278,()=>{const[B,oe]=W.getPosition(),he=i.screen.getCursorScreenPoint(),J=he.x-B,A=he.y-oe;return!(J>30&&A>=0&&A<=Math.max(W.getBounds().height*.15,35))||(W.setEnabled(!1),W.setEnabled(!0),this.f.fire({x:J,y:A})),0}),this.t.args["open-devtools"]===!0&&W.webContents.openDevTools(),g.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(W,z,V,B){super(),this.r=W,this.s=z,this.t=V,this.u=B,this.a=this.B(new P.$be),this.onDidClose=this.a.event,this.b=this.B(new P.$be),this.onDidMaximize=this.b.event,this.c=this.B(new P.$be),this.onDidUnmaximize=this.c.event,this.f=this.B(new P.$be),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new P.$be),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new P.$be),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,j.$tD)(this.r),this.G=void 0,this.H=void 0}w(W,z=i.screen.getAllDisplays().length>0){const V=this.r.getValue("window"),B=g.$j&&V?.nativeTabs===!0;(g.$j||g.$i)&&z&&(!B||i.BrowserWindow.getAllWindows().length===1)&&[W.width,W.height,W.x,W.y].every(oe=>typeof oe=="number")&&this.m?.setBounds({width:W.width,height:W.height,x:W.x,y:W.y}),(W.mode===0||W.mode===3)&&(this.m?.maximize(),W.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(W){g.$j?this.win?.setRepresentedFilename(W):this.z=W}getRepresentedFilename(){return g.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(W){g.$j&&this.win?.setDocumentEdited(W),this.C=W}isDocumentEdited(){return g.$j?!!this.win?.isDocumentEdited():!!this.C}focus(W){g.$j&&W?.force&&i.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const W=this.win;if(W)if(g.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":W.minimize();break;case"None":break;case"Maximize":default:W.isMaximized()?W.unmaximize():W.maximize()}else W.isMaximized()?W.unmaximize():W.maximize()}static{this.D="windowControlHeight"}updateWindowControls(W){const z=this.win;if(z){if(W.height&&this.s.setItem(G.D,W.height),g.$i&&this.F)z.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(g.$j&&W.height!==void 0){const V=(W.height-15)/2;V?z.setWindowButtonPosition({x:V,y:V}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(W,z){(0,j.$uD)(this.r)?this.J(W,z):this.M(W)}get isFullScreen(){if(g.$j&&typeof this.G=="boolean")return this.G;const W=this.win,z=W?.isFullScreen(),V=W?.isSimpleFullScreen();return!!(z||V)}J(W,z){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.L(W,z)}L(W,z){if(g.$j){this.G=W;const B=this.H=new D.$Nh;(async()=>{const oe=await Promise.race([B.p,(0,D.$rh)(1e4).then(()=>!1)]);this.H===B&&(this.G=void 0,this.H=void 0,!oe&&W&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(W)}M(W){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(W),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$lbc=Q;let G=class extends Q{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const W=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Ei)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(W,z,V,B,oe,he,J,A,N,_,ne,X,H,x,K,se,ue,me,$e,ye,ke){super(_,ye,B,z),this.fb=V,this.gb=oe,this.hb=he,this.ib=J,this.jb=A,this.kb=N,this.lb=ne,this.mb=X,this.nb=H,this.ob=x,this.pb=K,this.qb=se,this.rb=ue,this.sb=me,this.tb=$e,this.N=this.B(new P.$be),this.onWillLoad=this.N.event,this.O=this.B(new P.$be),this.onDidSignalReady=this.O.event,this.P=this.B(new P.$be),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[Ee,Oe]=this.Eb(W.state);this.U=Ee,this.u.trace("window#ctor: using window state",Ee);const we=ke.invokeFunction(C.$9ac,this.U,{preload:h.$Kg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,u.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow(we),(0,u.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Oe),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.X.push(W)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(W=>{function z(){V.dispose(),B.dispose(),W()}const V=this.onDidClose(()=>z()),B=this.onWillLoad(()=>z())})}vb(){this.B(P.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,V)=>V)(z=>this.yb(2,{...z}))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,V,B)=>({exitCode:V,reason:B}))(({exitCode:z,reason:V})=>this.yb(3,{reason:V,exitCode:z}))),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(P.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(z,V)=>{const B=await this.xb();V({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,B)})})}xb(){return this.wb||(this.wb=(0,s.$2p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(W,z){switch(W){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:W,reason:z?.reason,code:z?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:B}=await this.pb.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.S?.workspace?(0,k.localize)(5,null):void 0},this.m);if(V!==2){const oe=V===0;await this.zb(oe,B)}}else if(W===2){let V;z?V=(0,k.localize)(7,null,z.reason,z.exitCode??"<unknown>"):V=(0,k.localize)(6,null);const{response:B,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:V,detail:this.S?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.S?.workspace?(0,k.localize)(13,null):void 0},this.m),he=B===0;await this.zb(he,oe)}break}}async zb(W,z){const V=this.S?.workspace;if(z&&V)try{const B=this.kb.workspaceStorage(V);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.u.error(B)}this.P.fire();try{if(W&&this.S){let B,oe;(0,I.$Ai)(V)?B={folderUri:V.uri}:(0,I.$Fi)(V)?B={workspaceUri:V.configPath}:oe=!0,(0,le.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(W){this.S?.workspace?.id===W.id&&(this.S.workspace=void 0)}Bb(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!W||W.affectsConfiguration("http.proxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||V!==this.$)){this.Z=z,this.$=V;const B=z||"",oe=V?`${V},<local>`:"<local>";this.u.trace(`Setting proxy to '${B}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:B,proxyBypassRules:oe,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:B,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(W){g.$j&&W.win&&this.m.addTabbedWindow(W.win)}load(W,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(W,z),this.ub===0?this.S=W:this.db=W,this.ub=1,this.m.loadURL(h.$Kg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new D.$Ch(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:W.workspace,reason:z.isReload?3:V?2:1})}Cb(W,z){const V=(this.S??this.db)?.userEnv;if(V){const B=(0,f.$um)(V)&&!(0,f.$um)(W.userEnv),oe=this.isExtensionDevelopmentHost;(B||oe)&&(W.userEnv={...V,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(W["disable-extensions"]=z.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.m.isMaximized(),W.partsSplash=this.lb.getWindowSplash(),W.zoomLevel=this.Jb(),W.isCustomZoomLevel=typeof this.ab=="number",W.isCustomZoomLevel&&W.partsSplash&&(W.partsSplash.zoomLevel=W.zoomLevel),(0,u.mark)("code/willOpenNewWindow"),W.perfMarks=(0,u.getMarks)(),this.bb.update(W)}async reload(W){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&W&&(z.verbose=W.verbose,z.debugId=W.debugId,z.extensionEnvironment=W.extensionEnvironment,z["inspect-extensions"]=W["inspect-extensions"],z["inspect-brk-extensions"]=W["inspect-brk-extensions"],z["extensions-dir"]=W["extensions-dir"]),z.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async Db(W){if((0,I.$Fi)(W.workspace)){const z=W.workspace.configPath;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}else if((0,I.$Ai)(W.workspace)){const z=W.workspace.uri;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}return W.workspace}serializeWindowState(){if(!this.m)return(0,M.$Uac)();if(this.isFullScreen){let V;try{V=i.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,M.$Uac)();return{mode:3,display:V?V.id:void 0,width:this.U.width||B.width,height:this.U.height||B.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const W=Object.create(null);let z;if(!g.$j&&this.m.isMaximized()?z=0:z=1,z===0?W.mode=0:W.mode=1,z===1||z===0){let V;z===1?V=this.getBounds():V=this.m.getNormalBounds(),W.x=V.x,W.y=V.y,W.width=V.width,W.height=V.height}return W.zoomLevel=this.ab,W}Eb(W){(0,u.mark)("code/willRestoreCodeWindowState");let z=!1;if(W){this.ab=W.zoomLevel;try{const V=i.screen.getAllDisplays();z=V.length>1,W=C.WindowStateValidator.validateWindowState(this.u,W,V)}catch(V){this.u.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,u.mark)("code/didRestoreCodeWindowState"),[W||(0,M.$Uac)(),z]}getBounds(){const[W,z]=this.m.getPosition(),[V,B]=this.m.getSize();return{x:W,y:z,width:V,height:B}}I(W,z){super.I(W,z),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let W=(0,j.$pD)(this.r);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Hb(W,z=!0){g.$j||(W==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Ib(W)}):this.Ib(W))}Ib(W){const z=this.isFullScreen;switch(W){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(W){this.ab=W}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(W,z,...V){this.isReady?this.send(W,...V):this.ready().then(()=>{z.isCancellationRequested||this.send(W,...V)})}send(W,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.m.webContents.send(W,...z)}catch(V){this.u.warn(`Error sending IPC message to channel '${W}' of window ${this.Q}: ${(0,R.$bj)(V)}`)}}}updateTouchBar(W){g.$j&&this.Y.forEach((z,V)=>{const B=W[V];z.segments=this.Mb(B)})}Kb(){if(g.$j){for(let W=0;W<10;W++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new i.TouchBar({items:this.Y}))}}Lb(W=[]){const z=this.Mb(W),V=new i.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:V.segments[B].id,from:"touchbar"})}});return V}Mb(W=[]){return W.map(V=>{let B;V.icon&&!c.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===h.Schemas.file&&(B=i.nativeImage.createFromPath(y.URI.revive(V.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let oe;return typeof V.title=="string"?oe=V.title:oe=V.title.value,{id:V.id,label:B?void 0:oe,icon:B}})}matches(W){return this.m?.webContents.id===W.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$mbc=G,e.$mbc=G=Se([ie(1,a.$Wj),ie(2,U.$jbc),ie(3,m.$Wac),ie(4,F.$$n),ie(5,T.$$ac),ie(6,l.$Wk),ie(7,n.$wbc),ie(8,n.$ubc),ie(9,v.$Wi),ie(10,b.$6ac),ie(11,O.$hbc),ie(12,d.$2ac),ie(13,r.$Vl),ie(14,p.$3ac),ie(15,w.$obc),ie(16,t.$dk),ie(17,o.$5ac),ie(18,C.$8ac),ie(19,L.$sQ),ie(20,ee.$pi)],G)}),define(re[306],ae([0,1,14,4,18,24,20,5,34,55,135]),function(Z,e,i,D,S,R,P,E,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;let y=class extends g.$lbc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor($,d,v,p,m,f){super(p,m,d,v),this.O=$,this.P=f,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow($){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),$&&!this.N&&(this.N=!0,this.w({x:$.x,y:$.y,width:$.width,height:$.height,mode:$.show===!1?0:1})))}Q(){if(this.m)return;const $=i.BrowserWindow.fromWebContents(this.O);$&&(this.u.trace("[aux window] Claimed browser window instance"),this.n($),$.setMenu(null),(D.$i||D.$k)&&(0,u.$rD)(this.r)&&$.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches($){return this.O.id===$.id}};e.$nbc=y,e.$nbc=y=Se([ie(1,R.$Wac),ie(2,E.$Wj),ie(3,S.$Wi),ie(4,h.$sQ),ie(5,P.$obc)],y)}),define(re[307],ae([0,1,14,3,2,13,37,306,6,5,82,29]),function(Z,e,i,D,S,R,P,E,h,u,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;let k=class extends S.$Uc{constructor(d,v){super(),this.h=d,this.j=v,this.a=this.B(new D.$be),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new D.$be),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new D.$be),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new D.$be),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(d,v)=>{const p=this.getWindowByWebContents(v.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const m=new S.$Tc;m.add(D.Event.fromNodeEventEmitter(v.webContents,"did-create-window",(f,l)=>({browserWindow:f,details:l}))(({browserWindow:f,details:l})=>{const w=this.getWindowByWebContents(f.webContents);w&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),w.tryClaimWindow(l.options))})),m.add(D.Event.fromNodeEventEmitter(v,"closed")(()=>m.dispose()))}}),P.$DW.handle("vscode:registerAuxiliaryWindow",async(d,v)=>{const p=this.getWindowByWebContents(d.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=v),d.sender.id})}createWindow(d){return this.h.invokeFunction(y.$9ac,this.n(d),{preload:R.$Kg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(d){const v={},p=d.features.split(",");for(const f of p){const[l,w]=f.split("=");switch(l){case"width":v.width=parseInt(w,10);break;case"height":v.height=parseInt(w,10);break;case"left":v.x=parseInt(w,10);break;case"top":v.y=parseInt(w,10);break;case"window-maximized":v.mode=0;break;case"window-fullscreen":v.mode=3;break}}const m=y.WindowStateValidator.validateWindowState(this.j,v)??(0,g.$Vac)();return this.j.trace("[aux window] using window state",m),m}registerWindow(d){const v=new S.$Tc,p=this.h.createInstance(E.$nbc,d);this.g.set(p.id,p),v.add((0,S.$Sc)(()=>this.g.delete(p.id))),v.add(p.onDidMaximize(()=>this.a.fire(p))),v.add(p.onDidUnmaximize(()=>this.b.fire(p))),v.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),v.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),v.add(p.onDidTriggerSystemContextMenu(({x:m,y:f})=>this.f.fire({window:p,x:m,y:f}))),D.Event.once(p.onDidClose)(()=>v.dispose())}getWindowByWebContents(d){const v=this.g.get(d.id);return v?.matches(d)?v:void 0}getFocusedWindow(){const d=i.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,y.$0ac)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Rcc=k,e.$Rcc=k=Se([ie(0,h.$pi),ie(1,u.$Wj)],k)}),define(re[85],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,31,56]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,d.$qi)("workspacesHistoryMainService");let s=class extends E.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(r,c,b,j,C){super(),this.f=r,this.g=c,this.h=b,this.j=j,this.m=C,this.c=this.B(new R.$be),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$oh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let c=[],b=[];for(const C of r)if((0,f.$Vfb)(C))!this.g.isUntitledWorkspace(C.workspace)&&!this.w(c,C.workspace)&&c.push(C);else if((0,f.$Wfb)(C))this.y(c,C.folderUri)||c.push(C);else{const I=this.z(b,C.fileUri),O=C.fileUri.scheme===h.Schemas.file&&o.G.indexOf((0,g.$1g)(C.fileUri))>=0;!I&&!O&&(b.push(C),u.$i&&C.fileUri.scheme===h.Schemas.file&&i.app.addRecentDocument(C.fileUri.fsPath))}const j=await this.r({workspaces:c,files:b});c=j.workspaces,b=j.files,c.length>o.a&&(c.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:c,files:b}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(r){const c=I=>{const O=this.u(I);for(const M of r)if(g.$Ug.isEqual(M,O))return!1;return!0},b=await this.getRecentlyOpened(),j=b.workspaces.filter(c),C=b.files.filter(c);(j.length!==b.workspaces.length||C.length!==b.files.length)&&(await this.t({files:C,workspaces:j}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(r){if(r?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null)],message:(0,$.localize)(2,null),detail:(0,$.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(r){const c=new a.$Bc(C=>g.$Ug.getComparisonKey(C));if(r?.workspaces)for(const C of r.workspaces)c.set(this.u(C),C);const b=new a.$Bc(C=>g.$Ug.getComparisonKey(C));if(r?.files)for(const C of r.files)b.set(this.u(C),C);const j=await this.s();for(const C of j.workspaces){const I=c.get(this.u(C));I?I.label=I.label??C.label:c.set(this.u(C),C)}for(const C of j.files){const I=b.get(this.u(C));I?I.label=I.label??C.label:b.set(this.u(C),C)}return{workspaces:[...c.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let r;const c=this.j.get(o.b,-1);if(typeof c=="string")try{r=JSON.parse(c)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$3fb)(r,this.f)}async t(r){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$4fb)(r)),-1,1)}u(r){return(0,f.$Wfb)(r)?r.folderUri:(0,f.$Xfb)(r)?r.fileUri:r.workspace.configPath}w(r,c){return!!r.find(b=>(0,f.$Vfb)(b)&&b.workspace.id===c.id)}y(r,c){return!!r.find(b=>(0,f.$Wfb)(b)&&g.$Ug.isEqual(b.folderUri,c))}z(r,c){return!!r.find(b=>g.$Ug.isEqual(b.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){u.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!u.$i)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,$.localize)(4,null),description:(0,$.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const C of i.app.getJumpListSettings().removedItems){const I=C.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&c.push(y.URI.parse(O[2]))}}await this.removeRecentlyOpened(c);let b=!1;const j=(0,D.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(C=>{const I=(0,f.$Vfb)(C)?C.workspace:C.folderUri,{title:O,description:M}=this.L(I,C.label);let F;return y.URI.isUri(I)?F=`--folder-uri "${I.toString()}"`:(b=!0,F=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));j.length>0&&r.push({type:"custom",name:b?(0,$.localize)(6,null):(0,$.localize)(7,null),items:j})}r.push({type:"recent"});try{const c=i.app.setJumpList(r);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(r,c){if(c)return{title:(0,P.$ww)(c).name,description:c};if(y.URI.isUri(r))return{title:(0,g.$1g)(r),description:this.M(r)};if(this.g.isUntitledWorkspace(r))return{title:(0,$.localize)(8,null),description:""};let b=(0,g.$1g)(r.configPath);return b.endsWith(l.$Mi)&&(b=b.substr(0,b.length-l.$Mi.length-1)),{title:(0,$.localize)(9,null,b),description:this.M(r.configPath)}}M(r){return r.scheme==="file"?(0,P.$ow)(r.fsPath):r.toString()}async N(){if(!u.$j)return;i.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),c=[];let b=0;for(let C=0;C<r.workspaces.length&&b<o.C;C++){const I=this.u(r.workspaces[C]);if(I.scheme===h.Schemas.file){const O=(0,g.$Rg)(I);await k.Promises.exists(O)&&(c.push(O),b++)}}const j=[];for(let C=0;C<r.files.length&&b<o.D;C++){const I=this.u(r.files[C]);if(I.scheme===h.Schemas.file){const O=(0,g.$Rg)(I);if(o.G.includes((0,g.$1g)(I))||c.includes(O))continue;await k.Promises.exists(O)&&(j.push(O),b++)}}j.reverse().forEach(C=>i.app.addRecentDocument(C)),c.reverse().forEach(C=>i.app.addRecentDocument(C))}};e.$7bc=s,e.$7bc=s=o=Se([ie(0,p.$Wj),ie(1,w.$hbc),ie(2,v.$obc),ie(3,m.$wbc),ie(4,t.$3ac)],s)}),define(re[308],ae([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;const s="menu";let n=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,j,C,I,O,M,F,L,T,U,le,ee){this.n=b,this.o=j,this.p=C,this.q=I,this.r=O,this.s=M,this.t=F,this.u=L,this.v=T,this.w=U,this.x=le,this.y=ee,this.m=Object.create(null),this.g=new D.$Ch(()=>this.F(),0),this.h=new D.$Ch(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(P.$j||(0,w.$rD)(j))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,F,L)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:F?.id})},this.m["workbench.action.newWindow"]=(M,F,L)=>this.p.openEmptyWindow({context:2,contextWindowId:F?.id}),this.m["workbench.action.files.openFileFolder"]=(M,F,L)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(L),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,F,L)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(L),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,F,L)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(L),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const j=this.x.requestFeatureUrl;j&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(j,"openUserVoiceUrl"));const C=this.x.reportIssueUrl;C&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(C,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(P.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${P.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!P.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,j){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){P.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!P.$j)return;const b=i.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowByWebContents(b.webContents),this.E()}I(){const b=i.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(P.$j?new i.Menu:null);return}const j=new i.Menu;let C;if(P.$j){const O=new i.Menu;C=new i.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),j.append(C)}if(P.$j&&!this.c){this.c=!0;const O=new i.Menu;O.append(new i.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),i.app.dock.setMenu(O)}if(this.M("File")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(1,null)),submenu:O});this.O(O,"File"),j.append(M)}if(this.M("Edit")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(2,null)),submenu:O});this.O(O,"Edit"),j.append(M)}if(this.M("Selection")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(3,null)),submenu:O});this.O(O,"Selection"),j.append(M)}if(this.M("View")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(4,null)),submenu:O});this.O(O,"View"),j.append(M)}if(this.M("Go")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(5,null)),submenu:O});this.O(O,"Go"),j.append(M)}if(this.M("Run")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(6,null)),submenu:O});this.O(O,"Run"),j.append(M)}if(this.M("Terminal")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(7,null)),submenu:O});this.O(O,"Terminal"),j.append(M)}let I;if(this.M("Window")){const O=new i.Menu;I=new i.MenuItem({label:this.cb(h.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&j.append(I),this.M("Help")){const O=new i.Menu,M=new i.MenuItem({label:this.cb(h.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),j.append(M)}j.items&&j.items.length>0?this.J(j):this.J(null),this.h.schedule()}J(b){if(i.Menu.setApplicationMenu(b),b)for(const j of this.y.getWindows())j.win?.setMenu(null)}K(b){const j=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),C=this.V();let I;if(this.M("Preferences")){const ee=new i.Menu;this.O(ee,"Preferences"),I=new i.MenuItem({label:this.cb(h.localize(11,null)),submenu:ee})}const O=new i.Menu,M=new i.MenuItem({label:h.localize(12,null),role:"services",submenu:O}),F=new i.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),L=new i.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new i.MenuItem({label:h.localize(15,null),role:"unhide"}),U=new i.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ee,ce,Q)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||G?.win?.isMinimized())&&await this.L(Q)&&this.w.quit(void 0)}})),le=[j];le.push(...C),I&&le.push(r(),I),le.push(r(),M,r(),F,L,T,r(),U),le.forEach(ee=>b.append(ee))}async L(b){if(this.p.getWindowCount()===0)return!0;const j=this.o.getValue("window.confirmBeforeClose");if(j==="always"||j==="keyboardOnly"&&this.S(b)){const{response:C}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return C===0}return!0}M(b){if(!P.$j&&!(0,w.$rD)(this.o))return!1;switch(b){case"File":case"Help":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(P.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,j){j.forEach(C=>{if((0,d.$3bc)(C))b.append(r());else if((0,d.$2bc)(C)){const I=new i.Menu,O=new i.MenuItem({label:this.cb(C.label),submenu:I});this.N(I,C.submenu.items),b.append(O)}else(0,d.$4bc)(C)?b.append(this.Q(C)):(0,d.$5bc)(C)&&(C.id==="workbench.action.showAboutDialog"&&this.P(b),P.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[C.id]?b.append(new i.MenuItem(this.$(C.id,{label:this.cb(C.label),click:this.m[C.id]}))):b.append(this.W(C.label,C.id,!1,C.checked)):b.append(this.W(C.label,C.id,C.enabled!==!1,!!C.checked)):b.append(this.W(C.label,C.id,C.enabled!==!1,!!C.checked)))})}O(b,j){this.k&&this.k[j]&&this.N(b,this.k[j].items)}P(b){const j=this.V();j.length&&(j.forEach(C=>b.append(C)),b.append(r()))}Q(b){const j=E.URI.revive(b.uri),C=b.id,I=C==="openRecentFile"?{fileUri:j}:C==="openRecentWorkspace"?{workspaceUri:j}:{folderUri:j};return new i.MenuItem(this.$(C,{label:b.label,click:async(O,M,F)=>{const L=this.R(F);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:L,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([j])}},!1))}R(b){return!!(b&&(!P.$j&&(b.ctrlKey||b.shiftKey)||P.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,j,C){const I={label:this.cb(b),role:C,enabled:!0};return new i.MenuItem(this.Z(j,I))}U(b){const j=new i.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),C=new i.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new i.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(r()),M.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[j,C,r(),O,...M,r(),I].forEach(F=>b.append(F))}V(){switch(this.n.state.type){case"idle":return[new i.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new i.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new i.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new i.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return P.$j?[]:[new i.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new i.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new i.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,j,C,I){const O=this.cb(b),M=typeof j=="function"?j:(le,ee,ce)=>{const Q=le?le.userSettingsLabel:null;let G=j;Array.isArray(j)&&(G=this.R(ce)?j[1]:j[0]),Q&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Q}):this.Y({type:"commandId",commandId:G})},F=typeof C=="boolean"?C:this.p.getWindowCount()>0,L=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:F};L&&(T.type="checkbox",T.checked=L);let U;return typeof j=="string"?U=j:Array.isArray(j)&&(U=j[0]),P.$j&&(U==="editor.action.clipboardCutAction"?T.role="cut":U==="editor.action.clipboardCopyAction"?T.role="copy":U==="editor.action.clipboardPasteAction"&&(T.role="paste"),U==="undo"?T.click=this.X(M,{inDevTools:le=>le.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):U==="redo"?T.click=this.X(M,{inDevTools:le=>le.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):U==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:le=>le.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.Z(U,T))}X(b,j){return(C,I,O)=>{const M=i.BrowserWindow.getFocusedWindow();if(!M)return j.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return j.inDevTools(M.webContents.devToolsWebContents);b(C,I||M,O)}}Y(b){let j=i.BrowserWindow.getFocusedWindow();if(j){const I=this.y.getWindowByWebContents(j.webContents);I&&(j=this.p.getWindowById(I.parentId)?.win??null)}if(!j){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(j=I.win)}const C=j?this.p.getWindowById(j.id):void 0;if(C){if(this.v.trace("menubar#runActionInRenderer",b),P.$j&&!this.q.isBuilt&&!C.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const I={id:b.commandId,from:"menu"};C.sendWhenReady("vscode:runAction",S.CancellationToken.None,I)}else{const I={userSettingsLabel:b.userSettingsLabel};C.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,j){const C=typeof b=="string"?this.l[b]:void 0;if(C?.label){if(C.isNative!==!1)j.accelerator=C.label,j.userSettingsLabel=C.userSettingsLabel;else if(typeof j.label=="string"){const I=j.label.indexOf("[");I>=0?j.label=`${j.label.substr(0,I)} [${C.label}]`:j.label=`${j.label} [${C.label}]`}}else j.accelerator=void 0;return j}$(b,j,C=!j.accelerator){C&&(j=this.Z(b,j));const I=j.click;return j.click=(O,M,F)=>{this.bb(b),I?.(O,M,F)},j}ab(b,j){this.w.openExternal(void 0,b),this.bb(j)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:s})}cb(b){return(0,R.$tw)(b,!this.C)}};e.$8bc=n,e.$8bc=n=o=Se([ie(0,l.$CX),ie(1,g.$Wi),ie(2,a.$8ac),ie(3,y.$Wac),ie(4,f.$Vl),ie(5,t.$6bc),ie(6,m.$sQ),ie(7,k.$obc),ie(8,$.$Wj),ie(9,v.$Tbc),ie(10,p.$dk),ie(11,u.$Sbc)],n);function r(){return new i.MenuItem({type:"separator"})}}),define(re[309],ae([0,1,6,20,5,308]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,i.$qi)("menubarMainService");let P=class{constructor(h,u,g){this.b=h,this.c=u,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$8bc)}async updateMenubar(h,u){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(u,h)}};e.$0bc=P,e.$0bc=P=Se([ie(0,i.$pi),ie(1,D.$obc),ie(2,S.$Wj)],P)}),define(re[310],ae([0,1,14,21,102,26,22,23,3,32,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O,M,F,L,T,U,le,ee,ce,Q,G,q,W,z,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;function B(J){return(0,le.$Fi)(J?.workspace)}function oe(J){return(0,le.$Ai)(J?.workspace)}let he=class extends y.$Uc{constructor(A,N,_,ne,X,H,x,K,se,ue,me,$e,ye,ke,Ee,Oe,we,Y,fe,ge){super(),this.s=A,this.t=N,this.u=_,this.w=ne,this.z=X,this.C=H,this.D=x,this.F=K,this.G=se,this.H=ue,this.I=me,this.J=$e,this.L=ye,this.M=ke,this.N=Ee,this.O=Oe,this.P=we,this.Q=Y,this.R=fe,this.S=ge,this.a=this.B(new h.$be),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$be),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$be),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$be),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$be),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$be),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$be),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$be),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new U.$ucc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new y.$Tc;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,ne=N?.remoteAuthority||void 0,X=!0,H=N?.forceReuseWindow,x=!H;return this.open({...A,cli:_,forceEmpty:X,forceNewWindow:x,forceReuseWindow:H,remoteAuthority:ne})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],ne=[],X=[],H=[];let x,K=0;const se=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",se);for(const ke of se)oe(ke)?A.addMode?N.push(ke):_.push(ke):B(ke)?ne.push(ke):ke.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),x.filesToOpenOrCreate.push(ke)):ke.backupPath?H.push({backupFolder:(0,$.$oc)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):K++;A.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),A.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&A.waitMarkerFileURI&&(x.filesToWait={paths:(0,P.$Hb)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(X.push(...this.M.getUntitledWorkspaces()),ne.push(...X),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:ue,filesOpenedInWindow:me}=await this.X(A,ne,_,H,K,x,N);if(this.w.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${ne.length}, foldersToOpen: ${_.length}, emptyToRestore: ${H.length}, emptyToOpen: ${K})`),ue.length>1)if(me)me.focus();else{const ke=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ee=!0,Oe=!0;if(ke){const we=ue.filter(Y=>this.r.state.lastActiveWindow&&Y.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Ee=!1,Oe=!1)}if(Ee)for(let we=ue.length-1;we>=0;we--){const Y=ue[we];if(!(Y.openedWorkspace&&X.some(fe=>Y.openedWorkspace&&fe.workspace.id===Y.openedWorkspace.id)||Y.backupPath&&H.some(fe=>Y.backupPath&&fe.backupFolder===(0,$.$oc)(Y.backupPath)))){Y.focus(),Oe=!1;break}}Oe&&ue[ue.length-1].focus()}const $e=x&&x.filesToDiff.length>0,ye=x&&x.filesToMerge.length>0;if(!ue.some(ke=>ke.isExtensionDevelopmentHost)&&!$e&&!ye&&!A.noRecentEntry){const ke=[];for(const Ee of se)B(Ee)&&!Ee.transient?ke.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):oe(Ee)?ke.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ke.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.L.addRecentlyOpened(ke)}return this.W(A,ue),ue}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,ne,X,H,x){const K=[];let se;function ue(we,Y){K.push(we),Y&&(se=we,H=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:$e}=this.ob(A);if(!A.initialStartup&&x.length>0){const we=x[0].remoteAuthority,Y=this.ub(we);Y&&ue(this.$(Y,x.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+ne.length;if(H&&ye===0){const we=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],Y=this.getWindows().filter(ge=>H&&(0,m.$9g)(ge.remoteAuthority,H.remoteAuthority));let fe;we?.fileUri&&!$e&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,T.$abc)(Y,we.fileUri,async ge=>ge.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Y))),fe?(0,le.$Fi)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$Ai)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ue(this.Y(A,fe,H),!0):ue(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const ke=(0,P.$Mb)(N,we=>we.workspace.id);if(ke.length>0){const we=(0,P.$Hb)(ke.map(Y=>(0,T.$bbc)(this.getWindows(),Y.workspace.configPath)));if(we.length>0){const Y=we[0],fe=(0,m.$9g)(H?.remoteAuthority,Y.remoteAuthority)?H:void 0;ue(this.Y(A,Y,fe),!!fe),me=!0}for(const Y of ke){if(we.some(je=>je.openedWorkspace&&je.openedWorkspace.id===Y.workspace.id))continue;const fe=Y.remoteAuthority,ge=(0,m.$9g)(H?.remoteAuthority,fe)?H:void 0;ue(await this.bb(A,Y,me,ge),!!ge),me=!0}}const Ee=(0,P.$Mb)(_,we=>m.$Ug.getComparisonKey(we.workspace.uri));if(Ee.length>0){const we=(0,P.$Hb)(Ee.map(Y=>(0,T.$bbc)(this.getWindows(),Y.workspace.uri)));if(we.length>0){const Y=we[0],fe=(0,m.$9g)(H?.remoteAuthority,Y.remoteAuthority)?H:void 0;ue(this.Y(A,Y,fe),!!fe),me=!0}for(const Y of Ee){if(we.some(je=>(0,le.$Ai)(je.openedWorkspace)&&m.$Ug.isEqual(je.openedWorkspace.uri,Y.workspace.uri)))continue;const fe=Y.remoteAuthority,ge=(0,m.$9g)(H?.remoteAuthority,fe)?H:void 0;ue(await this.bb(A,Y,me,ge),!!ge),me=!0}}const Oe=(0,P.$Mb)(ne,we=>we.backupFolder);if(Oe.length>0)for(const we of Oe){const Y=we.remoteAuthority,fe=(0,m.$9g)(H?.remoteAuthority,Y)?H:void 0;ue(await this.ab(A,!0,Y,fe,we),!!fe),me=!0}if(K.length===0||H){H&&!X&&X++;const we=H?H.remoteAuthority:A.remoteAuthority;for(let Y=0;Y<X;Y++)ue(await this.ab(A,me,we,H),!!H),me=!0}return{windows:(0,P.$Mb)(K),filesOpenedInWindow:se}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const ne={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,ne),N}Z(A){let N=A;const _=i.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const ne=this.S.getWindowByWebContents(_.webContents);ne&&ne.parentId===A.id&&(N=ne)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,N,_,ne,X){this.w.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:_,filesToOpen:ne,forceNewWindow:N});let H;return!N&&typeof A.contextWindowId=="number"&&(H=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:H,emptyWindowBackupInfo:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,ne,X){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:ne}),!_&&!X&&typeof A.contextWindowId=="number"&&(X=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,ne=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),ne=!0),!A.addMode&&_){const X=N.filter(H=>oe(H));if(X.length>1){const H=X[0].remoteAuthority;if(X.every(x=>(0,m.$9g)(x.remoteAuthority,H))){const x=await this.M.createUntitledWorkspace(X.map(K=>({uri:K.workspace.uri})));N.push({workspace:x,remoteAuthority:H}),N=N.filter(K=>!oe(K))}}}if(A.initialStartup&&!ne&&this.J.getValue("window")?.restoreWindows==="preserve"){const X=await this.gb();N.unshift(...X.filter(H=>B(H)||oe(H)||H.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,P.$Hb)(A.urisToOpen||[]).map(async ne=>{const X=await this.ib(ne,N);if(X)return X.label=ne.label,X;const H=this.kb(ne);this.O.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:H.scheme===k.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:H.scheme===k.Schemas.file?(0,w.localize)(3,null,(0,g.$nw)(H,{os:v.OS,tildify:this.F})):(0,w.localize)(4,null,H.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,P.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},ne=A["folder-uri"];if(ne){const x=await Promise.all(ne.map(K=>{const se=this.fb(K);if(se)return this.ib({folderUri:se},_)}));N.push(...(0,P.$Hb)(x))}const X=A["file-uri"];if(X){const x=await Promise.all(X.map(K=>{const se=this.fb(K);if(se)return this.ib((0,le.$Vi)(K)?{workspaceUri:se}:{fileUri:se},_)}));N.push(...(0,P.$Hb)(x))}const H=await Promise.all(A._.map(x=>_.remoteAuthority?this.nb(x,_):this.lb(x,_)));return N.push(...(0,P.$Hb)(H)),N}fb(A){try{const N=l.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async ne=>{if(ne.workspace){const X=await this.ib({workspaceUri:ne.workspace.configPath},{remoteAuthority:ne.remoteAuthority,rejectTransientWorkspaces:!0});if(B(X))return X}else if(ne.folderUri){const X=await this.ib({folderUri:ne.folderUri},{remoteAuthority:ne.remoteAuthority});if(oe(X))return X}else if(A!=="folders"&&ne.backupPath)return{backupPath:ne.backupPath,remoteAuthority:ne.remoteAuthority}}));return(0,P.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===k.Schemas.file?((0,M.$oD)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const ne=(0,I.$Bm)(_)||N.remoteAuthority;if(_=(0,m.$$g)((0,m.$5g)(_)),(0,M.$oD)(A)){if(N.gotoLineMode){const{path:X,line:H,column:x}=(0,u.$xg)(_.path);return{fileUri:_.with({path:X}),options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0},remoteAuthority:ne}}return{fileUri:_,remoteAuthority:ne}}else if((0,M.$mD)(A))return{workspace:(0,ee.$ebc)(_),remoteAuthority:ne};return{workspace:(0,ee.$fbc)(_),remoteAuthority:ne}}kb(A){return(0,M.$mD)(A)?A.workspaceUri:(0,M.$nD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let ne,X;N.gotoLineMode&&({path:A,line:ne,column:X}=(0,u.$xg)(A)),A=(0,u.$sg)((0,$.$ic)(A),(0,p.cwd)());try{const H=await D.Promises.stat(A);if(H.isFile()){if(!N.forceOpenWorkspaceAsFile){const x=await this.M.resolveLocalWorkspace(l.URI.file(A));if(x)return x.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:n.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:l.URI.file(A),type:n.FileType.File,exists:!0,options:{selection:ne?{startLineNumber:ne,startColumn:X||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,ee.$fbc)(l.URI.file(A),H),type:n.FileType.Directory,exists:!0};if(!v.$i&&A==="/dev/null")return{fileUri:l.URI.file(A),type:n.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const x=l.URI.file(A);if(this.L.removeRecentlyOpened([x]),N.ignoreFileNotFound)return{fileUri:x,type:n.FileType.File,exists:!1}}}async mb(A,N){const _=l.URI.file(A),{response:ne,checkboxChecked:X}=await this.O.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,_.authority),detail:(0,w.localize)(9,null,(0,g.$nw)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,w.localize)(10,null,_.authority),cancelId:1});if(ne===0){if((0,S.addUNCHostToAllowlist)(_.authority),X){const H={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(A,N,!0)}if(ne===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),ne=N.remoteAuthority;let X,H;N.gotoLineMode&&({path:A,line:X,column:H}=(0,u.$xg)(A)),_!==47&&((0,u.$rg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,u.$kg)(A)),A=`/${A}`);const x=l.URI.from({scheme:k.Schemas.vscodeRemote,authority:ne,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.$Vi)(A))return N.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:X?{startLineNumber:X,startColumn:H||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.$ebc)(x),remoteAuthority:ne};if(N.gotoLineMode||$.$hc.basename(A).indexOf(".")!==-1)return{fileUri:x,options:{selection:X?{startLineNumber:X,startColumn:H||1}:void 0},remoteAuthority:ne}}return{workspace:(0,ee.$fbc)(x),remoteAuthority:ne}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",ne=N?.openFilesInNewWindow||"off";let X=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(X=_==="on");let H=!1;return A.forceNewWindow||A.forceReuseWindow?H=!!A.forceNewWindow&&!A.forceReuseWindow:(v.$j?A.context===1&&(H=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!A.cli.extensionDevelopmentPath&&(ne==="on"||ne==="off")&&(H=ne==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,T.$cbc)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let ne=N.cli["folder-uri"]||[],X=N.cli["file-uri"]||[],H=N.cli._;if(!H.length&&!ne.length&&!X.length&&!N.cli.extensionTestsPath){const se=this.r.state.lastPluginDevelopmentHostWindow,ue=se?.workspace??se?.folderUri;ue&&(l.URI.isUri(ue)?ue.scheme===k.Schemas.file?H=[ue.fsPath]:ne=[ue.toString()]:ue.configPath.scheme===k.Schemas.file?H=[(0,m.$Rg)(ue.configPath)]:X=[ue.configPath.toString()])}let x=N.remoteAuthority;for(const se of A)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=l.URI.parse(se),me=(0,I.$Bm)(ue);me&&(x?(0,m.$9g)(me,x)||this.w.error("more than one extension development path authority"):x=me)}H=H.filter(se=>{const ue=l.URI.file(se);return(0,T.$bbc)(this.getWindows(),ue)?!1:(0,m.$9g)((0,I.$Bm)(ue),x)}),ne=ne.filter(se=>{const ue=this.fb(se);return ue&&(0,T.$bbc)(this.getWindows(),ue)?!1:ue?(0,m.$9g)((0,I.$Bm)(ue),x):!1}),X=X.filter(se=>{const ue=this.fb(se);return ue&&(0,T.$bbc)(this.getWindows(),ue)?!1:ue?(0,m.$9g)((0,I.$Bm)(ue),x):!1}),N.cli._=H,N.cli["folder-uri"]=ne,N.cli["file-uri"]=X;const K={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!H.length&&!ne.length&&!X.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:x,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(K)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),ne=_?.profile??this.G.defaultProfile;let X;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||_,X&&X.focus());const H={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,$.$kc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:ne},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:j.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(X){const x=X.config;!H.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=x.extensionDevelopmentPath,H.extensionDevelopmentKind=x.extensionDevelopmentKind,H["enable-proposed-api"]=x["enable-proposed-api"],H.verbose=x.verbose,H["inspect-extensions"]=x["inspect-extensions"],H["inspect-brk-extensions"]=x["inspect-brk-extensions"],H.debugId=x.debugId,H.extensionEnvironment=x.extensionEnvironment,H["extensions-dir"]=x["extensions-dir"],H["disable-extensions"]=x["disable-extensions"]),H.loggers={global:H.loggers.global,window:x?.loggers.window??H.loggers.window}}else{const x=this.r.getNewWindowState(H);(0,d.mark)("code/willCreateCodeWindow");const K=X=this.N.createInstance(F.$mbc,{state:x,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(K),this.n.set(K.id,K),this.a.fire(K),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new y.$Tc;se.add(K.onDidSignalReady(()=>this.b.fire(K))),se.add(h.Event.once(K.onDidClose)(()=>this.sb(K,se))),se.add(h.Event.once(K.onDidDestroy)(()=>this.tb(K))),se.add(K.onDidMaximize(()=>this.g.fire(K))),se.add(K.onDidUnmaximize(()=>this.h.fire(K))),se.add(K.onDidEnterFullScreen(()=>this.j.fire({window:K,fullscreen:!0}))),se.add(K.onDidLeaveFullScreen(()=>this.j.fire({window:K,fullscreen:!1}))),se.add(K.onDidTriggerSystemContextMenu(({x:me,y:$e})=>this.m.fire({window:K,x:me,y:$e})));const ue=(0,f.$cg)(K.win?.webContents);ue.removeAllListeners("devtools-reload-page"),se.add(h.Event.fromNodeEventEmitter(ue,"devtools-reload-page")(()=>this.H.reload(K))),this.H.registerWindow(K)}return H.windowId=X.id,X.isReady?this.H.unload(X,4).then(async x=>{x||await this.qb(X,H,A,ne)}):await this.qb(X,H,A,ne),X}async qb(A,N,_,ne){if(N.extensionDevelopmentPath||((0,le.$Fi)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,le.$Ai)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,ee.$gbc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const X=N.workspace??(0,le.$Ei)(N.backupPath,!1),H=this.rb(_,X,ne),x=H instanceof Promise?await H:H;N.profiles.profile=x,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(X,x)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(ne=>ne.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=i.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,m.$9g)(N.remoteAuthority,A)))}vb(A){return(0,L.$0ac)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const ne of this.getWindows())_&&_.indexOf(ne.id)>=0||ne.sendWhenReady(A,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=i.BrowserWindow.fromWebContents(A);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(A)?_:void 0}};e.$xcc=he,e.$xcc=he=Se([ie(3,b.$Wj),ie(4,z.$jbc),ie(5,O.$sQ),ie(6,q.$$n),ie(7,s.$Wac),ie(8,W.$$ac),ie(9,c.$obc),ie(10,a.$2ac),ie(11,t.$Wi),ie(12,ce.$6bc),ie(13,Q.$hbc),ie(14,r.$pi),ie(15,o.$3ac),ie(16,n.$Wk),ie(17,C.$5ac),ie(18,G.$6ac),ie(19,V.$Sbc)],he)}),define(re[311],ae([0,1,65,29,85,58]),function(Z,e,i,D,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let P=class{constructor(h,u,g,y){this.a=h,this.b=u,this.c=g,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,u){const g=this.b.getWindowById(h);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),u)}createUntitledWorkspace(h,u,g){return this.a.createUntitledWorkspace(u,g)}deleteUntitledWorkspace(h,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(h,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(h,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$zcc=P,e.$zcc=P=Se([ie(0,R.$hbc),ie(1,D.$8ac),ie(2,S.$6bc),ie(3,i.$2ac)],P)}),define(re[312],ae([0,1,14,102,37,26,17,47,15,32,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O,M,F,L,T,U,le,ee,ce,Q,G,q,W,z,V,B,oe,he,J,A,N,_,ne,X,H,x,K,se,ue,me,$e,ye,ke,Ee,Oe,we,Y,fe,ge,je,Re,Be,We,Le,Ue,He,Xe,Te,te,de,pe,ve,Pe,Me,ze,Ge,Ye,Ze,Qe,st,it,ot,at,vt,kt,Et,St,Pt,ct,gt,jt,It,Ct,lt,Dt,mt,ut,At,Rt,ht,Ot,$t,Mt,wt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;let dt=class extends $.$Uc{static{ft=this}static{this.a={[d.Schemas.file]:"security.promptForLocalFileProtocolHandling",[d.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,Ce,Ae,be,De,qe,Ke,Ve,Fe,Ne,xe,Je){super(),this.g=Ie,this.h=Ce,this.j=Ae,this.m=be,this.n=De,this.s=qe,this.t=Ke,this.u=Ve,this.w=Fe,this.y=Ne,this.z=xe,this.C=Je,this.D(),this.F()}D(){const Ie=Fe=>Fe?.startsWith(`${d.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Fe,Ne,xe,Je)=>Ie(Je.requestingUrl)?xe(Ce.has(Ne)):xe(!1)),i.session.defaultSession.setPermissionCheckHandler((Fe,Ne,xe,Je)=>Ie(Je.requestingUrl)?Ce.has(Ne):!1);const Ae=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,d.Schemas.vscodeManagedRemoteResource,"devtools"]),be=Fe=>{for(let Ne=Fe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},De=Fe=>Fe.resourceType==="xhr"||be(Fe.frame),qe=Fe=>{const Ne=Fe.frame;if(!Ne||!this.b)return!1;const xe=i.BrowserWindow.getAllWindows();for(const Je of xe)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ke=(Fe,Ne)=>{if(Fe.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Fe,Ne)=>{const xe=f.URI.parse(Fe.url);return xe.scheme===d.Schemas.vscodeWebview&&!Ke(xe,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),Ne({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!qe(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!Ae.has(xe.scheme)?Ne({cancel:!De(Fe)}):Ne({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Fe,Ne)=>{const xe=Fe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=f.URI.parse(Fe.url);if(_e.path.endsWith(".svg")&&Ae.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!De(Fe)})}return Ne({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Fe,Ne)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const xe=Fe.responseHeaders??Object.create(null);if(xe["Access-Control-Allow-Origin"]===void 0)return xe["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:xe})}return Ne({cancel:!1})});const Ve=i.session.defaultSession;typeof Ve.setCodeCachePath=="function"&&this.s.codeCachePath&&Ve.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,h.$Z)(Ae)||(0,h.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,h.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,w.$EW)(),i.app.on("accessibility-support-changed",(Ae,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),i.app.on("activate",async(Ae,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),i.app.on("web-contents-created",(Ae,be)=>{be?.opener?.url.startsWith(`${d.Schemas.vscodeFileResource}://${d.$Jg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",De=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),be.setWindowOpenHandler(De=>De.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(De)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${De.url}}`),this.f?.openExternal(void 0,De.url),{action:"deny"}))});let Ie=[],Ce;i.app.on("open-file",(Ae,be)=>{be=(0,wt.$8l)(be),this.m.trace("app#open-file: ",be),Ae.preventDefault(),Ie.push((0,Me.$Vi)(be)?{workspaceUri:f.URI.file(be)}:{fileUri:f.URI.file(be)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Ce=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$DW.handle("vscode:fetchShellEnv",Ae=>{const be=this.b?.getWindowByWebContents(Ae.sender);let De,qe;return be?.config?(De=be.config,qe={...process.env,...be.config.userEnv}):(De=this.s.args,qe=process.env),this.X(De,qe,!1)}),S.$DW.handle("vscode:writeNlsFile",(Ae,be,De)=>{const qe=this.G([be]);if(!qe||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,P.$Ce.fromString(De))}),S.$DW.handle("vscode:readNlsFile",async(Ae,...be)=>{const De=this.G(be);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(De)).value.toString()}),S.$DW.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),S.$DW.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),S.$DW.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),S.$DW.handle("vscode:notifyZoomLevel",async(Ae,be)=>{const De=this.b?.getWindowByWebContents(Ae.sender);De&&De.notifyZoomLevel(be)})}G(Ie){let Ce;for(const Ae of Ie)typeof Ae=="string"&&(typeof Ce!="string"?Ce=Ae:Ce=(0,v.$kc)(Ce,Ae));if(!(typeof Ce!="string"||!(0,v.$jc)(Ce)||!(0,u.$qg)(Ce,this.s.cachedLanguagesPath,!p.$k)))return f.URI.file(Ce)}H(Ie){if(Ie){const Ce={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;p.$i&&Ie&&i.app.setAppUserModelId(Ie);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const Ce=new t.$KW;this.t.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,be]=await Promise.all([(0,gt.$Hcc)(this.w,this.m),(0,gt.$Icc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:De,sharedProcessClient:qe}=this.P(Ae,be),Ke=await this.Q(Ae,be,De);this.B(Ke.createInstance(s.$ybc)),this.B(Ke.createInstance(St.$Dcc)),Ke.invokeFunction(Ne=>this.R(Ne,Ce,qe));const Ve=await Ke.invokeFunction(Ne=>this.I(Ne,Ce));this.J(Ce),this.t.phase=2,await Ke.invokeFunction(Ne=>this.S(Ne,Ve)),this.t.phase=3,this.U(),this.B(new ct.$Ch(()=>{this.B((0,ct.$Gh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,Ce){const Ae=this.b=Ie.get(pe.$8ac),be=Ie.get(Le.$sX),De=this.f=Ie.get(H.$Tbc),qe=Ie.get(O.$3ac),Ke=this;be.registerHandler({async handleURL(_e,nt){return Ke.O(Ae,qe,be,_e,nt)}});const Ve=this.B(new Pe.$ycc({onDidOpenMainWindow:De.onDidOpenMainWindow,onDidFocusMainWindow:De.onDidFocusMainWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Fe=new a.$$h(_e=>Ve.getActiveClientId().then(nt=>_e===nt)),Ne=new Ue.$pcc(Fe,this.m),xe=Ce.getChannel("urlHandler",Ne);be.registerHandler(new Ue.$occ(xe));const Je=await this.L(Ae,qe);return this.B(new Xe.$qcc(Je?.urls,be,Ae,this.s,this.z,this.m)),Je}J(Ie){const Ce=()=>({statusCode:404,data:"Not found"}),Ae=new Ot.$V(()=>Ie.getChannel(ht.$Pcc,new ht.$Qcc));i.protocol.registerBufferProtocol(d.Schemas.vscodeManagedRemoteResource,(be,De)=>{const qe=f.URI.parse(be.url);if(!qe.authority.startsWith("window:"))return De(Ce());Ae.value.call(ht.$Occ,[qe]).then(Ke=>De({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.m.warn("error dispatching remote resource call",Ke),De({statusCode:500,data:String(Ke)})})})}async L(Ie,Ce){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ae.length+be.length===0)return;const De=[...Ae,...be].map(Ve=>{try{return{uri:f.URI.parse(Ve),originalUrl:Ve}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ve);return}}),qe=[],Ke=[];for(const Ve of De){if(!Ve)continue;const Fe=this.N(Ve.uri);if(Fe)if(await this.M(Fe,Ie,Ce)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ve.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ve.uri.toString(!0),Fe),qe.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ve.uri.toString(!0)),Ke.push(Ve)}return{urls:Ke,openables:qe}}async M(Ie,Ce,Ae){let be,De;if((0,de.$mD)(Ie)?(be=Ie.workspaceUri,De=(0,n.localize)(0,null,be.scheme===d.Schemas.file?(0,k.$nw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,de.$nD)(Ie)?(be=Ie.folderUri,De=(0,n.localize)(1,null,be.scheme===d.Schemas.file?(0,k.$nw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=Ie.fileUri,De=(0,n.localize)(2,null,be.scheme===d.Schemas.file?(0,k.$nw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==d.Schemas.file&&be.scheme!==d.Schemas.vscodeRemote||this.u.getValue(ft.a[be.scheme])===!1)return!1;const{response:Ke,checkboxChecked:Ve}=await Ae.showMessageBox({type:"warning",buttons:[(0,n.localize)(3,null),(0,n.localize)(4,null)],message:De,detail:(0,n.localize)(5,null),checkboxLabel:be.scheme===d.Schemas.file?(0,n.localize)(6,null):(0,n.localize)(7,null),cancelId:1});if(Ke!==0)return!0;if(Ve){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===d.Schemas.file?"local":"remote"};Ce.sendToFocused(Fe.channel,Fe.args),Ce.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===d.Schemas.file){const Ce=f.URI.file(Ie.fsPath);return(0,Me.$Vi)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ie.authority===d.Schemas.vscodeRemote){const Ce=Ie.path.indexOf(v.$hc.sep,1);if(Ce!==-1){const Ae=Ie.path.substring(1,Ce),be=Ie.path.substring(Ce);let De=Ie.query;const qe=new URLSearchParams(Ie.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),De=qe.toString());const Ke=f.URI.from({scheme:d.Schemas.vscodeRemote,authority:Ae,path:be,query:De,fragment:Ie.fragment});return(0,Me.$Vi)(be)?{workspaceUri:Ke}:/:[\d]+$/.test(be)?{fileUri:Ke}:{folderUri:Ke}}}}}async O(Ie,Ce,Ae,be,De){this.m.trace("app#handleProtocolUrl():",be.toString(!0),De),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:f.URI.parse(be.query).path,query:""}));let qe=!1;const Ke=new URLSearchParams(be.query);Ke.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ke.delete("windowId"),be=be.with({query:Ke.toString()}),qe=!0):p.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),qe=!0);const Ve=Ke.get("continueOn");Ve!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ke.delete("continueOn"),be=be.with({query:Ke.toString()}),this.s.continueOn=Ve??void 0);const Fe=this.N(be);return Fe?await this.M(Fe,Ie,Ce)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,be.toString(!0)),(0,mt.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,mt.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,K.$Bm)(be)}))?.ready(),Ae.open(be,De)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),De),!1)}P(Ie,Ce){const Ae=this.B(this.j.createInstance(se.$bcc,Ie,Ce)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const qe=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$LW(qe,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),be))(),sharedProcessClient:be}}async Q(Ie,Ce,Ae){const be=new oe.$oi;switch(process.platform){case"win32":be.set(fe.$CX,new V.$ni(We.$mcc));break;case"linux":p.$l?be.set(fe.$CX,new V.$ni(Be.$lcc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$CX,new V.$ni(Re.$kcc));break;case"darwin":be.set(fe.$CX,new V.$ni(je.$jcc));break}be.set(pe.$8ac,new V.$ni(ve.$xcc,[Ie,Ce,this.h],!1)),be.set($t.$Sbc,new V.$ni(Mt.$Rcc,void 0,!1));const De=new O.$4ac(this.m,this.z);be.set(O.$3ac,De),be.set(N.$Zbc,new V.$ni(N.$1bc,void 0,!1)),be.set(I.$Ebc,new V.$ni(I.$Fbc,void 0,!1)),be.set(C.$0m,a.ProxyChannel.toService((0,a.$9h)(Ae.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(he.$rJb,new V.$ni(J.$Vbc,[this.h])),be.set(M.$mX,new V.$ni(F.$Gbc)),be.set(A.$Wbc,new V.$ni(A.$Xbc)),be.set(H.$Tbc,new V.$ni(H.$Ubc,void 0,!1)),be.set(Te.$rcc,new V.$ni(te.$tcc)),be.set(X.$9bc,new V.$ni(X.$0bc)),be.set(le.$Hbc,new V.$ni(ee.$Jbc)),be.set(ye.$ubc,new V.$ni(ye.$vbc)),be.set(ye.$wbc,new V.$ni(ye.$xbc));const qe=new At.$Ncc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ke=new Rt.$ns(qe,this.u,this.m,this.n);be.set(ut.$1r,Ke),p.$i?be.set(ce.$Kbc,new V.$ni(Q.$Lbc)):p.$j?be.set(ce.$Kbc,new V.$ni(Q.$Mbc)):p.$k&&be.set(ce.$Kbc,new V.$ni(Q.$Nbc));const Ve=new c.$zbc(this.s,this.u,this.m,this.w);be.set(r.$2ac,Ve);const Fe=new Ze.$ibc(this.s,this.m,this.C,Ve,De);if(be.set(Ze.$hbc,Fe),be.set(ze.$Ufb,new V.$ni(Ye.$zcc,void 0,!1)),be.set(Ge.$6bc,new V.$ni(Ge.$7bc,void 0,!1)),be.set(Le.$sX,new V.$ni(He.$uX,void 0,!1)),(0,Y.$gp)(this.z,this.s)){const Ne=(0,Y.$lp)(this.z,this.u),xe=(0,a.$9h)(Ae.then(rt=>rt.getChannel("telemetryAppender"))),Je=new Oe.$ecc(xe),_e=(0,ke.$0o)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Ie,Ce,Ne),nt=(0,Y.$mp)(this.s),et={appenders:[Je],commonProperties:_e,piiPaths:nt,sendErrorTelemetry:!0};be.set(Ee.$Vl,new V.$ni(we.$Rr,[et],!1))}else be.set(Ee.$Vl,Y.$bp);return be.set(vt.$jq,new V.$ni(jt.$zQ,void 0,!0)),be.set(kt.$nq,new V.$ni(Et.$Ccc,void 0,!0)),be.set(lt.$Lcc,new V.$ni(lt.$Mcc,void 0,!0)),await ct.Promises.settled([Ve.initialize(),Fe.initialize()]),this.j.createChild(be)}R(Ie,Ce,Ae){const be=this.B(new $.$Tc),De=a.ProxyChannel.fromService(Ie.get(N.$Zbc),be,{disableMarshalling:!0});this.g.registerChannel("launch",De);const qe=a.ProxyChannel.fromService(Ie.get(I.$Ebc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const Ke=new st.$Acc(Ie.get(Qe.$$n));Ce.registerChannel("policy",Ke),Ae.then(tt=>tt.registerChannel("policy",Ke));const Ve=this.y.getProvider(d.Schemas.file);(0,m.$bg)(Ve instanceof z.$4q);const Fe=new W.$Obc(Ve,this.m,this.s);Ce.registerChannel(G.$iQ,Fe),Ae.then(tt=>tt.registerChannel(G.$iQ,Fe));const Ne=a.ProxyChannel.fromService(Ie.get(it.$$ac),be);Ce.registerChannel("userDataProfiles",Ne),Ae.then(tt=>tt.registerChannel("userDataProfiles",Ne));const xe=new ot.$Mr(Ie.get(at.$Hp));Ae.then(tt=>tt.registerChannel("request",xe));const Je=new ge.$fcc(Ie.get(fe.$CX));Ce.registerChannel("update",Je);const _e=a.ProxyChannel.fromService(Ie.get(he.$rJb),be);Ce.registerChannel("issue",_e);const nt=a.ProxyChannel.fromService(Ie.get(M.$mX),be);Ce.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(Ie.get(ue.$Jl),be);Ce.registerChannel("sign",et);const rt=a.ProxyChannel.fromService(Ie.get(A.$Wbc),be);Ce.registerChannel("keyboardLayout",rt),this.f=Ie.get(H.$Tbc);const pt=a.ProxyChannel.fromService(this.f,be);Ce.registerChannel("nativeHost",pt),Ae.then(tt=>tt.registerChannel("nativeHost",pt));const Wt=a.ProxyChannel.fromService(Ie.get(ze.$Ufb),be);Ce.registerChannel("workspaces",Wt);const Lt=a.ProxyChannel.fromService(Ie.get(X.$9bc),be);Ce.registerChannel("menubar",Lt);const Ft=a.ProxyChannel.fromService(Ie.get(Le.$sX),be);Ce.registerChannel("url",Ft);const Nt=a.ProxyChannel.fromService(Ie.get(Te.$rcc),be);Ce.registerChannel("webview",Nt);const bt=this.B(new $e.$ccc(this.m,Ie.get(ye.$ubc)));Ce.registerChannel("storage",bt),Ae.then(tt=>tt.registerChannel("storage",bt));const Tt=this.B(new Pt.$Ecc(Ie.get(ye.$ubc),Ie.get(it.$$ac),this.m));Ae.then(tt=>tt.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(Ie.get(ut.$1r),be);Ce.registerChannel(ut.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(Ie.get(ce.$Kbc),be);Ce.registerChannel("externalTerminal",Bt);const yt=new It.$Jcc(Ie.get(Ct.$jbc));Ce.registerChannel("logger",yt),Ae.then(tt=>tt.registerChannel("logger",yt));const qt=new j.$Abc(Ie.get(pe.$8ac));Ce.registerChannel("extensionhostdebugservice",qt);const Ut=a.ProxyChannel.fromService(Ie.get(le.$Hbc),be);Ce.registerChannel(le.$Ibc,Ut);const Kt=a.ProxyChannel.fromService(Ie.get(lt.$Lcc),be);Ce.registerChannel(Dt.$Kcc,Kt)}async S(Ie,Ce){const Ae=this.b=Ie.get(pe.$8ac);this.c=Ie.get($t.$Sbc);const be=(0,T.$um)(process.env)?0:4,De=this.s.args;if(Ce){if(Ce.openables.length>0)return Ae.open({context:be,cli:De,urisToOpen:Ce.openables,gotoLineMode:!0,initialStartup:!0});if(Ce.urls.length>0)for(const et of Ce.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Ae.open({context:be,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ke=De._.length,Ve=!!De["folder-uri"],Fe=!!De["file-uri"],Ne=De["skip-add-to-recently-opened"]===!0,xe=De.wait&&De.waitMarkerFilePath?f.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,_e=De.profile,nt=De["profile-temp"];if(!Ke&&!Ve&&!Fe){if(De["new-window"]||_e||nt)return Ae.open({context:be,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(qe.length)return Ae.open({context:1,cli:De,urisToOpen:qe.map(et=>(et=(0,wt.$8l)(et),(0,Me.$Vi)(et)?{workspaceUri:f.URI.file(et)}:{fileUri:f.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return Ae.open({context:be,cli:De,forceNewWindow:De["new-window"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}U(){this.W(),i.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Ie,Ce)=>{Ce({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(p.$i&&Ie)try{const Ce=await new Promise((be,De)=>{Z(["@vscode/windows-mutex"],be,De)}),Ae=new Ce.Mutex(Ie);g.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(Ce){this.m.error(Ce)}}async X(Ie,Ce,Ae){try{return await(0,U.$Am)(this.u,this.m,Ie,Ce)}catch(be){const De=(0,E.$bj)(be);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",De):this.m.error(De)}return{}}async Y(){try{const Ce=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,y.$Ln)(Ce)),De=(0,Y.$ip)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$Mg)()}"`,"}"],Ke=Ce.substring(0,Ce.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,P.$Ce.fromString(Ke))}else{const qe=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);qe!==Ce&&await this.y.writeFile(this.s.argvResource,P.$Ce.fromString(qe))}}catch(Ie){this.m.error(Ie)}}};e.$Scc=dt,e.$Scc=dt=ft=Se([ie(2,B.$pi),ie(3,ne.$Wj),ie(4,ne.$Xj),ie(5,L.$Wac),ie(6,_.$obc),ie(7,b.$Wi),ie(8,me.$sQ),ie(9,q.$Wk),ie(10,x.$dk),ie(11,it.$$ac)],dt)}),define(re[317],ae([0,1,14,43,7,22,8,47,15,32,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(Z,e,i,D,S,R,P,E,h,u,g,y,k,$,d,v,p,m,f,l,w,a,t,o,s,n,r,c,b,j,C,I,O,M,F,L,T,U,le,ee,ce,Q,G,q,W,z,V,B,oe,he,J,A,N,_,ne,X,H,x,K,se,ue,me,$e,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch(we){console.error(we.message),i.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Le=>console.error(Le));const[we,Y,fe,ge,je,Re,Be,We]=this.b();try{try{await this.d(fe,We,ge,je,Be)}catch(Le){throw this.g(fe,Be,Le),Le}await we.invokeFunction(async Le=>{const Ue=Le.get(U.$Wj),He=Le.get(L.$obc),Xe=Le.get(j.$Wk),Te=Le.get(U.$Xj),te=await this.f(Ue,fe,He,we,Be,!0);return f.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(de=>{Ue.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Re.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),g.Event.once(He.onWillShutdown)(de=>{Xe.dispose(),ge.dispose(),de.join("instanceLockfile",f.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$Scc,te,Y).startup()})}catch(Le){we.invokeFunction(this.j,Le)}}b(){const we=new F.$oi,Y=new X.$Tc;process.once("exit",()=>Y.dispose());const fe={_serviceBrand:void 0,...le.default};we.set(ee.$dk,fe);const ge=new r.$Xac(this.k(),fe),je=this.c(ge);we.set(r.$Wac,ge);const Re=new K.$kbc((0,U.$$j)(ge),ge.logsHome);we.set(K.$jbc,Re);const Be=new T.$C$b(Re.getLogLevel()),We=Y.add(new se.$AQ(Be,[new U.$4j(Re.getLogLevel())]));we.set(U.$Wj,We);const Le=new C.$Cq(We);we.set(j.$Wk,Le);const Ue=new I.$4q(We);Le.registerProvider(k.Schemas.file,Ue);const He=new x.$rs(Le);we.set(H.$ul,He);const Xe=new me.$vQ(1,ge,We,Le);we.set(oe.$rQ,Xe),we.set(oe.$sQ,Xe);const Te=new A.$_ac(Xe,He,ge,Le,We);we.set(A.$$ac,Te),Le.registerProvider(k.Schemas.vscodeUserData,new $e.$4cc(k.Schemas.file,Ue,k.Schemas.vscodeUserData,Te,He,We));const te=v.$i&&fe.win32RegValueName?Y.add(new _.$2cc(We,fe.win32RegValueName)):ge.policyFile?Y.add(new ne.$3cc(ge.policyFile,Le,We)):new N.$ao;we.set(N.$$n,te);const de=new s.$Ao(Te.defaultProfile.settingsResource,Le,te,We);return we.set(o.$Wi,de),we.set(L.$obc,new O.$ni(L.$pbc,void 0,!1)),we.set(W.$Hp,new O.$ni(z.$Zcc,void 0,!0)),we.set(J.$6ac,new O.$ni(J.$7ac)),we.set(V.$Jl,new O.$ni(B.$1cc,void 0,!1)),we.set(G.$5v,new O.$ni(q.$Xcc)),we.set(ce.$5ac,new Q.$Ucc(ge,Te,We)),[new M.$7q(we,!0),je,ge,de,Xe,Be,fe,Te]}c(we){const Y={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Y[fe]=ge)}),Object.assign(process.env,Y),Y}async d(we,Y,fe,ge,je){await P.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:k.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,we.backupHome].map(Re=>Re?f.Promises.mkdir(Re,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Y.init()}e(we){if(v.$i){const Y=(0,ye.getUNCHost)(we);Y&&(0,ye.addUNCHostToAllowlist)(Y)}return we}async f(we,Y,fe,ge,je,Re){let Be;try{(0,d.mark)("code/willStartMainServer"),Be=await(0,w.$li)(Y.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),g.Event.once(fe.onWillShutdown)(()=>Be.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.g(Y,je,We),We;let Le;try{Le=await(0,w.$mi)(Y.mainIPCHandle,"main")}catch(Te){if(!Re||v.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,je.nameShort),(0,t.localize)(2,null),je),Te;try{(0,D.unlinkSync)(Y.mainIPCHandle)}catch(te){throw we.warn("Could not delete obsolete instance handle",te),te}return this.f(we,Y,fe,ge,je,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${je.nameShort} is running.`;throw we.error(Te),Le.dispose(),new Error(Te)}let Ue;!Y.args.wait&&!Y.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,je.nameShort),(0,t.localize)(4,null),je)},1e4));const He=l.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=l.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return ge.invokeFunction(async()=>{const Te=new n.$ys(he.$bp,je),te=await Xe.getMainDiagnostics(),de=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Te.getDiagnostics(te,de);throw console.log(pe),new h.$ab});throw v.$i&&await this.i(He,we),we.trace("Sending env to running instance..."),await He.start(Y.args,process.env),Le.dispose(),Ue&&clearTimeout(Ue),new h.$ab("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,t.localize)(5,null,je.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}g(we,Y,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,R.$Hb)([we.userDataPath,we.extensionsPath,w.$hi]).map(je=>(0,y.$nw)(S.URI.file(je),{os:v.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$bj)(fe),ge.join(`
`)),Y)}}h(we,Y,fe){i.dialog.showMessageBoxSync((0,ue.$Bw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Y},fe).options)}async i(we,Y){if(v.$i){const fe=await we.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,je)=>{Z(["windows-foreground-love"],ge,je)})).allowSetForegroundWindow(fe)}catch(ge){Y.error(ge)}}}j(we,Y){const fe=we.get(U.$Wj),ge=we.get(L.$obc);let je=0;Y&&(Y.isExpected?Y.message&&fe.trace(Y.message):(je=1,Y.stack?fe.error(Y.stack):fe.error(`Startup error: ${Y.toString()}`))),ge.kill(je)}k(){const we=this.l((0,c.$rm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Y=(0,b.$Tcc)(we.verbose);Y&&((0,c.$tm)(process.argv,"--waitMarkerFilePath",Y),we.waitMarkerFilePath=Y)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Y=this.m(we._,we.goto);we._=Y}return we}m(we,Y){const fe=(0,p.cwd)(),ge=we.map(Be=>{let We=String(Be),Le;Y&&(Le=(0,u.$xg)(We),We=Le.path),We&&(We=this.n(fe,We));const Ue=(0,u.$sg)(We,fe),He=(0,$.$oc)(Ue);return He&&!(0,u.$og)(He)?null:Y&&Le?(Le.path=Ue,this.o(Le)):Ue}),je=v.$i||v.$j,Re=(0,R.$Mb)(ge,Be=>Be&&je?Be.toLowerCase():Be||"");return(0,R.$Hb)(Re)}n(we,Y){return v.$i&&(Y=(0,m.$bf)(Y,'"')),Y=(0,m.$_e)((0,m.$_e)(Y," "),"	"),v.$i&&(Y=(0,$.$lc)(we,Y),Y=(0,m.$bf)(Y,".")),Y}o(we){const Y=[we.path];return typeof we.line=="number"&&Y.push(String(we.line)),typeof we.column=="number"&&Y.push(String(we.column)),Y.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d30cf1447b6442215404fcba71ea59588d94908/core/vs/code/electron-main/main.js.map
