/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ne){for(var e=[],R=0,N=ne.length;R<N;R++)e[R]=ce[ne[R]];return e};define(ce[124],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class R{static get(){const j=new Map,L=new Map,A=new Map,I=new Map;function P(f,h){f.has(h.detail)||f.set(h.detail,-h.timestamp)}function $(f,h){const p=f.get(h.detail);p&&(p>=0||f.set(h.detail,p+h.timestamp))}let S=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(S=ne.getStats().slice(0).sort((f,h)=>f.timestamp-h.timestamp));for(const f of S)switch(f.type){case 10:P(j,f);break;case 11:case 12:$(j,f);break;case 21:P(L,f);break;case 22:$(L,f);break;case 33:P(A,f);break;case 34:$(A,f);break;case 31:P(I,f);break;case 32:$(I,f);break}let b=0;A.forEach(f=>b+=f);function m(f){const h=[];return f.forEach((p,w)=>h.push([w,p])),h}return{amdLoad:m(j),amdInvoke:m(L),nodeRequire:m(A),nodeEval:m(I),nodeRequireTotal:b}}static toMarkdownTable(j,L){let A="";const I=[];return j.forEach((P,$)=>{I[$]=P.length}),L.forEach(P=>{P.forEach(($,S)=>{typeof $>"u"&&($=P[S]="-");const b=$.toString().length;I[S]=Math.max(b,I[S])})}),j.forEach((P,$)=>{A+=`| ${P+" ".repeat(I[$]-P.toString().length)} `}),A+=`|
`,j.forEach((P,$)=>{A+=`| ${"-".repeat(I[$])} `}),A+=`|
`,L.forEach(P=>{P.forEach(($,S)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(I[S]-$.toString().length)} `)}),A+=`|
`}),A}}e.$U=R}),define(ce[125],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=R,e.$gb=N,e.$hb=j,e.$ib=L,e.$jb=A,e.$kb=I,e.$lb=P,e.$nb=S,e.$ob=b,e.$pb=m,e.$qb=f,e.$rb=h;function R(p,w){const u=N(p,w);if(u!==-1)return p[u]}function N(p,w,u=p.length-1){for(let d=u;d>=0;d--){const l=p[d];if(w(l))return d}return-1}function j(p,w){const u=L(p,w);return u===-1?void 0:p[u]}function L(p,w,u=0,d=p.length){let l=u,c=d;for(;l<c;){const g=Math.floor((l+c)/2);w(p[g])?l=g+1:c=g}return l-1}function A(p,w){const u=I(p,w);return u===p.length?void 0:p[u]}function I(p,w,u=0,d=p.length){let l=u,c=d;for(;l<c;){const g=Math.floor((l+c)/2);w(p[g])?c=g:l=g+1}return l}function P(p,w,u=0,d=p.length){const l=I(p,w,u,d);return l===p.length?-1:l}class ${static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if($.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!w(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const u=L(this.e,w,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=$;function S(p,w){if(p.length===0)return;let u=p[0];for(let d=1;d<p.length;d++){const l=p[d];w(l,u)>0&&(u=l)}return u}function b(p,w){if(p.length===0)return;let u=p[0];for(let d=1;d<p.length;d++){const l=p[d];w(l,u)>=0&&(u=l)}return u}function m(p,w){return S(p,(u,d)=>-w(u,d))}function f(p,w){if(p.length===0)return-1;let u=0;for(let d=1;d<p.length;d++){const l=p[d];w(l,p[u])>0&&(u=d)}return u}function h(p,w){for(const u of p){const d=w(u);if(d!==void 0)return d}}}),define(ce[126],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=R,e.$L=N,e.$M=j,e.$N=L;function R(A,I){const P=Object.create(null);for(const $ of A){const S=I($);let b=P[S];b||(b=P[S]=[]),b.push($)}return P}function N(A,I){const P=[],$=[];for(const S of A)I.has(S)||P.push(S);for(const S of I)A.has(S)||$.push(S);return{removed:P,added:$}}function j(A,I){const P=[],$=[];for(const[S,b]of A)I.has(S)||P.push(b);for(const[S,b]of I)A.has(S)||$.push(b);return{removed:P,added:$}}function L(A,I){const P=new Set;for(const $ of I)A.has($)&&P.add($);return P}}),define(ce[84],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=j,e.$Wh=L;function R(A){return(I,P,$)=>{let S=null,b=null;if(typeof $.value=="function"?(S="value",b=$.value):typeof $.get=="function"&&(S="get",b=$.get),!b)throw new Error("not supported");$[S]=A(b,P)}}function N(A,I,P){let $=null,S=null;if(typeof P.value=="function"?($="value",S=P.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&($="get",S=P.get),!S)throw new Error("not supported");const b=`$memoize$${I}`;P[$]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,m)}),this[b]}}function j(A,I,P){return R(($,S)=>{const b=`$debounce$${S}`,m=`$debounce$result$${S}`;return function(...f){this[m]||(this[m]=P?P():void 0),clearTimeout(this[b]),I&&(this[m]=I(this[m],...f),f=[this[m]]),this[b]=setTimeout(()=>{$.apply(this,f),this[m]=P?P():void 0},A)}})}function L(A,I,P){return R(($,S)=>{const b=`$throttle$timer$${S}`,m=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,h=`$throttle$pending$${S}`;return function(...p){if(this[m]||(this[m]=P?P():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...p)),this[h])return;const w=this[f]+A;w<=Date.now()?(this[f]=Date.now(),$.apply(this,[this[m]]),this[m]=P?P():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[f]=Date.now(),$.apply(this,[this[m]]),this[m]=P?P():void 0},w-Date.now()))}})}}),define(ce[7],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=j,e.$1=L,e.$2=A,e.$3=I,e.$4=$,e.$6=b,e.$7=m,e.$8=f,e.$0=p;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=R,e.$X=new R;function N(g){e.$X.setUnexpectedErrorHandler(g)}function j(g){if(!g||typeof g!="object")return!1;const i=g;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function L(g){$(g)||e.$X.onUnexpectedError(g)}function A(g){$(g)||e.$X.onUnexpectedExternalError(g)}function I(g){if(g instanceof Error){const{name:i,message:o}=g,n=g.stacktrace||g.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:l.isErrorNoTelemetry(g)}}return g}const P="Canceled";function $(g){return g instanceof S?!0:g instanceof Error&&g.name===P&&g.message===P}class S extends Error{constructor(){super(P),this.name=this.message}}e.$5=S;function b(){const g=new Error(P);return g.name=g.message,g}function m(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function f(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(ce[17],le([0,1,7,125]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=j,e.$tb=L,e.$ub=A,e.$vb=I,e.$wb=P,e.$xb=$,e.$yb=S,e.$zb=b,e.$Ab=m,e.$Bb=f,e.$Cb=h,e.$Db=p,e.$Eb=w,e.top=u,e.$Gb=d,e.$Hb=c,e.$Ib=g,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=y,e.$Rb=v,e.$Sb=C,e.$Tb=E,e.$Ub=k,e.$Vb=O,e.$Wb=M,e.$Xb=F,e.$Yb=U,e.$Zb=X,e.$1b=H,e.$2b=Z,e.$3b=W,e.$4b=J,e.$5b=V,e.$6b=B,e.$7b=te,e.$8b=ae,e.$$b=D;function j(K,ee=0){return K[K.length-(1+ee)]}function L(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function A(K,ee,_=(Y,se)=>Y===se){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let Y=0,se=K.length;Y<se;Y++)if(!_(K[Y],ee[Y]))return!1;return!0}function I(K,ee){const _=K.length-1;ee<_&&(K[ee]=K[_]),K.pop()}function P(K,ee,_){return $(K.length,Y=>_(K[Y],ee))}function $(K,ee){let _=0,Y=K-1;for(;_<=Y;){const se=(_+Y)/2|0,ue=ee(se);if(ue<0)_=se+1;else if(ue>0)Y=se-1;else return se}return-(_+1)}function S(K,ee,_){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const Y=ee[Math.floor(ee.length*Math.random())],se=[],ue=[],ge=[];for(const fe of ee){const $e=_(fe,Y);$e<0?se.push(fe):$e>0?ue.push(fe):ge.push(fe)}return K<se.length?S(K,se,_):K<se.length+ge.length?ge[0]:S(K-(se.length+ge.length),ue,_)}function b(K,ee){const _=[];let Y;for(const se of K.slice(0).sort(ee))!Y||ee(Y[0],se)!==0?(Y=[se],_.push(Y)):Y.push(se);return _}function*m(K,ee){let _,Y;for(const se of K)Y!==void 0&&ee(Y,se)?_.push(se):(_&&(yield _),_=[se]),Y=se;_&&(yield _)}function f(K,ee){for(let _=0;_<=K.length;_++)ee(_===0?void 0:K[_-1],_===K.length?void 0:K[_])}function h(K,ee){for(let _=0;_<K.length;_++)ee(_===0?void 0:K[_-1],K[_],_+1===K.length?void 0:K[_+1])}function p(K,ee,_){const Y=[];function se(fe,$e,ye){if($e===0&&ye.length===0)return;const ve=Y[Y.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=$e,ve.toInsert.push(...ye)):Y.push({start:fe,deleteCount:$e,toInsert:ye})}let ue=0,ge=0;for(;;){if(ue===K.length){se(ue,0,ee.slice(ge));break}if(ge===ee.length){se(ue,K.length-ue,[]);break}const fe=K[ue],$e=ee[ge],ye=_(fe,$e);ye===0?(ue+=1,ge+=1):ye<0?(se(ue,1,[]),ue+=1):ye>0&&(se(ue,0,[$e]),ge+=1)}return Y}function w(K,ee,_){const Y=p(K,ee,_),se=[],ue=[];for(const ge of Y)se.push(...K.slice(ge.start,ge.start+ge.deleteCount)),ue.push(...ge.toInsert);return{removed:se,added:ue}}function u(K,ee,_){if(_===0)return[];const Y=K.slice(0,_).sort(ee);return l(K,ee,Y,_,K.length),Y}function d(K,ee,_,Y,se){return _===0?Promise.resolve([]):new Promise((ue,ge)=>{(async()=>{const fe=K.length,$e=K.slice(0,_).sort(ee);for(let ye=_,ve=Math.min(_+Y,fe);ye<fe;ye=ve,ve=Math.min(ve+Y,fe)){if(ye>_&&await new Promise(Ce=>setTimeout(Ce)),se&&se.isCancellationRequested)throw new R.$5;l(K,ee,$e,ye,ve)}return $e})().then(ue,ge)})}function l(K,ee,_,Y,se){for(const ue=_.length;Y<se;Y++){const ge=K[Y];if(ee(ge,_[ue-1])<0){_.pop();const fe=(0,N.$kb)(_,$e=>ee(ge,$e)<0);_.splice(fe,0,ge)}}}function c(K){return K.filter(ee=>!!ee)}function g(K){let ee=0;for(let _=0;_<K.length;_++)K[_]&&(K[ee]=K[_],ee+=1);K.length=ee}function i(K,ee,_){K.splice(_,0,K.splice(ee,1)[0])}function o(K){return!Array.isArray(K)||K.length===0}function n(K){return Array.isArray(K)&&K.length>0}function s(K,ee=_=>_){const _=new Set;return K.filter(Y=>{const se=ee(Y);return _.has(se)?!1:(_.add(se),!0)})}function t(K){const ee=new Set;return _=>{const Y=K(_);return ee.has(Y)?!1:(ee.add(Y),!0)}}function r(K,ee){return K.length>0?K[0]:ee}function a(K,ee){return K.length>0?K[K.length-1]:ee}function y(K,ee,_=(Y,se)=>Y===se){let Y=0;for(let se=0,ue=Math.min(K.length,ee.length);se<ue&&_(K[se],ee[se]);se++)Y++;return Y}function v(K){return[].concat(...K)}function C(K,ee){let _=typeof ee=="number"?K:0;typeof ee=="number"?_=K:(_=0,ee=K);const Y=[];if(_<=ee)for(let se=_;se<ee;se++)Y.push(se);else for(let se=_;se>ee;se--)Y.push(se);return Y}function E(K,ee,_){return K.reduce((Y,se)=>(Y[ee(se)]=_?_(se):se,Y),Object.create(null))}function k(K,ee){return K.push(ee),()=>O(K,ee)}function O(K,ee){const _=K.indexOf(ee);if(_>-1)return K.splice(_,1),ee}function M(K,ee,_){const Y=K.slice(0,ee),se=K.slice(ee);return Y.concat(_,se)}function F(K,ee){let _;if(typeof ee=="number"){let Y=ee;_=()=>{const se=Math.sin(Y++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let Y=K.length-1;Y>0;Y-=1){const se=Math.floor(_()*(Y+1)),ue=K[Y];K[Y]=K[se],K[se]=ue}}function U(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.unshift(ee))}function X(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.push(ee))}function H(K,ee){for(const _ of ee)K.push(_)}function Z(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}function W(K){return Array.isArray(K)?K:[K]}function J(K){return K[Math.floor(Math.random()*K.length)]}function V(K,ee,_){const Y=ie(K,ee),se=K.length,ue=_.length;K.length=se+ue;for(let ge=se-1;ge>=Y;ge--)K[ge+ue]=K[ge];for(let ge=0;ge<ue;ge++)K[ge+Y]=_[ge]}function B(K,ee,_,Y){const se=ie(K,ee);let ue=K.splice(se,_);return ue===void 0&&(ue=[]),V(K,se,Y),ue}function ie(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var oe;(function(K){function ee(ue){return ue<0}K.isLessThan=ee;function _(ue){return ue<=0}K.isLessThanOrEqual=_;function Y(ue){return ue>0}K.isGreaterThan=Y;function se(ue){return ue===0}K.isNeitherLessOrGreaterThan=se,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function te(K,ee){return(_,Y)=>ee(K(_),K(Y))}function ae(...K){return(ee,_)=>{for(const Y of K){const se=Y(ee,_);if(!oe.isNeitherLessOrGreaterThan(se))return se}return oe.neitherLessOrGreaterThan}}const G=(K,ee)=>K-ee;e.$9b=G;const q=(K,ee)=>(0,e.$9b)(K?1:0,ee?1:0);e.$0b=q;function D(K){return(ee,_)=>-K(ee,_)}class T{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Y=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Y}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Y=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=T;class z{static{this.empty=new z(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new z(_=>this.iterate(Y=>ee(Y)?_(Y):!0))}map(ee){return new z(_=>this.iterate(Y=>_(ee(Y))))}some(ee){let _=!1;return this.iterate(Y=>(_=ee(Y),!_)),_}findFirst(ee){let _;return this.iterate(Y=>ee(Y)?(_=Y,!1):!0),_}findLast(ee){let _;return this.iterate(Y=>(ee(Y)&&(_=Y),!0)),_}findLastMaxBy(ee){let _,Y=!0;return this.iterate(se=>((Y||oe.isGreaterThan(ee(se,_)))&&(Y=!1,_=se),!0)),_}}e.$ac=z;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Y=Array.from(ee.keys()).sort((se,ue)=>_(ee[se],ee[ue]));return new x(Y)}apply(ee){return ee.map((_,Y)=>ee[this.c[Y]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(ce[127],le([0,1,7]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=j,e.$dd=L,e.$ed=A,e.$fd=I,e.$gd=P;function N($,S){if(!$)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function j($,S="Unreachable"){throw new Error(S)}function L($){if(!$)throw new R.$cb("Assertion Failed")}function A($){$||(0,R.$1)(new R.$cb("Soft Assertion Failed"))}function I($){if(!$()){debugger;$(),(0,R.$1)(new R.$cb("Assertion Failed"))}}function P($,S){let b=0;for(;b<$.length-1;){const m=$[b],f=$[b+1];if(!S(m,f))return!1;b++}return!0}}),define(ce[85],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=R;function R(N,j){const L=this;let A=!1,I;return function(){if(A)return I;if(A=!0,j)try{I=N.apply(L,arguments)}finally{j()}else I=N.apply(L,arguments);return I}}}),define(ce[61],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(N){function j(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}N.is=j;const L=Object.freeze([]);function A(){return L}N.empty=A;function*I(i){yield i}N.single=I;function P(i){return j(i)?i:I(i)}N.wrap=P;function $(i){return i||L}N.from=$;function*S(i){for(let o=i.length-1;o>=0;o--)yield i[o]}N.reverse=S;function b(i){return!i||i[Symbol.iterator]().next().done===!0}N.isEmpty=b;function m(i){return i[Symbol.iterator]().next().value}N.first=m;function f(i,o){for(const n of i)if(o(n))return!0;return!1}N.some=f;function h(i,o){for(const n of i)if(o(n))return n}N.find=h;function*p(i,o){for(const n of i)o(n)&&(yield n)}N.filter=p;function*w(i,o){let n=0;for(const s of i)yield o(s,n++)}N.map=w;function*u(...i){for(const o of i)yield*o}N.concat=u;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}N.reduce=d;function*l(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}N.slice=l;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,N.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=c;async function g(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}N.asyncToArray=g})(R||(e.Iterable=R={}))}),define(ce[35],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=A,e.$Cn=b,e.$Dn=m,e.$En=f,e.$Fn=h,e.$Gn=p,e.$Hn=w,e.$In=u,e.$Jn=d,e.$Kn=l,e.$Ln=c,e.$Mn=g;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var j;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,y=0;function v(U){let X=0,H=0;for(;X<U;){const Z=i.charCodeAt(n);if(Z>=48&&Z<=57)H=H*16+Z-48;else if(Z>=65&&Z<=70)H=H*16+Z-65+10;else if(Z>=97&&Z<=102)H=H*16+Z-97+10;else break;n++,X++}return X<U&&(H=-1),H}function C(U){n=U,t="",r=0,a=16,y=0}function E(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&$(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&$(i.charCodeAt(n)))for(n++;n<i.length&&$(i.charCodeAt(n));)n++;else return y=3,i.substring(U,n);let X=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&$(i.charCodeAt(n))){for(n++;n<i.length&&$(i.charCodeAt(n));)n++;X=n}else y=3;return i.substring(U,X)}function k(){let U="",X=n;for(;;){if(n>=s){U+=i.substring(X,n),y=2;break}const H=i.charCodeAt(n);if(H===34){U+=i.substring(X,n),n++;break}if(H===92){if(U+=i.substring(X,n),n++,n>=s){y=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=v(4);W>=0?U+=String.fromCharCode(W):y=4;break}default:y=5}X=n;continue}if(H>=0&&H<=31)if(P(H)){U+=i.substring(X,n),y=2;break}else y=6;n++}return U}function O(){if(t="",y=0,r=n,n>=s)return r=s,a=17;let U=i.charCodeAt(n);if(I(U)){do n++,t+=String.fromCharCode(U),U=i.charCodeAt(n);while(I(U));return a=15}if(P(U))return n++,t+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=k(),a=10;case 47:{const X=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(i.charCodeAt(n));)n++;return t=i.substring(X,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const H=s-1;let Z=!1;for(;n<H;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,y=1),t=i.substring(X,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===s||!$(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=E(),a=11;default:for(;n<s&&M(U);)n++,U=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function M(U){if(I(U)||P(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:C,getPosition:()=>n,scan:o?F:O,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>y}}function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function $(i){return i>=48&&i<=57}var S;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(S||(S={}));function b(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(v,C,E,k){r.value=v,r.offset=C,r.length=E,r.type=k,r.colonOffset=void 0,t=r}try{l(i,{onObjectBegin:(v,C)=>{if(o<=v)throw s;t=void 0,a=o>v,n.push("")},onObjectProperty:(v,C,E)=>{if(o<C||(y(v,C,E,"property"),n[n.length-1]=v,o<=C+E))throw s},onObjectEnd:(v,C)=>{if(o<=v)throw s;t=void 0,n.pop()},onArrayBegin:(v,C)=>{if(o<=v)throw s;t=void 0,n.push(0)},onArrayEnd:(v,C)=>{if(o<=v)throw s;t=void 0,n.pop()},onLiteralValue:(v,C,E)=>{if(o<C||(y(v,C,E,g(v)),o<=C+E))throw s},onSeparator:(v,C,E)=>{if(o<=C)throw s;if(v===":"&&t&&t.type==="property")t.colonOffset=C,a=!1,t=void 0;else if(v===","){const k=n[n.length-1];typeof k=="number"?n[n.length-1]=k+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(v){if(v!==s)throw v}return{path:n,previousNode:t,isAtPropertyKey:a,matches:v=>{let C=0;for(let E=0;C<v.length&&E<n.length;E++)if(v[C]===n[E]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}function m(i,o=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(v){Array.isArray(t)?t.push(v):s!==null&&(t[s]=v)}return l(i,{onObjectBegin:()=>{const v={};a(v),r.push(t),t=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const v=[];a(v),r.push(t),t=v,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(v,C,E)=>{o.push({error:v,offset:C,length:E})}},n),t[0]}function f(i,o=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function r(v){return s.children.push(v),v}l(i,{onObjectBegin:v=>{s=r({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,C,E)=>{s=r({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:C,length:E,parent:s})},onObjectEnd:(v,C)=>{s.length=v+C-s.offset,s=s.parent,t(v+C)},onArrayBegin:(v,C)=>{s=r({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,C)=>{s.length=v+C-s.offset,s=s.parent,t(v+C)},onLiteralValue:(v,C,E)=>{r({type:g(v),offset:C,length:E,parent:s,value:v}),t(C+E)},onSeparator:(v,C,E)=>{s.type==="property"&&(v===":"?s.colonOffset=C:v===","&&t(C))},onError:(v,C,E)=>{o.push({error:v,offset:C,length:E})}},n);const y=s.children[0];return y&&delete y.parent,y}function h(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=w(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function u(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function d(i,o,n=!1){if(u(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}function l(i,o,n=L.DEFAULT){const s=A(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ae=>te(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),y=r(o.onObjectProperty),v=t(o.onObjectEnd),C=t(o.onArrayBegin),E=t(o.onArrayEnd),k=r(o.onLiteralValue),O=r(o.onSeparator),M=t(o.onComment),F=r(o.onError),U=n&&n.disallowComments,X=n&&n.allowTrailingComma;function H(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:U||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(te){case 12:case 13:U?Z(10):M();break;case 16:Z(1);break;case 15:case 14:break;default:return te}}}function Z(te,ae=[],G=[]){if(F(te),ae.length+G.length>0){let q=s.getToken();for(;q!==17;){if(ae.indexOf(q)!==-1){H();break}else if(G.indexOf(q)!==-1)break;q=H()}}}function W(te){const ae=s.getTokenValue();return te?k(ae):y(ae),H(),!0}function J(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(Z(2),te=0)}catch{Z(2)}k(te);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return H(),!0}function V(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(O(":"),H(),oe()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function B(){a(),H();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),H(),s.getToken()===2&&X)break}else te&&Z(6,[],[]);V()||Z(4,[],[2,5]),te=!0}return v(),s.getToken()!==2?Z(7,[2],[]):H(),!0}function ie(){C(),H();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||Z(4,[],[]),O(","),H(),s.getToken()===4&&X)break}else te&&Z(6,[],[]);oe()||Z(4,[],[4,5]),te=!0}return E(),s.getToken()!==4?Z(8,[4],[]):H(),!0}function oe(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return J()}}return H(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):oe()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}function c(i,o){const n=A(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[43],le([0,1,35]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=N,e.$On=j,e.$Pn=I,e.$Qn=P;function N($,S,b){let m,f,h,p,w;if(S){for(p=S.offset,w=p+S.length,h=p;h>0&&!P($,h-1);)h--;let a=w;for(;a<$.length&&!P($,a);)a++;f=$.substring(h,a),m=A(f,b)}else f=$,m=0,h=0,p=0,w=$.length;const u=I(b,$);let d=!1,l=0,c;b.insertSpaces?c=L(" ",b.tabSize||4):c="	";const g=(0,R.$Bn)(f,!1);let i=!1;function o(){return u+L(c,m+l)}function n(){let a=g.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=g.scan();return i=a===16||g.getTokenError()!==0,a}const s=[];function t(a,y,v){!i&&y<w&&v>p&&$.substring(y,v)!==a&&s.push({offset:y,length:v-y,content:a})}let r=n();if(r!==17){const a=g.getTokenOffset()+h,y=L(c,m);t(y,h,a)}for(;r!==17;){let a=g.getTokenOffset()+g.getTokenLength()+h,y=n(),v="";for(;!d&&(y===12||y===13);){const E=g.getTokenOffset()+h;t(" ",a,E),a=g.getTokenOffset()+g.getTokenLength()+h,v=y===12?o():"",y=n()}if(y===2)r!==1&&(l--,v=o());else if(y===4)r!==3&&(l--,v=o());else{switch(r){case 3:case 1:l++,v=o();break;case 5:case 12:v=o();break;case 13:d?v=o():v=" ";break;case 6:v=" ";break;case 10:if(y===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?v=" ":y!==5&&y!==17&&(i=!0);break;case 16:i=!0;break}d&&(y===12||y===13)&&(v=o())}const C=g.getTokenOffset()+h;t(v,a,C),r=y}return s}function j($,S){const b=JSON.stringify($,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?b.replace(/\r\n|\r|\n/g,S.eol):b}function L($,S){let b="";for(let m=0;m<S;m++)b+=$;return b}function A($,S){let b=0,m=0;const f=S.tabSize||4;for(;b<$.length;){const h=$.charAt(b);if(h===" ")m++;else if(h==="	")m+=f;else break;b++}return Math.floor(m/f)}function I($,S){for(let b=0;b<S.length;b++){const m=S.charAt(b);if(m==="\r")return b+1<S.length&&S.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return $&&$.eol||`
`}function P($,S){return`\r
`.indexOf($.charAt(S))!==-1}}),define(ce[62],le([0,1,35,43]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=j,e.$Sn=L,e.$Tn=A,e.$Un=I,e.$Vn=P;function j($,S,b){return L($,S,void 0,b)}function L($,S,b,m,f){const h=S.slice(),p=[],w=(0,R.$En)($,p);let u,d;for(;h.length>0&&(d=h.pop(),u=(0,R.$Fn)(w,h),u===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const l=(0,R.$Fn)(u,[d]);if(l!==void 0)if(b===void 0){if(!l.parent)throw new Error("Malformed AST");const c=u.children.indexOf(l.parent);let g,i=l.parent.offset+l.parent.length;if(c>0){const o=u.children[c-1];g=o.offset+o.length}else g=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return A($,{offset:g,length:i-g,content:""},m)}else return A($,{offset:l.offset,length:l.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,g=f?f(u.children.map(o=>o.children[0].value)):u.children.length;let i;if(g>0){const o=u.children[g-1];i={offset:o.offset+o.length,length:0,content:","+c}}else u.children.length===0?i={offset:u.offset+1,length:0,content:c}:i={offset:u.offset+1,length:0,content:c+","};return A($,i,m)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(b!==void 0){const l=`${JSON.stringify(b)}`;let c;if(u.children.length===0||d===0)c={offset:u.offset+1,length:0,content:u.children.length===0?l:l+","};else{const g=d===-1||d>u.children.length?u.children.length:d,i=u.children[g-1];c={offset:i.offset+i.length,length:0,content:","+l}}return A($,c,m)}else{const l=d,c=u.children[l];let g;if(u.children.length===1)g={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===l){const i=u.children[l-1],o=i.offset+i.length,n=u.offset+u.length;g={offset:o,length:n-2-o,content:""}}else g={offset:c.offset,length:u.children[l+1].offset-c.offset,content:""};return A($,g,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else return b===void 0?[]:A($,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},m)}function A($,S,b){let m=I($,S),f=S.offset,h=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;f>0&&!(0,N.$Qn)(m,f-1);)f--;for(;h<m.length&&!(0,N.$Qn)(m,h);)h++}const p=(0,N.$Nn)(m,{offset:f,length:h-f},b);for(let u=p.length-1;u>=0;u--){const d=p[u];m=I(m,d),f=Math.min(f,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const w=$.length-(m.length-h)-f;return[{offset:f,length:w,content:m.substring(f,h)}]}function I($,S){return $.substring(0,S.offset)+S.content+$.substring(S.offset+S.length)}function P($,S){const b=S.slice(0).sort((f,h)=>{const p=f.offset-h.offset;return p===0?f.length-h.length:p});let m=$.length;for(let f=b.length-1;f>=0;f--){const h=b[f];if(h.offset+h.length<=m)$=I($,h);else throw new Error("Overlapping edit");m=h.offset}return $}}),define(ce[53],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class R{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=R}),define(ce[86],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(L){this.element=L,this.next=R.Undefined,this.prev=R.Undefined}}class N{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let L=this.a;for(;L!==R.Undefined;){const A=L.next;L.prev=R.Undefined,L.next=R.Undefined,L=A}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const I=new R(L);if(this.a===R.Undefined)this.a=I,this.b=I;else if(A){const $=this.b;this.b=I,I.prev=$,$.next=I}else{const $=this.a;this.a=I,I.next=$,$.prev=I}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(I))}}shift(){if(this.a!==R.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==R.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==R.Undefined&&L.next!==R.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===R.Undefined&&L.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):L.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):L.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==R.Undefined;)yield L.element,L=L.next}}e.$5c=N}),define(ce[34],le([0,1]),function(ne,e){"use strict";var R,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=L,e.$zc=A,e.$Ac=I,e.$Ic=d;function L(l,c,g){let i=l.get(c);return i===void 0&&(i=g,l.set(c,i)),i}function A(l){const c=[];return l.forEach((g,i)=>{c.push(`${i} => ${g}`)}),`Map(${l.size}) {${c.join(", ")}}`}function I(l){const c=[];return l.forEach(g=>{c.push(g)}),`Set(${l.size}) {${c.join(", ")}}`}class P{constructor(c,g){this.uri=c,this.value=g}}function $(l){return Array.isArray(l)}class S{static{this.c=c=>c.toString()}constructor(c,g){if(this[R]="ResourceMap",c instanceof S)this.d=new Map(c.d),this.e=g??S.c;else if($(c)){this.d=new Map,this.e=g??S.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??S.c}set(c,g){return this.d.set(this.e(c),new P(c,g)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,g){typeof g<"u"&&(c=c.bind(g));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=S;class b{constructor(c,g){this[N]="ResourceSet",!c||typeof c=="function"?this.c=new S(c):(this.c=new S(g),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,g){this.c.forEach((i,o)=>c.call(g,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=b;var m;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class f{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,g=0){const i=this.c.get(c);if(i)return g!==0&&this.l(i,g),i.value}set(c,g,i=0){let o=this.c.get(c);if(o)o.value=g,i!==0&&this.l(o,i);else{switch(o={key:c,value:g,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const g=this.c.get(c);if(g)return this.c.delete(c),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,g){const i=this.g;let o=this.d;for(;o;){if(g?c.bind(g)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,g=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==g)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let g=this.d,i=this.size;for(;g&&i>c;)this.c.delete(g.key),g=g.next,i--;this.d=g,this.f=i,g&&(g.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const g=c.next,i=c.previous;if(!g||!i)throw new Error("Invalid list");g.previous=i,i.next=g}c.next=void 0,c.previous=void 0,this.g++}l(c,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(g===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((g,i)=>{c.push([i,g])}),c}fromJSON(c){this.clear();for(const[g,i]of c)this.set(g,i)}}e.$Dc=f;class h extends f{constructor(c,g=1){super(),this.m=c,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,g=2){return super.get(c,g)}peek(c){return super.get(c,0)}set(c,g){return super.set(c,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=h;class p{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let g=this.c.get(c)||0;return g===0?!1:(g--,g===0?this.c.delete(c):this.c.set(c,g),!0)}has(c){return this.c.has(c)}}e.$Fc=p;class w{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[g,i]of c)this.set(g,i)}clear(){this.c.clear(),this.d.clear()}set(c,g){this.c.set(c,g),this.d.set(g,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const g=this.c.get(c);return g===void 0?!1:(this.c.delete(c),this.d.delete(g),!0)}forEach(c,g){this.c.forEach((i,o)=>{c.call(g,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class u{constructor(){this.c=new Map}add(c,g){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(g)}delete(c,g){const i=this.c.get(c);i&&(i.delete(g),i.size===0&&this.c.delete(c))}forEach(c,g){const i=this.c.get(c);i&&i.forEach(g)}get(c){const g=this.c.get(c);return g||new Set}}e.$Hc=u;function d(l,c){if(l===c)return!0;if(l.size!==c.size)return!1;for(const[g,i]of l)if(!c.has(g)||c.get(g)!==i)return!1;for(const[g]of c)if(!l.has(g))return!1;return!0}}),define(ce[2],le([0,1,17,126,34,85,61]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=S,e.$Lc=b,e.$Mc=m,e.$Nc=p,e.$Oc=w,e.$Pc=u,e.$Qc=d,e.$Rc=l,e.$Sc=c,e.$3c=v;const I=!1;let P=null;class ${constructor(){this.b=new Map}static{this.a=0}c(k){let O=this.b.get(k);return O||(O={parent:null,source:null,isSingleton:!1,value:k,idx:$.a++},this.b.set(k,O)),O}trackDisposable(k){const O=this.c(k);O.source||(O.source=new Error().stack)}setParent(k,O){const M=this.c(k);M.parent=O}markAsDisposed(k){this.b.delete(k)}markAsSingleton(k){this.c(k).isSingleton=!0}f(k,O){const M=O.get(k);if(M)return M;const F=k.parent?this.f(this.c(k.parent),O):k;return O.set(k,F),F}getTrackedDisposables(){const k=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,k).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(k=10,O){let M;if(O)M=O;else{const Z=new Map,W=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Z).isSingleton);if(W.length===0)return;const J=new Set(W.map(V=>V.value));if(M=W.filter(V=>!(V.parent&&J.has(V.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function F(Z){function W(V,B){for(;V.length>0&&B.some(ie=>typeof ie=="string"?ie===V[0]:V[0].match(ie));)V.shift()}const J=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const U=new j.$Hc;for(const Z of M){const W=F(Z);for(let J=0;J<=W.length;J++)U.add(W.slice(0,J).join(`
`),Z)}M.sort((0,R.$7b)(Z=>Z.idx,R.$9b));let X="",H=0;for(const Z of M.slice(0,k)){H++;const W=F(Z),J=[];for(let V=0;V<W.length;V++){let B=W[V];B=`(shared with ${U.get(W.slice(0,V+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const oe=U.get(W.slice(0,V).join(`
`)),te=(0,N.$K)([...oe].map(ae=>F(ae)[V]),ae=>ae);delete te[W[V]];for(const[ae,G]of Object.entries(te))J.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ae}`);J.unshift(B)}X+=`


==================== Leaking disposable ${H}/${M.length}: ${Z.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return M.length>k&&(X+=`


... and ${M.length-k} more leaking disposables

`),{leaks:M,details:X}}}e.$Jc=$;function S(E){P=E}if(I){const E="__is_disposable_tracked__";S(new class{trackDisposable(k){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[E]||console.log(O)},3e3)}setParent(k,O){if(k&&k!==i.None)try{k[E]=!0}catch{}}markAsDisposed(k){if(k&&k!==i.None)try{k[E]=!0}catch{}}markAsSingleton(k){}})}function b(E){return P?.trackDisposable(E),E}function m(E){P?.markAsDisposed(E)}function f(E,k){P?.setParent(E,k)}function h(E,k){if(P)for(const O of E)P.setParent(O,k)}function p(E){return P?.markAsSingleton(E),E}function w(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function u(E){if(A.Iterable.is(E)){const k=[];for(const O of E)if(O)try{O.dispose()}catch(M){k.push(M)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function d(E){for(const k of E)w(k)&&k.dispose();return[]}function l(...E){const k=c(()=>u(E));return h(E,k),k}function c(E){const k=b({dispose:(0,L.$db)(()=>{m(k),E()})});return k}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return f(k,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(k),k.dispose()}}deleteAndLeak(k){k&&this.f.has(k)&&(this.f.delete(k),f(k,null))}}e.$Tc=g;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,b(this),f(this.q,this)}dispose(){m(this),this.q.dispose()}B(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(k)}}e.$Uc=i;class o{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(k){this.b||k===this.a||(this.a?.dispose(),k&&f(k,this),this.a=k)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const k=this.a;return this.a=void 0,k&&f(k,null),k}}e.$Vc=o;class n{constructor(k){this.a=new o,this.b=!1,this.a.value=k}get value(){return this.a.value}set value(k){this.b||k===this.a.value||(this.a.value=k)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(k){this.b=k,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(k){let O=k;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,m(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(k,...O){let M=this.a.get(k);M||(M={counter:0,object:this.b(k,...O)},this.a.set(k,M));const{object:F}=M,U=(0,L.$db)(()=>{--M.counter===0&&(this.c(k,M.object),this.a.delete(k))});return M.counter++,{object:F,dispose:U}}}e.$Zc=r;class a{constructor(k){this.a=k}async acquire(k,...O){const M=this.a.acquire(k,...O);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(F){throw M.dispose(),F}}}e.$1c=a;class y{constructor(k){this.object=k}dispose(){}}e.$2c=y;function v(E){const k=new g;try{E(k)}finally{k.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(k){return this.a.has(k)}get size(){return this.a.size}get(k){return this.a.get(k)}set(k,O,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(k)?.dispose(),this.a.set(k,O)}deleteAndDispose(k){this.a.get(k)?.dispose(),this.a.delete(k)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=C}),define(ce[87],le([0,1,34]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=j,e.$9l=A;const N=new R.$Ec(1e4);function j($){return P($,"NFC",N)}const L=new R.$Ec(1e4);function A($){return P($,"NFD",L)}const I=/[^\u0000-\u0080]/;function P($,S,b){if(!$)return $;const m=b.get($);if(m)return m;let f;return I.test($)?f=$.normalize(S):f=$,b.set($,f),f}e.$0l=function(){const $=/[\u0300-\u036f]/g;return function(S){return A(S).replace($,"")}}()}),function(){function ne(j){const L=[];typeof j=="number"&&L.push("code/timeOrigin",j);function A(P){L.push(P,Date.now())}function I(){const P=[];for(let $=0;$<L.length;$+=2)P.push({name:L[$],startTime:L[$+1]});return P}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(j+A.startTime)});return L}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function R(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=R(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var N in R)(typeof exports=="object"?exports:ne)[N]=R[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function R(N){if(e[N])return e[N].exports;var j=e[N]={i:N,l:!1,exports:{}};return ne[N].call(j.exports,j,j.exports,R),j.l=!0,j.exports}return R.m=ne,R.c=e,R.d=function(N,j,L){R.o(N,j)||Object.defineProperty(N,j,{enumerable:!0,get:L})},R.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},R.t=function(N,j){if(1&j&&(N=R(N)),8&j||4&j&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(R.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&j&&typeof N!="string")for(var A in N)R.d(L,A,function(I){return N[I]}.bind(null,A));return L},R.n=function(N){var j=N&&N.__esModule?function(){return N.default}:function(){return N};return R.d(j,"a",j),j},R.o=function(N,j){return Object.prototype.hasOwnProperty.call(N,j)},R.p="",R(R.s=0)}([function(ne,e,R){(function(N){var j;e=ne.exports=G,j=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],$=0,S=$++;P[S]="0|[1-9]\\d*";var b=$++;P[b]="[0-9]+";var m=$++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=$++;P[f]="("+P[S]+")\\.("+P[S]+")\\.("+P[S]+")";var h=$++;P[h]="("+P[b]+")\\.("+P[b]+")\\.("+P[b]+")";var p=$++;P[p]="(?:"+P[S]+"|"+P[m]+")";var w=$++;P[w]="(?:"+P[b]+"|"+P[m]+")";var u=$++;P[u]="(?:-("+P[p]+"(?:\\."+P[p]+")*))";var d=$++;P[d]="(?:-?("+P[w]+"(?:\\."+P[w]+")*))";var l=$++;P[l]="[0-9A-Za-z-]+";var c=$++;P[c]="(?:\\+("+P[l]+"(?:\\."+P[l]+")*))";var g=$++,i="v?"+P[f]+P[u]+"?"+P[c]+"?";P[g]="^"+i+"$";var o="[v=\\s]*"+P[h]+P[d]+"?"+P[c]+"?",n=$++;P[n]="^"+o+"$";var s=$++;P[s]="((?:<|>)?=?)";var t=$++;P[t]=P[b]+"|x|X|\\*";var r=$++;P[r]=P[S]+"|x|X|\\*";var a=$++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[u]+")?"+P[c]+"?)?)?";var y=$++;P[y]="[v=\\s]*("+P[t]+")(?:\\.("+P[t]+")(?:\\.("+P[t]+")(?:"+P[d]+")?"+P[c]+"?)?)?";var v=$++;P[v]="^"+P[s]+"\\s*"+P[a]+"$";var C=$++;P[C]="^"+P[s]+"\\s*"+P[y]+"$";var E=$++;P[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=$++;P[k]="(?:~>?)";var O=$++;P[O]="(\\s*)"+P[k]+"\\s+",I[O]=new RegExp(P[O],"g");var M=$++;P[M]="^"+P[k]+P[a]+"$";var F=$++;P[F]="^"+P[k]+P[y]+"$";var U=$++;P[U]="(?:\\^)";var X=$++;P[X]="(\\s*)"+P[U]+"\\s+",I[X]=new RegExp(P[X],"g");var H=$++;P[H]="^"+P[U]+P[a]+"$";var Z=$++;P[Z]="^"+P[U]+P[y]+"$";var W=$++;P[W]="^"+P[s]+"\\s*("+o+")$|^$";var J=$++;P[J]="^"+P[s]+"\\s*("+i+")$|^$";var V=$++;P[V]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",I[V]=new RegExp(P[V],"g");var B=$++;P[B]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=$++;P[ie]="^\\s*("+P[y]+")\\s+-\\s+("+P[y]+")\\s*$";var oe=$++;P[oe]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)j(te,P[te]),I[te]||(I[te]=new RegExp(P[te]));function ae(he,me){if(he instanceof G)return he;if(typeof he!="string"||he.length>L||!(me?I[n]:I[g]).test(he))return null;try{return new G(he,me)}catch{return null}}function G(he,me){if(he instanceof G){if(he.loose===me)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof G))return new G(he,me);j("SemVer",he,me),this.loose=me;var we=he.trim().match(me?I[n]:I[g]);if(!we)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<A)return Re}return Pe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ae,e.valid=function(he,me){var we=ae(he,me);return we?we.version:null},e.clean=function(he,me){var we=ae(he.trim().replace(/^[=v]+/,""),me);return we?we.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(he){return j("SemVer.compare",this.version,this.loose,he),he instanceof G||(he=new G(he,this.loose)),this.compareMain(he)||this.comparePre(he)},G.prototype.compareMain=function(he){return he instanceof G||(he=new G(he,this.loose)),D(this.major,he.major)||D(this.minor,he.minor)||D(this.patch,he.patch)},G.prototype.comparePre=function(he){if(he instanceof G||(he=new G(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var me=0;do{var we=this.prerelease[me],Pe=he.prerelease[me];if(j("prerelease compare",me,we,Pe),we===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(we===void 0)return-1;if(we!==Pe)return D(we,Pe)}while(++me)},G.prototype.inc=function(he,me){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,me,we,Pe){typeof we=="string"&&(Pe=we,we=void 0);try{return new G(he,we).inc(me,Pe).version}catch{return null}},e.diff=function(he,me){if(K(he,me))return null;var we=ae(he),Pe=ae(me);if(we.prerelease.length||Pe.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Pe[Re])return Re},e.compareIdentifiers=D;var q=/^[0-9]+$/;function D(he,me){var we=q.test(he),Pe=q.test(me);return we&&Pe&&(he=+he,me=+me),we&&!Pe?-1:Pe&&!we?1:he<me?-1:he>me?1:0}function T(he,me,we){return new G(he,we).compare(new G(me,we))}function z(he,me,we){return T(he,me,we)>0}function x(he,me,we){return T(he,me,we)<0}function K(he,me,we){return T(he,me,we)===0}function ee(he,me,we){return T(he,me,we)!==0}function _(he,me,we){return T(he,me,we)>=0}function Y(he,me,we){return T(he,me,we)<=0}function se(he,me,we,Pe){var Re;switch(me){case"===":typeof he=="object"&&(he=he.version),typeof we=="object"&&(we=we.version),Re=he===we;break;case"!==":typeof he=="object"&&(he=he.version),typeof we=="object"&&(we=we.version),Re=he!==we;break;case"":case"=":case"==":Re=K(he,we,Pe);break;case"!=":Re=ee(he,we,Pe);break;case">":Re=z(he,we,Pe);break;case">=":Re=_(he,we,Pe);break;case"<":Re=x(he,we,Pe);break;case"<=":Re=Y(he,we,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function ue(he,me){if(he instanceof ue){if(he.loose===me)return he;he=he.value}if(!(this instanceof ue))return new ue(he,me);j("comparator",he,me),this.loose=me,this.parse(he),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(he,me){return D(me,he)},e.major=function(he,me){return new G(he,me).major},e.minor=function(he,me){return new G(he,me).minor},e.patch=function(he,me){return new G(he,me).patch},e.compare=T,e.compareLoose=function(he,me){return T(he,me,!0)},e.rcompare=function(he,me,we){return T(me,he,we)},e.sort=function(he,me){return he.sort(function(we,Pe){return e.compare(we,Pe,me)})},e.rsort=function(he,me){return he.sort(function(we,Pe){return e.rcompare(we,Pe,me)})},e.gt=z,e.lt=x,e.eq=K,e.neq=ee,e.gte=_,e.lte=Y,e.cmp=se,e.Comparator=ue;var ge={};function fe(he,me){if(he instanceof fe)return he.loose===me?he:new fe(he.raw,me);if(he instanceof ue)return new fe(he.value,me);if(!(this instanceof fe))return new fe(he,me);if(this.loose=me,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function $e(he){return!he||he.toLowerCase()==="x"||he==="*"}function ye(he,me,we,Pe,Re,Me,De,Ue,Te,qe,ze,Le,re){return((me=$e(we)?"":$e(Pe)?">="+we+".0.0":$e(Re)?">="+we+"."+Pe+".0":">="+me)+" "+(Ue=$e(Te)?"":$e(qe)?"<"+(+Te+1)+".0.0":$e(ze)?"<"+Te+"."+(+qe+1)+".0":Le?"<="+Te+"."+qe+"."+ze+"-"+Le:"<="+Ue)).trim()}function ve(he,me){for(var we=0;we<he.length;we++)if(!he[we].test(me))return!1;if(me.prerelease.length){for(we=0;we<he.length;we++)if(j(he[we].semver),he[we].semver!==ge&&he[we].semver.prerelease.length>0){var Pe=he[we].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function Ce(he,me,we){try{me=new fe(me,we)}catch{return!1}return me.test(he)}function Ae(he,me,we,Pe){var Re,Me,De,Ue,Te;switch(he=new G(he,Pe),me=new fe(me,Pe),we){case">":Re=z,Me=Y,De=x,Ue=">",Te=">=";break;case"<":Re=x,Me=_,De=z,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(he,me,Pe))return!1;for(var qe=0;qe<me.set.length;++qe){var ze=me.set[qe],Le=null,re=null;if(ze.forEach(function(de){de.semver===ge&&(de=new ue(">=0.0.0")),Le=Le||de,re=re||de,Re(de.semver,Le.semver,Pe)?Le=de:De(de.semver,re.semver,Pe)&&(re=de)}),Le.operator===Ue||Le.operator===Te||(!re.operator||re.operator===Ue)&&Me(he,re.semver)||re.operator===Te&&De(he,re.semver))return!1}return!0}ue.prototype.parse=function(he){var me=this.loose?I[W]:I[J],we=he.match(me);if(!we)throw new TypeError("Invalid comparator: "+he);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new G(we[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(he){return j("Comparator.test",he,this.loose),this.semver===ge||(typeof he=="string"&&(he=new G(he,this.loose)),se(he,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(he,me){if(!(he instanceof ue))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new fe(he.value,me),Ce(this.value,we,me);if(he.operator==="")return we=new fe(this.value,me),Ce(he.semver,we,me);var Pe=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Me=this.semver.version===he.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Ue=se(this.semver,"<",he.semver,me)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Te=se(this.semver,">",he.semver,me)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Pe||Re||Me&&De||Ue||Te},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(he){var me=this.loose;he=he.trim(),j("range",he,me);var we=me?I[ie]:I[B];he=he.replace(we,ye),j("hyphen replace",he),he=he.replace(I[V],"$1$2$3"),j("comparator trim",he,I[V]),he=(he=(he=he.replace(I[O],"$1~")).replace(I[X],"$1^")).split(/\s+/).join(" ");var Pe=me?I[W]:I[J],Re=he.split(" ").map(function(Me){return function(De,Ue){return j("comp",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(ze){return function(Le,re){j("caret",Le,re);var de=re?I[Z]:I[H];return Le.replace(de,function(pe,be,Se,Ie,Oe){var Ne;return j("caret",Le,pe,be,Se,Ie,Oe),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Oe?(j("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(j("no pr"),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),j("caret return",Ne),Ne})}(ze,qe)}).join(" ")}(De,Ue),j("caret",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(ze){return function(Le,re){var de=re?I[F]:I[M];return Le.replace(de,function(pe,be,Se,Ie,Oe){var Ne;return j("tilde",Le,pe,be,Se,Ie,Oe),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Oe?(j("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+be+"."+Se+"."+Ie+Oe+" <"+be+"."+(+Se+1)+".0"):Ne=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",j("tilde return",Ne),Ne})}(ze,qe)}).join(" ")}(De,Ue),j("tildes",De),De=function(Te,qe){return j("replaceXRanges",Te,qe),Te.split(/\s+/).map(function(ze){return function(Le,re){Le=Le.trim();var de=re?I[C]:I[v];return Le.replace(de,function(pe,be,Se,Ie,Oe,Ne){j("xRange",Le,pe,be,Se,Ie,Oe,Ne);var Ve=$e(Se),Be=Ve||$e(Ie),Fe=Be||$e(Oe);return be==="="&&Fe&&(be=""),Ve?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Fe?(Be&&(Ie=0),Fe&&(Oe=0),be===">"?(be=">=",Be?(Se=+Se+1,Ie=0,Oe=0):Fe&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Be?Se=+Se+1:Ie=+Ie+1),pe=be+Se+"."+Ie+"."+Oe):Be?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Fe&&(pe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),j("xRange return",pe),pe})}(ze,qe)}).join(" ")}(De,Ue),j("xrange",De),De=function(Te,qe){return j("replaceStars",Te,qe),Te.trim().replace(I[oe],"")}(De,Ue),j("stars",De),De}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Pe)})),Re=Re.map(function(Me){return new ue(Me,me)})},fe.prototype.intersects=function(he,me){if(!(he instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Pe){return he.set.some(function(Re){return Re.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(he,me){return new fe(he,me).set.map(function(we){return we.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new G(he,this.loose));for(var me=0;me<this.set.length;me++)if(ve(this.set[me],he))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(he,me,we){var Pe=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return he.forEach(function(De){Me.test(De)&&(Pe&&Re.compare(De)!==-1||(Re=new G(Pe=De,we)))}),Pe},e.minSatisfying=function(he,me,we){var Pe=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return he.forEach(function(De){Me.test(De)&&(Pe&&Re.compare(De)!==1||(Re=new G(Pe=De,we)))}),Pe},e.validRange=function(he,me){try{return new fe(he,me).range||"*"}catch{return null}},e.ltr=function(he,me,we){return Ae(he,me,"<",we)},e.gtr=function(he,me,we){return Ae(he,me,">",we)},e.outside=Ae,e.prerelease=function(he,me){var we=ae(he,me);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(he,me,we){return he=new fe(he,we),me=new fe(me,we),he.intersects(me)},e.coerce=function(he){if(he instanceof G)return he;if(typeof he!="string")return null;var me=he.match(I[E]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,R(1))},function(ne,e){var R,N,j=ne.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(w){if(R===setTimeout)return setTimeout(w,0);if((R===L||!R)&&setTimeout)return R=setTimeout,setTimeout(w,0);try{return R(w,0)}catch{try{return R.call(null,w,0)}catch{return R.call(this,w,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:L}catch{R=L}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var P,$=[],S=!1,b=-1;function m(){S&&P&&(S=!1,P.length?$=P.concat($):b=-1,$.length&&f())}function f(){if(!S){var w=I(m);S=!0;for(var u=$.length;u;){for(P=$,$=[];++b<u;)P&&P[b].run();b=-1,u=$.length}P=null,S=!1,function(d){if(N===clearTimeout)return clearTimeout(d);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(d);try{N(d)}catch{try{return N.call(null,d)}catch{return N.call(this,d)}}}(w)}}function h(w,u){this.fun=w,this.array=u}function p(){}j.nextTick=function(w){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];$.push(new h(w,u)),$.length!==1||S||I(f)},h.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=p,j.addListener=p,j.once=p,j.off=p,j.removeListener=p,j.removeAllListeners=p,j.emit=p,j.prependListener=p,j.prependOnceListener=p,j.listeners=function(w){return[]},j.binding=function(w){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(w){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(ce[128],le([0,1]),function(ne,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class N{constructor(I,P,$){this.level=I,this.key=P,this.value=$,this.forward=[]}}const j=void 0;class L{constructor(I,P=2**16){this.comparator=I,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new N(this.c,j,j)}get size(){return this.f}clear(){this.e=new N(this.c,j,j),this.f=0}has(I){return!!L.g(this,I,this.comparator)}get(I){return L.g(this,I,this.comparator)?.value}set(I,P){return L.h(this,I,P,this.comparator)&&(this.f+=1),this}delete(I){const P=L.k(this,I,this.comparator);return P&&(this.f-=1),P}forEach(I,P){let $=this.e.forward[0];for(;$;)I.call(P,$.value,$.key,this),$=$.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this.e.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static g(I,P,$){let S=I.e;for(let b=I.d-1;b>=0;b--)for(;S.forward[b]&&$(S.forward[b].key,P)<0;)S=S.forward[b];if(S=S.forward[0],S&&$(S.key,P)===0)return S}static h(I,P,$,S){const b=[];let m=I.e;for(let f=I.d-1;f>=0;f--){for(;m.forward[f]&&S(m.forward[f].key,P)<0;)m=m.forward[f];b[f]=m}if(m=m.forward[0],m&&S(m.key,P)===0)return m.value=$,!1;{const f=L.j(I);if(f>I.d){for(let h=I.d;h<f;h++)b[h]=I.e;I.d=f}m=new N(f,P,$);for(let h=0;h<f;h++)m.forward[h]=b[h].forward[h],b[h].forward[h]=m;return!0}}static j(I,P=.5){let $=1;for(;Math.random()<P&&$<I.c;)$+=1;return $}static k(I,P,$){const S=[];let b=I.e;for(let m=I.d-1;m>=0;m--){for(;b.forward[m]&&$(b.forward[m].key,P)<0;)b=b.forward[m];S[m]=b}if(b=b.forward[0],!b||$(b.key,P)!==0)return!1;for(let m=0;m<I.d&&S[m].forward[m]===b;m++)S[m].forward[m]=b.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===j;)I.d-=1;return!0}}e.$qs=L}),define(ce[63],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=R&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ce[3],le([0,1,7,85,2,86,63]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=f;const I=!1,P=!1,$=!1;var S;(function(O){O.None=()=>j.$Uc.None;function M(fe){if($){const{onDidAddListener:$e}=fe,ye=p.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),$e?.()}}}function F(fe,$e){return oe(fe,()=>{},0,void 0,!0,void 0,$e)}O.defer=F;function U(fe){return($e,ye=null,ve)=>{let Ce=!1,Ae;return Ae=fe(he=>{if(!Ce)return Ae?Ae.dispose():Ce=!0,$e.call(ye,he)},null,ve),Ce&&Ae.dispose(),Ae}}O.once=U;function X(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(he=>ve.call(Ce,$e(he)),null,Ae),ye)}O.map=X;function H(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(he=>{$e(he),ve.call(Ce,he)},null,Ae),ye)}O.forEach=H;function Z(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(he=>$e(he)&&ve.call(Ce,he),null,Ae),ye)}O.filter=Z;function W(fe){return fe}O.signal=W;function J(...fe){return($e,ye=null,ve)=>{const Ce=(0,j.$Rc)(...fe.map(Ae=>Ae(he=>$e.call(ye,he))));return ie(Ce,ve)}}O.any=J;function V(fe,$e,ye,ve){let Ce=ye;return X(fe,Ae=>(Ce=$e(Ce,Ae),Ce),ve)}O.reduce=V;function B(fe,$e){let ye;const ve={onWillAddFirstListener(){ye=fe(Ce.fire,Ce)},onDidRemoveLastListener(){ye?.dispose()}};$e||M(ve);const Ce=new g(ve);return $e?.add(Ce),Ce.event}function ie(fe,$e){return $e instanceof Array?$e.push(fe):$e&&$e.add(fe),fe}function oe(fe,$e,ye=100,ve=!1,Ce=!1,Ae,he){let me,we,Pe,Re=0,Me;const De={leakWarningThreshold:Ae,onWillAddFirstListener(){me=fe(Te=>{Re++,we=$e(we,Te),ve&&!Pe&&(Ue.fire(we),we=void 0),Me=()=>{const qe=we;we=void 0,Pe=void 0,(!ve||Re>1)&&Ue.fire(qe),Re=0},typeof ye=="number"?(clearTimeout(Pe),Pe=setTimeout(Me,ye)):Pe===void 0&&(Pe=0,queueMicrotask(Me))})},onWillRemoveListener(){Ce&&Re>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,me.dispose()}};he||M(De);const Ue=new g(De);return he?.add(Ue),Ue.event}O.debounce=oe;function te(fe,$e=0,ye){return O.debounce(fe,(ve,Ce)=>ve?(ve.push(Ce),ve):[Ce],$e,void 0,!0,void 0,ye)}O.accumulate=te;function ae(fe,$e=(ve,Ce)=>ve===Ce,ye){let ve=!0,Ce;return Z(fe,Ae=>{const he=ve||!$e(Ae,Ce);return ve=!1,Ce=Ae,he},ye)}O.latch=ae;function G(fe,$e,ye){return[O.filter(fe,$e,ye),O.filter(fe,ve=>!$e(ve),ye)]}O.split=G;function q(fe,$e=!1,ye=[],ve){let Ce=ye.slice(),Ae=fe(we=>{Ce?Ce.push(we):me.fire(we)});ve&&ve.add(Ae);const he=()=>{Ce?.forEach(we=>me.fire(we)),Ce=null},me=new g({onWillAddFirstListener(){Ae||(Ae=fe(we=>me.fire(we)),ve&&ve.add(Ae))},onDidAddFirstListener(){Ce&&($e?setTimeout(he):he())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ve&&ve.add(me),me.event}O.buffer=q;function D(fe,$e){return(ve,Ce,Ae)=>{const he=$e(new z);return fe(function(me){const we=he.evaluate(me);we!==T&&ve.call(Ce,we)},void 0,Ae)}}O.chain=D;const T=Symbol("HaltChainable");class z{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ye=>($e(ye),ye)),this}filter($e){return this.f.push(ye=>$e(ye)?ye:T),this}reduce($e,ye){let ve=ye;return this.f.push(Ce=>(ve=$e(ve,Ce),ve)),this}latch($e=(ye,ve)=>ye===ve){let ye=!0,ve;return this.f.push(Ce=>{const Ae=ye||!$e(Ce,ve);return ye=!1,ve=Ce,Ae?Ce:T}),this}evaluate($e){for(const ye of this.f)if($e=ye($e),$e===T)break;return $e}}function x(fe,$e,ye=ve=>ve){const ve=(...me)=>he.fire(ye(...me)),Ce=()=>fe.on($e,ve),Ae=()=>fe.removeListener($e,ve),he=new g({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return he.event}O.fromNodeEventEmitter=x;function K(fe,$e,ye=ve=>ve){const ve=(...me)=>he.fire(ye(...me)),Ce=()=>fe.addEventListener($e,ve),Ae=()=>fe.removeEventListener($e,ve),he=new g({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return he.event}O.fromDOMEventEmitter=K;function ee(fe){return new Promise($e=>U(fe)($e))}O.toPromise=ee;function _(fe){const $e=new g;return fe.then(ye=>{$e.fire(ye)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}O.fromPromise=_;function Y(fe,$e,ye){return $e(ye),fe(ve=>$e(ve))}O.runAndSubscribe=Y;class se{constructor($e,ye){this._observable=$e,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ye||M(ve),this.emitter=new g(ve),ye&&ye.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ye){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(fe,$e){return new se(fe,$e).emitter.event}O.fromObservable=ue;function ge(fe){return($e,ye,ve)=>{let Ce=0,Ae=!1;const he={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(fe.reportChanges(),Ae&&(Ae=!1,$e.call(ye)))},handlePossibleChange(){},handleChange(){Ae=!0}};fe.addObserver(he),fe.reportChanges();const me={dispose(){fe.removeObserver(he)}};return ve instanceof j.$Tc?ve.add(me):Array.isArray(ve)&&ve.push(me),me}}O.fromObservableLight=ge})(S||(e.Event=S={}));class b{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${b.f++}`,b.all.add(this)}start(M){this.g=new A.$0d,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$_d=b;let m=-1;function f(O){const M=m;return m=O,{dispose(){m=M}}}class h{constructor(M,F=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=F,this.g=0}dispose(){this.f?.clear()}check(M,F){const U=this.threshold;if(U<=0||F<U)return;this.f||(this.f=new Map);const X=this.f.get(M.value)||0;if(this.f.set(M.value,X+1),this.g-=1,this.g<=0){this.g=U*.5;let H,Z=0;for(const[W,J]of this.f)(!H||Z<J)&&(H=W,Z=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${Z}):`),console.warn(H)}return()=>{const H=this.f.get(M.value)||0;this.f.set(M.value,H-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(M){this.value=M,this.id=w++}}const d=2,l=(O,M)=>{if(O instanceof u)M(O);else for(let F=0;F<O.length;F++){const U=O[F];U&&M(U)}},c=I?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class g{constructor(M){this.w=0,this.f=M,this.g=m>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const M=this.t;queueMicrotask(()=>{l(M,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,F,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Uc.None;if(this.m)return j.$Uc.None;F&&(M=M.bind(F));const X=new u(M);let H,Z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=p.create(),H=this.g.check(X.stack,this.w+1)),P&&(X.stack=Z??p.create()),this.t?this.t instanceof u?(this.u??=new o,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,j.$Sc)(()=>{c?.unregister(W),H?.(),this.x(X)});if(U instanceof j.$Tc?U.add(W):Array.isArray(U)&&U.push(W),c){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(W,J,W)}return W},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,U=F.indexOf(M);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[U]=void 0;const X=this.u.current===this;if(this.w*d<=F.length){let H=0;for(let Z=0;Z<F.length;Z++)F[Z]?F[H++]=F[Z]:X&&(this.u.end--,H<this.u.i&&this.u.i--);F.length=H}}y(M,F){if(!M)return;const U=this.f?.onListenerError||R.$1;if(!U){M.value(F);return}try{M.value(F)}catch(X){U(X)}}z(M){const F=M.current.t;for(;M.i<M.end;)this.y(F[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,M);else{const F=this.u;F.enqueue(this,M,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=g;const i=()=>new o;e.$ce=i;class o{constructor(){this.i=-1,this.end=0}enqueue(M,F,U){this.i=0,this.end=U,this.current=M,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends g{async fireAsync(M,F,U){if(this.t)for(this.h||(this.h=new L.$5c),l(this.t,X=>this.h.push([X.value,M]));this.h.size>0&&!F.isCancellationRequested;){const[X,H]=this.h.shift(),Z=[],W={...H,token:F,waitUntil:J=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");U&&(J=U(J,X)),Z.push(J)}};try{X(W)}catch(J){(0,R.$1)(J);continue}Object.freeze(Z),await Promise.allSettled(Z).then(J=>{for(const V of J)V.status==="rejected"&&(0,R.$1)(V.reason)})}}}e.$de=n;class s extends g{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new L.$5c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$ee=s;class t extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$fe=t;class r extends g{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$ge=r;class a{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const F={event:M,listener:null};this.h.push(F),this.g&&this.m(F);const U=()=>{this.g&&this.o(F);const X=this.h.indexOf(F);this.h.splice(X,1)};return(0,j.$Sc)((0,N.$db)(U))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(F=>this.f.fire(F))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$he=a;class y{constructor(M,F,U,X){this.f=new j.$Tc;const H=this.f.add(new a),Z=this.f.add(new j.$4c);function W(J){Z.set(J,H.add(X(J)))}for(const J of M)W(J);this.f.add(F(J=>{W(J)})),this.f.add(U(J=>{Z.deleteAndDispose(J)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ie=y;class v{constructor(){this.f=[]}wrapEvent(M){return(F,U,X)=>M(H=>{const Z=this.f[this.f.length-1];Z?Z.push(()=>F.call(U,H)):F.call(U,H)},void 0,X)}bufferEvents(M){const F=[];this.f.push(F);const U=M();return this.f.pop(),F.forEach(X=>X()),U}}e.$je=v;class C{constructor(){this.f=!1,this.g=S.None,this.h=j.$Uc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=C;class E{static const(M){return new k(M)}constructor(M){this.g=M,this.f=new g,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$le=E;class k{constructor(M){this.value=M,this.onDidChange=S.None}}}),define(ce[26],le([0,1,3]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(I,P){const $=setTimeout(I.bind(P),0);return{dispose(){clearTimeout($)}}});var j;(function(I){function P($){return $===I.None||$===I.Cancelled||$ instanceof L?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}I.isCancellationToken=P,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(j||(e.CancellationToken=j={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new R.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=j.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=j.None}}e.$me=A}),define(ce[129],le([0,1,26]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class N{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new R.$me,P=this.b(I.token);return this.a={promise:P,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$Xe=N;class j{constructor(I,P=JSON.stringify){this.c=I,this.d=P,this.a=void 0,this.b=void 0}get(I){const P=this.d(I);return this.b!==P&&(this.b=P,this.a=this.c(I)),this.a}}e.$Ye=j;class L{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const P=this.b(I);return this.a.set(I,P),P}}e.$Ze=L}),define(ce[50],le([0,1,7,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=j,e.$oe=L,e.$pe=A,e.$qe=I,e.$re=$,e.$se=S,e.$te=b,e.$ue=m,e.$ve=f,e.$we=h,e.$xe=p,e.$ye=w,e.$ze=u,e.$Ae=d,e.$Be=l;function j(c){const g=c;return g?typeof g.read=="function":!1}function L(c){const g=c;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function A(c){const g=c;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function I(c,g){return new P(c,g)}class P{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,R.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let o;switch(g){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(c,g){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return g(i)}function S(c,g,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function b(c,g){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{g&&n.push(s)},onError:s=>{g?o(s):i(void 0)},onEnd:()=>{i(g?g(n):void 0)}})})}function m(c,g,i){c.on("error",o=>{i?.isCancellationRequested||g.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||g.onData(o)})}function f(c,g){return new Promise((i,o)=>{const n=new N.$Tc,s=[],t=y=>{if(s.push(y),s.length>g)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=y=>(n.dispose(),o(y)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,N.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,N.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function h(c,g){const i=I(g);return i.end(c),i}function p(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}function w(c){let g=!1;return{read:()=>g?null:(g=!0,c)}}function u(c,g,i){const o=I(i);return m(c,{onData:n=>o.write(g.data(n)),onError:n=>o.error(g.error?g.error(n):n),onEnd:()=>o.end()}),o}function d(c,g,i){let o=!1;return{read:()=>{const n=g.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function l(c,g,i){let o=!1;const n=I(i);return m(g,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(ce[15],le([0,1,53,50]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=$,e.$Ee=S,e.$Fe=b,e.$Ge=m,e.$He=f,e.$Ie=h,e.$Je=p,e.$Ke=w,e.$Le=u,e.$Me=d,e.$Ne=l,e.$Oe=c,e.$Pe=g,e.$Qe=i,e.$Re=o,e.$Se=n,e.$Te=s,e.$Ue=t,e.$Ve=r,e.$We=v;const j=typeof Buffer<"u",L=new R.$V(()=>new Uint8Array(256));let A,I;class P{static alloc(E){return j?new P(Buffer.allocUnsafe(E)):new P(new Uint8Array(E))}static wrap(E){return j&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new P(E)}static fromString(E,k){return!(k?.dontUseNodeBuffer||!1)&&j?new P(Buffer.from(E)):(A||(A=new TextEncoder),new P(A.encode(E)))}static fromByteArray(E){const k=P.alloc(E.length);for(let O=0,M=E.length;O<M;O++)k.buffer[O]=E[O];return k}static concat(E,k){if(typeof k>"u"){k=0;for(let F=0,U=E.length;F<U;F++)k+=E[F].byteLength}const O=P.alloc(k);let M=0;for(let F=0,U=E.length;F<U;F++){const X=E[F];O.set(X,M),M+=X.byteLength}return O}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=P.alloc(this.byteLength);return E.set(this),E}toString(){return j?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(E,k){return new P(this.buffer.subarray(E,k))}set(E,k){if(E instanceof P)this.buffer.set(E.buffer,k);else if(E instanceof Uint8Array)this.buffer.set(E,k);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),k);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,k){f(this.buffer,E,k)}readUInt32LE(E){return h(this.buffer,E)}writeUInt32LE(E,k){p(this.buffer,E,k)}readUInt8(E){return w(this.buffer,E)}writeUInt8(E,k){u(this.buffer,E,k)}indexOf(E,k=0){return $(this.buffer,E instanceof P?E.buffer:E,k)}}e.$Ce=P;function $(C,E,k=0){const O=E.byteLength,M=C.byteLength;if(O===0)return 0;if(O===1)return C.indexOf(E[0]);if(O>M-k)return-1;const F=L.value;F.fill(E.length);for(let Z=0;Z<E.length;Z++)F[E[Z]]=E.length-Z-1;let U=k+E.length-1,X=U,H=-1;for(;U<M;)if(C[U]===E[X]){if(X===0){H=U;break}U--,X--}else U+=Math.max(E.length-X,F[C[U]]),X=E.length-1;return H}function S(C,E){return C[E+0]<<0>>>0|C[E+1]<<8>>>0}function b(C,E,k){C[k+0]=E&255,E=E>>>8,C[k+1]=E&255}function m(C,E){return C[E]*2**24+C[E+1]*2**16+C[E+2]*2**8+C[E+3]}function f(C,E,k){C[k+3]=E,E=E>>>8,C[k+2]=E,E=E>>>8,C[k+1]=E,E=E>>>8,C[k]=E}function h(C,E){return C[E+0]<<0>>>0|C[E+1]<<8>>>0|C[E+2]<<16>>>0|C[E+3]<<24>>>0}function p(C,E,k){C[k+0]=E&255,E=E>>>8,C[k+1]=E&255,E=E>>>8,C[k+2]=E&255,E=E>>>8,C[k+3]=E&255}function w(C,E){return C[E]}function u(C,E,k){C[k]=E}function d(C){return N.$re(C,E=>P.concat(E))}function l(C){return N.$ye(C)}function c(C){return N.$te(C,E=>P.concat(E))}async function g(C){return C.ended?P.concat(C.buffer):P.concat([...C.buffer,await c(C.stream)])}function i(C){return N.$we(C,E=>P.concat(E))}function o(C){return N.$ze(C,{data:E=>typeof E=="string"?P.fromString(E):P.wrap(E)},E=>P.concat(E))}function n(C){return N.$qe(E=>P.concat(E),C)}function s(C,E){return N.$Ae(C,E,k=>P.concat(k))}function t(C,E){return N.$Be(C,E,k=>P.concat(k))}function r(C){let E=0,k=0,O=0;const M=new Uint8Array(Math.floor(C.length/4*3)),F=X=>{switch(k){case 3:M[O++]=E|X,k=0;break;case 2:M[O++]=E|X>>>2,E=X<<6,k=3;break;case 1:M[O++]=E|X>>>4,E=X<<4,k=2;break;default:E=X<<2,k=1}};for(let X=0;X<C.length;X++){const H=C.charCodeAt(X);if(H>=65&&H<=90)F(H-65);else if(H>=97&&H<=122)F(H-97+26);else if(H>=48&&H<=57)F(H-48+52);else if(H===43||H===45)F(62);else if(H===47||H===95)F(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${C[X]}`)}}const U=O;for(;k>0;)F(0);return P.wrap(M).slice(0,U)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:C},E=!0,k=!1){const O=k?y:a;let M="";const F=C.byteLength%3;let U=0;for(;U<C.byteLength-F;U+=3){const X=C[U+0],H=C[U+1],Z=C[U+2];M+=O[X>>>2],M+=O[(X<<4|H>>>4)&63],M+=O[(H<<2|Z>>>6)&63],M+=O[Z&63]}if(F===1){const X=C[U+0];M+=O[X>>>2],M+=O[X<<4&63],E&&(M+="==")}else if(F===2){const X=C[U+0],H=C[U+1];M+=O[X>>>2],M+=O[(X<<4|H>>>4)&63],M+=O[H<<2&63],E&&(M+="=")}return M}}),define(ce[27],le([0,1,129,53]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=j,e.$4e=A,e.$5e=P,e.$6e=$,e.$7e=S,e.$8e=b,e.$9e=m,e.$0e=f,e.$$e=h,e.$_e=p,e.$af=w,e.$bf=u,e.$cf=d,e.$df=l,e.$ef=c,e.$ff=g,e.$gf=i,e.$hf=o,e.$if=n,e.$jf=s,e.$kf=t,e.$lf=r,e.$mf=a,e.$nf=y,e.$of=v,e.$pf=C,e.$qf=E,e.$rf=k,e.$sf=O,e.$tf=M,e.$uf=F,e.$vf=U,e.$wf=X,e.$xf=H,e.$yf=Z,e.$zf=W,e.$Af=J,e.$Df=oe,e.$Ef=te,e.$Ff=ae,e.$Gf=G,e.$Hf=T,e.$If=x,e.$Kf=K,e.$Lf=ee,e.$Mf=_,e.$Nf=Y,e.$Of=ue,e.$Pf=ge,e.$Rf=fe,e.$Sf=$e,e.$Tf=ye,e.$Uf=ve,e.$Vf=Ce,e.$Wf=Ae,e.$Xf=he,e.$Yf=me,e.$Zf=De;function j(re){return!re||typeof re!="string"?!0:re.trim().length===0}const L=/{(\d+)}/g;function A(re,...de){return de.length===0?re:re.replace(L,function(pe,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=de.length?pe:de[Se]})}const I=/{([^}]+)}/g;function P(re,de){return Object.keys(de).length===0?re:re.replace(I,(pe,be)=>de[be]??pe)}function $(re){return re.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function S(re){return re.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function b(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(re,de){let pe=0;const be=de.charCodeAt(0);for(let Se=re.length-1;Se>=0;Se--)re.charCodeAt(Se)===be&&pe++;return pe}function f(re,de,pe="\u2026"){return re.length<=de?re:`${re.substr(0,de)}${pe}`}function h(re,de,pe="\u2026"){if(re.length<=de)return re;const be=Math.ceil(de/2)-pe.length/2,Se=Math.floor(de/2)-pe.length/2;return`${re.substr(0,be)}${pe}${re.substr(re.length-Se)}`}function p(re,de=" "){const pe=w(re,de);return u(pe,de)}function w(re,de){if(!re||!de)return re;const pe=de.length;if(pe===0||re.length===0)return re;let be=0;for(;re.indexOf(de,be)===be;)be=be+pe;return re.substring(be)}function u(re,de){if(!re||!de)return re;const pe=de.length,be=re.length;if(pe===0||be===0)return re;let Se=be,Ie=-1;for(;Ie=re.lastIndexOf(de,Se-1),!(Ie===-1||Ie+pe!==Se);){if(Ie===0)return"";Se=Ie}return re.substring(0,Se)}function d(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(re){return re.replace(/\*/g,"")}function c(re,de,pe={}){if(!re)throw new Error("Cannot create regex from empty string");de||(re=b(re)),pe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(re,be)}function g(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function i(re){return re.split(/\r\n|\r|\n/)}function o(re){const de=[],pe=re.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)de.push(pe[2*be]+(pe[2*be+1]??""));return de}function n(re){for(let de=0,pe=re.length;de<pe;de++){const be=re.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function s(re,de=0,pe=re.length){for(let be=de;be<pe;be++){const Se=re.charCodeAt(be);if(Se!==32&&Se!==9)return re.substring(de,be)}return re.substring(de,pe)}function t(re,de=re.length-1){for(let pe=de;pe>=0;pe--){const be=re.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function r(re,de,pe){const be=[];let Se=0;for(const Ie of re.matchAll(de)){if(be.push(re.slice(Se,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");Se=Ie.index+Ie[0].length,be.push(pe(Ie[0],...Ie.slice(1),Ie.index,re,Ie.groups))}return be.push(re.slice(Se)),Promise.all(be).then(Ie=>Ie.join(""))}function a(re,de){return re<de?-1:re>de?1:0}function y(re,de,pe=0,be=re.length,Se=0,Ie=de.length){for(;pe<be&&Se<Ie;pe++,Se++){const Ve=re.charCodeAt(pe),Be=de.charCodeAt(Se);if(Ve<Be)return-1;if(Ve>Be)return 1}const Oe=be-pe,Ne=Ie-Se;return Oe<Ne?-1:Oe>Ne?1:0}function v(re,de){return C(re,de,0,re.length,0,de.length)}function C(re,de,pe=0,be=re.length,Se=0,Ie=de.length){for(;pe<be&&Se<Ie;pe++,Se++){let Ve=re.charCodeAt(pe),Be=de.charCodeAt(Se);if(Ve===Be)continue;if(Ve>=128||Be>=128)return y(re.toLowerCase(),de.toLowerCase(),pe,be,Se,Ie);k(Ve)&&(Ve-=32),k(Be)&&(Be-=32);const Fe=Ve-Be;if(Fe!==0)return Fe}const Oe=be-pe,Ne=Ie-Se;return Oe<Ne?-1:Oe>Ne?1:0}function E(re){return re>=48&&re<=57}function k(re){return re>=97&&re<=122}function O(re){return re>=65&&re<=90}function M(re,de){return re.length===de.length&&C(re,de)===0}function F(re,de){const pe=de.length;return de.length>re.length?!1:C(re,de,0,pe)===0}function U(re,de){const pe=Math.min(re.length,de.length);let be;for(be=0;be<pe;be++)if(re.charCodeAt(be)!==de.charCodeAt(be))return be;return pe}function X(re,de){const pe=Math.min(re.length,de.length);let be;const Se=re.length-1,Ie=de.length-1;for(be=0;be<pe;be++)if(re.charCodeAt(Se-be)!==de.charCodeAt(Ie-be))return be;return pe}function H(re){return 55296<=re&&re<=56319}function Z(re){return 56320<=re&&re<=57343}function W(re,de){return(re-55296<<10)+(de-56320)+65536}function J(re,de,pe){const be=re.charCodeAt(pe);if(H(be)&&pe+1<de){const Se=re.charCodeAt(pe+1);if(Z(Se))return W(be,Se)}return be}function V(re,de){const pe=re.charCodeAt(de-1);if(Z(pe)&&de>1){const be=re.charCodeAt(de-2);if(H(be))return W(be,pe)}return pe}class B{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=V(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Bf=B;class ie{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new B(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ie=pe.offset,Oe=de.getGraphemeBreakType(pe.nextCodePoint());if(we(Se,Oe)){pe.setOffset(Ie);break}Se=Oe}return pe.offset-be}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ie=pe.offset,Oe=de.getGraphemeBreakType(pe.prevCodePoint());if(we(Oe,Se)){pe.setOffset(Ie);break}Se=Oe}return be-pe.offset}eol(){return this.c.eol()}}e.$Cf=ie;function oe(re,de){return new ie(re,de).nextGraphemeLength()}function te(re,de){return new ie(re,de).prevGraphemeLength()}function ae(re,de){de>0&&Z(re.charCodeAt(de))&&de--;const pe=de+oe(re,de);return[pe-te(re,pe),pe]}function G(re){const de=new ie(re);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let q;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(re){return q||(q=D()),q.test(re)}const z=/^[\t\n\r\x20-\x7E]*$/;function x(re){return z.test(re)}e.$Jf=/[\u2028\u2029]/;function K(re){return e.$Jf.test(re)}function ee(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function _(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function Y(re,de,pe=""){const be=re.trimStart();if(be.length<de)return be;const Se=/\b/g;let Ie=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<de);)Ie=Se.lastIndex,Se.lastIndex+=1;return Ie===0?be:pe+be.substring(Ie).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(re){let de=0;for(const pe of re.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:re.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==re.length&&(yield{isCode:!1,str:re.substring(de)})}function ge(re){return re&&(re=re.replace(se,"")),re}e.$Qf="\uFEFF";function fe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}function $e(re){return fe(re)?re.substr(1):re}function ye(re,de){if(!re||!de||re.length<de.length)return!1;const pe=de.length,be=re.toLowerCase();let Se=0,Ie=-1;for(;Se<pe;){const Oe=be.indexOf(de[Se],Ie+1);if(Oe<0)return!1;Ie=Oe,Se++}return!0}function ve(re,de=!1){return re?(de&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function Ce(re){return re.charAt(0).toUpperCase()+re.slice(1)}function Ae(re,de=1){if(de===0)return"";let pe=-1;do pe=re.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?re:(re[pe-1]==="\r"&&pe--,re.substr(0,pe))}function he(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}function me(re){return Re.getInstance().getGraphemeBreakType(re)}function we(re,de){return re===0?de!==5&&de!==7:re===2&&de===3?!1:re===4||re===2||re===3||de===4||de===2||de===3?!0:!(re===8&&(de===8||de===9||de===11||de===12)||(re===11||re===9)&&(de===9||de===10)||(re===12||re===10)&&de===10||de===5||de===13||de===7||re===1||re===13&&de===14||re===6&&de===6)}var Pe;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Me()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,be=pe.length/3;let Se=1;for(;Se<=be;)if(de<pe[3*Se])Se=2*Se;else if(de>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(re,de){if(re===0)return 0;const pe=Ue(re,de);if(pe!==void 0)return pe;const be=new B(de,re);return be.prevCodePoint(),be.offset}function Ue(re,de){const pe=new B(de,re);let be=pe.prevCodePoint();for(;Te(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Te(re){return 127995<=re&&re<=127999}var qe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$1f="\xA0";class ze{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$Ye(de=>{function pe(Fe){const Xe=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Xe.set(Fe[Ge],Fe[Ge+1]);return Xe}function be(Fe,Xe){const Ge=new Map(Fe);for(const[_e,tt]of Xe)Ge.set(_e,tt);return Ge}function Se(Fe,Xe){if(!Fe)return Xe;const Ge=new Map;for(const[_e,tt]of Fe)Xe.has(_e)&&Ge.set(_e,tt);return Ge}const Ie=this.c.value;let Oe=de.filter(Fe=>!Fe.startsWith("_")&&Fe in Ie);Oe.length===0&&(Oe=["_default"]);let Ne;for(const Fe of Oe){const Xe=pe(Ie[Fe]);Ne=Se(Ne,Xe)}const Ve=pe(Ie._common),Be=be(Ve,Ne);return new ze(Be)})}static getInstance(de){return ze.d.get(Array.from(de))}static{this.e=new N.$V(()=>Object.keys(ze.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return ze.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=ze;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter(de){return Le.e().has(de)}static get codePoints(){return Le.e()}}e.$3f=Le}),define(ce[54],le([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=N,e.$fj=j,e.$gj=L,e.$hj=I,e.$jj=p;function N(u){return j(u,0)}function j(u,d){switch(typeof u){case"object":return u===null?L(349,d):Array.isArray(u)?P(u,d):$(u,d);case"string":return I(u,d);case"boolean":return A(u,d);case"number":return L(u,d);case"undefined":return L(937,d);default:return L(617,d)}}function L(u,d){return(d<<5)-d+u|0}function A(u,d){return L(u?433:863,d)}function I(u,d){d=L(149417,d);for(let l=0,c=u.length;l<c;l++)d=L(u.charCodeAt(l),d);return d}function P(u,d){return d=L(104579,d),u.reduce((l,c)=>j(c,l),d)}function $(u,d){return d=L(181387,d),Object.keys(u).sort().reduce((l,c)=>(l=I(c,l),j(u[c],l)),d)}class S{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=j(d,this.g),this.g}}e.$ij=S;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(u,d,l=32){const c=l-d,g=~((1<<c)-1);return(u<<d|(g&u)>>>c)>>>0}function f(u,d=0,l=u.byteLength,c=0){for(let g=0;g<l;g++)u[d+g]=c}function h(u,d,l="0"){for(;u.length<d;)u=l+u;return u}function p(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((u>>>0).toString(16),d/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const l=d.length;if(l===0)return;const c=this.p;let g=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(R.$xf(o))if(n+1<l){const t=d.charCodeAt(n+1);R.$yf(t)?(n++,s=R.$zf(o,t)):s=65533}else{i=o;break}else R.$yf(o)&&(s=65533);if(g=this.w(c,g,s),n++,n<l)o=d.charCodeAt(n);else break}this.r=g,this.u=i}w(d,l,c){return c<128?d[l++]=c:c<2048?(d[l++]=192|(c&1984)>>>6,d[l++]=128|(c&63)>>>0):c<65536?(d[l++]=224|(c&61440)>>>12,d[l++]=128|(c&4032)>>>6,d[l++]=128|(c&63)>>>0):(d[l++]=240|(c&1835008)>>>18,d[l++]=128|(c&258048)>>>12,d[l++]=128|(c&4032)>>>6,d[l++]=128|(c&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=w.g,l=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,m(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this.h,g=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=g&i|~g&o,t=1518500249):a<40?(s=g^i^o,t=1859775393):a<60?(s=g&i|g&o|i&o,t=2400959708):(s=g^i^o,t=3395469782),r=m(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(g,30),g=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$kj=w}),define(ce[88],le([0,1,27]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(N||(N={})),function(j){const L="error",A="warning",I="warn",P="info",$="ignore";function S(m){return m?R.$tf(L,m)?j.Error:R.$tf(A,m)||R.$tf(I,m)?j.Warning:R.$tf(P,m)?j.Info:j.Ignore:j.Ignore}j.fromValue=S;function b(m){switch(m){case j.Error:return L;case j.Warning:return A;case j.Info:return P;default:return $}}j.toString=b}(N||(N={})),e.default=N}),define(ce[130],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ce[51],le([0,1,17,27]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class j{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const h=f.charCodeAt(0),p=this.b.charCodeAt(this.c);return h-p}value(){return this.b[this.c]}}e.$si=j;class L{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$nf)(f,this.b,0,f.length,this.c,this.d):(0,N.$pf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=L;class A{constructor(f=!0,h=!0){this.f=f,this.g=h}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let h=f.length-1;h>=0;h--,this.c--){const p=this.b.charCodeAt(h);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$nf)(f,this.b,0,f.length,this.d,this.e):(0,N.$pf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=A;var I;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(f,h){this.f=f,this.g=h,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$of)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$mf)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=P;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(S||(S={}));class b{static forUris(f=()=>!1,h=()=>!1){return new b(new P(f,h))}static forPaths(f=!1){return new b(new A(void 0,!f))}static forStrings(){return new b(new j)}static forConfigKeys(){return new b(new L)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,h){if(h){const p=h.slice(0);(0,R.$Xb)(p);for(const w of p)this.set(w,f)}else{const p=f.slice(0);(0,R.$Xb)(p);for(const w of p)this.set(w[0],w[1])}}set(f,h){const p=this.b.reset(f);let w;this.c||(this.c=new $,this.c.segment=p.value());const u=[];for(w=this.c;;){const l=p.cmp(w.segment);if(l>0)w.left||(w.left=new $,w.left.segment=p.value()),u.push([-1,w]),w=w.left;else if(l<0)w.right||(w.right=new $,w.right.segment=p.value()),u.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new $,w.mid.segment=p.value()),u.push([0,w]),w=w.mid;else break}const d=w.value;w.value=h,w.key=f;for(let l=u.length-1;l>=0;l--){const c=u[l][1];c.updateHeight();const g=c.balanceFactor();if(g<-1||g>1){const i=u[l][0],o=u[l+1][0];if(i===1&&o===1)u[l][1]=c.rotateLeft();else if(i===-1&&o===-1)u[l][1]=c.rotateRight();else if(i===1&&o===-1)c.right=u[l+1][1]=u[l+1][1].rotateRight(),u[l][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=u[l+1][1]=u[l+1][1].rotateLeft(),u[l][1]=c.rotateRight();else throw new Error;if(l>0)switch(u[l-1][0]){case-1:u[l-1][1].left=u[l][1];break;case 1:u[l-1][1].right=u[l][1];break;case 0:u[l-1][1].mid=u[l][1];break}else this.c=u[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const h=this.b.reset(f);let p=this.c;for(;p;){const w=h.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(h.hasNext())h.next(),p=p.mid;else break}return p}has(f){const h=this.d(f);return!(h?.value===void 0&&h?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,h){const p=this.b.reset(f),w=[];let u=this.c;for(;u;){const d=p.cmp(u.segment);if(d>0)w.push([-1,u]),u=u.left;else if(d<0)w.push([1,u]),u=u.right;else if(p.hasNext())p.next(),w.push([0,u]),u=u.mid;else break}if(u){if(h?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:l,value:c,segment:g}=d;this.e(d.key,!1),u.key=l,u.value=c,u.segment=g}}else{const d=u.left??u.right;if(w.length>0){const[l,c]=w[w.length-1];switch(l){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this.c=d}for(let d=w.length-1;d>=0;d--){const l=w[d][1];l.updateHeight();const c=l.balanceFactor();if(c>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),w[d][1]=l.rotateLeft()):c<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),w[d][1]=l.rotateRight()),d>0)switch(w[d-1][0]){case-1:w[d-1][1].left=w[d][1];break;case 1:w[d-1][1].right=w[d][1];break;case 0:w[d-1][1].mid=w[d][1];break}else this.c=w[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const h=this.b.reset(f);let p=this.c,w;for(;p;){const u=h.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(h.hasNext())h.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(f){return this.g(f,!1)}g(f,h){const p=this.b.reset(f);let w=this.c;for(;w;){const u=p.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):h?w.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[h,p]of this)f(p,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const h=[];return this.j(f,h),h[Symbol.iterator]()}j(f,h){f&&(f.left&&this.j(f.left,h),f.value&&h.push([f.key,f.value]),f.mid&&this.j(f.mid,h),f.right&&this.j(f.right,h))}_isBalanced(){const f=h=>{if(!h)return!0;const p=h.balanceFactor();return p<-1||p>1?!1:f(h.left)&&f(h.right)};return f(this.c)}}e.$wi=b}),define(ce[13],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=R,e.$5f=N,e.$6f=j,e.$7f=L,e.$8f=A,e.$9f=I,e.$0f=P,e.$$f=$,e.$_f=S,e.$ag=b,e.$bg=m,e.$cg=f,e.$dg=h,e.$eg=w,e.$fg=u,e.$gg=d,e.$hg=l,e.$ig=c;function R(g){return typeof g=="string"}function N(g){return Array.isArray(g)&&g.every(i=>R(i))}function j(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}function L(g){const i=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof i}function A(g){return typeof g=="number"&&!isNaN(g)}function I(g){return!!g&&typeof g[Symbol.iterator]=="function"}function P(g){return g===!0||g===!1}function $(g){return typeof g>"u"}function S(g){return!b(g)}function b(g){return $(g)||g===null}function m(g,i){if(!g)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(g){if(b(g))throw new Error("Assertion Failed: argument is undefined or null");return g}function h(...g){const i=[];for(let o=0;o<g.length;o++){const n=g[o];if(b(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const p=Object.prototype.hasOwnProperty;function w(g){if(!j(g))return!1;for(const i in g)if(p.call(g,i))return!1;return!0}function u(g){return typeof g=="function"}function d(...g){return g.length>0&&g.every(u)}function l(g,i){const o=Math.min(g.length,i.length);for(let n=0;n<o;n++)c(g[n],i[n])}function c(g,i){if(R(i)){if(typeof g!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(g instanceof i)return}catch{}if(!b(g)&&g.constructor===i||i.length===1&&i.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[30],le([0,1,13]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=N,e.$Xn=j,e.$Yn=A,e.$Zn=P,e.$1n=$,e.$2n=S,e.$3n=b,e.$4n=m,e.$5n=f,e.$6n=h,e.$7n=p,e.$8n=w;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([l,c])=>{d[l]=c&&typeof c=="object"?N(c):c}),d}function j(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const l=d.shift();Object.freeze(l);for(const c in l)if(L.call(l,c)){const g=l[c];typeof g=="object"&&!Object.isFrozen(g)&&!(0,R.$7f)(g)&&d.push(g)}}return u}const L=Object.prototype.hasOwnProperty;function A(u,d){return I(u,d,new Set)}function I(u,d,l){if((0,R.$ag)(u))return u;const c=d(u);if(typeof c<"u")return c;if(Array.isArray(u)){const g=[];for(const i of u)g.push(I(i,d,l));return g}if((0,R.$6f)(u)){if(l.has(u))throw new Error("Cannot clone recursive data-structure");l.add(u);const g={};for(const i in u)L.call(u,i)&&(g[i]=I(u[i],d,l));return l.delete(u),g}return u}function P(u,d,l=!0){return(0,R.$6f)(u)?((0,R.$6f)(d)&&Object.keys(d).forEach(c=>{c in u?l&&((0,R.$6f)(u[c])&&(0,R.$6f)(d[c])?P(u[c],d[c],l):u[c]=d[c]):u[c]=d[c]}),u):d}function $(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let l,c;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(l=0;l<u.length;l++)if(!$(u[l],d[l]))return!1}else{const g=[];for(c in u)g.push(c);g.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!$(g,i))return!1;for(l=0;l<g.length;l++)if(!$(u[g[l]],d[g[l]]))return!1}return!0}function S(u){const d=new Set;return JSON.stringify(u,(l,c)=>{if((0,R.$6f)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function b(u,d){const l=Object.create(null);return!u||!d||Object.keys(d).forEach(g=>{const i=u[g],o=d[g];$(i,o)||(l[g]=o)}),l}function m(u,d){const l=d.toLowerCase(),c=Object.keys(u).find(g=>g.toLowerCase()===l);return c?u[c]:u[d]}function f(u,d){const l=Object.create(null);for(const[c,g]of Object.entries(u))d(c,g)&&(l[c]=g);return l}function h(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}function p(u){const d=[];for(const l of h(u))typeof u[l]=="function"&&d.push(l);return d}function w(u,d){const l=g=>function(){const i=Array.prototype.slice.call(arguments,0);return d(g,i)},c={};for(const g of u)c[g]=l(g);return c}}),define(ce[32],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(j){return R.test(j)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){j(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let P=0,$="";return $+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$+="-",$+=A[L[P++]],$+=A[L[P++]],$+="-",$+=A[L[P++]],$+=A[L[P++]],$+="-",$+=A[L[P++]],$+=A[L[P++]],$+="-",$+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$+=A[L[P++]],$}}()}),define(ce[131],le([0,1,37]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=L;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(A){const I=A.replace(/\-/g,":").toLowerCase();return!N.has(I)}function L(){const A=(0,R.networkInterfaces)();for(const I in A){const P=A[I];if(P){for(const{mac:$}of P)if(j($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[132],le([0,1,273,15]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xW=void 0;class j extends R.Transform{constructor(A){if(super(),typeof A=="number")this.b=A,this.c=1;else{const I=Buffer.isBuffer(A)?A:Buffer.from(A);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(A,I,P){this.a?this.a=Buffer.concat([this.a,A]):this.a=A;let $=0;for(;$<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,$):(0,N.$De)(this.a,this.b,$);if(S===-1)break;this.push(this.a.slice($,S+this.c)),$=S+this.c}this.a=$===this.a.length?void 0:this.a.slice($),P()}_flush(A){this.a&&this.push(this.a),A()}}e.$xW=j}),define(ce[133],le([0,1,64]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N,e.$Qg=L;function N(I,P,$,S=1){let b=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!b)return b=!0,m(0)},$);j(I,P,S,h=>{if(!b)return b=!0,clearTimeout(f),m(h)})})}function j(I,P,$,S){if(P===0)return S(0);const b=new R.Socket;b.once("connect",()=>(A(b),j(I+$,P-1,$,S))),b.once("data",()=>{}),b.once("error",m=>(A(b),m.code!=="ECONNREFUSED"?j(I+$,P-1,$,S):S(I))),b.connect(I,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,P,$,S="127.0.0.1"){let b=!1,m,f=1;const h=R.createServer({pauseOnConnect:!0});function p(w,u){b||(b=!0,h.removeAllListeners(),h.close(),m&&clearTimeout(m),u(w))}return new Promise(w=>{m=setTimeout(()=>{p(0,w)},$),h.on("listening",()=>{p(I,w)}),h.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<P?(I++,f++,h.listen(I,S)):p(0,w)}),h.on("close",()=>{p(0,w)}),h.listen(I,S)})}function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(ce[134],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PW=R;function R(N){return!!N.parentPort}}),define(ce[135],le([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ce[65],le([0,1,135]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=$,e.$Wm=S,e.$Xm=b;const N=60,j=N*60,L=j*24,A=L*7,I=L*30,P=L*365;function $(m,f,h,p){typeof m!="number"&&(m=m.getTime());const w=Math.round((new Date().getTime()-m)/1e3);if(w<-30)return(0,R.localize)(0,null,$(new Date().getTime()+w*1e3,!1));if(!p&&w<30)return(0,R.localize)(1,null);let u;return w<N?(u=w,f?u===1?h?(0,R.localize)(2,null,u):(0,R.localize)(3,null,u):h?(0,R.localize)(4,null,u):(0,R.localize)(5,null,u):u===1?h?(0,R.localize)(6,null,u):(0,R.localize)(7,null,u):h?(0,R.localize)(8,null,u):(0,R.localize)(9,null,u)):w<j?(u=Math.floor(w/N),f?u===1?h?(0,R.localize)(10,null,u):(0,R.localize)(11,null,u):h?(0,R.localize)(12,null,u):(0,R.localize)(13,null,u):u===1?h?(0,R.localize)(14,null,u):(0,R.localize)(15,null,u):h?(0,R.localize)(16,null,u):(0,R.localize)(17,null,u)):w<L?(u=Math.floor(w/j),f?u===1?h?(0,R.localize)(18,null,u):(0,R.localize)(19,null,u):h?(0,R.localize)(20,null,u):(0,R.localize)(21,null,u):u===1?h?(0,R.localize)(22,null,u):(0,R.localize)(23,null,u):h?(0,R.localize)(24,null,u):(0,R.localize)(25,null,u)):w<A?(u=Math.floor(w/L),f?u===1?(0,R.localize)(26,null,u):(0,R.localize)(27,null,u):u===1?(0,R.localize)(28,null,u):(0,R.localize)(29,null,u)):w<I?(u=Math.floor(w/A),f?u===1?h?(0,R.localize)(30,null,u):(0,R.localize)(31,null,u):h?(0,R.localize)(32,null,u):(0,R.localize)(33,null,u):u===1?h?(0,R.localize)(34,null,u):(0,R.localize)(35,null,u):h?(0,R.localize)(36,null,u):(0,R.localize)(37,null,u)):w<P?(u=Math.floor(w/I),f?u===1?h?(0,R.localize)(38,null,u):(0,R.localize)(39,null,u):h?(0,R.localize)(40,null,u):(0,R.localize)(41,null,u):u===1?h?(0,R.localize)(42,null,u):(0,R.localize)(43,null,u):h?(0,R.localize)(44,null,u):(0,R.localize)(45,null,u)):(u=Math.floor(w/P),f?u===1?h?(0,R.localize)(46,null,u):(0,R.localize)(47,null,u):h?(0,R.localize)(48,null,u):(0,R.localize)(49,null,u):u===1?h?(0,R.localize)(50,null,u):(0,R.localize)(51,null,u):h?(0,R.localize)(52,null,u):(0,R.localize)(53,null,u))}function S(m,f){const h=Math.abs(m/1e3);return h<1?f?(0,R.localize)(54,null,m):(0,R.localize)(55,null,m):h<N?f?(0,R.localize)(56,null,Math.round(m)/1e3):(0,R.localize)(57,null,Math.round(m)/1e3):h<j?f?(0,R.localize)(58,null,Math.round(m/(1e3*N))):(0,R.localize)(59,null,Math.round(m/(1e3*N))):h<L?f?(0,R.localize)(60,null,Math.round(m/(1e3*j))):(0,R.localize)(61,null,Math.round(m/(1e3*j))):(0,R.localize)(62,null,Math.round(m/(1e3*L)))}function b(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[136],le([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ce[38],le([0,1,17,13,136]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=P,e.$cj=$,e.$dj=S;function L(b,m){return m&&(b.stack||b.stacktrace)?j.localize(0,null,I(b),A(b.stack)||A(b.stacktrace)):I(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?j.localize(1,null,b.message):b.message||j.localize(2,null)}function P(b=null,m=!1){if(!b)return j.localize(3,null);if(Array.isArray(b)){const f=R.$Hb(b),h=P(f[0],m);return f.length>1?j.localize(4,null,h,f.length):h}if(N.$4f(b))return b;if(b.detail){const f=b.detail;if(f.error)return L(f.error,m);if(f.exception)return L(f.exception,m)}return b.stack?L(b,m):b.message?b.message:j.localize(5,null)}function $(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}function S(b,m){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=m,f}}),define(ce[137],le([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ce[138],le([0,1,137]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=N;function N(j){switch(j){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}}),define(ce[139],le([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ce[5],le([0,1,139]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=y,e.$J=v,e.$g="en";let N=!1,j=!1,L=!1,A=!1,I=!1,P=!1,$=!1,S=!1,b=!1,m=!1,f,h=e.$g,p=e.$g,w,u;const d=globalThis;let l;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?l=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const c=typeof l?.versions?.electron=="string",g=c&&l?.type==="renderer";if(typeof l=="object"){N=l.platform==="win32",j=l.platform==="darwin",L=l.platform==="linux",A=L&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,$=c,b=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,h=e.$g;const C=l.env.VSCODE_NLS_CONFIG;if(C)try{const E=JSON.parse(C),k=E.availableLanguages["*"];f=E.locale,p=E.osLocale,h=k||e.$g,w=E._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!g?(u=navigator.userAgent,N=u.indexOf("Windows")>=0,j=u.indexOf("Macintosh")>=0,S=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=u.indexOf("Linux")>=0,m=u?.indexOf("Mobi")>=0,P=!0,f=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$g,h=f,p=navigator.language):console.error("Unable to resolve platform.");var i;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;j?n=1:N?n=3:L&&(n=2),e.$i=N,e.$j=j,e.$k=L,e.$l=A,e.$m=I,e.$n=$,e.$o=P,e.$p=P&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=S,e.$s=m,e.$t=b,e.$u=n,e.$v=u,e.$w=h;var s;(function(C){function E(){return e.$w}C.value=E;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=k;function O(){return e.$w==="en"}C.isDefault=O})(s||(e.Language=s={})),e.$x=f,e.$y=p,e.$z=w,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const C=[];d.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let O=0,M=C.length;O<M;O++){const F=C[O];if(F.id===k.data.vscodeScheduleAsyncWork){C.splice(O,1),F.callback();return}}});let E=0;return k=>{const O=++E;C.push({id:O,callback:k}),d.postMessage({vscodeScheduleAsyncWork:O},"*")}}return C=>setTimeout(C)})();var t;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=j||S?2:N?1:3;let r=!0,a=!1;function y(){if(!a){a=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,r=new Uint16Array(C.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(C){return parseFloat(C)>=20}}),define(ce[36],le([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const L=j.process;N={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ce[140],le([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eW=A;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const j="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function A(){const I=R.env[j];if(I){const $=I.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of $)switch(S){case"Unity":{const b=R.env.DESKTOP_SESSION;return b&&b.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const b=R.env[L];return b==="5"?N.KDE5:b==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const P=R.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return L in R.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?N.GNOME:"KDE_FULL_SESSION"in R.env?L in R.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ce[14],le([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,j=97,L=90,A=122,I=46,P=47,$=92,S=58,b=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function h(i,o){if(typeof i!="string")throw new m(o,"string",i)}const p=R.$ec==="win32";function w(i){return i===P||i===$}function u(i){return i===P}function d(i){return i>=N&&i<=L||i>=j&&i<=A}function l(i,o,n,s){let t="",r=0,a=-1,y=0,v=0;for(let C=0;C<=i.length;++C){if(C<i.length)v=i.charCodeAt(C);else{if(s(v))break;v=P}if(s(v)){if(!(a===C-1||y===1))if(y===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==I||t.charCodeAt(t.length-2)!==I){if(t.length>2){const E=t.lastIndexOf(n);E===-1?(t="",r=0):(t=t.slice(0,E),r=t.length-1-t.lastIndexOf(n)),a=C,y=0;continue}else if(t.length!==0){t="",r=0,a=C,y=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,C)}`:t=i.slice(a+1,C),r=C-a-1;a=C,y=0}else v===I&&y!==-1?++y:y=-1}return t}function c(i,o){f(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],h(r,"path"),r.length===0)continue}else o.length===0?r=R.cwd():(r=R.env[`=${o}`]||R.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===$)&&(r=`${o}\\`));const a=r.length;let y=0,v="",C=!1;const E=r.charCodeAt(0);if(a===1)w(E)&&(y=1,C=!0);else if(w(E))if(C=!0,w(r.charCodeAt(1))){let k=2,O=k;for(;k<a&&!w(r.charCodeAt(k));)k++;if(k<a&&k!==O){const M=r.slice(O,k);for(O=k;k<a&&w(r.charCodeAt(k));)k++;if(k<a&&k!==O){for(O=k;k<a&&!w(r.charCodeAt(k));)k++;(k===a||k!==O)&&(v=`\\\\${M}\\${r.slice(O,k)}`,y=k)}}}else y=1;else d(E)&&r.charCodeAt(1)===S&&(v=r.slice(0,2),y=2,a>2&&w(r.charCodeAt(2))&&(C=!0,y=3));if(v.length>0)if(o.length>0){if(v.toLowerCase()!==o.toLowerCase())continue}else o=v;if(s){if(o.length>0)break}else if(n=`${r.slice(y)}\\${n}`,s=C,C&&o.length>0)break}return n=l(n,!s,"\\",w),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){h(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return u(r)?"\\":i;if(w(r))if(t=!0,w(i.charCodeAt(1))){let y=2,v=y;for(;y<o&&!w(i.charCodeAt(y));)y++;if(y<o&&y!==v){const C=i.slice(v,y);for(v=y;y<o&&w(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&!w(i.charCodeAt(y));)y++;if(y===o)return`\\\\${C}\\${i.slice(v)}\\`;y!==v&&(s=`\\\\${C}\\${i.slice(v,y)}`,n=y)}}}else n=1;else d(r)&&i.charCodeAt(1)===S&&(s=i.slice(0,2),n=2,o>2&&w(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?l(i.slice(n),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){h(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return w(n)||o>2&&d(n)&&i.charCodeAt(1)===S&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];h(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===$;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===$;)r--;const a=r-t;let y=0;for(;y<o.length&&o.charCodeAt(y)===$;)y++;let v=o.length;for(;v-1>y&&o.charCodeAt(v-1)===$;)v--;const C=v-y,E=a<C?a:C;let k=-1,O=0;for(;O<E;O++){const F=i.charCodeAt(t+O);if(F!==o.charCodeAt(y+O))break;F===$&&(k=O)}if(O!==E){if(k===-1)return s}else{if(C>E){if(o.charCodeAt(y+O)===$)return s.slice(y+O+1);if(O===2)return s.slice(y+O)}a>E&&(i.charCodeAt(t+O)===$?k=O:O===2&&(k=3)),k===-1&&(k=0)}let M="";for(O=t+k+1;O<=r;++O)(O===r||i.charCodeAt(O)===$)&&(M+=M.length===0?"..":"\\..");return y+=k,M.length>0?`${M}${s.slice(y,v)}`:(s.charCodeAt(y)===$&&++y,s.slice(y,v))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===$){if(o.charCodeAt(1)===$){const n=o.charCodeAt(2);if(n!==b&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===S&&o.charCodeAt(2)===$)return`\\\\?\\${o}`;return i},dirname(i){h(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return w(t)?i:".";if(w(t)){if(n=s=1,w(i.charCodeAt(1))){let y=2,v=y;for(;y<o&&!w(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&w(i.charCodeAt(y));)y++;if(y<o&&y!==v){for(v=y;y<o&&!w(i.charCodeAt(y));)y++;if(y===o)return i;y!==v&&(n=s=y+1)}}}}else d(t)&&i.charCodeAt(1)===S&&(n=o>2&&w(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let y=o-1;y>=s;--y)if(w(i.charCodeAt(y))){if(!a){r=y;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===S&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=n;--r){const v=i.charCodeAt(r);if(w(v)){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(v===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(w(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===S&&d(i.charCodeAt(0))&&(o=s=2);for(let y=i.length-1;y>=o;--y){const v=i.charCodeAt(y);if(w(v)){if(!r){s=y+1;break}continue}t===-1&&(r=!1,t=y+1),v===I?n===-1?n=y:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return w(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(t)){if(s=1,w(i.charCodeAt(1))){let k=2,O=k;for(;k<n&&!w(i.charCodeAt(k));)k++;if(k<n&&k!==O){for(O=k;k<n&&w(i.charCodeAt(k));)k++;if(k<n&&k!==O){for(O=k;k<n&&!w(i.charCodeAt(k));)k++;k===n?s=k:k!==O&&(s=k+1)}}}}else if(d(t)&&i.charCodeAt(1)===S){if(n<=2)return o.root=o.dir=i,o;if(s=2,w(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,y=-1,v=!0,C=i.length-1,E=0;for(;C>=s;--C){if(t=i.charCodeAt(C),w(t)){if(!v){a=C+1;break}continue}y===-1&&(v=!1,y=C+1),t===I?r===-1?r=C:E!==1&&(E=1):r!==-1&&(E=-1)}return y!==-1&&(r===-1||E===0||E===1&&r===y-1&&r===a+1?o.base=o.name=i.slice(a,y):(o.name=i.slice(a,r),o.base=i.slice(a,y),o.ext=i.slice(r,y))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(p){const i=/\\/g;return()=>{const o=R.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>R.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:g();h(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===P)}return o=l(o,!n,"/",u),n?`/${o}`:o.length>0?o:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=l(i,!o,"/",u),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];h(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(h(i,"from"),h(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,y=t<a?t:a;let v=-1,C=0;for(;C<y;C++){const k=i.charCodeAt(n+C);if(k!==o.charCodeAt(r+C))break;k===P&&(v=C)}if(C===y)if(a>y){if(o.charCodeAt(r+C)===P)return o.slice(r+C+1);if(C===0)return o.slice(r+C)}else t>y&&(i.charCodeAt(n+C)===P?v=C:C===0&&(v=0));let E="";for(C=n+v+1;C<=s;++C)(C===s||i.charCodeAt(C)===P)&&(E+=E.length===0?"..":"/..");return`${E}${o.slice(r+v)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===P){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&h(o,"ext"),h(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,y=-1;for(r=i.length-1;r>=0;--r){const v=i.charCodeAt(r);if(v===P){if(!t){n=r+1;break}}else y===-1&&(t=!1,y=r+1),a>=0&&(v===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===P){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){h(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const y=i.charCodeAt(a);if(y===P){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),y===I?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){h(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,y=!0,v=i.length-1,C=0;for(;v>=s;--v){const E=i.charCodeAt(v);if(E===P){if(!y){r=v+1;break}continue}a===-1&&(y=!1,a=v+1),E===I?t===-1?t=v:C!==1&&(C=1):t!==-1&&(C=-1)}if(a!==-1){const E=r===0&&n?1:r;t===-1||C===0||C===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(E,a):(o.name=i.slice(E,t),o.base=i.slice(E,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=p?e.$gc.normalize:e.$hc.normalize,e.$jc=p?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=p?e.$gc.join:e.$hc.join,e.$lc=p?e.$gc.resolve:e.$hc.resolve,e.$mc=p?e.$gc.relative:e.$hc.relative,e.$nc=p?e.$gc.dirname:e.$hc.dirname,e.$oc=p?e.$gc.basename:e.$hc.basename,e.$pc=p?e.$gc.extname:e.$hc.extname,e.$qc=p?e.$gc.format:e.$hc.format,e.$rc=p?e.$gc.parse:e.$hc.parse,e.$sc=p?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=p?e.$gc.sep:e.$hc.sep,e.$uc=p?e.$gc.delimiter:e.$hc.delimiter}),define(ce[44],le([0,1,14,5,27,13]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=A,e.$kg=I,e.$lg=P,e.$mg=$,e.$ng=S,e.$og=h,e.$pg=p,e.$qg=w,e.$rg=u,e.$sg=d,e.$tg=l,e.$ug=c,e.$vg=g,e.$wg=i,e.$xg=o,e.$yg=t;function A(r){return r===47||r===92}function I(r){return r.replace(/[\\/]/g,R.$hc.sep)}function P(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function $(r,a=R.$hc.sep){if(!r)return"";const y=r.length,v=r.charCodeAt(0);if(A(v)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let E=3;const k=E;for(;E<y&&!A(r.charCodeAt(E));E++);if(k!==E&&!A(r.charCodeAt(E+1))){for(E+=1;E<y;E++)if(A(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(u(v)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let C=r.indexOf("://");if(C!==-1){for(C+=3;C<y;C++)if(A(r.charCodeAt(C)))return r.slice(0,C+1)}return""}function S(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let y=2;const v=y;for(;y<r.length&&(a=r.charCodeAt(y),a!==92);y++);return!(v===y||(a=r.charCodeAt(y+1),isNaN(a)||a===92))}const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,a=N.$i){const y=a?b:m;return!(!r||r.length===0||/^\s+$/.test(r)||(y.lastIndex=0,y.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function p(r,a,y){const v=r===a;return!y||v?v:!r||!a?!1:(0,j.$tf)(r,a)}function w(r,a,y,v=R.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(y){if(!(0,j.$uf)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===v&&E--,r.charAt(E)===v}return a.charAt(a.length-1)!==v&&(a+=v),r.indexOf(a)===0}function u(r){return r>=65&&r<=90||r>=97&&r<=122}function d(r,a){return N.$i&&r.endsWith(":")&&(r+=R.sep),(0,R.$jc)(r)||(r=(0,R.$kc)(a,r)),r=(0,R.$ic)(r),N.$i?(r=(0,j.$bf)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,j.$bf)(r,R.sep),r||(r=R.sep)),r}function l(r){const a=(0,R.$ic)(r);return N.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===R.$hc.sep}function c(r,a=N.$i){return a?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function g(r,a=N.$i){return c(r,a)?r[0]:void 0}function i(r,a,y){return a.length>r.length?-1:r===a?0:(y&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let y,v,C;for(const E of a){const k=Number(E);(0,L.$8f)(k)?v===void 0?v=k:C===void 0&&(C=k):y=y?[y,E].join(":"):E}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:v!==void 0?v:void 0,column:C!==void 0?C:v!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,y=8){let v="";for(let E=0;E<y;E++){let k;E===0&&N.$i&&!a&&(y===3||y===4)?k=s:k=n,v+=k.charAt(Math.floor(Math.random()*k.length))}let C;return a?C=`${a}-${v}`:C=v,r?(0,R.$kc)(r,C):C}}),define(ce[141],le([0,1,14]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=L,e.$Js=A,e.$Ks=I,e.$Ls=$,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(S){const b=(0,R.$pc)(S),m=N[b.toLowerCase()];return m!==void 0?m:A(S)}function A(S){const b=(0,R.$pc)(S);return j[b.toLowerCase()]}function I(S){for(const b in j)if(j[b]===S)return b}const P=/^(.+)\/(.+?)(;.+)?$/;function $(S,b){const m=P.exec(S);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:S}}),define(ce[89],le([0,1,5]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=L,e.$hm=A;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var j;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function L(I,...P){const $=P.reduce((m,f)=>(m[f]=!0,m),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!$[m]).forEach(m=>{for(let f=0;f<S.length;f++)if(m.search(S[f])!==-1){delete I[m];break}})}function A(I){I&&(delete I.DEBUG,R.$j&&delete I.DYLD_LIBRARY_PATH,R.$k&&delete I.LD_PRELOAD)}}),define(ce[8],le([0,1,14,5]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=h,e.$xc=c;const j=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function I(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!j.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,t){return!s&&!t?"file":s}function $(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const S="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,y,v,C=!1){typeof t=="object"?(this.scheme=t.scheme||S,this.authority=t.authority||S,this.path=t.path||S,this.query=t.query||S,this.fragment=t.fragment||S):(this.scheme=P(t,C),this.authority=r||S,this.path=$(this.scheme,a||S),this.query=y||S,this.fragment=v||S,I(this,C))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:y,query:v,fragment:C}=t;return r===void 0?r=this.scheme:r===null&&(r=S),a===void 0?a=this.authority:a===null&&(a=S),y===void 0?y=this.path:y===null&&(y=S),v===void 0?v=this.query:v===null&&(v=S),C===void 0?C=this.fragment:C===null&&(C=S),r===this.scheme&&a===this.authority&&y===this.path&&v===this.query&&C===this.fragment?this:new w(r,a,y,v,C)}static parse(t,r=!1){const a=m.exec(t);return a?new w(a[2]||S,n(a[4]||S),n(a[5]||S),n(a[7]||S),n(a[9]||S),r):new w(S,S,S,S,S)}static file(t){let r=S;if(N.$i&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const a=t.indexOf(b,2);a===-1?(r=t.substring(2),t=b):(r=t.substring(2,a),t=t.substring(a)||b)}return new w("file",r,t,S,S)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=f.file(R.$gc.join(c(t,!0),...r)).path:a=R.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return g(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=f;function h(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=N.$i?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,y=-1;for(let v=0;v<s.length;v++){const C=s.charCodeAt(v);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||t&&C===47||r&&C===91||r&&C===93||r&&C===58)y!==-1&&(a+=encodeURIComponent(s.substring(y,v)),y=-1),a!==void 0&&(a+=s.charAt(v));else{a===void 0&&(a=s.substr(0,v));const E=u[C];E!==void 0?(y!==-1&&(a+=encodeURIComponent(s.substring(y,v)),y=-1),a+=E):y===-1&&(y=v)}}return y!==-1&&(a+=encodeURIComponent(s.substring(y))),a!==void 0?a:s}function l(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=u[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}function g(s,t){const r=t?l:d;let a="",{scheme:y,authority:v,path:C,query:E,fragment:k}=s;if(y&&(a+=y,a+=":"),(v||y==="file")&&(a+=b,a+=b),v){let O=v.indexOf("@");if(O!==-1){const M=v.substr(0,O);v=v.substr(O+1),O=M.lastIndexOf(":"),O===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,O),!1,!1),a+=":",a+=r(M.substr(O+1),!1,!0)),a+="@"}v=v.toLowerCase(),O=v.lastIndexOf(":"),O===-1?a+=r(v,!1,!0):(a+=r(v.substr(0,O),!1,!0),a+=v.substr(O))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const O=C.charCodeAt(1);O>=65&&O<=90&&(C=`/${String.fromCharCode(O+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const O=C.charCodeAt(0);O>=65&&O<=90&&(C=`${String.fromCharCode(O+32)}:${C.substr(2)}`)}a+=r(C,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),k&&(a+="#",a+=t?k:d(k,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(ce[142],le([0,1,8]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=N,e.$Oq=j,e.$Pq=L,e.log=I;function N($){const S=$;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function j($){const S=[];let b;try{const m=JSON.parse($.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),b=f.__$stack),S.push(...m)}catch{S.push("Unable to log remote console arguments",$.arguments)}return{args:S,stack:b}}function L($){if(typeof $!="string")return L(j($).stack);const S=$;if(S){const b=A(S),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function A($){if(!$)return $;const S=$.indexOf(`
`);return S===-1?$:$.substring(0,S)}function I($,S){const{args:b,stack:m}=j($),f=typeof b[0]=="string"&&b.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let p=[];if(typeof b[0]=="string"?h&&f?p=[`%c[${S}] %c${b[0]} %c${h}`,P("blue"),P(""),P("grey")]:p=[`%c[${S}] %c${b[0]}`,P("blue"),P(""),...b.slice(1)]:p=[`%c[${S}]%`,P("blue"),...b],h&&!f&&p.push(h),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,p)}function P($){return`color: ${$}`}}),define(ce[66],le([0,1,15,8]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=j,e.$Yh=L,e.$Zh=I;function j(P){return JSON.stringify(P,A)}function L(P){let $=JSON.parse(P);return $=I($),$}function A(P,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function I(P,$=0){if(!P||$>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return N.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof R.$Ce||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let S=0;S<P.length;++S)P[S]=I(P[S],$+1);else for(const S in P)Object.hasOwnProperty.call(P,S)&&(P[S]=I(P[S],$+1))}return P}}),define(ce[23],le([0,1,7,5,27,8,14]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=P,e.$Ag=$,e.$Eg=b;var I;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(I||(e.Schemas=I={}));function P(h,p){return L.URI.isUri(h)?(0,j.$tf)(h.scheme,p):(0,j.$uf)(h,p+":")}function $(h,...p){return p.some(w=>P(h,w))}e.$Bg="vscode-tkn",e.$Cg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,w){this.f=b(p,w)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,I.vscodeRemoteResource)}set(p,w,u){this.a[p]=w,this.b[p]=u}setConnectionToken(p,w){this.c[p]=w}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(g){return R.$1(g),p}const w=p.authority;let u=this.a[w];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const d=this.b[w],l=this.c[w];let c=`path=${encodeURIComponent(p.path)}`;return typeof l=="string"&&(c+=`&${e.$Cg}=${encodeURIComponent(l)}`),L.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${u}:${d}`,path:this.g,query:c})}}e.$Dg=new S;function b(h,p){return A.$hc.join(p??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class m{static{this.a=e.$Jg}asBrowserUri(p){const w=this.b(p,ne);return this.uriToBrowserUri(w)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Dg.rewrite(p):p.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${m.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||m.a,query:null,fragment:null}):p}asFileUri(p){const w=this.b(p,ne);return this.uriToFileUri(w)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==m.a?p.authority:null,query:null,fragment:null}):p}b(p,w){return L.URI.isUri(p)?p:L.URI.parse(w.toUrl(p))}}e.$Kg=new m;var f;(function(h){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(p.get("3"));const w="vscode-coi";function u(l){let c;typeof l=="string"?c=new URL(l).searchParams:l instanceof URL?c=l.searchParams:L.URI.isUri(l)&&(c=new URL(l.toString(!0)).searchParams);const g=c?.get(w);if(g)return p.get(g)}h.getHeadersFromQuery=u;function d(l,c,g){if(!globalThis.crossOriginIsolated)return;const i=c&&g?"3":g?"2":"1";l instanceof URLSearchParams?l.set(w,i):l[w]=i}h.addSearchParam=d})(f||(e.COI=f={}))}),define(ce[143],le([0,1,124,23,5,8]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QD=S;class A{constructor(m,f,h){this.id=m,this.dependencies=f,this.callback=h}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,f,h)=>{typeof m!="string"&&(h=f,f=m,m=null),(typeof f!="object"||!Array.isArray(f))&&(h=f,f=null),this.c.push(new A(m,f,h))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const f=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!f)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(m){return new Promise((f,h)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",u),p.removeEventListener("error",d)},u=l=>{w(),f(this.c.pop())},d=l=>{w(),h(l)};p.addEventListener("load",u),p.addEventListener("error",d),this.f&&(m=this.f.createScriptURL(m)),p.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(m){return new Promise((f,h)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),f(this.c.pop())}catch(p){h(p)}})}async j(m){try{const f=globalThis._VSCODE_NODE_MODULES.fs,h=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=L.URI.parse(m).fsPath,u=f.readFileSync(w).toString(),d=p.wrap(u.replace(/^#!.*/,""));return new h.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const P=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function S(b,m,f){if(R.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[b]&&(b=$[b]);const h=`${b}/${m}`;if(P.has(h))return P.get(h);let p;if(/^\w[\w\d+.-]*:\/\//.test(h))p=h;else{const l=`${f&&!j.$o?N.$Hg:N.$Gg}/${h}`;p=N.$Kg.asBrowserUri(l).toString(!0)}const w=I.INSTANCE.load(p);return P.set(h,w),w}else return await new Promise((h,p)=>{ne([b],h,p)})}}),define(ce[20],le([0,1,44,23,14,5,27,8]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=P,e.$ah=S,e.$bh=m;function P(f){return(0,I.$xc)(f,!0)}class ${constructor(h){this.a=h}compare(h,p,w=!1){return h===p?0:(0,A.$mf)(this.getComparisonKey(h,w),this.getComparisonKey(p,w))}isEqual(h,p,w=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,w)===this.getComparisonKey(p,w)}getComparisonKey(h,p=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,p,w=!1){if(h.scheme===p.scheme){if(h.scheme===N.Schemas.file)return R.$qg(P(h),P(p),this.a(h))&&h.query===p.query&&(w||h.fragment===p.fragment);if((0,e.$9g)(h.authority,p.authority))return R.$qg(h.path,p.path,this.a(h),"/")&&h.query===p.query&&(w||h.fragment===p.fragment)}return!1}joinPath(h,...p){return I.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.$1g)(h)||h.authority}basename(h){return j.$hc.basename(h.path)}extname(h){return j.$hc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===N.Schemas.file?p=I.URI.file(j.$nc(P(h))).path:(p=j.$hc.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===N.Schemas.file?p=I.URI.file(j.$ic(P(h))).path:p=j.$hc.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.$9g)(h.authority,p.authority))return;if(h.scheme===N.Schemas.file){const d=j.$mc(P(h),P(p));return L.$i?R.$kg(d):d}let w=h.path||"/";const u=p.path||"/";if(this.a(h)){let d=0;for(const l=Math.min(w.length,u.length);d<l&&!(w.charCodeAt(d)!==u.charCodeAt(d)&&w.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);w=u.substr(0,d)+w.substr(d)}return j.$hc.relative(w,u)}resolvePath(h,p){if(h.scheme===N.Schemas.file){const w=I.URI.file(j.$lc(P(h),p));return h.with({authority:w.authority,path:w.path})}return p=R.$lg(p),h.with({path:j.$hc.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,A.$tf)(h,p)}hasTrailingPathSeparator(h,p=j.sep){if(h.scheme===N.Schemas.file){const w=P(h);return w.length>R.$mg(w).length&&w[w.length-1]===p}else{const w=h.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=j.sep){return(0,e.$0g)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=j.sep){let w=!1;if(h.scheme===N.Schemas.file){const u=P(h);w=u!==void 0&&u.length===R.$mg(u).length&&u[u.length-1]===p}else{p="/";const u=h.path;w=u.length===1&&u.charCodeAt(u.length-1)===47}return!w&&!(0,e.$0g)(h,p)?h.with({path:h.path+"/"}):h}}e.$Sg=$,e.$Tg=new $(()=>!1),e.$Ug=new $(f=>f.scheme===N.Schemas.file?!L.$k:!0),e.$Vg=new $(f=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function S(f,h){const p=[];for(let w=0;w<f.length;w++){const u=h(f[w]);f.some((d,l)=>l===w?!1:(0,e.$Xg)(u,h(d)))||p.push(f[w])}return p}var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,g]=l.split(":");c&&g&&w.set(c,g)});const d=p.path.substring(0,p.path.indexOf(";"));return d&&w.set(f.META_DATA_MIME,d),w}f.parseMetaData=h})(b||(e.DataUri=b={}));function m(f,h,p){if(h){let w=f.path;return w&&w[0]!==j.$hc.sep&&(w=j.$hc.sep+w),f.with({scheme:p,authority:h,path:w})}return f.with({scheme:p})}}),define(ce[6],le([0,1,26,7,3,2,20,5,130,53]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=S,e.$dh=b,e.$eh=m,e.$fh=f,e.$gh=h,e.$hh=p,e.$ih=w,e.$jh=u,e.$rh=r,e.$sh=a,e.$th=y,e.$uh=v,e.$vh=C,e.$Kh=B,e.$Sh=K;function S(_){return!!_&&typeof _.then=="function"}function b(_){const Y=new R.$me,se=_(Y.token),ue=new Promise((ge,fe)=>{const $e=Y.token.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});Promise.resolve(se).then(ye=>{$e.dispose(),Y.dispose(),ge(ye)},ye=>{$e.dispose(),Y.dispose(),fe(ye)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,fe){return ue.then(ge,fe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function m(_,Y,se){return new Promise((ue,ge)=>{const fe=Y.onCancellationRequested(()=>{fe.dispose(),ue(se)});_.then(ue,ge).finally(()=>fe.dispose())})}function f(_,Y){return new Promise((se,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new N.$5)});_.then(se,ue).finally(()=>ge.dispose())})}async function h(_){let Y=-1;const se=_.map((ue,ge)=>ue.then(fe=>(Y=ge,fe)));try{return await Promise.race(se)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function p(_,Y,se){let ue;const ge=setTimeout(()=>{ue?.(void 0),se?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(fe=>ue=fe)])}function w(_){return new Promise((Y,se)=>{const ue=_();S(ue)?ue.then(Y,se):Y(ue)})}function u(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=Y(),new Promise((se,ue)=>{this.a.then(ge=>{this.a=null,se(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$kh=d;class l{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$lh=l;class c{constructor(){this.a=new Map}queue(Y,se){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$mh=c;const g=(_,Y)=>{let se=!0;const ue=setTimeout(()=>{se=!1,Y()},_);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},i=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class o{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,se=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,fe)=>{this.d=ge,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===P.$$d?i(ue):g(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=o;class n{constructor(Y){this.a=new o(Y),this.b=new d}trigger(Y,se){return this.a.trigger(()=>this.b.queue(Y),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=n;class s{constructor(){this.a=!1,this.b=new Promise((Y,se)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=s;class t extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$qh=t;function r(_,Y){return Y?new Promise((se,ue)=>{const ge=setTimeout(()=>{fe.dispose(),se()},_),fe=Y.onCancellationRequested(()=>{clearTimeout(ge),fe.dispose(),ue(new N.$5)})}):b(se=>r(_,se))}function a(_,Y=0,se){const ue=setTimeout(()=>{_(),se&&ge.dispose()},Y),ge=(0,L.$Sc)(()=>{clearTimeout(ue),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function y(_){const Y=[];let se=0;const ue=_.length;function ge(){return se<ue?_[se++]():null}function fe($e){$e!=null&&Y.push($e);const ye=ge();return ye?ye.then(fe):Promise.resolve(Y)}return Promise.resolve(null).then(fe)}function v(_,Y=ue=>!!ue,se=null){let ue=0;const ge=_.length,fe=()=>{if(ue>=ge)return Promise.resolve(se);const $e=_[ue++];return Promise.resolve($e()).then(ve=>Y(ve)?Promise.resolve(ve):fe())};return fe()}function C(_,Y=ue=>!!ue,se=null){if(_.length===0)return Promise.resolve(se);let ue=_.length;const ge=()=>{ue=-1;for(const fe of _)fe.cancel?.()};return new Promise((fe,$e)=>{for(const ye of _)ye.then(ve=>{--ue>=0&&Y(ve)?(ge(),fe(ve)):ue===0&&fe(se)}).catch(ve=>{--ue>=0&&(ge(),$e(ve))})})}class E{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new j.$be}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:Y,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const se=Y.factory();se.then(Y.c,Y.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=E;class k extends E{constructor(){super(1)}}e.$xh=k;class O{constructor(){this.a=new ie,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$yh=O;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new ae;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,se=A.$Tg){const ue=se.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,se,ue=A.$Tg){const ge=ue.getComparisonKey(Y);let fe=this.a.get(ge);if(!fe){fe=new k;const $e=this.f++,ye=j.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$4c),this.d.set($e,ye),this.a.set(ge,fe)}return fe.queue(se)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=M;class F{constructor(Y,se){this.a=-1,typeof Y=="function"&&typeof se=="number"&&this.setIfNotSet(Y,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},se)}setIfNotSet(Y,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},se))}}e.$Ah=F;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,se,ue=globalThis){this.cancel();const ge=ue.setInterval(()=>{Y()},se);this.d=(0,L.$Sc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=U;class X{constructor(Y,se){this.b=-1,this.a=Y,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=X;class H{constructor(Y,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Y,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=H;class Z extends X{constructor(Y,se){super(Y,se),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Eh=Z;class W extends L.$Uc{constructor(Y,se){super(),this.g=Y,this.h=se,this.a=[],this.b=this.B(new L.$Vc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Y)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(_,Y)=>{(0,I.$B)(()=>{if(se)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Hh=(_,Y,se)=>{const ue=_.requestIdleCallback(Y,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Gh=_=>(0,e.$Hh)(globalThis,_)}();class J{constructor(Y,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Hh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=J;class V extends J{constructor(Y){super(globalThis,Y)}}e.$Jh=V;async function B(_,Y,se){let ue;for(let ge=0;ge<se;ge++)try{return await _()}catch(fe){ue=fe,await r(Y)}throw ue}class ie{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,se,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(Y),()=>this.d(Y)),se}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:se,resolve:ue,reject:ge}=u();this.b={run:Y,promise:se,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ie;class oe{constructor(Y,se=()=>Date.now()){this.d=Y,this.f=se,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Mh=oe;var te;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(te||(te={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Y,se)=>{this.a=Y,this.b=se})}complete(Y){return new Promise(se=>{this.a(Y),this.d={outcome:0,value:Y},se()})}error(Y){return new Promise(se=>{this.b(Y),this.d={outcome:1,value:Y},se()})}cancel(){return this.error(new N.$5)}}e.$Nh=ae;var G;(function(_){async function Y(ue){let ge;const fe=await Promise.all(ue.map($e=>$e.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return fe}_.settled=Y;function se(ue){return new Promise(async(ge,fe)=>{try{await ue(ge,fe)}catch($e){fe($e)}})}_.withAsyncBody=se})(G||(e.Promises=G={}));class q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=q;class D{constructor(Y){this.b=Y,this.a=new $.$V(()=>new q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=D;var T;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(T||(T={}));class z{static fromArray(Y){return new z(se=>{se.emitMany(Y)})}static fromPromise(Y){return new z(async se=>{se.emitMany(await Y)})}static fromPromises(Y){return new z(async se=>{await Promise.all(Y.map(async ue=>se.emitOne(await ue)))})}static merge(Y){return new z(async se=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)se.emitOne(ge)}))})}static{this.EMPTY=z.fromArray([])}constructor(Y,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new j.$be,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,se){return new z(async ue=>{for await(const ge of Y)ue.emitOne(se(ge))})}map(Y){return z.map(this,Y)}static filter(Y,se){return new z(async ue=>{for await(const ge of Y)se(ge)&&ue.emitOne(ge)})}filter(Y){return z.filter(this,Y)}static coalesce(Y){return z.filter(Y,se=>!!se)}coalesce(){return z.coalesce(this)}static async toPromise(Y){const se=[];for await(const ue of Y)se.push(ue);return se}toPromise(){return z.toPromise(this)}h(Y){this.a===0&&(this.b.push(Y),this.g.fire())}j(Y){this.a===0&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Y){this.a===0&&(this.a=2,this.d=Y,this.g.fire())}}e.$Qh=z;class x extends z{constructor(Y,se){super(se),this.m=Y}cancel(){this.m.cancel()}}e.$Rh=x;function K(_){const Y=new R.$me,se=_(Y.token);return new x(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new N.$5)});try{for await(const fe of se){if(Y.token.isCancellationRequested)return;ue.emitOne(fe)}ge.dispose(),Y.dispose()}catch(fe){ge.dispose(),Y.dispose(),ue.reject(fe)}})}class ee{constructor(Y){this.a=new ae,this.b=new z(ge=>{if(se){ge.reject(se);return}return ue&&ge.emitMany(ue),this.d=fe=>ge.reject(fe),this.f=fe=>ge.emitOne(fe),this.a.p},Y);let se,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{se||(se=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$Th=ee}),define(ce[90],le([0,1,17,6,44,34,14,5,27]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=$,e.$ik=h,e.$jk=k,e.$kk=O,e.$lk=M,e.$mk=F,e.$nk=U,e.$ok=W;function $(){return Object.create(null)}e.$gk="**",e.$hk="/";const S="[/\\\\]",b="[^/\\\\]",m=/\//g;function f(J,V){switch(J){case 0:return"";case 1:return`${b}*?`;default:return`(?:${S}|${b}+${S}${V?`|${S}${b}+`:""})*?`}}function h(J,V){if(!J)return[];const B=[];let ie=!1,oe=!1,te="";for(const ae of J){switch(ae){case V:if(!ie&&!oe){B.push(te),te="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=ae}return te&&B.push(te),B}function p(J){if(!J)return"";let V="";const B=h(J,e.$hk);if(B.every(ie=>ie===e.$gk))V=".*";else{let ie=!1;B.forEach((oe,te)=>{if(oe===e.$gk){if(ie)return;V+=f(2,te===B.length-1)}else{let ae=!1,G="",q=!1,D="";for(const T of oe){if(T!=="}"&&ae){G+=T;continue}if(q&&(T!=="]"||!D)){let z;T==="-"?z=T:(T==="^"||T==="!")&&!D?z="^":T===e.$hk?z="":z=(0,P.$8e)(T),D+=z;continue}switch(T){case"{":ae=!0;continue;case"[":q=!0;continue;case"}":{const x=`(?:${h(G,",").map(K=>p(K)).join("|")})`;V+=x,ae=!1,G="";break}case"]":{V+="["+D+"]",q=!1,D="";break}case"?":V+=b;continue;case"*":V+=f(1);continue;default:V+=(0,P.$8e)(T)}}te<B.length-1&&(B[te+1]!==e.$gk||te+2<B.length)&&(V+=S)}ie=oe===e.$gk})}return V}const w=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(J,V){if(!J)return n;let B;typeof J!="string"?B=J.pattern:B=J,B=B.trim();const ie=`${B}_${!!V.trimForExclusions}`;let oe=i.get(ie);if(oe)return t(oe,J);let te;return w.test(B)?oe=a(B.substr(4),B):(te=u.exec(r(B,V)))?oe=y(te[1],B):(V.trimForExclusions?l:d).test(B)?oe=v(B,V):(te=c.exec(r(B,V)))?oe=C(te[1].substr(1),B,!0):(te=g.exec(r(B,V)))?oe=C(te[1],B,!1):oe=E(B),i.set(ie,oe),t(oe,J)}function t(J,V){if(typeof V=="string")return J;const B=function(ie,oe){return(0,j.$qg)(ie,V.base,!I.$k)?J((0,P.$af)(ie.substr(V.base.length),A.sep),oe):null};return B.allBasenames=J.allBasenames,B.allPaths=J.allPaths,B.basenames=J.basenames,B.patterns=J.patterns,B}function r(J,V){return V.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,V){return function(B,ie){return typeof B=="string"&&B.endsWith(J)?V:null}}function y(J,V){const B=`/${J}`,ie=`\\${J}`,oe=function(ae,G){return typeof ae!="string"?null:G?G===J?V:null:ae===J||ae.endsWith(B)||ae.endsWith(ie)?V:null},te=[J];return oe.basenames=te,oe.patterns=[V],oe.allBasenames=te,oe}function v(J,V){const B=Z(J.slice(1,-1).split(",").map(G=>s(G,V)).filter(G=>G!==n),J),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const oe=function(G,q){for(let D=0,T=B.length;D<T;D++)if(B[D](G,q))return J;return null},te=B.find(G=>!!G.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ae=B.reduce((G,q)=>q.allPaths?G.concat(q.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function C(J,V,B){const ie=A.sep===A.$hc.sep,oe=ie?J:J.replace(m,A.sep),te=A.sep+oe,ae=A.$hc.sep+J;let G;return B?G=function(q,D){return typeof q=="string"&&(q===oe||q.endsWith(te)||!ie&&(q===J||q.endsWith(ae)))?V:null}:G=function(q,D){return typeof q=="string"&&(q===oe||!ie&&q===J)?V:null},G.allPaths=[(B?"*/":"./")+J],G}function E(J){try{const V=new RegExp(`^${p(J)}$`);return function(B){return V.lastIndex=0,typeof B=="string"&&V.test(B)?J:null}}catch{return n}}function k(J,V,B){return!J||typeof V!="string"?!1:O(J)(V,void 0,B)}function O(J,V={}){if(!J)return o;if(typeof J=="string"||M(J)){const B=s(J,V);if(B===n)return o;const ie=function(oe,te){return!!B(oe,te)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return X(J,V)}function M(J){const V=J;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function F(J){return J.allBasenames||[]}function U(J){return J.allPaths||[]}function X(J,V){const B=Z(Object.getOwnPropertyNames(J).map(G=>H(G,J[G],V)).filter(G=>G!==n)),ie=B.length;if(!ie)return n;if(!B.some(G=>!!G.requiresSiblings)){if(ie===1)return B[0];const G=function(T,z){let x;for(let K=0,ee=B.length;K<ee;K++){const _=B[K](T,z);if(typeof _=="string")return _;(0,N.$ch)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const K of x){const ee=await K;if(typeof ee=="string")return ee}return null})():null},q=B.find(T=>!!T.allBasenames);q&&(G.allBasenames=q.allBasenames);const D=B.reduce((T,z)=>z.allPaths?T.concat(z.allPaths):T,[]);return D.length&&(G.allPaths=D),G}const oe=function(G,q,D){let T,z;for(let x=0,K=B.length;x<K;x++){const ee=B[x];ee.requiresSiblings&&D&&(q||(q=(0,A.$oc)(G)),T||(T=q.substr(0,q.length-(0,A.$pc)(G).length)));const _=ee(G,q,T,D);if(typeof _=="string")return _;(0,N.$ch)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const x of z){const K=await x;if(typeof K=="string")return K}return null})():null},te=B.find(G=>!!G.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ae=B.reduce((G,q)=>q.allPaths?G.concat(q.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function H(J,V,B){if(V===!1)return n;const ie=s(J,B);if(ie===n)return n;if(typeof V=="boolean")return ie;if(V){const oe=V.when;if(typeof oe=="string"){const te=(ae,G,q,D)=>{if(!D||!ie(ae,G))return null;const T=oe.replace("$(basename)",()=>q),z=D(T);return(0,N.$ch)(z)?z.then(x=>x?J:null):z?J:null};return te.requiresSiblings=!0,te}}return ie}function Z(J,V){const B=J.filter(G=>!!G.basenames);if(B.length<2)return J;const ie=B.reduce((G,q)=>{const D=q.basenames;return D?G.concat(D):G},[]);let oe;if(V){oe=[];for(let G=0,q=ie.length;G<q;G++)oe.push(V)}else oe=B.reduce((G,q)=>{const D=q.patterns;return D?G.concat(D):G},[]);const te=function(G,q){if(typeof G!="string")return null;if(!q){let T;for(T=G.length;T>0;T--){const z=G.charCodeAt(T-1);if(z===47||z===92)break}q=G.substr(T)}const D=ie.indexOf(q);return D!==-1?oe[D]:null};te.basenames=ie,te.patterns=oe,te.allBasenames=ie;const ae=J.filter(G=>!G.basenames);return ae.push(te),ae}function W(J,V){return(0,R.$ub)(J,V,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(ce[91],le([0,1,15,8]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=I,e.$vn=$,e.$wn=S;function j(b){return b.toJSON()}class L{constructor(m){this.a=m}transformIncoming(m){const f=this.a.transformIncoming(m);return f===m?m:j(N.URI.from(f))}transformOutgoing(m){const f=this.a.transformOutgoing(m);return f===m?m:j(N.URI.from(f))}transformOutgoingURI(m){const f=this.a.transformOutgoing(m);return f===m?m:N.URI.from(f)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$sn=L,e.$tn=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function A(b,m,f){if(!b||f>200)return null;if(typeof b=="object"){if(b instanceof N.URI)return m.transformOutgoing(b);for(const h in b)if(Object.hasOwnProperty.call(b,h)){const p=A(b[h],m,f+1);p!==null&&(b[h]=p)}}return null}function I(b,m){const f=A(b,m,0);return f===null?b:f}function P(b,m,f,h){if(!b||h>200)return null;if(typeof b=="object"){if(b.$mid===1)return f?N.URI.revive(m.transformIncoming(b)):m.transformIncoming(b);if(b instanceof R.$Ce)return null;for(const p in b)if(Object.hasOwnProperty.call(b,p)){const w=P(b[p],m,f,h+1);w!==null&&(b[p]=w)}}return null}function $(b,m){const f=P(b,m,!1,0);return f===null?b:f}function S(b,m){const f=P(b,m,!0,0);return f===null?b:f}}),define(ce[144],le([0,1,37,51,32,131,5]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0,e.$zn=P,e.$An=b,e.$yn=new class{c(m){return this.a||(this.a=N.$wi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,f=0;const h=(0,R.networkInterfaces)();for(const p in h){const w=h[p];if(w)for(const{mac:u,internal:d}of w)d||(f+=1,this.c(u.toUpperCase())&&(m+=1))}this.b=f>0?m/f:0}return this.b}};let I;async function P(m){return I||(I=(async()=>await $(m)||j.$Mg())()),I}async function $(m){try{const f=await new Promise((p,w)=>{ne(["crypto"],p,w)}),h=(0,L.$xn)();return f.createHash("sha256").update(h,"utf8").digest("hex")}catch(f){m(f);return}}const S="Software\\Microsoft\\SQMClient";async function b(m){if(A.$i){const f=await new Promise((h,p)=>{ne(["@vscode/windows-registry"],h,p)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(h){return m(h),""}}return""}}),define(ce[145],le([0,1,40,146,14,36]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yW=S,e.$zW=b;const A="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var $;(function(m){m.Wayland="wayland",m.XWayland="xwayland",m.X11="x11",m.Unknown="unknown"})($||($={}));async function S(m){const f=L.env[A];if(f)return f==="wayland"||f==="x11"?f:"unknown";if(L.env[I]){const p=L.env[P];if(p){const w=(0,j.$kc)(p,"wayland-0");try{return await(0,N.access)(w,R.constants.R_OK),"wayland"}catch(u){return m(u),"unknown"}}else return"unknown"}else return"x11"}function b(m,f){if(f)switch(f){case"auto":return m;case"x11":return m==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return m==="wayland"?"xwayland":"x11"}}),define(ce[147],le([0,1,40,146,274,5]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=A;async function A(I){if(L.$j||L.$i)return;let P;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,N.open)($,R.constants.R_OK);break}catch{}if(!P){I("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const b of(0,j.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!b.includes("="))continue;const m=b.split("=")[0].toUpperCase().trim();if($.has(m)){const f=b.split("=")[1].replace(/"/g,"").toLowerCase().trim();m==="ID"||m==="DISTRIB_ID"?S.id=f:m==="ID_LIKE"?S.id_like=f:(m==="VERSION_ID"||m==="DISTRIB_RELEASE")&&(S.version_id=f)}}return S}catch($){I($)}}}),define(ce[31],le([0,1,40,37,275,6,44,87,14,5,20,8]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=l,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=y;var m;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function f(H,Z=m.UNLINK,W){if((0,A.$tg)(H))throw new Error("rimraf - will refuse to recursively delete root");return Z===m.UNLINK?p(H):h(H,W)}async function h(H,Z=(0,A.$yg)((0,N.tmpdir)())){try{try{await R.promises.rename(H,Z)}catch(W){return W.code==="ENOENT"?void 0:p(H)}p(Z).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(H){return(0,j.promisify)(R.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function w(H){if((0,A.$tg)(H))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function u(H,Z){return c(await(Z?d(H):(0,j.promisify)(R.readdir)(H)))}async function d(H){try{return await(0,j.promisify)(R.readdir)(H,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const Z=[],W=await u(H);for(const J of W){let V=!1,B=!1,ie=!1;try{const oe=await e.Promises.lstat((0,P.$kc)(H,J));V=oe.isFile(),B=oe.isDirectory(),ie=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}Z.push({name:J,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Z}function l(H){return c(R.readdirSync(H))}function c(H){return H.map(Z=>typeof Z=="string"?$.$j?(0,I.$8l)(Z):Z:(Z.name=$.$j?(0,I.$8l)(Z.name):Z.name,Z))}async function g(H){const Z=await u(H),W=[];for(const J of Z)await o.existsDirectory((0,P.$kc)(H,J))&&W.push(J);return W}function i(H,Z=1e3){return new Promise(W=>{let J=!1;const V=setInterval(()=>{J||(J=!0,R.access(H,B=>{J=!1,B&&(clearInterval(V),W(void 0))}))},Z)})}var o;(function(H){async function Z(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if($.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw oe}throw ie}}H.stat=Z;async function W(V){try{const{stat:B,symbolicLink:ie}=await H.stat(V);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}H.existsFile=W;async function J(V){try{const{stat:B,symbolicLink:ie}=await H.stat(V);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}H.existsDirectory=J})(o||(e.SymlinkSupport=o={}));const n=new L.$zh;function s(H,Z,W){return n.queueFor(b.URI.file(H),()=>{const J=v(W);return new Promise((V,B)=>a(H,Z,J,ie=>ie?B(ie):V()))},S.$Ug)}let t=!0;function r(H){t=H}function a(H,Z,W,J){if(!t)return R.writeFile(H,Z,{mode:W.mode,flag:W.flag},J);R.open(H,W.flag,W.mode,(V,B)=>{if(V)return J(V);R.writeFile(B,Z,ie=>{if(ie)return R.close(B,()=>J(ie));R.fdatasync(B,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),R.close(B,te=>J(te))))})})}function y(H,Z,W){const J=v(W);if(!t)return R.writeFileSync(H,Z,{mode:J.mode,flag:J.flag});const V=R.openSync(H,J.flag,J.mode);try{R.writeFileSync(V,Z);try{R.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{R.closeSync(V)}}function v(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function C(H,Z,W=6e4){if(H!==Z)try{$.$i&&typeof W=="number"?await E(H,Z,Date.now(),W):await(0,j.promisify)(R.rename)(H,Z)}catch(J){if(H.toLowerCase()!==Z.toLowerCase()&&J.code==="EXDEV"||H.endsWith("."))await k(H,Z,{preserveSymlinks:!1}),await f(H,m.MOVE);else throw J}}async function E(H,Z,W,J,V=0){try{return await(0,j.promisify)(R.rename)(H,Z)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${B}`),B;if(V===0){let ie=!1;try{const{stat:oe}=await o.stat(Z);oe.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,L.$rh)(Math.min(100,V*10)),E(H,Z,W,J,V+1)}}async function k(H,Z,W){return M(H,Z,{root:{source:H,target:Z},options:W,handledSourcePaths:new Set})}const O=511;async function M(H,Z,W){if(W.handledSourcePaths.has(H))return;W.handledSourcePaths.add(H);const{stat:J,symbolicLink:V}=await o.stat(H);if(V){if(W.options.preserveSymlinks)try{return await X(H,Z,W)}catch{}if(V.dangling)return}return J.isDirectory()?F(H,Z,J.mode&O,W):U(H,Z,J.mode&O)}async function F(H,Z,W,J){await e.Promises.mkdir(Z,{recursive:!0,mode:W});const V=await u(H);for(const B of V)await M((0,P.$kc)(H,B),(0,P.$kc)(Z,B),J)}async function U(H,Z,W){await e.Promises.copyFile(H,Z),await e.Promises.chmod(Z,W)}async function X(H,Z,W){let J=await e.Promises.readlink(H);(0,A.$qg)(J,W.root.source,!$.$k)&&(J=(0,P.$kc)(W.root.target,J.substr(W.root.source.length+1))),await e.Promises.symlink(J,Z)}e.Promises=new class{get access(){return(0,j.promisify)(R.access)}get stat(){return(0,j.promisify)(R.stat)}get lstat(){return(0,j.promisify)(R.lstat)}get utimes(){return(0,j.promisify)(R.utimes)}get read(){return(H,Z,W,J,V)=>new Promise((B,ie)=>{R.read(H,Z,W,J,V,(oe,te,ae)=>oe?ie(oe):B({bytesRead:te,buffer:ae}))})}get readFile(){return(0,j.promisify)(R.readFile)}get write(){return(H,Z,W,J,V)=>new Promise((B,ie)=>{R.write(H,Z,W,J,V,(oe,te,ae)=>oe?ie(oe):B({bytesWritten:te,buffer:ae}))})}get appendFile(){return(0,j.promisify)(R.appendFile)}get fdatasync(){return(0,j.promisify)(R.fdatasync)}get truncate(){return(0,j.promisify)(R.truncate)}get copyFile(){return(0,j.promisify)(R.copyFile)}get open(){return(0,j.promisify)(R.open)}get close(){return(0,j.promisify)(R.close)}get symlink(){return(0,j.promisify)(R.symlink)}get readlink(){return(0,j.promisify)(R.readlink)}get chmod(){return(0,j.promisify)(R.chmod)}get mkdir(){return(0,j.promisify)(R.mkdir)}get unlink(){return(0,j.promisify)(R.unlink)}get rmdir(){return(0,j.promisify)(R.rmdir)}get realpath(){return(0,j.promisify)(R.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return g}get writeFile(){return s}get rm(){return f}get rename(){return C}get copy(){return k}}}),define(ce[148],le([0,1,40,14,5,27,31]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=I,e.$Wq=P,e.$Xq=$,e.$Yq=S;function I(m){if(j.$k)return m;const f=(0,N.$nc)(m);if(m===f)return m;const h=((0,N.$oc)(m)||m).toLowerCase();try{const w=(0,A.readdirSync)(f).filter(u=>u.toLowerCase()===h);if(w.length===1){const u=I(f);if(u)return(0,N.$kc)(u,w[0])}else if(w.length>1){const u=w.indexOf(h);if(u>=0){const d=I(f);if(d)return(0,N.$kc)(d,w[u])}}}catch{}return null}async function P(m,f){if(j.$k)return m;const h=(0,N.$nc)(m);if(m===h)return m;const p=((0,N.$oc)(m)||m).toLowerCase();try{if(f?.isCancellationRequested)return null;const u=(await A.Promises.readdir(h)).filter(d=>d.toLowerCase()===p);if(u.length===1){const d=await P(h,f);if(d)return(0,N.$kc)(d,u[0])}else if(u.length>1){const d=u.indexOf(p);if(d>=0){const l=await P(h,f);if(l)return(0,N.$kc)(l,u[d])}}}catch{}return null}async function $(m){try{return await A.Promises.realpath(m)}catch{const h=b(m);return await A.Promises.access(h,R.constants.R_OK),h}}function S(m){try{return R.realpathSync(m)}catch{const h=b(m);return R.accessSync(h,R.constants.R_OK),h}}function b(m){return(0,L.$bf)((0,N.$ic)(m),N.sep)}}),define(ce[149],le([0,1,14,5,36,89,13,31]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=P,e.$jm=$,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function P(b=j.env){return b.comspec||"cmd.exe"}function $(b){let m=[],f=!1;const h=function(p){if(f){m.push(p);return}(!b.send(p,u=>{if(u&&console.error(u),f=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(l=>h(l))}})||N.$i)&&(f=!0)};return{send:h}}var S;(function(b){async function m(f,h,p){if(R.$jc(f))return f;if(h===void 0&&(h=j.cwd()),R.$nc(f)!=="."||(p===void 0&&A.$4f(j.env.PATH)&&(p=j.env.PATH.split(R.$uc)),p===void 0||p.length===0))return R.$kc(h,f);async function u(d){if(await I.Promises.exists(d)){let l;try{l=await I.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(l=await I.Promises.lstat(d))}return l?!l.isDirectory():!1}return!1}for(const d of p){let l;if(R.$jc(d)?l=R.$kc(d,f):l=R.$kc(h,d,f),await u(l))return l;let c=l+".com";if(await u(c)||(c=l+".exe",await u(c)))return c}return R.$kc(h,f)}b.findExecutable=m})(S||(e.win32=S={}))}),define(ce[150],le([0,1,67,23]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=j;function j(A){return new Promise((I,P)=>{let $;const S=new Map;function b(f,h,p,w,u){const d=S.get(h);if(f===A||d){const l={name:m(p),cmd:p,pid:f,ppid:h,load:w,mem:u};S.set(f,l),f===A&&($=l),d&&(d.children||(d.children=[]),d.children.push(l),d.children.length>1&&(d.children=d.children.sort((c,g)=>c.pid-g.pid)))}}function m(f){const h=/--utility-sub-type=network/i,p=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(p.exec(f))return"electron-crash-reporter";if(w.exec(f))return"winpty-agent";if(u.exec(f))return"conpty-agent";let l=d.exec(f);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?h.exec(f)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const c=/[a-zA-Z-]+\.js/g;let g="";do l=c.exec(f),l&&(g+=l+" ");while(l);return g&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${g})`:f}if(process.platform==="win32"){const f=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substring(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substring(5):h;new Promise((h,p)=>{ne(["@vscode/windows-process-tree"],h,p)}).then(h=>{h.getProcessList(A,p=>{if(!p){P(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(p,w=>{const u=new Map;w.forEach(d=>{const l=f(d.commandLine||"");u.set(d.pid,{name:m(l),cmd:l,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),$=u.get(A),$?(u.forEach(d=>{const l=u.get(d.ppid);l&&(l.children||(l.children=[]),l.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((l,c)=>l.pid-c.pid))}),I($)):P(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let f=function(){let h=[$];const p=[];for(;h.length;){const u=h.shift();u&&(p.push(u.pid),u.children&&(h=h.concat(u.children)))}let w=JSON.stringify(N.$Kg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,R.exec)(w,{},(u,d,l)=>{if(u||l)P(u||new Error(l.toString()));else{const c=d.toString().split(`
`);for(let g=0;g<p.length;g++){const i=S.get(p[g]);i.load=parseFloat(c[g])}if(!$){P(new Error(`Root process ${A} not found`));return}I($)}})};(0,R.exec)("which ps",{},(h,p,w)=>{if(h||w)if(process.platform!=="linux")P(h||new Error(w.toString()));else{const u=JSON.stringify(N.$Kg.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(u,{},(d,l,c)=>{d||c?P(d||new Error(c.toString())):(L(l,b),f())})}else{const u=p.toString().trim();(0,R.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,g)=>{l||g&&!g.includes("screen size is bogus")?P(l||new Error(g.toString())):(L(c,b),process.platform==="linux"?f():$?I($):P(new Error(`Root process ${A} not found`)))})}})}})}function L(A,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=A.toString().split(`
`);for(const S of $){const b=P.exec(S.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var Ee=this&&this.__decorate||function(ne,e,R,N){var j=arguments.length,L=j<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,R):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ne,e,R,N);else for(var I=ne.length-1;I>=0;I--)(A=ne[I])&&(L=(j<3?A(L):j>3?A(e,R,L):A(e,R))||L);return j>3&&L&&Object.defineProperty(e,R,L),L};define(ce[41],le([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=r,e.$4h=a,e.$9h=O,e.$0h=M;var f;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(f||(f={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function w(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function d(V){let B=0;for(let ie=0;;ie+=7){const oe=V.read(1);if(B|=(oe.buffer[0]&127)<<ie,!(oe.buffer[0]&128))return B}}const l=n(0);function c(V,B){if(B===0){V.write(l);return}let ie=0;for(let te=B;te!==0;te=te>>>7)ie++;const oe=j.$Ce.alloc(ie);for(let te=0;B!==0;te++)oe.buffer[te]=B&127,B=B>>>7,B>0&&(oe.buffer[te]|=128);V.write(oe)}class g{constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$1h=g;class i{constructor(){this.a=[]}get buffer(){return j.$Ce.concat(this.a)}write(B){this.a.push(B)}}e.$2h=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const B=j.$Ce.alloc(1);return B.writeUInt8(V,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(V,B){if(typeof B>"u")V.write(s.Undefined);else if(typeof B=="string"){const ie=j.$Ce.fromString(B);V.write(s.String),c(V,ie.byteLength),V.write(ie)}else if(t&&Buffer.isBuffer(B)){const ie=j.$Ce.wrap(B);V.write(s.Buffer),c(V,ie.byteLength),V.write(ie)}else if(B instanceof j.$Ce)V.write(s.VSBuffer),c(V,B.byteLength),V.write(B);else if(Array.isArray(B)){V.write(s.Array),c(V,B.length);for(const ie of B)r(V,ie)}else if(typeof B=="number"&&(B|0)===B)V.write(s.Uint),c(V,B);else{const ie=j.$Ce.fromString(JSON.stringify(B));V.write(s.Object),c(V,ie.byteLength),V.write(ie)}}function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(d(V)).toString();case o.Buffer:return V.read(d(V)).buffer;case o.VSBuffer:return V.read(d(V));case o.Array:{const ie=d(V),oe=[];for(let te=0;te<ie;te++)oe.push(a(V));return oe}case o.Object:return JSON.parse(V.read(d(V)).toString());case o.Int:return d(V)}}class y{constructor(B,ie,oe=null,te=1e3){this.h=B,this.j=ie,this.k=oe,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,w(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,w(B.type),B.data);return}}}o(B,ie=void 0){const oe=new i;return r(oe,B),r(oe,ie),this.p(oe.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new g(B),oe=a(ie),te=a(ie),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(B.byteLength,oe[1],1,`${h(ae)}: ${oe[2]}.${oe[3]}`,te),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 102:return this.k?.logIncoming(B.byteLength,oe[1],1,`${h(ae)}: ${oe[2]}.${oe[3]}`,te),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 101:return this.k?.logIncoming(B.byteLength,oe[1],1,`${h(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(B.byteLength,oe[1],1,`${h(ae)}`),this.u({type:ae,id:oe[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const oe=new L.$me;let te;try{te=ie.call(this.j,B.name,B.arg,oe.token)}catch(q){te=Promise.reject(q)}const ae=B.id;te.then(q=>{this.m({id:ae,data:q,type:201})},q=>{q instanceof Error?this.m({id:ae,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ae,data:q,type:203})}).finally(()=>{G.dispose(),this.d.delete(B.id)});const G=(0,$.$Sc)(()=>oe.cancel());this.d.set(B.id,G)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const oe=B.id,ae=ie.listen(this.j,B.name,B.arg)(G=>this.m({id:oe,data:G,type:204}));this.d.set(B.id,ae)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const oe=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:oe})}w(B){const ie=this.g.get(B);if(ie){for(const oe of ie)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$5h=y;var v;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class C{constructor(B,ie=null){this.l=B,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ie}getChannel(B){const ie=this;return{call(oe,te,ae){return ie.a?Promise.reject(new I.$5):ie.m(B,oe,te,ae)},listen(oe,te){return ie.a?P.Event.None:ie.o(B,oe,te)}}}m(B,ie,oe,te=L.CancellationToken.None){const ae=this.g++,q={id:ae,type:100,channelName:B,name:ie,arg:oe};if(te.isCancellationRequested)return Promise.reject(new I.$5);let D;return new Promise((z,x)=>{if(te.isCancellationRequested)return x(new I.$5);const K=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(ae),z(ue.data);break;case 202:{this.f.delete(ae);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(ae),x(ue.data);break}};this.f.set(ae,se),this.p(q)};let ee=null;this.b===u.Idle?K():(ee=(0,N.$dh)(se=>this.u()),ee.then(()=>{ee=null,K()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:ae,type:101}),x(new I.$5)},Y=te.onCancellationRequested(_);D=(0,$.$Rc)((0,$.$Sc)(_),Y),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(B,ie,oe){const te=this.g++,G={id:te,type:102,channelName:B,name:ie,arg:oe};let q=null;const D=new P.$be({onWillAddFirstListener:()=>{q=(0,N.$dh)(z=>this.u()),q.then(()=>{q=null,this.d.add(D),this.p(G)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(D),this.p({id:te,type:103}))}}),T=z=>D.fire(z.data);return this.f.set(te,T),D.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,h(B.type));return}}}q(B,ie=void 0){const oe=new i;return r(oe,B),r(oe,ie),this.r(oe.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new g(B),oe=a(ie),te=a(ie),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(B.byteLength,0,0,w(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,oe[1],0,w(ae),te),this.t({type:oe[0],id:oe[1],data:te})}}t(B){if(B.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$6h=C,Ee([A.$Uh],C.prototype,"onDidInitializePromise",null);class E{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,oe){this.a=new Map,this.f=new Set,this.g=new P.$be,this.onDidAddConnection=this.g.event,this.h=new P.$be,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(B(({protocol:te,onDidClientDisconnect:ae})=>{const G=P.Event.once(te.onMessage);this.j.add(G(q=>{const D=new g(q),T=a(D),z=new y(te,T,ie,oe),x=new C(te,ie);this.a.forEach((ee,_)=>z.registerChannel(_,ee));const K={channelServer:z,channelClient:x,ctx:T};this.f.add(K),this.g.fire(K),this.j.add(ae(()=>{z.dispose(),x.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(B,ie){const oe=this;return{call(te,ae,G){let q;if((0,m.$fg)(ie)){const T=(0,R.$4b)(oe.connections.filter(ie));q=T?Promise.resolve(T):P.Event.toPromise(P.Event.filter(oe.onDidAddConnection,ie))}else q=ie.routeCall(oe,te,ae);const D=q.then(T=>T.channelClient.getChannel(B));return O(D).call(te,ae,G)},listen(te,ae){if((0,m.$fg)(ie))return oe.k(B,ie,te,ae);const G=ie.routeEvent(oe,te,ae).then(q=>q.channelClient.getChannel(B));return O(G).listen(te,ae)}}}k(B,ie,oe,te){const ae=this;let G;const q=new P.$be({onWillAddFirstListener:()=>{G=new $.$Tc;const D=new P.$he,T=new Map,z=K=>{const _=K.channelClient.getChannel(B).listen(oe,te),Y=D.add(_);T.set(K,Y)},x=K=>{const ee=T.get(K);ee&&(ee.dispose(),T.delete(K))};ae.connections.filter(ie).forEach(z),P.Event.filter(ae.onDidAddConnection,ie)(z,void 0,G),ae.onDidRemoveConnection(x,void 0,G),D.event(q.fire,q,G),G.add(D)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return q.event}registerChannel(B,ie){this.a.set(B,ie);for(const oe of this.f)oe.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=E;class k{constructor(B,ie,oe=null){const te=new i;r(te,ie),B.send(te.buffer),this.a=new C(B,oe),this.d=new y(B,ie,oe)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=k;function O(V){return{call(B,ie,oe){return V.then(te=>te.call(B,ie,oe))},listen(B,ie){const oe=new P.$ke;return V.then(te=>oe.input=te.listen(B,ie)),oe.event}}}function M(V){let B=!1;return{call(ie,oe,te){return B?V.call(ie,oe,te):(0,N.$rh)(0).then(()=>B=!0).then(()=>V.call(ie,oe,te))},listen(ie,oe){if(B)return V.listen(ie,oe);const te=new P.$ke;return(0,N.$rh)(0).then(()=>B=!0).then(()=>te.input=V.listen(ie,oe)),te.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$$h=F;var U;(function(V){function B(ae,G,q){const D=ae,T=q&&q.disableMarshalling,z=new Map;for(const x in D)oe(x)&&z.set(x,P.Event.buffer(D[x],!0,void 0,G));return new class{listen(x,K,ee){const _=z.get(K);if(_)return _;const Y=D[K];if(typeof Y=="function"){if(te(K))return Y.call(D,ee);if(oe(K))return z.set(K,P.Event.buffer(D[K],!0,void 0,G)),z.get(K)}throw new I.$bb(`Event not found: ${K}`)}call(x,K,ee){const _=D[K];if(typeof _=="function"){if(!T&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,S.$Zh)(ee[se]);let Y=_.apply(D,ee);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new I.$bb(`Method not found: ${K}`)}}}V.fromService=B;function ie(ae,G){const q=G&&G.disableMarshalling;return new Proxy({},{get(D,T){if(typeof T=="string")return G?.properties?.has(T)?G.properties.get(T):te(T)?function(z){return ae.listen(T,z)}:oe(T)?ae.listen(T):async function(...z){let x;G&&!(0,m.$ag)(G.context)?x=[G.context,...z]:x=z;const K=await ae.call(T,x);return q?K:(0,S.$Zh)(K)};throw new I.$bb(`Property not found: ${String(T)}`)}})}V.toService=ie;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&b.$sf(ae.charCodeAt(2))}function te(ae){return/^onDynamic/.test(ae)&&b.$sf(ae.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const B=V.toString();if(B!=="[object Object]")return B}return V}function Z(V){return Array.isArray(V)?V.map(H):H(V)}function W(V,B,ie,oe,te,ae,G){G=Z(G);const q=X[te],D=q[oe%q.length];let T=[`%c[${V}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ae)?(T=T.concat(G),T.push(")")):T.push(G),console.log.apply(console,T)}class J{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,oe,te,ae){this.b+=B,W(this.d,this.b,B,ie,oe,te,ae)}logIncoming(B,ie,oe,te,ae){this.a+=B,W(this.f,this.a,B,ie,oe,te,ae)}}e.$_h=J}),define(ce[68],le([0,1,15,3,2,41]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(v,C){if(!t.has(v)){const E=String(++r);t.set(v,E)}return t.get(v)}function y(v,C,E,k){if(!s.enableDiagnostics)return;const O=a(v,C);if(k instanceof R.$Ce||k instanceof Uint8Array||k instanceof ArrayBuffer||ArrayBuffer.isView(k)){const M=R.$Ce.alloc(k.byteLength);M.set(k),s.records.push({timestamp:Date.now(),id:O,label:C,type:E,buff:M})}else s.records.push({timestamp:Date.now(),id:O,label:C,type:E,data:k})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let $=null;function S(){return $||($=R.$Ce.alloc(0)),$}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return S();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const C=this.a[0];return r&&(this.a.shift(),this.b-=t),C}if(this.a[0].byteLength>t){const C=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),C}const a=R.$Ce.alloc(t);let y=0,v=0;for(;t>0;){const C=this.a[v];if(C.byteLength>t){const E=C.slice(0,t);a.set(E,y),y+=t,r&&(this.a[v]=C.slice(t),this.b-=t),t-=t}else a.set(C,y),y+=C.byteLength,r?(this.a.shift(),this.b-=C.byteLength):v++,t-=C.byteLength}return a}}e.$ai=b;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(h||(e.ProtocolConstants=h={}));class p{constructor(t,r,a,y){this.type=t,this.id=r,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends j.$Uc{constructor(t){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new b,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,y=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,y,v,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Ce.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=R.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends j.$Uc{constructor(t){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new u(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$bi=d;class l extends L.$8h{static fromSocket(t,r){return new l(new d(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$ci=l;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$di=c;class g{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new g(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let y=0;y<o.a;y++)t-this.c[y]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Tc,this.o=t.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,S());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,S());this.p.write(t)}sendResume(){const t=new p(8,0,0,S());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,S());this.p.write(t);const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,S())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,y=r.length;a<y;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(r>=2e4&&a>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const v=Math.max(2e4-r,2e4-a,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,S());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,S());this.p.write(t)}}e.$ei=n}),define(ce[92],le([0,1,67,6,15,26,142,7,3,2,30,149,89,41]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class h extends f.$5h{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>j.$Ce.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Rq=h;class p{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.$be,this.onDidProcessExit=this.h.event;const l=d&&d.timeout?d.timeout:6e4;this.b=new N.$nh(l),this.d=null,this.f=null}getChannel(u){const d=this;return{call(l,c,g){return d.k(u,l,c,g)},listen(l,c){return d.l(u,l,c)}}}k(u,d,l,c=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const g=this.n(u),i=(0,N.$dh)(s=>g.call(d,l,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,$.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,d,l){if(!this.b)return P.Event.None;this.b.cancel();let c;const g=new P.$be({onWillAddFirstListener:()=>{c=this.n(u).listen(d,l)(g.fire,g),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,S.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.$hm)(d.env),this.d=(0,R.fork)(this.i,u,d);const l=new P.$be,g=P.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$Nq)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}l.fire(j.$Ce.wrap(Buffer.from(r,"base64")))}),i=this.j.useQueue?(0,b.$jm)(this.d):this.d,o=r=>this.d&&this.d.connected&&i.send(r.buffer.toString("base64")),n=l.event,s={send:o,onMessage:n};this.f=new f.$6h(s);const t=()=>this.o();process.once("exit",t),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",t),g.dispose(),this.c.forEach(y=>(0,$.$Pc)(y)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=p}),define(ce[151],le([0,1,134,15,41,3,13,17]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QW=void 0,e.$RW=S;class P{constructor(m){this.a=m,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?N.$Ce.wrap(f.data):N.$Ce.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class $ extends j.$7h{static b(m){(0,A.$bg)((0,R.$PW)(process),"Electron Utility Process");const f=new L.$be;return process.parentPort.on("message",h=>{if(m?.handledClientConnection(h))return;const p=(0,I.$Ob)(h.ports);p&&f.fire(p)}),L.Event.map(f.event,h=>({protocol:new P(h),onDidClientDisconnect:L.Event.fromNodeEventEmitter(h,"close")}))}constructor(m){super($.b(m))}}e.$QW=$;function S(b,m,f){const h=p=>{p.data===m&&(b.removeListener("message",h),f())};b.on("message",h)}}),define(ce[69],le([0,1,6,3,2,66,13]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=P;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function P(m){const f=m;return f?.changed instanceof Map||f?.deleted instanceof Set}var $;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})($||(e.StorageState=$={}));class S extends j.$Uc{static{this.a=100}constructor(f,h=Object.create(null)){super(),this.r=f,this.s=h,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new R.$oh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((h,p)=>this.w(p,h)),f.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(f,h){if(this.c===$.Closed)return;let p=!1;(0,A.$ag)(h)?p=this.f.delete(f):this.f.get(f)!==h&&(this.f.set(f,h),p=!0),p&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,h){const p=this.f.get(f);return(0,A.$ag)(p)?h:p}getBoolean(f,h){const p=this.get(f);return(0,A.$ag)(p)?h:p==="true"}getNumber(f,h){const p=this.get(f);return(0,A.$ag)(p)?h:parseInt(p,10)}getObject(f,h){const p=this.get(f);return(0,A.$ag)(p)?h:(0,L.$Yh)(p)}async set(f,h,p=!1){if(this.c===$.Closed)return;if((0,A.$ag)(h))return this.delete(f,p);const w=(0,A.$6f)(h)||Array.isArray(h)?(0,L.$Xh)(h):String(h);if(this.f.get(f)!==w)return this.f.set(f,w),this.j.set(f,w),this.h.delete(f),this.b.fire({key:f,external:p}),this.D()}async delete(f,h=!1){if(!(this.c===$.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:h}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Qp=S;class b{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((h,p)=>this.a.set(p,h)),f.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$Rp=b}),define(ce[152],le([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ce[70],le([0,1,40,6,14,13,31,152]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.zip=w,e.$cq=u,e.$dq=l,e.$_p="end of central directory record signature not found";const P=new RegExp(e.$_p);class $ extends Error{constructor(g,i){let o=i.message;switch(g){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=g,this.cause=i}}e.$aq=$;function S(c){const g=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,o)=>i+o,g&61440)}function b(c){if(c instanceof $)return c;let g;return P.test(c.message)&&(g="CorruptZip"),new $(g,c)}function m(c,g,i,o,n,s){const t=j.$nc(g),r=j.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(I.localize(0,null,g)));const a=j.$kc(o,g);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((v,C)=>{if(!s.isCancellationRequested)try{y=(0,R.createWriteStream)(a,{mode:i}),y.once("close",()=>v()),y.once("error",C),c.once("error",C),c.pipe(y)}catch(E){C(E)}}))}function f(c,g,i,o){let n=(0,N.$dh)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const y=new N.$lh,v=C=>{C.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new $("Incomplete",new Error(I.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",C=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){v(o);return}const E=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(E)){const M=j.$kc(g,E);n=(0,N.$dh)(F=>A.Promises.mkdir(M,{recursive:!0}).then(()=>v(F)).then(void 0,a));return}const k=p(c,C),O=S(C);n=(0,N.$dh)(M=>y.queue(()=>k.then(F=>m(F,E,O,g,i,M).then(()=>v(M)))).then(null,a))})}).finally(()=>t.dispose())}async function h(c,g=!1){const{open:i}=await new Promise((o,n)=>{ne(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,g?{lazyEntries:!0}:void 0,(s,t)=>{s?n(b(s)):o((0,L.$cg)(t))})})}function p(c,g){return new Promise((i,o)=>{c.openReadStream(g,(n,s)=>{n?o(b(n)):i((0,L.$cg)(s))})})}async function w(c,g){const{ZipFile:i}=await new Promise((o,n)=>{ne(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;g.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,R.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function u(c,g,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=h(c,!0);return i.overwrite&&(s=s.then(t=>A.Promises.rm(g).then(()=>t))),s.then(t=>f(t,g,{sourcePathRegex:n},o))}function d(c,g){return h(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===g&&p(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(I.localize(2,null,g))))}))}function l(c,g){return d(c,g).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(ce[153],le([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[154],le([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[155],le([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ce[156],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[157],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[158],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[159],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[160],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[161],le([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[162],le([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[163],le([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ce[164],le([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ce[165],le([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ce[166],le([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[167],le([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[168],le([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ce[169],le([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[170],le([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[171],le([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ce[172],le([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[173],le([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[174],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[175],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[176],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[177],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[178],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[179],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[180],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[181],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[182],le([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[183],le([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ce[184],le([0,1,7,155]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var j;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(j||(e.TokenType=j={}));function L(...$){switch($.length){case 1:return(0,N.localize)(0,null,$[0]);case 2:return(0,N.localize)(1,null,$[0],$[1]);case 3:return(0,N.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const b=this.d,m=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:m};this.g.push({offset:b,lexeme:m,additionalInfo:S}),this.f.push(f)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const b=this.c.substring(this.d,this.e),m=P.b.get(b);m?this.k(m):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,b=!1,m=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(I);return}const h=this.c.charCodeAt(S);if(b)b=!1;else if(h===47&&!m){S++;break}else h===91?m=!0:h===92?b=!0:h===93&&(m=!1);S++}for(;S<this.c.length&&P.a.has(this.c.charCodeAt(S));)S++;this.e=S;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=P}),define(ce[185],le([0,1,65,84,23,14,36,20,8]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$1m=S,e.$2m=b,e.$Ym=/^([^.]+\..+)[:=](.+)$/;class ${get appRoot(){return(0,L.$nc)(j.$Kg.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,L.$kc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.$4g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$4g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,R.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$kc)(this.userDataPath,"logs",f)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$4g)(P.URI.file((0,L.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$4g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$4g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$4g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?P.URI.file((0,L.$kc)(f,"argv.json")):(0,I.$4g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,L.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,L.$lc)(f):(0,L.$ic)((0,L.$kc)(j.$Kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?P.URI.file((0,L.$lc)(f)):P.URI.file((0,L.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,L.$lc)(f);const h=A.env.VSCODE_EXTENSIONS;if(h)return h;const p=A.env.VSCODE_PORTABLE;return p?(0,L.$kc)(p,"extensions"):(0,I.$4g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(h=>/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,L.$ic)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?P.URI.parse(f):P.URI.file((0,L.$ic)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Ym.test(f))}get extensionLogLevel(){const f=[];for(const h of this.args.log||[]){const p=e.$Ym.exec(h);p&&p[1]&&p[2]&&f.push([p[1],p[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,I.$4g)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?P.URI.file((0,L.$kc)(f,"policy.json")):(0,I.$4g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,h,p){this.a=f,this.b=h,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Zm=$,Ee([N.$Uh],$.prototype,"appRoot",null),Ee([N.$Uh],$.prototype,"userHome",null),Ee([N.$Uh],$.prototype,"userDataPath",null),Ee([N.$Uh],$.prototype,"appSettingsHome",null),Ee([N.$Uh],$.prototype,"tmpDir",null),Ee([N.$Uh],$.prototype,"cacheHome",null),Ee([N.$Uh],$.prototype,"stateResource",null),Ee([N.$Uh],$.prototype,"userRoamingDataHome",null),Ee([N.$Uh],$.prototype,"userDataSyncHome",null),Ee([N.$Uh],$.prototype,"sync",null),Ee([N.$Uh],$.prototype,"machineSettingsResource",null),Ee([N.$Uh],$.prototype,"workspaceStorageHome",null),Ee([N.$Uh],$.prototype,"localHistoryHome",null),Ee([N.$Uh],$.prototype,"keyboardLayoutResource",null),Ee([N.$Uh],$.prototype,"argvResource",null),Ee([N.$Uh],$.prototype,"isExtensionDevelopment",null),Ee([N.$Uh],$.prototype,"untitledWorkspacesHome",null),Ee([N.$Uh],$.prototype,"builtinExtensionsPath",null),Ee([N.$Uh],$.prototype,"extensionsPath",null),Ee([N.$Uh],$.prototype,"extensionDevelopmentLocationURI",null),Ee([N.$Uh],$.prototype,"extensionDevelopmentKind",null),Ee([N.$Uh],$.prototype,"extensionTestsLocationURI",null),Ee([N.$Uh],$.prototype,"debugExtensionHost",null),Ee([N.$Uh],$.prototype,"logLevel",null),Ee([N.$Uh],$.prototype,"extensionLogLevel",null),Ee([N.$Uh],$.prototype,"serviceMachineIdResource",null),Ee([N.$Uh],$.prototype,"disableTelemetry",null),Ee([N.$Uh],$.prototype,"disableWorkspaceTrust",null),Ee([N.$Uh],$.prototype,"useInMemorySecretStorage",null),Ee([N.$Uh],$.prototype,"policyFile",null);function S(m,f){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}function b(m,f,h,p,w,u){const l=Number(f||m)||(p?null:h),c=l?!!f:!1;let g;if(u)try{g=JSON.parse(u)}catch{}return{port:l,break:c,debugId:w,env:g}}}),function(){"use strict";function ne(e,R,N){function j(A,I){const P=L(A,I),$=[P];return e.isAbsolute(P)||$.unshift(N),e.resolve(...$)}function L(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,I);const S=A["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(b,"AppData","Roaming")}break;case"darwin":$=e.join(R.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,I)}return{getUserDataPath:j}}if(typeof define=="function")define(ce[186],le([276,37,36]),function(e,R,N){return ne(e,R,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ne(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[187],le([0,1,37,185,186]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=void 0,e.$4m=A,e.$5m=I;class L extends N.$Zm{constructor($,S){super($,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,j.getUserDataPath)($,S.nameShort)},S)}}e.$3m=L;function A(P,$){return(0,N.$2m)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,$,P.extensionEnvironment)}function I(P,$){return(0,N.$2m)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,$,P.extensionEnvironment)}}),define(ce[188],le([0,1,13,158]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=j;function j(A,I,P,$){try{L(A,I,P,$)}catch(S){A.error(S?.message??S)}return I}function L(A,I,P,$){const S=(b,m,f)=>{const h=b[m];if((0,R.$4f)(h)){const p=h,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const u=p.substr(1,w-2);let d=P[u];d===void 0&&$&&(d=$[u]);const l=typeof d=="string"?d:d?.message,c=$?.[u],g=typeof c=="string"?c:c?.message;if(!l){g||A.warn(`[${I.name}]: ${(0,N.localize)(0,null,u)}`);return}if(f&&(m==="title"||m==="category")&&g&&g!==l){const i={value:l,original:g};b[m]=i}else b[m]=l}}else if((0,R.$6f)(h))for(const p in h)h.hasOwnProperty(p)&&(p==="commands"?S(h,p,!0):S(h,p,f));else if(Array.isArray(h))for(let p=0;p<h.length;p++)S(h,p,f)};for(const b in I)I.hasOwnProperty(b)&&S(I,b)}}),define(ce[189],le([0,1,70,161]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=j;function j(L){return(0,R.$dq)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ce[190],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;class R{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Wdc=R;class N{constructor(L){this.a=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${A}`)}}e.$Xdc=N}),define(ce[71],le([0,1,20,88,162,55]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=P,e.$Bp=$,e.$Cp=S,e.$Dp=b,e.$Ep=m,e.$Fp=f,e.$Gp=h;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(u){return u=u.trim(),u==="*"||A.test(u)}function $(u){if(!P(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(A);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function S(u){if(!u)return null;const d=u.majorBase,l=u.majorMustEqual,c=u.minorBase;let g=u.minorMustEqual;const i=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(g=!1),o=!1);let n=0;if(u.preRelease){const s=I.exec(u.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:l,minorBase:c,minorMustEqual:g,patchBase:i,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:n}}function b(u,d,l){let c;typeof u=="string"?c=S($(u)):c=u;let g;d instanceof Date?g=d.getTime():typeof d=="string"&&(g=new Date(d).getTime());let i;if(typeof l=="string"?i=S($(l)):i=l,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const y=i.notBefore;let v=i.majorMustEqual,C=i.minorMustEqual,E=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||g&&g<y?!1:s>=a:(o===1&&t===0&&(!v||!C||!E)&&(t=1,r=0,a=0,v=!0,C=!1,E=!1),o<t?!1:o>t?!v:n<r?!1:n>r?!C:s<a?!1:s>a?!E:!(g&&g<y))}function m(u,d,l,c,g){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,j.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,j.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,j.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,j.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,j.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!w(c.extensionDependencies))return i.push([N.default.Error,j.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!w(c.activationEvents))return i.push([N.default.Error,j.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,j.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,j.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,j.localize(9,null,"main")]),i;{const s=(0,R.$4g)(l,c.main);(0,R.$Xg)(s,l)||i.push([N.default.Warning,j.localize(10,null,s.path,l.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,j.localize(11,null,"browser")]),i;{const s=(0,R.$4g)(l,c.browser);(0,R.$Xg)(s,l)||i.push([N.default.Warning,j.localize(12,null,s.path,l.path)])}}if(!L.valid(c.version))return i.push([N.default.Error,j.localize(13,null)]),i;const o=[];if(!f(u,d,c,g,o))for(const s of o)i.push([N.default.Error,s]);return i}function f(u,d,l,c,g){return c||typeof l.main>"u"&&typeof l.browser>"u"?!0:p(u,d,l.engines.vscode,g)}function h(u,d,l){return u==="*"||p(d,l,u)}function p(u,d,l,c=[]){const g=S($(l));if(!g)return c.push(j.localize(14,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(j.localize(15,null,l)),!1}else if(!g.majorMustEqual)return c.push(j.localize(16,null,l)),!1;return b(u,d,g)?!0:(c.push(j.localize(17,null,u,l)),!1)}function w(u){if(!Array.isArray(u))return!1;for(let d=0,l=u.length;d<l;d++)if(typeof u[d]!="string")return!1;return!0}}),define(ce[45],le([0,1,15,32]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=j;async function j(L,A,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const S=(await A.readFile(L.serviceMachineIdResource)).value.toString();P=(0,N.$Lg)(S)?S:null}catch{P=null}if(!P){P=(0,N.$Mg)();try{await A.writeFile(L.serviceMachineIdResource,R.$Ce.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}}),define(ce[72],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class R{constructor(j,L=[],A=!1){this.ctor=j,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$ni=R}),define(ce[191],le([0,1,72]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=L,e.$ps=A;const N=[];var j;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function L(I,P,$){P instanceof R.$ni||(P=new R.$ni(P,[],!!$)),N.push([I,P])}function A(){return N}}),define(ce[192],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class R{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$5q=R;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const I=this.lookupOrInsertNode(L),P=this.lookupOrInsertNode(A);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let I=this.a.get(A);return I||(I=new R(A,L),this.a.set(A,I)),I}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,I]of this.a)L.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const I=new Set([L]),P=this.c(A,I);if(P)return P}}c(L,A){for(const[I,P]of L.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const $=this.c(P,A);if($)return $;A.delete(I)}}}e.$6q=N}),define(ce[4],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=j,e.$ri=L;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(R||(e._util=R={})),e.$pi=j("instantiationService");function N(A,I,P){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:A,index:P}):(I[R.DI_DEPENDENCIES]=[{id:A,index:P}],I[R.DI_TARGET]=I)}function j(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const I=function(P,$,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,P,S)};return I.toString=()=>A,R.serviceIds.set(A,I),I}function L(A){return A}}),define(ce[193],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0,e.$wdc=(0,R.$qi)("checksumService")}),define(ce[21],le([0,1,13,8,4]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=L,e.$Yi=A,e.$Zi=P,e.$1i=$,e.$2i=S,e.$3i=b,e.$4i=m,e.$5i=h,e.$6i=p,e.$7i=w,e.$Wi=(0,j.$qi)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function P(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function S(u,d){const l=Object.create(null);for(const c in u)b(l,c,u[c],d);return l}function b(u,d,l,c){const g=d.split("."),i=g.pop();let o=u;for(let n=0;n<g.length;n++){const s=g[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":if(t===null){c(`Ignoring ${d} as ${g.slice(0,n+1).join(".")} is null`);return}break;default:c(`Ignoring ${d} as ${g.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{c(`Ignoring ${d} as ${g.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${g.join(".")} is ${JSON.stringify(o)}`)}function m(u,d){const l=d.split(".");f(u,l)}function f(u,d){const l=d.shift();if(d.length===0){delete u[l];return}if(Object.keys(u).indexOf(l)!==-1){const c=u[l];typeof c=="object"&&!Array.isArray(c)&&(f(c,d),Object.keys(c).length===0&&delete u[l])}}function h(u,d,l){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const g=d.split("."),i=c(u,g);return typeof i>"u"?l:i}function p(u,d,l){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in u?R.$6f(u[c])&&R.$6f(d[c])?p(u[c],d[c],l):l&&(u[c]=d[c]):u[c]=d[c])})}function w(u){return u.replace(/[\[\]]/g,"")}}),define(ce[93],le([0,1,5,27,184,4,154,7]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=$,e.$pj=o,e.$qj=n,e.$Jj=te;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",R.$j),P.set("isLinux",R.$k),P.set("isWindows",R.$i),P.set("isWeb",R.$o),P.set("isMacNative",R.$j&&!R.$o),P.set("isEdge",R.$H),P.set("isFirefox",R.$F),P.set("isChrome",R.$E),P.set("isSafari",R.$G);function $(q,D){if(P.get(q)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(q,D)}const S=Object.prototype.hasOwnProperty;var b;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const m={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),h=(0,A.localize)(1,null),p=(0,A.localize)(2,null),w=(0,A.localize)(3,null),u=(0,A.localize)(4,null),d=(0,A.localize)(5,null),l=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=m){this.k=D,this.d=new j.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const z=this.D(),x=z.type===17?d:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:j.$lj.getLexeme(z),additionalInfo:x}),g.c}return T}catch(T){if(T!==g.c)throw T;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const T=this.o();D.push(T)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const T=this.s();D.push(T)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,w),T?.negate()}case 17:return this.z(),k.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,w),T}case 17:{const T=D.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const K=x.lexeme,ee=K.lastIndexOf("/"),_=ee===K.length-1?void 0:this.w(K.substring(ee+1));let Y;try{Y=new RegExp(K.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return H.create(T,Y)}switch(x.type){case 10:case 19:{const K=[x.lexeme];this.z();let ee=this.D(),_=0;for(let fe=0;fe<x.lexeme.length;fe++)x.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--}if(_<0)break;K.push(j.$lj.getLexeme(ee)),this.z(),ee=this.D()}const Y=K.join(""),se=Y.lastIndexOf("/"),ue=se===Y.length-1?void 0:this.w(Y.substring(se+1));let ge;try{ge=new RegExp(Y.substring(1,se),ue)}catch{throw this.B("REGEX",x)}return i.regex(T,ge)}case 18:{const K=x.lexeme;this.z();let ee=null;if(!(0,N.$3e)(K)){const _=K.indexOf("/"),Y=K.lastIndexOf("/");if(_!==Y&&_>=0){const se=K.slice(_+1,Y),ue=K[Y+1]==="i"?"i":"";try{ee=new RegExp(se,ue)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return H.create(T,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const x=this.u();return i.notIn(T,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return i.equals(T,x);switch(x){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return i.notEquals(T,x);switch(x){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,x)}}case 5:return this.z(),U.create(T,this.u());case 6:return this.z(),X.create(T,this.u());case 7:return this.z(),M.create(T,this.u());case 8:return this.z(),F.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:l,offset:D.offset,lexeme:"",additionalInfo:c}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,T){if(this.C(D))return this.z();throw this.B(T,this.D())}B(D,T,z){const x=(0,A.localize)(8,null,D,j.$lj.getLexeme(T)),K=T.offset,ee=j.$lj.getLexeme(T);return this.h.push({message:x,offset:K,lexeme:ee,additionalInfo:z}),g.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=g;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(D){return a.create(D)}static equals(D,T){return y.create(D,T)}static notEquals(D,T){return E.create(D,T)}static regex(D,T){return H.create(D,T)}static in(D,T){return v.create(D,T)}static notIn(D,T){return C.create(D,T)}static not(D){return k.create(D)}static and(...D){return J.create(D,null,!0)}static or(...D){return V.create(D,null,!0)}static greater(D,T){return M.create(D,T)}static greaterEquals(D,T){return F.create(D,T)}static smaller(D,T){return U.create(D,T)}static smallerEquals(D,T){return X.create(D,T)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$oj=i;function o(q){const D=new g({regexParsingWithErrorRecovery:!1});return q.map(T=>(D.parse(T),D.lexingErrors.length>0?D.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(q,D){const T=q?q.substituteConstants():void 0,z=D?D.substituteConstants():void 0;return!T&&!z?!0:!T||!z?!1:T.equals(z)}function s(q,D){return q.cmp(D)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$rj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return t.INSTANCE}}e.$sj=r;class a{static create(D,T=null){const z=P.get(D);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new a(D,T)}constructor(D,T){this.key=D,this.c=T,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=P.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:t.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=k.create(this.key,this)),this.c}}e.$tj=a;class y{static create(D,T,z=null){if(typeof T=="boolean")return T?a.create(D,z):k.create(D,z);const x=P.get(D);return typeof x=="boolean"?T===(x?"true":"false")?r.INSTANCE:t.INSTANCE:new y(D,T,z)}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=P.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$uj=y;class v{static create(D,T){return new v(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.f),z=D.getValue(this.d);return Array.isArray(T)?T.includes(z):typeof z=="string"&&typeof T=="object"&&T!==null?S.call(T,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$vj=v;class C{static create(D,T){return new C(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=11,this.c=v.create(D,T)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=C;class E{static create(D,T,z=null){if(typeof T=="boolean")return T?k.create(D,z):a.create(D,z);const x=P.get(D);return typeof x=="boolean"?T===(x?"true":"false")?t.INSTANCE:r.INSTANCE:new E(D,T,z)}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=P.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$xj=E;class k{static create(D,T=null){const z=P.get(D);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new k(D,T)}constructor(D,T){this.c=D,this.d=T,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=P.get(this.c);return typeof D=="boolean"?D?t.INSTANCE:r.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$yj=k;function O(q,D){if(typeof q=="string"){const T=parseFloat(q);isNaN(T)||(q=T)}return typeof q=="string"||typeof q=="number"?D(q):t.INSTANCE}class M{static create(D,T,z=null){return O(T,x=>new M(D,x,z))}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$zj=M;class F{static create(D,T,z=null){return O(T,x=>new F(D,x,z))}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Aj=F;class U{static create(D,T,z=null){return O(T,x=>new U(D,x,z))}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Bj=U;class X{static create(D,T,z=null){return O(T,x=>new X(D,x,z))}constructor(D,T,z){this.c=D,this.d=T,this.f=z,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Cj=X;class H{static create(D,T){return new H(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const T=this.f?this.f.source:"",z=D.f?D.f.source:"";return T<z?-1:T>z?1:0}equals(D){if(D.type===this.type){const T=this.f?this.f.source:"",z=D.f?D.f.source:"";return this.d===D.d&&T===z}return!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Dj=H;class Z{static create(D){return new Z(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new Z(this.c.map(D))}negate(){return this.c}}e.$Ej=Z;function W(q){let D=null;for(let T=0,z=q.length;T<z;T++){const x=q[T].substituteConstants();if(q[T]!==x&&D===null){D=[];for(let K=0;K<T;K++)D[K]=q[K]}D!==null&&(D[T]=x)}return D===null?q:D}class J{static create(D,T,z){return J.d(D,T,z)}constructor(D,T){this.expr=D,this.c=T,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,z=this.expr.length;T<z;T++){const x=s(this.expr[T],D.expr[T]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:J.create(D,this.c,!1)}evaluate(D){for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].evaluate(D))return!1;return!0}static d(D,T,z){const x=[];let K=!1;for(const ee of D)if(ee){if(ee.type===1){K=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&K)return r.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Y=x.length===0,se=V.create(ee.expr.map(ue=>J.create([ue,_],null,z)),null,Y);se&&(x.push(se),x.sort(s))}if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return t.INSTANCE;if(x.length===1)return x[0]}return new J(x,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new J(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());this.c=V.create(D,this,!0)}return this.c}}e.$Fj=J;class V{static create(D,T,z){return V.d(D,T,z)}constructor(D,T){this.expr=D,this.c=T,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,z=this.expr.length;T<z;T++){const x=s(this.expr[T],D.expr[T]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,z=this.expr.length;T<z;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let T=0,z=this.expr.length;T<z;T++)if(this.expr[T].evaluate(D))return!0;return!1}static d(D,T,z){let x=[],K=!1;if(D){for(let ee=0,_=D.length;ee<_;ee++){const Y=D[ee];if(Y){if(Y.type===0){K=!0;continue}if(Y.type===1)return r.INSTANCE;if(Y.type===9){x=x.concat(Y.expr);continue}x.push(Y)}}if(x.length===0&&K)return t.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return r.INSTANCE;if(x.length===1)return x[0]}return new V(x,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new V(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());for(;D.length>1;){const T=D.shift(),z=D.shift(),x=[];for(const K of G(T))for(const ee of G(z))x.push(J.create([K,ee],null,!1));D.unshift(V.create(x,null,!1))}this.c=V.create(D,this,!0)}return this.c}}e.$Gj=V;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(D,T,z){super(D,null),this.f=T,typeof z=="object"?B.d.push({...z,key:D}):z!==!0&&B.d.push({key:D,description:z,type:T!=null?typeof T:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return E.create(this.key,D)}}e.$Hj=B,e.$Ij=(0,L.$qi)("contextKeyService");function ie(q,D){return q<D?-1:q>D?1:0}function oe(q,D,T,z){return q<T?-1:q>T?1:D<z?-1:D>z?1:0}function te(q,D){if(q.type===0||D.type===1)return!0;if(q.type===9)return D.type===9?ae(q.expr,D.expr):!1;if(D.type===9){for(const T of D.expr)if(te(q,T))return!0;return!1}if(q.type===6){if(D.type===6)return ae(D.expr,q.expr);for(const T of q.expr)if(te(T,D))return!0;return!1}return q.equals(D)}function ae(q,D){let T=0,z=0;for(;T<q.length&&z<D.length;){const x=q[T].cmp(D[z]);if(x<0)return!1;x===0&&T++,z++}return T===q.length}function G(q){return q.type===9?q.expr:[q]}}),define(ce[94],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$0m=e.ID=void 0,e.$$m=N,e.ID="diagnosticsService",e.$0m=(0,R.$qi)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}class j{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$_m=j}),define(ce[95],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=void 0,e.$Eo=(0,R.$qi)("downloadService")}),define(ce[16],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,R.$qi)("environmentService"),e.$yi=(0,R.$ri)(e.$xi)}),define(ce[29],le([0,1,157,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=j,e.$Uo=L,e.$Vo=A,e.$Wo=I,e.$Xo=P,e.$Yo=$,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function j(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(l,c){return c==="web"&&!l.includes("web")}function P(l,c,g){return I(c,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g}function $(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var S;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var b;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var h;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var p;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class w extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.$1o=w;var u;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class d extends Error{constructor(c,g){super(c),this.code=g,this.name=g}}e.$2o=d,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,R.localize2)(0,"Extensions"),e.$9o=(0,R.localize2)(1,"Preferences")}),define(ce[194],le([0,1,3,2,30,8,91,29]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=void 0;function P(w,u){return w?L.URI.revive(u?u.transformIncoming(w):w):void 0}function $(w,u){return u?u.transformOutgoingURI(w):w}function S(w,u){u=u||A.$tn;const d=w.manifest;return{...(0,A.$wn)({...w,manifest:void 0},u),manifest:d}}function b(w,u){return w?.profileLocation?(0,A.$wn)(w,u??A.$tn):w}function m(w,u){return u?(0,j.$Yn)(w,d=>d instanceof L.URI?u.transformOutgoingURI(d):void 0):w}class f{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=R.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const l=this.b(u);switch(d){case"onInstallExtension":return R.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,l):c.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,c=>c.map(g=>({...g,local:g.local?m(g.local,l):g.local,profileLocation:g.profileLocation?$(g.profileLocation,l):g.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,l):c.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?$(c.profileLocation,l):c.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,l))}throw new Error("Invalid listen")}async call(u,d,l){const c=this.b(u);switch(d){case"zip":{const g=S(l[0],c),i=await this.a.zip(g);return $(i,c)}case"unzip":return this.a.unzip(P(l[0],c));case"install":return this.a.install(P(l[0],c),b(l[1],c));case"installFromLocation":return this.a.installFromLocation(P(l[0],c),P(l[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],P(l[1],c),P(l[2],c));case"getManifest":return this.a.getManifest(P(l[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],b(l[1],c));case"installGalleryExtensions":{const g=l[0];return this.a.installGalleryExtensions(g.map(({extension:i,options:o})=>({extension:i,options:b(o,c)??{}})))}case"uninstall":return this.a.uninstall(S(l[0],c),b(l[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(l[0],c));case"getInstalled":return(await this.a.getInstalled(l[0],P(l[1],c),l[2])).map(i=>m(i,c));case"toggleAppliationScope":{const g=await this.a.toggleAppliationScope(S(l[0],c),P(l[1],c));return m(g,c)}case"copyExtensions":return this.a.copyExtensions(P(l[0],c),P(l[1],c));case"updateMetadata":{const g=await this.a.updateMetadata(S(l[0],c),l[1],P(l[2],c));return m(g,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$9p=f;class h extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new R.$be),this.f=this.B(new R.$be),this.g=this.B(new R.$be),this.h=this.B(new R.$be),this.j=this.B(new R.$be),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(l=>({...l,local:l.local?S(l.local,null):l.local,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(S(d,null))))}n(u,d){u.fire(d)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(l=>(0,I.$Xo)(l,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(d=>L.URI.revive(d)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,d){return Promise.resolve(this.m.call("install",[u,d])).then(l=>S(l,null))}installFromLocation(u,d){return Promise.resolve(this.m.call("installFromLocation",[u,d])).then(l=>S(l,null))}async installExtensionsFromProfile(u,d,l){return(await this.m.call("installExtensionsFromProfile",[u,d,l])).map(g=>S(g,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.m.call("installFromGallery",[u,d])).then(l=>S(l,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(l=>({...l,local:l.local?S(l.local,null):l.local,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))}uninstall(u,d){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(d=>S(d,null))}getInstalled(u=null,d,l){return Promise.resolve(this.m.call("getInstalled",[u,d,l])).then(c=>c.map(g=>S(g,null)))}updateMetadata(u,d,l){return Promise.resolve(this.m.call("updateMetadata",[u,d,l])).then(c=>S(c,null))}toggleAppliationScope(u,d){return this.m.call("toggleAppliationScope",[u,d]).then(l=>S(l,null))}copyExtensions(u,d){return this.m.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,d,l){const c=await this.m.call("download",[u,d,l]);return L.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$0p=h;class p{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,l){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$$p=p}),define(ce[96],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$K3b=j;var N;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function j(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$L3b=(0,R.$qi)("IExtensionRecommendationNotificationService")}),define(ce[12],le([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=m,e.$Yk=p,e.$Zk=u,e.$1k=d,e.$2k=l,e.$3k=c,e.$4k=g,e.$5k=i,e.$6k=o,e.$7k=n,e.$8k=s,e.$0k=a,e.$$k=y,e.$_k=v,e.$al=C,e.$bl=E,e.$el=U,e.$ql=V,e.$rl=B,e.$tl=oe,e.$Wk=(0,P.$qi)("fileService");function m(te){return te.create===!0}var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var h;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(h||(e.FilePermission=h={}));function p(te){const ae=te;return!!ae&&typeof ae.onDidChange=="function"}var w;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function u(te){return!!(te.capabilities&2)}function d(te){return!!(te.capabilities&8)}function l(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function g(te){return!!(te.capabilities&16)}function i(te){return u(te)?!!(te.capabilities&16384):!1}function o(te){return u(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,G){const q=new r(ae.toString(),G);return v(q,G),q}constructor(ae,G){super(ae),this.code=G}}e.$9k=r;function a(te,ae){return r.create(te,ae)}function y(te){return te||a((0,I.localize)(0,null),t.Unknown)}function v(te,ae){return te.name=ae?`${ae} (FileSystemError)`:"FileSystemError",te}function C(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ae=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function E(te){if(te instanceof X)return te.fileOperationResult;switch(C(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var k;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class O{constructor(ae,G,q){this.resource=ae,this.operation=G,this.target=q}isOperation(ae){return this.operation===ae}}e.$cl=O;var M;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class F{static{this.a=null}constructor(ae,G){this.c=G,this.b=void 0,this.d=new b.$V(()=>{const q=R.$wi.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new b.$V(()=>{const q=R.$wi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new b.$V(()=>{const q=R.$wi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ae){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==F.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ae,...G){return this.h(ae,{includeChildren:!1},...G)}affects(ae,...G){return this.h(ae,{includeChildren:!0},...G)}h(ae,G,...q){if(!ae)return!1;const D=q.length>0;return!!((!D||q.includes(1))&&(this.d.value.get(ae)||G.includeChildren&&this.d.value.findSuperstr(ae))||(!D||q.includes(0))&&(this.f.value.get(ae)||G.includeChildren&&this.f.value.findSuperstr(ae))||(!D||q.includes(2))&&(this.g.value.findSubstr(ae)||G.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$dl=F;function U(te,ae,G){return!te||!ae||te===ae||ae.length>te.length?!1:(ae.charAt(ae.length-1)!==N.sep&&(ae+=N.sep),G?(0,j.$uf)(te,ae):te.indexOf(ae)===0)}class X extends Error{constructor(ae,G,q){super(ae),this.fileOperationResult=G,this.options=q}}e.$fl=X;class H extends X{constructor(ae,G,q,D){super(ae,G,D),this.fileOperationResult=G,this.size=q}}e.$gl=H;class Z extends X{constructor(ae,G,q){super(ae,2,q),this.stat=G}}e.$hl=Z;var W;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var J;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.$pl="";function V(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function B(te,ae){if(!ae.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(G=>{const q=ae.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===te.scheme&&D.added&&(q.dispose(),G())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ae){return(0,L.$8f)(ae)||(ae=0),ae<ie.KB?(0,I.localize)(1,null,ae.toFixed(0)):ae<ie.MB?(0,I.localize)(2,null,(ae/ie.KB).toFixed(2)):ae<ie.GB?(0,I.localize)(3,null,(ae/ie.MB).toFixed(2)):ae<ie.TB?(0,I.localize)(4,null,(ae/ie.GB).toFixed(2)):(0,I.localize)(5,null,(ae/ie.TB).toFixed(2))}}e.$sl=ie;function oe(te){const ae=typeof te=="string"||te?.scheme===S.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===S.Schemas.file?1024*ie.MB:ae?10*ie.MB:$.$o?50*ie.MB:1024*ie.MB}});var Q=this&&this.__param||function(ne,e){return function(R,N){e(R,N,ne)}};define(ce[195],le([0,1,73,50,12]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let L=class{constructor(I){this.a=I}async checksum(I){const P=(await this.a.readFileStream(I)).value;return new Promise(($,S)=>{const b=(0,R.createHash)("sha256");(0,N.$ue)(P,{onData:m=>b.update(m.buffer),onError:m=>S(m),onEnd:()=>$(b.digest("base64").replace(/=+$/,""))})})}};e.$xdc=L,e.$xdc=L=Ee([Q(0,j.$Wk)],L)}),define(ce[97],le([0,1,15,7,165,12]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=A;async function A(S,b,m,f,h,p){let w;try{await I(S,b,m,f,h,p)}catch(u){w=u}finally{w&&h.errorTransformer&&(w=h.errorTransformer(w)),typeof w<"u"&&m.error(w),m.end()}}async function I(S,b,m,f,h,p){P(p);const w=await S.open(b,{create:!1});try{P(p);let u=0,d=0,l=h&&typeof h.length=="number"?h.length:void 0,c=R.$Ce.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),g=h&&typeof h.position=="number"?h.position:0,i=0;do d=await S.read(w,g,c.buffer,i,c.byteLength-i),g+=d,i+=d,u+=d,typeof l=="number"&&(l-=d),i===c.byteLength&&(await m.write(f(c)),c=R.$Ce.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),i=0);while(d>0&&(typeof l!="number"||l>0)&&P(p)&&$(u,h));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),m.write(f(c.slice(0,o)))}}catch(u){throw(0,L.$$k)(u)}finally{await S.close(w)}}function P(S){if(S.isCancellationRequested)throw(0,N.$6)();return!0}function $(S,b){if(typeof b?.limits?.size=="number"&&S>b.limits.size)throw(0,L.$0k)((0,j.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[46],le([0,1,90,2,14,5,8,12]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=P,e.$Eq=$,e.$Iq=f,e.$Jq=h,e.$Kq=p,e.$Lq=w;function P(d){return typeof d.correlationId=="number"}function $(d){return d.recursive===!0}class S extends N.$Uc{static{this.a=5}constructor(l,c,g,i){super(),this.h=l,this.j=c,this.m=g,this.n=i,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const l=new N.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(c=>this.h(c))),l.add(this.b.onDidLogMessage(c=>this.j(c))),l.add(this.b.onDidError(c=>this.t(c)))}t(l){this.n.restartOnError?this.g<S.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=S;class b extends S{constructor(l,c,g){super(l,c,g,{type:"node.js",restartOnError:!1})}}e.$Gq=b;class m extends S{constructor(l,c,g){super(l,c,g,{type:"universal",restartOnError:!0})}}e.$Hq=m;function f(d){return d.map(l=>({type:l.type,resource:A.URI.revive(l.resource),cId:l.cId}))}function h(d){const l=new u;for(const c of d)l.processEvent(c);return l.coalesce()}function p(d,l){return typeof l=="string"&&!l.startsWith(R.$gk)&&!(0,j.$jc)(l)?{base:d,pattern:l}:l}function w(d,l){const c=[];for(const g of l)c.push((0,R.$kk)(p(d,g)));return c}class u{constructor(){this.a=new Set,this.b=new Map}c(l){return L.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.b.get(this.c(l));let g=!1;if(c){const i=c.type,o=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?g=!0:i===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(c)):i===2&&o===1?c.type=0:i===1&&o===0||(c.type=o)}else g=!0;g&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],c=[];return Array.from(this.a).filter(g=>g.type!==2?(l.push(g),!1):!0).sort((g,i)=>g.resource.fsPath.length-i.resource.fsPath.length).filter(g=>c.some(i=>(0,I.$el)(g.resource.fsPath,i,!L.$k))?!1:(c.push(g.resource.fsPath),!0)).concat(l)}}}),define(ce[196],le([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,R,N,j,L,A,I,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$iQ=void 0,e.$iQ="localFilesystem";class b extends A.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$be),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$be),this.onDidWatchError=this.g.event,this.h=(0,P.$Mg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,h){const{buffer:p}=await this.a.call("readFile",[f,h]);return p}readFileStream(f,h,p){const w=(0,I.$qe)(d=>R.$Ce.concat(d.map(l=>R.$Ce.wrap(l))).buffer),u=new A.$Tc;return u.add(this.a.listen("readFileStream",[f,h])(d=>{if(d instanceof R.$Ce)w.write(d.buffer);else{if(d==="end")w.end();else{let l;if(d instanceof Error)l=d;else{const c=d;l=(0,$.$0k)(c.message??(0,N.$bj)(c),c.code??$.FileSystemProviderErrorCode.Unknown)}w.error(l),w.end()}u.dispose()}})),u.add(p.onCancellationRequested(()=>{w.error((0,j.$6)()),w.end(),u.dispose()})),w}writeFile(f,h,p){return this.a.call("writeFile",[f,R.$Ce.wrap(h),p])}open(f,h){return this.a.call("open",[f,h])}close(f){return this.a.call("close",[f])}async read(f,h,p,w,u){const[d,l]=await this.a.call("read",[f,h,u]);return p.set(d.buffer.slice(0,l),w),l}write(f,h,p,w,u){return this.a.call("write",[f,h,R.$Ce.wrap(p),w,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,h){return this.a.call("delete",[f,h])}rename(f,h,p){return this.a.call("rename",[f,h,p])}copy(f,h,p){return this.a.call("copy",[f,h,p])}cloneFile(f,h){return this.a.call("cloneFile",[f,h])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const h=f;this.f.fire((0,S.$Iq)(h))}else{const h=f;this.g.fire(h)}}))}watch(f,h){const p=(0,P.$Mg)();return this.a.call("watch",[this.h,p,f,h]),(0,A.$Sc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$jQ=b}),define(ce[197],le([0,1,40,2,46,3,8,6]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class P extends N.$Uc{constructor(){super(),this.a=this.B(new L.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new I.$Nh,this.B(this.f(S=>this.s(S)))}s(S){this.t(S)&&this.w(S)}t(S){return(0,j.$Dq)(S)}async watch(S){this.r.isSettled||this.r.complete(),this.r=new I.$Nh;try{this.h.clear(),this.g.clear();for(const b of S)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(S=>!this.j.has(S.correlationId))])}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async w(S){if(this.j.has(S.correlationId))return;const b=new N.$Tc;this.j.set(S.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(S,b),this.u())}y(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.u()}z(S,b){this.C(S,b)?(this.M(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.D(S,b),this.m.add(S.correlationId))}C(S,b){const m=this.L?.subscribe(S.path,(f,h)=>{b.isDisposed||(f?this.z(S,b):h?.type===1&&this.F(S))});return m?(b.add(m),!0):!1}D(S,b){let m=!1;const f=(h,p)=>{if(b.isDisposed)return;const w=this.G(h),u=this.G(p),d=m;m=w,!w&&(u||d)&&this.F(S)};this.M(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,R.watchFile)(S.path,{persistent:!1,interval:this.n},f)}catch(h){this.N(`fs.watchFile() failed with error ${h} on path ${S.path} (correlationId: ${S.correlationId})`)}b.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,R.unwatchFile)(S.path,f)}catch(h){this.N(`fs.unwatchFile() failed with error ${h} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}F(S){this.M(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const b={resource:A.URI.file(S.path),type:1,cId:S.correlationId};this.a.fire([b]),this.H(b,S),this.y(S)}G(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(S,b){const m=` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.M(typeof b.correlationId=="number"?`${m} (correlationId: ${b.correlationId})`:m)}I(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}}e.$Uq=P}),define(ce[198],le([0,1,40,6,26,44,2,87,14,5,20,8,148,31,46]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=w;class p extends A.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(d,l,c,g,i,o){super(),this.r=d,this.s=l,this.t=c,this.u=g,this.w=i,this.y=o,this.c=this.B(new N.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.t(n))),this.f=this.B(new N.$Eh(n=>this.L(n),p.b)),this.g=(0,h.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,h.$Lq)(this.r.path,this.r.includes):void 0,this.j=new j.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const d=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(d);if(this.j.token.isCancellationRequested)return;this.B(await this.F(d,l.isDirectory()))}catch(d){d.code!=="ENOENT"?this.N(d):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${d})`),this.C()}}C(){this.n=!0,this.u?.()}async D(d){let l=d.path;try{l=await f.Promises.realpath(d.path),d.path===l&&(l=await(0,m.$Wq)(d.path,this.j.token)??d.path),d.path!==l&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${l})`)}catch{}return l}async F(d,l){const c=new A.$Tc;return this.G(d,l,c)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(d,l,c)),c}G(d,l,c){if(l)return!1;const g=b.URI.file(this.r.path),i=this.s?.subscribe(this.r.path,async(o,n)=>{if(!c.isDisposed)if(o){const s=await this.F(d,l);c.isDisposed?s.dispose():c.add(s)}else n&&(typeof n.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:g,type:n.type,cId:this.r.correlationId}])});return i?(c.add(i),!0):!1}async H(d,l,c){if($.$j&&(0,L.$qg)(d,"/Volumes/",!0)){this.N(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const g=new j.$me(this.j.token);c.add((0,A.$Sc)(()=>g.dispose(!0)));const i=new A.$Tc;c.add(i);try{const o=b.URI.file(this.r.path),n=(0,P.$oc)(d),s=(0,R.watch)(d);i.add((0,A.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.P(`Started watching: '${d}'`);const t=new Set;if(l)try{for(const a of await f.Promises.readdir(d))t.add(a)}catch(a){this.N(a)}if(g.token.isCancellationRequested)return;const r=new Map;i.add((0,A.$Sc)(()=>{for(const[,a]of r)a.dispose();r.clear()})),s.on("error",(a,y)=>{g.token.isCancellationRequested||(this.N(`Failed to watch ${d} for changes using fs.watch() (${a}, ${y})`),this.C())}),s.on("change",(a,y)=>{if(g.token.isCancellationRequested)return;this.P(`[raw] ["${a}"] ${y}`);let v="";if(y&&(v=y.toString(),$.$j&&(v=(0,I.$8l)(v))),!(!v||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){r.get(v)?.dispose();const C=setTimeout(async()=>{if(r.delete(v),v===n&&!await f.Promises.exists(d)){this.I(o);return}if(g.token.isCancellationRequested)return;const E=await this.M((0,P.$kc)(d,v));if(g.token.isCancellationRequested)return;let k;E?t.has(v)?k=0:(k=1,t.add(v)):(t.delete(v),k=2),this.J({resource:(0,S.$4g)(o,v),type:k,cId:this.r.correlationId})},p.a);r.set(v,(0,A.$Sc)(()=>clearTimeout(C)))}else{let C;t.has(v)?C=0:(C=1,t.add(v)),this.J({resource:(0,S.$4g)(o,v),type:C,cId:this.r.correlationId})}else if(a==="rename"||v!==n){const C=setTimeout(async()=>{const E=await f.Promises.exists(d);g.token.isCancellationRequested||(E?(this.J({resource:o,type:0,cId:this.r.correlationId},!0),i.add(await this.F(d,!1))):this.I(o))},p.a);i.clear(),i.add((0,A.$Sc)(()=>clearTimeout(C)))}else this.J({resource:o,type:0,cId:this.r.correlationId},!0)})}catch(o){g.token.isCancellationRequested||this.N(`Failed to watch ${d} for changes using fs.watch() (${o.toString()})`),this.C()}}I(d){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:d,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(d,l=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!l&&this.g.some(c=>c(d.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${d.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(c=>c(d.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}L(d){const l=(0,h.$Jq)(d);if(l.length>0){if(this.y)for(const g of l)this.P(` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(d){if($.$k)return f.Promises.exists(d);try{const l=(0,P.$oc)(d);return(await f.Promises.readdir((0,P.$nc)(d))).some(g=>g===l)}catch(l){return this.P(l),!1}}setVerboseLogging(d){this.y=d}N(d){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}O(d){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}P(d){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=p;async function w(u,d,l,c,g=512){const i=await f.Promises.open(u,"r"),o=Buffer.allocUnsafe(g),n=new j.$me(c);let s,t=!1;const r={path:u,excludes:[],recursive:!1},a=new p(r,void 0,y=>{(async()=>{for(const{type:v}of y)if(v===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:C}=await f.Promises.read(i,o,0,g,null);if(!C||n.token.isCancellationRequested)break;d(o.slice(0,C))}}catch(C){s=new Error(C),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((y,v)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await f.Promises.close(i)}catch(C){s=new Error(C)}s?v(s):y()})})}}),define(ce[199],le([0,1,3,90,197,5,198,44]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class P extends j.$Uq{constructor(S){super(),this.L=S,this.onDidError=R.Event.None,this.watchers=new Set,this.O=!1}async J(S){S=this.W(S);const b=[],m=new Set(Array.from(this.watchers));for(const f of S){const h=this.R(f);h&&(0,N.$ok)(h.request.excludes,f.excludes)&&(0,N.$ok)(h.request.includes,f.includes)?m.delete(h):b.push(f)}b.length&&this.M(`Request to start watching: ${b.map(f=>this.I(f)).join(",")}`),m.size&&this.M(`Request to stop watching: ${Array.from(m).map(f=>this.I(f.request)).join(",")}`);for(const f of m)this.U(f);for(const f of b)this.S(f)}R(S){for(const b of this.watchers)if(typeof S.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===S.correlationId)return b}else if((0,I.$pg)(b.request.path,S.path,!L.$k))return b}S(S){const b=new A.$Zq(S,this.L,f=>this.a.fire(f),()=>this.c.fire(S),f=>this.b.fire(f),this.O),m={request:S,instance:b};this.watchers.add(m)}async stop(){await super.stop();for(const S of this.watchers)this.U(S)}U(S){this.M("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}W(S){const b=new Map;for(const m of S){const f=L.$k?m.path:m.path.toLowerCase();let h=b.get(m.correlationId);h||(h=new Map,b.set(m.correlationId,h)),h.has(f)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(m)}`),h.set(f,m)}return Array.from(b.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(S){this.O=S;for(const b of this.watchers)b.instance.setVerboseLogging(S)}M(S,b){this.O&&this.b.fire({type:"trace",message:this.Z(S,b)})}N(S){this.b.fire({type:"warn",message:this.Z(S)})}Z(S,b){return b?`[File Watcher (node.js)] ${S} (${this.I(b.request)})`:`[File Watcher (node.js)] ${S}`}}e.$2q=P}),define(ce[200],le([0,1,46,199]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class j extends R.$Gq{constructor(A,I,P){super(A,I,P),this.s()}r(A){return A.add(new N.$2q(void 0))}}e.$3q=j}),define(ce[201],le([0,1,23,41,92,46]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class A extends L.$Hq{constructor(P,$,S){super(P,$,S),this.s()}r(P){const $=P.add(new j.$Sq(R.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add($.onDidProcessExit(({code:S,signal:b})=>this.t(`terminated by itself with code ${S}, signal: ${b}`))),N.ProxyChannel.toService((0,N.$0h)($.getChannel("watcher")))}}e.$Tq=A}),define(ce[74],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class R{constructor(...j){this.a=new Map;for(const[L,A]of j)this.set(L,A)}set(j,L){const A=this.a.get(j);return this.a.set(j,L),A}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$oi=R}),define(ce[202],le([0,1,6,7,2,72,192,4,74,86]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const S=!1;class b extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class m{constructor(w=new P.$oi,u=!1,d,l=S){this.i=w,this.j=u,this.k=d,this.l=l,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$pi,this),this._globalGraph=l?d?._globalGraph??new A.$6q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,j.$Pc)(this.h),this.h.clear();for(const w of this.g)(0,j.$Oc)(w)&&w.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(w){this.m();const u=new class extends m{dispose(){this.h.delete(u),super.dispose()}}(w,this.j,this,this.l);return this.h.add(u),u}invokeFunction(w,...u){this.m();const d=h.traceInvocation(this.l,w);let l=!1;try{return w({get:g=>{if(l)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(g,d);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...u)}finally{l=!0,d.stop()}}createInstance(w,...u){this.m();let d,l;return w instanceof L.$ni?(d=h.traceCreation(this.l,w.ctor),l=this.o(w.ctor,w.staticArguments.concat(u),d)):(d=h.traceCreation(this.l,w),l=this.o(w,u,d)),d.stop(),l}o(w,u=[],d){const l=I._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),c=[];for(const i of l){const o=this.s(i.id,d);o||this.y(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const g=l.length>0?l[0].index:u.length;if(u.length!==g){console.trace(`[createInstance] First service dependency of ${w.name} at position ${g+1} conflicts with ${u.length} static arguments`);const i=g-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,g)}return Reflect.construct(w,u.concat(c))}q(w,u){if(this.i.get(w)instanceof L.$ni)this.i.set(w,u);else if(this.k)this.k.q(w,u);else throw new Error("illegalState - setting UNKNOWN service instance")}r(w){const u=this.i.get(w);return!u&&this.k?this.k.r(w):u}s(w,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const d=this.r(w);return d instanceof L.$ni?this.u(w,d,u.branch(w,!0)):(u.branch(w,!1),d)}u(w,u,d){if(this.t.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.t.add(w);try{return this.v(w,u,d)}finally{this.t.delete(w)}}v(w,u,d){const l=new A.$6q(i=>i.id.toString());let c=0;const g=[{id:w,desc:u,_trace:d}];for(;g.length;){const i=g.pop();if(l.lookupOrInsertNode(i),c++>1e3)throw new b(l);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof L.$ni){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,s),g.push(s)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new b(l);break}for(const{data:o}of i){if(this.r(o.id)instanceof L.$ni){const s=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,s)}l.removeNode(o)}}return this.r(w)}w(w,u,d=[],l,c){if(this.i.get(w)instanceof L.$ni)return this.x(w,u,d,l,c,this.g);if(this.k)return this.k.w(w,u,d,l,c);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}x(w,u,d=[],l,c,g){if(l){const i=new m(void 0,this.j,this,this.l);i.c=String(w);const o=new Map,n=new R.$Jh(()=>{const s=i.o(u,d,c);for(const[t,r]of o){const a=s[t];if(typeof a=="function")for(const y of r)y.disposable=a.apply(s,y.listener)}return o.clear(),g.add(s),s});return new Proxy(Object.create(null),{get(s,t){if(!n.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let y=o.get(t);return y||(y=new $.$5c,o.set(t,y)),(C,E,k)=>{if(n.isInitialized)return n.value[t](C,E,k);{const O={listener:[C,E,k],disposable:void 0},M=y.push(O);return(0,j.$Sc)(()=>{M(),O.disposable?.dispose()})}}}if(t in s)return s[t];const r=n.value;let a=r[t];return typeof a!="function"||(a=a.bind(r),s[t]=a),a},set(s,t,r){return n.value[t]=r,!0},getPrototypeOf(s){return u.prototype}})}else{const i=this.o(u,d,c);return g.add(i),i}}y(w,u){if(u&&console.warn(w),this.j)throw new Error(w)}}e.$7q=m;var f;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(f||(f={}));class h{static{this.all=new Set}static{this.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,u){return w?new h(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(w,u){return w?new h(1,u.name):h.c}static{this.f=0}constructor(w,u){this.type=w,this.name=u,this.g=Date.now(),this.h=[]}branch(w,u){const d=new h(3,w.toString());return this.h.push([w,u,d]),d}stop(){const w=Date.now()-this.g;h.f+=w;let u=!1;function d(c,g){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of g.h)if(s&&t){u=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(w>2||u)&&h.all.add(l.join(`
`))}}e.$8q=h}),define(ce[56],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0,e.$5cc=(0,R.$qi)("mainProcessService");class N{constructor(L,A){this.a=L,this.b=A}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,A){this.a.registerChannel(L,A)}}e.$6cc=N}),define(ce[75],le([0,1,26,2,5,167,29,4]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=void 0,e.$Ir=P;function P(S){return S.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Jr=(0,I.$qi)("languagePackService");let $=class extends N.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new R.$me;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const h=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],u=P(p);return{...this.f(u,w,p),extensionId:p.identifier.id,galleryExtension:p}});return h.push(this.f("en","English")),h}f(b,m,f){const h=m??b;let p;if(h!==b&&(p=`(${b})`),b.toLowerCase()===j.$w.toLowerCase()&&(p??="",p+=(0,L.localize)(0,null)),f?.installCount){p??="";const w=f.installCount;let u;w>1e6?u=`${Math.floor(w/1e5)/10}M`:w>1e3?u=`${Math.floor(w/1e3)}K`:u=String(w),p+=` $(cloud-download) ${u}`}return{id:b,label:h,description:p}}};e.$Kr=$,e.$Kr=$=Ee([Q(0,A.$Zo)],$)}),define(ce[203],le([0,1,2,75]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;let j=class extends R.$Uc{constructor(A){super(),this.a=A,this.b()}b(){this.a.update()}};e.$tdc=j,e.$tdc=j=Ee([Q(0,N.$Jr)],j)}),define(ce[9],le([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=p,e.log=u,e.$$j=a,e.$_j=y,e.$ak=v,e.$bk=C,e.$Wj=(0,f.$qi)("logService"),e.$Xj=(0,f.$qi)("loggerService");function h(){return new Date().toISOString()}function p(E){return(0,S.$8f)(E)}var w;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Zj=w.Info;function u(E,k,O){switch(k){case w.Trace:E.trace(O);break;case w.Debug:E.debug(O);break;case w.Info:E.info(O);break;case w.Warning:E.warn(O);break;case w.Error:E.error(O);break;case w.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function d(E,k=!1){let O="";for(let M=0;M<E.length;M++){let F=E[M];if(F instanceof Error&&(F=(0,N.$bj)(F,k)),typeof F=="object")try{F=JSON.stringify(F)}catch{}O+=(M>0?" ":"")+F}return O}class l extends A.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new j.$be),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==w.Off&&this.b<=k}}e.$2j=l;class c extends l{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...O){this.f(w.Trace)&&this.g(w.Trace,d([k,...O],!0))}debug(k,...O){this.f(w.Debug)&&this.g(w.Debug,d([k,...O]))}info(k,...O){this.f(w.Info)&&this.g(w.Info,d([k,...O]))}warn(k,...O){this.f(w.Warning)&&this.g(w.Warning,d([k,...O]))}error(k,...O){if(this.f(w.Error))if(k instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=k.stack,this.g(w.Error,d(M))}else this.g(w.Error,d([k,...O]))}flush(){}}e.$3j=c;class g extends l{constructor(k=e.$Zj){super(),this.setLevel(k),this.g=!P.$i}trace(k,...O){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...O):console.log(`[main ${h()}]`,k,...O))}debug(k,...O){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...O):console.log(`[main ${h()}]`,k,...O))}info(k,...O){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,k,...O):console.log(`[main ${h()}]`,k,...O))}warn(k,...O){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,k,...O):console.warn(`[main ${h()}]`,k,...O))}error(k,...O){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,k,...O):console.error(`[main ${h()}]`,k,...O))}flush(){}}e.$4j=g;class i extends l{constructor(k=e.$Zj,O=!0){super(),this.g=O,this.setLevel(k)}trace(k,...O){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...O):console.log(k,...O))}debug(k,...O){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...O):console.log(k,...O))}info(k,...O){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...O):console.log(k,...O))}warn(k,...O){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...O):console.log(k,...O))}error(k,...O){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...O):console.error(k,...O))}flush(){}}e.$5j=i;class o extends l{constructor(k,O=e.$Zj){super(),this.g=k,this.setLevel(O)}trace(k,...O){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(k),...O])}debug(k,...O){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(k),...O])}info(k,...O){this.f(w.Info)&&this.g.log(w.Info,[this.h(k),...O])}warn(k,...O){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(k),...O])}error(k,...O){this.f(w.Error)&&this.g.log(w.Error,[this.h(k),...O])}h(k){return typeof k=="string"?k:(0,N.$bj)(k,this.f(w.Trace))}flush(){}}e.$6j=o;class n extends l{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const O of this.g)O.setLevel(k);super.setLevel(k)}trace(k,...O){for(const M of this.g)M.trace(k,...O)}debug(k,...O){for(const M of this.g)M.debug(k,...O)}info(k,...O){for(const M of this.g)M.info(k,...O)}warn(k,...O){for(const M of this.g)M.warn(k,...O)}error(k,...O){for(const M of this.g)M.error(k,...O)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose();super.dispose()}}e.$7j=n;class s extends A.$Uc{constructor(k,O,M){if(super(),this.h=k,this.j=O,this.b=new I.$Bc,this.c=this.B(new j.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$be),this.onDidChangeVisibility=this.g.event,M)for(const F of M)this.b.set(F.resource,{logger:void 0,info:F})}m(k){return(0,S.$4f)(k)?[...this.b.values()].find(O=>O.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,O){const M=this.n(k),F=(0,S.$4f)(k)?k:O?.id??(0,L.$ej)(M.toString()).toString(16);let U=this.b.get(M)?.logger;const X=O?.logLevel==="always"?w.Trace:O?.logLevel;U||(U=this.s(M,X??this.getLogLevel(M)??this.h,{...O,id:F}));const H={logger:U,info:{resource:M,id:F,logLevel:X,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(H.info),this.b.set(M,H),U}n(k){return(0,S.$4f)(k)?(0,$.$4g)(this.j,`${k}.log`):k}setLogLevel(k,O){if(b.URI.isUri(k)){const M=k,F=O,U=this.b.get(M);U&&F!==U.info.logLevel&&(U.info.logLevel=F===this.h?void 0:F,U.logger?.setLevel(F),this.b.set(U.info.resource,U),this.f.fire([M,F]))}else{this.h=k;for(const[M,F]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,O){const M=this.m(k);M&&O!==!M.info.hidden&&(M.info.hidden=!O,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,O]))}getLogLevel(k){let O;return k&&(O=this.b.get(k)?.info.logLevel),O??this.h}registerLogger(k){const O=this.b.get(k.resource);O?O.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const O=this.b.get(k);O&&(O.logger&&O.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=s;class t{constructor(){this.onDidChangeLogLevel=new j.$be().event}setLevel(k){}getLevel(){return w.Info}trace(k,...O){}debug(k,...O){}info(k,...O){}warn(k,...O){}error(k,...O){}critical(k,...O){}dispose(){}flush(){}}e.$9j=t;class r extends t{}e.$0j=r;function a(E){if(E.verbose)return w.Trace;if(typeof E.logLevel=="string"){const k=C(E.logLevel.toLowerCase());if(k!==void 0)return k}return e.$Zj}function y(E){switch(E){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function v(E){switch(E){case w.Trace:return{original:"Trace",value:R.localize(0,null)};case w.Debug:return{original:"Debug",value:R.localize(1,null)};case w.Info:return{original:"Info",value:R.localize(2,null)};case w.Warning:return{original:"Warning",value:R.localize(3,null)};case w.Error:return{original:"Error",value:R.localize(4,null)};case w.Off:return{original:"Off",value:R.localize(5,null)}}}function C(E){switch(E){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$ck=new m.$Hj("logLevel",y(w.Info))}),define(ce[204],le([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,R,N,j,L,A,I,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;let b=class extends j.$Uc{constructor(f,h){super(),this.a=f,this.b=h,this.B(new R.$Ch(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,I.$1g)(this.a.logsHome),h=(0,I.$3g)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,u=(await P.Promises.readdir(h)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==f),d=u.slice(0,Math.max(0,u.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(l=>P.Promises.rm((0,A.$kc)(h,l)))))}catch(f){(0,N.$1)(f)}}};e.$udc=b,e.$udc=b=Ee([Q(0,$.$xi),Q(1,S.$Wj)],b)}),define(ce[205],le([0,1,17,6,7,3,2,14,46,9]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class S extends A.$Uc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new L.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$oh(0)),this.w=[],this.y=this.B(new N.$oh(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const h={path:this.I(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},p=(0,R.$Ub)(this.j,h);return this.r(),(0,A.$Sc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,j.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,P.$Iq)(f)),f=>this.G(f),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,P.$Eq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,P.$Eq)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const h={path:this.I(m),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},p=(0,R.$Ub)(this.w,h);return this.C(),(0,A.$Sc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,j.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,P.$Iq)(m)),m=>this.G(m),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,I.$ic)(m.fsPath)}}e.$Mq=S}),define(ce[206],le([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let g=class extends $.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$be),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$be),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$be),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$be),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$be),this.Y=this.B(new A.$be),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$be),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$zh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new $.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new w.$dl(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,$.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,$.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,f.$8g)(o))throw new w.$fl((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new l.$bb;throw s.message=(0,p.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,w.$3k)(n)||(0,w.$Zk)(n)||(0,w.$4k)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,w.$3k)(n)||(0,w.$Zk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,w.$al)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.$fl((0,p.localize)(2,null,this.sb(o)),1):(0,w.$$k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,y=n?.resolveMetadata,v=await s.stat(o);let C;return this.t(s,o,v,void 0,!!y,(E,k)=>(C||(C=S.$wi.forUris(()=>!t),C.set(o,!0),r&&C.fill(!0,r)),C.get(E.resource)||C.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&a?k===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:y}=this.R(o),v={resource:n,name:y.basename(n),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&w.FilePermission.Locked),etag:(0,w.$ql)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&a(v,t)){try{const C=await o.readdir(n),E=await N.Promises.settled(C.map(async([k,O])=>{try{const M=y.joinPath(n,k),F=r?await o.stat(M):{type:O};return await this.t(o,M,F,C.length,r,a)}catch(M){return this.b.trace(M),null}}));v.children=(0,R.$Hb)(E)}catch(C){this.b.trace(C),v.children=[]}return v}return v}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new w.$fl((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=j.$Ce.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new w.$cl(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,w.$6k)(t)&&!a?.atomic){const y=t.enforceAtomicWriteFile?.(o);y&&(a={...s,atomic:y})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let v;if((0,w.$Zk)(t)&&!(n instanceof j.$Ce))if((0,h.$oe)(n)){const C=await(0,h.$ve)(n,3);C.ended?v=j.$Ce.concat(C.buffer):v=C}else v=(0,h.$se)(n,C=>j.$Ce.concat(C),3);else v=n;!(0,w.$3k)(t)||(0,w.$Zk)(t)&&v instanceof j.$Ce||(0,w.$Zk)(t)&&(0,w.$6k)(t)&&a?.atomic?await this.hb(t,o,a,v):await this.db(t,o,a,v instanceof j.$Ce?(0,j.$Ne)(v):v),this.r.fire(new w.$cl(o,4))}catch(y){throw new w.$fl((0,p.localize)(4,null,this.sb(o),(0,w.$$k)(y).toString()),(0,w.$bl)(y),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&w.FileType.Directory)throw new w.$fl((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.$pl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,w.$ql)({mtime:s.mtime,size:a.size}))throw new w.$fl((0,p.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const y=await this.C(o,n,s,t);r(y)}catch(y){a(y)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,j.$Oe)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new L.$me(t);let a=s;(0,w.$5k)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const y=this.J(n,a).then(C=>C,C=>{throw r.dispose(!0),C});let v;try{return typeof a?.etag=="string"&&a.etag!==w.$pl&&await y,a?.atomic&&(0,w.$5k)(o)||!((0,w.$3k)(o)||(0,w.$4k)(o))||(0,w.$Zk)(o)&&a?.preferUnbuffered?v=this.I(o,n,a):(0,w.$4k)(o)?v=this.G(o,n,r.token,a):v=this.H(o,n,r.token,a),v.on("end",()=>r.dispose()),v.on("error",()=>r.dispose()),{...await y,value:v}}catch(C){throw v&&await(0,h.$te)(v),this.F(C,n,a)}}F(o,n,s){const t=(0,p.localize)(11,null,this.sb(n),(0,w.$$k)(o).toString());return o instanceof w.$hl?new w.$hl(t,o.stat,s):o instanceof w.$gl?new w.$gl(t,o.fileOperationResult,o.size,o.options):new w.$fl(t,(0,w.$bl)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,h.$ze)(r,{data:a=>a instanceof j.$Ce?a:j.$Ce.wrap(a),error:a=>this.F(a,n,t)},a=>j.$Ce.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,j.$Se)();return(0,u.$Bq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,h.$qe)(r=>j.$Ce.concat(r));return(async()=>{try{let r;s?.atomic&&(0,w.$5k)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(j.$Ce.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new w.$fl((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$pl&&n.etag===s.etag)throw new w.$hl((0,p.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new w.$gl((0,p.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$cl(o,a==="move"?2:3,y)),y}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$cl(o,a==="copy"?3:2,y)),y}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:y,isSameResourceWithDifferentPathCase:v}=await this.Q(o,n,s,t,r,a);if(y&&!v&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,w.$1k)(o))await o.copy(n,t,{overwrite:a});else{const C=await this.resolve(n);C.isDirectory?await this.P(o,C,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,w.$3k)(o)&&(0,w.$3k)(s))return this.jb(o,n,s,t);if((0,w.$3k)(o)&&(0,w.$Zk)(s))return this.pb(o,n,s,t);if((0,w.$Zk)(o)&&(0,w.$3k)(s))return this.nb(o,n,s,t);if((0,w.$Zk)(o)&&(0,w.$Zk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let y=!1;if(o===s){const{providerExtUri:C,isPathCaseSensitive:E}=this.R(o);if(E||(y=C.isEqual(n,t)),y&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!y&&C.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const v=await this.exists(t);if(v&&!y){if(!a)throw new w.$fl((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:C}=this.R(o);if(C.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:v,isSameResourceWithDifferentPathCase:y}}R(o){const n=this.S(o);return{providerExtUri:n?f.$Tg:f.$Vg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$cl(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$al)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,w.$al)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$fl((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const v=await this.resolve(o);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,w.$7k)(s)&&!t?.atomic){const v=s.enforceAtomicDelete?.(o);v&&(t={...n,atomic:v})}const r=!!t?.useTrash,a=!!t?.recursive,y=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:y}),this.r.fire(new w.$cl(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,w.$2k)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,w.$1k)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new $.$Tc;let t=!1,r=()=>{t=!0};s.add((0,$.$Sc)(()=>r())),(async()=>{try{const y=await this.bb(o,n);t?(0,$.$Pc)(y):r=()=>(0,$.$Pc)(y)}catch(y){this.b.error(y)}})();const a=n.correlationId;if(typeof a=="number"){const y=s.add(new A.$be);return s.add(this.X.event(C=>{C.correlates(a)&&y.fire(C)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,I.$ej)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,$.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,$.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,$.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,h.$oe)(t)||(0,h.$pe)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$$k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,h.$pe)(s)){if(s.buffer.length>0){const a=j.$Ce.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,y)=>{(0,h.$ue)(r,{onData:async v=>{r.pause();try{await this.gb(o,n,v,v.byteLength,t,0)}catch(C){return y(C)}t+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>y(v),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let y=0;for(;y<t;){const v=await o.write(n,r+y,s.buffer,a+y,t-y);y+=v}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof j.$Ce?r=t:(0,h.$oe)(t)?r=await(0,j.$Oe)(t):(0,h.$pe)(t)?r=await(0,j.$Pe)(t):r=(0,j.$Me)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const y=j.$Ce.alloc(this.a);let v=0,C=0,E=0;do E=await o.read(r,v,y.buffer,C,y.byteLength-C),await this.gb(s,a,y,E,v,C),v+=E,C+=E,C===y.byteLength&&(C=0);while(E>0)}catch(y){throw(0,w.$$k)(y)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,j.$Ce.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$$k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,j.$Oe)(this.H(o,n,L.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new w.$fl((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$fl((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.$Cq=g,e.$Cq=g=c=Ee([Q(0,d.$Wj)],g)}),define(ce[207],le([0,1,40,277,6,34,15,3,44,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,N.gracefulify)(R)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$bj)(o)}`)}})();class i extends d.$Mq{static{this.J=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.O=new L.$Bc(t=>m.$Ug.getComparisonKey(t)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,b.$k&&(this.L|=1024)),this.L}async stat(n){try{const{stat:s,symbolicLink:t}=await h.SymlinkSupport.stat(this.I(n));return{type:this.N(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:w.FilePermission.Locked}}catch(s){throw this.gb(s)}}async M(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await h.Promises.readdir(this.I(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$4g)(n,r.name))).type:a=this.N(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.gb(s)}}N(n,s){let t;return s?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,s&&(t|=w.FileType.SymbolicLink),t}async P(n){const s=this.I(n);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.O.get(n);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new j.$ph;return this.O.set(n,r),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,$.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.O.get(n)===r&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.O.delete(n)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),t=await this.P(n));const r=this.I(n);return await h.Promises.readFile(r)}catch(r){throw this.gb(r)}finally{t?.dispose()}}Q(n){i.J&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,f.$qe)(a=>A.$Ce.concat(a.map(y=>A.$Ce.wrap(y))).buffer);return(0,u.$Bq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.R(n)?this.S(n,(0,m.$4g)((0,m.$3g)(n),`${(0,m.$1g)(n)}${t.atomic.postfix}`),s,t):this.U(n,s,t)}async R(n){try{const s=this.I(n),{symbolicLink:t}=await h.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async S(n,s,t,r){const a=new $.$Tc;try{a.add(await this.P(n)),a.add(await this.P(s)),await this.U(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(y){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{a.dispose()}}async U(n,s,t,r){let a;try{const y=this.I(n);if(!t.create||!t.overwrite){if(await h.Promises.exists(y)){if(!t.overwrite)throw(0,w.$0k)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$0k)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(y){throw await this.hb(n,y)}finally{typeof a=="number"&&await this.close(a)}}static{this.Z=!0}static configureFlushOnWrite(n){i.Z=n}async open(n,s,t){const r=this.I(n);let a;(0,w.$Xk)(s)&&!t&&(a=await this.P(n));let y;try{if((0,w.$Xk)(s)&&s.unlock)try{const{stat:C}=await h.SymlinkSupport.stat(r);C.mode&128||await h.Promises.chmod(r,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let v;if((0,w.$Xk)(s)){if(b.$i)try{await h.Promises.truncate(r,0),v="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}v||(v="w")}else v="r";y=await h.Promises.open(r,v)}catch(v){throw a?.dispose(),(0,w.$Xk)(s)?await this.hb(n,v):this.gb(v)}if(this.W.set(y,0),(0,w.$Xk)(s)&&this.Y.set(y,n),a){const v=this.X.get(y);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${r})`),this.X.set(y,a),v&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${r})`),v.dispose())}return y}async close(n){const s=this.X.get(n);try{if(this.W.delete(n),this.Y.delete(n)&&i.Z)try{await h.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await h.Promises.close(n)}catch(t){throw this.gb(t)}finally{s&&(this.X.get(n)===s&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.X.delete(n)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const y=this.$(n,s);let v=null;try{v=(await h.Promises.read(n,t,r,a,y)).bytesRead}catch(C){throw this.gb(C)}finally{this.ab(n,y,v)}return v}$(n,s){return s===this.W.get(n)?null:s}ab(n,s,t){const r=this.W.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.W.set(n,r+t):this.W.delete(n)))}async write(n,s,t,r,a){return(0,j.$Kh)(()=>this.bb(n,s,t,r,a),100,3)}async bb(n,s,t,r,a){const y=this.$(n,s);let v=null;try{v=(await h.Promises.write(n,t,r,a,y)).bytesWritten}catch(C){throw await this.hb(this.Y.get(n),C)}finally{this.ab(n,y,v)}return v}async mkdir(n){try{await h.Promises.mkdir(this.I(n))}catch(s){throw this.gb(s)}}async delete(n,s){try{const t=this.I(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,S.$kc)((0,S.$nc)(t),`${(0,S.$oc)(t)}${s.atomic.postfix}`)),await h.Promises.rm(t,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:y,symbolicLink:v}=await h.SymlinkSupport.stat(t);a=y.isDirectory()&&!v}catch{}if(a)await h.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.gb(t)}}async rename(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"move",t.overwrite),await h.Promises.rename(r,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,p.localize)(2,null,(0,S.$oc)(r),(0,S.$oc)((0,S.$nc)(a)),y.toString()))),this.gb(y)}}async copy(n,s,t){const r=this.I(n),a=this.I(s);if(r!==a)try{await this.cb(n,s,"copy",t.overwrite),await h.Promises.copy(r,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,p.localize)(3,null,(0,S.$oc)(r),(0,S.$oc)((0,S.$nc)(a)),y.toString()))),this.gb(y)}}async cb(n,s,t,r){const a=this.I(n),y=this.I(s);let v=!1;if(!!(this.capabilities&1024)||(v=(0,P.$pg)(a,y,!0)),v){if(t==="copy")throw(0,w.$0k)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const E=await this.M(n);if(!E)throw(0,w.$0k)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const k=await this.M(s);if(k){if(!r)throw(0,w.$0k)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);E.type&w.FileType.File&&k.type&w.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.db(n,s,!1)}async db(n,s,t){const r=this.I(n),a=this.I(s),y=!!(this.capabilities&1024);if((0,P.$pg)(r,a,!y))return;const v=new $.$Tc;try{v.add(await this.P(n)),v.add(await this.P(s)),t&&await h.Promises.mkdir((0,S.$nc)(a),{recursive:!0}),await h.Promises.copyFile(r,a)}catch(C){if(C.code==="ENOENT"&&!t)return this.db(n,s,!0);throw this.gb(C)}finally{v.dispose()}}t(n,s,t){return new c.$Tq(r=>n(r),r=>s(r),t)}F(n,s,t){return new g.$3q(r=>n(r),r=>s(r),t)}gb(n){if(n instanceof w.$9k)return n;let s=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$0k)(s,t)}async hb(n,s){let t=this.gb(s);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(n));r.mode&128||(t=(0,w.$0k)(s,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$4q=i}),define(ce[99],le([0,1,3,2,4,9]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.$Tdc=void 0,e.$Tdc=(0,j.$qi)("sharedProcessLifecycleService");let A=class extends N.$Uc{constructor(P){super(),this.b=P,this.a=this.B(new R.$be),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Udc=A,e.$Udc=A=Ee([Q(0,L.$Wj)],A)}),define(ce[208],le([0,1,8,3,9,2]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=void 0;class A extends j.$8j{constructor(b,m,f,h,p){super(m,f,h),this.r=b,this.t=p,this.B(p.listen("onDidChangeLogLevel",b)(w=>{(0,j.$Yj)(w)?super.setLogLevel(w):super.setLogLevel(R.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",b)(([w,u])=>super.setVisibility(R.URI.revive(w),u))),this.B(p.listen("onDidChangeLoggers",b)(({added:w,removed:u})=>{for(const d of w)super.registerLogger({...d,resource:R.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new j.$6j({log:(b,m)=>{this.t.call("consoleLog",[b,m])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,m){super.setLogLevel(b,m),this.t.call("setLogLevel",[b,m])}setVisibility(b,m){super.setVisibility(b,m),this.t.call("setVisibility",[this.n(b),m])}s(b,m,f){return new I(this.t,b,m,f,this.r)}static setLogLevel(b,m,f){return b.call("setLogLevel",[m,f])}}e.$3r=A;class I extends j.$3j{constructor(b,m,f,h,p){super(h?.logLevel==="always"),this.r=b,this.s=m,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[m,h,p]).then(()=>{this.u(this.n),this.m=!0})}g(b,m){const f=[[b,m]];this.m?this.u(f):this.n.push(...f)}u(b){this.r.call("log",[this.s,b])}}class P{constructor(b,m){this.a=b,this.b=m}listen(b,m){const f=this.b(b);switch(m){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,h=>({added:[...h.added].map(p=>this.c(p,f)),removed:[...h.removed].map(p=>this.c(p,f))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,h=>[f.transformOutgoingURI(h[0]),h[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,h=>(0,j.$Yj)(h)?h:[f.transformOutgoingURI(h[0]),h[1]])}throw new Error(`Event not found: ${m}`)}async call(b,m,f){const h=this.b(b);switch(m){case"setLogLevel":return(0,j.$Yj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(R.URI.revive(h.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,h)))}throw new Error(`Call not found: ${m}`)}c(b,m){return{...b,resource:m.transformOutgoingURI(b.resource)}}}e.$4r=P;class $ extends L.$Uc{constructor(b,m){super(),m.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const h of f)b.registerLogger({...h,resource:R.URI.revive(h.resource)})}),this.B(m.listen("onDidChangeVisibility")(([f,h])=>b.setVisibility(R.URI.revive(f),h))),this.B(m.listen("onDidChangeLoggers")(({added:f,removed:h})=>{for(const p of f)b.registerLogger({...p,resource:R.URI.revive(p.resource)});for(const p of h)b.deregisterLogger(p.resource)}))}}e.$5r=$}),define(ce[209],le([0,1,2,9]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class j extends R.$Uc{constructor(A,I=[]){super(),this.a=new N.$7j([A,...I]),this.B(A.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$AQ=j}),define(ce[57],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0,e.$Pbc=(0,R.$qi)("nativeHostService")}),define(ce[210],le([0,1,41,56]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let j=class{constructor(A,I){return this.windowId=A,R.ProxyChannel.toService(I.getChannel("nativeHost"),{context:A,properties:(()=>{const P=new Map;return P.set("windowId",A),P})()})}};e.$$cc=j,e.$$cc=j=Ee([Q(1,N.$5cc)],j)}),define(ce[58],le([0,1,3,61,2,4]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=void 0,e.$$n=(0,L.$qi)("policy");class A extends j.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$be),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const S=Object.keys(this.f).length;return this.f={...$,...this.f},S!==Object.keys(this.f).length&&await this.j($),N.Iterable.reduce(this.g.entries(),(b,[m,f])=>({...b,[m]:f}),{})}getPolicyValue($){return this.g.get($)}serialize(){return N.Iterable.reduce(Object.entries(this.f),($,[S,b])=>({...$,[S]:{definition:b,value:this.g.get(S)}}),{})}}e.$_n=A;class I{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ao=I}),define(ce[211],le([0,1,3,2,58]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=void 0;class L{constructor(P){this.b=P,this.a=new N.$Tc}listen(P,$){switch($){case"onDidChange":return R.Event.map(this.b.onDidChange,S=>S.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${$}`)}call(P,$,S){switch($){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${$}`)}dispose(){this.a.dispose()}}e.$Acc=L;class A extends j.$_n{constructor(P,$){super(),this.a=$;for(const S in P){const{definition:b,value:m}=P[S];this.f[S]=b,m!==void 0&&this.g.set(S,m)}this.a.listen("onDidChange")(S=>{for(const b in S){const m=S[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(S))})}async j(P){const $=await this.a.call("updatePolicyDefinitions",P);for(const S in $)this.g.set(S,$[S])}}e.$Bcc=A}),define(ce[100],le([0,1,36]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.context<"u"){const L=j.context.configuration();if(L)N=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:L.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ce[24],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,R.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"}),define(ce[212],le([0,1,6,7,2,14,31,9,24]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let $=class extends j.$Uc{constructor(b,m,f){super(),this.b=m,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new R.$Ch(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),f=(0,L.$nc)(b),h=(0,L.$oc)(b),p=await A.Promises.readdir(f);await Promise.all(p.map(async w=>{if(w===h)return;const u=(0,L.$kc)(f,w),d=await A.Promises.stat(u);if(d.isDirectory()&&m-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),A.Promises.rm(u)}))}catch(m){(0,N.$1)(m)}}};e.$rdc=$,e.$rdc=$=Ee([Q(1,P.$dk),Q(2,I.$Wj)],$)}),define(ce[213],le([0,1,6,7,2,14,31,16,9,24]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let S=class extends j.$Uc{constructor(m,f,h){super(),this.b=m,this.c=f,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$Ch(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),f=JSON.parse(await A.Promises.readFile((0,L.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(f)){const l=f[d];m[`${l.hash}.${d}`]=!0}const h=(0,L.$kc)(this.b.userDataPath,"clp");if(!await A.Promises.exists(h))return;const w=await A.Promises.readdir(h);for(const d of w){if(m[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await A.Promises.rm((0,L.$kc)(h,d))}const u=Date.now();for(const d of Object.keys(m)){const l=(0,L.$kc)(h,d),c=await A.Promises.readdir(l);for(const g of c){if(g==="tcf.json")continue;const i=(0,L.$kc)(l,g),o=await A.Promises.stat(i);o.isDirectory()&&u-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$kc)(d,g)}`),await A.Promises.rm(i))}}}catch(m){(0,N.$1)(m)}}};e.$sdc=S,e.$sdc=S=Ee([Q(0,I.$yi),Q(1,P.$Wj),Q(2,$.$dk)],S)}),define(ce[214],le([0,1,14,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$dG=void 0,e.$dG=(0,N.$qi)("IV8InspectProfilingService");var j;(function(L){function A(P){return!!(P.samples&&P.timeDeltas)}L.isValidProfile=A;function I(P,$="noAbsolutePaths"){for(const S of P.nodes)S.callFrame&&S.callFrame.url&&((0,R.$jc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,R.$kc)($,(0,R.$oc)(S.callFrame.url)));return P}L.rewriteAbsolutePaths=I})(j||(e.Utils=j={}))}),define(ce[215],le([0,1,32]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const I=await(await new Promise(($,S)=>{ne(["v8-inspect-profiler"],$,S)})).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),P=(0,R.$Mg)();return this.a.set(P,I),P}async stopProfiling(L){const A=this.a.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const I=await A.stop();return this.a.delete(L),I.profile}}e.$Jdc=N}),define(ce[42],le([0,1,127,13]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class j{constructor(){this.a=new Map}add(A,I){R.ok(N.$4f(A)),R.ok(N.$6f(I)),R.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$9n=new j}),define(ce[101],le([0,1,3,42]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function j(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this.b=new R.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,$){this.a[j(P)]=$,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;N.$9n.add(e.$0n.JSONContribution,A)}),define(ce[47],le([0,1,17,3,13,153,21,101,42]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=p,e.$no=w,e.$oo=u,e.$po=l,e.$qo=c;var $;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$bo={Configuration:"base.contributions.configuration"};var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const b=P.$9n.as(I.$0n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$io,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),b.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),b.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$lo.test(r)){const a=this.a.get(r),y=a?.valuesSources??new Map;if(t)for(const k of Object.keys(s[r]))y.set(k,t);const v={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:v,valuesSources:y});const C=(0,A.$7i)(r),E={type:"object",default:v,description:L.localize(1,null,C),$ref:e.$io,defaultDefaultValue:v,source:j.$4f(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=E,this.b.properties[r]=E}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=j.$4f(s)?s:s?.id,y=j.$4f(r?.source)?r?.source:r?.source?.id;if(a===y)if(o.add(t),this.a.delete(t),e.$lo.test(t))delete this.d[t],delete this.b.properties[t];else{const v=this.d[t];v&&(this.w(t,v),this.r(t,v))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=j.$ag(i.scope)?t:i.scope;const a=i.properties;if(a)for(const v in a){const C=a[v];if(o&&l(v,C)){delete a[v];continue}if(C.source=n,C.defaultDefaultValue=a[v].default,this.w(v,C),e.$lo.test(v)?C.scope=void 0:(C.scope=j.$ag(C.scope)?t:C.scope,C.restricted=j.$ag(C.restricted)?!!s?.includes(v):C.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.f[v]=a[v],delete a[v];continue}else this.d[v]=a[v],a[v].policy?.name&&this.e.set(a[v].policy.name,v);!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),r.add(v)}const y=i.allOf;if(y)for(const v of y)this.p(v,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$co.properties[i]=o,o.scope){case 1:e.$do.properties[i]=o;break;case 2:e.$eo.properties[i]=o;break;case 6:e.$fo.properties[i]=o;break;case 3:e.$go.properties[i]=o;break;case 4:e.$ho.properties[i]=o;break;case 5:e.$ho.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$co.properties[i],o.scope){case 1:delete e.$do.properties[i];break;case 2:delete e.$eo.properties[i];break;case 6:delete e.$fo.properties[i];break;case 3:delete e.$go.properties[i];break;case 4:case 5:delete e.$ho.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$io};this.w(o,n),e.$co.properties[o]=n,e.$do.properties[o]=n,e.$eo.properties[o]=n,e.$fo.properties[o]=n,e.$go.properties[o]=n,e.$ho.properties[o]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=i,e.$do.patternProperties[e.$ko]=i,e.$eo.patternProperties[e.$ko]=i,e.$fo.patternProperties[e.$ko]=i,e.$go.patternProperties[e.$ko]=i,e.$ho.patternProperties[e.$ko]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;j.$$f(s)&&(s=o.defaultDefaultValue,t=void 0),j.$$f(s)&&(s=u(o.type)),o.default=s,o.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",h=new RegExp(f,"g");e.$ko=`^(${f})+$`,e.$lo=new RegExp(e.$ko);function p(g){const i=[];if(e.$lo.test(g)){let o=h.exec(g);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=h.exec(g)}}return(0,R.$Mb)(i)}function w(g){return g.reduce((i,o)=>`${i}[${o}]`,"")}function u(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new m;P.$9n.add(e.$bo.Configuration,d);function l(g,i){return g.trim()?e.$lo.test(g)?L.localize(7,null,g):d.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,g,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}function c(){const g=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))g.push([o,i[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(ce[76],le([0,1,17,3,35,2,34,30,13,8,21,47,42]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=l;function f(o){return Object.isFrozen(o)?o:I.$Xn(o)}class h{static createEmptyModel(n){return new h({},[],[],void 0,n)}constructor(n,s,t,r,a){this.b=n,this.c=s,this.d=t,this.raw=r,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof h)return s;const t=new p("",this.f);return t.parseRaw(s),t.configurationModel});this.g=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,S.$5i)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return f(t.rawConfiguration.getValue(n))},get override(){return s?f(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return f(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:y,keys:v}of t.rawConfiguration.overrides){const C=new h(a,v,[],void 0,t.f).getValue(n);C!==void 0&&r.push({identifiers:y,value:C})}return r.length?f(r):void 0}}}getOverrideValue(n,s){const t=this.j(s);return t?n?(0,S.$5i)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return R.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return R.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$Wn(this.contents),t=I.$Wn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const y of n)if(a.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const v of y.overrides){const[C]=t.filter(E=>R.$ub(E.identifiers,v.identifiers));C?(this.i(C.contents,v.contents),C.keys.push(...v.keys),C.keys=R.$Mb(C.keys)):t.push(I.$Wn(v))}for(const v of y.keys)r.indexOf(v)===-1&&r.push(v)}return new h(s,r,t,a.every(y=>y instanceof h)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of R.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const y=s[r];y&&(typeof a=="object"&&typeof y=="object"?(a=I.$Wn(a),this.i(a,y)):a=y),t[r]=a}return new h(t,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const t of Object.keys(s)){if(t in n&&P.$6f(n[t])&&P.$6f(s[t])){this.i(n[t],s[t]);continue}n[t]=I.$Wn(s[t])}}j(n){let s=null,t=null;const r=a=>{a&&(t?this.i(t,a):t=I.$Wn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,S.$4i)(this.contents,n),b.$lo.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>R.$ub(t.identifiers,(0,b.$mo)(n))),1))}k(n,s,t){(0,S.$3i)(this.contents,n,s,r=>this.f.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),b.$lo.test(n)&&this.overrides.push({identifiers:(0,b.$mo)(n),keys:Object.keys(this.contents[n]),contents:(0,S.$2i)(this.contents[n],r=>this.f.error(r))})}}e.$ro=h;class p{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||h.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$ag(n)){const t=this.h(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:y,hasExcludedProperties:v}=this.i(n,s);this.b=new h(t,r,a,v?[n]:void 0,this.g),this.c=y||[]}h(n){let s={},t=null,r=[];const a=[],y=[];function v(E){Array.isArray(r)?r.push(E):t!==null&&(r[t]=E)}const C={onObjectBegin:()=>{const E={};v(E),a.push(r),r=E,t=null},onObjectProperty:E=>{t=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];v(E),a.push(r),r=E,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:v,onError:(E,k,O)=>{y.push({error:E,offset:k,length:O})}};if(n)try{j.$Kn(n,C),s=r[0]||{}}catch(E){this.g.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return s}i(n,s){const t=m.$9n.as(b.$bo.Configuration).getConfigurationProperties(),r=this.j(n,t,!0,s);n=r.raw;const a=(0,S.$2i)(n,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`)),y=Object.keys(n),v=this.l(n,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:a,keys:y,overrides:v,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const y={},v=[];for(const C in n)if(b.$lo.test(C)&&t){const E=this.j(n[C],s,!1,r);y[C]=E.raw,a=a||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=s[C],k=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(C),!r.exclude?.includes(C)&&(r.include?.includes(C)||(k===void 0||r.scopes===void 0||r.scopes.includes(k))&&!(r.skipRestricted&&E?.restricted))?y[C]=n[C]:a=!0}return{raw:y,restricted:v,hasExcludedProperties:a}}l(n,s){const t=[];for(const r of Object.keys(n))if(b.$lo.test(r)){const a={};for(const y in n[r])a[y]=n[r][y];t.push({identifiers:(0,b.$mo)(r),keys:Object.keys(a),contents:(0,S.$2i)(a,s)})}return t}}e.$so=p;class w extends L.$Uc{constructor(n,s,t,r,a){super(),this.c=n,this.f=s,this.g=r,this.h=a,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),a),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&t.isEqual(y.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return h.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=w;class u{constructor(n,s,t,r,a,y,v,C,E,k,O,M,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=y,this.g=v,this.h=C,this.i=E,this.j=k,this.k=O,this.l=M,this.m=F}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(n,s,t,r,a,y,v,C,E,k){this.j=n,this.l=s,this.m=t,this.n=r,this.p=a,this.q=y,this.r=v,this.s=C,this.t=E,this.u=k,this.h=null,this.i=new A.$Bc,this.v=null}getValue(n,s,t){return this.w(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.t.get(t.resource),r||(r=h.createEmptyModel(this.u),this.t.set(t.resource,r))):r=this.s,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.h=null)}inspect(n,s,t){const r=this.w(n,s,t),a=this.A(s.resource,t),y=s.resource?this.t.get(s.resource)||this.s:this.s,v=new Set;for(const C of r.overrides)for(const E of C.identifiers)r.getOverrideValue(n,E)!==void 0&&v.add(E);return new u(n,s,r.getValue(n),v.size?[...v]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.q:void 0,a||void 0,y)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:y}=g(this.j,n);s=[...r,...a,...y]}for(const r of s)for(const a of(0,b.$mo)(r)){const y=this.j.getKeysForOverrideIdentifier(a),v=n.getKeysForOverrideIdentifier(a),C=[...v.filter(E=>y.indexOf(E)===-1),...y.filter(E=>v.indexOf(E)===-1),...y.filter(E=>!I.$1n(this.j.override(a).getValue(E),n.override(a).getValue(E)))];t.push([a,C])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=g(this.l,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.applicationConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.localUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.remoteUserConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=g(this.workspaceConfiguration,n),y=[...s,...t,...r];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:y,overrides:v}=g(t,s),C=[...r,...a,...y];return(C.length||!t)&&this.updateFolderConfiguration(n,s),{keys:C,overrides:v}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:y}=g(s,void 0);return{keys:[...t,...r,...a],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,t){let r=this.x(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(r=r.merge(this.l)),r}x({resource:n},s){let t=this.y();if(s&&n){const r=s.getFolder(n);r&&(t=this.z(r.uri)||t);const a=this.t.get(n);a&&(t=t.merge(a))}return t}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const t=this.y(),r=this.r.get(n);r?(s=t.merge(r),this.i.set(n,s)):s=t}return s}A(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.r.get(t.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.r.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.q.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.r.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n,s){const t=this.E(n.defaults,s),r=this.E(n.policy,s),a=this.E(n.application,s),y=this.E(n.user,s),v=this.E(n.workspace,s),C=n.folders.reduce((E,k)=>(E.set($.URI.revive(k[0]),this.E(k[1],s)),E),new A.$Bc);return new d(t,r,a,y,h.createEmptyModel(s),v,C,h.createEmptyModel(s),new A.$Bc,s)}static E(n,s){return new h(n.contents,n.keys,n.overrides,void 0,s)}}e.$uo=d;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,y])=>{const v=(0,A.$yc)(s,a,new Set);y.forEach(C=>v.add(C))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r,a){this.change=n,this.f=s,this.g=t,this.h=r,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of n.keys)this.affectedKeys.add(y);for(const[,y]of n.overrides)for(const v of y)this.affectedKeys.add(v);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const y=this.d.charCodeAt(a);if(y!==this.b&&y!==this.c)return!1;if(s){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,C=this.g.getValue(n,s,this.h);return!I.$1n(v,C)}return!0}}e.$wo=c;function g(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],y=o?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const C=v.filter(E=>!y.includes(E));for(const E of C)a.push([E,n.getKeysForOverrideIdentifier(E)])}if(o){const C=y.filter(E=>!v.includes(E));for(const E of C)a.push([E,o.getKeysForOverrideIdentifier(E)])}if(n&&o){for(const C of y)if(v.includes(C)){const E=i({contents:o.getOverrideValue(void 0,C)||{},keys:o.getKeysForOverrideIdentifier(C)},{contents:n.getOverrideValue(void 0,C)||{},keys:n.getKeysForOverrideIdentifier(C)});a.push([C,[...E.added,...E.removed,...E.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const y=(0,S.$5i)(n.contents,a),v=(0,S.$5i)(o.contents,a);I.$1n(y,v)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(ce[216],le([0,1,17,3,2,30,13,76,47,9,58,42]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0;class m extends j.$Uc{get configurationModel(){return this.b}constructor(w){super(),this.c=w,this.a=this.B(new N.$be),this.onDidChangeConfiguration=this.a.event,this.b=I.$ro.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$9n.as(P.$bo.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:u})=>this.f(Array.from(w),u))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(w,u){this.j(w,b.$9n.as(P.$bo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}g(){return{}}h(){this.b=I.$ro.createEmptyModel(this.c);const w=b.$9n.as(P.$bo.Configuration).getConfigurationProperties();this.j(Object.keys(w),w)}j(w,u){const d=this.g();for(const l of w){const c=d[l],g=u[l];c!==void 0?this.b.addValue(l,c):g?this.b.addValue(l,g.default):this.b.removeValue(l)}}}e.$xo=m;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$ro.createEmptyModel(new $.$0j)}async initialize(){return this.configurationModel}}e.$yo=f;let h=class extends j.$Uc{get configurationModel(){return this.b}constructor(w,u,d){super(),this.c=w,this.f=u,this.g=d,this.a=this.B(new N.$be),this.onDidChangeConfiguration=this.a.event,this.b=I.$ro.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const u={},d=[],l=b.$9n.as(P.$bo.Configuration).getConfigurationProperties();for(const c of w){const g=l[c];if(!g){d.push(c);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}d.push(c),u[g.policy.name]={type:g.type}}}return(0,A.$eg)(u)||await this.f.updatePolicyDefinitions(u),d}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const u=b.$9n.as(P.$bo.Configuration).getPolicyConfigurations(),d=(0,R.$Hb)(w.map(l=>u.get(l)));this.m(d,!0)}m(w,u){this.g.trace("PolicyConfiguration#update",w);const d=b.$9n.as(P.$bo.Configuration).getConfigurationProperties(),l=[],c=this.b.isEmpty();for(const g of w){const i=d[g]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,L.$1n)(this.b.getValue(g),o))&&l.push([g,o])}else this.b.getValue(g)!==void 0&&l.push([g,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const g=this.b;this.b=I.$ro.createEmptyModel(this.g);for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,o]of l)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);u&&this.a.fire(this.b)}}};e.$zo=h,e.$zo=h=Ee([Q(1,S.$$n),Q(2,$.$Wj)],h)}),define(ce[217],le([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0;class d extends P.$Uc{constructor(g,i,o,n){super(),this.m=g,this.n=n,this.h=this.B(new L.$be),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$xo(n)),this.c=o instanceof u.$ao?new w.$yo:this.B(new w.$zo(this.b,o,n)),this.f=this.B(new h.$to(this.m,{},m.$Ug,i,n)),this.a=new h.$uo(this.b.configurationModel,this.c.configurationModel,h.$ro.createEmptyModel(n),h.$ro.createEmptyModel(n),h.$ro.createEmptyModel(n),h.$ro.createEmptyModel(n),new $.$Bc,h.$ro.createEmptyModel(n),new $.$Bc,n),this.j=new l(g,i,this),this.g=this.B(new N.$Ch(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:t})=>this.s(s,t))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$uo(g,i,h.$ro.createEmptyModel(this.n),o,h.$ro.createEmptyModel(this.n),h.$ro.createEmptyModel(this.n),new $.$Bc,h.$ro.createEmptyModel(this.n),new $.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(g,i){const o=typeof g=="string"?g:void 0,n=(0,f.$Xi)(g)?g:(0,f.$Xi)(i)?i:{};return this.a.getValue(o,n,void 0)}async updateValue(g,i,o,n,s){const t=(0,f.$Yi)(o)?o:(0,f.$Xi)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,r=t?n:o;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${g} to target ${r}.`);t?.overrideIdentifiers&&(t.overrideIdentifiers=(0,R.$Mb)(t.overrideIdentifiers),t.overrideIdentifiers=t.overrideIdentifiers.length?t.overrideIdentifiers:void 0);const a=this.inspect(g,{resource:t?.resource,overrideIdentifier:t?.overrideIdentifiers?t.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${g} because it is configured in system policy.`);if((0,S.$1n)(i,a.defaultValue)&&(i=void 0),t?.overrideIdentifiers?.length&&t.overrideIdentifiers.length>1){const v=t.overrideIdentifiers.sort(),C=this.a.localUserConfiguration.overrides.find(E=>(0,R.$ub)([...E.identifiers].sort(),v));C&&(t.overrideIdentifiers=C.identifiers)}const y=t?.overrideIdentifiers?.length?[(0,p.$no)(t.overrideIdentifiers),g]:[g];await this.j.write(y,i),await this.reloadConfiguration()}inspect(g,i={}){return this.a.inspect(g,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.r(g)}r(g){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(g);this.u(o,i,2)}s(g,i){const o=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(g,i);this.u(n,o,7)}t(g){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(g);this.u(o,i,7)}u(g,i,o){const n=new h.$wo(g,{data:i},this.a,void 0,this.n);n.source=o,this.h.fire(n)}}e.$Ao=d;class l{constructor(g,i,o){this.b=g,this.c=i,this.d=o,this.a=new N.$xh}write(g,i){return this.a.queue(()=>this.e(g,i))}async e(g,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(t){if(t.fileOperationResult===1)o="{}";else throw t}const n=[];if((0,A.$Dn)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(o,g,i);o=(0,I.$Vn)(o,s),await this.c.writeFile(this.b,j.$Ce.fromString(o))}f(g,i,o){const{tabSize:n,insertSpaces:s,eol:t}=this.h;if(!i.length){const r=JSON.stringify(o,null,s?" ".repeat(n):"	");return[{content:r,length:r.length,offset:0}]}return(0,I.$Sn)(g,i,o,{tabSize:n,insertSpaces:s,eol:t})}get h(){if(!this.g){let g=b.OS===3||b.OS===2?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(g=i),this.g={eol:g,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[218],le([0,1,15,3,2,68]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsb=e.$Jsb=e.$Isb=void 0,e.$Ksb=I;const A=($,S,b)=>{const m=new Uint8Array(16);for(let p=0;p<16;p++)m[p]=Math.round(Math.random()*256);const f=(0,R.$We)(R.$Ce.wrap(m));return[`GET ws://localhost${$}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$Isb=A,e.$Jsb=R.$Ce.fromString(`\r
\r
`);async function I($,S,b,m,f){$.write(R.$Ce.fromString((0,e.$Isb)(S,b,m)));const h=new j.$Tc;try{return await new Promise((p,w)=>{let u;h.add($.onData(d=>{u?u=R.$Ce.concat([u,d],u.byteLength+d.byteLength):u=d;const l=u.indexOf(e.$Jsb);if(l===-1)return;p($),$.pauseData();const c=u.slice(l+e.$Jsb.byteLength);c.byteLength&&f.onData.fire(c)})),h.add($.onClose(d=>w(d??new Error("socket closed")))),h.add($.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw $.dispose(),p}finally{h.dispose()}}class P extends j.$Uc{constructor(S,b){super(),this.g=S,this.a=this.B(new N.$ee),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(b.onData),this.B(b.onData.event(m=>this.a.fire(m))),this.onClose=this.B(b.onClose).event,this.onEnd=this.B(b.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,b){L.SocketDiagnostics.traceSocketEvent(this,this.g,S,b)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Lsb=P}),define(ce[219],le([0,1,7,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=$,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var j;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class L{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=L;class A{constructor(b,m){this.host=b,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=A;var I;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class P extends R.$bb{static isNotAvailable(b){return b instanceof P&&b._code===I.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof P&&b._code===I.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof P&&b._code===I.NoResolverFound}static isInvalidAuthority(b){return b instanceof P&&b._code===I.InvalidAuthority}static isHandled(b){return b instanceof P&&b.isHandled}constructor(b,m=I.Unknown,f){super(b),this._message=b,this._code=m,this._detail=f,this.isHandled=m===I.NotAvailable&&f===!0,Object.setPrototypeOf(this,P.prototype)}}e.$El=P;function $(S){const b=S.indexOf("+");return b===-1?S:S.substring(0,b)}}),define(ce[220],le([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=y,e.$Ll=v,e.$Ml=E;const h=30*1e3;var p;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(q){const D=new j.$me;return setTimeout(()=>D.cancel(),q),D.token}function d(q,D){if(q.isCancellationRequested||D.isCancellationRequested)return j.CancellationToken.Cancelled;const T=new j.$me;return q.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$jh)(),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function c(q,D){const T=new l(D);return T.registerDisposable(q.onControlMessage(z=>{const x=JSON.parse(z.toString()),K=B(x);K?T.reject(K):T.resolve(x)})),T.promise}function g(q,D,T,z,x,K,ee,_){const Y=new l(_),se=S.$0d.create(!1);return q.info(`Creating a socket (${ee})...`),$.mark(`code/willCreateSocket/${K}`),D.connect(T,z,x,ee).then(ue=>{Y.didTimeout?($.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):($.mark(`code/didCreateSocketOK/${K}`),q.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),Y.resolve(ue))},ue=>{$.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),q.error(ue),Y.reject(ue)}),Y.promise}function i(q,D){const T=new l(D);return q.then(z=>{T.didTimeout||T.resolve(z)},z=>{T.didTimeout||T.reject(z)}),T.promise}async function o(q,D,T,z){const x=ae(q,D);q.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let K;try{K=await g(q.logService,q.remoteSocketFactoryService,q.connectTo,P.$Dg.getServerRootPath(),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,w(D),`renderer-${w(D)}-${q.reconnectionToken}`,z)}catch(ue){throw q.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ue),ue}q.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(K,null),ee=q.reconnectionProtocol,_=!1):(ee=new m.$ei({socket:K}),_=!0),q.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Y=await i(q.signService.createNewMessage((0,b.$Mg)()),z),se={type:"auth",auth:q.connectionToken||"00000000000000000000",data:Y.data};ee.sendControl(N.$Ce.fromString(JSON.stringify(se)));try{const ue=await c(ee,d(z,u(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(q.logService.trace(`${x} 4/6. received SignRequest control message.`),!await i(q.signService.validate(Y,ue.signedData),z)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const fe=await i(q.signService.sign(ue.data),z),$e={type:"connectionType",commit:q.commit,signedData:fe,desiredConnectionType:D};return T&&($e.args=T),q.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$Ce.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(q.logService.error(`${x} the handshake timed out. Error:`),q.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${x} received error control message when negotiating connection. Error:`),q.logService.error(ue)),_&&V(ee),ue}}async function n(q,D,T,z){const x=Date.now(),K=ae(q,D),{protocol:ee,ownsProtocol:_}=await o(q,D,T,z),Y=new l(z);return Y.registerDisposable(ee.onControlMessage(se=>{const ue=JSON.parse(se.toString()),ge=B(ue);ge?(q.logService.error(`${K} received error control message when negotiating connection. Error:`),q.logService.error(ge),_&&V(ee),Y.reject(ge)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${G(x)}!`),Y.resolve({protocol:ee,firstMessage:ue}))})),Y.promise}async function s(q,D){const{protocol:T}=await n(q,1,void 0,D);return{protocol:T}}async function t(q,D,T){const{protocol:z,firstMessage:x}=await n(q,2,D,T),K=x&&x.debugPort;return{protocol:z,debugPort:K}}async function r(q,D,T){const z=Date.now(),x=ae(q,3),{protocol:K}=await o(q,3,D,T);return q.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${G(z)}!`),K}async function a(q,D,T){const{connectTo:z,connectionToken:x}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:z,connectionToken:x,reconnectionToken:D,reconnectionProtocol:T,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function y(q,D,T){return C(q,async z=>{const{protocol:x}=await s(z,j.CancellationToken.None);return new W(q,D,T,z.reconnectionToken,x)})}async function v(q,D){return C(q,async T=>{const{protocol:z,debugPort:x}=await t(T,D,j.CancellationToken.None);return new J(q,D,T.reconnectionToken,z,x)})}async function C(q,D){for(let z=1;;z++)try{const x=(0,b.$Mg)(),K=await a(q,x,null);return await D(K)}catch(x){if(z<5)q.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(x);else throw q.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(x),Z.triggerPermanentFailure(0,0,f.$El.isHandled(x)),x}}async function E(q,D,T){const z=await a(q,(0,b.$Mg)(),null);return await r(z,{host:D,port:T},j.CancellationToken.None)}function k(q){return(0,R.$dh)(D=>new Promise((T,z)=>{const x=setTimeout(T,q*1e3);D.onCancellationRequested(()=>{clearTimeout(x),T()})}))}var O;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class M{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.$Nl=M;class F{constructor(D,T,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=z,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=F;class U{constructor(D,T,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=z,this.type=2}}e.$Pl=U;class X{constructor(D,T,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=z,this.type=4}}e.$Ql=X;class H{constructor(D,T,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=z,this.handled=x,this.type=3}}e.$Rl=H;class Z extends I.$Uc{static triggerPermanentFailure(D,T,z){this._permanentFailure=!0,this.f=D,this.g=T,this.h=z,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(D,T,z,x,K){super(),this.t=D,this.u=T,this.reconnectionToken=z,this.protocol=x,this.w=K,this.m=this.B(new A.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=te(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,I.$Sc)(()=>{const ee=Z.j.indexOf(this);ee>=0&&Z.j.splice(ee,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const x=z<T.length?T[z]:T[T.length-1];try{if(x>0){const ee=k(x);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${D} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${D} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${K.connectTo}...`),await this.G(K,u(h)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(f.$El.isTemporarilyNotAvailable(K)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,L.$4)(K)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof f.$El){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,f.$El.isHandled(K));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(D,T,z){this.w?Z.triggerPermanentFailure(D,T,z):this.D(D,T,z)}D(D,T,z){this.m.fire(new H(this.reconnectionToken,D,T,z)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=Z;class W extends Z{constructor(D,T,z,x,K){super(1,D,x,K,!0),this.client=this.B(new m.$ci(K,{remoteAuthority:T,clientId:z},D.ipcLogger))}async G(D,T){await s(D,T)}}e.$Tl=W;class J extends Z{constructor(D,T,z,x,K){super(2,D,z,x,!1),this.H=T,this.debugPort=K}async G(D,T){await t(D,this.H,T)}}e.$Ul=J;function V(q){try{q.acceptDisconnect();const D=q.getSocket();q.dispose(),D.dispose()}catch(D){(0,L.$1)(D)}}function B(q){if(q&&q.type==="error"){const D=new Error(`Connection error: ${q.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function ie(q,D){for(;q.length<D;)q+=" ";return q}function oe(q,D){return`[remote-connection][${ie(w(q),13)}][${D.substr(0,5)}\u2026]`}function te(q,D,T){return`${oe(q,D)}[${T?"reconnect":"initial"}]`}function ae(q,D){return`${te(D,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function G(q){return`${Date.now()-q} ms`}}),define(ce[102],le([0,1,23]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=j,e.$Dm=L,e.$Em=A;function N(P){return P.scheme===R.Schemas.vscodeRemote?P.authority:void 0}function j(P){if(!P)return;const $=P.indexOf("+");return $<0?P:P.substr(0,$)}function L(P){const{host:$,port:S}=I(P);if(typeof S>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:$,port:S}}function A(P,$){let{host:S,port:b}=I(P);return typeof b>"u"&&(b=$),{host:S,port:b}}function I(P){const $=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const S=P.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const b=P.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:P,port:void 0}}}),define(ce[48],le([0,1,27,4,102]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=L,e.$Om=b,e.$Pm=m,e.$Qm=f,e.$Rm=h,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class P{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,u){if(typeof w>"u"||w===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof w=="string"||typeof u=="string"){const d=typeof w=="string"?w:w.value,l=typeof u=="string"?u:u.value;return R.$tf(d,l)}return w._lower===u._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Lm=P;class ${get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const u of w)this.add(u)}add(w){this.c.add(P.toKey(w))}delete(w){return this.c.delete(P.toKey(w))}has(w){return this.c.has(P.toKey(w))}}e.$Mm=$;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(P.toKey(w))}get(w){return this.c.get(P.toKey(w))}has(w){return this.c.has(P.toKey(w))}set(w,u){this.c.set(P.toKey(w),u)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=S;function b(p){return m(p)}function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function f(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function h(p,w){if(w){const u=`onResolveRemoteAuthority:${(0,j.$Cm)(w)}`;return!!p.activationEvents?.includes(u)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(ce[221],le([0,1,2,48,12]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;class L extends R.$Uc{constructor(I,P,$,S,b){super(),this.a=I,this.b=P,this.c=$,this.f=b,this.B(S.onDidInstallExtensions(m=>this.g(m))),this.B(S.onDidUninstallExtension(m=>this.h(m)))}g(I){for(const P of I)P.local&&this.invalidate(P.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,I)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Fm))}catch(P){(0,j.$bl)(P)!==1&&this.f.error(P)}}}e.$vq=L}),define(ce[103],le([0,1,2,4]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,N.$qi)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(A,I){return this.a[A]??=[],this.a[A].push(I),(0,R.$Sc)(()=>{const P=this.a[A]?.indexOf(I);typeof P=="number"&&P>=0&&this.a[A]?.splice(P,1)})}b(A){return(this.a[A.type]||[]).find(P=>P.supports(A))}connect(A,I,P,$){const S=this.b(A);if(!S)throw new Error(`No socket factory found for ${A}`);return S.connect(A,I,P,$)}}e.$Hl=j}),define(ce[222],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0,e.$Gdc=(0,R.$qi)("sharedProcessTunnelService"),e.$Hdc="sharedProcessTunnel"}),define(ce[104],le([0,1,4,169]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=e.$Pdc=e.$Odc=e.$Ndc=e.TunnelStates=e.$Mdc=e.$Ldc=void 0,e.$Ldc=(0,R.$qi)("IRemoteTunnelService"),e.$Mdc={active:!1};var j;(function(L){L.disconnected=A=>({type:"disconnected",onTokenFailed:A}),L.connected=(A,I)=>({type:"connected",info:A,serviceInstallFailed:I}),L.connecting=A=>({type:"connecting",progress:A}),L.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$Ndc="remote.tunnels.access",e.$Odc=e.$Ndc+".hostNameOverride",e.$Pdc=e.$Ndc+".preventSleep",e.$Qdc="remoteTunnelService",e.$Rdc=(0,N.localize)(0,null)}),define(ce[59],le([0,1,15,7,2,171,47,4,9,42]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Jp=m,e.$Kp=f,e.$Lp=h,e.$Mp=p,e.$Np=w,e.$Op=u,e.$Hp=(0,I.$qi)("requestService");class S{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class b extends j.$Uc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,L.localize)(0,null),when:P.$ck.isEqualTo((0,P.$_j)(P.LogLevel.Trace)).serialize()})}async c(g,i,o){const n=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new S(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$0)(s)),s}}}e.$Ip=b;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function f(c){return c.res.statusCode===204}async function h(c){return f(c)?null:(await(0,R.$Oe)(c.stream)).toString()}async function p(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return h(c)}async function w(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const i=(await(0,R.$Oe)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function u(c){l(c)}let d;function l(c){const g=$.$9n.as(A.$bo.Configuration),i=d;d={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:i?[i]:[]})}l(1)}),define(ce[223],le([0,1,26,23,12,59]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=void 0;let A=class{constructor(P,$){this.a=P,this.b=$}async download(P,$,S=R.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.b.copy(P,$);return}const b={type:"GET",url:P.toString(!0)},m=await this.a.request(b,S);if(m.res.statusCode===200)await this.b.writeFile($,m.stream);else{const f=await(0,L.$Mp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.$PQ=A,e.$PQ=A=Ee([Q(0,L.$Hp),Q(1,j.$Wk)],A)}),define(ce[224],le([0,1,15,26]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0;class j{constructor(I){this.a=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,$,S=N.CancellationToken.None){switch(P){case"request":return this.a.request($[0],S).then(async({res:b,stream:m})=>{const f=await(0,R.$Oe)(m);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy($[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Mr=j;class L{constructor(I){this.a=I}async request(I,P){const[$,S]=await this.a.call("request",[I],P);return{res:$,stream:(0,R.$Qe)(S)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Nr=L}),define(ce[225],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=e.$$bc=void 0,e.$$bc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$_bc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$acc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[226],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const L=await this.c();if(L){const A=String(R.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,L){if(!j.id)return!0;const A=this.b.get(j.id);if(!A)return!1;this.b.delete(j.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$50b=R}),define(ce[105],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,R.$qi)(e.$Il)}),define(ce[227],le([0,1,226]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class N extends R.$50b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>ne(["vsda"],L,A))}}e.$1cc=N}),define(ce[77],le([0,1,3,2]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Jb=e.$2Jb=e.$1Jb=e.$ZJb=void 0;class j extends N.$Uc{constructor(b,m,f){super(),this.a=b,this.b=m,this.c=f}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}optimize(){const b={profile:this.b,workspace:this.c};return this.a.call("optimize",b)}}class L extends j{constructor(b,m){super(b,m,void 0),this.f=this.B(new R.$be),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class A extends L{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.$ZJb=A;class I extends L{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.$1Jb=I;class P extends j{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$2Jb=P;class ${constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$3Jb=$}),define(ce[106],le([0,1,5,36,32]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=A,e.$$o=I;function L(P){if(R.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function A(P,$,S,b,m,f,h,p,w){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=h,u.sessionID=(0,j.$Mg)()+Date.now(),u.commitHash=b,u.version=m,u["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,R.$h)(R.$u),u["common.nodePlatform"]=N.$ec,u["common.nodeArch"]=S,u["common.product"]=w||"desktop",p&&(u["common.msftInternal"]=p);let d=0;const l=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),R.$l&&(u["common.snap"]="true");const c=L($);return c&&(u["common.platformDetail"]=c),u}function I(P){const $=N.env.USERDNSDOMAIN;if(!$)return!1;const S=$.toLowerCase();return P.some(b=>S===b)}}),define(ce[22],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,R.$qi)("telemetryService"),e.$Wl=(0,R.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var j;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(ce[228],le([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0,e.$vs=u,e.$ws=l,e.$xs=c;const w=new Map;async function u(i,o){const n=`${i}::${o.join(":")}`,s=w.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,y=2e4;function v(E,k,O,M){const F=k.substring(E.length+1);return N.Promises.withAsyncBody(async U=>{let X;try{X=await S.Promises.readdir(k,{withFileTypes:!0})}catch{U();return}if(M.count>=y){M.count+=X.length,M.maxReached=!0,U();return}let H=X.length;if(H===0){U();return}let Z=X;M.count+X.length>y&&(M.maxReached=!0,H=y-M.count,Z=X.slice(0,H)),M.count+=X.length;for(const W of Z)if(W.isDirectory()){if(O.includes(W.name)||await v(E,(0,A.$kc)(k,W.name),O,M),--H===0){U();return}}else{const J=W.name.lastIndexOf(".");if(J>=0){const V=W.name.substring(J+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(F)!==!1&&V.filePattern.test(W.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--H===0){U();return}}})}const C=N.Promises.withAsyncBody(async E=>{const k={count:0,maxReached:!1};await v(i,i,o,k);const O=await c(i);E({configFiles:d(a),fileTypes:d(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:O})});return w.set(n,C),C}function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function l(){const i={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/f.$sl.GB).toFixed(2)}GB (${(R.freemem()/f.$sl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$yn.value()*100)}%`},o=R.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,A.$kc)(i,".vscode","launch.json"),s=await S.Promises.readFile(n),t=[],r=(0,j.$Dn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$Mn)(r)==="object"&&r.configurations)for(const a of r.configurations){const y=a.type;y&&(o.has(y)?o.set(y,o.get(y)+1):o.set(y,1))}return d(o)}catch{return[]}}let g=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const s=R.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/f.$sl.GB).toFixed(2)}GB (${(R.freemem()/f.$sl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${R.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round($.$yn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.$us)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(y=>{if((0,m.$$m)(y))a+=`
${y.errorMessage}`,r+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.m(o,y.processes)}`),y.workspaceMetadata){r+=`
|  Remote: ${y.hostName}`;for(const v of Object.keys(y.workspaceMetadata)){const C=y.workspaceMetadata[v];let E=`${C.fileCount} files`;C.maxFilesReached&&(E=`more than ${E}`),r+=`|    Folder (${v}): ${E}`,r+=this.h(C)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=l(),y={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(y.load=`${R.loadavg().map(v=>Math.round(v)).join(", ")}`),I.$k&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(o,n){const s=[];return(0,b.$us)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$$m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const y=r.workspaceMetadata[a];let v=`${y.fileCount} files`;y.maxFilesReached&&(v=`more than ${v}`),s.push(`Folder (${a}): ${v}`),s.push(this.h(y))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(C,E)=>{const k=` ${C}(${E})`;t+k.length>60?(n.push(a),a="|                 ",t=a.length):t+=k.length,a+=k};let a="|      File types:";const y=10,v=o.fileTypes.length>y?y:o.fileTypes.length;for(let C=0;C<v;C++){const E=o.fileTypes[C];r(E.name,E.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(C=>{r(C.name,C.count)}),n.push(a)),o.launchConfigFiles.length>0){let C="|      Launch Configs:";o.launchConfigFiles.forEach(E=>{const k=E.count>1?` ${E.name}(${E.count})`:` ${E.name}`;C+=k}),n.push(C)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===L.Schemas.file){const y=a.fsPath;s.push(u(y,["node_modules",".git"]).then(v=>{let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),n.push(`|    Folder (${(0,A.$oc)(y)}): ${C}`),n.push(this.h(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${v.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let y;a?y=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?y=n.get(t.pid):y=`${"  ".repeat(r)} ${t.name}`;const v=process.platform==="win32"?t.mem:R.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(v/f.$sl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(t.children)&&t.children.forEach(C=>this.n(o,n,s,C,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=P.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await u(r,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await u(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$ys=g,e.$ys=g=Ee([Q(0,p.$Vl),Q(1,h.$dk)],g)}),define(ce[107],le([0,1,7,4,9,22]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$6p=(0,N.$qi)("IExtensionSignatureVerificationService");let A=class{constructor(P,$){this.b=P,this.c=$}d(){return this.a||(this.a=new Promise((P,$)=>ne(["@vscode/vsce-sign"],async S=>P(S),$))),this.a}async verify(P,$,S){let b;try{b=await this.d()}catch(p){return this.b.error("Could not load vsce-sign module",(0,R.$0)(p)),!1}const m=new Date().getTime();let f,h;try{return f=await b.verify(P,$,S),f}catch(p){throw h=p,p}finally{const p=new Date().getTime()-m;this.c.publicLog2("extensionsignature:verification",{duration:p,verified:f,error:h?h.code??"unknown":void 0})}}};e.$7p=A,e.$7p=A=Ee([Q(0,j.$Wj),Q(1,L.$Vl)],A)}),define(ce[108],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class R{constructor(L){this.b=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:I,data:P}){return this.b.forEach($=>$.log(I,P)),Promise.resolve(null)}}e.$dcc=R;class N{constructor(L){this.b=L}log(L,A){return this.b.call("log",{eventName:L,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$ecc=N}),define(ce[49],le([0,1,30,13,102,106,22]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=S,e.$hp=b,e.$ip=m,e.$jp=f,e.$kp=p,e.$lp=u,e.$mp=d,e.$np=g;class I{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$_o=I;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=P,e.$bp=new P;class ${async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$cp=$,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function S(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function b(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function m(i){const o=i.getValue(A.$4l),n=i.getValue(A.$5l);if(i.getValue(A.$6l)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function f(i){const o={},n={},s={};w(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const o=(0,j.$Cm)(i);return h.has(o)?o:"other"}function w(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,R.$2n)(r):r instanceof Date?o[a]=r.toISOString():(0,N.$6f)(r)?n<2?w(r,o,n+1,a+"."):o[a]=(0,R.$2n)(r):o[a]=r}}function u(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,L.$$o)(n)||s}function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const y of o)for(;;){const v=y.exec(i);if(!v)break;s.push([v.index,y.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const y=r.exec(i);if(!y)break;const v=s.some(([C,E])=>y.index<E&&C<r.lastIndex);!t.test(y[0])&&!v&&(n+=i.substring(a,y.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function g(i,o){return(0,R.$Yn)(i,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=l(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(ce[33],le([0,1,27,29,48,5,8,7,36,49]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=S,e.$qp=h,e.$rp=p,e.$sp=w,e.$tp=u,e.$up=d,e.$vp=l,e.$wp=c,e.$yp=g,e.$zp=o;function S(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,R.$of)(n.id,s.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=b.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?S(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$pp=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(n){const s=f.exec(n);return s&&s[1]?[w(s[1]),s[2]]:[w(n),void 0]}function p(n,s){return`${n}.${s}`}function w(n){return n.toLowerCase()}function u(n,s){return w(p(n??j.$Hm,s))}function d(n,s){const t=[],r=a=>{for(const y of t)if(y.some(v=>S(s(v),s(a))))return y;return null};for(const a of n){const y=r(a);y?y.push(a):t.push([a])}return t}function l(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new $.$_o(n.identifier.id),name:new $.$_o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$xp=new j.$Lm("pprice.better-merge");function g(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(y=>!S(y.identifier,{id:a}))){const y=n.filter(v=>S(v.identifier,{id:a}));y.length===1&&(t.push(y[0]),r.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,N.$Vo)(t?"alpine":L.$u,P.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(ce[229],le([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=void 0;let h=class extends N.$Uc{constructor(l,c){super(),this.b=l,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,g])=>this.a.set(g.configPath,g))}getConfigBasedTips(l){return this.f(l)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(l){const c=[];for(const[g,i]of this.a)if(!(i.configScheme&&i.configScheme!==l.scheme))try{const o=(await this.b.readFile((0,j.$4g)(l,g))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$bac=h,e.$bac=h=Ee([Q(0,A.$Wk),Q(1,I.$dk)],h);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class u extends h{constructor(l,c,g,i,o,n,s,t){super(s,t),this.r=l,this.s=c,this.t=g,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const y=[],v=[],C=[];Object.entries(a.recommendations).forEach(([E,k])=>{k.important?a.important?y.push({extensionId:E,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):v.push({extensionId:E,extensionName:k.name,isExtensionPack:!!k.isExtensionPack}):C.push({extensionId:E,extensionName:k.name,isExtensionPack:!!k.isExtensionPack})}),y.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),v.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),C.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:C})}),(0,P.$sh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const l=await this.O(this.g),c=await this.O(this.h);return[...l,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const l=await this.O(this.g),c=await this.O(this.h),g=await this.u.getInstalled();this.m=this.D(l,g),this.n=this.D(c,g)}D(l,c){const g=new Map;l.forEach(t=>g.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...g.keys()],c);for(const t of i){const r=g.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=g.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=g.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[l,c]=[...this.m.entries()][0];this.H(c).then(g=>{switch(g){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(l);break;case"incompatibleWindow":{const i=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new N.$Vc);i.value=(0,P.$sh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const l=this.I(),c=Date.now()-l,g=7*24*60*60*1e3;if(c<g){const n=this.B(new N.$Vc);n.value=(0,P.$sh)(()=>{n.dispose(),this.G()},g-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new N.$Vc);s.value=(0,P.$sh)(()=>{s.dispose(),this.G()},g);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,P.$sh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(l){const c=await this.u.getInstalled(1),g=l.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,f.$op)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:g,source:3,name:l[0].exeFriendlyName,searchValue:`@exe:"${l[0].exeName}"`})}I(){let l=this.w.getNumber(w,-1);return l||(l=Date.now(),this.J(l)),l}J(l){this.w.store(w,l,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(l,c){const g=this.L();g[l]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(g),-1,0)}N(l,c){const g=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return l.forEach(n=>{o.has(n.toLowerCase())?g.push(n):i.push(n)}),{installed:g,uninstalled:i}}async O(l){const c=[],g=new Map;for(const i of l.keys()){const o=l.get(i);if(!o||!(0,R.$Lb)(o.recommendations))continue;const n=[];b.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,S.$kc)("/usr/local/bin",i)),n.push((0,S.$kc)("/usr/bin",i)),n.push((0,S.$kc)(this.r.fsPath,i)));for(const s of n){let t=g.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),g.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:y,whenNotInstalled:v}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:y,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:v})}}return c}}e.$cac=u}),define(ce[230],le([0,1,26,33]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$23b=j;async function j(L,A,I,P,$){try{const S=await L.getExtensionsControlManifest();if(!S.deprecated)return;const b=await L.getInstalled(1);for(const[m,f]of Object.entries(S.deprecated)){if(!f?.extension)continue;const{id:h,autoMigrate:p,preRelease:w}=f.extension;if(!p)continue;const u=b.find(l=>(0,N.$op)(l.identifier,{id:m}));if(!u)continue;const d=(await A.getExtensions([{id:h,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!d){$.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{$.info(`Migrating '${u.identifier.id}' extension to '${h}' extension...`);const l=!P.getDisabledExtensions().some(g=>(0,N.$op)(g,u.identifier));await L.uninstall(u),$.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let c=b.find(g=>(0,N.$op)(g.identifier,{id:h}));(!c||!c.isPreReleaseVersion&&l)&&(c=await L.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),$.info(`Installed the pre-release extension '${c.identifier.id}'`),l||(await P.disableExtension(c.identifier),$.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$rp)(u.manifest.publisher,u.manifest.name),(0,N.$rp)(c.manifest.publisher,c.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${u.identifier.id}' extension to '${h}' extension.`)}catch(l){$.error(l)}}}catch(S){$.error(S)}}}),define(ce[231],le([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;let c=class extends j.$Uc{static{l=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,A.$4g)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new h.$1o(r.message,h.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(a){const y=a;if(t=y.code,y.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${y.output}`),t===h.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===h.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(v){this.r.error(v)}throw new h.$1o(b.$_p,h.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,P.$0f)(o)?o:!0}async u(i){await this.g;const o=(0,A.$4g)(this.extensionsDownloadDir,`${this.z(i)}${l.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new h.$1o(n.message,h.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==L.Schemas.file){await n(o);return}const s=(0,A.$4g)(this.extensionsDownloadDir,`.${(0,$.$Mg)()}`);await this.h.exists(s)||await n(s);try{await S.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(l.c))s.push(a.resource);else{const y=p.$pp.parse(a.name);y&&n.push([y,a])}const t=(0,p.$up)(n,([a])=>a),r=[];for(const a of t)a.sort((y,v)=>I.rcompare(y[0].version,v[0].version)),o.push(...a.slice(1).map(y=>y[1].resource)),r.push(a[0][1]);r.sort((a,y)=>a.mtime-y.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await R.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?p.$pp.create(i).toString().toLowerCase():(0,$.$Mg)()}};e.$sq=c,e.$sq=c=l=Ee([Q(0,f.$yi),Q(1,u.$Wk),Q(2,h.$Zo),Q(3,m.$Wi),Q(4,w.$6p),Q(5,d.$Wj)],c)}),define(ce[232],le([0,1,3,2,34,33,48]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class I extends N.$Uc{constructor($,S,b,m,f,h,p){super(),this.f=$,this.g=S,this.h=b,this.j=m,this.m=f,this.n=h,this.r=p,this.a=this.B(new R.$be),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(S=>(this.c.set(S.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(S.extensionsResource)),this.n.watch(S.extensionsResource))),this.G(S.extensionsResource))))}catch(S){throw this.r.error(S),S}}async w($){for(const S of $.extensions)this.I(this.L(S.identifier,S.version),$.profileLocation)}async y($){for(const S of $.extensions){const b=this.L(S.identifier,S.version);$.error?this.J(b,$.profileLocation):this.I(b,$.profileLocation)}}async z($){for(const S of $.extensions)this.J(this.L(S.identifier,S.version),$.profileLocation)}async C($){const S=[],b=[];for(const m of $.extensions){const f=this.L(m.identifier,m.version);$.error?this.I(f,$.profileLocation):(this.J(f,$.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),b.push(this.f.scanInstalledExtensionAtLocation(m.location).then(h=>{h?S.push(h):this.r.info("Extension not found at the location",m.location.toString())},h=>this.r.error(h)))))}try{await Promise.all(b),S.length&&await this.H(S)}catch(m){this.r.error(m)}}D($){for(const S of this.h.profiles)$.contains(S.extensionsResource,0,1)&&this.F(S.extensionsResource)}async F($){const S=[],b=[],m=await this.j.scanProfileExtensions($),f=new Set,h=new Set;for(const[p,w]of this.b)w.has($)&&h.add(p);for(const p of m){const w=this.L(p.identifier,p.version);f.add(w),h.has(w)||(S.push(p.identifier),this.I(w,$))}for(const p of h)if(!f.has(p)){const w=this.M(p);w&&(b.push(w.identifier),this.J(p,$))}(S.length||b.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:$}:void 0,removed:b.length?{extensions:b,profileLocation:$}:void 0})}async G($){const S=await this.j.scanProfileExtensions($);for(const b of S)this.I(this.L(b.identifier,b.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,S){let b=this.b.get($);b||this.b.set($,b=new j.$Cc(m=>this.m.extUri.getComparisonKey(m))),b.add(S)}J($,S){const b=this.b.get($);b&&b.delete(S),b?.size||this.b.delete($)}L($,S){return`${A.$Lm.toKey($.id)}@${S}`}M($){const[S,b]=(0,L.$qp)($);return b?{identifier:{id:S},version:b}:void 0}}e.$wq=I}),define(ce[233],le([0,1,45,49]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=j;async function j(L,A,I,P,$,S,b){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,N.$gp)(A,I)&&(0,N.$ip)(P)===3){const f=await(0,R.$1p)(I,$,S);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=b.machineId||f}return m}}),define(ce[234],le([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;let p=class extends f.$Kr{constructor(l,c,g,i){super(g),this.h=l,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(l,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[l];return o?h.URI.file(o):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),c=Object.keys(l).map(g=>{const i=l[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((g,i)=>g.label.localeCompare(i.label)),c}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const c=await this.g.getLanguagePacks();Object.keys(c).some(g=>c[g]&&c[g].extensions.some(i=>(0,b.$op)(i.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(c);return!(0,N.$ub)(Object.keys(l),Object.keys(g))}};e.$Lr=p,e.$Lr=p=Ee([Q(0,S.$3o),Q(1,$.$yi),Q(2,S.$Zo),Q(3,m.$Wj)],p);let w=class extends L.$Uc{constructor(l,c){super(),this.j=c,this.c={},this.f=(0,I.$kc)(l.userDataPath,"languagepacks.json"),this.g=new j.$xh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s(c=>{Object.keys(c).forEach(g=>delete c[g]),this.m(c,...l)}).then(()=>this.c)}m(l,...c){for(const g of c)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(l,g);Object.keys(l).forEach(g=>this.r(l[g]))}n(l,c){const g=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===A.Schemas.file&&u(o)){let n=l[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},l[o.languageId]=n);const s=n.extensions.filter(t=>(0,b.$op)(t.extensionIdentifier,g))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:g,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,I.$kc)(c.location.fsPath,t.path)}}r(l){if(l){const c=(0,R.createHash)("md5");for(const g of l.extensions)c.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);l.hash=c.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let c=null;return P.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(c=l(g),g)).then(g=>{for(const o of Object.keys(g))g[o]||delete g[o];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),P.Promises.writeFile(this.f,i)}).then(()=>c,g=>this.j.error(g))})}};w=Ee([Q(0,$.$yi),Q(1,m.$Wj)],w);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const l of d.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ce[235],le([0,1,143,7,30,49]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(S,b,m){const f=await(0,R.$QD)("@microsoft/1ds-core-js","dist/ms.core.js"),h=await(0,R.$QD)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new f.AppInsightsCore,w=new h.PostChannel,u={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};u.extensionConfig[w.identifier]=d}return p.initialize(u,[]),p.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),p}class ${constructor(b,m,f,h,p){this.e=b,this.f=m,this.g=f,this.h=p,this.c=A,this.d=I,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(m=>{b(m)},m=>{(0,N.$1)(m),console.error(m)})}}log(b,m){if(!this.a)return;m=(0,j.$Zn)(m,this.g),m=(0,L.$jp)(m);const f=this.f+"/"+b;try{this.i(h=>{h.pluginVersionString=m?.properties.version??"Unknown",h.track({name:f,baseData:{name:f,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$nQ=$}),define(ce[109],le([0,1,2,172,16,9,24,49]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;let P=class extends R.$Uc{constructor(S,b,m,f,h=""){super(),this.b=h;const p=b.getLogger(I.$dp);if(p)this.a=this.B(p);else{const u=(0,I.$hp)(f,m)?" (Not Sent)":"",d=()=>(0,I.$gp)(f,m)&&S.getLevel()===L.LogLevel.Trace;this.a=this.B(b.createLogger(I.$dp,{name:(0,N.localize)(0,null,u),hidden:!d()})),this.B(S.onDidChangeLogLevel(()=>b.setVisibility(I.$dp,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,b){this.a.trace(`${this.b}telemetry/${S}`,(0,I.$jp)(b))}};e.$B_b=P,e.$B_b=P=Ee([Q(0,L.$Wj),Q(1,L.$Xj),Q(2,j.$xi),Q(3,A.$dk)],P)}),define(ce[110],le([0,1,2,30,5,27,173,21,47,100,24,42,22,49]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;let h=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,l){this.k=d,this.l=l,this.d={},this.i=new R.$Tc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,L.$8e)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$8e)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$4l)||c.affectsConfiguration(m.$6l)||c.affectsConfiguration(m.$5l))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,f.$ip)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const l=d.usage?3:d.error?2:0;u=Math.min(u,l)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,d,l){this.g<d||(l=(0,N.$Zn)(l,this.d),l=(0,f.$np)(l,this.j),l=(0,N.$Zn)(l,this.c),this.b.forEach(c=>c.log(u,l)))}publicLog(u,d){this.n(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this.h&&this.n(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.$Rr=h,e.$Rr=h=Ee([Q(1,I.$Wi),Q(2,S.$dk)],h);function p(){const w=(0,A.localize)(0,null,$.default.nameLong),u=$.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=j.$o?"":(0,A.localize)(3,null),l=(0,A.localize)(4,null),c=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),o=`
|       | ${l} | ${c} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${w} ${u} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}b.$9n.as(P.$bo.Configuration).registerConfiguration({id:m.$3l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[m.$4l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$9n.as(P.$bo.Configuration).registerConfiguration({id:m.$3l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[m.$6l]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,A.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,A.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${m.$4l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[236],le([0,1,15,26,278,235]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;async function A(S,b){const m=await b.request(S,N.CancellationToken.None),f=(await(0,R.$Oe)(m.stream)).toString(),h=m.res.statusCode??200;return{headers:m.res.headers,statusCode:h,responseData:f}}async function I(S){const b={method:S.type,headers:S.headers};return new Promise((f,h)=>{const p=j.request(S.url??"",b,w=>{w.on("data",function(u){f({headers:w.headers,statusCode:w.statusCode??200,responseData:u.toString()})}),w.on("error",function(u){h(u)})});p.write(S.data,w=>{w&&h(w)}),p.end()})}async function P(S,b,m){const f=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),h={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:f};try{const p=S?await A(h,S):await I(h);m(p.statusCode,p.headers,p.responseData)}catch{m(0,{})}}class $ extends L.$nQ{constructor(b,m,f,h,p){const w={sendPOST:(u,d)=>{P(b,u,d)}};super(m,f,h,p,w)}}e.$oQ=$}),define(ce[237],le([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;let m=class{constructor(h,p,w,u,d,l){this.b=h,this.c=p,this.d=w,this.e=u,this.f=d,this.g=l,this.a=new Map}h(h){if(!this.a.has(h.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[h.id,JSON.stringify(p),h.aiKey],d=new N.$Sq(R.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new $.$ecc(d),new S.$B_b(this.d,this.e,this.f,this.g,`[${h.id}] `)];this.a.set(h.id,new b.$Rr({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.g))}return this.a.get(h.id)}publicLog(h,p,w){this.h(h).publicLog(p,w)}publicLogError(h,p,w){this.h(h).publicLogError(p,w)}};e.$ydc=m,e.$ydc=m=Ee([Q(0,j.$Wi),Q(1,P.$Vl),Q(2,A.$Wj),Q(3,A.$Xj),Q(4,L.$xi),Q(5,I.$dk)],m)}),define(ce[78],le([0,1,3,8,21,4,9]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=$,e.$8v=b,e.$9v=m,e.$$v=f,e.$aw=h,e.$bw=p,e.$5v=(0,L.$qi)("tunnelService"),e.$6v=(0,L.$qi)("sharedTunnelsService");var I;(function(d){d.Http="http",d.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(P||(e.TunnelPrivacyId=P={}));function $(d){return!!d.forwardPort}var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function b(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(l)return{address:l[1],port:+l[2]}}function m(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const l=d.query.split("&");for(const c of l){const g=c.split("=")[1];if(/^https?:/.exec(g)){const i=b(N.URI.parse(g));if(i)return i}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(d){return e.$0v.indexOf(d)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(d){return e.$_v.indexOf(d)>=0}function p(d,l,c,g){if(c===1)return!1;if(c===2&&h(l)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(i?.length===4&&parseInt(i[1])>=18)return!1}return d<1024}class w{constructor(l,c,g){this.remoteAddress=l,this.localAddress=c,this.b=g,this.a=new R.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=w;let u=class{constructor(l,c){this.k=l,this.l=c,this.a=new R.$be,this.onTunnelOpened=this.a.event,this.b=new R.$be,this.onTunnelClosed=this.b.event,this.c=new R.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],c=Array.from(this.e.values());for(const g of c){const i=Array.from(g.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:c}of l.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,c,g,i,o){this.q(l,c,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:c,localAddress:g,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,c){(h(l)||f(l))&&(l=e.$0v[0]);const g=this.s(l,c);if(g)return++g.refcount,g.value}openTunnel(l,c,g,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${o}.`);const r=this.f??l;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(g)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,g,i,o,n,s,t);return a?a.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,g),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,g);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==g)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&y.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this.e.get(l.tunnelRemoteHost);if(c){const g=c.get(l.tunnelRemotePort);g&&(g.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,g))}}}}async p(l,c,g){if(g.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const i=g.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(c),i}}async closeTunnel(l,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const g=this.e.get(l);if(g&&g.has(c)){const i=g.get(c);i.refcount=0,await this.p(l,c,i)}}q(l,c,g){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(c,{refcount:1,value:g})}async r(l,c){const g=this.e.get(l);if(g){const i=g.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&g.delete(c),g.size===0&&this.e.delete(l)}}s(l,c){const g=[l];f(l)?(g.push(...e.$0v),g.push(...e.$_v)):h(l)&&g.push(...e.$_v);const i=g.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(l){return!!b(l)}u(l,c,g,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${i}.`);const t=g;this.j.add(t);const r=i===void 0?g:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},y={remoteAddress:{host:c,port:g},localAddressPort:i,privacy:n,public:n?n!==P.Private:void 0,protocol:s},v=l.forwardPort(y,a);return v?(this.q(c,g,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),v}};e.$dw=u,e.$dw=u=Ee([Q(0,A.$Wj),Q(1,j.$Wi)],u)}),define(ce[238],le([0,1,9,78,2,7,6]),function(ne,e,R,N,j,L,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class P extends j.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new A.$Nh),this.b.p)}setAddress(b){this.a=b,this.b&&(this.b.complete(b),this.b=null)}setTunnel(b){this.B(b)}}let $=class extends j.$Uc{static{I=this}static{this.a=0}constructor(b,m){super(),this.f=b,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(b,m,f,h,p,w,u){const d=new P,l=await Promise.resolve(this.f.openTunnel(b,d,f,h,p,w,u));if(!l||typeof l=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${h} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),d.dispose(),await l.dispose(),(0,L.$6)();return d.setTunnel(l),this.b.set(m,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${l.localAddress} (local) to ${f}:${h} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(b,m){const f=this.b.get(b);f&&f.setAddress(m)}async destroyTunnel(b){const m=this.b.get(b);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this.b.delete(b),await m.dispose();return}this.c.add(b)}};e.$Idc=$,e.$Idc=$=I=Ee([Q(0,N.$6v),Q(1,R.$Wj)],$)}),define(ce[28],le([0,1,4]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,R.$qi)("IUriIdentityService")}),define(ce[239],le([0,1,28,191,12,20,128,3,2]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class ${static{this._clock=0}constructor(m){this.uri=m,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let S=class{constructor(m){this.g=m,this.c=new P.$Tc,this.f=2**16;const f=new Map,h=p=>{let w=f.get(p.scheme);return w===void 0&&(w=m.hasProvider(p)&&!this.g.hasCapability(p,1024),f.set(p.scheme,w)),w};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{f.delete(p.scheme)})),this.extUri=new L.$Sg(h),this.d=new A.$qs((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.$5g)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new $(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((h,p)=>h[1].time<p[1].time?1:h[1].time>p[1].time?-1:0);$._clock=0,this.d.clear();const f=this.f*.5;for(let h=0;h<f;h++)this.d.set(m[h][0],m[h][1].touch())}};e.$rs=S,e.$rs=S=Ee([Q(0,j.$Wk)],S),(0,N.$os)(R.$ul,S,1)}),define(ce[240],le([0,1,3,2,12,51,34]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class I extends N.$Uc{constructor($,S,b,m,f,h){super(),this.f=$,this.g=S,this.h=b,this.j=m,this.m=f,this.n=h,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=L.$wi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Cc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const $ of this.j.profiles)this.c.add($.settingsResource),this.c.add($.keybindingsResource),this.c.add($.tasksResource),this.c.add($.extensionsResource)}open($,S){return this.g.open(this.t($),S)}close($){return this.g.close($)}read($,S,b,m,f){return this.g.read($,S,b,m,f)}write($,S,b,m,f){return this.g.write($,S,b,m,f)}watch($,S){this.b.set($,$);const b=this.g.watch(this.t($),S);return(0,N.$Sc)(()=>{this.b.delete($),b.dispose()})}stat($){return this.g.stat(this.t($))}mkdir($){return this.g.mkdir(this.t($))}rename($,S,b){return this.g.rename(this.t($),this.t(S),b)}readFile($,S){return this.g.readFile(this.t($),S)}readFileStream($,S,b){return this.g.readFileStream(this.t($),S,b)}readdir($){return this.g.readdir(this.t($))}enforceAtomicReadFile($){return this.c.has($)}writeFile($,S,b){return this.g.writeFile(this.t($),S,b)}enforceAtomicWriteFile($){return this.c.has($)?{postfix:".vsctmp"}:!1}delete($,S){return this.g.delete(this.t($),S)}copy($,S,b){if((0,j.$1k)(this.g))return this.g.copy(this.t($),this.t(S),b);throw new Error("copy not supported")}cloneFile($,S){if((0,j.$2k)(this.g))return this.g.cloneFile(this.t($),this.t(S));throw new Error("clone not supported")}s($){const S=[];for(const b of $){if(b.resource.scheme!==this.f)continue;const m=this.u(b.resource);this.b.findSubstr(m)&&S.push({resource:m,type:b.type,cId:b.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t($){return $.with({scheme:this.f})}u($){return $.with({scheme:this.h})}}e.$4cc=I}),define(ce[79],le([0,1,62]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$FJb=j,e.$GJb=L;function N(A,I,P,$){const S=(0,R.$Sn)(A,I,P,$)[0];return S&&(A=A.substring(0,S.offset)+S.content+A.substring(S.offset+S.length)),A}function j(A,I,P){let $=P;for(;$>=0;){if(A.charAt($)===I.charAt(I.length-1)&&I.length===1)return $+1;if($--,I.length===2&&$>=0&&A.charAt($)===I.charAt(0))return $+2}return 0}function L(A,I,P){let $=P;for(;$>=0;)if(A.charAt($)===I.charAt(I.length-1)&&I.length===1||($++,I.length===2&&$>=0&&A.charAt($)===I.charAt(1)))return $;return A.length-1}}),define(ce[241],le([0,1,30,55,13]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=L;function L(f,h,p,w,u,d){const l=[],c=[],g=[];if(!h){const U=f.filter(({identifier:X})=>u.every(H=>H.toLowerCase()!==X.id.toLowerCase()));return{local:{added:l,removed:c,updated:g},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}f=f.map(b),h=h.map(b),p=p?p.map(b):null;const i=new Map,o=U=>{U.uuid&&i.set(U.id.toLowerCase(),U.uuid)};f.forEach(({identifier:U})=>o(U)),h.forEach(({identifier:U})=>o(U)),p?.forEach(({identifier:U})=>o(U)),w?.forEach(({identifier:U})=>o(U)),d?.forEach(U=>o(U));const n=U=>{const X=U.identifier.uuid||i.get(U.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,X)=>(U.set(n(X),X),U),t=f.reduce(s,new Map),r=h.reduce(s,new Map),a=h.reduce((U,X)=>s(U,(0,R.$Wn)(X)),new Map),y=p?p.reduce(s,new Map):null,v=w.reduce(s,new Map),C=u.reduce((U,X)=>{const H=i.get(X.toLowerCase());return U.add(H?`uuid:${H}`:`id:${X.toLowerCase()}`)},new Set),E=d?d.reduce((U,{id:X,uuid:H})=>(H=H??i.get(X.toLowerCase()),U.add(H?`uuid:${H}`:`id:${X.toLowerCase()}`)),new Set):null,k=A(t,r,C,!1);if(k.added.size>0||k.removed.size>0||k.updated.size>0){const U=A(y,t,C,!1),X=A(y,r,C,!0),H=(Z,W,J,V)=>{let B,ie,oe;return W.installed?(B=V.pinned,oe=V.preRelease,B&&(ie=V.version)):(B=J.pinned,oe=J.preRelease,B&&(ie=J.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),oe===void 0&&(oe=W.preRelease),{...V,installed:W.installed||J.installed,pinned:B,preRelease:oe,version:ie??(J.version&&(!W.installed||N.gt(J.version,W.version))?J.version:W.version),state:P(W,J,y?.get(Z))}};for(const Z of X.removed.values()){const W=t.get(Z);if(!W)continue;const J=(0,j.$cg)(y?.get(Z)),V=E&&!E.has(Z)&&J.installed;W.installed&&V?c.push(W.identifier):a.set(Z,W)}for(const Z of X.added.values()){const W=(0,j.$cg)(r.get(Z)),J=t.get(Z);if(J){if(k.updated.has(Z)){const V=H(Z,J,W,W);I(J,W,!1,!1)||g.push(m(V,Z)),a.set(Z,V)}}else W.installed&&l.push(m(W,Z))}for(const Z of X.updated.values()){const W=(0,j.$cg)(r.get(Z)),J=(0,j.$cg)(y?.get(Z)),V=t.get(Z);if(V)if(E&&!E.has(Z)&&J.installed&&V.installed&&!W.installed)c.push(V.identifier);else{const ie=H(Z,V,W,W);g.push(m(ie,Z)),a.set(Z,ie)}else W.installed&&l.push(m(W,Z))}for(const Z of U.added.values())X.added.has(Z)||a.set(Z,(0,j.$cg)(t.get(Z)));for(const Z of U.updated.values()){if(X.removed.has(Z)||X.updated.has(Z))continue;const W=(0,j.$cg)(t.get(Z)),J=(0,j.$cg)(r.get(Z));a.set(Z,H(Z,W,J,W))}for(const Z of U.removed.values())X.updated.has(Z)||X.removed.has(Z)||v.has(Z)||(0,j.$cg)(r.get(Z)).installed&&E&&(E.has(Z)||!(0,j.$cg)(y?.get(Z)).installed||a.delete(Z))}const O=[],M=A(r,a,new Set,!0),F=M.added.size>0||M.updated.size>0||M.removed.size>0;return F&&a.forEach((U,X)=>O.push(m(U,X))),{local:{added:l,removed:c,updated:g},remote:F?{added:[...M.added].map(U=>a.get(U)),updated:[...M.updated].map(U=>a.get(U)),removed:[...M.removed].map(U=>r.get(U)),all:O}:null}}function A(f,h,p,w){const u=f?[...f.keys()].filter(i=>!p.has(i)):[],d=[...h.keys()].filter(i=>!p.has(i)),l=d.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=u.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),g=new Set;for(const i of u){if(c.has(i))continue;const o=f.get(i),n=h.get(i);(!n||!I(o,n,w,!0))&&g.add(i)}return{added:l,removed:c,updated:g}}function I(f,h,p,w){return!(f.disabled!==h.disabled||!!f.isApplicationScoped!=!!h.isApplicationScoped||w&&f.installed!==h.installed||f.installed&&h.installed&&(f.preRelease!==h.preRelease||f.pinned!==h.pinned||h.pinned&&f.version!==h.version)||!S(f.state,h.state)||p&&f.version!==h.version)}function P(f,h,p){const w=f.state,u=h.state,d=p?.state;if(!h.version||w&&N.gt(f.version,h.version))return w;if(u&&N.gt(h.version,f.version)||!w)return u;if(!u)return w;const l=(0,R.$Wn)(w),c=d?$(d,u):{added:Object.keys(u).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},g=d?$(d,w):{added:Object.keys(w).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])l[i]=u[i];for(const i of c.removed.values())g.updated.has(i)||delete l[i];return l}function $(f,h){const p=Object.keys(f),w=Object.keys(h),u=w.filter(c=>!p.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),d=p.filter(c=>!w.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),l=new Set;for(const c of p){if(d.has(c))continue;const g=f[c],i=h[c];(0,R.$1n)(g,i)||l.add(c)}return{added:u,removed:d,updated:l}}function S(f={},h={}){const{added:p,removed:w,updated:u}=$(f,h);return p.size===0&&w.size===0&&u.size===0}function b(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,h){const p={...f,identifier:{id:f.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete p.disabled,f.installed||delete p.installed,f.state||delete p.state,f.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ce[111],le([0,1,17,21,4]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OLb=e.$NLb=void 0,e.$NLb=(0,j.$qi)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return $=$.filter(S=>S!==I&&S!==`-${I}`),P&&$.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}updateSynchronizedExtensions(I,P){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return $=$.filter(S=>S!==I&&S!==`-${I}`),P&&$.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}getIgnoredExtensions(I){const P=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),$=this.b().map(m=>m.toLowerCase()),S=[],b=[];if(Array.isArray($))for(const m of $)m.startsWith("-")?b.push(m.substring(1)):S.push(m);return(0,R.$Mb)([...P,...S].filter(m=>!b.includes(m)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$OLb=L,e.$OLb=L=Ee([Q(0,N.$Wi)],L)}),define(ce[242],le([0,1,17,35,30,93,79]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=P;function I(c){return(0,N.$Dn)(c)||[]}async function P(c,g,i,o,n){const s=I(c),t=I(g),r=i?I(i):null,a=[...s,...t,...r||[]].map(H=>H.key),y=await n.resolveUserBindings(a),v=S(s,t,r,y);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const C=m(s),E=m(t),k=r?m(r):null,O=h(C,E,y),M=k?h(k,C,y):{added:[...C.keys()].reduce((H,Z)=>(H.add(Z),H),new Set),removed:new Set,updated:new Set},F=k?h(k,E,y):{added:[...E.keys()].reduce((H,Z)=>(H.add(Z),H),new Set),removed:new Set,updated:new Set},U=$(O,M,F);let X=c;for(const H of U.removed.values())U.conflicts.has(H)||(X=d(X,H,o));for(const H of U.added.values()){if(U.conflicts.has(H))continue;const Z=E.get(H);if(Z.some(W=>W.command!==`-${H}`&&v.conflicts.has(y[W.key]))){U.conflicts.add(H);continue}X=u(X,Z,o)}for(const H of U.updated.values()){if(U.conflicts.has(H))continue;const Z=E.get(H);if(Z.some(W=>W.command!==`-${H}`&&v.conflicts.has(y[W.key]))){U.conflicts.add(H);continue}X=l(X,H,Z,o)}return{mergeContent:X,hasChanges:!0,hasConflicts:U.conflicts.size>0}}function $(c,g,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of g.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(g.updated.has(r)?t.add(r):n.add(r));for(const r of g.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(g.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of g.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(g.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function S(c,g,i,o){const n=new Set,s=b(c,o),t=b(g,o),r=i?b(i,o):null,a=f(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,s):{added:[...s.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=r?f(r,t):{added:[...t.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:C,removed:E,updated:k,conflicts:O}=$(a,y,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:E,updated:k,conflicts:O}}function b(c,g){const i=new Map;for(const o of c){const n=g[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const g=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=g.get(o);n||(n=[],g.set(o,n)),n.push(i)}return g}function f(c,g){const i=[...c.keys()],o=[...g.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(v=>({...v,key:r})),y=g.get(r).map(v=>({...v,key:r}));(0,R.$ub)(a,y,(v,C)=>w(v,C))||t.add(r)}return{added:n,removed:s,updated:t}}function h(c,g,i){const o=[...c.keys()],n=[...g.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const y=c.get(a).map(C=>({...C,key:i[C.key]})),v=g.get(a).map(C=>({...C,key:i[C.key]}));p(y,v)||r.add(a)}return{added:s,removed:t,updated:r}}function p(c,g){return!(!(0,R.$ub)(c.filter(({command:i})=>i[0]!=="-"),g.filter(({command:i})=>i[0]!=="-"),(i,o)=>w(i,o))||!(0,R.$ub)(c.filter(({command:i})=>i[0]==="-"),g.filter(({command:i})=>i[0]==="-"),(i,o)=>w(i,o)))}function w(c,g){if(c.command!==g.command||c.key!==g.key)return!1;const i=L.$oj.deserialize(c.when),o=L.$oj.deserialize(g.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!j.$1n(c.args,g.args))}function u(c,g,i){for(const o of g)c=A.edit(c,[-1],o,i);return c}function d(c,g,i){const o=I(c);for(let n=o.length-1;n>=0;n--)(o[n].command===g||o[n].command===`-${g}`)&&(c=A.edit(c,[n],void 0,i));return c}function l(c,g,i,o){const n=I(c),s=n.findIndex(t=>t.command===g||t.command===`-${g}`);for(let t=n.length-1;t>=0;t--)(n[t].command===g||n[t].command===`-${g}`)&&(c=A.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=A.edit(c,[s],i[t],o);return c}}),define(ce[243],le([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=R,e.$t$b=j;function R(L,A,I){const P={},$={},S=new Set;if(!A)return{local:{added:P,updated:$,removed:[...S.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const b=N(L,A);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:P,updated:$,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=N(I,L),f=N(I,A),h={},p={},w=new Set,u=new Set;for(const d of m.removed.values())f.updated.has(d)?P[d]=A[d]:w.add(d);for(const d of f.removed.values())u.has(d)||(m.updated.has(d)?u.add(d):S.add(d));for(const d of m.updated.values())u.has(d)||(f.updated.has(d)?b.updated.has(d)&&u.add(d):p[d]=L[d]);for(const d of f.updated.values())u.has(d)||(m.updated.has(d)?b.updated.has(d)&&u.add(d):L[d]!==void 0&&($[d]=A[d]));for(const d of m.added.values())u.has(d)||(f.added.has(d)?b.updated.has(d)&&u.add(d):h[d]=L[d]);for(const d of f.added.values())u.has(d)||(m.added.has(d)?b.updated.has(d)&&u.add(d):P[d]=A[d]);return{local:{added:P,removed:[...S.values()],updated:$},remote:{added:h,removed:[...w.values()],updated:p},conflicts:[...u.values()]}}function N(L,A){const I=L?Object.keys(L):[],P=A?Object.keys(A):[],$=P.filter(m=>!I.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),S=I.filter(m=>!P.includes(m)).reduce((m,f)=>(m.add(f),m),new Set),b=new Set;for(const m of I){if(S.has(m))continue;const f=L[m],h=A[m];f!==h&&b.add(m)}return{added:$,removed:S,updated:b}}function j(L,A){const{added:I,removed:P,updated:$}=N(L,A);return I.size===0&&P.size===0&&$.size===0}}),define(ce[244],le([0,1,30]),function(ne,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=N;function N(L,A,I,P){const $={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const m=L.filter(({id:f})=>!P.includes(f));return m.length?S.added=m:S=null,{local:$,remote:S}}const b=j(L,A,P);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const m=j(I,L,P),f=j(I,A,P);for(const h of f.removed){const p=L.find(w=>w.id===h);p&&$.removed.push(p)}for(const h of f.added){const p=A.find(w=>w.id===h);m.added.includes(h)?b.updated.includes(h)&&$.updated.push(p):$.added.push(p)}for(const h of f.updated)$.updated.push(A.find(p=>p.id===h));for(const h of m.added)f.added.includes(h)||S.added.push(L.find(p=>p.id===h));for(const h of m.updated)f.removed.includes(h)||f.updated.includes(h)||S.updated.push(L.find(p=>p.id===h));for(const h of m.removed){const p=A.find(w=>w.id===h);p&&S.removed.push(p)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:$,remote:S}}function j(L,A,I){L=L?L.filter(({id:f})=>!I.includes(f)):[],A=A.filter(({id:f})=>!I.includes(f));const P=L.map(({id:f})=>f),$=A.map(({id:f})=>f),S=$.filter(f=>!P.includes(f)),b=P.filter(f=>!$.includes(f)),m=[];for(const{id:f,name:h,shortName:p,icon:w,useDefaultFlags:u}of L){if(b.includes(f))continue;const d=A.find(l=>l.id===f);(!d||d.name!==h||d.shortName!==p||d.icon!==w||!(0,R.$1n)(d.useDefaultFlags,u))&&m.push(f)}return{added:S,removed:b,updated:m}}}),define(ce[25],le([0,1,17,13,179,47,29,4,101,42]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oAb=e.$nAb=e.$mAb=e.$lAb=e.$kAb=e.$jAb=e.$iAb=e.$hAb=e.$gAb=e.$eAb=e.MergeState=e.Change=e.SyncStatus=e.$dAb=e.$cAb=e.$bAb=e.UserDataSyncErrorCode=e.$_zb=e.$$zb=e.$0zb=e.$9zb=e.$8zb=e.$5zb=e.SyncResource=e.$2zb=e.$1zb=void 0,e.$Yzb=S,e.$Zzb=b,e.$3zb=m,e.$4zb=f,e.$6zb=p,e.$7zb=w,e.$aAb=u,e.$fAb=s;function S(){const t=$.$9n.as(L.$bo.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function b(){const t=$.$9n.as(L.$bo.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(v=>!!t[v].ignoreSync),a=Object.keys(t).filter(v=>t[v].scope===2||t[v].scope===6),y=S();return(0,R.$Mb)([...r,...a,...y])}e.$1zb="settingsSync",e.$2zb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=$.$9n.as(L.$bo.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$2zb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:A.$No,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=$.$9n.as(P.$0n.JSONContribution),y=()=>{const v=S(),C=b(),E=Object.keys(L.$co.properties).filter(M=>!C.includes(M)),k=C.filter(M=>!v.includes(M)),O={items:{type:"string",enum:[...E,...k.map(M=>`-${M}`)]}};a.registerSchema(t,O)};return r.onDidUpdateConfiguration(()=>y())}function f(t){return t&&(0,N.$6f)(t)&&(0,N.$4f)(t.id)&&Array.isArray(t.scopes)}var h;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(h||(e.SyncResource=h={})),e.$5zb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}function w(t,r,a,y){return y.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$8zb=(0,I.$qi)("IUserDataSyncStoreManagementService"),e.$9zb=(0,I.$qi)("IUserDataSyncStoreService"),e.$0zb=(0,I.$qi)("IUserDataSyncLocalStoreService"),e.$$zb="x-operation-id",e.$_zb="X-Execution-Id";function u(t){const r={};return r[e.$_zb]=t,r}var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class l extends Error{constructor(r,a,y,v){super(r),this.code=a,this.resource=y,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$bAb=l;class c extends l{constructor(r,a,y,v,C){super(r,y,void 0,C),this.url=a,this.serverCode=v}}e.$cAb=c;class g extends l{constructor(r,a){super(r,a)}}e.$dAb=g,function(t){function r(a){if(a instanceof t)return a;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(y&&y[1]){const v=y[2]==="unknown"?void 0:y[2],C=y[3]==="unknown"?void 0:y[3];return new t(a.message,y[1],v,C)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(l||(e.$bAb=l={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$eAb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$gAb=(0,I.$qi)("IUserDataSyncEnablementService"),e.$hAb=(0,I.$qi)("IUserDataSyncService"),e.$iAb=(0,I.$qi)("IUserDataSyncResourceProviderService"),e.$jAb=(0,I.$qi)("IUserDataAutoSyncService"),e.$kAb=(0,I.$qi)("IUserDataSyncUtilService"),e.$lAb=(0,I.$qi)("IUserDataSyncLogService"),e.$mAb="userDataSync",e.$nAb="vscode-userdata-sync",e.$oAb="preview"}),define(ce[245],le([0,1,30,25]),function(ne,e,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Kb=j;function j(A,I,P,$,S){if(!I)return{remote:{added:Object.keys(A),removed:[],updated:[],all:Object.keys(A).length>0?A:null},local:{added:{},removed:[],updated:{}}};const b=L(A,I);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?L(P,I):{added:Object.keys(I).reduce((d,l)=>(d.add(l),d),new Set),removed:new Set,updated:new Set},f=P?L(P,A):{added:Object.keys(A).reduce((d,l)=>(d.add(l),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},p=R.$Wn(I),w=!P;for(const d of f.added.values())d!==N.$eAb&&w&&m.added.has(d)||(p[d]=A[d]);for(const d of f.updated.values())p[d]=A[d];for(const d of f.removed.values())$.unregistered.includes(d)||delete p[d];for(const d of m.added.values()){const l=I[d];if($.machine.includes(d)){S.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&f.added.has(d))continue;const c=A[d];c&&c.value===l.value||d===N.$eAb&&w&&f.added.has(d)||(c?h.updated[d]=l:h.added[d]=l)}for(const d of m.updated.values()){const l=I[d];if($.machine.includes(d)){S.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const c=A[d];c&&c.value===l.value||(h.updated[d]=l)}for(const d of m.removed.values()){if($.machine.includes(d)){S.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||h.removed.push(d)}const u=L(I,p);return{local:h,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}function L(A,I){const P=Object.keys(A),$=Object.keys(I),S=$.filter(f=>!P.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),b=P.filter(f=>!$.includes(f)).reduce((f,h)=>(f.add(h),f),new Set),m=new Set;for(const f of P){if(b.has(f))continue;const h=A[f],p=I[f];R.$1n(h,p)||m.add(f)}return{added:S,removed:b,updated:m}}}),define(ce[246],le([0,1,17,35,62,43,30,79,25]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJb=$,e.$IJb=m,e.$JJb=f,e.$KJb=h,e.$LJb=w,e.$MJb=d;function $(a,y,v){let C=[];v?C=b(v):C=S(y);const E=[],k=[...(0,P.$Yzb)()];if(Array.isArray(C))for(const O of C)O.startsWith("-")?k.push(O.substring(1)):E.push(O);return(0,R.$Mb)([...a,...E].filter(O=>!k.includes(O)))}function S(a){let y=a.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=a.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const y=(0,N.$Dn)(a);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function m(a,y){const v=(0,N.$Dn)(a)||{};let C="{}";for(const E of Object.keys(v)){const k=(0,j.$Sn)(C,[E],v[E],y);C=(0,j.$Vn)(C,k)}return C}function f(a,y,v,C){if(v.length){const E=r(y),k=(0,N.$Dn)(y)||{},O=(0,N.$Dn)(a);if(!O)return a;const M=[];for(const F of v){const U=k[F],X=O[F];U===void 0?a=I.edit(a,[F],void 0,C):X!==void 0?a=I.edit(a,[F],U,C):M.push(i(F,E))}M.sort((F,U)=>F.startOffset-U.startOffset),M.forEach(F=>a=d(F.setting.key,y,a,C))}return a}function h(a,y,v,C,E,k){const O=f(a,y,C,k),M=v!==O,F=v!==y;if(!M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:f(y,a,C,k),remoteContent:null,hasConflicts:!1};if(v===null&&w(a)){const T=p(a,y,C)?null:f(y,a,C,k);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let U=a,X=y;const H=(0,N.$Dn)(a),Z=(0,N.$Dn)(y),W=v?(0,N.$Dn)(v):null,J=C.reduce((T,z)=>(T.add(z),T),new Set),V=u(H,Z,J),B=u(W,H,J),ie=u(W,Z,J),oe=new Map,te=new Set,ae=T=>{te.add(T);const z=E.filter(({key:x})=>x===T)[0];z?(U=I.edit(U,[T],z.value,k),X=I.edit(X,[T],z.value,k)):oe.set(T,{key:T,localValue:H[T],remoteValue:Z[T]})};for(const T of B.removed.values())ie.updated.has(T)?ae(T):X=I.edit(X,[T],void 0,k);for(const T of ie.removed.values())te.has(T)||(B.updated.has(T)?ae(T):U=I.edit(U,[T],void 0,k));for(const T of B.updated.values())te.has(T)||(ie.updated.has(T)?V.updated.has(T)&&ae(T):X=I.edit(X,[T],H[T],k));for(const T of ie.updated.values())te.has(T)||(B.updated.has(T)?V.updated.has(T)&&ae(T):U=I.edit(U,[T],Z[T],k));for(const T of B.added.values())te.has(T)||(ie.added.has(T)?V.updated.has(T)&&ae(T):X=d(T,U,X,k));for(const T of ie.added.values())te.has(T)||(B.added.has(T)?V.updated.has(T)&&ae(T):U=d(T,X,U,k));const G=oe.size>0||!p(U,X,C),q=G||!p(U,a,[]),D=G||!p(X,y,[]);return{localContent:q?U:null,remoteContent:D?X:null,conflictsSettings:[...oe.values()],hasConflicts:G}}function p(a,y,v){if(a===y)return!0;const C=(0,N.$Dn)(a),E=(0,N.$Dn)(y),k=v.reduce((F,U)=>(F.add(U),F),new Set),O=r(a).filter(F=>!(F.setting&&k.has(F.setting.key))),M=r(y).filter(F=>!(F.setting&&k.has(F.setting.key)));if(O.length!==M.length)return!1;for(let F=0;F<O.length;F++){const U=O[F],X=M[F];if(U.setting&&X.setting){if(U.setting.key!==X.setting.key||!A.$1n(C[U.setting.key],E[U.setting.key]))return!1}else if(!U.setting&&!X.setting){if(U.value!==X.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}function u(a,y,v){const C=a?Object.keys(a).filter(F=>!v.has(F)):[],E=Object.keys(y).filter(F=>!v.has(F)),k=E.filter(F=>!C.includes(F)).reduce((F,U)=>(F.add(U),F),new Set),O=C.filter(F=>!E.includes(F)).reduce((F,U)=>(F.add(U),F),new Set),M=new Set;if(a)for(const F of C){if(O.has(F))continue;const U=a[F],X=y[F];A.$1n(U,X)||M.add(F)}return{added:k,removed:O,updated:M}}function d(a,y,v,C){const E=(0,N.$Dn)(y),k=r(y),O=r(v),M=l(a,k,O);return c(v,a,E[a],M,O,C)}function l(a,y,v){const C=y.findIndex(k=>k.setting?.key===a),E=y[C-1];if(E){if(E.setting){const O=i(E.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!0}}else{const O=o(C,y);if(O){const M=i(O.setting.key,v);if(M){const F=n(v.indexOf(M),v),U=s(y,O,y[C]);if(F){const X=s(v,M,F),H=t(U,X);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.indexOf(F),insertAfter:!1}}else{const X=s(v,M,v[v.length-1]),H=t(U,X);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const k=y[C+1];if(k)if(k.setting){const O=i(k.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!1}}else{const O=n(C,y);if(O){const M=i(O.setting.key,v);if(M){const F=o(v.indexOf(M),v),U=s(y,y[C],O);if(F){const X=s(v,F,M),H=t(U.reverse(),X.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:v.indexOf(F),insertAfter:!0}}else{const X=s(v,v[0],M),H=t(U.reverse(),X.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function c(a,y,v,C,E,k){let O;return C.index===-1?O=(0,j.$Sn)(a,[y],v,k):O=g(a,y,v,C,E,k).map(M=>(0,j.$Tn)(a,M,k)[0]),(0,j.$Vn)(a,O)}function g(a,y,v,C,E,k){const O=`${JSON.stringify(y)}: ${JSON.stringify(v)}`,M=(0,L.$Pn)(k,a),F=E[C.index];if(C.insertAfter){const U=[];if(F.setting)U.push({offset:F.endOffset,length:0,content:","+O});else{const X=n(C.index,E),H=o(C.index,E),Z=H?.setting?.commaOffset;H&&Z===void 0&&U.push({offset:H.endOffset,length:0,content:","});const W=Z!==void 0&&Z>F.endOffset;U.push({offset:W?Z+1:F.endOffset,length:0,content:X?M+O+",":M+O})}return U}else{if(F.setting)return[{offset:F.startOffset,length:0,content:O+","}];const U=(E[C.index-1]&&!E[C.index-1].setting?M:"")+O+(n(C.index,E)?",":"")+M;return[{offset:F.startOffset,length:0,content:U}]}}function i(a,y){return y.filter(v=>v.setting?.key===a)[0]}function o(a,y){for(let v=a-1;v>=0;v--)if(y[v].setting)return y[v]}function n(a,y){for(let v=a+1;v<y.length;v++)if(y[v].setting)return y[v]}function s(a,y,v){const C=a.indexOf(y),E=a.indexOf(v);return a.filter((k,O)=>C<O&&O<E)}function t(a,y){if(a.length&&y.length){let v=0;for(;v<y.length&&v<a.length;v++)if(a[v].value!==y[v].value)return y[v-1];return y[v-1]}}function r(a){const y=[];let v=-1,C,E;const k={onObjectBegin:O=>{v++},onObjectProperty:(O,M,F)=>{v===0&&(C=M,E=O)},onObjectEnd:(O,M)=>{v--,v===0&&y.push({startOffset:C,endOffset:O+M,value:a.substring(C,O+M),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(O,M)=>{v++},onArrayEnd:(O,M)=>{v--,v===0&&y.push({startOffset:C,endOffset:O+M,value:a.substring(C,O+M),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(O,M,F)=>{v===0&&y.push({startOffset:C,endOffset:M+F,value:a.substring(C,M+F),setting:{key:E,commaOffset:void 0}})},onSeparator:(O,M,F)=>{if(v===0&&O===","){let U=y.length-1;for(;U>=0&&!y[U].setting;U--);const X=y[U];X&&y.splice(U,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:M}})}},onComment:(O,M)=>{v===0&&y.push({startOffset:O,endOffset:O+M,value:a.substring(O,O+M)})}};return(0,N.$Kn)(a,k),y}}),define(ce[80],le([0,1,3,2,4,25]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJb=e.$pJb=void 0,e.$pJb=(0,j.$qi)("IUserDataSyncAccountService");let A=class extends N.$Uc{get account(){return this.a}constructor(P,$){super(),this.g=P,this.h=$,this.b=this.B(new R.$be),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$be),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$qJb=A,e.$qJb=A=Ee([Q(0,L.$9zb),Q(1,L.$lAb)],A)}),define(ce[247],le([0,1,20,180,16,9,25]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PLb=void 0;let I=class extends L.$2j{constructor($,S){super(),this.g=this.B($.createLogger((0,R.$4g)(S.logsHome,`${A.$mAb}.log`),{id:A.$mAb,name:(0,N.localize)(0,null)}))}trace($,...S){this.g.trace($,...S)}debug($,...S){this.g.debug($,...S)}info($,...S){this.g.info($,...S)}warn($,...S){this.g.warn($,...S)}error($,...S){this.g.error($,...S)}flush(){this.g.flush()}};e.$PLb=I,e.$PLb=I=Ee([Q(0,L.$Xj),Q(1,j.$xi)],I)}),define(ce[248],le([0,1,6,3,2]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class L extends j.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:P,getActiveWindowId:$}){super(),this.a=this.B(new j.$Tc),N.Event.latch(N.Event.any(I,P))(this.f,this,this.a),this.b=(0,R.$dh)(()=>$()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$ycc=L}),define(ce[112],le([0,1,183,14,51,20,8,4,23]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=$,e.$Bi=S,e.$Ei=b,e.$Fi=m,e.$Gi=f,e.$Hi=p,e.$Ii=w,e.$Li=l,e.$Qi=c,e.$Ri=g,e.$Ti=i,e.$Ui=o,e.$Vi=n,e.$zi=(0,I.$qi)("contextService");function $(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.uri)}function S(s){return typeof s?.id=="string"&&!$(s)&&!m(s)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function b(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:t?e.$Ci:e.$Di;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.configPath)}function f(s){const t=s;if(t?.uri)return{id:t.id,uri:A.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function p(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function w(s){const t=s;return!!(t&&typeof t=="object"&&A.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class u{constructor(t,r,a,y,v){this.h=t,this.j=a,this.k=y,this.l=v,this.c=j.$wi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$wi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=u;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$4g)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=d;function l(s){return new d({uri:s,index:0,name:(0,L.$Zg)(s)},{uri:s.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,R.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function c(s,t){return L.$Ug.isEqualOrParent(s,t.untitledWorkspacesHome)}function g(s){let t;return A.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Si}function o(s,t){return!c(s,t)&&!g(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,L.$2g)(s))===e.$Ni}}),define(ce[18],le([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=c,e.$xl=g,e.$yl=i;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&A.URI.isUri(t.location)&&A.URI.isUri(t.globalStorageHome)&&A.URI.isUri(t.settingsResource)&&A.URI.isUri(t.keybindingsResource)&&A.URI.isUri(t.tasksResource)&&A.URI.isUri(t.snippetsHome)&&A.URI.isUri(t.extensionsResource))}e.$wl=(0,S.$qi)("IUserDataProfilesService");function g(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:A.URI.revive(s.location).with({scheme:t}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,y,v){return{id:s,name:t,location:r,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:v&&y?.useDefaultFlags?.globalState?v.globalStorageHome:(0,L.$4g)(r,"globalStorage"),settingsResource:v&&y?.useDefaultFlags?.settings?v.settingsResource:(0,L.$4g)(r,"settings.json"),keybindingsResource:v&&y?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,L.$4g)(r,"keybindings.json"),tasksResource:v&&y?.useDefaultFlags?.tasks?v.tasksResource:(0,L.$4g)(r,"tasks.json"),snippetsHome:v&&y?.useDefaultFlags?.snippets?v.snippetsHome:(0,L.$4g)(r,"snippets"),extensionsResource:v&&y?.useDefaultFlags?.extensions?v.extensionsResource:(0,L.$4g)(r,"extensions.json"),cacheHome:(0,L.$4g)(a,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let o=class extends j.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,y){super(),this.t=t,this.u=r,this.w=a,this.y=y,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Bc,emptyWindows:new Map},this.profilesHome=(0,L.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,d.$4f)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}r.push(i((0,L.$1g)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},t))}}catch(v){this.y.error(v)}const a=new f.$Bc,y=new Map;if(r.length)try{const v=this.Q();if(v.workspaces)for(const[C,E]of Object.entries(v.workspaces)){const k=A.URI.parse(C),O=r.find(M=>M.id===E);O&&a.set(k,O)}if(v.emptyWindows)for(const[C,E]of Object.entries(v.emptyWindows)){const k=r.find(O=>O.id===E);k&&y.set(C,k)}}catch(v){this.y.error(v)}this.z={profiles:r,workspaces:a,emptyWindows:y}}return this.z}D(){const t=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,u.$8e)(r)}\\s(\\d+)`);let y=0;for(const C of this.profiles){const E=a.exec(C.name),k=E?parseInt(E[1]):0;y=k>y?k:y}const v=`${r} ${y+1}`;return this.createProfile((0,R.$ej)((0,w.$Mg)()).toString(16),v,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,R.$ej)((0,w.$Mg)()).toString(16),t,r,a)}async createProfile(t,r,a,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(t,r,a);return y&&await this.setProfileForWorkspace(y,v),v}async F(t,r,a){if(!(0,d.$4f)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(r);return y||(y=(async()=>{try{if(this.profiles.find(k=>k.name===r||k.id===t))throw new Error(`Profile with ${r} name already exists`);const C=i(t,r,(0,L.$4g)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(C.location);const E=[];return this.j.fire({profile:C,join(k){E.push(k)}}),await p.Promises.settled(E),this.I([C],[],[]),C}finally{this.r.delete(r)}})(),this.r.set(r,y)),y}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(y=>y.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(y=>y.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(y){a.push(y)}});try{await Promise.allSettled(a)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(y){(0,$.$bl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(y=>y.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$Ai)(t)?t.uri:(0,m.$Fi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const y=[...this.profiles,...t],v=[];this.s.profiles=[];for(let C of y)C.isDefault||r.some(E=>C.id===E.id)||(C=a.find(E=>C.id===E.id)??C,C.isTransient?this.s.profiles.push(C):v.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags}));this.P(v),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const y=this.G(t),v=a?this.s:this.C;A.URI.isUri(y)?(v.workspaces.delete(y),r&&v.workspaces.set(y,r)):(v.emptyWindows.delete(y),r&&v.emptyWindows.set(y,r)),a||this.M()}M(){const t={};for(const[a,y]of this.C.workspaces.entries())t[a.toString()]=y.id;const r={};for(const[a,y]of this.C.emptyWindows.entries())r[a.toString()]=y.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[v,C]of Object.entries(t.workspaces)){const E=A.URI.parse(C);r[v]=this.w.extUri.isEqual(E,a.location)?a.id:this.w.extUri.basename(E)}const y={};if(t.emptyWindows)for(const[v,C]of Object.entries(t.emptyWindows)){const E=A.URI.parse(C);y[v]=this.w.extUri.isEqual(E,a.location)?a.id:this.w.extUri.basename(E)}return{workspaces:r,emptyWindows:y}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$zl=o,e.$zl=o=Ee([Q(0,P.$xi),Q(1,$.$Wk),Q(2,h.$ul),Q(3,b.$Wj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Al=n}),define(ce[249],le([0,1,6,2,18]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let L=class extends N.$Uc{constructor(I){super(),this.B(new R.$Ch(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$Kdc=L,e.$Kdc=L=Ee([Q(0,j.$wl)],L)}),define(ce[250],le([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$eq=void 0,e.$fq=g,e.$gq=i;let c=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,y,v,C){super(),this.z=t,this.C=r,this.D=a,this.F=y,this.G=v,this.H=C,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$be),this.s=this.B(new A.$be),this.t=this.B(new A.$be),this.u=this.B(new A.$be),this.w=this.B(new A.$be),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.m.forEach(E=>E.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$Xo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const y=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:v})=>(0,f.$op)(v,t.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new m.$1o(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$1o(b.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:y,options:v})=>{try{const C=await this.N(y,!!v?.installGivenVersion,!!v?.installPreReleaseVersion,v.productVersion??{version:this.G.version,date:this.G.date});a.push({...C,options:v})}catch(C){r.push({identifier:y.identifier,operation:2,source:y,error:C})}})),a.length&&r.push(...await this.I(a));for(const y of r)y.error&&(this.F.error("Failed to install extension.",y.identifier.id),this.F.error(y.error),y.source&&!S.URI.isUri(y.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$wp)(y.source),error:y.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,h.$Om)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const y of this.H.profiles){const v=(await this.getInstalled(1,y.extensionsResource)).find(C=>(0,f.$op)(C.identifier,t.identifier));v?this.w.fire(v):this.u.fire({identifier:t.identifier,profileLocation:y.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=new Map,a=new Map,y=[],v=(E,k)=>`${f.$pp.create(E).toString()}-${k.toString()}`,C=(E,k,O,M)=>{const F=this.Y(E,k,O),U=`${(0,f.$tp)(E.publisher,E.name)}-${O.profileLocation.toString()}`;a.set(U,{task:F,root:M}),this.n.fire({identifier:F.identifier,source:k,profileLocation:O.profileLocation}),this.F.info("Installing extension:",F.identifier.id),S.URI.isUri(k)||this.j.set(v(k,O.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:E,extension:k,options:O}of t){const M=O.isApplicationScoped||O.isBuiltin||(0,h.$Om)(E),F={...O,installOnlyNewlyAddedFromExtensionPack:O.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(k),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:O.profileLocation??this.X(),productVersion:O.productVersion??{version:this.G.version,date:this.G.date}},U=S.URI.isUri(k)?void 0:this.j.get(v(k,F.profileLocation));U?(this.F.info("Extension is already requested to install",U.task.identifier.id),y.push(U.task.waitUntilTaskIsFinished())):C(E,k,F,void 0)}return await Promise.all([...a.values()].map(async({task:E})=>{if(E.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",E.identifier.id);else try{const k=await this.M(E.identifier,E.manifest,!!E.options.installOnlyNewlyAddedFromExtensionPack,!!E.options.installPreReleaseVersion,E.options.profileLocation,E.options.productVersion),O=await this.getInstalled(void 0,E.options.profileLocation,E.options.productVersion),M={...E.options,context:{...E.options.context,[m.$So]:!0}};for(const{gallery:F,manifest:U}of(0,R.$Mb)(k,({gallery:X})=>X.identifier.id)){if(a.has(`${F.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const X=this.j.get(v(F,M.profileLocation));if(X){if(this.J(E,X.task)){const H=X.task.identifier;this.F.info("Waiting for already requested installing extension",H.id,E.identifier.id),X.waitingTasks.push(E),y.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Z=>Z.some(W=>(0,f.$op)(W.identifier,H)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",H.id,E.identifier.id),!Z.find(J=>(0,f.$op)(J.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else O.some(({identifier:H})=>(0,f.$op)(H,F.identifier))||C(U,F,M,E)}}catch(k){if(S.URI.isUri(E.source))(0,R.$Lb)(E.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",E.identifier.id,k.message),(0,R.$Lb)(E.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",E.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",E.identifier.id),k}})),await this.L([...a.entries()].map(async([E,{task:k}])=>{const O=new Date().getTime();try{const M=await k.run();if(await this.L(this.y.map(F=>F.postInstall(M,k.source,k.options,j.CancellationToken.None))),!S.URI.isUri(k.source)){const F=k.operation===3,U=F?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$wp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-O,durationSinceUpdate:U}),P.$o&&k.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}r.set(E,{local:M,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw r.set(E,{error:M,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,L.$0)(M)),M}})),y.length&&await this.L(y),[...r.values()]}catch(E){const k=(F,U,X)=>{const H=[];F.manifest.extensionDependencies?.length&&H.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&H.push(...F.manifest.extensionPack);for(const Z of H){if(X.includes(Z.toLowerCase()))continue;X.push(Z.toLowerCase());const W=r.get(`${Z.toLowerCase()}-${U.toString()}`);W?.local&&(X=k(W.local,U,X))}return X},O=F=>({identifier:F.identifier,operation:2,source:F.source,context:F.options.context,profileLocation:F.profileLocation,error:E}),M=[];for(const[F,{task:U,root:X}]of a){const H=r.get(F);H?H.local&&X&&!r.get(`${X.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`)?.local&&(M.push(this.Z(H.local,{versionOnly:!0,profileLocation:U.profileLocation})),r.set(F,O(U))):(U.cancel(),r.set(F,O(U)))}for(const[F,{task:U}]of a){const X=r.get(F);if(!X?.local||U.options.donotIncludePackAndDependencies)continue;k(X.local,U.profileLocation,[X.local.identifier.id.toLowerCase()]).slice(1).some(Z=>a.has(`${Z.toLowerCase()}-${U.profileLocation.toString()}`)&&!r.get(`${Z.toLowerCase()}-${U.profileLocation.toString()}`)?.local)&&(M.push(this.Z(X.local,{versionOnly:!0,profileLocation:U.profileLocation})),r.set(F,O(U)))}throw M.length&&await Promise.allSettled(M.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(U){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,L.$0)(U))}})),E}finally{for(const{task:E}of a.values())E.source&&!S.URI.isUri(E.source)&&this.j.delete(v(E.source,E.profileLocation));if(r.size){const E=[...r.values()];for(const k of E)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(E)}}}J(t,r){for(const[,{task:a,waitingTasks:y}]of this.j.entries())if(a===t&&(y.includes(r)||y.some(v=>this.J(v,r)))||a===r&&y[0]&&!this.J(t,y[0]))return!1;return!0}async L(t){const r=[],a=[],y=await Promise.allSettled(t);for(const v of y)v.status==="fulfilled"?r.push(v.value):a.push(v.reason);if(a.length)throw g(a);return r}async M(t,r,a,y,v,C){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,v,C),k=[],O=[],M=async(F,U)=>{k.push(F);const X=U.extensionDependencies||[],H=[...X];if(U.extensionPack){const Z=a?E.find(W=>(0,f.$op)(W.identifier,F)):void 0;for(const W of U.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(J=>(0,f.$op)({id:J},{id:W}))||H.every(J=>!(0,f.$op)({id:J},{id:W}))&&H.push(W)}if(H.length){const Z=H.filter(W=>k.every(J=>!(0,f.$op)(J,{id:W})));if(Z.length){const W=await this.z.getExtensions(Z.map(J=>({id:J,preRelease:y})),j.CancellationToken.None);for(const J of W){if(k.find(ie=>(0,f.$op)(ie,J.identifier)))continue;const V=X.some(ie=>(0,f.$op)({id:ie},J.identifier));let B;try{B=await this.N(J,!1,y,C)}catch(ie){if(V)throw ie;this.F.info("Skipping the packed extension as it cannot be installed",J.identifier.id,(0,L.$0)(ie));continue}O.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(t,r),O}async N(t,r,a,y){let v;const C=await this.getExtensionsControlManifest();if(C.malicious.some(O=>(0,f.$op)(t.identifier,O)))throw new m.$1o(b.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const E=C.deprecated[t.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},j.CancellationToken.None))[0],!v)throw new m.$1o(b.localize(2,null,t.identifier.id,E.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new m.$1o(b.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$To)(O)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.O(t,r,a,y),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new m.$1o(b.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$1o(b.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const k=await this.z.getManifest(v,j.CancellationToken.None);if(k===null)throw new m.$1o(`Missing manifest for extension ${v.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(k.version!==v.version)throw new m.$1o(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:k}}async O(t,r,a,y){const v=await this.getTargetPlatform();let C=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(C=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0,productVersion:y},j.CancellationToken.None))[0]||null),!C&&await this.z.isExtensionCompatible(t,a,v,y)&&(C=t),C||(r?C=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0,productVersion:y},j.CancellationToken.None))[0]||null:C=await this.z.getCompatibleExtension(t,a,v,y)),C}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},y=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,v=this.m.get(y(t.identifier));if(v)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),v.waitUntilTaskIsFinished();const C=M=>{const F=this.Z(M,a);return this.m.set(y(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),F},E=(M,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$vp)(M),error:F}),this.u.fire({identifier:M.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},k=[],O=[];try{k.push(C(t));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,M);for(const U of F)this.m.has(y(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):k.push(C(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(k.map(F=>F.extension),M,t),await this.L(k.map(async F=>{try{if(await F.run(),await this.L(this.y.map(U=>U.postUninstall(F.extension,a,j.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}E(F.extension)}catch(U){const X=U instanceof m.$1o?U:new m.$1o((0,L.$0)(U),m.ExtensionManagementErrorCode.Internal);throw E(F.extension,X),X}finally{O.push(F)}}))}catch(M){const F=M instanceof m.$1o?M:new m.$1o((0,L.$0)(M),m.ExtensionManagementErrorCode.Internal);for(const U of k){try{U.cancel()}catch{}O.includes(U)||E(U.extension,F)}throw F}finally{for(const M of k)this.m.delete(y(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(t,r,a){for(const y of t){const v=this.U(y,r);if(v.length){const C=v.filter(E=>!t.some(k=>(0,f.$op)(k.identifier,E.identifier)));if(C.length)throw new Error(this.R(y,C,a))}}}R(t,r,a){return a===t?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const y=t.manifest.extensionPack?t.manifest.extensionPack:[];if(y.length){const v=r.filter(E=>!E.isBuiltin&&y.some(k=>(0,f.$op)({id:k},E.identifier))),C=[];for(const E of v)C.push(...this.S(E,r,a));return[...v,...C]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(y=>(0,f.$op)({id:y},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$eq=c,e.$eq=c=Ee([Q(0,m.$Zo),Q(1,u.$Vl),Q(2,d.$ul),Q(3,p.$Wj),Q(4,w.$dk),Q(5,l.$wl)],c);function g(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof m.$1o)return s;if(s instanceof m.$2o){const r=new m.$1o(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$1o(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:y,error:v,durationSinceUpdate:C}){let E,k;(0,$.$_f)(a)&&(a===!0?a="Verified":(a===!1||(E=m.ExtensionManagementErrorCode.Signature,k=a),a="Unverified")),v&&(v instanceof m.$1o||v instanceof m.$2o?(E=v.code,v.code===m.ExtensionManagementErrorCode.Signature&&(k=v.message)):E=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!v,duration:y,errorcode:E,errorcodeDetail:k,durationSinceUpdate:C})}class n{constructor(){this.d=new N.$ph}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$dh)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$dh)(t=>new Promise((r,a)=>{const y=t.onCancellationRequested(()=>{y.dispose(),a(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$hq=n}),define(ce[52],le([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class l extends Error{constructor(n,s){super(n),this.code=s}}e.$iq=l,e.$jq=(0,b.$qi)("IExtensionsProfileScannerService");let c=class extends j.$Uc{constructor(n,s,t,r,a,y){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=y,this.b=this.B(new L.$be),this.onAddExtensions=this.b.event,this.c=this.B(new L.$be),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$be),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$be),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,y=>{const v=[];if(t)v.push(...y);else for(const C of y)n.some(([E])=>(0,$.$op)(E.identifier,C.identifier)&&E.manifest.version!==C.version)?r.push(C):v.push(C);for(const[C,E]of n){const k=v.findIndex(M=>(0,$.$op)(M.identifier,C.identifier)&&M.version===C.manifest.version),O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:E};k===-1?(a.push(O),v.push(O)):v.splice(k,1,O)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),v}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(y){throw a.length&&this.c.fire({extensions:a,error:y,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:y,profileLocation:s}),y}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const y of r){const v=n.find(([C])=>(0,$.$op)(C.identifier,y.identifier)&&C.manifest.version===y.version);v&&(y.metadata={...y.metadata,...v[1]},t.push(y)),a.push(y)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const y of r)(0,$.$op)(y.identifier,n.identifier)?t.push(y):a.push(y);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const y=await this.m.readFile(n);a=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,S.$bl)(y)!==1)throw y;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new l((0,w.$0)(y),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let y=!1;for(const v of a){g(v)||this.w(n);let C;if((0,p.$4f)(v.relativeLocation)&&v.relativeLocation)C=this.z(v.relativeLocation);else if((0,p.$4f)(v.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${v.location}`);continue}else{C=I.URI.revive(v.location);const E=this.y(C);E&&(y=!0,v.relativeLocation=E)}(0,p.$$f)(v.metadata?.hasPreReleaseVersion)&&v.metadata?.preRelease&&(y=!0,v.metadata.hasPreReleaseVersion=!0),r.push({identifier:v.identifier,location:C,version:v.version,metadata:v.metadata})}y&&await this.m.writeFile(n,N.$Ce.fromString(JSON.stringify(a)))}if(s){r=s(r);const y=r.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(n,N.$Ce.fromString(JSON.stringify(y)))}return r})}w(n){const s=new l(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,S.$bl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(y=>g(y))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,S.$bl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,S.$bl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,S.$bl)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new R.$xh,this.h.set(n,s)),s}};e.$kq=c,e.$kq=c=Ee([Q(1,S.$Wk),Q(2,f.$wl),Q(3,h.$ul),Q(4,u.$Vl),Q(5,m.$Wj)],c);function g(o){return(0,p.$6f)(o)&&(0,P.$Yo)(o.identifier)&&(i(o.location)||(0,p.$4f)(o.location)&&o.location)&&((0,p.$$f)(o.relativeLocation)||(0,p.$4f)(o.relativeLocation))&&o.version&&(0,p.$4f)(o.version)}function i(o){return o?(0,p.$4f)(o.path)&&(0,p.$4f)(o.scheme):!1}}),define(ce[81],le([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o,n,s,t,r,a,y,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=e.$oq=e.$nq=e.Translations=void 0,e.$qq=X;var k;(function(Z){function W(J,V){if(J===V)return!0;const B=Object.keys(J),ie=new Set;for(const oe of Object.keys(V))ie.add(oe);if(B.length!==ie.size)return!1;for(const oe of B){if(J[oe]!==V[oe])return!1;ie.delete(oe)}return ie.size===0}Z.equals=W})(k||(e.Translations=k={})),e.$nq=(0,n.$qi)("IExtensionsScannerService");let O=class extends $.$Uc{constructor(W,J,V,B,ie,oe,te,ae,G,q,D,T){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=J,this.r=V,this.s=B,this.t=ie,this.u=oe,this.w=te,this.y=ae,this.z=G,this.C=q,this.D=D,this.F=T,this.g=this.B(new r.$be),this.onDidChangeCache=this.g.event,this.h=(0,f.$4g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$zp)(this.w,this.y)),this.G}async scanAllExtensions(W,J,V){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(J)]),oe=V?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const J=[];J.push(this.M(!!W.useCache,W.language)),J.push(this.N(W.language,!!W.checkControlFile));const[V,B]=await Promise.all(J);return this.J([...V,...B],0,W,!1)}async scanUserExtensions(W){const J=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const V=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(J,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let oe;try{oe=await ie.scanExtensions(B)}catch(te){if(te instanceof y.$iq&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await ie.scanExtensions(B);else throw te}return oe=await this.J(oe,1,W,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(W,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===S.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=J.find(ae=>(0,c.$op)(ae.identifier,te.identifier))?.type??te.type,this.n.validate(te,ie)))}))).flat();return this.J(V,"development",W,!0)}return[]}async scanExistingExtension(W,J,V){const B=await this.P(W,!1,J,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!V.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,J,V){const B=await this.P(W,!1,J,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,J,V,!0)}async scanMultipleExtensions(W,J,V){const B=[];return await Promise.all(W.map(async ie=>{const oe=await this.scanOneOrMultipleExtensions(ie,J,V);B.push(...oe)})),this.J(B,J,V,!0)}async scanMetadata(W){const J=(0,f.$4g)(W,"package.json"),V=(await this.w.readFile(J)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,J){const V=(0,f.$4g)(W,"package.json"),B=(await this.w.readFile(V)).value.toString(),ie=JSON.parse(B);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,f.$4g)(W,"package.json"),L.$Ce.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof y.$iq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Ce.fromString(JSON.stringify([])))}catch(J){(0,o.$bl)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,J,V,B){return V.includeAllVersions||(W=this.L(J===0?W:void 0,J===1?W:void 0,J==="development"?W:void 0,await this.getTargetPlatform(),B)),V.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,oe)=>{const te=b.$oc(ie.location.fsPath),ae=b.$oc(oe.location.fsPath);return te<ae?-1:te>ae?1:0})}L(W,J,V,B,ie){const oe=(ae,G,q)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(ie&&h.gt(ae.manifest.version,G.manifest.version))return this.y.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(h.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===B)return this.y.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},te=new g.$Nm;return W?.forEach(ae=>{const G=te.get(ae.identifier.id);(!G||oe(G,ae,!1))&&te.set(ae.identifier.id,ae)}),J?.forEach(ae=>{const G=te.get(ae.identifier.id);if(!G&&W&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||oe(G,ae,!1))&&te.set(ae.identifier.id,ae)}),V?.forEach(ae=>{const G=te.get(ae.identifier.id);(!G||oe(G,ae,!0))&&te.set(ae.identifier.id,ae),te.set(ae.identifier.id,ae)}),[...te.values()]}async M(W,J){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(W&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,J){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const B=J?await this.O():{},ie=[],oe=u.URI.file(b.$ic(b.$kc(S.$Kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of V){const G=B[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":ie.push((0,f.$4g)(oe,ae.name));break;default:ie.push(u.URI.file(G));break}}const te=await Promise.all(ie.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,R.$Hb)(te)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,J,V,B,ie,oe,te,ae){const G=await this.f(ie??m.$w),q=await this.Q(W),D=J&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=D?await this.Q(D):void 0;return new M(W,q,D,T,J,te,V,B,oe,ae.version,ae.date,this.C.commit,!this.z.isBuilt,ie,G)}async Q(W){try{const J=await this.w.stat(W);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$oq=O,e.$oq=O=Ee([Q(4,v.$wl),Q(5,y.$jq),Q(6,o.$Wk),Q(7,s.$Wj),Q(8,l.$xi),Q(9,t.$dk),Q(10,C.$ul),Q(11,n.$pi)],O);class M{constructor(W,J,V,B,ie,oe,te,ae,G,q,D,T,z,x,K){this.location=W,this.mtime=J,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=oe,this.type=te,this.excludeObsolete=ae,this.validate=G,this.productVersion=q,this.productDate=D,this.productCommit=T,this.devMode=z,this.language=x,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,J){return(0,f.$Wg)(W.location,J.location)&&W.mtime===J.mtime&&(0,f.$Wg)(W.applicationExtensionslocation,J.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&W.profile===J.profile&&j.$1n(W.profileScanOptions,J.profileScanOptions)&&W.type===J.type&&W.excludeObsolete===J.excludeObsolete&&W.validate===J.validate&&W.productVersion===J.productVersion&&W.productDate===J.productDate&&W.productCommit===J.productCommit&&W.devMode===J.devMode&&W.language===J.language&&k.equals(W.translations,J.translations)}}e.$pq=M;let F=class extends $.$Uc{constructor(W,J,V,B,ie){super(),this.f=W,this.g=J,this.h=V,this.j=B,this.m=ie}async scanExtensions(W){const J=W.profile?await this.r(W):await this.n(W);let V={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(B)}catch{}return(0,w.$eg)(V)?J:J.filter(B=>!V[c.$pp.create(B).toString()])}async n(W){const J=await this.j.resolve(W.location);if(!J.children?.length)return[];const V=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,f.$1g)(B.resource).indexOf(".")===0)return null;const ie=new M(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,R.$Hb)(V).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let J=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const V=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);J.push(...V)}return J}async s(W,J,V){const B=await this.g.scanProfileExtensions(W,V.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async oe=>{if(J(oe)){const te=new M(oe.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,oe.metadata)}return null}));return(0,R.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,f.$4g)(W.location,"package.json"))){const J=await this.scanExtension(W);return J?[J]:[]}else return await this.scanExtensions(W)}catch(J){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,A.$0)(J)),[]}}async scanExtension(W,J){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=g.$Hm),J=J??V.__metadata,delete V.__metadata;const B=(0,c.$tp)(V.publisher,V.name),ie=J?.id?{id:B,uuid:J.id}:{id:B},oe=J?.isSystem?0:W.type,te=oe===0||!!J?.isBuiltin;V=await this.t(W.location,V,M.createNlsConfiguration(W));const ae={type:oe,identifier:ie,manifest:V,location:W.location,isBuiltin:te,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return W.validate?this.validate(ae,W):ae}}catch(V){W.type!==0&&this.m.error(V)}return null}validate(W,J){let V=!0;const B=(0,i.$Ep)(J.productVersion,J.productDate,J.location,W.manifest,W.isBuiltin);for(const[ie,oe]of B)ie===p.default.Error&&(V=!1,this.m.error(this.z(J.location,oe)));return W.isValid=V,W.validations=B,W}async scanExtensionManifest(W){const J=(0,f.$4g)(W,"package.json");let V;try{V=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,o.$bl)(ie)!==1&&this.m.error(this.z(W,(0,d.localize)(0,null,J.path,ie.message))),null}let B;try{B=JSON.parse(V)}catch{const oe=[];(0,I.$Dn)(V,oe);for(const te of oe)this.m.error(this.z(W,(0,d.localize)(1,null,J.path,te.offset,te.length,(0,P.$lq)(te.error))));return null}return(0,I.$Mn)(B)!=="object"?(this.m.error(this.z(W,(0,d.localize)(2,null,J.path))),null):B}async t(W,J,V){const B=await this.u(W,J,V);if(B)try{const ie=[],oe=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(ae=>{this.m.error(this.z(W,(0,d.localize)(3,null,B.default?.path,(0,P.$lq)(ae.error))))}),J;if((0,I.$Mn)(B)!=="object")return this.m.error(this.z(W,(0,d.localize)(4,null,B.default?.path))),J;const te=B.values||Object.create(null);return(0,E.$mq)(this.m,J,te,oe)}catch{}return J}async u(W,J,V){const B=(0,f.$4g)(W,"package.nls.json"),ie=(G,q)=>{q.forEach(D=>{this.m.error(this.z(W,(0,d.localize)(5,null,G?.path,(0,P.$lq)(D.error))))})},oe=G=>{this.m.error(this.z(W,(0,d.localize)(6,null,G?.path)))},te=`${J.publisher}.${J.name}`,ae=V.translations[te];if(ae)try{const G=u.URI.file(ae),q=(await this.j.readFile(G)).value.toString(),D=[],T=(0,I.$Dn)(q,D);return D.length>0?(ie(G,D),{values:void 0,default:B}):(0,I.$Mn)(T)!=="object"?(oe(G),{values:void 0,default:B}):{values:T.contents?T.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let q;try{q=await this.y(W,V)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const D=(await this.j.readFile(q.localized)).value.toString(),T=[],z=(0,I.$Dn)(D,T);return T.length>0?(ie(q.localized,T),{values:void 0,default:q.original}):(0,I.$Mn)(z)!=="object"?(oe(q.localized),{values:void 0,default:q.original}):{values:z,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(W,J){if(W)try{const V=(await this.j.readFile(W)).value.toString();return(0,I.$Dn)(V,J)}catch{}}y(W,J){return new Promise((V,B)=>{const ie=oe=>{const te=(0,f.$4g)(W,`package.nls.${oe}.json`);this.j.exists(te).then(ae=>{ae&&V({localized:te,original:(0,f.$4g)(W,"package.nls.json")});const G=oe.lastIndexOf("-");G===-1?V({localized:(0,f.$4g)(W,"package.nls.json"),original:null}):(oe=oe.substring(0,G),ie(oe))})};if(J.devMode||J.pseudo||!J.language)return V({localized:(0,f.$4g)(W,"package.nls.json"),original:null});ie(J.language)})}z(W,J){return`[${W.path}]: ${J}`}};F=Ee([Q(1,y.$jq),Q(2,C.$ul),Q(3,o.$Wk),Q(4,s.$Wj)],F);let U=class extends F{constructor(W,J,V,B,ie,oe,te){super(J,B,ie,oe,te),this.G=W,this.H=V,this.D=this.B(new N.$oh(3e3)),this.F=this.B(new r.$be),this.onDidChangeCache=this.F.event}async scanExtensions(W){const J=this.M(W),V=await this.I(J);if(this.C=W,V&&V.input&&M.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ie=>(ie.location=u.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(J,{input:W,result:B}),B}async I(W){try{const J=await this.j.readFile(W),V=JSON.parse(J.value.toString());return{result:V.result,input:(0,a.$Zh)(V.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",W.path,(0,A.$0)(J))}return null}async J(W,J){try{await this.j.writeFile(W,L.$Ce.fromString(JSON.stringify(J)))}catch(V){this.m.debug("Error while writing the extension cache file:",W.path,(0,A.$0)(V))}}async L(){if(!this.C)return;const W=this.M(this.C),J=await this.I(W);if(!J)return;const V=J.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$1n(B,V))try{this.m.info("Invalidating Cache",V,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const J=this.N(W);return this.h.extUri.joinPath(J.cacheHome,W.type===0?g.$Gm:g.$Fm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(W.location,J.extensionsResource))??this.G:this.H.defaultProfile}};U=Ee([Q(2,v.$wl),Q(3,y.$jq),Q(4,C.$ul),Q(5,o.$Wk),Q(6,s.$Wj)],U);function X(Z,W){const J=(0,c.$rp)(Z.manifest.publisher,Z.manifest.name);return{id:J,identifier:new g.$Lm(J),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:W,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,publisherDisplayName:Z.publisherDisplayName,...Z.manifest}}class H extends O{constructor(W,J,V,B,ie,oe,te,ae,G,q,D,T){super(W,J,(0,f.$4g)(V,".vscode-oss-dev","extensions","control.json"),B,ie,oe,te,ae,G,q,D,T),this.S=(async()=>{if(m.$z)try{const z=await this.w.readFile(u.URI.file(m.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$rq=H}),define(ce[251],le([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let m=class extends A.$Uc{constructor(h,p){super(),this.b=h,this.f=p,this.a=new N.$wh(5)}async postUninstall(h){const p=this.g(h,"uninstall");p&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,h),this.f.info("Finished running post uninstall script",h.identifier.id,h.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",h.identifier.id,h.manifest.version),this.f.error(w)}}));try{await $.Promises.rm(this.m(h))}catch(w){this.f.error("Error while removing extension storage path",h.identifier.id),this.f.error(w)}}g(h,p){const w=`vscode:${p}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[w]=="string"){const u=h.manifest.scripts[w].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${w} should be a node script`),null):{script:(0,P.$kc)(h.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(h,p,w,u,d){return new Promise((l,c)=>{const g=this.j(h,p,w,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):l(void 0)};g.on("error",n=>{o((0,j.$bj)(n)||"Unknown")}),g.on("exit",(n,s)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),u&&(i=setTimeout(()=>{i=null,g.kill(),c("timed out")},5e3))})}j(h,p,w,u){const d={silent:!0,execArgv:void 0},l=(0,R.fork)(h,[`--type=extension-post-${p}`,...w],d);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(l.stdout,"data"),g=L.Event.fromNodeEventEmitter(l.stderr,"data");c(n=>this.f.info(u.identifier.id,u.manifest.version,`post-${p}`,n)),g(n=>this.f.error(u.identifier.id,u.manifest.version,`post-${p}`,n));const i=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(g,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}m(h){return(0,P.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};e.$tq=m,e.$tq=m=Ee([Q(0,b.$wl),Q(1,S.$Wj)],m)}),define(ce[113],le([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o,n,s,t,r,a,y,v,C,E,k,O,M,F,U,X,H,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=e.$xq=void 0,e.$xq=(0,M.$ri)(n.$3o);const W=".vsctmp";let J=class extends o.$eq{constructor(G,q,D,T,z,x,K,ee,_,Y,se,ue){super(G,q,se,D,Y,ue),this.eb=z,this.fb=x,this.gb=K,this.hb=_,this.db=new Map,this.qb=new S.$Cc;const ge=this.B(ee.createInstance(y.$tq));this.ab=this.B(ee.createInstance(V,$e=>ge.postUninstall($e))),this.bb=this.B(new C.$vq(ue,_,se,this,this.F)),this.cb=this.B(ee.createInstance(a.$sq));const fe=this.B(new E.$wq(this,this.eb,ue,x,se,_,D));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$zp)(this.hb,this.F)),this.ib}async zip(G){this.F.trace("ExtensionManagementService#zip",G.identifier.id);const q=await this.ob(G),D=await(0,l.zip)((0,f.$4g)(this.cb.extensionsDownloadDir,(0,u.$Mg)()).fsPath,q);return w.URI.file(D)}async unzip(G){return this.F.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:q,cleanup:D}=await this.kb(G),T=m.$lc(q.fsPath);try{return await(0,v.$uq)(T)}finally{await D()}}getInstalled(G,q=this.H.defaultProfile.extensionsResource,D={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(G??null,q,D)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.ab.scanUserExtensionAtLocation(G)}async install(G,q={}){this.F.trace("ExtensionManagementService#install",G.toString());const{location:D,cleanup:T}=await this.kb(G);try{const z=await(0,v.$uq)(m.$lc(D.fsPath)),x=(0,s.$tp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,k.$Gp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:z,extension:D,options:q}])).find(({identifier:_})=>(0,s.$op)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.$gq)(new Error(`Unknown error while installing extension ${x}`))}finally{await T()}}async installFromLocation(G,q){this.F.trace("ExtensionManagementService#installFromLocation",G.toString());const D=await this.ab.scanUserExtensionAtLocation(G);if(!D||!D.manifest.name||!D.manifest.version)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.tb([[D,{source:"resource"}]],q),this.F.info("Successfully installed extension",D.identifier.id,q.toString()),D}async installExtensionsFromProfile(G,q,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",G,q.toString(),D.toString());const T=(await this.getInstalled(1,q)).filter(z=>G.some(x=>(0,s.$op)(x,z.identifier)));if(T.length){const z=await Promise.all(T.map(x=>this.ab.scanMetadata(x,q)));await this.tb(T.map((x,K)=>[x,z[K]]),D),this.F.info("Successfully installed extensions",T.map(x=>x.identifier.id),D.toString())}return T}async updateMetadata(G,q,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",G.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),G=await this.ab.updateMetadata(G,q,D),this.bb.invalidate(D),this.w.fire(G),G}async reinstallFromGallery(G){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const q=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:q,compatible:!0},j.CancellationToken.None);if(!D)throw new Error(c.localize(2,null));await this.ab.setUninstalled(G);try{await this.ab.removeUninstalledExtension(G)}catch(T){throw new Error(c.localize(3,null,(0,L.$bj)(T)))}return this.installFromGallery(D)}$(G,q,D,T){return this.ab.copyExtension(G,q,D,T)}copyExtensions(G,q){return this.ab.copyExtensions(G,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...G){return this.ab.setUninstalled(...G)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(G){this.F.error(G)}}async download(G,q,D){const{location:T}=await this.cb.download(G,q,!D);return T}async kb(G){if(G.scheme===b.Schemas.file)return{location:G,async cleanup(){}};this.F.trace("Downloading extension from",G.toString());const q=(0,f.$4g)(this.cb.extensionsDownloadDir,(0,u.$Mg)());return await this.gb.download(G,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(G,q,D){if(w.URI.isUri(q))return new oe(G,q,D,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$pp.create(q).toString();let z=this.db.get(T);return z||(this.db.set(T,z=new ie(G,q,D,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),z}Z(G,q){return new te(G,q.profileLocation,this.fb)}async ob(G){const q=async T=>{let z=await d.Promises.readdir(T);z=z.map(ee=>m.$kc(T,ee));const x=await Promise.all(z.map(ee=>d.Promises.stat(ee)));let K=Promise.resolve([]);return x.forEach((ee,_)=>{const Y=z[_];ee.isFile()&&(K=K.then(se=>[...se,Y])),ee.isDirectory()&&(K=K.then(se=>q(Y).then(ue=>[...se,...ue])))}),K};return(await q(G.location.fsPath)).map(T=>({path:`extension/${m.$mc(G.location.fsPath,T)}`,localPath:T}))}async pb({added:G,removed:q}){if(q){const D=G&&this.D.extUri.isEqual(q.profileLocation,G.profileLocation)?q.extensions.filter(T=>G.extensions.every(z=>!(0,s.$op)(z,T))):q.extensions;for(const T of D)this.F.info("Extensions removed from another source",T.id,q.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:q.profileLocation})}if(G){const T=(await this.getInstalled(1,G.profileLocation)).filter(z=>G.extensions.some(x=>(0,s.$op)(x,z.identifier)));this.s.fire(T.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,G.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:G.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const G=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of G.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(G){if(!G.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const D of G.rawAdded){if(this.qb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.hb.stat(D)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(D);T&&T.installedTimestamp===void 0&&(this.qb.add(D),q.push(T))}q.length&&(await this.tb(q.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(D=>D.identifier.id)))}async tb(G,q){const D=G.map(T=>T[0]);await this.ub(D),await this.fb.addExtensionsToProfile(G,q),this.s.fire(D.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:q})))}async ub(G){const q=await this.ab.getUninstalledExtensions();for(const D of G){const T=s.$pp.create(D);q[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$yq=J,e.$yq=J=Ee([Q(0,n.$Zo),Q(1,X.$Vl),Q(2,F.$Wj),Q(3,i.$yi),Q(4,r.$nq),Q(5,t.$jq),Q(6,g.$Eo),Q(7,M.$pi),Q(8,O.$Wk),Q(9,U.$dk),Q(10,H.$ul),Q(11,Z.$wl)],J);let V=class extends $.$Uc{constructor(G,q,D,T,z,x){super(),this.j=G,this.m=q,this.n=D,this.s=T,this.t=z,this.u=x,this.h=this.B(new I.$be),this.onExtract=this.h.event,this.c=(0,f.$4g)(this.n.userExtensionsLocation,".obsolete"),this.g=new R.$xh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(G,q,D){const T={includeInvalid:!0,profileLocation:q,productVersion:D};let z=[];return G===null||G===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},T,!1)):G===1&&z.push(...await this.n.scanUserExtensions(T)),z=G!==null?z.filter(x=>x.type===G):z,Promise.all(z.map(x=>this.F(x)))}async scanAllUserExtensions(G){const q=await this.n.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(q.map(D=>this.F(D)))}async scanUserExtensionAtLocation(G){try{const q=await this.n.scanExistingExtension(G,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(G,q,D,T,z){const x=G.toString(),K=w.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$Mg)()}`)),ee=w.URI.file(m.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&T){try{await this.y(G.id,ee,"removeExisting")}catch{throw new n.$1o(c.localize(4,null,ee.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,D);else try{try{this.u.trace(`Started extracting the extension from ${q} to ${ee.fsPath}`),await(0,l.$cq)(q,K.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${ee}:`,G.id)}catch(Y){let se=n.ExtensionManagementErrorCode.Extract;throw Y instanceof l.$aq&&(Y.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$1o(Y.message,se)}await this.n.updateMetadata(K,D);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${ee.fsPath}`),await this.C(K.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Y){if(Y.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(Y)}. Deleted from extracted location`,K),Y}this.h.fire(ee)}catch(Y){try{await this.m.del(K,{recursive:!0})}catch{}throw Y}return this.D(ee,1)}async scanMetadata(G,q){return q?(await this.w(G,q))?.metadata:this.n.scanMetadata(G.location)}async w(G,q){return(await this.s.scanProfileExtensions(q)).find(T=>(0,s.$op)(T.identifier,G.identifier))}async updateMetadata(G,q,D){return D?await this.s.updateMetadata([[G,q]],D):await this.n.updateMetadata(G.location,q),this.D(G.location,G.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...G){const q=G.map(D=>s.$pp.create(D));await this.z(D=>q.forEach(T=>{D[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(G){await this.z(q=>delete q[G.toString()])}async removeExtension(G,q){if(this.t.extUri.isEqualOrParent(G.location,this.n.userExtensionsLocation))return this.y(G.identifier.id,G.location,q)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.z(q=>delete q[s.$pp.create(G).toString()])}async copyExtension(G,q,D,T){const z=await this.w(G,q),x=await this.w(G,D);if(T={...z?.metadata,...T},x)if(this.t.extUri.isEqual(x.location,G.location))await this.s.updateMetadata([[G,{...x.metadata,...T}]],D);else{const K=await this.D(x.location,G.type,D);await this.s.removeExtensionFromProfile(K,D),await this.s.addExtensionsToProfile([[G,{...x.metadata,...T}]],D)}else await this.s.addExtensionsToProfile([[G,T]],D);return this.D(G.location,G.type,D)}async copyExtensions(G,q,D){const T=await this.scanExtensions(1,G,D),z=await Promise.all(T.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,G)]));await this.s.addExtensionsToProfile(z,q)}async y(G,q,D){this.u.trace(`Deleting ${D} extension from disk`,G,q.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,P.$ej)((0,u.$Mg)()).toString(16)}${W}`);await this.C(q.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,G,q.fsPath)}async z(G){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,O.$bl)(T)!==1)throw T}let D={};if(q)try{D=JSON.parse(q)}catch{}return G&&(G(D),Object.keys(D).length?await this.m.writeFile(this.c,N.$Ce.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(G,q){try{await d.Promises.rename(G,q,2*60*1e3)}catch(D){throw new n.$1o(D.message||c.localize(5,null,G,q),D.code||n.ExtensionManagementErrorCode.Rename)}}async D(G,q,D){if(D){const z=(await this.n.scanUserExtensions({profileLocation:D})).find(x=>this.t.extUri.isEqual(x.location,G));if(z)return this.F(z)}else{const T=await this.n.scanExistingExtension(G,q,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(c.localize(6,null,G.path))}async F(G){const q=await this.m.resolve(G.location);let D,T;return q.children&&(D=q.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,T=q.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:D,changelogUrl:T,publisherDisplayName:G.metadata?.publisherDisplayName,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned,isWorkspaceScoped:!1,source:G.metadata?.source??(G.identifier.uuid?"gallery":"vsix")}}async G(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(G));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const z of q)G[s.$pp.create(z).toString()]||D.add(z.identifier.id.toLowerCase());try{const z=(0,s.$up)(q,x=>x.identifier);await R.Promises.settled(z.map(async x=>{const K=x.sort((ee,_)=>h.rcompare(ee.manifest.version,_.manifest.version))[0];D.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(z){this.u.error(z)}const T=q.filter(z=>z.metadata&&G[s.$pp.create(z).toString()]);await Promise.allSettled(T.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,O.$bl)(q)!==1&&this.u.error(q);return}if(G?.children)try{await Promise.allSettled(G.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(D){(0,O.$bl)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$zq=V,e.$zq=V=Ee([Q(1,O.$Wk),Q(2,r.$nq),Q(3,t.$jq),Q(4,H.$ul),Q(5,F.$Wj)],V);class B extends o.$hq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$$f)(this.options.operation)?this.l:this.options.operation}constructor(G,q,D,T,z,x,K,ee,_,Y){super(),this.manifest=G,this.identifier=q,this.source=D,this.options=T,this.m=z,this.n=x,this.o=K,this.p=ee,this.q=_,this.s=Y,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(G){const[q,D]=await this.x(G);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,D]],this.j,!q.isValid),q}async u({zipPath:G,key:q,metadata:D},T,z){let x=await this.v(q);return x?x=await this.m.updateMetadata(x,D):(this.s.trace("Extracting extension...",q.id),x=await this.m.extractUserExtension(q,G,D,T,z),this.s.info("Extracting extension completed.",q.id)),x}async v(G){return await this.w(G)?(this.s.trace("Removing the extension from uninstalled list:",G.id),await this.m.setInstalled(G),this.s.info("Removed the extension from uninstalled list:",G.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$pp.create(T).equals(G))):void 0}async w(G){return!!(await this.m.getUninstalledExtensions())[G.toString()]}}class ie extends B{constructor(G,q,D,T,z,x,K,ee,_,Y,se){super(G,q.identifier,q,D,z,x,K,ee,_,Y),this.y=q,this.z=T,this.A=se}async x(G){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(z){throw new n.$1o(z,n.ExtensionManagementErrorCode.Scanning)}const D=q.find(z=>(0,s.$op)(z.identifier,this.y.identifier));D&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:D?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:(0,p.$0f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||D?.preRelease,source:"gallery"};if(D&&D.type!==0&&D.manifest.version===this.y.version)try{return[await this.m.updateMetadata(D,T),T]}catch(z){throw new n.$1o((0,A.$0)(z),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(T,G)}catch(z){if(z instanceof n.$1o&&(z.code===n.ExtensionManagementErrorCode.CorruptZip||z.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(T,G);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw z}}async C(G,q){const{location:D,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.D(D.fsPath),[await this.u({zipPath:D.fsPath,key:s.$pp.create(this.y),metadata:G},!1,q),G]}catch(z){try{await this.z.delete(D)}catch(x){this.s.warn("Error while deleting the downloaded file",D.toString(),(0,A.$0)(x))}throw z}}async D(G){try{await(0,v.$uq)(G)}catch(q){throw new n.$1o((0,o.$fq)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Aq=ie;class oe extends B{constructor(G,q,D,T,z,x,K,ee,_,Y){super(G,{id:(0,s.$tp)(G.publisher,G.name)},q,D,z,x,K,ee,_,Y),this.y=q,this.z=T}async h(G){const q=await super.h(G);return this.C(q,G),q}async x(G){const q=new s.$pp(this.identifier,this.manifest.version),T=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(K=>(0,s.$op)(this.identifier,K.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,source:"vsix"};if(T)if(this.l=3,q.equals(new s.$pp(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(c.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&h.gt(T.manifest.version,this.manifest.version)&&await this.m.setUninstalled(T);else{const K=await this.v(q);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(c.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:m.$lc(this.y.fsPath),key:q,metadata:z},!0,G),z]}async C(G,q){try{let[D]=await this.z.getExtensions([{id:G.identifier.id,version:G.manifest.version}],q);if(D||([D]=await this.z.getExtensions([{id:G.identifier.id}],q)),D){const T={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(G,T,this.options.profileLocation)}}catch{}}}class te extends o.$hq{constructor(G,q,D){super(),this.extension=G,this.j=q,this.k=D}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[252],le([0,1,9,18,28,22,52,12,16,8]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;let S=class extends A.$kq{constructor(m,f,h,p,w,u){super($.URI.file(m.extensionsPath),f,h,p,w,u)}};e.$zQ=S,e.$zQ=S=Ee([Q(0,P.$yi),Q(1,I.$Wk),Q(2,N.$wl),Q(3,j.$ul),Q(4,L.$Vl),Q(5,R.$Wj)],S)}),define(ce[253],le([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let m=class extends L.$rq{constructor(h,p,w,u,d,l,c,g){super(R.URI.file(d.builtinExtensionsPath),R.URI.file(d.extensionsPath),d.userHome,h.defaultProfile,h,p,w,u,d,l,c,g)}};e.$Ccc=m,e.$Ccc=m=Ee([Q(0,b.$wl),Q(1,j.$jq),Q(2,A.$Wk),Q(3,P.$Wj),Q(4,N.$yi),Q(5,$.$dk),Q(6,S.$ul),Q(7,I.$pi)],m)}),define(ce[19],le([0,1,6,3,2,98,13,69,4,18]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=f,e.$Xp=p,e.$Zp=u,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,P.$qi)("storageService");var S;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f(d){const l=d.get(e.$Tp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class h extends j.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:h.a}){super(),this.m=l,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,c,g){return N.Event.filter(this.b.event,i=>i.scope===l&&(c===void 0||i.key===c),g)}n(){this.j.value=(0,R.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,c){const{key:g,external:i}=c;if(g===e.$Tp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:g,target:this.J(l)[g],external:i})}w(l){this.f.fire({reason:l})}get(l,c,g){return this.P(c)?.get(l,g)}getBoolean(l,c,g){return this.P(c)?.getBoolean(l,g)}getNumber(l,c,g){return this.P(c)?.getNumber(l,g)}getObject(l,c,g){return this.P(c)?.getObject(l,g)}storeAll(l,c){this.y(()=>{for(const g of l)this.store(g.key,g.value,g.scope,g.target,c)})}store(l,c,g,i,o=!1){if((0,A.$ag)(c)){this.remove(l,g,o);return}this.y(()=>{this.z(l,g,i),this.P(g)?.set(l,c,o)})}remove(l,c,g=!1){this.y(()=>{this.z(l,c,void 0),this.P(c)?.delete(l,g)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,c){const g=[],i=this.J(l);for(const o of Object.keys(i))i[o]===c&&g.push(o);return g}z(l,c,g,i=!1){const o=this.J(c);typeof g=="number"?o[l]!==g&&(o[l]=g,this.P(c)?.set(e.$Tp,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.P(c)?.set(e.$Tp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const c=this.P(l);return c?f(c):Object.create(null)}isNew(l){return this.getBoolean(e.$Sp,l)===!0}async flush(l=S.NONE){this.f.fire({reason:l});const c=this.P(-1),g=this.P(0),i=this.P(1);switch(l){case S.NONE:await R.Promises.settled([c?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await R.Promises.settled([c?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return u(l,c,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,c){return this.w(S.NONE),(0,$.$vl)(l)?this.R(l,c):this.S(l,c)}M(l,c){return!(l.id===c.id||p(c)&&p(l))}N(l,c,g){this.y(()=>{const i=new Set;for(const[o,n]of l)i.add(o),c.get(o)!==n&&this.u(g,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(g,{key:o,external:!0})})}}e.$Wp=h;function p(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class w extends h{constructor(){super(),this.U=this.B(new I.$Qp(new I.$Rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Qp(new I.$Rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Qp(new I.$Rp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Yp=w;async function u(d,l,c,g,i,o){const n=k=>{try{return JSON.parse(k)}catch{return k}},s=new Map,t=new Map;d.forEach((k,O)=>{s.set(O,k),t.set(O,n(k))});const r=new Map,a=new Map;l.forEach((k,O)=>{r.set(O,k),a.set(O,n(k))});const y=new Map,v=new Map;c.forEach((k,O)=>{y.set(O,k),v.set(O,n(k))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const C=[];if(s.forEach((k,O)=>{C.push({key:O,value:k})}),console.table(C),console.groupEnd(),console.log(t),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const k=[];r.forEach((O,M)=>{k.push({key:M,value:O})}),console.table(k),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const E=[];y.forEach((k,O)=>{E.push({key:O,value:k})}),console.table(E),console.groupEnd(),console.log(v)}}),define(ce[114],le([0,1,3,2,13,29,33,19]),function(ne,e,R,N,j,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJb=e.$nJb=void 0;let P=class extends N.$Uc{constructor(b,m){super(),this.a=new R.$be,this.onDidChangeEnablement=this.a.event,this.b=this.B(new $(b)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(m.onDidInstallExtensions(f=>f.forEach(({local:h,operation:p})=>{h&&p===4&&this.f(h.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(L.$4o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(f=>!(0,A.$op)(f,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const h=m[f];if((0,A.$op)(h,b))return m.splice(f,1),this.g(m),!0}return!1}g(b){this.j(L.$4o,b)}h(b){return this.b.get(b,0)}j(b,m){this.b.set(b,m,0)}};e.$nJb=P,e.$nJb=P=Ee([Q(0,I.$Up),Q(1,L.$3o)],P);class $ extends N.$Uc{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new R.$be),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(0,void 0,this.B(new N.$Tc))(m=>this.f(m)))}get(b,m){let f;return m===0?((0,j.$ag)(this.a[b])&&(this.a[b]=this.g(b,m)),f=this.a[b]):f=this.g(b,m),JSON.parse(f)}set(b,m,f){const h=JSON.stringify(m.map(({id:w,uuid:u})=>({id:w,uuid:u})));this.g(b,f)!==h&&(f===0&&(m.length?this.a[b]=h:delete this.a[b]),this.h(b,m.length?h:void 0,f))}f(b){if(!(0,j.$ag)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const f=this.get(b.key,b.scope);delete this.a[b.key];const h=this.get(b.key,b.scope),p=f.filter(u=>!h.some(d=>(0,A.$op)(u,d))),w=h.filter(u=>!f.some(d=>(0,A.$op)(d,u)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,f){m?this.c.store(b,m,f,1):this.c.remove(b,f)}}e.$oJb=$}),define(ce[254],le([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$3p=oe;const i=L.$o?"web":(0,b.$Vo)(L.$u,A.$fc),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((z,x)=>z|x,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class C{constructor(z=v){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,x=this.d.pageSize){return new C({...this.d,pageNumber:z,pageSize:x})}withFilter(z,...x){const K=[...this.d.criteria,...x.length?x.map(ee=>({filterType:z,value:ee})):[{filterType:z}]];return new C({...this.d,criteria:K})}withSortBy(z){return new C({...this.d,sortBy:z})}withSortOrder(z){return new C({...this.d,sortOrder:z})}withFlags(...z){return new C({...this.d,flags:z.reduce((x,K)=>x|K,0)})}withAssetTypes(...z){return new C({...this.d,assetTypes:z})}withSource(z){return new C({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_,flags:Y,assetTypes:se}=this.d;return{filters:[{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_}],assetTypes:se,flags:Y}}get searchText(){const z=this.d.criteria.filter(x=>x.filterType===t.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(T,z){const x=(T||[]).filter(K=>K.statisticName===z)[0];return x?x.value:0}function k(T){const z="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(K=>K.assetType.indexOf(z)===0).reduce((K,ee)=>{const _=F(T,ee.assetType);return _&&K.push([ee.assetType.substring(z.length),_]),K},[])}function O(T){if(T.properties){const z=T.properties.filter(ee=>ee.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=z.filter(ee=>x.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return F(T,r.Repository)}function M(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function F(T,z){return T.files.filter(K=>K.assetType===z)[0]?{uri:`${T.assetUri}/${z}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${z}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function U(T,z){const x=T.properties?T.properties.filter(ee=>ee.key===z):[],K=x.length>0&&x[0].value;return K?K.split(",").map(ee=>(0,m.$sp)(ee)):[]}function X(T){const z=T.properties?T.properties.filter(x=>x.key===a.Engine):[];return z.length>0&&z[0].value||""}function H(T){const z=T.properties?T.properties.filter(x=>x.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function Z(T){const z=T.properties?T.properties.filter(K=>K.key===a.LocalizedLanguages):[],x=z.length>0&&z[0].value||"";return x?x.split(","):[]}function W(T){return T.properties?.find(z=>z.key===a.SponsorLink)?.value}function J(T){return T.properties?.find(z=>z.key===a.SupportLink)?.value}function V(T){return T.indexOf("preview")!==-1}function B(T){return T.targetPlatform?(0,b.$Uo)(T.targetPlatform):"undefined"}function ie(T){const z=(0,R.$Mb)(T.versions.map(B)),x=!!T.tags?.includes(b.$Po),K=z.indexOf("web");return x?K===-1&&z.push("web"):K!==-1&&z.splice(K,1),z}function oe(T,z){for(let x=0;x<T.length;x++){const K=T[x];if(K.version===T[x-1]?.version){let ee=x;if(B(K)===z)for(;ee>0&&T[ee-1].version===K.version;)ee--;ee!==x&&(T.splice(x,1),T.splice(ee,0,K))}}return T}function te(T,z,x){T.telemetryData={index:z,querySource:x,queryActivityId:T.queryContext?.[o]}}function ae(T,z,x,K){const ee=T.versions[0],_={manifest:F(z,r.Manifest),readme:F(z,r.Details),changelog:F(z,r.Changelog),license:F(z,r.License),repository:O(z),download:M(z),icon:F(z,r.Icon),signature:F(z,r.Signature),coreTranslations:k(z)};return{identifier:{id:(0,m.$tp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:z.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:T.shortDescription??"",installCount:E(T.statistics,"install"),rating:E(T.statistics,"averagerating"),ratingCount:E(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:U(z,a.Dependency),extensionPack:U(z,a.ExtensionPack),engine:X(z),localizedLanguages:Z(z),targetPlatform:B(z),isPreReleaseVersion:H(z)},hasPreReleaseVersion:H(ee),hasReleaseVersion:!0,preview:V(T.flags),isSigned:!!_.signature,queryContext:K,supportLink:J(ee)}}let G=class{constructor(z,x,K,ee,_,Y,se,ue){this.k=x,this.l=K,this.n=ee,this.o=_,this.q=Y,this.u=se,this.w=ue;const ge=se.extensionsGallery,fe=ge?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=fe?ge.servicePPEUrl:ge?.serviceUrl,this.g=fe?void 0:ge?.searchUrl,this.h=ge?.controlUrl,this.j=(0,d.$2p)(se.version,se,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,x,K){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:K,Y=[],se=[],ue=[],ge=[];let fe=!0;for(const ve of z){ve.uuid?se.push(ve.uuid):Y.push(ve.id);const Ce=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ce}),ve.version&&ge.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ce}if(!se.length&&!Y.length)return[];let $e=new C().withPage(1,z.length);se.length&&($e=$e.withFilter(t.ExtensionId,...se)),Y.length&&($e=$e.withFilter(t.ExtensionName,...Y)),(ee.queryAllVersions||fe)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??i,includePreRelease:ue,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((ve,Ce)=>te(ve,Ce,ee.source)),ye}async getCompatibleExtension(z,x,K,ee={version:this.u.version,date:this.u.date}){if((0,b.$Wo)(z.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(z,x,K))return z;const _=new C().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,z.identifier.uuid),{extensions:Y}=await this.z(_,{targetPlatform:K,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(z,x,K,ee={version:this.u.version,date:this.u.date}){if(!(0,b.$Xo)(z.properties.targetPlatform,z.allTargetPlatforms,K)||!x&&z.properties.isPreReleaseVersion)return!1;let _=z.properties.engine;if(!_){const Y=await this.getManifest(z,N.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");_=Y.engines.vscode}return(0,f.$Gp)(_,ee.version,ee.date)}async y(z,x,K,ee,_,Y,se={version:this.u.version,date:this.u.date}){if(!(0,b.$Xo)(B(x),_,Y)||K!=="any"&&H(x)!==(K==="prerelease"))return!1;if(ee)try{const ue=await this.E(z,x);if(!(0,f.$Gp)(ue,se.version,se.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,j.$0)(ue)),!1}return!0}async query(z,x){let K=z.text||"";const ee=z.pageSize??50;let _=new C().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(t.Category,ye||$e),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(t.Tag,ye||$e),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),_=_.withFilter(t.SearchText,K)),_=_.withSortBy(0)):z.ids?_=_.withFilter(t.ExtensionId,...z.ids):z.names?_=_.withFilter(t.ExtensionName,...z.names):_=_.withSortBy(4),typeof z.sortBy=="number"&&(_=_.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(_=_.withSortOrder(z.sortOrder)),z.source&&(_=_.withSource(z.source));const Y=async(fe,$e)=>{const{extensions:ye,total:ve}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ce,Ae)=>te(Ce,(fe.pageNumber-1)*fe.pageSize+Ae,z.source)),{extensions:ye,total:ve}},{extensions:se,total:ue}=await Y(_,x),ge=async(fe,$e)=>{if($e.isCancellationRequested)throw new j.$5;const{extensions:ye}=await Y(_.withPage(fe+1),$e);return ye};return{firstPage:se,total:ue,pageSize:_.pageSize,getPage:ge}}async z(z,x,K){const ee=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Y,context:se}=await this.B(z,K);if(!(z.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const ve=await this.A(ye,x,se);ve&&$e.push(ve)}return{extensions:$e,total:Y}}const ge=[],fe=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],ve={id:(0,m.$tp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ce=(0,I.$0f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(he=>(0,m.$op)(he,ve))?.includePreRelease;if(x.compatible&&(0,b.$Wo)(ie(ye),x.targetPlatform))continue;const Ae=await this.A(ye,x,se);!Ae||Ae.properties.isPreReleaseVersion&&(!Ce||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==x.targetPlatform&&Ae.hasPreReleaseVersion?fe.set(ye.extensionId,$e):ge.push([$e,Ae])}if(fe.size){const $e=new g.$0d,ye=new C().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(ye,x,K);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:fe.size});for(const Ce of ve){const Ae=fe.get(Ce.identifier.uuid);ge.push([Ae,Ce])}}return{extensions:ge.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Y}}async A(z,x,K){const ee={id:(0,m.$tp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},_=x.versions?.find(ge=>(0,m.$op)(ge,ee))?.version,Y=(0,I.$0f)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ge=>(0,m.$op)(ge,ee))?.includePreRelease,se=ie(z),ue=oe(z.versions,x.targetPlatform);if(x.compatible&&(0,b.$Wo)(se,x.targetPlatform))return null;for(let ge=0;ge<ue.length;ge++){const fe=ue[ge];if(!(_&&fe.version!==_)){if(await this.y((0,m.$tp)(z.publisher.publisherName,z.extensionName),fe,Y?"any":"release",x.compatible,se,x.targetPlatform,x.productVersion))return ae(z,fe,se,K);if(_&&fe.version===_)return null}}return _||x.compatible?null:ae(z,z.versions[0],se)}async B(z,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,ee=JSON.stringify(z.raw),_={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Y=new g.$0d;let se,ue,ge=0;try{if(se=await this.k.request({type:"POST",url:this.g&&z.criteria.some($e=>$e.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const fe=await(0,u.$Np)(se);if(fe){const $e=fe.results[0],ye=$e.extensions,ve=$e.resultMetadata&&$e.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ge=ve&&ve.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge,context:{[o]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(fe){const $e=(0,j.$4)(fe)?b.ExtensionGalleryErrorCode.Cancelled:(0,j.$0)(fe).startsWith("XHR timeout")?b.ExtensionGalleryErrorCode.Timeout:b.ExtensionGalleryErrorCode.Failed;throw ue=new b.$2o((0,j.$0)(fe),$e),ue}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(ee.length),duration:Y.elapsed(),success:!!se&&(0,u.$Jp)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?.code,count:String(ge)})}}async reportStatistic(z,x,K,ee){if(!this.isEnabled())return;const _=L.$o?this.x(`/itemName/${z}.${x}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${x}/${K}/stats?statType=${ee}`),Y=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:_,headers:ue},N.CancellationToken.None)}catch{}}async download(z,x,K){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const ee=(0,m.$wp)(z),_=new Date().getTime(),Y=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),se=K===2?"install":K===3?"update":"",ue=se?{uri:`${z.assets.download.uri}${P.URI.parse(z.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${z.assets.download.fallbackUri}${P.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:z.assets.download,ge=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,fe=await this.D(z.identifier.id,ue,r.VSIX,ge?{headers:ge}:void 0);await this.q.writeFile(x,fe.stream),Y(new Date().getTime()-_)}async downloadSignatureArchive(z,x){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const K=await this.D(z.identifier.id,z.assets.signature,r.Signature);await this.q.writeFile(x,K.stream)}async getReadme(z,x){if(z.assets.readme){const K=await this.D(z.identifier.id,z.assets.readme,r.Details,{},x);return await(0,u.$Mp)(K)||""}return""}async getManifest(z,x){if(z.assets.manifest){const K=await this.D(z.identifier.id,z.assets.manifest,r.Manifest,{},x),ee=await(0,u.$Mp)(K);return ee?JSON.parse(ee):null}return null}async C(z,x,K){const ee=F(x,r.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Y=await this.D(z,ee,r.Manifest,{headers:_});return await(0,u.$Np)(Y)}async getCoreTranslation(z,x){const K=z.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(K){const ee=await this.D(z.identifier.id,K[1],K[0]),_=await(0,u.$Mp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(z,x){if(z.assets.changelog){const K=await this.D(z.identifier.id,z.assets.changelog,r.Changelog,{},x);return await(0,u.$Mp)(K)||""}return""}async getAllCompatibleVersions(z,x,K){let ee=new C().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?ee=ee.withFilter(t.ExtensionId,z.identifier.uuid):ee=ee.withFilter(t.ExtensionName,z.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Y=ie(_[0]);if((0,b.$Wo)(Y,K))return[];const se=[];await Promise.all(_[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,x?"any":"release",!0,Y,K)&&se.push(fe)}catch{}}));const ue=[],ge=new Set;for(const fe of oe(se,K))ge.has(fe.version)||(ge.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:H(fe)}));return ue}async D(z,x,K,ee={},_=N.CancellationToken.None){const Y=await this.j,se={type:"GET"},ue={...Y,...ee.headers||{}};ee={...ee,...se,headers:ue};const ge=x.uri,fe=x.fallbackUri,$e={...ee,url:ge};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const ve=await(0,u.$Mp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ve}`)}catch(ye){if((0,j.$4)(ye))throw ye;const ve=(0,j.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:K,message:ve});const Ce={...ee,url:fe};return this.k.request(Ce,_)}}async E(z,x){let K=X(x);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:x.version});const ee=await this.C(z,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");K=ee.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.$Np)(z),K=[],ee={},_=[];if(x){for(const Y of x.malicious)K.push({id:Y});if(x.migrateToPreRelease)for(const[Y,se]of Object.entries(x.migrateToPreRelease))(!se.engine||(0,f.$Gp)(se.engine,this.u.version,this.u.date))&&(ee[Y.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Y,se]of Object.entries(x.deprecated))se&&(ee[Y.toLowerCase()]=(0,I.$0f)(se)?{}:se);if(x.search)for(const Y of x.search)_.push(Y)}return{malicious:K,deprecated:ee,search:_}}};G=Ee([Q(1,u.$Hp),Q(2,p.$Wj),Q(3,S.$xi),Q(4,c.$Vl),Q(5,h.$Wk),Q(6,w.$dk),Q(7,$.$Wi)],G);let q=class extends G{constructor(z,x,K,ee,_,Y,se,ue){super(z,x,K,ee,_,Y,se,ue)}};e.$4p=q,e.$4p=q=Ee([Q(0,l.$Up),Q(1,u.$Hp),Q(2,p.$Wj),Q(3,S.$xi),Q(4,c.$Vl),Q(5,h.$Wk),Q(6,w.$dk),Q(7,$.$Wi)],q);let D=class extends G{constructor(z,x,K,ee,_,Y,se){super(void 0,z,x,K,ee,_,Y,se)}};e.$5p=D,e.$5p=D=Ee([Q(0,u.$Hp),Q(1,p.$Wj),Q(2,S.$xi),Q(3,c.$Vl),Q(4,h.$Wk),Q(5,w.$dk),Q(6,$.$Wi)],D)}),define(ce[82],le([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,R,N,j,L,A,I,P,$,S){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=void 0,e.$Qv=(0,R.$qi)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends j.$Uc{static{b=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,A.$sp)(p.id)}@${p.version}`}static c(p){const w=m.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const u=await p.getInstalled(),d=[];for(const[l,c]of b.f(w)){const g=u.find(i=>(0,A.$op)(i.identifier,{id:l}))?.manifest.version;for(const i of c)g!==i&&d.push(b.b({id:l,version:i}))}for(const l of d)w.remove(l,0)}static f(p){const w=new Map,u=p.keys(0,1);for(const d of u){const l=b.c(d);if(l){let c=w.get(l.id.toLowerCase());c||w.set(l.id.toLowerCase(),c=[]),c.push(l.version)}}return w}constructor(p,w,u){super(),this.j=p,this.m=w,this.n=u,this.g=this.B(new N.$be),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=b.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Tc))(d=>this.r(d)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=b.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let u=this.h.get(w.id.toLowerCase());u||this.h.set(w.id.toLowerCase(),u=[]),u.push(w.version),this.g.fire()}return}}s(p){if((0,S.$4f)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,u=p.manifest?p.manifest.name:p.name;return(0,A.$rp)(w,u)}getExtensionState(p,w){const u=this.s(p),d=this.getExtensionStateRaw(p,w);if(d)try{return JSON.parse(d)}catch(l){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${w}): ${l}`)}}getExtensionStateRaw(p,w){const u=this.s(p),d=this.j.get(u,w?0:1);return d&&d?.length>b.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${w}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(p,w,u){const d=this.s(p);w===void 0?this.j.remove(d,u?0:1):this.j.store(d,JSON.stringify(w),u?0:1,1)}setKeysForSync(p,w){this.j.store(b.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],u=this.j.get(b.b(p),0),d=u?JSON.parse(u):void 0;return d&&w?(0,P.$Mb)([...d,...w]):d||w}addToMigrationList(p,w){if(p!==w){const u=this.t.filter(d=>!d.includes(p)&&!d.includes(w));u.push([p,w]),this.t=u}}getSourceExtensionToMigrate(p){const w=this.t.find(([,u])=>p===u);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Rv=f,e.$Rv=f=b=Ee([Q(0,L.$Up),Q(1,I.$dk),Q(2,$.$Wj)],f)}),define(ce[255],le([0,1,2,29,82,230,113,9,19]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let $=class extends R.$Uc{constructor(b,m,f,h,p,w){super(),b.cleanUp(),(0,L.$23b)(b,m,f,h,w),j.$Rv.removeOutdatedExtensionVersions(b,p)}};e.$Sdc=$,e.$Sdc=$=Ee([Q(0,A.$xq),Q(1,N.$Zo),Q(2,j.$Qv),Q(3,N.$6o),Q(4,P.$Up),Q(5,I.$Wj)],$)}),define(ce[256],le([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,R,N,j,L,A,I,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;let b=class extends S.$cac{constructor(f,h,p,w,u,d,l,c){super(f.userHome,u,h,p,w,d,l,c)}};e.$Zdc=b,e.$Zdc=b=Ee([Q(0,L.$yi),Q(1,$.$Vl),Q(2,R.$3o),Q(3,P.$Up),Q(4,I.$Pbc),Q(5,A.$L3b),Q(6,N.$Wk),Q(7,j.$dk)],b)}),define(ce[257],le([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;const g=[R.$Odc,R.$Pdc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends A.$Uc{constructor(a,y,v,C,E,k,O){super(),this.y=a,this.z=y,this.C=v,this.D=k,this.F=O,this.f=new N.$be,this.onDidTokenFailed=this.f.event,this.g=new N.$be,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$be,this.onDidChangeMode=this.h.event,this.n=R.$Mdc,this.w=!1,this.I=(M,F)=>{F?this.j.error(M):this.j.info(M)},this.j=this.B(C.createLogger((0,c.$4g)(v.logsHome,`${R.$Qdc}.log`),{id:R.$Qdc,name:R.$Rdc})),this.t=new m.$nh(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$_j)(M)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(k.onDidChangeConfiguration(M=>{g.some(F=>M.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let a;b.$j?a=this.C.appRoot:a=(0,P.$nc)((0,P.$nc)(this.C.appRoot)),this.u=(0,P.$kc)(a,"bin",`${this.z.tunnelApplicationName}${b.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(R.$Mdc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",y=!1;const v=(F,U)=>{U?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,p.localize)(0,null)))},C=this.O("status",["status"],v);this.r=C;try{if(await C,this.r!==C)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(R.TunnelStates.disconnected());return}if(y=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(R.TunnelStates.disconnected());return}finally{this.r===C&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const F=E.token;this.G(R.TunnelStates.connecting((0,p.localize)(1,null,E.accountLabel,E.providerId)));const U=(H,Z)=>{H=H.replaceAll(F,"*".repeat(4)),v(H,Z)},X=this.O("login",["user","login","--provider",E.providerId,"--access-token",F,"--log",(0,I.$_j)(this.j.getLevel())],U);this.r=X;try{if(await X,this.r!==X)return}catch(H){this.j.error(H),this.r=void 0,this.f.fire(E),this.G(R.TunnelStates.disconnected(E));return}}const k=this.Q();k?this.G(R.TunnelStates.connecting((0,p.localize)(2,null,k))):this.G(R.TunnelStates.connecting((0,p.localize)(3,null)));const O=["--accept-server-license-terms","--log",(0,I.$_j)(this.j.getLevel())];k?O.push("--name",k):O.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!y&&(M=await this.M(O)===!1),this.N(E,O,M)}async M(a){let y;try{y=await this.O("serviceInstall",["service","install",...a])}catch(v){this.j.error(v),y=1}if(y!==0){const v=(0,p.localize)(4,null);return this.j.warn(v),this.G(R.TunnelStates.connecting(v)),!1}return!0}async N(a,y,v){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let C=!1;const E=this.O("tunnel",y,(k,O)=>{O?this.j.error(k):this.j.info(k),k.includes("Connected to an existing tunnel process")&&(C=!0);const M=k.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const F={link:M[1],domain:M[2],tunnelName:M[4],isAttached:C};this.G(R.TunnelStates.connected(F,v))}else k.match(/error refreshing token/)&&(E.cancel(),this.f.fire(a),this.G(R.TunnelStates.disconnected(a)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$Mdc,this.G(R.TunnelStates.disconnected()))})}O(a,y,v=this.I){return(0,m.$dh)(C=>new Promise((E,k)=>{C.isCancellationRequested&&E(-1);let O;const M=["ignore","pipe","pipe"];if(C.onCancellationRequested(()=>{O&&(this.j.info(`${a} terminating(${O.pid})`),O.kill())}),!this.C.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${a} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),O=(0,$.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,P.$kc)(this.C.appRoot,"cli"),stdio:M});else{v(`Running tunnel CLI
`,!1);const F=this.J();v(`${a} Spawning: ${F} tunnel ${y.join(" ")}
`,!1),O=(0,$.spawn)(F,["tunnel",...y],{cwd:(0,w.homedir)(),stdio:M})}O.stdout.pipe(new l.$xW(`
`)).on("data",F=>{if(O){const U=F.toString();v(U,!1)}}),O.stderr.pipe(new l.$xW(`
`)).on("data",F=>{if(O){const U=F.toString();v(U,!0)}}),O.on("exit",F=>{O&&(v(`${a} exit(${O.pid}): + ${F} `,!1),O=void 0,E(F||0))}),O.on("error",F=>{O&&(v(`${a} error(${O.pid}): + ${F} `,!0),O=void 0,k())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Pdc)}Q(){let a=this.D.getValue(R.$Odc)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),y=this.F.getBoolean(o,-1,!1);if(a){const v=JSON.parse(a);if(v&&(0,d.$4f)(v.accountLabel)&&(0,d.$4f)(v.sessionId)&&(0,d.$4f)(v.providerId))return{active:!0,session:v,asService:y};this.j.error("Problems restoring session from storage, invalid format",v)}}catch(a){this.j.error("Problems restoring session from storage",a)}return R.$Mdc}S(a){if(a.active){const y={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(y),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$Vdc=n,e.$Vdc=n=Ee([Q(0,j.$Vl),Q(1,S.$dk),Q(2,L.$yi),Q(3,I.$Xj),Q(4,f.$Tdc),Q(5,h.$Wi),Q(6,u.$Up)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(ce[258],le([0,1,6,2,23,20,69,19,77,18]),function(ne,e,R,N,j,L,A,I,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class S extends I.$Wp{constructor(m,f,h,p){super(),this.bb=m,this.cb=f,this.db=h,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new P.$ZJb(this.db.getChannel("storage"))),f=this.B(new A.$Qp(m));return this.B(f.onDidChangeStorage(h=>this.u(-1,h))),f}gb(m){this.X.clear(),this.W=m;let f;if((0,I.$Xp)(m))f=this.U;else{const h=this.X.add(new P.$1Jb(this.db.getChannel("storage"),m));f=this.X.add(new A.$Qp(h))}return this.X.add(f.onDidChangeStorage(h=>this.u(0,h))),f}hb(m){this.$.clear(),this.Z=m?.id;let f;if(m){const h=this.$.add(new P.$2Jb(this.db.getChannel("storage"),m));f=this.$.add(new A.$Qp(h)),this.$.add(f.onDidChangeStorage(p=>this.u(1,p)))}return f}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$4g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const f=this.Y,h=f.items;f!==this.U&&await f.close(),this.Y=this.gb(m),await this.Y.init(),this.N(h,this.Y,0)}async S(m,f){const h=this.ab,p=h?.items??new Map;await h?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(p,this.ab,1)}hasScope(m){return(0,$.$vl)(m)?this.W.id===m.id:this.Z===m.id}}e.$1dc=S}),define(ce[259],le([0,1,3,2,18,91]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=void 0;class A{constructor($,S){this.a=$,this.b=S}listen($,S){const b=this.b($);switch(S){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,L.$un)({...f},b)),added:m.added.map(f=>(0,L.$un)({...f},b)),removed:m.removed.map(f=>(0,L.$un)({...f},b)),updated:m.updated.map(f=>(0,L.$un)({...f},b))}))}throw new Error(`Invalid listen ${S}`)}async call($,S,b){const m=this.b($);switch(S){case"createProfile":{const f=await this.a.createProfile(b[0],b[1],b[2]);return(0,L.$un)({...f},m)}case"updateProfile":{let f=(0,j.$xl)((0,L.$vn)(b[0],m),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,b[1]),(0,L.$un)({...f},m)}case"removeProfile":{const f=(0,j.$xl)((0,L.$vn)(b[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${S}`)}}e.$GQ=A;class I extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,S,b){super(),this.profilesHome=S,this.f=b,this.a=[],this.b=this.B(new R.$be),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(m=>(0,j.$xl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const f=m.added.map(w=>(0,j.$xl)(w,this.profilesHome.scheme)),h=m.removed.map(w=>(0,j.$xl)(w,this.profilesHome.scheme)),p=m.updated.map(w=>(0,j.$xl)(w,this.profilesHome.scheme));this.a=m.all.map(w=>(0,j.$xl)(w,this.profilesHome.scheme)),this.b.fire({added:f,removed:h,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,S,b){const m=await this.f.call("createNamedProfile",[$,S,b]);return(0,j.$xl)(m,this.profilesHome.scheme)}async createProfile($,S,b,m){const f=await this.f.call("createProfile",[$,S,b,m]);return(0,j.$xl)(f,this.profilesHome.scheme)}async createTransientProfile($){const S=await this.f.call("createTransientProfile",[$]);return(0,j.$xl)(S,this.profilesHome.scheme)}async setProfileForWorkspace($,S){await this.f.call("setProfileForWorkspace",[$,S])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,S){const b=await this.f.call("updateProfile",[$,S]);return(0,j.$xl)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$HQ=I}),define(ce[60],le([0,1,2,69,4,19,3,77,18]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Jb=e.$5Jb=e.$4Jb=void 0,e.$4Jb=(0,j.$qi)("IUserDataProfileStorageService");let $=class extends R.$Uc{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async h=>this.b(h))}async updateStorageData(f,h,p){return this.withProfileScopedStorageService(f,async w=>this.c(w,h,p))}async withProfileScopedStorageService(f,h){if(this.a.hasScope(f))return h(this.a);const p=await this.g(f),w=new b(p);try{await w.initialize();const u=await h(w);return await w.flush(),u}finally{w.dispose(),await this.f(p)}}b(f){const h=new Map,p=w=>{for(const u of f.keys(0,w))h.set(u,{value:f.get(u,0),target:w})};return p(0),p(1),h}c(f,h,p){f.storeAll(Array.from(h.entries()).map(([w,u])=>({key:w,value:u,scope:0,target:p})),!0)}async f(f){try{await f.close()}finally{(0,R.$Oc)(f)&&f.dispose()}}};e.$5Jb=$,e.$5Jb=$=Ee([Q(0,L.$Up)],$);class S extends ${constructor(f,h,p,w){super(p),this.j=f;const u=f.getChannel("profileStorageListener"),d=this.B(new R.$Vc);this.h=this.B(new A.$be({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(l=>{w.trace("profile storage changes",l),this.h.fire({targetChanges:l.targetChanges.map(c=>(0,P.$xl)(c,h.profilesHome.scheme)),valueChanges:l.valueChanges.map(c=>({...c,profile:(0,P.$xl)(c.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(f){const h=this.j.getChannel("storage");return(0,L.$Xp)(f)?new I.$ZJb(h):new I.$1Jb(h,f)}}e.$6Jb=S;class b extends L.$Wp{constructor(f){super({flushInterval:100}),this.s=this.B(new N.$Qp(f))}O(){return this.s.init()}P(f){return f===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ce[260],le([0,1,19,9,18,56,60]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;let I=class extends A.$6Jb{constructor($,S,b,m){super($,S,b,m)}};e.$Fdc=I,e.$Fdc=I=Ee([Q(0,L.$5cc),Q(1,j.$wl),Q(2,R.$Up),Q(3,N.$Wj)],I)}),define(ce[39],le([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Kb=e.$4Kb=e.$3Kb=e.$2Kb=void 0,e.$YKb=i,e.$ZKb=o,e.$1Kb=n;function i(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||o(y.syncData)))}function o(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function n(y,v){return`${(0,$.$Vf)(y)}${v.isDefault?"":` (${v.name})`}`}let s=class extends P.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(v,C,E,k,O,M,F,U,X,H,Z,W){super(),this.syncResource=v,this.collection=C,this.G=E,this.H=k,this.I=O,this.J=M,this.L=F,this.M=U,this.N=X,this.O=H,this.P=Z,this.c=null,this.m="idle",this.n=this.B(new A.$be),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new A.$be),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$oh(50)),this.w=this.B(new A.$be),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(v.syncResource,v.profile),this.h=W.extUri,this.f=this.h.joinPath(k.userDataSyncHome,...(0,c.$6zb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,c.$oAb),this.y=(0,c.$7zb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,k,this.h),this.j=(0,w.$1p)(k,E,O)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const C=await this.Y(v.remoteUserData,v.lastSyncUserData,!0,this.ob());this.S(C)}else{this.O.trace(`${this.D}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.ub(v):!0)&&this.w.fire()}}S(v){this.m!==v&&(this.m=v,this.n.fire(v))}async sync(v,C={}){await this.U(v,!0,this.ob(),C)}async preview(v,C,E={}){return this.U(v,!1,C,E)}async apply(v,C={}){try{this.F={...C};const E=await this.ab(v);return this.S(E),this.c}finally{this.F={}}}async U(v,C,E,k){try{if(this.F={...k},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let O="idle";try{const M=await this.getLastSyncUserData(),F=await this.X(v,M);return O=await this.Y(F,M,C,E),O==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(O)}}finally{this.F={}}}async replace(v){const C=this.kb(v);if(!C)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const E=await this.getLastSyncUserData(),k=await this.X(null,E),O=await this.W(k),M=await this.qb({ref:k.ref,syncData:C},E,O,this.ob(),L.CancellationToken.None),F=[];for(const U of M){const X=await this.sb(U,U.remoteResource,void 0,L.CancellationToken.None),{remoteChange:H}=await this.sb(U,U.previewResource,U.remoteContent,L.CancellationToken.None);F.push([U,{...X,remoteChange:H!==0?H:2}])}await this.tb(k,E,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(v){const C=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===C}async X(v,C){if(C){const E=v?v[this.resource]:void 0;if(C.ref===E||E===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async Y(v,C,E,k){if(v.syncData&&v.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$bAb((0,b.localize)(0,null,this.resource,this.pb,v.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(v,C,E,k)}catch(O){if(O instanceof c.$bAb)switch(O.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(v,C,E,k);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.Y(v,C,E,k)}throw O}}async Z(v,C,E,k){try{const O=await this.W(v),M=!O&&C===null&&this.gb()!==void 0,F=E&&!M;this.c||(this.c=(0,N.$dh)(X=>this.eb(v,C,O,F,k,X)));let U=await this.c;if(E&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of U.resourcePreviews)U=await this.accept(X.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:X})=>X==="conflict")?"hasConflicts":E?await this.ab(!1):"syncing"}catch(O){throw this.c=null,O}}async merge(v){return await this.$(v,async C=>{const E=await this.rb(C,L.CancellationToken.None);await this.G.writeFile(C.previewResource,j.$Ce.fromString(E?.content||""));const k=E&&!E.hasConflicts?await this.sb(C,C.previewResource,void 0,L.CancellationToken.None):void 0;return C.acceptResult=k,C.mergeState=E.hasConflicts?"conflict":k?"accepted":"preview",C.localChange=k?k.localChange:E.localChange,C.remoteChange=k?k.remoteChange:E.remoteChange,C}),this.c}async accept(v,C){return await this.$(v,async E=>{const k=await this.sb(E,v,C,L.CancellationToken.None);return E.acceptResult=k,E.mergeState="accepted",E.localChange=k.localChange,E.remoteChange=k.remoteChange,E}),this.c}async discard(v){return await this.$(v,async C=>{const E=await this.rb(C,L.CancellationToken.None);return await this.G.writeFile(C.previewResource,j.$Ce.fromString(E.content||"")),C.acceptResult=void 0,C.mergeState="preview",C.localChange=E.localChange,C.remoteChange=E.remoteChange,C}),this.c}async $(v,C){if(!this.c)return;let E=await this.c;const k=E.resourcePreviews.findIndex(({localResource:O,remoteResource:M,previewResource:F})=>this.h.isEqual(O,v)||this.h.isEqual(M,v)||this.h.isEqual(F,v));k!==-1&&(this.c=(0,N.$dh)(async O=>{const M=[...E.resourcePreviews];return M[k]=await C(M[k]),{...E,resourcePreviews:M}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(v){if(!this.c)return"idle";const C=await this.c;return C.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":C.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.tb(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(E=>[E,E.acceptResult]),v),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(v){const C=v.filter(({mergeState:E})=>E==="conflict");(0,R.$ub)(this.s,C,(E,k)=>this.h.isEqual(E.previewResource,k.previewResource))||(this.s=C,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async db(v){const C=this.c?await this.c:null;if(C)for(const E of C.resourcePreviews){if(this.h.isEqual(E.acceptedResource,v))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,v))return E.remoteContent;if(this.h.isEqual(E.localResource,v))return E.localContent;if(this.h.isEqual(E.baseResource,v))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(v){(0,h.$bl)(v)!==1&&this.O.error(v)}}async eb(v,C,E,k,O,M){const F=await this.qb(v,C,E,O,M),U=[];for(const X of F){const H=X.previewResource.with({scheme:c.$nAb,authority:"accepted"});if(X.localChange===0&&X.remoteChange===0)U.push({...X,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=k?await this.rb(X,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(X.previewResource,j.$Ce.fromString(Z?.content||""));const W=Z&&!Z.hasConflicts?await this.sb(X,X.previewResource,void 0,M):void 0;U.push({...X,acceptResult:W,mergeState:Z?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Z?Z.localChange:X.localChange,remoteChange:W?W.remoteChange:Z?Z.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:C,resourcePreviews:U,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let v=this.gb();if(v||(v=await this.jb()),!v)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const C=JSON.parse(v),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!C.version&&!!E&&C.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let k,O=1;for(;k===void 0&&O++<6;)try{const M=await this.hb();M&&(M.ref===C.ref?k=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof h.$fl&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof c.$bAb)throw M;this.O.error(M,O)}}if(k===void 0)try{const M=await this.J.resolveResourceContent(this.resource,C.ref,this.collection,this.F);k=M===null?null:this.kb(M),await this.ib({ref:C.ref,syncData:k})}catch(M){if(M instanceof c.$bAb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return k===void 0?null:{...C,syncData:k}}async fb(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),k={ref:v.ref,version:E,...C};this.I.store(this.z,JSON.stringify(k),-1,1),await this.ib(v)}gb(){return this.I.get(this.z,-1)}async hb(){const v=(await this.G.readFile(this.y)).value.toString();try{const C=v?JSON.parse(v):void 0;if(i(C))return C}catch(C){this.O.error(C)}}async ib(v){await this.G.writeFile(this.y,j.$Ce.fromString(JSON.stringify(v)))}async jb(){try{const v=await this.G.readFile(this.y),C=JSON.parse(v.value.toString());await this.G.del(this.y),C.ref&&C.content!==void 0?(this.I.store(this.z,JSON.stringify({...C,content:void 0}),-1,1),await this.ib({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,C)}catch(v){v instanceof h.$fl&&v.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(v)}return this.I.get(this.z,-1)}async getRemoteUserData(v){const{ref:C,content:E}=await this.lb(v);let k=null;return E!==null&&(k=this.kb(E)),{ref:C,syncData:k}}kb(v){try{const C=JSON.parse(v);if(o(C))return C}catch(C){this.O.error(C)}throw new c.$bAb((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(v){const C=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.J.readResource(this.resource,C,this.collection,this.F)}async mb(v,C){const E=await this.j,k={version:this.pb,machineId:E,content:v};try{return C=await this.J.writeResource(this.resource,JSON.stringify(k),C,this.collection,this.F),{ref:C,syncData:k}}catch(O){throw O instanceof c.$bAb&&O.code==="TooLarge"&&(O=new c.$bAb(O.message,O.code,this.resource)),O}}async nb(v){const C={version:this.pb,content:v};return this.L.writeResource(this.resource,JSON.stringify(C),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$1zb)}};e.$2Kb=s,e.$2Kb=s=Ee([Q(2,h.$Wk),Q(3,f.$xi),Q(4,u.$Up),Q(5,c.$9zb),Q(6,c.$0zb),Q(7,c.$gAb),Q(8,d.$Vl),Q(9,c.$lAb),Q(10,m.$Wi),Q(11,l.$ul)],s);let t=class extends s{constructor(v,C,E,k,O,M,F,U,X,H,Z,W,J){super(C,E,k,O,M,F,U,X,H,Z,W,J),this.r=v,this.B(this.G.watch(this.h.dirname(v))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(v,C,E){try{C?await this.G.writeFile(this.r,j.$Ce.fromString(v),E?void 0:C):await this.G.createFile(this.r,j.$Ce.fromString(v),{overwrite:E})}catch(k){throw k instanceof h.$fl&&k.fileOperationResult===1||k instanceof h.$fl&&k.fileOperationResult===3?new c.$bAb(k.message,"LocalPreconditionFailed"):k}}async xb(){try{await this.G.del(this.r)}catch(v){if(!(v instanceof h.$fl&&v.fileOperationResult===1))throw v}}yb(v){v.contains(this.r)&&this.Q()}};e.$3Kb=t,e.$3Kb=t=Ee([Q(3,h.$Wk),Q(4,f.$xi),Q(5,u.$Up),Q(6,c.$9zb),Q(7,c.$0zb),Q(8,c.$gAb),Q(9,d.$Vl),Q(10,c.$lAb),Q(11,m.$Wi),Q(12,l.$ul)],t);let r=class extends t{constructor(v,C,E,k,O,M,F,U,X,H,Z,W,J,V){super(v,C,E,k,O,M,F,U,X,H,Z,J,V),this.zb=W,this.Bb=void 0}Ab(v,C){const E=[],k=(0,I.$Dn)(v,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$$f)(k)&&C!==Array.isArray(k)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$4Kb=r,e.$4Kb=r=Ee([Q(3,h.$Wk),Q(4,f.$xi),Q(5,u.$Up),Q(6,c.$9zb),Q(7,c.$0zb),Q(8,c.$gAb),Q(9,d.$Vl),Q(10,c.$lAb),Q(11,c.$kAb),Q(12,m.$Wi),Q(13,l.$ul)],r);let a=class{constructor(v,C,E,k,O,M,F){this.resource=v,this.g=C,this.h=E,this.j=k,this.k=O,this.l=M,this.d=F.extUri,this.f=(0,c.$7zb)(void 0,this.resource,E,this.d)}async initialize({ref:v,content:C}){if(!C){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(C);if(E)try{await this.o({ref:v,syncData:E})}catch(k){this.j.error(k)}}m(v){try{const C=JSON.parse(v);if(o(C))return C}catch(C){this.j.error(C)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const E={ref:v.ref,version:void 0,...C};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),-1,1),await this.k.writeFile(this.f,j.$Ce.fromString(JSON.stringify(v)))}};e.$5Kb=a,e.$5Kb=a=Ee([Q(1,g.$wl),Q(2,f.$xi),Q(3,p.$Wj),Q(4,h.$Wk),Q(5,u.$Up),Q(6,l.$ul)],a)}),define(ce[115],le([0,1,6,26,7,3,43,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=e.$j$b=e.$i$b=void 0,e.$g$b=v,e.$h$b=C;async function y(M,F){const U=JSON.parse(M.content);if(M.version===1||M.version===2){const X=(await F.getInstalled(0)).filter(H=>H.isBuiltin);for(const H of U)M.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),M.version===2&&X.every(Z=>!(0,f.$op)(Z.identifier,H.identifier))&&(H.installed=!0)}return U}function v(M){return JSON.parse(M.content)}function C(M,F){return M.sort((U,X)=>!U.identifier.uuid&&X.identifier.uuid?-1:U.identifier.uuid&&!X.identifier.uuid?1:(0,P.$mf)(U.identifier.id,X.identifier.id)),F?(0,A.$On)(M,{}):JSON.stringify(M)}let E=class extends n.$2Kb{constructor(F,U,X,H,Z,W,J,V,B,ie,oe,te,ae,G,q,D,T){super({syncResource:"extensions",profile:F},U,H,X,Z,W,J,te,ae,ie,oe,q),this.Cb=V,this.Db=B,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$nAb,authority:"base"}),this.yb=this.wb.with({scheme:r.$nAb,authority:"local"}),this.zb=this.wb.with({scheme:r.$nAb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$nAb,authority:"accepted"}),this.Bb=this.Eb.createInstance(k),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:x})=>!!x)),L.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),L.Event.filter(D.onDidChange,z=>z.valueChanges.some(({profile:x,changes:K})=>this.syncResource.profile.id===x.id&&K.some(ee=>ee.key===m.$4o))),G.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,U){const X=F.syncData?await y(F.syncData,this.Cb):null,H=U?.skippedExtensions??[],Z=U?.builtinExtensions??null,W=U?.syncData?await y(U.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$f$b)(J,X,W,H,V,Z),oe={local:B,remote:ie,content:this.Hb(J,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},te=this.Ob(J,!1);return[{skippedExtensions:H,builtinExtensions:Z,baseResource:this.xb,baseContent:W?this.Ob(W,!1):te,localResource:this.yb,localContent:te,localExtensions:J,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(F){const U=F.syncData?await y(F.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,s.$f$b)(X,U,U,F.skippedExtensions||[],H,F.builtinExtensions||[]);return Z!==null}Hb(F,U,X,H){const Z=[...U,...X],W=new Set,J=V=>{W.add(V.id.toLowerCase()),V.uuid&&W.add(V.uuid)};Z.forEach(({identifier:V})=>J(V)),H.forEach(J);for(const V of F)W.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&W.has(V.identifier.uuid)||Z.push(V);return this.Ob(Z,!1)}async rb(F,U){return{...F.previewResult,hasConflicts:!1}}async sb(F,U,X,H){if(this.h.isEqual(U,this.yb))return this.Kb(F);if(this.h.isEqual(U,this.zb))return this.Lb(F);if(this.h.isEqual(U,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(F){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(U),H=(0,s.$f$b)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Z,remote:W}=H;return{content:F.localContent,local:Z,remote:W,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(F){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(U),H=F.remoteContent?JSON.parse(F.remoteContent):null;if(H!==null){const Z=(0,s.$f$b)(F.localExtensions,H,F.localExtensions,[],X,F.builtinExtensions),{local:W,remote:J}=Z;return{content:F.remoteContent,local:W,remote:J,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,U,X,H){let{skippedExtensions:Z,builtinExtensions:W,localExtensions:J}=X[0][0];const{local:V,remote:B,localChange:ie,remoteChange:oe}=X[0][1];if(ie===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),Z=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,Z,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const te=JSON.stringify(B.all);F=await this.mb(te,H?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ae=>ae.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ae=>ae.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ae=>ae.identifier.id))}.`:""}`)}U?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(J,W),await this.fb(F,{skippedExtensions:Z,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(te=>te.identifier.id))}.`:""}`))}Nb(F,U){const X=new Set,H=[];for(const Z of F)X.add(Z.identifier.id.toLowerCase()),Z.installed||H.push(Z.identifier);if(U)for(const Z of U)X.has(Z.id.toLowerCase())||H.push(Z);return H}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const U=await this.db(F);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(F,U){return C(F,U)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$i$b=E,e.$i$b=E=Ee([Q(2,S.$xi),Q(3,w.$Wk),Q(4,c.$Up),Q(5,r.$9zb),Q(6,r.$0zb),Q(7,m.$3o),Q(8,t.$NLb),Q(9,r.$lAb),Q(10,$.$Wi),Q(11,r.$gAb),Q(12,g.$Vl),Q(13,h.$Qv),Q(14,i.$ul),Q(15,a.$4Jb),Q(16,u.$pi)],E);let k=class{constructor(F,U,X,H,Z,W){this.a=F,this.b=U,this.c=X,this.d=H,this.f=Z,this.g=W}async getLocalExtensions(F){const U=await this.a.getInstalled(void 0,F.extensionsResource),X=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(F,async(Z,W)=>{const J=Z.getDisabledExtensions();return U.map(V=>{const{identifier:B,isBuiltin:ie,manifest:oe,preRelease:te,pinned:ae,isApplicationScoped:G}=V,q={identifier:B,preRelease:te,version:oe.version,pinned:!!ae};G&&!(0,p.$Om)(oe)&&(q.isApplicationScoped=G),J.some(D=>(0,f.$op)(D,B))&&(q.disabled=!0),ie||(q.installed=!0);try{const D=W.getKeysForSync({id:B.id,version:oe.version});if(D){const T=W.getExtensionState(V,!0)||{};q.state=Object.keys(T).reduce((z,x)=>(D.includes(x)&&(z[x]=T[x]),z),{})}}catch(D){this.g.info(`${(0,n.$1Kb)("extensions",F)}: Error while parsing extension state`,(0,j.$0)(D))}return q})}),ignoredExtensions:X}}async updateLocalExtensions(F,U,X,H,Z){const W=(0,n.$1Kb)("extensions",Z),J=[],V=new Map,B=[],ie=[],oe=await this.a.getInstalled(void 0,Z.extensionsResource);if((F.length||X.length)&&await this.j(Z,async(G,q)=>{await R.Promises.settled([...F,...X].map(async D=>{const T=oe.find(K=>(0,f.$op)(K.identifier,D.identifier));if(T&&T.isBuiltin){D.state&&T.manifest.version===D.version&&this.h(D.state,T,T.manifest.version,q),G.getDisabledExtensions().some(ee=>(0,f.$op)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id),await G.disableExtension(D.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id),await G.enableExtension(D.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id))),B.push(D.identifier);return}const z=D.pinned?D.version:void 0,x=(await this.c.getExtensions([{...D.identifier,version:z,preRelease:z?void 0:D.preRelease}],N.CancellationToken.None))[0];if(D.state&&(T?T.manifest.version===D.version:x)&&this.h(D.state,T||x,T?.manifest.version,q),x)try{G.getDisabledExtensions().some(ee=>(0,f.$op)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id,x.version),await G.disableExtension(x.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id,x.version)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id,x.version),await G.enableExtension(x.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id,x.version))),(!T||T.preRelease!==D.preRelease||T.pinned!==D.pinned||z&&T.manifest.version!==z)&&(await this.a.canInstall(x)?(J.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[m.$Qo]:!0,[m.$Ro]:!0}}}),V.set(x.identifier.id.toLowerCase(),D)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(D)))}catch(K){ie.push(D),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(D),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),U.length){const G=oe.filter(({identifier:q,isBuiltin:D})=>!D&&U.some(T=>(0,f.$op)(q,T)));await R.Promises.settled(G.map(async q=>{this.g.trace(`${W}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,q.identifier.id),B.push(q.identifier)}))}const te=await this.a.installGalleryExtensions(J);for(const{identifier:G,local:q,error:D,source:T}of te){const z=T;if(q)this.g.info(`${W}: Installed extension.`,G.id,z.version),B.push(G);else{const x=V.get(G.id.toLowerCase());x&&(ie.push(x),this.g.info(`${W}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),D instanceof m.$1o&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):D&&this.g.error(D)}}const ae=[];for(const G of H)B.some(q=>(0,f.$op)(q,G.identifier))||ae.push(G);for(const G of ie)ae.some(q=>(0,f.$op)(q.identifier,G.identifier))||ae.push(G);return ae}h(F,U,X,H){const Z=H.getExtensionState(U,!0)||{},W=X?H.getKeysForSync({id:U.identifier.id,version:X}):void 0;W?W.forEach(J=>{Z[J]=F[J]}):Object.keys(F).forEach(J=>Z[J]=F[J]),H.setExtensionState(U,Z,!0)}async j(F,U){return this.b.withProfileScopedStorageService(F,async X=>{const H=new I.$Tc,Z=this.f.createChild(new d.$oi([c.$Up,X])),W=H.add(Z.createInstance(b.$nJb)),J=H.add(Z.createInstance(h.$Rv));try{return await U(W,J)}finally{H.dispose()}})}};e.$j$b=k,e.$j$b=k=Ee([Q(0,m.$3o),Q(1,a.$4Jb),Q(2,m.$Zo),Q(3,t.$NLb),Q(4,u.$pi),Q(5,r.$lAb)],k);let O=class extends n.$5Kb{constructor(F,U,X,H,Z,W,J,V){super("extensions",H,Z,W,X,J,V),this.p=F,this.q=U}async t(F){return F.syncData?await y(F.syncData,this.p):null}u(F,U){const X=[],H=[],Z=[];for(const W of F){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const J=U.find(V=>(0,f.$op)(V.identifier,W.identifier));J?(X.push(J),W.disabled&&Z.push(W.identifier)):W.installed&&(H.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&Z.push(W.identifier))}return{installedExtensions:X,newExtensions:H,disabledExtensions:Z,remoteExtensions:F}}};e.$k$b=O,e.$k$b=O=Ee([Q(0,m.$3o),Q(1,t.$NLb),Q(2,w.$Wk),Q(3,o.$wl),Q(4,S.$xi),Q(5,l.$Wj),Q(6,c.$Up),Q(7,i.$ul)],O)}),define(ce[116],le([0,1,15,7,3,35,43,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Kb=e.$0Kb=e.$9Kb=e.$8Kb=void 0,e.$7Kb=t;const n="globalState.argv.",s=["locale"];function t(E,k){const O=E.storage?Object.keys(E.storage).sort():[],M={};return O.forEach(F=>M[F]=E.storage[F]),E.storage=M,k?(0,A.$On)(E,{}):JSON.stringify(E)}const r=1;let a=class extends u.$2Kb{constructor(k,O,M,F,U,X,H,Z,W,J,V,B,ie,oe){super({syncResource:"globalState",profile:k},O,F,Z,B,U,X,W,J,H,V,ie),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$nAb,authority:"base"}),this.xb=this.vb.with({scheme:c.$nAb,authority:"local"}),this.yb=this.vb.with({scheme:c.$nAb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$nAb,authority:"accepted"}),this.Ab=oe.createInstance(y),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(F.onDidFilesChange,te=>te.contains(this.H.argvResource)),j.Event.filter(M.onDidChange,te=>!!(te.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||te.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(q=>q.target===0)))))(()=>this.Q()))}async qb(k,O,M){const F=k.syncData?JSON.parse(k.syncData.content):null;O=O===null&&M?k:O;const U=O&&O.syncData?JSON.parse(O.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Jb(U),{local:Z,remote:W}=(0,l.$6Kb)(X.storage,F?F.storage:null,U?U.storage:null,H,this.O),J={content:null,local:Z,remote:W,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:W.all!==null?2:0},V=t(X,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):V,localResource:this.xb,localContent:V,localUserData:X,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:H}]}async ub(k){const O=k.syncData?JSON.parse(k.syncData.content):null;if(O===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(O),{remote:U}=(0,l.$6Kb)(M.storage,O.storage,O.storage,F,this.O);return U.all!==null}async rb(k,O){return{...k.previewResult,hasConflicts:!1}}async sb(k,O,M,F){if(this.h.isEqual(O,this.xb))return this.Gb(k);if(this.h.isEqual(O,this.yb))return this.Hb(k);if(this.h.isEqual(O,this.vb))return k.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async Gb(k){return{content:k.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(k.localUserData.storage),removed:[],updated:[],all:k.localUserData.storage},localChange:0,remoteChange:2}}async Hb(k){if(k.remoteContent!==null){const O=JSON.parse(k.remoteContent),{local:M,remote:F}=(0,l.$6Kb)(k.localUserData.storage,O.storage,null,k.storageKeys,this.O);return{content:k.remoteContent,local:M,remote:F,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:k.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(k,O,M,F){const{localUserData:U}=M[0][0],{local:X,remote:H,localChange:Z,remoteChange:W}=M[0][1];if(Z===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Z!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:H.all});k=await this.mb(J,F?null:k.ref),this.O.info(`${this.D}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}O?.ref!==k.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(k),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(k){if(this.h.isEqual(this.yb,k)||this.h.isEqual(this.wb,k)||this.h.isEqual(this.xb,k)||this.h.isEqual(this.zb,k)){const O=await this.db(k);return O&&t(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:k}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(k).length>1||k[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(k){const O=await this.Bb.readStorageData(this.syncResource.profile),M=[],F=[];for(const[H,Z]of O)Z.target===0?M.push(H):Z.target===1&&F.push(H);const U=[...M,...F],X=k?.storage?Object.keys(k.storage).filter(H=>!H.startsWith(n)&&!U.includes(H)&&O.get(H)!==void 0):[];if(!I.$o){const H=[...c.$5zb.map(Z=>(0,c.$fAb)(Z)),c.$eAb];X.push(...H),F.push(...H)}return{user:M,machine:F,unregistered:X}}};e.$8Kb=a,e.$8Kb=a=Ee([Q(2,i.$4Jb),Q(3,b.$Wk),Q(4,c.$9zb),Q(5,c.$0zb),Q(6,c.$lAb),Q(7,S.$xi),Q(8,c.$gAb),Q(9,p.$Vl),Q(10,$.$Wi),Q(11,h.$Up),Q(12,w.$ul),Q(13,o.$pi)],a);let y=class{constructor(k,O,M,F){this.a=k,this.b=O,this.c=M,this.d=F}async getLocalGlobalState(k){const O={};if(k.isDefault){const F=await this.f(),U=(0,L.$Dn)(F);for(const X of s)U[X]!==void 0&&(O[`${n}${X}`]={version:1,value:U[X]})}const M=await this.c.readStorageData(k);for(const[F,U]of M)U.value&&U.target===0&&(O[F]={version:1,value:U.value});return{storage:O}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const k=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),k.value.toString()}catch(k){this.d.debug((0,N.$0)(k))}return"{}"}async writeLocalGlobalState({added:k,removed:O,updated:M},F){const U=(0,u.$1Kb)("globalState",F),X={},H=new Map,Z=await this.c.readStorageData(F),W=(J,V)=>{for(const B of J){if(B.startsWith(n)){X[B.substring(n.length)]=V?V[B].value:void 0;continue}if(V){const ie=V[B];ie.value!==Z.get(B)?.value&&H.set(B,ie.value)}else Z.get(B)!==void 0&&H.set(B,void 0)}};if(W(Object.keys(k),k),W(Object.keys(M),M),W(O),Object.keys(X).length){this.d.trace(`${U}: Updating locale...`);const J=await this.f();let V=J;for(const B of Object.keys(X))V=(0,d.edit)(V,[B],X[B],{});J!==V&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Ce.fromString(V)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}H.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(F,H,0),this.d.info(`${U}: Updated global state`,[...H.keys()]))}};e.$9Kb=y,e.$9Kb=y=Ee([Q(0,b.$Wk),Q(1,S.$xi),Q(2,i.$4Jb),Q(3,c.$lAb)],y);let v=class extends u.$5Kb{constructor(k,O,M,F,U,X){super("globalState",M,F,U,O,k,X)}async o(k){const O=k.syncData?JSON.parse(k.syncData.content):null;if(!O){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},F={};for(const U of Object.keys(O.storage))U.startsWith(n)?M[U.substring(n.length)]=O.storage[U].value:this.l.get(U,0)===void 0&&(F[U]=O.storage[U].value);if(Object.keys(M).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(M))U=(0,d.edit)(U,[X],M[X],{});await this.k.writeFile(this.h.argvResource,R.$Ce.fromString(U))}if(Object.keys(F).length){const U=[];for(const X of Object.keys(F))U.push({key:X,value:F[X],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$0Kb=v,e.$0Kb=v=Ee([Q(0,h.$Up),Q(1,b.$Wk),Q(2,g.$wl),Q(3,S.$xi),Q(4,c.$lAb),Q(5,w.$ul)],v);let C=class{constructor(k,O,M,F,U){this.a=k,this.b=O,this.c=M,this.d=F,this.f=U}getSyncStoreType(k){return this.h(k)?.storage[c.$eAb]?.value}async sync(k){const O=(0,c.$aAb)((0,P.$Mg)());try{return await this.g(k,O)}catch(M){if(M instanceof c.$bAb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(k,O)}throw M}}async g(k,O){const M=await this.a.readResource("globalState",null,void 0,O),F=this.h(M)||{storage:{}};F.storage[c.$eAb]={value:k,version:r};const U=await(0,f.$1p)(this.c,this.d,this.b),X={version:r,machineId:U,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(X),M.ref,void 0,O)}h({content:k}){if(!k)return null;const O=JSON.parse(k);if((0,u.$ZKb)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.$$Kb=C,e.$$Kb=C=Ee([Q(1,h.$Up),Q(2,S.$xi),Q(3,b.$Wk),Q(4,m.$Wj)],C)}),define(ce[117],le([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=e.$n$b=void 0,e.$m$b=l;function l(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,I.$$f)(s.all)?null:s.all;switch(A.OS){case 2:return(0,I.$$f)(s.mac)?null:s.mac;case 3:return(0,I.$$f)(s.linux)?null:s.linux;case 1:return(0,I.$$f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends w.$4Kb{constructor(o,n,s,t,r,a,y,v,C,E,k,O,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,v,C,E,s,t,y,O,r,k,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$nAb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$nAb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$nAb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$nAb,authority:"accepted"}),this.B(j.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?l(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,y=await this.vb(),v=await this.Cb();let C=null,E=!1,k=!1,O=!1;if(r){let U=y?y.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new d.$bAb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,u.$l$b)(U,r,a,v,this.zb);X.hasChanges&&(C=X.mergeContent,O=X.hasConflicts,E=O||X.mergeContent!==U,k=O||X.mergeContent!==r)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=y.value.toString(),k=!0);const M={content:O?a:C,localChange:E?y?2:1:0,remoteChange:k?2:0,hasConflicts:O},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,u.$l$b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:y,remoteChange:v}=s[0][1];if(y===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new d.$bAb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),v!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const C=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(C,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,L.$Dn)(o.value.toString());if((0,R.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:l(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,A.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(d.$2zb)}};e.$n$b=c,e.$n$b=c=Ee([Q(2,d.$9zb),Q(3,d.$0zb),Q(4,d.$lAb),Q(5,$.$Wi),Q(6,d.$gAb),Q(7,b.$Wk),Q(8,S.$xi),Q(9,m.$Up),Q(10,d.$kAb),Q(11,f.$Vl),Q(12,h.$ul)],c);let g=class extends w.$5Kb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ce.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$Dn)(o.value.toString());return!(0,R.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return l(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$o$b=g,e.$o$b=g=Ee([Q(0,b.$Wk),Q(1,p.$wl),Q(2,S.$xi),Q(3,d.$lAb),Q(4,m.$Up),Q(5,h.$ul)],g)}),define(ce[118],le([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=e.$q$b=void 0,e.$p$b=d;function u(g){return g&&g.settings&&typeof g.settings=="string"&&Object.keys(g).length===1}function d(g){const i=JSON.parse(g);return u(i)?i:{settings:g}}let l=class extends h.$4Kb{constructor(i,o,n,s,t,r,a,y,v,C,E,k,O,M){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,E,k,y,v,C,M),this.Eb=O,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$nAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$nAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$nAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$nAb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new A.$so(w.$1zb,this.O);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(w.$1zb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,y=await this.Pb();let v=null,C=!1,E=!1,k=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,p.$KJb)(U,r.settings,a?a.settings:null,y,[],t);v=X.localContent||X.remoteContent,C=X.localContent!==null,E=X.remoteContent!==null,k=X.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Qb(v),E=!0);const O=s?s.value.toString():null,M=a?.settings??null,F={content:k?M:v,localChange:C?2:0,remoteChange:E?2:0,hasConflicts:k};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:O,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$KJb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,p.$JJb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,p.$JJb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,p.$JJb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,p.$JJb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:y}=n[0][1];if(a===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),y!==0){const v=await this.Cb(),C=this.Lb(i),E=await this.Pb(r);r=(0,p.$JJb)(r,C?C.settings:"{}",E,v),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,p.$LJb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,p.$JJb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return d(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$HJb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new w.$bAb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$q$b=l,e.$q$b=l=Ee([Q(2,$.$Wk),Q(3,I.$xi),Q(4,S.$Up),Q(5,w.$9zb),Q(6,w.$0zb),Q(7,w.$lAb),Q(8,w.$kAb),Q(9,L.$Wi),Q(10,w.$gAb),Q(11,b.$Vl),Q(12,P.$3o),Q(13,m.$ul)],l);let c=class extends h.$5Kb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$Ce.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$LJb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return d(i)}catch(o){this.j.error(o)}return null}};e.$r$b=c,e.$r$b=c=Ee([Q(0,$.$Wk),Q(1,f.$wl),Q(2,I.$xi),Q(3,w.$lAb),Q(4,S.$Up),Q(5,m.$ul)],c)}),define(ce[119],le([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=void 0,e.$u$b=p;function p(d){return JSON.parse(d.content)}let w=class extends m.$2Kb{constructor(l,c,g,i,o,n,s,t,r,a,y,v){super({syncResource:"snippets",profile:l},c,i,g,o,n,s,a,y,t,r,v),this.pb=1,this.vb=l.snippetsHome,this.B(this.G.watch(g.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,C=>C.affects(this.vb))(()=>this.Q()))}async qb(l,c,g){const i=await this.Hb(),o=this.Gb(i),n=l.syncData?this.Fb(l.syncData):null;c=c===null&&g?l:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,f.$s$b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(l){const c=l.syncData?this.Fb(l.syncData):null;if(c===null)return!0;const g=await this.Hb(),i=this.Gb(g),o=(0,f.$s$b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(l,c){return l.previewResult}async sb(l,c,g,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$nAb,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:h.$nAb,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return g===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:g,localChange:g===null?l.fileContent!==null?3:0:2,remoteChange:g===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(l,c,g,i){const o=g.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(l=await this.Eb(o,l,i)),c?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(l,c,g,i){const o=new Map;for(const n of Object.keys(l.local.added)){const s={content:l.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of Object.keys(l.local.updated)){const s={content:l.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of l.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of Object.keys(l.remote.added)){const s={content:l.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of Object.keys(l.remote.updated)){const s={content:l.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of l.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of l.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:g[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"remote"}),remoteContent:g[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:h.$nAb,authority:"accepted"})})}return[...o.values()]}async resolveContent(l){return this.h.isEqualOrParent(l,this.g.with({scheme:h.$nAb,authority:"remote"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$nAb,authority:"local"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$nAb,authority:"base"}))||this.h.isEqualOrParent(l,this.g.with({scheme:h.$nAb,authority:"accepted"}))?this.db(l):null}async hasLocalData(){try{const l=await this.Hb();if(Object.keys(l).length)return!0}catch{}return!1}async Cb(l){const c={};for(const g of l)g.fileContent&&(c[this.h.basename(g.localResource)]=g.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(l,c){for(const{fileContent:g,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of l)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Ce.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Ce.fromString(i.content),c?void 0:g),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(l,c,g){const i=c.syncData?this.Fb(c.syncData):{},o=(0,j.$Wn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of l)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,f.$t$b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),g?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(l){return p(l)}Gb(l){const c={};for(const g of Object.keys(l))c[g]=l[g].value.toString();return c}async Hb(){const l={};let c;try{c=await this.G.resolve(this.vb)}catch(g){if(g instanceof I.$fl&&g.fileOperationResult===1)return l;throw g}for(const g of c.children||[]){const i=g.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);l[n]=s}}return l}};e.$v$b=w,e.$v$b=w=Ee([Q(2,A.$xi),Q(3,I.$Wk),Q(4,P.$Up),Q(5,h.$9zb),Q(6,h.$0zb),Q(7,h.$lAb),Q(8,L.$Wi),Q(9,h.$gAb),Q(10,$.$Vl),Q(11,S.$ul)],w);let u=class extends m.$5Kb{constructor(l,c,g,i,o,n){super("snippets",c,g,i,l,o,n)}async o(l){const c=l.syncData?JSON.parse(l.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,R.$Ce.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(l)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};e.$w$b=u,e.$w$b=u=Ee([Q(0,I.$Wk),Q(1,b.$wl),Q(2,A.$xi),Q(3,h.$lAb),Q(4,P.$Up),Q(5,S.$ul)],u)}),define(ce[120],le([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=e.$y$b=void 0,e.$x$b=m;function m(w,u){try{return JSON.parse(w).tasks??null}catch(d){return u.error(d),null}}let f=class extends S.$3Kb{constructor(u,d,l,c,g,i,o,n,s,t,r,a){super(u.tasksResource,{syncResource:"tasks",profile:u},d,n,s,t,l,c,o,r,g,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:b.$nAb,authority:"base"}),this.Cb=this.Ab.with({scheme:b.$nAb,authority:"local"}),this.Db=this.Ab.with({scheme:b.$nAb,authority:"remote"}),this.Eb=this.Ab.with({scheme:b.$nAb,authority:"accepted"})}async qb(u,d,l,c){const g=u.syncData?m(u.syncData.content,this.O):null;d=d===null&&l?u:d;const i=d?.syncData?m(d.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(u.syncData){const v=o?o.value.toString():null;if(!i||i!==v||i!==g){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const C=p(v,g,i);n=C.content,r=C.hasConflicts,s=C.hasLocalChanged,t=C.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},y=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:y,localChange:a.localChange,remoteResource:this.Db,remoteContent:g,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(u){const d=u?.syncData?m(u.syncData.content,this.O):null;if(d===null)return!0;const l=await this.vb(),c=l?l.value.toString():null,g=p(c,d,d);return g.hasLocalChanged||g.hasRemoteChanged}async rb(u,d){return u.previewResult}async sb(u,d,l,c){if(this.h.isEqual(d,this.Cb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.Db))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.Ab))return l===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(u,d,l,c){const{fileContent:g}=l[0][0],{content:i,localChange:o,remoteChange:n}=l[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),g&&await this.nb(JSON.stringify(this.Kb(g.value.toString()))),i?await this.wb(i,g,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));u=await this.mb(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(u){return this.h.isEqual(this.Db,u)||this.h.isEqual(this.Bb,u)||this.h.isEqual(this.Cb,u)||this.h.isEqual(this.Eb,u)?this.db(u):null}Kb(u){return u?{tasks:u}:{}}};e.$y$b=f,e.$y$b=f=Ee([Q(2,b.$9zb),Q(3,b.$0zb),Q(4,b.$lAb),Q(5,N.$Wi),Q(6,b.$gAb),Q(7,L.$Wk),Q(8,j.$xi),Q(9,A.$Up),Q(10,I.$Vl),Q(11,P.$ul)],f);let h=class extends S.$5Kb{constructor(u,d,l,c,g,i){super("tasks",d,l,c,u,g,i),this.c=this.g.defaultProfile.tasksResource}async o(u){const d=u.syncData?m(u.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Ce.fromString(d)),await this.n(u)}async p(){return this.k.exists(this.c)}};e.$z$b=h,e.$z$b=h=Ee([Q(0,L.$Wk),Q(1,$.$wl),Q(2,j.$xi),Q(3,b.$lAb),Q(4,A.$Up),Q(5,P.$ul)],h);function p(w,u,d){if(w===null&&u===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=d!==w,c=d!==u;return!l&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!c?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!l?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[121],le([0,1,43,21,16,12,19,22,28,18,39,244,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0,e.$hac=h,e.$iac=p;let f=class extends S.$2Kb{constructor(u,d,l,c,g,i,o,n,s,t,r,a,y){super({syncResource:"profiles",profile:u},d,c,g,i,o,n,r,a,s,t,y),this.vb=l,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$nAb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$nAb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$nAb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$nAb,authority:"accepted"}),this.B(l.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),l=await this.X(u,d);return l?.syncData?p(l.syncData):null}async qb(u,d,l){if(!this.vb.isEnabled())throw new m.$bAb("Cannot sync profiles because they are disabled","LocalError");const c=u.syncData?p(u.syncData):null,g=d?.syncData?p(d.syncData):null,i=this.Db(),{local:o,remote:n}=(0,b.$fac)(i,c,g,[]),s={local:o,remote:n,content:g?this.Eb(g):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=h(i,!1);return[{baseResource:this.baseResource,baseContent:g?this.Eb(g):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(u){const d=u?.syncData?p(u.syncData):null,l=this.Db(),{remote:c}=(0,b.$fac)(l,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(u,d){return{...u.previewResult,hasConflicts:!1}}async sb(u,d,l,c){if(this.h.isEqual(d,this.localResource))return this.Ab(u);if(this.h.isEqual(d,this.remoteResource))return this.Bb(u);if(this.h.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(u){const d=this.Db(),l=(0,b.$fac)(d,null,null,[]),{local:c,remote:g}=l;return{content:u.localContent,local:c,remote:g,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:g!==null?2:0}}async Bb(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,l=[],c=[];for(const g of this.Db()){const i=d?.find(o=>o.id===g.id);i&&(l.push({id:g.id,name:g.name,collection:i.collection}),c.push(g))}if(d!==null){const g=(0,b.$fac)(c,d,l,[]),{local:i,remote:o}=g;return{content:u.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(u,d,l,c){const{local:g,remote:i,localChange:o,remoteChange:n}=l[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=l[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$bAb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0&&(await this.nb(h(this.Db(),!1)),await Promise.all(g.removed.map(async t=>{this.O.trace(`${this.D}: Removing '${t.name}' profile...`),await this.vb.removeProfile(t),this.O.info(`${this.D}: Removed profile '${t.name}'.`)})),await Promise.all(g.added.map(async t=>{this.O.trace(`${this.D}: Creating '${t.name}' profile...`),await this.vb.createProfile(t.id,t.name,{shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${t.name}'.`)})),await Promise.all(g.updated.map(async t=>{const r=this.vb.profiles.find(a=>a.id===t.id);r?(this.O.trace(`${this.D}: Updating '${t.name}' profile...`),await this.vb.updateProfile(r,{name:t.name,shortName:t.shortName,icon:t.icon,useDefaultFlags:t.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${t.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${t.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const y=await this.J.createCollection(this.F);t.push(y),s.push({id:a.id,name:a.name,collection:y,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:y})=>a.id===y),1);for(const a of i?.updated||[]){const y=s.find(({id:v})=>a.id===v);y&&s.splice(s.indexOf(y),1,{...y,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(s,c?null:u.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of t)await this.J.deleteCollection(y,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.mb(this.Eb(u),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const d=await this.db(u);return d&&(0,R.$On)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Eb(u){return JSON.stringify([...u].sort((d,l)=>d.name.localeCompare(l.name)))}};e.$gac=f,e.$gac=f=Ee([Q(2,$.$wl),Q(3,L.$Wk),Q(4,j.$xi),Q(5,A.$Up),Q(6,m.$9zb),Q(7,m.$0zb),Q(8,m.$lAb),Q(9,N.$Wi),Q(10,m.$gAb),Q(11,I.$Vl),Q(12,P.$ul)],f);function h(w,u){const d=[...w].sort((l,c)=>l.name.localeCompare(c.name)).map(l=>({id:l.id,name:l.name}));return u?(0,R.$On)(d,{}):JSON.stringify(d)}function p(w){return JSON.parse(w.content)}}),define(ce[261],le([0,1,3,2,5,16,19,22,25]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=void 0;const $="sync.enable";let S=class extends N.$Uc{constructor(m,f,h,p){super(),this.c=m,this.f=f,this.g=h,this.h=p,this.a=new R.$be,this.onDidChangeEnablement=this.a.event,this.b=new R.$be,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean($,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2($,{enabled:m}),this.c.store($,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,P.$fAb)(m),-1,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const h=(0,P.$fAb)(m);this.j(h,f)}}getResourceSyncStateVersion(m){}j(m,f){this.c.store(m,f,-1,j.$o?0:1)}m(m){if($===m.key){this.a.fire(this.isEnabled());return}const f=P.$5zb.filter(h=>(0,P.$fAb)(h)===m.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$6_b=S,e.$6_b=S=Ee([Q(0,A.$Up),Q(1,I.$Vl),Q(2,L.$xi),Q(3,P.$8zb)],S)}),define(ce[262],le([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=void 0;let m=class extends L.$Uc{constructor(h,p,w,u,d){super(),this.a=h,this.b=p,this.c=w,this.f=u,this.g=d,this.h()}async h(){for(const p of this.g.profiles)for(const w of b.$5zb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(u){this.f.error(u)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,$.$bl)(p)!==1&&this.f.error(p);return}if(h.children){for(const p of h.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(h,p,w){const u=this.j(h,p,w);try{const d=await this.b.resolve(u);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(d){if((0,$.$bl)(d)!==1)throw d}return[]}async resolveResourceContent(h,p,w,u){const d=this.j(h,w,u),l=(0,A.$4g)(d,p);try{return(await this.b.readFile(l)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(h,p,w,u,d){const l=this.j(h,u,d),c=(0,A.$4g)(l,`${(0,j.$Xm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,N.$Ce.fromString(p))}catch(g){this.f.error(g)}}j(h,p,w=this.a.userDataSyncHome){return(0,A.$4g)(w,...p?[p,h]:[h])}async m(h){try{try{if(!await this.b.exists(h))return}catch{return}const p=await this.b.resolve(h);if(p.children){const w=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=w.filter(c=>Date.now()-this.n(c)>u);const l=w.length-d.length;l<10&&(d=d.slice(10-l)),await R.Promises.settled(d.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(p){this.f.error(p)}}n(h){return new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};e.$eac=m,e.$eac=m=Ee([Q(0,P.$xi),Q(1,$.$Wk),Q(2,I.$Wi),Q(3,b.$lAb),Q(4,S.$wl)],m)}),define(ce[83],le([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xzb=e.$Vzb=void 0,e.$Wzb=g,e.$Vzb=(0,$.$qi)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",u="Chrome",d="Edge",l="Firefox",c="Android";function g(n){switch(n){case w:case u:case d:case l:case c:case(0,j.$h)(0):return!0}return!1}function i(){return j.$G?w:j.$E?u:j.$H?d:j.$F?l:j.$I?c:(0,j.$h)(j.$o?0:j.$u)}let o=class extends N.$Uc{static{h=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,y,v){super(),this.h=r,this.j=a,this.m=y,this.n=v,this.c=this.B(new R.$be),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.$1p)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:y})=>y!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),y=a.machines.find(({id:v})=>v===s);if(y){y.name=t,await this.t(a);const v=await this.f;s===v&&this.h.store(p,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const y=t.machines.find(v=>v.id===r);y&&(y.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$8e)(r)}\\s#(\\d+)`);let y=0;for(const v of s){const C=a.exec(v.name),E=C?parseInt(C[1]):0;y=E>y?E:y}return`${r} #${y+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==h.a)throw new Error((0,A.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(h.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[h.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(h.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:h.a,machines:[]}}};e.$Xzb=o,e.$Xzb=o=h=Ee([Q(0,I.$xi),Q(1,P.$Wk),Q(2,m.$Up),Q(3,f.$9zb),Q(4,f.$lAb),Q(5,S.$dk)],o)}),define(ce[263],le([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;const d="sync.disableMachineEventually",l="sync.sessionId",c="sync.storeUrl",g="sync.productQuality";let i=class extends I.$Uc{get n(){const s=this.H.get(c,-1);return s?S.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(g,-1)}set s(s){s?this.H.store(g,s,-1,1):this.H.remove(g,-1)}constructor(s,t,r,a,y,v,C,E,k,O){super(),this.u=t,this.w=r,this.y=a,this.z=y,this.C=v,this.D=C,this.F=E,this.G=k,this.H=O,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new A.$be),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$oh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,$.$Wg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(C.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(A.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Xm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(l,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=p.$bAb.toUserDataSyncError(s);t instanceof p.$dAb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?P.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(d,!0,-1,1),await(0,R.$rh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,-1,!1)}R(){this.H.remove(d,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$kac=i,e.$kac=i=Ee([Q(0,m.$dk),Q(1,p.$8zb),Q(2,p.$9zb),Q(3,p.$gAb),Q(4,p.$hAb),Q(5,p.$lAb),Q(6,w.$pJb),Q(7,h.$Vl),Q(8,u.$Vzb),Q(9,f.$Up)],i);class o extends I.$Uc{static{this.a="Interval"}constructor(s,t,r,a,y,v,C,E,k){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=y,this.w=v,this.y=C,this.z=E,this.C=k,this.b=this.B(new I.$Vc),this.c=this.B(new A.$be),this.onDidStartSync=this.c.event,this.f=this.B(new A.$be),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,R.$sh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,R.$dh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,L.$4)(y))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,$.$Wg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,$.$Wg)(t.defaultUrl,s.defaultUrl)||!(0,$.$Wg)(t.insidersUrl,s.insidersUrl)||!(0,$.$Wg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(y){if(this.y.error(y),a=y,p.$bAb.toUserDataSyncError(y).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(v){this.y.error(v),a=v}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$dAb((0,b.localize)(0,null),"DefaultServiceChanged"):new p.$dAb((0,b.localize)(1,null),"ServiceChanged"):new p.$dAb((0,b.localize)(2,null),"TurnedOff");const r=this.C.get(l,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$dAb((0,b.localize)(3,null),"DefaultServiceChanged"):new p.$dAb((0,b.localize)(4,null),"ServiceChanged"):new p.$dAb((0,b.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const y=a.find(C=>C.isCurrent);if(y?.disabled)throw new p.$dAb((0,b.localize)(6,null),"TurnedOff");const v=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-v}),this.g===null)try{this.g=await this.s.manifest(null)}catch(C){throw new p.$dAb((0,j.$bj)(C),C instanceof p.$bAb?C.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(l,this.g.session,-1,1),!t.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ce[264],le([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,43,27]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,y,v,C,E,k,O,M){this.e=t,this.f=r,this.g=a,this.h=v,this.i=C,this.j=E,this.k=k,this.l=O,this.n=M,this.d=y.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$iac)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const y=this.L(a,"profiles");return(0,c.$iac)(y)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(v=>({...v,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:y,ref:v})=>({created:y,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:v,ref:C})=>({created:v,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:C,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(y=>y.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(y=>y.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,A.$1p)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,y,v){if(t){const{content:C}=await this.M(r,y,a);return C}return this.f.resolveResourceContent(r,y,a,v)}q(t,r,a){const y=this.L(r,t);switch(t){case"settings":return this.t(y,a);case"keybindings":return this.v(y,a);case"tasks":return this.x(y,a);case"snippets":return this.z(y,a);case"globalState":return this.E(y,a);case"extensions":return this.B(y,a);case"profiles":return this.H(y,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(y=>y.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),y=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}t(t,r){switch(r){case"settings.json":return(0,f.$p$b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),y=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}v(t,r){switch(r){case"keybindings.json":return(0,h.$m$b)(t.content,!!this.l.getValue($.$2zb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),y=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}x(t,r){switch(r){case"tasks.json":return(0,w.$x$b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const y=this.L(a,"snippets");if(y){const v=(0,m.$u$b)(y),C=[];for(const E of Object.keys(v)){const k=this.d.joinPath(t,E),O=r?this.d.joinPath(r.snippetsHome,E):this.d.joinPath(t,o.a);C.push({resource:k,comparableResource:O})}return C}}return[]}z(t,r){return(0,m.$u$b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),y=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}B(t,r){switch(r){case"extensions.json":return(0,u.$h$b)((0,u.$g$b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(u.$j$b).getLocalExtensions(t);return(0,u.$h$b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),y=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:y}]}E(t,r){switch(r){case"globalState.json":return(0,d.$7Kb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(d.$9Kb).getLocalGlobalState(t);return(0,d.$7Kb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),y=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:y}]}H(t,r){switch(r){case"profiles.json":return(0,g.$On)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$hac)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$_e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(R.URI.from({scheme:$.$nAb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==$.$nAb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let y,v;const C=[];let E,k,O,M,F;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?y=U.substring(7):U.startsWith("authority:")?v=U.substring(10):U.startsWith("syncResource:")?E=U.substring(13):U.startsWith("profile:")?k=U.substring(8):U.startsWith("collection:")?O=U.substring(11):U.startsWith("ref:")?M=U.substring(4):E?F=U:C.push(U)}return{remote:a,syncResource:E,profile:k,collection:O,ref:M,node:F,location:y&&v!==void 0?this.d.joinPath(R.URI.from({scheme:y,authority:v,query:t.query,fragment:t.fragment,path:"/"}),...C):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,b.$ZKb)(a))return a}catch(a){this.g.error(a)}throw new $.$bAb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const y=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:y}}};e.$Sac=n,e.$Sac=n=o=Ee([Q(0,$.$9zb),Q(1,$.$0zb),Q(2,$.$lAb),Q(3,P.$ul),Q(4,j.$xi),Q(5,I.$Up),Q(6,L.$Wk),Q(7,S.$wl),Q(8,p.$Wi),Q(9,l.$pi)],n)}),define(ce[265],le([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;const t="sync.lastSyncTime";let r=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,k,O,M,F,U,X,H,Z,W,J){super(),this.C=E,this.D=k,this.F=O,this.G=M,this.H=F,this.I=U,this.J=X,this.L=H,this.M=Z,this.N=W,this.O=J,this.f="uninitialized",this.g=this.B(new A.$be),this.onDidChangeStatus=this.g.event,this.h=this.B(new A.$be),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new A.$be),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new A.$be),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new A.$be),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new A.$be),this.onDidResetLocal=this.w.event,this.y=this.B(new A.$be),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=O.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,I.$Sc)(()=>this.bb()))}async createSyncTask(E,k){this.cb(),this.H.info("Sync started.");const O=new Date().getTime(),M=(0,S.$Mg)();try{const H=(0,s.$aAb)(M);k&&(H["Cache-Control"]="no-cache"),E=await this.D.manifest(E,H)}catch(H){const Z=s.$bAb.toUserDataSyncError(H);throw v(Z,M,this.F,this.I),Z}const F=!1,U=this;let X;return{manifest:E,async run(){if(F)throw new Error("Can run a task only once");X=(0,N.$dh)(H=>U.P(E,!1,M,H)),await X.finally(()=>X=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-O}ms`),U.$()},stop(){return X?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$bAb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const E=new Date().getTime(),k=(0,S.$Mg)(),O=(0,s.$aAb)(k);let M;try{M=await this.D.manifest(null,O)}catch(X){const H=s.$bAb.toUserDataSyncError(X);throw v(H,k,this.F,this.I),H}await this.resetLocal();const F=this,U=new j.$me;return{id:k,async merge(){return F.P(M,!0,k,U.token)},async apply(){try{try{await F.R(M,k,U.token)}catch(X){if(s.$bAb.toUserDataSyncError(X).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(M,k,U.token);else throw X}}catch(X){throw F.H.error(X),X}F.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),F.$()},async stop(){U.cancel(),await F.U(),await F.resetLocal()}}}async P(E,k,O,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,E,k,O,M));const U=F.enabled.find(X=>X.resource==="profiles");if(U){const X=await U.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(X,E,k,O,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(E,k,O,M,F){for(const U of E){if(F.isCancellationRequested)return;const X=this.M.profiles.find(Z=>Z.id===U.id);if(!X){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const H=this.getOrCreateActiveProfileSynchronizer(X,U);this.n.push(...await this.S(H,k,O,M,F))}for(const[U,X]of this.z.entries())this.M.profiles.some(H=>H.id===X[0].profile.id)||(X[1].dispose(),this.z.delete(U))}async R(E,k,O){const M=this.ab();for(const Z of M){if(O.isCancellationRequested)return;await Z.apply(k,O)}const F=M.find(Z=>Z.profile.isDefault);if(!F)return;const U=F.enabled.find(Z=>Z.resource==="profiles");if(!U)return;const H=(await U.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(Z=>M.every(W=>W.profile.id!==Z.id));H.length&&await this.Q(H,E,!1,k,O)}async S(E,k,O,M,F){return(await E.sync(k,O,M,F)).map(([X,H])=>({profile:E.profile,syncResource:X,error:H}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(E=>E.stop()))}async resolveContent(E){const k=await this.N.resolveContent(E);if(k)return k;for(const O of this.ab())for(const M of O.enabled){const F=await M.resolveContent(E);if(F)return F}return null}async replace(E){this.cb();const k=this.N.resolveUserDataSyncResource(E);if(!k)return;const O=await this.resolveContent(E.uri);O&&await this.W(k.profile,async M=>{if(k.syncResource===M.resource)return await M.replace(O),!0})}async accept(E,k,O,M){this.cb(),await this.W(E.profile,async F=>{if(E.syncResource===F.resource)return await F.accept(k,O),M&&await F.apply((0,$.$0f)(M)?!1:M.force,(0,s.$aAb)((0,S.$Mg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[E]of this.z.values())try{await E.resetLocal()}catch(k){this.H.error(k)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),k=E.map(U=>U.collection),O=await this.D.getAllCollections(),M=O.filter(U=>!k.includes(U));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const F=E.filter(U=>O.includes(U.collection));if(F.length!==E.length){const U=this.G.createInstance(n.$gac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(E){this.cb();const k=await this.D.getActivityData();await this.C.writeFile(E,k)}async extractActivityData(E,k){const O=(await this.C.readFile(E)).value.toString(),M=JSON.parse(O);if(M.resources)for(const F in M.resources)for(const U of M.resources[F])await this.O.writeResource(F,U.content,new Date(U.created*1e3),void 0,k);if(M.collections)for(const F in M.collections)for(const U in M.collections[F].resources)for(const X of M.collections[F].resources?.[U]??[])await this.O.writeResource(U,X.content,new Date(X.created*1e3),F,k)}async W(E,k){const O=new I.$Tc;try{const M=this.z.get(E.id);if(M){const Z=await this.X(M[0],k,O);return(0,$.$$f)(Z)?null:Z}if(E.isDefault){const Z=O.add(this.G.createInstance(a,E,void 0)),W=await this.X(Z,k,O);return(0,$.$$f)(W)?null:W}if(this.M.isEnabled())return null;const F=O.add(this.G.createInstance(n.$gac,E,void 0)),U=await this.D.manifest(null),H=(await F.getRemoteSyncedProfiles(U?.latest??null)||[]).find(Z=>Z.id===E.id);if(H){const Z=O.add(this.G.createInstance(a,E,H.collection)),W=await this.X(Z,k,O);return(0,$.$$f)(W)?null:W}return null}finally{O.dispose()}}async X(E,k,O){const M=[...E.enabled,...E.disabled.reduce((F,U)=>(U!=="workspaceState"&&F.push(O.add(E.createSynchronizer(U))),F),[])];for(const F of M){const U=await k(F);if(!(0,$.$$f)(U))return U}}Y(E){const k=this.f;this.f!==E&&(this.f=E,this.g.fire(E),k==="hasConflicts"&&this.$())}Z(){const E=this.ab().map(k=>k.conflicts).flat();(0,R.$ub)(this.j,E,(k,O)=>k.profile.id===O.profile.id&&k.syncResource===O.syncResource&&(0,R.$ub)(k.conflicts,O.conflicts,(M,F)=>(0,P.$Wg)(M.previewResource,F.previewResource)))||(this.j=E,this.m.fire(E))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,k){let O=this.z.get(E.id);if(O&&O[0].collection!==k?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.z.delete(E.id)),!O){const M=new I.$Tc,F=M.add(this.G.createInstance(a,E,k?.collection));M.add(F.onDidChangeStatus(U=>this.Y(U))),M.add(F.onDidChangeConflicts(U=>this.Z())),M.add(F.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(E.id,O=[F,M])}return O[0]}ab(){const E=[];for(const[k]of this.z.values())E.push(k);return E}bb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$jac=r,e.$jac=r=Ee([Q(0,f.$Wk),Q(1,s.$9zb),Q(2,s.$8zb),Q(3,h.$pi),Q(4,s.$lAb),Q(5,w.$Vl),Q(6,p.$Up),Q(7,s.$gAb),Q(8,u.$wl),Q(9,s.$iAb),Q(10,s.$0zb)],r);let a=class extends I.$Uc{get enabled(){return this.f.sort((E,k)=>E[1]-k[1]).map(([E])=>E)}get disabled(){return s.$5zb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,k,O,M,F,U,X,H,Z,W){super(),this.profile=E,this.collection=k,this.r=O,this.t=M,this.u=F,this.w=U,this.y=X,this.z=H,this.C=Z,this.D=W,this.f=[],this.g="idle",this.h=this.B(new A.$be),this.onDidChangeStatus=this.h.event,this.j=this.B(new A.$be),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new A.$be),this.onDidChangeConflicts=this.n.event,this.B(O.onDidChangeResourceEnablement(([J,V])=>this.F(J,V))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$5zb)O.isResourceEnabled(J)&&this.G(J)}F(E,k){k?this.G(E):this.H(E)}G(E){if(this.f.some(([F])=>F.resource===E))return;if(E==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||E==="workspaceState")return;if(E!=="profiles"&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const k=new I.$Tc,O=k.add(this.createSynchronizer(E));k.add(O.onDidChangeStatus(()=>this.L())),k.add(O.onDidChangeConflicts(()=>this.M())),k.add(O.onDidChangeLocal(()=>this.j.fire(E)));const M=this.N(E);this.f.push([O,M,k])}H(E){const k=this.f.findIndex(([O])=>O.resource===E);if(k!==-1){const[[O,,M]]=this.f.splice(k,1);M.dispose(),this.L(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(E){switch(E){case"settings":return this.t.createInstance(g.$q$b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$n$b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$v$b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$y$b,this.profile,this.collection);case"globalState":return this.t.createInstance(l.$8Kb,this.profile,this.collection);case"extensions":return this.t.createInstance(d.$i$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$gac,this.profile,this.collection)}}async sync(E,k,O,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const U=[],X=(0,s.$aAb)(O),H=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,Z=k?await this.I(H):{};for(const W of F){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(k){const J=await W.preview(H,Z,X);if(J)for(const V of J.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await W.merge(V.previewResource)}else await W.sync(H,X)}catch(J){const V=s.$bAb.toUserDataSyncError(J);if(v(V,O,this.w,this.y),y(J))throw V;this.z.error(J),this.z.error(`${W.resource}: ${(0,L.$bj)(J)}`),U.push([W.resource,V])}}return U}finally{this.L()}}async apply(E,k){const O=(0,s.$aAb)(E);for(const M of this.enabled){if(k.isCancellationRequested)return;try{await M.apply(!1,O)}catch(F){const U=s.$bAb.toUserDataSyncError(F);if(v(U,E,this.w,this.y),y(F))throw U;this.z.error(F),this.z.error(`${M.resource}: ${(0,L.$bj)(F)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(k){this.z.error(k)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(k){this.z.error(`${E.resource}: ${(0,L.$bj)(k)}`),this.z.error(k)}}async I(E){if(!this.profile.isDefault)return{};const k=this.D.getValue(s.$1zb),O=this.enabled.find(M=>M instanceof g.$q$b);if(O){const M=await O.getRemoteUserDataSyncConfiguration(E);return{...k,...M}}return k}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const E=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,R.$ub)(this.m,E,(k,O)=>k.syncResource===O.syncResource&&(0,R.$ub)(k.conflicts,O.conflicts,(M,F)=>(0,P.$Wg)(M.previewResource,F.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([Q(2,s.$gAb),Q(3,h.$pi),Q(4,m.$Zo),Q(5,s.$8zb),Q(6,w.$Vl),Q(7,s.$lAb),Q(8,u.$wl),Q(9,b.$Wi)],a);function y(C){if(C instanceof s.$bAb)switch(C.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function v(C,E,k,O){O.publicLog2("sync/error",{code:C.code,serverCode:C instanceof s.$cAb?String(C.serverCode):void 0,url:C instanceof s.$cAb?C.url:void 0,resource:C.resource,executionId:E,service:k.userDataSyncStore.url.toString()})}}),define(ce[266],le([0,1,3,2,8,18,25]),function(ne,e,R,N,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=void 0;function I(m,f){return{...m,profile:(0,L.$xl)(m.profile,f.profilesHome.scheme)}}function P(m){return{created:m.created,uri:j.URI.revive(m.uri)}}class ${constructor(f,h,p){this.c=f,this.d=h,this.f=p,this.a=new Map,this.b=new R.$be}listen(f,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${h}`)}async call(f,h,p){try{return await this.g(f,h,p)}catch(w){throw this.f.error(w),w}}async g(f,h,p){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),j.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(P(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(p[0]),j.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const w=h.substring(11),u=p[0],d=this.h(u);switch(p=p.slice(1),w){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const h=this.a.get(this.j(f));if(!h)throw new Error(`Manual sync taks not found: ${f}`);return h}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$Ddc=$;let S=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,h){super(),this.n=h,this.b="uninitialized",this.c=this.B(new R.$be),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$be),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$be),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$be),this.onSyncErrors=this.m.event,this.a={call(p,w,u){return f.call(p,w,u).then(null,d=>{throw A.$bAb.toUserDataSyncError(d)})},listen(p,w){return f.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,u])=>{this.s(p),this.t(w),u&&this.u(u),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:A.$bAb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),h=this;return new b(f,{async call(w,u,d){return h.a.call(`manualSync/${w}`,[f,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,h,p,w){return this.a.call("accept",[f,h,p,w])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,h){return this.a.call("extractActivityData",[f,h])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(h=>({syncResource:h.syncResource,profile:(0,L.$xl)(h.profile,this.n.profilesHome.scheme),conflicts:h.conflicts.map(p=>({...p,baseResource:j.URI.revive(p.baseResource),localResource:j.URI.revive(p.localResource),remoteResource:j.URI.revive(p.remoteResource),previewResource:j.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$Edc=S,e.$Edc=S=Ee([Q(1,L.$wl)],S);class b extends N.$Uc{constructor(f,h){super(),this.id=f,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ce[122],le([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XKb=e.$WKb=e.$VKb=e.$UKb=e.$TKb=void 0;const g="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends A.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$eAb,-1)}set c(O){this.h.store(c.$eAb,O,-1,P.$o?0:1)}constructor(O,M,F){super(),this.f=O,this.g=M,this.h=F,this.a=this.B(new L.$be),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new A.$Tc);this.B(L.Event.filter(F.onDidChangeValue(-1,c.$eAb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[g]),this.a.fire()}m(O){if(O&&(O=P.$o&&O.web?{...O,...O.web}:O,(0,S.$4f)(O.url)&&(0,S.$6f)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(M=>Array.isArray(O.authenticationProviders[M].scopes)))){const M=O,F=!!M.canSwitch,U=M.url===M.insidersUrl?"insiders":"stable",X=(F?this.c:void 0)||U,H=X==="insiders"?M.insidersUrl:X==="stable"?M.stableUrl:M.url;return{url:b.URI.parse(H),type:X,defaultType:U,defaultUrl:b.URI.parse(M.url),stableUrl:b.URI.parse(M.stableUrl),insidersUrl:b.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Z,W)=>(Z.push({id:W,scopes:M.authenticationProviders[W].scopes}),Z),[])}}}};e.$TKb=a,e.$TKb=a=Ee([Q(0,w.$dk),Q(1,f.$Wi),Q(2,l.$Up)],a);let y=class extends a{constructor(O,M,F){super(O,M,F);const U=this.h.get(i,-1);U&&(this.n=JSON.parse(U));const X=this.f[g];X?this.h.store(i,JSON.stringify(X),-1,1):this.h.remove(i,-1)}async switch(O){O!==this.c&&(this.c=O,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$UKb=y,e.$UKb=y=Ee([Q(0,w.$dk),Q(1,f.$Wi),Q(2,l.$Up)],y);let v=class extends A.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(O,M,F,U,X,H,Z){super(),this.n=F,this.r=U,this.s=Z,this.g=this.B(new L.$be),this.onTokenFailed=this.g.event,this.h=this.B(new L.$be),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$be),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(O),this.c=(0,d.$1p)(X,H,Z).then(W=>{const J={"X-Client-Name":`${M.applicationName}${P.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(J["X-Client-Commit"]=M.commit),J}),this.f=new E(t,r,this.n,this.r),this.u(),this.B((0,A.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(O,M){this.b={token:O,type:M}}t(O){this.a=O?(0,$.$4g)(O,"v1"):void 0}u(){const O=this.s.getNumber(o,-1);O&&Date.now()<O&&this.y(new Date(O))}y(O){this.j?.getTime()!==O?.getTime()&&(this.j=O,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,R.$dh)(M=>(0,R.$rh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,$.$4g)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.D(M,{type:"GET",headers:O},[],N.CancellationToken.None);return(await(0,u.$Np)(F))?.map(({id:U})=>U)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,$.$4g)(this.a,"collection").toString();O={...O},O["Content-Type"]=I.$Hs.text;const F=await this.D(M,{type:"POST",headers:O},[],N.CancellationToken.None),U=await(0,u.$Mp)(F);if(!U)throw new c.$cAb("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[c.$$zb]);return U}async deleteCollection(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=O?(0,$.$4g)(this.a,"collection",O).toString():(0,$.$4g)(this.a,"collection").toString();M={...M},await this.D(F,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(O,M){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,M,O),U={},X=await this.D(F.toString(),{type:"GET",headers:U},[],N.CancellationToken.None);return(await(0,u.$Np)(X)||[]).map(({url:Z,created:W})=>({ref:(0,$.$6g)(F,F.with({path:Z})),created:W*1e3}))}async resolveResourceContent(O,M,F,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,$.$4g)(this.z(this.a,F,O),M).toString();U={...U},U["Cache-Control"]="no-cache";const H=await this.D(X,{type:"GET",headers:U},[],N.CancellationToken.None);return await(0,u.$Mp)(H)}async deleteResource(O,M,F){if(!this.a)throw new Error("No settings sync store url configured.");const U=M!==null?(0,$.$4g)(this.z(this.a,F,O),M).toString():this.z(this.a,F,O).toString(),X={};await this.D(U,{type:"DELETE",headers:X},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,$.$4g)(this.a,"resource").toString(),M={"Content-Type":I.$Hs.text};await this.D(O,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(O,M,F,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,$.$4g)(this.z(this.a,F,O),"latest").toString();U={...U},U["Cache-Control"]="no-cache",M&&(U["If-None-Match"]=M.ref);const H=await this.D(X,{type:"GET",headers:U},[304],N.CancellationToken.None);let Z=null;if(H.res.statusCode===304&&(Z=M),Z===null){const W=H.res.headers.etag;if(!W)throw new c.$cAb("Server did not return the ref",X,"NoRef",H.res.statusCode,H.res.headers[c.$$zb]);const J=await(0,u.$Mp)(H);if(!J&&H.res.statusCode===304)throw new c.$cAb("Empty response",X,"EmptyResponse",H.res.statusCode,H.res.headers[c.$$zb]);Z={ref:W,content:J}}return Z}async writeResource(O,M,F,U,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const H=this.z(this.a,U,O).toString();X={...X},X["Content-Type"]=I.$Hs.text,F&&(X["If-Match"]=F);const Z=await this.D(H,{type:"POST",data:M,headers:X},[],N.CancellationToken.None),W=Z.res.headers.etag;if(!W)throw new c.$cAb("Server did not return the ref",H,"NoRef",Z.res.statusCode,Z.res.headers[c.$$zb]);return W}async manifest(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,$.$4g)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const U=await this.D(F,{type:"GET",headers:M},[304],N.CancellationToken.None);let X=null;if(U.res.statusCode===304&&(X=O),!X){const Z=U.res.headers.etag;if(!Z)throw new c.$cAb("Server did not return the ref",F,"NoRef",U.res.statusCode,U.res.headers[c.$$zb]);const W=await(0,u.$Mp)(U);if(!W&&U.res.statusCode===304)throw new c.$cAb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[c.$$zb]);W&&(X={...JSON.parse(W),ref:Z})}const H=this.s.get(n,-1);return H&&X&&H!==X.session&&this.C(),X===null&&H&&this.C(),X&&this.s.store(n,X.session,-1,1),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,$.$4g)(this.a,"download").toString(),M={},F=await this.D(O,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,u.$Jp)(F))throw new c.$cAb("Server returned "+F.res.statusCode,O,"EmptyResponse",F.res.statusCode,F.res.headers[c.$$zb]);if((0,u.$Kp)(F))throw new c.$cAb("Empty response",O,"EmptyResponse",F.res.statusCode,F.res.headers[c.$$zb]);return F.stream}z(O,M,F){return M?(0,$.$4g)(O,"collection",M,"resource",F):(0,$.$4g)(O,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(O,M,F,U){if(!this.b)throw new c.$cAb("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$cAb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const X=await this.c;M.headers={...M.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let H;try{H=await this.f.request(O,M,U)}catch(B){if(!(B instanceof c.$cAb)){let ie="RequestFailed";const oe=(0,j.$0)(B).toLowerCase();oe.includes("xhr timeout")?ie="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?ie="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":oe.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,j.$4)(B)&&(ie="RequestCanceled"),B=new c.$cAb(`Connection refused for the request '${O}'.`,O,ie,void 0,void 0)}throw this.r.info("Request failed",O),B}const Z=H.res.headers[c.$$zb],W={url:O,status:H.res.statusCode,"execution-id":M.headers[c.$_zb],"operation-id":Z},J=(0,u.$Jp)(H)||H.res.statusCode&&F.includes(H.res.statusCode);let V="";if(J?this.r.trace("Request succeeded",W):(V=await(0,u.$Lp)(H)||"",this.r.info("Request failed",W,V)),H.res.statusCode===401||H.res.statusCode===403){if(this.b=void 0,H.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$cAb(`${M.type} request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",H.res.statusCode,Z);if(H.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$cAb(`${M.type} request '${O}' failed because the access is forbidden (403).`,O,"Forbidden",H.res.statusCode,Z)}if(this.h.fire(),H.res.statusCode===404)throw new c.$cAb(`${M.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",H.res.statusCode,Z);if(H.res.statusCode===405)throw new c.$cAb(`${M.type} request '${O}' failed because the requested endpoint is not found (405). ${V}`,O,"MethodNotFound",H.res.statusCode,Z);if(H.res.statusCode===409)throw new c.$cAb(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",H.res.statusCode,Z);if(H.res.statusCode===410)throw new c.$cAb(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",H.res.statusCode,Z);if(H.res.statusCode===412)throw new c.$cAb(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",H.res.statusCode,Z);if(H.res.statusCode===413)throw new c.$cAb(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",H.res.statusCode,Z);if(H.res.statusCode===426)throw new c.$cAb(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",H.res.statusCode,Z);if(H.res.statusCode===429){const B=H.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$cAb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",H.res.statusCode,Z)):new c.$cAb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",H.res.statusCode,Z)}if(!J)throw new c.$cAb("Server returned "+H.res.statusCode,O,"Unknown",H.res.statusCode,Z);return H}F(O){let M=this.s.get(s,-1);M===void 0&&(M=(0,m.$Mg)(),this.s.store(s,M,-1,1)),O["X-Machine-Session-Id"]=M;const F=this.s.get(n,-1);F!==void 0&&(O["X-User-Session-Id"]=F)}};e.$VKb=v,e.$VKb=v=Ee([Q(1,w.$dk),Q(2,u.$Hp),Q(3,c.$lAb),Q(4,h.$xi),Q(5,p.$Wk),Q(6,l.$Up)],v);let C=class extends v{constructor(O,M,F,U,X,H,Z){super(O.userDataSyncStore?.url,M,F,U,X,H,Z),this.B(O.onDidChangeUserDataSyncStore(()=>this.t(O.userDataSyncStore?.url)))}};e.$WKb=C,e.$WKb=C=Ee([Q(0,c.$8zb),Q(1,w.$dk),Q(2,u.$Hp),Q(3,c.$lAb),Q(4,h.$xi),Q(5,p.$Wk),Q(6,l.$Up)],C);class E{constructor(O,M,F,U){this.c=O,this.d=M,this.f=F,this.g=U,this.a=[],this.b=void 0}request(O,M,F){if(this.h()&&this.i(),M.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$cAb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(M,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$XKb=E}),define(ce[267],le([0,1,3,2,8,21,24,19,122]),function(ne,e,R,N,j,L,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=e.$Bdc=e.$Adc=e.$zdc=void 0;class ${constructor(h){this.a=h}listen(h,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(h,p,w){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(w)}throw new Error("Invalid call")}}e.$zdc=$;class S extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(h){super(),this.c=h,this.b=this.B(new R.$be),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(w=>{this.a=w,this.b.fire(w)}))})}updateAccount(h){return this.c.call("updateAccount",h)}}e.$Adc=S;class b{constructor(h){this.a=h}listen(h,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(h,p,w){switch(p){case"switch":return this.a.switch(w[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Bdc=b;let m=class extends P.$TKb{constructor(h,p,w,u){super(p,w,u),this.n=h,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(h){return this.n.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.n.call("getPreviousUserDataSyncStore");return this.r(h)}r(h){return{url:j.URI.revive(h.url),type:h.type,defaultUrl:j.URI.revive(h.defaultUrl),insidersUrl:j.URI.revive(h.insidersUrl),stableUrl:j.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}};e.$Cdc=m,e.$Cdc=m=Ee([Q(1,A.$dk),Q(2,L.$Wi),Q(3,I.$Up)],m)}),define(ce[268],le([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,R,N,j,L,A,I,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;let b=class extends I.$kac{constructor(f,h,p,w,u,d,l,c,g,i,o){super(f,h,p,w,u,l,c,g,i,o),this.B(R.Event.debounce(R.Event.any(R.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Ydc=b,e.$Ydc=b=Ee([Q(0,j.$dk),Q(1,P.$8zb),Q(2,P.$9zb),Q(3,P.$gAb),Q(4,P.$hAb),Q(5,N.$Pbc),Q(6,P.$lAb),Q(7,$.$pJb),Q(8,A.$Vl),Q(9,S.$Vzb),Q(10,L.$Up)],b)}),define(ce[269],le([0,1,73,23,5,20]),function(ne,e,R,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0,e.$ebc=A,e.$fbc=I,e.$gbc=P,e.$dbc=128/4;function A($){function S(){let b=$.scheme===N.Schemas.file?(0,L.$Rg)($):$.toString();return j.$k||(b=b.toLowerCase()),(0,R.createHash)("md5").update(b).digest("hex")}return{id:S(),configPath:$}}function I($,S){function b(){if($.scheme!==N.Schemas.file)return(0,R.createHash)("md5").update($.toString()).digest("hex");if(!S)return;let f;return j.$k?f=S.ino:j.$j?f=S.birthtime.getTime():j.$i&&(typeof S.birthtimeMs=="number"?f=Math.floor(S.birthtimeMs):f=S.birthtime.getTime()),(0,R.createHash)("md5").update($.fsPath).update(f?String(f):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:$}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[270],le([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;let p=class extends j.$Uc{constructor(u,d,l,c){super(),this.a=u,this.b=d,this.c=l,this.f=c,this.B(new R.$Ch(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.a.workspaceStorageHome.with({scheme:h.Schemas.file}).fsPath,d=await A.Promises.readdir(u),l=new $.$3Jb(this.f.getChannel("storage"));await Promise.all(d.map(async c=>{const g=(0,L.$kc)(u,c);c.length===b.$dbc||c===S.$Ci.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await l.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await A.Promises.rm(g))}))}catch(u){(0,N.$1)(u)}}};e.$vdc=p,e.$vdc=p=Ee([Q(0,I.$yi),Q(1,P.$Wj),Q(2,m.$Pbc),Q(3,f.$5cc)],p)}),define(ce[123],le([0,1,73,64,37,279,15,7,3,2,14,5,32,41,68]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=n,e.$ji=s,e.$li=a,e.$mi=y;class p{traceSocketEvent(C,E){h.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,E)}constructor(C,E=""){this.f=!0,this.debugLabel=E,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,I.$1)(k)}},this.socket.on("error",this.a),this.b=k=>{this.traceSocketEvent("close",{hadError:k}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const E=k=>{this.traceSocketEvent("read",k),C(A.$Ce.wrap(k))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(C){const E=k=>{C({type:0,hadError:k,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(C){const E=()=>{C()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,I.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,I.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.$fi=p;var w;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var u;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(u||(u={}));class d extends $.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,E){this.socket.traceSocketEvent(C,E)}constructor(C,E,k,O){super(),this.f=this.B(new P.$be),this.g=this.B(new P.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:k?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new l(this,E,k,O,this.f,(M,F)=>this.m(M,F))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new h.$ai,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let E=0;for(;E<C.byteLength;)this.a.writeMessage(C.slice(E,Math.min(E+262144,C.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(C,{compressed:E,opcode:k}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let O=2;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const M=A.$Ce.alloc(O),F=E?64:0,U=k&15;if(M.writeUInt8(128|F|U,0),C.byteLength<126)M.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){M.writeUInt8(126,1);let X=1;M.writeUInt8(C.byteLength>>>8&255,++X),M.writeUInt8(C.byteLength>>>0&255,++X)}else{M.writeUInt8(127,1);let X=1;M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(C.byteLength>>>24&255,++X),M.writeUInt8(C.byteLength>>>16&255,++X),M.writeUInt8(C.byteLength>>>8&255,++X),M.writeUInt8(C.byteLength>>>0&255,++X)}this.socket.write(A.$Ce.concat([M,C]))}end(){this.h=!0,this.socket.end()}n(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),k=E.readUInt8(0),O=(k&128)>>>7,M=(k&64)>>>6,F=k&15,U=E.readUInt8(1),X=(U&128)>>>7,H=U&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),k=E.readUInt8(1),O=(k&128)>>>7;let M=k&127,F=1;M===126?M=E.readUInt8(++F)*2**8+E.readUInt8(++F):M===127&&(M=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let U=0;O&&(U=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=M,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),i(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=d;class l extends $.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Ce.alloc(0)}constructor(C,E,k,O,M,F){super(),this.n=C,this.r=M,this.s=F,this.a=this.B(new P.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new c(this.n,O,k,{windowBits:15})),this.f=this.B(new g(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(C,E){this.g.push({data:C,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:C,options:E}=this.g.shift();if(this.f&&E.compressed){const k=await this.w(this.f,C);this.s(k,E)}else this.s(C,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(C,E){return new Promise((k,O)=>{C.write(E),C.flush(M=>k(M))})}acceptFrame(C,E,k){this.h.push({data:C,isCompressed:E,isLastFrameOfMessage:k}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const E=await this.C(this.b,C.data,C.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(C.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(C,E,k){return new Promise((O,M)=>{C.write(E),k&&C.write(A.$Ce.fromByteArray([0,0,255,255])),C.flush(F=>O(F))})}}class c extends $.$Uc{get recordedInflateBytes(){return this.j?A.$Ce.concat(this.f):A.$Ce.alloc(0)}constructor(C,E,k,O){super(),this.h=C,this.j=E,this.a=this.B(new P.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(O),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(A.$Ce.wrap(M))}),k&&(this.h.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this.b.write(k.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=A.$Ce.concat(this.g);this.g.length=0,C(E)})}}class g extends $.$Uc{constructor(C,E){super(),this.g=C,this.a=this.B(new P.$be),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",k=>{this.g.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.g.traceSocketEvent("zlibDeflateData",k),this.f.push(A.$Ce.wrap(k))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=A.$Ce.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),C(E)})}}function i(v,C){if(C===0)return;const E=v.byteLength>>>2;for(let X=0;X<E;X++){const H=v.readUInt32BE(X*4);v.writeUInt32BE(H^C,X*4)}const k=E*4,O=v.byteLength-k,M=C>>>24&255,F=C>>>16&255,U=C>>>8&255;O>=1&&v.writeUInt8(v.readUInt8(k)^M,k),O>=2&&v.writeUInt8(v.readUInt8(k+1)^F,k+1),O>=3&&v.writeUInt8(v.readUInt8(k+2)^U,k+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const v=(0,m.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const C=process.platform!=="darwin"&&e.$hi?e.$hi:(0,j.tmpdir)(),E=(0,S.$kc)(C,`vscode-ipc-${v}.sock`);return t(E),E}function s(v,C,E){const O=(0,R.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${E}-${C}-sock`;const M=E.substr(0,4),F=C.substr(0,6);let U;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?U=(0,S.$kc)(e.$hi,`vscode-${O}-${M}-${F}.sock`):U=(0,S.$kc)(v,`${M}-${F}.sock`),t(U),U}function t(v){const C=o[b.$u];typeof C=="number"&&v.length>=C&&console.warn(`WARNING: IPC handle "${v}" is longer than ${C} chars, try a shorter --user-data-dir`)}class r extends f.$7h{static b(C){const E=P.Event.fromNodeEventEmitter(C,"connection");return P.Event.map(E,k=>({protocol:new h.$bi(new p(k,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(k,"close"))}))}constructor(C){super(r.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=r;function a(v){return new Promise((C,E)=>{const k=(0,N.createServer)();k.on("error",E),k.listen(v,()=>{k.removeListener("error",E),C(new r(k))})})}function y(v,C){return new Promise((E,k)=>{const O=(0,N.createConnection)(v,()=>{O.removeListener("error",k),E(h.$ci.fromSocket(new p(O,`ipc-client${C}`),C))});O.once("error",k)})}}),define(ce[271],le([0,1,64,123,218]),function(ne,e,R,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0,e.$2dc=new class{supports(L){return!0}connect({host:L,port:A},I,P,$){return new Promise((S,b)=>{const m=R.createConnection({host:L,port:A},()=>{m.removeListener("error",b),m.write((0,j.$Isb)(I,P,$));const f=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",f),S(new N.$fi(m,$)))};m.on("data",f)});m.setNoDelay(!0),m.once("error",b)})}}}),define(ce[272],le([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;async function u(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&j.$Pg[t]||!j.$Pg[r.tunnelLocalPort]));a--);return r}class d extends I.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=R.createServer(),this.c=new A.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,j.$Qg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$$v)(this.tunnelRemoteHost)||(0,p.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$Ml)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof L.$fi?t.socket.destroy():t.end()}),t instanceof L.$fi?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(w.$Ce.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$Vcc=d;let l=class extends p.$dw{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,p.$bw)(o,this.m,P.OS,N.release())}t(o,n,s,t,r,a,y,v){const C=this.s(n,s);if(C)return++C.refcount,C.value;if((0,p.$7v)(o))return this.u(o,n,s,r,a,y,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},k=u(E,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,k),k}}};e.$Wcc=l,e.$Wcc=l=Ee([Q(0,f.$Gl),Q(1,S.$Wj),Q(2,h.$Jl),Q(3,b.$dk),Q(4,$.$Wi)],l);let c=class extends l{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$Xcc=c,e.$Xcc=c=Ee([Q(0,f.$Gl),Q(1,S.$Wj),Q(2,h.$Jl),Q(3,b.$dk),Q(4,$.$Wi)],c);let g=class extends I.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,y,v,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const E=new c(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(o,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,y,v,C)}};e.$Ycc=g,e.$Ycc=g=Ee([Q(0,f.$Gl),Q(1,S.$Wj),Q(2,b.$dk),Q(3,h.$Jl),Q(4,$.$Wi)],g)}),define(ce[280],le([0,1,37,38,7,2,23,8,17,3,41,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,R,N,j,L,A,I,P,$,S,b,m,f,h,p,w,u,d,l,c,g,i,o,n,s,t,r,a,y,v,C,E,k,O,M,F,U,X,H,Z,W,J,V,B,ie,oe,te,ae,G,q,D,T,z,x,K,ee,_,Y,se,ue,ge,fe,$e,ye,ve,Ce,Ae,he,me,we,Pe,Re,Me,De,Ue,Te,qe,ze,Le,re,de,pe,be,Se,Ie,Oe,Ne,Ve,Be,Fe,Xe,Ge,_e,tt,St,kt,gt,Ct,Pt,It,Rt,At,Ot,Dt,jt,$t,Lt,mt,Nt,Mt,st,Tt,Ft,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class Ut extends L.$Uc{constructor(ke){super(),this.f=ke,this.a=this.B(new b.$QW(this)),this.b=void 0,this.c=this.B(new $.$be),this.g()}g(){let ke=!1;const je=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,b.$RW)(process.parentPort,st.$$bc.exit,je)}async init(){const ke=await this.h();(0,_.$3zb)(),ke.invokeFunction(je=>{const He=je.get(J.$Wj),We=je.get(G.$Vl),Qe=je.get(Ie.$wl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(He),this.n(We,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(We,Qe))),this.r(We,He)}),this.B((0,L.$Rc)(ke.createInstance(m.$rdc,this.f.codeCachePath),ke.createInstance(f.$sdc),ke.createInstance(w.$vdc),ke.createInstance(p.$udc),ke.createInstance(h.$tdc),ke.createInstance(tt.$Sdc),ke.createInstance(Xe.$Kdc)))}async h(){const ke=new H.$oi,je={_serviceBrand:void 0,...B.default};ke.set(ie.$dk,je);const He=new S.$$h(Ke=>Ke==="main"),We=new $t.$6cc(this.a,He);ke.set($t.$5cc,We);const Qe=this.f.policiesData?new Ne.$Bcc(this.f.policiesData,We.getChannel("policy")):new Ve.$ao;ke.set(Ve.$$n,Qe);const Je=new Mt.$3m(this.f.args,je);ke.set(s.$yi,Je);const et=new V.$3r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),We.getChannel("logger"));ke.set(J.$Xj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new J.$5j(ot.getLevel())),Ze=this.B(new kt.$AQ(ot,[ht]));ke.set(J.$Wj,Ze),this.b=this.B(new gt.$Udc(Ze)),ke.set(gt.$Tdc,this.b);const Ye=this.B(new O.$Cq(Ze));ke.set(k.$Wk,Ye);const ut=this.B(new M.$4q(Ze));Ye.registerProvider(A.Schemas.file,ut);const at=new qe.$rs(Ye);ke.set(Te.$ul,at);const xe=this.B(new Be.$HQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));ke.set(Ie.$wl,xe);const ft=this.B(new Le.$4cc(A.Schemas.file,this.B(new re.$jQ(We.getChannel(re.$iQ),{pathCaseSensitive:ze.$k})),A.Schemas.vscodeUserData,xe,at,Ze));Ye.registerProvider(A.Schemas.vscodeUserData,ft);const it=this.B(new c.$Ao(xe.defaultProfile.settingsResource,Ye,Qe,Ze));ke.set(l.$Wi,it);const dt=new Lt.$1dc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},We,Je);ke.set(te.$Up,dt),this.B((0,L.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new It.$Nr(We.getChannel("request"));ke.set(oe.$Hp,bt),ke.set(u.$wdc,new F.$ni(d.$xdc,void 0,!1)),ke.set(pe.$dG,new F.$ni(de.$Jdc,void 0,!1));const yt=new Ot.$$cc(-1,We);ke.set(At.$Pbc,yt),ke.set(o.$Eo,new F.$ni(n.$PQ,void 0,!0));const zt=this.B(new me.$ycc(yt)),Bt=new S.$$h(Ke=>zt.getActiveClientId().then(lt=>Ke===lt));ke.set(E.$L3b,new Rt.$Wdc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,z.$lp)(je,it);if((0,z.$gp)(je,Je)){const Ke=new D.$B_b(Ze,et,Je,je);if(nt.push(Ke),!(0,z.$hp)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Fe.$oQ(bt,vt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,L.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Rr({appenders:nt,commonProperties:(0,ae.$0o)((0,R.release)(),(0,R.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,z.$mp)(Je)},it,je)}else{ct=z.$bp;const Ke=z.$fp;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new q.$dcc(nt)),ke.set(G.$Vl,ct);const Wt=new x.$ydc(it,ct,Ze,et,Je,je);ke.set(G.$Wl,Wt),ke.set(Oe.$jq,new F.$ni(Pt.$zQ,void 0,!0)),ke.set(be.$nq,new F.$ni(Se.$Ccc,void 0,!0)),ke.set(y.$6p,new F.$ni(y.$7p,void 0,!0)),ke.set(C.$xq,new F.$ni(C.$yq,void 0,!0)),ke.set(a.$Zo,new F.$ni(r.$4p,void 0,!0)),ke.set(a.$7o,new F.$ni(jt.$Zdc,void 0,!1)),ke.set(Z.$Jr,new F.$ni(W.$Lr,void 0,!1)),ke.set(g.$0m,new F.$ni(i.$ys,void 0,!1)),ke.set(Y.$pJb,new F.$ni(Y.$qJb,void 0,!0)),ke.set(_.$lAb,new F.$ni(ge.$PLb,void 0,!0)),ke.set(_.$kAb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$6o,new F.$ni(t.$nJb,void 0,!1)),ke.set(ee.$NLb,new F.$ni(ee.$OLb,void 0,!0)),ke.set(K.$Qv,new F.$ni(K.$Rv)),ke.set(_.$8zb,new F.$ni(Ce.$UKb,void 0,!0)),ke.set(_.$9zb,new F.$ni(Ce.$WKb,void 0,!0)),ke.set(fe.$Vzb,new F.$ni(fe.$Xzb,void 0,!0)),ke.set(_.$0zb,new F.$ni(se.$eac,void 0,!1)),ke.set(_.$gAb,new F.$ni($e.$6_b,void 0,!0)),ke.set(_.$hAb,new F.$ni(ye.$jac,void 0,!1)),ke.set(Ae.$4Jb,new F.$ni(he.$Fdc,void 0,!0)),ke.set(_.$iAb,new F.$ni(_e.$Sac,void 0,!0)),ke.set(we.$Jl,new F.$ni(Pe.$1cc,void 0,!1));const Et=new mt.$Hl;return ke.set(mt.$Gl,Et),Et.register(0,Nt.$2dc),ke.set(Re.$6v,new F.$ni(Me.$Ycc)),ke.set(De.$Gdc,new F.$ni(Ue.$Idc)),ke.set(Ge.$Ldc,new F.$ni(Ct.$Vdc)),new X.$7q(ke)}j(ke){const je=new v.$9p(ke.get(a.$3o),()=>null);this.a.registerChannel("extensions",je);const He=S.ProxyChannel.fromService(ke.get(Z.$Jr),this.q);this.a.registerChannel("languagePacks",He);const We=S.ProxyChannel.fromService(ke.get(g.$0m),this.q);this.a.registerChannel("diagnostics",We);const Qe=new v.$$p(ke.get(a.$7o));this.a.registerChannel("extensionTipsService",Qe);const Je=S.ProxyChannel.fromService(ke.get(u.$wdc),this.q);this.a.registerChannel("checksum",Je);const et=S.ProxyChannel.fromService(ke.get(pe.$dG),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=S.ProxyChannel.fromService(ke.get(fe.$Vzb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=S.ProxyChannel.fromService(ke.get(G.$Wl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ze=new ue.$zdc(ke.get(Y.$pJb));this.a.registerChannel("userDataSyncAccount",Ze);const Ye=new ue.$Bdc(ke.get(_.$8zb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new ve.$Ddc(ke.get(_.$hAb),ke.get(Ie.$wl),ke.get(J.$Wj));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(U.$pi).createInstance(Dt.$Ydc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(ke.get(_.$iAb),this.q));const xe=S.ProxyChannel.fromService(ke.get(De.$Gdc),this.q);this.a.registerChannel(De.$Hdc,xe);const ft=S.ProxyChannel.fromService(ke.get(Ge.$Ldc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",je=>(0,j.$1)(je)),process.on("unhandledRejection",je=>(0,j.$1)(je)),(0,j.setUnexpectedErrorHandler)(je=>{const He=(0,N.$bj)(je,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,je){ke.publicLog2("profilesInfo",{count:je.profiles.length})}async r(ke,je){if(ze.$k){const[He,We]=await Promise.all([(0,Tt.$Ng)(je.error.bind(je)),(0,wt.$yW)(je.error.bind(je))]),Qe=(0,Ft.$eW)(),Je=(0,wt.$zW)(We,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Qe,displayProtocol:We,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$acc.response)return!1;const je=(0,P.$Ob)(ke.ports);return je?(this.c.fire(je),!0):!1}}async function pt(rt){try{const ke=new Ut(rt);process.parentPort.postMessage(st.$$bc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$$bc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const qt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(qt),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d30cf1447b6442215404fcba71ea59588d94908/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
