/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(le){for(var e=[],u=0,N=le.length;u<N;u++)e[u]=ke[le[u]];return e};define(ke[162],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const L=new Map,R=new Map,M=new Map,p=new Map;function $(y,v){y.has(v.detail)||y.set(v.detail,-v.timestamp)}function S(y,v){const l=y.get(v.detail);l&&(l>=0||y.set(v.detail,l+v.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((y,v)=>y.timestamp-v.timestamp));for(const y of A)switch(y.type){case 10:$(L,y);break;case 11:case 12:S(L,y);break;case 21:$(R,y);break;case 22:S(R,y);break;case 33:$(M,y);break;case 34:S(M,y);break;case 31:$(p,y);break;case 32:S(p,y);break}let C=0;M.forEach(y=>C+=y);function m(y){const v=[];return y.forEach((l,f)=>v.push([f,l])),v}return{amdLoad:m(L),amdInvoke:m(R),nodeRequire:m(M),nodeEval:m(p),nodeRequireTotal:C}}static toMarkdownTable(L,R){let M="";const p=[];return L.forEach(($,S)=>{p[S]=$.length}),R.forEach($=>{$.forEach((S,A)=>{typeof S>"u"&&(S=$[A]="-");const C=S.toString().length;p[A]=Math.max(C,p[A])})}),L.forEach(($,S)=>{M+=`| ${$+" ".repeat(p[S]-$.toString().length)} `}),M+=`|
`,L.forEach(($,S)=>{M+=`| ${"-".repeat(p[S])} `}),M+=`|
`,R.forEach($=>{$.forEach((S,A)=>{typeof S<"u"&&(M+=`| ${S+" ".repeat(p[A]-S.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[163],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=p,e.$lb=$,e.$nb=A,e.$ob=C,e.$pb=m,e.$qb=y,e.$rb=v;function u(l,f){const a=N(l,f);if(a!==-1)return l[a]}function N(l,f,a=l.length-1){for(let n=a;n>=0;n--){const i=l[n];if(f(i))return n}return-1}function L(l,f){const a=R(l,f);return a===-1?void 0:l[a]}function R(l,f,a=0,n=l.length){let i=a,r=n;for(;i<r;){const o=Math.floor((i+r)/2);f(l[o])?i=o+1:r=o}return i-1}function M(l,f){const a=p(l,f);return a===l.length?void 0:l[a]}function p(l,f,a=0,n=l.length){let i=a,r=n;for(;i<r;){const o=Math.floor((i+r)/2);f(l[o])?r=o:i=o+1}return i}function $(l,f,a=0,n=l.length){const i=p(l,f,a,n);return i===l.length?-1:i}class S{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const a=R(this.e,f,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=S;function A(l,f){if(l.length===0)return;let a=l[0];for(let n=1;n<l.length;n++){const i=l[n];f(i,a)>0&&(a=i)}return a}function C(l,f){if(l.length===0)return;let a=l[0];for(let n=1;n<l.length;n++){const i=l[n];f(i,a)>=0&&(a=i)}return a}function m(l,f){return A(l,(a,n)=>-f(a,n))}function y(l,f){if(l.length===0)return-1;let a=0;for(let n=1;n<l.length;n++){const i=l[n];f(i,l[a])>0&&(a=n)}return a}function v(l,f){for(const a of l){const n=f(a);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=L,e.$N=R;function u(M,p){const $=Object.create(null);for(const S of M){const A=p(S);let C=$[A];C||(C=$[A]=[]),C.push(S)}return $}function N(M,p){const $=[],S=[];for(const A of M)p.has(A)||$.push(A);for(const A of p)M.has(A)||S.push(A);return{removed:$,added:S}}function L(M,p){const $=[],S=[];for(const[A,C]of M)p.has(A)||$.push(C);for(const[A,C]of p)M.has(A)||S.push(C);return{removed:$,added:S}}function R(M,p){const $=new Set;for(const S of p)M.has(S)&&$.add(S);return $}}),define(ke[55],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=L,e.$Wh=R;function u(M){return(p,$,S)=>{let A=null,C=null;if(typeof S.value=="function"?(A="value",C=S.value):typeof S.get=="function"&&(A="get",C=S.get),!C)throw new Error("not supported");S[A]=M(C,$)}}function N(M,p,$){let S=null,A=null;if(typeof $.value=="function"?(S="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(S="get",A=$.get),!A)throw new Error("not supported");const C=`$memoize$${p}`;$[S]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,m)}),this[C]}}function L(M,p,$){return u((S,A)=>{const C=`$debounce$${A}`,m=`$debounce$result$${A}`;return function(...y){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),p&&(this[m]=p(this[m],...y),y=[this[m]]),this[C]=setTimeout(()=>{S.apply(this,y),this[m]=$?$():void 0},M)}})}function R(M,p,$){return u((S,A)=>{const C=`$throttle$timer$${A}`,m=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),p&&(this[m]=p(this[m],...l)),this[v])return;const f=this[y]+M;f<=Date.now()?(this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),S.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=p,e.$4=S,e.$6=C,e.$7=m,e.$8=y,e.$0=l;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(g=>{g(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(o){e.$X.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){S(o)||e.$X.onUnexpectedError(o)}function M(o){S(o)||e.$X.onUnexpectedExternalError(o)}function p(o){if(o instanceof Error){const{name:t,message:g}=o,c=o.stacktrace||o.stack;return{$isError:!0,name:t,message:g,stack:c,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const $="Canceled";function S(o){return o instanceof A?!0:o instanceof Error&&o.name===$&&o.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function C(){const o=new Error($);return o.name=o.message,o}function m(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function l(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const g=new i;return g.message=t.message,g.stack=t.stack,g}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,163]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=p,e.$wb=$,e.$xb=S,e.$yb=A,e.$zb=C,e.$Ab=m,e.$Bb=y,e.$Cb=v,e.$Db=l,e.$Eb=f,e.top=a,e.$Gb=n,e.$Hb=r,e.$Ib=o,e.$Jb=t,e.$Kb=g,e.$Lb=c,e.$Mb=h,e.$Nb=s,e.$Ob=w,e.$Pb=d,e.$Qb=D,e.$Rb=b,e.$Sb=E,e.$Tb=k,e.$Ub=P,e.$Vb=I,e.$Wb=j,e.$Xb=F,e.$Yb=z,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=W,e.$4b=X,e.$5b=x,e.$6b=Y,e.$7b=te,e.$8b=we,e.$$b=U;function L(se,re=0){return se[se.length-(1+re)]}function R(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function M(se,re,oe=(G,ie)=>G===ie){if(se===re)return!0;if(!se||!re||se.length!==re.length)return!1;for(let G=0,ie=se.length;G<ie;G++)if(!oe(se[G],re[G]))return!1;return!0}function p(se,re){const oe=se.length-1;re<oe&&(se[re]=se[oe]),se.pop()}function $(se,re,oe){return S(se.length,G=>oe(se[G],re))}function S(se,re){let oe=0,G=se-1;for(;oe<=G;){const ie=(oe+G)/2|0,me=re(ie);if(me<0)oe=ie+1;else if(me>0)G=ie-1;else return ie}return-(oe+1)}function A(se,re,oe){if(se=se|0,se>=re.length)throw new TypeError("invalid index");const G=re[Math.floor(re.length*Math.random())],ie=[],me=[],pe=[];for(const Ae of re){const fe=oe(Ae,G);fe<0?ie.push(Ae):fe>0?me.push(Ae):pe.push(Ae)}return se<ie.length?A(se,ie,oe):se<ie.length+pe.length?pe[0]:A(se-(ie.length+pe.length),me,oe)}function C(se,re){const oe=[];let G;for(const ie of se.slice(0).sort(re))!G||re(G[0],ie)!==0?(G=[ie],oe.push(G)):G.push(ie);return oe}function*m(se,re){let oe,G;for(const ie of se)G!==void 0&&re(G,ie)?oe.push(ie):(oe&&(yield oe),oe=[ie]),G=ie;oe&&(yield oe)}function y(se,re){for(let oe=0;oe<=se.length;oe++)re(oe===0?void 0:se[oe-1],oe===se.length?void 0:se[oe])}function v(se,re){for(let oe=0;oe<se.length;oe++)re(oe===0?void 0:se[oe-1],se[oe],oe+1===se.length?void 0:se[oe+1])}function l(se,re,oe){const G=[];function ie(Ae,fe,De){if(fe===0&&De.length===0)return;const Ie=G[G.length-1];Ie&&Ie.start+Ie.deleteCount===Ae?(Ie.deleteCount+=fe,Ie.toInsert.push(...De)):G.push({start:Ae,deleteCount:fe,toInsert:De})}let me=0,pe=0;for(;;){if(me===se.length){ie(me,0,re.slice(pe));break}if(pe===re.length){ie(me,se.length-me,[]);break}const Ae=se[me],fe=re[pe],De=oe(Ae,fe);De===0?(me+=1,pe+=1):De<0?(ie(me,1,[]),me+=1):De>0&&(ie(me,0,[fe]),pe+=1)}return G}function f(se,re,oe){const G=l(se,re,oe),ie=[],me=[];for(const pe of G)ie.push(...se.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:ie,added:me}}function a(se,re,oe){if(oe===0)return[];const G=se.slice(0,oe).sort(re);return i(se,re,G,oe,se.length),G}function n(se,re,oe,G,ie){return oe===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const Ae=se.length,fe=se.slice(0,oe).sort(re);for(let De=oe,Ie=Math.min(oe+G,Ae);De<Ae;De=Ie,Ie=Math.min(Ie+G,Ae)){if(De>oe&&await new Promise(Te=>setTimeout(Te)),ie&&ie.isCancellationRequested)throw new u.$5;i(se,re,fe,De,Ie)}return fe})().then(me,pe)})}function i(se,re,oe,G,ie){for(const me=oe.length;G<ie;G++){const pe=se[G];if(re(pe,oe[me-1])<0){oe.pop();const Ae=(0,N.$kb)(oe,fe=>re(pe,fe)<0);oe.splice(Ae,0,pe)}}}function r(se){return se.filter(re=>!!re)}function o(se){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]&&(se[re]=se[oe],re+=1);se.length=re}function t(se,re,oe){se.splice(oe,0,se.splice(re,1)[0])}function g(se){return!Array.isArray(se)||se.length===0}function c(se){return Array.isArray(se)&&se.length>0}function h(se,re=oe=>oe){const oe=new Set;return se.filter(G=>{const ie=re(G);return oe.has(ie)?!1:(oe.add(ie),!0)})}function s(se){const re=new Set;return oe=>{const G=se(oe);return re.has(G)?!1:(re.add(G),!0)}}function w(se,re){return se.length>0?se[0]:re}function d(se,re){return se.length>0?se[se.length-1]:re}function D(se,re,oe=(G,ie)=>G===ie){let G=0;for(let ie=0,me=Math.min(se.length,re.length);ie<me&&oe(se[ie],re[ie]);ie++)G++;return G}function b(se){return[].concat(...se)}function E(se,re){let oe=typeof re=="number"?se:0;typeof re=="number"?oe=se:(oe=0,re=se);const G=[];if(oe<=re)for(let ie=oe;ie<re;ie++)G.push(ie);else for(let ie=oe;ie>re;ie--)G.push(ie);return G}function k(se,re,oe){return se.reduce((G,ie)=>(G[re(ie)]=oe?oe(ie):ie,G),Object.create(null))}function P(se,re){return se.push(re),()=>I(se,re)}function I(se,re){const oe=se.indexOf(re);if(oe>-1)return se.splice(oe,1),re}function j(se,re,oe){const G=se.slice(0,re),ie=se.slice(re);return G.concat(oe,ie)}function F(se,re){let oe;if(typeof re=="number"){let G=re;oe=()=>{const ie=Math.sin(G++)*179426549;return ie-Math.floor(ie)}}else oe=Math.random;for(let G=se.length-1;G>0;G-=1){const ie=Math.floor(oe()*(G+1)),me=se[G];se[G]=se[ie],se[ie]=me}}function z(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.unshift(re))}function O(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.push(re))}function T(se,re){for(const oe of re)se.push(oe)}function B(se,re){return Array.isArray(se)?se.map(re):re(se)}function W(se){return Array.isArray(se)?se:[se]}function X(se){return se[Math.floor(Math.random()*se.length)]}function x(se,re,oe){const G=Z(se,re),ie=se.length,me=oe.length;se.length=ie+me;for(let pe=ie-1;pe>=G;pe--)se[pe+me]=se[pe];for(let pe=0;pe<me;pe++)se[pe+G]=oe[pe]}function Y(se,re,oe,G){const ie=Z(se,re);let me=se.splice(ie,oe);return me===void 0&&(me=[]),x(se,ie,G),me}function Z(se,re){return re<0?Math.max(re+se.length,0):Math.min(re,se.length)}var ue;(function(se){function re(me){return me<0}se.isLessThan=re;function oe(me){return me<=0}se.isLessThanOrEqual=oe;function G(me){return me>0}se.isGreaterThan=G;function ie(me){return me===0}se.isNeitherLessOrGreaterThan=ie,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function te(se,re){return(oe,G)=>re(se(oe),se(G))}function we(...se){return(re,oe)=>{for(const G of se){const ie=G(re,oe);if(!ue.isNeitherLessOrGreaterThan(ie))return ie}return ue.neitherLessOrGreaterThan}}const Se=(se,re)=>se-re;e.$9b=Se;const _=(se,re)=>(0,e.$9b)(se?1:0,re?1:0);e.$0b=_;function U(se){return(re,oe)=>-se(re,oe)}class ne{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let oe=this.c;for(;oe<this.g.length&&re(this.g[oe]);)oe++;const G=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,G}takeFromEndWhile(re){let oe=this.d;for(;oe>=0&&re(this.g[oe]);)oe--;const G=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const oe=this.g.slice(this.c,this.c+re);return this.c+=re,oe}}e.$_b=ne;class $e{static{this.empty=new $e(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(oe=>(re(oe),!0))}toArray(){const re=[];return this.iterate(oe=>(re.push(oe),!0)),re}filter(re){return new $e(oe=>this.iterate(G=>re(G)?oe(G):!0))}map(re){return new $e(oe=>this.iterate(G=>oe(re(G))))}some(re){let oe=!1;return this.iterate(G=>(oe=re(G),!oe)),oe}findFirst(re){let oe;return this.iterate(G=>re(G)?(oe=G,!1):!0),oe}findLast(re){let oe;return this.iterate(G=>(re(G)&&(oe=G),!0)),oe}findLastMaxBy(re){let oe,G=!0;return this.iterate(ie=>((G||ue.isGreaterThan(re(ie,oe)))&&(G=!1,oe=ie),!0)),oe}}e.$ac=$e;class Pe{constructor(re){this.c=re}static createSortPermutation(re,oe){const G=Array.from(re.keys()).sort((ie,me)=>oe(re[ie],re[me]));return new Pe(G)}apply(re){return re.map((oe,G)=>re[this.c[G]])}inverse(){const re=this.c.slice();for(let oe=0;oe<this.c.length;oe++)re[this.c[oe]]=oe;return new Pe(re)}}e.$bc=Pe}),define(ke[62],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=p,e.$gd=$;function N(S,A){if(!S)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(S,A="Unreachable"){throw new Error(A)}function R(S){if(!S)throw new u.$cb("Assertion Failed")}function M(S){S||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function p(S){if(!S()){debugger;S(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(S,A){let C=0;for(;C<S.length-1;){const m=S[C],y=S[C+1];if(!A(m,y))return!1;C++}return!0}}),define(ke[74],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,L){const R=this;let M=!1,p;return function(){if(M)return p;if(M=!0,L)try{p=N.apply(R,arguments)}finally{L()}else p=N.apply(R,arguments);return p}}}),define(ke[124],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class u{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$hP=u,e.$iP=new u("id#")}),define(ke[39],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*p(t){yield t}N.single=p;function $(t){return L(t)?t:p(t)}N.wrap=$;function S(t){return t||R}N.from=S;function*A(t){for(let g=t.length-1;g>=0;g--)yield t[g]}N.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}N.first=m;function y(t,g){for(const c of t)if(g(c))return!0;return!1}N.some=y;function v(t,g){for(const c of t)if(g(c))return c}N.find=v;function*l(t,g){for(const c of t)g(c)&&(yield c)}N.filter=l;function*f(t,g){let c=0;for(const h of t)yield g(h,c++)}N.map=f;function*a(...t){for(const g of t)yield*g}N.concat=a;function n(t,g,c){let h=c;for(const s of t)h=g(h,s);return h}N.reduce=n;function*i(t,g,c=t.length){for(g<0&&(g+=t.length),c<0?c+=t.length:c>t.length&&(c=t.length);g<c;g++)yield t[g]}N.slice=i;function r(t,g=Number.POSITIVE_INFINITY){const c=[];if(g===0)return[c,t];const h=t[Symbol.iterator]();for(let s=0;s<g;s++){const w=h.next();if(w.done)return[c,N.empty()];c.push(w.value)}return[c,{[Symbol.iterator](){return h}}]}N.consume=r;async function o(t){const g=[];for await(const c of t)g.push(c);return Promise.resolve(g)}N.asyncToArray=o})(u||(e.Iterable=u={}))}),define(ke[164],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=C,e.$Dn=m,e.$En=y,e.$Fn=v,e.$Gn=l,e.$Hn=f,e.$In=a,e.$Jn=n,e.$Kn=i,e.$Ln=r,e.$Mn=o;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,g=!1){let c=0;const h=t.length;let s="",w=0,d=16,D=0;function b(z){let O=0,T=0;for(;O<z;){const B=t.charCodeAt(c);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;c++,O++}return O<z&&(T=-1),T}function E(z){c=z,s="",w=0,d=16,D=0}function k(){const z=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&S(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&S(t.charCodeAt(c)))for(c++;c<t.length&&S(t.charCodeAt(c));)c++;else return D=3,t.substring(z,c);let O=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&S(t.charCodeAt(c))){for(c++;c<t.length&&S(t.charCodeAt(c));)c++;O=c}else D=3;return t.substring(z,O)}function P(){let z="",O=c;for(;;){if(c>=h){z+=t.substring(O,c),D=2;break}const T=t.charCodeAt(c);if(T===34){z+=t.substring(O,c),c++;break}if(T===92){if(z+=t.substring(O,c),c++,c>=h){D=2;break}switch(t.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=b(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=c;continue}if(T>=0&&T<=31)if($(T)){z+=t.substring(O,c),D=2;break}else D=6;c++}return z}function I(){if(s="",D=0,w=c,c>=h)return w=h,d=17;let z=t.charCodeAt(c);if(p(z)){do c++,s+=String.fromCharCode(z),z=t.charCodeAt(c);while(p(z));return d=15}if($(z))return c++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(c)===10&&(c++,s+=`
`),d=14;switch(z){case 123:return c++,d=1;case 125:return c++,d=2;case 91:return c++,d=3;case 93:return c++,d=4;case 58:return c++,d=6;case 44:return c++,d=5;case 34:return c++,s=P(),d=10;case 47:{const O=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<h&&!$(t.charCodeAt(c));)c++;return s=t.substring(O,c),d=12}if(t.charCodeAt(c+1)===42){c+=2;const T=h-1;let B=!1;for(;c<T;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,B=!0;break}c++}return B||(c++,D=1),s=t.substring(O,c),d=13}return s+=String.fromCharCode(z),c++,d=16}case 45:if(s+=String.fromCharCode(z),c++,c===h||!S(t.charCodeAt(c)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=k(),d=11;default:for(;c<h&&j(z);)c++,z=t.charCodeAt(c);if(w!==c){switch(s=t.substring(w,c),s){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return s+=String.fromCharCode(z),c++,d=16}}function j(z){if(p(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>c,scan:g?F:I,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>w,getTokenLength:()=>c-w,getTokenError:()=>D}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,g){const c=[],h=new Object;let s;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function D(b,E,k,P){w.value=b,w.offset=E,w.length=k,w.type=P,w.colonOffset=void 0,s=w}try{i(t,{onObjectBegin:(b,E)=>{if(g<=b)throw h;s=void 0,d=g>b,c.push("")},onObjectProperty:(b,E,k)=>{if(g<E||(D(b,E,k,"property"),c[c.length-1]=b,g<=E+k))throw h},onObjectEnd:(b,E)=>{if(g<=b)throw h;s=void 0,c.pop()},onArrayBegin:(b,E)=>{if(g<=b)throw h;s=void 0,c.push(0)},onArrayEnd:(b,E)=>{if(g<=b)throw h;s=void 0,c.pop()},onLiteralValue:(b,E,k)=>{if(g<E||(D(b,E,k,o(b)),g<=E+k))throw h},onSeparator:(b,E,k)=>{if(g<=E)throw h;if(b===":"&&s&&s.type==="property")s.colonOffset=E,d=!1,s=void 0;else if(b===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(d=!0,c[c.length-1]=""),s=void 0}}})}catch(b){if(b!==h)throw b}return{path:c,previousNode:s,isAtPropertyKey:d,matches:b=>{let E=0;for(let k=0;E<b.length&&k<c.length;k++)if(b[E]===c[k]||b[E]==="*")E++;else if(b[E]!=="**")return!1;return E===b.length}}}function m(t,g=[],c=R.DEFAULT){let h=null,s=[];const w=[];function d(b){Array.isArray(s)?s.push(b):h!==null&&(s[h]=b)}return i(t,{onObjectBegin:()=>{const b={};d(b),w.push(s),s=b,h=null},onObjectProperty:b=>{h=b},onObjectEnd:()=>{s=w.pop()},onArrayBegin:()=>{const b=[];d(b),w.push(s),s=b,h=null},onArrayEnd:()=>{s=w.pop()},onLiteralValue:d,onError:(b,E,k)=>{g.push({error:b,offset:E,length:k})}},c),s[0]}function y(t,g=[],c=R.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){h.type==="property"&&(h.length=b-h.offset,h=h.parent)}function w(b){return h.children.push(b),b}i(t,{onObjectBegin:b=>{h=w({type:"object",offset:b,length:-1,parent:h,children:[]})},onObjectProperty:(b,E,k)=>{h=w({type:"property",offset:E,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:b,offset:E,length:k,parent:h})},onObjectEnd:(b,E)=>{h.length=b+E-h.offset,h=h.parent,s(b+E)},onArrayBegin:(b,E)=>{h=w({type:"array",offset:b,length:-1,parent:h,children:[]})},onArrayEnd:(b,E)=>{h.length=b+E-h.offset,h=h.parent,s(b+E)},onLiteralValue:(b,E,k)=>{w({type:o(b),offset:E,length:k,parent:h,value:b}),s(E+k)},onSeparator:(b,E,k)=>{h.type==="property"&&(b===":"?h.colonOffset=E:b===","&&s(E))},onError:(b,E,k)=>{g.push({error:b,offset:E,length:k})}},c);const D=h.children[0];return D&&delete D.parent,D}function v(t,g){if(!t)return;let c=t;for(const h of g)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let s=!1;for(const w of c.children)if(Array.isArray(w.children)&&w.children[0].value===h){c=w.children[1],s=!0;break}if(!s)return}else{const s=h;if(c.type!=="array"||s<0||!Array.isArray(c.children)||s>=c.children.length)return;c=c.children[s]}return c}function l(t){if(!t.parent||!t.parent.children)return[];const g=l(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;g.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&g.push(c)}return g}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const g=Object.create(null);for(const c of t.children){const h=c.children[1];h&&(g[c.children[0].value]=f(h))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,g,c=!1){return g>=t.offset&&g<t.offset+t.length||c&&g===t.offset+t.length}function n(t,g,c=!1){if(a(t,g,c)){const h=t.children;if(Array.isArray(h))for(let s=0;s<h.length&&h[s].offset<=g;s++){const w=n(h[s],g,c);if(w)return w}return t}}function i(t,g,c=R.DEFAULT){const h=M(t,!1);function s(te){return te?()=>te(h.getTokenOffset(),h.getTokenLength()):()=>!0}function w(te){return te?we=>te(we,h.getTokenOffset(),h.getTokenLength()):()=>!0}const d=s(g.onObjectBegin),D=w(g.onObjectProperty),b=s(g.onObjectEnd),E=s(g.onArrayBegin),k=s(g.onArrayEnd),P=w(g.onLiteralValue),I=w(g.onSeparator),j=s(g.onComment),F=w(g.onError),z=c&&c.disallowComments,O=c&&c.allowTrailingComma;function T(){for(;;){const te=h.scan();switch(h.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:z?B(10):j();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,we=[],Se=[]){if(F(te),we.length+Se.length>0){let _=h.getToken();for(;_!==17;){if(we.indexOf(_)!==-1){T();break}else if(Se.indexOf(_)!==-1)break;_=T()}}}function W(te){const we=h.getTokenValue();return te?P(we):D(we),T(),!0}function X(){switch(h.getToken()){case 11:{let te=0;try{te=JSON.parse(h.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}P(te);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function x(){return h.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),h.getToken()===6?(I(":"),T(),ue()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Y(){d(),T();let te=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(te||B(4,[],[]),I(","),T(),h.getToken()===2&&O)break}else te&&B(6,[],[]);x()||B(4,[],[2,5]),te=!0}return b(),h.getToken()!==2?B(7,[2],[]):T(),!0}function Z(){E(),T();let te=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(te||B(4,[],[]),I(","),T(),h.getToken()===4&&O)break}else te&&B(6,[],[]);ue()||B(4,[],[4,5]),te=!0}return k(),h.getToken()!==4?B(8,[4],[]):T(),!0}function ue(){switch(h.getToken()){case 3:return Z();case 1:return Y();case 10:return W(!0);default:return X()}}return T(),h.getToken()===17?c.allowEmptyContent?!0:(B(4,[],[]),!1):ue()?(h.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,g){const c=M(t),h=[];let s,w=0,d;do switch(d=c.getPosition(),s=c.scan(),s){case 12:case 13:case 17:w!==d&&h.push(t.substring(w,d)),g!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,g)),w=c.getPosition();break}while(s!==17);return h.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(R){this.element=R,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let R=this.a;for(;R!==u.Undefined;){const M=R.next;R.prev=u.Undefined,R.next=u.Undefined,R=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const p=new u(R);if(this.a===u.Undefined)this.a=p,this.b=p;else if(M){const S=this.b;this.b=p,p.prev=S,S.next=p}else{const S=this.a;this.a=p,p.next=S,S.prev=p}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(p))}}shift(){if(this.a!==u.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==u.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==u.Undefined&&R.next!==u.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===u.Undefined&&R.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):R.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):R.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==u.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(ke[27],Ee([1,0]),function(le,e){"use strict";var u,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=p,e.$Ic=n;function R(i,r,o){let t=i.get(r);return t===void 0&&(t=o,i.set(r,t)),t}function M(i){const r=[];return i.forEach((o,t)=>{r.push(`${t} => ${o}`)}),`Map(${i.size}) {${r.join(", ")}}`}function p(i){const r=[];return i.forEach(o=>{r.push(o)}),`Set(${i.size}) {${r.join(", ")}}`}class ${constructor(r,o){this.uri=r,this.value=o}}function S(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,o){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=o??A.c;else if(S(r)){this.d=new Map,this.e=o??A.c;for(const[t,g]of r)this.set(t,g)}else this.d=new Map,this.e=r??A.c}set(r,o){return this.d.set(this.e(r),new $(r,o)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[t,g]of this.d)r(g.value,g.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class C{constructor(r,o){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(o),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,o){this.c.forEach((t,g)=>r.call(o,g,g,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class y{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,o=0){const t=this.c.get(r);if(t)return o!==0&&this.l(t,o),t.value}set(r,o,t=0){let g=this.c.get(r);if(g)g.value=o,t!==0&&this.l(g,t);else{switch(g={key:r,value:o,next:void 0,previous:void 0},t){case 0:this.j(g);break;case 1:this.i(g);break;case 2:this.j(g);break;default:this.j(g);break}this.c.set(r,g),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this.c.get(r);if(o)return this.c.delete(r),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,o){const t=this.g;let g=this.d;for(;g;){if(o?r.bind(o)(g.value,g.key,this):r(g.value,g.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.key,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return g}values(){const r=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.value,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return g}entries(){const r=this,o=this.g;let t=this.d;const g={[Symbol.iterator](){return g},next(){if(r.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:[t.key,t.value],done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return g}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>r;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const o=r.next,t=r.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}r.next=void 0,r.previous=void 0,this.g++}l(r,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this.d)return;const t=r.next,g=r.previous;r===this.e?(g.next=void 0,this.e=g):(t.previous=g,g.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(o===2){if(r===this.e)return;const t=r.next,g=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=g,g.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((o,t)=>{r.push([t,o])}),r}fromJSON(r){this.clear();for(const[o,t]of r)this.set(o,t)}}e.$Dc=y;class v extends y{constructor(r,o=1){super(),this.m=r,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class l{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let o=this.c.get(r)||0;return o===0?!1:(o--,o===0?this.c.delete(r):this.c.set(r,o),!0)}has(r){return this.c.has(r)}}e.$Fc=l;class f{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[o,t]of r)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(r,o){this.c.set(r,o),this.d.set(o,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const o=this.c.get(r);return o===void 0?!1:(this.c.delete(r),this.d.delete(o),!0)}forEach(r,o){this.c.forEach((t,g)=>{r.call(o,t,g,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=f;class a{constructor(){this.c=new Map}add(r,o){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(o)}delete(r,o){const t=this.c.get(r);t&&(t.delete(o),t.size===0&&this.c.delete(r))}forEach(r,o){const t=this.c.get(r);t&&t.forEach(o)}get(r){const o=this.c.get(r);return o||new Set}}e.$Hc=a;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[o,t]of i)if(!r.has(o)||r.get(o)!==t)return!1;for(const[o]of r)if(!i.has(o))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,39]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=C,e.$Mc=m,e.$Nc=l,e.$Oc=f,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=b;const p=!1;let $=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const j=this.c(P);j.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const j=I.get(P);if(j)return j;const F=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,I){let j;if(I)j=I;else{const B=new Map,W=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,B).isSingleton);if(W.length===0)return;const X=new Set(W.map(x=>x.value));if(j=W.filter(x=>!(x.parent&&X.has(x.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function F(B){function W(x,Y){for(;x.length>0&&Y.some(Z=>typeof Z=="string"?Z===x[0]:x[0].match(Z));)x.shift()}const X=B.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const z=new L.$Hc;for(const B of j){const W=F(B);for(let X=0;X<=W.length;X++)z.add(W.slice(0,X).join(`
`),B)}j.sort((0,u.$7b)(B=>B.idx,u.$9b));let O="",T=0;for(const B of j.slice(0,P)){T++;const W=F(B),X=[];for(let x=0;x<W.length;x++){let Y=W[x];Y=`(shared with ${z.get(W.slice(0,x+1).join(`
`)).size}/${j.length} leaks) at ${Y}`;const ue=z.get(W.slice(0,x).join(`
`)),te=(0,N.$K)([...ue].map(we=>F(we)[x]),we=>we);delete te[W[x]];for(const[we,Se]of Object.entries(te))X.unshift(`    - stacktraces of ${Se.length} other leaks continue with ${we}`);X.unshift(Y)}O+=`


==================== Leaking disposable ${T}/${j.length}: ${B.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return j.length>P&&(O+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:O}}}e.$Jc=S;function A(k){$=k}if(p){const k="__is_disposable_tracked__";A(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function C(k){return $?.trackDisposable(k),k}function m(k){$?.markAsDisposed(k)}function y(k,P){$?.setParent(k,P)}function v(k,P){if($)for(const I of k)$.setParent(I,P)}function l(k){return $?.markAsSingleton(k),k}function f(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function a(k){if(M.Iterable.is(k)){const P=[];for(const I of k)if(I)try{I.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function n(k){for(const P of k)f(P)&&P.dispose();return[]}function i(...k){const P=r(()=>a(k));return v(k,P),P}function r(k){const P=C({dispose:(0,R.$db)(()=>{m(P),k()})});return P}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return y(P,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),y(P,null))}}e.$Tc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),y(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&y(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&y(P,null),P}}e.$Vc=g;class c{constructor(P){this.a=new g,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=c;class h{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=h;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}e.$Yc=s;class w{constructor(){this.a=new Map}acquire(P,...I){let j=this.a.get(P);j||(j={counter:0,object:this.b(P,...I)},this.a.set(P,j));const{object:F}=j,z=(0,R.$db)(()=>{--j.counter===0&&(this.c(P,j.object),this.a.delete(P))});return j.counter++,{object:F,dispose:z}}}e.$Zc=w;class d{constructor(P){this.a=P}async acquire(P,...I){const j=this.a.acquire(P,...I);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(F){throw j.dispose(),F}}}e.$1c=d;class D{constructor(P){this.object=P}dispose(){}}e.$2c=D;function b(k){const P=new o;try{k(P)}finally{P.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(se,re){for(var oe=0;oe<re.length;oe++){var G=re[oe];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(se,G.key,G)}}function u(se,re,oe){return re&&e(se.prototype,re),oe&&e(se,oe),Object.defineProperty(se,"prototype",{writable:!1}),se}function N(se,re){if(se){if(typeof se=="string")return L(se,re);var oe=Object.prototype.toString.call(se).slice(8,-1);if(oe==="Object"&&se.constructor&&(oe=se.constructor.name),oe==="Map"||oe==="Set")return Array.from(se);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return L(se,re)}}function L(se,re){(re==null||re>se.length)&&(re=se.length);for(var oe=0,G=new Array(re);oe<re;oe++)G[oe]=se[oe];return G}function R(se,re){var oe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(oe)return(oe=oe.call(se)).next.bind(oe);if(Array.isArray(se)||(oe=N(se))||re&&se&&typeof se.length=="number"){oe&&(se=oe);var G=0;return function(){return G>=se.length?{done:!0}:{done:!1,value:se[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function p(se){le.defaults=se}var $=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return m[re]};function v(se,re){if(re){if($.test(se))return se.replace(S,y)}else if(A.test(se))return se.replace(C,y);return se}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(se){return se.replace(l,function(re,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(se,re){se=typeof se=="string"?se:se.source,re=re||"";var oe={replace:function(ie,me){return me=me.source||me,me=me.replace(a,"$1"),se=se.replace(ie,me),oe},getRegex:function(){return new RegExp(se,re)}};return oe}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(se,re,oe){if(se){var G;try{G=decodeURIComponent(f(oe)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}re&&!r.test(oe)&&(oe=s(re,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},g=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(se,re){t[" "+se]||(g.test(se)?t[" "+se]=se+"/":t[" "+se]=b(se,"/",!0)),se=t[" "+se];var oe=se.indexOf(":")===-1;return re.substring(0,2)==="//"?oe?re:se.replace(c,"$1")+re:re.charAt(0)==="/"?oe?re:se.replace(h,"$1")+re:se+re}var w={exec:function(){}};function d(se){for(var re=1,oe,G;re<arguments.length;re++){oe=arguments[re];for(G in oe)Object.prototype.hasOwnProperty.call(oe,G)&&(se[G]=oe[G])}return se}function D(se,re){var oe=se.replace(/\|/g,function(me,pe,Ae){for(var fe=!1,De=pe;--De>=0&&Ae[De]==="\\";)fe=!fe;return fe?"|":" |"}),G=oe.split(/ \|/),ie=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>re)G.splice(re);else for(;G.length<re;)G.push("");for(;ie<G.length;ie++)G[ie]=G[ie].trim().replace(/\\\|/g,"|");return G}function b(se,re,oe){var G=se.length;if(G===0)return"";for(var ie=0;ie<G;){var me=se.charAt(G-ie-1);if(me===re&&!oe)ie++;else if(me!==re&&oe)ie++;else break}return se.slice(0,G-ie)}function E(se,re){if(se.indexOf(re[1])===-1)return-1;for(var oe=se.length,G=0,ie=0;ie<oe;ie++)if(se[ie]==="\\")ie++;else if(se[ie]===re[0])G++;else if(se[ie]===re[1]&&(G--,G<0))return ie;return-1}function k(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(se,re){if(re<1)return"";for(var oe="";re>1;)re&1&&(oe+=se),re>>=1,se+=se;return oe+se}function I(se,re,oe,G){var ie=re.href,me=re.title?v(re.title):null,pe=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:oe,href:ie,title:me,text:pe,tokens:G.inlineTokens(pe)};return G.state.inLink=!1,Ae}return{type:"image",raw:oe,href:ie,title:me,text:v(pe)}}function j(se,re){var oe=se.match(/^(\s+)(?:```)/);if(oe===null)return re;var G=oe[1];return re.split(`
`).map(function(ie){var me=ie.match(/^\s+/);if(me===null)return ie;var pe=me[0];return pe.length>=G.length?ie.slice(G.length):ie}).join(`
`)}var F=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.space=function(G){var ie=this.rules.block.newline.exec(G);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},re.code=function(G){var ie=this.rules.block.code.exec(G);if(ie){var me=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?me:b(me,`
`)}}},re.fences=function(G){var ie=this.rules.block.fences.exec(G);if(ie){var me=ie[0],pe=j(me,ie[3]||"");return{type:"code",raw:me,lang:ie[2]?ie[2].trim():ie[2],text:pe}}},re.heading=function(G){var ie=this.rules.block.heading.exec(G);if(ie){var me=ie[2].trim();if(/#$/.test(me)){var pe=b(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:me,tokens:this.lexer.inline(me)}}},re.hr=function(G){var ie=this.rules.block.hr.exec(G);if(ie)return{type:"hr",raw:ie[0]}},re.blockquote=function(G){var ie=this.rules.block.blockquote.exec(G);if(ie){var me=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},re.list=function(G){var ie=this.rules.block.list.exec(G);if(ie){var me,pe,Ae,fe,De,Ie,Te,q,V,J,Q,he,be=ie[1].trim(),ze=be.length>1,Ve={type:"list",raw:"",ordered:ze,start:ze?+be.slice(0,-1):"",loose:!1,items:[]};be=ze?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=ze?be:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(he=!1,!(!(ie=Ye.exec(G))||this.rules.block.hr.test(G)));){if(me=ie[0],G=G.substring(me.length),q=ie[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(fe=2,Q=q.trimLeft()):(fe=ie[2].search(/[^ ]/),fe=fe>4?1:fe,Q=q.slice(fe),fe+=ie[1].length),Ie=!1,!q&&/^ *$/.test(V)&&(me+=V+`
`,G=G.substring(V.length+1),he=!0),!he)for(var it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(J=G.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(q)||st.test(q)||it.test(q)||ot.test(G)));){if(q.search(/[^ ]/)>=fe||!q.trim())Q+=`
`+q.slice(fe);else if(!Ie)Q+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),me+=J+`
`,G=G.substring(J.length+1)}Ve.loose||(Te?Ve.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(Q),pe&&(Ae=pe[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:Q}),Ve.raw+=me}Ve.items[Ve.items.length-1].raw=me.trimRight(),Ve.items[Ve.items.length-1].text=Q.trimRight(),Ve.raw=Ve.raw.trimRight();var Ce=Ve.items.length;for(De=0;De<Ce;De++){this.lexer.state.top=!1,Ve.items[De].tokens=this.lexer.blockTokens(Ve.items[De].text,[]);var Be=Ve.items[De].tokens.filter(function(Ne){return Ne.type==="space"}),He=Be.every(function(Ne){for(var Xe=Ne.raw.split(""),ae=0,ce=R(Xe),Re;!(Re=ce()).done;){var Ge=Re.value;if(Ge===`
`&&(ae+=1),ae>1)return!0}return!1});!Ve.loose&&Be.length&&He&&(Ve.loose=!0,Ve.items[De].loose=!0)}return Ve}},re.html=function(G){var ie=this.rules.block.html.exec(G);if(ie){var me={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},re.def=function(G){var ie=this.rules.block.def.exec(G);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var me=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ie[0],href:ie[2],title:ie[3]}}},re.table=function(G){var ie=this.rules.block.table.exec(G);if(ie){var me={type:"table",header:D(ie[1]).map(function(Te){return{text:Te}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ie[0];var pe=me.align.length,Ae,fe,De,Ie;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=D(me.rows[Ae],me.header.length).map(function(Te){return{text:Te}});for(pe=me.header.length,fe=0;fe<pe;fe++)me.header[fe].tokens=this.lexer.inline(me.header[fe].text);for(pe=me.rows.length,fe=0;fe<pe;fe++)for(Ie=me.rows[fe],De=0;De<Ie.length;De++)Ie[De].tokens=this.lexer.inline(Ie[De].text);return me}}},re.lheading=function(G){var ie=this.rules.block.lheading.exec(G);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},re.paragraph=function(G){var ie=this.rules.block.paragraph.exec(G);if(ie){var me=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:me,tokens:this.lexer.inline(me)}}},re.text=function(G){var ie=this.rules.block.text.exec(G);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},re.escape=function(G){var ie=this.rules.inline.escape.exec(G);if(ie)return{type:"escape",raw:ie[0],text:v(ie[1])}},re.tag=function(G){var ie=this.rules.inline.tag.exec(G);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]}},re.link=function(G){var ie=this.rules.inline.link.exec(G);if(ie){var me=ie[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=b(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=E(ie[2],"()");if(Ae>-1){var fe=ie[0].indexOf("!")===0?5:4,De=fe+ie[1].length+Ae;ie[2]=ie[2].substring(0,Ae),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var Ie=ie[2],Te="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Te=q[3])}else Te=ie[3]?ie[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(me)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),I(ie,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},re.reflink=function(G,ie){var me;if((me=this.rules.inline.reflink.exec(G))||(me=this.rules.inline.nolink.exec(G))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=ie[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return I(me,pe,me[0],this.lexer)}},re.emStrong=function(G,ie,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(G);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var fe=pe[0].length-1,De,Ie,Te=fe,q=0,V=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ie=ie.slice(-1*G.length+fe);(pe=V.exec(ie))!=null;)if(De=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!De){if(Ie=De.length,pe[3]||pe[4]){Te+=Ie;continue}else if((pe[5]||pe[6])&&fe%3&&!((fe+Ie)%3)){q+=Ie;continue}if(Te-=Ie,!(Te>0)){if(Ie=Math.min(Ie,Ie+Te+q),Math.min(fe,Ie)%2){var J=G.slice(1,fe+pe.index+Ie);return{type:"em",raw:G.slice(0,fe+pe.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Q=G.slice(2,fe+pe.index+Ie-1);return{type:"strong",raw:G.slice(0,fe+pe.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},re.codespan=function(G){var ie=this.rules.inline.code.exec(G);if(ie){var me=ie[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=v(me,!0),{type:"codespan",raw:ie[0],text:me}}},re.br=function(G){var ie=this.rules.inline.br.exec(G);if(ie)return{type:"br",raw:ie[0]}},re.del=function(G){var ie=this.rules.inline.del.exec(G);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},re.autolink=function(G,ie){var me=this.rules.inline.autolink.exec(G);if(me){var pe,Ae;return me[2]==="@"?(pe=v(this.options.mangle?ie(me[1]):me[1]),Ae="mailto:"+pe):(pe=v(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},re.url=function(G,ie){var me;if(me=this.rules.inline.url.exec(G)){var pe,Ae;if(me[2]==="@")pe=v(this.options.mangle?ie(me[0]):me[0]),Ae="mailto:"+pe;else{var fe;do fe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(fe!==me[0]);pe=v(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},re.inlineText=function(G,ie){var me=this.rules.inline.text.exec(G);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):v(me[0]):me[0]:pe=v(this.options.smartypants?ie(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},se}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=d({},z),z.gfm=d({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=d({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=d({},O),O.pedantic=d({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=d({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=d({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var re="",oe,G,ie=se.length;for(oe=0;oe<ie;oe++)G=se.charCodeAt(oe),Math.random()>.5&&(G="x"+G.toString(16)),re+="&#"+G+";";return re}var W=function(){function se(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:O.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}se.lex=function(G,ie){var me=new se(ie);return me.lex(G)},se.lexInline=function(G,ie){var me=new se(ie);return me.inlineTokens(G)};var re=se.prototype;return re.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},re.blockTokens=function(G,ie){var me=this;ie===void 0&&(ie=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Te,q,V){return q+"    ".repeat(V.length)});for(var pe,Ae,fe,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:me},G,ie))?(G=G.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.space(G)){G=G.substring(pe.raw.length),pe.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(pe);continue}if(pe=this.tokenizer.code(G)){G=G.substring(pe.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(pe);continue}if(pe=this.tokenizer.fences(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.heading(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.hr(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.blockquote(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.list(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.html(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.def(G)){G=G.substring(pe.raw.length),Ae=ie[ie.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.lheading(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,q=G.slice(1),V=void 0;me.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(Te=Math.min(Te,V))}),Te<1/0&&Te>=0&&(fe=G.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(fe))){Ae=ie[ie.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(pe),De=fe.length!==G.length,G=G.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(G)){G=G.substring(pe.raw.length),Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ie.push(pe);continue}if(G){var Ie="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ie},re.inline=function(G,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:G,tokens:ie}),ie},re.inlineTokens=function(G,ie){var me=this;ie===void 0&&(ie=[]);var pe,Ae,fe,De=G,Ie,Te,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ie.index)+"["+P("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ie.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Te||(q=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(pe=Q.call({lexer:me},G,ie))?(G=G.substring(pe.raw.length),ie.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.tag(G)){G=G.substring(pe.raw.length),Ae=ie[ie.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.link(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(pe.raw.length),Ae=ie[ie.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ie.push(pe);continue}if(pe=this.tokenizer.emStrong(G,De,q)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.codespan(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.br(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.del(G)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.autolink(G,B)){G=G.substring(pe.raw.length),ie.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(G,B))){G=G.substring(pe.raw.length),ie.push(pe);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,he=G.slice(1),be=void 0;me.options.extensions.startInline.forEach(function(ze){be=ze.call({lexer:this},he),typeof be=="number"&&be>=0&&(Q=Math.min(Q,be))}),Q<1/0&&Q>=0&&(fe=G.substring(0,Q+1))}(),pe=this.tokenizer.inlineText(fe,T)){G=G.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(q=pe.raw.slice(-1)),Te=!0,Ae=ie[ie.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):ie.push(pe);continue}if(G){var J="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ie},u(se,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),se}(),X=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.code=function(G,ie,me){var pe=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,pe);Ae!=null&&Ae!==G&&(me=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+v(pe,!0)+'">'+(me?G:v(G,!0))+`</code></pre>
`:"<pre><code>"+(me?G:v(G,!0))+`</code></pre>
`},re.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},re.html=function(G){return G},re.heading=function(G,ie,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+ie+' id="'+Ae+'">'+G+"</h"+ie+`>
`}return"<h"+ie+">"+G+"</h"+ie+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(G,ie,me){var pe=ie?"ol":"ul",Ae=ie&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+G+"</"+pe+`>
`},re.listitem=function(G){return"<li>"+G+`</li>
`},re.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(G){return"<p>"+G+`</p>
`},re.table=function(G,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ie+`</table>
`},re.tablerow=function(G){return`<tr>
`+G+`</tr>
`},re.tablecell=function(G,ie){var me=ie.header?"th":"td",pe=ie.align?"<"+me+' align="'+ie.align+'">':"<"+me+">";return pe+G+("</"+me+`>
`)},re.strong=function(G){return"<strong>"+G+"</strong>"},re.em=function(G){return"<em>"+G+"</em>"},re.codespan=function(G){return"<code>"+G+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(G){return"<del>"+G+"</del>"},re.link=function(G,ie,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var pe='<a href="'+v(G)+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=">"+me+"</a>",pe},re.image=function(G,ie,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var pe='<img src="'+G+'" alt="'+me+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=this.options.xhtml?"/>":">",pe},re.text=function(G){return G},se}(),x=function(){function se(){}var re=se.prototype;return re.strong=function(G){return G},re.em=function(G){return G},re.codespan=function(G){return G},re.del=function(G){return G},re.html=function(G){return G},re.text=function(G){return G},re.link=function(G,ie,me){return""+me},re.image=function(G,ie,me){return""+me},re.br=function(){return""},se}(),Y=function(){function se(){this.seen={}}var re=se.prototype;return re.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(G,ie){var me=G,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[G];do pe++,me=G+"-"+pe;while(this.seen.hasOwnProperty(me))}return ie||(this.seen[G]=pe,this.seen[me]=0),me},re.slug=function(G,ie){ie===void 0&&(ie={});var me=this.serialize(G);return this.getNextSafeSlug(me,ie.dryrun)},se}(),Z=function(){function se(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Y}se.parse=function(G,ie){var me=new se(ie);return me.parse(G)},se.parseInline=function(G,ie){var me=new se(ie);return me.parseInline(G)};var re=se.prototype;return re.parse=function(G,ie){ie===void 0&&(ie=!0);var me="",pe,Ae,fe,De,Ie,Te,q,V,J,Q,he,be,ze,Ve,Ye,it,ot,nt,st,Ce=G.length;for(pe=0;pe<Ce;pe++){if(Q=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(st=this.options.extensions.renderers[Q.type].call({parser:this},Q),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){me+=st||"";continue}switch(Q.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,f(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(V="",q="",De=Q.header.length,Ae=0;Ae<De;Ae++)q+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(V+=this.renderer.tablerow(q),J="",De=Q.rows.length,Ae=0;Ae<De;Ae++){for(Te=Q.rows[Ae],q="",Ie=Te.length,fe=0;fe<Ie;fe++)q+=this.renderer.tablecell(this.parseInline(Te[fe].tokens),{header:!1,align:Q.align[fe]});J+=this.renderer.tablerow(q)}me+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(Q.tokens),me+=this.renderer.blockquote(J);continue}case"list":{for(he=Q.ordered,be=Q.start,ze=Q.loose,De=Q.items.length,J="",Ae=0;Ae<De;Ae++)Ye=Q.items[Ae],it=Ye.checked,ot=Ye.task,Ve="",Ye.task&&(nt=this.renderer.checkbox(it),ze?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=nt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=nt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Ye.tokens,ze),J+=this.renderer.listitem(Ve,ot,it);me+=this.renderer.list(J,he,be);continue}case"html":{me+=this.renderer.html(Q.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(J=Q.tokens?this.parseInline(Q.tokens):Q.text;pe+1<Ce&&G[pe+1].type==="text";)Q=G[++pe],J+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);me+=ie?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return me},re.parseInline=function(G,ie){ie=ie||this.renderer;var me="",pe,Ae,fe,De=G.length;for(pe=0;pe<De;pe++){if(Ae=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(fe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=fe||"";continue}switch(Ae.type){case"escape":{me+=ie.text(Ae.text);break}case"html":{me+=ie.html(Ae.text);break}case"link":{me+=ie.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ie));break}case"image":{me+=ie.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=ie.strong(this.parseInline(Ae.tokens,ie));break}case"em":{me+=ie.em(this.parseInline(Ae.tokens,ie));break}case"codespan":{me+=ie.codespan(Ae.text);break}case"br":{me+=ie.br();break}case"del":{me+=ie.del(this.parseInline(Ae.tokens,ie));break}case"text":{me+=ie.text(Ae.text);break}default:{var Ie='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return me},se}();function ue(se,re,oe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof re=="function"&&(oe=re,re=null),re=d({},ue.defaults,re||{}),k(re),oe){var G=re.highlight,ie;try{ie=W.lex(se,re)}catch(De){return oe(De)}var me=function(Ie){var Te;if(!Ie)try{re.walkTokens&&ue.walkTokens(ie,re.walkTokens),Te=Z.parse(ie,re)}catch(q){Ie=q}return re.highlight=G,Ie?oe(Ie):oe(null,Te)};if(!G||G.length<3||(delete re.highlight,!ie.length))return me();var pe=0;ue.walkTokens(ie,function(De){De.type==="code"&&(pe++,setTimeout(function(){G(De.text,De.lang,function(Ie,Te){if(Ie)return me(Ie);Te!=null&&Te!==De.text&&(De.text=Te,De.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(De.message+"",!0)+"</pre>";throw De}try{var fe=W.lex(se,re);if(re.walkTokens){if(re.async)return Promise.all(ue.walkTokens(fe,re.walkTokens)).then(function(){return Z.parse(fe,re)}).catch(Ae);ue.walkTokens(fe,re.walkTokens)}return Z.parse(fe,re)}catch(De){Ae(De)}}ue.options=ue.setOptions=function(se){return d(ue.defaults,se),p(ue.defaults),ue},ue.getDefaults=M,ue.defaults=le.defaults,ue.use=function(){for(var se=arguments.length,re=new Array(se),oe=0;oe<se;oe++)re[oe]=arguments[oe];var G=d.apply(void 0,[{}].concat(re)),ie=ue.defaults.extensions||{renderers:{},childTokens:{}},me;re.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ie.renderers?ie.renderers[fe.name]:null;De?ie.renderers[fe.name]=function(){for(var Ie=arguments.length,Te=new Array(Ie),q=0;q<Ie;q++)Te[q]=arguments[q];var V=fe.renderer.apply(this,Te);return V===!1&&(V=De.apply(this,Te)),V}:ie.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[fe.level]?ie[fe.level].unshift(fe.tokenizer):ie[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ie.startBlock?ie.startBlock.push(fe.start):ie.startBlock=[fe.start]:fe.level==="inline"&&(ie.startInline?ie.startInline.push(fe.start):ie.startInline=[fe.start]))}fe.childTokens&&(ie.childTokens[fe.name]=fe.childTokens)})),pe.renderer&&function(){var fe=ue.defaults.renderer||new X,De=function(q){var V=fe[q];fe[q]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var be=pe.renderer[q].apply(fe,Q);return be===!1&&(be=V.apply(fe,Q)),be}};for(var Ie in pe.renderer)De(Ie);G.renderer=fe}(),pe.tokenizer&&function(){var fe=ue.defaults.tokenizer||new F,De=function(q){var V=fe[q];fe[q]=function(){for(var J=arguments.length,Q=new Array(J),he=0;he<J;he++)Q[he]=arguments[he];var be=pe.tokenizer[q].apply(fe,Q);return be===!1&&(be=V.apply(fe,Q)),be}};for(var Ie in pe.tokenizer)De(Ie);G.tokenizer=fe}(),pe.walkTokens){var Ae=ue.defaults.walkTokens;G.walkTokens=function(fe){var De=[];return De.push(pe.walkTokens.call(this,fe)),Ae&&(De=De.concat(Ae.call(this,fe))),De}}me&&(G.extensions=ie),ue.setOptions(G)})},ue.walkTokens=function(se,re){for(var oe=[],G=function(){var Ae=me.value;switch(oe=oe.concat(re.call(ue,Ae)),Ae.type){case"table":{for(var fe=R(Ae.header),De;!(De=fe()).done;){var Ie=De.value;oe=oe.concat(ue.walkTokens(Ie.tokens,re))}for(var Te=R(Ae.rows),q;!(q=Te()).done;)for(var V=q.value,J=R(V),Q;!(Q=J()).done;){var he=Q.value;oe=oe.concat(ue.walkTokens(he.tokens,re))}break}case"list":{oe=oe.concat(ue.walkTokens(Ae.items,re));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ae.type]?ue.defaults.extensions.childTokens[Ae.type].forEach(function(be){oe=oe.concat(ue.walkTokens(Ae[be],re))}):Ae.tokens&&(oe=oe.concat(ue.walkTokens(Ae.tokens,re)))}},ie=R(se),me;!(me=ie()).done;)G();return oe},ue.parseInline=function(se,re){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");re=d({},ue.defaults,re||{}),k(re);try{var oe=W.lexInline(se,re);return re.walkTokens&&ue.walkTokens(oe,re.walkTokens),Z.parseInline(oe,re)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+v(G.message+"",!0)+"</pre>";throw G}},ue.Parser=Z,ue.parser=Z.parse,ue.Renderer=X,ue.TextRenderer=x,ue.Lexer=W,ue.lexer=W.lex,ue.Tokenizer=F,ue.Slugger=Y,ue.parse=ue;var te=ue.options,we=ue.setOptions,Se=ue.use,_=ue.walkTokens,U=ue.parseInline,ne=ue,$e=Z.parse,Pe=W.lex;le.Lexer=W,le.Parser=Z,le.Renderer=X,le.Slugger=Y,le.TextRenderer=x,le.Tokenizer=F,le.getDefaults=M,le.lexer=Pe,le.marked=ue,le.options=te,le.parse=ne,le.parseInline=U,le.parser=$e,le.setOptions=we,le.use=Se,le.walkTokens=_,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=u;function u(l){const f=R(l);if(f&&f.length>0)return new Uint32Array(f)}let N=0;const L=new Uint32Array(10);function R(l){if(N=0,M(l,C,4352),N>0||(M(l,m,4449),N>0)||(M(l,y,4520),N>0)||(M(l,v,12593),N))return L.subarray(0,N);if(l>=44032&&l<=55203){const f=l-44032,a=f%588,n=Math.floor(f/588),i=Math.floor(a/28),r=a%28-1;if(n<C.length?M(n,C,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<m.length?M(i,m,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),r>=0&&(r<y.length?M(r,y,0):4520+r-12593<v.length&&M(4520+r-12593,v,12593)),N>0)return L.subarray(0,N)}}function M(l,f,a){l>=a&&l<a+f.length&&p(f[l-a])}function p(l){l!==0&&(L[N++]=l&255,l>>8&&(L[N++]=l>>8&255),l>>16&&(L[N++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var S;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(S||(S={}));var A;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=L,e.$9l=M;const N=new u.$Ec(1e4);function L(S){return $(S,"NFC",N)}const R=new u.$Ec(1e4);function M(S){return $(S,"NFD",R)}const p=/[^\u0000-\u0080]/;function $(S,A,C){if(!S)return S;const m=C.get(S);if(m)return m;let y;return p.test(S)?y=S.normalize(A):y=S,C.set(S,y),y}e.$0l=function(){const S=/[\u0300-\u036f]/g;return function(A){return M(A).replace(S,"")}}()}),define(ke[125],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=u,e.rot=N;function u(p,$,S){return Math.min(Math.max(p,$),S)}function N(p,$){return($+p%$)%$}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=L;class R{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=R;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const S=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function le(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M($){R.push($,Date.now())}function p(){const $=[];for(let S=0;S<R.length;S+=2)$.push({name:R[S],startTime:R[S+1]});return $}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function u(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[167],Ee([1,0,39]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,S,A){this.d($,C=>C._value=S,A)}mutate($,S){this.d($,A=>A._value=S(A._value===N?void 0:A._value))}delete($){const S=this.c($);if(!S)return;let A=S.length-1;const C=S[A].node._value;if(C!==N){for(this.b--,S[A].node._value=N;A>0;A--){const{node:m,part:y}=S[A];if(m.children?.size||m._value!==N)break;S[A-1].node.children.delete(y)}return C}}*deleteRecursive($){const S=this.c($);if(!S)return;const A=S[S.length-1].node;for(let C=S.length-1;C>0;C--){const m=S[C-1];if(m.node.children.delete(S[C].part),m.node.children.size>0||m.node._value!==N)break}for(const C of R(A))C._value!==N&&(this.b--,yield C._value)}find($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return;S=C}return S._value===N?void 0:S._value}hasKeyOrParent($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;if(C._value!==N)return!0;S=C}return!1}hasKeyOrChildren($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;S=C}return!0}hasKey($){let S=this.a;for(const A of $){const C=S.children?.get(A);if(!C)return!1;S=C}return S._value!==N}c($){const S=[{part:"",node:this.a}];let A=0;for(const C of $){const m=S[A].node.children?.get(C);if(!m)return;S.push({part:C,node:m}),A++}return S}d($,S,A){let C=this.a;for(const v of $){if(C.children)if(C.children.has(v))C=C.children.get(v);else{const l=new M;C.children.set(v,l),C=l}else{const l=new M;C.children=new Map([[v,l]]),C=l}A?.(C)}const m=C._value===N?0:1;S(C);const y=C._value===N?0:1;this.b+=y-m}*values(){for(const{_value:$}of R(this.a))$!==N&&(yield $)}}e.$4O=L;function*R(p){const $=[p];for(;$.length>0;){const S=$.pop();if(yield S,S.children)for(const A of S.children.values())$.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:le)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function u(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return le[N].call(L.exports,L,L.exports,u),L.l=!0,L.exports}return u.m=le,u.c=e,u.d=function(N,L,R){u.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,L){if(1&L&&(N=u(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(u.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)u.d(R,M,function(p){return N[p]}.bind(null,M));return R},u.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(L,"a",L),L},u.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},u.p="",u(u.s=0)}([function(le,e,u){(function(N){var L;e=le.exports=Se,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],S=0,A=S++;$[A]="0|[1-9]\\d*";var C=S++;$[C]="[0-9]+";var m=S++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=S++;$[y]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=S++;$[v]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=S++;$[l]="(?:"+$[A]+"|"+$[m]+")";var f=S++;$[f]="(?:"+$[C]+"|"+$[m]+")";var a=S++;$[a]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var n=S++;$[n]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var i=S++;$[i]="[0-9A-Za-z-]+";var r=S++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var o=S++,t="v?"+$[y]+$[a]+"?"+$[r]+"?";$[o]="^"+t+"$";var g="[v=\\s]*"+$[v]+$[n]+"?"+$[r]+"?",c=S++;$[c]="^"+g+"$";var h=S++;$[h]="((?:<|>)?=?)";var s=S++;$[s]=$[C]+"|x|X|\\*";var w=S++;$[w]=$[A]+"|x|X|\\*";var d=S++;$[d]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[a]+")?"+$[r]+"?)?)?";var D=S++;$[D]="[v=\\s]*("+$[s]+")(?:\\.("+$[s]+")(?:\\.("+$[s]+")(?:"+$[n]+")?"+$[r]+"?)?)?";var b=S++;$[b]="^"+$[h]+"\\s*"+$[d]+"$";var E=S++;$[E]="^"+$[h]+"\\s*"+$[D]+"$";var k=S++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;$[P]="(?:~>?)";var I=S++;$[I]="(\\s*)"+$[P]+"\\s+",p[I]=new RegExp($[I],"g");var j=S++;$[j]="^"+$[P]+$[d]+"$";var F=S++;$[F]="^"+$[P]+$[D]+"$";var z=S++;$[z]="(?:\\^)";var O=S++;$[O]="(\\s*)"+$[z]+"\\s+",p[O]=new RegExp($[O],"g");var T=S++;$[T]="^"+$[z]+$[d]+"$";var B=S++;$[B]="^"+$[z]+$[D]+"$";var W=S++;$[W]="^"+$[h]+"\\s*("+g+")$|^$";var X=S++;$[X]="^"+$[h]+"\\s*("+t+")$|^$";var x=S++;$[x]="(\\s*)"+$[h]+"\\s*("+g+"|"+$[d]+")",p[x]=new RegExp($[x],"g");var Y=S++;$[Y]="^\\s*("+$[d]+")\\s+-\\s+("+$[d]+")\\s*$";var Z=S++;$[Z]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ue=S++;$[ue]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)L(te,$[te]),p[te]||(p[te]=new RegExp($[te]));function we(V,J){if(V instanceof Se)return V;if(typeof V!="string"||V.length>R||!(J?p[c]:p[o]).test(V))return null;try{return new Se(V,J)}catch{return null}}function Se(V,J){if(V instanceof Se){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Se))return new Se(V,J);L("SemVer",V,J),this.loose=J;var Q=V.trim().match(J?p[c]:p[o]);if(!Q)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var be=+he;if(be>=0&&be<M)return be}return he}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,J){var Q=we(V,J);return Q?Q.version:null},e.clean=function(V,J){var Q=we(V.trim().replace(/^[=v]+/,""),J);return Q?Q.version:null},e.SemVer=Se,Se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Se.prototype.toString=function(){return this.version},Se.prototype.compare=function(V){return L("SemVer.compare",this.version,this.loose,V),V instanceof Se||(V=new Se(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Se.prototype.compareMain=function(V){return V instanceof Se||(V=new Se(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},Se.prototype.comparePre=function(V){if(V instanceof Se||(V=new Se(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var Q=this.prerelease[J],he=V.prerelease[J];if(L("prerelease compare",J,Q,he),Q===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Q===void 0)return-1;if(Q!==he)return U(Q,he)}while(++J)},Se.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,Q,he){typeof Q=="string"&&(he=Q,Q=void 0);try{return new Se(V,Q).inc(J,he).version}catch{return null}},e.diff=function(V,J){if(se(V,J))return null;var Q=we(V),he=we(J);if(Q.prerelease.length||he.prerelease.length){for(var be in Q)if((be==="major"||be==="minor"||be==="patch")&&Q[be]!==he[be])return"pre"+be;return"prerelease"}for(var be in Q)if((be==="major"||be==="minor"||be==="patch")&&Q[be]!==he[be])return be},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(V,J){var Q=_.test(V),he=_.test(J);return Q&&he&&(V=+V,J=+J),Q&&!he?-1:he&&!Q?1:V<J?-1:V>J?1:0}function ne(V,J,Q){return new Se(V,Q).compare(new Se(J,Q))}function $e(V,J,Q){return ne(V,J,Q)>0}function Pe(V,J,Q){return ne(V,J,Q)<0}function se(V,J,Q){return ne(V,J,Q)===0}function re(V,J,Q){return ne(V,J,Q)!==0}function oe(V,J,Q){return ne(V,J,Q)>=0}function G(V,J,Q){return ne(V,J,Q)<=0}function ie(V,J,Q,he){var be;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),be=V===Q;break;case"!==":typeof V=="object"&&(V=V.version),typeof Q=="object"&&(Q=Q.version),be=V!==Q;break;case"":case"=":case"==":be=se(V,Q,he);break;case"!=":be=re(V,Q,he);break;case">":be=$e(V,Q,he);break;case">=":be=oe(V,Q,he);break;case"<":be=Pe(V,Q,he);break;case"<=":be=G(V,Q,he);break;default:throw new TypeError("Invalid operator: "+J)}return be}function me(V,J){if(V instanceof me){if(V.loose===J)return V;V=V.value}if(!(this instanceof me))return new me(V,J);L("comparator",V,J),this.loose=J,this.parse(V),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(V,J){return U(J,V)},e.major=function(V,J){return new Se(V,J).major},e.minor=function(V,J){return new Se(V,J).minor},e.patch=function(V,J){return new Se(V,J).patch},e.compare=ne,e.compareLoose=function(V,J){return ne(V,J,!0)},e.rcompare=function(V,J,Q){return ne(J,V,Q)},e.sort=function(V,J){return V.sort(function(Q,he){return e.compare(Q,he,J)})},e.rsort=function(V,J){return V.sort(function(Q,he){return e.rcompare(Q,he,J)})},e.gt=$e,e.lt=Pe,e.eq=se,e.neq=re,e.gte=oe,e.lte=G,e.cmp=ie,e.Comparator=me;var pe={};function Ae(V,J){if(V instanceof Ae)return V.loose===J?V:new Ae(V.raw,J);if(V instanceof me)return new Ae(V.value,J);if(!(this instanceof Ae))return new Ae(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,J,Q,he,be,ze,Ve,Ye,it,ot,nt,st,Ce){return((J=fe(Q)?"":fe(he)?">="+Q+".0.0":fe(be)?">="+Q+"."+he+".0":">="+J)+" "+(Ye=fe(it)?"":fe(ot)?"<"+(+it+1)+".0.0":fe(nt)?"<"+it+"."+(+ot+1)+".0":st?"<="+it+"."+ot+"."+nt+"-"+st:"<="+Ye)).trim()}function Ie(V,J){for(var Q=0;Q<V.length;Q++)if(!V[Q].test(J))return!1;if(J.prerelease.length){for(Q=0;Q<V.length;Q++)if(L(V[Q].semver),V[Q].semver!==pe&&V[Q].semver.prerelease.length>0){var he=V[Q].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function Te(V,J,Q){try{J=new Ae(J,Q)}catch{return!1}return J.test(V)}function q(V,J,Q,he){var be,ze,Ve,Ye,it;switch(V=new Se(V,he),J=new Ae(J,he),Q){case">":be=$e,ze=G,Ve=Pe,Ye=">",it=">=";break;case"<":be=Pe,ze=oe,Ve=$e,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(V,J,he))return!1;for(var ot=0;ot<J.set.length;++ot){var nt=J.set[ot],st=null,Ce=null;if(nt.forEach(function(Be){Be.semver===pe&&(Be=new me(">=0.0.0")),st=st||Be,Ce=Ce||Be,be(Be.semver,st.semver,he)?st=Be:Ve(Be.semver,Ce.semver,he)&&(Ce=Be)}),st.operator===Ye||st.operator===it||(!Ce.operator||Ce.operator===Ye)&&ze(V,Ce.semver)||Ce.operator===it&&Ve(V,Ce.semver))return!1}return!0}me.prototype.parse=function(V){var J=this.loose?p[W]:p[X],Q=V.match(J);if(!Q)throw new TypeError("Invalid comparator: "+V);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Se(Q[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return L("Comparator.test",V,this.loose),this.semver===pe||(typeof V=="string"&&(V=new Se(V,this.loose)),ie(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,J){if(!(V instanceof me))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(V.value,J),Te(this.value,Q,J);if(V.operator==="")return Q=new Ae(this.value,J),Te(V.semver,Q,J);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),ze=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ye=ie(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),it=ie(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||be||ze&&Ve||Ye||it},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),L("range",V,J);var Q=J?p[Z]:p[Y];V=V.replace(Q,De),L("hyphen replace",V),V=V.replace(p[x],"$1$2$3"),L("comparator trim",V,p[x]),V=(V=(V=V.replace(p[I],"$1~")).replace(p[O],"$1^")).split(/\s+/).join(" ");var he=J?p[W]:p[X],be=V.split(" ").map(function(ze){return function(Ve,Ye){return L("comp",Ve),Ve=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){L("caret",st,Ce);var Be=Ce?p[B]:p[T];return st.replace(Be,function(He,Ne,Xe,ae,ce){var Re;return L("caret",st,He,Ne,Xe,ae,ce),fe(Ne)?Re="":fe(Xe)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=Ne==="0"?">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+".0 <"+(+Ne+1)+".0.0":ce?(L("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+ce+" <"+(+Ne+1)+".0.0"):(L("no pr"),Re=Ne==="0"?Xe==="0"?">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+Xe+"."+(+ae+1):">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0":">="+Ne+"."+Xe+"."+ae+" <"+(+Ne+1)+".0.0"),L("caret return",Re),Re})}(nt,ot)}).join(" ")}(Ve,Ye),L("caret",Ve),Ve=function(it,ot){return it.trim().split(/\s+/).map(function(nt){return function(st,Ce){var Be=Ce?p[F]:p[j];return st.replace(Be,function(He,Ne,Xe,ae,ce){var Re;return L("tilde",st,He,Ne,Xe,ae,ce),fe(Ne)?Re="":fe(Xe)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=">="+Ne+"."+Xe+".0 <"+Ne+"."+(+Xe+1)+".0":ce?(L("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=">="+Ne+"."+Xe+"."+ae+ce+" <"+Ne+"."+(+Xe+1)+".0"):Re=">="+Ne+"."+Xe+"."+ae+" <"+Ne+"."+(+Xe+1)+".0",L("tilde return",Re),Re})}(nt,ot)}).join(" ")}(Ve,Ye),L("tildes",Ve),Ve=function(it,ot){return L("replaceXRanges",it,ot),it.split(/\s+/).map(function(nt){return function(st,Ce){st=st.trim();var Be=Ce?p[E]:p[b];return st.replace(Be,function(He,Ne,Xe,ae,ce,Re){L("xRange",st,He,Ne,Xe,ae,ce,Re);var Ge=fe(Xe),Me=Ge||fe(ae),tt=Me||fe(ce);return Ne==="="&&tt&&(Ne=""),Ge?He=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&tt?(Me&&(ae=0),tt&&(ce=0),Ne===">"?(Ne=">=",Me?(Xe=+Xe+1,ae=0,ce=0):tt&&(ae=+ae+1,ce=0)):Ne==="<="&&(Ne="<",Me?Xe=+Xe+1:ae=+ae+1),He=Ne+Xe+"."+ae+"."+ce):Me?He=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":tt&&(He=">="+Xe+"."+ae+".0 <"+Xe+"."+(+ae+1)+".0"),L("xRange return",He),He})}(nt,ot)}).join(" ")}(Ve,Ye),L("xrange",Ve),Ve=function(it,ot){return L("replaceStars",it,ot),it.trim().replace(p[ue],"")}(Ve,Ye),L("stars",Ve),Ve}(ze,J)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(ze){return!!ze.match(he)})),be=be.map(function(ze){return new me(ze,J)})},Ae.prototype.intersects=function(V,J){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(he){return V.set.some(function(be){return be.every(function(ze){return he.intersects(ze,J)})})})})},e.toComparators=function(V,J){return new Ae(V,J).set.map(function(Q){return Q.map(function(he){return he.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Se(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],V))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(V,J,Q){var he=null,be=null;try{var ze=new Ae(J,Q)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&be.compare(Ve)!==-1||(be=new Se(he=Ve,Q)))}),he},e.minSatisfying=function(V,J,Q){var he=null,be=null;try{var ze=new Ae(J,Q)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&be.compare(Ve)!==1||(be=new Se(he=Ve,Q)))}),he},e.validRange=function(V,J){try{return new Ae(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,Q){return q(V,J,"<",Q)},e.gtr=function(V,J,Q){return q(V,J,">",Q)},e.outside=q,e.prerelease=function(V,J){var Q=we(V,J);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(V,J,Q){return V=new Ae(V,Q),J=new Ae(J,Q),V.intersects(J)},e.coerce=function(V){if(V instanceof Se)return V;if(typeof V!="string")return null;var J=V.match(p[k]);return J==null?null:we((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,u(1))},function(le,e){var u,N,L=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(f){if(u===setTimeout)return setTimeout(f,0);if((u===R||!u)&&setTimeout)return u=setTimeout,setTimeout(f,0);try{return u(f,0)}catch{try{return u.call(null,f,0)}catch{return u.call(this,f,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:R}catch{u=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var $,S=[],A=!1,C=-1;function m(){A&&$&&(A=!1,$.length?S=$.concat(S):C=-1,S.length&&y())}function y(){if(!A){var f=p(m);A=!0;for(var a=S.length;a;){for($=S,S=[];++C<a;)$&&$[C].run();C=-1,a=S.length}$=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(f)}}function v(f,a){this.fun=f,this.array=a}function l(){}L.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];S.push(new v(f,a)),S.length!==1||A||p(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=l,L.addListener=l,L.once=l,L.off=l,L.removeListener=l,L.removeAllListeners=l,L.emit=l,L.prependListener=l,L.prependOnceListener=l,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[40],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=u&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ke[4],Ee([1,0,13,74,3,75,40]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=y;const p=!1,$=!1,S=!1;var A;(function(I){I.None=()=>L.$Uc.None;function j(Ae){if(S){const{onDidAddListener:fe}=Ae,De=l.create();let Ie=0;Ae.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function F(Ae,fe){return ue(Ae,()=>{},0,void 0,!0,void 0,fe)}I.defer=F;function z(Ae){return(fe,De=null,Ie)=>{let Te=!1,q;return q=Ae(V=>{if(!Te)return q?q.dispose():Te=!0,fe.call(De,V)},null,Ie),Te&&q.dispose(),q}}I.once=z;function O(Ae,fe,De){return Y((Ie,Te=null,q)=>Ae(V=>Ie.call(Te,fe(V)),null,q),De)}I.map=O;function T(Ae,fe,De){return Y((Ie,Te=null,q)=>Ae(V=>{fe(V),Ie.call(Te,V)},null,q),De)}I.forEach=T;function B(Ae,fe,De){return Y((Ie,Te=null,q)=>Ae(V=>fe(V)&&Ie.call(Te,V),null,q),De)}I.filter=B;function W(Ae){return Ae}I.signal=W;function X(...Ae){return(fe,De=null,Ie)=>{const Te=(0,L.$Rc)(...Ae.map(q=>q(V=>fe.call(De,V))));return Z(Te,Ie)}}I.any=X;function x(Ae,fe,De,Ie){let Te=De;return O(Ae,q=>(Te=fe(Te,q),Te),Ie)}I.reduce=x;function Y(Ae,fe){let De;const Ie={onWillAddFirstListener(){De=Ae(Te.fire,Te)},onDidRemoveLastListener(){De?.dispose()}};fe||j(Ie);const Te=new o(Ie);return fe?.add(Te),Te.event}function Z(Ae,fe){return fe instanceof Array?fe.push(Ae):fe&&fe.add(Ae),Ae}function ue(Ae,fe,De=100,Ie=!1,Te=!1,q,V){let J,Q,he,be=0,ze;const Ve={leakWarningThreshold:q,onWillAddFirstListener(){J=Ae(it=>{be++,Q=fe(Q,it),Ie&&!he&&(Ye.fire(Q),Q=void 0),ze=()=>{const ot=Q;Q=void 0,he=void 0,(!Ie||be>1)&&Ye.fire(ot),be=0},typeof De=="number"?(clearTimeout(he),he=setTimeout(ze,De)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){Te&&be>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,J.dispose()}};V||j(Ve);const Ye=new o(Ve);return V?.add(Ye),Ye.event}I.debounce=ue;function te(Ae,fe=0,De){return I.debounce(Ae,(Ie,Te)=>Ie?(Ie.push(Te),Ie):[Te],fe,void 0,!0,void 0,De)}I.accumulate=te;function we(Ae,fe=(Ie,Te)=>Ie===Te,De){let Ie=!0,Te;return B(Ae,q=>{const V=Ie||!fe(q,Te);return Ie=!1,Te=q,V},De)}I.latch=we;function Se(Ae,fe,De){return[I.filter(Ae,fe,De),I.filter(Ae,Ie=>!fe(Ie),De)]}I.split=Se;function _(Ae,fe=!1,De=[],Ie){let Te=De.slice(),q=Ae(Q=>{Te?Te.push(Q):J.fire(Q)});Ie&&Ie.add(q);const V=()=>{Te?.forEach(Q=>J.fire(Q)),Te=null},J=new o({onWillAddFirstListener(){q||(q=Ae(Q=>J.fire(Q)),Ie&&Ie.add(q))},onDidAddFirstListener(){Te&&(fe?setTimeout(V):V())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ie&&Ie.add(J),J.event}I.buffer=_;function U(Ae,fe){return(Ie,Te,q)=>{const V=fe(new $e);return Ae(function(J){const Q=V.evaluate(J);Q!==ne&&Ie.call(Te,Q)},void 0,q)}}I.chain=U;const ne=Symbol("HaltChainable");class $e{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(De=>(fe(De),De)),this}filter(fe){return this.f.push(De=>fe(De)?De:ne),this}reduce(fe,De){let Ie=De;return this.f.push(Te=>(Ie=fe(Ie,Te),Ie)),this}latch(fe=(De,Ie)=>De===Ie){let De=!0,Ie;return this.f.push(Te=>{const q=De||!fe(Te,Ie);return De=!1,Ie=Te,q?Te:ne}),this}evaluate(fe){for(const De of this.f)if(fe=De(fe),fe===ne)break;return fe}}function Pe(Ae,fe,De=Ie=>Ie){const Ie=(...J)=>V.fire(De(...J)),Te=()=>Ae.on(fe,Ie),q=()=>Ae.removeListener(fe,Ie),V=new o({onWillAddFirstListener:Te,onDidRemoveLastListener:q});return V.event}I.fromNodeEventEmitter=Pe;function se(Ae,fe,De=Ie=>Ie){const Ie=(...J)=>V.fire(De(...J)),Te=()=>Ae.addEventListener(fe,Ie),q=()=>Ae.removeEventListener(fe,Ie),V=new o({onWillAddFirstListener:Te,onDidRemoveLastListener:q});return V.event}I.fromDOMEventEmitter=se;function re(Ae){return new Promise(fe=>z(Ae)(fe))}I.toPromise=re;function oe(Ae){const fe=new o;return Ae.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=oe;function G(Ae,fe,De){return fe(De),Ae(Ie=>fe(Ie))}I.runAndSubscribe=G;class ie{constructor(fe,De){this._observable=fe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||j(Ie),this.emitter=new o(Ie),De&&De.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,De){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function me(Ae,fe){return new ie(Ae,fe).emitter.event}I.fromObservable=me;function pe(Ae){return(fe,De,Ie)=>{let Te=0,q=!1;const V={beginUpdate(){Te++},endUpdate(){Te--,Te===0&&(Ae.reportChanges(),q&&(q=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){q=!0}};Ae.addObserver(V),Ae.reportChanges();const J={dispose(){Ae.removeObserver(V)}};return Ie instanceof L.$Tc?Ie.add(J):Array.isArray(Ie)&&Ie.push(J),J}}I.fromObservableLight=pe})(A||(e.Event=A={}));class C{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${C.f++}`,C.all.add(this)}start(j){this.g=new M.$0d,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$_d=C;let m=-1;function y(I){const j=m;return m=I,{dispose(){m=j}}}class v{constructor(j,F=Math.random().toString(18).slice(2,5)){this.threshold=j,this.name=F,this.g=0}dispose(){this.f?.clear()}check(j,F){const z=this.threshold;if(z<=0||F<z)return;this.f||(this.f=new Map);const O=this.f.get(j.value)||0;if(this.f.set(j.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let T,B=0;for(const[W,X]of this.f)(!T||B<X)&&(T=W,B=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${B}):`),console.warn(T)}return()=>{const T=this.f.get(j.value)||0;this.f.set(j.value,T-1)}}}class l{static create(){return new l(new Error().stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(j){this.value=j,this.id=f++}}const n=2,i=(I,j)=>{if(I instanceof a)j(I);else for(let F=0;F<I.length;F++){const z=I[F];z&&j(z)}},r=p?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(j){this.w=0,this.f=j,this.g=m>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const j=this.t;queueMicrotask(()=>{i(j,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,F,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;F&&(j=j.bind(F));const O=new a(j);let T,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=l.create(),T=this.g.check(O.stack,this.w+1)),$&&(O.stack=B??l.create()),this.t?this.t instanceof a?(this.u??=new g,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Sc)(()=>{r?.unregister(W),T?.(),this.x(O)});if(z instanceof L.$Tc?z.add(W):Array.isArray(z)&&z.push(W),r){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(W,X,W)}return W},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,z=F.indexOf(j);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[z]=void 0;const O=this.u.current===this;if(this.w*n<=F.length){let T=0;for(let B=0;B<F.length;B++)F[B]?F[T++]=F[B]:O&&(this.u.end--,T<this.u.i&&this.u.i--);F.length=T}}y(j,F){if(!j)return;const z=this.f?.onListenerError||u.$1;if(!z){j.value(F);return}try{j.value(F)}catch(O){z(O)}}z(j){const F=j.current.t;for(;j.i<j.end;)this.y(F[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,j);else{const F=this.u;F.enqueue(this,j,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=o;const t=()=>new g;e.$ce=t;class g{constructor(){this.i=-1,this.end=0}enqueue(j,F,z){this.i=0,this.end=z,this.current=j,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends o{async fireAsync(j,F,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,O=>this.h.push([O.value,j]));this.h.size>0&&!F.isCancellationRequested;){const[O,T]=this.h.shift(),B=[],W={...T,token:F,waitUntil:X=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(X=z(X,O)),B.push(X)}};try{O(W)}catch(X){(0,u.$1)(X);continue}Object.freeze(B),await Promise.allSettled(B).then(X=>{for(const x of X)x.status==="rejected"&&(0,u.$1)(x.reason)})}}}e.$de=c;class h extends o{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$ee=h;class s extends h{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$fe=s;class w extends o{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$ge=w;class d{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const F={event:j,listener:null};this.h.push(F),this.g&&this.m(F);const z=()=>{this.g&&this.o(F);const O=this.h.indexOf(F);this.h.splice(O,1)};return(0,L.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(F=>this.f.fire(F))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$he=d;class D{constructor(j,F,z,O){this.f=new L.$Tc;const T=this.f.add(new d),B=this.f.add(new L.$4c);function W(X){B.set(X,T.add(O(X)))}for(const X of j)W(X);this.f.add(F(X=>{W(X)})),this.f.add(z(X=>{B.deleteAndDispose(X)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ie=D;class b{constructor(){this.f=[]}wrapEvent(j){return(F,z,O)=>j(T=>{const B=this.f[this.f.length-1];B?B.push(()=>F.call(z,T)):F.call(z,T)},void 0,O)}bufferEvents(j){const F=[];this.f.push(F);const z=j();return this.f.pop(),F.forEach(O=>O()),z}}e.$je=b;class E{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=E;class k{static const(j){return new P(j)}constructor(j){this.g=j,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$le=k;class P{constructor(j){this.value=j,this.onDidChange=A.None}}}),define(ke[22],Ee([1,0,4]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(p,$){const S=setTimeout(p.bind($),0);return{dispose(){clearTimeout(S)}}});var L;(function(p){function $(S){return S===p.None||S===p.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}p.isCancellationToken=$,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$me=M}),define(ke[168],Ee([1,0,22]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class N{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new u.$me,$=this.b(p.token);return this.a={promise:$,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Xe=N;class L{constructor(p,$=JSON.stringify){this.c=p,this.d=$,this.a=void 0,this.b=void 0}get(p){const $=this.d(p);return this.b!==$&&(this.b=$,this.a=this.c(p)),this.a}}e.$Ye=L;class R{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const $=this.b(p);return this.a.set(p,$),$}}e.$Ze=R}),define(ke[98],Ee([1,0,13,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=L,e.$oe=R,e.$pe=M,e.$qe=p,e.$re=S,e.$se=A,e.$te=C,e.$ue=m,e.$ve=y,e.$we=v,e.$xe=l,e.$ye=f,e.$ze=a,e.$Ae=n,e.$Be=i;function L(r){const o=r;return o?typeof o.read=="function":!1}function R(r){const o=r;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function M(r){const o=r;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function p(r,o){return new $(r,o)}class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,u.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let g;switch(o){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const c=g.indexOf(t);c>=0&&g.splice(c,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(r,o){const t=[];let g;for(;(g=r.read())!==null;)t.push(g);return o(t)}function A(r,o,t){const g=[];let c;for(;(c=r.read())!==null&&g.length<t;)g.push(c);return c===null&&g.length>0?o(g):{read:()=>{if(g.length>0)return g.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return r.read()}}}function C(r,o){return new Promise((t,g)=>{const c=[];m(r,{onData:h=>{o&&c.push(h)},onError:h=>{o?g(h):t(void 0)},onEnd:()=>{t(o?o(c):void 0)}})})}function m(r,o,t){r.on("error",g=>{t?.isCancellationRequested||o.onError(g)}),r.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),r.on("data",g=>{t?.isCancellationRequested||o.onData(g)})}function y(r,o){return new Promise((t,g)=>{const c=new N.$Tc,h=[],s=D=>{if(h.push(D),h.length>o)return c.dispose(),r.pause(),t({stream:r,buffer:h,ended:!1})},w=D=>(c.dispose(),g(D)),d=()=>(c.dispose(),t({stream:r,buffer:h,ended:!0}));c.add((0,N.$Sc)(()=>r.removeListener("error",w))),r.on("error",w),c.add((0,N.$Sc)(()=>r.removeListener("end",d))),r.on("end",d),c.add((0,N.$Sc)(()=>r.removeListener("data",s))),r.on("data",s)})}function v(r,o){const t=p(o);return t.end(r),t}function l(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}function f(r){let o=!1;return{read:()=>o?null:(o=!0,r)}}function a(r,o,t){const g=p(t);return m(r,{onData:c=>g.write(o.data(c)),onError:c=>g.error(o.error?o.error(c):c),onEnd:()=>g.end()}),g}function n(r,o,t){let g=!1;return{read:()=>{const c=o.read();return g?c:(g=!0,c!==null?t([r,c]):r)}}}function i(r,o,t){let g=!1;const c=p(t);return m(o,{onData:h=>g?c.write(h):(g=!0,c.write(t([r,h]))),onError:h=>c.error(h),onEnd:()=>{g||(g=!0,c.write(r)),c.end()}}),c}}),define(ke[21],Ee([1,0,46,98]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=S,e.$Ee=A,e.$Fe=C,e.$Ge=m,e.$He=y,e.$Ie=v,e.$Je=l,e.$Ke=f,e.$Le=a,e.$Me=n,e.$Ne=i,e.$Oe=r,e.$Pe=o,e.$Qe=t,e.$Re=g,e.$Se=c,e.$Te=h,e.$Ue=s,e.$Ve=w,e.$We=b;const L=typeof Buffer<"u",R=new u.$V(()=>new Uint8Array(256));let M,p;class ${static alloc(k){return L?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&L?new $(Buffer.from(k)):(M||(M=new TextEncoder),new $(M.encode(k)))}static fromByteArray(k){const P=$.alloc(k.length);for(let I=0,j=k.length;I<j;I++)P.buffer[I]=k[I];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let F=0,z=k.length;F<z;F++)P+=k[F].byteLength}const I=$.alloc(P);let j=0;for(let F=0,z=k.length;F<z;F++){const O=k[F];I.set(O,j),j+=O.byteLength}return I}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,P){return new $(this.buffer.subarray(k,P))}set(k,P){if(k instanceof $)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return m(this.buffer,k)}writeUInt32BE(k,P){y(this.buffer,k,P)}readUInt32LE(k){return v(this.buffer,k)}writeUInt32LE(k,P){l(this.buffer,k,P)}readUInt8(k){return f(this.buffer,k)}writeUInt8(k,P){a(this.buffer,k,P)}indexOf(k,P=0){return S(this.buffer,k instanceof $?k.buffer:k,P)}}e.$Ce=$;function S(E,k,P=0){const I=k.byteLength,j=E.byteLength;if(I===0)return 0;if(I===1)return E.indexOf(k[0]);if(I>j-P)return-1;const F=R.value;F.fill(k.length);for(let B=0;B<k.length;B++)F[k[B]]=k.length-B-1;let z=P+k.length-1,O=z,T=-1;for(;z<j;)if(E[z]===k[O]){if(O===0){T=z;break}z--,O--}else z+=Math.max(k.length-O,F[E[z]]),O=k.length-1;return T}function A(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function C(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255}function m(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function y(E,k,P){E[P+3]=k,k=k>>>8,E[P+2]=k,k=k>>>8,E[P+1]=k,k=k>>>8,E[P]=k}function v(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function l(E,k,P){E[P+0]=k&255,k=k>>>8,E[P+1]=k&255,k=k>>>8,E[P+2]=k&255,k=k>>>8,E[P+3]=k&255}function f(E,k){return E[k]}function a(E,k,P){E[P]=k}function n(E){return N.$re(E,k=>$.concat(k))}function i(E){return N.$ye(E)}function r(E){return N.$te(E,k=>$.concat(k))}async function o(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await r(E.stream)])}function t(E){return N.$we(E,k=>$.concat(k))}function g(E){return N.$ze(E,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function c(E){return N.$qe(k=>$.concat(k),E)}function h(E,k){return N.$Ae(E,k,P=>$.concat(P))}function s(E,k){return N.$Be(E,k,P=>$.concat(P))}function w(E){let k=0,P=0,I=0;const j=new Uint8Array(Math.floor(E.length/4*3)),F=O=>{switch(P){case 3:j[I++]=k|O,P=0;break;case 2:j[I++]=k|O>>>2,k=O<<6,P=3;break;case 1:j[I++]=k|O>>>4,k=O<<4,P=2;break;default:k=O<<2,P=1}};for(let O=0;O<E.length;O++){const T=E.charCodeAt(O);if(T>=65&&T<=90)F(T-65);else if(T>=97&&T<=122)F(T-97+26);else if(T>=48&&T<=57)F(T-48+52);else if(T===43||T===45)F(62);else if(T===47||T===95)F(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${E[O]}`)}}const z=I;for(;P>0;)F(0);return $.wrap(j).slice(0,z)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:E},k=!0,P=!1){const I=P?D:d;let j="";const F=E.byteLength%3;let z=0;for(;z<E.byteLength-F;z+=3){const O=E[z+0],T=E[z+1],B=E[z+2];j+=I[O>>>2],j+=I[(O<<4|T>>>4)&63],j+=I[(T<<2|B>>>6)&63],j+=I[B&63]}if(F===1){const O=E[z+0];j+=I[O>>>2],j+=I[O<<4&63],k&&(j+="==")}else if(F===2){const O=E[z+0],T=E[z+1];j+=I[O>>>2],j+=I[(O<<4|T>>>4)&63],j+=I[T<<2&63],k&&(j+="=")}return j}}),define(ke[14],Ee([1,0,168,46]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=L,e.$4e=M,e.$5e=$,e.$6e=S,e.$7e=A,e.$8e=C,e.$9e=m,e.$0e=y,e.$$e=v,e.$_e=l,e.$af=f,e.$bf=a,e.$cf=n,e.$df=i,e.$ef=r,e.$ff=o,e.$gf=t,e.$hf=g,e.$if=c,e.$jf=h,e.$kf=s,e.$lf=w,e.$mf=d,e.$nf=D,e.$of=b,e.$pf=E,e.$qf=k,e.$rf=P,e.$sf=I,e.$tf=j,e.$uf=F,e.$vf=z,e.$wf=O,e.$xf=T,e.$yf=B,e.$zf=W,e.$Af=X,e.$Df=ue,e.$Ef=te,e.$Ff=we,e.$Gf=Se,e.$Hf=ne,e.$If=Pe,e.$Kf=se,e.$Lf=re,e.$Mf=oe,e.$Nf=G,e.$Of=me,e.$Pf=pe,e.$Rf=Ae,e.$Sf=fe,e.$Tf=De,e.$Uf=Ie,e.$Vf=Te,e.$Wf=q,e.$Xf=V,e.$Yf=J,e.$Zf=Ve;function L(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const R=/{(\d+)}/g;function M(Ce,...Be){return Be.length===0?Ce:Ce.replace(R,function(He,Ne){const Xe=parseInt(Ne,10);return isNaN(Xe)||Xe<0||Xe>=Be.length?He:Be[Xe]})}const p=/{([^}]+)}/g;function $(Ce,Be){return Object.keys(Be).length===0?Ce:Ce.replace(p,(He,Ne)=>Be[Ne]??He)}function S(Ce){return Ce.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(Ce){return Ce.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(Ce,Be){let He=0;const Ne=Be.charCodeAt(0);for(let Xe=Ce.length-1;Xe>=0;Xe--)Ce.charCodeAt(Xe)===Ne&&He++;return He}function y(Ce,Be,He="\u2026"){return Ce.length<=Be?Ce:`${Ce.substr(0,Be)}${He}`}function v(Ce,Be,He="\u2026"){if(Ce.length<=Be)return Ce;const Ne=Math.ceil(Be/2)-He.length/2,Xe=Math.floor(Be/2)-He.length/2;return`${Ce.substr(0,Ne)}${He}${Ce.substr(Ce.length-Xe)}`}function l(Ce,Be=" "){const He=f(Ce,Be);return a(He,Be)}function f(Ce,Be){if(!Ce||!Be)return Ce;const He=Be.length;if(He===0||Ce.length===0)return Ce;let Ne=0;for(;Ce.indexOf(Be,Ne)===Ne;)Ne=Ne+He;return Ce.substring(Ne)}function a(Ce,Be){if(!Ce||!Be)return Ce;const He=Be.length,Ne=Ce.length;if(He===0||Ne===0)return Ce;let Xe=Ne,ae=-1;for(;ae=Ce.lastIndexOf(Be,Xe-1),!(ae===-1||ae+He!==Xe);){if(ae===0)return"";Xe=ae}return Ce.substring(0,Xe)}function n(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ce){return Ce.replace(/\*/g,"")}function r(Ce,Be,He={}){if(!Ce)throw new Error("Cannot create regex from empty string");Be||(Ce=C(Ce)),He.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Ne="";return He.global&&(Ne+="g"),He.matchCase||(Ne+="i"),He.multiline&&(Ne+="m"),He.unicode&&(Ne+="u"),new RegExp(Ce,Ne)}function o(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function g(Ce){const Be=[],He=Ce.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(He.length/2);Ne++)Be.push(He[2*Ne]+(He[2*Ne+1]??""));return Be}function c(Ce){for(let Be=0,He=Ce.length;Be<He;Be++){const Ne=Ce.charCodeAt(Be);if(Ne!==32&&Ne!==9)return Be}return-1}function h(Ce,Be=0,He=Ce.length){for(let Ne=Be;Ne<He;Ne++){const Xe=Ce.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ce.substring(Be,Ne)}return Ce.substring(Be,He)}function s(Ce,Be=Ce.length-1){for(let He=Be;He>=0;He--){const Ne=Ce.charCodeAt(He);if(Ne!==32&&Ne!==9)return He}return-1}function w(Ce,Be,He){const Ne=[];let Xe=0;for(const ae of Ce.matchAll(Be)){if(Ne.push(Ce.slice(Xe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Xe=ae.index+ae[0].length,Ne.push(He(ae[0],...ae.slice(1),ae.index,Ce,ae.groups))}return Ne.push(Ce.slice(Xe)),Promise.all(Ne).then(ae=>ae.join(""))}function d(Ce,Be){return Ce<Be?-1:Ce>Be?1:0}function D(Ce,Be,He=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;He<Ne&&Xe<ae;He++,Xe++){const Ge=Ce.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge<Me)return-1;if(Ge>Me)return 1}const ce=Ne-He,Re=ae-Xe;return ce<Re?-1:ce>Re?1:0}function b(Ce,Be){return E(Ce,Be,0,Ce.length,0,Be.length)}function E(Ce,Be,He=0,Ne=Ce.length,Xe=0,ae=Be.length){for(;He<Ne&&Xe<ae;He++,Xe++){let Ge=Ce.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge===Me)continue;if(Ge>=128||Me>=128)return D(Ce.toLowerCase(),Be.toLowerCase(),He,Ne,Xe,ae);P(Ge)&&(Ge-=32),P(Me)&&(Me-=32);const tt=Ge-Me;if(tt!==0)return tt}const ce=Ne-He,Re=ae-Xe;return ce<Re?-1:ce>Re?1:0}function k(Ce){return Ce>=48&&Ce<=57}function P(Ce){return Ce>=97&&Ce<=122}function I(Ce){return Ce>=65&&Ce<=90}function j(Ce,Be){return Ce.length===Be.length&&E(Ce,Be)===0}function F(Ce,Be){const He=Be.length;return Be.length>Ce.length?!1:E(Ce,Be,0,He)===0}function z(Ce,Be){const He=Math.min(Ce.length,Be.length);let Ne;for(Ne=0;Ne<He;Ne++)if(Ce.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return He}function O(Ce,Be){const He=Math.min(Ce.length,Be.length);let Ne;const Xe=Ce.length-1,ae=Be.length-1;for(Ne=0;Ne<He;Ne++)if(Ce.charCodeAt(Xe-Ne)!==Be.charCodeAt(ae-Ne))return Ne;return He}function T(Ce){return 55296<=Ce&&Ce<=56319}function B(Ce){return 56320<=Ce&&Ce<=57343}function W(Ce,Be){return(Ce-55296<<10)+(Be-56320)+65536}function X(Ce,Be,He){const Ne=Ce.charCodeAt(He);if(T(Ne)&&He+1<Be){const Xe=Ce.charCodeAt(He+1);if(B(Xe))return W(Ne,Xe)}return Ne}function x(Ce,Be){const He=Ce.charCodeAt(Be-1);if(B(He)&&Be>1){const Ne=Ce.charCodeAt(Be-2);if(T(Ne))return W(Ne,He)}return He}class Y{get offset(){return this.e}constructor(Be,He=0){this.c=Be,this.d=Be.length,this.e=He}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=X(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Bf=Y;class Z{get offset(){return this.c.offset}constructor(Be,He=0){this.c=new Y(Be,He)}nextGraphemeLength(){const Be=be.getInstance(),He=this.c,Ne=He.offset;let Xe=Be.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const ae=He.offset,ce=Be.getGraphemeBreakType(He.nextCodePoint());if(Q(Xe,ce)){He.setOffset(ae);break}Xe=ce}return He.offset-Ne}prevGraphemeLength(){const Be=be.getInstance(),He=this.c,Ne=He.offset;let Xe=Be.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const ae=He.offset,ce=Be.getGraphemeBreakType(He.prevCodePoint());if(Q(ce,Xe)){He.setOffset(ae);break}Xe=ce}return Ne-He.offset}eol(){return this.c.eol()}}e.$Cf=Z;function ue(Ce,Be){return new Z(Ce,Be).nextGraphemeLength()}function te(Ce,Be){return new Z(Ce,Be).prevGraphemeLength()}function we(Ce,Be){Be>0&&B(Ce.charCodeAt(Be))&&Be--;const He=Be+ue(Ce,Be);return[He-te(Ce,He),He]}function Se(Ce){const Be=new Z(Ce);let He=0;for(;!Be.eol();)He++,Be.nextGraphemeLength();return He}let _;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(Ce){return _||(_=U()),_.test(Ce)}const $e=/^[\t\n\r\x20-\x7E]*$/;function Pe(Ce){return $e.test(Ce)}e.$Jf=/[\u2028\u2029]/;function se(Ce){return e.$Jf.test(Ce)}function re(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function oe(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function G(Ce,Be,He=""){const Ne=Ce.trimStart();if(Ne.length<Be)return Ne;const Xe=/\b/g;let ae=0;for(;Xe.test(Ne)&&!(Ne.length-Xe.lastIndex<Be);)ae=Xe.lastIndex,Xe.lastIndex+=1;return ae===0?Ne:He+Ne.substring(ae).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(Ce){let Be=0;for(const He of Ce.matchAll(ie))Be!==He.index&&(yield{isCode:!1,str:Ce.substring(Be,He.index)}),yield{isCode:!0,str:He[0]},Be=He.index+He[0].length;Be!==Ce.length&&(yield{isCode:!1,str:Ce.substring(Be)})}function pe(Ce){return Ce&&(Ce=Ce.replace(ie,"")),Ce}e.$Qf="\uFEFF";function Ae(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function fe(Ce){return Ae(Ce)?Ce.substr(1):Ce}function De(Ce,Be){if(!Ce||!Be||Ce.length<Be.length)return!1;const He=Be.length,Ne=Ce.toLowerCase();let Xe=0,ae=-1;for(;Xe<He;){const ce=Ne.indexOf(Be[Xe],ae+1);if(ce<0)return!1;ae=ce,Xe++}return!0}function Ie(Ce,Be=!1){return Ce?(Be&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function Te(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function q(Ce,Be=1){if(Be===0)return"";let He=-1;do He=Ce.indexOf(`
`,He+1),Be--;while(Be>0&&He>=0);return He===-1?Ce:(Ce[He-1]==="\r"&&He--,Ce.substr(0,He))}function V(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function J(Ce){return be.getInstance().getGraphemeBreakType(Ce)}function Q(Ce,Be){return Ce===0?Be!==5&&Be!==7:Ce===2&&Be===3?!1:Ce===4||Ce===2||Ce===3||Be===4||Be===2||Be===3?!0:!(Ce===8&&(Be===8||Be===9||Be===11||Be===12)||(Ce===11||Ce===9)&&(Be===9||Be===10)||(Ce===12||Ce===10)&&Be===10||Be===5||Be===13||Be===7||Ce===1||Ce===13&&Be===14||Ce===6&&Be===6)}var he;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class be{static{this.c=null}static getInstance(){return be.c||(be.c=new be),be.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const He=this.d,Ne=He.length/3;let Xe=1;for(;Xe<=Ne;)if(Be<He[3*Xe])Xe=2*Xe;else if(Be>He[3*Xe+1])Xe=2*Xe+1;else return He[3*Xe+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Ce,Be){if(Ce===0)return 0;const He=Ye(Ce,Be);if(He!==void 0)return He;const Ne=new Y(Be,Ce);return Ne.prevCodePoint(),Ne.offset}function Ye(Ce,Be){const He=new Y(Be,Ce);let Ne=He.prevCodePoint();for(;it(Ne)||Ne===65039||Ne===8419;){if(He.offset===0)return;Ne=He.prevCodePoint()}if(!oe(Ne))return;let Xe=He.offset;return Xe>0&&He.prevCodePoint()===8205&&(Xe=He.offset),Xe}function it(Ce){return 127995<=Ce&&Ce<=127999}var ot;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$1f="\xA0";class nt{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ye(Be=>{function He(tt){const ht=new Map;for(let wt=0;wt<tt.length;wt+=2)ht.set(tt[wt],tt[wt+1]);return ht}function Ne(tt,ht){const wt=new Map(tt);for(const[Lt,At]of ht)wt.set(Lt,At);return wt}function Xe(tt,ht){if(!tt)return ht;const wt=new Map;for(const[Lt,At]of tt)ht.has(Lt)&&wt.set(Lt,At);return wt}const ae=this.c.value;let ce=Be.filter(tt=>!tt.startsWith("_")&&tt in ae);ce.length===0&&(ce=["_default"]);let Re;for(const tt of ce){const ht=He(ae[tt]);Re=Xe(Re,ht)}const Ge=He(ae._common),Me=Ne(Ge,Re);return new nt(Me)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=nt;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$3f=st}),define(ke[126],Ee([1,0,27,166,14]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=R,e.$tk=p,e.$uk=$,e.$vk=C,e.$wk=w,e.$xk=d,e.$yk=I,e.$zk=j,e.$Ak=F,e.$Bk=z,e.$Ck=ne,e.$Ek=re,e.$Fk=ie,e.$Gk=me;function R(...fe){return function(De,Ie){for(let Te=0,q=fe.length;Te<q;Te++){const V=fe[Te](De,Ie);if(V)return V}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(fe,De,Ie){if(!Ie||Ie.length<De.length)return null;let Te;return fe?Te=L.$uf(Ie,De):Te=Ie.indexOf(De)===0,Te?De.length>0?[{start:0,end:De.length}]:[]:null}function p(fe,De){const Ie=De.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}function $(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}function S(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]===De[Te]){let q=null;return(q=S(fe,De,Ie+1,Te+1))?r({start:Te,end:Te+1},q):null}return S(fe,De,Ie,Te+1)}function A(fe){return 97<=fe&&fe<=122}function C(fe){return 65<=fe&&fe<=90}function m(fe){return 48<=fe&&fe<=57}function y(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function l(fe){return y(fe)||v.has(fe)}function f(fe,De){return fe===De||l(fe)&&l(De)}const a=new Map;function n(fe){if(a.has(fe))return a.get(fe);let De;const Ie=(0,N.$pk)(fe);return Ie&&(De=Ie),a.set(fe,De),De}function i(fe){return A(fe)||C(fe)||m(fe)}function r(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function o(fe,De){for(let Ie=De;Ie<fe.length;Ie++){const Te=fe.charCodeAt(Ie);if(C(Te)||m(Te)||Ie>0&&!i(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,De,Ie,Te){if(Ie===fe.length)return[];if(Te===De.length)return null;if(fe[Ie]!==De[Te].toLowerCase())return null;{let q=null,V=Te+1;for(q=t(fe,De,Ie+1,Te+1);!q&&(V=o(De,V))<De.length;)q=t(fe,De,Ie+1,V),V++;return q===null?null:r({start:Te,end:Te+1},q)}}function g(fe){let De=0,Ie=0,Te=0,q=0,V=0;for(let ze=0;ze<fe.length;ze++)V=fe.charCodeAt(ze),C(V)&&De++,A(V)&&Ie++,i(V)&&Te++,m(V)&&q++;const J=De/fe.length,Q=Ie/fe.length,he=Te/fe.length,be=q/fe.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:he,numericPercent:be}}function c(fe){const{upperPercent:De,lowerPercent:Ie}=fe;return Ie===0&&De>.6}function h(fe){const{upperPercent:De,lowerPercent:Ie,alphaPercent:Te,numericPercent:q}=fe;return Ie>.2&&De<.8&&Te>.6&&q<.2}function s(fe){let De=0,Ie=0,Te=0,q=0;for(let V=0;V<fe.length;V++)Te=fe.charCodeAt(V),C(Te)&&De++,A(Te)&&Ie++,y(Te)&&q++;return(De===0||Ie===0)&&q===0?fe.length<=30:De<=5}function w(fe,De){if(!De||(De=De.trim(),De.length===0)||!s(fe))return null;De.length>60&&(De=De.substring(0,60));const Ie=g(De);if(!h(Ie)){if(!c(Ie))return null;De=De.toLowerCase()}let Te=null,q=0;for(fe=fe.toLowerCase();q<De.length&&(Te=t(fe,De,0,q))===null;)q=o(De,q+1);return Te}function d(fe,De,Ie=!1){if(!De||De.length===0)return null;let Te=null,q=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();q<De.length&&(Te=D(fe,De,0,q,Ie),Te===null);)q=b(De,q+1);return Te}function D(fe,De,Ie,Te,q){let V=0;if(Ie===fe.length)return[];if(Te===De.length)return null;if(!f(fe.charCodeAt(Ie),De.charCodeAt(Te))){const he=n(fe.charCodeAt(Ie));if(!he)return null;for(let be=0;be<he.length;be++)if(!f(he[be],De.charCodeAt(Te+be)))return null;V+=he.length-1}let J=null,Q=Te+V+1;if(J=D(fe,De,Ie+1,Q,q),!q)for(;!J&&(Q=b(De,Q))<De.length;)J=D(fe,De,Ie+1,Q,q),Q++;if(!J)return null;if(fe.charCodeAt(Ie)!==De.charCodeAt(Te)){const he=n(fe.charCodeAt(Ie));if(!he)return J;for(let be=0;be<he.length;be++)if(he[be]!==De.charCodeAt(Te+be))return J}return r({start:Te,end:Te+V+1},J)}function b(fe,De){for(let Ie=De;Ie<fe.length;Ie++)if(l(fe.charCodeAt(Ie))||Ie>0&&l(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const E=R(e.$sk,w,p),k=R(e.$sk,w,$),P=new u.$Ec(1e4);function I(fe,De,Ie=!1){if(typeof fe!="string"||typeof De!="string")return null;let Te=P.get(fe);Te||(Te=new RegExp(L.$cf(fe),"i"),P.set(fe,Te));const q=Te.exec(De);return q?[{start:q.index,end:q.index+q[0].length}]:Ie?k(fe,De):E(fe,De)}function j(fe,De){const Ie=re(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?z(Ie):null}function F(fe,De,Ie,Te,q,V){const J=Math.min(13,fe.length);for(;Ie<J;Ie++){const Q=re(fe,De,Ie,Te,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,V]}function z(fe){if(typeof fe>"u")return[];const De=[],Ie=fe[1];for(let Te=fe.length-1;Te>1;Te--){const q=fe[Te]+Ie,V=De[De.length-1];V&&V.end===q?V.end=q+1:De.push({start:q,end:q+1})}return De}const O=128;function T(){const fe=[],De=[];for(let Ie=0;Ie<=O;Ie++)De[Ie]=0;for(let Ie=0;Ie<=O;Ie++)fe.push(De.slice(0));return fe}function B(fe){const De=[];for(let Ie=0;Ie<=fe;Ie++)De[Ie]=0;return De}const W=B(2*O),X=B(2*O),x=T(),Y=T(),Z=T(),ue=!1;function te(fe,De,Ie,Te,q){function V(Q,he,be=" "){for(;Q.length<he;)Q=be+Q;return Q}let J=` |   |${Te.split("").map(Q=>V(Q,3)).join("|")}
`;for(let Q=0;Q<=Ie;Q++)Q===0?J+=" |":J+=`${De[Q-1]}|`,J+=fe[Q].slice(0,q+1).map(he=>V(he.toString(),3)).join("|")+`
`;return J}function we(fe,De,Ie,Te){fe=fe.substr(De),Ie=Ie.substr(Te),console.log(te(Y,fe,fe.length,Ie,Ie.length)),console.log(te(Z,fe,fe.length,Ie,Ie.length)),console.log(te(x,fe,fe.length,Ie,Ie.length))}function Se(fe,De){if(De<0||De>=fe.length)return!1;const Ie=fe.codePointAt(De);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Mf(Ie)}}function _(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function U(fe,De,Ie){return De[fe]!==Ie[fe]}function ne(fe,De,Ie,Te,q,V,J=!1){for(;De<Ie&&q<V;)fe[De]===Te[q]&&(J&&(W[De]=q),De+=1),q+=1;return De===Ie}var $e;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})($e||($e={}));var Pe;(function(fe){fe.Default=[-100,0];function De(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=De})(Pe||(e.FuzzyScore=Pe={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ie){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ie}}e.$Dk=se;function re(fe,De,Ie,Te,q,V,J=se.default){const Q=fe.length>O?O:fe.length,he=Te.length>O?O:Te.length;if(Ie>=Q||V>=he||Q-Ie>he-V||!ne(De,Ie,Q,q,V,he,!0))return;oe(Q,he,Ie,V,De,q);let be=1,ze=1,Ve=Ie,Ye=V;const it=[!1];for(be=1,Ve=Ie;Ve<Q;be++,Ve++){const Be=W[Ve],He=X[Ve],Ne=Ve+1<Q?X[Ve+1]:he;for(ze=Be-V+1,Ye=Be;Ye<Ne;ze++,Ye++){let Xe=Number.MIN_SAFE_INTEGER,ae=!1;Ye<=He&&(Xe=G(fe,De,Ve,Ie,Te,q,Ye,he,V,x[be-1][ze-1]===0,it));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Xe+Y[be-1][ze-1]);const Re=Ye>Be,Ge=Re?Y[be][ze-1]+(x[be][ze-1]>0?-5:0):0,Me=Ye>Be+1&&x[be][ze-1]>0,tt=Me?Y[be][ze-2]+(x[be][ze-2]>0?-5:0):0;if(Me&&(!Re||tt>=Ge)&&(!ae||tt>=ce))Y[be][ze]=tt,Z[be][ze]=3,x[be][ze]=0;else if(Re&&(!ae||Ge>=ce))Y[be][ze]=Ge,Z[be][ze]=2,x[be][ze]=0;else if(ae)Y[be][ze]=ce,Z[be][ze]=1,x[be][ze]=x[be-1][ze-1]+1;else throw new Error("not possible")}}if(ue&&we(fe,Ie,Te,V),!it[0]&&!J.firstMatchCanBeWeak)return;be--,ze--;const ot=[Y[be][ze],V];let nt=0,st=0;for(;be>=1;){let Be=ze;do{const He=Z[be][Be];if(He===3)Be=Be-2;else if(He===2)Be=Be-1;else break}while(Be>=1);nt>1&&De[Ie+be-1]===q[V+ze-1]&&!U(Be+V-1,Te,q)&&nt+1>x[be][Be]&&(Be=ze),Be===ze?nt++:nt=1,st||(st=Be),be--,ze=Be-1,ot.push(ze)}he===Q&&J.boostFullMatch&&(ot[0]+=2);const Ce=st-Q;return ot[0]-=Ce,ot}function oe(fe,De,Ie,Te,q,V){let J=fe-1,Q=De-1;for(;J>=Ie&&Q>=Te;)q[J]===V[Q]&&(X[J]=Q,J--),Q--}function G(fe,De,Ie,Te,q,V,J,Q,he,be,ze){if(De[Ie]!==V[J])return Number.MIN_SAFE_INTEGER;let Ve=1,Ye=!1;return J===Ie-Te?Ve=fe[Ie]===q[J]?7:5:U(J,q,V)&&(J===0||!U(J-1,q,V))?(Ve=fe[Ie]===q[J]?7:5,Ye=!0):Se(V,J)&&(J===0||!Se(V,J-1))?Ve=5:(Se(V,J-1)||_(V,J-1))&&(Ve=5,Ye=!0),Ve>1&&Ie===Te&&(ze[0]=!0),Ye||(Ye=U(J,q,V)||Se(V,J-1)||_(V,J-1)),Ie===Te?J>he&&(Ve-=Ye?3:5):be?Ve+=Ye?2:0:Ve+=Ye?0:1,J+1===Q&&(Ve-=Ye?3:5),Ve}function ie(fe,De,Ie,Te,q,V,J){return pe(fe,De,Ie,Te,q,V,!0,J)}function me(fe,De,Ie,Te,q,V,J){return pe(fe,De,Ie,Te,q,V,!1,J)}function pe(fe,De,Ie,Te,q,V,J,Q){let he=re(fe,De,Ie,Te,q,V,Q);if(he&&!J)return he;if(fe.length>=3){const be=Math.min(7,fe.length-1);for(let ze=Ie+1;ze<be;ze++){const Ve=Ae(fe,ze);if(Ve){const Ye=re(Ve,Ve.toLowerCase(),Ie,Te,q,V,Q);Ye&&(Ye[0]-=3,(!he||Ye[0]>he[0])&&(he=Ye))}}}return he}function Ae(fe,De){if(De+1>=fe.length)return;const Ie=fe[De],Te=fe[De+1];if(Ie!==Te)return fe.slice(0,De)+Te+Ie+fe.slice(De+2)}}),define(ke[56],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=N,e.$fj=L,e.$gj=R,e.$hj=p,e.$jj=l;function N(a){return L(a,0)}function L(a,n){switch(typeof a){case"object":return a===null?R(349,n):Array.isArray(a)?$(a,n):S(a,n);case"string":return p(a,n);case"boolean":return M(a,n);case"number":return R(a,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(a,n){return(n<<5)-n+a|0}function M(a,n){return R(a?433:863,n)}function p(a,n){n=R(149417,n);for(let i=0,r=a.length;i<r;i++)n=R(a.charCodeAt(i),n);return n}function $(a,n){return n=R(104579,n),a.reduce((i,r)=>L(r,i),n)}function S(a,n){return n=R(181387,n),Object.keys(a).sort().reduce((i,r)=>(i=p(r,i),L(a[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$ij=A;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(a,n,i=32){const r=i-n,o=~((1<<r)-1);return(a<<n|(o&a)>>>r)>>>0}function y(a,n=0,i=a.byteLength,r=0){for(let o=0;o<i;o++)a[n+o]=r}function v(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function l(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((a>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let o=this.r,t=this.u,g,c;for(t!==0?(g=t,c=-1,t=0):(g=n.charCodeAt(0),c=0);;){let h=g;if(u.$xf(g))if(c+1<i){const s=n.charCodeAt(c+1);u.$yf(s)?(c++,h=u.$zf(g,s)):h=65533}else{t=g;break}else u.$yf(g)&&(h=65533);if(o=this.w(r,o,h),c++,c<i)g=n.charCodeAt(c);else break}this.r=o,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,i=this.q;for(let d=0;d<64;d+=4)n.setUint32(d,i.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)n.setUint32(d,m(n.getUint32(d-12,!1)^n.getUint32(d-32,!1)^n.getUint32(d-56,!1)^n.getUint32(d-64,!1),1),!1);let r=this.h,o=this.l,t=this.m,g=this.n,c=this.o,h,s,w;for(let d=0;d<80;d++)d<20?(h=o&t|~o&g,s=1518500249):d<40?(h=o^t^g,s=1859775393):d<60?(h=o&t|o&g|t&g,s=2400959708):(h=o^t^g,s=3395469782),w=m(r,5)+h+c+s+n.getUint32(d*4,!1)&4294967295,c=g,g=t,t=m(o,30),o=r,r=w;this.h=this.h+r&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+g&4294967295,this.o=this.o+c&4294967295}}e.$kj=f}),define(ke[41],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",p="warn",$="info",S="ignore";function A(m){return m?u.$tf(R,m)?L.Error:u.$tf(M,m)||u.$tf(p,m)?L.Warning:u.$tf($,m)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function C(m){switch(m){case L.Error:return R;case L.Warning:return M;case L.Info:return $;default:return S}}L.toString=C}(N||(N={})),e.default=N}),define(ke[169],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),l=this.b.charCodeAt(this.c);return v-l}value(){return this.b[this.c]}}e.$si=L;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,N.$nf)(y,this.b,0,y.length,this.c,this.d):(0,N.$pf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=R;class M{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const l=this.b.charCodeAt(v);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,N.$nf)(y,this.b,0,y.length,this.d,this.e):(0,N.$pf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,N.$of)(y,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,N.$mf)(y,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=$;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class C{static forUris(y=()=>!1,v=()=>!1){return new C(new $(y,v))}static forPaths(y=!1){return new C(new M(void 0,!y))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const l=v.slice(0);(0,u.$Xb)(l);for(const f of l)this.set(f,y)}else{const l=y.slice(0);(0,u.$Xb)(l);for(const f of l)this.set(f[0],f[1])}}set(y,v){const l=this.b.reset(y);let f;this.c||(this.c=new S,this.c.segment=l.value());const a=[];for(f=this.c;;){const i=l.cmp(f.segment);if(i>0)f.left||(f.left=new S,f.left.segment=l.value()),a.push([-1,f]),f=f.left;else if(i<0)f.right||(f.right=new S,f.right.segment=l.value()),a.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new S,f.mid.segment=l.value()),a.push([0,f]),f=f.mid;else break}const n=f.value;f.value=v,f.key=y;for(let i=a.length-1;i>=0;i--){const r=a[i][1];r.updateHeight();const o=r.balanceFactor();if(o<-1||o>1){const t=a[i][0],g=a[i+1][0];if(t===1&&g===1)a[i][1]=r.rotateLeft();else if(t===-1&&g===-1)a[i][1]=r.rotateRight();else if(t===1&&g===-1)r.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=r.rotateLeft();else if(t===-1&&g===1)r.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let l=this.c;for(;l;){const f=v.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const l=this.b.reset(y),f=[];let a=this.c;for(;a;){const n=l.cmp(a.segment);if(n>0)f.push([-1,a]),a=a.left;else if(n<0)f.push([1,a]),a=a.right;else if(l.hasNext())l.next(),f.push([0,a]),a=a.mid;else break}if(a){if(v?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:r,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=r,a.segment=o}}else{const n=a.left??a.right;if(f.length>0){const[i,r]=f[f.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const i=f[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),f[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),f[n][1]=i.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let l=this.c,f;for(;l;){const a=v.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(v.hasNext())v.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(y){return this.g(y,!1)}g(y,v){const l=this.b.reset(y);let f=this.c;for(;f;){const a=l.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this.h(f.mid):v?f.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[v,l]of this)y(l,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const v=[];return this.j(y,v),v[Symbol.iterator]()}j(y,v){y&&(y.left&&this.j(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.j(y.mid,v),y.right&&this.j(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.$wi=C}),define(ke[18],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=u,e.$5f=N,e.$6f=L,e.$7f=R,e.$8f=M,e.$9f=p,e.$0f=$,e.$$f=S,e.$_f=A,e.$ag=C,e.$bg=m,e.$cg=y,e.$dg=v,e.$eg=f,e.$fg=a,e.$gg=n,e.$hg=i,e.$ig=r;function u(o){return typeof o=="string"}function N(o){return Array.isArray(o)&&o.every(t=>u(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function M(o){return typeof o=="number"&&!isNaN(o)}function p(o){return!!o&&typeof o[Symbol.iterator]=="function"}function $(o){return o===!0||o===!1}function S(o){return typeof o>"u"}function A(o){return!C(o)}function C(o){return S(o)||o===null}function m(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function v(...o){const t=[];for(let g=0;g<o.length;g++){const c=o[g];if(C(c))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);t.push(c)}return t}const l=Object.prototype.hasOwnProperty;function f(o){if(!L(o))return!1;for(const t in o)if(l.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const g=Math.min(o.length,t.length);for(let c=0;c<g;c++)r(o[c],t[c])}function r(o,t){if(u(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=L,e.$Lj=R;const N=Object.create(null);function L(M,p){if((0,u.$4f)(p)){const $=N[p];if($===void 0)throw new Error(`${M} references an unknown codicon: ${p}`);p=$}return N[M]=p,{id:M}}function R(){return N}}),define(ke[170],Ee([1,0,99]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0,e.$Mj={add:(0,u.$Kj)("add",6e4),plus:(0,u.$Kj)("plus",6e4),gistNew:(0,u.$Kj)("gist-new",6e4),repoCreate:(0,u.$Kj)("repo-create",6e4),lightbulb:(0,u.$Kj)("lightbulb",60001),lightBulb:(0,u.$Kj)("light-bulb",60001),repo:(0,u.$Kj)("repo",60002),repoDelete:(0,u.$Kj)("repo-delete",60002),gistFork:(0,u.$Kj)("gist-fork",60003),repoForked:(0,u.$Kj)("repo-forked",60003),gitPullRequest:(0,u.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Kj)("record-keys",60005),keyboard:(0,u.$Kj)("keyboard",60005),tag:(0,u.$Kj)("tag",60006),gitPullRequestLabel:(0,u.$Kj)("git-pull-request-label",60006),tagAdd:(0,u.$Kj)("tag-add",60006),tagRemove:(0,u.$Kj)("tag-remove",60006),person:(0,u.$Kj)("person",60007),personFollow:(0,u.$Kj)("person-follow",60007),personOutline:(0,u.$Kj)("person-outline",60007),personFilled:(0,u.$Kj)("person-filled",60007),gitBranch:(0,u.$Kj)("git-branch",60008),gitBranchCreate:(0,u.$Kj)("git-branch-create",60008),gitBranchDelete:(0,u.$Kj)("git-branch-delete",60008),sourceControl:(0,u.$Kj)("source-control",60008),mirror:(0,u.$Kj)("mirror",60009),mirrorPublic:(0,u.$Kj)("mirror-public",60009),star:(0,u.$Kj)("star",60010),starAdd:(0,u.$Kj)("star-add",60010),starDelete:(0,u.$Kj)("star-delete",60010),starEmpty:(0,u.$Kj)("star-empty",60010),comment:(0,u.$Kj)("comment",60011),commentAdd:(0,u.$Kj)("comment-add",60011),alert:(0,u.$Kj)("alert",60012),warning:(0,u.$Kj)("warning",60012),search:(0,u.$Kj)("search",60013),searchSave:(0,u.$Kj)("search-save",60013),logOut:(0,u.$Kj)("log-out",60014),signOut:(0,u.$Kj)("sign-out",60014),logIn:(0,u.$Kj)("log-in",60015),signIn:(0,u.$Kj)("sign-in",60015),eye:(0,u.$Kj)("eye",60016),eyeUnwatch:(0,u.$Kj)("eye-unwatch",60016),eyeWatch:(0,u.$Kj)("eye-watch",60016),circleFilled:(0,u.$Kj)("circle-filled",60017),primitiveDot:(0,u.$Kj)("primitive-dot",60017),closeDirty:(0,u.$Kj)("close-dirty",60017),debugBreakpoint:(0,u.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Kj)("primitive-square",60018),edit:(0,u.$Kj)("edit",60019),pencil:(0,u.$Kj)("pencil",60019),info:(0,u.$Kj)("info",60020),issueOpened:(0,u.$Kj)("issue-opened",60020),gistPrivate:(0,u.$Kj)("gist-private",60021),gitForkPrivate:(0,u.$Kj)("git-fork-private",60021),lock:(0,u.$Kj)("lock",60021),mirrorPrivate:(0,u.$Kj)("mirror-private",60021),close:(0,u.$Kj)("close",60022),removeClose:(0,u.$Kj)("remove-close",60022),x:(0,u.$Kj)("x",60022),repoSync:(0,u.$Kj)("repo-sync",60023),sync:(0,u.$Kj)("sync",60023),clone:(0,u.$Kj)("clone",60024),desktopDownload:(0,u.$Kj)("desktop-download",60024),beaker:(0,u.$Kj)("beaker",60025),microscope:(0,u.$Kj)("microscope",60025),vm:(0,u.$Kj)("vm",60026),deviceDesktop:(0,u.$Kj)("device-desktop",60026),file:(0,u.$Kj)("file",60027),fileText:(0,u.$Kj)("file-text",60027),more:(0,u.$Kj)("more",60028),ellipsis:(0,u.$Kj)("ellipsis",60028),kebabHorizontal:(0,u.$Kj)("kebab-horizontal",60028),mailReply:(0,u.$Kj)("mail-reply",60029),reply:(0,u.$Kj)("reply",60029),organization:(0,u.$Kj)("organization",60030),organizationFilled:(0,u.$Kj)("organization-filled",60030),organizationOutline:(0,u.$Kj)("organization-outline",60030),newFile:(0,u.$Kj)("new-file",60031),fileAdd:(0,u.$Kj)("file-add",60031),newFolder:(0,u.$Kj)("new-folder",60032),fileDirectoryCreate:(0,u.$Kj)("file-directory-create",60032),trash:(0,u.$Kj)("trash",60033),trashcan:(0,u.$Kj)("trashcan",60033),history:(0,u.$Kj)("history",60034),clock:(0,u.$Kj)("clock",60034),folder:(0,u.$Kj)("folder",60035),fileDirectory:(0,u.$Kj)("file-directory",60035),symbolFolder:(0,u.$Kj)("symbol-folder",60035),logoGithub:(0,u.$Kj)("logo-github",60036),markGithub:(0,u.$Kj)("mark-github",60036),github:(0,u.$Kj)("github",60036),terminal:(0,u.$Kj)("terminal",60037),console:(0,u.$Kj)("console",60037),repl:(0,u.$Kj)("repl",60037),zap:(0,u.$Kj)("zap",60038),symbolEvent:(0,u.$Kj)("symbol-event",60038),error:(0,u.$Kj)("error",60039),stop:(0,u.$Kj)("stop",60039),variable:(0,u.$Kj)("variable",60040),symbolVariable:(0,u.$Kj)("symbol-variable",60040),array:(0,u.$Kj)("array",60042),symbolArray:(0,u.$Kj)("symbol-array",60042),symbolModule:(0,u.$Kj)("symbol-module",60043),symbolPackage:(0,u.$Kj)("symbol-package",60043),symbolNamespace:(0,u.$Kj)("symbol-namespace",60043),symbolObject:(0,u.$Kj)("symbol-object",60043),symbolMethod:(0,u.$Kj)("symbol-method",60044),symbolFunction:(0,u.$Kj)("symbol-function",60044),symbolConstructor:(0,u.$Kj)("symbol-constructor",60044),symbolBoolean:(0,u.$Kj)("symbol-boolean",60047),symbolNull:(0,u.$Kj)("symbol-null",60047),symbolNumeric:(0,u.$Kj)("symbol-numeric",60048),symbolNumber:(0,u.$Kj)("symbol-number",60048),symbolStructure:(0,u.$Kj)("symbol-structure",60049),symbolStruct:(0,u.$Kj)("symbol-struct",60049),symbolParameter:(0,u.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Kj)("symbol-type-parameter",60050),symbolKey:(0,u.$Kj)("symbol-key",60051),symbolText:(0,u.$Kj)("symbol-text",60051),symbolReference:(0,u.$Kj)("symbol-reference",60052),goToFile:(0,u.$Kj)("go-to-file",60052),symbolEnum:(0,u.$Kj)("symbol-enum",60053),symbolValue:(0,u.$Kj)("symbol-value",60053),symbolRuler:(0,u.$Kj)("symbol-ruler",60054),symbolUnit:(0,u.$Kj)("symbol-unit",60054),activateBreakpoints:(0,u.$Kj)("activate-breakpoints",60055),archive:(0,u.$Kj)("archive",60056),arrowBoth:(0,u.$Kj)("arrow-both",60057),arrowDown:(0,u.$Kj)("arrow-down",60058),arrowLeft:(0,u.$Kj)("arrow-left",60059),arrowRight:(0,u.$Kj)("arrow-right",60060),arrowSmallDown:(0,u.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Kj)("arrow-small-up",60064),arrowUp:(0,u.$Kj)("arrow-up",60065),bell:(0,u.$Kj)("bell",60066),bold:(0,u.$Kj)("bold",60067),book:(0,u.$Kj)("book",60068),bookmark:(0,u.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Kj)("briefcase",60076),broadcast:(0,u.$Kj)("broadcast",60077),browser:(0,u.$Kj)("browser",60078),bug:(0,u.$Kj)("bug",60079),calendar:(0,u.$Kj)("calendar",60080),caseSensitive:(0,u.$Kj)("case-sensitive",60081),check:(0,u.$Kj)("check",60082),checklist:(0,u.$Kj)("checklist",60083),chevronDown:(0,u.$Kj)("chevron-down",60084),chevronLeft:(0,u.$Kj)("chevron-left",60085),chevronRight:(0,u.$Kj)("chevron-right",60086),chevronUp:(0,u.$Kj)("chevron-up",60087),chromeClose:(0,u.$Kj)("chrome-close",60088),chromeMaximize:(0,u.$Kj)("chrome-maximize",60089),chromeMinimize:(0,u.$Kj)("chrome-minimize",60090),chromeRestore:(0,u.$Kj)("chrome-restore",60091),circleOutline:(0,u.$Kj)("circle-outline",60092),circle:(0,u.$Kj)("circle",60092),debugBreakpointUnverified:(0,u.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Kj)("circle-slash",60093),circuitBoard:(0,u.$Kj)("circuit-board",60094),clearAll:(0,u.$Kj)("clear-all",60095),clippy:(0,u.$Kj)("clippy",60096),closeAll:(0,u.$Kj)("close-all",60097),cloudDownload:(0,u.$Kj)("cloud-download",60098),cloudUpload:(0,u.$Kj)("cloud-upload",60099),code:(0,u.$Kj)("code",60100),collapseAll:(0,u.$Kj)("collapse-all",60101),colorMode:(0,u.$Kj)("color-mode",60102),commentDiscussion:(0,u.$Kj)("comment-discussion",60103),creditCard:(0,u.$Kj)("credit-card",60105),dash:(0,u.$Kj)("dash",60108),dashboard:(0,u.$Kj)("dashboard",60109),database:(0,u.$Kj)("database",60110),debugContinue:(0,u.$Kj)("debug-continue",60111),debugDisconnect:(0,u.$Kj)("debug-disconnect",60112),debugPause:(0,u.$Kj)("debug-pause",60113),debugRestart:(0,u.$Kj)("debug-restart",60114),debugStart:(0,u.$Kj)("debug-start",60115),debugStepInto:(0,u.$Kj)("debug-step-into",60116),debugStepOut:(0,u.$Kj)("debug-step-out",60117),debugStepOver:(0,u.$Kj)("debug-step-over",60118),debugStop:(0,u.$Kj)("debug-stop",60119),debug:(0,u.$Kj)("debug",60120),deviceCameraVideo:(0,u.$Kj)("device-camera-video",60121),deviceCamera:(0,u.$Kj)("device-camera",60122),deviceMobile:(0,u.$Kj)("device-mobile",60123),diffAdded:(0,u.$Kj)("diff-added",60124),diffIgnored:(0,u.$Kj)("diff-ignored",60125),diffModified:(0,u.$Kj)("diff-modified",60126),diffRemoved:(0,u.$Kj)("diff-removed",60127),diffRenamed:(0,u.$Kj)("diff-renamed",60128),diff:(0,u.$Kj)("diff",60129),diffSidebyside:(0,u.$Kj)("diff-sidebyside",60129),discard:(0,u.$Kj)("discard",60130),editorLayout:(0,u.$Kj)("editor-layout",60131),emptyWindow:(0,u.$Kj)("empty-window",60132),exclude:(0,u.$Kj)("exclude",60133),extensions:(0,u.$Kj)("extensions",60134),eyeClosed:(0,u.$Kj)("eye-closed",60135),fileBinary:(0,u.$Kj)("file-binary",60136),fileCode:(0,u.$Kj)("file-code",60137),fileMedia:(0,u.$Kj)("file-media",60138),filePdf:(0,u.$Kj)("file-pdf",60139),fileSubmodule:(0,u.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Kj)("file-symlink-file",60142),fileZip:(0,u.$Kj)("file-zip",60143),files:(0,u.$Kj)("files",60144),filter:(0,u.$Kj)("filter",60145),flame:(0,u.$Kj)("flame",60146),foldDown:(0,u.$Kj)("fold-down",60147),foldUp:(0,u.$Kj)("fold-up",60148),fold:(0,u.$Kj)("fold",60149),folderActive:(0,u.$Kj)("folder-active",60150),folderOpened:(0,u.$Kj)("folder-opened",60151),gear:(0,u.$Kj)("gear",60152),gift:(0,u.$Kj)("gift",60153),gistSecret:(0,u.$Kj)("gist-secret",60154),gist:(0,u.$Kj)("gist",60155),gitCommit:(0,u.$Kj)("git-commit",60156),gitCompare:(0,u.$Kj)("git-compare",60157),compareChanges:(0,u.$Kj)("compare-changes",60157),gitMerge:(0,u.$Kj)("git-merge",60158),githubAction:(0,u.$Kj)("github-action",60159),githubAlt:(0,u.$Kj)("github-alt",60160),globe:(0,u.$Kj)("globe",60161),grabber:(0,u.$Kj)("grabber",60162),graph:(0,u.$Kj)("graph",60163),gripper:(0,u.$Kj)("gripper",60164),heart:(0,u.$Kj)("heart",60165),home:(0,u.$Kj)("home",60166),horizontalRule:(0,u.$Kj)("horizontal-rule",60167),hubot:(0,u.$Kj)("hubot",60168),inbox:(0,u.$Kj)("inbox",60169),issueReopened:(0,u.$Kj)("issue-reopened",60171),issues:(0,u.$Kj)("issues",60172),italic:(0,u.$Kj)("italic",60173),jersey:(0,u.$Kj)("jersey",60174),json:(0,u.$Kj)("json",60175),kebabVertical:(0,u.$Kj)("kebab-vertical",60176),key:(0,u.$Kj)("key",60177),law:(0,u.$Kj)("law",60178),lightbulbAutofix:(0,u.$Kj)("lightbulb-autofix",60179),linkExternal:(0,u.$Kj)("link-external",60180),link:(0,u.$Kj)("link",60181),listOrdered:(0,u.$Kj)("list-ordered",60182),listUnordered:(0,u.$Kj)("list-unordered",60183),liveShare:(0,u.$Kj)("live-share",60184),loading:(0,u.$Kj)("loading",60185),location:(0,u.$Kj)("location",60186),mailRead:(0,u.$Kj)("mail-read",60187),mail:(0,u.$Kj)("mail",60188),markdown:(0,u.$Kj)("markdown",60189),megaphone:(0,u.$Kj)("megaphone",60190),mention:(0,u.$Kj)("mention",60191),milestone:(0,u.$Kj)("milestone",60192),gitPullRequestMilestone:(0,u.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Kj)("mortar-board",60193),move:(0,u.$Kj)("move",60194),multipleWindows:(0,u.$Kj)("multiple-windows",60195),mute:(0,u.$Kj)("mute",60196),noNewline:(0,u.$Kj)("no-newline",60197),note:(0,u.$Kj)("note",60198),octoface:(0,u.$Kj)("octoface",60199),openPreview:(0,u.$Kj)("open-preview",60200),package:(0,u.$Kj)("package",60201),paintcan:(0,u.$Kj)("paintcan",60202),pin:(0,u.$Kj)("pin",60203),play:(0,u.$Kj)("play",60204),run:(0,u.$Kj)("run",60204),plug:(0,u.$Kj)("plug",60205),preserveCase:(0,u.$Kj)("preserve-case",60206),preview:(0,u.$Kj)("preview",60207),project:(0,u.$Kj)("project",60208),pulse:(0,u.$Kj)("pulse",60209),question:(0,u.$Kj)("question",60210),quote:(0,u.$Kj)("quote",60211),radioTower:(0,u.$Kj)("radio-tower",60212),reactions:(0,u.$Kj)("reactions",60213),references:(0,u.$Kj)("references",60214),refresh:(0,u.$Kj)("refresh",60215),regex:(0,u.$Kj)("regex",60216),remoteExplorer:(0,u.$Kj)("remote-explorer",60217),remote:(0,u.$Kj)("remote",60218),remove:(0,u.$Kj)("remove",60219),replaceAll:(0,u.$Kj)("replace-all",60220),replace:(0,u.$Kj)("replace",60221),repoClone:(0,u.$Kj)("repo-clone",60222),repoForcePush:(0,u.$Kj)("repo-force-push",60223),repoPull:(0,u.$Kj)("repo-pull",60224),repoPush:(0,u.$Kj)("repo-push",60225),report:(0,u.$Kj)("report",60226),requestChanges:(0,u.$Kj)("request-changes",60227),rocket:(0,u.$Kj)("rocket",60228),rootFolderOpened:(0,u.$Kj)("root-folder-opened",60229),rootFolder:(0,u.$Kj)("root-folder",60230),rss:(0,u.$Kj)("rss",60231),ruby:(0,u.$Kj)("ruby",60232),saveAll:(0,u.$Kj)("save-all",60233),saveAs:(0,u.$Kj)("save-as",60234),save:(0,u.$Kj)("save",60235),screenFull:(0,u.$Kj)("screen-full",60236),screenNormal:(0,u.$Kj)("screen-normal",60237),searchStop:(0,u.$Kj)("search-stop",60238),server:(0,u.$Kj)("server",60240),settingsGear:(0,u.$Kj)("settings-gear",60241),settings:(0,u.$Kj)("settings",60242),shield:(0,u.$Kj)("shield",60243),smiley:(0,u.$Kj)("smiley",60244),sortPrecedence:(0,u.$Kj)("sort-precedence",60245),splitHorizontal:(0,u.$Kj)("split-horizontal",60246),splitVertical:(0,u.$Kj)("split-vertical",60247),squirrel:(0,u.$Kj)("squirrel",60248),starFull:(0,u.$Kj)("star-full",60249),starHalf:(0,u.$Kj)("star-half",60250),symbolClass:(0,u.$Kj)("symbol-class",60251),symbolColor:(0,u.$Kj)("symbol-color",60252),symbolConstant:(0,u.$Kj)("symbol-constant",60253),symbolEnumMember:(0,u.$Kj)("symbol-enum-member",60254),symbolField:(0,u.$Kj)("symbol-field",60255),symbolFile:(0,u.$Kj)("symbol-file",60256),symbolInterface:(0,u.$Kj)("symbol-interface",60257),symbolKeyword:(0,u.$Kj)("symbol-keyword",60258),symbolMisc:(0,u.$Kj)("symbol-misc",60259),symbolOperator:(0,u.$Kj)("symbol-operator",60260),symbolProperty:(0,u.$Kj)("symbol-property",60261),wrench:(0,u.$Kj)("wrench",60261),wrenchSubaction:(0,u.$Kj)("wrench-subaction",60261),symbolSnippet:(0,u.$Kj)("symbol-snippet",60262),tasklist:(0,u.$Kj)("tasklist",60263),telescope:(0,u.$Kj)("telescope",60264),textSize:(0,u.$Kj)("text-size",60265),threeBars:(0,u.$Kj)("three-bars",60266),thumbsdown:(0,u.$Kj)("thumbsdown",60267),thumbsup:(0,u.$Kj)("thumbsup",60268),tools:(0,u.$Kj)("tools",60269),triangleDown:(0,u.$Kj)("triangle-down",60270),triangleLeft:(0,u.$Kj)("triangle-left",60271),triangleRight:(0,u.$Kj)("triangle-right",60272),triangleUp:(0,u.$Kj)("triangle-up",60273),twitter:(0,u.$Kj)("twitter",60274),unfold:(0,u.$Kj)("unfold",60275),unlock:(0,u.$Kj)("unlock",60276),unmute:(0,u.$Kj)("unmute",60277),unverified:(0,u.$Kj)("unverified",60278),verified:(0,u.$Kj)("verified",60279),versions:(0,u.$Kj)("versions",60280),vmActive:(0,u.$Kj)("vm-active",60281),vmOutline:(0,u.$Kj)("vm-outline",60282),vmRunning:(0,u.$Kj)("vm-running",60283),watch:(0,u.$Kj)("watch",60284),whitespace:(0,u.$Kj)("whitespace",60285),wholeWord:(0,u.$Kj)("whole-word",60286),window:(0,u.$Kj)("window",60287),wordWrap:(0,u.$Kj)("word-wrap",60288),zoomIn:(0,u.$Kj)("zoom-in",60289),zoomOut:(0,u.$Kj)("zoom-out",60290),listFilter:(0,u.$Kj)("list-filter",60291),listFlat:(0,u.$Kj)("list-flat",60292),listSelection:(0,u.$Kj)("list-selection",60293),selection:(0,u.$Kj)("selection",60293),listTree:(0,u.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Kj)("symbol-string",60301),debugReverseContinue:(0,u.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Kj)("debug-step-back",60303),debugRestartFrame:(0,u.$Kj)("debug-restart-frame",60304),debugAlt:(0,u.$Kj)("debug-alt",60305),callIncoming:(0,u.$Kj)("call-incoming",60306),callOutgoing:(0,u.$Kj)("call-outgoing",60307),menu:(0,u.$Kj)("menu",60308),expandAll:(0,u.$Kj)("expand-all",60309),feedback:(0,u.$Kj)("feedback",60310),gitPullRequestReviewer:(0,u.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Kj)("ungroup-by-ref-type",60312),account:(0,u.$Kj)("account",60313),gitPullRequestAssignee:(0,u.$Kj)("git-pull-request-assignee",60313),bellDot:(0,u.$Kj)("bell-dot",60314),debugConsole:(0,u.$Kj)("debug-console",60315),library:(0,u.$Kj)("library",60316),output:(0,u.$Kj)("output",60317),runAll:(0,u.$Kj)("run-all",60318),syncIgnored:(0,u.$Kj)("sync-ignored",60319),pinned:(0,u.$Kj)("pinned",60320),githubInverted:(0,u.$Kj)("github-inverted",60321),serverProcess:(0,u.$Kj)("server-process",60322),serverEnvironment:(0,u.$Kj)("server-environment",60323),pass:(0,u.$Kj)("pass",60324),issueClosed:(0,u.$Kj)("issue-closed",60324),stopCircle:(0,u.$Kj)("stop-circle",60325),playCircle:(0,u.$Kj)("play-circle",60326),record:(0,u.$Kj)("record",60327),debugAltSmall:(0,u.$Kj)("debug-alt-small",60328),vmConnect:(0,u.$Kj)("vm-connect",60329),cloud:(0,u.$Kj)("cloud",60330),merge:(0,u.$Kj)("merge",60331),export:(0,u.$Kj)("export",60332),graphLeft:(0,u.$Kj)("graph-left",60333),magnet:(0,u.$Kj)("magnet",60334),notebook:(0,u.$Kj)("notebook",60335),redo:(0,u.$Kj)("redo",60336),checkAll:(0,u.$Kj)("check-all",60337),pinnedDirty:(0,u.$Kj)("pinned-dirty",60338),passFilled:(0,u.$Kj)("pass-filled",60339),circleLargeFilled:(0,u.$Kj)("circle-large-filled",60340),circleLarge:(0,u.$Kj)("circle-large",60341),circleLargeOutline:(0,u.$Kj)("circle-large-outline",60341),combine:(0,u.$Kj)("combine",60342),gather:(0,u.$Kj)("gather",60342),table:(0,u.$Kj)("table",60343),variableGroup:(0,u.$Kj)("variable-group",60344),typeHierarchy:(0,u.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Kj)("git-pull-request-create",60348),runAbove:(0,u.$Kj)("run-above",60349),runBelow:(0,u.$Kj)("run-below",60350),notebookTemplate:(0,u.$Kj)("notebook-template",60351),debugRerun:(0,u.$Kj)("debug-rerun",60352),workspaceTrusted:(0,u.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Kj)("workspace-unknown",60355),terminalCmd:(0,u.$Kj)("terminal-cmd",60356),terminalDebian:(0,u.$Kj)("terminal-debian",60357),terminalLinux:(0,u.$Kj)("terminal-linux",60358),terminalPowershell:(0,u.$Kj)("terminal-powershell",60359),terminalTmux:(0,u.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Kj)("terminal-ubuntu",60361),terminalBash:(0,u.$Kj)("terminal-bash",60362),arrowSwap:(0,u.$Kj)("arrow-swap",60363),copy:(0,u.$Kj)("copy",60364),personAdd:(0,u.$Kj)("person-add",60365),filterFilled:(0,u.$Kj)("filter-filled",60366),wand:(0,u.$Kj)("wand",60367),debugLineByLine:(0,u.$Kj)("debug-line-by-line",60368),inspect:(0,u.$Kj)("inspect",60369),layers:(0,u.$Kj)("layers",60370),layersDot:(0,u.$Kj)("layers-dot",60371),layersActive:(0,u.$Kj)("layers-active",60372),compass:(0,u.$Kj)("compass",60373),compassDot:(0,u.$Kj)("compass-dot",60374),compassActive:(0,u.$Kj)("compass-active",60375),azure:(0,u.$Kj)("azure",60376),issueDraft:(0,u.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Kj)("git-pull-request-draft",60379),debugAll:(0,u.$Kj)("debug-all",60380),debugCoverage:(0,u.$Kj)("debug-coverage",60381),runErrors:(0,u.$Kj)("run-errors",60382),folderLibrary:(0,u.$Kj)("folder-library",60383),debugContinueSmall:(0,u.$Kj)("debug-continue-small",60384),beakerStop:(0,u.$Kj)("beaker-stop",60385),graphLine:(0,u.$Kj)("graph-line",60386),graphScatter:(0,u.$Kj)("graph-scatter",60387),pieChart:(0,u.$Kj)("pie-chart",60388),bracket:(0,u.$Kj)("bracket",60175),bracketDot:(0,u.$Kj)("bracket-dot",60389),bracketError:(0,u.$Kj)("bracket-error",60390),lockSmall:(0,u.$Kj)("lock-small",60391),azureDevops:(0,u.$Kj)("azure-devops",60392),verifiedFilled:(0,u.$Kj)("verified-filled",60393),newline:(0,u.$Kj)("newline",60394),layout:(0,u.$Kj)("layout",60395),layoutActivitybarLeft:(0,u.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Kj)("layout-panel-right",60401),layoutPanel:(0,u.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Kj)("layout-statusbar",60405),layoutMenubar:(0,u.$Kj)("layout-menubar",60406),layoutCentered:(0,u.$Kj)("layout-centered",60407),target:(0,u.$Kj)("target",60408),indent:(0,u.$Kj)("indent",60409),recordSmall:(0,u.$Kj)("record-small",60410),errorSmall:(0,u.$Kj)("error-small",60411),terminalDecorationError:(0,u.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Kj)("layout-sidebar-left-off",60418),blank:(0,u.$Kj)("blank",60419),heartFilled:(0,u.$Kj)("heart-filled",60420),map:(0,u.$Kj)("map",60421),mapHorizontal:(0,u.$Kj)("map-horizontal",60421),foldHorizontal:(0,u.$Kj)("fold-horizontal",60421),mapFilled:(0,u.$Kj)("map-filled",60422),mapHorizontalFilled:(0,u.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Kj)("circle-small",60423),bellSlash:(0,u.$Kj)("bell-slash",60424),bellSlashDot:(0,u.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Kj)("search-fuzzy",60429),commentDraft:(0,u.$Kj)("comment-draft",60430),send:(0,u.$Kj)("send",60431),sparkle:(0,u.$Kj)("sparkle",60432),insert:(0,u.$Kj)("insert",60433),mic:(0,u.$Kj)("mic",60434),thumbsdownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Kj)("thumbsup-filled",60436),coffee:(0,u.$Kj)("coffee",60437),snake:(0,u.$Kj)("snake",60438),game:(0,u.$Kj)("game",60439),vr:(0,u.$Kj)("vr",60440),chip:(0,u.$Kj)("chip",60441),piano:(0,u.$Kj)("piano",60442),music:(0,u.$Kj)("music",60443),micFilled:(0,u.$Kj)("mic-filled",60444),repoFetch:(0,u.$Kj)("repo-fetch",60445),copilot:(0,u.$Kj)("copilot",60446),lightbulbSparkle:(0,u.$Kj)("lightbulb-sparkle",60447),robot:(0,u.$Kj)("robot",60448),sparkleFilled:(0,u.$Kj)("sparkle-filled",60449),diffSingle:(0,u.$Kj)("diff-single",60450),diffMultiple:(0,u.$Kj)("diff-multiple",60451),surroundWith:(0,u.$Kj)("surround-with",60452),share:(0,u.$Kj)("share",60453),gitStash:(0,u.$Kj)("git-stash",60454),gitStashApply:(0,u.$Kj)("git-stash-apply",60455),gitStashPop:(0,u.$Kj)("git-stash-pop",60456),vscode:(0,u.$Kj)("vscode",60457),vscodeInsiders:(0,u.$Kj)("vscode-insiders",60458),codeOss:(0,u.$Kj)("code-oss",60459),runCoverage:(0,u.$Kj)("run-coverage",60460),runAllCoverage:(0,u.$Kj)("run-all-coverage",60461),coverage:(0,u.$Kj)("coverage",60462),githubProject:(0,u.$Kj)("github-project",60463),mapVertical:(0,u.$Kj)("map-vertical",60464),foldVertical:(0,u.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Kj)("fold-vertical-filled",60465),goToSearch:(0,u.$Kj)("go-to-search",60466),percentage:(0,u.$Kj)("percentage",60467),sortPercentage:(0,u.$Kj)("sort-percentage",60467)}}),define(ke[78],Ee([1,0,99,170]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Nj=L;function L(){return Object.values(e.$Pj)}e.$Oj={dialogError:(0,u.$Kj)("dialog-error","error"),dialogWarning:(0,u.$Kj)("dialog-warning","warning"),dialogInfo:(0,u.$Kj)("dialog-info","info"),dialogClose:(0,u.$Kj)("dialog-close","close"),treeItemExpanded:(0,u.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Kj)("tree-item-loading","loading"),menuSelection:(0,u.$Kj)("menu-selection","check"),menuSubmenu:(0,u.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Kj)("toolbar-more","more"),quickInputBack:(0,u.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Kj)("drop-down-button",60084),symbolCustomColor:(0,u.$Kj)("symbol-customcolor",60252),exportIcon:(0,u.$Kj)("export",60332),workspaceUnspecified:(0,u.$Kj)("workspace-unspecified",60355),newLine:(0,u.$Kj)("newline",60394),thumbsDownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Kj)("thumbsup-filled",60436),gitFetch:(0,u.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Kj)("debug-breakpoint-pending",60377)},e.$Pj={...N.$Mj,...e.$Oj}}),define(ke[24],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=N,e.$Xn=L,e.$Yn=M,e.$Zn=$,e.$1n=S,e.$2n=A,e.$3n=C,e.$4n=m,e.$5n=y,e.$6n=v,e.$7n=l,e.$8n=f;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?N(r):r}),n}function L(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(R.call(i,r)){const o=i[r];typeof o=="object"&&!Object.isFrozen(o)&&!(0,u.$7f)(o)&&n.push(o)}}return a}const R=Object.prototype.hasOwnProperty;function M(a,n){return p(a,n,new Set)}function p(a,n,i){if((0,u.$ag)(a))return a;const r=n(a);if(typeof r<"u")return r;if(Array.isArray(a)){const o=[];for(const t of a)o.push(p(t,n,i));return o}if((0,u.$6f)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)R.call(a,t)&&(o[t]=p(a[t],n,i));return i.delete(a),o}return a}function $(a,n,i=!0){return(0,u.$6f)(a)?((0,u.$6f)(n)&&Object.keys(n).forEach(r=>{r in a?i&&((0,u.$6f)(a[r])&&(0,u.$6f)(n[r])?$(a[r],n[r],i):a[r]=n[r]):a[r]=n[r]}),a):n}function S(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!S(a[i],n[i]))return!1}else{const o=[];for(r in a)o.push(r);o.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!S(o,t))return!1;for(i=0;i<o.length;i++)if(!S(a[o[i]],n[o[i]]))return!1}return!0}function A(a){const n=new Set;return JSON.stringify(a,(i,r)=>{if((0,u.$6f)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function C(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],g=n[o];S(t,g)||(i[o]=g)}),i}function m(a,n){const i=n.toLowerCase(),r=Object.keys(a).find(o=>o.toLowerCase()===i);return r?a[r]:a[n]}function y(a,n){const i=Object.create(null);for(const[r,o]of Object.entries(a))n(r,o)&&(i[r]=o);return i}function v(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function l(a){const n=[];for(const i of v(a))typeof a[i]=="function"&&n.push(i);return n}function f(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},r={};for(const o of a)r[o]=i(o);return r}}),define(ke[57],Ee([1,0,78]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=L;var N;(function(M){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(n){const i=p.exec(n.id);if(!i)return $(u.$Pj.error);const[,r,o]=i,t=["codicon","codicon-"+r];return o&&t.push("codicon-modifier-"+o.substring(1)),t}M.asClassNameArray=$;function S(n){return $(n).join(" ")}M.asClassName=S;function A(n){return"."+$(n).join(".")}M.asCSSSelector=A;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=C;const m=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function y(n){const i=m.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=y;function v(n){return{id:n}}M.fromId=v;function l(n,i){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),i&&(r=`${r}~${i}`),{id:r}}M.modify=l;function f(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=f;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=a})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=$,e.$Ik=A,e.$Jk=m,e.$Kk=y,e.$Lk=l,e.$Mk=f;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function $(a){return a.replace(p,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${M.source}`,"g");function A(a){return a.replace(S,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(a){return a.indexOf(R)===-1?a:a.replace(C,(n,i,r,o)=>r?n:i||o||"")}function y(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(a){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const o=v.lastIndex,t=v.exec(a),g=a.substring(o,t?.index);if(g.length>0){n+=g;for(let c=0;c<g.length;c++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function f(a,n,i=!1){const{text:r,iconOffsets:o}=n;if(!o||o.length===0)return(0,u.$yk)(a,r,i);const t=(0,N.$af)(r," "),g=r.length-t.length,c=(0,u.$yk)(a,t,i);if(c)for(const h of c){const s=o[h.start+g]+g;h.start+=s,h.end+=s}return c}}),define(ke[127],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$1e=N,e.$2e=L;var u;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return u.test(L)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const R=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,S="";return S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+="-",S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S+=M[R[$++]],S}}()}),define(ke[172],Ee([1,0,19,39,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=R,e.$Ht=M,e.$Jt=S;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function M(C,m,y){const v={id:(0,L.$Mg)(),name:C,uri:m,data:y};return{asString:async()=>"",asFile:()=>v,value:void 0}}class p{constructor(){this.a=new Map}get size(){let m=0;for(const y of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const y=[...this.a.keys()];return N.Iterable.some(this,([v,l])=>l.asFile())&&y.push("files"),A($(m),y)}get(m){return this.a.get(this.b(m))?.[0]}append(m,y){const v=this.a.get(m);v?v.push(y):this.a.set(this.b(m),[y])}replace(m,y){this.a.set(this.b(m),[y])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,y]of this.a)for(const v of y)yield[m,v]}b(m){return $(m)}}e.$It=p;function $(C){return C.toLowerCase()}function S(C,m){return A($(C),m.map($))}function A(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const y=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[v,l,f]=y;return f==="*"?m.some(a=>a.startsWith(l+"/")):!1}e.$Kt=Object.freeze({create:C=>(0,u.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Kt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N,e.$Qg=R;function N(p,$,S,A=1){let C=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!C)return C=!0,m(0)},S);L(p,$,A,v=>{if(!C)return C=!0,clearTimeout(y),m(v)})})}function L(p,$,S,A){if($===0)return A(0);const C=new u.Socket;C.once("connect",()=>(M(C),L(p+S,$-1,S,A))),C.once("data",()=>{}),C.once("error",m=>(M(C),m.code!=="ECONNREFUSED"?L(p+S,$-1,S,A):A(p))),C.connect(p,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(p,$,S,A="127.0.0.1"){let C=!1,m,y=1;const v=u.createServer({pauseOnConnect:!0});function l(f,a){C||(C=!0,v.removeAllListeners(),v.close(),m&&clearTimeout(m),a(f))}return new Promise(f=>{m=setTimeout(()=>{l(0,f)},S),v.on("listening",()=>{l(p,f)}),v.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&y<$?(p++,y++,v.listen(p,A)):l(0,f)}),v.on("close",()=>{l(0,f)}),v.listen(p,A)})}function M(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch($){console.error($)}}}),define(ke[128],Ee([1,0,127]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$yt=void 0;class N{constructor(p){const $=(0,u.$1e)(p);this.c=$,this.a=N.d($),this.b=new Map}static d(p){const $=new Uint8Array(256);return $.fill(p),$}set(p,$){const S=(0,u.$1e)($);p>=0&&p<256?this.a[p]=S:this.b.set(p,S)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$yt=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$zt=R}),define(ke[174],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var u;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(L){let R=0,M=0,p=0,$=0;for(let S=0,A=L.length;S<A;S++){const C=L.charCodeAt(S);C===13?(R===0&&(M=S),R++,S+1<A&&L.charCodeAt(S+1)===10?($|=2,S++):$|=3,p=S+1):C===10&&($|=1,R===0&&(M=S),R++,p=S+1)}return R===0&&(M=L.length),[R,M,L.length-p,$]}}),define(ke[50],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0;class u{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new u(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return u.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return u.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return u.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,p=R.lineNumber|0;if(M===p){const $=L.column|0,S=R.column|0;return $-S}return M-p}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new u(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$jt=u}),define(ke[29],Ee([1,0,50]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;class N{constructor(R,M,p,$){R>p||R===p&&M>$?(this.startLineNumber=p,this.startColumn=$,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=p,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let p,$,S,A;return M.startLineNumber<R.startLineNumber?(p=M.startLineNumber,$=M.startColumn):M.startLineNumber===R.startLineNumber?(p=M.startLineNumber,$=Math.min(M.startColumn,R.startColumn)):(p=R.startLineNumber,$=R.startColumn),M.endLineNumber>R.endLineNumber?(S=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(S=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(S=R.endLineNumber,A=R.endColumn),new N(p,$,S,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let p=R.startLineNumber,$=R.startColumn,S=R.endLineNumber,A=R.endColumn;const C=M.startLineNumber,m=M.startColumn,y=M.endLineNumber,v=M.endColumn;return p<C?(p=C,$=m):p===C&&($=Math.max($,m)),S>y?(S=y,A=v):S===y&&(A=Math.min(A,v)),p>S||p===S&&$>A?null:new N(p,$,S,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new u.$jt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new u.$jt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const S=R.startLineNumber|0,A=M.startLineNumber|0;if(S===A){const C=R.startColumn|0,m=M.startColumn|0;if(C===m){const y=R.endLineNumber|0,v=M.endLineNumber|0;if(y===v){const l=R.endColumn|0,f=M.endColumn|0;return l-f}return y-v}return C-m}return S-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$kt=N}),define(ke[175],Ee([1,0,29]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;class N{static insert(R,M){return{range:new u.$kt(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$lt=N}),define(ke[176],Ee([1,0,50,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$kt{constructor(p,$,S,A){super(p,$,S,A),this.selectionStartLineNumber=p,this.selectionStartColumn=$,this.positionLineNumber=S,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return R.selectionsEqual(this,p)}static selectionsEqual(p,$){return p.selectionStartLineNumber===$.selectionStartLineNumber&&p.selectionStartColumn===$.selectionStartColumn&&p.positionLineNumber===$.positionLineNumber&&p.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,$){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,p,$):new R(p,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,$){return this.getDirection()===0?new R(p,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,p,$)}static fromPositions(p,$=p){return new R(p.lineNumber,p.column,$.lineNumber,$.column)}static fromRange(p,$){return $===0?new R(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new R(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new R(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,$){if(p&&!$||!p&&$)return!1;if(!p&&!$)return!0;if(p.length!==$.length)return!1;for(let S=0,A=p.length;S<A;S++)if(!this.selectionsEqual(p[S],$[S]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,$,S,A,C){return C===0?new R(p,$,S,A):new R(S,A,p,$)}}e.$mt=R}),define(ke[177],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.WordCharacterClass=void 0,e.$Bt=p;var L;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$yt{constructor(S,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,m=S.length;C<m;C++)this.set(S.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,A){let C=null;for(const m of this.h(S)){if(m.index>A)break;C=m}return C}findNextIntlWordAtOrAfterOffset(S,A){for(const C of this.h(S))if(!(C.index<A))return C;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const A=[];for(const C of S)this.k(C)&&A.push(C);return A}k(S){return!!S.isWordLike}}e.$At=R;const M=new u.$Ec(10);function p($,S){const A=`${$}/${S.join(",")}`;let C=M.get(A);return C||(C=new R($,S),M.set(A,C)),C}}),define(ke[129],Ee([1,0,39,3,75]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0,e.$Xs=M,e.$Ys=$,e.$Zs=S,e.$Vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$Vs)C.indexOf(y)>=0||(m+="\\"+y);return m+="\\s]+)",new RegExp(m,"g")}e.$Ws=R();function M(C){let m=e.$Ws;if(C&&C instanceof RegExp)if(C.global)m=C;else{let y="g";C.ignoreCase&&(y+="i"),C.multiline&&(y+="m"),C.unicode&&(y+="u"),m=new RegExp(C.source,y)}return m.lastIndex=0,m}const p=new L.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=p.unshift(C);return(0,N.$Sc)(m)}function S(C,m,y,v,l){if(m=M(m),l||(l=u.Iterable.first(p)),y.length>l.maxLen){let r=C-l.maxLen/2;return r<0?r=0:v+=r,y=y.substring(r,C+l.maxLen/2),S(C,m,y,v,l)}const f=Date.now(),a=C-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-f>=l.timeBudget);r++){const o=a-l.windowSize*r;m.lastIndex=Math.max(0,o);const t=A(m,y,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return m.lastIndex=0,r}return null}function A(C,m,y,v){let l;for(;l=C.exec(m);){const f=l.index||0;if(f<=y&&C.lastIndex>=y)return l;if(v>0&&f>v)return null}return null}}),define(ke[179],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,S=p.notIn.length;$<S;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const S=p.findTokenIndexAtOffset($-2),A=p.getStandardTokenType(S);return this.isOK(A)}g(p,$){for(let S=p;S<=$;S++){const A=String.fromCharCode(S);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class L{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)R(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),R(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),R(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),R(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&R(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$bu=L;function R(M,p,$){M.has(p)?M.get(p).push($):M.set(p,[$])}}),define(ke[180],Ee([1,0,128]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42=e.$32=e.State=void 0,e.$52=m;var N;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(v,l,f){const a=new Uint8Array(v*l);for(let n=0,i=v*l;n<i;n++)a[n]=f;this.a=a,this.rows=v,this.cols=l}get(v,l){return this.a[v*this.cols+l]}set(v,l,f){this.a[v*this.cols+l]=f}}class R{constructor(v){let l=0,f=0;for(let n=0,i=v.length;n<i;n++){const[r,o,t]=v[n];o>l&&(l=o),r>f&&(f=r),t>f&&(f=t)}l++,f++;const a=new L(f,l,0);for(let n=0,i=v.length;n<i;n++){const[r,o,t]=v[n];a.set(r,o,t)}this.a=a,this.b=l}nextState(v,l){return l<0||l>=this.b?0:this.a.get(v,l)}}e.$32=R;let M=null;function p(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})($||($={}));let S=null;function A(){if(S===null){S=new u.$yt(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<y.length;l++)S.set(y.charCodeAt(l),1);const v=".,;:";for(let l=0;l<v.length;l++)S.set(v.charCodeAt(l),2)}return S}class C{static a(v,l,f,a,n){let i=n-1;do{const r=l.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>a);if(a>0){const r=l.charCodeAt(a-1),o=l.charCodeAt(i);(r===40&&o===41||r===91&&o===93||r===123&&o===125)&&i--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:i+2},url:l.substring(a,i+1)}}static computeLinks(v,l=p()){const f=A(),a=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),o=r.length;let t=0,g=0,c=0,h=1,s=!1,w=!1,d=!1,D=!1;for(;t<o;){let b=!1;const E=r.charCodeAt(t);if(h===13){let k;switch(E){case 40:s=!0,k=0;break;case 41:k=s?0:1;break;case 91:d=!0,w=!0,k=0;break;case 93:d=!1,k=w?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:case 34:case 96:c===E?k=1:c===39||c===34||c===96?k=0:k=1;break;case 42:k=c===42?1:0;break;case 124:k=c===124?1:0;break;case 32:k=d?0:1;break;default:k=f.get(E)}k===1&&(a.push(C.a(f,r,n,g,t)),b=!0)}else if(h===12){let k;E===91?(w=!0,k=0):k=f.get(E),k===1?b=!0:h=13}else h=l.nextState(h,E),h===0&&(b=!0);b&&(h=1,s=!1,w=!1,D=!1,g=t+1,c=E),t++}h===13&&a.push(C.a(f,r,n,g,o))}return a}}e.$42=C;function m(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:C.computeLinks(y)}}),define(ke[79],Ee([1,0,24]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$vv=e.$uv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$wv=v,e.$Av=r;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var p;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(p||(e.InjectedTextCursorStops=p={}));var $;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var S;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var A;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$1n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$uv=C;class m{constructor(t,g){this._findMatchBrand=void 0,this.range=t,this.matches=g}}e.$vv=m;var y;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function v(o){return o&&typeof o.read=="function"}var l;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(l||(e.PositionAffinity=l={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,g,c,h,s,w){this.identifier=t,this.range=g,this.text=c,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=s,this._isTracked=w}}e.$xv=a;class n{constructor(t,g,c){this.regex=t,this.wordSeparators=g,this.simpleSearch=c}}e.$yv=n;class i{constructor(t,g,c){this.reverseEdits=t,this.changes=g,this.trimAutoWhitespaceLineNumbers=c}}e.$zv=i;function r(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.NodeColor=e.$pC=void 0,e.$rC=L,e.$sC=R,e.$tC=S,e.$uC=A,e.$vC=C,e.$wC=m,e.$xC=y,e.$yC=v;class u{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$qC)return L(this.right);let f=this;for(;f.parent!==e.$qC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$qC?e.$qC:f.parent}prev(){if(this.left!==e.$qC)return R(this.left);let f=this;for(;f.parent!==e.$qC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$qC?e.$qC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$pC=u;var N;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$qC=new u(null,0),e.$qC.parent=e.$qC,e.$qC.left=e.$qC,e.$qC.right=e.$qC,e.$qC.color=0;function L(l){for(;l.left!==e.$qC;)l=l.left;return l}function R(l){for(;l.right!==e.$qC;)l=l.right;return l}function M(l){return l===e.$qC?0:l.size_left+l.piece.length+M(l.right)}function p(l){return l===e.$qC?0:l.lf_left+l.piece.lineFeedCnt+p(l.right)}function $(){e.$qC.parent=e.$qC}function S(l,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.$qC&&(a.left.parent=f),a.parent=f.parent,f.parent===e.$qC?l.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function A(l,f){const a=f.left;f.left=a.right,a.right!==e.$qC&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.$qC?l.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function C(l,f){let a,n;if(f.left===e.$qC?(n=f,a=n.right):f.right===e.$qC?(n=f,a=n.left):(n=L(f.right),a=n.right),n===l.root){l.root=a,a.color=0,f.detach(),$(),l.root.parent=e.$qC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===f?(a.parent=n.parent,v(l,a)):(n.parent===f?a.parent=n:a.parent=n.parent,v(l,a),n.left=f.left,n.right=f.right,n.parent=f.parent,n.color=f.color,f===l.root?l.root=n:f===f.parent.left?f.parent.left=n:f.parent.right=n,n.left!==e.$qC&&(n.left.parent=n),n.right!==e.$qC&&(n.right.parent=n),n.size_left=f.size_left,n.lf_left=f.lf_left,v(l,n)),f.detach(),a.parent.left===a){const o=M(a),t=p(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const g=o-a.parent.size_left,c=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,y(l,a.parent,g,c)}}if(v(l,a.parent),i){$();return}let r;for(;a!==l.root&&a.color===0;)a===a.parent.left?(r=a.parent.right,r.color===1&&(r.color=0,a.parent.color=1,S(l,a.parent),r=a.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(l,r),r=a.parent.right),r.color=a.parent.color,a.parent.color=0,r.right.color=0,S(l,a.parent),a=l.root)):(r=a.parent.left,r.color===1&&(r.color=0,a.parent.color=1,A(l,a.parent),r=a.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,a=a.parent):(r.left.color===0&&(r.right.color=0,r.color=1,S(l,r),r=a.parent.left),r.color=a.parent.color,a.parent.color=0,r.left.color=0,A(l,a.parent),a=l.root));a.color=0,$()}function m(l,f){for(v(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,S(l,f)),f.parent.color=0,f.parent.parent.color=1,A(l,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,A(l,f)),f.parent.color=0,f.parent.parent.color=1,S(l,f.parent.parent))}l.root.color=0}function y(l,f,a,n){for(;f!==l.root&&f!==e.$qC;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}function v(l,f){let a=0,n=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,a=M(f.left)-f.size_left,n=p(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=n;f!==l.root&&(a!==0||n!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}}}),define(ke[182],Ee([1,0,19,127]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=void 0;class L{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,S){$=(0,N.$2e)($);const A=this.a,C=this.b,m=S.length;return m===0?!1:(this.a=new Uint32Array(A.length+m),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+m),this.a.set(S,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,S){return $=(0,N.$2e)($),S=(0,N.$2e)(S),this.a[$]===S?!1:(this.a[$]=S,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,S){$=(0,N.$2e)($),S=(0,N.$2e)(S);const A=this.a,C=this.b;if($>=A.length)return!1;const m=A.length-$;return S>=m&&(S=m),S===0?!1:(this.a=new Uint32Array(A.length-S),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+S),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$2e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),$>=this.a.length&&($=this.a.length-1);for(let A=S;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let S=0,A=this.a.length-1,C=0,m=0,y=0;for(;S<=A;)if(C=S+(A-S)/2|0,m=this.b[C],y=m-this.a[C],$<y)A=C-1;else if($>=m)S=C+1;else break;return new M(C,$-y)}}e.$Mv=L;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const S=this.e[$],A=S>0?this.d[S-1]:0;return new M(S,$-A)}removeValues($,S){this.a.splice($,S),this.f($)}insertValues($,S){this.a=(0,u.$Wb)(this.a,$,S),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,S=this.a.length;$<S;$++){const A=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+A;for(let m=0;m<A;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,S){this.a[$]!==S&&(this.a[$]=S,this.f($))}}e.$Nv=R;class M{constructor($,S){this.index=$,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=S}}e.$Ov=M}),define(ke[183],Ee([1,0,14,50,182]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=void 0;class R{constructor(p,$,S,A){this.d=p,this.f=$,this.g=S,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const $=p.changes;for(const S of $)this.o(S.range),this.p(new N.$jt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,$=this.f.length,S=new Uint32Array($);for(let A=0;A<$;A++)S[A]=this.f[A].length+p;this.j=new L.$Mv(S)}}n(p,$){this.f[p]=$,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,$){if($.length===0)return;const S=(0,u.$gf)($);if(S.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+S[0]+this.f[p.lineNumber-1].substring(p.column-1));return}S[S.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+S[0]);const A=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(p.lineNumber+C-1,0,S[C]),A[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Pv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EC=e.$CC=e.$zC=void 0,e.$AC=S,e.$BC=A,e.$DC=l;const p=999;class ${constructor(n,i,r,o){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$ef(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$yv(i,this.wordSeparators?(0,N.$Bt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$zC=$;function S(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const r=a.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function A(a,n,i){if(!i)return new M.$vv(a,null);const r=[];for(let o=0,t=n.length;o<t;o++)r[o]=n[o];return new M.$vv(a,r)}class C{constructor(n){const i=[];let r=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[r++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;r<o;){const t=r+((o-r)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(r=t,o=t):r=t+1}return r+1}}class m{static findMatches(n,i,r,o,t){const g=i.parseSearchRequest();return g?g.regex.multiline?this.b(n,r,new f(g.wordSeparators,g.regex),o,t):this.c(n,r,g,o,t):[]}static a(n,i,r,o,t,g){let c,h=0;o?(h=o.findLineFeedCountBeforeOffset(t),c=i+t+h):c=i+t;let s;if(o){const b=o.findLineFeedCountBeforeOffset(t+g.length)-h;s=c+g.length+b}else s=c+g.length;const w=n.getPositionAt(c),d=n.getPositionAt(s);return new R.$kt(w.lineNumber,w.column,d.lineNumber,d.column)}static b(n,i,r,o,t){const g=n.getOffsetAt(i.getStartPosition()),c=n.getValueInRange(i,1),h=n.getEOL()===`\r
`?new C(c):null,s=[];let w=0,d;for(r.reset(0);d=r.next(c);)if(s[w++]=A(this.a(n,g,c,h,d.index,d[0]),d,o),w>=t)return s;return s}static c(n,i,r,o,t){const g=[];let c=0;if(i.startLineNumber===i.endLineNumber){const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return c=this.d(r,s,i.startLineNumber,i.startColumn-1,c,g,o,t),g}const h=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);c=this.d(r,h,i.startLineNumber,i.startColumn-1,c,g,o,t);for(let s=i.startLineNumber+1;s<i.endLineNumber&&c<t;s++)c=this.d(r,n.getLineContent(s),s,0,c,g,o,t);if(c<t){const s=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);c=this.d(r,s,i.endLineNumber,0,c,g,o,t)}return g}static d(n,i,r,o,t,g,c,h){const s=n.wordSeparators;if(!c&&n.simpleSearch){const D=n.simpleSearch,b=D.length,E=i.length;let k=-b;for(;(k=i.indexOf(D,k+b))!==-1;)if((!s||l(s,i,E,k,b))&&(g[t++]=new M.$vv(new R.$kt(r,k+1+o,r,k+1+b+o),null),t>=h))return t;return t}const w=new f(n.wordSeparators,n.regex);let d;w.reset(0);do if(d=w.next(i),d&&(g[t++]=A(new R.$kt(r,d.index+1+o,r,d.index+1+d[0].length+o),d,c),t>=h))return t;while(d);return t}static findNextMatch(n,i,r,o){const t=i.parseSearchRequest();if(!t)return null;const g=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,g,o):this.f(n,r,g,o)}static e(n,i,r,o){const t=new L.$jt(i.lineNumber,1),g=n.getOffsetAt(t),c=n.getLineCount(),h=n.getValueInRange(new R.$kt(t.lineNumber,t.column,c,n.getLineMaxColumn(c)),1),s=n.getEOL()===`\r
`?new C(h):null;r.reset(i.column-1);const w=r.next(h);return w?A(this.a(n,g,h,s,w.index,w[0]),w,o):i.lineNumber!==1||i.column!==1?this.e(n,new L.$jt(1,1),r,o):null}static f(n,i,r,o){const t=n.getLineCount(),g=i.lineNumber,c=n.getLineContent(g),h=this.g(r,c,g,i.column,o);if(h)return h;for(let s=1;s<=t;s++){const w=(g+s-1)%t,d=n.getLineContent(w+1),D=this.g(r,d,w+1,1,o);if(D)return D}return null}static g(n,i,r,o,t){n.reset(o-1);const g=n.next(i);return g?A(new R.$kt(r,g.index+1,r,g.index+1+g[0].length),g,t):null}static findPreviousMatch(n,i,r,o){const t=i.parseSearchRequest();if(!t)return null;const g=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,g,o):this.j(n,r,g,o)}static h(n,i,r,o){const t=this.b(n,new R.$kt(1,1,i.lineNumber,i.column),r,o,10*p);if(t.length>0)return t[t.length-1];const g=n.getLineCount();return i.lineNumber!==g||i.column!==n.getLineMaxColumn(g)?this.h(n,new L.$jt(g,n.getLineMaxColumn(g)),r,o):null}static j(n,i,r,o){const t=n.getLineCount(),g=i.lineNumber,c=n.getLineContent(g).substring(0,i.column-1),h=this.k(r,c,g,o);if(h)return h;for(let s=1;s<=t;s++){const w=(t+g-s-1)%t,d=n.getLineContent(w+1),D=this.k(r,d,w+1,o);if(D)return D}return null}static k(n,i,r,o){let t=null,g;for(n.reset(0);g=n.next(i);)t=A(new R.$kt(r,g.index+1,r,g.index+1+g[0].length),g,o);return t}}e.$CC=m;function y(a,n,i,r,o){if(r===0)return!0;const t=n.charCodeAt(r-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const g=n.charCodeAt(r);if(a.get(g)!==0)return!0}return!1}function v(a,n,i,r,o){if(r+o===i)return!0;const t=n.charCodeAt(r+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const g=n.charCodeAt(r+o-1);if(a.get(g)!==0)return!0}return!1}function l(a,n,i,r,o){return y(a,n,i,r,o)&&v(a,n,i,r,o)}class f{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const o=r.index,t=r[0].length;if(o===this.b&&t===this.c){if(t===0){u.$Af(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||l(this._wordSeparators,n,i,o,t))return r}while(r);return null}}e.$EC=f}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.$HC=void 0,e.$FC=A,e.$GC=C;const p=65535;function $(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class S{constructor(n,i,r,o,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=o,this.isBasicASCII=t}}function A(a,n=!0){const i=[0];let r=1;for(let o=0,t=a.length;o<t;o++){const g=a.charCodeAt(o);g===13?o+1<t&&a.charCodeAt(o+1)===10?(i[r++]=o+2,o++):i[r++]=o+1:g===10&&(i[r++]=o+1)}return n?$(i):i}function C(a,n){a.length=0,a[0]=0;let i=1,r=0,o=0,t=0,g=!0;for(let h=0,s=n.length;h<s;h++){const w=n.charCodeAt(h);w===13?h+1<s&&n.charCodeAt(h+1)===10?(t++,a[i++]=h+2,h++):(r++,a[i++]=h+1):w===10?(o++,a[i++]=h+1):g&&w!==9&&(w<32||w>126)&&(g=!1)}const c=new S($(a),r,o,t,g);return a.length=0,c}class m{constructor(n,i,r,o,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=o,this.length=t}}e.$HC=m;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$IC=y;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$qC&&n.iterate(n.root,r=>(r!==R.$qC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let o=0;o<r.length;o++){const t=r[o];if(t.node.parent===null||t.nodeStartOffset>=n){r[o]=null,i=!0;continue}}if(i){const o=[];for(const t of r)t!==null&&o.push(t);this.b=o}}}class f{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=R.$qC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let o=null;for(let t=0,g=n.length;t<g;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const c=new m(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,c)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,r=i-Math.floor(i/3),o=r*2;let t="",g=0;const c=[];if(this.iterate(this.root,h=>{const s=this.R(h),w=s.length;if(g<=r||g+w<o)return t+=s,g+=w,!0;const d=t.replace(/\r\n|\r|\n/g,n);return c.push(new y(d,A(d))),t=s,g=w,!0}),g>0){const h=t.replace(/\r\n|\r|\n/g,n);c.push(new y(h,A(h)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$qC)return!0;const t=this.R(o),g=t.length,c=n.G(i),h=n.G(i+g),s=n.getValueInRange2(c,h);return i+=g,t===s})}getOffsetAt(n,i){let r=0,o=this.root;for(;o!==R.$qC;)if(o.left!==R.$qC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){r+=o.size_left;const t=this.B(o,n-o.lf_left-2);return r+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const o=n;for(;i!==R.$qC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const g=this.getOffsetAt(r+1,1),c=o-g;return new u.$jt(r+1,c+1)}return new u.$jt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$qC){const t=this.getOffsetAt(r+1,1),g=o-n-t;return new u.$jt(r+1,g+1)}else i=i.right;return new u.$jt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,h=this.a[c.piece.bufferIndex].buffer,s=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(s+n.remainder,s+i.remainder)}let r=n.node;const o=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let g=o.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==R.$qC;){const c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){g+=c.substring(h,h+i.remainder);break}else g+=c.substr(h,r.piece.length);r=r.next()}return g}getLinesContent(){const n=[];let i=0,r="",o=!1;return this.iterate(this.root,t=>{if(t===R.$qC)return!0;const g=t.piece;let c=g.length;if(c===0)return!0;const h=this.a[g.bufferIndex].buffer,s=this.a[g.bufferIndex].lineStarts,w=g.start.line,d=g.end.line;let D=s[w]+g.start.column;if(o&&(h.charCodeAt(D)===10&&(D++,c--),n[i++]=r,r="",o=!1,c===0))return!0;if(w===d)return!this.f&&h.charCodeAt(D+c-1)===13?(o=!0,r+=h.substr(D,c-1)):r+=h.substr(D,c),!0;r+=this.f?h.substring(D,Math.max(D,s[w+1]-this.e)):h.substring(D,s[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let b=w+1;b<d;b++)r=this.f?h.substring(s[b],s[b+1]-this.e):h.substring(s[b],s[b+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&h.charCodeAt(s[d]+g.end.column-1)===13?(o=!0,g.end.column===0?i--:r=h.substr(s[d],g.end.column-1)):r=h.substr(s[d],g.end.column),!0}),o&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,o,t,g,c,h,s,w,d){const D=this.a[n.piece.bufferIndex],b=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,g);let P;const I={line:0,column:0};let j,F;i._wordSeparators?(j=D.buffer.substring(E,k),F=z=>z+E,i.reset(0)):(j=D.buffer,F=z=>z,i.reset(E));do if(P=i.next(j),P){if(F(P.index)>=k)return w;this.s(n,F(P.index)-b,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+o:I.column+1,T=O+P[0].length;if(d[w++]=(0,M.$BC)(new N.$kt(r+z,O,r+z,T),P,h),F(P.index)+P[0].length>=k||w>=s)return w}while(P);return w}findMatchesLineByLine(n,i,r,o){const t=[];let g=0;const c=new M.$EC(i.wordSeparators,i.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const s=this.H(n.endLineNumber,n.endColumn);if(s===null)return[];let w=this.s(h.node,h.remainder);const d=this.s(s.node,s.remainder);if(h.node===s.node)return this.findMatchesInNode(h.node,c,n.startLineNumber,n.startColumn,w,d,i,r,o,g,t),t;let D=n.startLineNumber,b=h.node;for(;b!==s.node;){const k=this.t(b.piece.bufferIndex,w,b.piece.end);if(k>=1){const I=this.a[b.piece.bufferIndex].lineStarts,j=this.u(b.piece.bufferIndex,b.piece.start),F=I[w.line+k],z=D===n.startLineNumber?n.startColumn:1;if(g=this.findMatchesInNode(b,c,D,z,w,this.s(b,F-j),i,r,o,g,t),g>=o)return t;D+=k}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(P,n.endColumn-1);return g=this.n(i,c,I,n.endLineNumber,P,g,t,r,o),t}if(g=this.n(i,c,this.getLineContent(D).substr(P),D,P,g,t,r,o),g>=o)return t;D++,h=this.H(D,1),b=h.node,w=this.s(h.node,h.remainder)}if(D===n.endLineNumber){const k=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(k,n.endColumn-1);return g=this.n(i,c,P,n.endLineNumber,k,g,t,r,o),t}const E=D===n.startLineNumber?n.startColumn:1;return g=this.findMatchesInNode(s.node,c,D,E,w,d,i,r,o,g,t),t}n(n,i,r,o,t,g,c,h,s){const w=n.wordSeparators;if(!h&&n.simpleSearch){const D=n.simpleSearch,b=D.length,E=r.length;let k=-b;for(;(k=r.indexOf(D,k+b))!==-1;)if((!w||(0,M.$DC)(w,r,E,k,b))&&(c[g++]=new L.$vv(new N.$kt(o,k+1+t,o,k+1+b+t),null),g>=s))return g;return g}let d;i.reset(0);do if(d=i.next(r),d&&(c[g++]=(0,M.$BC)(new N.$kt(o,d.index+1+t,o,d.index+1+d[0].length+t),d,h),g>=s))return g;while(d);return g}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$qC){const{node:o,remainder:t,nodeStartOffset:g}=this.G(n),c=o.piece,h=c.bufferIndex,s=this.s(o,t);if(o.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&g+c.length===n&&i.length<p){this.F(o,i),this.y();return}if(g===n)this.o(i,o),this.h.validate(n);else if(g+o.piece.length>n){const w=[];let d=new m(c.bufferIndex,s,c.end,this.t(c.bufferIndex,s,c.end),this.u(h,c.end)-this.u(h,s));if(this.K()&&this.M(i)&&this.I(o,t)===10){const k={line:d.start.line+1,column:0};d=new m(d.bufferIndex,k,d.end,this.t(d.bufferIndex,k,d.end),d.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const k=this.s(o,t-1);this.C(o,k),i="\r"+i,o.piece.length===0&&w.push(o)}else this.C(o,s);else this.C(o,s);const D=this.w(i);d.length>0&&this.S(o,d);let b=o;for(let E=0;E<D.length;E++)b=this.S(b,D[E]);this.v(w)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let g=1;g<o.length;g++)t=this.S(t,o[g])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$qC)return;const r=this.G(n),o=this.G(n+i),t=r.node,g=o.node;if(t===g){const D=this.s(t,r.remainder),b=this.s(t,o.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,R.$vC)(this,t),this.N(E),this.y();return}this.D(t,b),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,b),this.y();return}const c=[],h=this.s(t,r.remainder);this.C(t,h),this.h.validate(n),t.piece.length===0&&c.push(t);const s=this.s(g,o.remainder);this.D(g,s),g.piece.length===0&&c.push(g);const w=t.next();for(let D=w;D!==R.$qC&&D!==g;D=D.next())c.push(D);const d=t.piece.length===0?t.prev():t;this.v(c),this.O(d),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const g=i.piece,c={line:g.start.line+1,column:0},h=new m(g.bufferIndex,c,g.end,this.t(g.bufferIndex,c,g.end),g.length-1);i.piece=h,n+=`
`,(0,R.$xC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let g=o.length-2;g>=0;g--)t=this.T(t,o[g]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),o=this.S(i,r[0]);let t=o;for(let g=1;g<r.length;g++)t=this.S(t,r[g]);this.N(o)}s(n,i,r){const o=n.piece,t=n.piece.bufferIndex,g=this.a[t].lineStarts,h=g[o.start.line]+o.start.column+i;let s=o.start.line,w=o.end.line,d=0,D=0,b=0;for(;s<=w&&(d=s+(w-s)/2|0,b=g[d],d!==w);)if(D=g[d+1],h<b)w=d-1;else if(h>=D)s=d+1;else break;return r?(r.line=d,r.column=h-b,null):{line:d,column:h-b}}t(n,i,r){if(r.column===0)return r.line-i.line;const o=this.a[n].lineStarts;if(r.line===o.length-1)return r.line-i.line;const t=o[r.line+1],g=o[r.line]+r.column;if(t>g+1)return r.line-i.line;const c=g-1;return this.a[n].buffer.charCodeAt(c)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$vC)(this,n[i])}w(n){if(n.length>p){const w=[];for(;n.length>p;){const D=n.charCodeAt(p-1);let b;D===13||D>=55296&&D<=56319?(b=n.substring(0,p-1),n=n.substring(p-1)):(b=n.substring(0,p),n=n.substring(p));const E=A(b);w.push(new m(this.a.length,{line:0,column:0},{line:E.length-1,column:b.length-E[E.length-1]},E.length-1,b.length)),this.a.push(new y(b,E))}const d=A(n);return w.push(new m(this.a.length,{line:0,column:0},{line:d.length-1,column:n.length-d[d.length-1]},d.length-1,n.length)),this.a.push(new y(n,d)),w}let i=this.a[0].buffer.length;const r=A(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let w=0;w<r.length;w++)r[w]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let w=0;w<r.length;w++)r[w]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[g],h={line:g,column:c},s=new m(0,o,h,this.t(0,o,h),t-i);return this.g=h,[s]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,o="";const t=this.h.get2(n);if(t){r=t.node;const g=this.B(r,n-t.nodeStartLineNumber-1),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)o=c.substring(h+g,h+r.piece.length);else{const s=this.B(r,n-t.nodeStartLineNumber);return c.substring(h+g,h+s-i)}}else{let g=0;const c=n;for(;r!==R.$qC;)if(r.left!==R.$qC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const h=this.B(r,n-r.lf_left-2),s=this.B(r,n-r.lf_left-1),w=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);return g+=r.size_left,this.h.set({node:r,nodeStartOffset:g,nodeStartLineNumber:c-(n-1-r.lf_left)}),w.substring(d+h,d+s-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const h=this.B(r,n-r.lf_left-2),s=this.a[r.piece.bufferIndex].buffer,w=this.u(r.piece.bufferIndex,r.piece.start);o=s.substring(w+h,w+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,g+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$qC;){const g=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const c=this.B(r,0),h=this.u(r.piece.bufferIndex,r.piece.start);return o+=g.substring(h,h+c-i),o}else{const c=this.u(r.piece.bufferIndex,r.piece.start);o+=g.substr(c,r.piece.length)}r=r.next()}return o}y(){let n=this.root,i=1,r=0;for(;n!==R.$qC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,o=this.s(n,i),t=o.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const g=this.t(n.piece.bufferIndex,r.start,o);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const r=n.piece,o=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?o[r.end.line]+r.end.column-o[r.start.line]-r.start.column:o[t]-o[r.start.line]-r.start.column}C(n,i){const r=n.piece,o=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),g=i,c=this.u(r.bufferIndex,g),h=this.t(r.bufferIndex,r.start,g),s=h-o,w=c-t,d=r.length+w;n.piece=new m(r.bufferIndex,r.start,g,h,d),(0,R.$xC)(this,n,w,s)}D(n,i){const r=n.piece,o=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),g=i,c=this.t(r.bufferIndex,g,r.end),h=this.u(r.bufferIndex,g),s=c-o,w=t-h,d=r.length+w;n.piece=new m(r.bufferIndex,g,r.end,c,d),(0,R.$xC)(this,n,w,s)}E(n,i,r){const o=n.piece,t=o.start,g=o.end,c=o.length,h=o.lineFeedCnt,s=i,w=this.t(o.bufferIndex,o.start,s),d=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new m(o.bufferIndex,o.start,s,w,d),(0,R.$xC)(this,n,d-c,w-h);const D=new m(o.bufferIndex,r,g,this.t(o.bufferIndex,r,g),this.u(o.bufferIndex,g)-this.u(o.bufferIndex,r)),b=this.S(n,D);this.N(b)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let b=0;b<t.length;b++)t[b]+=o;if(r){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[g],h={line:g,column:c},s=n.piece.length+i.length,w=n.piece.lineFeedCnt,d=this.t(0,n.piece.start,h),D=d-w;n.piece=new m(n.piece.bufferIndex,n.piece.start,h,d,s),this.g=h,(0,R.$xC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let o=0;for(;i!==R.$qC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,o=0;for(;r!==R.$qC;)if(r.left!==R.$qC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),g=this.B(r,n-r.lf_left-1);return o+=r.size_left,{node:r,remainder:Math.min(t+i-1,g),nodeStartOffset:o}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:o};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$qC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),g=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:g}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$qC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=r[o]+i.start.column;return o===r.length-1||r[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$qC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const g=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new m(n.piece.bufferIndex,n.piece.start,t,c,g),(0,R.$xC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const h={line:i.piece.start.line+1,column:0},s=i.piece.length-1,w=this.t(i.piece.bufferIndex,h,i.piece.end);i.piece=new m(i.piece.bufferIndex,h,i.piece.end,w,s),(0,R.$xC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const d=this.w(`\r
`);this.S(n,d[0]);for(let D=0;D<r.length;D++)(0,R.$vC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,R.$vC)(this,r);else{const o=r.piece,t={line:o.start.line+1,column:0},g=o.length-1,c=this.t(o.bufferIndex,t,o.end);r.piece=new m(o.bufferIndex,t,o.end,c,g),(0,R.$xC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$qC)return i(R.$qC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$qC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,o=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,o)}S(n,i){const r=new R.$pC(i,1);if(r.left=R.$qC,r.right=R.$qC,r.parent=R.$qC,r.size_left=0,r.lf_left=0,this.root===R.$qC)this.root=r,r.color=0;else if(n.right===R.$qC)n.right=r,r.parent=n;else{const t=(0,R.$rC)(n.right);t.left=r,r.parent=t}return(0,R.$wC)(this,r),r}T(n,i){const r=new R.$pC(i,1);if(r.left=R.$qC,r.right=R.$qC,r.parent=R.$qC,r.size_left=0,r.lf_left=0,this.root===R.$qC)this.root=r,r.color=0;else if(n.left===R.$qC)n.left=r,r.parent=n;else{const o=(0,R.$sC)(n.left);o.right=r,r.parent=o}return(0,R.$wC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$JC=f}),define(ke[184],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9=e.$n9=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$n9=u;class N{constructor(R){this.identifier=R}}e.$o9=N}),define(ke[185],Ee([1,0,4,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$be,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,$){return this.a.set(p,$),this.handleChange([p]),(0,N.$Sc)(()=>{this.a.get(p)===$&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,$){this.b.get(p)?.dispose();const S=new R(this,p,$);return this.b.set(p,S),(0,N.$Sc)(()=>{const A=this.b.get(p);!A||A!==S||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const $=this.get(p);if($)return $;const S=this.b.get(p);return!S||S.isResolved?null:(await S.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const S=this.b.get(p);return!!(!S||S.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Mt=L;class R extends N.$Uc{get isResolved(){return this.c}constructor(p,$,S){super(),this.f=p,this.g=$,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[186],Ee([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=A;class R extends N.$Uc{constructor(m,y="",v="",l=!0,f){super(),this.h=this.B(new u.$be),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=y,this.u=v,this.w=l,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,y){this.C&&await this.C(m)}}e.$8i=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$be),this.onWillRun=this.f.event,this.m=this.B(new u.$be),this.onDidRun=this.m.event}async run(m,y){if(!m.enabled)return;this.f.fire({action:m});let v;try{await this.u(m,y)}catch(l){v=l}this.m.fire({action:m,error:v})}async u(m,y){await m.run(y)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let y=[];for(const v of m)v.length&&(y.length?y=[...y,new p,...v]:y=v);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class ${get actions(){return this.a}constructor(m,y,v,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=y,this.class=l,this.a=v}async run(){}}e.$$i=$;class S extends R{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$_i=S;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...m)=>C.run(...m),tooltip:C.label}}}),define(ke[188],Ee([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=S,e.$Wm=A,e.$Xm=C;const N=60,L=N*60,R=L*24,M=R*7,p=R*30,$=R*365;function S(m,y,v,l){typeof m!="number"&&(m=m.getTime());const f=Math.round((new Date().getTime()-m)/1e3);if(f<-30)return(0,u.localize)(0,null,S(new Date().getTime()+f*1e3,!1));if(!l&&f<30)return(0,u.localize)(1,null);let a;return f<N?(a=f,y?a===1?v?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):v?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a):a===1?v?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):v?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):f<L?(a=Math.floor(f/N),y?a===1?v?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):v?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a):a===1?v?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):v?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):f<R?(a=Math.floor(f/L),y?a===1?v?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):v?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a):a===1?v?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):v?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):f<M?(a=Math.floor(f/R),y?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a)):f<p?(a=Math.floor(f/M),y?a===1?v?(0,u.localize)(30,null,a):(0,u.localize)(31,null,a):v?(0,u.localize)(32,null,a):(0,u.localize)(33,null,a):a===1?v?(0,u.localize)(34,null,a):(0,u.localize)(35,null,a):v?(0,u.localize)(36,null,a):(0,u.localize)(37,null,a)):f<$?(a=Math.floor(f/p),y?a===1?v?(0,u.localize)(38,null,a):(0,u.localize)(39,null,a):v?(0,u.localize)(40,null,a):(0,u.localize)(41,null,a):a===1?v?(0,u.localize)(42,null,a):(0,u.localize)(43,null,a):v?(0,u.localize)(44,null,a):(0,u.localize)(45,null,a)):(a=Math.floor(f/$),y?a===1?v?(0,u.localize)(46,null,a):(0,u.localize)(47,null,a):v?(0,u.localize)(48,null,a):(0,u.localize)(49,null,a):a===1?v?(0,u.localize)(50,null,a):(0,u.localize)(51,null,a):v?(0,u.localize)(52,null,a):(0,u.localize)(53,null,a))}function A(m,y){const v=Math.abs(m/1e3);return v<1?y?(0,u.localize)(54,null,m):(0,u.localize)(55,null,m):v<N?y?(0,u.localize)(56,null,Math.round(m)/1e3):(0,u.localize)(57,null,Math.round(m)/1e3):v<L?y?(0,u.localize)(58,null,Math.round(m/(1e3*N))):(0,u.localize)(59,null,Math.round(m/(1e3*N))):v<R?y?(0,u.localize)(60,null,Math.round(m/(1e3*L))):(0,u.localize)(61,null,Math.round(m/(1e3*L))):(0,u.localize)(62,null,Math.round(m/(1e3*R)))}function C(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=$,e.$cj=S,e.$dj=A;function R(C,m){return m&&(C.stack||C.stacktrace)?L.localize(0,null,p(C),M(C.stack)||M(C.stacktrace)):p(C)}function M(C){return Array.isArray(C)?C.join(`
`):C}function p(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function $(C=null,m=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const y=u.$Hb(C),v=$(y[0],m);return y.length>1?L.localize(4,null,v,y.length):v}if(N.$4f(C))return C;if(C.detail){const y=C.detail;if(y.error)return R(y.error,m);if(y.exception)return R(y.exception,m)}return C.stack?R(C,m):C.message?C.message:L.localize(5,null)}function S(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}function A(C,m){let y;return typeof C=="string"?y=new Error(C):y=C,y.actions=m,y}}),define(ke[191],Ee([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=g,e.$D=D,e.$J=b,e.$g="en";let N=!1,L=!1,R=!1,M=!1,p=!1,$=!1,S=!1,A=!1,C=!1,m=!1,y,v=e.$g,l=e.$g,f,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",o=r&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=r,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,v=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const k=JSON.parse(E),P=k.availableLanguages["*"];y=k.locale,l=k.osLocale,v=P||e.$g,f=k._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,A=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,m=a?.indexOf("Mobi")>=0,$=!0,y=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=y,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function g(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let c=0;L?c=1:N?c=3:R&&(c=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=p,e.$n=S,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=m,e.$t=C,e.$u=c,e.$v=a,e.$w=v;var h;(function(E){function k(){return e.$w}E.value=k;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=P;function I(){return e.$w==="en"}E.isDefault=I})(h||(e.Language=h={})),e.$x=y,e.$y=l,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,j=E.length;I<j;I++){const F=E[I];if(F.id===P.data.vscodeScheduleAsyncWork){E.splice(I,1),F.callback();return}}});let k=0;return P=>{const I=++k;E.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return E=>setTimeout(E)})();var s;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||A?2:N?1:3;let w=!0,d=!1;function D(){if(!d){d=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,w=new Uint16Array(E.buffer)[0]===513}return w}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(E){return parseFloat(E)>=20}}),define(ke[51],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,p=46,$=47,S=92,A=58,C=63;class m extends Error{constructor(g,c,h){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const w=g.indexOf(".")!==-1?"property":"argument";let d=`The "${g}" ${w} ${s} of type ${c}`;d+=`. Received type ${typeof h}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,g){if(t===null||typeof t!="object")throw new m(g,"Object",t)}function v(t,g){if(typeof t!="string")throw new m(g,"string",t)}const l=u.$ec==="win32";function f(t){return t===$||t===S}function a(t){return t===$}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,g,c,h){let s="",w=0,d=-1,D=0,b=0;for(let E=0;E<=t.length;++E){if(E<t.length)b=t.charCodeAt(E);else{if(h(b))break;b=$}if(h(b)){if(!(d===E-1||D===1))if(D===2){if(s.length<2||w!==2||s.charCodeAt(s.length-1)!==p||s.charCodeAt(s.length-2)!==p){if(s.length>2){const k=s.lastIndexOf(c);k===-1?(s="",w=0):(s=s.slice(0,k),w=s.length-1-s.lastIndexOf(c)),d=E,D=0;continue}else if(s.length!==0){s="",w=0,d=E,D=0;continue}}g&&(s+=s.length>0?`${c}..`:"..",w=2)}else s.length>0?s+=`${c}${t.slice(d+1,E)}`:s=t.slice(d+1,E),w=E-d-1;d=E,D=0}else b===p&&D!==-1?++D:D=-1}return s}function r(t,g){y(g,"pathObject");const c=g.dir||g.root,h=g.base||`${g.name||""}${g.ext||""}`;return c?c===g.root?`${c}${h}`:`${c}${t}${h}`:h}e.$gc={resolve(...t){let g="",c="",h=!1;for(let s=t.length-1;s>=-1;s--){let w;if(s>=0){if(w=t[s],v(w,"path"),w.length===0)continue}else g.length===0?w=u.cwd():(w=u.env[`=${g}`]||u.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==g.toLowerCase()&&w.charCodeAt(2)===S)&&(w=`${g}\\`));const d=w.length;let D=0,b="",E=!1;const k=w.charCodeAt(0);if(d===1)f(k)&&(D=1,E=!0);else if(f(k))if(E=!0,f(w.charCodeAt(1))){let P=2,I=P;for(;P<d&&!f(w.charCodeAt(P));)P++;if(P<d&&P!==I){const j=w.slice(I,P);for(I=P;P<d&&f(w.charCodeAt(P));)P++;if(P<d&&P!==I){for(I=P;P<d&&!f(w.charCodeAt(P));)P++;(P===d||P!==I)&&(b=`\\\\${j}\\${w.slice(I,P)}`,D=P)}}}else D=1;else n(k)&&w.charCodeAt(1)===A&&(b=w.slice(0,2),D=2,d>2&&f(w.charCodeAt(2))&&(E=!0,D=3));if(b.length>0)if(g.length>0){if(b.toLowerCase()!==g.toLowerCase())continue}else g=b;if(h){if(g.length>0)break}else if(c=`${w.slice(D)}\\${c}`,h=E,E&&g.length>0)break}return c=i(c,!h,"\\",f),h?`${g}\\${c}`:`${g}${c}`||"."},normalize(t){v(t,"path");const g=t.length;if(g===0)return".";let c=0,h,s=!1;const w=t.charCodeAt(0);if(g===1)return a(w)?"\\":t;if(f(w))if(s=!0,f(t.charCodeAt(1))){let D=2,b=D;for(;D<g&&!f(t.charCodeAt(D));)D++;if(D<g&&D!==b){const E=t.slice(b,D);for(b=D;D<g&&f(t.charCodeAt(D));)D++;if(D<g&&D!==b){for(b=D;D<g&&!f(t.charCodeAt(D));)D++;if(D===g)return`\\\\${E}\\${t.slice(b)}\\`;D!==b&&(h=`\\\\${E}\\${t.slice(b,D)}`,c=D)}}}else c=1;else n(w)&&t.charCodeAt(1)===A&&(h=t.slice(0,2),c=2,g>2&&f(t.charCodeAt(2))&&(s=!0,c=3));let d=c<g?i(t.slice(c),!s,"\\",f):"";return d.length===0&&!s&&(d="."),d.length>0&&f(t.charCodeAt(g-1))&&(d+="\\"),h===void 0?s?`\\${d}`:d:s?`${h}\\${d}`:`${h}${d}`},isAbsolute(t){v(t,"path");const g=t.length;if(g===0)return!1;const c=t.charCodeAt(0);return f(c)||g>2&&n(c)&&t.charCodeAt(1)===A&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let g,c;for(let w=0;w<t.length;++w){const d=t[w];v(d,"path"),d.length>0&&(g===void 0?g=c=d:g+=`\\${d}`)}if(g===void 0)return".";let h=!0,s=0;if(typeof c=="string"&&f(c.charCodeAt(0))){++s;const w=c.length;w>1&&f(c.charCodeAt(1))&&(++s,w>2&&(f(c.charCodeAt(2))?++s:h=!1))}if(h){for(;s<g.length&&f(g.charCodeAt(s));)s++;s>=2&&(g=`\\${g.slice(s)}`)}return e.$gc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g)return"";const c=e.$gc.resolve(t),h=e.$gc.resolve(g);if(c===h||(t=c.toLowerCase(),g=h.toLowerCase(),t===g))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===S;)s++;let w=t.length;for(;w-1>s&&t.charCodeAt(w-1)===S;)w--;const d=w-s;let D=0;for(;D<g.length&&g.charCodeAt(D)===S;)D++;let b=g.length;for(;b-1>D&&g.charCodeAt(b-1)===S;)b--;const E=b-D,k=d<E?d:E;let P=-1,I=0;for(;I<k;I++){const F=t.charCodeAt(s+I);if(F!==g.charCodeAt(D+I))break;F===S&&(P=I)}if(I!==k){if(P===-1)return h}else{if(E>k){if(g.charCodeAt(D+I)===S)return h.slice(D+I+1);if(I===2)return h.slice(D+I)}d>k&&(t.charCodeAt(s+I)===S?P=I:I===2&&(P=3)),P===-1&&(P=0)}let j="";for(I=s+P+1;I<=w;++I)(I===w||t.charCodeAt(I)===S)&&(j+=j.length===0?"..":"\\..");return D+=P,j.length>0?`${j}${h.slice(D,b)}`:(h.charCodeAt(D)===S&&++D,h.slice(D,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const g=e.$gc.resolve(t);if(g.length<=2)return t;if(g.charCodeAt(0)===S){if(g.charCodeAt(1)===S){const c=g.charCodeAt(2);if(c!==C&&c!==p)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(n(g.charCodeAt(0))&&g.charCodeAt(1)===A&&g.charCodeAt(2)===S)return`\\\\?\\${g}`;return t},dirname(t){v(t,"path");const g=t.length;if(g===0)return".";let c=-1,h=0;const s=t.charCodeAt(0);if(g===1)return f(s)?t:".";if(f(s)){if(c=h=1,f(t.charCodeAt(1))){let D=2,b=D;for(;D<g&&!f(t.charCodeAt(D));)D++;if(D<g&&D!==b){for(b=D;D<g&&f(t.charCodeAt(D));)D++;if(D<g&&D!==b){for(b=D;D<g&&!f(t.charCodeAt(D));)D++;if(D===g)return t;D!==b&&(c=h=D+1)}}}}else n(s)&&t.charCodeAt(1)===A&&(c=g>2&&f(t.charCodeAt(2))?3:2,h=c);let w=-1,d=!0;for(let D=g-1;D>=h;--D)if(f(t.charCodeAt(D))){if(!d){w=D;break}}else d=!1;if(w===-1){if(c===-1)return".";w=c}return t.slice(0,w)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let c=0,h=-1,s=!0,w;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(c=2),g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let d=g.length-1,D=-1;for(w=t.length-1;w>=c;--w){const b=t.charCodeAt(w);if(f(b)){if(!s){c=w+1;break}}else D===-1&&(s=!1,D=w+1),d>=0&&(b===g.charCodeAt(d)?--d===-1&&(h=w):(d=-1,h=D))}return c===h?h=D:h===-1&&(h=t.length),t.slice(c,h)}for(w=t.length-1;w>=c;--w)if(f(t.charCodeAt(w))){if(!s){c=w+1;break}}else h===-1&&(s=!1,h=w+1);return h===-1?"":t.slice(c,h)},extname(t){v(t,"path");let g=0,c=-1,h=0,s=-1,w=!0,d=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(g=h=2);for(let D=t.length-1;D>=g;--D){const b=t.charCodeAt(D);if(f(b)){if(!w){h=D+1;break}continue}s===-1&&(w=!1,s=D+1),b===p?c===-1?c=D:d!==1&&(d=1):c!==-1&&(d=-1)}return c===-1||s===-1||d===0||d===1&&c===s-1&&c===h+1?"":t.slice(c,s)},format:r.bind(null,"\\"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const c=t.length;let h=0,s=t.charCodeAt(0);if(c===1)return f(s)?(g.root=g.dir=t,g):(g.base=g.name=t,g);if(f(s)){if(h=1,f(t.charCodeAt(1))){let P=2,I=P;for(;P<c&&!f(t.charCodeAt(P));)P++;if(P<c&&P!==I){for(I=P;P<c&&f(t.charCodeAt(P));)P++;if(P<c&&P!==I){for(I=P;P<c&&!f(t.charCodeAt(P));)P++;P===c?h=P:P!==I&&(h=P+1)}}}}else if(n(s)&&t.charCodeAt(1)===A){if(c<=2)return g.root=g.dir=t,g;if(h=2,f(t.charCodeAt(2))){if(c===3)return g.root=g.dir=t,g;h=3}}h>0&&(g.root=t.slice(0,h));let w=-1,d=h,D=-1,b=!0,E=t.length-1,k=0;for(;E>=h;--E){if(s=t.charCodeAt(E),f(s)){if(!b){d=E+1;break}continue}D===-1&&(b=!1,D=E+1),s===p?w===-1?w=E:k!==1&&(k=1):w!==-1&&(k=-1)}return D!==-1&&(w===-1||k===0||k===1&&w===D-1&&w===d+1?g.base=g.name=t.slice(d,D):(g.name=t.slice(d,w),g.base=t.slice(d,D),g.ext=t.slice(w,D))),d>0&&d!==h?g.dir=t.slice(0,d-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(l){const t=/\\/g;return()=>{const g=u.cwd().replace(t,"/");return g.slice(g.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let g="",c=!1;for(let h=t.length-1;h>=-1&&!c;h--){const s=h>=0?t[h]:o();v(s,"path"),s.length!==0&&(g=`${s}/${g}`,c=s.charCodeAt(0)===$)}return g=i(g,!c,"/",a),c?`/${g}`:g.length>0?g:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$,c=t.charCodeAt(t.length-1)===$;return t=i(t,!g,"/",a),t.length===0?g?"/":c?"./":".":(c&&(t+="/"),g?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let g;for(let c=0;c<t.length;++c){const h=t[c];v(h,"path"),h.length>0&&(g===void 0?g=h:g+=`/${h}`)}return g===void 0?".":e.$hc.normalize(g)},relative(t,g){if(v(t,"from"),v(g,"to"),t===g||(t=e.$hc.resolve(t),g=e.$hc.resolve(g),t===g))return"";const c=1,h=t.length,s=h-c,w=1,d=g.length-w,D=s<d?s:d;let b=-1,E=0;for(;E<D;E++){const P=t.charCodeAt(c+E);if(P!==g.charCodeAt(w+E))break;P===$&&(b=E)}if(E===D)if(d>D){if(g.charCodeAt(w+E)===$)return g.slice(w+E+1);if(E===0)return g.slice(w+E)}else s>D&&(t.charCodeAt(c+E)===$?b=E:E===0&&(b=0));let k="";for(E=c+b+1;E<=h;++E)(E===h||t.charCodeAt(E)===$)&&(k+=k.length===0?"..":"/..");return`${k}${g.slice(w+b)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const g=t.charCodeAt(0)===$;let c=-1,h=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===$){if(!h){c=s;break}}else h=!1;return c===-1?g?"/":".":g&&c===1?"//":t.slice(0,c)},basename(t,g){g!==void 0&&v(g,"ext"),v(t,"path");let c=0,h=-1,s=!0,w;if(g!==void 0&&g.length>0&&g.length<=t.length){if(g===t)return"";let d=g.length-1,D=-1;for(w=t.length-1;w>=0;--w){const b=t.charCodeAt(w);if(b===$){if(!s){c=w+1;break}}else D===-1&&(s=!1,D=w+1),d>=0&&(b===g.charCodeAt(d)?--d===-1&&(h=w):(d=-1,h=D))}return c===h?h=D:h===-1&&(h=t.length),t.slice(c,h)}for(w=t.length-1;w>=0;--w)if(t.charCodeAt(w)===$){if(!s){c=w+1;break}}else h===-1&&(s=!1,h=w+1);return h===-1?"":t.slice(c,h)},extname(t){v(t,"path");let g=-1,c=0,h=-1,s=!0,w=0;for(let d=t.length-1;d>=0;--d){const D=t.charCodeAt(d);if(D===$){if(!s){c=d+1;break}continue}h===-1&&(s=!1,h=d+1),D===p?g===-1?g=d:w!==1&&(w=1):g!==-1&&(w=-1)}return g===-1||h===-1||w===0||w===1&&g===h-1&&g===c+1?"":t.slice(g,h)},format:r.bind(null,"/"),parse(t){v(t,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return g;const c=t.charCodeAt(0)===$;let h;c?(g.root="/",h=1):h=0;let s=-1,w=0,d=-1,D=!0,b=t.length-1,E=0;for(;b>=h;--b){const k=t.charCodeAt(b);if(k===$){if(!D){w=b+1;break}continue}d===-1&&(D=!1,d=b+1),k===p?s===-1?s=b:E!==1&&(E=1):s!==-1&&(E=-1)}if(d!==-1){const k=w===0&&c?1:w;s===-1||E===0||E===1&&s===d-1&&s===w+1?g.base=g.name=t.slice(k,d):(g.name=t.slice(k,s),g.base=t.slice(k,d),g.ext=t.slice(s,d))}return w>0?g.dir=t.slice(0,w-1):c&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=l?e.$gc.normalize:e.$hc.normalize,e.$jc=l?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=l?e.$gc.join:e.$hc.join,e.$lc=l?e.$gc.resolve:e.$hc.resolve,e.$mc=l?e.$gc.relative:e.$hc.relative,e.$nc=l?e.$gc.dirname:e.$hc.dirname,e.$oc=l?e.$gc.basename:e.$hc.basename,e.$pc=l?e.$gc.extname:e.$hc.extname,e.$qc=l?e.$gc.format:e.$hc.format,e.$rc=l?e.$gc.parse:e.$hc.parse,e.$sc=l?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=l?e.$gc.sep:e.$hc.sep,e.$uc=l?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=$,e.$ar=S,e.$br=A,e.$cr=C,e.$dr=m,e.$er=y,e.$fr=v,e.$gr=l,e.$hr=f,e.$ir=s,e.$jr=w,e.$kr=d;const L=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,b,E=!1){const k=D||"",P=b||"",I=L.value.collator.compare(k,P);return L.value.collatorIsNumeric&&I===0&&k!==P?k<P?-1:1:I}function $(D,b){const E=R.value.collator;return D=D||"",b=b||"",r(E,D,b)}function S(D,b){const E=R.value.collator;return D=D||"",b=b||"",c(D,b)||r(E,D,b)}function A(D,b){const E=R.value.collator;return D=D||"",b=b||"",g(D,b)||r(E,D,b)}function C(D,b){return D=D||"",b=b||"",D===b?0:D<b?-1:1}function m(D,b){const[E,k]=n(D),[P,I]=n(b);let j=L.value.collator.compare(k,I);if(j===0){if(L.value.collatorIsNumeric&&k!==I)return k<I?-1:1;if(j=L.value.collator.compare(E,P),L.value.collatorIsNumeric&&j===0&&E!==P)return E<P?-1:1}return j}function y(D,b){D=D||"",b=b||"";const E=i(D),k=i(b),P=R.value.collator,I=M.value.collator;return r(I,E,k)||r(P,D,b)}function v(D,b){D=D||"",b=b||"";const E=i(D),k=i(b),P=R.value.collator,I=M.value.collator;return r(I,E,k)||c(D,b)||r(P,D,b)}function l(D,b){D=D||"",b=b||"";const E=i(D),k=i(b),P=R.value.collator,I=M.value.collator;return r(I,E,k)||g(D,b)||r(P,D,b)}function f(D,b){D=D||"",b=b||"";const E=i(D).toLowerCase(),k=i(b).toLowerCase();return E!==k?E<k?-1:1:D!==b?D<b?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(D,b=!1){const E=D?a.exec(D):[];let k=[E&&E[1]||"",E&&E[3]||""];return b&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(D){const b=D?a.exec(D):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function r(D,b,E){const k=D.compare(b,E);return k!==0?k:b.length!==E.length?b.length<E.length?-1:1:0}function o(D){const b=D.charAt(0);return b.toLocaleUpperCase()!==b}function t(D){const b=D.charAt(0);return b.toLocaleLowerCase()!==b}function g(D,b){return o(D)&&t(b)?-1:t(D)&&o(b)?1:0}function c(D,b){return t(D)&&o(b)?-1:o(D)&&t(b)?1:0}function h(D,b,E=!1){return E||(D=D&&D.toLowerCase(),b=b&&b.toLowerCase()),D===b?0:D<b?-1:1}function s(D,b,E=!1){const k=D.split(N.sep),P=b.split(N.sep),I=k.length-1,j=P.length-1;let F,z;for(let O=0;;O++){if(F=I===O,z=j===O,F&&z)return p(k[O],P[O],E);if(F)return-1;if(z)return 1;const T=h(k[O],P[O],E);if(T!==0)return T}}function w(D,b,E){const k=D.toLowerCase(),P=b.toLowerCase(),I=d(D,b,E);if(I)return I;const j=k.endsWith(E),F=P.endsWith(E);if(j!==F)return j?-1:1;const z=p(k,P);return z!==0?z:k.localeCompare(P)}function d(D,b,E){const k=D.toLowerCase(),P=b.toLowerCase(),I=k.startsWith(E),j=P.startsWith(E);if(I!==j)return I?-1:1;if(I&&j){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=$,e.$mg=S,e.$ng=A,e.$og=v,e.$pg=l,e.$qg=f,e.$rg=a,e.$sg=n,e.$tg=i,e.$ug=r,e.$vg=o,e.$wg=t,e.$xg=g,e.$yg=s;function M(w){return w===47||w===92}function p(w){return w.replace(/[\\/]/g,u.$hc.sep)}function $(w){return w.indexOf("/")===-1&&(w=p(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function S(w,d=u.$hc.sep){if(!w)return"";const D=w.length,b=w.charCodeAt(0);if(M(b)){if(M(w.charCodeAt(1))&&!M(w.charCodeAt(2))){let k=3;const P=k;for(;k<D&&!M(w.charCodeAt(k));k++);if(P!==k&&!M(w.charCodeAt(k+1))){for(k+=1;k<D;k++)if(M(w.charCodeAt(k)))return w.slice(0,k+1).replace(/[\\/]/g,d)}}return d}else if(a(b)&&w.charCodeAt(1)===58)return M(w.charCodeAt(2))?w.slice(0,2)+d:w.slice(0,2);let E=w.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(M(w.charCodeAt(E)))return w.slice(0,E+1)}return""}function A(w){if(!N.$i||!w||w.length<5)return!1;let d=w.charCodeAt(0);if(d!==92||(d=w.charCodeAt(1),d!==92))return!1;let D=2;const b=D;for(;D<w.length&&(d=w.charCodeAt(D),d!==92);D++);return!(b===D||(d=w.charCodeAt(D+1),isNaN(d)||d===92))}const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,d=N.$i){const D=d?C:m;return!(!w||w.length===0||/^\s+$/.test(w)||(D.lastIndex=0,D.test(w))||d&&y.test(w)||w==="."||w===".."||d&&w[w.length-1]==="."||d&&w.length!==w.trim().length||w.length>255)}function l(w,d,D){const b=w===d;return!D||b?b:!w||!d?!1:(0,L.$tf)(w,d)}function f(w,d,D,b=u.sep){if(w===d)return!0;if(!w||!d||d.length>w.length)return!1;if(D){if(!(0,L.$uf)(w,d))return!1;if(d.length===w.length)return!0;let k=d.length;return d.charAt(d.length-1)===b&&k--,w.charAt(k)===b}return d.charAt(d.length-1)!==b&&(d+=b),w.indexOf(d)===0}function a(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,d){return N.$i&&w.endsWith(":")&&(w+=u.sep),(0,u.$jc)(w)||(w=(0,u.$kc)(d,w)),w=(0,u.$ic)(w),N.$i?(w=(0,L.$bf)(w,u.sep),w.endsWith(":")&&(w+=u.sep)):(w=(0,L.$bf)(w,u.sep),w||(w=u.sep)),w}function i(w){const d=(0,u.$ic)(w);return N.$i?w.length>3?!1:r(d)&&(w.length===2||d.charCodeAt(2)===92):d===u.$hc.sep}function r(w,d=N.$i){return d?a(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function o(w,d=N.$i){return r(w,d)?w[0]:void 0}function t(w,d,D){return d.length>w.length?-1:w===d?0:(D&&(w=w.toLowerCase(),d=d.toLowerCase()),w.indexOf(d))}function g(w){const d=w.split(":");let D,b,E;for(const k of d){const P=Number(k);(0,R.$8f)(P)?b===void 0?b=P:E===void 0&&(E=P):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:b!==void 0?b:void 0,column:E!==void 0?E:b!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(w,d,D=8){let b="";for(let k=0;k<D;k++){let P;k===0&&N.$i&&!d&&(D===3||D===4)?P=h:P=c,b+=P.charAt(Math.floor(Math.random()*P.length))}let E;return d?E=`${d}-${b}`:E=b,w?(0,u.$kc)(w,E):E}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=A,e.$mr=f,e.$nr=c,e.$or=E,e.$pr=z,e.$qr=T;const $=0,S=[$,[]];function A(B,W,X,x){if(!B||!W)return S;const Y=B.length,Z=W.length;if(Y<Z)return S;const ue=B.toLowerCase();return C(W,X,Z,B,ue,Y,x)}function C(B,W,X,x,Y,Z,ue){const te=[],we=[];for(let ne=0;ne<X;ne++){const $e=ne*Z,Pe=$e-Z,se=ne>0,re=B[ne],oe=W[ne];for(let G=0;G<Z;G++){const ie=G>0,me=$e+G,pe=me-1,Ae=Pe+G-1,fe=ie?te[pe]:0,De=se&&ie?te[Ae]:0,Ie=se&&ie?we[Ae]:0;let Te;!De&&se?Te=0:Te=m(re,oe,x,Y,G,Ie),Te&&De+Te>=fe&&(ue||se||Y.startsWith(W,G))?(we[me]=Ie+1,te[me]=De+Te):(we[me]=$,te[me]=fe)}}const Se=[];let _=X-1,U=Z-1;for(;_>=0&&U>=0;){const ne=_*Z+U;we[ne]===$||(Se.push(U),_--),U--}return[te[X*Z-1],Se.reverse()]}function m(B,W,X,x,Y,Z){let ue=0;if(!y(W,x[Y]))return ue;if(ue+=1,Z>0&&(ue+=Z*5),B===X[Y]&&(ue+=1),Y===0)ue+=8;else{const te=v(X.charCodeAt(Y-1));te?ue+=te:(0,N.$vk)(X.charCodeAt(Y))&&Z===0&&(ue+=2)}return ue}function y(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(B,W,X=0,x=0){const Y=W;return Y.values&&Y.values.length>1?a(B,Y.values,X,x):n(B,W,X,x)}function a(B,W,X,x){let Y=0;const Z=[];for(const ue of W){const[te,we]=n(B,ue,X,x);if(typeof te!="number")return l;Y+=te,Z.push(...we)}return[Y,D(Z)]}function n(B,W,X,x){const Y=(0,N.$Ek)(W.original,W.originalLowercase,X,B,B.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,N.$Bk)(Y)]:l}const i=Object.freeze({score:0}),r=1<<18,o=1<<17,t=65536;function g(B,W,X,x){const Y=x.values?x.values:[x];return(0,L.$ej)({[x.normalized]:{values:Y.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:X}})}function c(B,W,X,x,Y){if(!B||!W.normalized)return i;const Z=x.getItemLabel(B);if(!Z)return i;const ue=x.getItemDescription(B),te=g(Z,ue,X,W),we=Y[te];if(we)return we;const Se=h(Z,ue,x.getItemPath(B),W,X);return Y[te]=Se,Se}function h(B,W,X,x,Y){const Z=!X||!x.containsPathSeparator;return X&&(M.$k?x.pathNormalized===X:(0,p.$tf)(x.pathNormalized,X))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:x.values&&x.values.length>1?s(B,W,X,x.values,Z,Y):w(B,W,X,x,Z,Y)}function s(B,W,X,x,Y,Z){let ue=0;const te=[],we=[];for(const Se of x){const{score:_,labelMatch:U,descriptionMatch:ne}=w(B,W,X,Se,Y,Z);if(_===$)return i;ue+=_,U&&te.push(...U),ne&&we.push(...ne)}return{score:ue,labelMatch:D(te),descriptionMatch:D(we)}}function w(B,W,X,x,Y,Z){if(Y||!W){const[ue,te]=A(B,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ue){const we=(0,N.$sk)(x.normalized,B);let Se;if(we){Se=o;const _=Math.round(x.normalized.length/B.length*100);Se+=_}else Se=t;return{score:Se+ue,labelMatch:we||d(te)}}}if(W){let ue=W;X&&(ue=`${W}${R.sep}`);const te=ue.length,we=`${ue}${B}`,[Se,_]=A(we,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(Se){const U=d(_),ne=[],$e=[];return U.forEach(Pe=>{Pe.start<te&&Pe.end>te?(ne.push({start:0,end:Pe.end-te}),$e.push({start:Pe.start,end:te})):Pe.start>=te?ne.push({start:Pe.start-te,end:Pe.end-te}):$e.push(Pe)}),{score:Se,labelMatch:ne,descriptionMatch:$e}}}return i}function d(B){const W=[];if(!B)return W;let X;for(const x of B)X&&X.end===x?X.end+=1:(X={start:x,end:x+1},W.push(X));return W}function D(B){const W=B.sort((Y,Z)=>Y.start-Z.start),X=[];let x;for(const Y of W)!x||!b(x,Y)?(x=Y,X.push(Y)):(x.start=Math.min(x.start,Y.start),x.end=Math.max(x.end,Y.end));return X}function b(B,W){return!(B.end<W.start||W.end<B.start)}function E(B,W,X,x,Y,Z){const ue=c(B,X,x,Y,Z),te=c(W,X,x,Y,Z),we=ue.score,Se=te.score;if((we===r||Se===r)&&we!==Se)return we===r?-1:1;if(we>t||Se>t){if(we!==Se)return we>Se?-1:1;if(we<o&&Se<o){const re=P(ue.labelMatch,te.labelMatch);if(re!==0)return re}const Pe=Y.getItemLabel(B)||"",se=Y.getItemLabel(W)||"";if(Pe.length!==se.length)return Pe.length-se.length}if(we!==Se)return we>Se?-1:1;const _=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,U=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const ne=k(B,ue,Y),$e=k(W,te,Y);return ne&&$e&&ne!==$e?$e>ne?-1:1:I(B,W,X,Y)}function k(B,W,X){let x=-1,Y=-1;if(W.descriptionMatch&&W.descriptionMatch.length?x=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(x=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(Y=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Z=X.getItemDescription(B);Z&&(Y+=Z.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(Y=W.descriptionMatch[W.descriptionMatch.length-1].end);return Y-x}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,Y=B[B.length-1].end-X,Z=W[0].start,te=W[W.length-1].end-Z;return Y===te?0:te<Y?1:-1}function I(B,W,X,x){const Y=x.getItemLabel(B)||"",Z=x.getItemLabel(W)||"",ue=x.getItemDescription(B),te=x.getItemDescription(W),we=Y.length+(ue?ue.length:0),Se=Z.length+(te?te.length:0);if(we!==Se)return we-Se;const _=x.getItemPath(B),U=x.getItemPath(W);return _&&U&&_.length!==U.length?_.length-U.length:Y!==Z?(0,u.$jr)(Y,Z,X.normalized):ue&&te&&ue!==te?(0,u.$jr)(ue,te,X.normalized):_&&U&&_!==U?(0,u.$jr)(_,U,X.normalized):0}function j(B){return B.startsWith('"')&&B.endsWith('"')}const F=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:X,normalized:x,normalizedLowercase:Y}=O(B),Z=X.indexOf(R.sep)>=0,ue=j(B);let te;const we=B.split(F);if(we.length>1)for(const Se of we){const _=j(Se),{pathNormalized:U,normalized:ne,normalizedLowercase:$e}=O(Se);ne&&(te||(te=[]),te.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:$e,expectContiguousMatch:_}))}return{original:B,originalLowercase:W,pathNormalized:X,normalized:x,normalizedLowercase:Y,values:te,containsPathSeparator:Z,expectContiguousMatch:ue}}function O(B){let W;M.$i?W=B.replace(/\//g,R.sep):W=B.replace(/\\/g,R.sep);const X=(0,p.$df)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:X,normalizedLowercase:X.toLowerCase()}}function T(B){return Array.isArray(B)?z(B.map(W=>W.original).join(F)):z(B.original)}}),define(ke[101],Ee([1,0,17]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=R,e.$Js=M,e.$Ks=p,e.$Ls=S,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,u.$pc)(A),m=N[C.toLowerCase()];return m!==void 0?m:M(A)}function M(A){const C=(0,u.$pc)(A);return L[C.toLowerCase()]}function p(A){for(const C in L)if(L[C]===A)return C}const $=/^(.+)\/(.+?)(;.+)?$/;function S(A,C){const m=$.exec(A);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:A}}),define(ke[102],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=R,e.$hm=M;var N;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(p,...$){const S=$.reduce((m,y)=>(m[y]=!0,m),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(m=>!S[m]).forEach(m=>{for(let y=0;y<A.length;y++)if(m.search(A[y])!==-1){delete p[m];break}})}function M(p){p&&(delete p.DEBUG,u.$j&&delete p.DYLD_LIBRARY_PATH,u.$k&&delete p.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function p(h,s){if(!h.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!L.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!R.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(h,s){return!h&&!s?"file":h}function S(h,s){switch(h){case"https":case"http":case"file":s?s[0]!==C&&(s=C+s):s=C;break}return s}const A="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,w,d,D,b,E=!1){typeof s=="object"?(this.scheme=s.scheme||A,this.authority=s.authority||A,this.path=s.path||A,this.query=s.query||A,this.fragment=s.fragment||A):(this.scheme=$(s,E),this.authority=w||A,this.path=S(this.scheme,d||A),this.query=D||A,this.fragment=b||A,p(this,E))}get fsPath(){return r(this,!1)}with(s){if(!s)return this;let{scheme:w,authority:d,path:D,query:b,fragment:E}=s;return w===void 0?w=this.scheme:w===null&&(w=A),d===void 0?d=this.authority:d===null&&(d=A),D===void 0?D=this.path:D===null&&(D=A),b===void 0?b=this.query:b===null&&(b=A),E===void 0?E=this.fragment:E===null&&(E=A),w===this.scheme&&d===this.authority&&D===this.path&&b===this.query&&E===this.fragment?this:new f(w,d,D,b,E)}static parse(s,w=!1){const d=m.exec(s);return d?new f(d[2]||A,c(d[4]||A),c(d[5]||A),c(d[7]||A),c(d[9]||A),w):new f(A,A,A,A,A)}static file(s){let w=A;if(N.$i&&(s=s.replace(/\\/g,C)),s[0]===C&&s[1]===C){const d=s.indexOf(C,2);d===-1?(w=s.substring(2),s=C):(w=s.substring(2,d),s=s.substring(d)||C)}return new f("file",w,s,A,A)}static from(s,w){return new f(s.scheme,s.authority,s.path,s.query,s.fragment,w)}static joinPath(s,...w){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return N.$i&&s.scheme==="file"?d=y.file(u.$gc.join(r(s,!0),...w)).path:d=u.$hc.join(s.path,...w),s.with({path:d})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const w=new f(s);return w._formatted=s.external??null,w._fsPath=s._sep===l?s.fsPath??null:null,w}}else return s}}e.URI=y;function v(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const l=N.$i?1:void 0;class f extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=l),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(h,s,w){let d,D=-1;for(let b=0;b<h.length;b++){const E=h.charCodeAt(b);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||s&&E===47||w&&E===91||w&&E===93||w&&E===58)D!==-1&&(d+=encodeURIComponent(h.substring(D,b)),D=-1),d!==void 0&&(d+=h.charAt(b));else{d===void 0&&(d=h.substr(0,b));const k=a[E];k!==void 0?(D!==-1&&(d+=encodeURIComponent(h.substring(D,b)),D=-1),d+=k):D===-1&&(D=b)}}return D!==-1&&(d+=encodeURIComponent(h.substring(D))),d!==void 0?d:h}function i(h){let s;for(let w=0;w<h.length;w++){const d=h.charCodeAt(w);d===35||d===63?(s===void 0&&(s=h.substr(0,w)),s+=a[d]):s!==void 0&&(s+=h[w])}return s!==void 0?s:h}function r(h,s){let w;return h.authority&&h.path.length>1&&h.scheme==="file"?w=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?s?w=h.path.substr(1):w=h.path[1].toLowerCase()+h.path.substr(2):w=h.path,N.$i&&(w=w.replace(/\//g,"\\")),w}function o(h,s){const w=s?i:n;let d="",{scheme:D,authority:b,path:E,query:k,fragment:P}=h;if(D&&(d+=D,d+=":"),(b||D==="file")&&(d+=C,d+=C),b){let I=b.indexOf("@");if(I!==-1){const j=b.substr(0,I);b=b.substr(I+1),I=j.lastIndexOf(":"),I===-1?d+=w(j,!1,!1):(d+=w(j.substr(0,I),!1,!1),d+=":",d+=w(j.substr(I+1),!1,!0)),d+="@"}b=b.toLowerCase(),I=b.lastIndexOf(":"),I===-1?d+=w(b,!1,!0):(d+=w(b.substr(0,I),!1,!0),d+=b.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const I=E.charCodeAt(1);I>=65&&I<=90&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const I=E.charCodeAt(0);I>=65&&I<=90&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}d+=w(E,!0,!1)}return k&&(d+="?",d+=w(k,!1,!1)),P&&(d+="#",d+=s?P:n(P,!1,!1)),d}function t(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+t(h.substr(3)):h}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(h){return h.match(g)?h.replace(g,s=>t(s)):h}}),define(ke[192],Ee([1,0,2]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=N,e.$Oq=L,e.$Pq=R,e.log=p;function N(S){const A=S;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(S){const A=[];let C;try{const m=JSON.parse(S.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),C=y.__$stack),A.push(...m)}catch{A.push("Unable to log remote console arguments",S.arguments)}return{args:A,stack:C}}function R(S){if(typeof S!="string")return R(L(S).stack);const A=S;if(A){const C=M(A),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:u.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function M(S){if(!S)return S;const A=S.indexOf(`
`);return A===-1?S:S.substring(0,A)}function p(S,A){const{args:C,stack:m}=L(S),y=typeof C[0]=="string"&&C.length===1;let v=M(m);v&&(v=`(${v.trim()})`);let l=[];if(typeof C[0]=="string"?v&&y?l=[`%c[${A}] %c${C[0]} %c${v}`,$("blue"),$(""),$("grey")]:l=[`%c[${A}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${A}]%`,$("blue"),...C],v&&!y&&l.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,l)}function $(S){return`color: ${S}`}}),define(ke[58],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=L,e.$Yh=R,e.$Zh=p;function L($){return JSON.stringify($,M)}function R($){let S=JSON.parse($);return S=p(S),S}function M($,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function p($,S=0){if(!$||S>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$Ce||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=p($[A],S+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=p($[A],S+1))}return $}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=$,e.$Ag=S,e.$Eg=C;var p;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(p||(e.Schemas=p={}));function $(v,l){return R.URI.isUri(v)?(0,L.$tf)(v.scheme,l):(0,L.$uf)(v,l+":")}function S(v,...l){return l.some(f=>$(v,f))}e.$Bg="vscode-tkn",e.$Cg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,f){this.f=C(l,f)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(l,f,a){this.a[l]=f,this.b[l]=a}setConnectionToken(l,f){this.c[l]=f}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(o){return u.$1(o),l}const f=l.authority;let a=this.a[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[f],i=this.c[f];let r=`path=${encodeURIComponent(l.path)}`;return typeof i=="string"&&(r+=`&${e.$Cg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:r})}}e.$Dg=new A;function C(v,l){return M.$hc.join(l??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class m{static{this.a=e.$Jg}asBrowserUri(l){const f=this.b(l,le);return this.uriToBrowserUri(f)}uriToBrowserUri(l){return l.scheme===p.vscodeRemote?e.$Dg.rewrite(l):l.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${m.a}`)?l.with({scheme:p.vscodeFileResource,authority:l.authority||m.a,query:null,fragment:null}):l}asFileUri(l){const f=this.b(l,le);return this.uriToFileUri(f)}uriToFileUri(l){return l.scheme===p.vscodeFileResource?l.with({scheme:p.file,authority:l.authority!==m.a?l.authority:null,query:null,fragment:null}):l}b(l,f){return R.URI.isUri(l)?l:R.URI.parse(f.toUrl(l))}}e.$Kg=new m;var y;(function(v){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(l.get("3"));const f="vscode-coi";function a(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:R.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const o=r?.get(f);if(o)return l.get(o)}v.getHeadersFromQuery=a;function n(i,r,o){if(!globalThis.crossOriginIsolated)return;const t=r&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(f,t):i[f]=t}v.addSearchParam=n})(y||(e.COI=y={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QD=A;class M{constructor(m,y,v){this.id=m,this.dependencies=y,this.callback=v}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,y,v)=>{typeof m!="string"&&(v=y,y=m,m=null),(typeof y!="object"||!Array.isArray(y))&&(v=y,y=null),this.c.push(new M(m,y,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const y=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!y)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(m){return new Promise((y,v)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",a),l.removeEventListener("error",n)},a=i=>{f(),y(this.c.pop())},n=i=>{f(),v(i)};l.addEventListener("load",a),l.addEventListener("error",n),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((y,v)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),y(this.c.pop())}catch(l){v(l)}})}async j(m){try{const y=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=R.URI.parse(m).fsPath,a=y.readFileSync(f).toString(),n=l.wrap(a.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const $=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function A(C,m,y){if(u.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const v=`${C}/${m}`;if($.has(v))return $.get(v);let l;if(/^\w[\w\d+.-]*:\/\//.test(v))l=v;else{const i=`${y&&!L.$o?N.$Hg:N.$Gg}/${v}`;l=N.$Kg.asBrowserUri(i).toString(!0)}const f=p.INSTANCE.load(l);return $.set(v,f),f}else return await new Promise((v,l)=>{le([C],v,l)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=$,e.$ah=A,e.$bh=m;function $(y){return(0,p.$xc)(y,!0)}class S{constructor(v){this.a=v}compare(v,l,f=!1){return v===l?0:(0,M.$mf)(this.getComparisonKey(v,f),this.getComparisonKey(l,f))}isEqual(v,l,f=!1){return v===l?!0:!v||!l?!1:this.getComparisonKey(v,f)===this.getComparisonKey(l,f)}getComparisonKey(v,l=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,l,f=!1){if(v.scheme===l.scheme){if(v.scheme===N.Schemas.file)return u.$qg($(v),$(l),this.a(v))&&v.query===l.query&&(f||v.fragment===l.fragment);if((0,e.$9g)(v.authority,l.authority))return u.$qg(v.path,l.path,this.a(v),"/")&&v.query===l.query&&(f||v.fragment===l.fragment)}return!1}joinPath(v,...l){return p.URI.joinPath(v,...l)}basenameOrAuthority(v){return(0,e.$1g)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let l;return v.scheme===N.Schemas.file?l=p.URI.file(L.$nc($(v))).path:(l=L.$hc.dirname(v.path),v.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),l="/")),v.with({path:l})}normalizePath(v){if(!v.path.length)return v;let l;return v.scheme===N.Schemas.file?l=p.URI.file(L.$ic($(v))).path:l=L.$hc.normalize(v.path),v.with({path:l})}relativePath(v,l){if(v.scheme!==l.scheme||!(0,e.$9g)(v.authority,l.authority))return;if(v.scheme===N.Schemas.file){const n=L.$mc($(v),$(l));return R.$i?u.$kg(n):n}let f=v.path||"/";const a=l.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(f.length,a.length);n<i&&!(f.charCodeAt(n)!==a.charCodeAt(n)&&f.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);f=a.substr(0,n)+f.substr(n)}return L.$hc.relative(f,a)}resolvePath(v,l){if(v.scheme===N.Schemas.file){const f=p.URI.file(L.$lc($(v),l));return v.with({authority:f.authority,path:f.path})}return l=u.$lg(l),v.with({path:L.$hc.resolve(v.path,l)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,l){return v===l||v!==void 0&&l!==void 0&&(0,M.$tf)(v,l)}hasTrailingPathSeparator(v,l=L.sep){if(v.scheme===N.Schemas.file){const f=$(v);return f.length>u.$mg(f).length&&f[f.length-1]===l}else{const f=v.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,l=L.sep){return(0,e.$0g)(v,l)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,l=L.sep){let f=!1;if(v.scheme===N.Schemas.file){const a=$(v);f=a!==void 0&&a.length===u.$mg(a).length&&a[a.length-1]===l}else{l="/";const a=v.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.$0g)(v,l)?v.with({path:v.path+"/"}):v}}e.$Sg=S,e.$Tg=new S(()=>!1),e.$Ug=new S(y=>y.scheme===N.Schemas.file?!R.$k:!0),e.$Vg=new S(y=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function A(y,v){const l=[];for(let f=0;f<y.length;f++){const a=v(y[f]);y.some((n,i)=>i===f?!1:(0,e.$Xg)(a,v(n)))||l.push(y[f])}return l}var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,o]=i.split(":");r&&o&&f.set(r,o)});const n=l.path.substring(0,l.path.indexOf(";"));return n&&f.set(y.META_DATA_MIME,n),f}y.parseMetaData=v})(C||(e.DataUri=C={}));function m(y,v,l){if(v){let f=y.path;return f&&f[0]!==L.$hc.sep&&(f=L.$hc.sep+f),y.with({scheme:l,authority:v,path:f})}return y.with({scheme:l})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,169,46]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=A,e.$dh=C,e.$eh=m,e.$fh=y,e.$gh=v,e.$hh=l,e.$ih=f,e.$jh=a,e.$rh=w,e.$sh=d,e.$th=D,e.$uh=b,e.$vh=E,e.$Kh=Y,e.$Sh=se;function A(oe){return!!oe&&typeof oe.then=="function"}function C(oe){const G=new u.$me,ie=oe(G.token),me=new Promise((pe,Ae)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Ae(new N.$5)});Promise.resolve(ie).then(De=>{fe.dispose(),G.dispose(),pe(De)},De=>{fe.dispose(),G.dispose(),Ae(De)})});return new class{cancel(){G.cancel(),G.dispose()}then(pe,Ae){return me.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function m(oe,G,ie){return new Promise((me,pe)=>{const Ae=G.onCancellationRequested(()=>{Ae.dispose(),me(ie)});oe.then(me,pe).finally(()=>Ae.dispose())})}function y(oe,G){return new Promise((ie,me)=>{const pe=G.onCancellationRequested(()=>{pe.dispose(),me(new N.$5)});oe.then(ie,me).finally(()=>pe.dispose())})}async function v(oe){let G=-1;const ie=oe.map((me,pe)=>me.then(Ae=>(G=pe,Ae)));try{return await Promise.race(ie)}finally{oe.forEach((me,pe)=>{pe!==G&&me.cancel()})}}function l(oe,G,ie){let me;const pe=setTimeout(()=>{me?.(void 0),ie?.()},G);return Promise.race([oe.finally(()=>clearTimeout(pe)),new Promise(Ae=>me=Ae)])}function f(oe){return new Promise((G,ie)=>{const me=oe();A(me)?me.then(G,ie):G(me)})}function a(){let oe,G;return{promise:new Promise((me,pe)=>{oe=me,G=pe}),resolve:oe,reject:G}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ie=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(ie,ie).then(me)})}return new Promise((ie,me)=>{this.b.then(ie,me)})}return this.a=G(),new Promise((ie,me)=>{this.a.then(pe=>{this.a=null,ie(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$kh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$lh=i;class r{constructor(){this.a=new Map}queue(G,ie){const pe=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(G)===pe&&this.a.delete(G)});return this.a.set(G,pe),pe}}e.$mh=r;const o=(oe,G)=>{let ie=!0;const me=setTimeout(()=>{ie=!1,G()},oe);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(me),ie=!1}}},t=oe=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,oe())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class g{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ie=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=ie===$.$$d?t(me):o(ie,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=g;class c{constructor(G){this.a=new g(G),this.b=new n}trigger(G,ie){return this.a.trigger(()=>this.b.queue(G),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=c;class h{constructor(){this.a=!1,this.b=new Promise((G,ie)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=h;class s extends h{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$qh=s;function w(oe,G){return G?new Promise((ie,me)=>{const pe=setTimeout(()=>{Ae.dispose(),ie()},oe),Ae=G.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),me(new N.$5)})}):C(ie=>w(oe,ie))}function d(oe,G=0,ie){const me=setTimeout(()=>{oe(),ie&&pe.dispose()},G),pe=(0,R.$Sc)(()=>{clearTimeout(me),ie?.deleteAndLeak(pe)});return ie?.add(pe),pe}function D(oe){const G=[];let ie=0;const me=oe.length;function pe(){return ie<me?oe[ie++]():null}function Ae(fe){fe!=null&&G.push(fe);const De=pe();return De?De.then(Ae):Promise.resolve(G)}return Promise.resolve(null).then(Ae)}function b(oe,G=me=>!!me,ie=null){let me=0;const pe=oe.length,Ae=()=>{if(me>=pe)return Promise.resolve(ie);const fe=oe[me++];return Promise.resolve(fe()).then(Ie=>G(Ie)?Promise.resolve(Ie):Ae())};return Ae()}function E(oe,G=me=>!!me,ie=null){if(oe.length===0)return Promise.resolve(ie);let me=oe.length;const pe=()=>{me=-1;for(const Ae of oe)Ae.cancel?.()};return new Promise((Ae,fe)=>{for(const De of oe)De.then(Ie=>{--me>=0&&G(Ie)?(pe(),Ae(Ie)):me===0&&Ae(ie)}).catch(Ie=>{--me>=0&&(pe(),fe(Ie))})})}class k{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new L.$be}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,me)=>{this.g.push({factory:G,c:ie,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ie=G.factory();ie.then(G.c,G.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=k;class P extends k{constructor(){super(1)}}e.$xh=P;class I{constructor(){this.a=new Z,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$yh=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new we;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ie=M.$Tg){const me=ie.getComparisonKey(G);return this.a.get(me)?.size??0}queueFor(G,ie,me=M.$Tg){const pe=me.getComparisonKey(G);let Ae=this.a.get(pe);if(!Ae){Ae=new P;const fe=this.f++,De=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(fe,De),this.a.set(pe,Ae)}return Ae.queue(ie)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=j;class F{constructor(G,ie){this.a=-1,typeof G=="function"&&typeof ie=="number"&&this.setIfNotSet(G,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ie)}setIfNotSet(G,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ie))}}e.$Ah=F;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ie,me=globalThis){this.cancel();const pe=me.setInterval(()=>{G()},ie);this.d=(0,R.$Sc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=z;class O{constructor(G,ie){this.b=-1,this.a=G,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=O;class T{constructor(G,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=G,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=T;class B extends O{constructor(G,ie){super(G,ie),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Eh=B;class W extends R.$Uc{constructor(G,ie){super(),this.g=G,this.h=ie,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of G)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(oe,G)=>{(0,p.$B)(()=>{if(ie)return;const me=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Hh=(oe,G,ie)=>{const me=oe.requestIdleCallback(G,typeof ie=="number"?{timeout:ie}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,oe.cancelIdleCallback(me))}}},e.$Gh=oe=>(0,e.$Hh)(globalThis,oe)}();class X{constructor(G,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Hh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=X;class x extends X{constructor(G){super(globalThis,G)}}e.$Jh=x;async function Y(oe,G,ie){let me;for(let pe=0;pe<ie;pe++)try{return await oe()}catch(Ae){me=Ae,await w(G)}throw me}class Z{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ie,me){return this.a={taskId:G,cancel:()=>me?.(),promise:ie},ie.then(()=>this.d(G),()=>this.d(G)),ie}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ie,resolve:me,reject:pe}=a();this.b={run:G,promise:ie,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=Z;class ue{constructor(G,ie=()=>Date.now()){this.d=G,this.f=ie,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Mh=ue;var te;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(te||(te={}));class we{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ie)=>{this.a=G,this.b=ie})}complete(G){return new Promise(ie=>{this.a(G),this.d={outcome:0,value:G},ie()})}error(G){return new Promise(ie=>{this.b(G),this.d={outcome:1,value:G},ie()})}cancel(){return this.error(new N.$5)}}e.$Nh=we;var Se;(function(oe){async function G(me){let pe;const Ae=await Promise.all(me.map(fe=>fe.then(De=>De,De=>{pe||(pe=De)})));if(typeof pe<"u")throw pe;return Ae}oe.settled=G;function ie(me){return new Promise(async(pe,Ae)=>{try{await me(pe,Ae)}catch(fe){Ae(fe)}})}oe.withAsyncBody=ie})(Se||(e.Promises=Se={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=_;class U{constructor(G){this.b=G,this.a=new S.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var ne;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(ne||(ne={}));class $e{static fromArray(G){return new $e(ie=>{ie.emitMany(G)})}static fromPromise(G){return new $e(async ie=>{ie.emitMany(await G)})}static fromPromises(G){return new $e(async ie=>{await Promise.all(G.map(async me=>ie.emitOne(await me)))})}static merge(G){return new $e(async ie=>{await Promise.all(G.map(async me=>{for await(const pe of me)ie.emitOne(pe)}))})}static{this.EMPTY=$e.fromArray([])}constructor(G,ie){this.a=0,this.b=[],this.d=null,this.f=ie,this.g=new L.$be,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(G(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(G,ie){return new $e(async me=>{for await(const pe of G)me.emitOne(ie(pe))})}map(G){return $e.map(this,G)}static filter(G,ie){return new $e(async me=>{for await(const pe of G)ie(pe)&&me.emitOne(pe)})}filter(G){return $e.filter(this,G)}static coalesce(G){return $e.filter(G,ie=>!!ie)}coalesce(){return $e.coalesce(this)}static async toPromise(G){const ie=[];for await(const me of G)ie.push(me);return ie}toPromise(){return $e.toPromise(this)}h(G){this.a===0&&(this.b.push(G),this.g.fire())}j(G){this.a===0&&(this.b=this.b.concat(G),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(G){this.a===0&&(this.a=2,this.d=G,this.g.fire())}}e.$Qh=$e;class Pe extends $e{constructor(G,ie){super(ie),this.m=G}cancel(){this.m.cancel()}}e.$Rh=Pe;function se(oe){const G=new u.$me,ie=oe(G.token);return new Pe(G,async me=>{const pe=G.token.onCancellationRequested(()=>{pe.dispose(),G.dispose(),me.reject(new N.$5)});try{for await(const Ae of ie){if(G.token.isCancellationRequested)return;me.emitOne(Ae)}pe.dispose(),G.dispose()}catch(Ae){pe.dispose(),G.dispose(),me.reject(Ae)}})}class re{constructor(G){this.a=new we,this.b=new $e(pe=>{if(ie){pe.reject(ie);return}return me&&pe.emitMany(me),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},G);let ie,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{ie||(ie=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Th=re}),define(ke[35],Ee([1,0,19,8,34,27,17,11,14]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=S,e.$ik=v,e.$jk=P,e.$kk=I,e.$lk=j,e.$mk=F,e.$nk=z,e.$ok=W;function S(){return Object.create(null)}e.$gk="**",e.$hk="/";const A="[/\\\\]",C="[^/\\\\]",m=/\//g;function y(X,x){switch(X){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${x?`|${A}${C}+`:""})*?`}}function v(X,x){if(!X)return[];const Y=[];let Z=!1,ue=!1,te="";for(const we of X){switch(we){case x:if(!Z&&!ue){Y.push(te),te="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}te+=we}return te&&Y.push(te),Y}function l(X){if(!X)return"";let x="";const Y=v(X,e.$hk);if(Y.every(Z=>Z===e.$gk))x=".*";else{let Z=!1;Y.forEach((ue,te)=>{if(ue===e.$gk){if(Z)return;x+=y(2,te===Y.length-1)}else{let we=!1,Se="",_=!1,U="";for(const ne of ue){if(ne!=="}"&&we){Se+=ne;continue}if(_&&(ne!=="]"||!U)){let $e;ne==="-"?$e=ne:(ne==="^"||ne==="!")&&!U?$e="^":ne===e.$hk?$e="":$e=(0,$.$8e)(ne),U+=$e;continue}switch(ne){case"{":we=!0;continue;case"[":_=!0;continue;case"}":{const Pe=`(?:${v(Se,",").map(se=>l(se)).join("|")})`;x+=Pe,we=!1,Se="";break}case"]":{x+="["+U+"]",_=!1,U="";break}case"?":x+=C;continue;case"*":x+=y(1);continue;default:x+=(0,$.$8e)(ne)}}te<Y.length-1&&(Y[te+1]!==e.$gk||te+2<Y.length)&&(x+=A)}Z=ue===e.$gk})}return x}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),g=function(){return!1},c=function(){return null};function h(X,x){if(!X)return c;let Y;typeof X!="string"?Y=X.pattern:Y=X,Y=Y.trim();const Z=`${Y}_${!!x.trimForExclusions}`;let ue=t.get(Z);if(ue)return s(ue,X);let te;return f.test(Y)?ue=d(Y.substr(4),Y):(te=a.exec(w(Y,x)))?ue=D(te[1],Y):(x.trimForExclusions?i:n).test(Y)?ue=b(Y,x):(te=r.exec(w(Y,x)))?ue=E(te[1].substr(1),Y,!0):(te=o.exec(w(Y,x)))?ue=E(te[1],Y,!1):ue=k(Y),t.set(Z,ue),s(ue,X)}function s(X,x){if(typeof x=="string")return X;const Y=function(Z,ue){return(0,L.$qg)(Z,x.base,!p.$k)?X((0,$.$af)(Z.substr(x.base.length),M.sep),ue):null};return Y.allBasenames=X.allBasenames,Y.allPaths=X.allPaths,Y.basenames=X.basenames,Y.patterns=X.patterns,Y}function w(X,x){return x.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function d(X,x){return function(Y,Z){return typeof Y=="string"&&Y.endsWith(X)?x:null}}function D(X,x){const Y=`/${X}`,Z=`\\${X}`,ue=function(we,Se){return typeof we!="string"?null:Se?Se===X?x:null:we===X||we.endsWith(Y)||we.endsWith(Z)?x:null},te=[X];return ue.basenames=te,ue.patterns=[x],ue.allBasenames=te,ue}function b(X,x){const Y=B(X.slice(1,-1).split(",").map(Se=>h(Se,x)).filter(Se=>Se!==c),X),Z=Y.length;if(!Z)return c;if(Z===1)return Y[0];const ue=function(Se,_){for(let U=0,ne=Y.length;U<ne;U++)if(Y[U](Se,_))return X;return null},te=Y.find(Se=>!!Se.allBasenames);te&&(ue.allBasenames=te.allBasenames);const we=Y.reduce((Se,_)=>_.allPaths?Se.concat(_.allPaths):Se,[]);return we.length&&(ue.allPaths=we),ue}function E(X,x,Y){const Z=M.sep===M.$hc.sep,ue=Z?X:X.replace(m,M.sep),te=M.sep+ue,we=M.$hc.sep+X;let Se;return Y?Se=function(_,U){return typeof _=="string"&&(_===ue||_.endsWith(te)||!Z&&(_===X||_.endsWith(we)))?x:null}:Se=function(_,U){return typeof _=="string"&&(_===ue||!Z&&_===X)?x:null},Se.allPaths=[(Y?"*/":"./")+X],Se}function k(X){try{const x=new RegExp(`^${l(X)}$`);return function(Y){return x.lastIndex=0,typeof Y=="string"&&x.test(Y)?X:null}}catch{return c}}function P(X,x,Y){return!X||typeof x!="string"?!1:I(X)(x,void 0,Y)}function I(X,x={}){if(!X)return g;if(typeof X=="string"||j(X)){const Y=h(X,x);if(Y===c)return g;const Z=function(ue,te){return!!Y(ue,te)};return Y.allBasenames&&(Z.allBasenames=Y.allBasenames),Y.allPaths&&(Z.allPaths=Y.allPaths),Z}return O(X,x)}function j(X){const x=X;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function F(X){return X.allBasenames||[]}function z(X){return X.allPaths||[]}function O(X,x){const Y=B(Object.getOwnPropertyNames(X).map(Se=>T(Se,X[Se],x)).filter(Se=>Se!==c)),Z=Y.length;if(!Z)return c;if(!Y.some(Se=>!!Se.requiresSiblings)){if(Z===1)return Y[0];const Se=function(ne,$e){let Pe;for(let se=0,re=Y.length;se<re;se++){const oe=Y[se](ne,$e);if(typeof oe=="string")return oe;(0,N.$ch)(oe)&&(Pe||(Pe=[]),Pe.push(oe))}return Pe?(async()=>{for(const se of Pe){const re=await se;if(typeof re=="string")return re}return null})():null},_=Y.find(ne=>!!ne.allBasenames);_&&(Se.allBasenames=_.allBasenames);const U=Y.reduce((ne,$e)=>$e.allPaths?ne.concat($e.allPaths):ne,[]);return U.length&&(Se.allPaths=U),Se}const ue=function(Se,_,U){let ne,$e;for(let Pe=0,se=Y.length;Pe<se;Pe++){const re=Y[Pe];re.requiresSiblings&&U&&(_||(_=(0,M.$oc)(Se)),ne||(ne=_.substr(0,_.length-(0,M.$pc)(Se).length)));const oe=re(Se,_,ne,U);if(typeof oe=="string")return oe;(0,N.$ch)(oe)&&($e||($e=[]),$e.push(oe))}return $e?(async()=>{for(const Pe of $e){const se=await Pe;if(typeof se=="string")return se}return null})():null},te=Y.find(Se=>!!Se.allBasenames);te&&(ue.allBasenames=te.allBasenames);const we=Y.reduce((Se,_)=>_.allPaths?Se.concat(_.allPaths):Se,[]);return we.length&&(ue.allPaths=we),ue}function T(X,x,Y){if(x===!1)return c;const Z=h(X,Y);if(Z===c)return c;if(typeof x=="boolean")return Z;if(x){const ue=x.when;if(typeof ue=="string"){const te=(we,Se,_,U)=>{if(!U||!Z(we,Se))return null;const ne=ue.replace("$(basename)",()=>_),$e=U(ne);return(0,N.$ch)($e)?$e.then(Pe=>Pe?X:null):$e?X:null};return te.requiresSiblings=!0,te}}return Z}function B(X,x){const Y=X.filter(Se=>!!Se.basenames);if(Y.length<2)return X;const Z=Y.reduce((Se,_)=>{const U=_.basenames;return U?Se.concat(U):Se},[]);let ue;if(x){ue=[];for(let Se=0,_=Z.length;Se<_;Se++)ue.push(x)}else ue=Y.reduce((Se,_)=>{const U=_.patterns;return U?Se.concat(U):Se},[]);const te=function(Se,_){if(typeof Se!="string")return null;if(!_){let ne;for(ne=Se.length;ne>0;ne--){const $e=Se.charCodeAt(ne-1);if($e===47||$e===92)break}_=Se.substr(ne)}const U=Z.indexOf(_);return U!==-1?ue[U]:null};te.basenames=Z,te.patterns=ue,te.allBasenames=Z;const we=X.filter(Se=>!Se.basenames);return we.push(te),we}function W(X,x){return(0,u.$ub)(X,x,(Y,Z)=>typeof Y=="string"&&typeof Z=="string"?Y===Z:typeof Y!="string"&&typeof Z!="string"?Y.base===Z.base&&Y.pattern===Z.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=S,e.$Pk=A,e.$Qk=C,e.$Rk=m,e.$Sk=y,e.$Tk=v,e.$Uk=l,e.$Vk=f;var p;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=m(this.supportThemeIcons?(0,N.$Hk)(n):n).replace(/([ \t]+)/g,(r,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,R.$8e)(i),"g");return n.replace(r,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Nk=$;function S(a){return A(a)?!a.value:Array.isArray(a)?a.every(S):!0}function A(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function C(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,L.$Wg)(M.URI.from(a.baseUri),M.URI.from(n.baseUri)))}function m(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,a,`${"`".repeat(r)}`].join(`
`)}function v(a){return a.replace(/"/g,"&quot;")}function l(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const r=i[1];if(r){const o=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),g=o?o[1]:"",c=t?t[1]:"",h=isFinite(parseInt(c)),s=isFinite(parseInt(g));h&&n.push(`width="${c}"`),s&&n.push(`height="${g}"`)}return{href:a,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=$,e.$ow=A,e.$pw=m,e.$qw=y,e.$rw=a,e.$sw=i,e.$tw=r,e.$uw=o,e.$vw=t,e.$ww=g;function $(h,s){const{os:w,tildify:d,relative:D}=s;if(D){const k=S(h,D,w);if(typeof k=="string")return k}let b=h.fsPath;if(w===1&&!R.$i?b=b.replace(/\//g,"\\"):w!==1&&R.$i&&(b=b.replace(/\\/g,"/")),w!==1&&d?.userHome){const k=d.userHome.fsPath;let P;h.scheme!==d.userHome.scheme&&h.path[0]===L.$hc.sep&&h.path[1]!==L.$hc.sep?P=d.userHome.with({path:h.path}).fsPath:P=b,b=m(P,k,w)}return(w===1?L.$gc:L.$hc).normalize(A(b,w===1))}function S(h,s,w){const d=w===1?L.$gc:L.$hc,D=w===3?M.$Tg:M.$Vg,b=s.getWorkspace(),E=(0,u.$Ob)(b.folders);if(!E)return;h.scheme!==E.uri.scheme&&h.path[0]===L.$hc.sep&&h.path[1]!==L.$hc.sep&&(h=E.uri.with({path:h.path}));const k=s.getWorkspaceFolder(h);if(!k)return;let P;if(D.isEqual(k.uri,h)?P="":P=D.relativePath(k.uri,h)??"",P&&(P=d.normalize(P)),b.folders.length>1&&!s.noPrefix){const I=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${I} \u2022 ${P}`:I}return P}function A(h,s=R.$i){return(0,N.$ug)(h,s)?h.charAt(0).toUpperCase()+h.slice(1):h}let C=Object.create(null);function m(h,s,w=R.OS){if(w===1||!h||!s)return h;let d=C.original===s?C.normalized:void 0;d||(d=s,R.$i&&(d=(0,N.$kg)(d)),d=`${(0,p.$bf)(d,L.$hc.sep)}${L.$hc.sep}`,C={original:s,normalized:d});let D=h;return R.$i&&(D=(0,N.$kg)(D)),(w===3?D.startsWith(d):(0,p.$uf)(D,d))?`~/${D.substr(d.length)}`:h}function y(h,s){return h.replace(/^~($|\/|\\)/,`${s}$1`)}const v="\u2026",l="\\\\",f="~";function a(h,s=L.sep){const w=new Array(h.length);let d=!1;for(let D=0;D<h.length;D++){const b=h[D];if(b===""){w[D]=`.${s}`;continue}if(!b){w[D]=b;continue}d=!0;let E="",k=b;k.indexOf(l)===0?(E=k.substr(0,k.indexOf(l)+l.length),k=k.substr(k.indexOf(l)+l.length)):k.indexOf(s)===0?(E=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length)):k.indexOf(f)===0&&(E=k.substr(0,k.indexOf(f)+f.length),k=k.substr(k.indexOf(f)+f.length));const P=k.split(s);for(let I=1;d&&I<=P.length;I++)for(let j=P.length-I;d&&j>=0;j--){d=!1;let F=P.slice(j,j+I).join(s);for(let z=0;!d&&z<h.length;z++)if(z!==D&&h[z]&&h[z].indexOf(F)>-1){const O=j+I===P.length,T=j>0&&h[z].indexOf(s)>-1?s+F:F,B=h[z].endsWith(T);d=!O||B}if(!d){let z="";(P[0].endsWith(":")||E!=="")&&(j===1&&(j=0,I++,F=P[0]+s+F),j>0&&(z=P[0]+s),z=E+z),j>0&&(z=z+v+s),z=z+F,j+I<P.length&&(z=z+s+v),w[D]=z}}d&&(w[D]=b)}return w}var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(h,s=Object.create(null)){const w=[];let d=!1,D="";for(const b of h)if(b==="$"||d&&b==="{")D&&w.push({value:D,type:n.TEXT}),D="",d=!0;else if(b==="}"&&d){const E=s[D];if(typeof E=="string")E.length&&w.push({value:E,type:n.VARIABLE});else if(E){const k=w[w.length-1];(!k||k.type!==n.SEPARATOR)&&w.push({value:E.label,type:n.SEPARATOR})}D="",d=!1}else D+=b;return D&&!d&&w.push({value:D,type:n.TEXT}),w.filter((b,E)=>{if(b.type===n.SEPARATOR){const k=w[E-1],P=w[E+1];return[k,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(b=>b.value).join("")}function r(h,s){return R.$j||s?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):h.replace(/&&|&/g,w=>w==="&"?"&&":"&")}function o(h,s){return R.$j||s?h.replace(/\(&&\w\)|&&/g,""):R.$i?h.replace(/&&|&/g,w=>w==="&"?"&&":"&"):h.replace(/&&/g,"_")}function t(h){return h.replace(/&/g,"&&")}function g(h){if(h.endsWith("]")){const s=h.lastIndexOf(" [",h.length-2);if(s!==-1){const w=c(h.substring(0,s)),d=h.substring(s);return{name:w.name+d,parentPath:w.parentPath}}}return c(h)}function c(h){const s=h.indexOf("/")!==-1?L.$hc:L.$gc,w=s.basename(h),d=s.dirname(h);return w.length?{name:w,parentPath:d}:{name:d,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=S,e.$wn=A;function L(C){return C.toJSON()}class R{constructor(m){this.a=m}transformIncoming(m){const y=this.a.transformIncoming(m);return y===m?m:L(N.URI.from(y))}transformOutgoing(m){const y=this.a.transformOutgoing(m);return y===m?m:L(N.URI.from(y))}transformOutgoingURI(m){const y=this.a.transformOutgoing(m);return y===m?m:N.URI.from(y)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$sn=R,e.$tn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function M(C,m,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const l=M(C[v],m,y+1);l!==null&&(C[v]=l)}}return null}function p(C,m){const y=M(C,m,0);return y===null?C:y}function $(C,m,y,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof u.$Ce)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const f=$(C[l],m,y,v+1);f!==null&&(C[l]=f)}}return null}function S(C,m){const y=$(C,m,!1,0);return y===null?C:y}function A(C,m){const y=$(C,m,!0,0);return y===null?C:y}}),define(ke[31],Ee([1,0,52,64,394,8,34,76,17,11,23,2]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=w,e.writeFileSync=D;var m;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function y(T,B=m.UNLINK,W){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?l(T):v(T,W)}async function v(T,B=(0,M.$yg)((0,N.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(W){return W.code==="ENOENT"?void 0:l(T)}l(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function l(T){return(0,L.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function f(T){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function a(T,B){return r(await(B?n(T):(0,L.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],W=await a(T);for(const X of W){let x=!1,Y=!1,Z=!1;try{const ue=await e.Promises.lstat((0,$.$kc)(T,X));x=ue.isFile(),Y=ue.isDirectory(),Z=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}B.push({name:X,isFile:()=>x,isDirectory:()=>Y,isSymbolicLink:()=>Z})}return B}function i(T){return r(u.readdirSync(T))}function r(T){return T.map(B=>typeof B=="string"?S.$j?(0,p.$8l)(B):B:(B.name=S.$j?(0,p.$8l)(B.name):B.name,B))}async function o(T){const B=await a(T),W=[];for(const X of B)await g.existsDirectory((0,$.$kc)(T,X))&&W.push(X);return W}function t(T,B=1e3){return new Promise(W=>{let X=!1;const x=setInterval(()=>{X||(X=!0,u.access(T,Y=>{X=!1,Y&&(clearInterval(x),W(void 0))}))},B)})}var g;(function(T){async function B(x){let Y;try{if(Y=await e.Promises.lstat(x),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(S.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ue}throw Z}}T.stat=B;async function W(x){try{const{stat:Y,symbolicLink:Z}=await T.stat(x);return Y.isFile()&&Z?.dangling!==!0}catch{}return!1}T.existsFile=W;async function X(x){try{const{stat:Y,symbolicLink:Z}=await T.stat(x);return Y.isDirectory()&&Z?.dangling!==!0}catch{}return!1}T.existsDirectory=X})(g||(e.SymlinkSupport=g={}));const c=new R.$zh;function h(T,B,W){return c.queueFor(C.URI.file(T),()=>{const X=b(W);return new Promise((x,Y)=>d(T,B,X,Z=>Z?Y(Z):x()))},A.$Ug)}let s=!0;function w(T){s=T}function d(T,B,W,X){if(!s)return u.writeFile(T,B,{mode:W.mode,flag:W.flag},X);u.open(T,W.flag,W.mode,(x,Y)=>{if(x)return X(x);u.writeFile(Y,B,Z=>{if(Z)return u.close(Y,()=>X(Z));u.fdatasync(Y,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),w(!1)),u.close(Y,te=>X(te))))})})}function D(T,B,W){const X=b(W);if(!s)return u.writeFileSync(T,B,{mode:X.mode,flag:X.flag});const x=u.openSync(T,X.flag,X.mode);try{u.writeFileSync(x,B);try{u.fdatasyncSync(x)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),w(!1)}}finally{u.closeSync(x)}}function b(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function E(T,B,W=6e4){if(T!==B)try{S.$i&&typeof W=="number"?await k(T,B,Date.now(),W):await(0,L.promisify)(u.rename)(T,B)}catch(X){if(T.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||T.endsWith("."))await P(T,B,{preserveSymlinks:!1}),await y(T,m.MOVE);else throw X}}async function k(T,B,W,X,x=0){try{return await(0,L.promisify)(u.rename)(T,B)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Y}`),Y;if(x===0){let Z=!1;try{const{stat:ue}=await g.stat(B);ue.isFile()||(Z=!0)}catch{}if(Z)throw Y}return await(0,R.$rh)(Math.min(100,x*10)),k(T,B,W,X,x+1)}}async function P(T,B,W){return j(T,B,{root:{source:T,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function j(T,B,W){if(W.handledSourcePaths.has(T))return;W.handledSourcePaths.add(T);const{stat:X,symbolicLink:x}=await g.stat(T);if(x){if(W.options.preserveSymlinks)try{return await O(T,B,W)}catch{}if(x.dangling)return}return X.isDirectory()?F(T,B,X.mode&I,W):z(T,B,X.mode&I)}async function F(T,B,W,X){await e.Promises.mkdir(B,{recursive:!0,mode:W});const x=await a(T);for(const Y of x)await j((0,$.$kc)(T,Y),(0,$.$kc)(B,Y),X)}async function z(T,B,W){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,W)}async function O(T,B,W){let X=await e.Promises.readlink(T);(0,M.$qg)(X,W.root.source,!S.$k)&&(X=(0,$.$kc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,L.promisify)(u.access)}get stat(){return(0,L.promisify)(u.stat)}get lstat(){return(0,L.promisify)(u.lstat)}get utimes(){return(0,L.promisify)(u.utimes)}get read(){return(T,B,W,X,x)=>new Promise((Y,Z)=>{u.read(T,B,W,X,x,(ue,te,we)=>ue?Z(ue):Y({bytesRead:te,buffer:we}))})}get readFile(){return(0,L.promisify)(u.readFile)}get write(){return(T,B,W,X,x)=>new Promise((Y,Z)=>{u.write(T,B,W,X,x,(ue,te,we)=>ue?Z(ue):Y({bytesWritten:te,buffer:we}))})}get appendFile(){return(0,L.promisify)(u.appendFile)}get fdatasync(){return(0,L.promisify)(u.fdatasync)}get truncate(){return(0,L.promisify)(u.truncate)}get copyFile(){return(0,L.promisify)(u.copyFile)}get open(){return(0,L.promisify)(u.open)}get close(){return(0,L.promisify)(u.close)}get symlink(){return(0,L.promisify)(u.symlink)}get readlink(){return(0,L.promisify)(u.readlink)}get chmod(){return(0,L.promisify)(u.chmod)}get mkdir(){return(0,L.promisify)(u.mkdir)}get unlink(){return(0,L.promisify)(u.unlink)}get rmdir(){return(0,L.promisify)(u.rmdir)}get realpath(){return(0,L.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return h}get rm(){return y}get rename(){return E}get copy(){return P}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=p,e.$Wq=$,e.$Xq=S,e.$Yq=A;function p(m){if(L.$k)return m;const y=(0,N.$nc)(m);if(m===y)return m;const v=((0,N.$oc)(m)||m).toLowerCase();try{const f=(0,M.readdirSync)(y).filter(a=>a.toLowerCase()===v);if(f.length===1){const a=p(y);if(a)return(0,N.$kc)(a,f[0])}else if(f.length>1){const a=f.indexOf(v);if(a>=0){const n=p(y);if(n)return(0,N.$kc)(n,f[a])}}}catch{}return null}async function $(m,y){if(L.$k)return m;const v=(0,N.$nc)(m);if(m===v)return m;const l=((0,N.$oc)(m)||m).toLowerCase();try{if(y?.isCancellationRequested)return null;const a=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===l);if(a.length===1){const n=await $(v,y);if(n)return(0,N.$kc)(n,a[0])}else if(a.length>1){const n=a.indexOf(l);if(n>=0){const i=await $(v,y);if(i)return(0,N.$kc)(i,a[n])}}}catch{}return null}async function S(m){try{return await M.Promises.realpath(m)}catch{const v=C(m);return await M.Promises.access(v,u.constants.R_OK),v}}function A(m){try{return u.realpathSync(m)}catch{const v=C(m);return u.accessSync(v,u.constants.R_OK),v}}function C(m){return(0,R.$bf)((0,N.$ic)(m),N.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=$,e.$jm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(C=L.env){return C.comspec||"cmd.exe"}function S(C){let m=[],y=!1;const v=function(l){if(y){m.push(l);return}(!C.send(l,a=>{if(a&&console.error(a),y=!1,m.length>0){const n=m.slice(0);m=[],n.forEach(i=>v(i))}})||N.$i)&&(y=!0)};return{send:v}}var A;(function(C){async function m(y,v,l){if(u.$jc(y))return y;if(v===void 0&&(v=L.cwd()),u.$nc(y)!=="."||(l===void 0&&M.$4f(L.env.PATH)&&(l=L.env.PATH.split(u.$uc)),l===void 0||l.length===0))return u.$kc(v,y);async function a(n){if(await p.Promises.exists(n)){let i;try{i=await p.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await p.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of l){let i;if(u.$jc(n)?i=u.$kc(n,y):i=u.$kc(v,n,y),await a(i))return i;let r=i+".com";if(await a(r)||(r=i+".exe",await a(r)))return r}return u.$kc(v,y)}C.findExecutable=m})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(le,e,u,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,u,N);else for(var p=le.length-1;p>=0;p--)(M=le[p])&&(R=(L<3?M(R):L>3?M(e,u,R):M(e,u))||R);return L>3&&R&&Object.defineProperty(e,u,R),R};define(ke[81],Ee([1,0,19,8,21,22,55,13,4,3,58,14,18]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=w,e.$4h=d,e.$9h=I,e.$0h=j;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y||(y={}));function v(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(l||(l={}));function f(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(a||(a={}));function n(x){let Y=0;for(let Z=0;;Z+=7){const ue=x.read(1);if(Y|=(ue.buffer[0]&127)<<Z,!(ue.buffer[0]&128))return Y}}const i=c(0);function r(x,Y){if(Y===0){x.write(i);return}let Z=0;for(let te=Y;te!==0;te=te>>>7)Z++;const ue=L.$Ce.alloc(Z);for(let te=0;Y!==0;te++)ue.buffer[te]=Y&127,Y=Y>>>7,Y>0&&(ue.buffer[te]|=128);x.write(ue)}class o{constructor(Y){this.b=Y,this.a=0}read(Y){const Z=this.b.slice(this.a,this.a+Y);return this.a+=Z.byteLength,Z}}e.$1h=o;class t{constructor(){this.a=[]}get buffer(){return L.$Ce.concat(this.a)}write(Y){this.a.push(Y)}}e.$2h=t;var g;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(g||(g={}));function c(x){const Y=L.$Ce.alloc(1);return Y.writeUInt8(x,0),Y}const h={Undefined:c(g.Undefined),String:c(g.String),Buffer:c(g.Buffer),VSBuffer:c(g.VSBuffer),Array:c(g.Array),Object:c(g.Object),Uint:c(g.Int)},s=typeof Buffer<"u";function w(x,Y){if(typeof Y>"u")x.write(h.Undefined);else if(typeof Y=="string"){const Z=L.$Ce.fromString(Y);x.write(h.String),r(x,Z.byteLength),x.write(Z)}else if(s&&Buffer.isBuffer(Y)){const Z=L.$Ce.wrap(Y);x.write(h.Buffer),r(x,Z.byteLength),x.write(Z)}else if(Y instanceof L.$Ce)x.write(h.VSBuffer),r(x,Y.byteLength),x.write(Y);else if(Array.isArray(Y)){x.write(h.Array),r(x,Y.length);for(const Z of Y)w(x,Z)}else if(typeof Y=="number"&&(Y|0)===Y)x.write(h.Uint),r(x,Y);else{const Z=L.$Ce.fromString(JSON.stringify(Y));x.write(h.Object),r(x,Z.byteLength),x.write(Z)}}function d(x){switch(x.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return x.read(n(x)).toString();case g.Buffer:return x.read(n(x)).buffer;case g.VSBuffer:return x.read(n(x));case g.Array:{const Z=n(x),ue=[];for(let te=0;te<Z;te++)ue.push(d(x));return ue}case g.Object:return JSON.parse(x.read(n(x)).toString());case g.Int:return n(x)}}class D{constructor(Y,Z,ue=null,te=1e3){this.h=Y,this.j=Z,this.k=ue,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(Y,Z){this.b.set(Y,Z),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const Z=this.o([Y.type]);this.k?.logOutgoing(Z,0,1,f(Y.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(Z,Y.id,1,f(Y.type),Y.data);return}}}o(Y,Z=void 0){const ue=new t;return w(ue,Y),w(ue,Z),this.p(ue.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const Z=new o(Y),ue=d(Z),te=d(Z),we=ue[0];switch(we){case 100:return this.k?.logIncoming(Y.byteLength,ue[1],1,`${v(we)}: ${ue[2]}.${ue[3]}`,te),this.s({type:we,id:ue[1],channelName:ue[2],name:ue[3],arg:te});case 102:return this.k?.logIncoming(Y.byteLength,ue[1],1,`${v(we)}: ${ue[2]}.${ue[3]}`,te),this.t({type:we,id:ue[1],channelName:ue[2],name:ue[3],arg:te});case 101:return this.k?.logIncoming(Y.byteLength,ue[1],1,`${v(we)}`),this.u({type:we,id:ue[1]});case 103:return this.k?.logIncoming(Y.byteLength,ue[1],1,`${v(we)}`),this.u({type:we,id:ue[1]})}}s(Y){const Z=this.b.get(Y.channelName);if(!Z){this.v(Y);return}const ue=new R.$me;let te;try{te=Z.call(this.j,Y.name,Y.arg,ue.token)}catch(_){te=Promise.reject(_)}const we=Y.id;te.then(_=>{this.m({id:we,data:_,type:201})},_=>{_ instanceof Error?this.m({id:we,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:we,data:_,type:203})}).finally(()=>{Se.dispose(),this.d.delete(Y.id)});const Se=(0,S.$Sc)(()=>ue.cancel());this.d.set(Y.id,Se)}t(Y){const Z=this.b.get(Y.channelName);if(!Z){this.v(Y);return}const ue=Y.id,we=Z.listen(this.j,Y.name,Y.arg)(Se=>this.m({id:ue,data:Se,type:204}));this.d.set(Y.id,we)}u(Y){const Z=this.d.get(Y.id);Z&&(Z.dispose(),this.d.delete(Y.id))}v(Y){let Z=this.g.get(Y.channelName);Z||(Z=[],this.g.set(Y.channelName,Z));const ue=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Y,timeoutTimer:ue})}w(Y){const Z=this.g.get(Y);if(Z){for(const ue of Z)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$5h=D;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class E{constructor(Y,Z=null){this.l=Y,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=Z}getChannel(Y){const Z=this;return{call(ue,te,we){return Z.a?Promise.reject(new p.$5):Z.m(Y,ue,te,we)},listen(ue,te){return Z.a?$.Event.None:Z.o(Y,ue,te)}}}m(Y,Z,ue,te=R.CancellationToken.None){const we=this.g++,_={id:we,type:100,channelName:Y,name:Z,arg:ue};if(te.isCancellationRequested)return Promise.reject(new p.$5);let U;return new Promise(($e,Pe)=>{if(te.isCancellationRequested)return Pe(new p.$5);const se=()=>{const ie=me=>{switch(me.type){case 201:this.f.delete(we),$e(me.data);break;case 202:{this.f.delete(we);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,Pe(pe);break}case 203:this.f.delete(we),Pe(me.data);break}};this.f.set(we,ie),this.p(_)};let re=null;this.b===a.Idle?se():(re=(0,N.$dh)(ie=>this.u()),re.then(()=>{re=null,se()}));const oe=()=>{re?(re.cancel(),re=null):this.p({id:we,type:101}),Pe(new p.$5)},G=te.onCancellationRequested(oe);U=(0,S.$Rc)((0,S.$Sc)(oe),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,Z,ue){const te=this.g++,Se={id:te,type:102,channelName:Y,name:Z,arg:ue};let _=null;const U=new $.$be({onWillAddFirstListener:()=>{_=(0,N.$dh)($e=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(Se)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:te,type:103}))}}),ne=$e=>U.fire($e.data);return this.f.set(te,ne),U.event}p(Y){switch(Y.type){case 100:case 102:{const Z=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(Z,Y.id,0,`${v(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const Z=this.q([Y.type,Y.id]);this.j?.logOutgoing(Z,Y.id,0,v(Y.type));return}}}q(Y,Z=void 0){const ue=new t;return w(ue,Y),w(ue,Z),this.r(ue.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const Z=new o(Y),ue=d(Z),te=d(Z),we=ue[0];switch(we){case 200:return this.j?.logIncoming(Y.byteLength,0,0,f(we)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ue[1],0,f(we),te),this.t({type:ue[0],id:ue[1],data:te})}}t(Y){if(Y.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$6h=E,Je([M.$Uh],E.prototype,"onDidInitializePromise",null);class k{get connections(){const Y=[];return this.f.forEach(Z=>Y.push(Z)),Y}constructor(Y,Z,ue){this.a=new Map,this.f=new Set,this.g=new $.$be,this.onDidAddConnection=this.g.event,this.h=new $.$be,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(Y(({protocol:te,onDidClientDisconnect:we})=>{const Se=$.Event.once(te.onMessage);this.j.add(Se(_=>{const U=new o(_),ne=d(U),$e=new D(te,ne,Z,ue),Pe=new E(te,Z);this.a.forEach((re,oe)=>$e.registerChannel(oe,re));const se={channelServer:$e,channelClient:Pe,ctx:ne};this.f.add(se),this.g.fire(se),this.j.add(we(()=>{$e.dispose(),Pe.dispose(),this.f.delete(se),this.h.fire(se)}))}))}))}getChannel(Y,Z){const ue=this;return{call(te,we,Se){let _;if((0,m.$fg)(Z)){const ne=(0,u.$4b)(ue.connections.filter(Z));_=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(ue.onDidAddConnection,Z))}else _=Z.routeCall(ue,te,we);const U=_.then(ne=>ne.channelClient.getChannel(Y));return I(U).call(te,we,Se)},listen(te,we){if((0,m.$fg)(Z))return ue.k(Y,Z,te,we);const Se=Z.routeEvent(ue,te,we).then(_=>_.channelClient.getChannel(Y));return I(Se).listen(te,we)}}}k(Y,Z,ue,te){const we=this;let Se;const _=new $.$be({onWillAddFirstListener:()=>{Se=new S.$Tc;const U=new $.$he,ne=new Map,$e=se=>{const oe=se.channelClient.getChannel(Y).listen(ue,te),G=U.add(oe);ne.set(se,G)},Pe=se=>{const re=ne.get(se);re&&(re.dispose(),ne.delete(se))};we.connections.filter(Z).forEach($e),$.Event.filter(we.onDidAddConnection,Z)($e,void 0,Se),we.onDidRemoveConnection(Pe,void 0,Se),U.event(_.fire,_,Se),Se.add(U)},onDidRemoveLastListener:()=>{Se?.dispose(),Se=void 0}});return _.event}registerChannel(Y,Z){this.a.set(Y,Z);for(const ue of this.f)ue.channelServer.registerChannel(Y,Z)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=k;class P{constructor(Y,Z,ue=null){const te=new t;w(te,Z),Y.send(te.buffer),this.a=new E(Y,ue),this.d=new D(Y,Z,ue)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,Z){this.d.registerChannel(Y,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=P;function I(x){return{call(Y,Z,ue){return x.then(te=>te.call(Y,Z,ue))},listen(Y,Z){const ue=new $.$ke;return x.then(te=>ue.input=te.listen(Y,Z)),ue.event}}}function j(x){let Y=!1;return{call(Z,ue,te){return Y?x.call(Z,ue,te):(0,N.$rh)(0).then(()=>Y=!0).then(()=>x.call(Z,ue,te))},listen(Z,ue){if(Y)return x.listen(Z,ue);const te=new $.$ke;return(0,N.$rh)(0).then(()=>Y=!0).then(()=>te.input=x.listen(Z,ue)),te.event}}}class F{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const Z of Y.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$$h=F;var z;(function(x){function Y(we,Se,_){const U=we,ne=_&&_.disableMarshalling,$e=new Map;for(const Pe in U)ue(Pe)&&$e.set(Pe,$.Event.buffer(U[Pe],!0,void 0,Se));return new class{listen(Pe,se,re){const oe=$e.get(se);if(oe)return oe;const G=U[se];if(typeof G=="function"){if(te(se))return G.call(U,re);if(ue(se))return $e.set(se,$.Event.buffer(U[se],!0,void 0,Se)),$e.get(se)}throw new p.$bb(`Event not found: ${se}`)}call(Pe,se,re){const oe=U[se];if(typeof oe=="function"){if(!ne&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,A.$Zh)(re[ie]);let G=oe.apply(U,re);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new p.$bb(`Method not found: ${se}`)}}}x.fromService=Y;function Z(we,Se){const _=Se&&Se.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return Se?.properties?.has(ne)?Se.properties.get(ne):te(ne)?function($e){return we.listen(ne,$e)}:ue(ne)?we.listen(ne):async function(...$e){let Pe;Se&&!(0,m.$ag)(Se.context)?Pe=[Se.context,...$e]:Pe=$e;const se=await we.call(ne,Pe);return _?se:(0,A.$Zh)(se)};throw new p.$bb(`Property not found: ${String(ne)}`)}})}x.toService=Z;function ue(we){return we[0]==="o"&&we[1]==="n"&&C.$sf(we.charCodeAt(2))}function te(we){return/^onDynamic/.test(we)&&C.$sf(we.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Y=x.toString();if(Y!=="[object Object]")return Y}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function W(x,Y,Z,ue,te,we,Se){Se=B(Se);const _=O[te],U=_[ue%_.length];let ne=[`%c[${x}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(we)?(ne=ne.concat(Se),ne.push(")")):ne.push(Se),console.log.apply(console,ne)}class X{constructor(Y,Z){this.d=Y,this.f=Z,this.a=0,this.b=0}logOutgoing(Y,Z,ue,te,we){this.b+=Y,W(this.d,this.b,Y,Z,ue,te,we)}logIncoming(Y,Z,ue,te,we){this.a+=Y,W(this.f,this.a,Y,Z,ue,te,we)}}e.$_h=X}),define(ke[82],Ee([1,0,21,4,3,81]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(h){h.Created="created",h.Read="read",h.Write="write",h.Open="open",h.Error="error",h.Close="close",h.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",h.NodeEndReceived="nodeEndReceived",h.NodeEndSent="nodeEndSent",h.NodeDrainBegin="nodeDrainBegin",h.NodeDrainEnd="nodeDrainEnd",h.zlibInflateError="zlibInflateError",h.zlibInflateData="zlibInflateData",h.zlibInflateInitialWrite="zlibInflateInitialWrite",h.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",h.zlibInflateWrite="zlibInflateWrite",h.zlibInflateFlushFired="zlibInflateFlushFired",h.zlibDeflateError="zlibDeflateError",h.zlibDeflateData="zlibDeflateData",h.zlibDeflateWrite="zlibDeflateWrite",h.zlibDeflateFlushFired="zlibDeflateFlushFired",h.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",h.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",h.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",h.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",h.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",h.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",h.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",h.ProtocolHeaderRead="protocolHeaderRead",h.ProtocolMessageRead="protocolMessageRead",h.ProtocolHeaderWrite="protocolHeaderWrite",h.ProtocolMessageWrite="protocolMessageWrite",h.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var p;(function(h){h.enableDiagnostics=!1,h.records=[];const s=new WeakMap;let w=0;function d(b,E){if(!s.has(b)){const k=String(++w);s.set(b,k)}return s.get(b)}function D(b,E,k,P){if(!h.enableDiagnostics)return;const I=d(b,E);if(P instanceof u.$Ce||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const j=u.$Ce.alloc(P.byteLength);j.set(P),h.records.push({timestamp:Date.now(),id:I,label:E,type:k,buff:j})}else h.records.push({timestamp:Date.now(),id:I,label:E,type:k,data:P})}h.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var $;(function(h){h[h.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",h[h.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let S=null;function A(){return S||(S=u.$Ce.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,w){if(s===0)return A();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const E=this.a[0];return w&&(this.a.shift(),this.b-=s),E}if(this.a[0].byteLength>s){const E=this.a[0].slice(0,s);return w&&(this.a[0]=this.a[0].slice(s),this.b-=s),E}const d=u.$Ce.alloc(s);let D=0,b=0;for(;s>0;){const E=this.a[b];if(E.byteLength>s){const k=E.slice(0,s);d.set(k,D),D+=s,w&&(this.a[b]=E.slice(s),this.b-=s),s-=s}else d.set(E,D),D+=E.byteLength,w?(this.a.shift(),this.b-=E.byteLength):b++,s-=E.byteLength}return d}}e.$ai=C;var m;(function(h){h[h.None=0]="None",h[h.Regular=1]="Regular",h[h.Control=2]="Control",h[h.Ack=3]="Ack",h[h.Disconnect=5]="Disconnect",h[h.ReplayRequest=6]="ReplayRequest",h[h.Pause=7]="Pause",h[h.Resume=8]="Resume",h[h.KeepAlive=9]="KeepAlive"})(m||(m={}));function y(h){switch(h){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(h){h[h.HeaderLength=13]="HeaderLength",h[h.AcknowledgeTime=2e3]="AcknowledgeTime",h[h.TimeoutTime=2e4]="TimeoutTime",h[h.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",h[h.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",h[h.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class l{constructor(s,w,d,D){this.type=s,this.id=w,this.ack=d,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.$Uc{constructor(s){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new C,this.B(this.a.onData(w=>this.acceptChunk(w))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const w=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=w.readUInt32BE(9),this.g.messageType=w.readUInt8(0),this.g.id=w.readUInt32BE(1),this.g.ack=w.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const d=this.g.messageType,D=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",w),this.f.fire(new l(d,D,b,w)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const w=u.$Ce.alloc(13);w.writeUInt8(s.type,0),w.writeUInt32BE(s.id,1),w.writeUInt32BE(s.ack,5),w.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(w,s.data)}g(s,w){const d=this.f===0;return this.d.push(s,w),this.f+=s.byteLength+w.byteLength,d}h(){const s=u.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,w){this.g(s,w)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class n extends L.$Uc{constructor(s){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new a(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(w=>{w.type===1&&this.f.fire(w.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new l(1,0,0,s))}}e.$bi=n;class i extends R.$8h{static fromSocket(s,w){return new i(new n(s),w)}get onDidDispose(){return this.b.onDidDispose}constructor(s,w,d=null){super(s,w,d),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ci=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$di=r;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,w=this.a;for(;w;)w=w.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let w=0,d=this.a;for(;d;)s[w++]=d.data,d=d.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const w=new o(s);if(!this.a){this.a=w,this.b=w;return}this.b.next=w,this.b=w}}class g{static{this.a=10}static{this.b=null}static getInstance(){return g.b||(g.b=new g),g.b}constructor(){this.c=[];const s=Date.now();for(let w=0;w<g.a;w++)this.c[w]=s-1e3*w;setInterval(()=>{for(let w=g.a;w>=1;w--)this.c[w]=this.c[w-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),w=(1+g.a)*1e3;let d=0;for(let D=0;D<g.a;D++)s-this.c[D]<=w&&d++;return 1-d/g.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??g.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=s.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new l(5,0,0,A());this.p.write(s),this.p.flush()}sendPause(){const s=new l(7,0,0,A());this.p.write(s)}sendResume(){const s=new l(8,0,0,A());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,w){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),this.q.acceptChunk(w)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new l(3,0,this.h,A());this.p.write(s);const w=this.b.toArray();for(let d=0,D=w.length;d<D;d++)this.p.write(w[d]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const w=this.b.peek();if(w&&w.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const w=Date.now();w-this.m>1e4&&(this.m=w,this.p.write(new l(6,0,0,A())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const w=this.b.toArray();for(let d=0,D=w.length;d<D;d++)this.p.write(w[d]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const w=++this.c;this.h=this.g;const d=new l(1,w,this.h,s);this.b.push(d),this.a||(this.p.write(d),this.B())}sendControl(s){const w=new l(2,0,0,s);this.p.write(w)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),w=Date.now()-s.writtenTime,d=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(w>=2e4&&d>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:w,timeSinceLastReceivedSomeData:d});return}const b=Math.max(2e4-w,2e4-d,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new l(3,0,this.h,A());this.p.write(s)}D(){this.h=this.g;const s=new l(9,0,this.h,A());this.p.write(s)}}e.$ei=c}),define(ke[194],Ee([1,0,53,8,21,22,192,13,4,3,24,105,102,81]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class v extends y.$5h{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>L.$Ce.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Rq=v;class l{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$be,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$nh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,r,o){return n.k(a,i,r,o)},listen(i,r){return n.l(a,i,r)}}}k(a,n,i,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const o=this.n(a),t=(0,N.$dh)(h=>o.call(n,i,h)),g=r.onCancellationRequested(()=>t.cancel()),c=(0,S.$Sc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{g.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return $.Event.None;this.b.cancel();let r;const o=new $.$be({onWillAddFirstListener:()=>{r=this.n(a).listen(n,i)(o.fire,o),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(w=>!/^--inspect(-brk)?=/.test(w)).filter(w=>!w.startsWith("--vscode-"))),(0,m.$hm)(n.env),this.d=(0,u.fork)(this.i,a,n);const i=new $.$be,o=$.Event.fromNodeEventEmitter(this.d,"message",w=>w)(w=>{if((0,M.$Nq)(w)){(0,M.log)(w,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Ce.wrap(Buffer.from(w,"base64")))}),t=this.j.useQueue?(0,C.$jm)(this.d):this.d,g=w=>this.d&&this.d.connected&&t.send(w.buffer.toString("base64")),c=i.event,h={send:g,onMessage:c};this.f=new y.$6h(h);const s=()=>this.o();process.once("exit",s),this.d.on("error",w=>console.warn('IPC "'+this.j.serverName+'" errored with '+w)),this.d.on("exit",(w,d)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),w!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+w+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:w,signal:d})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=l}),define(ke[195],Ee([1,0,8,4,3,58,18]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=$;var p;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(m){const y=m;return y?.changed instanceof Map||y?.deleted instanceof Set}var S;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(S||(e.StorageState=S={}));class A extends L.$Uc{static{this.a=100}constructor(y,v=Object.create(null)){super(),this.r=y,this.s=v,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new u.$oh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((v,l)=>this.w(l,v)),y.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(y,v){if(this.c===S.Closed)return;let l=!1;(0,M.$ag)(v)?l=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),l=!0),l&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,v){const l=this.f.get(y);return(0,M.$ag)(l)?v:l}getBoolean(y,v){const l=this.get(y);return(0,M.$ag)(l)?v:l==="true"}getNumber(y,v){const l=this.get(y);return(0,M.$ag)(l)?v:parseInt(l,10)}getObject(y,v){const l=this.get(y);return(0,M.$ag)(l)?v:(0,R.$Yh)(l)}async set(y,v,l=!1){if(this.c===S.Closed)return;if((0,M.$ag)(v))return this.delete(y,l);const f=(0,M.$6f)(v)||Array.isArray(v)?(0,R.$Xh)(v):String(v);if(this.f.get(y)!==f)return this.f.set(y,f),this.j.set(y,f),this.h.delete(y),this.b.fire({key:y,external:l}),this.D()}async delete(y,v=!1){if(!(this.c===S.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Qp=A;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,l)=>this.a.set(l,v)),y.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Rp=C}),define(ke[196],Ee([1,0,14,11,21]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=A,e.$ut=C;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let S;function A(){return S||(S=N.$D()?M():$()),S}function C(v,l,f){const a=new Uint16Array(v.buffer,l,f);return f>0&&(a[0]===65279||a[0]===65534)?m(v,l,f):M().decode(a)}function m(v,l,f){const a=[];let n=0;for(let i=0;i<f;i++){const r=L.$Ee(v,l);l+=2,a[n++]=String.fromCharCode(r)}return a.join("")}class y{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return A().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const f=this.a-this.d;f<=1&&(f===0||u.$xf(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const f=l.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=l;return}for(let a=0;a<f;a++)this.b[this.d++]=l.charCodeAt(a)}}e.$vt=y}),define(ke[197],Ee([1,0,21,196]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function L($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,A,C,m){this.oldPosition=S,this.oldText=A,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,A,C){const m=A.length;u.$He(S,m,C),C+=4;for(let y=0;y<m;y++)u.$Fe(S,A.charCodeAt(y),C),C+=2;return C}static d(S,A){const C=u.$Ge(S,A);return A+=4,(0,N.$ut)(S,A,C)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(S,A){return u.$He(S,this.oldPosition,A),A+=4,u.$He(S,this.newPosition,A),A+=4,A=R.c(S,this.oldText,A),A=R.c(S,this.newText,A),A}static read(S,A,C){const m=u.$Ge(S,A);A+=4;const y=u.$Ge(S,A);A+=4;const v=R.d(S,A);A+=R.a(v);const l=R.d(S,A);return A+=R.a(l),C.push(new R(m,v,y,l)),A}}e.$wt=R;function M($,S){return $===null||$.length===0?S:new p($,S).compress()}class p{constructor(S,A){this.a=S,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,A=0,C=this.n(S),m=this.l(A);for(;S<this.f||A<this.h;){if(C===null){this.k(m),m=this.l(++A);continue}if(m===null){this.m(C),C=this.n(++S);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++A);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++S);continue}if(m.oldPosition<C.newPosition){const[a,n]=p.r(m,C.newPosition-m.oldPosition);this.k(a),m=n;continue}if(C.newPosition<m.oldPosition){const[a,n]=p.q(C,m.oldPosition-C.newPosition);this.m(a),C=n;continue}let l,f;if(m.oldEnd===C.newEnd)l=C,f=m,C=this.n(++S),m=this.l(++A);else if(m.oldEnd<C.newEnd){const[a,n]=p.q(C,m.oldLength);l=a,f=m,C=n,m=this.l(++A)}else{const[a,n]=p.r(m,C.newLength);l=C,f=a,C=this.n(++S),m=n}this.d[this.e++]=new R(l.oldPosition,l.oldText,f.newPosition,f.newText),this.g+=l.newLength-l.oldLength,this.j+=f.newLength-f.oldLength}const y=p.s(this.d);return p.t(y)}k(S){this.d[this.e++]=p.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=p.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,A){return new R(A.oldPosition-S,A.oldText,A.newPosition,A.newText)}static p(S,A){return new R(A.oldPosition,A.oldText,A.newPosition+S,A.newText)}static q(S,A){const C=S.newText.substr(0,A),m=S.newText.substr(A);return[new R(S.oldPosition,S.oldText,S.newPosition,C),new R(S.oldEnd,"",S.newPosition+A,m)]}static r(S,A){const C=S.oldText.substr(0,A),m=S.oldText.substr(A);return[new R(S.oldPosition,C,S.newPosition,S.newText),new R(S.oldPosition+A,m,S.newEnd,"")]}static s(S){if(S.length===0)return S;const A=[];let C=0,m=S[0];for(let y=1;y<S.length;y++){const v=S[y];m.oldEnd===v.oldPosition?m=new R(m.oldPosition,m.oldText+v.oldText,m.newPosition,m.newText+v.newText):(A[C++]=m,m=v)}return A[C++]=m,A}static t(S){if(S.length===0)return S;const A=[];let C=0;for(let m=0;m<S.length;m++){const y=S[m];y.oldText!==y.newText&&(A[C++]=y)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=L,e.$Vt=R;function L(M,p,$,S,A,C){if(Array.isArray(M)){let m=0;for(const y of M){const v=L(y,p,$,S,A,C);if(v===10)return v;v>m&&(m=v)}return m}else{if(typeof M=="string")return S?M==="*"?5:M===$?10:0:0;if(M){const{language:m,pattern:y,scheme:v,hasAccessToAllModels:l,notebookType:f}=M;if(!S&&!l)return 0;f&&A&&(p=A);let a=0;if(v)if(v===p.scheme)a=10;else if(v==="*")a=5;else return 0;if(m)if(m===$)a=10;else if(m==="*")a=Math.max(a,5);else return 0;if(f)if(f===C)a=10;else if(f==="*"&&C!==void 0)a=Math.max(a,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,N.$ic)(y.base)},n===p.fsPath||(0,u.$jk)(n,p.fsPath))a=10;else return 0}return a}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=void 0;class A extends S.$Uc{constructor(m,y,v,l,f,a,n){super(),this.m=this.B(new u.$be),this.onDidChangeContent=this.m.event,this.f=y,this.j=!a,this.g=l,this.h=f,this.c=new M.$JC(m,v,n)}equals(m){return!(m instanceof A)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,y){return this.c.getOffsetAt(m,y)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,y){const v=m+y,l=this.getPositionAt(m),f=this.getPositionAt(v);return new L.$kt(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(m,y=0){if(m.isEmpty())return"";const v=this.n(y);return this.c.getValueInRange(m,v)}getValueLengthInRange(m,y=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const v=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const a=this.n(y),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,r=m.endLineNumber-m.startLineNumber;f=i*r}return l-v+f}getCharacterCountInRange(m,y=0){if(this.j){let v=0;const l=m.startLineNumber,f=m.endLineNumber;for(let a=l;a<=f;a++){const n=this.getLineContent(a),i=a===l?m.startColumn-1:0,r=a===f?m.endColumn-1:n.length;for(let o=i;o<r;o++)N.$xf(n.charCodeAt(o))?(v=v+1,o=o+1):v=v+1}return v+=this.n(y).length*(f-l),v}return this.getValueLengthInRange(m,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,y){return this.c.getLineCharCode(m,y)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const y=N.$if(this.getLineContent(m));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(m){const y=N.$kf(this.getLineContent(m));return y===-1?0:y+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,y,v){let l=this.g,f=this.h,a=this.j,n=!0,i=[];for(let s=0;s<m.length;s++){const w=m[s];n&&w._isTracked&&(n=!1);const d=w.range;if(w.text){let P=!0;a||(P=!N.$If(w.text),a=P),!l&&P&&(l=N.$Hf(w.text)),!f&&P&&(f=N.$Kf(w.text))}let D="",b=0,E=0,k=0;if(w.text){let P;[b,E,k,P]=(0,p.$Nt)(w.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=w.text:D=w.text.replace(/\r\n|\r|\n/g,I)}i[s]={sortIndex:s,identifier:w.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:D,eolCount:b,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let s=0,w=i.length-1;s<w;s++){const d=i[s].range.getEndPosition(),D=i[s+1].range.getStartPosition();if(D.isBeforeOrEqual(d)){if(D.isBefore(d))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const o=v||y?A._getInverseEditRanges(i):[],t=[];if(y)for(let s=0;s<i.length;s++){const w=i[s],d=o[s];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let D=d.startLineNumber;D<=d.endLineNumber;D++){let b="";D===d.startLineNumber&&(b=this.getLineContent(w.range.startLineNumber),N.$if(b)!==-1)||t.push({lineNumber:D,oldContent:b})}}let g=null;if(v){let s=0;g=[];for(let w=0;w<i.length;w++){const d=i[w],D=o[w],b=this.getValueInRange(d.range),E=d.rangeOffset+s;s+=d.text.length-b.length,g[w]={sortIndex:d.sortIndex,identifier:d.identifier,range:D,text:b,textChange:new $.$wt(d.rangeOffset,b,E,d.text)}}r||g.sort((w,d)=>w.sortIndex-d.sortIndex)}this.g=l,this.h=f,this.j=a;const c=this.t(i);let h=null;if(y&&t.length>0){t.sort((s,w)=>w.lineNumber-s.lineNumber),h=[];for(let s=0,w=t.length;s<w;s++){const d=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===d)continue;const D=t[s].oldContent,b=this.getLineContent(d);b.length===0||b===D||N.$if(b)!==-1||h.push(d)}}return this.m.fire(),new R.$zv(g,c,h)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let y=!1;const v=m[0].range,l=m[m.length-1].range,f=new L.$kt(v.startLineNumber,v.startColumn,l.endLineNumber,l.endColumn);let a=v.startLineNumber,n=v.startColumn;const i=[];for(let c=0,h=m.length;c<h;c++){const s=m[c],w=s.range;y=y||s.forceMoveMarkers,i.push(this.getValueInRange(new L.$kt(a,n,w.startLineNumber,w.startColumn))),s.text.length>0&&i.push(s.text),a=w.endLineNumber,n=w.endColumn}const r=i.join(""),[o,t,g]=(0,p.$Nt)(r);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:r,eolCount:o,firstLineLength:t,lastLineLength:g,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(m){m.sort(A.w);const y=[];for(let v=0;v<m.length;v++){const l=m[v],f=l.range.startLineNumber,a=l.range.startColumn,n=l.range.endLineNumber,i=l.range.endColumn;if(f===n&&a===i&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const r=new L.$kt(f,a,n,i);y.push({range:r,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return y}findMatchesLineByLine(m,y,v,l){return this.c.findMatchesLineByLine(m,y,v,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,y){const v=m.startLineNumber,l=m.startColumn,[f,a,n]=(0,p.$Nt)(y);let i;if(y.length>0){const r=f+1;r===1?i=new L.$kt(v,l,v,l+a):i=new L.$kt(v,l,v+r-1,n+1)}else i=new L.$kt(v,l,v,l);return i}static _getInverseEditRanges(m){const y=[];let v=0,l=0,f=null;for(let a=0,n=m.length;a<n;a++){const i=m[a];let r,o;f?f.range.endLineNumber===i.range.startLineNumber?(r=v,o=l+(i.range.startColumn-f.range.endColumn)):(r=v+(i.range.startLineNumber-f.range.endLineNumber),o=i.range.startColumn):(r=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const g=i.eolCount+1;g===1?t=new L.$kt(r,o,r,o+i.firstLineLength):t=new L.$kt(r,o,r+g-1,i.lastLineLength+1)}else t=new L.$kt(r,o,r,o);v=t.endLineNumber,l=t.endColumn,y.push(t),f=i}return y}static u(m,y){const v=L.$kt.compareRangesUsingEnds(m.range,y.range);return v===0?m.sortIndex-y.sortIndex:v}static w(m,y){const v=L.$kt.compareRangesUsingEnds(m.range,y.range);return v===0?y.sortIndex-m.sortIndex:-v}}e.$KC=A}),define(ke[200],Ee([1,0,14,130,199]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class R{constructor($,S,A,C,m,y,v,l,f){this.a=$,this.b=S,this.c=A,this.d=C,this.e=m,this.f=y,this.g=v,this.h=l,this.j=f}k($){const S=this.c+this.d+this.e,A=this.c+this.e;return S===0?$===1?`
`:`\r
`:A>S/2?`\r
`:`
`}create($){const S=this.k($),A=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let m=0,y=A.length;m<y;m++){const v=A[m].buffer.replace(/\r\n|\r|\n/g,S),l=(0,N.$FC)(v);A[m]=new N.$IC(v,l)}const C=new L.$KC(A,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$Rf($)&&(this.b=u.$Qf,$=$.substr(1));const S=$.charCodeAt($.length-1);S===13||S>=55296&&S<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=S):(this.m($,!1),this.c=!1,this.d=S)}m($,S){!S&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const S=(0,N.$GC)(this.e,$);this.a.push(new N.$IC($,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Hf($)),this.k||(this.k=u.$Kf($)))}finish($=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const S=(0,N.$FC)($.buffer);$.lineStarts=S,this.d===13&&this.f++}}}e.$LC=M}),define(ke[134],Ee([1,0,21,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbb=$,e.$Gbb=A;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function R(C){for(let m=0,y=C.length;m<y;m+=4){const v=C[m+0],l=C[m+1],f=C[m+2],a=C[m+3];C[m+0]=a,C[m+1]=f,C[m+2]=l,C[m+3]=v}}function M(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||R(m),u.$Ce.wrap(m)}function p(C){const m=C.buffer;if(N.$D()||R(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const y=new Uint8Array(m.byteLength);return y.set(m),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function $(C){const m=new Uint32Array(S(C));let y=0;if(m[y++]=C.id,C.type==="full")m[y++]=1,m[y++]=C.data.length,m.set(C.data,y),y+=C.data.length;else{m[y++]=2,m[y++]=C.deltas.length;for(const v of C.deltas)m[y++]=v.start,m[y++]=v.deleteCount,v.data?(m[y++]=v.data.length,m.set(v.data,y),y+=v.data.length):m[y++]=0}return M(m)}function S(C){let m=0;if(m+=2,C.type==="full")m+=1+C.data.length;else{m+=1,m+=3*C.deltas.length;for(const y of C.deltas)y.data&&(m+=y.data.length)}return m}function A(C){const m=p(C);let y=0;const v=m[y++];if(m[y++]===1){const n=m[y++],i=m.subarray(y,y+n);return y+=n,{id:v,type:"full",data:i}}const f=m[y++],a=[];for(let n=0;n<f;n++){const i=m[y++],r=m[y++],o=m[y++];let t;o>0&&(t=m.subarray(y,y+o),y+=o),a[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:a}}}),define(ke[201],Ee([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=n,e.clampedFloat=r,e.stringSet=g,e.cursorStyleToString=k,e.filterValidationDecorations=pe;var $;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=S;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(ce,Re,Ge,Me){this.id=ce,this.name=Re,this.defaultValue=Ge,this.schema=Me}applyUpdate(ce,Re){return y(ce,Re)}compute(ce,Re,Ge){return Ge}}class m{constructor(ce,Re){this.newValue=ce,this.didChange=Re}}e.ApplyUpdateResult=m;function y(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new m(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ge=Array.isArray(ae)&&Array.isArray(ce)&&u.$ub(ae,ce);return new m(ce,!Ge)}let Re=!1;for(const Ge in ce)if(ce.hasOwnProperty(Ge)){const Me=y(ae[Ge],ce[Ge]);Me.didChange&&(ae[Ge]=Me.newValue,Re=!0)}return new m(ae,Re)}class v{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Re){return y(ce,Re)}validate(ce){return this.defaultValue}}class l{constructor(ce,Re,Ge,Me){this.id=ce,this.name=Re,this.defaultValue=Ge,this.schema=Me}applyUpdate(ce,Re){return y(ce,Re)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Re,Ge){return Ge}}function f(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends l{constructor(ce,Re,Ge,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ge),super(ce,Re,Ge,Me)}validate(ce){return f(ce,this.defaultValue)}}function n(ae,ce,Re,Ge){if(typeof ae>"u")return ce;let Me=parseInt(ae,10);return isNaN(Me)?ce:(Me=Math.max(Re,Me),Me=Math.min(Ge,Me),Me|0)}class i extends l{static clampedInt(ce,Re,Ge,Me){return n(ce,Re,Ge,Me)}constructor(ce,Re,Ge,Me,tt,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ge,ht.minimum=Me,ht.maximum=tt),super(ce,Re,Ge,ht),this.minimum=Me,this.maximum=tt}validate(ce){return i.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function r(ae,ce,Re,Ge){if(typeof ae>"u")return ce;const Me=o.float(ae,ce);return o.clamp(Me,Re,Ge)}class o extends l{static clamp(ce,Re,Ge){return ce<Re?Re:ce>Ge?Ge:ce}static float(ce,Re){if(typeof ce=="number")return ce;if(typeof ce>"u")return Re;const Ge=parseFloat(ce);return isNaN(Ge)?Re:Ge}constructor(ce,Re,Ge,Me,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ge),super(ce,Re,Ge,tt),this.validationFn=Me}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends l{static string(ce,Re){return typeof ce!="string"?Re:ce}constructor(ce,Re,Ge,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ge),super(ce,Re,Ge,Me)}validate(ce){return t.string(ce,this.defaultValue)}}function g(ae,ce,Re,Ge){return typeof ae!="string"?ce:Ge&&ae in Ge?Ge[ae]:Re.indexOf(ae)===-1?ce:ae}class c extends l{constructor(ce,Re,Ge,Me,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Me,tt.default=Ge),super(ce,Re,Ge,tt),this.c=Me}validate(ce){return g(ce,this.defaultValue,this.c)}}class h extends C{constructor(ce,Re,Ge,Me,tt,ht,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=tt,wt.default=Me),super(ce,Re,Ge,wt),this.c=tt,this.d=ht}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function s(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Re,Ge){return Ge===0?ce.accessibilitySupport:Ge}}class d extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertSpace:f(Re.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Re.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function b(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(ae){switch(ae){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(ae){switch(ae){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ce,Re,Ge){const Me=["monaco-editor"];return Re.get(39)&&Me.push(Re.get(39)),ce.extraEditorClassName&&Me.push(ce.extraEditorClassName),Re.get(74)==="default"?Me.push("mouse-default"):Re.get(74)==="copy"&&Me.push("mouse-copy"),Re.get(111)&&Me.push("showUnused"),Re.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class j extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ce,Re,Ge){return Ge&&ce.emptySelectionClipboard}}class F extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:p.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:p.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{cursorMoveOnType:f(Re.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":g(Re.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":g(Re.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Re.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Re.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Re.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.TRANSLATE:ce:ce?O.TRANSLATE:O.OFF}compute(ce,Re,Ge){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ce,Re,Ge){return ce.fontInfo}}class B extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ce){const Re=o.float(ce,this.defaultValue);return Re===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Re,6,100)}compute(ce,Re,Ge){return ce.fontInfo.fontSize}}class W extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(i.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class X extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Re={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Re},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Re},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Re},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Re},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Re},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{multiple:g(Re.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Re.multipleDefinitions??g(Re.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Re.multipleTypeDefinitions??g(Re.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Re.multipleDeclarations??g(Re.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Re.multipleImplementations??g(Re.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Re.multipleReferences??g(Re.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Re.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Re.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Re.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Re.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Re.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:p.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),delay:i.clampedInt(Re.delay,this.defaultValue.delay,0,1e4),sticky:f(Re.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Re.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Re.above,this.defaultValue.above)}}}var Y;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class Z extends v{constructor(){super(145)}compute(ce,Re,Ge){return Z.computeLayout(Re,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Re=ce.height/ce.lineHeight,Ge=Math.floor(ce.paddingTop/ce.lineHeight);let Me=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Me=Math.max(Me,Re-1));const tt=(Ge+ce.viewLineCount+Me)/(ce.pixelRatio*ce.height),ht=Math.floor(ce.viewLineCount/tt);return{typicalViewportLineCount:Re,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Me,desiredRatio:tt,minimapLineCount:ht}}static c(ce,Re){const Ge=ce.outerWidth,Me=ce.outerHeight,tt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const ht=Re.stableMinimapLayoutInput,wt=ht&&ce.outerHeight===ht.outerHeight&&ce.lineHeight===ht.lineHeight&&ce.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ht.pixelRatio&&ce.scrollBeyondLastLine===ht.scrollBeyondLastLine&&ce.paddingTop===ht.paddingTop&&ce.paddingBottom===ht.paddingBottom&&ce.minimap.enabled===ht.minimap.enabled&&ce.minimap.side===ht.minimap.side&&ce.minimap.size===ht.minimap.size&&ce.minimap.showSlider===ht.minimap.showSlider&&ce.minimap.renderCharacters===ht.minimap.renderCharacters&&ce.minimap.maxColumn===ht.minimap.maxColumn&&ce.minimap.scale===ht.minimap.scale&&ce.verticalScrollbarWidth===ht.verticalScrollbarWidth&&ce.isViewportWrapping===ht.isViewportWrapping,Lt=ce.lineHeight,At=ce.typicalHalfwidthCharacterWidth,xt=ce.scrollBeyondLastLine,_t=ce.minimap.renderCharacters;let Pt=tt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Vt=ce.minimap.maxColumn,Xt=ce.minimap.size,et=ce.minimap.side,si=ce.verticalScrollbarWidth,Yt=ce.viewLineCount,dt=ce.remainingWidth,vt=ce.isViewportWrapping,ti=_t?2:3;let Zt=Math.floor(tt*Me);const zt=Zt/tt;let gt=!1,Ut=!1,Wt=ti*Pt,Kt=Pt/tt,Ze=1;if(Xt==="fill"||Xt==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Nt}=Z.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:xt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Me,lineHeight:Lt,pixelRatio:tt});if(Yt/Nt>1)gt=!0,Ut=!0,Pt=1,Wt=1,Kt=Pt/tt;else{let It=!1,St=Pt+1;if(Xt==="fit"){const bt=Math.ceil((ii+Yt+Gt)*Wt);vt&&wt&&dt<=Re.stableFitRemainingWidth?(It=!0,St=Re.stableFitMaxMinimapScale):It=bt>Zt}if(Xt==="fill"||It){gt=!0;const bt=Pt;Wt=Math.min(Lt*tt,Math.max(1,Math.floor(1/ni))),vt&&wt&&dt<=Re.stableFitRemainingWidth&&(St=Re.stableFitMaxMinimapScale),Pt=Math.min(St,Math.max(1,Math.floor(Wt/ti))),Pt>bt&&(Ze=Math.min(2,Pt/bt)),Kt=Pt/tt/Ze,Zt=Math.ceil(Math.max(jt,ii+Yt+Gt)*Wt),vt?(Re.stableMinimapLayoutInput=ce,Re.stableFitRemainingWidth=dt,Re.stableFitMaxMinimapScale=Pt):(Re.stableMinimapLayoutInput=null,Re.stableFitRemainingWidth=0)}}}const ui=Math.floor(Vt*Kt),Ht=Math.min(ui,Math.max(0,Math.floor((dt-si-2)*Kt/(At+Kt)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(tt*Ht);const mt=Bt/tt;Bt=Math.floor(Bt*Ze);const Tt=_t?1:2,Rt=et==="left"?0:Ge-Ht-si;return{renderMinimap:Tt,minimapLeft:Rt,minimapWidth:Ht,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:Pt,minimapLineHeight:Wt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ce,Re){const Ge=Re.outerWidth|0,Me=Re.outerHeight|0,tt=Re.lineHeight|0,ht=Re.lineNumbersDigitCount|0,wt=Re.typicalHalfwidthCharacterWidth,Lt=Re.maxDigitWidth,At=Re.pixelRatio,xt=Re.viewLineCount,_t=ce.get(137),Pt=_t==="inherit"?ce.get(136):_t,Vt=Pt==="inherit"?ce.get(132):Pt,Xt=ce.get(135),et=Re.isDominatedByLongLines,si=ce.get(57),Yt=ce.get(68).renderType!==0,dt=ce.get(69),vt=ce.get(105),ti=ce.get(84),Zt=ce.get(73),zt=ce.get(103),gt=zt.verticalScrollbarSize,Ut=zt.verticalHasArrows,Wt=zt.arrowSize,Kt=zt.horizontalScrollbarSize,Ze=ce.get(43),ui=ce.get(110)!=="never";let Ht=ce.get(66);Ze&&ui&&(Ht+=16);let Bt=0;if(Yt){const li=Math.max(ht,dt);Bt=Math.round(li*Lt)}let mt=0;si&&(mt=tt*Re.glyphMarginDecorationLaneCount);let Tt=0,Rt=Tt+mt,jt=Rt+Bt,ii=jt+Ht;const Gt=Ge-mt-Bt-Ht;let ni=!1,Nt=!1,Ot=-1;Pt==="inherit"&&et?(ni=!0,Nt=!0):Vt==="on"||Vt==="bounded"?Nt=!0:Vt==="wordWrapColumn"&&(Ot=Xt);const It=Z.c({outerWidth:Ge,outerHeight:Me,lineHeight:tt,typicalHalfwidthCharacterWidth:wt,pixelRatio:At,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Zt,verticalScrollbarWidth:gt,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Nt},Re.memory||new A);It.renderMinimap!==0&&It.minimapLeft===0&&(Tt+=It.minimapWidth,Rt+=It.minimapWidth,jt+=It.minimapWidth,ii+=It.minimapWidth);const St=Gt-It.minimapWidth,bt=Math.max(1,Math.floor((St-gt-2)/wt)),Ct=Ut?Wt:0;return Nt&&(Ot=Math.max(1,bt),Vt==="bounded"&&(Ot=Math.min(Ot,Xt))),{width:Ge,height:Me,glyphMarginLeft:Tt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Re.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Bt,decorationsLeft:jt,decorationsWidth:Ht,contentLeft:ii,contentWidth:St,minimap:It,viewportColumn:bt,isWordWrapMinified:ni,isViewportWrapping:Nt,wrappingColumn:Ot,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Kt,overviewRuler:{top:Ct,width:gt,height:Me-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Z;class ue extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ce){return g(ce,"simple",["simple","advanced"])}compute(ce,Re,Ge){return Re.get(2)===2?"advanced":Ge}}var te;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class we extends C{constructor(){const ce={enabled:te.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:ce.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:g(ce.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class Se extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:p.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Re.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(Re.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Re.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:p.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return typeof Re.enabled=="boolean"&&(Re.enabled=Re.enabled?"on":"off"),{enabled:g(Re.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Re.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),padding:f(Re.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):i.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Re,Ge){return Ge<0?i.clampedInt(-Ge*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ne extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:p.localize(66,null)})}compute(ce,Re,Ge){return ce.fontInfo.lineHeight}}class $e extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:ce.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),autohide:f(Re.autohide,this.defaultValue.autohide),size:g(Re.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Re.side,this.defaultValue.side,["right","left"]),showSlider:g(Re.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Re.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Re.scale,1,1,3),maxColumn:i.clampedInt(Re.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(Re.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(Re.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Re.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(ae){return ae==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class se extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{top:i.clampedInt(Re.top,0,0,1e3),bottom:i.clampedInt(Re.bottom,0,0,1e3)}}}class re extends C{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:p.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),cycle:f(Re.cycle,this.defaultValue.cycle)}}}class oe extends v{constructor(){super(143)}compute(ce,Re,Ge){return ce.pixelRatio}}class G extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Re=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Re,default:ce.strings,description:p.localize(88,null)},comments:{anyOf:Re,default:ce.comments,description:p.localize(89,null)},other:{anyOf:Re,default:ce.other,description:p.localize(90,null)}},default:ce,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const At=ce?"on":"off";return{comments:At,strings:At,other:At}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Re,comments:Ge,strings:Me}=ce,tt=["on","inline","off"];let ht,wt,Lt;return typeof Re=="boolean"?ht=Re?"on":"off":ht=g(Re,this.defaultValue.other,tt),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=g(Ge,this.defaultValue.comments,tt),typeof Me=="boolean"?Lt=Me?"on":"off":Lt=g(Me,this.defaultValue.strings,tt),{other:ht,comments:wt,strings:Lt}}}var ie;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class me extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(ce){let Re=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Re=4,Ge=ce):ce==="interval"?Re=3:ce==="relative"?Re=2:ce==="on"?Re=1:Re=0),{renderType:Re,renderFn:Ge}}}function pe(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Ae extends C{constructor(){const ce=[],Re={type:"number",description:p.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Re,{type:["object"],properties:{column:Re,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:ce,description:p.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Re=[];for(const Ge of ce)if(typeof Ge=="number")Re.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Me=Ge;Re.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Re.sort((Ge,Me)=>Ge.column-Me.column),Re}return this.defaultValue}}class fe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce,Ge=i.clampedInt(Re.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Re.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Re.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Re.vertical,this.defaultValue.vertical),horizontal:De(Re.horizontal,this.defaultValue.horizontal),useShadows:f(Re.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Re.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Re.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Re.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Re.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Re.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Re.verticalSliderSize,Me,0,1e3),scrollByPage:f(Re.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Re.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Te extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:p.localize(118,null)}})}applyUpdate(ce,Re){let Ge=!1;Re.allowedCharacters&&ce&&(N.$1n(ce.allowedCharacters,Re.allowedCharacters)||(ce={...ce,allowedCharacters:Re.allowedCharacters},Ge=!0)),Re.allowedLocales&&ce&&(N.$1n(ce.allowedLocales,Re.allowedLocales)||(ce={...ce,allowedLocales:Re.allowedLocales},Ge=!0));const Me=super.applyUpdate(ce,Re);return Ge?new m(Me.newValue,!0):Me}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{nonBasicASCII:he(Re.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Re.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Re.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Re.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Re.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Re){if(typeof ce!="object"||!ce)return Re;const Ge={};for(const[Me,tt]of Object.entries(ce))tt===!0&&(Ge[Me]=!0);return Ge}}class q extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:p.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),mode:g(Re.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Re.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Re.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily)}}}class V extends C{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:p.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(Re.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(Re.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends C{constructor(){const ce={enabled:R.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Re.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:ce.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:ce.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:ce.highlightActiveIndentation,description:p.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{bracketPairs:he(Re.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Re.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Re.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Re.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Re.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Re){const Ge=Re.indexOf(ae);return Ge===-1?ce:Re[Ge]}class be extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:ce.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:ce.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertMode:g(Re.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Re.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Re.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Re.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Re.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Re.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Re.showIcons,this.defaultValue.showIcons),showStatusBar:f(Re.showStatusBar,this.defaultValue.showStatusBar),preview:f(Re.preview,this.defaultValue.preview),previewMode:g(Re.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Re.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Re.showMethods,this.defaultValue.showMethods),showFunctions:f(Re.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Re.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Re.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Re.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Re.showFields,this.defaultValue.showFields),showVariables:f(Re.showVariables,this.defaultValue.showVariables),showClasses:f(Re.showClasses,this.defaultValue.showClasses),showStructs:f(Re.showStructs,this.defaultValue.showStructs),showInterfaces:f(Re.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Re.showModules,this.defaultValue.showModules),showProperties:f(Re.showProperties,this.defaultValue.showProperties),showEvents:f(Re.showEvents,this.defaultValue.showEvents),showOperators:f(Re.showOperators,this.defaultValue.showOperators),showUnits:f(Re.showUnits,this.defaultValue.showUnits),showValues:f(Re.showValues,this.defaultValue.showValues),showConstants:f(Re.showConstants,this.defaultValue.showConstants),showEnums:f(Re.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Re.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Re.showKeywords,this.defaultValue.showKeywords),showWords:f(Re.showWords,this.defaultValue.showWords),showColors:f(Re.showColors,this.defaultValue.showColors),showFiles:f(Re.showFiles,this.defaultValue.showFiles),showReferences:f(Re.showReferences,this.defaultValue.showReferences),showFolders:f(Re.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Re.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Re.showSnippets,this.defaultValue.showSnippets),showUsers:f(Re.showUsers,this.defaultValue.showUsers),showIssues:f(Re.showIssues,this.defaultValue.showIssues)}}}class ze extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends C{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Re=[];for(const Ge of ce)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Re.push(Ge)}catch{}return Re}return this.defaultValue}}var Ye;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class it extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Re,Ge){return Re.get(2)===2?0:Ge}}class ot extends v{constructor(){super(146)}compute(ce,Re,Ge){const Me=Re.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class nt extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showDropSelector:g(Re.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:f(Re.enabled,this.defaultValue.enabled),showPasteSelector:g(Re.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ce="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?He:Ce,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Xe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ne(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ne(new w),accessibilityPageSize:Ne(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ne(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ne(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ne(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ne(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ne(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ne(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ne(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ne(new a(13,"automaticLayout",!1)),autoSurround:Ne(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ne(new J),bracketPairGuides:Ne(new Q),stickyTabStops:Ne(new a(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ne(new a(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ne(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ne(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ne(new a(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ne(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ne(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ne(new a(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ne(new d),contextmenu:Ne(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new a(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ne(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ne(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ne(new h(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(260,null)})),cursorSurroundingLines:Ne(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ne(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ne(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ne(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new a(34,"domReadOnly",!1)),dragAndDrop:Ne(new a(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ne(new j),dropIntoEditor:Ne(new nt),stickyScroll:Ne(new Se),experimentalWhitespaceRendering:Ne(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ne(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:p.localize(271,null)})),find:Ne(new F),fixedOverflowWidgets:Ne(new a(42,"fixedOverflowWidgets",!1)),folding:Ne(new a(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ne(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ne(new a(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ne(new a(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ne(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ne(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ne(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ne(new T),fontLigatures2:Ne(new z),fontSize:Ne(new B),fontWeight:Ne(new W),fontVariations:Ne(new O),formatOnPaste:Ne(new a(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ne(new a(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ne(new a(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ne(new X),hideCursorInOverviewRuler:Ne(new a(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ne(new x),inDiffEditor:Ne(new a(61,"inDiffEditor",!1)),letterSpacing:Ne(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:p.localize(285,null)})),lightbulb:Ne(new we),lineDecorationsWidth:Ne(new U),lineHeight:Ne(new ne),lineNumbers:Ne(new me),lineNumbersMinChars:Ne(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new a(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ne(new a(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ne(new c(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ne(new $e),mouseStyle:Ne(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ne(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ne(new a(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ne(new h(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ne(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ne(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ne(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ne(new a(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ne(new i(83,"overviewRulerLanes",3,0,3)),padding:Ne(new se),pasteAs:Ne(new st),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ne(new a(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ne(new G),quickSuggestionsDelay:Ne(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ne(new a(91,"readOnly",!1)),readOnlyMessage:Ne(new fe),renameOnType:Ne(new a(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ne(new a(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ne(new c(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ne(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ne(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ne(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ne(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new a(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ne(new Ae),scrollbar:Ne(new Ie),scrollBeyondLastColumn:Ne(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ne(new a(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ne(new a(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ne(new a(107,"selectionClipboard",!0,{description:p.localize(325,null),included:L.$k})),selectionHighlight:Ne(new a(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ne(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ne(new a(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ne(new a(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ne(new _),snippetSuggestions:Ne(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new a(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ne(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new be),inlineSuggest:Ne(new q),inlineEdit:Ne(new V),inlineCompletionsAccessibilityVerbose:Ne(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ne(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new a(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ne(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ne(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ne(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new Te),unusualLineTerminators:Ne(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ne(new a(127,"useShadowDOM",!0)),useTabStops:Ne(new a(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ne(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ne(new Ve),wordSeparators:Ne(new t(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:Ne(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ne(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ne(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new I),defaultColorDecorators:Ne(new a(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ne(new oe),tabFocusMode:Ne(new a(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ne(new Z),wrappingInfo:Ne(new ot),wrappingIndent:Ne(new it),wrappingStrategy:Ne(new ue)}}),define(ke[202],Ee([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$8t=e.$7t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$6t=e.$5t=e.SymbolKinds=e.SymbolTag=e.$3t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$1t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Zt=e.$Yt=e.$Xt=void 0,e.$2t=g,e.$4t=h;class ${constructor(X,x,Y){this.offset=X,this.type=x,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Xt=$;class S{constructor(X,x){this.tokens=X,this.endState=x,this._tokenizationResultBrand=void 0}}e.$Yt=S;class A{constructor(X,x){this.tokens=X,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$Zt=A;var C;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(W){const X=new Map;X.set(0,u.$Pj.symbolMethod),X.set(1,u.$Pj.symbolFunction),X.set(2,u.$Pj.symbolConstructor),X.set(3,u.$Pj.symbolField),X.set(4,u.$Pj.symbolVariable),X.set(5,u.$Pj.symbolClass),X.set(6,u.$Pj.symbolStruct),X.set(7,u.$Pj.symbolInterface),X.set(8,u.$Pj.symbolModule),X.set(9,u.$Pj.symbolProperty),X.set(10,u.$Pj.symbolEvent),X.set(11,u.$Pj.symbolOperator),X.set(12,u.$Pj.symbolUnit),X.set(13,u.$Pj.symbolValue),X.set(15,u.$Pj.symbolEnum),X.set(14,u.$Pj.symbolConstant),X.set(15,u.$Pj.symbolEnum),X.set(16,u.$Pj.symbolEnumMember),X.set(17,u.$Pj.symbolKeyword),X.set(27,u.$Pj.symbolSnippet),X.set(18,u.$Pj.symbolText),X.set(19,u.$Pj.symbolColor),X.set(20,u.$Pj.symbolFile),X.set(21,u.$Pj.symbolReference),X.set(22,u.$Pj.symbolCustomColor),X.set(23,u.$Pj.symbolFolder),X.set(24,u.$Pj.symbolTypeParameter),X.set(25,u.$Pj.account),X.set(26,u.$Pj.issues);function x(ue){let te=X.get(ue);return te||(console.info("No codicon found for CompletionItemKind "+ue),te=u.$Pj.symbolProperty),te}W.toIcon=x;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function Z(ue,te){let we=Y.get(ue);return typeof we>"u"&&!te&&(we=9),we}W.fromString=Z})(m||(e.CompletionItemKinds=m={}));var y;(function(W){W[W.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var l;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(l||(e.PartialAcceptTriggerKind=l={}));var f;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var a;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(a||(e.InlineCompletionTriggerKind=a={}));class n{constructor(X,x,Y,Z){this.range=X,this.text=x,this.completionKind=Y,this.isSnippetText=Z}equals(X){return R.$kt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}e.$1t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var o;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function g(W){return W&&N.URI.isUri(W.uri)&&R.$kt.isIRange(W.range)&&(R.$kt.isIRange(W.originSelectionRange)||R.$kt.isIRange(W.targetSelectionRange))}var c;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$3t={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function h(W,X){return(0,p.localize)(26,null,W,e.$3t[X])}var s;(function(W){W[W.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var w;(function(W){const X=new Map;X.set(0,u.$Pj.symbolFile),X.set(1,u.$Pj.symbolModule),X.set(2,u.$Pj.symbolNamespace),X.set(3,u.$Pj.symbolPackage),X.set(4,u.$Pj.symbolClass),X.set(5,u.$Pj.symbolMethod),X.set(6,u.$Pj.symbolProperty),X.set(7,u.$Pj.symbolField),X.set(8,u.$Pj.symbolConstructor),X.set(9,u.$Pj.symbolEnum),X.set(10,u.$Pj.symbolInterface),X.set(11,u.$Pj.symbolFunction),X.set(12,u.$Pj.symbolVariable),X.set(13,u.$Pj.symbolConstant),X.set(14,u.$Pj.symbolString),X.set(15,u.$Pj.symbolNumber),X.set(16,u.$Pj.symbolBoolean),X.set(17,u.$Pj.symbolArray),X.set(18,u.$Pj.symbolObject),X.set(19,u.$Pj.symbolKey),X.set(20,u.$Pj.symbolNull),X.set(21,u.$Pj.symbolEnumMember),X.set(22,u.$Pj.symbolStruct),X.set(23,u.$Pj.symbolEvent),X.set(24,u.$Pj.symbolOperator),X.set(25,u.$Pj.symbolTypeParameter);function x(Y){let Z=X.get(Y);return Z||(console.info("No codicon found for SymbolKind "+Y),Z=u.$Pj.symbolProperty),Z}W.toIcon=x})(w||(e.SymbolKinds=w={}));class d{static asEditOperation(X){return L.$lt.replace(R.$kt.lift(X.range),X.text)}}e.$5t=d;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(X){switch(X){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(X)}constructor(X){this.value=X}}e.$6t=D;var b;(function(W){W[W.AIGenerated=1]="AIGenerated"})(b||(e.NewSymbolNameTag=b={}));var E;(function(W){function X(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}W.is=X})(E||(e.Command=E={}));var k;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var j;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var F;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(F||(e.CommentState=F={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$7t=O,e.$8t=new M.$Mt;var T;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[232],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[233],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[234],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[235],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[236],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[237],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[238],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[239],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[240],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[241],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[242],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[243],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[244],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[245],Ee([1,0,13,205]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,m=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,m=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const v=this.c.charCodeAt(A);if(C)C=!1;else if(v===47&&!m){A++;break}else v===91?m=!0:v===92?C=!0:v===93&&(m=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=$}),define(ke[246],Ee([1,0,23,41,208,395]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=$,e.$Bp=S,e.$Cp=A,e.$Dp=C,e.$Ep=m,e.$Fp=y,e.$Gp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||M.test(a)}function S(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,r=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),g=!1);let c=0;if(a.preRelease){const h=p.exec(a.preRelease);if(h){const[,s,w,d]=h;c=Date.UTC(Number(s),Number(w)-1,Number(d))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:o,patchBase:t,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:c}}function C(a,n,i){let r;typeof a=="string"?r=A(S(a)):r=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=A(S(i)):t=i,!r||!t)return!1;const g=r.majorBase,c=r.minorBase,h=r.patchBase;let s=t.majorBase,w=t.minorBase,d=t.patchBase;const D=t.notBefore;let b=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?g>s?!0:g<s?!1:c>w?!0:c<w||o&&o<D?!1:h>=d:(g===1&&s===0&&(!b||!E||!k)&&(s=1,w=0,d=0,b=!0,E=!1,k=!1),g<s?!1:g>s?!b:c<w?!1:c>w?!E:h<d?!1:h>d?!k:!(o&&o<D))}function m(a,n,i,r,o){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!f(r.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!f(r.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const h=(0,u.$4g)(i,r.main);(0,u.$Xg)(h,i)||t.push([N.default.Warning,L.localize(10,null,h.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const h=(0,u.$4g)(i,r.browser);(0,u.$Xg)(h,i)||t.push([N.default.Warning,L.localize(12,null,h.path,i.path)])}}if(!R.valid(r.version))return t.push([N.default.Error,L.localize(13,null)]),t;const g=[];if(!y(a,n,r,o,g))for(const h of g)t.push([N.default.Error,h]);return t}function y(a,n,i,r,o){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:l(a,n,i.engines.vscode,o)}function v(a,n,i){return a==="*"||l(n,i,a)}function l(a,n,i,r=[]){const o=A(S(i));if(!o)return r.push(L.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!o.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return C(a,n,o)?!0:(r.push(L.localize(17,null,a,i)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class u{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ni=u}),define(ke[84],Ee([1,0,106]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=R,e.$ps=M;const N=[];var L;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(p,$,S){$ instanceof u.$ni||($=new u.$ni($,[],!!S)),N.push([p,$])}function M(){return N}}),define(ke[247],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class u{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=u;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const p=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(M);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let p=this.a.get(M);return p||(p=new u(M,R),this.a.set(M,p)),p}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,p]of this.a)R.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const p=new Set([R]),$=this.c(M,p);if($)return $}}c(R,M){for(const[p,$]of R.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const S=this.c($,M);if(S)return S;M.delete(p)}}}e.$6q=N}),define(ke[5],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=L,e.$ri=R;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(u||(e._util=u={})),e.$pi=L("instantiationService");function N(M,p,$){p[u.DI_TARGET]===p?p[u.DI_DEPENDENCIES].push({id:M,index:$}):(p[u.DI_DEPENDENCIES]=[{id:M,index:$}],p[u.DI_TARGET]=p)}function L(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const p=function($,S,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,$,A)};return p.toString=()=>M,u.serviceIds.set(M,p),p}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=R,e.$Yi=M,e.$Zi=$,e.$1i=S,e.$2i=A,e.$3i=C,e.$4i=m,e.$5i=v,e.$6i=l,e.$7i=f,e.$Wi=(0,L.$qi)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,n){const i=Object.create(null);for(const r in a)C(i,r,a[r],n);return i}function C(a,n,i,r){const o=n.split("."),t=o.pop();let g=a;for(let c=0;c<o.length;c++){const h=o[c];let s=g[h];switch(typeof s){case"undefined":s=g[h]=Object.create(null);break;case"object":if(s===null){r(`Ignoring ${n} as ${o.slice(0,c+1).join(".")} is null`);return}break;default:r(`Ignoring ${n} as ${o.slice(0,c+1).join(".")} is ${JSON.stringify(s)}`);return}g=s}if(typeof g=="object"&&g!==null)try{g[t]=i}catch{r(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(g)}`)}else r(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(g)}`)}function m(a,n){const i=n.split(".");y(a,i)}function y(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const r=a[i];typeof r=="object"&&!Array.isArray(r)&&(y(r,n),Object.keys(r).length===0&&delete a[i])}}function v(a,n,i){function r(g,c){let h=g;for(const s of c){if(typeof h!="object"||h===null)return;h=h[s]}return h}const o=n.split("."),t=r(a,o);return typeof t>"u"?i:t}function l(a,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in a?u.$6f(a[r])&&u.$6f(n[r])?l(a[r],n[r],i):i&&(a[r]=n[r]):a[r]=n[r])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(ke[37],Ee([1,0,11,14,245,5,204,13]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=S,e.$pj=g,e.$qj=c,e.$Jj=te;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function S(_,U){if($.get(_)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(_,U)}const A=Object.prototype.hasOwnProperty;var C;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},y=(0,M.localize)(0,null),v=(0,M.localize)(1,null),l=(0,M.localize)(2,null),f=(0,M.localize)(3,null),a=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new L.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const $e=this.D(),Pe=$e.type===17?n:void 0;throw this.h.push({message:a,offset:$e.offset,lexeme:L.$lj.getLexeme($e),additionalInfo:Pe}),o.c}return ne}catch(ne){if(ne!==o.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),w.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const se=Pe.lexeme,re=se.lastIndexOf("/"),oe=re===se.length-1?void 0:this.w(se.substring(re+1));let G;try{G=new RegExp(se.substring(1,re),oe)}catch{throw this.B("REGEX",Pe)}return T.create(ne,G)}switch(Pe.type){case 10:case 19:{const se=[Pe.lexeme];this.z();let re=this.D(),oe=0;for(let Ae=0;Ae<Pe.lexeme.length;Ae++)Pe.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Ae=0;Ae<re.lexeme.length;Ae++)re.lexeme.charCodeAt(Ae)===40?oe++:Pe.lexeme.charCodeAt(Ae)===41&&oe--}if(oe<0)break;se.push(L.$lj.getLexeme(re)),this.z(),re=this.D()}const G=se.join(""),ie=G.lastIndexOf("/"),me=ie===G.length-1?void 0:this.w(G.substring(ie+1));let pe;try{pe=new RegExp(G.substring(1,ie),me)}catch{throw this.B("REGEX",Pe)}return t.regex(ne,pe)}case 18:{const se=Pe.lexeme;this.z();let re=null;if(!(0,N.$3e)(se)){const oe=se.indexOf("/"),G=se.lastIndexOf("/");if(oe!==G&&oe>=0){const ie=se.slice(oe+1,G),me=se[G+1]==="i"?"i":"";try{re=new RegExp(ie,me)}catch{throw this.B("REGEX",Pe)}}}if(re===null)throw this.B("REGEX",Pe);return T.create(ne,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const Pe=this.u();return t.notIn(ne,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(ne,Pe);switch(Pe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(ne,Pe);switch(Pe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Pe)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),O.create(ne,this.u());case 7:return this.z(),j.create(ne,this.u());case 8:return this.z(),F.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,$e){const Pe=(0,M.localize)(8,null,U,L.$lj.getLexeme(ne)),se=ne.offset,re=L.$lj.getLexeme(ne);return this.h.push({message:Pe,offset:se,lexeme:re,additionalInfo:$e}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=o;class t{static false(){return s.INSTANCE}static true(){return w.INSTANCE}static has(U){return d.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return k.create(U,ne)}static regex(U,ne){return T.create(U,ne)}static in(U,ne){return b.create(U,ne)}static notIn(U,ne){return E.create(U,ne)}static not(U){return P.create(U)}static and(...U){return X.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,ne){return j.create(U,ne)}static greaterEquals(U,ne){return F.create(U,ne)}static smaller(U,ne){return z.create(U,ne)}static smallerEquals(U,ne){return O.create(U,ne)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function g(_){const U=new o({regexParsingWithErrorRecovery:!1});return _.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map($e=>({errorMessage:$e.additionalInfo?(0,M.localize)(9,null,$e.additionalInfo):(0,M.localize)(10,null),offset:$e.offset,length:$e.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map($e=>({errorMessage:$e.additionalInfo?`${$e.message}. ${$e.additionalInfo}`:$e.message,offset:$e.offset,length:$e.lexeme.length})):[]))}function c(_,U){const ne=_?_.substituteConstants():void 0,$e=U?U.substituteConstants():void 0;return!ne&&!$e?!0:!ne||!$e?!1:ne.equals($e)}function h(_,U){return _.cmp(U)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return w.INSTANCE}}e.$rj=s;class w{static{this.INSTANCE=new w}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return s.INSTANCE}}e.$sj=w;class d{static create(U,ne=null){const $e=$.get(U);return typeof $e=="boolean"?$e?w.INSTANCE:s.INSTANCE:new d(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?w.INSTANCE:s.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$tj=d;class D{static create(U,ne,$e=null){if(typeof ne=="boolean")return ne?d.create(U,$e):P.create(U,$e);const Pe=$.get(U);return typeof Pe=="boolean"?ne===(Pe?"true":"false")?w.INSTANCE:s.INSTANCE:new D(U,ne,$e)}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?w.INSTANCE:s.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$uj=D;class b{static create(U,ne){return new b(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),$e=U.getValue(this.d);return Array.isArray(ne)?ne.includes($e):typeof $e=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,$e):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$vj=b;class E{static create(U,ne){return new E(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=b.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=E;class k{static create(U,ne,$e=null){if(typeof ne=="boolean")return ne?P.create(U,$e):d.create(U,$e);const Pe=$.get(U);return typeof Pe=="boolean"?ne===(Pe?"true":"false")?s.INSTANCE:w.INSTANCE:new k(U,ne,$e)}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?s.INSTANCE:w.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=k;class P{static create(U,ne=null){const $e=$.get(U);return typeof $e=="boolean"?$e?s.INSTANCE:w.INSTANCE:new P(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?s.INSTANCE:w.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$yj=P;function I(_,U){if(typeof _=="string"){const ne=parseFloat(_);isNaN(ne)||(_=ne)}return typeof _=="string"||typeof _=="number"?U(_):s.INSTANCE}class j{static create(U,ne,$e=null){return I(ne,Pe=>new j(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zj=j;class F{static create(U,ne,$e=null){return I(ne,Pe=>new F(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Aj=F;class z{static create(U,ne,$e=null){return I(ne,Pe=>new z(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Bj=z;class O{static create(U,ne,$e=null){return I(ne,Pe=>new O(U,Pe,$e))}constructor(U,ne,$e){this.c=U,this.d=ne,this.f=$e,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Cj=O;class T{static create(U,ne){return new T(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",$e=U.f?U.f.source:"";return ne<$e?-1:ne>$e?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",$e=U.f?U.f.source:"";return this.d===U.d&&ne===$e}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Dj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Ej=B;function W(_){let U=null;for(let ne=0,$e=_.length;ne<$e;ne++){const Pe=_[ne].substituteConstants();if(_[ne]!==Pe&&U===null){U=[];for(let se=0;se<ne;se++)U[se]=_[se]}U!==null&&(U[ne]=Pe)}return U===null?_:U}class X{static create(U,ne,$e){return X.d(U,ne,$e)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,$e=this.expr.length;ne<$e;ne++){const Pe=h(this.expr[ne],U.expr[ne]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,$e){const Pe=[];let se=!1;for(const re of U)if(re){if(re.type===1){se=!0;continue}if(re.type===0)return s.INSTANCE;if(re.type===6){Pe.push(...re.expr);continue}Pe.push(re)}if(Pe.length===0&&se)return w.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(h);for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const re=Pe[Pe.length-1];if(re.type!==9)break;Pe.pop();const oe=Pe.pop(),G=Pe.length===0,ie=x.create(re.expr.map(me=>X.create([me,oe],null,$e)),null,G);ie&&(Pe.push(ie),Pe.sort(h))}if(Pe.length===1)return Pe[0];if($e){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return s.INSTANCE;if(Pe.length===1)return Pe[0]}return new X(Pe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new X(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Fj=X;class x{static create(U,ne,$e){return x.d(U,ne,$e)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,$e=this.expr.length;ne<$e;ne++){const Pe=h(this.expr[ne],U.expr[ne]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let ne=0,$e=this.expr.length;ne<$e;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,$e){let Pe=[],se=!1;if(U){for(let re=0,oe=U.length;re<oe;re++){const G=U[re];if(G){if(G.type===0){se=!0;continue}if(G.type===1)return w.INSTANCE;if(G.type===9){Pe=Pe.concat(G.expr);continue}Pe.push(G)}}if(Pe.length===0&&se)return s.INSTANCE;Pe.sort(h)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let re=1;re<Pe.length;re++)Pe[re-1].equals(Pe[re])&&(Pe.splice(re,1),re--);if(Pe.length===1)return Pe[0];if($e){for(let re=0;re<Pe.length;re++)for(let oe=re+1;oe<Pe.length;oe++)if(Pe[re].negate().equals(Pe[oe]))return w.INSTANCE;if(Pe.length===1)return Pe[0]}return new x(Pe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new x(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),$e=U.shift(),Pe=[];for(const se of Se(ne))for(const re of Se($e))Pe.push(X.create([se,re],null,!1));U.unshift(x.create(Pe,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Gj=x;class Y extends d{static{this.d=[]}static all(){return Y.d.values()}constructor(U,ne,$e){super(U,null),this.f=ne,typeof $e=="object"?Y.d.push({...$e,key:U}):$e!==!0&&Y.d.push({key:U,description:$e,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$Hj=Y,e.$Ij=(0,R.$qi)("contextKeyService");function Z(_,U){return _<U?-1:_>U?1:0}function ue(_,U,ne,$e){return _<ne?-1:_>ne?1:U<$e?-1:U>$e?1:0}function te(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?we(_.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(te(_,ne))return!0;return!1}if(_.type===6){if(U.type===6)return we(U.expr,_.expr);for(const ne of _.expr)if(te(ne,U))return!0;return!1}return _.equals(U)}function we(_,U){let ne=0,$e=0;for(;ne<_.length&&$e<U.length;){const Pe=_[ne].cmp(U[$e]);if(Pe<0)return!1;Pe===0&&ne++,$e++}return ne===_.length}function Se(_){return _.type===9?_.expr:[_]}}),define(ke[248],Ee([1,0,23,41,206,5,103,11,24]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$zw=e.$yw=e.$xw=void 0,e.$Aw=y,e.$Bw=v,e.$xw=(0,R.$qi)("dialogService");var S;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(S||(S={}));class A{a(f){return this.d(f,S.Confirmation)}b(f){return this.d(f,S.Prompt)}c(f){return this.d(f,S.Input)}d(f,a){const n=[];switch(a){case S.Confirmation:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case S.Prompt:{const i=f;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case S.Input:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===N.default.Info?"info":f===N.default.Error?"error":f===N.default.Warning?"warning":"none"}f(f,a,n){const i=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&i.push(f.cancelButton);let r=i[a]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$yw=A,e.$zw=(0,R.$qi)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function y(l){const f=[];return f.push(...l.slice(0,m).map(a=>typeof a=="string"?a:(0,u.$1g)(a))),l.length>m&&(l.length-m===1?f.push((0,L.localize)(7,null)):f.push((0,L.localize)(8,null,l.length-m))),f.push(""),f.join(`
`)}function v(l,f){const a=(0,$.$Wn)(l);let n=(a.buttons??[]).map(t=>(0,M.$uw)(t)),i=(l.buttons||[]).map((t,g)=>g),r=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const g=i[o];i.splice(o,1),i.splice(1,0,g),o=1}p.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(o=r-1))}else if(p.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const g=i[o];i.splice(o,1),i.push(g),o=n.length-1}}return a.buttons=n,a.defaultId=r,a.cancelId=o,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,u.$qi)("environmentService"),e.$yi=(0,u.$ri)(e.$xi)}),define(ke[137],Ee([1,0,207,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=L,e.$Uo=R,e.$Vo=M,e.$Wo=p,e.$Xo=$,e.$Yo=S,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,r){return r==="web"&&!i.includes("web")}function $(i,r,o){return p(r,o)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===o}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(i){i.Install="install",i.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var y;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var l;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(r,o){super(r),this.code=o,this.name=o}}e.$1o=f;var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class n extends Error{constructor(r,o){super(r),this.code=o,this.name=o}}e.$2o=n,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,u.localize2)(0,"Extensions"),e.$9o=(0,u.localize2)(1,"Preferences")}),define(ke[249],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=void 0,e.$D6b=(0,u.$qi)("externalTerminal"),e.$E6b="Terminal.app"}),define(ke[250],Ee([1,0,53,55,15,17,11,102,31,105,209,249]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=e.$Lbc=void 0;const m=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends y{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(u,o,S.$im(),t)}spawnTerminal(o,t,g,c){const h=t.windowsExec||v.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const s=R.$oc(h,".exe").toLowerCase();if(s==="cmder")return o.spawn(h,c?[c]:void 0),Promise.resolve(void 0);const w=["/c","start","/wait"];return h.indexOf(" ")>=0&&w.push('""'),w.push(h),s==="wt"&&w.push("-d ."),new Promise((d,D)=>{const b=a(process),E=o.spawn(g,w,{cwd:c,env:b,detached:!0});E.on("error",D),E.on("exit",()=>d())})}async runInTerminal(o,t,g,c,h){const s="windowsExec"in h&&h.windowsExec?h.windowsExec:v.getDefaultTerminalWindows(),w=await v.f();return new Promise((d,D)=>{const b=`"${t} - ${m}"`,E=`"${g.join('" "')}" & pause`,k=Object.assign({},a(process),c);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const P={cwd:t,env:k,windowsVerbatimArguments:!0};let I,j;R.$oc(s,".exe")==="wt"?(I=s,j=["-d",".",v.b,"/c",E]):w?(I=w,j=["-d",".",s,"/c",E]):(I=v.b,j=["/c","start",b,"/wait",s,"/c",`"${E}"`]),u.spawn(I,j,P).on("error",z=>{D(n(z))}),d(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const o=await S.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$Lbc=v,Je([N.$Uh],v,"f",null);class l extends y{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(u,o,t)}runInTerminal(o,t,g,c,h){const s=h.osxExec||C.$E6b;return new Promise((w,d)=>{if(s===C.$E6b||s==="iTerm.app"){const D=s===C.$E6b?"TerminalHelper":"iTermHelper",E=[L.$Kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||m,"-w",t];for(const I of g)E.push("-a"),E.push(I);if(c){const I=Object.assign({},a(process),c);for(const j in I){const F=I[j];F===null?(E.push("-u"),E.push(j)):(E.push("-e"),E.push(`${j}=${F}`))}}let k="";const P=u.spawn(l.b,E);P.on("error",I=>{d(n(I))}),P.stderr.on("data",I=>{k+=I.toString()}),P.on("exit",I=>{if(I===0)w(void 0);else if(k){const j=k.split(`
`,1);d(new Error(j[0]))}else d(new Error(A.localize(1,null,D,I)))})}else d(new Error(A.localize(2,null,s)))})}spawnTerminal(o,t,g){const c=t.osxExec||C.$E6b;return new Promise((h,s)=>{const w=["-a",c];g&&w.push(g);const d=a(process),D=o.spawn("/usr/bin/open",w,{cwd:g,env:d});D.on("error",s),D.on("exit",()=>h())})}}e.$Mbc=l;class f extends y{static{this.b=A.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(u,o,t)}runInTerminal(o,t,g,c,h){const s=h.linuxExec?Promise.resolve(h.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((w,d)=>{const D=[];s.then(b=>{b.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const E=`${i(g)}; echo; read -p "${f.b}" -n1;`;D.push(`''${E}''`);const k=Object.assign({},a(process),c);Object.keys(k).filter(F=>k[F]===null).forEach(F=>delete k[F]);const P={cwd:t,env:k};let I="";const j=u.spawn(b,D,P);j.on("error",F=>{d(n(F))}),j.stderr.on("data",F=>{I+=F.toString()}),j.on("exit",F=>{if(F===0)w(void 0);else if(I){const z=I.split(`
`,1);d(new Error(z[0]))}else d(new Error(A.localize(4,null,b,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!M.$k)f.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(o,t,g){const c=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,s)=>{c.then(w=>{const d=a(process),D=o.spawn(w,[],{cwd:g,env:d});D.on("error",s),D.on("exit",()=>h())})})}}e.$Nbc=f;function a(r){const o={...r.env};return(0,p.$gm)(o),o}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let o="";for(const t of r)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=m,e.$Yk=l,e.$Zk=a,e.$1k=n,e.$2k=i,e.$3k=r,e.$4k=o,e.$5k=t,e.$6k=g,e.$7k=c,e.$8k=h,e.$0k=d,e.$$k=D,e.$_k=b,e.$al=E,e.$bl=k,e.$el=z,e.$ql=x,e.$rl=Y,e.$tl=ue,e.$Wk=(0,$.$qi)("fileService");function m(te){return te.create===!0}var y;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function l(te){const we=te;return!!we&&typeof we.onDidChange=="function"}var f;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function a(te){return!!(te.capabilities&2)}function n(te){return!!(te.capabilities&8)}function i(te){return!!(te.capabilities&131072)}function r(te){return!!(te.capabilities&4)}function o(te){return!!(te.capabilities&16)}function t(te){return a(te)?!!(te.capabilities&16384):!1}function g(te){return a(te)?!!(te.capabilities&32768):!1}function c(te){return!!(te.capabilities&65536)}function h(te){return!!(te.capabilities&2048)}var s;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class w extends Error{static create(we,Se){const _=new w(we.toString(),Se);return b(_,Se),_}constructor(we,Se){super(we),this.code=Se}}e.$9k=w;function d(te,we){return w.create(te,we)}function D(te){return te||d((0,p.localize)(0,null),s.Unknown)}function b(te,we){return te.name=we?`${we} (FileSystemError)`:"FileSystemError",te}function E(te){if(!te)return s.Unknown;if(te instanceof w)return te.code;const we=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!we)return s.Unknown;switch(we[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function k(te){if(te instanceof O)return te.fileOperationResult;switch(E(te)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var P;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class I{constructor(we,Se,_){this.resource=we,this.operation=Se,this.target=_}isOperation(we){return this.operation===we}}e.$cl=I;var j;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor(we,Se){this.c=Se,this.b=void 0,this.d=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of we){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==F.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(we,...Se){return this.h(we,{includeChildren:!1},...Se)}affects(we,...Se){return this.h(we,{includeChildren:!0},...Se)}h(we,Se,..._){if(!we)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get(we)||Se.includeChildren&&this.d.value.findSuperstr(we))||(!U||_.includes(0))&&(this.f.value.get(we)||Se.includeChildren&&this.f.value.findSuperstr(we))||(!U||_.includes(2))&&(this.g.value.findSubstr(we)||Se.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$dl=F;function z(te,we,Se){return!te||!we||te===we||we.length>te.length?!1:(we.charAt(we.length-1)!==N.sep&&(we+=N.sep),Se?(0,L.$uf)(te,we):te.indexOf(we)===0)}class O extends Error{constructor(we,Se,_){super(we),this.fileOperationResult=Se,this.options=_}}e.$fl=O;class T extends O{constructor(we,Se,_,U){super(we,Se,U),this.fileOperationResult=Se,this.size=_}}e.$gl=T;class B extends O{constructor(we,Se,_){super(we,2,_),this.stat=Se}}e.$hl=B;var W;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var X;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$pl="";function x(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function Y(te,we){if(!we.hasProvider(M.URI.from({scheme:te.scheme})))return new Promise(Se=>{const _=we.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===te.scheme&&U.added&&(_.dispose(),Se())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(we){return(0,R.$8f)(we)||(we=0),we<Z.KB?(0,p.localize)(1,null,we.toFixed(0)):we<Z.MB?(0,p.localize)(2,null,(we/Z.KB).toFixed(2)):we<Z.GB?(0,p.localize)(3,null,(we/Z.MB).toFixed(2)):we<Z.TB?(0,p.localize)(4,null,(we/Z.GB).toFixed(2)):(0,p.localize)(5,null,(we/Z.TB).toFixed(2))}}e.$sl=Z;function ue(te){const we=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*Z.MB:we?10*Z.MB:S.$o?50*Z.MB:1024*Z.MB}}),define(ke[251],Ee([1,0,21,13,211,32]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=M;async function M(A,C,m,y,v,l){let f;try{await p(A,C,m,y,v,l)}catch(a){f=a}finally{f&&v.errorTransformer&&(f=v.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}async function p(A,C,m,y,v,l){$(l);const f=await A.open(C,{create:!1});try{$(l);let a=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),o=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(f,o,r.buffer,t,r.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await m.write(y(r)),r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(l)&&S(a,v));if(t>0){let g=t;typeof i=="number"&&(g=Math.min(t,i)),m.write(y(r.slice(0,g)))}}catch(a){throw(0,R.$$k)(a)}finally{await A.close(f)}}function $(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function S(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$0k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=$,e.$Eq=S,e.$Iq=y,e.$Jq=v,e.$Kq=l,e.$Lq=f;function $(n){return typeof n.correlationId=="number"}function S(n){return n.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(i,r,o,t){super(),this.h=i,this.j=r,this.m=o,this.n=t,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const i=new N.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=A;class C extends A{constructor(i,r,o){super(i,r,o,{type:"node.js",restartOnError:!1})}}e.$Gq=C;class m extends A{constructor(i,r,o){super(i,r,o,{type:"universal",restartOnError:!0})}}e.$Hq=m;function y(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new a;for(const r of n)i.processEvent(r);return i.coalesce()}function l(n,i){return typeof i=="string"&&!i.startsWith(u.$gk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function f(n,i){const r=[];for(const o of i)r.push((0,u.$kk)(l(n,o)));return r}class a{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let o=!1;if(r){const t=r.type,g=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:t===1&&g===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&g===1?r.type=0:t===1&&g===0||(r.type=g)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,t)=>o.resource.fsPath.length-t.resource.fsPath.length).filter(o=>r.some(t=>(0,p.$el)(o.resource.fsPath,t,!R.$k))?!1:(r.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[252],Ee([1,0,52,3,65,4,2,8]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class $ extends N.$Uc{constructor(){super(),this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new p.$Nh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Dq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new p.$Nh;try{this.h.clear(),this.g.clear();for(const C of A)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const C=new N.$Tc;this.j.set(A.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(A,C),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,C){this.C(A,C)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,C),this.m.add(A.correlationId))}C(A,C){const m=this.L?.subscribe(A.path,(y,v)=>{C.isDisposed||(y?this.z(A,C):v?.type===1&&this.F(A))});return m?(C.add(m),!0):!1}D(A,C){let m=!1;const y=(v,l)=>{if(C.isDisposed)return;const f=this.G(v),a=this.G(l),n=m;m=f,!f&&(a||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.watchFile)(A.path,{persistent:!1,interval:this.n},y)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}C.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.unwatchFile)(A.path,y)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const C={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([C]),this.H(C,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,C){const m=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof C.correlationId=="number"?`${m} (correlationId: ${C.correlationId})`:m)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Uq=$}),define(ke[253],Ee([1,0,52,8,22,34,3,76,17,11,23,2,104,31,65]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=f;class l extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,r,o,t,g){super(),this.r=n,this.s=i,this.t=r,this.u=o,this.w=t,this.y=g,this.c=this.B(new N.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.t(c))),this.f=this.B(new N.$Eh(c=>this.L(c),l.b)),this.g=(0,v.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Lq)(this.r.path,this.r.includes):void 0,this.j=new L.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,m.$Wq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const r=new M.$Tc;return this.G(n,i,r)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,r)),r}G(n,i,r){if(i)return!1;const o=C.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(g,c)=>{if(!r.isDisposed)if(g){const h=await this.F(n,i);r.isDisposed?h.dispose():r.add(h)}else c&&(typeof c.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:o,type:c.type,cId:this.r.correlationId}])});return t?(r.add(t),!0):!1}async H(n,i,r){if(S.$j&&(0,R.$qg)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.$me(this.j.token);r.add((0,M.$Sc)(()=>o.dispose(!0)));const t=new M.$Tc;r.add(t);try{const g=C.URI.file(this.r.path),c=(0,$.$oc)(n),h=(0,u.watch)(n);t.add((0,M.$Sc)(()=>{h.removeAllListeners(),h.close()})),this.P(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const d of await y.Promises.readdir(n))s.add(d)}catch(d){this.N(d)}if(o.token.isCancellationRequested)return;const w=new Map;t.add((0,M.$Sc)(()=>{for(const[,d]of w)d.dispose();w.clear()})),h.on("error",(d,D)=>{o.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${d}, ${D})`),this.C())}),h.on("change",(d,D)=>{if(o.token.isCancellationRequested)return;this.P(`[raw] ["${d}"] ${D}`);let b="";if(D&&(b=D.toString(),S.$j&&(b=(0,p.$8l)(b))),!(!b||d!=="change"&&d!=="rename"))if(i)if(d==="rename"){w.get(b)?.dispose();const E=setTimeout(async()=>{if(w.delete(b),b===c&&!await y.Promises.exists(n)){this.I(g);return}if(o.token.isCancellationRequested)return;const k=await this.M((0,$.$kc)(n,b));if(o.token.isCancellationRequested)return;let P;k?s.has(b)?P=0:(P=1,s.add(b)):(s.delete(b),P=2),this.J({resource:(0,A.$4g)(g,b),type:P,cId:this.r.correlationId})},l.a);w.set(b,(0,M.$Sc)(()=>clearTimeout(E)))}else{let E;s.has(b)?E=0:(E=1,s.add(b)),this.J({resource:(0,A.$4g)(g,b),type:E,cId:this.r.correlationId})}else if(d==="rename"||b!==c){const E=setTimeout(async()=>{const k=await y.Promises.exists(n);o.token.isCancellationRequested||(k?(this.J({resource:g,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(g))},l.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(E)))}else this.J({resource:g,type:0,cId:this.r.correlationId},!0)})}catch(g){o.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${g.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Jq)(n);if(i.length>0){if(this.y)for(const o of i)this.P(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(S.$k)return y.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await y.Promises.readdir((0,$.$nc)(n))).some(o=>o===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=l;async function f(a,n,i,r,o=512){const t=await y.Promises.open(a,"r"),g=Buffer.allocUnsafe(o),c=new L.$me(r);let h,s=!1;const w={path:a,excludes:[],recursive:!1},d=new l(w,void 0,D=>{(async()=>{for(const{type:b}of D)if(b===0){if(s)return;s=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:E}=await y.Promises.read(t,g,0,o,null);if(!E||c.token.isCancellationRequested)break;n(g.slice(0,E))}}catch(E){h=new Error(E),c.dispose(!0)}finally{s=!1}}})()});return await d.ready,i(),new Promise((D,b)=>{c.token.onCancellationRequested(async()=>{d.dispose();try{await y.Promises.close(t)}catch(E){h=new Error(E)}h?b(h):D()})})}}),define(ke[254],Ee([1,0,4,35,252,11,253,34]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class $ extends L.$Uq{constructor(A){super(),this.L=A,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const C=[],m=new Set(Array.from(this.watchers));for(const y of A){const v=this.R(y);v&&(0,N.$ok)(v.request.excludes,y.excludes)&&(0,N.$ok)(v.request.includes,y.includes)?m.delete(v):C.push(y)}C.length&&this.M(`Request to start watching: ${C.map(y=>this.I(y)).join(",")}`),m.size&&this.M(`Request to stop watching: ${Array.from(m).map(y=>this.I(y.request)).join(",")}`);for(const y of m)this.U(y);for(const y of C)this.S(y)}R(A){for(const C of this.watchers)if(typeof A.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===A.correlationId)return C}else if((0,p.$pg)(C.request.path,A.path,!R.$k))return C}S(A){const C=new M.$Zq(A,this.L,y=>this.a.fire(y),()=>this.c.fire(A),y=>this.b.fire(y),this.O),m={request:A,instance:C};this.watchers.add(m)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const C=new Map;for(const m of A){const y=R.$k?m.path:m.path.toLowerCase();let v=C.get(m.correlationId);v||(v=new Map,C.set(m.correlationId,v)),v.has(y)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(m)}`),v.set(y,m)}return Array.from(C.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(A){this.O=A;for(const C of this.watchers)C.instance.setVerboseLogging(A)}M(A,C){this.O&&this.b.fire({type:"trace",message:this.Z(A,C)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,C){return C?`[File Watcher (node.js)] ${A} (${this.I(C.request)})`:`[File Watcher (node.js)] ${A}`}}e.$2q=$}),define(ke[255],Ee([1,0,65,254]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class L extends u.$Gq{constructor(M,p,$){super(M,p,$),this.s()}r(M){return M.add(new N.$2q(void 0))}}e.$3q=L}),define(ke[256],Ee([1,0,15,81,194,65]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class M extends R.$Hq{constructor($,S,A){super($,S,A),this.s()}r($){const S=$.add(new L.$Sq(u.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(S.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$0h)(S.getChannel("watcher")))}}e.$Tq=M}),define(ke[107],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class u{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$oi=u}),define(ke[257],Ee([1,0,8,13,3,106,247,5,107,75]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const A=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$oi,a=!1,n,i=A){this.i=f,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=i?n?._globalGraph??new M.$6q(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const f of this.g)(0,L.$Oc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const a=new class extends m{dispose(){this.h.delete(a),super.dispose()}}(f,this.j,this,this.l);return this.h.add(a),a}invokeFunction(f,...a){this.m();const n=v.traceInvocation(this.l,f);let i=!1;try{return f({get:o=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(f,...a){this.m();let n,i;return f instanceof R.$ni?(n=v.traceCreation(this.l,f.ctor),i=this.o(f.ctor,f.staticArguments.concat(a),n)):(n=v.traceCreation(this.l,f),i=this.o(f,a,n)),n.stop(),i}o(f,a=[],n){const i=p._util.getServiceDependencies(f).sort((t,g)=>t.index-g.index),r=[];for(const t of i){const g=this.s(t.id,n);g||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(g)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(f,a.concat(r))}q(f,a){if(this.i.get(f)instanceof R.$ni)this.i.set(f,a);else if(this.k)this.k.q(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const a=this.i.get(f);return!a&&this.k?this.k.r(f):a}s(f,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const n=this.r(f);return n instanceof R.$ni?this.u(f,n,a.branch(f,!0)):(a.branch(f,!1),n)}u(f,a,n){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,a,n)}finally{this.t.delete(f)}}v(f,a,n){const i=new M.$6q(t=>t.id.toString());let r=0;const o=[{id:f,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new C(i);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const c=this.r(g.id);if(c||this.y(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),c instanceof R.$ni){const h={id:g.id,desc:c,_trace:t._trace.branch(g.id,!0)};i.insertEdge(t,h),o.push(h)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:g}of t){if(this.r(g.id)instanceof R.$ni){const h=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,h)}i.removeNode(g)}}return this.r(f)}w(f,a,n=[],i,r){if(this.i.get(f)instanceof R.$ni)return this.x(f,a,n,i,r,this.g);if(this.k)return this.k.w(f,a,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(f,a,n=[],i,r,o){if(i){const t=new m(void 0,this.j,this,this.l);t.c=String(f);const g=new Map,c=new u.$Jh(()=>{const h=t.o(a,n,r);for(const[s,w]of g){const d=h[s];if(typeof d=="function")for(const D of w)D.disposable=d.apply(h,D.listener)}return g.clear(),o.add(h),h});return new Proxy(Object.create(null),{get(h,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let D=g.get(s);return D||(D=new S.$5c,g.set(s,D)),(E,k,P)=>{if(c.isInitialized)return c.value[s](E,k,P);{const I={listener:[E,k,P],disposable:void 0},j=D.push(I);return(0,L.$Sc)(()=>{j(),I.disposable?.dispose()})}}}if(s in h)return h[s];const w=c.value;let d=w[s];return typeof d!="function"||(d=d.bind(w),h[s]=d),d},set(h,s,w){return c.value[s]=w,!0},getPrototypeOf(h){return a.prototype}})}else{const t=this.o(a,n,r);return o.add(t),t}}y(f,a){if(a&&console.warn(f),this.j)throw new Error(f)}}e.$7q=m;var y;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(y||(y={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new v(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(f,a){return f?new v(1,a.name):v.c}static{this.f=0}constructor(f,a){this.type=f,this.name=a,this.g=Date.now(),this.h=[]}branch(f,a){const n=new v(3,f.toString());return this.h.push([f,a,n]),n}stop(){const f=Date.now()-this.g;v.f+=f;let a=!1;function n(r,o){const t=[],g=new Array(r+1).join("	");for(const[c,h,s]of o.h)if(h&&s){a=!0,t.push(`${g}CREATES -> ${c}`);const w=n(r+1,s);w&&t.push(w)}else t.push(`${g}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(f>2||a)&&v.all.add(i.join(`
`))}}e.$8q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=l,e.log=a,e.$$j=d,e.$_j=D,e.$ak=b,e.$bk=E,e.$Wj=(0,y.$qi)("logService"),e.$Xj=(0,y.$qi)("loggerService");function v(){return new Date().toISOString()}function l(k){return(0,A.$8f)(k)}var f;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$Zj=f.Info;function a(k,P,I){switch(P){case f.Trace:k.trace(I);break;case f.Debug:k.debug(I);break;case f.Info:k.info(I);break;case f.Warning:k.warn(I);break;case f.Error:k.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(k,P=!1){let I="";for(let j=0;j<k.length;j++){let F=k[j];if(F instanceof Error&&(F=(0,N.$bj)(F,P)),typeof F=="object")try{F=JSON.stringify(F)}catch{}I+=(j>0?" ":"")+F}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new L.$be),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==f.Off&&this.b<=P}}e.$2j=i;class r extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(f.Trace)&&this.g(f.Trace,n([P,...I],!0))}debug(P,...I){this.f(f.Debug)&&this.g(f.Debug,n([P,...I]))}info(P,...I){this.f(f.Info)&&this.g(f.Info,n([P,...I]))}warn(P,...I){this.f(f.Warning)&&this.g(f.Warning,n([P,...I]))}error(P,...I){if(this.f(f.Error))if(P instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=P.stack,this.g(f.Error,n(j))}else this.g(f.Error,n([P,...I]))}flush(){}}e.$3j=r;class o extends i{constructor(P=e.$Zj){super(),this.setLevel(P),this.g=!$.$i}trace(P,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,P,...I):console.warn(`[main ${v()}]`,P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,P,...I):console.error(`[main ${v()}]`,P,...I))}flush(){}}e.$4j=o;class t extends i{constructor(P=e.$Zj,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$5j=t;class g extends i{constructor(P,I=e.$Zj){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(P),...I])}debug(P,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(P),...I])}info(P,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(P),...I])}warn(P,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(P),...I])}error(P,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$bj)(P,this.f(f.Trace))}flush(){}}e.$6j=g;class c extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const j of this.g)j.trace(P,...I)}debug(P,...I){for(const j of this.g)j.debug(P,...I)}info(P,...I){for(const j of this.g)j.info(P,...I)}warn(P,...I){for(const j of this.g)j.warn(P,...I)}error(P,...I){for(const j of this.g)j.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$7j=c;class h extends M.$Uc{constructor(P,I,j){if(super(),this.h=P,this.j=I,this.b=new p.$Bc,this.c=this.B(new L.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$be),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(P){return(0,A.$4f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const j=this.n(P),F=(0,A.$4f)(P)?P:I?.id??(0,R.$ej)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const O=I?.logLevel==="always"?f.Trace:I?.logLevel;z||(z=this.s(j,O??this.getLogLevel(j)??this.h,{...I,id:F}));const T={logger:z,info:{resource:j,id:F,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(j,T),z}n(P){return(0,A.$4f)(P)?(0,S.$4g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const j=P,F=I,z=this.b.get(j);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([j,F]))}else{this.h=P;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const j=this.m(P);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=h;class s{constructor(){this.onDidChangeLogLevel=new L.$be().event}setLevel(P){}getLevel(){return f.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$9j=s;class w extends s{}e.$0j=w;function d(k){if(k.verbose)return f.Trace;if(typeof k.logLevel=="string"){const P=E(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Zj}function D(k){switch(k){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function b(k){switch(k){case f.Trace:return{original:"Trace",value:u.localize(0,null)};case f.Debug:return{original:"Debug",value:u.localize(1,null)};case f.Info:return{original:"Info",value:u.localize(2,null)};case f.Warning:return{original:"Warning",value:u.localize(3,null)};case f.Error:return{original:"Error",value:u.localize(4,null)};case f.Off:return{original:"Off",value:u.localize(5,null)}}}function E(k){switch(k){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ck=new m.$Hj("logLevel",D(f.Info))}),define(ke[258],Ee([1,0,19,8,13,4,3,17,65,12]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class A extends M.$Uc{constructor(m,y){super(),this.a=m,this.b=y,this.c=this.B(new R.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$oh(0)),this.w=[],this.y=this.B(new N.$oh(0))}watch(m,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(m,y):this.z(m,y)}n(m,y){const v={path:this.I(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},l=(0,u.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,L.$1)(m))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,$.$Iq)(y)),y=>this.G(y),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.j)(0,$.$Eq)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.j)(0,$.$Eq)(y)&&m.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,y){const v={path:this.I(m),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},l=(0,u.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,L.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$Iq)(m)),m=>this.G(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,p.$ic)(m.fsPath)}}e.$Mq=A}),define(ke[259],Ee([1,0,52,396,8,27,21,4,34,3,17,11,23,98,31,212,32,251,258,47,256,255]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(g){console.error(`Error enabling graceful-fs: ${(0,i.$bj)(g)}`)}})();class t extends n.$Mq{static{this.J=!1}constructor(c,h){super(c,h),this.onDidChangeCapabilities=p.Event.None,this.O=new R.$Bc(s=>m.$Ug.getComparisonKey(s)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,C.$k&&(this.L|=1024)),this.L}async stat(c){try{const{stat:h,symbolicLink:s}=await v.SymlinkSupport.stat(this.I(c));return{type:this.N(h,s),ctime:h.birthtime.getTime(),mtime:h.mtime.getTime(),size:h.size,permissions:h.mode&128?void 0:f.FilePermission.Locked}}catch(h){throw this.gb(h)}}async M(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const h=await v.Promises.readdir(this.I(c),{withFileTypes:!0}),s=[];return await Promise.all(h.map(async w=>{try{let d;w.isSymbolicLink()?d=(await this.stat((0,m.$4g)(c,w.name))).type:d=this.N(w),s.push([w.name,d])}catch(d){this.a.trace(d)}})),s}catch(h){throw this.gb(h)}}N(c,h){let s;return h?.dangling?s=f.FileType.Unknown:c.isFile()?s=f.FileType.File:c.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,h&&(s|=f.FileType.SymbolicLink),s}async P(c){const h=this.I(c);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${h})`);let s;for(;s=this.O.get(c);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${h})`),await s.wait();const w=new L.$ph;return this.O.set(c,w),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${h})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${h})`),this.O.get(c)===w&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${h})`),this.O.delete(c)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${h})`),w.open()})}async readFile(c,h){let s;try{h?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(c)})`),s=await this.P(c));const w=this.I(c);return await v.Promises.readFile(w)}catch(w){throw this.gb(w)}finally{s?.dispose()}}Q(c){t.J&&this.a.trace(c)}readFileStream(c,h,s){const w=(0,y.$qe)(d=>M.$Ce.concat(d.map(D=>M.$Ce.wrap(D))).buffer);return(0,a.$Bq)(this,c,w,d=>d.buffer,{...h,bufferSize:256*1024},s),w}async writeFile(c,h,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.R(c)?this.S(c,(0,m.$4g)((0,m.$3g)(c),`${(0,m.$1g)(c)}${s.atomic.postfix}`),h,s):this.U(c,h,s)}async R(c){try{const h=this.I(c),{symbolicLink:s}=await v.SymlinkSupport.stat(h);if(s)return!1}catch{}return!0}async S(c,h,s,w){const d=new S.$Tc;try{d.add(await this.P(c)),d.add(await this.P(h)),await this.U(h,s,w,!0);try{await this.rename(h,c,{overwrite:!0})}catch(D){try{await this.delete(h,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{d.dispose()}}async U(c,h,s,w){let d;try{const D=this.I(c);if(!s.create||!s.overwrite){if(await v.Promises.exists(D)){if(!s.overwrite)throw(0,f.$0k)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.$0k)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(c,{create:!0,unlock:s.unlock},w),await this.write(d,0,h,0,h.byteLength)}catch(D){throw await this.hb(c,D)}finally{typeof d=="number"&&await this.close(d)}}static{this.Z=!0}static configureFlushOnWrite(c){t.Z=c}async open(c,h,s){const w=this.I(c);let d;(0,f.$Xk)(h)&&!s&&(d=await this.P(c));let D;try{if((0,f.$Xk)(h)&&h.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(w);E.mode&128||await v.Promises.chmod(w,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let b;if((0,f.$Xk)(h)){if(C.$i)try{await v.Promises.truncate(w,0),b="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}b||(b="w")}else b="r";D=await v.Promises.open(w,b)}catch(b){throw d?.dispose(),(0,f.$Xk)(h)?await this.hb(c,b):this.gb(b)}if(this.W.set(D,0),(0,f.$Xk)(h)&&this.Y.set(D,c),d){const b=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${w})`),this.X.set(D,d),b&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${w})`),b.dispose())}return D}async close(c){const h=this.X.get(c);try{if(this.W.delete(c),this.Y.delete(c)&&t.Z)try{await v.Promises.fdatasync(c)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await v.Promises.close(c)}catch(s){throw this.gb(s)}finally{h&&(this.X.get(c)===h&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.X.delete(c)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),h.dispose())}}async read(c,h,s,w,d){const D=this.$(c,h);let b=null;try{b=(await v.Promises.read(c,s,w,d,D)).bytesRead}catch(E){throw this.gb(E)}finally{this.ab(c,D,b)}return b}$(c,h){return h===this.W.get(c)?null:h}ab(c,h,s){const w=this.W.get(c);typeof w=="number"&&(typeof h=="number"||(typeof s=="number"?this.W.set(c,w+s):this.W.delete(c)))}async write(c,h,s,w,d){return(0,L.$Kh)(()=>this.bb(c,h,s,w,d),100,3)}async bb(c,h,s,w,d){const D=this.$(c,h);let b=null;try{b=(await v.Promises.write(c,s,w,d,D)).bytesWritten}catch(E){throw await this.hb(this.Y.get(c),E)}finally{this.ab(c,D,b)}return b}async mkdir(c){try{await v.Promises.mkdir(this.I(c))}catch(h){throw this.gb(h)}}async delete(c,h){try{const s=this.I(c);if(h.recursive){let w;h?.atomic!==!1&&h.atomic.postfix&&(w=(0,A.$kc)((0,A.$nc)(s),`${(0,A.$oc)(s)}${h.atomic.postfix}`)),await v.Promises.rm(s,v.RimRafMode.MOVE,w)}else try{await v.Promises.unlink(s)}catch(w){if(w.code==="EPERM"||w.code==="EISDIR"){let d=!1;try{const{stat:D,symbolicLink:b}=await v.SymlinkSupport.stat(s);d=D.isDirectory()&&!b}catch{}if(d)await v.Promises.rmdir(s);else throw w}else throw w}}catch(s){throw this.gb(s)}}async rename(c,h,s){const w=this.I(c),d=this.I(h);if(w!==d)try{await this.cb(c,h,"move",s.overwrite),await v.Promises.rename(w,d)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(2,null,(0,A.$oc)(w),(0,A.$oc)((0,A.$nc)(d)),D.toString()))),this.gb(D)}}async copy(c,h,s){const w=this.I(c),d=this.I(h);if(w!==d)try{await this.cb(c,h,"copy",s.overwrite),await v.Promises.copy(w,d,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(3,null,(0,A.$oc)(w),(0,A.$oc)((0,A.$nc)(d)),D.toString()))),this.gb(D)}}async cb(c,h,s,w){const d=this.I(c),D=this.I(h);let b=!1;if(!!(this.capabilities&1024)||(b=(0,$.$pg)(d,D,!0)),b){if(s==="copy")throw(0,f.$0k)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const k=await this.M(c);if(!k)throw(0,f.$0k)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const P=await this.M(h);if(P){if(!w)throw(0,f.$0k)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);k.type&f.FileType.File&&P.type&f.FileType.File||await this.delete(h,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,h){return this.db(c,h,!1)}async db(c,h,s){const w=this.I(c),d=this.I(h),D=!!(this.capabilities&1024);if((0,$.$pg)(w,d,!D))return;const b=new S.$Tc;try{b.add(await this.P(c)),b.add(await this.P(h)),s&&await v.Promises.mkdir((0,A.$nc)(d),{recursive:!0}),await v.Promises.copyFile(w,d)}catch(E){if(E.code==="ENOENT"&&!s)return this.db(c,h,!0);throw this.gb(E)}finally{b.dispose()}}t(c,h,s){return new r.$Tq(w=>c(w),w=>h(w),s)}F(c,h,s){return new o.$3q(w=>c(w),w=>h(w),s)}gb(c){if(c instanceof f.$9k)return c;let h=c,s;switch(c.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":h=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=f.FileSystemProviderErrorCode.Unknown;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.$0k)(h,s)}async hb(c,h){let s=this.gb(h);if(c&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await v.SymlinkSupport.stat(this.I(c));w.mode&128||(s=(0,f.$0k)(h,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.a.trace(w)}return s}}e.$4q=t}),define(ke[260],Ee([1,0,3,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class L extends u.$Uc{constructor(M,p=[]){super(),this.a=new N.$7j([M,...p]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$AQ=L}),define(ke[261],Ee([1,0,32,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function R(S,A,C,m,y){try{const v=await new Promise((f,a)=>{le(["@vscode/spdlog"],f,a)});v.setFlushOn(L.Trace);const l=await v.createAsyncRotatingLogger(S,A,C,m);return y?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(v){console.error(v)}return null}function M(S,A,C){switch(A){case N.LogLevel.Trace:S.trace(C);break;case N.LogLevel.Debug:S.debug(C);break;case N.LogLevel.Info:S.info(C);break;case N.LogLevel.Warning:S.warn(C);break;case N.LogLevel.Error:S.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(S,A){switch(A){case N.LogLevel.Trace:S.setLevel(L.Trace);break;case N.LogLevel.Debug:S.setLevel(L.Debug);break;case N.LogLevel.Info:S.setLevel(L.Info);break;case N.LogLevel.Warning:S.setLevel(L.Warning);break;case N.LogLevel.Error:S.setLevel(L.Error);break;case N.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$3j{constructor(A,C,m,y,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,C,m,y),this.B(this.onDidChangeLogLevel(l=>{this.r&&p(this.r,l)}))}async s(A,C,m,y){const v=m?6:1,l=30/v*u.$sl.MB,f=await R(A,C,l,v,y);if(f){this.r=f,p(this.r,this.getLevel());for(const{level:a,message:n}of this.m)M(this.r,a,n);this.m=[]}}g(A,C){this.r?M(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pQ=$}),define(ke[138],Ee([1,0,41,214,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function S(v,l){return l-v}$.compare=S;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function C(v){return A[v]||""}$.toString=C;function m(v){switch(v){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=m;function y(v){switch(v){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=y}(M||(e.MarkerSeverity=M={}));var p;(function($){const S="";function A(m){return C(m,!0)}$.makeKey=A;function C(m,y){const v=[S];return m.source?v.push(m.source.replace("\xA6","\\\xA6")):v.push(S),m.code?typeof m.code=="string"?v.push(m.code.replace("\xA6","\\\xA6")):v.push(m.code.value.replace("\xA6","\\\xA6")):v.push(S),m.severity!==void 0&&m.severity!==null?v.push(M.toString(m.severity)):v.push(S),m.message&&y?v.push(m.message.replace("\xA6","\\\xA6")):v.push(S),m.startLineNumber!==void 0&&m.startLineNumber!==null?v.push(m.startLineNumber.toString()):v.push(S),m.startColumn!==void 0&&m.startColumn!==null?v.push(m.startColumn.toString()):v.push(S),m.endLineNumber!==void 0&&m.endLineNumber!==null?v.push(m.endLineNumber.toString()):v.push(S),m.endColumn!==void 0&&m.endColumn!==null?v.push(m.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}$.makeKeyOptionalMessage=C})(p||(e.IMarkerData=p={})),e.$Tt=(0,L.$qi)("markerService")}),define(ke[262],Ee([1,0,4,41,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=N.default,e.$Tv=(0,L.$qi)("notificationService");var R;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class S{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$Vv=S;class A{infinite(){}done(){}total(m){}worked(m){}}e.$Wv=A}),define(ke[263],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,u.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(le,e){return function(u,N){e(u,N,le)}};define(ke[108],Ee([1,0,8,22,3,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,R.$qi)("progressService");var M;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$Zv=p;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const y=this.d;this.d=()=>{y?.(),m()}}):Promise.resolve()}}e.$1v=$;let S=class extends L.$Uc{constructor(m,y){super(),this.a=new u.$Nh,y.withProgress(m,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$2v=S,e.$2v=S=Je([qe(1,e.$Xv)],S);class A extends L.$Uc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new L.$Tc)}start(m){this.stop();const y=++this.a,v=new N.$me;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:y,token:v.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$3v=A,e.$4v=(0,R.$qi)("editorProgressService")}),define(ke[38],Ee([1,0,62,18]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class L{constructor(){this.a=new Map}add(M,p){u.ok(N.$4f(M)),u.ok(N.$6f(p)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new L}),define(ke[109],Ee([1,0,4,38]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function L(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this.b=new u.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,S){this.a[L($)]=S,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$9n.add(e.$0n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,38]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=l,e.$no=f,e.$oo=a,e.$po=i,e.$qo=r;var S;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$bo={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const C=$.$9n.as(p.$0n.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const c=new Set;this.n(t,g,c),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const g=new Set;this.o(t,g),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const c=new Set;this.o(g,c),this.n(t,!1,c),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const c=[];for(const{overrides:h,source:s}of t)for(const w in h)if(g.add(w),e.$lo.test(w)){const d=this.a.get(w),D=d?.valuesSources??new Map;if(s)for(const P of Object.keys(h[w]))D.set(P,s);const b={...d?.value||{},...h[w]};this.a.set(w,{source:s,value:b,valuesSources:D});const E=(0,M.$7i)(w),k={type:"object",default:b,description:R.localize(1,null,E),$ref:e.$io,defaultDefaultValue:b,source:L.$4f(s)?void 0:s,defaultValueSource:s};c.push(...l(w)),this.d[w]=k,this.b.properties[w]=k}else{this.a.set(w,{value:h[w],source:s});const d=this.d[w];d&&(this.w(w,d),this.r(w,d))}this.m(c)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:c,source:h}of t)for(const s in c){const w=this.a.get(s),d=L.$4f(h)?h:h?.id,D=L.$4f(w?.source)?w?.source:w?.source?.id;if(d===D)if(g.add(s),this.a.delete(s),e.$lo.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}}this.u()}deltaConfiguration(t){let g=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,c){t.forEach(h=>{this.p(h,g,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(t,g){const c=h=>{if(h.properties)for(const s in h.properties){g.add(s);const w=this.d[s];w?.policy?.name&&this.e.delete(w.policy.name),delete this.d[s],this.s(s,h.properties[s])}h.allOf?.forEach(s=>c(s))};for(const h of t){c(h);const s=this.c.indexOf(h);s!==-1&&this.c.splice(s,1)}}p(t,g=!0,c,h,s=3,w){s=L.$ag(t.scope)?s:t.scope;const d=t.properties;if(d)for(const b in d){const E=d[b];if(g&&i(b,E)){delete d[b];continue}if(E.source=c,E.defaultDefaultValue=d[b].default,this.w(b,E),e.$lo.test(b)?E.scope=void 0:(E.scope=L.$ag(E.scope)?s:E.scope,E.restricted=L.$ag(E.restricted)?!!h?.includes(b):E.restricted),d[b].hasOwnProperty("included")&&!d[b].included){this.f[b]=d[b],delete d[b];continue}else this.d[b]=d[b],d[b].policy?.name&&this.e.set(d[b].policy.name,b);!d[b].deprecationMessage&&d[b].markdownDeprecationMessage&&(d[b].deprecationMessage=d[b].markdownDeprecationMessage),w.add(b)}const D=t.allOf;if(D)for(const b of D)this.p(b,g,c,h,s,w)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=c=>{const h=c.properties;if(h)for(const w in h)this.r(w,h[w]);c.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$co.properties[t]=g,g.scope){case 1:e.$do.properties[t]=g;break;case 2:e.$eo.properties[t]=g;break;case 6:e.$fo.properties[t]=g;break;case 3:e.$go.properties[t]=g;break;case 4:e.$ho.properties[t]=g;break;case 5:e.$ho.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$co.properties[t],g.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,c={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$io};this.w(g,c),e.$co.properties[g]=c,e.$do.properties[g]=c,e.$eo.properties[g]=c,e.$fo.properties[g]=c,e.$go.properties[g]=c,e.$ho.properties[g]=c}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,g){const c=this.a.get(t);let h=c?.value,s=c?.source;L.$$f(h)&&(h=g.defaultDefaultValue,s=void 0),L.$$f(h)&&(h=a(g.type)),g.default=h,g.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.$ko=`^(${y})+$`,e.$lo=new RegExp(e.$ko);function l(o){const t=[];if(e.$lo.test(o)){let g=v.exec(o);for(;g?.length;){const c=g[1].trim();c&&t.push(c),g=v.exec(o)}}return(0,u.$Mb)(t)}function f(o){return o.reduce((t,g)=>`${t}[${g}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new m;$.$9n.add(e.$bo.Configuration,n);function i(o,t){return o.trim()?e.$lo.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function r(){const o=[],t=n.getConfigurationProperties();for(const g of Object.keys(t))o.push([g,t[g].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[264],Ee([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function y(g){return Object.isFrozen(g)?g:p.$Xn(g)}class v{static createEmptyModel(c){return new v({},[],[],void 0,c)}constructor(c,h,s,w,d){this.b=c,this.c=h,this.d=s,this.raw=w,this.f=d,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof v)return h;const s=new l("",this.f);return s.parseRaw(h),s.configurationModel});this.g=c.reduce((h,s)=>s===h?s:h.merge(s),c[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$5i)(this.contents,c):this.contents}inspect(c,h){const s=this;return{get value(){return y(s.rawConfiguration.getValue(c))},get override(){return h?y(s.rawConfiguration.getOverrideValue(c,h)):void 0},get merged(){return y(h?s.rawConfiguration.override(h).getValue(c):s.rawConfiguration.getValue(c))},get overrides(){const w=[];for(const{contents:d,identifiers:D,keys:b}of s.rawConfiguration.overrides){const E=new v(d,b,[],void 0,s.f).getValue(c);E!==void 0&&w.push({identifiers:D,value:E})}return w.length?y(w):void 0}}}getOverrideValue(c,h){const s=this.j(h);return s?c?(0,A.$5i)(s,c):s:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const s of this.overrides)s.identifiers.includes(c)&&h.push(...s.keys);return u.$Mb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return u.$Mb(c)}override(c){let h=this.a.get(c);return h||(h=this.h(c),this.a.set(c,h)),h}merge(...c){const h=p.$Wn(this.contents),s=p.$Wn(this.overrides),w=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const D of c)if(d.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(h,D.contents);for(const b of D.overrides){const[E]=s.filter(k=>u.$ub(k.identifiers,b.identifiers));E?(this.i(E.contents,b.contents),E.keys.push(...b.keys),E.keys=u.$Mb(E.keys)):s.push(p.$Wn(b))}for(const b of D.keys)w.indexOf(b)===-1&&w.push(b)}return new v(h,w,s,d.every(D=>D instanceof v)?void 0:d,this.f)}h(c){const h=this.j(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const s={};for(const w of u.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let d=this.contents[w];const D=h[w];D&&(typeof d=="object"&&typeof D=="object"?(d=p.$Wn(d),this.i(d,D)):d=D),s[w]=d}return new v(s,this.keys,this.overrides,void 0,this.f)}i(c,h){for(const s of Object.keys(h)){if(s in c&&$.$6f(c[s])&&$.$6f(h[s])){this.i(c[s],h[s]);continue}c[s]=p.$Wn(h[s])}}j(c){let h=null,s=null;const w=d=>{d&&(s?this.i(s,d):s=p.$Wn(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===c?h=d.contents:d.identifiers.includes(c)&&w(d.contents);return w(h),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.k(c,h,!0)}setValue(c,h){this.k(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$4i)(this.contents,c),C.$lo.test(c)&&this.overrides.splice(this.overrides.findIndex(s=>u.$ub(s.identifiers,(0,C.$mo)(c))),1))}k(c,h,s){(0,A.$3i)(this.contents,c,h,w=>this.f.error(w)),s=s||this.keys.indexOf(c)===-1,s&&this.keys.push(c),C.$lo.test(c)&&this.overrides.push({identifiers:(0,C.$mo)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$2i)(this.contents[c],w=>this.f.error(w))})}}e.$ro=v;class l{constructor(c,h){this.f=c,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!$.$ag(c)){const s=this.h(c);this.parseRaw(s,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:s,keys:w,overrides:d,restricted:D,hasExcludedProperties:b}=this.i(c,h);this.b=new v(s,w,d,b?[c]:void 0,this.g),this.c=D||[]}h(c){let h={},s=null,w=[];const d=[],D=[];function b(k){Array.isArray(w)?w.push(k):s!==null&&(w[s]=k)}const E={onObjectBegin:()=>{const k={};b(k),d.push(w),w=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const k=[];b(k),d.push(w),w=k,s=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:b,onError:(k,P,I)=>{D.push({error:k,offset:P,length:I})}};if(c)try{L.$Kn(c,E),h=w[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return h}i(c,h){const s=m.$9n.as(C.$bo.Configuration).getConfigurationProperties(),w=this.j(c,s,!0,h);c=w.raw;const d=(0,A.$2i)(c,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(c),b=this.l(c,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:d,keys:D,overrides:b,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}j(c,h,s,w){let d=!1;if(!w?.scopes&&!w?.skipRestricted&&!w?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:d};const D={},b=[];for(const E in c)if(C.$lo.test(E)&&s){const k=this.j(c[E],h,!1,w);D[E]=k.raw,d=d||k.hasExcludedProperties,b.push(...k.restricted)}else{const k=h[E],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&b.push(E),!w.exclude?.includes(E)&&(w.include?.includes(E)||(P===void 0||w.scopes===void 0||w.scopes.includes(P))&&!(w.skipRestricted&&k?.restricted))?D[E]=c[E]:d=!0}return{raw:D,restricted:b,hasExcludedProperties:d}}l(c,h){const s=[];for(const w of Object.keys(c))if(C.$lo.test(w)){const d={};for(const D in c[w])d[D]=c[w][D];s.push({identifiers:(0,C.$mo)(w),keys:Object.keys(d),contents:(0,A.$2i)(d,h)})}return s}}e.$so=l;class f extends R.$Uc{constructor(c,h,s,w,d){super(),this.c=c,this.f=h,this.g=w,this.h=d,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new l(this.c.toString(),d),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&s.isEqual(D.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=f;class a{constructor(c,h,s,w,d,D,b,E,k,P,I,j,F){this.a=c,this.b=h,this.c=s,this.overrideIdentifiers=w,this.d=d,this.f=D,this.g=b,this.h=E,this.i=k,this.j=P,this.k=I,this.l=j,this.m=F}get value(){return y(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,h,s,w,d,D,b,E,k,P){this.j=c,this.l=h,this.m=s,this.n=w,this.p=d,this.q=D,this.r=b,this.s=E,this.t=k,this.u=P,this.h=null,this.i=new M.$Bc,this.v=null}getValue(c,h,s){return this.w(c,h,s).getValue(c)}updateValue(c,h,s={}){let w;s.resource?(w=this.t.get(s.resource),w||(w=v.createEmptyModel(this.u),this.t.set(s.resource,w))):w=this.s,h===void 0?w.removeValue(c):w.setValue(c,h),s.resource||(this.h=null)}inspect(c,h,s){const w=this.w(c,h,s),d=this.A(h.resource,s),D=h.resource?this.t.get(h.resource)||this.s:this.s,b=new Set;for(const E of w.overrides)for(const k of E.identifiers)w.getOverrideValue(c,k)!==void 0&&b.add(k);return new a(c,h,w.getValue(c),b.size?[...b]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,d||void 0,D)}keys(c){const h=this.A(void 0,c);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.j=c,this.h=null,this.i.clear()}updatePolicyConfiguration(c){this.l=c}updateApplicationConfiguration(c){this.m=c,this.h=null,this.i.clear()}updateLocalUserConfiguration(c){this.n=c,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(c){this.p=c,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(c){this.q=c,this.h=null,this.i.clear()}updateFolderConfiguration(c,h){this.r.set(c,h),this.i.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.i.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const s=[];if(!h){const{added:w,updated:d,removed:D}=o(this.j,c);h=[...w,...d,...D]}for(const w of h)for(const d of(0,C.$mo)(w)){const D=this.j.getKeysForOverrideIdentifier(d),b=c.getKeysForOverrideIdentifier(d),E=[...b.filter(k=>D.indexOf(k)===-1),...D.filter(k=>b.indexOf(k)===-1),...D.filter(k=>!p.$1n(this.j.override(d).getValue(k),c.override(d).getValue(k)))];s.push([d,E])}return this.updateDefaultConfiguration(c),{keys:h,overrides:s}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:s,removed:w}=o(this.l,c),d=[...h,...s,...w];return d.length&&this.updatePolicyConfiguration(c),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:s,removed:w,overrides:d}=o(this.applicationConfiguration,c),D=[...h,...s,...w];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:d}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:s,removed:w,overrides:d}=o(this.localUserConfiguration,c),D=[...h,...s,...w];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:d}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:s,removed:w,overrides:d}=o(this.remoteUserConfiguration,c),D=[...h,...s,...w];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:d}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:s,removed:w,overrides:d}=o(this.workspaceConfiguration,c),D=[...h,...s,...w];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:d}}compareAndUpdateFolderConfiguration(c,h){const s=this.folderConfigurations.get(c),{added:w,updated:d,removed:D,overrides:b}=o(s,h),E=[...w,...d,...D];return(E.length||!s)&&this.updateFolderConfiguration(c,h),{keys:E,overrides:b}}compareAndDeleteFolderConfiguration(c){const h=this.folderConfigurations.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:s,updated:w,removed:d,overrides:D}=o(h,void 0);return{keys:[...s,...w,...d],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(c,h,s){let w=this.x(h,s);return h.overrideIdentifier&&(w=w.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(c)!==void 0&&(w=w.merge(this.l)),w}x({resource:c},h){let s=this.y();if(h&&c){const w=h.getFolder(c);w&&(s=this.z(w.uri)||s);const d=this.t.get(c);d&&(s=s.merge(d))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(c){let h=this.i.get(c);if(!h){const s=this.y(),w=this.r.get(c);w?(h=s.merge(w),this.i.set(c,h)):h=s}return h}A(c,h){if(h&&c){const s=h.getFolder(c);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((c,h)=>{const{contents:s,overrides:w,keys:d}=this.r.get(h);return c.push([h,{contents:s,overrides:w,keys:d}]),c},[])}}allKeys(){const c=new Set;return this.j.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.q.keys.forEach(h=>c.add(h)),this.r.forEach(h=>h.keys.forEach(s=>c.add(s))),[...c.values()]}B(){const c=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(s=>c.add(s))),[...c.values()]}D(c){const h=new Set;return this.j.getKeysForOverrideIdentifier(c).forEach(s=>h.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(s=>h.add(s)),this.q.getKeysForOverrideIdentifier(c).forEach(s=>h.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w))),[...h.values()]}static parse(c,h){const s=this.E(c.defaults,h),w=this.E(c.policy,h),d=this.E(c.application,h),D=this.E(c.user,h),b=this.E(c.workspace,h),E=c.folders.reduce((k,P)=>(k.set(S.URI.revive(P[0]),this.E(P[1],h)),k),new M.$Bc);return new n(s,w,d,D,v.createEmptyModel(h),b,E,v.createEmptyModel(h),new M.$Bc,h)}static E(c,h){return new v(c.contents,c.keys,c.overrides,void 0,h)}}e.$uo=n;function i(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const c=new Set,h=new Map;for(const w of g)w.keys.forEach(d=>c.add(d)),w.overrides.forEach(([d,D])=>{const b=(0,M.$yc)(h,d,new Set);D.forEach(E=>b.add(E))});const s=[];return h.forEach((w,d)=>s.push([d,[...w.values()]])),{keys:[...c.values()],overrides:s}}class r{constructor(c,h,s,w,d){this.change=c,this.f=h,this.g=s,this.h=w,this.i=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of c.keys)this.affectedKeys.add(D);for(const[,D]of c.overrides)for(const b of D)this.affectedKeys.add(b);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(c,h){const s=this.a+c,w=this.d.indexOf(s);if(w<0)return!1;const d=w+s.length;if(d>=this.d.length)return!1;const D=this.d.charCodeAt(d);if(D!==this.b&&D!==this.c)return!1;if(h){const b=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,E=this.g.getValue(c,h,this.h);return!p.$1n(b,E)}return!0}}e.$wo=r;function o(g,c){const{added:h,removed:s,updated:w}=t(c?.rawConfiguration,g?.rawConfiguration),d=[],D=g?.getAllOverrideIdentifiers()||[],b=c?.getAllOverrideIdentifiers()||[];if(c){const E=b.filter(k=>!D.includes(k));for(const k of E)d.push([k,c.getKeysForOverrideIdentifier(k)])}if(g){const E=D.filter(k=>!b.includes(k));for(const k of E)d.push([k,g.getKeysForOverrideIdentifier(k)])}if(c&&g){for(const E of D)if(b.includes(E)){const k=t({contents:g.getOverrideValue(void 0,E)||{},keys:g.getKeysForOverrideIdentifier(E)},{contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)});d.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:h,removed:s,updated:w,overrides:d}}function t(g,c){const h=g?c?g.keys.filter(d=>c.keys.indexOf(d)===-1):[...g.keys]:[],s=c?g?c.keys.filter(d=>g.keys.indexOf(d)===-1):[...c.keys]:[],w=[];if(g&&c){for(const d of c.keys)if(g.keys.indexOf(d)!==-1){const D=(0,A.$5i)(c.contents,d),b=(0,A.$5i)(g.contents,d);p.$1n(D,b)||w.push(d)}}return{added:h,removed:s,updated:w}}}),define(ke[265],Ee([1,0,21,4,3,82]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsb=e.$Jsb=e.$Isb=void 0,e.$Ksb=p;const M=(S,A,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const y=(0,u.$We)(u.$Ce.wrap(m));return[`GET ws://localhost${S}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Isb=M,e.$Jsb=u.$Ce.fromString(`\r
\r
`);async function p(S,A,C,m,y){S.write(u.$Ce.fromString((0,e.$Isb)(A,C,m)));const v=new L.$Tc;try{return await new Promise((l,f)=>{let a;v.add(S.onData(n=>{a?a=u.$Ce.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$Jsb);if(i===-1)return;l(S),S.pauseData();const r=a.slice(i+e.$Jsb.byteLength);r.byteLength&&y.onData.fire(r)})),v.add(S.onClose(n=>f(n??new Error("socket closed")))),v.add(S.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw S.dispose(),l}finally{v.dispose()}}class $ extends L.$Uc{constructor(A,C){super(),this.g=A,this.a=this.B(new N.$ee),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Lsb=$}),define(ke[66],Ee([1,0,13,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=S,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=R;class M{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends u.$bb{static isNotAvailable(C){return C instanceof $&&C._code===p.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===p.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===p.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===p.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=p.Unknown,y){super(C),this._message=C,this._code=m,this._detail=y,this.isHandled=m===p.NotAvailable&&y===!0,Object.setPrototypeOf(this,$.prototype)}}e.$El=$;function S(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}}),define(ke[266],Ee([1,0,8,21,22,13,4,3,15,59,40,30,82,66]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=D,e.$Ll=b,e.$Ml=k;const v=30*1e3;var l;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(_){const U=new L.$me;return setTimeout(()=>U.cancel(),_),U.token}function n(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ne=new L.$me;return _.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$jh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(_,U){const ne=new i(U);return ne.registerDisposable(_.onControlMessage($e=>{const Pe=JSON.parse($e.toString()),se=Y(Pe);se?ne.reject(se):ne.resolve(Pe)})),ne.promise}function o(_,U,ne,$e,Pe,se,re,oe){const G=new i(oe),ie=A.$0d.create(!1);return _.info(`Creating a socket (${re})...`),S.mark(`code/willCreateSocket/${se}`),U.connect(ne,$e,Pe,re).then(me=>{G.didTimeout?(S.mark(`code/didCreateSocketError/${se}`),_.info(`Creating a socket (${re}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):(S.mark(`code/didCreateSocketOK/${se}`),_.info(`Creating a socket (${re}) was successful after ${ie.elapsed()} ms.`),G.resolve(me))},me=>{S.mark(`code/didCreateSocketError/${se}`),_.info(`Creating a socket (${re}) returned an error after ${ie.elapsed()} ms.`),_.error(me),G.reject(me)}),G.promise}function t(_,U){const ne=new i(U);return _.then($e=>{ne.didTimeout||ne.resolve($e)},$e=>{ne.didTimeout||ne.reject($e)}),ne.promise}async function g(_,U,ne,$e){const Pe=we(_,U);_.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let se;try{se=await o(_.logService,_.remoteSocketFactoryService,_.connectTo,$.$Dg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,f(U),`renderer-${f(U)}-${_.reconnectionToken}`,$e)}catch(me){throw _.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),_.logService.error(me),me}_.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let re,oe;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(se,null),re=_.reconnectionProtocol,oe=!1):(re=new m.$ei({socket:se}),oe=!0),_.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,C.$Mg)()),$e),ie={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};re.sendControl(N.$Ce.fromString(JSON.stringify(ie)));try{const me=await r(re,n($e,a(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(_.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,me.signedData),$e)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(_.signService.sign(me.data),$e),fe={type:"connectionType",commit:_.commit,signedData:Ae,desiredConnectionType:U};return ne&&(fe.args=ne),_.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(N.$Ce.fromString(JSON.stringify(fe))),{protocol:re,ownsProtocol:oe}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(_.logService.error(`${Pe} the handshake timed out. Error:`),_.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${Pe} received error control message when negotiating connection. Error:`),_.logService.error(me)),oe&&x(re),me}}async function c(_,U,ne,$e){const Pe=Date.now(),se=we(_,U),{protocol:re,ownsProtocol:oe}=await g(_,U,ne,$e),G=new i($e);return G.registerDisposable(re.onControlMessage(ie=>{const me=JSON.parse(ie.toString()),pe=Y(me);pe?(_.logService.error(`${se} received error control message when negotiating connection. Error:`),_.logService.error(pe),oe&&x(re),G.reject(pe)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${Se(Pe)}!`),G.resolve({protocol:re,firstMessage:me}))})),G.promise}async function h(_,U){const{protocol:ne}=await c(_,1,void 0,U);return{protocol:ne}}async function s(_,U,ne){const{protocol:$e,firstMessage:Pe}=await c(_,2,U,ne),se=Pe&&Pe.debugPort;return{protocol:$e,debugPort:se}}async function w(_,U,ne){const $e=Date.now(),Pe=we(_,3),{protocol:se}=await g(_,3,U,ne);return _.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${Se($e)}!`),se}async function d(_,U,ne){const{connectTo:$e,connectionToken:Pe}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:$e,connectionToken:Pe,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function D(_,U,ne){return E(_,async $e=>{const{protocol:Pe}=await h($e,L.CancellationToken.None);return new W(_,U,ne,$e.reconnectionToken,Pe)})}async function b(_,U){return E(_,async ne=>{const{protocol:$e,debugPort:Pe}=await s(ne,U,L.CancellationToken.None);return new X(_,U,ne.reconnectionToken,$e,Pe)})}async function E(_,U){for(let $e=1;;$e++)try{const Pe=(0,C.$Mg)(),se=await d(_,Pe,null);return await U(se)}catch(Pe){if($e<5)_.logService.error(`[remote-connection][attempt ${$e}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(Pe);else throw _.logService.error(`[remote-connection][attempt ${$e}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(Pe),B.triggerPermanentFailure(0,0,y.$El.isHandled(Pe)),Pe}}async function k(_,U,ne){const $e=await d(_,(0,C.$Mg)(),null);return await w($e,{host:U,port:ne},L.CancellationToken.None)}function P(_){return(0,u.$dh)(U=>new Promise((ne,$e)=>{const Pe=setTimeout(ne,_*1e3);U.onCancellationRequested(()=>{clearTimeout(Pe),ne()})}))}var I;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class j{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$Nl=j;class F{constructor(U,ne,$e,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=$e,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=F;class z{constructor(U,ne,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.type=2}}e.$Pl=z;class O{constructor(U,ne,$e){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.type=4}}e.$Ql=O;class T{constructor(U,ne,$e,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=$e,this.handled=Pe,this.type=3}}e.$Rl=T;class B extends p.$Uc{static triggerPermanentFailure(U,ne,$e){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=$e,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ne,$e,Pe,se){super(),this.t=U,this.u=ne,this.reconnectionToken=$e,this.protocol=Pe,this.w=se,this.m=this.B(new M.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(re=>{const oe=te(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(re=>{const oe=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,p.$Sc)(()=>{const re=B.j.indexOf(this);re>=0&&B.j.splice(re,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let $e=-1;do{$e++;const Pe=$e<ne.length?ne[$e]:ne[ne.length-1];try{if(Pe>0){const re=P(Pe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,re)),this.u.logService.info(`${U} waiting for ${Pe} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$e+1)),this.u.logService.info(`${U} resolving connection...`);const se=await d(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,a(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$e+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}if($e>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}if(y.$El.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,R.$4)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof y.$El){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,y.$El.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),$e+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,$e){this.w?B.triggerPermanentFailure(U,ne,$e):this.D(U,ne,$e)}D(U,ne,$e){this.m.fire(new T(this.reconnectionToken,U,ne,$e)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=B;class W extends B{constructor(U,ne,$e,Pe,se){super(1,U,Pe,se,!0),this.client=this.B(new m.$ci(se,{remoteAuthority:ne,clientId:$e},U.ipcLogger))}async G(U,ne){await h(U,ne)}}e.$Tl=W;class X extends B{constructor(U,ne,$e,Pe,se){super(2,U,$e,Pe,!1),this.H=ne,this.debugPort=se}async G(U,ne){await s(U,this.H,ne)}}e.$Ul=X;function x(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function Y(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Z(_,U){for(;_.length<U;)_+=" ";return _}function ue(_,U){return`[remote-connection][${Z(f(_),13)}][${U.substr(0,5)}\u2026]`}function te(_,U,ne){return`${ue(_,U)}[${ne?"reconnect":"initial"}]`}function we(_,U){return`${te(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function Se(_){return`${Date.now()-_} ms`}}),define(ke[86],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=L,e.$Dm=R,e.$Em=M;function N($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function L($){if(!$)return;const S=$.indexOf("+");return S<0?$:$.substr(0,S)}function R($){const{host:S,port:A}=p($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:A}}function M($,S){let{host:A,port:C}=p($);return typeof C>"u"&&(C=S),{host:A,port:C}}function p($){const S=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const C=$.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:$,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=R,e.$Om=C,e.$Pm=m,e.$Qm=y,e.$Rm=v,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function R(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const n=typeof f=="string"?f:f.value,i=typeof a=="string"?a:a.value;return u.$tf(n,i)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Lm=$;class S{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const a of f)this.add(a)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$Mm=S;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,a){this.c.set($.toKey(f),a)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=A;function C(l){return m(l)}function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}function v(l,f){if(f){const a=`onResolveRemoteAuthority:${(0,L.$Cm)(f)}`;return!!l.activationEvents?.includes(a)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cG=e.$bG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const $ of M){const S=this.readActivationEvents($);S.length>0&&(p[N.$Lm.toKey($.identifier)]=S)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const $ in M.contributes){const S=this.a.get($);if(!S)continue;const A=M.contributes[$],C=Array.isArray(A)?A:[A];try{S(C,p)}catch(m){(0,u.$1)(m)}}return p}}e.$bG=L,e.$cG=new L}),define(ke[267],Ee([1,0,3,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,N.$qi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,p){return this.a[M]??=[],this.a[M].push(p),(0,u.$Sc)(()=>{const $=this.a[M]?.indexOf(p);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,p,$,S){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,p,$,S)}}e.$Hl=L}),define(ke[268],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(u.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$50b=u}),define(ke[110],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,u.$qi)(e.$Il)}),define(ke[141],Ee([1,0,268]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class N extends u.$50b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>le(["vsda"],R,M))}}e.$1cc=N}),define(ke[269],Ee([1,0,11,51,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function R($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,S,A,C,m,y,v,l,f){const a=Object.create(null);a["common.machineId"]=y,a["common.sqmId"]=v,a.sessionID=(0,L.$Mg)()+Date.now(),a.commitHash=C,a.version=m,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,u.$h)(u.$u),a["common.nodePlatform"]=N.$ec,a["common.nodeArch"]=A,a["common.product"]=f||"desktop",l&&(a["common.msftInternal"]=l);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(a["common.snap"]="true");const r=R(S);return r&&(a["common.platformDetail"]=r),a}function p($){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const A=S.toLowerCase();return $.some(C=>A===C)}}),define(ke[270],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,u.$qi)("telemetryService"),e.$Wl=(0,u.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,269,270]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=A,e.$hp=C,e.$ip=m,e.$jp=y,e.$kp=l,e.$lp=a,e.$mp=n,e.$np=o;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$_o=p;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=$,e.$bp=new $;class S{async publicLog(g,c,h){}async publicLogError(g,c,h){}}e.$cp=S,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function C(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function m(t){const g=t.getValue(M.$4l),c=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||c===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const g={},c={},h={};f(t,h);for(let s in h){s=s.length>150?s.substr(s.length-149):s;const w=h[s];typeof w=="number"?c[s]=w:typeof w=="boolean"?c[s]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${w.length}`),g[s]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(g[s]=w)}return{properties:g,measurements:c}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const g=(0,L.$Cm)(t);return v.has(g)?g:"other"}function f(t,g,c=0,h){if(t)for(const s of Object.getOwnPropertyNames(t)){const w=t[s],d=h?h+s:s;Array.isArray(w)?g[d]=(0,u.$2n)(w):w instanceof Date?g[d]=w.toISOString():(0,N.$6f)(w)?c<2?f(w,g,c+1,d+"."):g[d]=(0,u.$2n)(w):g[d]=w}}function a(t,g){const c=t.msftInternalDomains||[],h=g.getValue("telemetry.internalTesting");return(0,R.$$o)(c)||h}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const h=[];for(const D of g)for(;;){const b=D.exec(t);if(!b)break;h.push([b.index,D.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(c="";;){const D=w.exec(t);if(!D)break;const b=h.some(([E,k])=>D.index<k&&E<w.lastIndex);!s.test(D[0])&&!b&&(c+=t.substring(d,D.index)+"<REDACTED: user-file-path>",d=w.lastIndex)}return d<t.length&&(c+=t.substr(d)),c}function r(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of g)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function o(t,g){return(0,u.$Yn)(t,c=>{if(c instanceof p||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let h=c.replaceAll("%20"," ");h=i(h,g);for(const s of g)h=h.replace(s,"");return h=r(h),h}})}}),define(ke[271],Ee([1,0,14,137,25,11,2,13,51,87]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=A,e.$qp=v,e.$rp=l,e.$sp=f,e.$tp=a,e.$up=n,e.$vp=i,e.$wp=r,e.$yp=o,e.$zp=g;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,u.$of)(c.id,h.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(h){const s=h.manifest?h.manifest.version:h.version,w=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new m(h.identifier,s,w)}static parse(h){const s=C.exec(h);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(h,s,w="undefined"){this.version=s,this.targetPlatform=w,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof m?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$pp=m;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(c){const h=y.exec(c);return h&&h[1]?[f(h[1]),h[2]]:[f(c),void 0]}function l(c,h){return`${c}.${h}`}function f(c){return c.toLowerCase()}function a(c,h){return f(l(c??L.$Hm,h))}function n(c,h){const s=[],w=d=>{for(const D of s)if(D.some(b=>A(h(b),h(d))))return D;return null};for(const d of c){const D=w(d);D?D.push(d):s.push([d])}return s}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function r(c){return{id:new S.$_o(c.identifier.id),name:new S.$_o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$xp=new L.$Lm("pprice.better-merge");function o(c,h){const s=[],w=h.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const d=w.shift();if(d&&s.every(D=>!A(D.identifier,{id:d}))){const D=c.filter(b=>A(b.identifier,{id:d}));D.length===1&&(s.push(D[0]),w.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(c,h){if(!R.$k)return!1;let s;try{s=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){h.debug("Error while getting the os-release file.",(0,p.$0)(d))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(c,h){const s=await t(c,h),w=(0,N.$Vo)(s?"alpine":R.$u,$.$fc);return h.debug("ComputeTargetPlatform:",w),w}}),define(ke[272],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=u,e.$ds=N,e.$es=L,e.$fs=R,e.$gs=M,e.$hs=p;function u($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function L($){return new Map($)}function R($){return new Map($??[])}function M($){return Array.from($.entries()).map(S=>[S[0],u(S[1].map),N(S[1].descriptionMap)])}function p($){return new Map($.map(S=>[S[0],{map:L(S[1]),descriptionMap:R(S[2])}]))}}),define(ke[273],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sb=void 0;class u{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const p=R($=>{const S=typeof $=="string"?$:$.data;let A=this.a.get(L);if(A){A.data.push(S);return}const C=setTimeout(()=>this.flushBuffer(L),M);A={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),p.dispose()}},this.a.set(L,A)});return p}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$4sb=u}),define(ke[274],Ee([1,0,8,78,99,57,4,18,2,215,109,38]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.$4w=e.IconFontDefinition=e.IconContribution=e.$1w=void 0,e.$2w=f,e.$3w=a,e.$1w={IconContribution:"base.contributions.icons"};var m;(function(o){function t(g,c){let h=g.defaults;for(;R.ThemeIcon.isThemeIcon(h);){const s=l.getIcon(h.id);if(!s)return;h=s.defaults}return h}o.getDefinition=t})(m||(e.IconContribution=m={}));var y;(function(o){function t(c){return{weight:c.weight,style:c.style,src:c.src.map(h=>({format:h.format,location:h.location.toString()}))}}o.toJSONObject=t;function g(c){const h=s=>(0,p.$4f)(s)?s:void 0;if(c&&Array.isArray(c.src)&&c.src.every(s=>(0,p.$4f)(s.format)&&(0,p.$4f)(s.location)))return{weight:h(c.weight),style:h(c.style),src:c.src.map(s=>({format:s.format,location:$.URI.parse(s.location)}))}}o.fromJSONObject=g})(y||(e.IconFontDefinition=y={}));class v{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,c,h){const s=this.b[t];if(s){if(c&&!s.description){s.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return s}const w={id:t,description:c,defaults:g,deprecationMessage:h};this.b[t]=w;const d={$ref:"#/definitions/icons"};return h&&(d.deprecationMessage=h),c&&(d.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=d,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const c=this.f[t];return c||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(s,w)=>s.id.localeCompare(w.id),g=s=>{for(;R.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(s=>this.b[s]);for(const s of h.filter(w=>!!w.description).sort(t))c.push(`|<i class="${g(s)}"></i>|${s.id}|${R.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const s of h.filter(w=>!R.ThemeIcon.isThemeIcon(w.defaults)).sort(t))c.push(`|<i class="${g(s)}"></i>|${s.id}|`);return c.join(`
`)}}const l=new v;C.$9n.add(e.$1w.IconContribution,l);function f(o,t,g,c){return l.registerIcon(o,t,g,c)}function a(){return l}function n(){const o=(0,L.$Lj)();for(const t in o){const g="\\"+o[t].toString(16);l.registerIcon(t,{fontCharacter:g})}}n(),e.$4w="vscode://schemas/icons";const i=C.$9n.as(A.$0n.JSONContribution);i.registerSchema(e.$4w,l.getIconSchema());const r=new u.$Ch(()=>i.notifySchemaChanged(e.$4w),200);l.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$5w=f("widget-close",N.$Pj.close,(0,S.localize)(2,null)),e.$6w=f("goto-previous-location",N.$Pj.arrowUp,(0,S.localize)(3,null)),e.$7w=f("goto-next-location",N.$Pj.arrowDown,(0,S.localize)(4,null)),e.$8w=R.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$9w=R.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=S,e.$8v=C,e.$9v=m,e.$$v=y,e.$aw=v,e.$bw=l,e.$5v=(0,R.$qi)("tunnelService"),e.$6v=(0,R.$qi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function S(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function m(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const o=r.split("=")[1];if(/^https?:/.exec(o)){const t=C(N.URI.parse(o));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$_v.indexOf(n)>=0}function l(n,i,r,o){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class f{constructor(i,r,o){this.remoteAddress=i,this.localAddress=r,this.b=o,this.a=new u.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=f;let a=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$be,this.onTunnelOpened=this.a.event,this.b=new u.$be,this.onTunnelClosed=this.b.event,this.c=new u.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const o of r){const t=Array.from(o.values());for(const g of t){const c=await g.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,o,t,g){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:o,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||y(i))&&(i=e.$0v[0]);const o=this.s(i,r);if(o)return++o.refcount,o.value}openTunnel(i,r,o,t,g,c=!1,h,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${o} on local port ${g}.`);const w=this.f??i;if(!w)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(w,r,o,t,g,c,h,s);return d?d.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,o),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&D.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const o=r.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,r,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=o.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const o=this.e.get(i);if(o&&o.has(r)){const t=o.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:o})}async r(i,r){const o=this.e.get(i);if(o){const t=o.get(r),g=t?await t.value:void 0;(!g||typeof g=="string")&&o.delete(r),o.size===0&&this.e.delete(i)}}s(i,r){const o=[i];y(i)?(o.push(...e.$0v),o.push(...e.$_v)):v(i)&&o.push(...e.$_v);const t=o.map(g=>this.e.get(g));for(const g of t){const c=g?.get(r);if(c)return c}}canTunnel(i){return!!C(i)}u(i,r,o,t,g,c,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${o} on local port ${t}.`);const s=o;this.j.add(s);const w=t===void 0?o:t,d={elevationRequired:g?this.isPortPrivileged(w):!1},D={remoteAddress:{host:r,port:o},localAddressPort:t,privacy:c,public:c?c!==$.Private:void 0,protocol:h},b=i.forwardPort(D,d);return b?(this.q(r,o,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),b}};e.$dw=a,e.$dw=a=Je([qe(0,M.$Wj),qe(1,L.$Wi)],a)}),define(ke[275],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,u.$qi)("IUriIdentityService")}),define(ke[276],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,u.$qi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[277],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=L,e.$oM=R,e.$pM=M,e.$qM=p;function N($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function L($){if($.folders.length)return $.folders.every(S=>N(S.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function R($){return L($)?.scheme}function M($){return L($)?.authority}function p($){return L($)!==void 0}}),define(ke[42],Ee([1,0,217,17,77,23,2,5,15]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=S,e.$Bi=A,e.$Ei=C,e.$Fi=m,e.$Gi=y,e.$Hi=l,e.$Ii=f,e.$Li=i,e.$Qi=r,e.$Ri=o,e.$Ti=t,e.$Ui=g,e.$Vi=c,e.$zi=(0,p.$qi)("contextService");function S(h){const s=h;return typeof s?.id=="string"&&M.URI.isUri(s.uri)}function A(h){return typeof h?.id=="string"&&!S(h)&&!m(h)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function C(h,s){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,N.$oc)(h)}:s?e.$Ci:e.$Di;const w=h;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}function m(h){const s=h;return typeof s?.id=="string"&&M.URI.isUri(s.configPath)}function y(h){const s=h;if(s?.uri)return{id:s.id,uri:M.URI.revive(s.uri)};const w=h;if(w?.configPath)return{id:w.id,configPath:M.URI.revive(w.configPath)};if(h?.id)return{id:h.id}}var v;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function l(h){const s=h;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function f(h){const s=h;return!!(s&&typeof s=="object"&&M.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class a{constructor(s,w,d,D,b){this.h=s,this.j=d,this.k=D,this.l=b,this.c=L.$wi.forUris(this.l,()=>!0),this.folders=w}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=L.$wi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=a;class n{constructor(s,w){this.raw=w,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.$4g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function i(h){return new n({uri:h,index:0,name:(0,R.$Zg)(h)},{uri:h.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,u.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function r(h,s){return R.$Ug.isEqualOrParent(h,s.untitledWorkspacesHome)}function o(h){let s;return M.URI.isUri(h)?s=h:s=h.configuration,s?.scheme===$.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(h){return h.id===e.$Si}function g(h,s){return!r(h,s)&&!o(h)}function c(h){return(typeof h=="string"?(0,N.$pc)(h):(0,R.$2g)(h))===e.$Ni}}),define(ke[278],Ee([1,0,56,4,3,23,2,216,136,32,5,12,42,27,275,8,30,14,18]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=r,e.$xl=o,e.$yl=t;var i;(function(h){h.Settings="settings",h.Keybindings="keybindings",h.Snippets="snippets",h.Tasks="tasks",h.Extensions="extensions",h.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(h){const s=h;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&M.URI.isUri(s.location)&&M.URI.isUri(s.globalStorageHome)&&M.URI.isUri(s.settingsResource)&&M.URI.isUri(s.keybindingsResource)&&M.URI.isUri(s.tasksResource)&&M.URI.isUri(s.snippetsHome)&&M.URI.isUri(s.extensionsResource))}e.$wl=(0,A.$qi)("IUserDataProfilesService");function o(h,s){return{id:h.id,isDefault:h.isDefault,name:h.name,shortName:h.shortName,icon:h.icon,location:M.URI.revive(h.location).with({scheme:s}),globalStorageHome:M.URI.revive(h.globalStorageHome).with({scheme:s}),settingsResource:M.URI.revive(h.settingsResource).with({scheme:s}),keybindingsResource:M.URI.revive(h.keybindingsResource).with({scheme:s}),tasksResource:M.URI.revive(h.tasksResource).with({scheme:s}),snippetsHome:M.URI.revive(h.snippetsHome).with({scheme:s}),extensionsResource:M.URI.revive(h.extensionsResource).with({scheme:s}),cacheHome:M.URI.revive(h.cacheHome).with({scheme:s}),useDefaultFlags:h.useDefaultFlags,isTransient:h.isTransient}}function t(h,s,w,d,D,b){return{id:h,name:s,location:w,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:b&&D?.useDefaultFlags?.globalState?b.globalStorageHome:(0,R.$4g)(w,"globalStorage"),settingsResource:b&&D?.useDefaultFlags?.settings?b.settingsResource:(0,R.$4g)(w,"settings.json"),keybindingsResource:b&&D?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,R.$4g)(w,"keybindings.json"),tasksResource:b&&D?.useDefaultFlags?.tasks?b.tasksResource:(0,R.$4g)(w,"tasks.json"),snippetsHome:b&&D?.useDefaultFlags?.snippets?b.snippetsHome:(0,R.$4g)(w,"snippets"),extensionsResource:b&&D?.useDefaultFlags?.extensions?b.extensionsResource:(0,R.$4g)(w,"extensions.json"),cacheHome:(0,R.$4g)(d,h),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let g=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,w,d,D){super(),this.t=s,this.u=w,this.w=d,this.y=D,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),w=[s];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,n.$4f)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}w.push(t((0,R.$1g)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},s))}}catch(b){this.y.error(b)}const d=new y.$Bc,D=new Map;if(w.length)try{const b=this.Q();if(b.workspaces)for(const[E,k]of Object.entries(b.workspaces)){const P=M.URI.parse(E),I=w.find(j=>j.id===k);I&&d.set(P,I)}if(b.emptyWindows)for(const[E,k]of Object.entries(b.emptyWindows)){const P=w.find(I=>I.id===k);P&&D.set(E,P)}}catch(b){this.y.error(b)}this.z={profiles:w,workspaces:d,emptyWindows:D}}return this.z}D(){const s=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const w="Temp",d=new RegExp(`${(0,a.$8e)(w)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const k=d.exec(E.name),P=k?parseInt(k[1]):0;D=P>D?P:D}const b=`${w} ${D+1}`;return this.createProfile((0,u.$ej)((0,f.$Mg)()).toString(16),b,{transient:!0},s)}async createNamedProfile(s,w,d){return this.createProfile((0,u.$ej)((0,f.$Mg)()).toString(16),s,w,d)}async createProfile(s,w,d,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(s,w,d);return D&&await this.setProfileForWorkspace(D,b),b}async F(s,w,d){if(!(0,n.$4f)(w)||!w)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(w);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===w||P.id===s))throw new Error(`Profile with ${w} name already exists`);const E=t(s,w,(0,R.$4g)(this.profilesHome,s),this.g,d,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(P){k.push(P)}}),await l.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete(w)}})(),this.r.set(w,D)),D}async updateProfile(s,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(D=>D.id===s.id);if(!d)throw new Error(`Profile '${s.name}' does not exist`);return d=t(d.id,w.name??d.name,d.location,this.g,{shortName:w.shortName??d.shortName,icon:w.icon===null?void 0:w.icon??d.icon,transient:w.transient??d.isTransient,useDefaultFlags:w.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.I([],[],[d]),d}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const w=this.profiles.find(D=>D.id===s.id);if(!w)throw new Error(`Profile '${s.name}' does not exist`);const d=[];this.m.fire({profile:w,join(D){d.push(D)}});try{await Promise.allSettled(d)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])w.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])w.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[w],[]);try{await this.u.del(w.cacheHome,{recursive:!0})}catch(D){(0,S.$bl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(s,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(D=>D.id===w.id);if(!d)throw new Error(`Profile '${w.name}' does not exist`);this.L(s,d)}unsetWorkspace(s,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,w)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(w=>w.isDirectory&&this.profiles.every(d=>!this.w.extUri.isEqual(d.location,w.resource))).map(w=>this.u.del(w.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(w=>!this.H(w));await Promise.allSettled(s.map(w=>this.removeProfile(w)))}getProfileForWorkspace(s){const w=this.G(s);return M.URI.isUri(w)?this.s.workspaces.get(w)??this.C.workspaces.get(w):this.s.emptyWindows.get(w)??this.C.emptyWindows.get(w)}G(s){return(0,m.$Ai)(s)?s.uri:(0,m.$Fi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(w=>this.w.extUri.isEqual(w.location,s.location))||[...this.s.workspaces.values()].some(w=>this.w.extUri.isEqual(w.location,s.location))||[...this.C.emptyWindows.values()].some(w=>this.w.extUri.isEqual(w.location,s.location))||[...this.C.workspaces.values()].some(w=>this.w.extUri.isEqual(w.location,s.location)))}I(s,w,d){const D=[...this.profiles,...s],b=[];this.s.profiles=[];for(let E of D)E.isDefault||w.some(k=>E.id===k.id)||(E=d.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):b.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(b),this.z=void 0,this.J(s,w,d)}J(s,w,d){this.h.fire({added:s,removed:w,updated:d,all:this.profiles})}L(s,w,d){d=w?.isTransient?!0:d,d||this.L(s,void 0,!0);const D=this.G(s),b=d?this.s:this.C;M.URI.isUri(D)?(b.workspaces.delete(D),w&&b.workspaces.set(D,w)):(b.emptyWindows.delete(D),w&&b.emptyWindows.set(D,w)),d||this.M()}M(){const s={};for(const[d,D]of this.C.workspaces.entries())s[d.toString()]=D.id;const w={};for(const[d,D]of this.C.emptyWindows.entries())w[d.toString()]=D.id;this.R({workspaces:s,emptyWindows:w}),this.z=void 0}N(s){const w={},d=this.D();if(s.workspaces)for(const[b,E]of Object.entries(s.workspaces)){const k=M.URI.parse(E);w[b]=this.w.extUri.isEqual(k,d.location)?d.id:this.w.extUri.basename(k)}const D={};if(s.emptyWindows)for(const[b,E]of Object.entries(s.emptyWindows)){const k=M.URI.parse(E);D[b]=this.w.extUri.isEqual(k,d.location)?d.id:this.w.extUri.basename(k)}return{workspaces:w,emptyWindows:D}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$zl=g,e.$zl=g=Je([qe(0,$.$xi),qe(1,S.$Wk),qe(2,v.$ul),qe(3,C.$Wj)],g);class c extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Al=c}),define(ke[279],Ee([1,0,8,4,3,59,18,195,5,278]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=y,e.$Xp=l,e.$Zp=a,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,$.$qi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function y(n){const i=n.get(e.$Tp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new u.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,o){return N.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),o)}n(){this.j.value=(0,u.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:o,external:t}=r;if(o===e.$Tp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,r,o){return this.P(r)?.get(i,o)}getBoolean(i,r,o){return this.P(r)?.getBoolean(i,o)}getNumber(i,r,o){return this.P(r)?.getNumber(i,o)}getObject(i,r,o){return this.P(r)?.getObject(i,o)}storeAll(i,r){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,r)})}store(i,r,o,t,g=!1){if((0,M.$ag)(r)){this.remove(i,o,g);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,r,g)})}remove(i,r,o=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const o=[],t=this.J(i);for(const g of Object.keys(t))t[g]===r&&o.push(g);return o}z(i,r,o,t=!1){const g=this.J(r);typeof o=="number"?g[i]!==o&&(g[i]=o,this.P(r)?.set(e.$Tp,JSON.stringify(g),t)):typeof g[i]=="number"&&(delete g[i],this.P(r)?.set(e.$Tp,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?y(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Sp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,r,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,S.$vl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||l(r)&&l(i))}N(i,r,o){this.y(()=>{const t=new Set;for(const[g,c]of i)t.add(g),r.get(g)!==c&&this.u(o,{key:g,external:!0});for(const[g]of r.items)t.has(g)||this.u(o,{key:g,external:!0})})}}e.$Wp=v;function l(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class f extends v{constructor(){super(),this.U=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Yp=f;async function a(n,i,r,o,t,g){const c=P=>{try{return JSON.parse(P)}catch{return P}},h=new Map,s=new Map;n.forEach((P,I)=>{h.set(I,P),s.set(I,c(P))});const w=new Map,d=new Map;i.forEach((P,I)=>{w.set(I,P),d.set(I,c(P))});const D=new Map,b=new Map;r.forEach((P,I)=>{D.set(I,P),b.set(I,c(P))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const E=[];if(h.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];w.forEach((I,j)=>{P.push({key:j,value:I})}),console.table(P),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${g})`);const k=[];D.forEach((P,I)=>{k.push({key:I,value:P})}),console.table(k),console.groupEnd(),console.log(b)}}),define(ke[111],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;class u{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qkc=u}),define(ke[60],Ee([1,0,15,23,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$vkc=void 0;class R{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Sg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$vkc=R,e.$wkc=(0,L.$qi)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0,e.$sP=(0,u.$qi)("IExtHostInitDataService")}),define(ke[280],Ee([1,0,222,12,260,28]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;let M=class extends L.$AQ{constructor($,S,A){const C=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=A.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(S.createLogger(C,{name:m}))}};e.$Cmc=M,e.$Cmc=M=Je([qe(1,N.$Xj),qe(2,R.$sP)],M)}),define(ke[281],Ee([1,0,8]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0;class N{constructor(M,p,$){this.h=new Map,this.a=M,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new u.$Ch(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of S.values())A.complete()}catch(A){for(const C of S.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let $=this.f[M];return typeof $>"u"&&($=p),$}update(M,p){this.f[M]=p;const $=this.h.get(M);if($!==void 0)return $.p;const S=new u.$Nh;return this.h.set(M,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$blc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$clc=L}),define(ke[282],Ee([1,0,4,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class L{constructor(M){this.c=M,this.a=new u.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,$,S){const C=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,$,S);this.b.fire(C)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$3lc=L}),define(ke[20],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0,e.$cP=(0,u.$qi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$dP=N}),define(ke[283],Ee([1,0,25,4]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class L{#e;constructor(M,p){this.b=new N.$be,this.onDidChange=this.b.event,this.a=u.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$llc=L}),define(ke[67],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,u.$qi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Mkc=N}),define(ke[284],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$job=L,e.$kob=M;class N{constructor(){this.buffers=[]}add($){let S=this.buffers.indexOf($);return S<0&&(S=this.buffers.length,this.buffers.push($)),S}}function L(p,$){if($.serializeBuffersForPostMessage){const S=new N,C=JSON.stringify(p,(y,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const l=R(v);if(l)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:l,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),m=S.buffers.map(y=>{const v=new Uint8Array(y);return u.$Ce.wrap(v)});return{message:C,buffers:m}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,$){const S=$.map(m=>{const y=new ArrayBuffer(m.byteLength);return new Uint8Array(y).set(m.buffer),y}),A=$.length?(m,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:l}=v,f=S[l];if(v.view)switch(v.view.type){case 1:return new Int8Array(f,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return y}:void 0;return{message:JSON.parse(p,A),arrayBuffers:S}}}),define(ke[285],Ee([1,0,286,397,398,63,2,12,399]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=A;const S=!1;function A(i,r,o,t,g,c){const h=c.environment.useHostProxy,s=typeof h=="boolean"?h:!c.remote.isRemote,w={resolveProxy:b=>i.resolveProxy(b),lookupProxyAuthorization:f.bind(void 0,t,g,r,{},c.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(r),addCertificatesV2:()=>y(r),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case p.LogLevel.Trace:return $.LogLevel.Trace;case p.LogLevel.Debug:return $.LogLevel.Debug;case p.LogLevel.Info:return $.LogLevel.Info;case p.LogLevel.Warning:return $.LogLevel.Warning;case p.LogLevel.Error:return $.LogLevel.Error;case p.LogLevel.Off:return $.LogLevel.Off;default:return E(b)}function E(k){return t.error("Unknown log level",k),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const b=[];if(c.remote.isRemote&&b.push((0,$.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),b.push(E)}return(await Promise.all(b)).flat()},env:process.env},d=(0,$.createProxyResolver)(w),D=C(w,d);return l(o,D)}function C(i,r){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,r)),https:Object.assign(N,(0,$.createHttpPatch)(i,N,r)),net:Object.assign(R,(0,$.createNetPatch)(i,R)),tls:Object.assign(L,(0,$.createTlsPatch)(i,L))}}function m(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}function y(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}const v=new Map;function l(i,r){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,g=t._load;t._load=function(h,s,w){if(h==="net")return r.net;if(h==="tls")return r.tls;if(h!=="http"&&h!=="https")return g.apply(this,arguments);const d=o.findSubstr(M.URI.file(s.filename));let D=v.get(d);if(D||v.set(d,D={}),!D[h]){const b=r[h];D[h]={...b}}return D[h]}})}async function f(i,r,o,t,g,c,h,s){const w=t[c];h&&(t[c]=h),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${h}`,`proxyAuthenticateCache:${w}`);const d=h||w,D=Array.isArray(d)?d:typeof d=="string"?[d]:[];if(n(r,D,g),D.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const b=await new Promise((j,F)=>{le(["kerberos"],j,F)}),E=new URL(c),k=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${k}`),"Negotiate "+await(await b.initializeClient(k)).step("")}catch(b){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let a=!1;function n(i,r,o){a||!r.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[287],Ee([1,0,133]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new u.$sn(N(R))}}),define(ke[142],Ee([1,0,232,18,2,3,5,38,32,15,47,187,41]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$AF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$rF=e.EditorInputCapabilities=e.$qF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=void 0,e.$hF=l,e.$iF=f,e.$jF=a,e.$kF=n,e.$lF=i,e.$mF=r,e.$nF=o,e.$oF=t,e.$pF=g,e.$sF=D,e.$tF=E,e.$uF=k,e.$vF=P,e.$wF=I,e.$xF=j,e.$yF=F,e.$zF=X,e.$BF=Z,e.$CF=te,e.$DF=we,e.$EF=Se,e.$cF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$dF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$eF="workbench.editor.sidebysideEditor",e.$fF="workbench.editors.textDiffEditor",e.$gF="workbench.editors.binaryResourceDiffEditor";var y;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var v;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function l(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function f(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function a(_,U,ne){for(const $e of ne.visibleEditorPanes)if($e.group.id===U&&_.matches($e.input))return $e.getViewState()}function n(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.resource)}function i(_){if(D(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function r(_){if(D(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function o(_){if(D(_)||i(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(D(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function g(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var c;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var h;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class s{constructor(){this.a=new Map}registerSource(U,ne){let $e=this.a.get(U);return $e||($e={source:U,label:ne},this.a.set(U,$e)),$e.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$qF=new s;var w;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class d extends R.$Uc{}e.$rF=d;function D(_){return _ instanceof d}function b(_){const U=_;return L.URI.isUri(U?.preferredResource)}function E(_){const U=_;return D(U?.primary)&&D(U?.secondary)}function k(_){const U=_;return D(U?.modified)&&D(U?.original)}function P(_,U,ne,$e,Pe){return Se($e,[(0,C.$aj)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const se={...ne,limits:{size:Number.MAX_VALUE}};_.openEditor(U,se)}}),(0,C.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function I(_){return D(_?.editor)}function j(_){const U=_;return I(_)&&U?.group!==void 0}function F(_){const U=_;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ne){if(!U)return;if(g(U))return e.$AF.getOriginalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getOriginalUri(Pe,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||r(U)||o(U)||g(U))return;const $e=b(U)?U.preferredResource:U.resource;return!$e||!ne||!ne.filterByScheme?$e:this.b($e,ne.filterByScheme)}a(U){return E(U)||o(U)?{primary:U.primary,secondary:U.secondary}:k(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ne){if(!U)return;if(g(U))return e.$AF.getCanonicalUri(U.result,ne);if(ne?.supportSideBySide){const{primary:Pe,secondary:se}=this.a(U);if(Pe&&se){if(ne?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===T.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ne.filterByScheme});U=ne.supportSideBySide===T.PRIMARY?Pe:se}}if(i(U)||r(U)||o(U)||g(U))return;const $e=U.resource;return!$e||!ne||!ne.filterByScheme?$e:this.b($e,ne.filterByScheme)}b(U,ne){if(Array.isArray(ne)){if(ne.some($e=>U.scheme===$e))return U}else if(ne===U.scheme)return U}}var W;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(_,U,ne,$e){if(!_.isSticky(U))return!1;switch($e.preventPinnedEditorClose){case"keyboardAndMouse":return ne===W.MOUSE||ne===W.KEYBOARD;case"mouse":return ne===W.MOUSE;case"keyboard":return ne===W.KEYBOARD}return!1}e.$AF=new B;var x;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(U){const ne=this.a=U.get(M.$pi);for(const[$e,Pe]of this.c)this.e($e,Pe,ne);this.c.clear()}e(U,ne,$e){const Pe=$e.createInstance(ne);this.d.set(U,Pe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,ne){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ne,this.a):this.c.set(U,ne),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$9n.add(e.$cF.EditorFactory,new Y);async function Z(_,U,ne){return!_||!_.length?[]:await Promise.all(_.map(async $e=>{const Pe=L.URI.revive($e.fileUri);if(!Pe){ne.info("Cannot resolve the path because it is not valid.",$e);return}if(!await U.canHandleResource(Pe)){ne.info("Cannot resolve the path because it cannot be handled",$e);return}let re=$e.exists,oe=$e.type;if(typeof re!="boolean"||typeof oe!="number")try{oe=(await U.stat(Pe)).isDirectory?$.FileType.Directory:$.FileType.Unknown,re=!0}catch(ie){ne.error(ie),re=!1}if(!re&&$e.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",$e);return}if(oe===$.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",$e);return}const G={...$e.options,pinned:!0};return re?{resource:Pe,options:G}:{resource:Pe,options:G,forceUntitled:!0}}))}var ue;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function te(_){const U=_;if(!U)return!1;const ne=U;if(ne.modified)return te(ne.modified);const $e=U;return!!($e.contributionsState&&$e.viewState&&Array.isArray($e.cursorState))}function we(_){return(0,A.$cj)(_)}function Se(_,U,ne){const $e=(0,A.$dj)(_,U);return $e.forceMessage=ne?.forceMessage,$e.forceSeverity=ne?.forceSeverity,$e.allowDialog=ne?.allowDialog,$e}}),define(ke[288],Ee([1,0,4,233,5,3,27,38,19,24,78,274]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.$LF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$KF=e.ViewContentGroups=e.$IF=e.ViewContainerLocation=e.Extensions=e.$HF=e.$GF=e.$FF=void 0,e.$JF=v,e.$FF="views",e.$GF=(0,N.localize)(0,null),e.$HF=(0,C.$2w)("default-view-icon",A.$Pj.window,(0,N.localize)(1,null));var m;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var y;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$IF=[0,1,2];function v(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class l extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onDidRegister=this.c.event,this.f=this.B(new u.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(c,h,s){const w=this.get(c.id);if(w)return w;const d=c;return d.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$yc)(this.g,h,[]).push(d),s?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:h}),d}deregisterViewContainer(c){for(const h of this.g.keys()){const s=this.g.get(h),w=s?.indexOf(c);if(w!==-1){s?.splice(w,1),s.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(s=>s?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}p.$9n.add(m.ViewContainersRegistry,new l);var f;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(f||(e.ViewContentGroups=f={}));function a(g,c){const h=g.group??f.More,s=c.group??f.More;return h!==s?h.localeCompare(s):(g.order??5)-(c.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:s})=>this.r(h,s)),this.c.fire(c)}deregisterViews(c,h){const s=this.s(c,h);s.length&&this.f.fire({views:s,viewContainer:h})}moveViews(c,h){for(const s of this.m.keys())if(s!==h){const w=this.s(c,s);w.length&&(this.r(w,h),this.g.fire({views:w,from:s,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const s=(this.m.get(h)||[]).filter(w=>w.id===c)[0];if(s)return s}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(w=>w.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,R.$Sc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const s=new Map;for(const[w,d]of h)this.n.add(c,d),s.set(w,(0,R.$Sc)(()=>{this.n.delete(c,d),this.h.fire(c)}));return this.h.fire(c),s}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,s=>h.push(s)),h.sort(a)}r(c,h){let s=this.m.get(h);s||(s=[],this.m.set(h,s),this.j.push(h));for(const w of c){if(this.getView(w.id)!==null)throw new Error((0,N.localize)(2,null,w.id));s.push(w)}}s(c,h){const s=this.m.get(h);if(!s)return[];const w=[],d=[];for(const D of s)c.includes(D)?w.push(D):d.push(D);return w.length&&(d.length?this.m.set(h,d):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),w}}p.$9n.add(m.ViewsRegistry,new n),e.$KF=(0,L.$qi)("viewDescriptorService");var i;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class o{constructor(c,h){this.c=!1,this.d=!1,(0,S.$Zn)(this,c),this.d=!!h,this.resolve=async s=>{if(h&&!this.c){const w=await h(s);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$LF=o;class t extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$MF=t}),define(ke[289],Ee([1,0,234,37]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,u.localize)(0,null)}),e.$RF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,u.localize)(1,null)}),e.$SF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,u.localize)(2,null)}),e.$TF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,u.localize)(3,null)}),e.$UF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,u.localize)(4,null)}),e.$VF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,u.localize)(5,null)}),e.$WF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,u.localize)(6,null)}),e.$XF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,u.localize)(7,null)}),e.$YF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,u.localize)(8,null)}),e.$ZF=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,u.localize)(9,null)}),e.$1F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,u.localize)(10,null)}),e.$2F=new N.$Hj("chatIsEnabled",!1,{type:"boolean",description:(0,u.localize)(11,null)}),e.$3F=new N.$Hj("chatCursorAtTop",!1),e.$4F=new N.$Hj("chatInputHasAgent",!1),e.$5F=new N.$Hj("chatLocation",void 0)}),define(ke[290],Ee([1,0,4,39,3,37,5,289]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var $;(function(C){C.Panel="panel",C.Terminal="terminal",C.Notebook="notebook",C.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(C){function m(y){switch(y){case"panel":return C.Panel;case"terminal":return C.Terminal;case"notebook":return C.Notebook;case"editor":return C.Editor}return C.Panel}C.fromRaw=m}($||(e.ChatAgentLocation=$={})),e.$3G=(0,M.$qi)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor(m){this.f=m,this.b=[],this.d=new u.$be,this.onDidChangeAgents=this.d.event,this.e=p.$2F.bindTo(this.f)}registerAgent(m,y){if(this.getAgent(m))throw new Error(`Agent already registered: ${JSON.stringify(m)}`);const l=this,f=y.slashCommands;y={...y,get slashCommands(){return f.filter(n=>!n.when||l.f.contextMatchesRules(R.$oj.deserialize(n.when)))}};const a={data:y};return this.b.push(a),(0,L.$Sc)(()=>{this.b=this.b.filter(n=>n!==a),this.d.fire(void 0)})}registerAgentImplementation(m,y){const v=this.g(m);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(m)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(m)}`);return v.data.isDefault&&this.e.set(!0),v.impl=y,this.d.fire(new A(v.data,y)),(0,L.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(m,y){const v={data:m,impl:y};return this.b.push(v),this.d.fire(new A(m,y)),(0,L.$Sc)(()=>{this.b=this.b.filter(l=>l!==v),this.d.fire(void 0)})}updateAgent(m,y){const v=this.g(m);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(m)} registered`);v.data.metadata={...v.data.metadata,...y},this.d.fire(new A(v.data,v.impl))}getDefaultAgent(m){return this.getActivatedAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getContributedDefaultAgent(m){return this.getAgents().find(y=>!!y.isDefault&&y.locations.includes(m))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),m=>!!m.data.metadata.isSecondary)?.data}g(m){return this.b.find(y=>y.data.id===m)}getAgent(m){return this.g(m)?.data}getAgents(){return this.b.map(m=>m.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(m=>!!m.impl).map(m=>new A(m.data,m.impl))}getAgentsByName(m){return this.getAgents().filter(y=>y.name===m)}async invokeAgent(m,y,v,l,f){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return await a.impl.invoke(y,v,l,f)}async getFollowups(m,y,v,l,f){const a=this.g(m);if(!a?.impl)throw new Error(`No activated agent with id ${m}`);return a.impl?.provideFollowups?a.impl.provideFollowups(y,v,l,f):[]}};e.$4G=S,e.$4G=S=Je([qe(0,R.$Ij)],S);class A{constructor(m,y){this.b=m,this.d=y}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(m,y,v,l){return this.d.invoke(m,y,v,l)}async provideFollowups(m,y,v,l){return this.d.provideFollowups?this.d.provideFollowups(m,y,v,l):[]}provideWelcomeMessage(m,y){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(m,y)}provideSampleQuestions(m,y){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(m,y)}}e.$5G=A}),define(ke[291],Ee([1,0,2,29,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$0F=R,e.$$F=M;function R(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof u.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$kt.isIRange)}function M(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(R)}var p;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$_F=(0,L.$qi)("IChatService"),e.$aG="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,235]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new u.$be,this.o=new u.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,$,S,A){const C={command:p};if($&&Object.keys($).length>0&&(C.arguments=$),this.u("request",C),typeof A=="number"){const m=setTimeout(()=>{clearTimeout(m);const y=this.f.get(C.seq);if(y){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:p,message:(0,L.localize)(0,null,A,p)};y(v)}},A)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,$){return p.type!=="event"||$.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,S=this.f.get($.request_seq);S&&(this.f.delete($.request_seq),S($));break}}}}u(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,S)=>p.set(S,$)),await(0,N.$rh)(500),p.forEach(($,S)=>{$({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Qob=R}),define(ke[292],Ee([1,0,2,236,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=$,e.$hJ=A,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new L.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new L.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new L.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new L.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new L.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new L.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new L.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new L.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new L.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new L.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new L.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new L.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new L.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new L.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new L.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new L.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new L.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new L.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new L.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new L.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new L.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new L.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new L.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new L.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new L.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new L.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new L.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new L.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new L.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new L.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new L.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new L.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new L.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new L.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new L.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new L.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new L.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new L.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new L.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new L.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new L.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new L.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new L.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new L.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new L.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new L.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new L.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new L.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new L.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new L.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new L.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new L.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new L.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new L.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new L.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new L.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new L.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new L.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new L.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new L.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new L.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$gJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var m;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$iJ=(0,R.$qi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var l;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(l||(e.DebugVisualizationType=l={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:u.URI.revive(r.iconPath.light),dark:u.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(n||(e.IDebugVisualization=n={}))}),define(ke[293],Ee([1,0,14,2,17,24,15,29,22,19]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=C,e.$9G=m,e.$0G=y,e.$$G=v,e.$_G=l,e.$aH=f,e.$bH=a,e.$cH=i,e.$dH=t,e.$eH=g,e.$fH=h,e.$gH=w;const A=/{([^}]+)}/g;function C(D,b,E){return D.replace(A,function(k,P){return b&&P.length>0&&P[0]!=="_"?k:E&&E.hasOwnProperty(P)?E[P]:k})}function m(D){const b={};for(const E of Object.keys(D))E.startsWith("!")||(b[E]=D[E]);return b}function y(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||y(D.parentSession))}function v(D){let b=D.configuration.type;if(b)return b==="vslsShare"&&(b=D.configuration.adapterProxy.configuration.type),(0,u.$tf)(b,"extensionhost")||(0,u.$tf)(b,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function l(D){return D.type&&(D.label||D.program||D.runtime)}function f(D,b,E){let k,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=I.exec(D);){const F=j.index+1,z=F+j[0].length;if(F<=b&&z>=E){k=j[0],P=F;break}}if(k){const F=/\w+/g;let z=null;for(;(z=F.exec(k))&&!(z.index+1+P+z[0].length>=E););z&&(k=k.substring(0,F.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}async function a(D,b,E,k){if(D.evaluatableExpressionProvider.has(b)){const P=D.evaluatableExpressionProvider.ordered(b),I=(0,S.$Hb)(await Promise.all(P.map(async j=>{try{return await j.provideEvaluatableExpression(b,E,k??$.CancellationToken.None)}catch{return}})));if(I.length>0){let j=I[0].expression;const F=I[0].range;return j||(j=b.getLineContent(E.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:j}}}else{const P=b.getLineContent(E.lineNumber),{start:I,end:j}=f(P,E.column,E.column),F=P.substring(I-1,j);return{matchingExpression:F,range:new p.$kt(E.lineNumber,I,E.lineNumber,I+F.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,L.$jc)(D.path))return N.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const b=N.URI.revive(D.path);if(b)return b.scheme===M.Schemas.file?b.fsPath:b.toString()}return D.path}function t(D,b){const E=b?r:o,k=(0,R.$Wn)(D);return c(k,(P,I)=>{P&&I&&(I.path=E(I))}),k}function g(D,b){const E=b?r:o,k=(0,R.$Wn)(D);return c(k,(P,I)=>{!P&&I&&(I.path=E(I))}),k}function c(D,b){switch(D.type){case"event":{const E=D;switch(E.event){case"output":b(!1,E.body.source);break;case"loadedSource":b(!1,E.body.source);break;case"breakpoint":b(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=D;switch(E.command){case"setBreakpoints":b(!0,E.arguments.source);break;case"breakpointLocations":b(!0,E.arguments.source);break;case"source":b(!0,E.arguments.source);break;case"gotoTargets":b(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>b(!1,k));break;default:break}break}case"response":{const E=D;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>b(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>b(!1,k));break;case"scopes":E.body.scopes.forEach(k=>b(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>b(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>b(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function h(D){return D.filter(b=>!b.presentation?.hidden).sort((b,E)=>b.presentation?E.presentation?b.presentation.group?E.presentation.group?b.presentation.group!==E.presentation.group?b.presentation.group.localeCompare(E.presentation.group):s(b.presentation.order,E.presentation.order):-1:E.presentation.group?1:s(b.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function s(D,b){return typeof D!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:D-b}async function w(D,b){const E=D.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(E!=="none"&&(await b.saveAll(),E==="allEditorsInActiveGroup")){const k=b.activeEditorPane;k&&k.input.resource?.scheme===M.Schemas.untitled&&await b.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}const d=(D,b)=>!D||!b?D===b:D.name===b.name&&D.path===b.path&&D.sourceReference===b.sourceReference;e.$hH=d}),define(ke[294],Ee([1,0,53,63,24,17,11,14,31,237,143]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=e.$Kmc=e.$Jmc=e.$Imc=void 0;class C extends A.$Qob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(C.b);for(const o of r){const t=o.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$Imc=C;class m extends C{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Jmc=m;class y extends m{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$Kmc=y;class v extends m{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$Lmc=v;class l extends C{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(R.$jc(a)){if(!await $.Promises.exists(a))throw new Error(S.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.$Zn(L.$Wn(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const g=u.fork(n[0],n.slice(1),t);if(!g.pid)throw new Error(S.localize(2,null,n[0]));this.x=g}else throw new Error(S.localize(3,null));else{const o={env:r};i.cwd&&(o.cwd=i.cwd),this.x=u.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((a,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,o,t){if(r)return n(r)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=R.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(R.$jc(a.program)?i.program=a.program:i.program=R.$kc(n,a.program)),a.args&&(i.args=a.args);const r=a;return r.win&&(i.win=l.A(r.win,n)),r.winx86&&(i.winx86=l.A(r.winx86,n)),r.windows&&(i.windows=l.A(r.windows,n)),r.osx&&(i.osx=l.A(r.osx,n)),r.linux&&(i.linux=l.A(r.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const h of a)if(h.contributes){const s=h.contributes.debuggers;s&&s.length>0&&s.filter(w=>typeof w.type=="string"&&p.$tf(w.type,n)).forEach(w=>{const d=l.A(w,h.extensionLocation.fsPath);i=L.$Zn(i,d,h.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const o=r.program||i.program,t=r.args||i.args,g=r.runtime||i.runtime,c=r.runtimeArgs||i.runtimeArgs;if(g)return{type:"executable",command:g,args:(c||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Mmc=l}),define(ke[295],Ee([1,0,53,34,11]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=M,e.$Omc=$;function R(S,A){return new Promise((C,m)=>{let y="";const v=u.spawn(S,A);v.pid&&v.stdout.on("data",l=>{y+=l.toString()}),v.on("error",l=>{m(l)}),v.on("close",l=>{C(y)})})}async function M(S){if(S)if(L.$i){const A=await new Promise((C,m)=>{le(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{A.getProcessTree(S,m=>{C(!!m&&m.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(S)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var p;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(p||(p={}));function $(S,A,C,m,y){S=S.trim().toLowerCase();let v;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?v=1:S.indexOf("cmd.exe")>=0?v=0:S.indexOf("bash")>=0?v=2:L.$i?v=0:v=2;let l,f=" ";switch(v){case 1:if(l=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),m){const a=(0,N.$vg)(m);a&&(f+=`${a}:; `),f+=`cd ${l(m)}; `}if(y)for(const a in y){const n=y[a];n===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${n}'; `}if(A.length>0){const a=A.shift(),n=C?a:l(a);f+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)f+=i==="<"||i===">"||C?i:l(i),f+=" "}break;case 0:if(l=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),m){const a=(0,N.$vg)(m);a&&(f+=`${a}: && `),f+=`cd ${l(m)} && `}if(y){f+='cmd /C "';for(const a in y){let n=y[a];n===null?f+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),f+=`set "${a}=${n}" && `)}}for(const a of A)f+=a==="<"||a===">"||C?a:l(a),f+=" ";y&&(f+='"');break;case 2:{l=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(m&&(f+=`cd ${l(m)} ; `),y){f+="/usr/bin/env";for(const n in y){const i=y[n];i===null?f+=` -u ${a(n)}`:f+=` ${a(`${n}=${i}`)}`}f+=" "}for(const n of A)f+=n==="<"||n===">"||C?n:l(n),f+=" ";break}}return f}}),define(ke[296],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,u.$qi)("INotebookExecutionService")}),define(ke[297],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kib=e.$Jib=e.ProxyKernelState=e.$Iib=void 0,e.$Iib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Jib=(0,u.$qi)("INotebookKernelService"),e.$Kib=(0,u.$qi)("INotebookKernelHistoryService")}),define(ke[298],Ee([1,0,3,29,200,100]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zWb=void 0;class M extends u.$Uc{constructor($,S,A){super(),this._source=$,this.b=S,this.c=A,this.a=void 0}f($){const S=$.getLineCount();return new N.$kt(1,1,S,this.g($,S))}g($,S){if(S<1||S>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const $=new L.$LC;$.acceptChunk(this._source);const S=$.finish(!0),{textBuffer:A,disposable:C}=S.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const S=new L.$LC;S.acceptChunk($);const A=S.finish(!0),{textBuffer:C,disposable:m}=A.create(1);return this.B(m),C})),this.a}findInInputs($){const A=new R.$zC($,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs($){const A=new R.$zC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$zWb=M}),define(ke[68],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(R){R.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,p,$=M.parent){if(M._isRoot)return new L([p]);const S=[M.id];for(let A=$;A&&A.id!==p;A=A.parent)S.push(A.id);return S.push(p),new L(S.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new L(M.split("\0"))}static join(M,p){return new L([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:L.isChild(M,p)?2:L.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$DL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$EL=S;var A;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:L.$kt.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})(m||(e.ITestErrorMessage=m={}));const y=(O,T)=>`${T?"s":"e"}${O}`;e.$FL=y;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var l;(function(O){O.serialize=T=>T.type===0?m.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?m.deserialize(T,B):v.deserialize(T,B)})(l||(e.ITestMessage=l={}));var f;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(l.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>l.deserialize(T,W))})})(f||(e.ITestTaskState=f={}));const a="\0",n=(O,T)=>O+a+T;e.$GL=n;const i=O=>{const T=O.indexOf(a);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$HL=i;var r;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?L.$kt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var o;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:R.$BL.root(B.item.extId),expand:B.expand,item:r.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var g;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$kt.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(g||(e.ITestItemUpdate=g={}));const c=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$IL=c;var h;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>f.deserialize(T,W)),retired:!0})})(h||(e.TestResultItem=h={}));var s;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(s||(e.ICoverageCount=s={}));var w;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(w||(e.IFileCoverage=w={}));function d(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$jt.isIPosition(O.location)?N.$jt.lift(O.location):L.$kt.lift(O.location):void 0,O}e.$JL=3;var b;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(b||(e.DetailType=b={}));var E;(function(O){O.serialize=T=>T.type===0?P.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?P.deserialize(T):I.deserialize(T)})(E||(e.CoverageDetails=E={}));var k;(function(O){O.serialize=d,O.deserialize=D})(k||(e.IBranchCoverage=k={}));var P;(function(O){O.serialize=d,O.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(O){O.serialize=T=>({...d(T),branches:T.branches?.map(k.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(k.deserialize)})})(I||(e.IStatementCoverage=I={}));var j;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var F;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:g.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:g.serialize(T.item)}:T})(F||(e.TestsDiffOp=F={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const W of T)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(g.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(T,B){const W=R.$BL.parentId(T.item.extId)?.toString();let X;if(!W)X=this.w(T),this.g.add(X),this.f.set(T.item.extId,X);else if(this.f.has(W)){const x=this.f.get(W);x.children.add(T.item.extId),X=this.w(T,x),this.f.set(T.item.extId,X)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(X),T.expand===2&&this.h++,X}o(T,B){const W=this.f.get(T.extId);if(W)return T.expand!==void 0&&(W.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$IL)(W,T),B.update?.(W),W}p(T,B){const W=this.f.get(T);if(!W)return;const X=R.$BL.parentId(W.item.extId)?.toString();X?this.f.get(X).children.delete(W.item.extId):this.g.delete(W);const x=[[T]];for(;x.length;)for(const Y of x.pop()){const Z=this.f.get(Y);Z&&(x.push(Z.children),this.f.delete(Y),B.remove?.(Z,Z!==W),Z.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$KL=z}),define(ke[112],Ee([1,0,8,4,3,62,89,68]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const S=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),m=(n,i)=>{let r;for(const[o,t]of C)t(n[o],i[o])||(r?r[o]=i[o]:r={[o]:i[o]});return r};class y extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||r>o.expandLevels)&&(o.expandLevels=r),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,r-1):t.wait().then(()=>this.L(o,r-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,r-1)):this.L(o,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(p.$BL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const o of r.ops)this.w(i,o);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const o=p.$BL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let g=this.tree.get(o.toString());if(!g){g={fullId:o,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(i)}}),this.I(i,g,r);return}if(g.actual===i){this.H(i,g,r);return}if(g.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,r);const c=this.s.getChildren(g.actual),h=g.actual,s=m(this.s.toITestItem(h),this.s.toITestItem(i));this.s.getApiFor(h).listener=void 0,g.actual=i,g.resolveBarrier=void 0,g.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(i.tags,h.tags,o.toString()),delete s.tags),this.w(g,{op:4,update:s})),this.I(i,g,r);for(const[d,D]of c)this.s.getChildren(i).get(D.id)||this.O(p.$BL.joinToString(o,D.id));const w=g.expandLevels;w!==void 0&&queueMicrotask(()=>{g.expand===1&&(g.expandLevels=void 0,this.expand(o.toString(),w))}),this.y(g.actual.uri)}C(i,r,o){const t=new Set(r.map(g=>g.id));for(const g of i)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(g=>(0,M.$GL)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=g=>this.w(r,g),this.J(r)}I(i,r,o){this.H(i,r,o);for(const[t,g]of this.s.getChildren(i))this.z(g,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const o=[];for(const[t,g]of this.s.getChildren(i.actual)){const c=this.expand(p.$BL.joinToString(i.fullId,g.id),r);(0,u.$ch)(c)&&o.push(c)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const g=new u.$ph;return g.open(),g}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$ph,o=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(g){o(g)}return(0,u.$ch)(t)?t.catch(o).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[r];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,c]of this.s.getChildren(t.actual))o.push(this.tree.get(p.$BL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$5O=y;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$6O=v;class l extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7O=l;class f extends Error{constructor(i,r,o){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${o}".`)}}e.$8O=f;const a=(n,i,r)=>{let o=new Map;return{get size(){return o.size},forEach(t,g){for(const c of o.values())t.call(g,c,this)},[Symbol.iterator](){return o.entries()},replace(t){const g=new Map,c=new Set(o.keys()),h={op:5,ops:[]};for(const s of t){if(!(s instanceof r))throw new l(s.id);const w=i(s).controllerId;if(w!==n.controllerId)throw new f(s.id,w,n.controllerId);if(g.has(s.id))throw new v(s.id);g.set(s.id,s),c.delete(s.id),h.ops.push({op:0,item:s})}for(const s of c.keys())h.ops.push({op:3,id:s});n.listener?.(h),o=g},add(t){if(!(t instanceof r))throw new l(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$9O=a}),define(ke[144],Ee([1,0,112]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;const N=new WeakMap,L=(M,p)=>{const $={controllerId:p};return N.set(M,$),$};e.$0O=L;const R=M=>{const p=N.get(M);if(!p)throw new u.$7O(M?.id||"<unknown>");return p};e.$$O=R}),define(ke[113],Ee([1,0,15,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4xb=e.$3xb=e.$2xb=void 0,e.$5xb=L,e.$6xb=M,e.$2xb="vscode-cdn.net",e.$3xb=`vscode-resource.${e.$2xb}`,e.$4xb=`'self' https://*.${e.$2xb}`;function L(p,$){return p.scheme===u.Schemas.http||p.scheme===u.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===u.Schemas.file&&(p=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:p.path})),N.URI.from({scheme:u.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$3xb}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,$=>{const S=$.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?$:"-"+S.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,($,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[299],Ee([1,0,4,3,113]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class R{constructor(p,$,S){this.d=p,this.e=$,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,S,A,C){let m;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){m=i;break}if(!m)throw new Error("not a visible editor");const y=this,v=this.a++,l=new u.$be,f=new u.$be,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$5xb)(i,y.f)}get cspSource(){return L.$4xb}set options(i){this.b=i,y.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(i){return y.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=p,this.line=$,this.height=S,this.webview=a,this.onDidDispose=f.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),f.fire(),f.dispose(),l.dispose())}};return this.d.$createEditorInset(v,m.id,m.value.document.uri,$+1,S,A||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:p,inset:n,onDidReceiveMessage:l}),n}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$Jkc=R}),define(ke[145],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,u.$qi)("IAuthenticationService"),e.$TL=(0,u.$qi)("IAuthenticationExtensionsService")}),define(ke[300],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.VariableKind=e.$1P=void 0,e.$1P=(0,u.$qi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,p){super(p),this.variable=M}}e.$2P=L}),define(ke[301],Ee([1,0,17,51,18,24,11,103,240,300,14]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,v,l,f){this.h=new Map,this.a=y,this.b=v,this.g=l,f&&(this.c=f.then(a=>this.i(a)))}i(y){if(M.$i){const v=Object.create(null);return Object.keys(y).forEach(l=>{v[l.toLowerCase()]=y[l]}),v}return y}resolveWithEnvironment(y,v,l){return this.l({env:this.i(y),userHome:void 0},v?v.uri:void 0,l)}async resolveAsync(y,v){const l={env:await this.c,userHome:await this.g};return this.l(l,y?y.uri:void 0,v)}async j(y,v,l,f){const a=R.$Wn(v);M.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):M.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):M.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,a,l,f)}async resolveAnyAsync(y,v,l){return this.j(y,v,l)}async resolveAnyMap(y,v,l){const f=new Map;return{newConfig:await this.j(y,v,l,f),resolvedVariables:f}}resolveWithInteractionReplace(y,v,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,v)}async l(y,v,l,f,a){if(L.$4f(l))return this.m(y,v,l,f,a);if(Array.isArray(l))return Promise.all(l.map(n=>this.l(y,v,n,f,a)));if(L.$6f(l)){const n=Object.create(null),i=await Promise.all(Object.keys(l).map(async r=>[await this.m(y,v,r,f,a),await this.l(y,v,l[r],f,a)]));for(const[r,o]of i)n[r]=o;return n}return l}m(y,v,l,f,a){return(0,A.$lf)(l,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let r=await this.o(y,n,i,v,f);return a?.set(i,r),r!==n&&L.$4f(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(y,v,r,f,a)),r})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,v,l,f,a){let n;const i=l.split(":");i.length>1&&(l=i[0],n=i[1]);const r=g=>{const c=this.a.getFilePath();if(c)return(0,p.$ow)(c);throw new S.$2P(g,(0,$.localize)(0,null,v))},o=g=>{const c=r(g);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,p.$ow)(h)}throw new S.$2P(g,(0,$.localize)(1,null,v,u.$oc(c)))},t=g=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new S.$2P(g,(0,$.localize)(2,null,v,n))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new S.$2P(g,(0,$.localize)(3,null,v)):new S.$2P(g,(0,$.localize)(4,null,v))};switch(l){case"env":if(n){if(y.env){const g=y.env[M.$i?n.toLowerCase():n];if(L.$4f(g))return g}return""}throw new S.$2P(S.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const g=this.a.getConfigurationValue(f,n);if(L.$ag(g))throw new S.$2P(S.VariableKind.Config,(0,$.localize)(6,null,v,n));if(L.$6f(g))throw new S.$2P(S.VariableKind.Config,(0,$.localize)(7,null,v,n));return g}throw new S.$2P(S.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,a,"command");case"input":return this.p(S.VariableKind.Input,v,n,a,"input");case"extensionInstallFolder":if(n){const g=await this.a.getExtension(n);if(!g)throw new S.$2P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(g.extensionLocation)}throw new S.$2P(S.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,p.$ow)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return f||n?(0,p.$ow)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$ow)(u.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new S.$2P(S.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new S.$2P(S.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new S.$2P(S.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return r(S.VariableKind.File);case"fileWorkspaceFolder":return o(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(o(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||n?u.$mc(this.n(t(S.VariableKind.RelativeFile)),r(S.VariableKind.RelativeFile)):r(S.VariableKind.RelativeFile);case"relativeFileDirname":{const g=u.$nc(r(S.VariableKind.RelativeFileDirname));if(f||n){const c=u.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),g);return c.length===0?".":c}return g}case"fileDirname":return u.$nc(r(S.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(S.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=u.$oc(r(S.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-u.$pc(g).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(S.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||v}case"execInstallFolder":{const g=this.a.getAppRoot();return g||v}case"pathSeparator":case"/":return u.sep;default:try{const g=n?`${l}:${n}`:l;return this.p(S.VariableKind.Unknown,v,g,a,void 0)}catch{return v}}}}p(y,v,l,f,a){if(l&&f){const n=a===void 0?f[l]:f[a+":"+l];if(typeof n=="string")return n;throw new S.$2P(y,(0,$.localize)(14,null,v))}return v}}e.$eQ=C}),define(ke[146],Ee([1,0,5,142]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$HD=void 0,e.$ID=S,e.$JD=m,e.$KD=y,e.$HD=(0,u.$qi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function S(v){const l=v;return(0,N.$sF)(l?.editor)&&(0,N.$sF)(l?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(v){const l=v;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[302],Ee([1,0,5,146]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$PD=L,e.$LD=(0,u.$qi)("editorService"),e.$MD=-1,e.$ND=-2,e.$OD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$JD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,u.$ri)(N.$xi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=e.$7$b=e.$6$b=e.$5$b=e.$4$b=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$4$b=p;class ${static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const o=r.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(l),this.f=new u.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=f(this.e,i),this.e=this.e.concat(n);const r=$.l(this.e);return this.e=f(this.e,r.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,h){this.addNode(c),this.addNode(h),this.c.has(c)?this.c.get(c).push(h):this.c.set(c,[h])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,h){const s=i.getArcs(c);for(let w=0;w<s.length;w++)if(!h.has(s[w]))return!1;return!0}getNodes(){return this.e}},r=new u.$Nm;for(const c of n)if(r.set(c.identifier,c),c.extensionDependencies)for(const h of c.extensionDependencies)i.addArc(u.$Lm.toKey(c.identifier),u.$Lm.toKey(h));const o=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>o.add(c));const t=i.getNodes().filter(c=>!o.has(c));let g;do{g=!1;for(let c=0;c<t.length;c++){const h=t[c];i.hasOnlyGoodArcs(h,o)&&(t.splice(c,1),c--,o.add(h),g=!0)}}while(g);return t.map(c=>r.get(c))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$5$b=$;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$6$b=S;class A{constructor(n){this.d=new y,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$7$b=A;class C extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$8$b=C;class m{constructor(n){this.name=n;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new m(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(o))}}var v;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(v||(v={}));function l(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const o=L.$hc.basename(a.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function f(a,n){const i=new u.$Mm(n);return a.filter(r=>!i.has(r.identifier))}}),define(ke[303],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.ExtHostConnectionType=void 0,e.$hn=p,e.$in=$;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$en=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$fn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$gn=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function p(A,C){M(C),A.serialize(C)}function $(A){if(A[N.ENV_KEY])return S(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return S(A,new L);if(A[R.ENV_KEY])return S(A,new R);throw new Error("No connection information defined in environment!")}function S(A,C){return M(A),C}}),define(ke[114],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(S){const A=u.$Ce.alloc(1);switch(S){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function p(S,A){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,225]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$uP=e.$tP=void 0,e.$vP=l;let y=class extends C.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$ep,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const r=this.getTelemetryDetails(),o=new v(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Cm)((0,$.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(r):this.r.set(r,o)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const r=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(a.value),!1;let o=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$tP=y,e.$tP=y=Je([qe(0,R.$sP),qe(1,L.$Xj)],y);class v{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,r,o,t,g){this.g=i,this.h=r,this.i=o,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,$.$np)(n,[]),this.c&&(n=(0,S.$Zn)(n,this.c)),this.b||(n=(0,S.$Zn)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},r=(0,$.$np)(i,[]),o=new Error(r.message,{cause:r.cause});o.stack=r.stack,o.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$uP=v;function l(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$wP=(0,u.$qi)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,271,140,25,5]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.ActivationKind=e.$zG=e.$yG=e.$vG=e.ExtensionHostStartup=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$wG=m,e.$xG=y,e.$AG=a,e.$BG=n,e.$rG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$sG="extensions.webWorker",e.$tG=(0,p.$qi)("extensionService");class ${constructor(o){this.dependency=o}}e.$uG=$;var S;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,g){this.c=o,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$cG.createActivationEventsMap(this.d)}}set(o,t,g){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const c=[],h=[],s=[],w=[],d=C(this.d),D=C(t),b=(j,F)=>j.extensionLocation.toString()===F.extensionLocation.toString()||j.isBuiltin===F.isBuiltin||j.isUserBuiltin===F.isUserBuiltin||j.isUnderDevelopment===F.isUnderDevelopment;for(const j of this.d){const F=D.get(j.identifier);if(!F){c.push(j.identifier),d.delete(j.identifier);continue}if(!b(j,F)){c.push(j.identifier),d.delete(j.identifier);continue}}for(const j of t){const F=d.get(j.identifier);if(!F){h.push(j);continue}if(!b(F,j)){c.push(F.identifier),d.delete(F.identifier);continue}}const E=new M.$Mm(this.e),k=new M.$Mm(g);for(const j of this.e)k.has(j)||s.push(j);for(const j of g)E.has(j)||w.push(j);const P=R.$cG.createActivationEventsMap(h),I={versionId:o,toRemove:c,toAdd:h,addActivationEvents:P,myToRemove:s,myToAdd:w};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:c,myToAdd:h}=o,s=new M.$Mm(t),w=new M.$Mm(c);for(let d=0;d<this.d.length;d++)s.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)w.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of g)this.d.push(d);for(const d of h)this.e.push(d);return this.f=null,o}containsExtension(o){for(const t of this.e)if(M.$Lm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=R.$cG.readActivationEvents(t);for(const c of g)o.add(c)}return o}}e.$vG=A;function C(r){const o=new M.$Nm;for(const t of r)o.set(t.identifier,t);return o}function m(r,o){return r.enabledApiProposals?r.enabledApiProposals.includes(o):!1}function y(r,o){if(!m(r,o))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(o,t,g,c){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=c}}e.$yG=v;class l{constructor(o,t){this.description=o,this.value=t}}e.$zG=l;var f;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$tp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,o){return{identifier:new M.$Lm((0,L.$rp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!o,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$CG=i}),define(ke[304],Ee([1,0,13,148,25,26,12,8]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=e.$9kc=e.$8kc=e.$7kc=e.$6kc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,n,i,r){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$6kc=$;class S{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7kc=S;class A{constructor(a,n,i,r,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=o,this.subscriptions=t}}e.$8kc=A;class C extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9kc=C;class m extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0kc=m;class y extends A{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(a,n,i,r){this.g=r,this.a=a,this.b=n,this.c=i,this.d=new L.$Nm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new y(o));return this.c.onExtensionActivationError(a.id,o,new R.$uG(a.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of r){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const g=this.a.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;i.push(this.j({id:g.identifier,reason:a.reason}));continue}const c=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${o}'`),s=this.k(a,n.displayName,[],new y(h));return this.c.onExtensionActivationError(n.identifier,h,new R.$uG(o)),s}return this.k(a,n.displayName,i,null)}k(a,n,i,r){const o=new l(a.id,n,a.reason,i,r,this.c,this.g);return this.d.set(a.id,o),o}l(a){return N.$5$b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$$kc=v,e.$$kc=v=Je([qe(3,M.$Wj)],v);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,r,o,t,g){this.c=a,this.d=n,this.f=i,this.g=r,this.h=o,this.j=t,this.k=g,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new y(n),this.b&&u.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};l=Je([qe(6,M.$Wj)],l)}),define(ke[305],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[306],Ee([1,0,242,13,41,137,109,38,25,305,139,140]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=void 0;const m=p.$9n.as(M.$0n.JSONContribution);class y{constructor(o,t,g){this.a=o,this.b=t,this.c=g}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(L.default.Error,o)}warn(o){this.d(L.default.Warning,o)}info(o){this.d(L.default.Info,o)}}e.$lG=y;class v{static a(o){const t=new $.$Mm;for(let g=0,c=o.length;g<c;g++)t.add(o[g].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new v(t,[]);if(!t||!t.length)return new v([],o);const g=this.a(o),c=this.a(t),h=t.filter(w=>!g.has(w.description.identifier)),s=o.filter(w=>!c.has(w.description.identifier));return new v(h,s)}constructor(o,t){this.added=o,this.removed=t}}e.$mG=v;class l{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=v.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$nG=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$oG={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Km},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionKind:{description:u.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new l(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$cG.register(o.extensionPoint,o.activationEventsGenerator),e.$oG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,m.registerSchema(a,e.$oG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$pG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(i.ExtensionsRegistry,new n),e.$qG=p.$9n.as(i.ExtensionsRegistry),m.registerSchema(a,e.$oG),m.registerSchema(A.$ek,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[307],Ee([1,0,238,18,24,306,37,4]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var S;(function(m){function y(v,l,f){if(!v)return;const a=N.$4f(v.type)?v.type:void 0;if(!a||a.length===0){f.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$4f(i)&&n.push(i);return{extensionId:l.value,taskType:a,required:n,properties:v.properties?L.$Wn(v.properties):{},when:v.when?M.$oj.deserialize(v.when):void 0}}m.from=y})(S||(S={}));const A=R.$qG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,y)=>{for(const v of m)v.type&&y.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{A.setHandler((l,f)=>{this.c=void 0;try{for(const a of f.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of f.added){const n=a.value;for(const i of n){const r=S.from(i,a.description.identifier,a.collector);r&&(this.a[r.taskType]=r)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const l={type:"object",additionalProperties:!1};v.required.length>0&&(l.required=v.required.slice(0)),v.properties!==void 0?l.properties=L.$Wn(v.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[v.taskType]},y.push(l)}this.c={oneOf:y}}return this.c}}e.$UH=new C}),define(ke[308],Ee([1,0,239,18,23,24,37,307]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,u.localize(0,null)),e.$XH=u.localize2(2,"Tasks");var $;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$YH="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}($||(e.ShellQuoting=$={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(A||(e.RevealKind=A={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(C||(e.RevealProblemKind=C={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m||(e.PanelKind=m={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}(m||(e.PanelKind=m={}));var y;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var l;(function(O){function T(B){return N.$4f(B)?B:B.value}O.value=T})(l||(e.CommandString=l={}));var f;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=T;function B(W){if(W!==void 0)return N.$4f(W)?T(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(f||(e.TaskGroup=f={}));var a;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var o;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(T,B,W,X,x,Y){this._label="",this._id=T,B&&(this._label=B),W&&(this.type=W),this.runOptions=X,this.configurationProperties=x,this._source=Y}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$4f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$ZH=t;class g extends t{constructor(T,B,W,X,x,Y,Z,ue){super(T,W,void 0,Z,ue,B),this.command={},this._source=B,this.hasDefinedMatchers=Y,x&&(this.command=x)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof g}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new g(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$1H=g;class c extends t{constructor(T,B,W,X,x,Y,Z){super(T,W,X,Y,Z,B),this._source=B,this.configures=x}static is(T){return T instanceof c}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}}e.$2H=c;class h extends t{constructor(T,B,W,X,x,Y,Z,ue,te){super(T,W,X,ue,te,B),this.defines=x,this.hasDefinedMatchers=Z,this.command=Y,this.icon=te.icon,this.hide=te.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof h}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new h(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$3H=h;class s extends t{constructor(T,B,W,X,x,Y){super(T,W,X,x,Y,B),this._source=B}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new s(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$4H=s;var w;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(w||(e.ExecutionEngine=w={})),function(O){O._default=O.Terminal}(w||(e.ExecutionEngine=w={}));var d;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const W=T.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(W&&X){let x=this.c.get(W.uri.toString());x=x===void 0?0:x+1;let Y=this.c.get(X.uri.toString());return Y=Y===void 0?0:Y+1,x===Y?T._label.localeCompare(B._label):x-Y}else return!W&&X?-1:W&&!X?1:0}}e.$5H=D;var b;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(b||(e.TaskEventKind=b={}));var E;(function(O){O.SingleRun="singleRun",O.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(O){function T(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function B(ue,te,we){return{...T(ue),kind:"start",terminalId:te,resolvedVariables:we}}O.start=B;function W(ue,te,we){return{...T(ue),kind:"processStarted",terminalId:te,processId:we}}O.processStarted=W;function X(ue,te,we){return{...T(ue),kind:"processEnded",terminalId:te,exitCode:we}}O.processEnded=X;function x(ue,te,we){return{...T(ue),kind:"terminated",exitReason:we,terminalId:te}}O.terminated=x;function Y(ue,te,we){return{...T(te),kind:ue,terminalId:we}}O.general=Y;function Z(){return{kind:"changed"}}O.changed=Z})(P||(e.TaskEvent=P={}));var I;(function(O){function T(W){const X=Object.keys(W).sort();let x="";for(const Y of X){let Z=W[Y];Z instanceof Object?Z=T(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),x+=Y+","+Z+","}return x}function B(W){const x={_key:T(W),type:W.taskType};return Object.assign(x,W),x}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var j;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var F;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var z;(function(O){function T(B,W){const X=p.$UH.get(B.type);if(X===void 0){const ue=R.$Wn(B);return delete ue._key,I.create(ue)}const x=Object.create(null);x.type=X.taskType;const Y=new Set;X.required.forEach(ue=>Y.add(ue));const Z=X.properties;for(const ue of Object.keys(Z)){const te=B[ue];if(te!=null)x[ue]=te;else if(Y.has(ue)){const we=Z[ue];if(we.default!==void 0)x[ue]=R.$Wn(we.default);else switch(we.type){case"boolean":x[ue]=!1;break;case"number":case"integer":x[ue]=0;break;case"string":x[ue]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),ue));return}}}return I.create(x)}O.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[309],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$9$b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$0$b=L}),define(ke[48],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$iw=void 0,e.$jw=L,e.$kw=R;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$iw=u;const N=[];function L(p){const $=new u(p);return N[$.nid]=$,$}function R(p){return N[p].sid}class M{constructor($){this.value=$}}e.$lw=M}),define(ke[6],Ee([1,0,48]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput",l[l.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var S;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var A;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$OM=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var y;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var v;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$PM={MainThreadAuthentication:(0,u.$jw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$jw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$jw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$jw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$jw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$jw)("MainThreadClipboard"),MainThreadCommands:(0,u.$jw)("MainThreadCommands"),MainThreadComments:(0,u.$jw)("MainThreadComments"),MainThreadConfiguration:(0,u.$jw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$jw)("MainThreadConsole"),MainThreadDebugService:(0,u.$jw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$jw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$jw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$jw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$jw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$jw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$jw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$jw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$jw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$jw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$jw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$jw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$jw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$jw)("MainThreadLanguages"),MainThreadLogger:(0,u.$jw)("MainThreadLogger"),MainThreadMessageService:(0,u.$jw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$jw)("MainThreadOutputService"),MainThreadProgress:(0,u.$jw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$jw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$jw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$jw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$jw)("MainThreadSecretState"),MainThreadStorage:(0,u.$jw)("MainThreadStorage"),MainThreadSpeech:(0,u.$jw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$jw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$jw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$jw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$jw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$jw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$jw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$jw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$jw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$jw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$jw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$jw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$jw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$jw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$jw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$jw)("MainThreadSCM"),MainThreadSearch:(0,u.$jw)("MainThreadSearch"),MainThreadShare:(0,u.$jw)("MainThreadShare"),MainThreadTask:(0,u.$jw)("MainThreadTask"),MainThreadWindow:(0,u.$jw)("MainThreadWindow"),MainThreadLabelService:(0,u.$jw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$jw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$jw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$jw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$jw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$jw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$jw)("MainThreadInteractive"),MainThreadInlineChat:(0,u.$jw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$jw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$jw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$jw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$jw)("MainThreadTimeline"),MainThreadTesting:(0,u.$jw)("MainThreadTesting"),MainThreadLocalization:(0,u.$jw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$jw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$jw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,u.$jw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$jw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$jw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$jw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$jw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$jw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$jw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$jw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$jw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$jw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$jw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$jw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$jw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$jw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$jw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$jw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$jw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$jw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$jw)("ExtHostStatusBar"),ExtHostShare:(0,u.$jw)("ExtHostShare"),ExtHostExtensionService:(0,u.$jw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$jw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$jw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$jw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$jw)("ExtHostSCM"),ExtHostSearch:(0,u.$jw)("ExtHostSearch"),ExtHostTask:(0,u.$jw)("ExtHostTask"),ExtHostWorkspace:(0,u.$jw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$jw)("ExtHostWindow"),ExtHostWebviews:(0,u.$jw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$jw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$jw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$jw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$jw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$jw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$jw)("ExtHostProgress"),ExtHostComments:(0,u.$jw)("ExtHostComments"),ExtHostSecretState:(0,u.$jw)("ExtHostSecretState"),ExtHostStorage:(0,u.$jw)("ExtHostStorage"),ExtHostUrls:(0,u.$jw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$jw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$jw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$jw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$jw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$jw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$jw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$jw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$jw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$jw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$jw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$jw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$jw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,u.$jw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$jw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$jw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$jw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$jw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$jw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$jw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$jw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$jw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$jw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$jw)("ExtHostTimeline"),ExtHostTesting:(0,u.$jw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$jw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$jw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=e.$tkc=e.$skc=void 0,e.$skc=(0,u.$qi)("IExtHostApiDeprecationService");let M=class{constructor($,S){this.c=S,this.a=new Set,this.b=$.getProxy(L.$PM.MainThreadTelemetry)}report($,S,A){const C=this.d($,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:$}))}d($,S){return`${$}-${S.identifier.value}`}};e.$tkc=M,e.$tkc=M=Je([qe(0,R.$cP),qe(1,N.$Wj)],M),e.$ukc=Object.freeze(new class{report(p,$,S){}})}),define(ke[310],Ee([1,0,6]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;class N{constructor(R){const M=R.getProxy(u.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$Hkc=N}),define(ke[311],Ee([1,0,24,6,28,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;let M=class{constructor(A,C){this.a=A.getProxy(N.$PM.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const m=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){m.e(A,C,y,arguments)}})}e(A,C,m,y){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(y,this.b)}),this.c&&this.f(A,m,y)}};e.$Bmc=M,e.$Bmc=M=Je([qe(0,R.$cP),qe(1,L.$sP)],M);const p=1e5;function $(S,A){const C=[];if(S.length)for(let m=0;m<S.length;m++){let y=S[m];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}C.push(y)}if(A){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,u.$2n)(C);return m.length>p?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[312],Ee([1,0,2,6,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class R{constructor(p){this.a=p.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,L.$xG)(p,"showLocal"),this.a.$showOpenDialog($).then(S=>S?S.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?u.URI.revive($):void 0)}}e.$Elc=R}),define(ke[313],Ee([1,0,3,6]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Ylc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;let A=class{constructor(m,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(p.$PM.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===u.$g}getMessage(m,y){const{message:v,args:l,comment:f}=y;if(this.c)return(0,N.$5e)(v,l??{});let a=v;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const n=this.d.get(m)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$5e)(n??v,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let y;const v=await this.g(m);if(!v){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(v),f=JSON.parse(l);y=m.isBuiltin?f.contents?.bundle:f}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${v}: ${l.message}`);return}y&&this.d.set(m.identifier.value,{contents:y,uri:v})}async g(m){if(m.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return L.URI.revive(y)}return m.l10n?L.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mlc=A,e.$mlc=A=Je([qe(0,$.$sP),qe(1,S.$cP),qe(2,M.$Wj)],A),e.$nlc=(0,R.$qi)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;let $=class extends u.$8j{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(y=>(0,p.$Zh)(y))),this.r=C.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(M.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,y){return new S(this.r,C,m,y)}};e.$Amc=$,e.$Amc=$=Je([qe(0,R.$cP),qe(1,L.$sP)],$);class S extends u.$3j{constructor(C,m,y,v){super(v?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(m,v).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const y=[[C,m]];this.m?this.u(y):this.n.push(...y)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0,e.$olc=(0,N.$qi)("IExtHostManagedSockets");let p=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(u.$PM.MainThreadManagedSockets)}setFactory(C,m){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,y=await this.c.makeConnection(),v=new L.$Tc;return this.d.set(m,new S(m,y,v)),v.add((0,L.$Sc)(()=>this.d.delete(m))),v.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),v.dispose()})),v.add(y.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),v.dispose()})),v.add(y.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,M.$Ce.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$plc=p,e.$plc=p=Je([qe(0,R.$cP)],p);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class S extends L.$Uc{constructor(C,m,y){super(),this.socketId=C,this.actual=m,this.B(y)}}}),define(ke[314],Ee([1,0,6,12,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;function R(p){return p&&p.title}let M=class{constructor($,S){this.b=S,this.a=$.getProxy(u.$PM.MainThreadMessageService)}showMessage($,S,A,C,m){const y={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof C=="string"||R(C)?v=[C,...m]:(y.modal=C?.modal,y.useCustom=C?.useCustom,y.detail=C?.detail,v=m),y.useCustom&&(0,L.$xG)($,"resolvers");const l=[];let f=!1;for(let a=0;a<v.length;a++){const n=v[a];if(typeof n=="string")l.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;l.push({title:i,isCloseAffordance:!!r,handle:a}),r&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,A,y,l).then(a=>{if(typeof a=="number")return v[a]})}};e.$1lc=M,e.$1lc=M=Je([qe(1,N.$Wj)],M)}),define(ke[315],Ee([1,0,3,18,2,26,6]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class p{constructor(S){this.b=new Map,this.a=S.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,A,C){if((0,R.$xG)(S,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,S.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(S,A,C,m){const y=this.b.get(S);if(!y)throw new Error(`Unknown handler with id: ${S}`);return y.saveProfile(A,C,m)}async $readProfile(S,A,C){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.readProfile((0,N.$4f)(A)?A:L.URI.revive(A),C)}}e.$0lc=p}),define(ke[117],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0;class R{constructor(p){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(u.$PM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,S){return this.a.$setPassword(p,$,S)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$jlc=R,e.$klc=(0,L.$qi)("IExtHostSecretState")}),define(ke[316],Ee([1,0,22,3,6]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class R{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(L.$PM.MainThreadSpeech)}async $createSpeechToTextSession(p,$,S){const A=this.c.get(p);if(!A)return;const C=new N.$Tc,m=new u.$me;this.d.set($,m);const y=C.add(A.provideSpeechToTextSession(m.token,S?{language:S}:void 0));C.add(y.onDidChange(v=>{m.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),C.add(m.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,$){const S=this.c.get(p);if(!S)return;const A=new N.$Tc,C=new u.$me;this.d.set($,C);const m=A.add(S.provideKeywordRecognitionSession(C.token));A.add(m.onDidChange(y=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,y)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,S){const A=R.a++;return this.c.set(A,S),this.b.$registerProvider(A,$,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$emc=R}),define(ke[118],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;class R{constructor(p,$){this.c=$,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(u.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,S){const A=await this.a.$initializeExtensionStorage(p,$);let C;return A&&(C=this.d(p,$,A)),C||S}setValue(p,$,S){return this.a.$setValue(p,$,S)}$acceptValue(p,$,S){const A=this.d(p,$,S);A&&this.b.fire({shared:p,key:$,value:A})}d(p,$,S){try{return JSON.parse(S)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${A}`)}}}e.$_kc=R,e.$alc=(0,L.$qi)("IExtHostStorage")}),define(ke[317],Ee([1,0,3,15,2,6]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$PM.MainThreadUriOpeners)}registerExternalUriOpener($,S,A,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const m=C.schemes.find(y=>!M.a.has(y));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(S,A),this.b.$registerUriOpener(S,C.schemes,$,C.label),(0,u.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri($,S,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=L.URI.revive(S);return C.canOpenExternalUri(m,A)}async $openUri($,S,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},A)}}e.$umc=M}),define(ke[318],Ee([1,0,6,2,3,13,25]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class p{static{this.a=0}constructor(S){this.c=new M.$Mm,this.d=new Map,this.b=S.getProxy(u.$PM.MainThreadUrls)}registerUriHandler(S,A){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=p.a++;return this.c.add(C),this.d.set(m,A),this.b.$registerUriHandler(m,C,S.displayName||S.name),(0,L.$Sc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(S,A){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(A))}catch(m){(0,R.$1)(m)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$vmc=p}),define(ke[92],Ee([1,0,4,3,15,24,2,246,284,113,6]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Wkc=void 0,e.$Xkc=m,e.$Zkc=l,e.$1kc=f;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,o,t,g,c,h,s){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$be,this._onDidDispose=this.#h.event,this.#e=r,this.#t=o,this.#o=t,this.#n=g,this.#s=c,this.#r=h,this.#l=m(h),this.#d=y(h),this.#i=s}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,S.$5xb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let o=r.toString();return o.endsWith("/")||(o+="/"),o+" "+S.$4xb}return S.$4xb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),R.$1n(this.#o,r)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const o=(0,$.$job)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,c,h,s,w,d)=>{const D=M.URI.from({scheme:s||"file",path:decodeURIComponent(w)}),b=(0,S.$5xb)(D,{isRemote:o,authority:t}).toString();return`${c}${b}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,c,h,s,w,d)=>{const D=M.URI.from({scheme:s||"file",path:decodeURIComponent(w)}),b=(0,S.$5xb)(D,{isRemote:o,authority:t}).toString();return`${c}${b}${d}`})}}e.$Wkc=C;function m(i){try{const r=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function y(i){try{const r=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(r,o,t,g,c){super(),this.c=o,this.f=t,this.g=g,this.h=c,this.b=new Map,this.a=r.getProxy(A.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,o,t){const g=this.j(r);if(g){const{message:c}=(0,$.$kob)(o,t.value);g._onMessageEmitter.fire(c)}}$onMissingCsp(r,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,o,t){const g=new C(r,this.a,a(o),this.c,this.f,t,this.h);this.b.set(r,g);const c=g._onDidDispose(()=>{c.dispose(),this.deleteWebview(r)});return g}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Ykc=v;function l(i){return{id:i.identifier,location:i.extensionLocation}}function f(i,r,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,r)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(le,e,u,N,L,R,M,p,$,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const v=this.d;return{get focused(){return v.focused},get active(){return(0,S.$xG)(y,"windowActivity"),v.active}}}constructor(y){this.c=new u.$be,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:l})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,v){v!==this.d[y]&&(this.d={...this.d,[y]:v},this.c.fire(this.d))}openUri(y,v){let l;if(typeof y=="string"){l=y;try{y=L.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,M.$3e)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,l,v)}async asExternalUri(y,v){if((0,M.$3e)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(y,v);return L.URI.from(l)}};e.$xmc=C,e.$xmc=C=A=Je([qe(0,$.$cP)],C),e.$ymc=(0,p.$qi)("IExtHostWindow")}),define(ke[319],Ee([1,0,311,28,20]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;const R=1024*1024;let M=class extends u.$Bmc{constructor($,S){super($,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,S,A){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,S){const A=process[$],C=A.write;let m="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,v,l)=>{if(!this.g){m+=y.toString(v);const f=m.length>R?m.length:m.lastIndexOf(`
`);f!==-1&&(console[S](m.slice(0,f)),m=m.slice(f+1))}C.call(A,y,v,l)}})}};e.$anc=M,e.$anc=M=Je([qe(0,L.$cP),qe(1,N.$sP)],M)}),define(ke[320],Ee([1,0,149,15,261,30]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class M extends u.$Amc{s($,S,A){return $.scheme===N.Schemas.file?new L.$pQ(A?.name||(0,R.$Mg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,S):super.s($,S,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$mnc=M}),define(ke[321],Ee([1,0,8,21,22,13,4,3,133,309,48]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$$$b=f,e.$_$b=a;function m(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class l{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function f(k,P=null,I=!1){const j=[];return{jsonString:(I?m:JSON.stringify)(k,(z,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$Ce){const T=j.push(O)-1;return{[y]:T}}if(P)return P(z,O)}return O}),referencedBuffers:j}}function a(k,P,I){return JSON.parse(k,(j,F)=>{if(F){const z=F[y];if(typeof z=="number")return P[z];if(I&&F.$mid===1)return I.transformIncoming(F)}return F})}function n(k,P){return JSON.stringify(k,P)}function i(k){return k?(P,I)=>I&&I.$mid===1?k.transformOutgoing(I):I:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var o;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},g=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends p.$Uc{static{C=g}static{this.a=3*1e3}constructor(P,I=null,j=null){super(),this[C]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,z=A.$iw.count;F<z;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$Ch(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$vn)(P,this.g):P}getProxy(P){const{nid:I,sid:j}=P;return this.s[I]||(this.s[I]=this.J(I,j)),this.s[I]}J(P,I){const j={get:(F,z)=>(typeof z=="string"&&!F[z]&&z.charCodeAt(0)===36&&(F[z]=(...O)=>this.U(P,z,O)),z===c?I:F[z])};return new Proxy(Object.create(null),j)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,j=P.length;I<j;I++){const F=P[I];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,j=w.read(P,0),F=j.readUInt8(),z=j.readUInt32();switch(F){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(j);this.g&&(B=(0,$.$vn)(B,this.g)),this.M(I,z,O,T,B,F===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(j);this.g&&(B=(0,$.$vn)(B,this.g)),this.M(I,z,O,T,B,F===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(j);this.g&&(O=(0,$.$vn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(j);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(j);this.g&&(O=(0,$.$vn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,j,F,z,O){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,A.$kw)(j)}.${F}(`,z);const T=String(I);let B,W;if(O){const x=new L.$me;z.push(x.token),B=this.Q(j,F,z),W=()=>x.cancel()}else B=this.Q(j,F,z),W=t;this.u[T]=W;const X=D.serializeAcknowledged(I);this.f?.logOutgoing(X.byteLength,I,1,"ack"),this.c.send(X),B.then(x=>{delete this.u[T];const Y=D.serializeReplyOK(I,x,this.h);this.f?.logOutgoing(Y.byteLength,I,1,"reply:",x),this.c.send(Y)},x=>{delete this.u[T];const Y=D.serializeReplyErr(I,x);this.f?.logOutgoing(Y.byteLength,I,1,"replyErr:",x),this.c.send(Y)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const j=String(I);this.u[j]?.()}O(P,I,j){this.f?.logIncoming(P,I,0,"receiveReply:",j);const F=String(I);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F],z.resolveOk(j)}P(P,I,j){this.f?.logIncoming(P,I,0,"receiveReplyErr:",j);const F=String(I);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F];let O;j&&(j.$isError?(O=new Error,O.name=j.name,O.message=j.message,O.stack=j.stack):O=j),z.resolveErr(O)}Q(P,I,j){try{return Promise.resolve(this.S(P,I,j))}catch(F){return Promise.reject(F)}}S(P,I,j){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,A.$kw)(P));const z=F[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$kw)(P));return z.apply(F,j)}U(P,I,j){if(this.j)return new S.$0$b;let F=null;if(j.length>0&&L.CancellationToken.isCancellationToken(j[j.length-1])&&(F=j.pop()),F&&F.isCancellationRequested)return Promise.reject(R.$6());const z=D.serializeRequestArguments(j,this.h),O=++this.t,T=String(O),B=new S.$9$b,W=new p.$Tc;F&&W.add(F.onCancellationRequested(()=>{const x=D.serializeCancel(O);this.f?.logOutgoing(x.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new s(B,W),this.F(O);const X=D.serializeRequest(O,P,I,z,!!F);return this.f?.logOutgoing(X.byteLength,O,0,`request: ${(0,A.$kw)(P)}.${I}(`,j),this.c.send(X),B}}e.$a_b=h;class s{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class w{static alloc(P,I,j){const F=new w(N.$Ce.alloc(j+1+4),0);return F.writeUInt8(P),F.writeUInt32(I),F}static read(P,I){return new w(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let j=0,F=P.length;j<F;j++){const z=P[j];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,j=P.length;I<j;I++){const F=P[I];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let z=0;z<F.buffers.length;++z)this.writeBuffer(F.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let j=0;j<P;j++)switch(this.readUInt8()){case 1:I[j]=this.readLongString();break;case 2:I[j]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<z;++B)T.push(this.readVSBuffer());I[j]=new A.$lw(a(O,T,null));break}case 4:I[j]=void 0;break}return I}}var d;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(d||(d={}));class D{static a(P){for(let I=0,j=P.length;I<j;I++)if(P[I]instanceof N.$Ce||P[I]instanceof A.$lw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const j=[];for(let F=0,z=P.length;F<z;F++){const O=P[F];if(O instanceof N.$Ce)j[F]={type:2,value:O};else if(typeof O>"u")j[F]={type:4};else if(O instanceof A.$lw){const{jsonString:T,referencedBuffers:B}=f(O.value,I);j[F]={type:3,value:N.$Ce.fromString(T),buffers:B}}else j[F]={type:1,value:N.$Ce.fromString(n(O,I))}}return{type:1,args:j}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,j,F,z){switch(F.type){case 0:return this.b(P,I,j,F.args,z);case 1:return this.c(P,I,j,F.args,z)}}static b(P,I,j,F,z){const O=N.$Ce.fromString(j),T=N.$Ce.fromString(F);let B=0;B+=w.sizeUInt8(),B+=w.sizeShortString(O),B+=w.sizeLongString(T);const W=w.alloc(z?2:1,P,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),j=P.readShortString(),F=P.readLongString();return{rpcId:I,method:j,args:JSON.parse(F)}}static c(P,I,j,F,z){const O=N.$Ce.fromString(j);let T=0;T+=w.sizeUInt8(),T+=w.sizeShortString(O),T+=w.sizeMixedArray(F);const B=w.alloc(z?4:3,P,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(F),B.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),j=P.readShortString(),F=P.readMixedArray(),z=new Array(F.length);for(let O=0,T=F.length;O<T;O++){const B=F[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:j,args:z}}static serializeAcknowledged(P){return w.alloc(5,P,0).buffer}static serializeCancel(P){return w.alloc(6,P,0).buffer}static serializeReplyOK(P,I,j){if(typeof I>"u")return this.d(P);if(I instanceof N.$Ce)return this.e(P,I);if(I instanceof A.$lw){const{jsonString:F,referencedBuffers:z}=f(I.value,j,!0);return this.g(P,F,z)}else return this.f(P,m(I,j))}static d(P){return w.alloc(7,P,0).buffer}static e(P,I){let j=0;j+=w.sizeVSBuffer(I);const F=w.alloc(8,P,j);return F.writeVSBuffer(I),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const j=N.$Ce.fromString(I);let F=0;F+=w.sizeLongString(j);const z=w.alloc(9,P,F);return z.writeLongString(j),z.buffer}static g(P,I,j){const F=N.$Ce.fromString(I);let z=0;z+=w.sizeUInt32,z+=w.sizeLongString(F);for(const T of j)z+=w.sizeVSBuffer(T);const O=w.alloc(10,P,z);O.writeUInt32(j.length),O.writeLongString(F);for(const T of j)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const j=P.readUInt32(),F=P.readLongString(),z=[];for(let O=0;O<j;++O)z.push(P.readVSBuffer());return new A.$lw(a(F,z,I))}static serializeReplyErr(P,I){const j=I?m(R.$3(I),null):void 0;if(typeof j!="string")return this.h(P);const F=N.$Ce.fromString(j);let z=0;z+=w.sizeLongString(F);const O=w.alloc(11,P,z);return O.writeLongString(F),O.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return w.alloc(12,P,0).buffer}}var b;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(ke[322],Ee([1,0,21,27,15,84,5]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=A,e.$tK=C,e.$rK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${p.join("")}]+`),S=7;function A(y){if(y.scheme!==L.Schemas.vscodeNotebookCell)return;const v=y.fragment.indexOf("s");if(v<0)return;const l=parseInt(y.fragment.substring(0,v).replace($,""),S),f=(0,u.$Ve)(y.fragment.substring(v+1)).toString();if(!isNaN(l))return{handle:l,notebook:y.with({scheme:f,fragment:null})}}function C(y,v){const l=v.toString(S),a=`${l.length<p.length?p[l.length-1]:"z"}${l}s${(0,u.$We)(u.$Ce.fromString(y.scheme),!0,!0)}`;return y.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class m{constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const l=A(v);if(l){const f=this.a.get(l.notebook);if(f)return f}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$uK=m,(0,R.$os)(e.$rK,m,1)}),define(ke[119],Ee([1,0,21,35,39,101,15,17,11,37,322]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=g,e.$IK=h,e.$JK=s,e.$MK=D,e.$NK=E,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var C;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(C||(e.CellKind=C={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",R.$Hs.latex,R.$Hs.markdown,"image/png","image/jpeg",R.$Hs.text],e.$BK=[R.$Hs.latex,R.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var m;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var y;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var l;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function W(te,we){return(0,A.$tK)(te,we)}B.generate=W;function X(te){return(0,A.$sK)(te)}B.parse=X;function x(te,we){return te.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${te.scheme!==M.Schemas.file?te.scheme:""}`})}B.generateCellOutputUri=x;function Y(te){if(te.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!we)return;const Se=we[1]&&we[1]!==""?we[1]:void 0,_=we[2];return{outputId:Se,notebook:te.with({scheme:_||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=Y;function Z(te,we,Se){return B.generate(te,we).with({scheme:Se})}B.generateCellPropertyUri=Z;function ue(te,we){if(te.scheme===we)return B.parse(te.with({scheme:B.scheme}))}B.parseCellPropertyUri=ue})(r||(e.CellUri=r={}));const o=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],X=e.$AK){this.e=X,this.d=[...new Set(W)].map(x=>({pattern:x,matches:N.$kk(o(x))}))}sort(W){const X=new Map(L.Iterable.map(W,Y=>[Y,o(Y)]));let x=[];for(const{matches:Y}of this.d)for(const[Z,ue]of X)if(Y(ue)){x.push(Z),X.delete(Z);break}return X.size&&(x=x.concat([...X.keys()].sort((Y,Z)=>this.e.indexOf(Y)-this.e.indexOf(Z)))),x}prioritize(W,X){const x=this.f(W);if(x===-1){this.d.unshift({pattern:W,matches:N.$kk(o(W))});return}const Y=new Set(X.map(ue=>this.f(ue,x)));Y.delete(-1);const Z=Array.from(Y).sort();this.d.splice(x+1,0,...Z.map(ue=>this.d[ue]));for(let ue=Z.length-1;ue>=0;ue--)this.d.splice(Z[ue],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const x=o(W);for(let Y=0;Y<X;Y++)if(this.d[Y].matches(x))return Y;return-1}}e.$EK=t;function g(B,W,X,x=(Y,Z)=>Y===Z){const Y=[];function Z(we,Se,_){if(Se===0&&_.length===0)return;const U=Y[Y.length-1];U&&U.start+U.deleteCount===we?(U.deleteCount+=Se,U.toInsert.push(..._)):Y.push({start:we,deleteCount:Se,toInsert:_})}let ue=0,te=0;for(;;){if(ue===B.length){Z(ue,0,W.slice(te));break}if(te===W.length){Z(ue,B.length-ue,[]);break}const we=B[ue],Se=W[te];if(x(we,Se)){ue+=1,te+=1;continue}X(Se)?(Z(ue,1,[]),ue+=1):(Z(ue,0,[Se]),te+=1)}return Y}e.$GK=new S.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new S.$Hj("notebookEditorCursorAtLineBoundary","none");var c;(function(B){B.default="default",B.option="option"})(c||(e.NotebookEditorPriority=c={}));function h(B){const W=B;return!!((typeof W.include=="string"||N.$lk(W.include))&&(typeof W.exclude=="string"||N.$lk(W.exclude)))}function s(B,W,X){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const x=h(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Y=h(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$jk(x,(0,p.$oc)(X.fsPath).toLowerCase()))return!(Y&&N.$jk(Y,(0,p.$oc)(X.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var w;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static{this.d="notebook/"}static create(W){return`${d.d}${W}`}static parse(W){if(W.startsWith(d.d))return W.substring(d.d.length)}}e.$LK=d;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const b=new TextDecoder;function E(B){const W=[];let X=!1;for(const ue of B)(W.length===0||X)&&(W.push(ue),X=!0);let x=I(W);const Y=u.$Ce.concat(W.map(ue=>u.$Ce.wrap(ue))),Z=T(Y);return x=x||Z.byteLength!==Y.byteLength,{data:Z,didCompression:x}}e.$OK="\x1B[A";const k=e.$OK.split("").map(B=>B.charCodeAt(0)),P=10;function I(B){let W=!1;return B.forEach((X,x)=>{if(x===0||X.length<e.$OK.length)return;const Y=B[x-1],Z=X.subarray(0,e.$OK.length);if(Z[0]===k[0]&&Z[1]===k[1]&&Z[2]===k[2]){const ue=Y.lastIndexOf(P);if(ue===-1)return;W=!0,B[x-1]=Y.subarray(0,ue),B[x]=X.subarray(e.$OK.length)}}),W}function j(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function F(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let X=B.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return B}const z=8,O=13;function T(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:u.$Ce.fromString(F(j(b.decode(B.buffer))))}}),define(ke[7],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";var l,f,a,n,i,r,o,t,g,c,h,s,w,d,D,b,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$3O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2O=e.$1O=e.$ZO=e.$YO=e.ChatLocation=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=ht,e.$QN=ee,e.$vO=Mt;function k(H){return Object.assign(H,{apply:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const Oe=ge.length===1?[]:ge[1];return Reflect.construct(H,Oe,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const[Oe,...xe]=ge;return Reflect.construct(H,xe,Oe.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let j=l=class{static from(...K){let ge=K;return new l(function(){if(ge){for(const Oe of ge)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();ge=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=j,e.$RM=j=l=Je([k],j);let F=f=class{static Min(...K){if(K.length===0)throw new TypeError;let ge=K[0];for(let Oe=1;Oe<K.length;Oe++){const xe=K[Oe];xe.isBefore(ge)&&(ge=xe)}return ge}static Max(...K){if(K.length===0)throw new TypeError;let ge=K[0];for(let Oe=1;Oe<K.length;Oe++){const xe=K[Oe];xe.isAfter(ge)&&(ge=xe)}return ge}static isPosition(K){if(!K)return!1;if(K instanceof f)return!0;const{line:ge,character:Oe}=K;return typeof ge=="number"&&typeof Oe=="number"}static of(K){if(K instanceof f)return K;if(this.isPosition(K))return new f(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,ge){if(K<0)throw(0,N.$7)("line must be non-negative");if(ge<0)throw(0,N.$7)("character must be non-negative");this.c=K,this.e=ge}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,ge=0){if(K===null||ge===null)throw(0,N.$7)();let Oe;return typeof K>"u"?Oe=0:typeof K=="number"?Oe=K:(Oe=typeof K.lineDelta=="number"?K.lineDelta:0,ge=typeof K.characterDelta=="number"?K.characterDelta:0),Oe===0&&ge===0?this:new f(this.line+Oe,this.character+ge)}with(K,ge=this.character){if(K===null||ge===null)throw(0,N.$7)();let Oe;return typeof K>"u"?Oe=this.line:typeof K=="number"?Oe=K:(Oe=typeof K.line=="number"?K.line:this.line,ge=typeof K.character=="number"?K.character:this.character),Oe===this.line&&ge===this.character?this:new f(Oe,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=F,e.$SM=F=f=Je([k],F);let z=a=class{static isRange(K){return K instanceof a?!0:K?F.isPosition(K.start)&&F.isPosition(K.end):!1}static of(K){if(K instanceof a)return K;if(this.isRange(K))return new a(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,ge,Oe,xe){let rt,ft;if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new F(K,ge),ft=new F(Oe,xe)):F.isPosition(K)&&F.isPosition(ge)&&(rt=F.of(K),ft=F.of(ge)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(K){return a.isRange(K)?this.contains(K.start)&&this.contains(K.end):F.isPosition(K)?!(F.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const ge=F.Max(K.start,this.c),Oe=F.Min(K.end,this.e);if(!ge.isAfter(Oe))return new a(ge,Oe)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const ge=F.Min(K.start,this.c),Oe=F.Max(K.end,this.end);return new a(ge,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,ge=this.end){if(K===null||ge===null)throw(0,N.$7)();let Oe;return K?F.isPosition(K)?Oe=K:(Oe=K.start||this.start,ge=K.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&ge.isEqual(this.end)?this:new a(Oe,ge)}toJSON(){return[this.start,this.end]}};e.$TM=z,e.$TM=z=a=Je([k],z);let O=n=class extends z{static isSelection(K){return K instanceof n?!0:K?z.isRange(K)&&F.isPosition(K.anchor)&&F.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,ge,Oe,xe){let rt,ft;if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"?(rt=new F(K,ge),ft=new F(Oe,xe)):F.isPosition(K)&&F.isPosition(ge)&&(rt=F.of(K),ft=F.of(ge)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=O,e.$UM=O=n=Je([k],O);const T=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,ge,Oe){if(typeof K!="string"||K.length===0)throw(0,N.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,N.$7)("port");typeof Oe<"u"&&T(Oe),this.host=K,this.port=Math.round(ge),this.connectionToken=Oe}}e.$VM=B;class W{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,ge){this.makeConnection=K,this.connectionToken=ge,typeof ge<"u"&&T(ge)}}e.$WM=W;class X extends Error{static NotAvailable(K,ge){return new X(K,y.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(K){return new X(K,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,ge=y.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(K),this._message=K,this._code=ge,this._detail=Oe,Object.setPrototypeOf(this,X.prototype)}}e.$XM=X;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var Y;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let Z=i=class{static isTextEdit(K){return K instanceof i?!0:K?z.isRange(K)&&typeof K.newText=="string":!1}static replace(K,ge){return new i(K,ge)}static insert(K,ge){return i.replace(new z(K,K),ge)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const ge=new i(new z(new F(0,0),new F(0,0)),"");return ge.newEol=K,ge}get range(){return this.c}set range(K){if(K&&!z.isRange(K))throw(0,N.$7)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,N.$7)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,N.$7)("newEol");this.f=K}constructor(K,ge){this.c=K,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=Z,e.$YM=Z=i=Je([k],Z);let ue=r=class{static isNotebookCellEdit(K){return K instanceof r?!0:K?at.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,ge){return new r(K,ge)}static insertCells(K,ge){return new r(new at(K,K),ge)}static deleteCells(K){return new r(K,[])}static updateCellMetadata(K,ge){const Oe=new r(new at(K,K),[]);return Oe.newCellMetadata=ge,Oe}static updateNotebookMetadata(K){const ge=new r(new at(0,0),[]);return ge.newNotebookMetadata=K,ge}constructor(K,ge){this.range=K,this.newCells=ge}};e.$ZM=ue,e.$ZM=ue=r=Je([k],ue);class te{static isSnippetTextEdit(K){return K instanceof te?!0:K?z.isRange(K.range)&&_.isSnippetString(K.snippet):!1}static replace(K,ge){return new te(K,ge)}static insert(K,ge){return te.replace(new z(K,K),ge)}constructor(K,ge){this.range=K,this.snippet=ge}}e.$1M=te;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let Se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,ge,Oe,xe){this.c.push({_type:1,from:K,to:ge,options:Oe,metadata:xe})}createFile(K,ge,Oe){this.c.push({_type:1,from:void 0,to:K,options:ge,metadata:Oe})}deleteFile(K,ge,Oe){this.c.push({_type:1,from:K,to:void 0,options:ge,metadata:Oe})}e(K,ge,Oe){this.c.push({_type:3,metadata:Oe,uri:K,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(K,ge,Oe,xe){const rt=ge.start,ft=ge.end;(rt!==ft||Oe.length>0)&&this.c.push({_type:5,uri:K,index:rt,count:ft-rt,cells:Oe,metadata:xe})}g(K,ge,Oe,xe){this.c.push({_type:3,metadata:xe,uri:K,edit:{editType:3,index:ge,metadata:Oe}})}replace(K,ge,Oe,xe){this.c.push({_type:2,uri:K,edit:new Z(ge,Oe),metadata:xe})}insert(K,ge,Oe,xe){this.replace(K,new z(ge,ge),Oe,xe)}delete(K,ge,Oe){this.replace(K,ge,"",Oe)}has(K){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===K.toString())}set(K,ge){if(ge)for(const Oe of ge){if(!Oe)continue;let xe,rt;Array.isArray(Oe)?(xe=Oe[0],rt=Oe[1]):xe=Oe,ue.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(K,xe.range.start,xe.newCellMetadata,rt):xe.newNotebookMetadata?this.e(K,xe.newNotebookMetadata,rt):this.f(K,xe.range,xe.newCells,rt):te.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:K,range:xe.range,edit:xe.snippet,metadata:rt}):this.c.push({_type:2,uri:K,edit:xe,metadata:rt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const xe=this.c[Oe];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===K.toString()&&(this.c[Oe]=void 0);break}}(0,u.$Ib)(this.c)}}get(K){const ge=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===K.toString()&&ge.push(Oe.edit);return ge}entries(){const K=new R.$Bc;for(const ge of this.c)if(ge._type===2){let Oe=K.get(ge.uri);Oe||(Oe=[ge.uri,[]],K.set(ge.uri,Oe)),Oe[1].push(ge.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Se,e.$2M=Se=Je([k],Se);let _=o=class{static isSnippetString(K){return K instanceof o?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=o.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,ge=this.e++){if(typeof K=="function"){const Oe=new o;Oe.e=this.e,K(Oe),this.e=Oe.e,K=Oe.value}else K=o.c(K);return this.value+="${",this.value+=ge,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,ge=this.e++){const Oe=K.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(K,ge){if(typeof ge=="function"){const Oe=new o;Oe.e=this.e,ge(Oe),this.e=Oe.e,ge=Oe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$3M=_,e.$3M=_=o=Je([k],_);var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let $e=t=class{static isLocation(K){return K instanceof t?!0:K?z.isRange(K.range)&&S.URI.isUri(K.uri):!1}constructor(K,ge){if(this.uri=K,ge)if(z.isRange(ge))this.range=z.of(ge);else if(F.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=$e,e.$4M=$e=t=Je([k],$e);let Pe=class{static is(K){return K?typeof K.message=="string"&&K.location&&z.isRange(K.location.range)&&S.URI.isUri(K.location.uri):!1}constructor(K,ge){this.location=K,this.message=ge}static isEqual(K,ge){return K===ge?!0:!K||!ge?!1:K.message===ge.message&&K.location.range.isEqual(ge.location.range)&&K.location.uri.toString()===ge.location.uri.toString()}};e.$5M=Pe,e.$5M=Pe=Je([k],Pe);let se=class{constructor(K,ge,Oe=ne.Error){if(!z.isRange(K))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=K,this.message=ge,this.severity=Oe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,ge){return K===ge?!0:!K||!ge?!1:K.message===ge.message&&K.severity===ge.severity&&K.code===ge.code&&K.severity===ge.severity&&K.source===ge.source&&K.range.isEqual(ge.range)&&(0,u.$ub)(K.tags,ge.tags)&&(0,u.$ub)(K.relatedInformation,ge.relatedInformation,Pe.isEqual)}};e.$6M=se,e.$6M=se=Je([k],se);let re=class{constructor(K,ge){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=ge}};e.$7M=re,e.$7M=re=Je([k],re);var oe;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let G=class{constructor(K,ge=oe.Text){this.range=K,this.kind=ge}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$8M=G,e.$8M=G=Je([k],G);let ie=class{constructor(K,ge){this.uri=K,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$9M=ie,e.$9M=ie=Je([k],ie);var me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(H){H[H.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Ae=g=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,ge,Oe,xe,rt){this.name=K,this.kind=ge,this.containerName=rt,typeof Oe=="string"&&(this.containerName=Oe),xe instanceof $e?this.location=xe:Oe instanceof z&&(this.location=new $e(xe,Oe)),g.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Ae,e.$0M=Ae=g=Je([k],Ae);let fe=c=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(c.validate)}constructor(K,ge,Oe,xe,rt){this.name=K,this.detail=ge,this.kind=Oe,this.range=xe,this.selectionRange=rt,this.children=[],c.validate(this)}};e.$$M=fe,e.$$M=fe=c=Je([k],fe);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Ie=class{constructor(K,ge){this.title=K,this.kind=ge}};e.$_M=Ie,e.$_M=Ie=Je([k],Ie);let Te=class{static{h=this}static{this.c="."}constructor(K){this.value=K}append(K){return new h(this.value?this.value+h.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+h.c)}};e.$aN=Te,e.$aN=Te=h=Je([k],Te),Te.Empty=new Te(""),Te.QuickFix=Te.Empty.append("quickfix"),Te.Refactor=Te.Empty.append("refactor"),Te.RefactorExtract=Te.Refactor.append("extract"),Te.RefactorInline=Te.Refactor.append("inline"),Te.RefactorMove=Te.Refactor.append("move"),Te.RefactorRewrite=Te.Refactor.append("rewrite"),Te.Source=Te.Empty.append("source"),Te.SourceOrganizeImports=Te.Source.append("organizeImports"),Te.SourceFixAll=Te.Source.append("fixAll"),Te.Notebook=Te.Empty.append("notebook");let q=class{constructor(K,ge){if(this.range=K,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=q,e.$bN=q=Je([k],q);class V{constructor(K,ge,Oe,xe,rt,ft){this.kind=K,this.name=ge,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$cN=V;class J{constructor(K,ge){this.fromRanges=ge,this.from=K}}e.$dN=J;class Q{constructor(K,ge){this.fromRanges=ge,this.to=K}}e.$eN=Q;var he;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let be=class{constructor(K,ge){this.range=K,this.command=ge}get isResolved(){return!!this.command}};e.$fN=be,e.$fN=be=Je([k],be);let ze=s=class{#e;static isMarkdownString(K){return K instanceof s?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,ge=!1){this.#e=new L.$Nk(K,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,ge){return this.#e.appendCodeblock(ge??"",K),this}};e.$gN=ze,e.$gN=ze=s=Je([k],ze);let Ve=class{constructor(K,ge){this.label=K,this.documentation=ge}};e.$hN=Ve,e.$hN=Ve=Je([k],Ve);let Ye=class{constructor(K,ge){this.label=K,this.documentation=ge,this.parameters=[]}};e.$iN=Ye,e.$iN=Ye=Je([k],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=it,e.$jN=it=Je([k],it);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var nt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let st=class{constructor(K){this.value=K}};e.$kN=st,e.$kN=st=Je([k],st);let Ce=class{constructor(K,ge,Oe){this.position=K,this.label=ge,this.kind=Oe}};e.$lN=Ce,e.$lN=Ce=Je([k],Ce);var Be;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var He;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Ne;(function(H){H[H.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let Xe=class{constructor(K,ge){this.label=K,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=Xe,e.$mN=Xe=Je([k],Xe);let ae=class{constructor(K=[],ge=!1){this.items=K,this.isIncomplete=ge}};e.$nN=ae,e.$nN=ae=Je([k],ae);let ce=class{constructor(K,ge,Oe){this.insertText=K,this.range=ge,this.command=Oe}};e.$oN=ce,e.$oN=ce=Je([k],ce);let Re=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$pN=Re,e.$pN=Re=Je([k],Re);var Ge;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var Me;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Me||(e.ViewColumn=Me={}));var tt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(tt||(e.StatusBarAlignment=tt={}));function ht(H,K){return`${C.$Lm.toKey(H)}.${K}`}var wt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Lt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var At;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var xt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(H){function K(ge){switch(ge){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=K}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Vt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(H){function K(ge){switch(ge){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=K}(Vt||(e.SyntaxTokenType=Vt={}));let Xt=class{constructor(K,ge){if(ge&&!S.URI.isUri(ge))throw(0,N.$7)("target");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.target=ge}};e.$rN=Xt,e.$rN=Xt=Je([k],Xt);let et=class{constructor(K,ge,Oe,xe){this.red=K,this.green=ge,this.blue=Oe,this.alpha=xe}};e.$sN=et,e.$sN=et=Je([k],et);let si=class{constructor(K,ge){if(ge&&!(ge instanceof et))throw(0,N.$7)("color");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.color=ge}};e.$tN=si,e.$tN=si=Je([k],si);let Yt=class{constructor(K){if(!K||typeof K!="string")throw(0,N.$7)("label");this.label=K}};e.$uN=Yt,e.$uN=Yt=Je([k],Yt);var dt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(dt||(e.ColorFormat=dt={}));var vt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Zt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(Zt||(e.TerminalShellExecutionCommandLineConfidence=Zt={}));class zt{constructor(K,ge,Oe){if(this.startIndex=K,this.length=ge,this.tooltip=Oe,typeof K!="number"||K<0)throw(0,N.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,N.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,N.$7)("tooltip")}}e.$vN=zt;class gt{constructor(K){this.uri=K}}e.$wN=gt;class Ut{constructor(K){this.terminalCommand=K}}e.$xN=Ut;var Wt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Kt{constructor(K){if(this.options=K,typeof K!="object")throw(0,N.$7)("options")}}e.$yN=Kt;var Ze;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ze||(e.TaskRevealKind=Ze={}));var ui;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(K){switch(K){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(K,ge){if(this.label=ge,typeof K!="string"||typeof ge!="string")throw(0,N.$7)("name");this.c=K}get id(){return this.c}};e.$zN=Ht,e.$zN=Ht=w=Je([k],Ht);function Bt(H){let K="";for(let ge=0;ge<H.length;ge++)K+=H[ge].replace(/,/g,",,")+",";return K}let mt=class{constructor(K,ge,Oe){if(typeof K!="string")throw(0,N.$7)("process");this.e=[],this.c=K,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Oe):this.f=ge)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,N.$7)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)K.push(ge);return Bt(K)}};e.$AN=mt,e.$AN=mt=Je([k],mt);let Tt=class{constructor(K,ge,Oe){if(this.f=[],Array.isArray(ge)){if(!K)throw(0,N.$7)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K,this.f=ge,this.g=Oe}else{if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K,this.g=ge}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)K.push(typeof ge=="string"?ge:ge.value);return Bt(K)}};e.$BN=Tt,e.$BN=Tt=Je([k],Tt);var Rt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Rt||(e.ShellQuoting=Rt={}));var jt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(jt||(e.TaskScope=jt={}));class ii{constructor(K){this.c=K}computeId(){return"customExecution"+(0,A.$Mg)()}set callback(K){this.c=K}get callback(){return this.c}}e.$CN=ii;let Gt=class{static{d=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,ge,Oe,xe,rt,ft){this.k=!1,this.l=this.definition=K;let $t;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Oe,this.execution=xe,$t=rt,this.k=!0):ge===jt.Global||ge===jt.Workspace?(this.target=ge,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft):(this.target=ge,this.o=this.name=Oe,this.w=this.source=xe,this.execution=rt,$t=ft),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:d.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:d.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:d.c,id:this.q.computeId()}:this.l={type:d.g,id:(0,A.$Mg)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,N.$7)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const ge=this.l.type;(d.g===ge||d.e===ge||d.f===ge||d.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$DN=Gt,e.$DN=Gt=d=Je([k],Gt);var ni;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Nt;(function(H){function K(ge){const Oe=ge;return(0,$.$8f)(Oe.value)?Oe.tooltip&&!(0,$.$4f)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}H.isViewBadge=K})(Nt||(e.ViewBadge=Nt={}));let Ot=D=class{static isTreeItem(K,ge){const Oe=K;if(Oe.checkboxState!==void 0){const xe=(0,$.$8f)(Oe.checkboxState)?Oe.checkboxState:(0,$.$6f)(Oe.checkboxState)&&(0,$.$8f)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,rt=!(0,$.$8f)(Oe.checkboxState)&&(0,$.$6f)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(xe===void 0||xe!==St.Checked&&xe!==St.Unchecked||rt!==void 0&&!(0,$.$4f)(rt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(K instanceof D)return!0;if(Oe.label!==void 0&&!(0,$.$4f)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,$.$4f)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,$.$4f)(Oe.iconPath)&&!S.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,$.$4f)(Oe.iconPath.id))){const xe=Oe.iconPath;if(!xe||!(0,$.$4f)(xe.light)&&!S.URI.isUri(xe.light)&&!(0,$.$4f)(xe.dark)&&!S.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,$.$4f)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!S.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,$.$4f)(Oe.tooltip)&&!(Oe.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<It.None&&Oe.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,$.$4f)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(K,ge=It.None){this.collapsibleState=ge,S.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$EN=Ot,e.$EN=Ot=D=Je([k],Ot);var It;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$FN=bt,e.$FN=bt=Je([k],bt);class Ct extends bt{}e.$GN=Ct;class li extends Ct{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$HN=li;class Dt{constructor(K,ge,Oe,xe){this.name=K,this.uri=ge,this._itemId=Oe,this.c=xe}data(){return this.c()}}e.$IN=Dt;let hi=class{#e=new Map;constructor(K){for(const[ge,Oe]of K??[]){const xe=this.#e.get(this.#t(ge));xe?xe.push(Oe):this.#e.set(this.#t(ge),[Oe])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,ge){this.#e.set(this.#t(K),[ge])}forEach(K,ge){for(const[Oe,xe]of this.#e)for(const rt of xe)K.call(ge,rt,Oe,this)}*[Symbol.iterator](){for(const[K,ge]of this.#e)for(const Oe of ge)yield[K,Oe]}#t(K){return K.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([k],hi);let Jt=class{constructor(K,ge,Oe){this.insertText=K,this.title=ge,this.kind=Oe}};e.$KN=Jt,e.$KN=Jt=Je([k],Jt);var wi;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ei{static{this.c="."}constructor(K){this.value=K}append(...K){return new ei((this.value?[this.value,...K]:K).join(ei.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+ei.c)}}e.$LN=ei,ei.Empty=new ei("");class vi{constructor(K,ge,Oe){this.title=ge,this.insertText=K,this.kind=Oe}}e.$MN=vi;let kt=class{constructor(K,ge){this.id=K,this.color=ge}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$NN=kt,e.$NN=kt=Je([k],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let $i=class{constructor(K){this.id=K}};e.$ON=$i,e.$ON=$i=Je([k],$i);var Le;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Le||(e.ConfigurationTarget=Le={}));let Fe=class{get base(){return this.c}set base(K){this.c=K,this.e=S.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,ge){if(typeof K!="string"&&(!K||!S.URI.isUri(K)&&!S.URI.isUri(K.uri)))throw(0,N.$7)("base");if(typeof ge!="string")throw(0,N.$7)("pattern");typeof K=="string"?this.baseUri=S.URI.file(K):S.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Fe,e.$PN=Fe=Je([k],Fe);const ye=new WeakMap;function ee(H,K){ye.set(H,K)}let je=class{constructor(K,ge,Oe,xe,rt){this.enabled=typeof K=="boolean"?K:!0,typeof ge=="string"&&(this.condition=ge),typeof Oe=="string"&&(this.hitCondition=Oe),typeof xe=="string"&&(this.logMessage=xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=ye.get(this)??(0,A.$Mg)()),this.c}};e.$RN=je,e.$RN=je=Je([k],je);let Ke=class extends je{constructor(K,ge,Oe,xe,rt,ft){if(super(ge,Oe,xe,rt,ft),K===null)throw(0,N.$7)("location");this.location=K}};e.$SN=Ke,e.$SN=Ke=Je([k],Ke);let _e=class extends je{constructor(K,ge,Oe,xe,rt,ft){super(ge,Oe,xe,rt,ft),this.functionName=K}};e.$TN=_e,e.$TN=_e=Je([k],_e);let Qe=class extends je{constructor(K,ge,Oe,xe,rt,ft,$t,Qt){if(super(xe,rt,ft,$t,Qt),!ge)throw(0,N.$7)("dataId");this.label=K,this.dataId=ge,this.canPersist=Oe}};e.$UN=Qe,e.$UN=Qe=Je([k],Qe);let lt=class{constructor(K,ge,Oe){this.command=K,this.args=ge||[],this.options=Oe}};e.$VN=lt,e.$VN=lt=Je([k],lt);let Et=class{constructor(K,ge){this.port=K,this.host=ge}};e.$WN=Et,e.$WN=Et=Je([k],Et);let Ft=class{constructor(K){this.path=K}};e.$XN=Ft,e.$XN=Ft=Je([k],Ft);let qt=class{constructor(K){this.implementation=K}};e.$YN=qt,e.$YN=qt=Je([k],qt);class ut{constructor(K,ge,Oe){this.session=K,this.threadId=ge,this.frameId=Oe}}e.$ZN=ut;class ri{constructor(K,ge){this.session=K,this.threadId=ge}}e.$1N=ri;let di=class{constructor(K,ge){this.range=K,this.expression=ge}};e.$2N=di,e.$2N=di=Je([k],di);var bi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(bi||(e.InlineCompletionTriggerKind=bi={}));let Di=class{constructor(K,ge){this.range=K,this.text=ge}};e.$3N=Di,e.$3N=Di=Je([k],Di);let Ri=class{constructor(K,ge,Oe=!0){this.range=K,this.variableName=ge,this.caseSensitiveLookup=Oe}};e.$4N=Ri,e.$4N=Ri=Je([k],Ri);let Mi=class{constructor(K,ge){this.range=K,this.expression=ge}};e.$5N=Mi,e.$5N=Mi=Je([k],Mi);let Li=class{constructor(K,ge){this.frameId=K,this.stoppedLocation=ge}};e.$6N=Li,e.$6N=Li=Je([k],Li);var Ni;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(K,ge){this.newSymbolName=K,this.tags=ge}}e.$7N=cn;var Oi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ti=b=class extends Error{static FileExists(K){return new b(K,m.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(K){return new b(K,m.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(K){return new b(K,m.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(K){return new b(K,m.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(K){return new b(K,m.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(K){return new b(K,m.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(K,ge=m.FileSystemProviderErrorCode.Unknown,Oe){super(S.URI.isUri(K)?K.toString(!0):K),this.code=Oe?.name??"Unknown",(0,m.$_k)(this,ge),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$8N=Ti,e.$8N=Ti=b=Je([k],Ti);let yi=class{constructor(K,ge,Oe){this.start=K,this.end=ge,this.kind=Oe}};e.$9N=yi,e.$9N=yi=Je([k],yi);var Ci;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Hi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Gi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var pi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(pi||(e.CommentState=pi={}));var Ji;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(K,ge=[]){this.tokenTypes=K,this.tokenModifiers=ge}}e.$0N=un;function ji(H){return typeof H>"u"||(0,$.$5f)(H)}class Fi{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let ge=0,Oe=K.tokenTypes.length;ge<Oe;ge++)this.k.set(K.tokenTypes[ge],ge);for(let ge=0,Oe=K.tokenModifiers.length;ge<Oe;ge++)this.l.set(K.tokenModifiers[ge],ge)}}push(K,ge,Oe,xe,rt){if(typeof K=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(K,ge,Oe,xe,rt);if(z.isRange(K)&&typeof ge=="string"&&ji(Oe))return this.o(K,ge,Oe);throw(0,N.$7)()}o(K,ge,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const xe=K.start.line,rt=K.start.character,ft=K.end.character-K.start.character,$t=this.k.get(ge);let Qt=0;if(Oe)for(const ci of Oe){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Qt|=1<<fi>>>0}this.q(xe,rt,ft,$t,Qt)}q(K,ge,Oe,xe,rt){if(this.f&&(K<this.c||K===this.c&&ge<this.e)){this.f=!1;const Qt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Qt;gi++){let mi=this.g[5*gi],Vi=this.g[5*gi+1];mi===0?(mi=ci,Vi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=Vi,ci=mi,fi=Vi}}let ft=K,$t=ge;this.f&&this.j>0&&(ft-=this.c,ft===0&&($t-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=$t,this.g[this.j++]=Oe,this.g[this.j++]=xe,this.g[this.j++]=rt,this.c=K,this.e=ge}static r(K){const ge=[],Oe=K.length/5|0;for(let $t=0;$t<Oe;$t++)ge[$t]=$t;ge.sort(($t,Qt)=>{const ci=K[5*$t],fi=K[5*Qt];if(ci===fi){const gi=K[5*$t+1],mi=K[5*Qt+1];return gi-mi}return ci-fi});const xe=new Uint32Array(K.length);let rt=0,ft=0;for(let $t=0;$t<Oe;$t++){const Qt=5*ge[$t],ci=K[Qt+0],fi=K[Qt+1],gi=K[Qt+2],mi=K[Qt+3],Vi=K[Qt+4],Mn=ci-rt,ur=Mn===0?fi-ft:fi,Ki=5*$t;xe[Ki+0]=Mn,xe[Ki+1]=ur,xe[Ki+2]=gi,xe[Ki+3]=mi,xe[Ki+4]=Vi,rt=ci,ft=fi}return xe}build(K){return this.f?new Pi(new Uint32Array(this.g),K):new Pi(Fi.r(this.g),K)}}e.$$N=Fi;class Pi{constructor(K,ge){this.resultId=ge,this.data=K}}e.$_N=Pi;class ln{constructor(K,ge,Oe){this.start=K,this.deleteCount=ge,this.data=Oe}}e.$aO=ln;class Xi{constructor(K,ge){this.resultId=ge,this.edits=K}}e.$bO=Xi;var Yi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class hn{constructor(K){this.name=K}}e.$cO=hn;let zi=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.$dO=zi,e.$dO=zi=Je([k],zi);var Zi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Ii;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Ii||(e.InputBoxValidationSeverity=Ii={}));var Bi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Bi||(e.ExtensionKind=Bi={}));class We{static validate(K){if(typeof K.badge=="string"){let ge=(0,p.$Df)(K.badge,0);if(ge<K.badge.length&&(ge+=(0,p.$Df)(K.badge,ge)),K.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!kt.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,ge,Oe){this.badge=K,this.tooltip=ge,this.color=Oe}}e.$eO=We;let oi=class{constructor(K){this.kind=K}};e.$fO=oi,e.$fO=oi=Je([k],oi);var Ui;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class at{static isNotebookRange(K){return K instanceof at?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,ge){if(K<0)throw(0,N.$7)("start must be positive");if(ge<0)throw(0,N.$7)("end must be positive");K<=ge?(this.c=K,this.e=ge):(this.c=ge,this.e=K)}with(K){let ge=this.c,Oe=this.e;return K.start!==void 0&&(ge=K.start),K.end!==void 0&&(Oe=K.end),ge===this.c&&Oe===this.e?this:new at(ge,Oe)}}e.$gO=at;class pt{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(ge=>pt.isNotebookCellData(ge))}static isNotebookCellData(K){return!0}constructor(K,ge,Oe,xe,rt,ft,$t){this.kind=K,this.value=ge,this.languageId=Oe,this.mime=xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=$t,pt.validate(this)}}e.$hO=pt;class dn{constructor(K){this.cells=K}}e.$iO=dn;class ai{static isNotebookCellOutputItem(K){return K instanceof ai?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const ge={name:K.name,message:K.message,stack:K.stack};return ai.json(ge,"application/vnd.code.notebook.error")}static stdout(K){return ai.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return ai.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,ge="application/octet-stream"){return new ai(K,ge)}static#e=new TextEncoder;static text(K,ge=M.$Hs.text){const Oe=ai.#e.encode(String(K));return new ai(Oe,ge)}static json(K,ge="text/x-json"){const Oe=JSON.stringify(K,void 0,"	");return ai.text(Oe,ge)}constructor(K,ge){this.data=K,this.mime=ge;const Oe=(0,M.$Ls)(ge,!0);if(!Oe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$jO=ai;class ki{static isNotebookCellOutput(K){return K instanceof ki?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,ge=!1){const Oe=new Set,xe=new Set;for(let rt=0;rt<K.length;rt++){const ft=K[rt],$t=(0,M.$Ls)(ft.mime);if(!Oe.has($t)||(0,v.$MK)($t)){Oe.add($t);continue}xe.add(rt),ge&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return xe.size===0?K:K.filter((rt,ft)=>!xe.has(ft))}constructor(K,ge,Oe){this.items=ki.ensureUniqueMimeTypes(K,!0),typeof ge=="string"?(this.id=ge,this.metadata=Oe):(this.id=(0,A.$Mg)(),this.metadata=ge??Oe)}}e.$kO=ki;var xi;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(K,ge){this.text=K,this.alignment=ge}}e.$lO=fn;var Wi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(K,ge=[]){this.uri=K,this.provides=(0,u.$3b)(ge)}}e.$mO=gn;class mn{constructor(K){this.label=K}}e.$nO=mn;var nn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let qi=class{constructor(K,ge){this.label=K,this.timestamp=ge}};e.$oO=qi,e.$oO=qi=Je([k],qi);var rn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(K,ge){this.ranges=K,this.wordPattern=ge}}e.$pO=$n;class bn{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$qO=bn;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var de;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let ve=class{constructor(K=void 0,ge=void 0,Oe=void 0,xe=!1){this.include=K,this.exclude=ge,this.profile=Oe,this.continuous=xe}};e.$rO=ve,e.$rO=ve=Je([k],ve);let Ue=E=class{static diff(K,ge,Oe){const xe=new E(K);return xe.expectedOutput=ge,xe.actualOutput=Oe,xe}constructor(K){this.message=K}};e.$sO=Ue,e.$sO=Ue=E=Je([k],Ue);let ct=class{constructor(K){this.id=K}};e.$tO=ct,e.$tO=ct=Je([k],ct);class yt{constructor(K,ge){this.covered=K,this.total=ge,Mt(this)}}e.$uO=yt;function Mt(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class Si{static fromDetails(K,ge){const Oe=new yt(0,0),xe=new yt(0,0),rt=new yt(0,0);for(const $t of ge)if("branches"in $t){Oe.total+=1,Oe.covered+=$t.executed?1:0;for(const Qt of $t.branches)xe.total+=1,xe.covered+=Qt.executed?1:0}else rt.total+=1,rt.covered+=$t.executed?1:0;const ft=new Si(K,Oe,xe.total>0?xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=ge,ft}constructor(K,ge,Oe,xe){this.uri=K,this.statementCoverage=ge,this.branchCoverage=Oe,this.declarationCoverage=xe}}e.$wO=Si;class Ln{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe=[]){this.executed=K,this.location=ge,this.branches=Oe}}e.$xO=Ln;class Nn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe){this.executed=K,this.location=ge,this.label=Oe}}e.$yO=Nn;class On{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,ge,Oe){this.name=K,this.executed=ge,this.location=Oe}}e.$zO=On;var pn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var wn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Tn{constructor(K,ge,Oe,xe,rt,ft){this.kind=K,this.name=ge,this.detail=Oe,this.uri=xe,this.range=rt,this.selectionRange=ft}}e.$AO=Tn;class jn{constructor(K){this.uri=K}}e.$BO=jn;class Fn{constructor(K,ge){this.original=K,this.modified=ge}}e.$CO=Fn;class zn{constructor(K,ge,Oe,xe){this.base=K,this.input1=ge,this.input2=Oe,this.result=xe}}e.$DO=zn;class Bn{constructor(K,ge){this.uri=K,this.viewType=ge}}e.$EO=Bn;class Un{constructor(K){this.viewType=K}}e.$FO=Un;class Wn{constructor(K,ge){this.uri=K,this.notebookType=ge}}e.$GO=Wn;class qn{constructor(K,ge,Oe){this.original=K,this.modified=ge,this.notebookType=Oe}}e.$HO=qn;class Vn{constructor(){}}e.$IO=Vn;class Kn{constructor(K,ge){this.uri=K,this.inputBoxUri=ge}}e.$JO=Kn;class Hn{constructor(){}}e.$KO=Hn;class Gn{constructor(K){this.textDiffs=K}}e.$LO=Gn;var yn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(K,ge){this.label=K,this.values=ge}}e.$MO=Jn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Qn{constructor(K){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new ze(K):K}}e.$NO=Qn;class Xn{constructor(K,ge){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new ze(K):K,this.vulnerabilities=ge}}e.$OO=Xn;class Yn{constructor(K,ge){this.participant=K,this.command=ge}}e.$PO=Yn;class Zn{constructor(K,ge){this.value=K,this.baseUri=ge}}e.$QO=Zn;class xn{constructor(K,ge){this.value=K,this.title=ge}}e.$RO=xn;class _n{constructor(K){this.value=K}}e.$SO=_n;class er{constructor(K){this.value=K}}e.$TO=er;class tr{constructor(K){this.value=K}}e.$UO=tr;class ir{constructor(K,ge){this.uri=K,this.edits=Array.isArray(ge)?ge:[ge]}}e.$VO=ir;class nr{constructor(K,ge,Oe,xe){this.prompt=K,this.command=ge,this.variables=Oe,this.participant=xe}}e.$WO=nr;class rr{constructor(K,ge,Oe,xe){this.response=K,this.result=ge,this.participant=Oe,this.command=xe}}e.$XO=rr;var Cn;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class sr{constructor(K){this.content=K}}e.$YO=sr;class or{constructor(K,ge){this.content=K,this.name=ge}}e.$ZO=or;class ar{constructor(K,ge){this.content=K,this.name=ge}}e.$1O=ar;class Ai extends Error{static NotFound(K){return new Ai(K,Ai.NotFound.name)}static NoPermissions(K){return new Ai(K,Ai.NoPermissions.name)}constructor(K,ge,Oe){super(K,{cause:Oe}),this.name="LanguageModelError",this.code=ge??""}}e.$2O=Ai;var Pn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var An;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class cr{constructor(K,ge){this.text=K,this.range=ge}}e.$3O=cr;var Rn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[323],Ee([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(M);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(p,$)??[]}getRelatedInformation(M,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(M,p,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiRelatedInformationProvider(S,p),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$rkc=L}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=void 0,e.$Ckc=(0,p.$qi)("IExtHostAuthentication");let S=class{constructor(m){this.b=new Map,this.c=new u.$be,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=m.getProxy(N.$PM.MainThreadAuthentication)}async getSession(m,y,v,l={}){const f=R.$Lm.toKey(m.identifier),a=[...v].sort().join(" ");return await this.d.getOrCreate(`${f} ${y} ${a}`,async()=>{await this.a.$ensureProvider(y);const n=m.displayName||m.name;return this.a.$getSession(y,v,f,n,l)})}async getSessions(m,y,v){const l=R.$Lm.toKey(m.identifier),f=[...v].sort().join(" ");return await this.f.getOrCreate(`${l} ${f}`,async()=>{await this.a.$ensureProvider(y);const a=m.displayName||m.name;return this.a.$getSessions(y,v,l,a)})}async removeSession(m,y){const v=this.b.get(m);return v?v.provider.removeSession(y):this.a.$removeSession(m,y)}registerAuthenticationProvider(m,y,v,l){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:y,provider:v,options:l??{supportsMultipleAccounts:!1}});const f=v.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(m,a));return this.a.$registerAuthenticationProvider(m,y,l?.supportsMultipleAccounts??!1),new L.$RM(()=>{f.dispose(),this.b.delete(m),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,y,v){const l=this.b.get(m);if(l)return Promise.resolve(l.provider.createSession(y,v));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,y){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,y){const v=this.b.get(m);if(v)return Promise.resolve(v.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,y){return m.startsWith(M.$RL)||this.c.fire({provider:{id:m,label:y}}),Promise.resolve()}};e.$Dkc=S,e.$Dkc=S=Je([qe(0,$.$cP)],S);class A{constructor(){this.a=new Map}getOrCreate(m,y){const v=this.a.get(m);if(v)return v;const l=y().finally(()=>this.a.delete(m));return this.a.set(m,l),l}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;let y=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,f){this.h=f,this.f=new Map,this.g=l.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(l,f){const a=m.c++;this.f.set(a,{provider:l,extensionDescription:f}),this.g.$registerDecorationProvider(a,f.identifier.value);const n=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const r=(0,$.$3b)(i);if(r.length<=m.d){this.g.$onDidChange(a,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,r.length);const o=r.map(c=>({uri:c,rank:(0,S.$9e)(c.path,"/")})),t=(0,$.$zb)(o,(c,h)=>c.rank-h.rank||(0,S.$mf)(c.uri.path,h.uri.path)),g=[];e:for(const c of t){let h;for(const s of c){const w=(0,A.$nc)(s.uri.path);if(h!==w&&(h=w,g.push(s.uri)>=m.d))break e}}this.g.$onDidChange(a,g)});return new L.$RM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(l,f,a){if(!this.f.has(l))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(l);return await Promise.all(f.map(async o=>{try{const{uri:t,id:g}=o,c=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),a));if(!c)return;try{L.$eO.validate(c),c.badge&&typeof c.badge!="string"&&(0,C.$xG)(r,"codiconDecoration"),n[g]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${h}`)}}catch(t){this.h.error(t)}})),n}};e.$Clc=y,e.$Clc=y=m=Je([qe(0,M.$cP),qe(1,p.$Wj)],y),e.$Dlc=(0,R.$qi)("IExtHostDecorations")}),define(ke[324],Ee([1,0,13,2,7,6,15,22,14]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class S{static{this.a=0}constructor(C,m,y){this.d=m,this.e=y,this.b=new Map,this.c=C.getProxy(R.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(M.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const y=S.a++;this.b.set(y,m),this.c.$registerTextContentProvider(y,C);let v;if(typeof m.onDidChange=="function"){let l;v=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;l&&await l;const a=this.$provideTextDocumentContent(y,f).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(f);if(!i)return;const r=(0,$.$gf)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(f,n)}).catch(u.$1).finally(()=>{l===a&&(l=void 0)});l=a})}return new L.$RM(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,m){const y=this.b.get(C);return y?Promise.resolve(y.provideTextDocumentContent(N.URI.revive(m),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$Flc=S}),define(ke[152],Ee([1,0,62,15,14,183,129,7,19]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$eP=A;const S=new Map;function A(v,l){l?S.set(v,l):S.delete(v)}function C(v){return S.get(v)}class m extends R.$Pv{constructor(l,f,a,n,i,r,o){super(f,a,n,i),this.c=l,this.m=r,this.q=o,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===N.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(f){return f?l.s(f):l.getText()},get eol(){return l.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(f){return l.t(f)},offsetAt(f){return l.u(f)},positionAt(f){return l.v(f)},validateRange(f){return l.w(f)},validatePosition(f){return l.x(f)},getWordRangeAtPosition(f,a){return l.y(f,a)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,u.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,u.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const f=this.w(l);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const a=this.g,n=f.start.line,i=f.end.line,r=[];r.push(this.f[n].substring(f.start.character));for(let o=n+1;o<i;o++)r.push(this.f[o]);return r.push(this.f[i].substring(0,f.end.character)),r.join(a)}t(l){let f;if(l instanceof p.$SM?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new y(f,this.f[f],f===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const f=this.j.getIndexOf(l),a=this.f[f.index].length;return new p.$SM(f.index,Math.min(f.remainder,a))}w(l){if(!(l instanceof p.$TM))throw new Error("Invalid argument");const f=this.x(l.start),a=this.x(l.end);return f===l.start&&a===l.end?l:new p.$TM(f.line,f.character,a.line,a.character)}x(l){if(!(l instanceof p.$SM))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:f,character:a}=l,n=!1;if(f<0)f=0,a=0,n=!0;else if(f>=this.f.length)f=this.f.length-1,a=this.f[f].length,n=!0;else{const i=this.f[f].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new p.$SM(f,a):l}y(l,f){const a=this.x(l);if(!f)f=C(this.m);else if((0,L.$ff)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const n=(0,M.$Zs)(a.character+1,(0,M.$Xs)(f),this.f[a.line],0);if(n)return new p.$TM(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$fP=m;class y{constructor(l,f,a){this.a=l,this.b=f,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gP=y}),define(ke[325],Ee([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(M);if(!S)throw new Error("Embedding vector provider not found");const A=await S.provideEmbeddingVector(p,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,p,$){const S=this.b;return this.b++,this.a.set(S,$),this.c.$registerAiEmbeddingVectorProvider(p,S),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$Hlc=L}),define(ke[69],Ee([1,0,6,32,7,21,5,20,60,3,8,23,15]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=e.$Skc=void 0;let v=y=class{constructor(f,a){this.b=new Map,this.c=new A.$zh,this.a=f.getProxy(u.$PM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),r=await o.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){y.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return y.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return y.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return y.e(r)}},async writeFile(i,r){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ce.wrap(r))}catch(o){return y.e(o)}},async delete(i,r){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(o){return y.e(o)}},async rename(i,r,o){try{return await n.a.$rename(i,r,{overwrite:!1,...o})}catch(t){return y.e(t)}},async copy(i,r,o){try{return await n.a.$copy(i,r,{overwrite:!1,...o})}catch(t){return y.e(t)}},isWritableFileSystem(i){const r=a.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(f,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await f.stat(n)).type&N.FileType.Directory))throw L.$8N.FileExists(`Unable to create folder '${n.scheme===m.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$al(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(a.basename(n)),n=a.dirname(n)}for(let r=i.length-1;r>=0;r--){n=a.joinPath(n,i[r]);try{await f.createDirectory(n)}catch(o){if(N.$al(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(f){if(f instanceof L.$8N)throw f;if(f instanceof N.$9k)switch(f.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(f.message);default:throw new L.$8N(f.message,f.name)}if(!(f instanceof Error))throw new L.$8N(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw L.$8N.Unavailable(f.message);switch(f.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(f.message);default:throw new L.$8N(f.message,f.name)}}addFileSystemProvider(f,a,n){return this.b.set(f,{impl:a,extUri:n?.isCaseSensitive?C.$Tg:C.$Vg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$Tg}};e.$Skc=v,e.$Skc=v=y=Je([qe(0,p.$cP),qe(1,$.$wkc)],v),e.$Tkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0,e.$Ukc=(0,u.$qi)("IExtensionStoragePaths");let p=class{constructor(S,A,C){this.d=A,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(S){return M.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,A=await this.g(S);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return M.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return M.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Vkc=p,e.$Vkc=p=Je([qe(0,N.$sP),qe(1,L.$Wj),qe(2,R.$Tkc)],p)}),define(ke[326],Ee([1,0,7,20,4]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;let R=class{constructor(p){this.a=new u.$fO(u.ColorThemeKind.Dark),this.b=new L.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$fO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$qmc=R,e.$qmc=R=Je([qe(0,N.$cP)],R)}),define(ke[70],Ee([1,0,22,4,3,228,5,12,88,6,28,20,7]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OCb=e.$NCb=e.TunnelDtoConverter=void 0;class y extends $.$cw{}var v;(function(f){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}f.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}f.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$NCb=(0,M.$qi)("IExtHostTunnelService");let l=class extends L.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(S.$PM.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const r=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new m.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,r,o){const t=[];for(const c of a){const h=this.r.get(c);if(!h)return[];t.push(...await Promise.all(n.map(async s=>{let w;try{w=await h.provider.providePortAttributes({port:s,pid:i,commandLine:r},o)}catch{w=await h.provider.providePortAttributes(s,i,r,o)}return{providedAttributes:w,port:s}})))}const g=t.filter(c=>!!c.providedAttributes);return g.length>0?g.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,o)=>await a.provideTunnel(r,o,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:r,disposeListener:o}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(r=>this.f(r.host,r.port,r.detail??""))),i=a.filter((r,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$OCb=l,e.$OCb=l=Je([qe(0,C.$cP),qe(1,A.$sP),qe(2,p.$Wj)],l)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,290,119,68,89,302,7]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_O=T,e.$aP=W,e.$bP=X;var w;(function(Le){function Fe(ee){const{selectionStartLineNumber:je,selectionStartColumn:Ke,positionLineNumber:_e,positionColumn:Qe}=ee,lt=new s.$SM(je-1,Ke-1),Et=new s.$SM(_e-1,Qe-1);return new s.$UM(lt,Et)}Le.to=Fe;function ye(ee){const{anchor:je,active:Ke}=ee;return{selectionStartLineNumber:je.line+1,selectionStartColumn:je.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Le.from=ye})(w||(e.Selection=w={}));var d;(function(Le){function Fe(ee){if(!ee)return;const{start:je,end:Ke}=ee;return{startLineNumber:je.line+1,startColumn:je.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Le.from=Fe;function ye(ee){if(!ee)return;const{startLineNumber:je,startColumn:Ke,endLineNumber:_e,endColumn:Qe}=ee;return new s.$TM(je-1,Ke-1,_e-1,Qe-1)}Le.to=ye})(d||(e.Range=d={}));var D;(function(Le){function Fe(ee){return{uri:ee.uri,range:d.from(ee.range)}}Le.from=Fe;function ye(ee){return new s.$4M(l.URI.revive(ee.uri),d.to(ee.range))}Le.to=ye})(D||(e.Location=D={}));var b;(function(Le){function Fe(ye){switch(ye){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Le.to=Fe})(b||(e.TokenType=b={}));var E;(function(Le){function Fe(ee){return new s.$SM(ee.lineNumber-1,ee.column-1)}Le.to=Fe;function ye(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Le.from=ye})(E||(e.Position=E={}));var k;(function(Le){function Fe(je,Ke,_e){return(0,u.$Hb)((0,u.$3b)(je).map(Qe=>ye(Qe,Ke,_e)))}Le.from=Fe;function ye(je,Ke,_e){if(typeof je=="string")return{$serialized:!0,language:je,isBuiltin:_e?.isBuiltin};if(je)return{$serialized:!0,language:je.language,scheme:ee(je.scheme,Ke),pattern:ce.from(je.pattern)??void 0,exclusive:je.exclusive,notebookType:je.notebookType,isBuiltin:_e?.isBuiltin}}function ee(je,Ke){return Ke&&typeof je=="string"?Ke.transformOutgoingScheme(je):je}})(k||(e.DocumentSelector=k={}));var P;(function(Le){function Fe(ee){switch(ee){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Le.from=Fe;function ye(ee){switch(ee){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Le.to=ye})(P||(e.DiagnosticTag=P={}));var I;(function(Le){function Fe(ee){let je;return ee.code&&((0,v.$4f)(ee.code)||(0,v.$8f)(ee.code)?je=String(ee.code):je={value:String(ee.code.value),target:ee.code.target}),{...d.from(ee.range),message:ee.message,source:ee.source,code:je,severity:F.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(j.from),tags:Array.isArray(ee.tags)?(0,u.$Hb)(ee.tags.map(P.from)):void 0}}Le.from=Fe;function ye(ee){const je=new s.$6M(d.to(ee),ee.message,F.to(ee.severity));return je.source=ee.source,je.code=(0,v.$4f)(ee.code)?ee.code:ee.code?.value,je.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(j.to),je.tags=ee.tags&&(0,u.$Hb)(ee.tags.map(P.to)),je}Le.to=ye})(I||(e.Diagnostic=I={}));var j;(function(Le){function Fe(ee){return{...d.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Le.from=Fe;function ye(ee){return new s.$5M(new s.$4M(ee.resource,d.to(ee)),ee.message)}Le.to=ye})(j||(e.DiagnosticRelatedInformation=j={}));var F;(function(Le){function Fe(ee){switch(ee){case s.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=Fe;function ye(ee){switch(ee){case n.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Le.to=ye})(F||(e.DiagnosticSeverity=F={}));var z;(function(Le){function Fe(ee){return typeof ee=="number"&&ee>=s.ViewColumn.One?ee-1:ee===s.ViewColumn.Beside?h.$ND:h.$MD}Le.from=Fe;function ye(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ye})(z||(e.ViewColumn=z={}));function O(Le){return typeof Le.range<"u"}function T(Le){return Le.length===0?!0:!!O(Le[0])}var B;(function(Le){function Fe(Qe){return Qe.map(Le.from)}Le.fromMany=Fe;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let lt;if(ye(Qe)){const{language:ut,value:ri}=Qe;lt={value:"```"+ut+`
`+ri+"\n```\n"}}else s.$gN.isMarkdownString(Qe)?lt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?lt={value:Qe}:lt={value:""};const Et=Object.create(null);lt.uris=Et;const Ft=ut=>{try{let ri=l.URI.parse(ut,!0);ri=ri.with({query:je(ri.query,Et)}),Et[ut]=ri}catch{}return""},qt=new $.marked.Renderer;return qt.link=Ft,qt.image=ut=>typeof ut=="string"?Ft(M.$Vk(ut).href):"",(0,$.marked)(lt.value,{renderer:qt}),lt}Le.from=ee;function je(Qe,lt){if(!Qe)return Qe;let Et;try{Et=(0,S.$Yh)(Qe)}catch{}if(!Et)return Qe;let Ft=!1;return Et=(0,C.$Yn)(Et,qt=>{if(l.URI.isUri(qt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ut]=qt,Ft=!0,ut}else return}),Ft?JSON.stringify(Et):Qe}function Ke(Qe){const lt=new s.$gN(Qe.value,Qe.supportThemeIcons);return lt.isTrusted=Qe.isTrusted,lt.supportHtml=Qe.supportHtml,lt.baseUri=Qe.baseUri?l.URI.from(Qe.baseUri):void 0,lt}Le.to=Ke;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Le.from(Qe)}Le.fromStrict=_e})(B||(e.MarkdownString=B={}));function W(Le){return T(Le)?Le.map(Fe=>({range:d.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?B.fromMany(Fe.hoverMessage):Fe.hoverMessage?B.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Le.map(Fe=>({range:d.from(Fe)}))}function X(Le){return typeof Le>"u"?Le:typeof Le=="string"?l.URI.file(Le):Le}var x;(function(Le){function Fe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?X(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Le.from=Fe})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var Y;(function(Le){function Fe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?X(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Le.from=Fe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var Z;(function(Le){function Fe(ye){if(typeof ye>"u")return ye;switch(ye){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Fe})(Z||(e.DecorationRangeBehavior=Z={}));var ue;(function(Le){function Fe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?Z.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Y.from(ye.light):void 0,dark:ye.dark?Y.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?X(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?x.from(ye.before):void 0,after:ye.after?x.from(ye.after):void 0}}Le.from=Fe})(ue||(e.DecorationRenderOptions=ue={}));var te;(function(Le){function Fe(ee){return{text:ee.newText,eol:ee.newEol&&Be.from(ee.newEol),range:d.from(ee.range)}}Le.from=Fe;function ye(ee){const je=new s.$YM(d.to(ee.range),ee.text);return je.newEol=typeof ee.eol>"u"?void 0:Be.to(ee.eol),je}Le.to=ye})(te||(e.TextEdit=te={}));var we;(function(Le){function Fe(ee,je){const Ke={edits:[]};if(ee instanceof s.$2M){const _e=new p.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&l.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let lt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?lt={type:"base64",value:(0,N.$We)(N.$Ce.wrap(Qe.options.contents))}:lt={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ke.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:lt},metadata:Qe.metadata})}else Qe._type===2?Ke.edits.push({resource:Qe.uri,textEdit:te.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:je?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ke.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:je?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:je?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:je?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(At.from)}})}return Ke}Le.from=Fe;function ye(ee){const je=new s.$2M,Ke=new p.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,lt=l.URI.revive(Qe.resource),Et=d.to(Qe.textEdit.range),Ft=Qe.textEdit.text,qt=Qe.textEdit.insertAsSnippet;let ut;qt?ut=s.$1M.replace(Et,new s.$3M(Ft)):ut=s.$YM.replace(Et,Ft);const ri=Ke.get(lt);ri?ri.push(ut):Ke.set(lt,[ut])}else je.renameFile(l.URI.revive(_e.oldResource),l.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ke)je.set(_e,Qe);return je}Le.to=ye})(we||(e.WorkspaceEdit=we={}));var Se;(function(Le){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function ye(je){return typeof Fe[je]=="number"?Fe[je]:6}Le.from=ye;function ee(je){for(const Ke in Fe)if(Fe[Ke]===je)return Number(Ke);return s.SymbolKind.Property}Le.to=ee})(Se||(e.SymbolKind=Se={}));var _;(function(Le){function Fe(ee){switch(ee){case s.SymbolTag.Deprecated:return 1}}Le.from=Fe;function ye(ee){switch(ee){case 1:return s.SymbolTag.Deprecated}}Le.to=ye})(_||(e.SymbolTag=_={}));var U;(function(Le){function Fe(ee){return{name:ee.name,kind:Se.from(ee.kind),tags:ee.tags&&ee.tags.map(_.from),containerName:ee.containerName,location:re.from(ee.location)}}Le.from=Fe;function ye(ee){const je=new s.$0M(ee.name,Se.to(ee.kind),ee.containerName,re.to(ee.location));return je.tags=ee.tags&&ee.tags.map(_.to),je}Le.to=ye})(U||(e.WorkspaceSymbol=U={}));var ne;(function(Le){function Fe(ee){const je={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),kind:Se.from(ee.kind),tags:ee.tags?.map(_.from)??[]};return ee.children&&(je.children=ee.children.map(Fe)),je}Le.from=Fe;function ye(ee){const je=new s.$$M(ee.name,ee.detail,Se.to(ee.kind),d.to(ee.range),d.to(ee.selectionRange));return(0,u.$Lb)(ee.tags)&&(je.tags=ee.tags.map(_.to)),ee.children&&(je.children=ee.children.map(ye)),je}Le.to=ye})(ne||(e.DocumentSymbol=ne={}));var $e;(function(Le){function Fe(ee){const je=new s.$cN(Se.to(ee.kind),ee.name,ee.detail||"",l.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return je._sessionId=ee._sessionId,je._itemId=ee._itemId,je}Le.to=Fe;function ye(ee,je,Ke){if(je=je??ee._sessionId,Ke=Ke??ee._itemId,je===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:Ke,name:ee.name,detail:ee.detail,kind:Se.from(ee.kind),uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(_.from)}}Le.from=ye})($e||(e.CallHierarchyItem=$e={}));var Pe;(function(Le){function Fe(ye){return new s.$dN($e.to(ye.from),ye.fromRanges.map(ee=>d.to(ee)))}Le.to=Fe})(Pe||(e.CallHierarchyIncomingCall=Pe={}));var se;(function(Le){function Fe(ye){return new s.$eN($e.to(ye.to),ye.fromRanges.map(ee=>d.to(ee)))}Le.to=Fe})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Le){function Fe(ee){return{range:ee.range&&d.from(ee.range),uri:ee.uri}}Le.from=Fe;function ye(ee){return new s.$4M(l.URI.revive(ee.uri),d.to(ee.range))}Le.to=ye})(re||(e.location=re={}));var oe;(function(Le){function Fe(ee){const je=ee,Ke=ee;return{originSelectionRange:je.originSelectionRange?d.from(je.originSelectionRange):void 0,uri:je.targetUri?je.targetUri:Ke.uri,range:d.from(je.targetRange?je.targetRange:Ke.range),targetSelectionRange:je.targetSelectionRange?d.from(je.targetSelectionRange):void 0}}Le.from=Fe;function ye(ee){return{targetUri:l.URI.revive(ee.uri),targetRange:d.to(ee.range),targetSelectionRange:ee.targetSelectionRange?d.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?d.to(ee.originSelectionRange):void 0}}Le.to=ye})(oe||(e.DefinitionLink=oe={}));var G;(function(Le){function Fe(ee){return{range:d.from(ee.range),contents:B.fromMany(ee.contents)}}Le.from=Fe;function ye(ee){return new s.$7M(ee.contents.map(B.to),d.to(ee.range))}Le.to=ye})(G||(e.Hover=G={}));var ie;(function(Le){function Fe(ee){return{range:d.from(ee.range),expression:ee.expression}}Le.from=Fe;function ye(ee){return new s.$2N(d.to(ee.range),ee.expression)}Le.to=ye})(ie||(e.EvaluatableExpression=ie={}));var me;(function(Le){function Fe(ee){if(ee instanceof s.$3N)return{type:"text",range:d.from(ee.range),text:ee.text};if(ee instanceof s.$4N)return{type:"variable",range:d.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof s.$5N)return{type:"expression",range:d.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Fe;function ye(ee){switch(ee.type){case"text":return{range:d.to(ee.range),text:ee.text};case"variable":return{range:d.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:d.to(ee.range),expression:ee.expression}}}Le.to=ye})(me||(e.InlineValue=me={}));var pe;(function(Le){function Fe(ee){return{frameId:ee.frameId,stoppedLocation:d.from(ee.stoppedLocation)}}Le.from=Fe;function ye(ee){return new s.$6N(ee.frameId,d.to(ee.stoppedLocation))}Le.to=ye})(pe||(e.InlineValueContext=pe={}));var Ae;(function(Le){function Fe(ee){return{range:d.from(ee.range),kind:ee.kind}}Le.from=Fe;function ye(ee){return new s.$8M(d.to(ee.range),ee.kind)}Le.to=ye})(Ae||(e.DocumentHighlight=Ae={}));var fe;(function(Le){function Fe(ee){return{uri:ee.uri,highlights:ee.highlights.map(Ae.from)}}Le.from=Fe;function ye(ee){return new s.$9M(l.URI.revive(ee.uri),ee.highlights.map(Ae.to))}Le.to=ye})(fe||(e.MultiDocumentHighlight=fe={}));var De;(function(Le){function Fe(ye){switch(ye){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Le.to=Fe})(De||(e.CompletionTriggerKind=De={}));var Ie;(function(Le){function Fe(ye){return{triggerKind:De.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Le.to=Fe})(Ie||(e.CompletionContext=Ie={}));var Te;(function(Le){function Fe(ee){switch(ee){case s.CompletionItemTag.Deprecated:return 1}}Le.from=Fe;function ye(ee){switch(ee){case 1:return s.CompletionItemTag.Deprecated}}Le.to=ye})(Te||(e.CompletionItemTag=Te={}));var q;(function(Le){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ye(Ke){return Fe.get(Ke)??9}Le.from=ye;const ee=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function je(Ke){return ee.get(Ke)??s.CompletionItemKind.Property}Le.to=je})(q||(e.CompletionItemKind=q={}));var V;(function(Le){function Fe(ye,ee){const je=new s.$mN(ye.label);return je.insertText=ye.insertText,je.kind=q.to(ye.kind),je.tags=ye.tags?.map(Te.to),je.detail=ye.detail,je.documentation=M.$Pk(ye.documentation)?B.to(ye.documentation):ye.documentation,je.sortText=ye.sortText,je.filterText=ye.filterText,je.preselect=ye.preselect,je.commitCharacters=ye.commitCharacters,f.$kt.isIRange(ye.range)?je.range=d.to(ye.range):typeof ye.range=="object"&&(je.range={inserting:d.to(ye.range.insert),replacing:d.to(ye.range.replace)}),je.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?je.insertText=new s.$3M(ye.insertText):(je.insertText=ye.insertText,je.textEdit=je.range instanceof s.$TM?new s.$YM(je.range,je.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(je.additionalTextEdits=ye.additionalTextEdits.map(Ke=>te.to(Ke))),je.command=ee&&ye.command?ee.fromInternal(ye.command):void 0,je}Le.to=Fe})(V||(e.CompletionItem=V={}));var J;(function(Le){function Fe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:B.fromStrict(ee.documentation)}}Le.from=Fe;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?B.to(ee.documentation):ee.documentation}}Le.to=ye})(J||(e.ParameterInformation=J={}));var Q;(function(Le){function Fe(ee){return{label:ee.label,documentation:B.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.from):[],activeParameter:ee.activeParameter}}Le.from=Fe;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?B.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.to):[],activeParameter:ee.activeParameter}}Le.to=ye})(Q||(e.SignatureInformation=Q={}));var he;(function(Le){function Fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.from):[]}}Le.from=Fe;function ye(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.to):[]}}Le.to=ye})(he||(e.SignatureHelp=he={}));var be;(function(Le){function Fe(ye,ee){const je=new s.$lN(E.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ze.to.bind(void 0,ye)),ee.kind&&Ve.to(ee.kind));return je.textEdits=ee.textEdits&&ee.textEdits.map(te.to),je.tooltip=M.$Pk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,je.paddingLeft=ee.paddingLeft,je.paddingRight=ee.paddingRight,je}Le.to=Fe})(be||(e.InlayHint=be={}));var ze;(function(Le){function Fe(ye,ee){const je=new s.$kN(ee.label);return je.tooltip=M.$Pk(ee.tooltip)?B.to(ee.tooltip):ee.tooltip,a.Command.is(ee.command)&&(je.command=ye.fromInternal(ee.command)),ee.location&&(je.location=re.to(ee.location)),je}Le.to=Fe})(ze||(e.InlayHintLabelPart=ze={}));var Ve;(function(Le){function Fe(ee){return ee}Le.from=Fe;function ye(ee){return ee}Le.to=ye})(Ve||(e.InlayHintKind=Ve={}));var Ye;(function(Le){function Fe(ee){return{range:d.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Le.from=Fe;function ye(ee){let je;if(ee.url)try{je=typeof ee.url=="string"?l.URI.parse(ee.url,!0):l.URI.revive(ee.url)}catch{}return new s.$rN(d.to(ee.range),je)}Le.to=ye})(Ye||(e.DocumentLink=Ye={}));var it;(function(Le){function Fe(ee){const je=new s.$uN(ee.label);return ee.textEdit&&(je.textEdit=te.to(ee.textEdit)),ee.additionalTextEdits&&(je.additionalTextEdits=ee.additionalTextEdits.map(Ke=>te.to(Ke))),je}Le.to=Fe;function ye(ee){return{label:ee.label,textEdit:ee.textEdit?te.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(je=>te.from(je)):void 0}}Le.from=ye})(it||(e.ColorPresentation=it={}));var ot;(function(Le){function Fe(ee){return new s.$sN(ee[0],ee[1],ee[2],ee[3])}Le.to=Fe;function ye(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Le.from=ye})(ot||(e.Color=ot={}));var nt;(function(Le){function Fe(ee){return{range:d.from(ee.range)}}Le.from=Fe;function ye(ee){return new s.$bN(d.to(ee.range))}Le.to=ye})(nt||(e.SelectionRange=nt={}));var st;(function(Le){function Fe(ye){switch(ye){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Le.to=Fe})(st||(e.TextDocumentSaveReason=st={}));var Ce;(function(Le){function Fe(ee){switch(ee){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Fe;function ye(ee){switch(ee){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Le.to=ye})(Ce||(e.TextEditorLineNumbersStyle=Ce={}));var Be;(function(Le){function Fe(ee){if(ee===s.EndOfLine.CRLF)return 1;if(ee===s.EndOfLine.LF)return 0}Le.from=Fe;function ye(ee){if(ee===1)return s.EndOfLine.CRLF;if(ee===0)return s.EndOfLine.LF}Le.to=ye})(Be||(e.EndOfLine=Be={}));var He;(function(Le){function Fe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Fe})(He||(e.ProgressLocation=He={}));var Ne;(function(Le){function Fe(ee){const je={start:ee.start+1,end:ee.end+1};return ee.kind&&(je.kind=Xe.from(ee.kind)),je}Le.from=Fe;function ye(ee){const je={start:ee.start-1,end:ee.end-1};return ee.kind&&(je.kind=Xe.to(ee.kind)),je}Le.to=ye})(Ne||(e.FoldingRange=Ne={}));var Xe;(function(Le){function Fe(ee){if(ee)switch(ee){case s.FoldingRangeKind.Comment:return a.$6t.Comment;case s.FoldingRangeKind.Imports:return a.$6t.Imports;case s.FoldingRangeKind.Region:return a.$6t.Region}}Le.from=Fe;function ye(ee){if(ee)switch(ee.value){case a.$6t.Comment.value:return s.FoldingRangeKind.Comment;case a.$6t.Imports.value:return s.FoldingRangeKind.Imports;case a.$6t.Region.value:return s.FoldingRangeKind.Region}}Le.to=ye})(Xe||(e.FoldingRangeKind=Xe={}));var ae;(function(Le){function Fe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?d.from(ye.selection):void 0,override:typeof ye.override=="boolean"?r.$dF.id:void 0}}Le.from=Fe})(ae||(e.TextEditorOpenOptions=ae={}));var ce;(function(Le){function Fe(Ke){return Ke instanceof s.$PN?Ke.toJSON():typeof Ke=="string"?Ke:ye(Ke)||ee(Ke)?new s.$PN(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Le.from=Fe;function ye(Ke){const _e=Ke;return _e?l.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(Ke){const _e=Ke;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function je(Ke){return typeof Ke=="string"?Ke:new s.$PN(l.URI.revive(Ke.baseUri),Ke.pattern)}Le.to=je})(ce||(e.GlobPattern=ce={}));var Re;(function(Le){function Fe(ye){if(ye){if(Array.isArray(ye))return ye.map(Fe);if(typeof ye=="string")return ye;{const ee=ye;return{language:ee.language,scheme:ee.scheme,pattern:ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Le.from=Fe})(Re||(e.LanguageSelector=Re={}));var Ge;(function(Le){function Fe(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(je=>Array.isArray(je)&&je.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&l.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(_e=>_e instanceof s.$TM)))}Le.is=Fe;function ye(ee){return{documents:ee.documents.map(je=>je.map(Ke=>({uri:l.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(_e=>d.from(_e))})))}}Le.from=ye})(Ge||(e.MappedEditsContext=Ge={}));var Me;(function(Le){function Fe(ee){return{start:ee.start,end:ee.end}}Le.from=Fe;function ye(ee){return new s.$gO(ee.start,ee.end)}Le.to=ye})(Me||(e.NotebookRange=Me={}));var tt;(function(Le){function Fe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Le.to=Fe;function ye(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Le.from=ye})(tt||(e.NotebookCellExecutionSummary=tt={}));var ht;(function(Le){function Fe(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Le.to=Fe})(ht||(e.NotebookCellExecutionState=ht={}));var wt;(function(Le){function Fe(ee){switch(ee){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=Fe;function ye(ee){switch(ee){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Le.to=ye})(wt||(e.NotebookCellKind=wt={}));var Lt;(function(Le){function Fe(ee){const je={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ke of ee.cells)s.$hO.validate(Ke),je.cells.push(At.from(Ke));return je}Le.from=Fe;function ye(ee){const je=new s.$iO(ee.cells.map(At.to));return(0,v.$eg)(ee.metadata)||(je.metadata=ee.metadata),je}Le.to=ye})(Lt||(e.NotebookData=Lt={}));var At;(function(Le){function Fe(ee){return{cellKind:wt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:tt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(_t.from):[]}}Le.from=Fe;function ye(ee){return new s.$hO(wt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(_t.to):void 0,ee.metadata,ee.internalMetadata?tt.to(ee.internalMetadata):void 0)}Le.to=ye})(At||(e.NotebookCellData=At={}));var xt;(function(Le){function Fe(ee){return{mime:ee.mime,valueBytes:N.$Ce.wrap(ee.data)}}Le.from=Fe;function ye(ee){return new s.$jO(ee.valueBytes.buffer,ee.mime)}Le.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(Le){function Fe(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Le.from=Fe;function ye(ee){const je=ee.items.map(xt.to);return new s.$kO(je,ee.outputId,ee.metadata)}Le.to=ye})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(Le){function Fe(je){return ee(je)?{include:ce.from(je.include)??void 0,exclude:ce.from(je.exclude)??void 0}:ce.from(je)??void 0}Le.from=Fe;function ye(je){return ee(je)?{include:ce.to(je.include),exclude:ce.to(je.exclude)}:ce.to(je)}Le.to=ye;function ee(je){const Ke=je;return Ke?!(0,v.$ag)(Ke.include)&&!(0,v.$ag)(Ke.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Vt;(function(Le){function Fe(ye,ee,je){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ke,je),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Le.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var Xt;(function(Le){function Fe(ye,ee,je){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ee.toInternal(Ke,je),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Le.from=Fe})(Xt||(e.NotebookKernelSourceAction=Xt={}));var et;(function(Le){function Fe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Le.from=Fe})(et||(e.NotebookDocumentContentOptions=et={}));var si;(function(Le){function Fe(ee){return{uri:ee.uri,provides:ee.provides}}Le.from=Fe;function ye(ee){return new s.$mO(l.URI.revive(ee.uri),ee.provides)}Le.to=ye})(si||(e.NotebookRendererScript=si={}));var Yt;(function(Le){function Fe(ee){return{message:B.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:d.from(ee.location.range),uri:ee.location.uri}}}Le.from=Fe;function ye(ee){const je=new s.$sO(typeof ee.message=="string"?ee.message:B.to(ee.message));return je.actualOutput=ee.actual,je.expectedOutput=ee.expected,je.contextValue=ee.contextValue,je.location=ee.location?re.to(ee.location):void 0,je}Le.to=ye})(Yt||(e.TestMessage=Yt={}));var dt;(function(Le){Le.namespace=c.$GL,Le.denamespace=c.$HL})(dt||(e.TestTag=dt={}));var vt;(function(Le){function Fe(ee){const je=(0,i.$$O)(ee).controllerId;return{extId:g.$BL.fromExtHostTestItem(ee,je).toString(),label:ee.label,uri:l.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ke=>dt.namespace(je,Ke.id)),range:f.$kt.lift(d.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&B.fromStrict(ee.error)||null}}Le.from=Fe;function ye(ee){return{parent:void 0,error:void 0,id:g.$BL.fromString(ee.extId).localId,label:ee.label,uri:l.URI.revive(ee.uri),tags:(ee.tags||[]).map(je=>{const{tagId:Ke}=dt.denamespace(je);return new s.$tO(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Le.toPlain=ye})(vt||(e.TestItem=vt={})),function(Le){function Fe(ee){return{id:ee.id}}Le.from=Fe;function ye(ee){return new s.$tO(ee.id)}Le.to=ye}(dt||(e.TestTag=dt={}));var ti;(function(Le){const Fe=(ee,je)=>{const Ke=ee.value;if(!Ke)return;const _e={...vt.toPlain(Ke.item),parent:je,taskStates:Ke.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(lt=>lt.type===0).map(Yt.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const lt=Fe(Qe,_e);lt&&_e.children.push(lt)}return _e};function ye(ee){const je=new m.$4O;for(const Qe of ee.items)je.insert(g.$BL.fromString(Qe.item.extId).path,Qe);const Ke=[je.nodes],_e=[];for(;Ke.length;)for(const Qe of Ke.pop())Qe.value?_e.push(Qe):Qe.children&&Ke.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>Fe(Qe)).filter(v.$_f)}}Le.to=ye})(ti||(e.TestResults=ti={}));var Zt;(function(Le){function Fe(Ke){return{covered:Ke.covered,total:Ke.total}}function ye(Ke){return"line"in Ke?E.from(Ke):d.from(Ke)}function ee(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ye(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Ke.name,count:Ke.executed,location:ye(Ke.location)}}Le.fromDetails=ee;function je(Ke,_e){return s.$vO(_e.statementCoverage),s.$vO(_e.branchCoverage),s.$vO(_e.declarationCoverage),{id:Ke,uri:_e.uri,statement:Fe(_e.statementCoverage),branch:_e.branchCoverage&&Fe(_e.branchCoverage),declaration:_e.declarationCoverage&&Fe(_e.declarationCoverage)}}Le.fromFile=je})(Zt||(e.TestCoverage=Zt={}));var zt;(function(Le){function Fe(ye){switch(ye){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Le.to=Fe})(zt||(e.CodeActionTriggerKind=zt={}));var gt;(function(Le){function Fe(ee){const je=new s.$AO(Se.to(ee.kind),ee.name,ee.detail||"",l.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return je._sessionId=ee._sessionId,je._itemId=ee._itemId,je}Le.to=Fe;function ye(ee,je,Ke){if(je=je??ee._sessionId,Ke=Ke??ee._itemId,je===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:Ke,kind:Se.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(_.from)}}Le.from=ye})(gt||(e.TypeHierarchyItem=gt={}));var Ut;(function(Le){function Fe(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Le.from=Fe})(Ut||(e.ViewBadge=Ut={}));var Wt;(function(Le){function Fe(Ke,_e,Qe){const lt=_e.fileData;return lt?new s.$HN(new s.$IN(lt.name,l.URI.revive(lt.uri),lt.id,(0,R.$db)(()=>Qe(lt.id)))):Ke===A.$Hs.uriList&&_e.uriListData?new s.$GN(je(_e.uriListData)):new s.$GN(_e.asString)}Le.to=Fe;async function ye(Ke,_e){const Qe=await _e.asString();if(Ke===A.$Hs.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const lt=_e.asFile();return{asString:Qe,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}Le.from=ye;function ee(Ke){return L.$Kt.split(Ke).map(_e=>{if(_e.startsWith("#"))return _e;try{return l.URI.parse(_e)}catch{}return _e})}function je(Ke){return L.$Kt.create(Ke.map(_e=>typeof _e=="string"?_e:l.URI.revive(_e)))}})(Wt||(e.DataTransferItem=Wt={}));var Kt;(function(Le){function Fe(ee,je){const Ke=ee.items.map(([_e,Qe])=>[_e,Wt.to(_e,Qe,je)]);return new s.$JN(Ke)}Le.toDataTransfer=Fe;async function ye(ee){const je={items:[]},Ke=[];for(const[_e,Qe]of ee)Ke.push((async()=>{je.items.push([_e,await Wt.from(_e,Qe)])})());return await Promise.all(Ke),je}Le.from=ye})(Kt||(e.DataTransfer=Kt={}));var Ze;(function(Le){function Fe(ee,je){return{kind:"reply",agentId:ee.participant??je?.agentId??"",subCommand:ee.command??je?.command,message:ee.prompt,title:ee.label}}Le.from=Fe;function ye(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Le.to=ye})(Ze||(e.ChatFollowup=Ze={}));var ui;(function(Le){function Fe(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Le.from=Fe})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(Le){function Fe(ee){switch(ee.role){case 0:return new s.$YO(ee.content);case 1:return new s.$ZO(ee.content);case 2:return new s.$1O(ee.content)}}Le.to=Fe;function ye(ee){if(ee instanceof s.$YO)return{role:0,content:ee.content};if(ee instanceof s.$ZO)return{role:1,content:ee.content};if(ee instanceof s.$1O)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Le.from=ye})(Ht||(e.LanguageModelMessage=Ht={}));var Bt;(function(Le){function Fe(je){const Ke={};for(const _e of Object.keys(je))Ke[_e]=je[_e].map(Le.to);return Ke}Le.objectTo=Fe;function ye(je){return{level:mt.to(je.level),kind:je.kind,value:(0,l.$wc)(je.value)?l.URI.revive(je.value):je.value,description:je.description}}Le.to=ye;function ee(je){return{level:mt.from(je.level),kind:je.kind,value:je.value,description:je.description}}Le.from=ee})(Bt||(e.ChatVariable=Bt={}));var mt;(function(Le){function Fe(ee){switch(ee){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Le.to=Fe;function ye(ee){switch(ee){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Le.from=ye})(mt||(e.ChatVariableLevel=mt={}));var Tt;(function(Le){function Fe(ye){switch(ye){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=Fe})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(Le){function Fe(ee){return{kind:"markdownContent",content:B.from(ee.value)}}Le.from=Fe;function ye(ee){return new s.$NO(B.to(ee.content))}Le.to=ye})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var jt;(function(Le){function Fe(ee){return{kind:"markdownVuln",content:B.from(ee.value),vulnerabilities:ee.vulnerabilities}}Le.from=Fe;function ye(ee){return new s.$OO(B.to(ee.content),ee.vulnerabilities)}Le.to=ye})(jt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=jt={}));var ii;(function(Le){function Fe(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Le.from=Fe;function ye(ee){return new s.$PO(ee.agentId,ee.command)}Le.to=ye})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(Le){function Fe(ee){const{value:je,baseUri:Ke}=ee;function _e(Qe,lt){return Qe.map(Et=>{const Ft=l.URI.joinPath(lt,Et.name);return{label:Et.name,uri:Ft,children:Et.children&&_e(Et.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,y.$1g)(Ke),uri:Ke,children:_e(je,Ke)}}}Le.from=Fe;function ye(ee){const je=(0,S.$Zh)(ee.treeData);function Ke(lt){return lt.map(Et=>({name:Et.label,children:Et.children&&Ke(Et.children)}))}const _e=je.uri,Qe=je.children?Ke(je.children):[];return new s.$QO(Qe,_e)}Le.to=ye})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(Le){function Fe(ee){return{kind:"inlineReference",name:ee.title,inlineReference:l.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=Fe;function ye(ee){const je=(0,S.$Zh)(ee);return new s.$RO(l.URI.isUri(je.inlineReference)?je.inlineReference:D.to(je.inlineReference),ee.name)}Le.to=ye})(ni||(e.ChatResponseAnchorPart=ni={}));var Nt;(function(Le){function Fe(ee){return{kind:"progressMessage",content:B.from(ee.value)}}Le.from=Fe;function ye(ee){return new s.$SO(ee.content.value)}Le.to=ye})(Nt||(e.ChatResponseProgressPart=Nt={}));var Ot;(function(Le){function Fe(ee,je,Ke){return{kind:"command",command:je.toInternal(ee.value,Ke)??{command:ee.value.command,title:ee.value.title}}}Le.from=Fe;function ye(ee,je){return new s.$TO(je.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Le.to=ye})(Ot||(e.ChatResponseCommandButtonPart=Ot={}));var It;(function(Le){function Fe(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(je=>te.from(je))}}Le.from=Fe;function ye(ee){return new s.$VO(l.URI.revive(ee.uri),ee.edits.map(je=>te.to(je)))}Le.to=ye})(It||(e.ChatResponseTextEditPart=It={}));var St;(function(Le){function Fe(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:l.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:D.from(ee.value.value)}}:{kind:"reference",reference:l.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Le.from=Fe;function ye(ee){const je=(0,S.$Zh)(ee),Ke=_e=>l.URI.isUri(_e)?_e:D.to(_e);return new s.$UO("variableName"in je.reference?{variableName:je.reference.variableName,value:je.reference.value&&Ke(je.reference.value)}:Ke(je.reference))}Le.to=ye})(St||(e.ChatResponseReferencePart=St={}));var bt;(function(Le){function Fe(je,Ke,_e){return je instanceof s.$NO?Rt.from(je):je instanceof s.$RO?ni.from(je):je instanceof s.$UO?St.from(je):je instanceof s.$SO?Nt.from(je):je instanceof s.$QO?Gt.from(je):je instanceof s.$TO?Ot.from(je,Ke,_e):je instanceof s.$VO?It.from(je):je instanceof s.$OO?jt.from(je):je instanceof s.$PO?ii.from(je):{kind:"markdownContent",content:B.from("")}}Le.from=Fe;function ye(je,Ke){switch(je.kind){case"reference":return St.to(je);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(je,Ke)}}Le.to=ye;function ee(je,Ke){switch(je.kind){case"markdownContent":return Rt.to(je);case"inlineReference":return ni.to(je);case"progressMessage":return;case"treeData":return Gt.to(je);case"command":return Ot.to(je,Ke)}}Le.toContent=ee})(bt||(e.ChatResponsePart=bt={}));var Ct;(function(Le){function Fe(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(Dt.to),location:li.to(ye.location)}}Le.to=Fe})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Le){function Fe(ye){switch(ye){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Le.to=Fe})(li||(e.ChatLocation=li={}));var Dt;(function(Le){function Fe(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(Bt.to)}}Le.to=Fe})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(Le){function Fe(ye){return{label:ye.label,values:ye.values.map(Bt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Le.from=Fe})(hi||(e.ChatAgentCompletionItem=hi={}));var Jt;(function(Le){function Fe(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Le.to=Fe})(Jt||(e.ChatAgentResult=Jt={}));var wi;(function(Le){function Fe(ye,ee,je){if(ee.action.kind==="vote")return;const Ke=Jt.to(ye);if(ee.action.kind==="command"){const _e=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:je.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Ke}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:Ze.to(ee.action.followup)},result:Ke}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:Ke}:{action:ee.action,result:Ke}}Le.to=Fe})(wi||(e.ChatAgentUserActionEvent=wi={}));var ei;(function(Le){function Fe(ye,ee,je){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ee.toInternal(ye,je)}Le.from=Fe})(ei||(e.TerminalQuickFix=ei={}));var vi;(function(Le){function Fe(ye){return{kind:kt.to(ye.kind)}}Le.to=Fe})(vi||(e.PartialAcceptInfo=vi={}));var kt;(function(Le){function Fe(ye){switch(ye){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Le.to=Fe})(kt||(e.PartialAcceptTriggerKind=kt={}));var $i;(function(Le){function Fe(ye,ee){return{id:ee,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Le.from=Fe})($i||(e.DebugTreeItem=$i={}))}),define(ke[327],Ee([1,0,6,20,16,48]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;let M=class{constructor($,S){this.a=$.getProxy(u.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>S.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,S,A){const C=new R.$lw(L.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,A?.isRefactoring??!1)}};e.$Ekc=M,e.$Ekc=M=Je([qe(0,N.$cP)],M)}),define(ke[328],Ee([1,0,19,8,47,4,39,3,40,18,2,25,6,16,7,291,26]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class a{constructor(o,t,g,c,h){this.i=o,this.j=t,this.k=g,this.l=c,this.m=h,this.b=$.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(c){if(o.c){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,c),h}};const o=this;this.b.reset();const g=c=>{typeof this.d>"u"&&"content"in c&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,c)};this.g={markdown(c){t(this.markdown);const h=new v.$NO(c),s=y.ChatResponseMarkdownPart.from(h);return g(s),this},markdownWithVulnerabilities(c,h){t(this.markdown),h&&(0,f.$xG)(o.i,"chatParticipantAdditions");const s=new v.$OO(c,h),w=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return g(w),this},filetree(c,h){t(this.filetree);const s=new v.$QO(c,h),w=y.ChatResponseFilesPart.from(s);return g(w),this},anchor(c,h){t(this.anchor);const s=new v.$RO(c,h),w=y.ChatResponseAnchorPart.from(s);return g(w),this},button(c){t(this.anchor);const h=new v.$TO(c),s=y.ChatResponseCommandButtonPart.from(h,o.l,o.m);return g(s),this},progress(c){t(this.progress);const h=new v.$SO(c),s=y.ChatResponseProgressPart.from(h);return g(s),this},reference(c){if(t(this.reference),"variableName"in c&&!c.value){const h=o.j.variables.variables.find(s=>s.name===c.variableName);if(h){let s;if(h.references?.length)s=h.references.map(w=>({kind:"reference",reference:{variableName:c.variableName,value:w.reference}}));else{const w=new v.$UO(c);s=[y.ChatResponseReferencePart.from(w)]}return s.forEach(w=>g(w)),this}}else{const h=new v.$UO(c),s=y.ChatResponseReferencePart.from(h);g(s)}return this},textEdit(c,h){t(this.textEdit),(0,f.$xG)(o.i,"chatParticipantAdditions");const s=new v.$VO(c,h),w=y.ChatResponseTextEditPart.from(s);return g(w),this},detectedParticipant(c,h){t(this.detectedParticipant),(0,f.$xG)(o.i,"chatParticipantAdditions");const s=new v.$PO(c,h),w=y.ChatResponseDetectedParticipantPart.from(s);return g(w),this},push(c){if(t(this.push),(c instanceof v.$VO||c instanceof v.$OO||c instanceof v.$PO)&&(0,f.$xG)(o.i,"chatParticipantAdditions"),c instanceof v.$UO)this.reference(c.value);else{const h=y.ChatResponsePart.from(c,o.l,o.m);g(h)}return this}}}return this.g}}class n{static{this.b=0}constructor(o,t,g){this.i=t,this.j=g,this.c=new Map,this.g=new p.$4c,this.d=o.getProxy(m.$PM.MainThreadChatAgents2)}transferActiveChat(o){this.d.$transferActiveChatSession(o)}createChatAgent(o,t,g){const c=n.b++,h=new i(o,t,this.d,c,g);return this.c.set(c,h),this.d.$registerAgent(c,o.identifier,t,{},void 0),h.apiAgent}createDynamicChatAgent(o,t,g,c,h){const s=n.b++,w=new i(o,t,this.d,s,h);return this.c.set(s,w),this.d.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:g,description:c}),w.apiAgent}async $invokeAgent(o,t,g,c){const h=this.c.get(o);if(!h)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this.g.get(t.sessionId);s||(s=new p.$Tc,this.g.set(t.sessionId,s));const w=new a(h.extension,t,this.d,this.j.converter,s);try{const d=await this.k(t.agentId,g),D=h.invoke(y.ChatAgentRequest.to(t),{history:d},w.apiObject,c);return await(0,N.$eh)(Promise.resolve(D).then(b=>{if(b?.metadata)try{JSON.stringify(b.metadata)}catch(E){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.i.error(`[${h.extension.identifier.value}] [@${h.id}] ${k}`,h.extension),{errorDetails:{message:k},timings:w.timings}}return{errorDetails:b?.errorDetails,timings:w.timings,metadata:b?.metadata}}),c)}catch(d){return this.i.error(d,h.extension),{errorDetails:{message:(0,L.$bj)(d),responseIsIncomplete:!0}}}finally{w.close()}}async k(o,t){const g=[];for(const c of t.history){const h=y.ChatAgentResult.to(c.result),s=o===c.request.agentId?h:{...h,metadata:void 0};g.push(new v.$WO(c.request.message,c.request.command,c.request.variables.variables.map(y.ChatAgentResolvedVariable.to),c.request.agentId));const w=(0,u.$Hb)(c.response.map(d=>y.ChatResponsePart.toContent(d,this.j.converter)));g.push(new v.$XO(w,s,c.request.agentId,c.request.command))}return g}$releaseSession(o){this.g.deleteAndDispose(o)}async $provideFollowups(o,t,g,c,h){const s=this.c.get(t);if(!s)return Promise.resolve([]);const w=await this.k(s.id,c),d=y.ChatAgentResult.to(g);return(await s.provideFollowups(d,{history:w},h)).filter(D=>{const b=!D.participant||M.Iterable.some(this.c.values(),E=>E.id===D.participant&&C.$Lm.equals(E.extension.identifier,s.extension.identifier));return b||this.i.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),b}).map(D=>y.ChatFollowup.from(D,o))}$acceptFeedback(o,t,g,c){const h=this.c.get(o);if(!h)return;const s=y.ChatAgentResult.to(t);let w;switch(g){case l.InteractiveSessionVoteDirection.Down:w=v.ChatResultFeedbackKind.Unhelpful;break;case l.InteractiveSessionVoteDirection.Up:w=v.ChatResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(c?{result:s,kind:w,reportIssue:c}:{result:s,kind:w}))}$acceptAction(o,t,g){const c=this.c.get(o);if(!c||g.action.kind==="vote")return;const h=y.ChatAgentUserActionEvent.to(t,g,this.j.converter);h&&c.acceptAction(Object.freeze(h))}async $invokeCompletionProvider(o,t,g){const c=this.c.get(o);return c?(await c.invokeCompletionProvider(t,g)).map(y.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(o,t,g){const c=this.c.get(o);if(c)return await c.provideWelcomeMessage(y.ChatLocation.to(t),g)}async $provideSampleQuestions(o,t,g){const c=this.c.get(o);if(c)return(await c.provideSampleQuestions(y.ChatLocation.to(t),g)).map(h=>y.ChatFollowup.from(h,void 0))}}e.$Fkc=n;class i{constructor(o,t,g,c,h){this.extension=o,this.id=t,this.t=g,this.u=c,this.w=h,this.m=new R.$be,this.n=new R.$be}acceptFeedback(o){this.m.fire(o)}acceptAction(o){this.n.fire(o)}async invokeCompletionProvider(o,t){return this.p?await this.p.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,g){if(!this.b)return[];const c=await this.b.provideFollowups(o,t,g);return c?c.filter(h=>!(h&&"commandId"in h)).filter(h=>!(h&&"message"in h)):[]}async provideWelcomeMessage(o,t){if(!this.q)return[];const g=await this.q.provideWelcomeMessage(o,t);return g?g.map(c=>typeof c=="string"?c:y.MarkdownString.from(c)):[]}async provideSampleQuestions(o,t){if(!this.q||!this.q.provideSampleQuestions)return[];const g=await this.q.provideSampleQuestions(o,t);return g||[]}get apiAgent(){let o=!1,t=!1;const g=()=>{o||t||(t=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof v.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:y.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.s}),t=!1}))},c=this;return{get id(){return c.id},get fullName(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.c??c.extension.displayName??c.extension.name},set fullName(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.c=h,g()},get iconPath(){return c.d},set iconPath(h){c.d=h,g()},get requestHandler(){return c.w},set requestHandler(h){(0,S.$bg)(typeof h=="function","Invalid request handler"),c.w=h},get followupProvider(){return c.b},set followupProvider(h){c.b=h,g()},get isDefault(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.g},set isDefault(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.g=h,g()},get helpTextPrefix(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.i},set helpTextPrefix(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.i=h,g()},get helpTextVariablesPrefix(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.j},set helpTextVariablesPrefix(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.j=h,g()},get helpTextPostfix(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.k},set helpTextPostfix(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.k=h,g()},get isSecondary(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.l},set isSecondary(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.l=h,g()},get supportIssueReporting(){return(0,f.$xG)(c.extension,"chatParticipantAdditions"),c.o},set supportIssueReporting(h){(0,f.$xG)(c.extension,"chatParticipantAdditions"),c.o=h,g()},get onDidReceiveFeedback(){return c.m.event},set participantVariableProvider(h){if((0,f.$xG)(c.extension,"chatParticipantAdditions"),c.p=h,h){if(!h.triggerCharacters.length)throw new Error("triggerCharacters are required");c.t.$registerAgentCompletionsProvider(c.u,h.triggerCharacters)}else c.t.$unregisterAgentCompletionsProvider(c.u)},get participantVariableProvider(){return(0,f.$xG)(c.extension,"chatParticipantAdditions"),c.p},set welcomeMessageProvider(h){(0,f.$xG)(c.extension,"defaultChatParticipant"),c.q=h,g()},get welcomeMessageProvider(){return(0,f.$xG)(c.extension,"defaultChatParticipant"),c.q},onDidPerformAction:(0,f.$wG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(h){c.s=h,g()},get requester(){return c.s},dispose(){o=!0,c.b=void 0,c.m.dispose(),c.t.$unregisterAgent(c.u)}}}invoke(o,t,g,c){return this.w(o,t,g,c)}}}),define(ke[329],Ee([1,0,13,3,6,16,7,26]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class ${static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$PM.MainThreadChatVariables)}async $resolveVariable(C,m,y,v){const l=this.b.get(C);if(l)try{if(l.resolver.resolve2){(0,p.$xG)(l.extension,"chatParticipantAdditions");const f=new S(m,this.c),a=await l.resolver.resolve2(l.data.name,{prompt:y},f.apiObject,v);if(a)return a.map(R.ChatVariable.from)}else{const f=await l.resolver.resolve(l.data.name,{prompt:y},v);if(f)return f.map(R.ChatVariable.from)}}catch(f){(0,u.$2)(f)}}registerVariableResolver(C,m,y,v){const l=$.a++;return this.b.set(l,{extension:C,data:{name:m,description:y},resolver:v}),this.c.$registerVariable(l,{name:m,description:y}),(0,N.$Sc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Gkc=$;class S{constructor(C,m){this.c=C,this.d=m,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let m=function(v){if(C.a){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,v),l}};const C=this,y=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){m(this.progress);const l=new M.$SO(v),f=R.ChatResponseProgressPart.from(l);return y(f),this},reference(v){m(this.reference);const l=new M.$UO(v),f=R.ChatResponseReferencePart.from(l);return y(f),this},push(v){return m(this.push),v instanceof M.$UO?y(R.ChatResponseReferencePart.from(v)):v instanceof M.$SO&&y(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[330],Ee([1,0,8,55,4,3,2,83,25,16,7,6,26]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=y;function y(v,l,f){const a=v.getProxy(C.$PM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Nm,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const D=this.b.get(d.handle);return D?D.value:d}else if(d&&d.$mid===7){const D=d,b=this.b.get(D.commentControlHandle);if(!b)return D;const E=b.getCommentThread(D.commentThreadHandle);return E?E.value:D}else if(d&&(d.$mid===9||d.$mid===8)){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const b=D.getCommentThread(d.thread.commentThreadHandle);return b?d.$mid===8?b.value:{thread:b.value,text:d.text}:d}else if(d&&d.$mid===10){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const b=D.getCommentThread(d.thread.commentThreadHandle);if(!b)return d;const E=d.commentUniqueId,k=b.getCommentByUniqueId(E);return k||d}else if(d&&d.$mid===11){const D=this.b.get(d.thread.commentControlHandle);if(!D)return d;const b=D.getCommentThread(d.thread.commentThreadHandle);if(!b)return d;const E=d.text,k=d.commentUniqueId,P=b.getCommentByUniqueId(k);return P?(typeof P.body=="string"?P.body=E:P.body=new A.$gN(E),P):d}return d}})}createCommentController(d,D,b){const E=n.a++,k=new r(d,E,D,b);this.b.set(k.handle,k);const P=this.c.get(d.identifier)||[];return P.push(k),this.c.set(d.identifier,P),k.value}async $createCommentThreadTemplate(d,D,b){const E=this.b.get(d);E&&E.$createCommentThreadTemplate(D,b)}async $setActiveComment(d,D){const b=this.b.get(d);b&&b.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(d,D,b){const E=this.b.get(d);E&&E.$updateCommentThreadTemplate(D,b)}$deleteCommentThread(d,D){this.b.get(d)?.$deleteCommentThread(D)}async $provideCommentingRanges(d,D,b){const E=this.b.get(d);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await f.ensureDocumentData(M.URI.revive(D));return(0,u.$ih)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(k.document,b);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(j=>S.Range.from(j)),fileComments:P.fileComments}),I})}$toggleReaction(d,D,b,E,k){const P=this.b.get(d);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,u.$ih)(()=>{const I=P.getCommentThread(D);if(I){const j=I.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&j&&P.reactionHandler)return P.reactionHandler(j,g(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,typeof d=="object"?((0,m.$xG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=d.resolved,this.b.applicability=d.applicability):this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,D,b,E,k,P,I,j){this.m=D,this.n=b,this.o=E,this.p=k,this.q=P,this.extensionDescription=I,this.r=j,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${d}.${this.handle}`),a.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(z){F.range=z},get comments(){return F.comments},set comments(z){F.comments=z},get collapsibleState(){return F.collapsibleState},set collapsibleState(z){F.collapsibleState=z},get canReply(){return F.canReply},set canReply(z){F.canReply=z},get contextValue(){return F.contextValue},set contextValue(z){F.contextValue=z},get label(){return F.label},set label(z){F.label=z},get state(){return F.state},set state(z){F.state=z},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const d=b=>Object.prototype.hasOwnProperty.call(this.b,b),D={};d("range")&&(D.range=S.Range.from(this.p)),d("label")&&(D.label=this.label),d("contextValue")&&(D.contextValue=this.contextValue??null),d("comments")&&(D.comments=this.q.map(b=>o(this,b,this.k,this.extensionDescription))),d("collapsibleState")&&(D.collapseState=c(this.g)),d("canReply")&&(D.canReply=this.canReply),d("state")&&(D.state=h(this.h)),d("applicability")&&(D.applicability=s(this.h)),d("isTemplate")&&(D.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(d){for(const D of this.k){const b=D[0],E=D[1];if(d===E)return b}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,m.$xG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$xG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$xG)(this.h,"activeComment"),this.f}constructor(d,D,b,E){this.h=d,this.i=D,this.j=b,this.k=E,this.a=new Map,a.$registerCommentController(this.handle,b,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},get activeCommentThread(){return k.activeCommentThread},createCommentThread(P,I,j){return k.createCommentThread(P,I,j).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(d,D,b){D===void 0&&(0,m.$xG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,d,D,b,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const D=this.a.get(d.commentThreadHandle);D&&(this.e=d.uniqueIdInThread?D.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(d,D){const b=new i(this.id,this.handle,void 0,M.URI.revive(d),S.Range.to(D),[],this.h,!0);return b.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(d,D){const b=this.a.get(d);b&&(b.range=S.Range.to(D))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function o(w,d,D,b){let E=D.get(d);return E||(E=++w.commentHandle,D.set(d,E)),d.state!==void 0&&(0,m.$xG)(b,"commentsDraftState"),d.reactions?.some(k=>k.reactors!==void 0)&&(0,m.$xG)(b,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:E,body:typeof d.body=="string"?d.body:S.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(k=>t(k)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(w){return{label:w.label,iconPath:w.iconPath?S.$bP(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted,reactors:w.reactors&&w.reactors.length>0&&typeof w.reactors[0]!="string"?w.reactors.map(d=>d.name):w.reactors}}function g(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?M.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1,reactors:w.reactors?.map(d=>({name:d}))}}function c(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function h(w){let d;if(typeof w=="object"?d=w.resolved:d=w,d!==void 0)switch(d){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function s(w){let d;if(typeof w=="object"&&(d=w.applicability),d!==void 0)switch(d){case A.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(ke[331],Ee([1,0,22,56,3,15,23,2,16,92,111,6,7]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0;class y{constructor(g,c){this.document=g,this.b=c,this.a=1,this.c=new A.$qkc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,c){await this.f(g).undo(),c||this.disposeBackup()}async redo(g,c){await this.f(g).redo(),c||this.disposeBackup()}disposeEdits(g){for(const c of g)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=o(this.document.uri)+this.a++;return(0,M.$4g)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const c=this.c.get(g,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(g,c){return this.a.get(this.b(g,c))}add(g,c,h){const s=this.b(g,c.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${g} resource:${c.uri}`);const w=new y(c,h);return this.a.set(s,w),w}delete(g,c){const h=this.b(g,c.uri);this.a.delete(h)}b(g,c){return`${g}@@@${c}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this.a=new Map}addTextProvider(g,c,h){return this.b(0,g,c,h)}addCustomProvider(g,c,h){return this.b(1,g,c,h)}get(g){return this.a.get(g)}b(g,c,h,s){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:g,extension:h,provider:s}),new m.$RM(()=>this.a.delete(c))}}class a{constructor(g,c,h,s,w){this.d=c,this.f=h,this.g=s,this.h=w,this.b=new f,this.c=new v,this.a=g.getProxy(C.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(g,c,h,s){const w=new L.$Tc;return i(h)?(w.add(this.b.addTextProvider(c,g,h)),this.a.$registerTextEditorProvider((0,S.$Zkc)(g),c,s.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,S.$Xkc)(g))):(w.add(this.b.addCustomProvider(c,g,h)),n(h)&&w.add(h.onDidChangeCustomDocument(d=>{const D=this.i(c,d.document.uri);if(r(d)){const b=D.addEdit(d);this.a.$onDidEdit(d.document.uri,c,b,d.label)}else this.a.$onContentChange(d.document.uri,c)})),this.a.$registerCustomEditorProvider((0,S.$Zkc)(g),c,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,S.$Xkc)(g))),m.$RM.from(w,new m.$RM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(g,c,h,s,w){const d=this.b.get(c);if(!d)throw new Error(`No provider found for '${c}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=p.URI.revive(g),b=await d.provider.openCustomDocument(D,{backupId:h,untitledDocumentData:s?.buffer},w);let E;return n(d.provider)&&this.f&&(E=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(c,b,E),{editable:n(d.provider)}}async $disposeCustomDocument(g,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const s=p.URI.revive(g),{document:w}=this.i(c,s);this.c.delete(c,w),w.dispose()}async $resolveCustomEditor(g,c,h,s,w,d){const D=this.b.get(h);if(!D)throw new Error(`No provider found for '${h}'`);const b=$.ViewColumn.to(w),E=this.g.createNewWebview(c,s.contentOptions,D.extension),k=this.h.createNewWebviewPanel(c,h,s.title,b,s.options,E,s.active),P=p.URI.revive(g);switch(D.type){case 1:{const{document:I}=this.i(h,P);return D.provider.resolveCustomEditor(I,k,d)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,k,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,c,h){this.i(c,g).disposeEdits(h)}async $onMoveCustomEditor(g,c,h){const s=this.b.get(h);if(!s)throw new Error(`No provider found for '${h}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const w=this.h.getWebviewPanel(g);if(!w)throw new Error("No webview found");const d=p.URI.revive(c),D=this.d.getDocument(d);await s.provider.moveCustomTextEditor(D,w,u.CancellationToken.None)}async $undo(g,c,h,s){return this.i(c,g).undo(h,s)}async $redo(g,c,h,s){return this.i(c,g).redo(h,s)}async $revert(g,c,h){const s=this.i(c,g);await this.j(c).revertCustomDocument(s.document,h),s.disposeBackup()}async $onSave(g,c,h){const s=this.i(c,g);await this.j(c).saveCustomDocument(s.document,h),s.disposeBackup()}async $onSaveAs(g,c,h,s){const w=this.i(c,g);return this.j(c).saveCustomDocumentAs(w.document,p.URI.revive(h),s)}async $backup(g,c,h){const s=this.i(c,g),d=await this.j(c).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},h);return s.updateBackup(d),d.id}i(g,c){const h=this.c.get(g,p.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(g){const h=this.b.get(g)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$3kc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const g=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(g)+""}}),define(ke[332],Ee([1,0,218,138,2,6,7,16,4,12,27,60]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=e.$xkc=void 0;class y{#e;#t;#i;constructor(f,a,n,i,r,o,t,g){this.d=f,this.e=a,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(c=>o.getComparisonKey(c)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,a){if(!f){this.clear();return}this.j();let n=[];if(L.URI.isUri(f)){if(!a){this.delete(f);return}this.#i.set(f,a.slice()),n=[f]}else if(Array.isArray(f)){n=[];let o;f=[...f].sort(y.k);for(const t of f){const[g,c]=t;if((!o||g.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=g,n.push(g),this.#i.set(g,[])),c)this.#i.get(g)?.push(...c);else{const h=this.#i.get(g);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const o of n){let t=[];const g=this.#i.get(o);if(g)if(g.length>this.g){t=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const s of g)if(s.severity===c[h]&&t.push({...p.Diagnostic.from(s),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(c=>({...p.Diagnostic.from(c),modelVersionId:this.h(o)}));if(i.push([o,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,a){this.j();for(const[n,i]of this)f.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const a=this.#i.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.$xkc=y;let v=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const a=new A.$Bc;for(const n of f)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new $.$fe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(R.$PM.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{g:n,f:i,h:r,j:o,k:t,l:g}=this,c=new class{$changeMany(w,d){i.$changeMany(w,d),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,w,d.length===0?"CLEARING":d)}$clear(w){i.$clear(w),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,w)}dispose(){i.dispose()}};let h;if(!a)a="_generated_diagnostic_collection_name_#"+m.c++,h=a;else if(!n.has(a))h=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do h=a+m.c++;while(n.has(h))}return new class extends y{constructor(){super(a,h,m.e,m.d,w=>g.getDocument(w)?.version,t.extUri,c,r),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(f){if(f)return this.m(f);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((r,o)=>{let t=a.get(r.toString());typeof t>"u"&&(t=n.length,a.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(f){let a=[];for(const n of this.g.values())n.has(f)&&(a=a.concat(n.get(f)));return a}$acceptMarkersChange(f){if(!this.n){const a="_generated_mirror",n=new y(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of f)this.n.set(L.URI.revive(a),n.map(p.Diagnostic.to))}};e.$ykc=v,e.$ykc=v=m=Je([qe(1,S.$Wj),qe(2,C.$wkc)],v)}),define(ke[333],Ee([1,0,2,13,7,16,75,48]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class ${constructor(A,C,m,y={timeout:1500,errors:3}){this.c=A,this.d=C,this.f=m,this.g=y,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(C,m,y)=>{const l={dispose:this.a.push([C,m,A])};return Array.isArray(y)&&y.push(l),l}}async $participateInSave(A,C){const m=u.URI.revive(A);let y=!1;const v=setTimeout(()=>y=!0,this.g.timeout),l=[];try{for(const f of[...this.a]){if(y)break;const a=this.d.getDocument(m),n=await this.h(f,{document:a,reason:R.TextDocumentSaveReason.to(C)});l.push(n)}}finally{clearTimeout(v)}return l}h([A,C,m],y){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(m,A,C,y).then(()=>!0,l=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' threw ERROR`),this.c.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const f=this.b.get(A);this.b.set(A,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,C,m,y){const v=[],l=Date.now(),{document:f,reason:a}=y,{version:n}=f,i=Object.freeze({document:f,reason:a,waitUntil(r){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{C.apply(m,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(t),r(g)}).catch(g=>{clearTimeout(t),o(g)})}).then(r=>{const o={edits:[]};for(const t of r)if(Array.isArray(t)&&t.every(g=>g instanceof L.$YM))for(const{newText:g,newEol:c,range:h}of t)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:h&&R.Range.from(h),text:g,eol:c&&R.EndOfLine.from(c)}});if(o.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(new p.$lw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$Glc=$}),define(ke[334],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class C{constructor(y,v){this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=y.getProxy(R.$PM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(l=>{for(const f of l)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const f of l)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let l=this.h.get(y.toString());return l||(l=this.f.$tryOpenDocument(y).then(f=>{this.h.delete(y.toString());const a=L.URI.revive(f);return(0,$.$cg)(this.g.getDocument(a))},f=>(this.h.delete(y.toString()),Promise.reject(f))),this.h.set(y.toString(),l)),l}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(y,v){const l=L.URI.revive(y),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(v),this.a.fire(f.document)}$acceptModelSaved(y){const v=L.URI.revive(y),l=this.g.getDocument(v);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(y,v){const l=L.URI.revive(y),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(v),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,l){const f=L.URI.revive(y),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(l),a.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Xn)({document:a.document,contentChanges:v.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,v){(0,M.$eP)(y,v)}}e.$zkc=C}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,7]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,M.$qi)("IExtHostEditorTabs");class C{constructor(f,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$BO(R.URI.revive(this.b.input.uri));case 2:return new A.$CO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$DO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$EO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$FO(this.b.input.viewType);case 4:return new A.$GO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$HO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$IO;case 9:return new A.$JO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$KO;case 11:return new A.$LO(this.b.input.diffEditors.map(f=>new A.$CO(R.URI.revive(f.original),R.URI.revive(f.modified))));default:return}}}class m{constructor(f,a){this.c=[],this.d="",this.b=f,this.e=a;for(const n of f.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return S.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(n=>n.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const n=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,n),f.tabDto.isActive&&(this.d=n.tabId),n}else if(f.kind===1){const n=this.c.splice(f.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(f.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,n),n}const a=this.c.find(n=>n.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this.d}}let y=class{constructor(f){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=f.getProxy(p.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,a={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(n=>n.apiObject))},get activeTabGroup(){const n=f.d;return(0,L.$cg)(f.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(f){const a=new Set(this.e.map(c=>c.groupId)),n=new Set(f.map(c=>c.groupId)),i=(0,u.$L)(a,n),r=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),o=[],t=[];this.e=f.map(c=>{const h=new m(c,()=>this.d);return i.added.includes(h.groupId)?o.push(h.apiObject):t.push(h.apiObject),h});const g=(0,L.$cg)(f.find(c=>c.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:o,closed:r,changed:t}))}$acceptTabGroupUpdate(f){const a=this.e.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this.e.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(f){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===f)return n}h(f){return this.e.find(a=>a.apiObject===f)}async i(f,a){const n=[];for(const i of f){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,a)}async j(f,a){const n=[];for(const i of f){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,a)}};e.$5kc=y,e.$5kc=y=Je([qe(0,$.$cP)],y);function v(l){return l.tabs!==void 0}}),define(ke[335],Ee([1,0,2,6,3,7,16,180,14,21,26,80]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const f=this.a.indexOf(l);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),f=[];let a,n,i=14,r=14;for(const o of l){let t=a?(0,$.$vf)(a,o):0;for(t===0?n=1:n=r;t<o.length;t++)t+1===o.length?(i=r,r=9):r+=1,f.push([n,o.toUpperCase().charCodeAt(t),r]),f.push([n,o.toLowerCase().charCodeAt(t),r]),n=r;a=o,r=i}f.push([9,58,10]),f.push([10,47,12]),this.b=new p.$32(f)}}provideDocumentLinks(l){this.c();const f=[],a=p.$42.computeLinks({getLineContent(n){return l.lineAt(n-1).text},getLineCount(){return l.lineCount}},this.b);for(const n of a){const i=M.DocumentLink.to(n);i.target&&f.push(i)}return f}}class y{constructor(l,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,f,a,n={}){if(y.j(a),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const i=this.h++;this.b.add(f),this.d.add(f),this.c.set(i,a);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof a.copy=="function"&&(r+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,A.$xG)(l,"fsChunks"),r+=4);let o;n.isReadonly&&(0,C.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,f,r,o).catch(g=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(g)});const t=a.onDidChangeFile(g=>{const c=[];for(const h of g){const{uri:s,type:w}=h;if(s.scheme!==f)continue;let d;switch(w){case R.FileChangeType.Changed:d=0;break;case R.FileChangeType.Created:d=1;break;case R.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:s,type:d})}this.a.$onFileSystemChange(i,c)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:f,ctime:a,mtime:n,size:i,permissions:r}=l;return{type:f,ctime:a,mtime:n,size:i,permissions:r}}$stat(l,f){return Promise.resolve(this.l(l).stat(u.URI.revive(f))).then(a=>y.k(a))}$readdir(l,f){return Promise.resolve(this.l(l).readDirectory(u.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this.l(l).readFile(u.URI.revive(f))).then(a=>S.$Ce.wrap(a))}$writeFile(l,f,a,n){return Promise.resolve(this.l(l).writeFile(u.URI.revive(f),a.buffer,n))}$delete(l,f,a){return Promise.resolve(this.l(l).delete(u.URI.revive(f),a))}$rename(l,f,a,n){return Promise.resolve(this.l(l).rename(u.URI.revive(f),u.URI.revive(a),n))}$copy(l,f,a,n){const i=this.l(l);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(f),u.URI.revive(a),n))}$mkdir(l,f){return Promise.resolve(this.l(l).createDirectory(u.URI.revive(f)))}$watch(l,f,a,n){const i=this.l(l).watch(u.URI.revive(a),n);this.f.set(f,i)}$unwatch(l,f){const a=this.f.get(f);a&&(a.dispose(),this.f.delete(f))}$open(l,f,a){const n=this.l(l);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(f),a))}$close(l,f){const a=this.l(l);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(l,f,a,n){const i=this.l(l);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=S.$Ce.alloc(n);return Promise.resolve(i.read(f,a,r.buffer,0,n)).then(o=>r.slice(0,o))}$write(l,f,a,n){const i=this.l(l);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(f,a,n.buffer,0,n.byteLength))}l(l){const f=this.c.get(l);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.$Ilc=y}),define(ke[336],Ee([1,0,4,35,2,6,16,7,46]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,v,l,f,a,n){this.a=Math.random(),this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(a),r=typeof a=="string",o=n?.correlate,t=f(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(o&&typeof g.session>"u")){if(!n?.ignoreCreateEvents)for(const c of g.created){const h=L.URI.revive(c);i(h.fsPath)&&(!r||v.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const c of g.changed){const h=L.URI.revive(c);i(h.fsPath)&&(!r||v.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const c of g.deleted){const h=L.URI.revive(c);i(h.fsPath)&&(!r||v.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=p.$RM.from(this.i(y,l,a,n,n?.correlate),this.b,this.c,this.d,t)}i(y,v,l,f,a){const n=p.$RM.from();if(typeof l=="string")return n;const i=y.getProxy(R.$PM.MainThreadFileSystemEventService);let r=!1;return(l.pattern.includes(N.$gk)||l.pattern.includes(N.$hk))&&(r=!0),i.$watch(v.identifier.value,this.a,l.baseUri,{recursive:r,excludes:f?.excludes??[]},!!a),p.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(L.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(y,v,l){this.j=y,this.k=v,this.l=l,this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.g=new u.$de,this.h=new u.$de,this.i=new u.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,v,l,f){return new S(this.j,y,v,this.a.event,M.GlobPattern.from(l),f)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,v){switch(y){case 2:this.b.fire(Object.freeze({files:v.map(l=>({oldUri:L.URI.revive(l.source),newUri:L.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(l=>L.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(l=>L.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,v){return(l,f,a)=>{const n=function(r){l.call(f,r)};return n.extension=y,v.event(n,void 0,a)}}async $onWillRunFileOperation(y,v,l,f){switch(y){case 2:return await this.n(this.g,{files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},l,f);case 1:return await this.n(this.i,{files:v.map(a=>L.URI.revive(a.target))},l,f);case 0:case 3:return await this.n(this.h,{files:v.map(a=>L.URI.revive(a.target))},l,f)}}async n(y,v,l,f){const a=new Set,n=[];if(await y.fireAsync(v,f,async(r,o)=>{const t=Date.now(),g=await Promise.resolve(r);g instanceof p.$2M&&(n.push([o.extension,g]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",o.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:o}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$Jlc=C}),define(ke[337],Ee([1,0,19,8,22,13,124,3,24,40,14,18,2,29,176,83,134,220,25,16,7,26,111,6]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class c{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(J,V);if(!(0,u.$Kb)(Q))return Q[0]instanceof r.$$M?Q.map(i.DocumentSymbol.from):c.f(Q)}static f(q){q=q.slice(0).sort((Q,he)=>{let be=Q.location.range.start.compareTo(he.location.range.start);return be===0&&(be=he.location.range.end.compareTo(Q.location.range.end)),be});const V=[],J=[];for(const Q of q){const he={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(he),V.push(he);break}const be=J[J.length-1];if(y.$kt.containsRange(be.range,he.range)&&!y.$kt.equalsRange(be.range,he.range)){be.children?.push(he),J.push(he);break}J.pop()}}return V}}class h{constructor(q,V,J,Q,he,be){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.l=be,this.d=new t.$qkc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),Q=await this.h.provideCodeLenses(J,V);if(!Q||V.isCancellationRequested)return;const he=this.d.add(Q),be=new p.$Tc;this.e.set(he,be);const ze={cacheId:he,lenses:[]};for(let Ve=0;Ve<Q.length;Ve++)ze.lenses.push({cacheId:[he,Ve],range:i.Range.from(Q[Ve].range),command:this.g.toInternal(Q[Ve].command,be)});return ze}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let Q;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.h.resolveCodeLens(J,V),Q||(Q=J),V.isCancellationRequested)return;const he=q.cacheId&&this.e.get(q.cacheId[0]);if(he){if(!Q.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return q.command=this.g.toInternal(Q.command,he),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function s(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class w{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideDefinition(Q,he,J);return s(be)}}class d{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideDeclaration(Q,he,J);return s(be)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideImplementation(Q,he,J);return s(be)}}class b{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideTypeDefinition(Q,he,J);return s(be)}}class E{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideHover(Q,he,J);if(!(!be||(0,u.$Kb)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(he)),be.range||(be.range=new r.$TM(he,he)),i.Hover.from(be)}}class k{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideEvaluatableExpression(Q,he,J);if(be)return i.EvaluatableExpression.from(be)}}class P{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,Q){const he=this.d.getDocument(q),be=await this.e.provideInlineValues(he,i.Range.to(V),i.InlineValueContext.to(J),Q);if(Array.isArray(be))return be.map(ze=>i.InlineValue.from(ze))}}class I{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideDocumentHighlights(Q,he,J);if(Array.isArray(be))return be.map(i.DocumentHighlight.from)}}class j{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,Q){const he=this.d.getDocument(q),be=J.map(Ye=>this.d.getDocument(Ye)),ze=i.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights(he,ze,be,Q);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const Q=this.d.getDocument(q),he=i.Position.to(V),be=await this.e.provideLinkedEditingRanges(Q,he,J);if(be&&Array.isArray(be.ranges))return{ranges:(0,u.$Hb)(be.ranges.map(i.Range.from)),wordPattern:be.wordPattern}}}class z{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,Q){const he=this.d.getDocument(q),be=i.Position.to(V),ze=await this.e.provideReferences(he,be,J,Q);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(q,V,J,Q,he,be,ze){this.g=q,this.h=V,this.j=J,this.k=Q,this.l=he,this.m=be,this.n=ze,this.e=new t.$qkc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,Q){const he=this.g.getDocument(q),be=v.$mt.isISelection(V)?i.Selection.to(V):i.Range.to(V),ze=[];for(const st of this.j.getDiagnostics(q))if(be.intersection(st.range)&&ze.push(st)>O.d)break;const Ve={diagnostics:ze,only:J.only?new r.$aN(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ye=await this.k.provideCodeActions(he,be,Ve,Q);if(!(0,u.$Lb)(Ye)||Q.isCancellationRequested)return;const it=this.e.add(Ye),ot=new p.$Tc;this.f.set(it,ot);const nt=[];for(let st=0;st<Ye.length;st++){const Ce=Ye[st];if(Ce)if(O.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,ot)});else{Ve.only&&(Ce.kind?Ve.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ce.ranges??[];nt.push({cacheId:[it,st],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,ot),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(i.Diagnostic.from),edit:Ce.edit&&i.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,o.$wG)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,o.$wG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:it,actions:nt}}async resolveCodeAction(q,V){const[J,Q]=q,he=this.e.get(J,Q);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(he,V)??he;let ze;be.edit&&(ze=i.WorkspaceEdit.from(be.edit,void 0));let Ve;if(be.command){const Ye=this.f.get(J);Ye&&(Ve=this.h.toInternal(be.command,Ye))}return{edit:ze,command:Ve}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class T{constructor(q,V,J,Q,he){this.e=q,this.f=V,this.g=J,this.h=Q,this.j=he,this.d=new t.$qkc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,Q){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(q),be=V.map(Ye=>i.Range.to(Ye)),ze=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,be,ze,Q),Q.isCancellationRequested)return;const Ve=Array.from(ze).filter(([,Ye])=>!(Ye instanceof r.$GN));return i.DataTransfer.from(Ve)}async providePasteEdits(q,V,J,Q,he,be){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(V),Ve=J.map(nt=>i.Range.to(nt)),Ye=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,q,nt)).buffer),it=await this.g.provideDocumentPasteEdits(ze,Ve,Ye,{only:he.only?new r.$LN(he.only):void 0,triggerKind:he.triggerKind},be);if(!it||be.isCancellationRequested)return[];const ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,Q]=q,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(he,V)??he;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideDocumentFormattingEdits(Q,V,J);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,Q){const he=this.d.getDocument(q),be=i.Range.to(V),ze=await this.e.provideDocumentRangeFormattingEdits(he,be,J,Q);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,Q){(0,C.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(q),be=V.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,be,J,Q);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class X{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,Q,he){const be=this.d.getDocument(q),ze=i.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(be,ze,J,Q,he);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class x{constructor(q,V){this.e=q,this.f=V,this.d=new t.$qkc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(J))return{symbols:[]};const Q=this.d.add(J),he={cacheId:Q,symbols:[]};for(let be=0;be<J.length;be++){const ze=J[be];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[Q,be]})}return he}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,V);return Q&&(0,$.$Zn)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class Y{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,Q){const he=this.d.getDocument(q),be=i.Position.to(V);try{const ze=await this.e.provideRenameEdits(he,be,J,Q);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const Ve=Y.g(ze);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),he=i.Position.to(V);try{const be=await this.e.prepareRename(Q,he,J);let ze,Ve;if(r.$TM.isRange(be)?(ze=be,Ve=Q.getText(be)):(0,C.$6f)(be)&&(ze=be.range,Ve=be.placeholder),!ze||!Ve)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:Ve}}catch(be){const ze=Y.g(be);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(be)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Z{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideNewSymbolNames(q,V,J){const Q=this.d.getDocument(q),he=i.Range.to(V);try{const be=await this.e.provideNewSymbolNames(Q,he,J);return be?be.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(be){this.f.error(Z.g(be)??JSON.stringify(be,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ue{constructor(q,V){this.resultId=q,this.tokens=V}}class te{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const Q=this.f.getDocument(q),he=V!==0?this.d.get(V):null;let be=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,he.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return he&&this.d.delete(V),be?(be=te.h(be),this.o(te.n(he,be),be)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return te.j(q)?te.k(q)?q:new r.$_N(new Uint32Array(q.data),q.resultId):te.l(q)?te.m(q)?q:new r.$bO(q.edits.map(V=>new r.$aO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!te.j(V)||!q||!q.tokens)return V;const J=q.tokens,Q=J.length,he=V.data,be=he.length;let ze=0;const Ve=Math.min(Q,be);for(;ze<Ve&&J[ze]===he[ze];)ze++;if(ze===Q&&ze===be)return new r.$bO([],V.resultId);let Ye=0;const it=Ve-ze;for(;Ye<it&&J[Q-Ye-1]===he[be-Ye-1];)Ye++;return new r.$bO([{start:ze,deleteCount:Q-ze-Ye,data:he.subarray(ze,be-Ye)}],V.resultId)}o(q,V){if(te.j(q)){const J=this.e++;return this.d.set(J,new ue(q.resultId,q.data)),(0,f.$Fbb)({id:J,type:"full",data:q.data})}if(te.l(q)){const J=this.e++;return te.j(V)?this.d.set(J,new ue(V.resultId,V.data)):this.d.set(J,new ue(q.resultId)),(0,f.$Fbb)({id:J,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class we{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(V),J);return he?this.f(he):null}f(q){return(0,f.$Fbb)({id:0,type:"full",data:q.data})}}class Se{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,Q,he){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.d=new t.$qkc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,Q){const he=this.f.getDocument(q),be=i.Position.to(V),ze=he.getWordRangeAtPosition(be)||new r.$TM(be,be),Ve=ze.with({end:be}),Ye=new S.$0d,it=await this.h.provideCompletionItems(he,be,Q,i.CompletionContext.to(J));if(!it||Q.isCancellationRequested)return;const ot=Array.isArray(it)?new r.$nN(it):it,nt=Se.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new p.$Tc;this.e.set(nt,st);const Ce=[],Be={x:nt,b:Ce,a:{replace:i.Range.from(ze),insert:i.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Ye.elapsed()};for(let He=0;He<ot.items.length;He++){const Ne=ot.items[He],Xe=this.l(Ne,[nt,He],Ve,ze);Ce.push(Xe)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const Q=this.l(J,q),he=await this.h.resolveCompletionItem(J,V);if(!he)return;const be=this.l(he,q);return(Q.h!==be.h||Q.i!==be.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==be.n||Q.o!==be.o||!(0,$.$1n)(Q.p,be.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:be.d,c:be.c,l:be.l,h:be.h,i:be.i,n:be.n,o:be.o,p:be.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,Q){const he=this.e.get(V[0]);if(!he)throw Error("DisposableStore is missing...");const be=this.g.toInternal(q.command,he),ze={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=q.textEdit.newText):typeof q.insertText=="string"?ze.h=q.insertText:q.insertText instanceof r.$3M&&(ze.h=q.insertText.value,ze.i|=4);let Ve;return q.textEdit?Ve=q.textEdit.range:q.range&&(Ve=q.range),r.$TM.isRange(Ve)?ze.j=i.Range.from(Ve):Ve&&(!J?.isEqual(Ve.inserting)||!Q?.isEqual(Ve.replacing))&&(ze.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),ze}}class _{async provideInlineCompletions(q,V,J,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,Q){}}class U extends _{constructor(q,V,J,Q){super(),this.f=q,this.g=V,this.h=J,this.j=Q,this.d=new $e,this.e=(0,o.$wG)(this.f,"inlineCompletionsAdditions"),this.k={[l.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$wG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,Q){const he=this.g.getDocument(q),be=i.Position.to(V),ze=await this.h.provideInlineCompletionItems(he,be,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ze||Q.isCancellationRequested)return;const Ve=Array.isArray(ze)?ze:ze.items,Ye=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],it=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((st,Ce)=>{let Be;st.command&&(ot||(ot=new p.$Tc),Be=this.j.toInternal(st.command,ot));const He=st.insertText;return{insertText:typeof He=="string"?He:{snippet:He.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:Ce,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ye.map(st=>(ot||(ot=new p.$Tc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const Q=this.d.get(q)?.items[V];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(q,V,J,Q){const he=this.d.get(q)?.items[V];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(Q)))}}class ne{async provideInlineEdits(q,V,J){const Q=this.f.getDocument(q),he=await this.g.provideInlineEdit(Q,{triggerKind:this.e[V.triggerKind]},J);if(!he||J.isCancellationRequested)return;let be;const ze=this.d.createReferenceId({dispose(){be?.dispose()},item:he});let Ve;he.accepted&&(be||(be=new p.$Tc),Ve=this.h.toInternal(he.accepted,be));let Ye;return he.rejected&&(be||(be=new p.$Tc),Ye=this.h.toInternal(he.rejected,be)),{pid:ze,text:he.text,range:i.Range.from(he.range),accepted:Ve,rejected:Ye}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,Q){this.f=V,this.g=J,this.h=Q,this.d=new $e,this.e={[l.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class $e{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Pe{constructor(q,V){this.e=q,this.f=V,this.d=new t.$qkc("SignatureHelp")}async provideSignatureHelp(q,V,J,Q){const he=this.e.getDocument(q),be=i.Position.to(V),ze=this.g(J),Ve=await this.f.provideSignatureHelp(he,be,Q,ze);if(Ve){const Ye=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ye}}}g(q){let V;if(q.activeSignatureHelp){const J=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(V=Q,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class se{constructor(q,V,J,Q,he){this.f=q,this.g=V,this.h=J,this.j=Q,this.k=he,this.d=new t.$qkc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const Q=this.f.getDocument(q),he=i.Range.to(V),be=await this.h.provideInlayHints(Q,he,J);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const ze=this.d.add(be);this.e.set(ze,new p.$Tc);const Ve={hints:[],cacheId:ze};for(let Ye=0;Ye<be.length;Ye++)this.l(be[Ye],he)&&Ve.hints.push(this.m(be[Ye],[ze,Ye]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const Q=await this.h.resolveInlayHint(J,V);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const he=[];Q.label=he;for(const be of q.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:be.value,tooltip:i.MarkdownString.fromStrict(be.tooltip)};r.$4M.isLocation(be.location)&&(ze.location=i.location.from(be.location)),be.command&&(ze.command=this.g.toInternal(be.command,J)),he.push(ze)}}return Q}}class re{constructor(q,V){this.e=q,this.f=V,this.d=new t.$qkc("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(Q)||Q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(re.g).map(i.DocumentLink.from)};{const he=this.d.add(Q),be={links:[],cacheId:he};for(let ze=0;ze<Q.length;ze++){if(!re.g(Q[ze]))continue;const Ve=i.DocumentLink.from(Q[ze]);Ve.cacheId=[he,ze],be.links.push(Ve)}return be}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const Q=await this.f.resolveDocumentLink(J,V);if(!(!Q||!re.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class oe{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),Q=await this.e.provideDocumentColors(J,V);return Array.isArray(Q)?Q.map(be=>({color:i.Color.from(be.color),range:i.Range.from(be.range)})):[]}async provideColorPresentations(q,V,J){const Q=this.d.getDocument(q),he=i.Range.to(V.range),be=i.Color.to(V.color),ze=await this.e.provideColorPresentations(be,{document:Q,range:he},J);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class G{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const Q=this.d.getDocument(q),he=await this.e.provideFoldingRanges(Q,V,J);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class ie{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const Q=this.d.getDocument(q),he=V.map(i.Position.to),be=await this.e.provideSelectionRanges(Q,he,J);if(!(0,u.$Lb)(be))return[];if(be.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let Ve=0;Ve<he.length;Ve++){const Ye=[];ze.push(Ye);let it=he[Ve],ot=be[Ve];for(;;){if(!ot.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(i.SelectionRange.from(ot)),!ot.parent)break;it=ot.range,ot=ot.parent}}return ze}}class me{constructor(q,V){this.f=q,this.g=V,this.d=new M.$hP(""),this.e=new Map}async prepareSession(q,V,J){const Q=this.f.getDocument(q),he=i.Position.to(V),be=await this.g.prepareCallHierarchy(Q,he,J);if(!be)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(be)?be.map(Ve=>this.h(ze,Ve)):[this.h(ze,be)]}async provideCallsTo(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(he)return he.map(be=>({from:this.h(q,be.from),fromRanges:be.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(he)return he.map(be=>({to:this.h(q,be.to),fromRanges:be.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),Q=i.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class pe{constructor(q,V){this.f=q,this.g=V,this.d=new M.$hP(""),this.e=new Map}async prepareSession(q,V,J){const Q=this.f.getDocument(q),he=i.Position.to(V),be=await this.g.prepareTypeHierarchy(Q,he,J);if(!be)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(be)?be.map(Ve=>this.h(ze,Ve)):[this.h(ze,be)]}async provideSupertypes(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Q,J);if(he)return he.map(be=>this.h(q,be))}async provideSubtypes(q,V,J){const Q=this.j(q,V);if(!Q)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Q,J);if(he)return he.map(be=>this.h(q,be))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),Q=i.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(Q._itemId,V),Q}j(q,V){return this.e.get(q)?.get(V)}}class Ae{constructor(q,V,J,Q,he){this.e=q,this.f=V,this.g=J,this.h=Q,this.j=he,this.d=new t.$qkc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,J,Q,he){const be=this.f.getDocument(V),ze=i.Position.to(J),Ve=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,nt)).buffer),Ye=await this.g.provideDocumentDropEdits(be,ze,Ve,he);if(!Ye)return;const it=(0,u.$3b)(Ye),ot=this.d.add(it);return it.map((nt,st)=>({_cacheId:[ot,st],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(Ce=>Ce.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[J,Q]=q,he=this.d.get(J,Q);if(!he||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(he,V)??he;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class fe{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,Q){const he=m.URI.revive(q),be=this.d.getDocument(he),ze=J.documents.map(it=>it.map(ot=>({uri:m.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(nt=>i.Range.to(nt))}))),Ve={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(be,V,Ve,Q);return Ye?i.WorkspaceEdit.from(Ye):null}}class De{constructor(q,V){this.adapter=q,this.extension=V}}class Ie{static{this.d=0}constructor(q,V,J,Q,he,be,ze,Ve){this.g=V,this.h=J,this.j=Q,this.k=he,this.l=be,this.m=ze,this.n=Ve,this.f=new Map,this.e=q.getProxy(g.$PM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$RM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,V,J,Q,he,be=!1){const ze=this.f.get(q);if(!ze||!(ze.adapter instanceof V))return Q;const Ve=Date.now();be||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ye=J(ze.adapter,ze.extension);return Promise.resolve(Ye).catch(it=>{(0,R.$4)(it)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(ze.extension.identifier,it))}).finally(()=>{be||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,N.$fh)(Ye,he):Ye}t(q,V){const J=this.q();return this.f.set(J,new De(q,V)),J}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,J,Q){const he=this.t(new c(this.h,J),q),be=Q&&Q.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(he,this.o(V,q),be),this.p(he)}$provideDocumentSymbols(q,V,J){return this.s(q,c,Q=>Q.provideDocumentSymbols(m.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const Q=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new De(new h(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(V,q),he);let be=this.p(Q);if(he!==void 0){const ze=J.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(he));be=r.$RM.from(be,ze)}return be}$provideCodeLenses(q,V,J){return this.s(q,h,Q=>Q.provideCodeLenses(m.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,h,Q=>Q.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,h,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const Q=this.t(new w(this.h,J),q);return this.e.$registerDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideDefinition(q,V,J,Q){return this.s(q,w,he=>he.provideDefinition(m.URI.revive(V),J,Q),[],Q)}registerDeclarationProvider(q,V,J){const Q=this.t(new d(this.h,J),q);return this.e.$registerDeclarationSupport(Q,this.o(V,q)),this.p(Q)}$provideDeclaration(q,V,J,Q){return this.s(q,d,he=>he.provideDeclaration(m.URI.revive(V),J,Q),[],Q)}registerImplementationProvider(q,V,J){const Q=this.t(new D(this.h,J),q);return this.e.$registerImplementationSupport(Q,this.o(V,q)),this.p(Q)}$provideImplementation(q,V,J,Q){return this.s(q,D,he=>he.provideImplementation(m.URI.revive(V),J,Q),[],Q)}registerTypeDefinitionProvider(q,V,J){const Q=this.t(new b(this.h,J),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(V,q)),this.p(Q)}$provideTypeDefinition(q,V,J,Q){return this.s(q,b,he=>he.provideTypeDefinition(m.URI.revive(V),J,Q),[],Q)}registerHoverProvider(q,V,J,Q){const he=this.t(new E(this.h,J),q);return this.e.$registerHoverProvider(he,this.o(V,q)),this.p(he)}$provideHover(q,V,J,Q){return this.s(q,E,he=>he.provideHover(m.URI.revive(V),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(q,V,J,Q){const he=this.t(new k(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(he,this.o(V,q)),this.p(he)}$provideEvaluatableExpression(q,V,J,Q){return this.s(q,k,he=>he.provideEvaluatableExpression(m.URI.revive(V),J,Q),void 0,Q)}registerInlineValuesProvider(q,V,J,Q){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new P(this.h,J),q);this.e.$registerInlineValuesProvider(be,this.o(V,q),he);let ze=this.p(be);if(he!==void 0){const Ve=J.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(he));ze=r.$RM.from(ze,Ve)}return ze}$provideInlineValues(q,V,J,Q,he){return this.s(q,P,be=>be.provideInlineValues(m.URI.revive(V),J,Q,he),void 0,he)}registerDocumentHighlightProvider(q,V,J){const Q=this.t(new I(this.h,J),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,V,J){const Q=this.t(new j(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentHighlights(q,V,J,Q){return this.s(q,I,he=>he.provideDocumentHighlights(m.URI.revive(V),J,Q),void 0,Q)}$provideMultiDocumentHighlights(q,V,J,Q,he){return this.s(q,j,be=>be.provideMultiDocumentHighlights(m.URI.revive(V),J,Q.map(ze=>m.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(q,V,J){const Q=this.t(new F(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideLinkedEditingRanges(q,V,J,Q){return this.s(q,F,async he=>{const be=await he.provideLinkedEditingRanges(m.URI.revive(V),J,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ie.w(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,V,J){const Q=this.t(new z(this.h,J),q);return this.e.$registerReferenceSupport(Q,this.o(V,q)),this.p(Q)}$provideReferences(q,V,J,Q,he){return this.s(q,z,be=>be.provideReferences(m.URI.revive(V),J,Q,he),void 0,he)}registerCodeActionProvider(q,V,J,Q){const he=new p.$Tc,be=this.t(new O(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(be,this.o(V,q),{providedKinds:Q?.providedCodeActionKinds?.map(ze=>ze.value),documentation:Q?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ie.u(q),!!J.resolveCodeAction),he.add(this.p(be)),he}$provideCodeActions(q,V,J,Q,he){return this.s(q,O,be=>be.provideCodeActions(m.URI.revive(V),J,Q,he),void 0,he)}$resolveCodeAction(q,V,J){return this.s(q,O,Q=>Q.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,O,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const Q=this.t(new B(this.h,J),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(V,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,V,J,Q){return this.s(q,B,he=>he.provideDocumentFormattingEdits(m.URI.revive(V),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,V,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,J),q);return this.e.$registerRangeFormattingSupport(he,this.o(V,q),q.identifier,q.displayName||q.name,Q),this.p(he)}$provideDocumentRangeFormattingEdits(q,V,J,Q,he){return this.s(q,W,be=>be.provideDocumentRangeFormattingEdits(m.URI.revive(V),J,Q,he),void 0,he)}$provideDocumentRangesFormattingEdits(q,V,J,Q,he){return this.s(q,W,be=>be.provideDocumentRangesFormattingEdits(m.URI.revive(V),J,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(q,V,J,Q){const he=this.t(new X(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(he,this.o(V,q),Q,q.identifier),this.p(he)}$provideOnTypeFormattingEdits(q,V,J,Q,he,be){return this.s(q,X,ze=>ze.provideOnTypeFormattingEdits(m.URI.revive(V),J,Q,he,be),void 0,be)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new x(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,x,Q=>Q.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,x,Q=>Q.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,x,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const Q=this.t(new Y(this.h,J,this.l),q);return this.e.$registerRenameSupport(Q,this.o(V,q),Y.supportsResolving(J)),this.p(Q)}$provideRenameEdits(q,V,J,Q,he){return this.s(q,Y,be=>be.provideRenameEdits(m.URI.revive(V),J,Q,he),void 0,he)}$resolveRenameLocation(q,V,J,Q){return this.s(q,Y,he=>he.resolveRenameLocation(m.URI.revive(V),J,Q),void 0,Q)}registerNewSymbolNamesProvider(q,V,J){const Q=this.t(new Z(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(V,q)),this.p(Q)}$provideNewSymbolNames(q,V,J,Q){return this.s(q,Z,he=>he.provideNewSymbolNames(m.URI.revive(V),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(q,V,J,Q){const he=this.t(new te(this.h,J),q),be=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(V,q),Q,be);let ze=this.p(he);if(be){const Ve=J.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(be));ze=r.$RM.from(ze,Ve)}return ze}$provideDocumentSemanticTokens(q,V,J,Q){return this.s(q,te,he=>he.provideDocumentSemanticTokens(m.URI.revive(V),J,Q),null,Q)}$releaseDocumentSemanticTokens(q,V){this.s(q,te,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,Q){const he=this.t(new we(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(V,q),Q),this.p(he)}$provideDocumentRangeSemanticTokens(q,V,J,Q){return this.s(q,we,he=>he.provideDocumentRangeSemanticTokens(m.URI.revive(V),J,Q),null,Q)}registerCompletionItemProvider(q,V,J,Q){const he=this.t(new Se(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(he,this.o(V,q),Q,Se.supportsResolving(J),q.identifier),this.p(he)}$provideCompletionItems(q,V,J,Q,he){return this.s(q,Se,be=>be.provideCompletionItems(m.URI.revive(V),J,Q,he),void 0,he)}$resolveCompletionItem(q,V,J){return this.s(q,Se,Q=>Q.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,Se,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,Q){const he=new U(q,this.h,J,this.j.converter),be=this.t(he,q);return this.e.$registerInlineCompletionsSupport(be,this.o(V,q),he.supportsHandleEvents,n.$Lm.toKey(q.identifier.value),Q?.yieldTo?.map(ze=>n.$Lm.toKey(ze))||[]),this.p(be)}$provideInlineCompletions(q,V,J,Q,he){return this.s(q,_,be=>be.provideInlineCompletions(m.URI.revive(V),J,Q,he),void 0,he)}$handleInlineCompletionDidShow(q,V,J,Q){this.s(q,_,async he=>{he.handleDidShowCompletionItem(V,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,Q,he){this.s(q,_,async be=>{be.handlePartialAccept(V,J,Q,he)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,_,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const Q=new ne(q,this.h,J,this.j.converter),he=this.t(Q,q);return this.e.$registerInlineEditProvider(he,this.o(V,q),q.identifier),this.p(he)}$provideInlineEdit(q,V,J,Q){return this.s(q,ne,he=>he.provideInlineEdits(m.URI.revive(V),J,Q),void 0,Q)}$freeInlineEdit(q,V){this.s(q,ne,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this.t(new Pe(this.h,J),q);return this.e.$registerSignatureHelpProvider(be,this.o(V,q),he),this.p(be)}$provideSignatureHelp(q,V,J,Q,he){return this.s(q,Pe,be=>be.provideSignatureHelp(m.URI.revive(V),J,Q,he),void 0,he)}$releaseSignatureHelp(q,V){this.s(q,Pe,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new se(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(he,this.o(V,q),typeof J.resolveInlayHint=="function",Q,Ie.u(q));let be=this.p(he);if(Q!==void 0){const ze=J.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Q));be=r.$RM.from(be,ze)}return be}$provideInlayHints(q,V,J,Q){return this.s(q,se,he=>he.provideInlayHints(m.URI.revive(V),J,Q),void 0,Q)}$resolveInlayHint(q,V,J){return this.s(q,se,Q=>Q.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,se,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const Q=this.t(new re(this.h,J),q);return this.e.$registerDocumentLinkProvider(Q,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,V,J){return this.s(q,re,Q=>Q.provideLinks(m.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,re,Q=>Q.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,re,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const Q=this.t(new oe(this.h,J),q);return this.e.$registerDocumentColorProvider(Q,this.o(V,q)),this.p(Q)}$provideDocumentColors(q,V,J){return this.s(q,oe,Q=>Q.provideColors(m.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,Q){return this.s(q,oe,he=>he.provideColorPresentations(m.URI.revive(V),J,Q),void 0,Q)}registerFoldingRangeProvider(q,V,J){const Q=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new De(new G(this.h,J),q)),this.e.$registerFoldingRangeProvider(Q,this.o(V,q),q.identifier,he);let be=this.p(Q);if(he!==void 0){const ze=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));be=r.$RM.from(be,ze)}return be}$provideFoldingRanges(q,V,J,Q){return this.s(q,G,he=>he.provideFoldingRanges(m.URI.revive(V),J,Q),void 0,Q)}registerSelectionRangeProvider(q,V,J){const Q=this.t(new ie(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(V,q)),this.p(Q)}$provideSelectionRanges(q,V,J,Q){return this.s(q,ie,he=>he.provideSelectionRanges(m.URI.revive(V),J,Q),[],Q)}registerCallHierarchyProvider(q,V,J){const Q=this.t(new me(this.h,J),q);return this.e.$registerCallHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareCallHierarchy(q,V,J,Q){return this.s(q,me,he=>Promise.resolve(he.prepareSession(m.URI.revive(V),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,V,J,Q){return this.s(q,me,he=>he.provideCallsTo(V,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,V,J,Q){return this.s(q,me,he=>he.provideCallsFrom(V,J,Q),void 0,Q)}$releaseCallHierarchy(q,V){this.s(q,me,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const Q=this.t(new pe(this.h,J),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(V,q)),this.p(Q)}$prepareTypeHierarchy(q,V,J,Q){return this.s(q,pe,he=>Promise.resolve(he.prepareSession(m.URI.revive(V),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,V,J,Q){return this.s(q,pe,he=>he.provideSupertypes(V,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,V,J,Q){return this.s(q,pe,he=>he.provideSubtypes(V,J,Q),void 0,Q)}$releaseTypeHierarchy(q,V){this.s(q,pe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,Q){const he=this.q();return this.f.set(he,new De(new Ae(this.e,this.h,J,he,q),q)),this.e.$registerDocumentOnDropEditProvider(he,this.o(V,q),(0,o.$wG)(q,"documentPaste")&&Q?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(q,V,J,Q,he,be){return this.s(q,Ae,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(V,m.URI.revive(J),Q,he,be)),void 0,void 0)}$resolveDropEdit(q,V,J){return this.s(q,Ae,Q=>Q.resolveDropEdit(V,J),{},void 0)}$releaseDropEdits(q,V){this.s(q,Ae,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const Q=this.t(new fe(this.h,J),q);return this.e.$registerMappedEditsProvider(Q,this.o(V,q)),this.p(Q)}$provideMappedEdits(q,V,J,Q,he){return this.s(q,fe,be=>Promise.resolve(be.provideMappedEdits(V,J,Q,he)),null,he)}registerDocumentPasteEditProvider(q,V,J,Q){const he=this.q();return this.f.set(he,new De(new T(this.e,this.h,J,he,q),q)),this.e.$registerPasteEditProvider(he,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(q,V,J,Q,he){return this.s(q,T,be=>be.prepareDocumentPaste(m.URI.revive(V),J,Q,he),void 0,he)}$providePasteEdits(q,V,J,Q,he,be,ze){return this.s(q,T,Ve=>Ve.providePasteEdits(V,m.URI.revive(J),Q,he,be,ze),void 0,ze)}$resolvePasteEdit(q,V,J){return this.s(q,T,Q=>Q.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,T,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ie.w(q.decreaseIndentPattern),increaseIndentPattern:Ie.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ie.w(q.beforeText),afterText:q.afterText?Ie.w(q.afterText):void 0,previousLineText:q.previousLineText?Ie.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ie.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Ie.C)}setLanguageConfiguration(q,V,J){const{wordPattern:Q}=J;if(Q&&(0,A.$ff)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(V,Q):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const he=this.q(),be={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,V,be),this.p(he)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Akc=Ie}),define(ke[121],Ee([1,0,22,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12,39]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=e.$hlc=void 0,e.$hlc=(0,v.$qi)("IExtHostLanguageModels");class r{constructor(c,h){this.option=c,this.stream=new S.$Th,this.stream=h??new S.$Th}}class o{constructor(){this.a=new Map,this.b=new S.$Th,this.c=!1,this.d=!1;const c=this;this.apiObject={stream:c.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,c]of this.a)yield c.stream;else yield this.b}handleFragment(c){if(this.c)return;this.d=!0;let h=this.a.get(c.index);h||(this.a.size===0?h=new r(c.index,this.b):h=new r(c.index),this.a.set(c.index,h)),h.stream.emitOne(c.part)}get isStreaming(){return this.d}reject(c){this.c=!0;for(const h of this.f())h.reject(c)}resolve(){this.c=!0;for(const c of this.f())c.resolve()}}let t=class{static{i=this}static{this.a=1}constructor(c,h,s){this.j=h,this.k=s,this.c=new A.$be,this.d=new A.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Nm,this.i=new Map,this.o=new Set,this.b=c.getProxy(L.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,h,s,w){const d=i.a++;this.f.set(d,{extension:c.identifier,provider:s,languageModelId:h});let D;return w.auth&&(D={providerLabel:c.displayName||c.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(d,h,{extension:c.identifier,identifier:h,model:w.name??"",auth:D}),(0,N.$Sc)(()=>{this.f.delete(d),this.b.$unregisterProvider(d)})}async $provideLanguageModelResponse(c,h,s,w,d,D){const b=this.f.get(c);if(!b)return;const E=new p.$Zv(async k=>{if(D.isCancellationRequested){this.j.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(h,{index:k.index,part:k.part})});return b.provider.provideLanguageModelResponse2(w.map(R.LanguageModelMessage.to),d,$.$Lm.toKey(s),E,D)}$provideTokenLength(c,h,s){const w=this.f.get(c);return w?Promise.resolve(w.provider.provideTokenCount(h,s)):Promise.resolve(0)}$updateLanguageModels(c){const h=[],s=[];if(c.added)for(const w of c.added)this.g.set(w.identifier,w),h.push(w.model);if(c.removed)for(const w of c.removed){this.g.delete(w),s.push(w);for(const[d,D]of this.i)D.languageModelId===w&&(D.res.reject(new y.$5),this.i.delete(d))}this.d.fire(Object.freeze({added:Object.freeze(h),removed:Object.freeze(s)})),c.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(c){const h=new Array;for(const{from:s,to:w,enabled:d}of c){const D=this.h.get(s)??new $.$Mm;if(D.has(w)!==d){d?D.add(w):D.delete(w),this.h.set(s,D);const E={from:s,to:w};h.push(E),this.c.fire(E)}}}async sendChatRequest(c,h,s,w,d){const D=c.identifier,b=await this.b.$prepareChatAccess(D,h,w.justification);if(!b||!this.g.has(h))throw M.$2O.NotFound(`Language model '${h}' is unknown.`);if(this.m(D,b)&&(!await this.l(c,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,w.silent)||!this.h.get(D)?.has(b.extension)))throw M.$2O.NoPermissions(`Language model '${h}' cannot be used by '${D.value}'.`);const E=Math.random()*1e6|0,k=this.b.$fetchResponse(D,h,E,s.map(R.LanguageModelMessage.from),w.modelOptions??{},d),P=new S.$ph,I=new o;this.i.set(E,{languageModelId:h,res:I});let j;if(k.catch(F=>{P.isOpen()?I.reject(F):j=F}).finally(()=>{this.i.delete(E),I.resolve(),P.open()}),await P.wait(),j)throw new M.$2O(`Language model '${h}' errored, check cause for more details`,"Unknown",j);return I.apiObject}async $handleResponseFragment(c,h){const s=this.i.get(c);s&&s.res.handleFragment(h)}async l(c,h,s,w){const d=m.$RL+h.identifier.value;if(await this.k.getSession(c,d,[],{silent:!0}))return this.$updateModelAccesslist([{from:c.identifier,to:h.identifier,enabled:!0}]),!0;if(w)return!1;try{const b=s?(0,C.localize)(0,null,h.displayName,s):(0,C.localize)(1,null,h.displayName);return await this.k.getSession(c,d,[],{forceNewSession:{detail:b}}),this.$updateModelAccesslist([{from:c.identifier,to:h.identifier,enabled:!0}]),!0}catch{return!1}}m(c,h){return!!h.auth&&!$.$Lm.equals(h.extension,c)}async n(c){for(const h of this.o)try{await this.l(h,{identifier:c.extension,displayName:""},void 0,!0)}catch(s){this.j.error("Fake Auth request failed"),this.j.error(s)}}createLanguageModelAccessInformation(c){this.o.add(c);const h=this,s=A.Event.signal(A.Event.filter(this.c.event,d=>$.$Lm.equals(d.from,c.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(s,w)},canSendRequest(d){const D=h.g.get(d);if(!D)return;if(!h.m(c.identifier,D))return!0;const b=h.h.get(c.identifier);if(b)return b.has(D.extension)},async computeTokenLength(d,D,b){b??=u.CancellationToken.None;const E=h.g.get(d);if(!E)throw M.$2O.NotFound(`Language model '${d}' is unknown.`);const k=n.Iterable.find(h.f.values(),P=>P.languageModelId===d);return k?k.provider.provideTokenCount(D,b):h.b.$countTokens(E.identifier,D,b)}}}};e.$ilc=t,e.$ilc=t=i=Je([qe(0,l.$cP),qe(1,a.$Wj),qe(2,f.$Ckc)],t)}),define(ke[338],Ee([1,0,6,16,7,41,8,3,26]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class S{constructor(C,m,y,v){this.c=m,this.d=y,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(u.$PM.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const y=this.c.getDocumentData(C);if(!y)throw new Error(`document '${C.toString()}' NOT found`);return y.document}async tokenAtPosition(C,m){const y=C.version,v=N.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,v),f={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new L.$TM(m.line,m.character,m.line,m.character)};if(!l)return f;const a={range:N.Range.to(l.range),type:N.TokenType.to(l.type)};return!a.range.contains(m)||y!==C.version?f:a}createLanguageStatusItem(C,m,y){const v=this.f++,l=this.a,f=this.g,a=`${C.identifier.value}/${m}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(a);const n={selector:y,id:m,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new p.$Tc,o=()=>{if(i?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:a,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),l.$removeLanguageStatus(v),f.delete(a)},get id(){return n.id},get name(){return n.name},set name(g){n.name=g,o()},get selector(){return n.selector},set selector(g){n.selector=g,o()},get text(){return n.text},set text(g){n.text=g,o()},set text2(g){(0,$.$xG)(C,"languageStatusText"),n.text=g,o()},get text2(){return(0,$.$xG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(g){n.detail=g,o()},get severity(){return n.severity},set severity(g){n.severity=g,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(g){n.accessibilityInformation=g,o()},get command(){return n.command},set command(g){n.command=g,o()},get busy(){return n.busy},set busy(g){n.busy=g,o()}};return o(),t}}e.$Zlc=S}),define(ke[339],Ee([1,0,15,2,16,7,119]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;class p{constructor(C,m,y,v){this.start=C,this.deletedCount=m,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new R.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,m,y){this.notebook=C,this.h=m,this.j=y,this.handle=y.handle,this.uri=N.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(L.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(y)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,m,y){const v=y.map(L.NotebookCellOutputItem.to),l=this.a.find(f=>f.id===C);if(l&&(m||(l.items.length=0),l.items.push(...v),l.items.length>1&&l.items.every(f=>M.$MK(f.mime)))){const f=new Map,a=[];l.items.forEach(n=>{let i;f.has(n.mime)?i=f.get(n.mime):(i=[],f.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),l.items.length=0,a.forEach(n=>{const i=M.$NK(f.get(n));l.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Llc=$;class S{static{this.a=0}constructor(C,m,y,v,l){this.k=C,this.l=m,this.m=y,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===u.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(y){return y=C.n(y),C.b[y].apiCell},getCells(y){return(y?C.p(y):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,y){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},l=[];for(const a of C.rawEvents)a.kind===M.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,v.contentChanges):a.kind===M.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,v.contentChanges):a.kind===M.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),l.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),l.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),l.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===M.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),l.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),l.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<l.length;a++){const n=l[a],i=f.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});f.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,y=C.end|0;return m<0&&(m=0),y>this.b.length&&(y=this.b.length),C.with({start:m,end:y})}p(C){C=this.o(C);const m=[];for(let y=C.start;y<C.end;y++)m.push(this.b[y]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,y){if(this.j)return;const v=[],l=[],f=[];if(C.reverse().forEach(a=>{const i=a[2].map(t=>{const g=new $(this,this.l,t);return m||l.push($.asModelAddData(t)),g}),r=new p(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)f.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),y)for(const a of v)y.push(a.asApiEvent())}s(C,m,y,v){const l=this.b.splice(C,m);this.b.splice(y,0,...l);const f=[new p(C,m,l.map(a=>a.apiCell),[]),new p(y,0,[],l)];for(const a of f)v.push(a.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,y,v){this.b[C].setOutputItems(m,y,v)}v(C,m){const y=this.b[C];y.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(y.uri,m)}w(C,m){const y=this.b[C];y.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Mlc=S}),define(ke[340],Ee([1,0,4,2,16,7,48]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class p{constructor(S,A,C,m={timeout:1500,errors:3}){this.b=S,this.c=A,this.d=C,this.f=m,this.a=new u.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(A,C,m)=>{const y=function(l){A.call(C,l)};return y.extension=S,this.a.event(y,void 0,m)}}async $participateInSave(S,A,C){const m=N.URI.revive(S),y=this.c.getNotebookDocument(m);if(!y)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},C,async(f,a)=>{const n=Date.now(),i=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof R.$2M?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(v.length===0)return!0;const l={edits:[]};for(const f of v){const{edits:a}=L.WorkspaceEdit.from(f);l.edits=l.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new M.$lw(l))}}e.$2lc=p}),define(ke[153],Ee([1,0,13,16,7]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,$,S,A,C,m){this.id=p,this.f=$,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=m}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(L.$gO.isNotebookRange))throw(0,u.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,S){p.f.$tryRevealRange(p.id,N.NotebookRange.from($),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Nlc=R}),define(ke[341],Ee([1,0,4,12,16]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;let R=class{constructor(p,$){this.c=p,this.d=$,this.a=new u.$be,this.b=new u.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,$);const S=this.d.getEditorById(p);$.visibleRanges&&S._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&S._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const $ in p)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(p[$]))}};e.$4lc=R,e.$4lc=R=Je([qe(0,N.$Wj)],R)}),define(ke[342],Ee([1,0,4,6,153]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class R{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(p,$,S){const A=this.c.getEditorById(p);this.a.get($)?.fire({editor:A.apiEditor,message:S})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,C,m)=>this.d($).event(A,C,m),postMessage:(A,C)=>{L.$Nlc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const m=C&&L.$Nlc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,A)}}}d(p){let $=this.a.get(p);return $||($=new u.$be({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$7lc=R}),define(ke[343],Ee([1,0,16,108,22,55,13]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class p{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,y){const v=this.b++,{title:l,location:f,cancellable:a}=m,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(f),title:l,source:n,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(M.$2),this.d(v,y,!!a)}d(C,m,y){let v;y&&(v=new L.$me,this.c.set(C,v));const l=a=>{this.a.$progressEnd(a),this.c.delete(a),v?.dispose()};let f;try{f=m(new S(this.a,C),y&&v?v.token:L.CancellationToken.None)}catch(a){throw l(C),a}return f.then(a=>l(C),a=>l(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$$lc=p;function $(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class S extends N.$Zv{constructor(C,m){super(y=>this.throttledReport(y)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Je([(0,R.$Wh)(100,(A,C)=>$(A,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[344],Ee([1,0,2,6,8,16]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class M{static{this.a=0}constructor($,S){this.d=S,this.c=new Map,this.b=$.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource($,S,A){const C=u.URI.revive(S),m=this.c.get($);return m?(0,L.$ih)(()=>m.provideOriginalResource(C,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider($,S,A,C){const m=M.a++;return this.c.set(m,S),this.b.$registerQuickDiffProvider(m,R.DocumentSelector.from($,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$_lc=M}),define(ke[345],Ee([1,0,22,4,3,6,2,7,13,19,41,57,26,16]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=v;function v(l,f,a){const n=l.getProxy(R.$PM.MainThreadQuickOpen);class i{constructor(d,D){this.e=new Map,this.f=0,this.a=d,this.b=D}showQuickPick(d,D,b,E=u.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,I=n.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},E),j={},F=I.then(()=>j);return Promise.race([F,k]).then(z=>{if(z===j)return;const O=(0,m.$wG)(d,"quickPickItemTooltip");return k.then(T=>{const B=[];for(let W=0;W<T.length;W++){const X=T[W];if(typeof X=="string")B.push({label:X,handle:W});else if(X.kind===p.QuickPickItemKind.Separator)B.push({type:"separator",label:X.label});else{X.tooltip&&!O&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const x=X.iconPath?c(X.iconPath):void 0;B.push({label:X.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,tooltip:O?y.MarkdownString.fromStrict(X.tooltip):void 0,handle:W})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=W=>{b.onDidSelectItem(T[W])}),n.$setItems(P,B),I.then(W=>{if(typeof W=="number")return T[W];if(Array.isArray(W))return W.map(X=>T[X])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(d){this.c?.(d)}showInput(d,D=u.CancellationToken.None){return this.d=d?.validateInput,n.$input(d,typeof this.d=="function",D).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(d){if(!this.d)return;const D=await this.d(d);if(!D||typeof D=="string")return D;let b;switch(D.severity){case p.InputBoxValidationSeverity.Info:b=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:b=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:b=A.default.Error;break;default:b=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:b}}async showWorkspaceFolderPick(d,D=u.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!b)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===b.uri.toString())}createQuickPick(d){const D=new h(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(d){const D=new s(d,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(d,D){this.e.get(d)?._fireDidChangeValue(D)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,D){const b=this.e.get(d);b instanceof h&&b._fireDidChangeActive(D)}$onDidChangeSelection(d,D){const b=this.e.get(d);b instanceof h&&b._fireDidChangeSelection(D)}$onDidTriggerButton(d,D){this.e.get(d)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(d,D,b){const E=this.e.get(d);E instanceof h&&E._fireDidTriggerItemButton(D,b)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class r{static{this.a=1}constructor(d,D){this.x=d,this.y=D,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((D,b)=>{const E=D===p.$dO.Back?-1:b;this.o.set(E,D)}),this.z({buttons:d.map((D,b)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===p.$dO.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const D=this.o.get(d);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(d){if(!this.v){for(const D of Object.keys(d)){const b=d[D];this.u[D]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(w){if(w instanceof p.$NN)return{id:w.id};const d=g(w),D=t(w);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof D=="string"?M.URI.file(D):D}}function t(w){return typeof w=="object"&&"light"in w?w.light:w}function g(w){return typeof w=="object"&&"dark"in w?w.dark:w}function c(w){const d=o(w);let D,b;return"id"in d?b=C.ThemeIcon.asClassName(d):D=d,{iconPath:D,iconClass:b}}class h extends r{constructor(d,D){super(d.identifier,D),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const D=(0,m.$wG)(this.O,"quickPickItemTooltip"),b=[];for(let E=0;E<d.length;E++){const k=d[E];if(k.kind===p.QuickPickItemKind.Separator)b.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?c(k.iconPath):void 0;b.push({handle:E,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((I,j)=>({...c(I.iconPath),tooltip:I.tooltip,handle:j}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(d){const D=(0,S.$Hb)(d.map(b=>this.C.get(b)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(d){const D=(0,S.$Hb)(d.map(b=>this.C.get(b)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(d,D){const b=this.C.get(d);if(!b||!b.buttons||!b.buttons.length)return;const E=b.buttons[D];E&&this.N.fire({button:E,item:b})}}class s extends r{constructor(d,D){super(d.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:A.default.Error}):this.z({validationMessage:d.message,severity:d.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(f,a)}}),define(ke[346],Ee([1,0,2,4,55,3,8,6,19,131,12,25,57,16,26,15,11]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;function n(P){return P instanceof u.URI}function i(P,I){return P.scheme===l.Schemas.file&&I.scheme===l.Schemas.file&&f.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?u.URI.file(P.iconPath):u.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function o(P){if(P.icon){if(u.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const j=typeof P.iconPath=="string"?P.iconPath:u.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,F=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$ir)(j,F)}function g(P,I){let j=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(j=t(P,I),j!==0)return j;if(P.light&&I.light)j=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(j!==0)return j;if(P.dark&&I.dark)j=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return j}function c(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let j=0;j<P.arguments.length;j++){const F=P.arguments[j],z=I.arguments[j];if(F!==z&&!(n(F)&&n(z)&&i(F,z)))return F<z?-1:1}return 0}function h(P,I){let j=(0,S.$ir)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(j!==0)return j;if(P.command&&I.command)j=c(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(j!==0)return j;if(P.decorations&&I.decorations)j=g(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)j=(0,S.$ir)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)j=(0,S.$ir)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return j}function s(P,I){for(let j=0;j<P.length;j++)if(P[j]!==I[j])return!1;return!0}function w(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?s(P.arguments,I.arguments):P.arguments===I.arguments)}function d(P,I){return(0,$.$ub)(P,I,w)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$xG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$xG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$xG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,j,F,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=F}showValidationMessage(I,j){(0,v.$xG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,j)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$bmc=D;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,j,F,z,O,T,B){this.q=I,this.s=j,this.t=F,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,j){const F=this.h.get(I);return F?(0,M.$ih)(()=>this.s.executeCommand(F.command,...F.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(h),F=(0,$.$Db)(this.o,I,h).map(T=>{const B=T.toInsert.map(W=>{const X=this.e++;this.g.set(X,W);const x=W.resourceUri;let Y;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const oe=new R.$Tc;Y=this.s.converter.toInternal(W.command,oe),this.j.set(X,oe)}else this.h.set(X,W.command);const Z=(0,v.$wG)(this.w,"scmMultiDiffEditor"),ue=Z?W.multiDiffEditorOriginalUri:void 0,te=Z?W.multiFileDiffEditorModifiedUri:void 0,we=r(W.decorations),Se=W.decorations&&r(W.decorations.light)||we,_=W.decorations&&r(W.decorations.dark)||we,U=[Se,_],ne=W.decorations&&W.decorations.tooltip||"",$e=W.decorations&&!!W.decorations.strikeThrough,Pe=W.decorations&&!!W.decorations.faded,se=W.contextValue||"";return{rawResource:[X,x,U,ne,$e,Pe,se,Y,ue,te],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),z=F.map(({start:T,deleteCount:B,toInsert:W})=>[T,B,W.map(X=>X.rawResource)]),O=F.reverse();for(const{start:T,deleteCount:B,toInsert:W}of O){const X=W.map(Y=>Y.handle),x=this.n.splice(T,B,...X);for(const Y of x)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let j;(0,v.$wG)(this.x,"quickDiffProvider")&&(j=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:j})}get historyProvider(){return(0,v.$xG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$xG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const j=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:j})}get actionButton(){return(0,v.$xG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$xG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const j=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(F=>F.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:j??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&d(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const j=(I||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:j})}get selected(){return this.u}constructor(I,j,F,z,O,T,B){this.x=I,this.y=z,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=F;const W=u.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,j,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,T,B,W)}createResourceGroup(I,j,F){const z=(0,v.$wG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,O=new b(this.#e,this.y,this.w,I,j,z,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],j=[];for(const[F,z]of this.C){z.dispose();const O=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});N.Event.once(F.onDidDispose)(()=>{this.D.delete(F),O.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),I.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const T=F._takeResourceStateSnapshot();T.length>0&&j.push([F.handle,T]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,I,j),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(j=>{const F=j._takeResourceStateSnapshot();F.length!==0&&I.push([j.handle,F])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Vh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Vh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,j,F,z){this.l=j,this.m=F,this.n=z,this.g=new Map,this.h=new C.$Nm,this.j=new N.$be,this.e=I.getProxy(p.$PM.MainThreadSCM),this.f=I.getProxy(p.$PM.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,j,F,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,j,F,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=a.d++,T=new E(I,this.m,this.e,this.l,j,F,z);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const j=this.h.get(I.identifier),F=j&&j[j.length-1];return F&&F.inputBox}$provideOriginalResource(I,j,F){const z=u.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>O.quickDiffProvider.provideOriginalResource(z,F)).then(T=>T||null)}$onInputBoxValueChange(I,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const F=this.g.get(I);return F&&F.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(I,j,F,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,j,F);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(j);return T?T.$executeResourceCommand(F,z):Promise.resolve(void 0)}$validateInput(I,j,F){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>z.inputBox.validateInput(j,F)).then(O=>{if(!O)return Promise.resolve(void 0);const T=y.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,j,F,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,F,z)??void 0}async $provideHistoryItems(I,j,F,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(j,F,z))?.map(B=>({...B,icon:o(B)}))??void 0}async $provideHistoryItemSummary(I,j,F,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(j,F,z);return T?{...T,icon:o(T)}:void 0}async $provideHistoryItemChanges(I,j,F,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(j,F,z)??void 0}};e.$cmc=k,e.$cmc=k=a=Je([qe(3,A.$Wj)],k)}),define(ke[347],Ee([1,0,6,16,2]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class R{static{this.a=0}constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(u.$PM.MainThreadShare)}async $provideShare(p,$,S){return await this.c.get(p)?.provideShare({selection:N.Range.to($.selection),resourceUri:L.URI.revive($.resourceUri)},S)??void 0}registerShareProvider(p,$){const S=R.a++;return this.c.set(S,$),this.b.$registerShareProvider(S,N.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$dmc=R}),define(ke[348],Ee([1,0,7,6,224,3,16,18]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(m,y,v,l,f,a=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=m,this.#t=y,f&&l){this.c=(0,u.$qN)(l.identifier,f);const i=v.get(this.c);i&&(a=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=f,this.g=a,this.h=this.u(n)}u(m){if((0,p.$8f)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let y;this.m?y=this.m:y=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const l=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,y,this.k,l,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$fmc=$;class S{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const y={message:m};return this.b.unshift(y),this.c(),new u.$RM(()=>{const v=this.b.indexOf(y);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(m,y){this.e=new Map,this.a=m.getProxy(N.$PM.MainThreadStatusBar),this.b=y,this.c=new S(this)}$acceptStaticEntries(m){for(const y of m)this.e.set(y.entryId,y)}createStatusBarEntry(m,y,v,l){return new $(this.a,this.b,this.e,m,y,v,l)}setStatusBarMessage(m,y){const v=this.c.setMessage(m);let l;return typeof y=="number"?l=setTimeout(()=>v.dispose(),y):typeof y<"u"&&y.then(()=>v.dispose(),()=>v.dispose()),new u.$RM(()=>{v.dispose(),clearTimeout(l)})}}e.$gmc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=void 0;const S=(i,r,o,t)=>{let g=r;return{enumerable:!0,configurable:!1,get(){return g},set(c){if(!o(g,c)){const h=g;g=c,i.listener?.(t(c,h))}}}},A=(i,r)=>i===r,C={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(o=>!r.find(t=>o.id===t.id)))},m=i=>r=>({op:4,update:i(r)}),y=(i,r)=>({range:(()=>{let o;const t=m(g=>({range:u.$kt.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return o},set(g){i.listener?.({op:6}),C.range(o,g)||(o=g,i.listener?.(t(g)))}}})(),label:S(i,r,C.label,m(o=>({label:o}))),description:S(i,void 0,C.description,m(o=>({description:o}))),sortText:S(i,void 0,C.sortText,m(o=>({sortText:o}))),canResolveChildren:S(i,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:S(i,!1,C.busy,m(o=>({busy:o}))),error:S(i,void 0,C.error,m(o=>({error:p.MarkdownString.fromStrict(o)||null}))),tags:S(i,[],C.tags,(o,t)=>({op:1,new:o.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),v=i=>{const r=L.$BL.fromString(i.extId),o=new f(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return o.range=p.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>p.TestTag.to({id:(0,M.$HL)(t).tagId})),o},l=i=>{let r;for(const o of i.tests){const t=v(o.item);(0,N.$$O)(t).parent=r,r=t}return r};e.$oP=l;class f{constructor(r,o,t,g){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const c=(0,N.$0O)(this,r);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof a?void 0:c.parent}},children:{value:(0,R.$9O)(c,N.$$O,f),enumerable:!0,writable:!1},...y(c,t)})}}e.$pP=f;class a extends f{constructor(r,o){super(r,r,o,void 0),this._isRoot=!0}}e.$qP=a;class n extends R.$5O{constructor(r,o,t){super({controllerId:r,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:N.$$O,getChildren:g=>g.children,root:new a(r,o),toITestItem:p.TestItem.from})}}e.$rP=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,40,87,90,30]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=void 0;let c=class{#e;#t;#i;constructor(b,E,k){this.b=new Map,this.c=new Map,this.#e=b.getProxy(M.$PM.MainThreadCommands),this.d=E,this.#i=k,this.#t=b.getProxy(M.$PM.MainThreadTelemetry),this.converter=new h(this,P=>{const I=this.c.get(P);return I?.result===w.Void?I:void 0},E),this.f=[{processArgument(P){return(0,S.$Zh)(P)}},{processArgument(P){return(0,R.$Yn)(P,function(I){if(A.$kt.isIRange(I))return L.Range.to(I);if(C.$jt.isIPosition(I))return L.Position.to(I);if(A.$kt.isIRange(I.range)&&m.URI.isUri(I.uri))return L.location.to(I);if(I instanceof a.$Ce)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const E=this.registerCommand(!1,b.id,async(...k)=>{const P=b.args.map((j,F)=>{if(!j.validate(k[F]))throw new Error(`Invalid argument '${j.name}' when running '${b.id}', received: ${typeof k[F]=="object"?JSON.stringify(k[F],null,"	"):k[F]} `);return j.convert(k[F])}),I=await this.executeCommand(b.internalId,...P);return b.result.convert(I,k,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new N.$RM(()=>{E.dispose(),this.c.delete(b.id)})}registerCommand(b,E,k,P,I,j){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:P,metadata:I,extension:j}),b&&this.#e.$registerCommand(E),new N.$RM(()=>{this.b.delete(E)&&b&&this.#e.$unregisterCommand(E)})}executeCommand(b,...E){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,E,!0)}async g(b,E,k){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,E,!1);{let P=!1;const I=(0,R.$Yn)(E,function(j){if(j instanceof N.$SM)return L.Position.from(j);if(j instanceof N.$TM)return L.Range.from(j);if(j instanceof N.$4M)return L.location.from(j);if(N.$gO.isNotebookRange(j))return L.NotebookRange.from(j);if(j instanceof ArrayBuffer)return P=!0,a.$Ce.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return P=!0,a.$Ce.wrap(j);if(j instanceof a.$Ce)return P=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(b,P?new n.$lw(I):I,k);return(0,S.$Zh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(b,E,!1);throw j}}}async h(b,E,k){const P=this.b.get(b);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:j,metadata:F}=P;if(F?.args)for(let O=0;O<F.args.length;O++)try{(0,u.$ig)(E[O],F.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${F.args[O].name}' - ${F.args[O].description}`)}const z=r.$0d.create();try{return await I.apply(j,E)}catch(O){if(b===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...E);T&&(b=T.command)}if(this.d.error(O,b,P.extension?.identifier),!k)throw O;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,O);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(O)),this.id=b,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,b,z.elapsed())}}j(b,E,k){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new o.$_o(E),duration:k})}$executeContributedCommand(b,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const k=this.b.get(b);return k?(E=E.map(P=>this.f.reduce((I,j)=>j.processArgument(I,k.extension?.identifier),P)),this.h(b,E,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(E=>(b&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[E,k]of this.b){const{metadata:P}=k;P&&(b[E]=P)}return Promise.resolve(b)}};e.$xP=c,e.$xP=c=Je([qe(0,l.$cP),qe(1,$.$Wj),qe(2,t.$wP)],c),e.$yP=(0,v.$qi)("IExtHostCommands");class h{constructor(b,E,k){this.d=b,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,g.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,E){if(!b)return;const k={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return k;const P=this.f(b.command);if(P)k.id=P.internalId,k.arguments=P.args.map((I,j)=>I.convert(b.arguments&&b.arguments[j]));else if((0,p.$Lb)(b.arguments)){const I=`${b.command} /${++this.c}`;this.b.set(I,b),E.add((0,y.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),k.$ident=I,k.id=this.delegatingCommandId,k.arguments=[I],this.g.trace("CommandsConverter#CREATE",b.command,I)}return k}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const E=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$zP=h;class s{static{this.Uri=new s("uri","Uri of a text document",b=>m.URI.isUri(b),b=>b)}static{this.Position=new s("position","A position in a text document",b=>N.$SM.isPosition(b),L.Position.from)}static{this.Range=new s("range","A range in a text document",b=>N.$TM.isRange(b),L.Range.from)}static{this.Selection=new s("selection","A selection in a text document",b=>N.$UM.isSelection(b),L.Selection.from)}static{this.Number=new s("number","",b=>typeof b=="number",b=>b)}static{this.String=new s("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=s.Arr(s.String)}static Arr(b){return new s(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,E=>Array.isArray(E)&&E.every(k=>b.validate(k)),E=>E.map(k=>b.convert(k)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",b=>b instanceof N.$cN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",b=>b instanceof N.$AO,L.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",b=>b instanceof f.$pP,L.TestItem.from)}constructor(b,E,k,P){this.name=b,this.description=E,this.validate=k,this.convert=P}optional(){return new s(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,E){return new s(b??this.name,E??this.description,this.validate,this.convert)}}e.$AP=s;class w{static{this.Void=new w("no result",b=>b)}constructor(b,E){this.description=b,this.convert=E}}e.$BP=w;class d{constructor(b,E,k,P,I){this.id=b,this.internalId=E,this.description=k,this.args=P,this.result=I}}e.$CP=d}),define(ke[349],Ee([1,0,19,15,2,83,134,37,33,16,7]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;const C=[new $.$CP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of DocumentHighlight-instances.",y(S.DocumentHighlight.to))),new $.$CP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,u.$Kb)(l))return;class a extends A.$0M{static to(i){const r=new a(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new A.$4M(f[0],S.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=S.Range.to(i.selectionRange),r.children=i.children?i.children.map(a.to):[],r}}return l.map(a.to)})),new $.$CP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$AP.Uri,new $.$AP("options","Formatting options",l=>!0,l=>l)],new $.$BP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$CP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$AP.Uri,$.$AP.Range,new $.$AP("options","Formatting options",l=>!0,l=>l)],new $.$BP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$CP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$AP.Uri,$.$AP.Position,new $.$AP("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$AP("options","Formatting options",l=>!0,l=>l)],new $.$BP("A promise that resolves to an array of TextEdits.",y(S.TextEdit.to))),new $.$CP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$CP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Location-instances.",y(S.location.to))),new $.$CP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of Hover-instances.",y(S.Hover.to))),new $.$CP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$AP.Uri,new $.$AP("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>A.$SM.isPosition(f)),l=>l.map(S.Position.from))],new $.$BP("A promise that resolves to an array of ranges.",l=>l.map(f=>{let a;for(const n of f.reverse())a=new A.$bN(S.Range.to(n),a);return a}))),new $.$CP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$AP.String.with("query","Search string")],new $.$BP("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(S.WorkspaceSymbol.to))),new $.$CP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(S.CallHierarchyItem.to))),new $.$CP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(S.CallHierarchyIncomingCall.to))),new $.$CP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$AP.CallHierarchyItem],new $.$BP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(S.CallHierarchyOutgoingCall.to))),new $.$CP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:S.Range.to(l.range),placeholder:l.text}})),new $.$CP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("newName","The new symbol name")],new $.$BP("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return S.WorkspaceEdit.to(l)}})),new $.$CP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$AP.Uri,$.$AP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$BP("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(S.DocumentLink.to))),new $.$CP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$0N(l.tokenTypes,l.tokenModifiers)})),new $.$CP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$AP.Uri],new $.$BP("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,M.$Gbb)(l);if(f.type==="full")return new A.$_N(f.data,void 0)})),new $.$CP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$AP.Uri,$.$AP.Range.optional()],new $.$BP("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new A.$0N(l.tokenTypes,l.tokenModifiers)})),new $.$CP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,M.$Gbb)(l);if(f.type==="full")return new A.$_N(f.data,void 0)})),new $.$CP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$AP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$BP("A promise that resolves to a CompletionList-instance.",(l,f,a)=>{if(!l)return new A.$nN([]);const n=l.suggestions.map(i=>S.CompletionItem.to(i,a));return new A.$nN(n,l.incomplete)})),new $.$CP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$AP.Uri,$.$AP.Position,$.$AP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$BP("A promise that resolves to SignatureHelp.",l=>{if(l)return S.SignatureHelp.to(l)})),new $.$CP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$AP.Uri,$.$AP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$BP("A promise that resolves to an array of CodeLens-instances.",(l,f,a)=>y(n=>new A.$fN(S.Range.to(n.range),n.command&&a.fromInternal(n.command)))(l))),new $.$CP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$AP.Uri,new $.$AP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>A.$TM.isRange(l),l=>A.$UM.isSelection(l)?S.Selection.from(l):S.Range.from(l)),$.$AP.String.with("kind","Code action kind to return code actions for").optional(),$.$AP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$BP("A promise that resolves to an array of Command-instances.",(l,f,a)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new A.$_M(n.title,n.kind?new A.$aN(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(l))),new $.$CP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new A.$tN(S.Range.to(f.range),S.Color.to(f.color))):[])),new $.$CP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$AP("color","The color to show and insert",l=>l instanceof A.$sN,S.Color.from),new $.$AP("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:S.Range.from(l.range)}))],new $.$BP("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(S.ColorPresentation.to):[])),new $.$CP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$AP.Uri,$.$AP.Range],new $.$BP("A promise that resolves to an array of Inlay objects",(l,f,a)=>l.map(S.InlayHint.to.bind(void 0,a)))),new $.$CP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$AP.Uri],new $.$BP("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(S.FoldingRange.to)})),new $.$CP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$BP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.to(f))})))),new $.$CP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$AP.Uri,$.$AP.Range,new $.$AP("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof A.$TM,l=>S.InlineValueContext.from(l))],new $.$BP("A promise that resolves to an array of InlineValue objects",l=>l.map(S.InlineValue.to))),new $.$CP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$AP("uriOrString","Uri-instance or string (only http/https)",l=>L.URI.isUri(l)||typeof l=="string"&&(0,N.$Ag)(l,N.Schemas.http,N.Schemas.https),l=>l),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional(),$.$AP.String.with("label","").optional()],$.$BP.Void),new $.$CP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$AP.Uri.with("resource","Resource to open"),$.$AP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional()],$.$BP.Void),new $.$CP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$AP.Uri.with("left","Left-hand side resource of the diff editor"),$.$AP.Uri.with("right","Right-hand side resource of the diff editor"),$.$AP.String.with("title","Human readable title for the diff editor").optional(),new $.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)]).optional()],$.$BP.Void),new $.$CP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$AP.String.with("title","Human readable title for the changes editor"),new $.$AP("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[a,n,i]=f;if(!L.URI.isUri(a)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},l=>l)],$.$BP.Void),new $.$CP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$AP.Uri,$.$AP.Position],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$AP.TypeHierarchyItem],new $.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new $.$CP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$AP.TestItem],$.$BP.Void),new $.$CP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$AP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$BP.Void),new $.$CP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$AP.String.with("name","The context key name"),new $.$AP("value","The context key value",()=>!0,l=>l)],$.$BP.Void),new $.$CP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$AP.Uri,$.$AP.StringArray,new $.$AP("MappedEditsContext","Mapped Edits Context",l=>S.MappedEditsContext.is(l),l=>S.MappedEditsContext.from(l))],new $.$BP("A promise that resolves to a workspace edit or null",l=>l?S.WorkspaceEdit.to(l):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$Bkc=m;function y(l){return f=>{if(Array.isArray(f))return f.map(l)}}function v(l){if(!Array.isArray(l))return;const f=[];for(const a of l)R.$2t(a)?f.push(S.DefinitionLink.to(a)):f.push(S.location.to(a));return f}}),define(ke[350],Ee([1,0,8,3,2,6,33,16,7]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class S{static{this.a=0}constructor(y,v){this.extension=y,this.provider=v,this.handle=S.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class C{static{this.a=0}constructor(y,v,l,f){this.f=l,this.g=f,this.b=new Map,this.d=new Map,this.e=y.getProxy(R.$PM.MainThreadInlineChat),v.registerApiCommand(new M.$CP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$AP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?p.Range.from(a.initialRange):void 0,initialSelection:$.$UM.isSelection(a.initialSelection)?p.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?p.Position.from(a.position):void 0}})],M.$BP.Void))}registerProvider(y,v,l){const f=new S(y,v);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,l?.label??y.displayName??y.name,y.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",l?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(y,v,l,f){const a=this.b.get(y);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=p.Selection.to(l),r=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},f);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new A(r)),{id:o,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(r.wholeRange),message:r.message}}async $provideResponse(y,v,l,f){const a=this.b.get(y);if(!a)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:l.prompt,selection:p.Selection.to(l.selection),wholeRange:p.Range.to(l.wholeRange),attempt:l.attempt,live:l.live,previewDocument:this.f.getDocument(L.URI.revive(l.previewDocument)),withIntentDetection:l.withIntentDetection};let r=!1;const o={report:async D=>{if(!l.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||f.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$gN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,f));let g;try{g=await(0,u.$eh)(t,f)}finally{r=!0}if(!g)return;const c=n.responses.push(g)-1,h={wholeRange:p.Range.from(g.wholeRange),placeholder:g.placeholder};if(!C.h(g))return{...h,id:c,type:"editorEdit",message:p.MarkdownString.from(g.contents),edits:[]};const{edits:s,contents:w}=g,d=w!==void 0?p.MarkdownString.from(w):void 0;return s instanceof $.$2M?{...h,id:c,type:"bulkEdit",edits:p.WorkspaceEdit.from(s),message:d}:{...h,id:c,type:"editorEdit",edits:s.map(p.TextEdit.from),message:d}}async $provideFollowups(y,v,l,f){const a=this.b.get(y),n=this.d.get(v),i=n?.responses[l];if(a&&i&&a.provider.provideFollowups){const r=Promise.resolve(a.provider.provideFollowups(n.session,i,f));return(await(0,u.$eh)(r,f))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(y,v,l,f){const a=this.b.get(y),n=this.d.get(v),i=n?.responses[l];if(a&&i){const r=p.InteractiveEditorResponseFeedbackKind.to(f);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(y,v){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$Klc=C}),define(ke[351],Ee([1,0,2,33]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class L{constructor(M,p,$,S,A){this.a=p,this.b=$,this.c=S;const C=new N.$CP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$AP("showOptions","Show Options",m=>!0,m=>m),new N.$AP("resource","Interactive resource Uri",m=>!0,m=>m),new N.$AP("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$AP("title","Interactive editor title",m=>!0,m=>m)],new N.$BP("Notebook and input URI",m=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const y=this.a.getEditorById(m.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:u.URI.revive(m.notebookUri),inputUri:u.URI.revive(m.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:u.URI.revive(m.notebookUri),inputUri:u.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(M,p,$,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Xlc=L}),define(ke[352],Ee([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,296,26,48,297]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0,e.$6lc=s;let r=class{constructor(d,D,b,E,k){this.m=D,this.n=b,this.o=E,this.q=k,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(C.$PM.MainThreadNotebookKernels);const P=new m.$CP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$AP("options","Select kernel options",j=>!0,j=>{if(j&&"notebookEditor"in j&&"id"in j){const F=this.n.getIdByEditor(j.notebookEditor);return{id:j.id,extension:j.extension,notebookEditorId:F}}else if(j&&"notebookEditor"in j){const F=this.n.getIdByEditor(j.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${j.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return j})],m.$BP.Void),I=new m.$CP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[m.$AP.Uri],new m.$BP("A promise that resolves to an array of variables",(j,F)=>j.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(d,D,b,E,k,P){for(const we of this.j.values())if(we.controller.id===D&&S.$Lm.equals(d.identifier,we.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,j=this;this.q.trace(`NotebookController[${I}], CREATED by ${d.identifier.value}, ${D}`);const F=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${d.identifier}'`);let z=!1;const O=new R.$be,T=new R.$be,B={id:s(d.identifier,D),notebookType:b,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:E||d.identifier.value,preloads:P?P.map(y.NotebookRendererScript.from):[]};let W=k??F,X,x;this.a.$addKernel(I,B).catch(we=>{console.log(we),z=!0});let Y=0;const Z=()=>{if(z)return;const we=++Y;Promise.resolve().then(()=>{we===Y&&this.a.$updateKernel(I,B)})},ue=new p.$Bc,te={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(we){B.label=we??d.displayName??d.name,Z()},get detail(){return B.detail??""},set detail(we){B.detail=we,Z()},get description(){return B.description??""},set description(we){B.description=we,Z()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(we){B.supportedLanguages=we,Z()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(we){B.supportsExecutionOrder=we,Z()},get rendererScripts(){return B.preloads?B.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(we){W=we??F},get interruptHandler(){return X},set interruptHandler(we){X=we,B.supportsInterrupt=!!we,Z()},set variableProvider(we){(0,a.$xG)(d,"notebookVariableProvider"),x=we,B.hasVariableProvider=!!we,we?.onDidChangeVariables(Se=>j.a.$variablesUpdated(Se.uri)),Z()},get variableProvider(){return x},createNotebookCellExecution(we){if(z)throw new Error("notebook controller is DISPOSED");if(!ue.has(we.notebook.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return j._createNotebookCellExecution(we,s(d.identifier,this.id))},createNotebookExecution(we){if((0,a.$xG)(d,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ue.has(we.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return j._createNotebookExecution(we,s(d.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(we,Se){Se===v.NotebookControllerAffinity2.Hidden&&(0,a.$xG)(d,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(I,we.uri,Se)},onDidReceiveMessage:T.event,postMessage(we,Se){return(0,a.$xG)(d,"notebookMessaging"),j.a.$postMessage(I,Se&&j.n.getIdByEditor(Se),we)},asWebviewUri(we){return(0,a.$xG)(d,"notebookMessaging"),(0,l.$5xb)(we,j.m.remote)}};return this.j.set(I,{extensionId:d.identifier,controller:te,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ue}),te}getIdByController(d){for(const[D,b]of this.j)if(b.controller===d)return s(b.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,D){const b=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(b,D);const k={dispose:()=>{this.f.delete(b),E.a.$removeKernelDetectionTask(b)}};return this.f.set(b,k),k}registerKernelSourceActionProvider(d,D,b){const E=this.i++,k=typeof b.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,b),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,D);let I;return k!==void 0&&(I=b.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),I?.dispose()}}}async $provideKernelSourceActions(d,D){const b=this.h.get(d);if(b){const E=new M.$Tc;return(await b.provideNotebookKernelSourceActions(D)??[]).map(P=>y.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(d,D,b){const E=this.j.get(d);if(E){const k=this.n.getNotebookDocument($.URI.revive(D));b?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,k.uri.toString(),b),E.onDidChangeSelection.fire({selected:b,notebook:k.apiNotebook})}}async $executeCells(d,D,b){const E=this.j.get(d);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(D)),P=[];for(const I of b){const j=k.getCell(I);j&&P.push(j.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,k.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,k.apiNotebook,E.controller)}catch(I){this.q.error(`NotebookController[${d}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(d,D,b){const E=this.j.get(d);if(!E)return;const k=this.n.getNotebookDocument($.URI.revive(D));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const P of b){const I=k.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(k.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(d,D,b,E,k,P,I){const j=this.j.get(d);if(!j)return;const F=this.n.getNotebookDocument($.URI.revive(b)),z=j.controller.variableProvider;if(!z)return;let O;if(E!==void 0){if(O=this.s[E],!O)return}else this.s={};const T=k==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(F.apiNotebook,O,T,P,I);let W=0;for await(const X of B){if(I.isCancellationRequested)return;const x={id:this.r++,name:X.variable.name,value:X.variable.value,type:X.variable.type,interfaces:X.variable.interfaces,language:X.variable.language,expression:X.variable.expression,hasNamedChildren:X.hasNamedChildren,indexedChildrenCount:X.indexedChildrenCount,extensionId:j.extensionId.value};if(this.s[x.id]=X.variable,this.a.$receiveVariable(D,x),W++>=i.$Iib)return}}$acceptKernelMessageFromRenderer(d,D,b){const E=this.j.get(d);if(!E)return;const k=this.n.getEditorById(D);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:b}))}$cellExecutionChanged(d,D,b){const k=this.n.getNotebookDocument($.URI.revive(d)).getCell(D);if(k){const P=b?y.NotebookCellExecutionState.to(b):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution(d,D){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new t(D,E,this.a);this.b.set(E.uri,k);const P=k.onDidChangeState(()=>{k.state===o.Resolved&&(k.dispose(),P.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(d,D){const b=this.n.getNotebookDocument(d.uri),E=d.getCells().find(I=>{const j=b.getCellFromApiCell(I);return j&&this.b.has(j.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const k=new c(D,b,this.a),P=k.onDidChangeState(()=>{k.state===g.Resolved&&(k.dispose(),P.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[k,P]),k.asApiObject()}};e.$5lc=r,e.$5lc=r=Je([qe(4,A.$Wj)],r);var o;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(o||(o={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,b){super(),this.m=D,this.n=b,this.b=t.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new L.$me),this.h=new h(10,E=>this.s(E)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const D=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$lw(D))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let D=this.m;if(d&&(D=this.m.notebook.getCellFromApiCell(d)),!D)throw new Error("INVALID cell");return D.handle}y(d){return d.map(D=>{const b=v.$kO.ensureUniqueMimeTypes(D.items,!0);return b===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:b,id:D.id,metadata:D.metadata})})}async z(d,D,b){const E=this.w(D),k=this.y((0,u.$3b)(d));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:E,append:b,outputs:k})}async C(d,D,b){return d=v.$kO.ensureUniqueMimeTypes((0,u.$3b)(d),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(y.NotebookCellOutputItem.from),outputId:D.id,append:b})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(b){d.j=b,d.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(b){if(d.f===o.Resolved||d.f===o.Started)throw new Error("Cannot call start again");d.f=o.Started,d.c.fire(),d.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,E,k){if(d.f===o.Resolved)throw new Error("Cannot call resolve twice");d.f=o.Resolved,d.c.fire(),d.h.flush();const P=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;d.n.$completeExecution(d.b,new n.$lw({runEndTime:E,lastRunSuccess:b,error:P}))},clearOutput(b){return d.t(),d.z([],b,!1)},appendOutput(b,E){return d.t(),d.z(b,E,!0)},replaceOutput(b,E){return d.t(),d.z(b,E,!1)},appendOutputItems(b,E){return d.t(),d.C(b,E,!0)},replaceOutputItems(b,E){return d.t(),d.C(b,E,!1)}})}}var g;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(g||(g={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,D,b){super(),this.h=D,this.j=b,this.b=c.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new L.$me),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class h{constructor(d,D){this.f=d,this.g=D,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>d.complete())}}function s(w,d){return`${w.value}/${d}`}}),define(ke[43],Ee([1,0,4,6,5,2,20,3,7,226,13,272,22,30,273,57,8,16,33]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=e.$elc=e.$dlc=void 0,e.$dlc=(0,L.$qi)("IExtHostTerminalService");class i extends p.$Uc{constructor(b,E,k,P){super(),this.u=b,this._id=E,this.w=k,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(j,F=!0){I.C(),I.u.$sendText(I._id,j,F)},show(j){I.C(),I.u.$show(I._id,j)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??E?.cwd??void 0,env:b.env??void 0,icon:s(b.iconPath)??void 0,color:l.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(b.location,E?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,E,k,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:l.ThemeColor.isThemeColor(I)?I.id:void 0,location:E?.location||this.z(b,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,E){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in b?{viewColumn:a.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,E){this.j=Object.freeze({code:b,reason:E})}setDimensions(b,E){return b===this.f&&E===this.h||b===0||E===0?!1:(this.f=b,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(E=>{E!==b&&(this.b=Promise.resolve(b))})}}e.$elc=i;class r{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new u.$be,this.onProcessData=this.a.event,this.b=new u.$be,this.d=new u.$be,this.onDidChangeProperty=this.d.event,this.f=new u.$be,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,E){this.g.setDimensions?.({columns:b,rows:E})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$be,this.onDidCloseTerminal=this.H.event,this.I=new u.$be,this.onDidOpenTerminal=this.I.event,this.J=new u.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$be,this.onDidChangeTerminalState=this.M.event,this.N=new u.$be,this.onDidChangeShell=this.N.event,this.O=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(N.$PM.MainThreadTerminalService),this.y=new v.$4sb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const I=j=>{const F=j;return this.getTerminalById(F.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let j=0;j<P.length&&P[j].$mid===15;j++)P[j]=I(P[j]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,E){const k=new i(this.a,(0,y.$Mg)(),b,b.name),P=new r(b.pty);return k.createExtensionTerminal(b.location,E,this.R(b,E).resolvedExtHostIdentifier,s(b.iconPath),w(b.color)).then(I=>{const j=this.S(I,P);this.h[I]=j}),this.f.push(k),k.value}R(b,E){if(E=E||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const k=b.location.parentTerminal;if(k){const P=this.f.find(I=>I.value===k);P&&(E.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?E.location=b.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(b,E){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new r(E),I=this.S(b,P);this.h[b]=I}async $acceptActiveTerminalChanged(b){const E=this.b;if(b===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(b);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,E){const k=this.getTerminalById(b);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(b,E,k){const P=this.getTerminalById(b);P&&P.setDimensions(E,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,E){const k=this.getTerminalById(b);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(b,E,k){this.g.get(b)?.resize(E,k)}async $acceptTerminalTitleChange(b,E){const k=this.getTerminalById(b);k&&(k.name=E)}async $acceptTerminalClosed(b,E,k){const P=this.X(this.f,b);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(E,k),this.H.fire(I.value)}}$acceptTerminalOpened(b,E,k,P){if(E){const F=this.X(this.f,E);if(F!==null){this.f[F]._id=b,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new i(this.a,b,I,k);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(b,E){this.getTerminalById(b)?._setProcessId(E)}async $startExtensionTerminal(b,E){const k=this.getTerminalById(b);if(!k)return{message:(0,S.localize)(0,null,b)};k.isOpen||await new Promise(I=>{const j=this.onDidOpenTerminal(async F=>{F===k.value&&(j.dispose(),I())})});const P=this.g.get(b);P?P.startSendingEvents(E):this.j[b]={initialDimensions:E}}S(b,E){const k=new p.$Tc;k.add(E.onProcessReady(I=>this.a.$sendProcessReady(b,I.pid,I.cwd,I.windowsPty))),k.add(E.onDidChangeProperty(I=>this.a.$sendProcessProperty(b,I))),this.y.startBuffering(b,E.onProcessData),k.add(E.onProcessExit(I=>this.U(b,I))),this.g.set(b,E);const P=this.j[b];return P&&E instanceof r&&(E.startSendingEvents(P.initialDimensions),delete this.j[b]),k}$acceptProcessAckDataEvent(b,E){this.g.get(b)?.acknowledgeDataEvent(E)}$acceptProcessInput(b,E){this.g.get(b)?.input(E)}$acceptTerminalInteraction(b){const E=this.getTerminalById(b);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(b,E){this.getTerminalById(b)?.setSelection(E)}$acceptProcessResize(b,E,k){try{this.g.get(b)?.resize(E,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,E){this.g.get(b)?.shutdown(E)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(E=>this.a.$sendProcessProperty(b,{type:"cwd",value:E}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$RM(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,b.identifier.value),new $.$RM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(b,E,k){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,k),this.a.$registerQuickFixProvider(b,E),new $.$RM(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,E){const k=new m.$me().token;if(k.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const I=await P.provideTerminalQuickFixes(E,k);if(I===null||Array.isArray(I)&&I.length===0)return;const j=new p.$Tc;if(this.w.value=j,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,j):void 0;const F=[];for(const z of I){const O=a.TerminalQuickFix.from(z,this.Q.converter,j);O&&F.push(O)}return F}async $createContributedProfileTerminal(b,E){const k=new m.$me().token;let P=await this.C.get(b)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(b,E){const k=this.getTerminalById(b);if(!k)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const I=new m.$me;this.G.set(b,I);const j=[],F={terminal:k.value,line:E},z=[];for(const B of this.z)z.push(f.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const X=await B.provideTerminalLinks(F,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:X})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&j.push(...B.links.map(W=>{const X={id:o++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return T.set(X.id,{provider:B.provider,link:W}),X}));return this.F.set(b,T),j}$activateLink(b,E){const k=this.F.get(b)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(b,E){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const k=this.h[b];k&&(k.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,E)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const E=this.f.findIndex(k=>k.value===b);return E>=0?E:null}W(b,E){const k=this.X(b,E);return k!==null?b[k]:null}X(b,E){const k=b.findIndex(P=>P._id===E);return k>=0?k:null}getEnvironmentVariableCollection(b){let E=this.n.get(b.identifier.value);return E||(E=new g,this.Z(b.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(b,E){const k=(0,C.$cs)(E.map),P=(0,C.$ds)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(b,E.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(b){b.forEach(E=>{const k=E[0],P=new g(E[1]);this.Z(k,P)})}$acceptDefaultProfile(b,E){const k=this.s;this.s=b,this.u=E,k?.path!==b.path&&this.N.fire(b.path)}Z(b,E){this.n.set(b,E),E.onDidChangeCollection(()=>{this.Y(b,E)})}};e.$flc=t,e.$flc=t=Je([qe(1,n.$yP),qe(2,M.$cP)],t);class g{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$be,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const E=this.h(b);let k=this.a.get(E);return k||(k=new c(this,b),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(b,E,k,P){this.f(b,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(b,E,k,P){this.f(b,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(b,E,k,P){this.f(b,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(b,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(b,E.scope),P=this.map.get(k),I=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const j=this.g(b,E.scope),F={variable:b,...E,options:I};this.map.set(j,F),this.d.fire()}}get(b,E){const k=this.g(b,E),P=this.map.get(k);return P?d(P):void 0}g(b,E){const k=this.h(E);return k.length?`${b}:::${k}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const E=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(b)&&E.set(P.variable,d(P));return E}delete(b,E){const k=this.g(b,E);this.map.delete(k),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(E);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,E){const k=this.h(E),P=this.descriptionMap.get(k);if(!P||P.description!==b){let I;typeof b=="string"?I=b:I=b?.value.split(`

`)[0];const j={description:I,scope:E};this.descriptionMap.set(k,j),this.d.fire()}}getDescription(b){const E=this.h(b);return this.descriptionMap.get(E)?.description}k(b){const E=this.h(b);this.descriptionMap.delete(E)}}class c{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,E){this.b=b,this.d=E,this.a=new u.$be}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,E,k){this.b.replace(b,E,k,this.d)}append(b,E,k){this.b.append(b,E,k,this.d)}prepend(b,E,k){this.b.prepend(b,E,k,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,E){this.b.getVariableMap(this.d).forEach((k,P)=>b.call(E,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends t{constructor(b,E){super(!1,b,E)}createTerminal(b,E,k){throw new A.$_}createTerminalFromOptions(b,E){throw new A.$_}};e.$glc=h,e.$glc=h=Je([qe(0,n.$yP),qe(1,M.$cP)],h);function s(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function w(D){return l.ThemeColor.isThemeColor(D)?D:void 0}function d(D){const b={...D};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ke[155],Ee([1,0,7,3,5,6,20,43,4,2,8]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,L.$qi)("IExtHostTerminalShellIntegration");let C=class extends N.$Uc{constructor(f,a){super(),this.h=a,this.b=new Map,this.c=new $.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(R.$PM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(f){const a=this.h.getTerminalById(f);if(!a)return;const n=a.value;let i=this.b.get(f);i||(i=new m(a.value,this.f),this.b.set(f,i),i.store.add(a.onWillDispose(()=>this.b.get(f)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(f,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(f,a,n,i,r){this.b.has(f)||this.$shellIntegrationChange(f);const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.startShellExecution(o,r)}$shellExecutionEnd(f,a,n,i,r){const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.endShellExecution(o,r)}$shellExecutionData(f,a){this.b.get(f)?.emitData(a)}$cwdChange(f,a){this.b.get(f)?.setCwd((0,S.$wc)(a)?S.URI.revive(a):a)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$lmc=C,e.$lmc=C=Je([qe(0,M.$cP),qe(1,p.$dlc)],C);class m extends N.$Uc{get currentExecution(){return this.a}constructor(f,a){super(),this.j=f,this.m=a,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new $.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,r){let o=i;r&&(o+=` "${r.map(c=>`${c.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:u.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=n.startShellExecution(t,n.c,!0).value;return n.b=!0,g}}}startShellExecution(f,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(f,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(f){let a=!1;S.URI.isUri(this.c)?a=!S.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(a=!0),a&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(f,a){this.c=f,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Qh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const f=this.a=new A.$ph;return new A.$Qh(async n=>{this.b.push(n),await f.wait()})}emitData(f){for(const a of this.b)a.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[353],Ee([1,0,8,21,22,4,74,56,3,18,30,12,6,20,154,16,7,68,112,89]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=e.$nmc=e.$mmc=void 0;let r=class extends $.$Uc{constructor(I,j,F,z){super(),this.w=z,this.f=this.B(new R.$be),this.g=new Map,this.s=this.B(new R.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(m.$PM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,j),F.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(a.$BL.root(B))?.collection.tree.get(B)?.actual??(0,v.$oP)(O)}case 18:{const{test:T,message:B}=O,W=T.item.extId;return{test:this.g.get(a.$BL.root(W))?.collection.tree.get(W)?.actual??(0,v.$oP)({$mid:16,tests:[T]}),message:l.TestMessage.to(B)}}default:return O}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await F.executeCommand("_testing.getExplorerSelection"),T=B=>{const W=this.g.get(a.$BL.root(B));if(W)return a.$BL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$_f)||[],exclude:O?.exclude.map(T).filter(S.$_f)||[]}})}createTestController(I,j,F,z){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const O=new $.$Tc,T=O.add(new v.$rP(j,F,this.w));T.root.label=F;const B=new Map,W=new Set,X=this.h,x={items:T.root.children,get label(){return F},set label(Z){F=Z,T.root.label=Z,X.$updateController(j,{label:F})},get refreshHandler(){return z},set refreshHandler(Z){z=Z,X.$updateController(j,{canRefresh:!!Z})},get id(){return j},createRunProfile:(Z,ue,te,we,Se,_)=>{let U=(0,p.$ej)(Z);for(;B.has(U);)U++;return new E(this.h,B,W,this.s.event,j,U,Z,ue,te,we,Se,_)},createTestItem(Z,ue,te){return new v.$pP(j,Z,ue,te)},createTestRun:(Z,ue,te=!0)=>this.j.createTestRun(j,T,Z,ue,te),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const ue=Z instanceof Array?Z:[Z];this.h.$markTestRetired(ue.map(te=>a.$BL.fromExtHostTestItem(te,j).toString()))}},set resolveHandler(Z){T.resolveHandler=Z},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};X.$registerTestController(j,F,!!z),O.add((0,$.$Sc)(()=>X.$unregisterTestController(j)));const Y={controller:x,collection:T,profiles:B,extension:I,activeProfiles:W};return this.g.set(j,Y),O.add((0,$.$Sc)(()=>this.g.delete(j))),O.add(T.onDidGenerateDiff(Z=>X.$publishDiff(j,Z.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(I,j=L.CancellationToken.None){const F=h(I);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(F.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>a.$BL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:k[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:I.exclude?.map(O=>O.id)},j)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,j){return(await this.j.getCoverageDetails(I,j))?.map(l.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,j){this.g.get(I)?.profiles.get(j)?.configureHandler?.()}$setDefaultRunProfiles(I){const j=new Map;for(const[F,z]of Object.entries(I)){const O=this.g.get(F);if(!O)continue;const T=new Map,B=z.filter(X=>!O.activeProfiles.has(X)),W=[...O.activeProfiles].filter(X=>!z.includes(X));for(const X of B)T.set(X,!0),O.activeProfiles.add(X);for(const X of W)T.set(X,!1),O.activeProfiles.delete(X);T.size&&j.set(F,T)}this.s.fire(j)}async $refreshTests(I,j){await this.g.get(I)?.controller.refreshHandler?.(j)}$publishTestResults(I){this.results=Object.freeze(I.map(l.TestResults.to).concat(this.results).sort((j,F)=>F.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,j){const F=this.g.get(a.$BL.fromString(I).controllerId)?.collection;F&&(await F.expand(I,j<0?1/0:j),F.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(j=>i.TestsDiffOp.deserialize({asCanonicalUri:F=>F},j)))}async $runControllerTests(I,j){return Promise.all(I.map(F=>this.y(F,!1,j)))}async $startContinuousRun(I,j){const F=new L.$me(j),z=await Promise.all(I.map(O=>this.y(O,!0,F.token)));return!j.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>j.onCancellationRequested(O)),F.dispose(!0),z}async y(I,j,F){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:T}=z,B=T.get(I.profileId);if(!B)return{};const W=I.testIds.map(Z=>O.tree.get(Z)).filter(S.$_f),X=I.excludeExtIds.map(Z=>z.collection.tree.get(Z)).filter(S.$_f).filter(Z=>W.some(ue=>ue.fullId.compare(Z.fullId)===2));if(!W.length)return{};const x=new f.$rO(W.some(Z=>Z.actual instanceof v.$qP)?void 0:W.map(Z=>Z.actual),X.map(Z=>Z.actual),B,j),Y=(0,i.$EL)(I)&&this.j.prepareForMainThreadTestRun(x,s.fromInternal(I,z.collection),B,F);try{return await B.runHandler(x,F),{}}catch(Z){return{error:String(Z)}}finally{Y&&Y.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(Y.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$mmc=r,e.$mmc=r=Je([qe(0,y.$cP),qe(1,C.$Wj)],r);const o=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class g extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,j,F,z,O){super(),this.y=I,this.z=j,this.C=F,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$me(O));const T=this.B(new u.$Ch(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new R.$be;this.s=B.event,this.B((0,$.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,j){const[,F,z]=a.$BL.fromString(I).path,O=this.w.get(z);if(!O)return[];const T=this.g.get(F);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,j)??[]}createRun(I){const j=this.y.id,F=this.y.controllerId,z=(0,A.$Mg)(),O=X=>(x,...Y)=>{if(B){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.H(x),X(x,...Y))},T=(X,x)=>{const Y=x instanceof Array?x.map(l.TestMessage.from):[l.TestMessage.from(x)];if(X.uri&&X.range){const Z={range:l.Range.from(X.range),uri:X.uri};for(const ue of Y)ue.location=ue.location||Z}this.z.$appendTestMessagesInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),Y)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:X=>{const x=X.uri.toString(),Y=new a.$BL([j,z,x]).toString();this.w.set(x,X),this.z.$appendCoverage(j,z,l.TestCoverage.fromFile(Y,X))},enqueued:O(X=>{this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),1)}),skipped:O(X=>{this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),5)}),started:O(X=>{this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),2)}),errored:O((X,x,Y)=>{T(X,x),this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),6,Y)}),failed:O((X,x,Y)=>{T(X,x),this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,F).toString(),4,Y)}),passed:O((X,x)=>{this.z.$updateTestStateInRun(j,z,a.$BL.fromExtHostTestItem(X,this.y.controllerId).toString(),3,x)}),appendOutput:(X,x,Y)=>{B||(Y&&(this.y.isIncluded(Y)?this.H(Y):Y=void 0),this.z.$appendOutputToRun(j,z,N.$Ce.fromString(X),x&&l.location.from(x),Y&&a.$BL.fromExtHostTestItem(Y,F).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(j,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(j,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$pP))throw new n.$7O(I.id);if(this.h.has(a.$BL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const j=[],F=this.y.colllection.root;for(;;){const z=l.TestItem.from(I);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===F))break;I=I.parent||F}this.z.$addTestsToRun(this.y.controllerId,this.y.id,j)}dispose(){this.G(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(I,j){this.g=I,this.h=j,this.c=new Map,this.f=new Map}getCoverageDetails(I,j){const F=a.$BL.root(I);return this.f.get(F)?.getCoverageDetails(I,j)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[j,{id:F}]of this.c)F===I&&this.c.delete(j)}prepareForMainThreadTestRun(I,j,F,z){return this.j(I,j,F,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,j,F,z,O){const T=this.c.get(F);if(T)return T.createRun(z);const B=s.fromPublic(I,j,F,O),W=h(F);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!F.continuous,profile:W&&{group:k[W.kind],id:W.profileId},exclude:F.exclude?.map(x=>a.$BL.fromExtHostTestItem(x,j.root.id).toString())??[],id:B.id,include:F.include?.map(x=>a.$BL.fromExtHostTestItem(x,j.root.id).toString())??[j.root.id],persist:O});const X=this.j(F,B,F.profile);return R.Event.once(X.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),X.createRun(z)}j(I,j,F,z){const O=new g(j,this.g,this.h,F,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$nmc=c;const h=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class s{static fromPublic(I,j,F,z){return new s(I,(0,A.$Mg)(),F.include?.map(O=>a.$BL.fromExtHostTestItem(O,I).toString())??[I],F.exclude?.map(O=>a.$BL.fromExtHostTestItem(O,I).toString())??[],z,j)}static fromInternal(I,j){return new s(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,j)}constructor(I,j,F,z,O,T){this.controllerId=I,this.id=j,this.isPersisted=O,this.colllection=T,this.c=F.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const j=a.$BL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const F of this.f)if(j===F||j.startsWith(F))return!1;for(const F of this.c)if(j===F||j.startsWith(F))return!0;return!1}}e.$omc=s;class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,l.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const j=a.$BL.parentId(I.item.extId);if(j&&this.h.has(j.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:j,g:F}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...F].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends i.$KL{constructor(){super(...arguments),this.s=new R.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,j){return{...I,revived:l.TestItem.toPlain(I.item),depth:j?j.depth+1:0,children:new Set}}v(){return new w(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(j=>j.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new d({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const b=(P,I,j,F)=>{j?Object.assign(j,F):I.$updateTestRunConfig(P.controllerId,P.profileId,F)};class E{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,b(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,b(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),b(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,b(this,this.#e,this.#n,{tag:I?l.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,b(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(S.$_f))}constructor(I,j,F,z,O,T,B,W,X,x=!1,Y=void 0,Z=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=W,this.runHandler=X,this._tag=Y,this.g=Z,this.#e=I,this.#s=j,this.#t=F,this.#i=z,j.set(T,this);const ue=k[W];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);x&&F.add(T),this.#n={profileId:T,controllerId:O,tag:Y?l.TestTag.namespace(this.controllerId,Y.id):null,label:B,group:ue,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Z},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$pmc=E;const k={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,7]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=e.$jP=void 0;class p{static{this.c=new L.$hP("TextEditorDecorationType")}constructor(m,y,v){const l=p.c.nextId();m.$registerTextEditorDecorationType(y.identifier,l,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$jP=p;class ${constructor(m,y){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,y){this.k();let v=null;if(m instanceof M.$SM)v=new M.$TM(m,m);else if(m instanceof M.$TM)v=m;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(m,y){this.k(),this.l(new M.$TM(m,m),y,!0)}delete(m){this.k();let y=null;if(m instanceof M.$TM)y=m;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(m,y,v){const l=this.c.validateRange(m);this.g.push({range:l,text:y,forceMoveMarkers:v})}setEndOfLine(m){if(this.k(),m!==M.EndOfLine.LF&&m!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=m}}class S{constructor(m,y,v,l){this.c=m,this.d=y,this._accept(v),this.e=l;const f=this;this.value={get tabSize(){return f.f},set tabSize(a){f.n(a)},get indentSize(){return f.g},set indentSize(a){f.p(a)},get insertSpaces(){return f.j},set insertSpaces(a){f.s(a)},get cursorStyle(){return f.k},set cursorStyle(a){f.t(a)},get lineNumbers(){return f.l},set lineNumbers(a){f.u(a)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}n(m){const y=this.m(m);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const y=Math.floor(m);return y>0?y:null}if(typeof m=="string"){const y=parseInt(m,10);return isNaN(y)?null:y>0?y:null}return null}p(m){const y=this.o(m);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const y=this.q(m);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(m)})))}assign(m){const y={};let v=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(v=!0,y.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,v=!0,y.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(v=!0,y.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,v=!0,y.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(v=!0,y.insertSpaces=l):this.j!==l&&(this.j=l,v=!0,y.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,v=!0,y.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,v=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(m.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(m,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(v)})}}e.$kP=S;class A{constructor(m,y,v,l,f,a,n,i){this.id=m,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=f,this.d=new S(this.j,this.id,a,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return l.value},set document(o){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(o){if(!(o instanceof M.$UM))throw(0,N.$7)("selection");r.c=[o],r.l()},get selections(){return r.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");r.c=o,r.l()},get visibleRanges(){return r.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(o){r.g||r.d.assign(o)},get viewColumn(){return r.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(l.value,t);return o(g),r.m(g)},insertSnippet(o,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=r.c.map(h=>R.Range.from(h));else if(t instanceof M.$SM){const{lineNumber:h,column:s}=R.Position.from(t);c=[{startLineNumber:h,startColumn:s,endLineNumber:h,endColumn:s}]}else if(t instanceof M.$TM)c=[R.Range.from(t)];else{c=[];for(const h of t)if(h instanceof M.$TM)c.push(R.Range.from(h));else{const{lineNumber:s,column:w}=R.Position.from(h);c.push({startLineNumber:s,startColumn:w,endLineNumber:s,endColumn:w})}}return y.$tryInsertSnippet(m,l.value.version,o.value,c,g)},setDecorations(o,t){const g=t.length===0;g&&!r.h.has(o.key)||(g?r.h.delete(o.key):r.h.add(o.key),r.n(()=>{if(R.$_O(t))return y.$trySetDecorations(m,o.key,R.$aP(t));{const c=new Array(4*t.length);for(let h=0,s=t.length;h<s;h++){const w=t[h];c[4*h]=w.start.line+1,c[4*h+1]=w.start.character+1,c[4*h+2]=w.end.line+1,c[4*h+3]=w.end.character+1}return y.$trySetDecorationsFast(m,o.key,c)}}))},revealRange(o,t){r.n(()=>y.$tryRevealRange(m,R.Range.from(o),t||M.TextEditorRevealType.Default))},show(o){y.$tryShowEditor(m,R.ViewColumn.from(o))},hide(){y.$tryHideEditor(m)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,u.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,u.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,u.ok)(!this.g),this.f=m}_acceptSelections(m){(0,u.ok)(!this.g),this.c=m}async l(){const m=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const y=m.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(f=>f.range);v.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=v.length-1;f<a;f++){const n=v[f].end;if(v[f+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=y.edits.map(f=>({range:R.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,l,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$lP=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,39,46]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class a{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,o){this.h=r,this.i=o,this.a=null,this.b=new Map,this.c=new y.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const o=[],t=[],g=[];if(r.removedDocuments)for(const c of r.removedDocuments){const h=R.URI.revive(c),s=this.c.get(h);s?.unref()&&(this.c.delete(h),o.push(s.value))}if(r.addedDocuments)for(const c of r.addedDocuments){const h=R.URI.revive(c.uri);let s=this.c.get(h);if(s&&h.scheme!==v.Schemas.vscodeNotebookCell&&h.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);s||(s=new a(new $.$fP(this.h.getProxy(p.$PM.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set(h,s),t.push(s.value)),s.ref()}if(r.removedEditors)for(const c of r.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&g.push(h)}if(r.addedEditors)for(const c of r.addedEditors){const h=R.URI.revive(c.documentUri);u.ok(this.c.has(h),`document '${h}' does not exist`),u.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const s=this.c.get(h).value,w=new A.$lP(c.id,this.h.getProxy(p.$PM.MainThreadTextEditors),this.i,new f.$V(()=>s.document),c.selections.map(C.Selection.to),c.options,c.visibleRanges.map(d=>C.Range.to(d)),typeof c.editorPosition=="number"?C.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,w)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Pc)(o),(0,L.$Pc)(g),r.removedDocuments&&this.e.fire(o),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return l.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const o=this.b.get(this.a);return r?o:o?.value}allEditors(){return[...this.b.values()]}};e.$mP=n,e.$mP=n=Je([qe(0,S.$cP),qe(1,m.$Wj)],n),e.$nP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(ke[354],Ee([1,0,19,4,6,156,16,7]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class ${constructor(A,C){this.i=C,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map(m=>m.value)}async showTextDocument(A,C,m){let y;typeof C=="number"?y={position:M.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?y={position:M.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?M.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,y),l=v&&this.i.getEditor(v);if(l)return l.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new R.$jP(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const m=this.i.getEditor(A);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const y=C.selections.selections.map(M.Selection.to);m._acceptSelections(y)}if(C.visibleRanges){const y=u.$Hb(C.visibleRanges.map(M.Range.to));m._acceptVisibleRanges(y)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:M.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const y=p.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(M.Selection.to);this.a.fire({textEditor:m.value,selections:v,kind:y})}if(C.visibleRanges){const y=u.$Hb(C.visibleRanges.map(M.Range.to));this.c.fire({textEditor:m.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const C in A){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const y=M.ViewColumn.to(A[C]);m.value.viewColumn!==y&&(m._acceptViewColumn(y),this.d.fire({textEditor:m.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Ikc=$}),define(ke[355],Ee([1,0,2,5,6,3,7,16,25,18]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$rmc=(0,N.$qi)("IExtHostTimeline");class A{constructor(y,v){this.b=new Map,this.c=new Map,this.a=y.getProxy(L.$PM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$Lm.equals(f,this.b.get(l.source)?.extension)){const a=l.uri===void 0?void 0:u.URI.revive(l.uri);return this.c.get(l.source)?.get(C(a))?.get(l.handle)}else return;return l}})}async $getTimeline(y,v,l,f){return this.b.get(y)?.provider.provideTimeline(u.URI.revive(v),l,f)}registerTimelineProvider(y,v,l,f){const a=new R.$Tc,n=this.d(v.id,f,a).bind(this);let i;v.onDidChange&&(i=v.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:v.id}),this));const r=this.c;return this.f({...v,scheme:y,onDidChange:void 0,async provideTimeline(o,t,g){t?.resetCache&&(a.clear(),r.get(v.id)?.clear());const c=await v.provideTimeline(o,t,g);if(c==null)return;const h=n(o,t);return{...c,source:v.id,items:c.items.map(h)}},dispose(){for(const o of r.values())o.get(v.id)?.clear();i?.dispose(),a.dispose()}},l)}d(y,v,l){return(f,a)=>{let n;if(a?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const r=C(f);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...o}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let g,c,h;i.iconPath&&(r instanceof M.$NN?h={id:r.id,color:r.color}:u.URI.isUri(r)?(g=r,c=r):{light:g,dark:c}=r);let s;return M.$gN.isMarkdownString(o.tooltip)?s=p.MarkdownString.from(o.tooltip):(0,S.$4f)(o.tooltip)?s=o.tooltip:M.$gN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=p.MarkdownString.from(o.detail)):(0,S.$4f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:y,command:i.command?v.toInternal(i.command,l):void 0,icon:g,iconDark:c,themeIcon:h,tooltip:s,accessibilityInformation:i.accessibilityInformation}}}}f(y,v){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:v}),(0,R.$Sc)(()=>{for(const f of this.c.values())f.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$smc=A;function C(m){return m?.toString()}}),define(ke[356],Ee([1,0,227,23,2,4,3,288,8,7,18,19,16,80,22,184,26]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;function a(r,o){if((0,A.$4f)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(o,t,g){super(),this.f=o,this.g=t,this.h=g,this.a=new Map,this.b=new l.$n9;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(s=>c(s)?this.r(s):s):h})}registerTreeDataProvider(o,t,g){const c=this.createTreeView(o,{treeDataProvider:t},g);return{dispose:()=>c.dispose()}}createTreeView(o,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],h=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,w=!!t.dragAndDropController?.handleDrop,d=this.m(o,t,g),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:s,hasHandleDrop:w,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(o,D),E={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,f.$xG)(g,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,f.$xG)(g,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(k){(0,y.$Pk)(k)&&(0,f.$xG)(g,"treeViewMarkdownMessage"),d.message=k},get title(){return d.title},set title(k){d.title=k},get description(){return d.description},set description(k){d.description=k},get badge(){return d.badge},set badge(k){k!==void 0&&S.ViewBadge.isViewBadge(k)?d.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(d.badge=void 0)},reveal:(k,P)=>d.reveal(k,P),dispose:async()=>{await b,this.a.delete(o),d.dispose()}};return this.B(E),E}$getChildren(o,t){const g=this.a.get(o);return g?g.getChildren(t):Promise.reject(new p.$MF(o))}async $handleDrop(o,t,g,c,h,s,w,d){const D=this.a.get(o);if(!D)return Promise.reject(new p.$MF(o));const b=m.DataTransfer.toDataTransfer(g,async E=>(await this.f.$resolveDropFileData(o,t,E)).buffer);return w===o&&d&&await this.j(b,D,d,h,s),D.onDrop(b,c,h)}async j(o,t,g,c,h){const s=this.b.removeDragOperationTransfer(h);if(s)(await s)?.forEach((w,d)=>{w&&o.set(d,w)});else if(h&&t.handleDrag){const w=t.handleDrag(g,o,c);this.b.addDragOperationTransfer(h,w),await w}return o}async $handleDrag(o,t,g,c){const h=this.a.get(o);if(!h)return Promise.reject(new p.$MF(o));const s=await this.j(new S.$JN,h,t,c,g);if(!(!s||c.isCancellationRequested))return m.DataTransfer.from(s)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new p.$MF(o);return t.hasResolve}$resolve(o,t,g){const c=this.a.get(o);if(!c)throw new p.$MF(o);return c.resolveTreeItem(t,g)}$setExpanded(o,t,g){const c=this.a.get(o);if(!c)throw new p.$MF(o);c.setExpanded(t,g)}$setSelectionAndFocus(o,t,g){const c=this.a.get(o);if(!c)throw new p.$MF(o);c.setSelectionAndFocus(t,g)}$setVisible(o,t){const g=this.a.get(o);if(!g){if(!t)return;throw new p.$MF(o)}g.setVisible(t)}$changeCheckboxState(o,t){const g=this.a.get(o);if(!g)throw new p.$MF(o);g.setCheckboxState(t)}m(o,t,g){const c=this.B(new i(o,t,this.f,this.g.converter,this.h,g));return this.a.set(o,c),c}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$tmc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$ag)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,g,c,h,s){if(super(),this.I=o,this.J=g,this.L=c,this.M=h,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$me,s.contributes&&s.contributes.views)for(const b in s.contributes.views)for(const E of s.contributes.views[b])E.id===o&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let w,d;const D=R.Event.debounce(this.F.event,(b,E)=>(b||(b={message:!1,elements:[]}),E.element!==!1&&(w||(w=new Promise(k=>d=k),this.G=this.G.then(()=>w)),Array.isArray(E.element)?b.elements.push(...E.element):b.elements.push(E.element)),E.message&&(b.message=!0),b),200,!0);this.B(D(({message:b,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=d;return w=null,this.$(E).then(()=>k())})),b&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let g=this.X(o);return g||(g=await this.Y(t)),g?g.map(c=>c.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const g=(0,A.$ag)(t.select)?!0:t.select,c=(0,A.$ag)(t.focus)?!1:t.focus,h=(0,A.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(s=>this.W(o,s[s.length-1]).then(w=>this.J.$reveal(this.I,{item:w.item,parentChain:s.map(d=>d.item)},{select:g,focus:c,expand:h})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:g,focus:c,expand:h})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=m.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const g=this.getExtensionElement(o);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(o,t){const g=!(0,C.$ub)(this.s,o);this.s=o;const c=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async g=>{const c=this.getExtensionElement(g.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:g.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(o,t,g){const c=[];for(const h of o){const s=this.getExtensionElement(h);s&&c.push(s)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,g){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,$.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(c,o,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(o);if(g){const c=this.m.get(g);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,g,t)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(c=>(g.push(c),g))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ih)(()=>this.f.getParent(o))}W(o,t){const g=this.m.get(o);return g?Promise.resolve(g):(0,$.$ih)(()=>this.f.getTreeItem(o)).then(c=>this.kb(o,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const s=this.m.get(h);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const g=this.getExtensionElement(o);t=g?this.m.get(g):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new v.$me(this.Z.token);try{const g=o?this.m.get(o):void 0,c=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const h=(0,C.$Hb)(c||[]),s=await Promise.all((0,C.$Hb)(h).map(d=>this.f.getTreeItem(d)));if(t.token.isCancellationRequested)return;const w=s.map((d,D)=>d?this.db(h[D],d,g):null);return(0,C.$Hb)(w)}finally{t.dispose()}}$(o){if(o.some(g=>!g))return this.Z.dispose(!0),this.Z=new v.$me,this.tb(),this.J.$refresh(this.I);{const g=this.ab(o);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(o){const t=new Set,g=o.map(h=>this.m.get(h));for(const h of g)if(h&&!t.has(h.item.handle)){let s=h;for(;s&&s.parent&&g.findIndex(w=>s&&s.parent&&w&&w.item.handle===s.parent.item.handle)===-1;){const w=this.j.get(s.parent.item.handle);s=w?this.m.get(w):void 0}s&&!s.parent&&t.add(h.item.handle)}const c=[];return t.forEach(h=>{const s=this.j.get(h);if(s){const w=this.m.get(s);w&&(!w.parent||!t.has(w.parent.item.handle))&&c.push(h)}}),c}bb(o){const t={};return Promise.all(o.map(g=>this.cb(g).then(c=>{c&&(t[g]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,$.$ih)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const h=this.ib(t,c,g.parent);return this.pb(t,h,g,g.parent),g.dispose(),h}return null})}return Promise.resolve(null)}db(o,t,g){const c=this.ib(o,t,g);if(t.id&&this.j.has(c.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(o,c),this.qb(c,g),c}eb(o){return S.$gN.isMarkdownString(o)?m.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,g,c;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,g=o.checkboxState.tooltip,c=o.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:c}}hb(o){if(!S.$EN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,g){this.hb(t);const c=this.B(new M.$Tc),h=this.kb(o,t,g),s=this.lb(t);return{item:{handle:h,parentHandle:g?g.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,A.$ag)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(o){return o.iconPath instanceof S.$NN?o.iconPath:void 0}kb(o,{id:t,label:g,resourceUri:c},h,s){if(t)return`${i.b}/${t}`;const w=a(g,this.N),d=h?h.item.handle:i.a;let D=w?w.label:c?(0,N.$1g)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const b=this.m.has(o)?this.m.get(o).item.handle:void 0,E=this.X(h)||[];let k,P=0;do{if(k=`${d}/${P}:${D}`,s||!this.j.has(k)||b===k)break;P++}while(P<=E.length);return k}lb(o){if(o.iconPath&&!(o.iconPath instanceof S.$NN))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof S.$NN)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return L.URI.isUri(o)?o:L.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,g,c){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(o,t);const h=this.X(c)||[],s=h.filter(w=>w.item.handle===g.item.handle)[0];s&&h.splice(h.indexOf(s),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const g of t.children){const c=this.j.get(g.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const g of t.children){const c=this.j.get(g.item.handle);c&&this.sb(c)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[357],Ee([1,0,4,3,2,30,16,92,6,7]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class A extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,l,f,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$be),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=l,this.#n=f,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Uc{static c(){return(0,R.$Mg)()}constructor(v,l,f){super(),this.j=l,this.m=f,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,l,f,a,n={}){const i=typeof a=="object"?a.viewColumn:a,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,p.$Xkc)(v),t=C.c();this.f.$createWebviewPanel((0,p.$Zkc)(v),t,l,{title:f,panelOptions:m(n),webviewOptions:(0,p.$1kc)(v,this.m,n),serializeBuffersForPostMessage:o},r);const g=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,l,f,i,n,g,!0)}$onDidChangeWebviewPanelViewStates(v){const l=Object.keys(v);l.sort((f,a)=>{const n=v[f],i=v[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const f of l){const a=this.getWebviewPanel(f);if(!a)continue;const n=v[f];a._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,l,f){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:f,extension:v}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,p.$Xkc)(v)}),new S.$RM(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(v,l,f,a){const n=this.h.get(l);if(!n)throw new Error(`No serializer found for '${l}'`);const{serializer:i,extension:r}=n,o=this.j.createNewWebview(v,f.webviewOptions,r),t=this.createNewWebviewPanel(v,l,f.title,a,f.panelOptions,o,f.active);await i.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(v,l,f,a,n,i,r){const o=new A(v,this.f,i,{viewType:l,title:f,viewColumn:a,panelOptions:n,active:r});return this.g.set(v,o),o}getWebviewPanel(v){return this.g.get(v)}}e.$2kc=C;function m(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[358],Ee([1,0,4,3,92,16,6,7]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class $ extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,m,y,v,l,f){super(),this.#s=!1,this.#u=this.B(new u.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$be),this.onDidDispose=this.#l.event,this.#i=y,this.#a=v,this.#e=C,this.#t=m,this.#n=l,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,y,v){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:y,extension:C}),this.a.$registerWebviewViewProvider((0,L.$Zkc)(C),m,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$Xkc)(C)}),new p.$RM(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,y,v,l){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:a,extension:n}=f,i=this.d.createNewWebview(C,{},n),r=new $(C,this.a,m,y,i,!0);this.c.set(C,r),await a.resolveWebviewView(r,{state:v},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$wmc=S}),define(ke[359],Ee([1,0,69,15,12,259,32,11]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new S(m),{isCaseSensitive:p.$k})}};e.$bnc=$,e.$bnc=$=Je([qe(0,u.$Tkc),qe(1,L.$Wj)],$);class S{constructor(C){this.b=C,this.a=new R.$4q(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,y){return this.a.writeFile(C,m,{...y,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,y){return this.a.rename(C,m,y)}copy(C,m,y){return this.a.copy(C,m,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[360],Ee([1,0,17,64,30,33,3,6,2,20]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;let A=class extends M.$Uc{constructor(m,y){super();const v=m.getProxy(p.$PM.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=$.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,L.$Mg)()));return await v.$download(l,f),f})}};e.$_mc=A,e.$_mc=A=Je([qe(0,S.$cP),qe(1,R.$yP)],A)}),define(ke[361],Ee([1,0,52,17,2,93,3,15,8,31]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class A extends R.$Vkc{constructor(){super(...arguments),this.i=null}async g(t){const g=await super.g(t);if(g.scheme!==p.Schemas.file)return g;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${g.fsPath}.`),g;const c=g.fsPath;let h=0;do{let s;h===0?s=c:s=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${h}`:`${c}-${h}`,await C(s);const w=N.$kc(s,"vscode.lock"),d=await l(this.d,w,!1);if(d)return this.i=d,process.on("exit",()=>{d.dispose()}),L.URI.file(s);h++}while(h<10);return g}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$lnc=A;async function C(o){try{await S.Promises.stat(o);return}catch{}try{await S.Promises.mkdir(o,{recursive:!0})}catch{}}const m=1e3,y=10*60*1e3;class v extends M.$Uc{constructor(t,g){super(),this.b=t,this.c=g,this.a=this.B(new $.$Bh),this.a.cancelAndSet(async()=>{const c=await f(t,g);(!c||c.pid!==process.pid)&&(t.info(`Lock '${g}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(g,new Date,new Date)}catch(h){t.error(h),t.info(`Lock '${g}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const g={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(g),{flag:"w"})}catch(g){this.b.error(g)}}}async function l(o,t,g){try{const h={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(h),{flag:"wx"})}catch(h){o.error(h)}const c=await f(o,t);return!c||c.pid!==process.pid?g?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new v(o,t))}async function f(o,t){let g;try{g=await S.Promises.readFile(t)}catch(c){return o.error(c),null}try{return JSON.parse(String(g))}catch(c){return o.error(c),null}}async function a(o,t){let g;try{g=await S.Promises.stat(t)}catch(c){return o.error(c),0}return g.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const g=await f(o,t);if(!g)return o.info(`Lock '${t}': Could not read pid of lock holder.`),r(o,t);if(g.willReleaseAt){let d=g.willReleaseAt-Date.now();if(d<5e3){for(d>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${d} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,$.$rh)(Math.min(100,d)),await a(o,t)===0)return r(o,t);d=g.willReleaseAt-Date.now()}return r(o,t)}}if(!n(g.pid))return o.info(`Lock '${t}': The pid ${g.pid} appears to be gone.`),r(o,t);const c=await a(o,t),h=Date.now()-c;if(h<=y)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$rh)(2e3);const s=await a(o,t),w=Date.now()-s;return w<=y?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${w} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(o,t))}async function r(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return l(o,t,!0)}}),define(ke[362],Ee([1,0,30,20,43,33]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;let M=class extends L.$flc{constructor($,S){super(!0,$,S)}createTerminal($,S,A){return this.createTerminalFromOptions({name:$,shellPath:S,shellArgs:A})}createTerminalFromOptions($,S){const A=new L.$elc(this.a,(0,u.$Mg)(),$,$.name);return this.f.push(A),A.create($,this.R($,S)),A.value}};e.$Gmc=M,e.$Gmc=M=Je([qe(0,R.$yP),qe(1,N.$cP)],M)}),define(ke[363],Ee([1,0,4,38,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new L.$Hj("inOutput",!1),e.$5L=new L.$Hj("activeLogOutput",!1),e.$6L=new L.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new L.$Hj("activeLogOutput.level",""),e.$8L=new L.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new L.$Hj("outputView.scrollLock",!1),e.$0L=(0,R.$qi)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new u.$be,this.onDidRegisterChannel=this.b.event,this.c=new u.$be,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(A=>S.push(A)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$9n.add(e.$$L.OutputChannels,new p),e.$_L=new L.$Hj("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,363,69,28,60,189,21,18,32,4,3]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;class a extends M.$3j{get disposed(){return this.n}constructor(o,t,g,c,h){super(),this.id=o,this.name=t,this.r=g,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=m.$Ce.fromString(t).byteLength,(0,M.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,g,c,h,s){this.i=t,this.j=g,this.k=c,this.l=h,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(u.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(o,t,g){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,h=(0,y.$4f)(t)?t:void 0;if((0,y.$4f)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const w=this.i.environment.extensionLogLevel?.find(([D])=>R.$Lm.equals(g.identifier,D))?.[1];w&&(s=(0,M.$bk)(w));const d=c?this.o(o,s,g):this.n(o,h,g);return d.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(o,s??this.m.getLevel(),d):this.q(o,d)}async n(o,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.a.$register(o,h,t,g.identifier.value);return new a(w,o,s,this.a,g)}async o(o,t,g){const c=await this.p(g),h=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(c,`${h}.log`),w=`${g.identifier.value}.${h}`,d=this.l.createLogger(s,{id:w,name:o,logLevel:t,extensionId:g.identifier.value});return new n(w,o,d,this.a,g)}p(o){let t=this.d.get(o.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(c){if((0,v.$al)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return g})())}return t}q(o,t){let g=!1;const c=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return o},append(h){c(),t.then(s=>s.append(h))},appendLine(h){c(),t.then(s=>s.appendLine(h))},clear(){c(),t.then(h=>h.clear())},replace(h){c(),t.then(s=>s.replace(h))},show(h,s){c(),t.then(w=>w.show(h,s))},hide(){c(),t.then(h=>h.hide())},dispose(){g=!0,t.then(h=>h.dispose())}}}r(o,t,g){const c=new f.$Tc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},s=c.add(new l.$be);function w(d){t=d,s.fire(d)}return g.then(d=>{c.add(d),d.logLevel!==t&&w(d.logLevel),c.add(d.onDidChangeLogLevel(D=>w(D)))}),{...this.q(o,g),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(d,...D){h(),g.then(b=>b.trace(d,...D))},debug(d,...D){h(),g.then(b=>b.debug(d,...D))},info(d,...D){h(),g.then(b=>b.info(d,...D))},warn(d,...D){h(),g.then(b=>b.warn(d,...D))},error(d,...D){h(),g.then(b=>b.error(d,...D))},dispose(){c.dispose()}}}};e.$8lc=i,e.$8lc=i=Je([qe(0,L.$cP),qe(1,S.$sP),qe(2,$.$Tkc),qe(3,A.$wkc),qe(4,M.$Xj),qe(5,M.$Wj)],i),e.$9lc=(0,N.$qi)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,8]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,u.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await L.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[364],Ee([1,0,231,85,38,42,54,3,4,158,11,24,8]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new $.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new y;L.$9n.add(e.$uJ.ConfigurationMigration,v);let l=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const o of r.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of o){const c=r[t];if(!c)continue;const h=[];if(c.value!==void 0){const s=await this.h(n,t,c.value,i,void 0);for(const w of s??[])h.push([w,[]])}for(const{identifiers:s,value:w}of c.overrides??[])if(w!==void 0){const d=await this.h(n,t,w,i,s);for(const D of d??[])h.push([D,s])}h.length&&await Promise.allSettled(h.map(async([[s,w],d])=>this.a.updateValue(s,w.value,{resource:i,overrideIdentifiers:d},g)))}}async h(n,i,r,o,t){const g=h=>{const w=this.a.inspect(h,{resource:o})[i];if(w)return t?w.overrides?.find(({identifiers:d})=>(0,C.$1n)(d,t))?.value:w.value},c=await n.migrateFn(r,g);return Array.isArray(c)?c:[[n.key,c]]}};e.$vJ=l,e.$vJ=l=Je([qe(0,M.$Wi),qe(1,R.$zi)],l);let f=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new m.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$wJ=f,e.$wJ=f=Je([qe(0,S.$an)],f)}),define(ke[365],Ee([1,0,35,15,17,23,241,364,85,5,38]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Igb=e.$Hgb=void 0,e.$Jgb=l,e.$Kgb=f,e.$Hgb=(0,S.$qi)("editorResolverService"),e.$Igb="workbench.editorAssociations";const C=A.$9n.as($.$bo.Configuration),m={...p.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var y;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(y||(e.RegisteredEditorPriority=y={}));var v;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function l(a){switch(a){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function f(a,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$1g)(n);return u.$jk(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[366],Ee([1,0,34,15,17,11,23,2,5,277,42,147,158]),function(le,e,u,N,L,R,M,p,$,S,A,C,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,$.$qi)("pathService");let v=y=class{constructor(f,a,n,i){this.d=f,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??f})()}hasValidBasename(f,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(f,i,a)):this.h(f,a,n)}h(f,a,n){return f.scheme===N.Schemas.file||f.scheme===N.Schemas.vscodeRemote?(0,u.$og)(n??(0,M.$1g)(f),a===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$oM)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=a.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?L.$gc:L.$hc)}async fileURI(f){let a="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const i=f.indexOf("/",2);i===-1?(a=f.substring(2),f="/"):(a=f.substring(2,i),f=f.substring(i)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.$sM=v,e.$sM=v=y=Je([qe(1,m.$an),qe(2,C.$aM),qe(3,A.$zi)],v)}),define(ke[367],Ee([1,0,243,19,55,4,56,3,2,54,248,12,66,279,88,42,147,26,22,18,24,37]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.OnPortForward=e.$fM=e.$eM=e.TunnelSource=e.TunnelCloseReason=e.$cM=e.$bM=void 0,e.$dM=s,e.$gM=D,e.$hM=b,e.$iM=E,e.$jM=P;const t=10*1e3,g="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.$bM="onTunnel",e.$cM=new o.$Hj("forwardedPortsViewEnabled",!1,u.localize(0,null));function s(F){const z=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var w;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var d;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(d||(e.TunnelSource=d={})),e.$eM={source:d.User,description:u.localize(1,null)},e.$fM={source:d.Auto,description:u.localize(2,null)};function D(F,z,O){const T=F.get(E(z,O));if(T)return T;if((0,v.$$v)(z))for(const B of v.$0v){const W=E(B,O);if(F.has(W))return F.get(W)}else if((0,v.$aw)(z))for(const B of v.$_v){const W=E(B,O);if(F.has(W))return F.get(W)}}function b(F,z,O){const T=D(F,z,O);if(T)return T;const B=(0,v.$aw)(z)?"localhost":(0,v.$$v)(z)?"0.0.0.0":void 0;if(B)return D(F,B,O)}function E(F,z){return F+":"+z}var k;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(k||(e.OnPortForward=k={}));function P(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class I extends p.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$be,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,T){let B=this.w(z,O,T,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const X=this.j[B];X.key===z?(W.onAutoForward=X.onAutoForward??W.onAutoForward,W.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:W.elevateIfNeeded,W.label=X.label??W.label,W.requireLocalPort=X.requireLocalPort,W.protocol=X.protocol):(W.onAutoForward=W.onAutoForward??X.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:X.elevateIfNeeded,W.label=W.label??X.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??X.protocol),B=this.w(z,O,T,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$4f)(z.host)&&(0,i.$8f)(z.port)}w(z,O,T,B,W){if(W>=B.length)return-1;const X=!(0,v.$$v)(O)&&!(0,v.$aw)(O),Y=B.slice(W).findIndex(Z=>(0,i.$8f)(Z.key)?X?!1:Z.key===z:this.t(Z.key)?X?!1:z>=Z.key.start&&z<=Z.key.end:this.u(Z.key)?z===Z.key.port&&O===Z.key.host:T?Z.key.test(T):!1);return Y>=0?Y+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$6f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let X;if(Number(B))X=Number(B);else if((0,i.$4f)(B))if(I.g.test(B)){const x=B.match(I.g);X={start:Number(x[1]),end:Number(x[2])}}else if(I.h.test(B)){const x=B.match(I.h);X={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(B)}catch{}x&&(X=x)}X&&O.push({key:X,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(z){function O(T,B){return(0,i.$8f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return k.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case v.ProvidedOnAutoForward.Silent:return k.Silent;case v.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(z,O,T){const W=this.r.inspect(I.c).userRemoteValue;let X;!W||!(0,i.$6f)(W)?X={}:X=(0,r.$Wn)(W),X[`${z}`]||(X[`${z}`]={});for(const x in O)X[`${z}`][x]=O[x];return this.r.updateValue(I.c,X,T)}}e.$kM=I;let j=class extends p.$Uc{constructor(z,O,T,B,W,X,x,Y,Z,ue){super(),this.H=z,this.I=O,this.J=T,this.L=B,this.M=W,this.N=X,this.O=x,this.P=Y,this.Q=Z,this.R=ue,this.c=new Map,this.g=new R.$be,this.onForwardPort=this.g.event,this.h=new R.$be,this.onClosePort=this.h.event,this.j=new R.$be,this.onPortName=this.j.event,this.n=new R.$be,this.onCandidatesChanged=this.n.event,this.t=new R.$be,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$be,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const we=await this.getAttributes(te.map(Se=>({port:Se.tunnelRemotePort,host:Se.tunnelRemoteHost})));for(const Se of te)if(Se.localAddress){const _=E(Se.tunnelRemoteHost,Se.tunnelRemotePort),U=b(this.m??new Map,Se.tunnelRemoteHost,Se.tunnelRemotePort);this.forwarded.set(_,{remotePort:Se.tunnelRemotePort,remoteHost:Se.tunnelRemoteHost,localAddress:Se.localAddress,protocol:we?.get(Se.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Se.localAddress,we?.get(Se.tunnelRemotePort)),localPort:Se.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Se.privacy,source:e.$eM}),this.f.set(_,Se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const we=E(te.tunnelRemoteHost,te.tunnelRemotePort);if(!b(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!b(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!b(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const Se=b(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),_=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(we,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:_?.protocol??v.TunnelProtocol.Http,localUri:await this.X(te.localAddress,_),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:Se?.detail,hasRunningProcess:!!Se,pid:Se?.pid,privacy:te.privacy,source:e.$eM})}await this.cb(),this.f.set(we,te),this.g.fire(this.forwarded.get(we))})),this.B(this.H.onTunnelClosed(te=>this.W(te,w.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$bM))?(this.R.createKey(e.$cM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const T=E(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return $.URI.parse(z);const T=O?.protocol??"http";return $.URI.parse(`${T}://${z}`)}async Y(z){const O=this.N.getWorkspace(),T=O.configuration?(0,M.$ej)(O.configuration.path):O.folders.length>0?(0,M.$ej)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(g)}async $(){return this.Y(c)}async ab(){const z=this.I.get(g,1);if(z)return this.I.remove(g,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=b(this.detected,T.remoteHost,T.remotePort);T.source.source!==d.Extension&&!B||T.source.source===d.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===d.Extension&&!B&&this.D.set(E(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new p.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(c));for(const O of z){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(c,g);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let T;z.length>0&&(T=JSON.stringify(O));const B=await this.Z(),W=await this.$();!T&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):T!==this.y&&B&&W&&(this.I.store(B,T,0,0),this.I.store(W,Date.now()+h,0,0)),this.y=T}}async eb(z,O,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$bM);const T=b(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(T)return this.hb(T,z,O);{const X=this.L.remoteAuthority,x=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,Y=E(z.remote.host,z.remote.port);this.c.set(Y,!0),z=this.gb(Y,z);const Z=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof Z=="string")W=Z;else if(Z&&Z.localAddress){const ue=b(this.m??new Map,z.remote.host,z.remote.port),te=Z.protocol?Z.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,we={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:Z.localAddress,protocol:te,localUri:await this.X(Z.localAddress,O),runningProcess:ue?.detail,hasRunningProcess:!!ue,pid:ue?.pid,source:z.source??e.$eM,privacy:Z.privacy};return this.forwarded.set(Y,we),this.f.set(Y,Z),this.c.delete(Y),await this.cb(),await this.eb(Z,B,O),this.g.fire(we),Z}this.c.delete(Y)}return W}gb(z,O){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const B=T.get(z);T.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,T){const B=T?.label??O.name;let W;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(W||(W={}));let X=W.None;switch(B!==z.name&&(z.name=B,X=W.Fire),(T?.protocol||z.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(O.source=z.source,X=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(X=W.Reopen),X){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,w.User),await this.fb(O,T)}return b(this.f,O.remote.host,O.remote.port)}async name(z,O,T){const B=b(this.forwarded,z,O),W=E(z,O);if(B){B.name=T,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=T,this.j.fire({host:z,port:O}))}async close(z,O,T){const B=E(z,O),W=this.forwarded.get(B);return T===w.AutoForwardEnd&&W&&W.source.source===d.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},T)}address(z,O){const T=E(z,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const T=b(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:E(O.localAddress.host,O.localAddress.port);this.detected.set(E(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:d.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(z){const O=this.m??new Map,T=new Map;return this.m=T,z.forEach(B=>{const W=E(B.host,B.port);T.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const X=b(this.forwarded,B.host,B.port);X&&(X.runningProcess=B.detail,X.hasRunningProcess=!0,X.pid=B.pid)}),O.forEach((B,W)=>{const X=s(W);if(!X)return;const x=b(this.forwarded,X.host,X.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const Y=b(this.detected,X.host,X.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of z){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(z,O=!0){const T=new Map,B=new Map;z.forEach(Z=>{const ue=b(this.m??new Map,v.$0v[0],Z.port)??Z;if(ue){T.set(Z.port,ue);const te=P(ue)?ue.pid:void 0;B.has(te)||B.set(te,[]),B.get(te)?.push(Z.port)}});const W=new Map;if(z.forEach(Z=>{const ue=this.configPortsAttributes.getAttributes(Z.port,Z.host,T.get(Z.port)?.detail);ue&&W.set(Z.port,ue)}),this.G.length===0||!O)return W.size>0?W:void 0;const X=await Promise.all((0,N.$Rb)(this.G.map(Z=>Array.from(B.entries()).map(ue=>{const te=ue[1],we=T.get(te[0]);return Z.providePortAttributes(te,we?.pid,we?.detail,n.CancellationToken.None)})))),x=new Map;if(X.forEach(Z=>Z.forEach(ue=>{ue&&x.set(ue.port,ue)})),!W&&!x)return;const Y=new Map;return z.forEach(Z=>{const ue=W.get(Z.port),te=x.get(Z.port);Y.set(Z.port,{elevateIfNeeded:ue?.elevateIfNeeded,label:ue?.label,onAutoForward:ue?.onAutoForward??I.providedActionToAction(te?.autoForwardAction),requireLocalPort:ue?.requireLocalPort,protocol:ue?.protocol})}),Y}addAttributesProvider(z){this.G.push(z)}};e.$lM=j,Je([(0,L.$Vh)(1e3)],j.prototype,"cb",null),e.$lM=j=Je([qe(0,v.$5v),qe(1,y.$Up),qe(2,S.$Wi),qe(3,f.$aM),qe(4,m.$Bl),qe(5,l.$zi),qe(6,C.$Wj),qe(7,A.$xw),qe(8,a.$tG),qe(9,o.$Ij)],j)}),define(ke[94],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class u{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new u(0,0)}with(M){return new u(0,0)}}e.$WK=u;class N{constructor(M,p,$,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,p),this.end=new u($,S)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(le,e,u,N,L,R,M,p,$,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=a,e.$6K=n,e.$7K=i,e.$_K=d,e.$aL=D,e.$cL=k,e.$dL=P,e.$eL=I,e.$fL=j,e.$gL=F,e.$hL=z,e.$jL=T,e.$lL=X,e.$mL=x,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const m="\u27EA ",y=" characters skipped \u27EB",v=(m.length+y.length+5)*2;e.$4K=(0,p.$qi)("searchService");var l;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(l||(e.SearchProviderType=l={}));var f;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(Z){return!!Z.preview}function n(Z){return!!Z.resource}function i(Z){return!!Z.message}var r;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class o{constructor(ue){this.resource=ue,this.results=[]}}e.$8K=o;class t{constructor(ue,te,we,Se){this.ranges=te,this.webviewIndex=Se;const _=Array.isArray(te)?te:[te];if(we&&we.matchLines===1&&g(_)){ue=(0,M.$Wf)(ue,we.matchLines);let U="",ne=0,$e=0;const Pe=Math.floor(we.charsPerLine/5),se=[];for(const re of _){const oe=Math.max(re.startColumn-Pe,0),G=re.startColumn+we.charsPerLine;if(oe>$e+Pe+v){const ie=m+(oe-$e)+y;U+=ie+ue.slice(oe,G),ne+=oe-($e+ie.length)}else U+=ue.slice($e,G);se.push(new h(0,re.startColumn-ne,re.endColumn-ne)),$e=G}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,u.$2b)(te,ne=>new c(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$9K=t;function g(Z){const ue=Z[0].startLineNumber;for(const te of Z)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class c{constructor(ue,te,we,Se){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=we,this.endColumn=Se}}e.$0K=c;class h extends c{constructor(ue,te,we){super(ue,te,ue,we)}}e.$$K=h;var s;(function(Z){Z.List="list",Z.Tree="tree"})(s||(e.ViewMode=s={}));var w;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function d(Z,ue=!0){const te=Z&&Z.files&&Z.files.exclude,we=ue&&Z&&Z.search&&Z.search.exclude;if(!te&&!we)return;if(!te||!we)return te||we;let Se=Object.create(null);return Se=L.$Zn(Se,L.$Wn(te)),Se=L.$Zn(Se,L.$Wn(we),!0),Se}function D(Z,ue){return Z.excludePattern&&N.$jk(Z.excludePattern,ue)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&N.$jk(Z.includePattern,ue)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(te=>{const we=te.folder.fsPath;if(R.$qg(ue,we)){const Se=$.$mc(we,ue);return!te.includePattern||!!N.$jk(te.includePattern,Se)}else return!1}):!1:!0}var b;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class E extends Error{constructor(ue,te){super(ue),this.code=te}}e.$bL=E;function k(Z){const ue=Z.message;if((0,S.$4)(Z))return new E(ue,b.canceled);try{const te=JSON.parse(ue);return new E(te.message,te.code)}catch{return new E(ue,b.other)}}function P(Z){const ue={message:Z.message,code:Z.code};return new Error(JSON.stringify(ue))}function I(Z){return Z.type==="error"?!0:Z.type==="success"}function j(Z){return Z.type==="success"}function F(Z){return!!Z.path}function z(Z,ue,te=!0){const we=Z.searchPath?Z.searchPath:Z.relativePath;return te?(0,M.$Tf)(we,ue):N.$jk(ue,we)}class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=O;function T(Z,ue){const te={...Z||{},...ue||{}};return Object.keys(te).filter(we=>{const Se=te[we];return typeof Se=="boolean"&&Se})}class B{constructor(ue,te){this.c=null,this.a={...ue.excludePattern||{},...te.excludePattern||{}},this.b=N.$kk(this.a);let we=ue.includePattern;te.includePattern&&(we?we={...we,...te.includePattern}:we=te.includePattern),we&&(this.c=N.$kk(we))}matchesExcludesSync(ue,te,we){return!!(this.b&&this.b(ue,te,we))}includedInQuerySync(ue,te,we){return!(this.b&&this.b(ue,te,we)||this.c&&!this.c(ue,te,we))}includedInQuery(ue,te,we){const Se=this.b(ue,te,we),_=()=>this.c?!!this.c(ue,te,we):!0;return(0,C.$ch)(Se)?Se.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return W(this.a)}}e.$kL=B;function W(Z){for(const ue in Z)if(typeof Z[ue]!="boolean")return!0;return!1}function X(Z){if(!Z)return;let ue;return te=>(ue||(ue=(Z()||Promise.resolve([])).then(we=>we?Y(we):{})),ue.then(we=>!!we[te]))}function x(Z){if(!Z)return;let ue;return te=>{if(!ue){const we=Z();ue=we?Y(we):{}}return!!ue[te]}}function Y(Z){const ue={};for(const te of Z)ue[te]=!0;return ue}}),define(ke[44],Ee([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,262,42,60,28,20,16,7,67,36,6,58]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=void 0;function w(j,F,z){return new A.$Sg(O=>E(O,z)).isEqual(j,F)}function d(j,F,z){return w(j.uri,F.uri,z)?0:(0,C.$mf)(j.uri.toString(),F.uri.toString())}function D(j,F,z){return j.index!==F.index?j.index<F.index?-1:1:w(j.uri,F.uri,z)?(0,C.$mf)(j.name,F.name):(0,C.$mf)(j.uri.toString(),F.uri.toString())}function b(j,F,z,O){const T=j.slice(0).sort((W,X)=>z(W,X,O)),B=F.slice(0).sort((W,X)=>z(W,X,O));return(0,u.$Eb)(T,B,(W,X)=>z(W,X,O))}function E(j,F){const z=F.getCapabilities(j.scheme);return!(z&&z&1024)}class k extends a.$Ji{static toExtHostWorkspace(F,z,O,T){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:X,configuration:x,transient:Y,isUntitled:Z}=F,ue=[],te=z;z?X.forEach((U,ne)=>{const $e=m.URI.revive(U.uri),Pe=k.o(O||z,$e,T);Pe?(Pe.name=U.name,Pe.index=U.index,ue.push(Pe)):ue.push({uri:$e,name:U.name,index:ne})}):ue.push(...X.map(({uri:U,name:ne,index:$e})=>({uri:m.URI.revive(U),name:ne,index:$e}))),ue.sort((U,ne)=>U.index<ne.index?-1:1);const we=new k(B,W,ue,!!Y,x?m.URI.revive(x):null,!!Z,U=>E(U,T)),{added:Se,removed:_}=b(te?te.workspaceFolders:[],we.workspaceFolders,d,T);return{workspace:we,added:Se,removed:_}}static o(F,z,O){for(let T=0;T<F.folders.length;T++){const B=F.workspaceFolders[T];if(w(B.uri,z,O))return B}}constructor(F,z,O,T,B,W,X){super(F,O.map(x=>new a.$Ki(x)),T,B,X),this.t=z,this.u=W,this.q=[],this.s=p.$wi.forUris(X),O.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,z){return z&&this.s.get(F)&&(F=(0,A.$3g)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,z,O,T,B){this.c=new R.$be,this.onDidChangeWorkspace=this.c.event,this.g=new R.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$de,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$xm,this.k=new N.$ph,this.o=F.getProxy(h.$PM.MainThreadWorkspace),this.q=F.getProxy(h.$PM.MainThreadMessageService);const W=z.workspace;this.l=W?new k(W.id,W.name,[],!!W.transient,W.configuration?m.URI.revive(W.configuration):null,!!W.isUntitled,X=>E(X,O)):void 0}$initializeWorkspace(F,z){this.v=z,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,A.$1g)((0,A.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(Z=>{m.URI.isUri(Z.uri)&&!B.some(ue=>w(ue.uri,Z.uri,this.s))&&B.push({uri:Z.uri,name:Z.name||(0,A.$Zg)(Z.uri)})}),this.n||[z,O].some(Z=>typeof Z!="number"||Z<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const X=W.slice(0);X.splice(z,O,...B.map(Z=>({uri:Z.uri,name:Z.name||(0,A.$Zg)(Z.uri),index:void 0})));for(let Z=0;Z<X.length;Z++){const ue=X[Z];if(X.some((te,we)=>we!==Z&&w(ue.uri,te.uri,this.s)))return!1}X.forEach((Z,ue)=>Z.index=ue);const{added:x,removed:Y}=b(W,X,D,this.s);if(x.length===0&&Y.length===0)return!1;if(this.o){const Z=F.displayName||F.name;this.o.$updateWorkspaceFolders(Z,z,O,B).then(void 0,ue=>{this.n=void 0;const te={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(f.Severity.Error,(0,y.localize)(0,null,Z,ue.toString()),te,[])})}return this.y(X),!0}getWorkspaceFolder(F,z){if(this.x)return this.x.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,z){let O,T="";if(typeof F=="string"?(O=m.URI.file(F),T=F):typeof F<"u"&&(O=F,T=F.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,A.$6g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(F){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:O,removed:T}=k.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(F,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let W="",X=!0;return z===null?X=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(F,void 0,{exclude:W,maxResults:O,useDefaultExcludes:X,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(F,z={},O,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,F,z,T)}async z(F,z,O,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let X;if(F){const{includePattern:x,folder:Y}=I(o.GlobPattern.from(F));X=Y,W.includePattern=x}else{const{includePattern:x,folder:Y}=I(o.GlobPattern.from(z));X=Y,W.filePattern=x}return this.o.$startFileSearch(X??null,W,T).then(x=>Array.isArray(x)?x.map(Y=>m.URI.revive(Y)):[])}async findTextInFiles(F,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:x,folder:Y}=I(o.GlobPattern.from(z.include)),Z=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ue={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:x,excludePattern:Z},te=!1;if(this.u[W]=we=>{if(te)return;const Se=m.URI.revive(we.resource);we.results.forEach(_=>{const U=(0,s.$Zh)(_);(0,c.$5K)(U)?O({uri:Se,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ne=>new t.$TM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,u.$2b)(U.ranges,ne=>new t.$TM(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):O({uri:Se,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(F,Y??null,ue,W,B);return delete this.u[W],we||{}}catch(we){throw delete this.u[W],we}}$handleTextSearchResult(F,z){this.u[z]?.(F)}async save(F){const z=await this.o.$save(F,{saveAs:!1});return m.URI.revive(z)}async saveAs(F){const z=await this.o.$save(F,{saveAs:!0});return m.URI.revive(z)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,z){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,z);const O=this.t.transformOutgoingScheme(F),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,M.$Sc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(F,z){this.h.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,z,O,T){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const X=await W.provideEditSessionIdentityMatch?.(z,O,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(F){return(z,O,T)=>{const B=function(X){z.call(O,X)};return B.extension=F,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(F,z,O){const T=await this.resolveWorkspaceFolder(m.URI.revive(F));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(B,W)=>{const X=Date.now();await Promise.resolve(B),Date.now()-X>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(F,z){if(this.C.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.C.set(F,z);const O=this.t.transformOutgoingScheme(F),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,M.$Sc)(()=>{this.C.delete(F),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(F,z,O){const T=this.C.get(F.scheme);if(!T)return;const B=await T.provideCanonicalUri?.(m.URI.revive(F),z,O);if(B)return B}async $provideCanonicalUri(F,z,O){return this.provideCanonicalUri(m.URI.revive(F),{targetScheme:z},O)}};e.$Nkc=P,e.$Nkc=P=Je([qe(0,r.$cP),qe(1,i.$sP),qe(2,n.$wkc),qe(3,l.$Wj),qe(4,g.$Lkc)],P),e.$Okc=(0,v.$qi)("IExtHostWorkspace");function I(j){let F,z;return j&&(typeof j=="string"?F=j:(F=j.pattern,z=m.URI.revive(j.baseUri))),{includePattern:F,folder:z}}}),define(ke[45],Ee([1,0,24,4,44,6,7,264,85,18,8,5,20,12,2]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=e.$Pkc=void 0;function l(g,c){if(c){const h=c.split(".");let s=g;for(let w=0;s&&w<h.length;w++)s=s[h[w]];return s}}function f(g){return g instanceof v.URI}function a(g){return g&&g.uri instanceof v.URI&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&g.uri instanceof v.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function r(g){if(f(g))return{resource:g};if(a(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(n(g))return{overrideIdentifier:g.languageId};if(i(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(c,h,s){this.a=c.getProxy(R.$PM.MainThreadConfiguration),this.c=h,this.b=s,this.d=new A.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(c,h))}};e.$Pkc=o,e.$Pkc=o=Je([qe(0,m.$cP),qe(1,L.$Okc),qe(2,y.$Wj)],o);class t{constructor(c,h,s,w){this.a=new N.$be,this.b=c,this.f=w,this.c=h,this.e=p.$uo.parse(s,w),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(c,this.f),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,s))}getConfiguration(c,h,s){const w=r(h)||{},d=this.g(c?l(this.e.getValue(void 0,w,this.c.workspace),c):this.e.getValue(void 0,w,this.c.workspace));c&&this.h(c,w,s?.identifier);function D(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(E){return typeof l(d,E)<"u"},get:(E,k)=>{this.h(c?`${c}.${E}`:E,w,s?.identifier);let P=l(d,E);if(typeof P>"u")P=k;else{let I;const j=(F,z)=>{if((0,S.$6f)(F)){let O;const T=()=>{I=I||(0,u.$Wn)(d),O=O||l(I,z)};return new Proxy(F,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||l(I,z),O[W];const X=B[W];return typeof W=="string"?j(X,`${z}.${W}`):X},set:(B,W,X)=>(T(),O&&(O[W]=X),!0),deleteProperty:(B,W)=>(T(),O&&delete O[W],!0),defineProperty:(B,W,X)=>(T(),O&&Object.defineProperty(O,W,X),!0)})}return Array.isArray(F)?(0,u.$Wn)(F):F};P=j(P,E)}return P},update:(E,k,P,I)=>{E=c?`${c}.${E}`:E;const j=D(P);return k!==void 0?this.b.$updateConfigurationOption(j,E,k,w,I):this.b.$removeConfigurationOption(j,E,w,I)},inspect:E=>{E=c?`${c}.${E}`:E;const k=this.e.inspect(E,w,this.c.workspace);if(k)return{key:E,defaultValue:(0,u.$Wn)(k.policy?.value??k.default?.value),globalValue:(0,u.$Wn)(k.user?.value??k.application?.value),workspaceValue:(0,u.$Wn)(k.workspace?.value),workspaceFolderValue:(0,u.$Wn)(k.workspaceFolder?.value),defaultLanguageValue:(0,u.$Wn)(k.default?.override),globalLanguageValue:(0,u.$Wn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,u.$Wn)(k.workspace?.override),workspaceFolderLanguageValue:(0,u.$Wn)(k.workspaceFolder?.override),languageIds:(0,u.$Wn)(k.overrideIdentifiers)}}};return typeof d=="object"&&(0,u.$Zn)(b,d,!1),Object.freeze(b)}g(c){const h=s=>(0,S.$6f)(s)?new Proxy(s,{get:(w,d)=>h(w[d]),set:(w,d,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(w,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(w,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return h(c)}h(c,h,s){const w=$.$lo.test(c)?4:this.d.get(c),d=s?`[${s.value}] `:"";if(w===4){typeof h?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){h?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const s=new p.$wo(c,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(w,d)=>s.affectsConfiguration(w,r(d))})}k(c){return c.reduce((h,s)=>(h.set(s[0],s[1]),h),new Map)}}e.$Qkc=t,e.$Rkc=(0,C.$qi)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,44,72,45,22,43,20,28,5,15,11,12,91,308,13]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(o||(o={}));var t;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(t||(t={}));var g;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(g||(g={}));var c;(function(j){function F(T){if(T){const B=T;return B&&!!B.process}else return!1}j.is=F;function z(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=g.from(T.options)),B}j.from=z;function O(T){if(T!=null)return new M.$AN(T.process,T.args,T.options)}j.to=O})(c||(c={}));var h;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(h||(h={}));var s;(function(j){function F(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}j.is=F;function z(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=h.from(T.options)),B}j.from=z;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$BN(T.commandLine,T.options):new M.$BN(T.command,T.args?T.args:[],T.options)}j.to=O})(s||(s={}));var w;(function(j){function F(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}j.is=F;function z(T){return{customExecution:"customExecution"}}j.from=z;function O(T,B){return B.get(T)}j.to=O})(w||(e.CustomExecutionDTO=w={}));var d;(function(j){function F(z,O){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$VH),{id:z._id,workspaceFolder:T}}j.from=F})(d||(e.TaskHandleDTO=d={}));var D;(function(j){function F(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=F})(D||(D={}));var b;(function(j){function F(T,B){if(T==null)return[];const W=[];for(const X of T){const x=z(X,B);x&&W.push(x)}return W}j.fromMany=F;function z(T,B){if(T==null)return;let W;T.execution instanceof M.$AN?W=c.from(T.execution):T.execution instanceof M.$BN?W=s.from(T.execution):T.execution&&T.execution instanceof M.$CN&&(W=w.from(T.execution));const X=o.from(T.definition);let x;return T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=M.TaskScope.Workspace,!X||!x?void 0:{_id:T._id,definition:X,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:x},execution:W,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}j.from=z;async function O(T,B,W){if(T==null)return;let X;c.is(T.execution)?X=c.to(T.execution):s.is(T.execution)?X=s.to(T.execution):w.is(T.execution)&&(X=w.to(T._id,W));const x=o.to(T.definition);let Y;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Y=T.source.scope:Y=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):Y=M.TaskScope.Workspace),!x||!Y)return;const Z=new M.$DN(x,Y,T.name,T.source.label,X,T.problemMatchers);return T.isBackground!==void 0&&(Z.isBackground=T.isBackground),T.group!==void 0&&(Z.group=M.$zN.from(T.group._id),Z.group&&T.group.isDefault&&(Z.group=new M.$zN(Z.group.id,Z.group.label),T.group.isDefault===!0&&(Z.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Z.presentationOptions=t.to(T.presentationOptions)),T._id&&(Z._id=T._id),T.detail&&(Z.detail=T.detail),Z}j.to=O})(b||(e.TaskDTO=b={}));var E;(function(j){function F(O){return O}j.from=F;function z(O){if(O)return Object.assign(Object.create(null),O)}j.to=z})(E||(E={}));class k{#e;constructor(F,z,O){this._id=z,this.a=O,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,z,O,T,B,W,X,x){this.q=new L.$be,this.r=new L.$be,this.s=new L.$be,this.u=new L.$be,this.a=F.getProxy(R.$PM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,z,O){if(!O)return new M.$RM(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:O,extension:F}),this.a.$registerTaskProvider(T,z),new M.$RM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(F,z){this.a.$registerTaskSystem(F,z)}fetchTasks(F){return this.a.$fetchTasks(E.from(F)).then(async z=>{const O=[];for(const T of z){const B=await b.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const F=[];return this.k.forEach(z=>F.push(z)),F}terminateTask(F){if(!(F instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,z,O){const T=this.m.get(F.id);T&&(this.o.set(F.id,T),this.e.attachPtyToTerminal(z,await T.callback(O))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const z=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const z=await this.z(F.id);this.s.fire({execution:z,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const z=await this.z(F.id);this.u.fire({execution:z,exitCode:F.exitCode})}$provideTasks(F,z){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$ih)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(W=>this.v(z,T,O,W));return new Promise(W=>{B.then(X=>{Promise.all(T).then(()=>{W(X)})})})}async $resolveTask(F,z){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await b.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,O);const W=b.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(F,z,O){const T=await this.a.$createTaskId(F);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(F,z){if(typeof F=="string"){const B=this.l.get(F);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(F.id);if(O)return O;let T;return z?T=Promise.resolve(new k(this,F.id,z)):T=b.to(F.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new k(this,F.id,B)}),this.l.set(F.id,T),T.then(B=>(this.k.set(F.id,B),B))}A(F,z){F._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$hmc=P,e.$hmc=P=Je([qe(0,m.$cP),qe(1,y.$sP),qe(2,p.$Okc),qe(3,$.$nP),qe(4,S.$Rkc),qe(5,C.$dlc),qe(6,a.$Wj),qe(7,n.$skc)],P);let I=class extends P{constructor(F,z,O,T,B,W,X,x){super(F,z,O,T,B,W,X,x),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(F,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=b.from(z,F);if(O===void 0)throw new Error("Task is not valid");if(w.is(O.execution))await this.y(O,z,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(F,z,O,T){const B=[];if(T)for(const W of T){if(this.A(W,O),!W.definition||!F[W.definition.type]){const x=W.source?W.source:"No task source";this.f.warn(`The task [${x}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=b.from(W,O.extension);X&&w.is(X.execution)?(B.push(X),z.push(this.y(X,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(F){if(w.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,z,O){}};e.$imc=I,e.$imc=I=Je([qe(0,m.$cP),qe(1,y.$sP),qe(2,p.$Okc),qe(3,$.$nP),qe(4,S.$Rkc),qe(5,C.$dlc),qe(6,a.$Wj),qe(7,n.$skc)],I),e.$jmc=(0,v.$qi)("IExtHostTask")}),define(ke[368],Ee([1,0,36,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=L,e.$uL=R;function L(M){return"cellResults"in M}e.$tL="rawCell#";function R(M,p){let $=-1;const S=[];let A=[];return M.forEach(m=>{m.range.startLineNumber!==$&&A.length>0&&(S.push([...A]),A=[]),A.push(m),$=m.range.endLineNumber}),A.length>0&&S.push([...A]),S.map(m=>{const y=[],v=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let f=v;f<=l;f++)y.push(p.getLineContent(f));return new u.$9K(y.join(`
`)+`
`,m.map(f=>new N.$kt(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(ke[369],Ee([1,0,223,21,4,3,27,14,18,2,32,111,6,33,16,7,48,339,153,24,15,298,368,365]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,w,d,D,b,E){this.q=d,this.r=D,this.s=b,this.t=E,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$qkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=s.getProxy(m.$PM.MainThreadNotebook),this.c=s.getProxy(m.$PM.MainThreadNotebookDocuments),this.d=s.getProxy(m.$PM.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,I=k.cell.handle,F=this.g.get(P)?.getCell(I);if(F)return F.apiCell}if(k&&k.$mid===14){const P=k.uri,I=this.g.get(P);if(I)return I.apiNotebook}return k}}),c.B(w)}getEditorById(s){const w=this.h.get(s);if(!w)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(s){for(const[w,d]of this.h)if(d.apiEditor===s)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,w){const d=this.g.get(s);if(!d&&!w)throw new Error(`NO notebook document for '${s}'`);return d}static u(s,w){if(!w)return;const d=w.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(w.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:w.displayName,filenamePattern:d,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,w,d){const D=c.a++,b=typeof d.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,d),this.b.$registerNotebookCellStatusBarItemProvider(D,b,w);let E;return b!==void 0&&(E=d.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(b))),new l.$RM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,b),E?.dispose()})}async createNotebookDocument(s){const w=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&v.NotebookData.from(s.content)});return S.URI.revive(w)}async openNotebookDocument(s){const w=this.g.get(s);if(w)return w.apiNotebook;const d=await this.c.$tryOpenNotebook(s),D=this.g.get(S.URI.revive(d));return(0,$.$cg)(D?.apiNotebook)}async showNotebookDocument(s,w){S.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let d;typeof w=="object"?d={position:v.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(v.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:d={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,d),b=D&&this.h.get(D)?.apiEditor;if(b)return b;throw D?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,w,d,D){const b=this.f.get(s),E=S.URI.revive(w),k=this.g.get(E);if(!k||!b)return;const P=k.getCellFromIndex(d);if(!P)return;const I=await b.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const j=new R.$Tc,F=this.p.add([j]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,j));return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,w,d,D,b){if((0,p.$3e)(w))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:w,serializer:d,options:D}),this.b.$registerNotebookSerializer(E,{id:s.identifier,location:s.extensionLocation},w,v.NotebookDocumentContentOptions.from(D),c.u(s,b)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(s,w,d){const D=this.x.get(s);if(!D)throw new Error("NO serializer found");const b=await D.serializer.deserializeNotebook(w.buffer,d);return new f.$lw(v.NotebookData.from(b))}async $notebookToData(s,w,d){const D=this.x.get(s);if(!D)throw new Error("NO serializer found");const b=await D.serializer.serializeNotebook(v.NotebookData.to(w.value),d);return N.$Ce.wrap(b)}async $saveNotebook(s,w,d,D,b){const E=S.URI.revive(w),k=this.x.get(s);if(!k)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$fl((0,u.localize)(0,null,this.z(E)),6);await this.y(E,D);const I={metadata:(0,i.$5n)(P.apiNotebook.metadata,T=>!(k.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const B=new l.$hO(T.kind,T.document.getText(),T.document.languageId,T.mime,k.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$5n)(T.metadata,W=>!(k.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const j=await k.serializer.serializeNotebook(I,b);await this.s.value.writeFile(E,j);const F=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:F.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$ql({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(s,w,d,D,b){const E=this.x.get(s)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new M.$Cc;await(async(z,O,T)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const X={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(X,O,x=>{x.forEach(Y=>{k.has(Y)||D.some(ue=>B.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(te=>(0,g.$Kgb)(te,Y)))||k.add(Y)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})(d,b,w);const I=new M.$Bc;let j=!1;const F=Array.from(k).map(async z=>{const O=[];try{if(b.isCancellationRequested)return;if(w.maxResults&&[...I.values()].reduce((X,x)=>X+x.cellResults.length,0)>w.maxResults){j=!0;return}const T=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(x=>T.push({input:x.document.getText(),outputs:x.outputs.flatMap(Y=>Y.items.map(Z=>Z.data.toString()))}));else{const X=await this.s.value.readFile(z),x=N.$Ce.fromString(X.toString()),Y=await E.deserializeNotebook(x.buffer,b);if(b.isCancellationRequested)return;v.NotebookData.from(Y).cells.forEach(ue=>T.push({input:ue.source,outputs:ue.outputs.flatMap(te=>te.items.map(we=>we.valueBytes.toString()))}))}if(b.isCancellationRequested)return;T.forEach((X,x)=>{const Y=w.contentPattern.pattern,Z=new o.$zWb(X.input,void 0,X.outputs),ue=Z.findInInputs(Y),te=Z.findInOutputs(Y),we=te.flatMap(Se=>(0,t.$uL)(Se.matches,Se.textBuffer)).map((Se,_)=>(Se.webviewIndex=_,Se));if(ue.length>0||te.length>0){const Se={index:x,contentResults:(0,t.$uL)(ue,Z.inputTextBuffer),webviewResults:we};O.push(Se)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(F),{limitHit:j,results:[...I.values()]}}async y(s,w){const d=await this.s.value.stat(s);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==A.$pl&&typeof d.mtime=="number"&&typeof d.size=="number"&&w.mtime<d.mtime&&w.etag!==A.$ql({mtime:w.mtime,size:d.size}))throw new A.$fl((0,u.localize)(1,null),3,w)}z(s){return s.scheme===r.Schemas.file?s.fsPath:s.toString()}A(s,w,d){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const D=new n.$Nlc(w,this.d,s,d.visibleRanges.map(v.NotebookRange.to),d.selections.map(v.NotebookRange.to),typeof d.viewColumn=="number"?v.ViewColumn.to(d.viewColumn):void 0);this.h.set(w,D)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const d of s.value.removedDocuments){const D=S.URI.revive(d),b=this.g.get(D);b&&(b.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(b.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===D.toString()&&this.h.delete(E.id)}if(s.value.addedDocuments){const d=[];for(const D of s.value.addedDocuments){const b=S.URI.revive(D.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const E=new a.$Mlc(this.c,this.q,this.r,b,D);d.push(...D.cells.map(k=>a.$Llc.asModelAddData(k))),this.g.get(b)?.dispose(),this.g.set(b,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(E.apiNotebook)}}if(s.value.addedEditors)for(const d of s.value.addedEditors){if(this.h.has(d.id))return;const D=S.URI.revive(d.documentUri),b=this.g.get(D);b&&this.A(b,d.id,d)}const w=[];if(s.value.removedEditors)for(const d of s.value.removedEditors){const D=this.h.get(d);D&&(this.h.delete(d),this.k?.id===D.id&&(this.k=void 0),w.push(D))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const d=new Set;this.l.forEach(D=>d.add(D.id));for(const D of this.h.values()){const b=d.has(D.id);D._acceptVisibility(b)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(s){const w=y.$AP.String.with("notebookType","A notebook type"),d=new y.$CP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new y.$AP("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>N.$Ce.wrap(b))],new y.$BP("Notebook Data",b=>v.NotebookData.to(b.value))),D=new y.$CP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new y.$AP("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new f.$lw(v.NotebookData.from(b)))],new y.$BP("Bytes",b=>b.buffer));s.registerApiCommand(d),s.registerApiCommand(D)}}e.$Wlc=c}),define(ke[370],Ee([1,0,17,22,47,35,23,40,36]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class S{constructor(m,y,v){this.k=m,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&R.$kk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&R.$kk(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const y=this.k.folderQueries||[];return new Promise((v,l)=>{const f=a=>{this.f++,m(a)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(f,{base:a,basename:i})}),Promise.all(y.map(a=>this.p(a,f))).then(a=>{v({limitHit:this.e,stats:a[0]||void 0})},a=>{l(new Error((0,L.$bj)(a)))})})}async p(m,y){const v=new N.$me,l=this.q(m),f=this.r(),a=new $.$kL(this.k,m),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=p.$0d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,v.token),o=i.elapsed(),t=p.$0d.create();return this.g&&!this.e||(r&&r.forEach(g=>{const c=u.$hc.relative(m.folder.path,g.path);if(n){const h=u.$oc(g.path);this.v(y,{base:m.folder,relativePath:c,basename:h});return}this.s(f,m.folder,c,y)}),this.g&&!this.e)?null:(this.u(f,a,y),{providerTime:o,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(m){const y=(0,$.$jL)(this.k.includePattern,m.includePattern),v=(0,$.$jL)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:v,includes:y,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},y,v,l){if(v===this.a){const a=u.$oc(this.a);this.v(l,{base:y,relativePath:this.a,basename:a})}function f(a){const n=u.$oc(a),i=u.$nc(a);let r=m[i];r||(r=m[i]=[],f(i)),r.push({base:y,relativePath:a,basename:n})}f(v)}u({rootEntries:m,pathToEntries:y},v,l){const f=this,a=this.a;function n(i){const r=(0,$.$mL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const g=i[o],{relativePath:c,basename:h}=g;if(v.matchesExcludesSync(c,h,a!==h?r:void 0))continue;const s=y[c];if(s)n(s);else{if(c===a)continue;f.v(l,g)}if(f.e)break}}n(m)}v(m,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,y,v,l){const f=this.c(m.cacheKey),a=new S(m,y,f&&f.token);let n=0;const i=r=>{n+=r.length,v(r.map(o=>this.d(o)))};return this.e(a,A.a,i,l).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$me),this.b.get(m)}d(m){return m.relativePath?{resource:M.$4g(m.base,m.relativePath)}:{resource:m.base}}e(m,y,v,l){const f=l.onCancellationRequested(()=>{m.cancel()}),a=i=>{i&&(n.push(i),y>0&&n.length>=y&&(v(n),n=[]))};let n=[];return m.search(a).then(i=>(n.length&&v(n),f.dispose(),i),i=>(n.length&&v(n),f.dispose(),Promise.reject(i)))}}e.$Olc=A}),define(ke[371],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,244,54,12,42,146,366,36]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=D;let o=class{constructor(E,k,P,I,j){this.a=E,this.b=k,this.c=P,this.d=I,this.e=j}text(E,k,P={}){E=this.f(E,P);const I=this.a.getValue(),j=k&&k.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(k?.map(a.$Li),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||j||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,k){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const I={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,k)&&(I.isCaseSensitive=!0),this.k(E)&&(I.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),I}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map(s):s(E),k?this.parseSearchPaths(E):{pattern:g(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),I=this.g(k.excludePattern,k.expandPatterns),j=E.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,k,I)):E.map(T=>this.r(T,k,I,j))).filter(T=>!!T),z={_reason:k._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(X=>X.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(X=>(0,r.$aL)(z,X.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=k.extraFileResources&&k.extraFileResources.filter(T=>(0,r.$aL)(z,T.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(E){const k=[],P=new M.$Bc,I={};let j=!1;return E.forEach(F=>{if(F.scheme===p.Schemas.walkThrough)return;if((0,S.$8g)(F)){const O=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$nc(F.fsPath)});let T=P.get(O);T||(j=!0,T={folder:O,includePattern:{}},k.push(T),P.set(O,T));const B=$.$mc(O.fsPath,F.fsPath);(0,C.$cg)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(j=!0,I[F.fsPath]=!0)}),{folderQueries:k,includePattern:I,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(A.$Uf(E.pattern,!0))return!0}else if(A.$Uf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,y.$AC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(E)?E:c(E)).map(W=>{const X=this.e.resolvedUserHome;return X?(0,R.$qw)(W,X.scheme===p.Schemas.file?X.fsPath:X.path):W}),j=N.$K(I,W=>k(W)?"searchPaths":"exprSegments"),F=(j.exprSegments||[]).map(W=>A.$bf(W,"/")).map(W=>A.$bf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),h(W))),z={},O=this.m(j.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const T=u.$Rb(F),B=g(...T);return B&&(z.pattern=B),z}l(E,k){return k.disregardExcludeSettings?void 0:(0,r.$_K)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(I=>{let{pathPortion:j,globPortion:F}=t(I);return F&&(F=w(F)),this.n(j).flatMap(O=>this.o(O,F))}),P=new Map;return k.forEach(I=>{const j=I.searchPath.toString(),F=P.get(j);F?I.pattern&&(F.pattern=F.pattern||{},F.pattern[I.pattern]=!0):P.set(j,{searchPath:I.searchPath,pattern:I.pattern?g(I.pattern):void 0})}),Array.from(P.values())}n(E){if($.$jc(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:m.URI.file($.$ic(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=s(E),E.startsWith("../")||E===".."){const I=$.$hc.resolve(k.path,E);return[{searchPath:k.with({path:I})}]}const P=w(E);return[{searchPath:k,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(j=>{const F=k.match(new RegExp(`^${A.$8e(j.name)}(?:/(.*)|$)`));return F?{match:F,folder:j}:null}).filter(C.$_f);if(I.length)return I.map(j=>{const F=j.match[1];return{searchPath:j.folder.uri,pattern:F&&w(F)}});{const j=E.match(/\.[\/\\](.+)[\/\\]?/),F=j?j[1]:E,z=v.localize(0,null,F);throw new Error(z)}}}}o(E,k){const P=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,I=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:E.searchPath,pattern:P+"/**"}),I}q(E,k,P){const I=this.r((0,a.$Li)(E.searchPath),k,P,!1);return I?{...I,includePattern:E.pattern}:null}r(E,k,P,I){let j;const F=m.URI.isUri(E)?E:E.uri;if(P.searchPaths){const W=P.searchPaths.filter(X=>(0,S.$Wg)(X.searchPath,F))[0];if(W&&!W.pattern)return null;W&&(j=W.pattern)}const z=this.a.getValue({resource:F}),T={...this.l(z,k)||{},...j||{}},B=m.URI.isUri(E)?(0,S.$1g)(E):E.name;return{folder:F,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!z.search.followSymlinks}}};e.$tM=o,e.$tM=o=Je([qe(0,l.$Wi),qe(1,a.$zi),qe(2,n.$HD),qe(3,f.$Wj),qe(4,i.$rM)],o);function t(b){const E=b.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,P=b.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let I=b.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function g(...b){return b.length?b.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function c(b){return L.$ik(b,",").map(E=>E.trim()).filter(E=>!!E.length)}function h(b){return[`**/${b}/**`,`**/${b}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function w(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(b){return b.replace(/([?*[\]])/g,"[$1]")}function D(b,E){b=u.$Mb(b,I=>I.toString());const k=[],P=E.getWorkspace();return b&&b.forEach(I=>{let j;if(E.getWorkbenchState()===2)j=(0,S.$6g)(P.folders[0].uri,I),j&&j!=="."&&(j="./"+j);else{const F=E.getWorkspaceFolder(I);if(F){const z=F.name;if(P.folders.filter(T=>T.name===z).length===1){const T=(0,S.$6g)(F.uri,I);T===""?j=`./${F.name}`:j=`./${F.name}/${T}`}else j=I.fsPath}}j&&k.push(d(j))}),k}}),define(ke[372],Ee([1,0,23,2,22,13,5,371,36,42,8]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ktb=m,e.$Ltb=l;const C=7e3;function m(f,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const s of n)if(/^workspaceContains:/.test(s)){const w=s.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?r.push(w):i.push(w)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,A.$jh)(),g=s=>t({activationEvent:s}),c=Promise.all(i.map(s=>y(f,s,g))).then(()=>{}),h=v(f,a.identifier,r,g);return Promise.all([c,h]).then(()=>{t(void 0)}),o}async function y(f,a,n){for(const i of f.folders)if(await f.exists(u.$4g(N.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function v(f,a,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.$me,o=f.checkExists(f.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let g=!1;try{g=await o}catch(c){R.$4(c)||R.$1(c)}r.dispose(),clearTimeout(t),g&&i(`workspaceContains:${n.join(",")}`)}function l(f,a,n,i){const r=f.get(M.$pi),o=f.get($.$4K),g=r.createInstance(p.$tM).file(a.map(c=>(0,S.$Li)(N.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(g,i).then(c=>!!c.limitHit,c=>R.$4(c)?!1:Promise.reject(c))}}),define(ke[49],Ee([1,0,219,17,59,23,8,3,77,2,12,6,45,304,118,44,26,148,13,25,21,281,7,66,5,28,93,20,107,70,43,121,4,372,117,283,15,115,40,11,116]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c,h,s,w,d,D,b,E,k,P,I,j,F,z,O,T,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=e.$slc=e.$rlc=e.$qlc=void 0,e.$qlc=(0,c.$qi)("IHostUtils");let X=W=class extends p.$Uc{constructor(U,ne,$e,Pe,se,re,oe,G,ie,me,pe,Ae,fe){super(),this.Y=Ae,this.Z=fe,this.a=this.B(new k.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ne,this.g=$e,this.f=oe,this.j=Pe,this.m=se,this.s=re,this.t=ie,this.u=me,this.w=pe,this.y=this.g.getProxy(C.$PM.MainThreadWorkspace),this.z=this.g.getProxy(C.$PM.MainThreadTelemetry),this.C=this.g.getProxy(C.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Se(this.f.extensions.activationEvents),this.L=new a.$5$b(this.I,this.f.extensions.allExtensions);const De=new i.$Mm(this.f.extensions.myExtensions);this.J=new a.$5$b(this.I,te(this.L,De)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new v.$_kc(this.g,this.s),this.N=new I.$jlc(this.g),this.O=G,this.h=U.createChild(new d.$oi([v.$alc,this.M],[I.$klc,this.N])),this.P=this.B(new y.$$kc(this.J,this.L,{onExtensionActivationError:(Ie,Te,q)=>{this.C.$onExtensionActivationError(Ie,n.$3(Te),q)},actualActivateExtension:async(Ie,Te)=>{if(a.$5$b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Te),new y.$0kc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.eb(se))}catch{}await Promise.all(U)}terminate(U,ne=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const $e=this.$();Promise.race([(0,M.$rh)(5e3),$e]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ne=await this.C.$getExtension(U);return ne&&{...ne,identifier:new i.$Lm(ne.identifier.value),extensionLocation:S.URI.revive(ne.extensionLocation)}}ab(U,ne){return this.P.activateByEvent(U,ne)}bb(U,ne){return this.P.activateById(U,ne)}activateByIdWithErrors(U,ne){return this.bb(U,ne).then(()=>{const $e=this.P.getActivatedExtension(U);if($e.activationFailed)return Promise.reject($e.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===F.Schemas.file&&this.c.fsRealpath){const ne=U.fsPath;this.R.has(ne)||this.R.set(ne,this.c.fsRealpath(ne));const $e=await this.R.get(ne);return S.URI.file($e)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new we(U))),this.Q}async db(U){const ne=$.$wi.forUris($e=>R.$Ug.ignorePathCasing($e));return await Promise.all(U.map(async $e=>{if(this.wb($e)){const Pe=await this.cb($e.extensionLocation);ne.set(Pe,$e)}})),ne}eb(U){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ne;const $e=this.P.getActivatedExtension(U);if(!$e)return ne;try{typeof $e.module.deactivate=="function"&&(ne=Promise.resolve($e.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Pe)}try{(0,p.$Pc)($e.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Pe)}return ne}async fb(U,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ne).then($e=>{const Pe=$e.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,ne),this.gb(U,ne,"success",Pe),$e},$e=>{throw this.gb(U,ne,"failure"),$e})}gb(U,ne,$e,Pe){const se=Y(U,ne);this.z.$publicLog2("extensionActivationTimes",{...se,...Pe||{},outcome:$e})}hb(U,ne){const $e=Y(U,ne);this.z.$publicLog2("activatePlugin",$e);const Pe=this.wb(U);if(!Pe)return Promise.resolve(new y.$9kc(y.$6kc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${U.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const se=new y.$7kc(ne.startup);return Promise.all([this.xb(U,(0,R.$4g)(U.extensionLocation,Pe),se),this.ib(U)]).then(re=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,re[0],re[1],se))).then(re=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}ib(U){const ne=this.Z.createLanguageModelAccessInformation(U),$e=new o.$clc(U,this.M),Pe=new o.$blc(U.identifier.value,!1,this.M),se=new j.$llc(U,this.N),re=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([$e.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const G=this;let ie,me;const pe=(0,f.$wG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:$e,workspaceState:Pe,secrets:se,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return N.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return G.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return G.O.globalValue(U).fsPath},get logPath(){return N.$kc(G.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(G.f.logsLocation,U.identifier.value)},get storageUri(){return G.O.workspaceValue(U)},get globalStorageUri(){return G.O.globalValue(U)},get extensionMode(){return re},get extension(){return ie===void 0&&(ie=new ue(G,U.identifier,U,oe,!1)),ie},get extensionRuntime(){return(0,f.$xG)(U,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!me){if(!pe)return;const Ae=k.Event.buffer(k.Event.fromDOMEventEmitter(pe,"message",fe=>fe.data));pe.start(),me={onDidReceiveMessage:Ae,postMessage:pe.postMessage.bind(pe)}}return me}})})}static jb(U,ne,$e,Pe,se){return $e=$e||{activate:void 0,deactivate:void 0},this.kb(U,ne,$e,Pe,se).then(re=>new y.$8kc(!1,null,se.build(),$e,re,Pe.subscriptions))}static kb(U,ne,$e,Pe,se){if(typeof $e.activate=="function")try{se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const re=typeof global=="object"?global:self,oe=$e.activate.apply(re,[Pe]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(oe).then(G=>(se.activateResolveStop(),G))}catch(re){return Promise.reject(re)}else return Promise.resolve($e)}lb(U,ne){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ne}).then(void 0,$e=>{this.s.error($e)})}mb(U,ne=0){const Pe=Date.now();(0,T.$B)(()=>{for(let se=ne;se<U.length;se+=1){const re=U[se];for(const oe of re.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Pe>50){this.mb(U,se);break}else this.lb(re,oe)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ne=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),$e=this.J.getAllExtensionDescriptions();if(ne)this.mb($e);else for(const Pe of $e)if(Pe.activationEvents)for(const se of Pe.activationEvents)se==="onStartupFinished"&&this.lb(Pe,se)})}ob(){const U=this.ab("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.pb(re.added)));const ne=this.j.workspace?this.j.workspace.folders:[],$e=this.pb(ne),Pe=this.rb(),se=Promise.all([Pe,U,$e]).then(()=>{});return Promise.race([se,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),se}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.qb(U,ne))).then(()=>{})}async qb(U,ne){if(this.isActivated(ne.identifier))return;const $e=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:U.map(re=>re.uri),forceUsingSearch:$e||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,oe,G)=>this.y.$checkExists(re,oe,G)},se=await(0,P.$Ktb)(Pe,ne);if(se)return this.bb(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ne}=this.f.environment;if(!U||!ne)throw new Error(u.localize(0,null));const $e=await this.xb(null,ne,new y.$7kc(!1));if(!$e||typeof $e.run!="function")throw new Error(u.localize(1,null,ne.toString()));return new Promise((Pe,se)=>{const re=(ie,me)=>{ie?(T.$t&&this.s.error("Test runner called back with error",ie),se(ie)):(T.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof me=="number"&&me>0?1:0))},oe=(0,R.$Rg)(ne),G=$e.run(oe,re);G&&G.then&&G.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(ie=>{T.$t&&this.s.error("Test runner finished with error",ie),se(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ne){return this.S[U]=ne,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ne}=await this.ub(U);return ne?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ne=U.indexOf("+");if(ne===-1)throw new t.$XM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const $e=U.substr(0,ne);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${$e}`,!1),{authorityPrefix:$e,resolver:this.S[$e]}}async $resolveAuthority(U,ne){const $e=O.$0d.create(!1),Pe=()=>`[resolveAuthority(${(0,g.$Fl)(U)},${ne})][${$e.elapsed()}ms] `,se=V=>this.s.info(`${Pe()}${V}`),re=V=>this.s.warn(`${Pe()}${V}`),oe=(V,J=void 0)=>this.s.error(`${Pe()}${V}`,J),G=V=>{if(V instanceof t.$XM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},ie=async V=>{se(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:Q}=await this.ub(V);if(!J)throw oe(`no resolver for ${Q}`),new t.$XM(`No remote extension installed to resolve ${Q}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Q,remoteAuthority:V}},me=U.split(/@|%40/g).reverse();se(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(ie)).catch(async V=>{if(!(V instanceof t.$XM)||V._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return re(`resolving nested authorities failed: ${V.message}`),[await ie(U)]})}catch(V){return G(V)}const Ae=new M.$Bh;Ae.cancelAndSet(()=>se("waiting..."),1e3);let fe,De;for(const[V,{authorityPrefix:J,resolver:Q,remoteAuthority:he}]of pe.entries())try{if(V===pe.length-1)se("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${J}`),fe=await Q.resolve(he,{resolveAttempt:ne,execServer:De}),L.mark(`code/extHost/didResolveAuthorityOK/${J}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$WM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(se(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${J}`),De=await Q.resolveExecServer?.(he,{resolveAttempt:ne,execServer:De}),!De)throw new t.$XM(`Exec server was not available for ${he}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(be){return L.mark(`code/extHost/didResolveAuthorityError/${J}`),oe("returned an error",be),Ae.dispose(),G(be)}Ae.dispose();const Ie={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$WM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let q;if(t.$WM.isManagedResolvedAuthority(fe)){const V=ne;this.Y.setFactory(V,fe.makeConnection),q={authority:U,connectTo:new g.$Cl(V),connectionToken:fe.connectionToken}}else q={authority:U,connectTo:new g.$Dl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:q,options:Te,tunnelInformation:Ie}}}async $getCanonicalURI(U,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Fl)(U)})`);const{resolver:$e}=await this.ub(U);if(!$e)return null;const Pe=S.URI.revive(ne);if(typeof $e.getCanonicalURI>"u")return Pe;const se=await(0,M.$ih)(()=>$e.getCanonicalURI(Pe));return se||Pe}async $startExtensionHost(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:ne,myExtensions:$e}=x(this.I,this.L,this.J,U),Pe=await this.db($e);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set($e),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.tb()}$activateByEvent(U,ne){return ne===1?this.D.wait().then($e=>this.ab(U,!1)):this.G.wait().then($e=>this.ab(U,!1))}async $activate(U,ne){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ne),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(re=>re.extensionLocation=S.URI.revive(re.extensionLocation));const{globalRegistry:ne,myExtensions:$e}=x(this.I,this.L,this.J,U),Pe=await this.db($e);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set($e),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ne=r.$Ce.alloc(U),$e=Math.random()%256;for(let Pe=0;Pe<U;Pe++)ne.writeUInt8($e,Pe);return ne}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$rlc=X,e.$rlc=X=W=Je([qe(0,c.$pi),qe(1,e.$qlc),qe(2,w.$cP),qe(3,l.$Okc),qe(4,m.$Rkc),qe(5,A.$Wj),qe(6,h.$sP),qe(7,s.$Ukc),qe(8,D.$NCb),qe(9,b.$dlc),qe(10,z.$nlc),qe(11,B.$olc),qe(12,E.$hlc)],X);function x(_,U,ne,$e){_.addActivationEvents($e.addActivationEvents);const Pe=new a.$5$b(_,U.getAllExtensionDescriptions());Pe.deltaExtensions($e.toAdd,$e.toRemove);const se=new i.$Mm(ne.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of $e.myToRemove)se.delete(oe);for(const oe of $e.myToAdd)se.add(oe);const re=te(Pe,se);return{globalRegistry:Pe,myExtensions:re}}function Y(_,U){return{id:_.identifier.value,name:_.name,extensionVersion:_.version,publisherDisplayName:_.publisher,activationEvents:_.activationEvents?_.activationEvents.join(","):null,isBuiltin:_.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Z(_){return _.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$slc=(0,c.$qi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(U,ne,$e,Pe,se){this.#e=U,this.#t=ne,this.#i=$e.identifier,this.id=$e.identifier.value,this.extensionUri=$e.extensionLocation,this.extensionPath=N.$ic((0,R.$Rg)($e.extensionLocation)),this.packageJSON=$e,this.extensionKind=Pe,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tlc=ue;function te(_,U){return _.getAllExtensionDescriptions().filter(ne=>U.has(ne.identifier))}class we{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$ulc=we;class Se{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ne of Object.keys(U))this.a.set(ne,U[ne])}}}),define(ke[373],Ee([1,0,59,2,6,45,26,25,20,28,5,49,12,14]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;let l=class{constructor(r,o,t,g,c,h,s){this.c=r,this.d=o,this.e=t,this.f=g,this.g=c,this.h=h,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,r,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const o of r.nodeModuleName)this.a.set(o,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(o=>r.alternativeModuleName(o))}};e.$Dmc=l,e.$Dmc=l=Je([qe(2,A.$pi),qe(3,R.$Rkc),qe(4,C.$slc),qe(5,S.$sP),qe(6,m.$Wj)],l);let f=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const o=(0,y.$8e)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${c}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const o=this.b.exec(this.c(r));if(!o)return;const[,t,g,c]=o,h=v.a.get(g);if(h!==void 0)return console.warn(`${g} as been renamed to ${h}, please update your imports`),t+h+c}c(r){return r.replace(/\\/g,"/")}};f=v=Je([qe(0,S.$sP)],f);class a{constructor(r,o,t,g,c){this.c=r,this.d=o,this.e=t,this.f=g,this.g=c,this.nodeModuleName="vscode",this.a=new p.$Nm}load(r,o){const t=this.d.findSubstr(o);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((c,h)=>g+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${g}`),this.b=this.c(M.$rG,this.e,this.f)}return this.b}}let n=class{constructor(r,o,t){this.e=r,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$PM.MainThreadTelemetry);const g=t.getProxy(L.$PM.MainThreadWindow);this.c=(c,h)=>{const s=N.URI.parse(c);return h?this.g(c,h):s.scheme==="http"||s.scheme==="https"?g.$openUri(s,c,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?g.$openUri(s,c,{}):this.g(c,h)}}load(r,o,t){const g=this.e.findSubstr(o);return g&&(this.a=g.identifier.value,this.h()),this.b=t(r),this.c}g(r,o){return this.i(),this.b(r,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,$.$cP)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,7,44,301,45]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0,e.$vlc=(0,M.$qi)("IExtHostVariableResolverProvider");class v extends m.$eQ{constructor(a,n,i,r,o,t,g){function c(){if(i){const h=i.activeEditor();if(h)return h.document.uri;const s=r.tabGroups.all.find(w=>w.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof A.$CO||s.input instanceof A.$HO)return s.input.modified;if(s.input instanceof A.$BO||s.input instanceof A.$GO||s.input instanceof A.$EO)return s.input.uri}}}super({getFolderUri:h=>{const s=t.folders.filter(w=>w.name===h);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(h,s)=>o.getConfiguration(void 0,h).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return L.$ic(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=c();if(h){const s=n.getWorkspaceFolder(h);if(s)return L.$ic(s.uri.fsPath)}}},getSelectedText:()=>{if(i){const h=i.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(i){const h=i.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>a.getExtension(h)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(R.env))}}let l=class extends N.$Uc{constructor(a,n,i,r,o){super(),this.b=a,this.c=n,this.g=i,this.h=r,this.j=o,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$wlc=l,e.$wlc=l=Je([qe(0,S.$slc),qe(1,C.$Okc),qe(2,p.$nP),qe(3,y.$Rkc),qe(4,$.$4kc)],l)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,71,49,20,7,44,143,293,45,61,3,57,33,16]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=e.$zlc=e.$ylc=e.$xlc=void 0,e.$xlc=(0,M.$qi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,D,b,E,k,P,I){this.N=D,this.O=b,this.P=E,this.Q=k,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=d.getProxy(p.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new g(this.l),this.z=new Map,this.O.getExtensionRegistry().then(j=>{j.onDidChange(F=>{this.V(j)}),this.V(j)})}async $getVisualizerTreeItem(d,D){const b=this.W(D);if(!b)return;const E=await this.H.get(d)?.getTreeItem?.(b);return E?this.U(d,E):void 0}registerDebugVisualizationTree(d,D,b){const E=R.$Lm.toKey(d.identifier),k=this.jb(E,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,b),this.l.$registerDebugVisualizerTree(k,!!b.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren(d,D){const b=this.J.get(D)?.item;return b?(await this.H.get(d)?.getChildren?.(b))?.map(k=>this.U(d,k))||[]:[]}async $editVisualizerTreeItem(d,D){const b=this.J.get(d);if(!b)return;const E=await this.H.get(b.provider)?.editItem?.(b.item,D);return this.U(b.provider,E||b.item)}$disposeVisualizedTree(d){const D=this.J.get(d);if(!D)return;const b=[D.children];for(const E of b)if(E)for(const k of E)b.push(this.J.get(k)?.children),this.J.delete(k)}U(d,D){let b=this.I.get(D);return b||(b=this.F++,this.I.set(D,b),this.J.set(b,{provider:d,item:D})),r.DebugTreeItem.from(D,b)}asDebugSourceUri(d,D){const b=d;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let E=`debug:${encodeURIComponent(b.path||"")}`,k="?";return D&&(E+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),E+=`${k}ref=${b.sourceReference}`,L.URI.parse(E)}else{if(b.path)return L.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const D=[];for(const b of d.getAllExtensionDescriptions())if(b.contributes){const E=b.contributes.debuggers;if(E&&E.length>0)for(const k of E)(0,v.$_G)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(D=>d.push(D)),d}async $resolveDebugVisualizer(d,D){const b=this.L.get(d);if(!b)throw new Error(`No debug visualizer found with id '${d}'`);let{v:E,provider:k,extensionId:P}=b;if(E.visualization||(E=await k.resolveDebugVisualization?.(E,D)||E,b.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(P,E.visualization)}async $executeDebugVisualizerCommand(d){const D=this.L.get(d);if(!D)throw new Error(`No debug visualizer found with id '${d}'`);const b=D.v.visualization;b&&"command"in b&&this.S.executeCommand(b.command,...b.arguments||[])}W(d){const D=this.m.get(d.sessionId);return D&&{session:D.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,D,b,E){const k=this.W(b),P=this.jb(d,D),I=this.G.get(P);if(!k||!I)return[];const j=await I.provideDebugVisualization(k,E);return j?j.map(F=>{const z=++this.M;this.L.set(z,{v:F,provider:I,extensionId:d});const O=F.iconPath?this.lb(F.iconPath):void 0;return{id:z,name:F.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(d,F.visualization)}}):[]}$disposeDebugVisualizers(d){for(const D of d)this.L.delete(D)}registerDebugVisualizationProvider(d,D,b){if(!d.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const E=R.$Lm.toKey(d.identifier),k=this.jb(E,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,b),this.l.$registerDebugVisualizer(E,D),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(E,D),this.G.delete(D)})}addBreakpoints(d){const D=d.filter(k=>{const P=k.id;return this.z.has(P)?!1:(this.z.set(P,k),!0)});this.gb(D,[],[]);const b=[],E=new Map;for(const k of D)if(k instanceof C.$SN){let P=E.get(k.location.uri.toString());P||(P={type:"sourceMulti",uri:k.location.uri,lines:[]},E.set(k.location.uri.toString(),P),b.push(P)),P.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof C.$TN&&b.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(b)}removeBreakpoints(d){const D=d.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const b=D.filter(P=>P instanceof C.$SN).map(P=>P.id),E=D.filter(P=>P instanceof C.$TN).map(P=>P.id),k=D.filter(P=>P instanceof C.$UN).map(P=>P.id);return this.l.$unregisterBreakpoints(b,E,k)}startDebugging(d,D,b){return this.l.$startDebugging(d?d.uri:void 0,D,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,D,b){if(!D)return new C.$RM(()=>{});const E=this.d++;return this.f.push({type:d,handle:E,provider:D}),this.l.$registerDebugConfigurationProvider(d,b,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,E),new C.$RM(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(d,D,b){if(!b)return new C.$RM(()=>{});if(!this.cb(d,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:D,handle:E,factory:b}),this.l.$registerDebugAdapterDescriptorFactory(D,E),new C.$RM(()=>{this.h=this.h.filter(k=>k.factory!==b),this.l.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(d,D){if(!D)return new C.$RM(()=>{});const b=this.j++;return this.k.push({type:d,handle:b,factory:D}),new C.$RM(()=>{this.k=this.k.filter(E=>E.factory!==D)})}async $runInTerminal(d,D){return Promise.resolve(void 0)}async $substituteVariables(d,D){let b;const E=await this.ib(d);return E&&(b={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(b,D)}X(d,D){if(d.type==="implementation")return new h(d.implementation)}Y(){}async $startDASession(d,D){const b=this,E=await this.hb(D);return this.eb(this.$(E.type),E).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const P=this.Z(k),I=this.X(P,E);if(!I)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const j=I;return this.D.set(d,j),this.db(E).then(F=>(F&&this.E.set(d,F),j.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},j.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,j.sendResponse(T)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(z),z=(0,v.$eH)(z,!0),b.l.$acceptDAMessage(d,z)}),j.onError(z=>{F&&F.onError&&F.onError(z),this.l.$acceptDAError(d,z.name,z.message,z.stack)}),j.onExit(z=>{F&&F.onExit&&F.onExit(z??void 0,void 0),this.l.$acceptDAExit(d,z??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),j.startSession()))})}$sendDAMessage(d,D){D=(0,v.$dH)(D,!1);const b=this.E.get(d);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(D),this.D.get(d)?.sendMessage(D)}$stopDASession(d){const D=this.E.get(d);this.E.delete(d),D&&D.onWillStopSession&&D.onWillStopSession();const b=this.D.get(d);return this.D.delete(d),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const D=[],b=[],E=[];if(d.added)for(const k of d.added){const P=k.id;if(P&&!this.z.has(P)){let I;if(k.type==="function")I=new C.$TN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")I=new C.$UN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const j=L.URI.revive(k.uri);I=new C.$SN(new C.$4M(j,new C.$SM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,C.$QN)(I,P),this.z.set(P,I),D.push(I)}}if(d.removed)for(const k of d.removed){const P=this.z.get(k);P&&(this.z.delete(k),b.push(P))}if(d.changed){for(const k of d.changed)if(k.id){const P=this.z.get(k.id);if(P){if(P instanceof C.$TN&&k.type==="function"){const I=P;I.enabled=k.enabled,I.condition=k.condition,I.hitCondition=k.hitCondition,I.logMessage=k.logMessage,I.functionName=k.functionName}else if(P instanceof C.$SN&&k.type==="source"){const I=P;I.enabled=k.enabled,I.condition=k.condition,I.hitCondition=k.hitCondition,I.logMessage=k.logMessage,I.location=new C.$4M(L.URI.revive(k.uri),new C.$SM(k.line,k.character))}E.push(P)}}}this.gb(D,b,E)}async $acceptStackFrameFocus(d){let D;if(d){const b=await this.hb(d.sessionId);d.kind==="thread"?D=new C.$1N(b.api,d.threadId):D=new C.$ZN(b.api,d.threadId,d.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(d,D,b){return(0,u.$ih)(async()=>{const E=this.bb(d);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return E.provideDebugConfigurations(k,b)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(d,D,b,E){return(0,u.$ih)(async()=>{const k=this.bb(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return k.resolveDebugConfiguration(P,b,E)})}$resolveDebugConfigurationWithSubstitutedVariables(d,D,b,E){return(0,u.$ih)(async()=>{const k=this.bb(d);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(P,b,E)})}async $provideDebugAdapter(d,D){const b=this.ab(d);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.hb(D);return this.eb(b,E).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(d){const D=await this.hb(d);this.n.fire(D.api)}async $acceptDebugSessionTerminated(d){const D=await this.hb(d);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,D){(await this.hb(d))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(d,D){const E={session:(await this.hb(d)).api,event:D.event,body:D.body};this.w.fire(E)}Z(d){if(d instanceof C.$VN)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.$WN)return{type:"server",port:d.port,host:d.host};if(d instanceof C.$XN)return{type:"pipeServer",path:d.path};if(d instanceof C.$YN)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const D=this.h.filter(b=>b.type===d);if(D.length>0)return D[0].factory}ab(d){const D=this.h.filter(b=>b.handle===d);if(D.length>0)return D[0].factory}bb(d){const D=this.f.filter(b=>b.handle===d);if(D.length>0)return D[0].provider}cb(d,D){if(d.contributes){const b=d.contributes.debuggers;if(b&&b.length>0){for(const E of b)if(E.label&&E.type&&E.type===D)return!0}}return!1}db(d){const b=d.configuration.type,E=this.k.filter(k=>k.type===b||k.type==="*").map(k=>(0,u.$ih)(()=>k.factory.createDebugAdapterTracker(d.api)).then(P=>P,P=>null));return Promise.race([Promise.all(E).then(k=>{const P=k.filter(I=>!!I);if(P.length>0)return new c(P)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(d,D){const b=D.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new C.$WN(b));if(d){const k=await this.O.getExtensionRegistry();return(0,u.$ih)(()=>d.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(P=>{if(P)return P})}const E=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,E))}fb(d,D){}gb(d,D,b){(d.length>0||D.length>0||b.length>0)&&this.A.fire(Object.freeze({added:d,removed:D,changed:b}))}async hb(d){if(d)if(typeof d=="string"){const D=this.m.get(d);if(D)return D}else{let D=this.m.get(d.id);if(!D){const b=await this.ib(d.folderUri),E=d.parent?this.m.get(d.parent):void 0;D=new t(this.l,d.id,d.type,d.name,b,d.configuration,E?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(d){if(d){const D=L.URI.revive(d);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(d,D){return`${d}\0${D}`}kb(d,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${d}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const D=this.mb(d);let b,E;return"id"in D?E=n.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:E}}mb(d){if(d instanceof C.$NN)return{id:d.id};const D=typeof d=="object"&&"dark"in d?d.dark:d,b=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof b=="string"?L.URI.file(b):b}}};e.$ylc=o,e.$ylc=o=Je([qe(0,A.$cP),qe(1,m.$Okc),qe(2,S.$slc),qe(3,l.$Rkc),qe(4,$.$4kc),qe(5,f.$vlc),qe(6,i.$yP)],o);class t{constructor(d,D,b,E,k,P,I){this.f=d,this.g=D,this.h=b,this.j=E,this.k=k,this.l=P,this.m=I}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(D){d.j=D,d.f.$setDebugSessionName(d.g,D)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(D,b){return d.f.$customDebugAdapterRequest(d.g,D,b)},getDebugProtocolBreakpoint(D){return d.f.$getDebugProtocolBreakpoint(d.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$zlc=t;class g{constructor(d){this.value=Object.freeze({append(D){d.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Alc=g;class c{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(D=>D.onError?D.onError(d):void 0)}onExit(d,D){this.d.forEach(b=>b.onExit?b.onExit(d,D):void 0)}}class h extends y.$Qob{constructor(d){super(),this.h=d,d.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(d,D,b,E,k,P,I){super(d,D,b,E,k,P,I)}};e.$Blc=s,e.$Blc=s=Je([qe(0,A.$cP),qe(1,m.$Okc),qe(2,S.$slc),qe(3,l.$Rkc),qe(4,$.$4kc),qe(5,f.$vlc),qe(6,i.$yP)],s)}),define(ke[374],Ee([1,0,13,59,2,6,321,12,84,107,28,257,20,67,49,90]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=e.$Emc=void 0;class f{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(p.$Wj),t=i.get(m.$cP).getProxy(R.$PM.MainThreadErrors);u.setUnexpectedErrorHandler(g=>{r.error(g);const c=u.$3(g);t.$onUnexpectedError(c)})}static async installFullHandler(i){const r=i.get(p.$Wj),o=i.get(m.$cP),t=i.get(v.$slc),g=i.get(l.$wP),c=o.getProxy(R.$PM.MainThreadExtensionService),h=o.getProxy(R.$PM.MainThreadErrors),s=await t.getExtensionPathIndex(),w=new WeakMap;function d(E,k){if(w.has(E))return w.get(E).stack;let P="",I,j;for(const z of k)P+=`
	at ${z.toString()}`,j=z.getFileName(),!I&&j&&(I=s.findSubstr(L.URI.file(j)));const F=`${E.name||"Error"}: ${E.message||""}${P}`;return w.set(E,{extensionIdentifier:I?.identifier,stack:F}),F}const D=Symbol("prepareStackTrace wrapped");let b=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(E){if(E===d||!E||E[D]){b=E||d;return}b=function(k,P){return d(k,P),E.call(Error,k,P)},Object.assign(b,{[D]:!0})}}),u.setUnexpectedErrorHandler(E=>{r.error(E);const k=u.$3(E),P=w.get(E);if(!P?.extensionIdentifier){h.$onUnexpectedError(k);return}c.$onExtensionRuntimeError(P.extensionIdentifier,k);const I=g.onExtensionError(P.extensionIdentifier,E);r.trace("forwarded error to extension?",I,P)})}}e.$Emc=f;class a{constructor(i,r,o,t,g){this.a=o,this.b=new M.$a_b(i,null,t),r=a.e(r,this.b);const c=new S.$oi(...(0,$.$ps)());c.set(A.$sP,{_serviceBrand:void 0,...r,messagePorts:g}),c.set(m.$cP,new m.$dP(this.b)),c.set(y.$Lkc,new y.$Mkc(t)),c.set(v.$qlc,o);const h=new C.$7q(c,!0);h.invokeFunction(f.installEarlyHandler),this.d=h.invokeFunction(s=>s.get(p.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=h.invokeFunction(s=>s.get(v.$slc)),this.c.initialize(),h.invokeFunction(f.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(R.$PM.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Fmc=a}),define(ke[375],Ee([1,0,8,11,230,250,141,96,71,49,20,43,7,61,44,294,295,45,33]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;let i=class extends p.$ylc{constructor(c,h,s,w,d,D,b,E){super(c,h,s,w,D,b,E),this.pb=d,this.nb=new t}X(c,h){switch(c.type){case"server":return new l.$Kmc(c);case"pipeServer":return new l.$Lmc(c);case"executable":return new l.$Mmc(c,h.type)}return super.X(c,h)}fb(c,h){const s=l.$Mmc.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(s)return new m.$VN(s.command,s.args,s.options)}Y(){return new M.$1cc}async $runInTerminal(c,h){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const s=await this.P.getConfigProvider(),w=this.pb.getDefaultShell(!0),d=this.pb.getDefaultShellArgs(!0),D=c.title||L.localize(0,null),b=JSON.stringify({shell:w,shellArgs:d});let E=await this.nb.checkout(b,D),k,P=!1;if(E)k=c.cwd;else{const z={shellPath:w,shellArgs:d,cwd:c.cwd,name:D,iconPath:new m.$NN("debug")};P=!0,E=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(E,b)}E.show(!0);const I=await E.processId;P?await new Promise(z=>setTimeout(z,1e3)):(E.state.isInteractedWith&&E.sendText(""),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0||w.indexOf("cmd.exe")>=0?E.sendText("cls"):w.indexOf("bash")>=0?E.sendText("clear"):N.$i?E.sendText("cls"):E.sendText("clear")));const j=(0,f.$Omc)(w,c.args,!!c.argsCanBeInterpretedByShell,k,c.env);E.sendText(j);const F=this.onDidTerminateDebugSession(z=>{z.id===h&&(this.nb.free(E),F.dispose())});return I}else if(c.kind==="external")return o(c,await this.P.getConfigProvider());return super.$runInTerminal(c,h)}};e.$Pmc=i,e.$Pmc=i=Je([qe(0,A.$cP),qe(1,v.$Okc),qe(2,S.$slc),qe(3,a.$Rkc),qe(4,C.$dlc),qe(5,$.$4kc),qe(6,y.$vlc),qe(7,n.$yP)],i);let r;function o(g,c){if(!r)if(N.$i)r=new R.$Lbc;else if(N.$j)r=new R.$Mbc;else if(N.$k)r=new R.$Nbc;else throw new Error("external terminals not supported on this platform");const h=c.getConfiguration("terminal");return r.runInTerminal(g.title,g.cwd,g.args,g.env||{},h.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,h,s=!1){const d=[...this.b.entries()].map(([D,b])=>(0,u.$dh)(async E=>{if(D.name!==h||b.lastUsedAt!==-1&&await(0,f.$Nmc)(await D.processId))return null;const k=Date.now();return b.lastUsedAt+t.a>k||E.isCancellationRequested?null:b.config!==c?(s&&D.dispose(),null):(b.lastUsedAt=k,D)}));return await(0,u.$vh)(d,D=>!!D)}insert(c,h){this.b.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this.b.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(ke[376],Ee([1,0,17,2,105,44,72,45,42,43,20,28,95,15,12,91,23,64,61]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;let i=class extends m.$hmc{constructor(o,t,g,c,h,s,w,d,D){super(o,t,g,c,h,s,w,d),this.C=g,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const g=t;if(!t.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const c=m.TaskHandleDTO.from(g,this.C),h=await this.a.$getTaskExecution(c);if(h.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.z(h,t);return this.a.$executeTask(c).catch(()=>{}),s}else{const c=m.TaskDTO.from(t,o);if(c===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(c.execution)&&await this.y(c,t,!1);const h=await this.z(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),h}}v(o,t,g,c){const h=[];if(c)for(const s of c){this.A(s,g),(!s.definition||!o[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const w=m.TaskDTO.from(s,g.extension);w&&(h.push(w),m.CustomExecutionDTO.is(w.execution)&&t.push(this.y(w,s,!0)))}return{tasks:h,extension:g.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const g=N.URI.file((0,a.homedir)());t=new $.$Ki({uri:g,name:f.$1g(g),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const g=N.URI.revive(o),c={process:void 0,variables:Object.create(null)},h=await this.b.resolveWorkspaceFolder(g),s=await this.b.getWorkspaceFolders2()??[],w=await this.D.getResolver(),d=h?{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(s);for(const D of t.variables)c.variables[D]=await w.resolveAsync(d,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let b=0;b<D.length;b++)D[b]=await w.resolveAsync(d,D[b])}c.process=await L.win32.findExecutable(await w.resolveAsync(d,t.process.name),t.process.cwd!==void 0?await w.resolveAsync(d,t.process.cwd):void 0,D)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,g){return L.win32.findExecutable(o,t,g)}};e.$Hmc=i,e.$Hmc=i=Je([qe(0,A.$cP),qe(1,C.$sP),qe(2,R.$Okc),qe(3,M.$nP),qe(4,p.$Rkc),qe(5,S.$dlc),qe(6,v.$Wj),qe(7,l.$skc),qe(8,n.$vlc)],i)}),define(ke[377],Ee([1,0,64,61]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class L extends N.$wlc{m(){return(0,u.homedir)()}}e.$nnc=L}),define(ke[159],Ee([1,0,19,8,22,47,15,17,23,2,36]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Qlc=e.$Plc=void 0,e.$Rlc=l;class C{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],o=new L.$me(i);return new Promise((t,g)=>{this.a=new y(n);let c=!1;const h=(s,w)=>{if(!c&&!this.b){const d=this.h(s);l(s)&&typeof this.g.maxResults=="number"&&this.c+d>this.g.maxResults&&(this.b=!0,c=!0,o.cancel(),s=this.j(s,this.g.maxResults-this.c));const D=this.h(s);this.c+=D,(D>0||!l(s))&&this.a.add(s,w)}};Promise.all(r.map((s,w)=>this.k(s,d=>h(d,w),o.token))).then(s=>{o.dispose(),this.a.flush();const w=s.some(d=>!!d&&!!d.limitHit);t({limitHit:this.b||w,messages:(0,u.$Rb)(s.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.f}})},s=>{o.dispose();const w=(0,R.$bj)(s);g(new Error(w))})})}h(n){return l(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const o=new A.$kL(this.g,n),t=[],g={report:s=>{if(!this.l(s))return;const w=n.folder.scheme===M.Schemas.file?(0,A.$lL)(()=>this.e.readdir($.$3g(s.uri))):void 0,d=$.$6g(n.folder,s.uri);if(d){const D=o.includedInQuery(d,p.$oc(d),w);(0,N.$ch)(D)?t.push(D.then(b=>{b&&i(s)})):D&&i(s)}}},c=this.n(n);let h;return this.d.query.type===3?h=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,g,r):h=await this.d.provider.provideTextSearchResults(m(this.d.query.contentPattern),c,g,r),t.length&&await Promise.all(t),h}l(n){if(l(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$jL)(this.g.includePattern,n.includePattern),r=(0,A.$jL)(this.g.excludePattern,n.excludePattern),o={folder:S.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$Plc=C;function m(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new f(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Qlc=y;function v(a){return l(a)?{preview:{matches:(0,u.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,u.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function l(a){return!!a.preview}class f{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Slc=f}),define(ke[97],Ee([1,0,3,6,5,370,20,67,12,2,159]),function(le,e,u,N,L,R,M,p,$,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Vlc=m,e.$Tlc=(0,L.$qi)("IExtHostSearch");let C=class{constructor(l,f,a){this.n=l,this.o=f,this.q=a,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Olc}s(l){return this.o.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const a=this.d++;return this.e.set(a,f),this.c.$registerTextSearchProvider(a,this.s(l)),(0,u.$Sc)(()=>{this.g.delete(l),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(l,f){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const a=this.d++;return this.h.set(a,f),this.c.$registerAITextSearchProvider(a,this.s(l)),(0,u.$Sc)(()=>{this.i.delete(l),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(l,f){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const a=this.d++;return this.j.set(a,f),this.c.$registerFileSearchProvider(a,this.s(l)),(0,u.$Sc)(()=>{this.k.delete(l),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(l,f,a,n){const i=m(a),r=this.j.get(l);if(r)return this.l.fileSearch(i,r,o=>{this.c.$handleFileMatch(l,f,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,a){return{messages:[]}}$clearCache(l){return this.l.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,a,n){const i=this.e.get(l);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${l}`);const r=m(a);return this.t(r,i).search(t=>this.c.$handleTextMatch(l,f,t),n)}$provideAITextSearchResults(l,f,a,n){const i=this.h.get(l);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${l}`);const r=m(a);return this.v(r,i).search(t=>this.c.$handleTextMatch(l,f,t),n)}$enableExtensionHostSearch(){}t(l,f){return new A.$Plc({query:l,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(l,f){return new A.$Plc({query:l,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Ulc=C,e.$Ulc=C=Je([qe(0,M.$cP),qe(1,p.$Lkc),qe(2,$.$Wj)],C);function m(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(l=>S.URI.revive(l))}}function y(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[378],Ee([1,0,22,13,4,3,15,41,2,135,198,179,79,25,32,12,86,87,276,6,323,349,91,120,327,328,329,310,299,33,330,45,331,96,151,332,312,324,333,334,72,71,325,49,335,69,336,60,28,350,351,313,337,121,338,115,116,314,369,340,282,341,352,342,157,315,343,344,345,20,346,97,117,347,316,348,118,93,95,90,43,155,353,354,326,355,356,70,16,7,317,67,318,92,357,358,150,44,292,114,26,94]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c,h,s,w,d,D,b,E,k,P,I,j,F,z,O,T,B,W,X,x,Y,Z,ue,te,we,Se,_,U,ne,$e,Pe,se,re,oe,G,ie,me,pe,Ae,fe,De,Ie,Te,q,V,J,Q,he,be,ze,Ve,Ye,it,ot,nt,st,Ce,Be,He,Ne,Xe,ae,ce,Re,Ge,Me,tt,ht,wt,Lt,At,xt,_t,Pt,Vt,Xt,et,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=Yt;function Yt(dt){const vt=dt.get(we.$sP),ti=dt.get(te.$wkc),Zt=dt.get(Z.$Tkc),zt=dt.get(x.$slc),gt=dt.get(Pt.$Okc),Ut=dt.get(st.$wP),Wt=dt.get(E.$Rkc),Kt=dt.get(ht.$Lkc),Ze=dt.get(J.$cP),ui=dt.get(it.$alc),Ht=dt.get(ot.$Ukc),Bt=dt.get(l.$Xj),mt=dt.get(l.$Wj),Tt=dt.get(Re.$NCb),Rt=dt.get(t.$skc),jt=dt.get(_t.$ymc),ii=dt.get(be.$klc),Gt=dt.get(W.$4kc),ni=dt.get(re.$olc),Nt=dt.get(g.$Ckc),Ot=dt.get($e.$hlc);Ze.set(i.$QM.ExtHostFileSystemInfo,ti),Ze.set(i.$QM.ExtHostLogLevelServiceShape,Bt),Ze.set(i.$QM.ExtHostWorkspace,gt),Ze.set(i.$QM.ExtHostConfiguration,Wt),Ze.set(i.$QM.ExtHostExtensionService,zt),Ze.set(i.$QM.ExtHostStorage,ui),Ze.set(i.$QM.ExtHostTunnelService,Tt),Ze.set(i.$QM.ExtHostWindow,jt),Ze.set(i.$QM.ExtHostSecretState,ii),Ze.set(i.$QM.ExtHostTelemetry,Ut),Ze.set(i.$QM.ExtHostEditorTabs,Gt),Ze.set(i.$QM.ExtHostManagedSockets,ni),Ze.set(i.$QM.ExtHostAuthentication,Nt),Ze.set(i.$QM.ExtHostChatProvider,Ot);const It=Ze.set(i.$QM.ExtHostDecorations,dt.get(I.$Dlc)),St=Ze.set(i.$QM.ExtHostDocumentsAndEditors,dt.get(B.$nP)),bt=Ze.set(i.$QM.ExtHostCommands,dt.get(D.$yP)),Ct=Ze.set(i.$QM.ExtHostTerminalService,dt.get(Ce.$dlc)),li=Ze.set(i.$QM.ExtHostTerminalShellIntegration,dt.get(Be.$kmc)),Dt=Ze.set(i.$QM.ExtHostDebugService,dt.get(P.$xlc)),hi=Ze.set(i.$QM.ExtHostSearch,dt.get(he.$Tlc)),Jt=Ze.set(i.$QM.ExtHostTask,dt.get(nt.$jmc)),wi=Ze.set(i.$QM.ExtHostOutputService,dt.get(De.$9lc)),ei=Ze.set(i.$QM.ExtHostLocalization,dt.get(se.$nlc)),vi=Ze.set(i.$QM.ExtHostUrls,new wt.$vmc(Ze)),kt=Ze.set(i.$QM.ExtHostDocuments,new T.$zkc(Ze,St)),$i=Ze.set(i.$QM.ExtHostDocumentContentProviders,new z.$Flc(Ze,St,mt)),Le=Ze.set(i.$QM.ExtHostDocumentSaveParticipant,new O.$Glc(mt,kt,Ze.getProxy(i.$PM.MainThreadBulkEdits))),Fe=Ze.set(i.$QM.ExtHostNotebook,new G.$Wlc(Ze,bt,St,kt,Zt,hi)),ye=Ze.set(i.$QM.ExtHostNotebookDocuments,new me.$3lc(Fe)),ee=Ze.set(i.$QM.ExtHostNotebookEditors,new pe.$4lc(mt,Fe)),je=Ze.set(i.$QM.ExtHostNotebookKernels,new Ae.$5lc(Ze,vt,Fe,bt,mt)),Ke=Ze.set(i.$QM.ExtHostNotebookRenderers,new fe.$7lc(Ze,Fe)),_e=Ze.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new ie.$2lc(mt,Fe,Ze.getProxy(i.$PM.MainThreadBulkEdits))),Qe=Ze.set(i.$QM.ExtHostEditors,new Ne.$Ikc(Ze,St)),lt=Ze.set(i.$QM.ExtHostTreeViews,new ce.$tmc(Ze.getProxy(i.$PM.MainThreadTreeViews),bt,mt)),Et=Ze.set(i.$QM.ExtHostEditorInsets,new d.$Jkc(Ze.getProxy(i.$PM.MainThreadEditorInsets),Qe,vt.remote)),Ft=Ze.set(i.$QM.ExtHostDiagnostics,new j.$ykc(Ze,mt,ti,St)),qt=Ze.set(i.$QM.ExtHostLanguages,new Pe.$Zlc(Ze,kt,bt.converter,Kt)),ut=Ze.set(i.$QM.ExtHostLanguageFeatures,new ne.$Akc(Ze,Kt,kt,bt,Ft,mt,Rt,Ut)),ri=Ze.set(i.$QM.ExtHostFileSystem,new Y.$Ilc(Ze,ut)),di=Ze.set(i.$QM.ExtHostFileSystemEventService,new ue.$Jlc(Ze,mt,St)),bi=Ze.set(i.$QM.ExtHostQuickOpen,(0,V.$amc)(Ze,gt,bt)),Di=Ze.set(i.$QM.ExtHostSCM,new Q.$cmc(Ze,bt,kt,mt)),Ri=Ze.set(i.$QM.ExtHostQuickDiff,new q.$_lc(Ze,Kt)),Mi=Ze.set(i.$QM.ExtHostShare,new ze.$dmc(Ze,Kt)),Li=Ze.set(i.$QM.ExtHostComments,(0,b.$Kkc)(Ze,bt,kt)),Ni=Ze.set(i.$QM.ExtHostProgress,new Te.$$lc(Ze.getProxy(i.$PM.MainThreadProgress))),cn=Ze.set(i.$QM.ExtHostLabelService,new U.$Ylc(Ze)),Oi=Ze.set(i.$QM.ExtHostTheming,new Xe.$qmc(Ze)),Ti=Ze.set(i.$QM.ExtHostTimeline,new ae.$smc(Ze,bt)),yi=Ze.set(i.$QM.ExtHostWebviews,new Lt.$Ykc(Ze,vt.remote,gt,mt,Rt)),Ci=Ze.set(i.$QM.ExtHostWebviewPanels,new At.$2kc(Ze,yi,gt)),Hi=Ze.set(i.$QM.ExtHostCustomEditors,new k.$3kc(Ze,kt,Ht,yi,Ci)),Gi=Ze.set(i.$QM.ExtHostWebviewViews,new xt.$wmc(Ze,yi)),pi=Ze.set(i.$QM.ExtHostTesting,new He.$mmc(Ze,mt,bt,St)),Ji=Ze.set(i.$QM.ExtHostUriOpeners,new tt.$umc(Ze)),Qi=Ze.set(i.$QM.ExtHostProfileContentHandlers,new Ie.$0lc(Ze));Ze.set(i.$QM.ExtHostInteractive,new _.$Xlc(Ze,Fe,St,bt,mt));const un=Ze.set(i.$QM.ExtHostInlineChat,new Se.$Klc(Ze,bt,kt,mt)),ji=Ze.set(i.$QM.ExtHostChatAgents2,new h.$Fkc(Ze,mt,bt)),Fi=Ze.set(i.$QM.ExtHostChatVariables,new s.$Gkc(Ze)),Pi=Ze.set(i.$QM.ExtHostAiRelatedInformation,new r.$rkc(Ze)),ln=Ze.set(i.$QM.ExtHostAiEmbeddingVector,new X.$Hlc(Ze)),Xi=Ze.set(i.$QM.ExtHostStatusBar,new Ye.$gmc(Ze,bt.converter)),Yi=Ze.set(i.$QM.ExtHostSpeech,new Ve.$emc(Ze)),hn=Object.values(i.$QM);Ze.assertRegistered(hn);const zi=new c.$Ekc(Ze,St),Zi=new w.$Hkc(Ze),Ii=new oe.$1lc(Ze,mt),Bi=new F.$Elc(Ze);return o.$Bkc.register(bt),function(We,oi,Ui){function at(de){return(ve,Ue,ct)=>{const yt=de(Mt=>{try{ve.call(Ue,Mt)}catch(Si){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ut.onExtensionError(We.identifier,Si)}});return ct?.push(yt),yt}}const pt=function(){let de=!We.isUnderDevelopment;function ve(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ve();else{const yt=ct;typeof yt.scheme>"u"&&ve(),typeof yt.exclusive=="boolean"&&(0,et.$xG)(We,"documentFiltersExclusive")}return ct}}(),dn={getSession(de,ve,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$xG)(We,"authLearnMore"),Nt.getSession(We,de,ve,Ue)},getSessions(de,ve){return(0,et.$xG)(We,"authGetSessions"),Nt.getSessions(We,de,ve)},async hasSession(de,ve){return(0,et.$xG)(We,"authSession"),!!await Nt.getSession(We,de,ve,{silent:!0})},get onDidChangeSessions(){return at(Nt.onDidChangeSessions)},registerAuthenticationProvider(de,ve,Ue,ct){return Nt.registerAuthenticationProvider(de,ve,Ue,ct)}},ai={registerCommand(de,ve,Ue){return bt.registerCommand(!0,de,ve,Ue,void 0,We)},registerTextEditorCommand(de,ve,Ue){return bt.registerCommand(!0,de,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Mt=>{ve.apply(Ue,[yt,Mt,...ct])}).then(Mt=>{Mt||mt.warn("Edits from command "+de+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+de,Mt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ve,Ue)=>((0,et.$xG)(We,"diffCommand"),bt.registerCommand(!0,de,async(...ct)=>{const yt=St.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Mt=await Qe.getDiffInformation(yt.id);ve.apply(Ue,[Mt,...ct])},void 0,void 0,We)),executeCommand(de,...ve){return bt.executeCommand(de,...ve)},getCommands(de=!1){return bt.getCommands(de)}},ki={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$xG)(We,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$xG)(We,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$vP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ve){return st.$uP.validateSender(de),Ut.instantiateLogger(We,de,ve)},openExternal(de,ve){return jt.openUri(de,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===vt.environment.appUriScheme)return vi.createAppUri(de);try{return await jt.asExternalUri(de,{allowTunneling:!!vt.remote.authority})}catch(ve){if((0,M.$zg)(de,M.Schemas.http)||(0,M.$zg)(de,M.Schemas.https))return de;throw ve}},get remoteName(){return(0,f.$Cm)(vt.remote.authority)},get remoteAuthority(){return(0,et.$xG)(We,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$xG)(We,"resolvers"),vt.quality},get appCommit(){return(0,et.$xG)(We,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(de,ve,Ue){return pi.createTestController(We,de,ve,Ue)},createTestObserver(){return(0,et.$xG)(We,"testObserver"),pi.createTestObserver()},runTests(de){return(0,et.$xG)(We,"testObserver"),pi.runTests(de)},get onDidChangeTestResults(){return(0,et.$xG)(We,"testObserver"),at(pi.onResultsChanged)},get testResults(){return(0,et.$xG)(We,"testObserver"),pi.results}},Ei=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,_i={getExtension(de,ve){(0,et.$wG)(We,"extensionsAny")||(ve=!1);const Ue=oi.mine.getExtensionDescription(de);if(Ue)return new x.$tlc(zt,We.identifier,Ue,Ei,!1);if(ve){const ct=oi.all.getExtensionDescription(de);if(ct)return new x.$tlc(zt,We.identifier,ct,Ei,!0)}},get all(){const de=[];for(const ve of oi.mine.getAllExtensionDescriptions())de.push(new x.$tlc(zt,We.identifier,ve,Ei,!1));return de},get allAcrossExtensionHosts(){(0,et.$xG)(We,"extensionsAny");const de=new y.$Mm(oi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of oi.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ve.push(new x.$tlc(zt,We.identifier,Ue,Ei,ct))}return ve},get onDidChange(){return(0,et.$wG)(We,"extensionsAny")?at(L.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):at(oi.mine.onDidChange)}},en={createDiagnosticCollection(de){return Ft.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(Ft.onDidChangeDiagnostics)},getDiagnostics:de=>Ft.getDiagnostics(de),getLanguages(){return qt.getLanguages()},setTextDocumentLanguage(de,ve){return qt.changeLanguage(de.uri,ve)},match(de,ve){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,A.$Vt)(Ue)&&(ct=Fe.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Mt=>Mt.document===ve))?.apiNotebook),(0,A.$Ut)(Ue,ve.uri,ve.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ve,Ue){return ut.registerCodeActionProvider(We,pt(de),ve,Ue)},registerDocumentPasteEditProvider(de,ve,Ue){return(0,et.$xG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,pt(de),ve,Ue)},registerCodeLensProvider(de,ve){return ut.registerCodeLensProvider(We,pt(de),ve)},registerDefinitionProvider(de,ve){return ut.registerDefinitionProvider(We,pt(de),ve)},registerDeclarationProvider(de,ve){return ut.registerDeclarationProvider(We,pt(de),ve)},registerImplementationProvider(de,ve){return ut.registerImplementationProvider(We,pt(de),ve)},registerTypeDefinitionProvider(de,ve){return ut.registerTypeDefinitionProvider(We,pt(de),ve)},registerHoverProvider(de,ve){return ut.registerHoverProvider(We,pt(de),ve,We.identifier)},registerEvaluatableExpressionProvider(de,ve){return ut.registerEvaluatableExpressionProvider(We,pt(de),ve,We.identifier)},registerInlineValuesProvider(de,ve){return ut.registerInlineValuesProvider(We,pt(de),ve,We.identifier)},registerDocumentHighlightProvider(de,ve){return ut.registerDocumentHighlightProvider(We,pt(de),ve)},registerMultiDocumentHighlightProvider(de,ve){return ut.registerMultiDocumentHighlightProvider(We,pt(de),ve)},registerLinkedEditingRangeProvider(de,ve){return ut.registerLinkedEditingRangeProvider(We,pt(de),ve)},registerReferenceProvider(de,ve){return ut.registerReferenceProvider(We,pt(de),ve)},registerRenameProvider(de,ve){return ut.registerRenameProvider(We,pt(de),ve)},registerNewSymbolNamesProvider(de,ve){return(0,et.$xG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,pt(de),ve)},registerDocumentSymbolProvider(de,ve,Ue){return ut.registerDocumentSymbolProvider(We,pt(de),ve,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ve){return ut.registerDocumentFormattingEditProvider(We,pt(de),ve)},registerDocumentRangeFormattingEditProvider(de,ve){return ut.registerDocumentRangeFormattingEditProvider(We,pt(de),ve)},registerOnTypeFormattingEditProvider(de,ve,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,pt(de),ve,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentSemanticTokensProvider(We,pt(de),ve,Ue)},registerDocumentRangeSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,pt(de),ve,Ue)},registerSignatureHelpProvider(de,ve,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,pt(de),ve,Ue):ut.registerSignatureHelpProvider(We,pt(de),ve,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ve,...Ue){return ut.registerCompletionItemProvider(We,pt(de),ve,Ue)},registerInlineCompletionItemProvider(de,ve,Ue){return ve.handleDidShowCompletionItem&&(0,et.$xG)(We,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,et.$xG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$xG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,pt(de),ve,Ue)},registerInlineEditProvider(de,ve){return(0,et.$xG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,pt(de),ve)},registerDocumentLinkProvider(de,ve){return ut.registerDocumentLinkProvider(We,pt(de),ve)},registerColorProvider(de,ve){return ut.registerColorProvider(We,pt(de),ve)},registerFoldingRangeProvider(de,ve){return ut.registerFoldingRangeProvider(We,pt(de),ve)},registerSelectionRangeProvider(de,ve){return ut.registerSelectionRangeProvider(We,de,ve)},registerCallHierarchyProvider(de,ve){return ut.registerCallHierarchyProvider(We,de,ve)},registerTypeHierarchyProvider(de,ve){return ut.registerTypeHierarchyProvider(We,de,ve)},setLanguageConfiguration:(de,ve)=>ut.setLanguageConfiguration(We,de,ve),getTokenInformationAtPosition(de,ve){return(0,et.$xG)(We,"tokenInformation"),qt.tokenAtPosition(de,ve)},registerInlayHintsProvider(de,ve){return ut.registerInlayHintsProvider(We,de,ve)},createLanguageStatusItem(de,ve){return qt.createLanguageStatusItem(We,de,ve)},registerDocumentDropEditProvider(de,ve,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ve,(0,et.$wG)(We,"documentPaste")?Ue:void 0)}},fn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(de,ve,Ue){$.URI.isUri(de)&&de.scheme===M.Schemas.vscodeRemote&&!de.authority&&Rt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(de)?Promise.resolve(Wi.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ve,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ve,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ve,Ue)},onDidChangeVisibleTextEditors(de,ve,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ve,Ue)},onDidChangeTextEditorSelection(de,ve,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ve,Ue)},onDidChangeTextEditorOptions(de,ve,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ve,Ue)},onDidChangeTextEditorVisibleRanges(de,ve,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ve,Ue)},onDidChangeTextEditorViewColumn(de,ve,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ve,Ue)},onDidCloseTerminal(de,ve,Ue){return at(Ct.onDidCloseTerminal)(de,ve,Ue)},onDidOpenTerminal(de,ve,Ue){return at(Ct.onDidOpenTerminal)(de,ve,Ue)},onDidChangeActiveTerminal(de,ve,Ue){return at(Ct.onDidChangeActiveTerminal)(de,ve,Ue)},onDidChangeTerminalDimensions(de,ve,Ue){return(0,et.$xG)(We,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(de,ve,Ue)},onDidChangeTerminalState(de,ve,Ue){return at(Ct.onDidChangeTerminalState)(de,ve,Ue)},onDidWriteTerminalData(de,ve,Ue){return(0,et.$xG)(We,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(de,ve,Ue)},onDidExecuteTerminalCommand(de,ve,Ue){return(0,et.$xG)(We,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(de,ve,Ue)},onDidChangeTerminalShellIntegration(de,ve,Ue){return(0,et.$xG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ve,Ue)},onDidStartTerminalShellExecution(de,ve,Ue){return(0,et.$xG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ve,Ue)},onDidEndTerminalShellExecution(de,ve,Ue){return(0,et.$xG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ve,Ue)},get state(){return jt.getState(We)},onDidChangeWindowState(de,ve,Ue){return at(jt.onDidChangeWindowState)(de,ve,Ue)},showInformationMessage(de,...ve){return Ii.showMessage(We,p.default.Info,de,ve[0],ve.slice(1))},showWarningMessage(de,...ve){return Ii.showMessage(We,p.default.Warning,de,ve[0],ve.slice(1))},showErrorMessage(de,...ve){return Ii.showMessage(We,p.default.Error,de,ve[0],ve.slice(1))},showQuickPick(de,ve,Ue){return bi.showQuickPick(We,de,ve,Ue)},showWorkspaceFolderPick(de){return bi.showWorkspaceFolderPick(de)},showInputBox(de,ve){return bi.showInput(de,ve)},showOpenDialog(de){return Bi.showOpenDialog(We,de)},showSaveDialog(de){return Bi.showSaveDialog(de)},createStatusBarItem(de,ve,Ue){let ct,yt,Mt;return typeof de=="string"?(ct=de,yt=ve,Mt=Ue):(yt=de,Mt=ve),Xi.createStatusBarEntry(We,ct,yt,Mt)},setStatusBarMessage(de,ve){return Xi.setStatusBarMessage(de,ve)},withScmProgress(de){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ni.withProgress(We,{location:Me.ProgressLocation.SourceControl},(ve,Ue)=>de({report(ct){}}))},withProgress(de,ve){return Ni.withProgress(We,de,ve)},createOutputChannel(de,ve){return wi.createOutputChannel(de,ve,We)},createWebviewPanel(de,ve,Ue,ct){return Ci.createWebviewPanel(We,de,ve,Ue,ct)},createWebviewTextEditorInset(de,ve,Ue,ct){return(0,et.$xG)(We,"editorInsets"),Et.createWebviewEditorInset(de,ve,Ue,ct,We)},createTerminal(de,ve,Ue){return typeof de=="object"?"pty"in de?Ct.createExtensionTerminal(de):Ct.createTerminalFromOptions(de):Ct.createTerminal(de,ve,Ue)},registerTerminalLinkProvider(de){return Ct.registerLinkProvider(de)},registerTerminalProfileProvider(de,ve){return Ct.registerProfileProvider(We,de,ve)},registerTerminalQuickFixProvider(de,ve){return(0,et.$xG)(We,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(de,We.identifier.value,ve)},registerTreeDataProvider(de,ve){return lt.registerTreeDataProvider(de,ve,We)},createTreeView(de,ve){return lt.createTreeView(de,ve,We)},registerWebviewPanelSerializer:(de,ve)=>Ci.registerWebviewPanelSerializer(We,de,ve),registerCustomEditorProvider:(de,ve,Ue={})=>Hi.registerCustomEditorProvider(We,de,ve,Ue),registerFileDecorationProvider(de){return It.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vi.registerUriHandler(We,de)},createQuickPick(){return bi.createQuickPick(We)},createInputBox(){return bi.createInputBox(We)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(de,ve,Ue){return at(Oi.onDidChangeActiveColorTheme)(de,ve,Ue)},registerWebviewViewProvider(de,ve,Ue){return Gi.registerWebviewViewProvider(We,de,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return Fe.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ve,Ue){return at(Fe.onDidChangeActiveNotebookEditor)(de,ve,Ue)},get visibleNotebookEditors(){return Fe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Fe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ve,Ue){return at(ee.onDidChangeNotebookEditorSelection)(de,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ve,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(de,ve,Ue)},showNotebookDocument(de,ve){return Fe.showNotebookDocument(de,ve)},registerExternalUriOpener(de,ve,Ue){return(0,et.$xG)(We,"externalUriOpener"),Ji.registerExternalUriOpener(We.identifier,de,ve,Ue)},registerProfileContentHandler(de,ve){return(0,et.$xG)(We,"profileContentHandlers"),Qi.registerProfileContentHandler(We,de,ve)},registerQuickDiffProvider(de,ve,Ue,ct){return(0,et.$xG)(We,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(de),ve,Ue,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider(de,ve){return(0,et.$xG)(We,"shareProvider"),Mi.registerShareProvider(pt(de),ve)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ve,...Ue)=>gt.updateWorkspaceFolders(We,de,ve||0,...Ue),onDidChangeWorkspaceFolders:function(de,ve,Ue){return at(gt.onDidChangeWorkspace)(de,ve,Ue)},asRelativePath:(de,ve)=>gt.getRelativePath(de,ve),findFiles:(de,ve,Ue,ct)=>gt.findFiles(de,ve,Ue,We.identifier,ct),findFiles2:(de,ve,Ue)=>((0,et.$xG)(We,"findFiles2"),gt.findFiles2(de,ve,We.identifier,Ue)),findTextInFiles:(de,ve,Ue,ct)=>{(0,et.$xG)(We,"findTextInFiles");let yt,Mt;return typeof ve=="object"?(yt=ve,Mt=Ue):(yt={},Mt=ve,ct=Ue),gt.findTextInFiles(de,yt||{},Mt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ve){return zi.applyWorkspaceEdit(de,We,ve)},createFileSystemWatcher:(de,ve,Ue,ct)=>{let yt;return typeof ve=="boolean"?yt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ve&&((0,et.$xG)(We,"createFileSystemWatcher"),yt={...ve,correlate:!0}),di.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return kt.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ve;const Ue=de;if(typeof de=="string")ve=Promise.resolve($.URI.file(de));else if($.URI.isUri(de))ve=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ve=kt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ve,Ue)=>at(kt.onDidAddDocument)(de,ve,Ue),onDidCloseTextDocument:(de,ve,Ue)=>at(kt.onDidRemoveDocument)(de,ve,Ue),onDidChangeTextDocument:(de,ve,Ue)=>at(kt.onDidChangeDocument)(de,ve,Ue),onDidSaveTextDocument:(de,ve,Ue)=>at(kt.onDidSaveDocument)(de,ve,Ue),onWillSaveTextDocument:(de,ve,Ue)=>at(Le.getOnWillSaveTextDocumentEvent(We))(de,ve,Ue),get notebookDocuments(){return Fe.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ve){let Ue;if($.URI.isUri(de))Ue=de,await Fe.openNotebookDocument(de);else if(typeof de=="string")Ue=$.URI.revive(await Fe.createNotebookDocument({viewType:de,content:ve}));else throw new Error("Invalid arguments");return Fe.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ve,Ue){return at(ye.onDidSaveNotebookDocument)(de,ve,Ue)},onDidChangeNotebookDocument(de,ve,Ue){return at(ye.onDidChangeNotebookDocument)(de,ve,Ue)},onWillSaveNotebookDocument(de,ve,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ve,Ue)},get onDidOpenNotebookDocument(){return at(Fe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Fe.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ve,Ue,ct){return Fe.registerNotebookSerializer(We,de,ve,Ue,(0,et.$wG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ve,Ue)=>at(Ui.onDidChangeConfiguration)(de,ve,Ue),getConfiguration(de,ve){return ve=arguments.length===1?void 0:ve,Ui.getConfiguration(de,ve,We)},registerTextDocumentContentProvider(de,ve){return $i.registerTextDocumentContentProvider(de,ve)},registerTaskProvider:(de,ve)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(We,de,ve)),registerFileSystemProvider(de,ve,Ue){return(0,R.$Rc)(ri.registerFileSystemProvider(We,de,ve,Ue),Zt.addFileSystemProvider(de,ve,Ue))},get fs(){return Zt.value},registerFileSearchProvider:(de,ve)=>((0,et.$xG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ve)),registerTextSearchProvider:(de,ve)=>((0,et.$xG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ve)),registerAITextSearchProvider:(de,ve)=>((0,et.$xG)(We,"aiTextSearchProvider"),(0,et.$xG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ve)),registerRemoteAuthorityResolver:(de,ve)=>((0,et.$xG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ve)),registerResourceLabelFormatter:de=>((0,et.$xG)(We,"resolvers"),cn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$xG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ve,Ue)=>at(di.onDidCreateFile)(de,ve,Ue),onDidDeleteFiles:(de,ve,Ue)=>at(di.onDidDeleteFile)(de,ve,Ue),onDidRenameFiles:(de,ve,Ue)=>at(di.onDidRenameFile)(de,ve,Ue),onWillCreateFiles:(de,ve,Ue)=>at(di.getOnWillCreateFileEvent(We))(de,ve,Ue),onWillDeleteFiles:(de,ve,Ue)=>at(di.getOnWillDeleteFileEvent(We))(de,ve,Ue),onWillRenameFiles:(de,ve,Ue)=>at(di.getOnWillRenameFileEvent(We))(de,ve,Ue),openTunnel:de=>((0,et.$xG)(We,"tunnels"),Tt.openTunnel(We,de).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,et.$xG)(We,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(de,ve,Ue)=>((0,et.$xG)(We,"tunnels"),at(Tt.onDidChangeTunnels)(de,ve,Ue)),registerPortAttributesProvider:(de,ve)=>((0,et.$xG)(We,"portsAttributes"),Tt.registerPortsAttributesProvider(de,ve)),registerTunnelProvider:(de,ve)=>((0,et.$xG)(We,"tunnelFactory"),Tt.registerTunnelProvider(de,ve)),registerTimelineProvider:(de,ve)=>((0,et.$xG)(We,"timeline"),Ti.registerTimelineProvider(de,ve,We.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$xG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ve,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ve,Ue),registerEditSessionIdentityProvider:(de,ve)=>((0,et.$xG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ve)),onWillCreateEditSessionIdentity:(de,ve,Ue)=>((0,et.$xG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ve,Ue)),registerCanonicalUriProvider:(de,ve)=>((0,et.$xG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ve)),getCanonicalUri:(de,ve,Ue)=>((0,et.$xG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ve,Ue))},tn={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(de,ve,Ue){return Di.createSourceControl(We,de,ve,Ue)}},gn={createCommentController(de,ve){return Li.createCommentController(We,de,ve)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$wG)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(de,ve){return(0,et.$xG)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,de,ve)},registerDebugVisualizationTreeProvider(de,ve){return(0,et.$xG)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,de,ve)},onDidStartDebugSession(de,ve,Ue){return at(Dt.onDidStartDebugSession)(de,ve,Ue)},onDidTerminateDebugSession(de,ve,Ue){return at(Dt.onDidTerminateDebugSession)(de,ve,Ue)},onDidChangeActiveDebugSession(de,ve,Ue){return at(Dt.onDidChangeActiveDebugSession)(de,ve,Ue)},onDidReceiveDebugSessionCustomEvent(de,ve,Ue){return at(Dt.onDidReceiveDebugSessionCustomEvent)(de,ve,Ue)},onDidChangeBreakpoints(de,ve,Ue){return at(Dt.onDidChangeBreakpoints)(de,ve,Ue)},onDidChangeActiveStackItem(de,ve,Ue){return(0,et.$xG)(We,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(de,ve,Ue)},registerDebugConfigurationProvider(de,ve,Ue){return Dt.registerDebugConfigurationProvider(de,ve,Ue||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ve){return Dt.registerDebugAdapterDescriptorFactory(We,de,ve)},registerDebugAdapterTrackerFactory(de,ve){return Dt.registerDebugAdapterTrackerFactory(de,ve)},startDebugging(de,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,ve,{parentSession:Ue}):Dt.startDebugging(de,ve,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,ve){return Dt.asDebugSourceUri(de,ve)}},nn={registerTaskProvider:(de,ve)=>Jt.registerTaskProvider(We,de,ve),fetchTasks:de=>Jt.fetchTasks(de),executeTask:de=>Jt.executeTask(We,de),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(de,ve,Ue)=>at(Jt.onDidStartTask)(de,ve,Ue),onDidEndTask:(de,ve,Ue)=>at(Jt.onDidEndTask)(de,ve,Ue),onDidStartTaskProcess:(de,ve,Ue)=>at(Jt.onDidStartTaskProcess)(de,ve,Ue),onDidEndTaskProcess:(de,ve,Ue)=>at(Jt.onDidEndTaskProcess)(de,ve,Ue)},qi={createNotebookController(de,ve,Ue,ct,yt){return je.createNotebookController(We,de,ve,Ue,ct,(0,et.$wG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ve)=>Fe.registerNotebookCellStatusBarItemProvider(We,de,ve),createRendererMessaging(de){return Ke.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$xG)(We,"notebookKernelSource"),je.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ve){return(0,et.$xG)(We,"notebookKernelSource"),je.registerKernelSourceActionProvider(We,de,ve)},onDidChangeNotebookCellExecutionState(de,ve,Ue){return(0,et.$xG)(We,"notebookCellExecutionState"),at(je.onDidChangeNotebookCellExecutionState)(de,ve,Ue)}},rn={t(...de){if(typeof de[0]=="string"){const ve=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return ei.getMessage(We.identifier.value,{message:ve,args:Ue})}return ei.getMessage(We.identifier.value,de[0])},get bundle(){return ei.getBundle(We.identifier.value)},get uri(){return ei.getBundleUri(We.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(de,ve){return(0,et.$xG)(We,"interactive"),un.registerProvider(We,de,ve)},transferActiveChat(de){return(0,et.$xG)(We,"interactive"),ji.transferActiveChat(de)}},on={getRelatedInformation(de,ve){return(0,et.$xG)(We,"aiRelatedInformation"),Pi.getRelatedInformation(We,de,ve)},registerRelatedInformationProvider(de,ve){return(0,et.$xG)(We,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(We,de,ve)},registerEmbeddingVectorProvider(de,ve){return(0,et.$xG)(We,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(We,de,ve)}},$n={registerChatResponseProvider(de,ve,Ue){return(0,et.$xG)(We,"chatProvider"),Ot.registerLanguageModel(We,de,ve,Ue)},registerChatVariableResolver(de,ve,Ue){return(0,et.$xG)(We,"chatVariableResolver"),Fi.registerVariableResolver(We,de,ve,Ue)},registerMappedEditsProvider(de,ve){return(0,et.$xG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ve)},createChatParticipant(de,ve){return(0,et.$xG)(We,"chatParticipant"),ji.createChatAgent(We,de,ve)},createDynamicChatParticipant(de,ve,Ue,ct){return(0,et.$xG)(We,"chatParticipantAdditions"),ji.createDynamicChatAgent(We,de,ve,Ue,ct)}},bn={get languageModels(){return(0,et.$xG)(We,"languageModels"),Ot.getLanguageModelIds()},onDidChangeLanguageModels:(de,ve,Ue)=>((0,et.$xG)(We,"languageModels"),Ot.onDidChangeProviders(de,ve,Ue)),sendChatRequest(de,ve,Ue,ct){return(0,et.$xG)(We,"languageModels"),Ot.sendChatRequest(We,de,ve,Ue,ct)}},an={registerSpeechProvider(de,ve){return(0,et.$xG)(We,"speech"),Yi.registerProvider(We.identifier,de,ve)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:bn,notebooks:qi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:Me.$RN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$MO,CallHierarchyIncomingCall:Me.$dN,CallHierarchyItem:Me.$cN,CallHierarchyOutgoingCall:Me.$eN,CancellationError:N.$5,CancellationTokenSource:u.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$_M,CodeActionKind:Me.$aN,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$fN,Color:Me.$sN,ColorInformation:Me.$tN,ColorPresentation:Me.$uN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$mN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$nN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$CN,DebugAdapterExecutable:Me.$VN,DebugAdapterInlineImplementation:Me.$YN,DebugAdapterNamedPipeServer:Me.$XN,DebugAdapterServer:Me.$WN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$cO,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$6M,DiagnosticRelatedInformation:Me.$5M,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$RM,DocumentHighlight:Me.$8M,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$9M,DocumentLink:Me.$rN,DocumentSymbol:Me.$$M,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$2N,InlineValueText:Me.$3N,InlineValueVariableLookup:Me.$4N,InlineValueEvaluatableExpression:Me.$5N,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$be,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$eO,FileDecoration2:Me.$eO,FileSystemError:Me.$8N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$9N,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$TN,InlineCompletionItem:Me.$oN,InlineCompletionList:Me.$pN,Hover:Me.$7M,IndentAction:C.IndentAction,Location:Me.$4M,MarkdownString:Me.$gN,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Me.$hN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$SM,ProcessExecution:Me.$AN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$dO,Range:Me.$TM,RelativePattern:Me.$PN,Selection:Me.$UM,SelectionRange:Me.$bN,SemanticTokens:Me.$_N,SemanticTokensBuilder:Me.$$N,SemanticTokensEdit:Me.$aO,SemanticTokensEdits:Me.$bO,SemanticTokensLegend:Me.$0N,ShellExecution:Me.$BN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$jN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$iN,SnippetString:Me.$3M,SourceBreakpoint:Me.$SN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$0M,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$DN,TaskGroup:Me.$zN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$vN,TerminalQuickFixTerminalCommand:Me.$xN,TerminalQuickFixOpener:Me.$wN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$yN,TerminalExitReason:Me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$YM,SnippetTextEdit:Me.$1M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$ON,ThemeIcon:Me.$NN,TreeItem:Me.$EN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$AO,UIKind:Xt.UIKind,Uri:$.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$2M,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$KN,DocumentDropOrPasteEditKind:Me.$LN,DocumentPasteEdit:Me.$MN,InlayHint:Me.$lN,InlayHintLabelPart:Me.$kN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$XM,ResolvedAuthority:Me.$VM,ManagedResolvedAuthority:Me.$WM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$oO,NotebookRange:Me.$gO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$hO,NotebookData:Me.$iO,NotebookRendererScript:Me.$mO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$kO,NotebookCellOutputItem:Me.$jO,NotebookCellStatusBarItem:Me.$lO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$ZM,NotebookKernelSourceAction:Me.$nO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$qO,LinkedEditingRanges:Me.$pO,TestResultState:Me.TestResultState,TestRunRequest:Me.$rO,TestMessage:Me.$sO,TestTag:Me.$tO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:Me.$JN,DataTransferItem:Me.$FN,TestCoverageCount:Me.$uO,FileCoverage:Me.$wO,StatementCoverage:Me.$xO,BranchCoverage:Me.$yO,DeclarationCoverage:Me.$zO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$BO,TabInputTextDiff:Me.$CO,TabInputTextMerge:Me.$DO,TabInputCustom:Me.$EO,TabInputNotebook:Me.$GO,TabInputNotebookDiff:Me.$HO,TabInputWebview:Me.$FO,TabInputTerminal:Me.$IO,TabInputInteractiveWindow:Me.$JO,TabInputChat:Me.$KO,TabInputTextMultiDiff:Me.$LO,TelemetryTrustedValue:a.$_o,LogLevel:l.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$ZN,Thread:Me.$1N,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$NO,ChatResponseFileTreePart:Me.$QO,ChatResponseAnchorPart:Me.$RO,ChatResponseProgressPart:Me.$SO,ChatResponseReferencePart:Me.$UO,ChatResponseTextEditPart:Me.$VO,ChatResponseMarkdownWithVulnerabilitiesPart:Me.$OO,ChatResponseCommandButtonPart:Me.$TO,ChatResponseDetectedParticipantPart:Me.$PO,ChatRequestTurn:Me.$WO,ChatResponseTurn:Me.$XO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$YO,LanguageModelChatUserMessage:Me.$ZO,LanguageModelChatAssistantMessage:Me.$1O,LanguageModelSystemMessage:Me.$YO,LanguageModelUserMessage:Me.$ZO,LanguageModelAssistantMessage:Me.$1O,LanguageModelError:Me.$2O,NewSymbolName:Me.$7N,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$3O,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[379],Ee([1,0,84,157,44,151,45,33,72,43,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c,h,s,w,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(h.$nlc,h.$mlc,1),(0,u.$os)(g.$Xj,t.$Amc,1),(0,u.$os)(l.$skc,l.$tkc,1),(0,u.$os)(p.$yP,p.$xP,0),(0,u.$os)(w.$Ckc,w.$Dkc,0),(0,u.$os)(d.$hlc,d.$ilc,0),(0,u.$os)(M.$Rkc,M.$Pkc,0),(0,u.$os)(a.$Tkc,a.$Skc,0),(0,u.$os)(C.$xlc,C.$Blc,0),(0,u.$os)(R.$Dlc,R.$Clc,0),(0,u.$os)($.$nP,$.$mP,0),(0,u.$os)(s.$olc,s.$plc,0),(0,u.$os)(n.$wkc,n.$vkc,0),(0,u.$os)(N.$9lc,N.$8lc,1),(0,u.$os)(m.$Tlc,m.$Ulc,0),(0,u.$os)(y.$alc,y.$_kc,0),(0,u.$os)(A.$jmc,A.$imc,0),(0,u.$os)(S.$dlc,S.$glc,0),(0,u.$os)(D.$kmc,D.$lmc,0),(0,u.$os)(v.$NCb,v.$OCb,0),(0,u.$os)(f.$ymc,f.$xmc,0),(0,u.$os)(L.$Okc,L.$Nkc,0),(0,u.$os)(i.$klc,i.$jlc,0),(0,u.$os)(r.$wP,r.$tP,0),(0,u.$os)(o.$4kc,o.$5kc,0),(0,u.$os)(c.$vlc,c.$wlc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0,e.$Qmc=M,e.$Rmc=p;function M(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function p(C,m,y,v){const l=(0,u.$2b)(y,$),f=new L.$9K(m,l,v),a=f.preview.matches;return{ranges:(0,u.$2b)(l,S),uri:C,preview:{text:f.preview.text,matches:(0,u.$2b)(a,S)}}}function $(C){return new L.$0K(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new R.$XK(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor(m,y){this.a=m,this.b=y}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Smc=A,e.$Smc=A=Je([qe(1,N.$Wj)],A)}),define(ke[380],Ee([1,0,53,17,76,34,11,14,122,381]),function(le,e,u,N,L,R,M,p,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=C,e.$Umc=f,e.$Vmc=n;const A=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,r,o,t){const g=m(i,r,o,t),c=r.folder.fsPath;return{cmd:u.spawn(A,g.args,{cwd:c}),rgDiskPath:A,siblingClauses:g.siblingClauses,rgArgs:g,cwd:c}}function m(i,r,o,t){const g=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],o,!1).forEach(h=>{const s=(0,$.$Qmc)(h);if(g.push("-g",s),M.$j){const w=(0,L.$9l)(s);w!==s&&g.push("-g",w)}});const c=y([r],t,void 0,!1);return c.globArgs.forEach(h=>{const s=`!${(0,$.$Qmc)(h)}`;if(g.push("-g",s),M.$j){const w=(0,L.$9l)(s);w!==s&&g.push("-g",w)}}),r.disregardIgnoreFiles!==!1?g.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&g.push("--no-ignore-parent"),r.ignoreSymlinks||g.push("--follow"),i.exists&&g.push("--quiet"),g.push("--no-config"),r.disregardGlobalIgnoreFiles&&g.push("--no-ignore-global"),{args:g,siblingClauses:c.siblingClauses}}function y(i,r,o,t=!0){const g=[];let c={};return i.forEach(h=>{const s=Object.assign({},h.excludePattern||{},r||{}),w=l(s,t?h.folder.fsPath:void 0,o);g.push(...w.globArgs),w.siblingClauses&&(c=Object.assign(c,w.siblingClauses))}),{globArgs:g,siblingClauses:c}}function v(i,r,o=!0){const t=[];return i.forEach(g=>{const c=Object.assign({},r||{},g.includePattern||{}),h=l(c,o?g.folder.fsPath:void 0);t.push(...h.globArgs)}),t}function l(i,r,o){const t=[],g={};return Object.keys(i).forEach(c=>{if(o&&o.has(c)||!c)return;const h=i[c];c=a(r?f(r,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof h=="boolean"&&h?(c.startsWith("\\\\")&&(c+="**"),t.push(n(c))):h&&h.when&&(g[c]=h)}),{globArgs:t,siblingClauses:g}}function f(i,r){return N.$jc(r)?r:N.$kc(i,r)}function a(i){return i=p.$bf(i,"\\"),p.$bf(i,"/")}function n(i){return R.$mg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[382],Ee([1,0,53,52,17,383,19,47,35,76,34,11,40,14,18,31,36,380,132]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(c=>c())});class r{constructor(h){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=h,this.b=h.filePattern||"",this.d=h.includePattern&&$.$kk(h.includePattern),this.f=h.maxResults||null,this.g=!!h.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=h.shouldGlobMatchFilePattern?null:(0,n.$pr)(this.b).normalizedLowercase),this.u=h.excludePattern&&$.$kk(h.excludePattern),this.t=new Map,h.folderQueries.forEach(s=>{const w=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),d=s.folder.fsPath;h.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==d).forEach(D=>{(0,A.$qg)(D,d)&&(w[L.$mc(d,D)]=!0)}),this.t.set(d,new t(w,d))})}cancel(){this.l=!0,i.forEach(h=>h())}walk(h,s,w,d,D){if(this.m=m.$0d.create(!1),this.l)return D(null,this.j);s.forEach(b=>{const E=L.$oc(b.fsPath);this.u&&this.u(b.fsPath,E)||this.J(w,{relativePath:b.fsPath,searchPath:void 0})}),this.r=m.$0d.create(!1),this.w(h,(b,E)=>{this.x(this.y,this,b,w,d,k=>{if(k){const P=(0,p.$bj)(k);console.error(P),this.q.push(P),E(k,void 0)}else E(null,void 0)})},(b,E)=>{this.m.stop();const k=b?M.$Hb(b)[0]:null;D(k,this.j)})}w(h,s,w){const d=new Array(h.length),D=new Array(h.length);let b=!1,E=0;if(h.length===0)return w(null,[]);h.forEach((k,P)=>{s(k,(I,j)=>{if(I?(b=!0,d[P]=null,D[P]=I):(d[P]=j,D[P]=null),++E===h.length)return w(b?D:null,d)})})}x(h,s,...w){try{h.apply(s,w)}catch(d){w[w.length-1](d)}}y(h,s,w,d){const D=h.folder.fsPath,b=C.$j,E=()=>F&&F.kill();i.add(E);let k=B=>{i.delete(E),k=()=>{},d(B)},P="";const I=this.D(),j=(0,a.$Tmc)(this.a,h,this.a.includePattern,this.t.get(h.folder.fsPath).expression),F=j.cmd,z=!Object.keys(j.siblingClauses).length,O=j.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${j.rgDiskPath} ${O}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),w({message:T}),this.s=0,this.z(F,"utf8",w,(B,W,X)=>{if(B){k(B);return}if(this.j){k();return}const Y=(P+(b?S.$8l(W||""):W)).split(`
`);if(X){const Z=Y.length;Y[Z-1]=Y[Z-1].trim(),Y[Z-1]||Y.pop()}else P=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Y.length,z){for(const Z of Y)if(this.J(s,{base:D,relativePath:Z,searchPath:this.N(h,Z)}),this.j){E();break}(X||this.j)&&k();return}this.G(h,I,D,Y,s),X&&(this.H(I,D,s),k())})}spawnFindCmd(h){const s=this.t.get(h.folder.fsPath),w=s.getBasenameTerms(),d=s.getPathTerms(),D=["-L","."];if(w.length||d.length){D.push("-not","(","(");for(const b of w)D.push("-name",b),D.push("-o");for(const b of d)D.push("-path",b),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:h.folder.fsPath})}readStdout(h,s,w){let d="";this.z(h,s,()=>{},(D,b,E)=>{if(D){w(D);return}d+=b,E&&w(null,d)})}z(h,s,w,d){let D=(k,P,I)=>{(k||I)&&(D=()=>{},this.r?.stop()),d(k,P,I)},b=!1;h.stdout?(this.A(h.stdout,s,D),h.stdout.once("data",()=>b=!0)):w({message:"stdout is null"});let E;h.stderr?E=this.B(h.stderr):w({message:"stderr is null"}),h.on("error",k=>{D(k)}),h.on("close",k=>{let P;!b&&(P=this.C(E,s))&&g(P)?D(new Error(`command failed with error code ${k}: ${this.C(E,s)}`)):(this.g&&k===0&&(this.j=!0),D(null,"",!0))})}A(h,s,w){const d=new R.StringDecoder(s);return h.on("data",D=>{w(null,d.write(D))}),d}B(h){const s=[];return h.on("data",w=>{s.push(w)}),s}C(h,s){const w=new R.StringDecoder(s);return h.map(d=>w.write(d)).join("")}D(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}G(h,{pathToEntries:s},w,d,D){d.indexOf(this.b)!==-1&&this.J(D,{base:w,relativePath:this.b,searchPath:this.N(h,this.b)});const b=E=>{const k=L.$oc(E),P=L.$nc(E);let I=s[P];I||(I=s[P]=[],b(P)),I.push({base:w,relativePath:E,basename:k,searchPath:this.N(h,E)})};d.forEach(b)}H({rootEntries:h,pathToEntries:s},w,d){const D=this,b=this.t.get(w),E=this.b;function k(P){D.o++;const I=(0,f.$mL)(()=>P.map(j=>j.basename));for(let j=0,F=P.length;j<F;j++){const z=P[j],{relativePath:O,basename:T}=z;if(b.test(O,T,E!==T?I:void 0))continue;const B=s[O];if(B)k(B);else{if(D.p++,O===E)continue;D.J(d,z)}if(D.j)break}}k(h)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(h,s,w,d,D){const b=h.folder,E=(0,f.$mL)(()=>w);this.w(w,(k,P)=>{if(this.l||this.j)return P(null);const I=s?[s,k].join(L.sep):k;if(this.t.get(h.folder.fsPath).test(I,k,this.a.filePattern!==k?E:void 0))return P(null);const j=[b.fsPath,I].join(L.sep);N.lstat(j,(F,z)=>{if(F||this.l||this.j)return P(null);this.L(j,z,(O,T)=>O||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(j,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?P(null):(this.v[W]=!0,l.Promises.readdir(j).then(X=>{if(this.l||this.j)return P(null);this.I(h,I,X,d,x=>P(x||null))},X=>{P(null)})))):(this.p++,I===this.b||this.h&&v.$8f(T.size)&&T.size>this.h||this.J(d,{base:b.fsPath,relativePath:I,searchPath:this.N(h,I)}),P(null,void 0)))})},k=>{const P=k&&M.$Hb(k);return D(P&&P.length>0?P[0]:void 0)})}J(h,s){this.K(s)&&(!this.d||this.d(s.relativePath,L.$oc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||h(s))}K(h){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$hL)(h,this.c);if(this.b)return(0,f.$hL)(h,this.b,!1)}return!0}L(h,s,w){return s.isSymbolicLink()?N.stat(h,w):w(null,s)}M(h,s,w){return s.isSymbolicLink()?N.realpath(h,(d,D)=>d?w(d):w(null,D)):w(null,h)}N(h,s){return h.folderName?L.$kc(h.folderName,s):s}}e.$Wmc=r;class o{constructor(h){this.a=h.folderQueries,this.b=h.extraFileResources||[],this.c=new r(h)}search(h,s,w){this.c.walk(this.a,this.b,h,s,(d,D)=>{w(d,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Xmc=o;class t{constructor(h,s){this.expression=h,this.c=s,this.d(h)}d(h){let s,w;Object.keys(h).filter(d=>h[d]).forEach(d=>{L.$jc(d)?(s=s||$.$fk(),s[d]=h[d]):(w=w||$.$fk(),w[d]=h[d])}),this.a=s&&$.$kk(s,{trimForExclusions:!0}),this.b=w&&$.$kk(w,{trimForExclusions:!0})}test(h,s,w){return this.b&&this.b(h,s,w)||this.a&&this.a(L.$kc(this.c,h),s,w)}getBasenameTerms(){const h=[];return this.a&&h.push(...$.$mk(this.a)),this.b&&h.push(...$.$mk(this.b)),h}getPathTerms(){const h=[];return this.a&&h.push(...$.$nk(this.a)),this.b&&h.push(...$.$nk(this.b)),h}}function g(c){const h=c.trim().split(`
`),s=h[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.$Vf(h[h.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ke[384],Ee([1,0,98,21,193,22]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=e.$ZD=e.DecodeStreamErrorKind=e.$YD=e.$XD=e.$WD=e.$UD=e.$TD=e.$SD=e.$RD=void 0,e.$VD=M,e.$1D=v,e.$2D=l,e.$3D=f,e.$4D=a,e.$5D=n,e.$6D=c,e.$7D=h,e.$RD="utf8",e.$SD="utf8bom",e.$TD="utf16be",e.$UD="utf16le";function M(s){return[e.$RD,e.$SD,e.$TD,e.$UD].some(w=>w===s)}e.$WD=[254,255],e.$XD=[255,254],e.$YD=[239,187,191];const p=512,$=512,S=512*8,A=512*128;var C;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(w,d){super(w),this.decodeStreamErrorKind=d}}e.$ZD=m;class y{static async create(w){let d;if(w!==e.$RD)d=(await(0,L.$QD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(w));else{const D=new TextDecoder;d={write(b){return D.decode(b,{stream:!0})},end(){return D.decode()}}}return new y(d)}constructor(w){this.a=w}write(w){return this.a.write(w)}end(){return this.a.end()}}function v(s,w){const d=w.minBytesRequiredForDetection??w.guessEncoding?S:$;return new Promise((D,b)=>{const E=(0,u.$qe)(z=>z.join("")),k=[];let P=0,I;const j=new R.$me,F=async()=>{try{const z=await h({buffer:N.$Ce.concat(k),bytesRead:P},w.guessEncoding);if(z.seemsBinary&&w.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);z.encoding=await w.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const O=I.write(N.$Ce.concat(k).buffer);E.write(O),k.length=0,P=0,D({stream:E,detected:z})}catch(z){j.cancel(),E.destroy(),b(z)}};(0,u.$ue)(s,{onData:async z=>{I?E.write(I.write(z.buffer)):(k.push(z),P+=z.byteLength,P>=d&&(s.pause(),await F(),setTimeout(()=>s.resume())))},onError:z=>E.error(z),onEnd:async()=>{I||await F(),E.end(I?.end())}},j.token)})}async function l(s,w,d){const b=(await(0,L.$QD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(w),d);let E=!1,k=!1;return{read(){if(k)return null;const P=s.read();if(typeof P!="string"){if(k=!0,!E&&d?.addBOM)switch(w){case e.$RD:case e.$SD:return N.$Ce.wrap(Uint8Array.from(e.$YD));case e.$TD:return N.$Ce.wrap(Uint8Array.from(e.$WD));case e.$UD:return N.$Ce.wrap(Uint8Array.from(e.$XD))}const I=b.end();return I&&I.length>0?(E=!0,N.$Ce.wrap(I)):null}return E=!0,N.$Ce.wrap(b.write(P))}}}async function f(s){return(await(0,L.$QD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(s))}function a(s){return s===e.$SD||s===null?e.$RD:s}function n(s,w){if(!s||w<e.$WD.length)return null;const d=s.readUInt8(0),D=s.readUInt8(1);if(d===e.$WD[0]&&D===e.$WD[1])return e.$TD;if(d===e.$XD[0]&&D===e.$XD[1])return e.$UD;if(w<e.$YD.length)return null;const b=s.readUInt8(2);return d===e.$YD[0]&&D===e.$YD[1]&&b===e.$YD[2]?e.$SD:null}const i=["ascii","utf-16","utf-32"];async function r(s){const w=await(0,L.$QD)("jschardet","dist/jschardet.min.js"),d=s.slice(0,A),D=g(d.buffer),b=w.detect(D);if(!b||!b.encoding)return null;const E=b.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(b.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const w=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[w]||w}function g(s){let w="";for(let d=0;d<s.length;d++)w+=String.fromCharCode(s[d]);return w}function c(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const w=s.match(/windows(\d+)/);return w?"windows-"+w[1]:s}}}function h({buffer:s,bytesRead:w},d){let D=n(s,w),b=!1;if(D!==e.$TD&&D!==e.$UD&&s){let E=!0,k=!0,P=!1;for(let I=0;I<w&&I<p;I++){const j=I%2===1,F=s.readUInt8(I)===0;if(F&&(P=!0),E&&(j&&!F||!j&&F)&&(E=!1),k&&(j&&F||!j&&!F)&&(k=!1),F&&!E&&!k)break}P&&(E?D=e.$UD:k?D=e.$TD:b=!0)}return d&&!b&&!D&&s?r(s.slice(0,w)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:b,encoding:D}}e.$8D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,384,31,159]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class R extends L.$Plc{constructor(p,$,S=N,A="searchProcess"){super({query:p,provider:$},{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,u.$6D)(C)},A)}}e.$6mc=R}),define(ke[161],Ee([1,0,53,400,383,19,73,35,14,2,36,94,401,381,122]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0,e.$1mc=t,e.$2mc=c,e.$3mc=s,e.$4mc=w,e.$5mc=D;const l=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(E){this.a=E}provideTextSearchResults(E,k,P,I){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((j,F)=>{I.onCancellationRequested(()=>Y());const z=t(E,k),O=k.folder.fsPath,T=z.map(Se=>Se.match(/^-/)?Se:`'${Se}'`).join(" ");this.a.appendLine(`${l} ${T}
 - cwd: ${O}`);let B=u.spawn(l,z,{cwd:O});B.on("error",Se=>{console.error(Se),this.a.appendLine("Error: "+(Se&&Se.message)),F((0,A.$dL)(new A.$bL(Se&&Se.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const X=new i(k.maxResults,k.folder,k.previewOptions);X.on("result",Se=>{W=!0,ue="",P.report(Se)});let x=!1;const Y=()=>{x=!0,B?.kill(),X?.cancel()};let Z=!1;X.on("hitLimit",()=>{Z=!0,Y()});let ue="";B.stdout.on("data",Se=>{X.handleData(Se),W||(ue+=Se)});let te=!1;B.stdout.once("data",()=>te=!0);let we="";B.stderr.on("data",Se=>{const _=Se.toString();this.a.appendLine(_),we.length+_.length<1e6&&(we+=_)}),B.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),x)j({limitHit:Z});else{X.flush(),B=null;let Se;we&&!te&&(Se=a(we))?F((0,A.$dL)(new A.$bL(Se.message,Se.code))):j({limitHit:Z})}})})}}e.$Ymc=f;function a(b){const E=b.split(`
`),k=E[0].trim();if(E.some(I=>I.startsWith("regex parse error")))return new A.$bL(n(E),A.SearchErrorCode.regexParseError);const P=k.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.$bL(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new A.$bL(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new A.$bL(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new A.$bL(k,A.SearchErrorCode.regexParseError)}function n(b){const E=["Regex parse error"],k=b.filter(P=>P.startsWith("PCRE2:"));if(k.length>=1){const P=k[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];E.push(":"+I)}}return E.join("")}class i extends N.EventEmitter{constructor(E,k,P){super(),this.g=E,this.h=k,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,k){return super.on(E,k),this}handleData(E){if(this.b)return;const k=typeof E=="string"?E:this.d.write(E);this.k(k)}k(E){let k=E.indexOf(`
`);const P=this.a+E;if(k>=0)k+=this.a.length;else{this.a=P;return}let I=0;for(;k>=0;)this.m(P.substring(I,k).trim()),I=k+1,k=P.indexOf(`
`,I);this.a=P.substring(I)}m(E){if(this.b||!E)return;let k;try{k=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(k.type==="match"){const P=r(k.data.path),I=S.URI.joinPath(this.h,P),j=this.n(k.data,I);this.p(j),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const P=r(k.data.path),I=S.URI.joinPath(this.h,P);this.o(k.data,I).forEach(F=>this.p(F))}}n(E,k){const P=E.line_number-1,I=r(E.lines),j=Buffer.from(I);let F=0,z=0,O=P;E.submatches.length===0&&E.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(E.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=r(B.match),x=j.slice(F,B.start).toString(),Y=o(x),Z=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+z,ue=o(X),te=Y.numLines+O,we=ue.numLines+te,Se=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+Z;return F=B.end,z=Se,O=we,new C.$XK(te,Z,we,Se)}));return(0,v.$Rmc)(k,I,T,this.j)}o(E,k){const P=r(E.lines),I=E.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((j,F)=>({text:j,uri:k,lineNumber:I+F}))}p(E){this.emit("result",E)}}e.$Zmc=i;function r(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function o(b){const E=/\n/g;let k=0,P=-1,I;for(;I=E.exec(b);)k++,P=I.index;const j=P>=0?b.length-P-1:b.length;return{numLines:k,lastLineLength:j}}function t(b,E){const k=["--hidden","--no-require-git"];k.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,M.$K)(E.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const F=new Set;I.forEach(z=>{F.add(z)}),k.push("-g","!*"),F.forEach(z=>{g(z).map(v.$Qmc).forEach(O=>{k.push("-g",O)})})}P&&P.length&&P.forEach(F=>{k.push("-g",F)}),E.excludes.map(v.$Qmc).forEach(F=>k.push("-g",`!${F}`)),E.maxFileSize&&k.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),E.followSymlinks&&k.push("--follow"),E.encoding&&E.encoding!=="utf8"&&k.push("--encoding",E.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,$.$8e)(b.pattern),b.isRegExp=!0),E.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),b.isRegExp&&(b.pattern=c(b.pattern),k.push("--engine","auto"));let j;if(b.isWordMatch){const z=(0,$.$ef)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",z)}else if(b.isRegExp){let F=s(b.pattern);F=w(F),k.push("--regexp",F)}else j=b.pattern,k.push("--fixed-strings");return k.push("--no-config"),E.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),b.isMultiline&&k.push("--multiline"),E.beforeContext&&k.push("--before-context",E.beforeContext+""),E.afterContext&&k.push("--after-context",E.afterContext+""),k.push("--"),j&&k.push(j),k.push("."),k}function g(b){return D(b).flatMap(k=>{const P=(0,p.$ik)(k,"/");return P.map((I,j)=>P.slice(0,j+1).join("/"))})}function c(b){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(E);)b=b.replace(E,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(k);)b=b.replace(k,"$1\\x{$2}");return b}const h=b=>b.type==="Assertion"&&b.kind==="lookbehind";function s(b){let E;try{E=new m.RegExpParser().parsePattern(b)}catch{return b}let k="",P=0;const I=(z,O,T)=>{k+=b.slice(P,z)+T,P=O},j=[];return new m.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=j[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!j.some(h))if(O.type==="CharacterClass")if(O.negate){const T=b.slice(O.start+2,z.start)+b.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=b.slice(O.start+1,z.start)+b.slice(z.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){j.unshift(z)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(z){j.unshift(z)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(z){j.unshift(z)},onCharacterClassLeave(){j.shift()},onAssertionEnter(z){h(z)&&j.push(z)},onAssertionLeave(z){j[0]===z&&j.shift()}}).visit(E),k+=b.slice(P),k}function w(b){return b.replace(/\n/g,"\\r?\\n")}function d(b){let E=!1,k=!1,P="",I="";for(let j=0;j<b.length;j++){const F=b[j];switch(F){case"\\":k?(E?I+="\\"+F:P+="\\"+F,k=!1):k=!0;break;case"{":if(k)E?I+=F:P+=F,k=!1;else{if(E)return{strInBraces:P+"{"+I+"{"+b.substring(j+1)};E=!0}break;case"}":if(k)E?I+=F:P+=F,k=!1;else{if(E)return{fixedStart:P,strInBraces:I,fixedEnd:b.substring(j+1)};P+=F}break;default:E?I+=(k?"\\":"")+F:P+=(k?"\\":"")+F,k=!1;break}}return{strInBraces:P+(E?"{"+I:"")}}function D(b){const{fixedStart:E,strInBraces:k,fixedEnd:P}=d(b);if(E===void 0||P===void 0)return[k];let I=(0,p.$ik)(k,",");I.length||(I=[""]);const j=D(P);return I.flatMap(F=>{const z=E+F;return j.map(O=>z+O)})}}),define(ke[385],Ee([1,0,22,161,108,15]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class M{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,A,C,m){const y=new N.$Ymc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},l=new L.$Zv(f=>C.report({...f,uri:f.uri.with({scheme:A.folder.scheme})}));return this.c(m,f=>y.provideTextSearchResults(S,v,l,f))}else return this.c(m,v=>y.provideTextSearchResults(S,A,C,v))}async c(S,A){const C=p(S);this.a.add(C);const m=await A(C.token);return this.a.delete(C),m}d(){this.a.forEach(S=>S.cancel())}}e.$9mc=M;function p($){const S=new u.$me;return $.onCancellationRequested(()=>S.cancel()),S}}),define(ke[386],Ee([1,0,31,161,160]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class R{constructor($){this.a=$}search($,S,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(y){A({message:y})}},m=new L.$6mc(this.a,new N.$Ymc(C),u);return new Promise((y,v)=>m.search(l=>{S(l.map(M))},$).then(l=>y({limitHit:l.limitHit,type:"success",stats:l.stats}),v))}}e.$7mc=R;function M(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce(($,S)=>{if(S.ranges){const A=S;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(ke[387],Ee([1,0,19,8,13,4,132,17,40,2,32,36,382,386]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let o;const t=a(r),g=new R.$be({onDidAddFirstListener:()=>{o=(0,N.$dh)(c=>this.doFileSearchWithEngine(m.$Xmc,t,h=>g.fire(h),c)),o.then(c=>g.fire(c),c=>g.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return g.event}textSearch(r){let o;const t=a(r),g=new R.$be({onDidAddFirstListener:()=>{o=(0,N.$dh)(c=>this.f(t,h=>g.fire(h),c)),o.then(c=>g.fire(c),c=>g.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return g.event}f(r,o,t){return r.maxFileSize=this.g().maxFileSize,new y.$7mc(r).search(t,o,o)}g(){return{maxFileSize:16*A.$sl.GB}}doFileSearch(r,o,t){return this.doFileSearchWithEngine(m.$Xmc,r,o,t)}doFileSearchWithEngine(r,o,t,g,c=v.a){let h=0;const s=d=>{Array.isArray(d)?(h+=d.length,t(d.map(D=>this.h(D)))):d.relativePath?(h++,t(this.h(d))):t(d)};if(o.sortByScore){let d=this.l(o,s,g);if(!d){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,b=new r(D);d=this.j(b,o,t,s,g)}return new Promise((D,b)=>{d.then(([E,k])=>{const P=k.map(I=>this.h(I));this.o(P,t,c),D(E)},b)})}const w=new r(o);return this.r(w,s,c,g).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:this.d,fromCache:!1,resultCount:h,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$kc)(r.base,r.relativePath):r.relativePath}}j(r,o,t,g,c){const h=new R.$be;let s=(0,N.$dh)(d=>{let D=[];const b=E=>{Array.isArray(E)?D=E:(g(E),h.fire(E))};return this.r(r,b,-1,d).then(E=>[E,D])}),w;if(o.cacheKey){w=this.k(o.cacheKey);const d={promise:s,event:h.event,resolved:!1};w.resultsToSearchCache[o.filePattern||""]=d,s.then(()=>{d.resolved=!0},D=>{delete w.resultsToSearchCache[o.filePattern||""]}),s=this.s(s)}return s.then(([d,D])=>{const b=w?w.scorerCache:Object.create(null),E=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$0d.create(!1);return this.n(o,D,b,c).then(k=>{const P=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:k.length},messages:d.messages,limitHit:d.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},k]})})}k(r){const o=this.b[r];return o||(this.b[r]=new l)}l(r,o,t){const g=r.cacheKey&&this.b[r.cacheKey];if(!g)return;const c=this.q(g,r.filePattern||"",o,t);if(c)return c.then(([h,s,w])=>{const d=$.$0d.create(!1);return this.n(r,s,g.scorerCache,t).then(D=>{const b=d.elapsed(),E={fromCache:!0,detailStats:w,type:this.d,resultCount:s.length,sortingTime:b};return[{type:"success",limitHit:h.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults,stats:E},D]})})}n(r,o,t,g){const c=(0,M.$pr)(r.filePattern||""),h=(w,d)=>(0,M.$or)(w,d,c,!0,f,t),s=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(o,h,s,1e4,g)}o(r,o,t){if(t&&t>0)for(let g=0;g<r.length;g+=t)o(r.slice(g,g+t));else o(r)}q(r,o,t,g){const c=$.$0d.create(!1),h=o.indexOf(p.sep)>=0;let s;for(const b in r.resultsToSearchCache)if(o.startsWith(b)){if(h&&b.indexOf(p.sep)<0&&b!=="")continue;const E=r.resultsToSearchCache[b];s={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!s)return null;const w=c.elapsed(),d=$.$0d.create(!1),D=s.event(t);return g&&g.onCancellationRequested(()=>{D.dispose()}),s.promise.then(([b,E])=>{if(g&&g.isCancellationRequested)throw(0,L.$6)();const k=[],P=(0,M.$pr)(o).normalizedLowercase;for(const I of E)(0,C.$hL)(I,P)&&k.push(I);return[b,k,{cacheWasResolved:s.resolved,cacheLookupTime:w,cacheFilterTime:d.elapsed(),cacheEntryCount:E.length}]})}r(r,o,t,g){return new Promise((c,h)=>{let s=[];g?.onCancellationRequested(()=>r.cancel()),r.search(w=>{w&&(t?(s.push(w),t>0&&s.length>=t&&(o(s),s=[])):o(w))},w=>{o(w)},(w,d)=>{s.length&&o(s),w?(o({message:"Search finished. Error: "+w.message}),h(w)):(o({message:"Search finished. Stats: "+JSON.stringify(d.stats)}),c(d))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return r.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return r.finally(o)}}}}e.$8mc=v;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(i){return(0,p.$oc)(i.relativePath)}getItemDescription(i){return(0,p.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>S.URI.revive(r))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[388],Ee([1,0,3,15,2,31,12,28,20,97,67,36,387,385,122,160]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;let f=class extends S.$Ulc{constructor(n,i,r,o){super(n,r,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$Smc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new y.$9mc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$Smc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new y.$9mc(n))),this.A.add(this.C(N.Schemas.file,new m.$8mc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,o){const t=(0,S.$Vlc)(r);if(n===this.x){const g=Date.now();return this.D(n,i,t,o).then(c=>{const h=Date.now()-g;return this.q.debug(`Ext host file search time: ${h}ms`),c})}return super.$provideFileSearchResults(n,i,r,o)}doInternalFileSearchWithCustomCallback(n,i,r){const o=t=>{if((0,C.$gL)(t)&&(t=[t]),Array.isArray(t)){r(t.map(g=>L.URI.file(g.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,r,o){return this.doInternalFileSearchWithCustomCallback(r,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new l.$6mc(n,i,void 0,"textSearchProvider")}};e.$0mc=f,e.$0mc=f=Je([qe(0,$.$cP),qe(1,p.$sP),qe(2,A.$Lkc),qe(3,M.$Wj)],f)}),define(ke[123],Ee([1,0,402,63,64,403,21,13,4,3,17,11,30,81,82]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=c,e.$ji=h,e.$li=d,e.$mi=D;class l{traceSocketEvent(E,k){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,k)}constructor(E,k=""){this.f=!0,this.debugLabel=k,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,p.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const k=P=>{this.traceSocketEvent("read",P),E(M.$Ce.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(E){const k=P=>{E({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(E){const k=()=>{E()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,p.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$fi=l;var f;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(a||(a={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,k){this.socket.traceSocketEvent(E,k)}constructor(E,k,P,I){super(),this.f=this.B(new $.$be),this.g=this.B(new $.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,k,P,I,this.f,(j,F)=>this.m(j,F))),this.B(this.a.onError(j=>{console.error(j),(0,p.$1)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new v.$ai,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let k=0;for(;k<E.byteLength;)this.a.writeMessage(E.slice(k,Math.min(k+262144,E.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(E,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let I=2;E.byteLength<126?I+=0:E.byteLength<2**16?I+=2:I+=8;const j=M.$Ce.alloc(I),F=k?64:0,z=P&15;if(j.writeUInt8(128|F|z,0),E.byteLength<126)j.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){j.writeUInt8(126,1);let O=1;j.writeUInt8(E.byteLength>>>8&255,++O),j.writeUInt8(E.byteLength>>>0&255,++O)}else{j.writeUInt8(127,1);let O=1;j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(E.byteLength>>>24&255,++O),j.writeUInt8(E.byteLength>>>16&255,++O),j.writeUInt8(E.byteLength>>>8&255,++O),j.writeUInt8(E.byteLength>>>0&255,++O)}this.socket.write(M.$Ce.concat([j,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),I=(P&128)>>>7,j=(P&64)>>>6,F=P&15,z=k.readUInt8(1),O=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),I=(P&128)>>>7;let j=P&127,F=1;j===126?j=k.readUInt8(++F)*2**8+k.readUInt8(++F):j===127&&(j=k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F));let z=0;I&&(z=k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Ce.alloc(0)}constructor(E,k,P,I,j,F){super(),this.n=E,this.r=j,this.s=F,this.a=this.B(new $.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,I,P,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,k){this.g.push({data:E,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,E);this.s(P,k)}else this.s(E,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,k){return new Promise((P,I)=>{E.write(k),E.flush(j=>P(j))})}acceptFrame(E,k,P){this.h.push({data:E,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const k=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,k,P){return new Promise((I,j)=>{E.write(k),P&&E.write(M.$Ce.fromByteArray([0,0,255,255])),E.flush(F=>I(F))})}}class r extends S.$Uc{get recordedInflateBytes(){return this.j?M.$Ce.concat(this.f):M.$Ce.alloc(0)}constructor(E,k,P,I){super(),this.h=E,this.j=k,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(M.$Ce.wrap(j))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=M.$Ce.concat(this.g);this.g.length=0,E(k)})}}class o extends S.$Uc{constructor(E,k){super(),this.g=E,this.a=this.B(new $.$be),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(M.$Ce.wrap(P))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=M.$Ce.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),E(k)})}}function t(b,E){if(E===0)return;const k=b.byteLength>>>2;for(let O=0;O<k;O++){const T=b.readUInt32BE(O*4);b.writeUInt32BE(T^E,O*4)}const P=k*4,I=b.byteLength-P,j=E>>>24&255,F=E>>>16&255,z=E>>>8&255;I>=1&&b.writeUInt8(b.readUInt8(P)^j,P),I>=2&&b.writeUInt8(b.readUInt8(P+1)^F,P+1),I>=3&&b.writeUInt8(b.readUInt8(P+2)^z,P+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const g={2:107,1:103};function c(){const b=(0,m.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const E=process.platform!=="darwin"&&e.$hi?e.$hi:(0,L.tmpdir)(),k=(0,A.$kc)(E,`vscode-ipc-${b}.sock`);return s(k),k}function h(b,E,k){const I=(0,u.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${k}-${E}-sock`;const j=k.substr(0,4),F=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$hi,`vscode-${I}-${j}-${F}.sock`):z=(0,A.$kc)(b,`${j}-${F}.sock`),s(z),z}function s(b){const E=g[C.$u];typeof E=="number"&&b.length>=E&&console.warn(`WARNING: IPC handle "${b}" is longer than ${E} chars, try a shorter --user-data-dir`)}class w extends y.$7h{static b(E){const k=$.Event.fromNodeEventEmitter(E,"connection");return $.Event.map(k,P=>({protocol:new v.$bi(new l(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(E){super(w.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=w;function d(b){return new Promise((E,k)=>{const P=(0,N.createServer)();P.on("error",k),P.listen(b,()=>{P.removeListener("error",k),E(new w(P))})})}function D(b,E){return new Promise((k,P)=>{const I=(0,N.createConnection)(b,()=>{I.removeListener("error",P),k(v.$ci.fromSocket(new l(I,`ipc-client${E}`),E))});I.once("error",P)})}}),define(ke[389],Ee([1,0,63,64,173,123,8,3,11,54,12,139,266,267,110,88,21]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;async function a(t,g,c,h,s){let w;for(let d=3;d&&(w?.dispose(),w=await new n(t,g,c,h,s).waitForReady(),!(s&&L.$Pg[s]||!L.$Pg[w.tunnelLocalPort]));d--);return w}class n extends p.$Uc{constructor(g,c,h,s,w){super(),this.m=c,this.n=w,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=g,this.b=u.createServer(),this.c=new M.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=d=>this.r(d),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const g=this.n??this.tunnelRemotePort,c=(0,l.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let h=await(0,L.$Qg)(g,2,1e3,c),s=null;return this.b.listen(h,this.m),await this.c.wait(),s=this.b.address(),s||(h=0,this.b.listen(h,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(g){g.pause();const c=(0,l.$$v)(this.tunnelRemoteHost)||(0,l.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,m.$Ml)(this.a,c,this.tunnelRemotePort),s=h.getSocket(),w=h.readEntireBuffer();h.dispose(),w.byteLength>0&&g.write(w.buffer),g.on("end",()=>{g.localAddress&&this.j.delete(g.localAddress),s.end()}),g.on("close",()=>s.end()),g.on("error",()=>{g.localAddress&&this.j.delete(g.localAddress),s instanceof R.$fi?s.socket.destroy():s.end()}),s instanceof R.$fi?this.t(g,s):this.s(g,s),g.localAddress&&this.j.set(g.localAddress,()=>{g.end(),s.end()})}s(g,c){c.onClose(()=>g.destroy()),c.onEnd(()=>g.end()),c.onData(h=>g.write(h.buffer)),g.on("data",h=>c.write(f.$Ce.wrap(h))),g.resume()}t(g,c){const h=c.socket;h.on("end",()=>g.end()),h.on("close",()=>g.end()),h.on("error",()=>{g.destroy()}),h.pipe(g),g.pipe(h)}}e.$Vcc=n;let i=class extends l.$dw{constructor(g,c,h,s,w){super(c,w),this.v=g,this.w=h,this.y=s}isPortPrivileged(g){return(0,l.$bw)(g,this.m,$.OS,N.release())}t(g,c,h,s,w,d,D,b){const E=this.s(c,h);if(E)return++E.refcount,E.value;if((0,l.$7v)(g))return this.u(g,c,h,w,d,D,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${h} on local port ${w}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:g,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=a(k,s,c,h,w);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(c,h,P),P}}};e.$Wcc=i,e.$Wcc=i=Je([qe(0,y.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],i);let r=class extends i{constructor(g,c,h,s,w){super(g,c,h,s,w)}};e.$Xcc=r,e.$Xcc=r=Je([qe(0,y.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],r);let o=class extends p.$Uc{constructor(g,c,h,s,w){super(),this.b=g,this.c=c,this.f=h,this.g=s,this.h=w,this.a=new Map}async openTunnel(g,c,h,s,w,d,D,b,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${s} on local port ${d}.`),!this.a.has(g)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(g,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(g))})}return this.a.get(g).openTunnel(c,h,s,w,d,D,b,E)}};e.$Ycc=o,e.$Ycc=o=Je([qe(0,y.$Gl),qe(1,A.$Wj),qe(2,C.$dk),qe(3,v.$Jl),qe(4,S.$Wi)],o)}),define(ke[390],Ee([1,0,123,286,52,33,2,12,42]),function(le,e,u,N,L,R,M,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.$DP=void 0;class S{constructor(m,y,v){this.b=m,this.c=y,this.f=v,this.a=N.createServer((l,f)=>this.h(l,f)),this.g().catch(l=>(y.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,y){const v=(f,a)=>{y.writeHead(f,{"content-type":"application/json"}),y.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},l=[];m.setEncoding("utf8"),m.on("data",f=>l.push(f)),m.on("end",async()=>{try{const f=JSON.parse(l.join(""));let a;switch(f.type){case"open":a=await this.i(f);break;case"openExternal":a=await this.j(f);break;case"status":a=await this.l(f);break;case"extensionManagement":a=await this.k(f);break;default:v(404,`Unknown message type: ${f.type}`);break}v(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);v(500,a),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:y,folderURIs:v,forceNewWindow:l,diffMode:f,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:o,remoteAuthority:t}=m,g=[];if(Array.isArray(v))for(const w of v)try{g.push({folderUri:M.URI.parse(w)})}catch{}if(Array.isArray(y))for(const w of y)try{(0,$.$Vi)(w)?g.push({workspaceUri:M.URI.parse(w)}):g.push({fileUri:M.URI.parse(w)})}catch{}const c=o?M.URI.file(o):void 0,s={forceNewWindow:l,diffMode:f,mergeMode:a,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!c&&!n,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",g,s)}async j(m){for(const y of m.uris){const v=M.URI.parse(y),l=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const y=l=>l?.map(f=>/\.vsix$/i.test(f)?M.URI.parse(f):f),v={list:m.list,install:y(m.install),uninstall:y(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$DP=S;let A=class extends S{constructor(m,y){super(m,y,(0,u.$ii)())}};e.$EP=A,e.$EP=A=Je([qe(0,R.$yP),qe(1,p.$Wj)],A)}),define(ke[391],Ee([1,0,59,378,373,285,49,360,2,15,7,390,104,319,359]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class l extends L.$Dmc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(c,h,s){return c=t(c),n.a.has(c)?n.a.get(c).load(c,$.URI.file((0,m.$Yq)(h.filename)),w=>r.apply(this,[w,h,s])):r.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(g,c)=>o.call(this,t(g),c);const t=g=>{for(const c of n.b){const h=c(g);if(h){g=h;break}}return g}}}class f extends M.$rlc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$anc);const n=this.h.invokeFunction(N.$zmc);if(this.h.createInstance(p.$_mc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$EP);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(v.$bnc),await this.h.createInstance(l,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$$mc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),o=le.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$cnc=f}),define(ke[392],Ee([1,0,53,21,4,3,125,11,23,2,31,12,265,66,110,88,389,28,20,70,367]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0,e.$dnc=o,e.$enc=t,e.$fnc=g,e.$gnc=c,e.$hnc=s,e.$inc=w,e.$jnc=d;function o(E){const k=E.trim().split(`
`),P=[];return k.forEach(j=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((j,F)=>(j[F.socket]=F,j),{})}function t(...E){const k=[].concat(...E.map(c));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:g(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function g(E){let k="";if(E.length===8)for(let P=E.length-2;P>=0;P-=2)k+=parseInt(E.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<E.length;P+=8){const I=E.substring(P,P+8);let j="";for(let F=8;F>=2;F-=2)j+=I.substring(F-2,F),(F===6||F===2)&&(j=parseInt(j,16).toString(16),k+=`${j}`,j="",P+F!==E.length-6&&(k+=":"))}return k}function c(E){const k=E.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return k.map(j=>j.trim().split(/\s+/).reduce((F,z,O)=>(F[P[O]||O]=z,F),{}))}function h(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function s(E){const k=E.trim().split(`
`),P=[];return k.forEach(I=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);j&&j.length>=4&&P.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),P}async function w(E,k,P){const I=P.reduce((F,z)=>(F[z.pid]=z,F),{}),j=[];return E.forEach(({socket:F,ip:z,port:O})=>{const T=k[F]?k[F].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!h(B)&&j.push({host:z,port:O,detail:B,pid:T})}),j}function d(E,k,P){const I=new Map,j=s(k);for(const F of E){const z=P.get(F.port);if(z){I.set(F.port,z);continue}const O=j.find(T=>T.cmd.includes(`${F.port}`));if(O){let T=O,B;do B=j.find(W=>W.ppid===T.pid),B&&(T=B);while(B);I.set(F.port,{host:F.ip,port:F.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$OCb{constructor(k,P,I,j){super(k,P,I),this.D=P,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$ym;let j=0;for(;this.C;){const F=new Date().getTime(),z=(await this.I()).filter(B=>(0,l.$$v)(B.host)||(0,l.$aw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),j++>3&&I.update(O),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(k,P),j=await new Promise(x=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,Z,ue)=>{x(Z)})}),F=o(j),z=await A.Promises.readdir("/proc"),O=[];for(const x of z)try{const Y=Number(x),Z=$.$4g(S.URI.file("/proc"),x);if((await A.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Y)){const te=await A.Promises.readlink($.$4g(Z,"cwd").fsPath),we=await A.Promises.readFile($.$4g(Z,"cmdline").fsPath,"utf8");O.push({pid:Y,cwd:te,cmd:we})}}catch{}const T=[],B=I.filter(x=>{const Y=F[x.socket];return Y||T.push(x),Y}),W=w(B,F,O);let X;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const x=await new Promise(Y=>{(0,u.exec)("ps -F -A -l | grep root",(Z,ue,te)=>{Y(ue)})});this.z=d(T,x,this.z),X=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.map(Y=>Y.port).join(", ")}`)}return W.then(x=>X?x.concat(X):x)}w(k){return async P=>{const I=new f.$Vcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,z,O,T){const B=await k.makeConnection();return b.connect(B,z,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Cl(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const j=new L.$be;return{localAddress:(0,r.$dM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{I.dispose(),j.fire(),j.dispose()}}}}};e.$knc=D,e.$knc=D=Je([qe(0,n.$cP),qe(1,a.$sP),qe(2,C.$Wj),qe(3,v.$Jl)],D);class b extends m.$Lsb{static connect(k,P,I,j){const F=new R.$Tc,z={onClose:F.add(new L.$be),onData:F.add(new L.$be),onEnd:F.add(new L.$be)};F.add(k.onDidReceiveMessage(T=>z.onData.fire(N.$Ce.wrap(T)))),F.add(k.onDidEnd(()=>z.onEnd.fire())),F.add(k.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const O=new b(k,j,z);return O.B(F),(0,m.$Ksb)(O,P,I,j,z)}constructor(k,P,I){super(P,I),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[393],Ee([1,0,84,362,376,375,388,391,392,96,49,97,95,43,70,93,361,320,12,377,61,280,106,110,141]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a,n,i,r,o,t,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(A.$slc,p.$cnc,0),(0,u.$os)(n.$Xj,a.$mnc,1),(0,u.$os)(n.$Wj,new t.$ni(o.$Cmc,[!1],!0)),(0,u.$os)(g.$Jl,c.$1cc,1),(0,u.$os)(l.$Ukc,f.$lnc,0),(0,u.$os)(S.$xlc,R.$Pmc,0),(0,u.$os)(C.$Tlc,M.$0mc,0),(0,u.$os)(m.$jmc,L.$Hmc,0),(0,u.$os)(y.$dlc,N.$Gmc,0),(0,u.$os)(v.$NCb,$.$knc,0),(0,u.$os)(r.$vlc,i.$nnc,0)}),define(ke[404],Ee([1,0,63,405,59,13,82,123,263,114,374,21,31,104,8,135,287,303,379,393]),function(le,e,u,N,L,R,M,p,$,S,A,C,m,y,v,l,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const w=globalThis._VSCODE_NODE_MODULES.module,d=w._load;w._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function o(w){process.exit=function(d){if(w)i(d);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(d,D){d==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(d,D)}}let t=function(w){i()};function g(){const w=(0,a.$in)(process.env);if(w.type===3)return new Promise((d,D)=>{const b=E=>{const k=E[0],P=new M.$di;k.on("message",I=>P.fire(C.$Ce.wrap(I.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),d({onMessage:P.event,send:I=>k.postMessage(I.buffer)})};process.parentPort.on("message",E=>b(E.ports))});if(w.type===2)return new Promise((d,D)=>{let b=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,P=3e5,I=new v.$Dh(()=>t("renderer disconnected for too long (1)"),k),j=new v.$Dh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=C.$Ce.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new p.$fi(O,"extHost-socket");else{const W=C.$Ce.wrap(Buffer.from(z.inflateBytes,"base64"));B=new p.$gi(new p.$fi(O,"extHost-socket"),z.permessageDeflate,W,!1)}b?(I.cancel(),j.cancel(),b.beginAcceptReconnection(B,T),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(E),b=new M.$ei({socket:B,initialChunk:T}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),d(b),b.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;I.isScheduled()&&j.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const d=w.pipeName;return new Promise((D,b)=>{const E=u.createConnection(d,()=>{E.removeListener("error",b);const k=new M.$ei({socket:new p.$fi(E,"extHost-renderer")});k.sendResume(),D(k)});E.once("error",b),E.on("close",()=>{t("renderer closed the socket")})})}}async function c(){const w=await g();return new class{constructor(){this.a=new M.$di,this.onMessage=this.a.event,this.b=!1,w.onMessage(d=>{(0,S.$Um)(d,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(d)})}send(d){this.b||w.send(d)}async drain(){if(w.drain)return w.drain()}}}function h(w){return new Promise(d=>{const D=w.onMessage(b=>{D.dispose();const E=JSON.parse(b.toString()),k=E.commit,P=$.default.commit;if(k&&P&&k!==P&&i(55),E.parentPid){let I=0;setInterval(function(){try{process.kill(E.parentPid,0),I=0}catch(F){F&&F.code==="EPERM"?(I++,I>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(E.parentPid)}catch(F){(0,R.$1)(F)}}w.send((0,S.$Tm)(0)),d({protocol:w,initData:E})});w.send((0,S.$Tm)(1))})}async function s(){const w=[];process.on("unhandledRejection",(I,j)=>{w.push(j),setTimeout(()=>{const F=w.indexOf(j);F>=0&&j.catch(z=>{w.splice(F,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const j=w.indexOf(I);j>=0&&w.splice(j,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const d=await c();L.mark("code/extHost/didConnectToRenderer");const D=await h(d);L.mark("code/extHost/didWaitForInitData");const{initData:b}=D;o(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,l.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(j){i(j)}fsExists(j){return m.Promises.exists(j)}fsRealpath(j){return(0,y.$Xq)(j)}};let k=null;b.remote.authority&&n.transformURIs&&(k=(0,f.$ss)(b.remote.authority));const P=new A.$Fmc(D.protocol,b,E,k);t=I=>P.terminate(I)}s().catch(w=>console.log(w))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d30cf1447b6442215404fcba71ea59588d94908/core/vs/workbench/api/node/extensionHostProcess.js.map
