/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],I=0,T=ge.length;I<T;I++)e[I]=Ae[ge[I]];return e};define(Ae[68],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=T,e.$Vh=A,e.$Wh=O;function I(M){return(p,g,k)=>{let N=null,y=null;if(typeof k.value=="function"?(N="value",y=k.value):typeof k.get=="function"&&(N="get",y=k.get),!y)throw new Error("not supported");k[N]=M(y,g)}}function T(M,p,g){let k=null,N=null;if(typeof g.value=="function"?(k="value",N=g.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(k="get",N=g.get),!N)throw new Error("not supported");const y=`$memoize$${p}`;g[k]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,u)}),this[y]}}function A(M,p,g){return I((k,N)=>{const y=`$debounce$${N}`,u=`$debounce$result$${N}`;return function(...v){this[u]||(this[u]=g?g():void 0),clearTimeout(this[y]),p&&(this[u]=p(this[u],...v),v=[this[u]]),this[y]=setTimeout(()=>{k.apply(this,v),this[u]=g?g():void 0},M)}})}function O(M,p,g){return I((k,N)=>{const y=`$throttle$timer$${N}`,u=`$throttle$result$${N}`,v=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...s){if(this[u]||(this[u]=g?g():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[u]=p(this[u],...s)),this[m])return;const o=this[v]+M;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[u]]),this[u]=g?g():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),k.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}}),define(Ae[90],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=void 0;class I{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$hP=I,e.$iP=new I("id#")}),define(Ae[123],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=y,e.$Dn=u,e.$En=v,e.$Fn=m,e.$Gn=s,e.$Hn=o,e.$In=r,e.$Jn=n,e.$Kn=t,e.$Ln=c,e.$Mn=h;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(i,b=!1){let a=0;const $=i.length;let l="",S=0,d=16,E=0;function f(q){let R=0,j=0;for(;R<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;a++,R++}return R<q&&(j=-1),j}function D(q){a=q,l="",S=0,d=16,E=0}function w(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&k(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&k(i.charCodeAt(a)))for(a++;a<i.length&&k(i.charCodeAt(a));)a++;else return E=3,i.substring(q,a);let R=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&k(i.charCodeAt(a))){for(a++;a<i.length&&k(i.charCodeAt(a));)a++;R=a}else E=3;return i.substring(q,R)}function C(){let q="",R=a;for(;;){if(a>=$){q+=i.substring(R,a),E=2;break}const j=i.charCodeAt(a);if(j===34){q+=i.substring(R,a),a++;break}if(j===92){if(q+=i.substring(R,a),a++,a>=$){E=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const se=f(4);se>=0?q+=String.fromCharCode(se):E=4;break}default:E=5}R=a;continue}if(j>=0&&j<=31)if(g(j)){q+=i.substring(R,a),E=2;break}else E=6;a++}return q}function P(){if(l="",E=0,S=a,a>=$)return S=$,d=17;let q=i.charCodeAt(a);if(p(q)){do a++,l+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return d=15}if(g(q))return a++,l+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,l+=`
`),d=14;switch(q){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,l=C(),d=10;case 47:{const R=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<$&&!g(i.charCodeAt(a));)a++;return l=i.substring(R,a),d=12}if(i.charCodeAt(a+1)===42){a+=2;const j=$-1;let K=!1;for(;a<j;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,E=1),l=i.substring(R,a),d=13}return l+=String.fromCharCode(q),a++,d=16}case 45:if(l+=String.fromCharCode(q),a++,a===$||!k(i.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=w(),d=11;default:for(;a<$&&V(q);)a++,q=i.charCodeAt(a);if(S!==a){switch(l=i.substring(S,a),l){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return l+=String.fromCharCode(q),a++,d=16}}function V(q){if(p(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:b?W:P,getToken:()=>d,getTokenValue:()=>l,getTokenOffset:()=>S,getTokenLength:()=>a-S,getTokenError:()=>E}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function y(i,b){const a=[],$=new Object;let l;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function E(f,D,w,C){S.value=f,S.offset=D,S.length=w,S.type=C,S.colonOffset=void 0,l=S}try{t(i,{onObjectBegin:(f,D)=>{if(b<=f)throw $;l=void 0,d=b>f,a.push("")},onObjectProperty:(f,D,w)=>{if(b<D||(E(f,D,w,"property"),a[a.length-1]=f,b<=D+w))throw $},onObjectEnd:(f,D)=>{if(b<=f)throw $;l=void 0,a.pop()},onArrayBegin:(f,D)=>{if(b<=f)throw $;l=void 0,a.push(0)},onArrayEnd:(f,D)=>{if(b<=f)throw $;l=void 0,a.pop()},onLiteralValue:(f,D,w)=>{if(b<D||(E(f,D,w,h(f)),b<=D+w))throw $},onSeparator:(f,D,w)=>{if(b<=D)throw $;if(f===":"&&l&&l.type==="property")l.colonOffset=D,d=!1,l=void 0;else if(f===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(d=!0,a[a.length-1]=""),l=void 0}}})}catch(f){if(f!==$)throw f}return{path:a,previousNode:l,isAtPropertyKey:d,matches:f=>{let D=0;for(let w=0;D<f.length&&w<a.length;w++)if(f[D]===a[w]||f[D]==="*")D++;else if(f[D]!=="**")return!1;return D===f.length}}}function u(i,b=[],a=O.DEFAULT){let $=null,l=[];const S=[];function d(f){Array.isArray(l)?l.push(f):$!==null&&(l[$]=f)}return t(i,{onObjectBegin:()=>{const f={};d(f),S.push(l),l=f,$=null},onObjectProperty:f=>{$=f},onObjectEnd:()=>{l=S.pop()},onArrayBegin:()=>{const f=[];d(f),S.push(l),l=f,$=null},onArrayEnd:()=>{l=S.pop()},onLiteralValue:d,onError:(f,D,w)=>{b.push({error:f,offset:D,length:w})}},a),l[0]}function v(i,b=[],a=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(f){$.type==="property"&&($.length=f-$.offset,$=$.parent)}function S(f){return $.children.push(f),f}t(i,{onObjectBegin:f=>{$=S({type:"object",offset:f,length:-1,parent:$,children:[]})},onObjectProperty:(f,D,w)=>{$=S({type:"property",offset:D,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:f,offset:D,length:w,parent:$})},onObjectEnd:(f,D)=>{$.length=f+D-$.offset,$=$.parent,l(f+D)},onArrayBegin:(f,D)=>{$=S({type:"array",offset:f,length:-1,parent:$,children:[]})},onArrayEnd:(f,D)=>{$.length=f+D-$.offset,$=$.parent,l(f+D)},onLiteralValue:(f,D,w)=>{S({type:h(f),offset:D,length:w,parent:$,value:f}),l(D+w)},onSeparator:(f,D,w)=>{$.type==="property"&&(f===":"?$.colonOffset=D:f===","&&l(D))},onError:(f,D,w)=>{b.push({error:f,offset:D,length:w})}},a);const E=$.children[0];return E&&delete E.parent,E}function m(i,b){if(!i)return;let a=i;for(const $ of b)if(typeof $=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const S of a.children)if(Array.isArray(S.children)&&S.children[0].value===$){a=S.children[1],l=!0;break}if(!l)return}else{const l=$;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const b=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;b.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&b.push(a)}return b}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const b=Object.create(null);for(const a of i.children){const $=a.children[1];$&&(b[a.children[0].value]=o($))}return b}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function r(i,b,a=!1){return b>=i.offset&&b<i.offset+i.length||a&&b===i.offset+i.length}function n(i,b,a=!1){if(r(i,b,a)){const $=i.children;if(Array.isArray($))for(let l=0;l<$.length&&$[l].offset<=b;l++){const S=n($[l],b,a);if(S)return S}return i}}function t(i,b,a=O.DEFAULT){const $=M(i,!1);function l(ie){return ie?()=>ie($.getTokenOffset(),$.getTokenLength()):()=>!0}function S(ie){return ie?Pe=>ie(Pe,$.getTokenOffset(),$.getTokenLength()):()=>!0}const d=l(b.onObjectBegin),E=S(b.onObjectProperty),f=l(b.onObjectEnd),D=l(b.onArrayBegin),w=l(b.onArrayEnd),C=S(b.onLiteralValue),P=S(b.onSeparator),V=l(b.onComment),W=S(b.onError),q=a&&a.disallowComments,R=a&&a.allowTrailingComma;function j(){for(;;){const ie=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(ie){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return ie}}}function K(ie,Pe=[],Fe=[]){if(W(ie),Pe.length+Fe.length>0){let ne=$.getToken();for(;ne!==17;){if(Pe.indexOf(ne)!==-1){j();break}else if(Fe.indexOf(ne)!==-1)break;ne=j()}}}function se(ie){const Pe=$.getTokenValue();return ie?C(Pe):E(Pe),j(),!0}function ce(){switch($.getToken()){case 11:{let ie=0;try{ie=JSON.parse($.getTokenValue()),typeof ie!="number"&&(K(2),ie=0)}catch{K(2)}C(ie);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function ve(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(se(!1),$.getToken()===6?(P(":"),j(),be()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){d(),j();let ie=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(ie||K(4,[],[]),P(","),j(),$.getToken()===2&&R)break}else ie&&K(6,[],[]);ve()||K(4,[],[2,5]),ie=!0}return f(),$.getToken()!==2?K(7,[2],[]):j(),!0}function ue(){D(),j();let ie=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(ie||K(4,[],[]),P(","),j(),$.getToken()===4&&R)break}else ie&&K(6,[],[]);be()||K(4,[],[4,5]),ie=!0}return w(),$.getToken()!==4?K(8,[4],[]):j(),!0}function be(){switch($.getToken()){case 3:return ue();case 1:return Ie();case 10:return se(!0);default:return ce()}}return j(),$.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):be()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,b){const a=M(i),$=[];let l,S=0,d;do switch(d=a.getPosition(),l=a.scan(),l){case 12:case 13:case 17:S!==d&&$.push(i.substring(S,d)),b!==void 0&&$.push(a.getTokenValue().replace(/[^\r\n]/g,b)),S=a.getPosition();break}while(l!==17);return $.join("")}function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Ae[124],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ke,$e){for(var fe=0;fe<$e.length;fe++){var J=$e[fe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ke,J.key,J)}}function I(ke,$e,fe){return $e&&e(ke.prototype,$e),fe&&e(ke,fe),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function T(ke,$e){if(ke){if(typeof ke=="string")return A(ke,$e);var fe=Object.prototype.toString.call(ke).slice(8,-1);if(fe==="Object"&&ke.constructor&&(fe=ke.constructor.name),fe==="Map"||fe==="Set")return Array.from(ke);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return A(ke,$e)}}function A(ke,$e){($e==null||$e>ke.length)&&($e=ke.length);for(var fe=0,J=new Array($e);fe<$e;fe++)J[fe]=ke[fe];return J}function O(ke,$e){var fe=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(fe)return(fe=fe.call(ke)).next.bind(fe);if(Array.isArray(ke)||(fe=T(ke))||$e&&ke&&typeof ke.length=="number"){fe&&(ke=fe);var J=0;return function(){return J>=ke.length?{done:!0}:{done:!1,value:ke[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(ke){ge.defaults=ke}var g=/[&<>"']/,k=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function($e){return u[$e]};function m(ke,$e){if($e){if(g.test(ke))return ke.replace(k,v)}else if(N.test(ke))return ke.replace(y,v);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(s,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var r=/(^|[^\[])\^/g;function n(ke,$e){ke=typeof ke=="string"?ke:ke.source,$e=$e||"";var fe={replace:function(Y,he){return he=he.source||he,he=he.replace(r,"$1"),ke=ke.replace(Y,he),fe},getRegex:function(){return new RegExp(ke,$e)}};return fe}var t=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,$e,fe){if(ke){var J;try{J=decodeURIComponent(o(fe)).replace(t,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}$e&&!c.test(fe)&&(fe=l($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},b=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ke,$e){i[" "+ke]||(b.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=f(ke,"/",!0)),ke=i[" "+ke];var fe=ke.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:ke.replace(a,"$1")+$e:$e.charAt(0)==="/"?fe?$e:ke.replace($,"$1")+$e:ke+$e}var S={exec:function(){}};function d(ke){for(var $e=1,fe,J;$e<arguments.length;$e++){fe=arguments[$e];for(J in fe)Object.prototype.hasOwnProperty.call(fe,J)&&(ke[J]=fe[J])}return ke}function E(ke,$e){var fe=ke.replace(/\|/g,function(he,le,Te){for(var de=!1,Ce=le;--Ce>=0&&Te[Ce]==="\\";)de=!de;return de?"|":" |"}),J=fe.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>$e)J.splice($e);else for(;J.length<$e;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function f(ke,$e,fe){var J=ke.length;if(J===0)return"";for(var Y=0;Y<J;){var he=ke.charAt(J-Y-1);if(he===$e&&!fe)Y++;else if(he!==$e&&fe)Y++;else break}return ke.slice(0,J-Y)}function D(ke,$e){if(ke.indexOf($e[1])===-1)return-1;for(var fe=ke.length,J=0,Y=0;Y<fe;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===$e[0])J++;else if(ke[Y]===$e[1]&&(J--,J<0))return Y;return-1}function w(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ke,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=ke),$e>>=1,ke+=ke;return fe+ke}function P(ke,$e,fe,J){var Y=$e.href,he=$e.title?m($e.title):null,le=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){J.state.inLink=!0;var Te={type:"link",raw:fe,href:Y,title:he,text:le,tokens:J.inlineTokens(le)};return J.state.inLink=!1,Te}return{type:"image",raw:fe,href:Y,title:he,text:m(le)}}function V(ke,$e){var fe=ke.match(/^(\s+)(?:```)/);if(fe===null)return $e;var J=fe[1];return $e.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var le=he[0];return le.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var W=function(){function ke(fe){this.options=fe||ge.defaults}var $e=ke.prototype;return $e.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},$e.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:f(he,`
`)}}},$e.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var he=Y[0],le=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:le}}},$e.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var le=f(he,"#");(this.options.pedantic||!le||/ $/.test(le))&&(he=le.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},$e.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},$e.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},$e.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var he,le,Te,de,Ce,Me,ze,z,L,G,H,ee,re=Y[1].trim(),Ne=re.length>1,Be={type:"list",raw:"",ordered:Ne,start:Ne?+re.slice(0,-1):"",loose:!1,items:[]};re=Ne?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Ne?re:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(he=Y[0],J=J.substring(he.length),z=Y[2].split(`
`,1)[0],L=J.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Y[1].length),Me=!1,!z&&/^ *$/.test(L)&&(he+=L+`
`,J=J.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");J&&(G=J.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(z)||it.test(z)||_e.test(z)||et.test(J)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),he+=G+`
`,J=J.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(H),le&&(Te=le[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!le,checked:Te,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var at=Be.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),mt=at.every(function(Ue){for(var st=Ue.raw.split(""),X=0,Z=O(st),me;!(me=Z()).done;){var He=me.value;if(He===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},$e.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);he.type="paragraph",he.text=le,he.tokens=this.lexer.inline(le)}return he}},$e.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},$e.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var he={type:"table",header:E(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var le=he.align.length,Te,de,Ce,Me;for(Te=0;Te<le;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(le=he.rows.length,Te=0;Te<le;Te++)he.rows[Te]=E(he.rows[Te],he.header.length).map(function(ze){return{text:ze}});for(le=he.header.length,de=0;de<le;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(le=he.rows.length,de=0;de<le;de++)for(Me=he.rows[de],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return he}}},$e.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},$e.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},$e.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},$e.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},$e.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},$e.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var le=f(he.slice(0,-1),"\\");if((he.length-le.length)%2===0)return}else{var Te=D(Y[2],"()");if(Te>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},$e.reflink=function(J,Y){var he;if((he=this.rules.inline.reflink.exec(J))||(he=this.rules.inline.nolink.exec(J))){var le=(he[2]||he[1]).replace(/\s+/g," ");if(le=Y[le.toLowerCase()],!le||!le.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(he,le,he[0],this.lexer)}},$e.emStrong=function(J,Y,he){he===void 0&&(he="");var le=this.rules.inline.emStrong.lDelim.exec(J);if(le&&!(le[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=le[1]||le[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var de=le[0].length-1,Ce,Me,ze=de,z=0,L=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*J.length+de);(le=L.exec(Y))!=null;)if(Ce=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!Ce){if(Me=Ce.length,le[3]||le[4]){ze+=Me;continue}else if((le[5]||le[6])&&de%3&&!((de+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(de,Me)%2){var G=J.slice(1,de+le.index+Me);return{type:"em",raw:J.slice(0,de+le.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=J.slice(2,de+le.index+Me-1);return{type:"strong",raw:J.slice(0,de+le.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var he=Y[2].replace(/\n/g," "),le=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return le&&Te&&(he=he.substring(1,he.length-1)),he=m(he,!0),{type:"codespan",raw:Y[0],text:he}}},$e.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},$e.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},$e.autolink=function(J,Y){var he=this.rules.inline.autolink.exec(J);if(he){var le,Te;return he[2]==="@"?(le=m(this.options.mangle?Y(he[1]):he[1]),Te="mailto:"+le):(le=m(he[1]),Te=le),{type:"link",raw:he[0],text:le,href:Te,tokens:[{type:"text",raw:le,text:le}]}}},$e.url=function(J,Y){var he;if(he=this.rules.inline.url.exec(J)){var le,Te;if(he[2]==="@")le=m(this.options.mangle?Y(he[0]):he[0]),Te="mailto:"+le;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);le=m(he[0]),he[1]==="www."?Te="http://"+le:Te=le}return{type:"link",raw:he[0],text:le,href:Te,tokens:[{type:"text",raw:le,text:le}]}}},$e.inlineText=function(J,Y){var he=this.rules.inline.text.exec(J);if(he){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]:le=m(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:le}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=d({},q),q.gfm=d({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=d({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=n(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=d({},R),R.pedantic=d({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=d({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=d({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var $e="",fe,J,Y=ke.length;for(fe=0;fe<Y;fe++)J=ke.charCodeAt(fe),Math.random()>.5&&(J="x"+J.toString(16)),$e+="&#"+J+";";return $e}var se=function(){function ke(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:R.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=R.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=R.breaks:J.inline=R.gfm),this.tokenizer.rules=J}ke.lex=function(J,Y){var he=new ke(Y);return he.lex(J)},ke.lexInline=function(J,Y){var he=new ke(Y);return he.inlineTokens(J)};var $e=ke.prototype;return $e.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},$e.blockTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var le,Te,de,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(le=ze.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.space(J)){J=J.substring(le.raw.length),le.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(le);continue}if(le=this.tokenizer.code(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le);continue}if(le=this.tokenizer.fences(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.heading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.hr(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.blockquote(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.list(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.html(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.def(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.lheading(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=J.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(de=J.substring(0,ze+1))}(),this.state.top&&(le=this.tokenizer.paragraph(de))){Te=Y[Y.length-1],Ce&&Te.type==="paragraph"?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le),Ce=de.length!==J.length,J=J.substring(le.raw.length);continue}if(le=this.tokenizer.text(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+le.raw,Te.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(le);continue}if(J){var Me="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},$e.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},$e.inlineTokens=function(J,Y){var he=this;Y===void 0&&(Y=[]);var le,Te,de,Ce=J,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(le=H.call({lexer:he},J,Y))?(J=J.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.escape(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.tag(J)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&le.type==="text"&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.link(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(le.raw.length),Te=Y[Y.length-1],Te&&le.type==="text"&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.emStrong(J,Ce,z)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.codespan(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.br(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.del(J)){J=J.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.autolink(J,K)){J=J.substring(le.raw.length),Y.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(J,K))){J=J.substring(le.raw.length),Y.push(le);continue}if(de=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Ne){re=Ne.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=J.substring(0,H+1))}(),le=this.tokenizer.inlineText(de,j)){J=J.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(z=le.raw.slice(-1)),ze=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=le.raw,Te.text+=le.text):Y.push(le);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(ke,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),ke}(),ce=function(){function ke(fe){this.options=fe||ge.defaults}var $e=ke.prototype;return $e.code=function(J,Y,he){var le=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(J,le);Te!=null&&Te!==J&&(he=!0,J=Te)}return J=J.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+m(le,!0)+'">'+(he?J:m(J,!0))+`</code></pre>
`:"<pre><code>"+(he?J:m(J,!0))+`</code></pre>
`},$e.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},$e.html=function(J){return J},$e.heading=function(J,Y,he,le){if(this.options.headerIds){var Te=this.options.headerPrefix+le.slug(he);return"<h"+Y+' id="'+Te+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(J,Y,he){var le=Y?"ol":"ul",Te=Y&&he!==1?' start="'+he+'"':"";return"<"+le+Te+`>
`+J+"</"+le+`>
`},$e.listitem=function(J){return"<li>"+J+`</li>
`},$e.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(J){return"<p>"+J+`</p>
`},$e.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},$e.tablerow=function(J){return`<tr>
`+J+`</tr>
`},$e.tablecell=function(J,Y){var he=Y.header?"th":"td",le=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return le+J+("</"+he+`>
`)},$e.strong=function(J){return"<strong>"+J+"</strong>"},$e.em=function(J){return"<em>"+J+"</em>"},$e.codespan=function(J){return"<code>"+J+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(J){return"<del>"+J+"</del>"},$e.link=function(J,Y,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<a href="'+m(J)+'"';return Y&&(le+=' title="'+Y+'"'),le+=">"+he+"</a>",le},$e.image=function(J,Y,he){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var le='<img src="'+J+'" alt="'+he+'"';return Y&&(le+=' title="'+Y+'"'),le+=this.options.xhtml?"/>":">",le},$e.text=function(J){return J},ke}(),ve=function(){function ke(){}var $e=ke.prototype;return $e.strong=function(J){return J},$e.em=function(J){return J},$e.codespan=function(J){return J},$e.del=function(J){return J},$e.html=function(J){return J},$e.text=function(J){return J},$e.link=function(J,Y,he){return""+he},$e.image=function(J,Y,he){return""+he},$e.br=function(){return""},ke}(),Ie=function(){function ke(){this.seen={}}var $e=ke.prototype;return $e.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(J,Y){var he=J,le=0;if(this.seen.hasOwnProperty(he)){le=this.seen[J];do le++,he=J+"-"+le;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[J]=le,this.seen[he]=0),he},$e.slug=function(J,Y){Y===void 0&&(Y={});var he=this.serialize(J);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ue=function(){function ke(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}ke.parse=function(J,Y){var he=new ke(Y);return he.parse(J)},ke.parseInline=function(J,Y){var he=new ke(Y);return he.parseInline(J)};var $e=ke.prototype;return $e.parse=function(J,Y){Y===void 0&&(Y=!0);var he="",le,Te,de,Ce,Me,ze,z,L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt=J.length;for(le=0;le<nt;le++){if(H=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=it||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Ce=H.header.length,Te=0;Te<Ce;Te++)z+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(L+=this.renderer.tablerow(z),G="",Ce=H.rows.length,Te=0;Te<Ce;Te++){for(ze=H.rows[Te],z="",Me=ze.length,de=0;de<Me;de++)z+=this.renderer.tablecell(this.parseInline(ze[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(z)}he+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Ne=H.loose,Ce=H.items.length,G="",Te=0;Te<Ce;Te++)Qe=H.items[Te],_e=Qe.checked,et=Qe.task,Be="",Qe.task&&(tt=this.renderer.checkbox(_e),Ne?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=tt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=tt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Qe.tokens,Ne),G+=this.renderer.listitem(Be,et,_e);he+=this.renderer.list(G,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;le+1<nt&&J[le+1].type==="text";)H=J[++le],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},$e.parseInline=function(J,Y){Y=Y||this.renderer;var he="",le,Te,de,Ce=J.length;for(le=0;le<Ce;le++){if(Te=J[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(de=this.options.extensions.renderers[Te.type].call({parser:this},Te),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=de||"";continue}switch(Te.type){case"escape":{he+=Y.text(Te.text);break}case"html":{he+=Y.html(Te.text);break}case"link":{he+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{he+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{he+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{he+=Y.codespan(Te.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{he+=Y.text(Te.text);break}default:{var Me='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},ke}();function be(ke,$e,fe){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=d({},be.defaults,$e||{}),w($e),fe){var J=$e.highlight,Y;try{Y=se.lex(ke,$e)}catch(Ce){return fe(Ce)}var he=function(Me){var ze;if(!Me)try{$e.walkTokens&&be.walkTokens(Y,$e.walkTokens),ze=ue.parse(Y,$e)}catch(z){Me=z}return $e.highlight=J,Me?fe(Me):fe(null,ze)};if(!J||J.length<3||(delete $e.highlight,!Y.length))return he();var le=0;be.walkTokens(Y,function(Ce){Ce.type==="code"&&(le++,setTimeout(function(){J(Ce.text,Ce.lang,function(Me,ze){if(Me)return he(Me);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),le--,le===0&&he()})},0))}),le===0&&he();return}function Te(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=se.lex(ke,$e);if($e.walkTokens){if($e.async)return Promise.all(be.walkTokens(de,$e.walkTokens)).then(function(){return ue.parse(de,$e)}).catch(Te);be.walkTokens(de,$e.walkTokens)}return ue.parse(de,$e)}catch(Ce){Te(Ce)}}be.options=be.setOptions=function(ke){return d(be.defaults,ke),p(be.defaults),be},be.getDefaults=M,be.defaults=ge.defaults,be.use=function(){for(var ke=arguments.length,$e=new Array(ke),fe=0;fe<ke;fe++)$e[fe]=arguments[fe];var J=d.apply(void 0,[{}].concat($e)),Y=be.defaults.extensions||{renderers:{},childTokens:{}},he;$e.forEach(function(le){if(le.extensions&&(he=!0,le.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=de.renderer.apply(this,ze);return L===!1&&(L=Ce.apply(this,ze)),L}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),le.renderer&&function(){var de=be.defaults.renderer||new ce,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.renderer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.renderer)Ce(Me);J.renderer=de}(),le.tokenizer&&function(){var de=be.defaults.tokenizer||new W,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=le.tokenizer[z].apply(de,H);return re===!1&&(re=L.apply(de,H)),re}};for(var Me in le.tokenizer)Ce(Me);J.tokenizer=de}(),le.walkTokens){var Te=be.defaults.walkTokens;J.walkTokens=function(de){var Ce=[];return Ce.push(le.walkTokens.call(this,de)),Te&&(Ce=Ce.concat(Te.call(this,de))),Ce}}he&&(J.extensions=Y),be.setOptions(J)})},be.walkTokens=function(ke,$e){for(var fe=[],J=function(){var Te=he.value;switch(fe=fe.concat($e.call(be,Te)),Te.type){case"table":{for(var de=O(Te.header),Ce;!(Ce=de()).done;){var Me=Ce.value;fe=fe.concat(be.walkTokens(Me.tokens,$e))}for(var ze=O(Te.rows),z;!(z=ze()).done;)for(var L=z.value,G=O(L),H;!(H=G()).done;){var ee=H.value;fe=fe.concat(be.walkTokens(ee.tokens,$e))}break}case"list":{fe=fe.concat(be.walkTokens(Te.items,$e));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[Te.type]?be.defaults.extensions.childTokens[Te.type].forEach(function(re){fe=fe.concat(be.walkTokens(Te[re],$e))}):Te.tokens&&(fe=fe.concat(be.walkTokens(Te.tokens,$e)))}},Y=O(ke),he;!(he=Y()).done;)J();return fe},be.parseInline=function(ke,$e){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");$e=d({},be.defaults,$e||{}),w($e);try{var fe=se.lexInline(ke,$e);return $e.walkTokens&&be.walkTokens(fe,$e.walkTokens),ue.parseInline(fe,$e)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(J.message+"",!0)+"</pre>";throw J}},be.Parser=ue,be.parser=ue.parse,be.Renderer=ce,be.TextRenderer=ve,be.Lexer=se,be.lexer=se.lex,be.Tokenizer=W,be.Slugger=Ie,be.parse=be;var ie=be.options,Pe=be.setOptions,Fe=be.use,ne=be.walkTokens,U=be.parseInline,x=be,pe=ue.parse,Oe=se.lex;ge.Lexer=se,ge.Parser=ue,ge.Renderer=ce,ge.Slugger=Ie,ge.TextRenderer=ve,ge.Tokenizer=W,ge.getDefaults=M,ge.lexer=Oe,ge.marked=be,ge.options=ie,ge.parse=x,ge.parseInline=U,ge.parser=pe,ge.setOptions=Pe,ge.use=Fe,ge.walkTokens=ne,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ae[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=I;function I(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let T=0;const A=new Uint32Array(10);function O(s){if(T=0,M(s,y,4352),T>0||(M(s,u,4449),T>0)||(M(s,v,4520),T>0)||(M(s,m,12593),T))return A.subarray(0,T);if(s>=44032&&s<=55203){const o=s-44032,r=o%588,n=Math.floor(o/588),t=Math.floor(r/28),c=r%28-1;if(n<y.length?M(n,y,0):4352+n-12593<m.length&&M(4352+n,m,12593),t<u.length?M(t,u,0):4449+t-12593<m.length&&M(4449+t-12593,m,12593),c>=0&&(c<v.length?M(c,v,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),T>0)return A.subarray(0,T)}}function M(s,o,r){s>=r&&s<r+o.length&&p(o[s-r])}function p(s){s!==0&&(A[T++]=s&255,s>>8&&(A[T++]=s>>8&255),s>>16&&(A[T++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ae[126],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=I,e.rot=T;function I(p,g,k){return Math.min(Math.max(p,g),k)}function T(p,g){return(g+p%g)%g}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=A;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=O;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const k=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function ge(A){const O=[];typeof A=="number"&&O.push("code/timeOrigin",A);function M(g){O.push(g,Date.now())}function p(){const g=[];for(let k=0;k<O.length;k+=2)g.push({name:O[k],startTime:O[k+1]});return g}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(A+M.startTime)});return O}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=I(T))}(),define(Ae[127],Re([1,0,40]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0;const T=Symbol("unset");class A{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(g,k,N){this.d(g,y=>y._value=k,N)}mutate(g,k){this.d(g,N=>N._value=k(N._value===T?void 0:N._value))}delete(g){const k=this.c(g);if(!k)return;let N=k.length-1;const y=k[N].node._value;if(y!==T){for(this.b--,k[N].node._value=T;N>0;N--){const{node:u,part:v}=k[N];if(u.children?.size||u._value!==T)break;k[N-1].node.children.delete(v)}return y}}*deleteRecursive(g){const k=this.c(g);if(!k)return;const N=k[k.length-1].node;for(let y=k.length-1;y>0;y--){const u=k[y-1];if(u.node.children.delete(k[y].part),u.node.children.size>0||u.node._value!==T)break}for(const y of O(N))y._value!==T&&(this.b--,yield y._value)}find(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return;k=y}return k._value===T?void 0:k._value}hasKeyOrParent(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;if(y._value!==T)return!0;k=y}return!1}hasKeyOrChildren(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return!0}hasKey(g){let k=this.a;for(const N of g){const y=k.children?.get(N);if(!y)return!1;k=y}return k._value!==T}c(g){const k=[{part:"",node:this.a}];let N=0;for(const y of g){const u=k[N].node.children?.get(y);if(!u)return;k.push({part:y,node:u}),N++}return k}d(g,k,N){let y=this.a;for(const m of g){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}N?.(y)}const u=y._value===T?0:1;k(y);const v=y._value===T?0:1;this.b+=v-u}*values(){for(const{_value:g}of O(this.a))g!==T&&(yield g)}}e.$4O=A;function*O(p){const g=[p];for(;g.length>0;){const k=g.pop();if(yield k,k.children)for(const N of k.children.values())g.push(N)}}class M{constructor(){this._value=T}get value(){return this._value===T?void 0:this._value}set value(g){this._value=g===void 0?T:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var T in I)(typeof exports=="object"?exports:ge)[T]=I[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(T){if(e[T])return e[T].exports;var A=e[T]={i:T,l:!1,exports:{}};return ge[T].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=ge,I.c=e,I.d=function(T,A,O){I.o(T,A)||Object.defineProperty(T,A,{enumerable:!0,get:O})},I.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},I.t=function(T,A){if(1&A&&(T=I(T)),8&A||4&A&&typeof T=="object"&&T&&T.__esModule)return T;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:T}),2&A&&typeof T!="string")for(var M in T)I.d(O,M,function(p){return T[p]}.bind(null,M));return O},I.n=function(T){var A=T&&T.__esModule?function(){return T.default}:function(){return T};return I.d(A,"a",A),A},I.o=function(T,A){return Object.prototype.hasOwnProperty.call(T,A)},I.p="",I(I.s=0)}([function(ge,e,I){(function(T){var A;e=ge.exports=Fe,A=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],g=e.src=[],k=0,N=k++;g[N]="0|[1-9]\\d*";var y=k++;g[y]="[0-9]+";var u=k++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;g[v]="("+g[N]+")\\.("+g[N]+")\\.("+g[N]+")";var m=k++;g[m]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var s=k++;g[s]="(?:"+g[N]+"|"+g[u]+")";var o=k++;g[o]="(?:"+g[y]+"|"+g[u]+")";var r=k++;g[r]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var n=k++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var t=k++;g[t]="[0-9A-Za-z-]+";var c=k++;g[c]="(?:\\+("+g[t]+"(?:\\."+g[t]+")*))";var h=k++,i="v?"+g[v]+g[r]+"?"+g[c]+"?";g[h]="^"+i+"$";var b="[v=\\s]*"+g[m]+g[n]+"?"+g[c]+"?",a=k++;g[a]="^"+b+"$";var $=k++;g[$]="((?:<|>)?=?)";var l=k++;g[l]=g[y]+"|x|X|\\*";var S=k++;g[S]=g[N]+"|x|X|\\*";var d=k++;g[d]="[v=\\s]*("+g[S]+")(?:\\.("+g[S]+")(?:\\.("+g[S]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var E=k++;g[E]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var f=k++;g[f]="^"+g[$]+"\\s*"+g[d]+"$";var D=k++;g[D]="^"+g[$]+"\\s*"+g[E]+"$";var w=k++;g[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;g[C]="(?:~>?)";var P=k++;g[P]="(\\s*)"+g[C]+"\\s+",p[P]=new RegExp(g[P],"g");var V=k++;g[V]="^"+g[C]+g[d]+"$";var W=k++;g[W]="^"+g[C]+g[E]+"$";var q=k++;g[q]="(?:\\^)";var R=k++;g[R]="(\\s*)"+g[q]+"\\s+",p[R]=new RegExp(g[R],"g");var j=k++;g[j]="^"+g[q]+g[d]+"$";var K=k++;g[K]="^"+g[q]+g[E]+"$";var se=k++;g[se]="^"+g[$]+"\\s*("+b+")$|^$";var ce=k++;g[ce]="^"+g[$]+"\\s*("+i+")$|^$";var ve=k++;g[ve]="(\\s*)"+g[$]+"\\s*("+b+"|"+g[d]+")",p[ve]=new RegExp(g[ve],"g");var Ie=k++;g[Ie]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var ue=k++;g[ue]="^\\s*("+g[E]+")\\s+-\\s+("+g[E]+")\\s*$";var be=k++;g[be]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)A(ie,g[ie]),p[ie]||(p[ie]=new RegExp(g[ie]));function Pe(L,G){if(L instanceof Fe)return L;if(typeof L!="string"||L.length>O||!(G?p[a]:p[h]).test(L))return null;try{return new Fe(L,G)}catch{return null}}function Fe(L,G){if(L instanceof Fe){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Fe))return new Fe(L,G);A("SemVer",L,G),this.loose=G;var H=L.trim().match(G?p[a]:p[h]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<M)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Pe,e.valid=function(L,G){var H=Pe(L,G);return H?H.version:null},e.clean=function(L,G){var H=Pe(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Fe,Fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Fe.prototype.toString=function(){return this.version},Fe.prototype.compare=function(L){return A("SemVer.compare",this.version,this.loose,L),L instanceof Fe||(L=new Fe(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Fe.prototype.compareMain=function(L){return L instanceof Fe||(L=new Fe(L,this.loose)),U(this.major,L.major)||U(this.minor,L.minor)||U(this.patch,L.patch)},Fe.prototype.comparePre=function(L){if(L instanceof Fe||(L=new Fe(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=L.prerelease[G];if(A("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return U(H,ee)}while(++G)},Fe.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Fe(L,H).inc(G,ee).version}catch{return null}},e.diff=function(L,G){if(ke(L,G))return null;var H=Pe(L),ee=Pe(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=U;var ne=/^[0-9]+$/;function U(L,G){var H=ne.test(L),ee=ne.test(G);return H&&ee&&(L=+L,G=+G),H&&!ee?-1:ee&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Fe(L,H).compare(new Fe(G,H))}function pe(L,G,H){return x(L,G,H)>0}function Oe(L,G,H){return x(L,G,H)<0}function ke(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function fe(L,G,H){return x(L,G,H)>=0}function J(L,G,H){return x(L,G,H)<=0}function Y(L,G,H,ee){var re;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L!==H;break;case"":case"=":case"==":re=ke(L,H,ee);break;case"!=":re=$e(L,H,ee);break;case">":re=pe(L,H,ee);break;case">=":re=fe(L,H,ee);break;case"<":re=Oe(L,H,ee);break;case"<=":re=J(L,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function he(L,G){if(L instanceof he){if(L.loose===G)return L;L=L.value}if(!(this instanceof he))return new he(L,G);A("comparator",L,G),this.loose=G,this.parse(L),this.semver===le?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(L,G){return U(G,L)},e.major=function(L,G){return new Fe(L,G).major},e.minor=function(L,G){return new Fe(L,G).minor},e.patch=function(L,G){return new Fe(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(L,G){return L.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=pe,e.lt=Oe,e.eq=ke,e.neq=$e,e.gte=fe,e.lte=J,e.cmp=Y,e.Comparator=he;var le={};function Te(L,G){if(L instanceof Te)return L.loose===G?L:new Te(L.raw,G);if(L instanceof he)return new Te(L.value,G);if(!(this instanceof Te))return new Te(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function de(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=de(_e)?"":de(et)?"<"+(+_e+1)+".0.0":de(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(A(L[H].semver),L[H].semver!==le&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Te(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,ee){var re,Ne,Be,Qe,_e;switch(L=new Fe(L,ee),G=new Te(G,ee),H){case">":re=pe,Ne=J,Be=Oe,Qe=">",_e=">=";break;case"<":re=Oe,Ne=fe,Be=pe,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,ee))return!1;for(var et=0;et<G.set.length;++et){var tt=G.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===le&&(at=new he(">=0.0.0")),it=it||at,nt=nt||at,re(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Qe||it.operator===_e||(!nt.operator||nt.operator===Qe)&&Ne(L,nt.semver)||nt.operator===_e&&Be(L,nt.semver))return!1}return!0}he.prototype.parse=function(L){var G=this.loose?p[se]:p[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Fe(H[2],this.loose):this.semver=le},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return A("Comparator.test",L,this.loose),this.semver===le||(typeof L=="string"&&(L=new Fe(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,G){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Te(this.value,G),ze(L.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Ne=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=Y(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Ne&&Be||Qe||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),A("range",L,G);var H=G?p[ue]:p[Ie];L=L.replace(H,Ce),A("hyphen replace",L),L=L.replace(p[ve],"$1$2$3"),A("comparator trim",L,p[ve]),L=(L=(L=L.replace(p[P],"$1~")).replace(p[R],"$1^")).split(/\s+/).join(" ");var ee=G?p[se]:p[ce],re=L.split(" ").map(function(Ne){return function(Be,Qe){return A("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){A("caret",it,nt);var at=nt?p[K]:p[j];return it.replace(at,function(mt,Ue,st,X,Z){var me;return A("caret",it,mt,Ue,st,X,Z),de(Ue)?me="":de(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?me=Ue==="0"?">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+".0 <"+(+Ue+1)+".0.0":Z?(A("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+X+Z+" <"+Ue+"."+st+"."+(+X+1):">="+Ue+"."+st+"."+X+Z+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+X+Z+" <"+(+Ue+1)+".0.0"):(A("no pr"),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+X+" <"+Ue+"."+st+"."+(+X+1):">="+Ue+"."+st+"."+X+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+X+" <"+(+Ue+1)+".0.0"),A("caret return",me),me})}(tt,et)}).join(" ")}(Be,Qe),A("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[W]:p[V];return it.replace(at,function(mt,Ue,st,X,Z){var me;return A("tilde",it,mt,Ue,st,X,Z),de(Ue)?me="":de(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?me=">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":Z?(A("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+Ue+"."+st+"."+X+Z+" <"+Ue+"."+(+st+1)+".0"):me=">="+Ue+"."+st+"."+X+" <"+Ue+"."+(+st+1)+".0",A("tilde return",me),me})}(tt,et)}).join(" ")}(Be,Qe),A("tildes",Be),Be=function(_e,et){return A("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[D]:p[f];return it.replace(at,function(mt,Ue,st,X,Z,me){A("xRange",it,mt,Ue,st,X,Z,me);var He=de(st),ye=He||de(X),ot=ye||de(Z);return Ue==="="&&ot&&(Ue=""),He?mt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&ot?(ye&&(X=0),ot&&(Z=0),Ue===">"?(Ue=">=",ye?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):Ue==="<="&&(Ue="<",ye?st=+st+1:X=+X+1),mt=Ue+st+"."+X+"."+Z):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),A("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Qe),A("xrange",Be),Be=function(_e,et){return A("replaceStars",_e,et),_e.trim().replace(p[be],"")}(Be,Qe),A("stars",Be),Be}(Ne,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Ne){return!!Ne.match(ee)})),re=re.map(function(Ne){return new he(Ne,G)})},Te.prototype.intersects=function(L,G){if(!(L instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(re){return re.every(function(Ne){return ee.intersects(Ne,G)})})})})},e.toComparators=function(L,G){return new Te(L,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Fe(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var ee=null,re=null;try{var Ne=new Te(G,H)}catch{return null}return L.forEach(function(Be){Ne.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Fe(ee=Be,H)))}),ee},e.minSatisfying=function(L,G,H){var ee=null,re=null;try{var Ne=new Te(G,H)}catch{return null}return L.forEach(function(Be){Ne.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Fe(ee=Be,H)))}),ee},e.validRange=function(L,G){try{return new Te(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Pe(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Te(L,H),G=new Te(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Fe)return L;if(typeof L!="string")return null;var G=L.match(p[w]);return G==null?null:Pe((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,T,A=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{T=typeof clearTimeout=="function"?clearTimeout:M}catch{T=M}})();var g,k=[],N=!1,y=-1;function u(){N&&g&&(N=!1,g.length?k=g.concat(k):y=-1,k.length&&v())}function v(){if(!N){var o=p(u);N=!0;for(var r=k.length;r;){for(g=k,k=[];++y<r;)g&&g[y].run();y=-1,r=k.length}g=null,N=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===M||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(o)}}function m(o,r){this.fun=o,this.array=r}function s(){}A.nextTick=function(o){var r=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)r[n-1]=arguments[n];k.push(new m(o,r)),k.length!==1||N||p(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=s,A.addListener=s,A.once=s,A.off=s,A.removeListener=s,A.removeAllListeners=s,A.emit=s,A.prependListener=s,A.prependOnceListener=s,A.listeners=function(o){return[]},A.binding=function(o){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(o){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ae[128],Re([1,0,14,6]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=A,e.$oe=O,e.$pe=M,e.$qe=p,e.$re=k,e.$se=N,e.$te=y,e.$ue=u,e.$ve=v,e.$we=m,e.$xe=s,e.$ye=o,e.$ze=r,e.$Ae=n,e.$Be=t;function A(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}function M(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function p(c,h){return new g(c,h)}class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let b;switch(h){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const a=b.indexOf(i);a>=0&&b.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,h){const i=[];let b;for(;(b=c.read())!==null;)i.push(b);return h(i)}function N(c,h,i){const b=[];let a;for(;(a=c.read())!==null&&b.length<i;)b.push(a);return a===null&&b.length>0?h(b):{read:()=>{if(b.length>0)return b.shift();if(typeof a<"u"){const $=a;return a=void 0,$}return c.read()}}}function y(c,h){return new Promise((i,b)=>{const a=[];u(c,{onData:$=>{h&&a.push($)},onError:$=>{h?b($):i(void 0)},onEnd:()=>{i(h?h(a):void 0)}})})}function u(c,h,i){c.on("error",b=>{i?.isCancellationRequested||h.onError(b)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",b=>{i?.isCancellationRequested||h.onData(b)})}function v(c,h){return new Promise((i,b)=>{const a=new T.$Tc,$=[],l=E=>{if($.push(E),$.length>h)return a.dispose(),c.pause(),i({stream:c,buffer:$,ended:!1})},S=E=>(a.dispose(),b(E)),d=()=>(a.dispose(),i({stream:c,buffer:$,ended:!0}));a.add((0,T.$Sc)(()=>c.removeListener("error",S))),c.on("error",S),a.add((0,T.$Sc)(()=>c.removeListener("end",d))),c.on("end",d),a.add((0,T.$Sc)(()=>c.removeListener("data",l))),c.on("data",l)})}function m(c,h){const i=p(h);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function r(c,h,i){const b=p(i);return u(c,{onData:a=>b.write(h.data(a)),onError:a=>b.error(h.error?h.error(a):a),onEnd:()=>b.end()}),b}function n(c,h,i){let b=!1;return{read:()=>{const a=h.read();return b?a:(b=!0,a!==null?i([c,a]):c)}}}function t(c,h,i){let b=!1;const a=p(i);return u(h,{onData:$=>b?a.write($):(b=!0,a.write(i([c,$]))),onError:$=>a.error($),onEnd:()=>{b||(b=!0,a.write(c)),a.end()}}),a}}),define(Ae[23],Re([1,0,41,128]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=k,e.$Ee=N,e.$Fe=y,e.$Ge=u,e.$He=v,e.$Ie=m,e.$Je=s,e.$Ke=o,e.$Le=r,e.$Me=n,e.$Ne=t,e.$Oe=c,e.$Pe=h,e.$Qe=i,e.$Re=b,e.$Se=a,e.$Te=$,e.$Ue=l,e.$Ve=S,e.$We=f;const A=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let M,p;class g{static alloc(w){return A?new g(Buffer.allocUnsafe(w)):new g(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new g(w)}static fromString(w,C){return!(C?.dontUseNodeBuffer||!1)&&A?new g(Buffer.from(w)):(M||(M=new TextEncoder),new g(M.encode(w)))}static fromByteArray(w){const C=g.alloc(w.length);for(let P=0,V=w.length;P<V;P++)C.buffer[P]=w[P];return C}static concat(w,C){if(typeof C>"u"){C=0;for(let W=0,q=w.length;W<q;W++)C+=w[W].byteLength}const P=g.alloc(C);let V=0;for(let W=0,q=w.length;W<q;W++){const R=w[W];P.set(R,V),V+=R.byteLength}return P}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=g.alloc(this.byteLength);return w.set(this),w}toString(){return A?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(w,C){return new g(this.buffer.subarray(w,C))}set(w,C){if(w instanceof g)this.buffer.set(w.buffer,C);else if(w instanceof Uint8Array)this.buffer.set(w,C);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),C);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,C){v(this.buffer,w,C)}readUInt32LE(w){return m(this.buffer,w)}writeUInt32LE(w,C){s(this.buffer,w,C)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,C){r(this.buffer,w,C)}indexOf(w,C=0){return k(this.buffer,w instanceof g?w.buffer:w,C)}}e.$Ce=g;function k(D,w,C=0){const P=w.byteLength,V=D.byteLength;if(P===0)return 0;if(P===1)return D.indexOf(w[0]);if(P>V-C)return-1;const W=O.value;W.fill(w.length);for(let K=0;K<w.length;K++)W[w[K]]=w.length-K-1;let q=C+w.length-1,R=q,j=-1;for(;q<V;)if(D[q]===w[R]){if(R===0){j=q;break}q--,R--}else q+=Math.max(w.length-R,W[D[q]]),R=w.length-1;return j}function N(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0}function y(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255}function u(D,w){return D[w]*2**24+D[w+1]*2**16+D[w+2]*2**8+D[w+3]}function v(D,w,C){D[C+3]=w,w=w>>>8,D[C+2]=w,w=w>>>8,D[C+1]=w,w=w>>>8,D[C]=w}function m(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0|D[w+2]<<16>>>0|D[w+3]<<24>>>0}function s(D,w,C){D[C+0]=w&255,w=w>>>8,D[C+1]=w&255,w=w>>>8,D[C+2]=w&255,w=w>>>8,D[C+3]=w&255}function o(D,w){return D[w]}function r(D,w,C){D[C]=w}function n(D){return T.$re(D,w=>g.concat(w))}function t(D){return T.$ye(D)}function c(D){return T.$te(D,w=>g.concat(w))}async function h(D){return D.ended?g.concat(D.buffer):g.concat([...D.buffer,await c(D.stream)])}function i(D){return T.$we(D,w=>g.concat(w))}function b(D){return T.$ze(D,{data:w=>typeof w=="string"?g.fromString(w):g.wrap(w)},w=>g.concat(w))}function a(D){return T.$qe(w=>g.concat(w),D)}function $(D,w){return T.$Ae(D,w,C=>g.concat(C))}function l(D,w){return T.$Be(D,w,C=>g.concat(C))}function S(D){let w=0,C=0,P=0;const V=new Uint8Array(Math.floor(D.length/4*3)),W=R=>{switch(C){case 3:V[P++]=w|R,C=0;break;case 2:V[P++]=w|R>>>2,w=R<<6,C=3;break;case 1:V[P++]=w|R>>>4,w=R<<4,C=2;break;default:w=R<<2,C=1}};for(let R=0;R<D.length;R++){const j=D.charCodeAt(R);if(j>=65&&j<=90)W(j-65);else if(j>=97&&j<=122)W(j-97+26);else if(j>=48&&j<=57)W(j-48+52);else if(j===43||j===45)W(62);else if(j===47||j===95)W(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${D[R]}`)}}const q=P;for(;C>0;)W(0);return g.wrap(V).slice(0,q)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:D},w=!0,C=!1){const P=C?E:d;let V="";const W=D.byteLength%3;let q=0;for(;q<D.byteLength-W;q+=3){const R=D[q+0],j=D[q+1],K=D[q+2];V+=P[R>>>2],V+=P[(R<<4|j>>>4)&63],V+=P[(j<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const R=D[q+0];V+=P[R>>>2],V+=P[R<<4&63],w&&(V+="==")}else if(W===2){const R=D[q+0],j=D[q+1];V+=P[R>>>2],V+=P[(R<<4|j>>>4)&63],V+=P[j<<2&63],w&&(V+="=")}return V}}),define(Ae[129],Re([1,0,28,125,15]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=O,e.$tk=p,e.$uk=g,e.$vk=y,e.$wk=S,e.$xk=d,e.$yk=P,e.$zk=V,e.$Ak=W,e.$Bk=q,e.$Ck=x,e.$Ek=$e,e.$Fk=Y,e.$Gk=he;function O(...de){return function(Ce,Me){for(let ze=0,z=de.length;ze<z;ze++){const L=de[ze](Ce,Me);if(L)return L}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(de,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return de?ze=A.$uf(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(de,Ce){const Me=Ce.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function g(de,Ce){return k(de.toLowerCase(),Ce.toLowerCase(),0,0)}function k(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]===Ce[ze]){let z=null;return(z=k(de,Ce,Me+1,ze+1))?c({start:ze,end:ze+1},z):null}return k(de,Ce,Me,ze+1)}function N(de){return 97<=de&&de<=122}function y(de){return 65<=de&&de<=90}function u(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>m.add(de.charCodeAt(0)));function s(de){return v(de)||m.has(de)}function o(de,Ce){return de===Ce||s(de)&&s(Ce)}const r=new Map;function n(de){if(r.has(de))return r.get(de);let Ce;const Me=(0,T.$pk)(de);return Me&&(Ce=Me),r.set(de,Ce),Ce}function t(de){return N(de)||y(de)||u(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function h(de,Ce){for(let Me=Ce;Me<de.length;Me++){const ze=de.charCodeAt(Me);if(y(ze)||u(ze)||Me>0&&!t(de.charCodeAt(Me-1)))return Me}return de.length}function i(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]!==Ce[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=i(de,Ce,Me+1,ze+1);!z&&(L=h(Ce,L))<Ce.length;)z=i(de,Ce,Me+1,L),L++;return z===null?null:c({start:ze,end:ze+1},z)}}function b(de){let Ce=0,Me=0,ze=0,z=0,L=0;for(let Ne=0;Ne<de.length;Ne++)L=de.charCodeAt(Ne),y(L)&&Ce++,N(L)&&Me++,t(L)&&ze++,u(L)&&z++;const G=Ce/de.length,H=Me/de.length,ee=ze/de.length,re=z/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Me}=de;return Me===0&&Ce>.6}function $(de){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=de;return Me>.2&&Ce<.8&&ze>.6&&z<.2}function l(de){let Ce=0,Me=0,ze=0,z=0;for(let L=0;L<de.length;L++)ze=de.charCodeAt(L),y(ze)&&Ce++,N(ze)&&Me++,v(ze)&&z++;return(Ce===0||Me===0)&&z===0?de.length<=30:Ce<=5}function S(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!l(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=b(Ce);if(!$(Me)){if(!a(Me))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(ze=i(de,Ce,0,z))===null;)z=h(Ce,z+1);return ze}function d(de,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=E(de,Ce,0,z,Me),ze===null);)z=f(Ce,z+1);return ze}function E(de,Ce,Me,ze,z){let L=0;if(Me===de.length)return[];if(ze===Ce.length)return null;if(!o(de.charCodeAt(Me),Ce.charCodeAt(ze))){const ee=n(de.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],Ce.charCodeAt(ze+re)))return null;L+=ee.length-1}let G=null,H=ze+L+1;if(G=E(de,Ce,Me+1,H,z),!z)for(;!G&&(H=f(Ce,H))<Ce.length;)G=E(de,Ce,Me+1,H,z),H++;if(!G)return null;if(de.charCodeAt(Me)!==Ce.charCodeAt(ze)){const ee=n(de.charCodeAt(Me));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(ze+re))return G}return c({start:ze,end:ze+L+1},G)}function f(de,Ce){for(let Me=Ce;Me<de.length;Me++)if(s(de.charCodeAt(Me))||Me>0&&s(de.charCodeAt(Me-1)))return Me;return de.length}const D=O(e.$sk,S,p),w=O(e.$sk,S,g),C=new I.$Ec(1e4);function P(de,Ce,Me=!1){if(typeof de!="string"||typeof Ce!="string")return null;let ze=C.get(de);ze||(ze=new RegExp(A.$cf(de),"i"),C.set(de,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Me?w(de,Ce):D(de,Ce)}function V(de,Ce){const Me=$e(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(de,Ce,Me,ze,z,L){const G=Math.min(13,de.length);for(;Me<G;Me++){const H=$e(de,Ce,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(de){if(typeof de>"u")return[];const Ce=[],Me=de[1];for(let ze=de.length-1;ze>1;ze--){const z=de[ze]+Me,L=Ce[Ce.length-1];L&&L.end===z?L.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const R=128;function j(){const de=[],Ce=[];for(let Me=0;Me<=R;Me++)Ce[Me]=0;for(let Me=0;Me<=R;Me++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Me=0;Me<=de;Me++)Ce[Me]=0;return Ce}const se=K(2*R),ce=K(2*R),ve=j(),Ie=j(),ue=j(),be=!1;function ie(de,Ce,Me,ze,z){function L(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,z+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return G}function Pe(de,Ce,Me,ze){de=de.substr(Ce),Me=Me.substr(ze),console.log(ie(Ie,de,de.length,Me,Me.length)),console.log(ie(ue,de,de.length,Me,Me.length)),console.log(ie(ve,de,de.length,Me,Me.length))}function Fe(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Me=de.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Mf(Me)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function U(de,Ce,Me){return Ce[de]!==Me[de]}function x(de,Ce,Me,ze,z,L,G=!1){for(;Ce<Me&&z<L;)de[Ce]===ze[z]&&(G&&(se[Ce]=z),Ce+=1),z+=1;return Ce===Me}var pe;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Oe;(function(de){de.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Ce})(Oe||(e.FuzzyScore=Oe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Dk=ke;function $e(de,Ce,Me,ze,z,L,G=ke.default){const H=de.length>R?R:de.length,ee=ze.length>R?R:ze.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Ce,Me,H,z,L,ee,!0))return;fe(H,ee,Me,L,Ce,z);let re=1,Ne=1,Be=Me,Qe=L;const _e=[!1];for(re=1,Be=Me;Be<H;re++,Be++){const at=se[Be],mt=ce[Be],Ue=Be+1<H?ce[Be+1]:ee;for(Ne=at-L+1,Qe=at;Qe<Ue;Ne++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=mt&&(st=J(de,Ce,Be,Me,ze,z,Qe,ee,L,ve[re-1][Ne-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Ie[re-1][Ne-1]);const me=Qe>at,He=me?Ie[re][Ne-1]+(ve[re][Ne-1]>0?-5:0):0,ye=Qe>at+1&&ve[re][Ne-1]>0,ot=ye?Ie[re][Ne-2]+(ve[re][Ne-2]>0?-5:0):0;if(ye&&(!me||ot>=He)&&(!X||ot>=Z))Ie[re][Ne]=ot,ue[re][Ne]=3,ve[re][Ne]=0;else if(me&&(!X||He>=Z))Ie[re][Ne]=He,ue[re][Ne]=2,ve[re][Ne]=0;else if(X)Ie[re][Ne]=Z,ue[re][Ne]=1,ve[re][Ne]=ve[re-1][Ne-1]+1;else throw new Error("not possible")}}if(be&&Pe(de,Me,ze,L),!_e[0]&&!G.firstMatchCanBeWeak)return;re--,Ne--;const et=[Ie[re][Ne],L];let tt=0,it=0;for(;re>=1;){let at=Ne;do{const mt=ue[re][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Ce[Me+re-1]===z[L+Ne-1]&&!U(at+L-1,ze,z)&&tt+1>ve[re][at]&&(at=Ne),at===Ne?tt++:tt=1,it||(it=at),re--,Ne=at-1,et.push(Ne)}ee===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function fe(de,Ce,Me,ze,z,L){let G=de-1,H=Ce-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function J(de,Ce,Me,ze,z,L,G,H,ee,re,Ne){if(Ce[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=de[Me]===z[G]?7:5:U(G,z,L)&&(G===0||!U(G-1,z,L))?(Be=de[Me]===z[G]?7:5,Qe=!0):Fe(L,G)&&(G===0||!Fe(L,G-1))?Be=5:(Fe(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Ne[0]=!0),Qe||(Qe=U(G,z,L)||Fe(L,G-1)||ne(L,G-1)),Me===ze?G>ee&&(Be-=Qe?3:5):re?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!0,G)}function he(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!1,G)}function le(de,Ce,Me,ze,z,L,G,H){let ee=$e(de,Ce,Me,ze,z,L,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Ne=Me+1;Ne<re;Ne++){const Be=Te(de,Ne);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Te(de,Ce){if(Ce+1>=de.length)return;const Me=de[Ce],ze=de[Ce+1];if(Me!==ze)return de.slice(0,Ce)+ze+Me+de.slice(Ce+2)}}),define(Ae[33],Re([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(T||(T={})),function(A){const O="error",M="warning",p="warn",g="info",k="ignore";function N(u){return u?I.$tf(O,u)?A.Error:I.$tf(M,u)||I.$tf(p,u)?A.Warning:I.$tf(g,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=N;function y(u){switch(u){case A.Error:return O;case A.Warning:return M;case A.Info:return g;default:return k}}A.toString=y}(T||(T={})),e.default=T}),define(Ae[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Ae[52],Re([1,0,18,15]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class A{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$si=A;class O{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$nf)(v,this.b,0,v.length,this.c,this.d):(0,T.$pf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=O;class M{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$nf)(v,this.b,0,v.length,this.d,this.e):(0,T.$pf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$of)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$of)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$mf)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$mf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=g;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(N||(N={}));class y{static forUris(v=()=>!1,m=()=>!1){return new y(new g(v,m))}static forPaths(v=!1){return new y(new M(void 0,!v))}static forStrings(){return new y(new A)}static forConfigKeys(){return new y(new O)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const s=m.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o,v)}else{const s=v.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(v,m){const s=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=s.value());const r=[];for(o=this.c;;){const t=s.cmp(o.segment);if(t>0)o.left||(o.left=new k,o.left.segment=s.value()),r.push([-1,o]),o=o.left;else if(t<0)o.right||(o.right=new k,o.right.segment=s.value()),r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),r.push([0,o]),o=o.mid;else break}const n=o.value;o.value=m,o.key=v;for(let t=r.length-1;t>=0;t--){const c=r[t][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=r[t][0],b=r[t+1][0];if(i===1&&b===1)r[t][1]=c.rotateLeft();else if(i===-1&&b===-1)r[t][1]=c.rotateRight();else if(i===1&&b===-1)c.right=r[t+1][1]=r[t+1][1].rotateRight(),r[t][1]=c.rotateLeft();else if(i===-1&&b===1)c.left=r[t+1][1]=r[t+1][1].rotateLeft(),r[t][1]=c.rotateRight();else throw new Error;if(t>0)switch(r[t-1][0]){case-1:r[t-1][1].left=r[t][1];break;case 1:r[t-1][1].right=r[t][1];break;case 0:r[t-1][1].mid=r[t][1];break}else this.c=r[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const s=this.b.reset(v),o=[];let r=this.c;for(;r;){const n=s.cmp(r.segment);if(n>0)o.push([-1,r]),r=r.left;else if(n<0)o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),o.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const n=this.f(r.right);if(n.key){const{key:t,value:c,segment:h}=n;this.e(n.key,!1),r.key=t,r.value=c,r.segment=h}}else{const n=r.left??r.right;if(o.length>0){const[t,c]=o[o.length-1];switch(t){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const t=o[n][1];t.updateHeight();const c=t.balanceFactor();if(c>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),o[n][1]=t.rotateLeft()):c<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),o[n][1]=t.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let s=this.c,o;for(;s;){const r=m.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const s=this.b.reset(v);let o=this.c;for(;o;){const r=s.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,s]of this)v(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){v&&(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.$wi=y}),define(Ae[42],Re([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=A;var T;(function(M){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=p})(T||(e.ThemeColor=T={}));function A(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(n){const t=p.exec(n.id);if(!t)return g(I.$Pj.error);const[,c,h]=t,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}M.asClassNameArray=g;function k(n){return g(n).join(" ")}M.asClassName=k;function N(n){return"."+g(n).join(".")}M.asCSSSelector=N;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}M.isThemeIcon=y;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(n){const t=u.exec(n);if(!t)return;const[,c]=t;return{id:c}}M.fromString=v;function m(n){return{id:n}}M.fromId=m;function s(n,t){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),t&&(c=`${c}~${t}`),{id:c}}M.modify=s;function o(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}M.getModifier=o;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}M.isEqual=r})(O||(e.ThemeIcon=O={}))}),define(Ae[131],Re([1,0,129,15,42]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=g,e.$Ik=N,e.$Jk=u,e.$Kk=v,e.$Lk=s,e.$Mk=o;const O="$(",M=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function g(r){return r.replace(p,(n,t)=>t?n:`\\${n}`)}const k=new RegExp(`\\\\${M.source}`,"g");function N(r){return r.replace(k,n=>`\\${n}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(r){return r.indexOf(O)===-1?r:r.replace(y,(n,t,c,h)=>c?n:t||h||"")}function v(r){return r?r.replace(/\$\((.*?)\)/g,(n,t)=>` ${t} `).trim():""}const m=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){m.lastIndex=0;let n="";const t=[];let c=0;for(;;){const h=m.lastIndex,i=m.exec(r),b=r.substring(h,i?.index);if(b.length>0){n+=b;for(let a=0;a<b.length;a++)t.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:t}}function o(r,n,t=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$yk)(r,c,t);const i=(0,T.$af)(c," "),b=c.length-i.length,a=(0,I.$yk)(r,i,t);if(a)for(const $ of a){const l=h[$.start+b]+b;$.start+=l,$.end+=l}return a}}),define(Ae[35],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=T;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(A){return I.test(A)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){A(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,k="";return k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+="-",k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k+=M[O[g++]],k}}()}),define(Ae[132],Re([1,0,18,40,35]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=O,e.$Ht=M,e.$Jt=k;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,u,v){const m={id:(0,A.$Mg)(),name:y,uri:u,data:v};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let u=0;for(const v of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const v=[...this.a.keys()];return T.Iterable.some(this,([m,s])=>s.asFile())&&v.push("files"),N(g(u),v)}get(u){return this.a.get(this.b(u))?.[0]}append(u,v){const m=this.a.get(u);m?m.push(v):this.a.set(this.b(u),[v])}replace(u,v){this.a.set(this.b(u),[v])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,v]of this.a)for(const m of v)yield[u,m]}b(u){return g(u)}}e.$It=p;function g(y){return y.toLowerCase()}function k(y,u){return N(g(y),u.map(g))}function N(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const v=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[m,s,o]=v;return o==="*"?u.some(r=>r.startsWith(s+"/")):!1}e.$Kt=Object.freeze({create:y=>(0,I.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Kt.split(y).filter(u=>!u.startsWith("#"))})}),define(Ae[133],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=T;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function T(A){let O=0,M=0,p=0,g=0;for(let k=0,N=A.length;k<N;k++){const y=A.charCodeAt(k);y===13?(O===0&&(M=k),O++,k+1<N&&A.charCodeAt(k+1)===10?(g|=2,k++):g|=3,p=k+1):y===10&&(g|=1,O===0&&(M=k),O++,p=k+1)}return O===0&&(M=A.length),[O,M,A.length-p,g]}}),define(Ae[134],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[135],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let g=0,k=p.notIn.length;g<k;g++)switch(p.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,g){if(p.getTokenCount()===0)return!0;const k=p.findTokenIndexAtOffset(g-2),N=p.getStandardTokenType(k);return this.isOK(N)}g(p,g){for(let k=p;k<=g;k++){const N=String.fromCharCode(k);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=T;class A{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of p)O(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),O(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),O(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),O(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&O(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$bu=A;function O(M,p,g){M.has(p)?M.get(p).push(g):M.set(p,[g])}}),define(Ae[136],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.NodeColor=e.$pC=void 0,e.$rC=A,e.$sC=O,e.$tC=k,e.$uC=N,e.$vC=y,e.$wC=u,e.$xC=v,e.$yC=m;class I{constructor(o,r){this.piece=o,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$qC)return A(this.right);let o=this;for(;o.parent!==e.$qC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$qC?e.$qC:o.parent}prev(){if(this.left!==e.$qC)return O(this.left);let o=this;for(;o.parent!==e.$qC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$qC?e.$qC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$pC=I;var T;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$qC=new I(null,0),e.$qC.parent=e.$qC,e.$qC.left=e.$qC,e.$qC.right=e.$qC,e.$qC.color=0;function A(s){for(;s.left!==e.$qC;)s=s.left;return s}function O(s){for(;s.right!==e.$qC;)s=s.right;return s}function M(s){return s===e.$qC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$qC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function g(){e.$qC.parent=e.$qC}function k(s,o){const r=o.right;r.size_left+=o.size_left+(o.piece?o.piece.length:0),r.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=r.left,r.left!==e.$qC&&(r.left.parent=o),r.parent=o.parent,o.parent===e.$qC?s.root=r:o.parent.left===o?o.parent.left=r:o.parent.right=r,r.left=o,o.parent=r}function N(s,o){const r=o.left;o.left=r.right,r.right!==e.$qC&&(r.right.parent=o),r.parent=o.parent,o.size_left-=r.size_left+(r.piece?r.piece.length:0),o.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),o.parent===e.$qC?s.root=r:o===o.parent.right?o.parent.right=r:o.parent.left=r,r.right=o,o.parent=r}function y(s,o){let r,n;if(o.left===e.$qC?(n=o,r=n.right):o.right===e.$qC?(n=o,r=n.left):(n=A(o.right),r=n.right),n===s.root){s.root=r,r.color=0,o.detach(),g(),s.root.parent=e.$qC;return}const t=n.color===1;if(n===n.parent.left?n.parent.left=r:n.parent.right=r,n===o?(r.parent=n.parent,m(s,r)):(n.parent===o?r.parent=n:r.parent=n.parent,m(s,r),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===s.root?s.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$qC&&(n.left.parent=n),n.right!==e.$qC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,m(s,n)),o.detach(),r.parent.left===r){const h=M(r),i=p(r);if(h!==r.parent.size_left||i!==r.parent.lf_left){const b=h-r.parent.size_left,a=i-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=i,v(s,r.parent,b,a)}}if(m(s,r.parent),t){g();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,k(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,k(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,N(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,N(s,r.parent),r=s.root));r.color=0,g()}function u(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const r=o.parent.parent.right;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(s,o)),o.parent.color=0,o.parent.parent.color=1,N(s,o.parent.parent))}else{const r=o.parent.parent.left;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,N(s,o)),o.parent.color=0,o.parent.parent.color=1,k(s,o.parent.parent))}s.root.color=0}function v(s,o,r,n){for(;o!==s.root&&o!==e.$qC;)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}function m(s,o){let r=0,n=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,r=M(o.left)-o.size_left,n=p(o.left)-o.lf_left,o.size_left+=r,o.lf_left+=n;o!==s.root&&(r!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=n),o=o.parent}}}),define(Ae[92],Re([1,0,93,29,94,136,95]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.$HC=void 0,e.$FC=N,e.$GC=y;const p=65535;function g(r){let n;return r[r.length-1]<65536?n=new Uint16Array(r.length):n=new Uint32Array(r.length),n.set(r,0),n}class k{constructor(n,t,c,h,i){this.lineStarts=n,this.cr=t,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function N(r,n=!0){const t=[0];let c=1;for(let h=0,i=r.length;h<i;h++){const b=r.charCodeAt(h);b===13?h+1<i&&r.charCodeAt(h+1)===10?(t[c++]=h+2,h++):t[c++]=h+1:b===10&&(t[c++]=h+1)}return n?g(t):t}function y(r,n){r.length=0,r[0]=0;let t=1,c=0,h=0,i=0,b=!0;for(let $=0,l=n.length;$<l;$++){const S=n.charCodeAt($);S===13?$+1<l&&n.charCodeAt($+1)===10?(i++,r[t++]=$+2,$++):(c++,r[t++]=$+1):S===10?(h++,r[t++]=$+1):b&&S!==9&&(S<32||S>126)&&(b=!1)}const a=new k(g(r),c,h,i,b);return r.length=0,a}class u{constructor(n,t,c,h,i){this.bufferIndex=n,this.start=t,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$HC=u;class v{constructor(n,t){this.buffer=n,this.lineStarts=t}}e.$IC=v;class m{constructor(n,t){this.a=[],this.c=n,this.d=t,this.b=0,n.root!==O.$qC&&n.iterate(n.root,c=>(c!==O.$qC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let t=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,t=!0;continue}}if(t){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,t,c){this.create(n,t,c)}create(n,t,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=O.$qC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=c;let h=null;for(let i=0,b=n.length;i<b;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=N(n[i].buffer));const a=new u(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const t=p,c=t-Math.floor(t/3),h=c*2;let i="",b=0;const a=[];if(this.iterate(this.root,$=>{const l=this.R($),S=l.length;if(b<=c||b+S<h)return i+=l,b+=S,!0;const d=i.replace(/\r\n|\r|\n/g,n);return a.push(new v(d,N(d))),i=l,b=S,!0}),b>0){const $=i.replace(/\r\n|\r|\n/g,n);a.push(new v($,N($)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new m(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let t=0;return this.iterate(this.root,h=>{if(h===O.$qC)return!0;const i=this.R(h),b=i.length,a=n.G(t),$=n.G(t+b),l=n.getValueInRange2(a,$);return t+=b,i===l})}getOffsetAt(n,t){let c=0,h=this.root;for(;h!==O.$qC;)if(h.left!==O.$qC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+t-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let t=this.root,c=0;const h=n;for(;t!==O.$qC;)if(t.size_left!==0&&t.size_left>=n)t=t.left;else if(t.size_left+t.piece.length>=n){const i=this.A(t,n-t.size_left);if(c+=t.lf_left+i.index,i.index===0){const b=this.getOffsetAt(c+1,1),a=h-b;return new I.$jt(c+1,a+1)}return new I.$jt(c+1,i.remainder+1)}else if(n-=t.size_left+t.piece.length,c+=t.lf_left+t.piece.lineFeedCnt,t.right===O.$qC){const i=this.getOffsetAt(c+1,1),b=h-n-i;return new I.$jt(c+1,b+1)}else t=t.right;return new I.$jt(1,1)}getValueInRange(n,t){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(n,t){if(n.node===t.node){const a=n.node,$=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return $.substring(l+n.remainder,l+t.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let b=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==O.$qC;){const a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(c===t.node){b+=a.substring($,$+t.remainder);break}else b+=a.substr($,c.piece.length);c=c.next()}return b}getLinesContent(){const n=[];let t=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===O.$qC)return!0;const b=i.piece;let a=b.length;if(a===0)return!0;const $=this.a[b.bufferIndex].buffer,l=this.a[b.bufferIndex].lineStarts,S=b.start.line,d=b.end.line;let E=l[S]+b.start.column;if(h&&($.charCodeAt(E)===10&&(E++,a--),n[t++]=c,c="",h=!1,a===0))return!0;if(S===d)return!this.f&&$.charCodeAt(E+a-1)===13?(h=!0,c+=$.substr(E,a-1)):c+=$.substr(E,a),!0;c+=this.f?$.substring(E,Math.max(E,l[S+1]-this.e)):$.substring(E,l[S+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;for(let f=S+1;f<d;f++)c=this.f?$.substring(l[f],l[f+1]-this.e):$.substring(l[f],l[f+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;return!this.f&&$.charCodeAt(l[d]+b.end.column-1)===13?(h=!0,b.end.column===0?t--:c=$.substr(l[d],b.end.column-1)):c=$.substr(l[d],b.end.column),!0}),h&&(n[t++]=c,c=""),n[t++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t)return 0;const c=this.a[t.piece.bufferIndex],h=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.charCodeAt(h)}else{const t=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return t.buffer.charCodeAt(h)}}getLineCharCode(n,t){const c=this.H(n,t+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const t=this.getOffsetAt(n,1);return this.getLength()-t}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const t=this.G(n);return this.l(t)}findMatchesInNode(n,t,c,h,i,b,a,$,l,S,d){const E=this.a[n.piece.bufferIndex],f=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,i),w=this.u(n.piece.bufferIndex,b);let C;const P={line:0,column:0};let V,W;t._wordSeparators?(V=E.buffer.substring(D,w),W=q=>q+D,t.reset(0)):(V=E.buffer,W=q=>q,t.reset(D));do if(C=t.next(V),C){if(W(C.index)>=w)return S;this.s(n,W(C.index)-f,P);const q=this.t(n.piece.bufferIndex,i,P),R=P.line===i.line?P.column-i.column+h:P.column+1,j=R+C[0].length;if(d[S++]=(0,M.$BC)(new T.$kt(c+q,R,c+q,j),C,$),W(C.index)+C[0].length>=w||S>=l)return S}while(C);return S}findMatchesLineByLine(n,t,c,h){const i=[];let b=0;const a=new M.$EC(t.wordSeparators,t.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const l=this.H(n.endLineNumber,n.endColumn);if(l===null)return[];let S=this.s($.node,$.remainder);const d=this.s(l.node,l.remainder);if($.node===l.node)return this.findMatchesInNode($.node,a,n.startLineNumber,n.startColumn,S,d,t,c,h,b,i),i;let E=n.startLineNumber,f=$.node;for(;f!==l.node;){const w=this.t(f.piece.bufferIndex,S,f.piece.end);if(w>=1){const P=this.a[f.piece.bufferIndex].lineStarts,V=this.u(f.piece.bufferIndex,f.piece.start),W=P[S.line+w],q=E===n.startLineNumber?n.startColumn:1;if(b=this.findMatchesInNode(f,a,E,q,S,this.s(f,W-V),t,c,h,b,i),b>=h)return i;E+=w}const C=E===n.startLineNumber?n.startColumn-1:0;if(E===n.endLineNumber){const P=this.getLineContent(E).substring(C,n.endColumn-1);return b=this.n(t,a,P,n.endLineNumber,C,b,i,c,h),i}if(b=this.n(t,a,this.getLineContent(E).substr(C),E,C,b,i,c,h),b>=h)return i;E++,$=this.H(E,1),f=$.node,S=this.s($.node,$.remainder)}if(E===n.endLineNumber){const w=E===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(E).substring(w,n.endColumn-1);return b=this.n(t,a,C,n.endLineNumber,w,b,i,c,h),i}const D=E===n.startLineNumber?n.startColumn:1;return b=this.findMatchesInNode(l.node,a,E,D,S,d,t,c,h,b,i),i}n(n,t,c,h,i,b,a,$,l){const S=n.wordSeparators;if(!$&&n.simpleSearch){const E=n.simpleSearch,f=E.length,D=c.length;let w=-f;for(;(w=c.indexOf(E,w+f))!==-1;)if((!S||(0,M.$DC)(S,c,D,w,f))&&(a[b++]=new A.$vv(new T.$kt(h,w+1+i,h,w+1+f+i),null),b>=l))return b;return b}let d;t.reset(0);do if(d=t.next(c),d&&(a[b++]=(0,M.$BC)(new T.$kt(h,d.index+1+i,h,d.index+1+d[0].length+i),d,$),b>=l))return b;while(d);return b}insert(n,t,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$qC){const{node:h,remainder:i,nodeStartOffset:b}=this.G(n),a=h.piece,$=a.bufferIndex,l=this.s(h,i);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&b+a.length===n&&t.length<p){this.F(h,t),this.y();return}if(b===n)this.o(t,h),this.h.validate(n);else if(b+h.piece.length>n){const S=[];let d=new u(a.bufferIndex,l,a.end,this.t(a.bufferIndex,l,a.end),this.u($,a.end)-this.u($,l));if(this.K()&&this.M(t)&&this.I(h,i)===10){const w={line:d.start.line+1,column:0};d=new u(d.bufferIndex,w,d.end,this.t(d.bufferIndex,w,d.end),d.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(h,i-1)===13){const w=this.s(h,i-1);this.C(h,w),t="\r"+t,h.piece.length===0&&S.push(h)}else this.C(h,l);else this.C(h,l);const E=this.w(t);d.length>0&&this.S(h,d);let f=h;for(let D=0;D<E.length;D++)f=this.S(f,E[D]);this.v(S)}else this.q(t,h)}else{const h=this.w(t);let i=this.T(null,h[0]);for(let b=1;b<h.length;b++)i=this.S(i,h[b])}this.y()}delete(n,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===O.$qC)return;const c=this.G(n),h=this.G(n+t),i=c.node,b=h.node;if(i===b){const E=this.s(i,c.remainder),f=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(t===i.piece.length){const D=i.next();(0,O.$vC)(this,i),this.N(D),this.y();return}this.D(i,f),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+t){this.C(i,E),this.O(i),this.y();return}this.E(i,E,f),this.y();return}const a=[],$=this.s(i,c.remainder);this.C(i,$),this.h.validate(n),i.piece.length===0&&a.push(i);const l=this.s(b,h.remainder);this.D(b,l),b.piece.length===0&&a.push(b);const S=i.next();for(let E=S;E!==O.$qC&&E!==b;E=E.next())a.push(E);const d=i.piece.length===0?i.prev():i;this.v(a),this.O(d),this.y()}o(n,t){const c=[];if(this.K()&&this.M(n)&&this.L(t)){const b=t.piece,a={line:b.start.line+1,column:0},$=new u(b.bufferIndex,a,b.end,this.t(b.bufferIndex,a,b.end),b.length-1);t.piece=$,n+=`
`,(0,O.$xC)(this,t,-1,-1),t.piece.length===0&&c.push(t)}const h=this.w(n);let i=this.T(t,h[h.length-1]);for(let b=h.length-2;b>=0;b--)i=this.T(i,h[b]);this.N(i),this.v(c)}q(n,t){this.Q(n,t)&&(n+=`
`);const c=this.w(n),h=this.S(t,c[0]);let i=h;for(let b=1;b<c.length;b++)i=this.S(i,c[b]);this.N(h)}s(n,t,c){const h=n.piece,i=n.piece.bufferIndex,b=this.a[i].lineStarts,$=b[h.start.line]+h.start.column+t;let l=h.start.line,S=h.end.line,d=0,E=0,f=0;for(;l<=S&&(d=l+(S-l)/2|0,f=b[d],d!==S);)if(E=b[d+1],$<f)S=d-1;else if($>=E)l=d+1;else break;return c?(c.line=d,c.column=$-f,null):{line:d,column:$-f}}t(n,t,c){if(c.column===0)return c.line-t.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-t.line;const i=h[c.line+1],b=h[c.line]+c.column;if(i>b+1)return c.line-t.line;const a=b-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-t.line+1:c.line-t.line}u(n,t){return this.a[n].lineStarts[t.line]+t.column}v(n){for(let t=0;t<n.length;t++)(0,O.$vC)(this,n[t])}w(n){if(n.length>p){const S=[];for(;n.length>p;){const E=n.charCodeAt(p-1);let f;E===13||E>=55296&&E<=56319?(f=n.substring(0,p-1),n=n.substring(p-1)):(f=n.substring(0,p),n=n.substring(p));const D=N(f);S.push(new u(this.a.length,{line:0,column:0},{line:D.length-1,column:f.length-D[D.length-1]},D.length-1,f.length)),this.a.push(new v(f,D))}const d=N(n);return S.push(new u(this.a.length,{line:0,column:0},{line:d.length-1,column:n.length-d[d.length-1]},d.length-1,n.length)),this.a.push(new v(n,d)),S}let t=this.a[0].buffer.length;const c=N(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let S=0;S<c.length;S++)c[S]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,t+=1}else{if(t!==0)for(let S=0;S<c.length;S++)c[S]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[b],$={line:b,column:a},l=new u(0,h,$,this.t(0,h,$),i-t);return this.g=$,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,t=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const b=this.B(c,n-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=a.substring($+b,$+c.piece.length);else{const l=this.B(c,n-i.nodeStartLineNumber);return a.substring($+b,$+l-t)}}else{let b=0;const a=n;for(;c!==O.$qC;)if(c.left!==O.$qC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const $=this.B(c,n-c.lf_left-2),l=this.B(c,n-c.lf_left-1),S=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);return b+=c.size_left,this.h.set({node:c,nodeStartOffset:b,nodeStartLineNumber:a-(n-1-c.lf_left)}),S.substring(d+$,d+l-t)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const $=this.B(c,n-c.lf_left-2),l=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);h=l.substring(S+$,S+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,b+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$qC;){const b=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),$=this.u(c.piece.bufferIndex,c.piece.start);return h+=b.substring($,$+a-t),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=b.substr(a,c.piece.length)}c=c.next()}return h}y(){let n=this.root,t=1,c=0;for(;n!==O.$qC;)t+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=t,this.c=c,this.h.validate(this.c)}A(n,t){const c=n.piece,h=this.s(n,t),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===t){const b=this.t(n.piece.bufferIndex,c.start,h);if(b!==i)return{index:b,remainder:0}}return{index:i,remainder:h.column}}B(n,t){if(t<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+t+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,t){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),b=t,a=this.u(c.bufferIndex,b),$=this.t(c.bufferIndex,c.start,b),l=$-h,S=a-i,d=c.length+S;n.piece=new u(c.bufferIndex,c.start,b,$,d),(0,O.$xC)(this,n,S,l)}D(n,t){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),b=t,a=this.t(c.bufferIndex,b,c.end),$=this.u(c.bufferIndex,b),l=a-h,S=i-$,d=c.length+S;n.piece=new u(c.bufferIndex,b,c.end,a,d),(0,O.$xC)(this,n,S,l)}E(n,t,c){const h=n.piece,i=h.start,b=h.end,a=h.length,$=h.lineFeedCnt,l=t,S=this.t(h.bufferIndex,h.start,l),d=this.u(h.bufferIndex,t)-this.u(h.bufferIndex,i);n.piece=new u(h.bufferIndex,h.start,l,S,d),(0,O.$xC)(this,n,d-a,S-$);const E=new u(h.bufferIndex,c,b,this.t(h.bufferIndex,c,b),this.u(h.bufferIndex,b)-this.u(h.bufferIndex,c)),f=this.S(n,E);this.N(f)}F(n,t){this.Q(t,n)&&(t+=`
`);const c=this.K()&&this.L(t)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=t;const i=N(t,!1);for(let f=0;f<i.length;f++)i[f]+=h;if(c){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const b=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[b],$={line:b,column:a},l=n.piece.length+t.length,S=n.piece.lineFeedCnt,d=this.t(0,n.piece.start,$),E=d-S;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,d,l),this.g=$,(0,O.$xC)(this,n,t.length,E)}G(n){let t=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;t!==O.$qC;)if(t.size_left>n)t=t.left;else if(t.size_left+t.piece.length>=n){h+=t.size_left;const i={node:t,remainder:n-t.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=t.size_left+t.piece.length,h+=t.size_left+t.piece.length,t=t.right;return null}H(n,t){let c=this.root,h=0;for(;c!==O.$qC;)if(c.left!==O.$qC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+t-1,b),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+t-1<=c.piece.length)return{node:c,remainder:i+t-1,nodeStartOffset:h};t-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$qC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),b=this.J(c);return{node:c,remainder:Math.min(t-1,i),nodeStartOffset:b}}else if(c.piece.length>=t-1){const i=this.J(c);return{node:c,remainder:t-1,nodeStartOffset:i}}else t-=c.piece.length;c=c.next()}return null}I(n,t){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+t;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let t=n.size_left;for(;n!==this.root;)n.parent.right===n&&(t+=n.parent.size_left+n.parent.piece.length),n=n.parent;return t}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===O.$qC||n.piece.lineFeedCnt===0)return!1;const t=n.piece,c=this.a[t.bufferIndex].lineStarts,h=t.start.line,i=c[h]+t.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===O.$qC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const t=n.prev();this.M(t)&&this.P(t,n)}}O(n){if(this.K()&&this.M(n)){const t=n.next();this.L(t)&&this.P(n,t)}}P(n,t){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const b=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,i,a,b),(0,O.$xC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const $={line:t.piece.start.line+1,column:0},l=t.piece.length-1,S=this.t(t.piece.bufferIndex,$,t.piece.end);t.piece=new u(t.piece.bufferIndex,$,t.piece.end,S,l),(0,O.$xC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const d=this.w(`\r
`);this.S(n,d[0]);for(let E=0;E<c.length;E++)(0,O.$vC)(this,c[E])}Q(n,t){if(this.K()&&this.M(n)){const c=t.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,O.$vC)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},b=h.length-1,a=this.t(h.bufferIndex,i,h.end);c.piece=new u(h.bufferIndex,i,h.end,a,b),(0,O.$xC)(this,c,-1,-1)}return!0}}return!1}iterate(n,t){if(n===O.$qC)return t(O.$qC);const c=this.iterate(n.left,t);return c&&t(n)&&this.iterate(n.right,t)}R(n){if(n===O.$qC)return"";const t=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return t.buffer.substring(h,i)}getPieceContent(n){const t=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return t.buffer.substring(c,h)}S(n,t){const c=new O.$pC(t,1);if(c.left=O.$qC,c.right=O.$qC,c.parent=O.$qC,c.size_left=0,c.lf_left=0,this.root===O.$qC)this.root=c,c.color=0;else if(n.right===O.$qC)n.right=c,c.parent=n;else{const i=(0,O.$rC)(n.right);i.left=c,c.parent=i}return(0,O.$wC)(this,c),c}T(n,t){const c=new O.$pC(t,1);if(c.left=O.$qC,c.right=O.$qC,c.parent=O.$qC,c.size_left=0,c.lf_left=0,this.root===O.$qC)this.root=c,c.color=0;else if(n.left===O.$qC)n.left=c,c.parent=n;else{const h=(0,O.$sC)(n.left);h.right=c,c.parent=h}return(0,O.$wC)(this,c),c}U(n){let t="";return this.iterate(n,c=>(t+=this.R(c),!0)),t}}e.$JC=o}),define(Ae[137],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9=e.$n9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$n9=I;class T{constructor(O){this.identifier=O}}e.$o9=T}),define(Ae[138],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ae[139],Re([1,0,5,6,138]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=N;class O extends T.$Uc{constructor(u,v="",m="",s=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=v,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,v){this.C&&await this.C(u)}}e.$8i=O;class M extends T.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(u,v){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,v)}catch(s){m=s}this.m.fire({action:u,error:m})}async u(u,v){await u.run(v)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let v=[];for(const m of u)m.length&&(v.length?v=[...v,new p,...m]:v=m);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class g{get actions(){return this.a}constructor(u,v,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=v,this.class=s,this.a=m}async run(){}}e.$$i=g;class k extends O{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,A.localize(0,null),void 0,!1)}}e.$_i=k;function N(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u),tooltip:y.label}}}),define(Ae[140],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ae[141],Re([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=k,e.$Wm=N,e.$Xm=y;const T=60,A=T*60,O=A*24,M=O*7,p=O*30,g=O*365;function k(u,v,m,s){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,I.localize)(1,null);let r;return o<T?(r=o,v?r===1?m?(0,I.localize)(2,null,r):(0,I.localize)(3,null,r):m?(0,I.localize)(4,null,r):(0,I.localize)(5,null,r):r===1?m?(0,I.localize)(6,null,r):(0,I.localize)(7,null,r):m?(0,I.localize)(8,null,r):(0,I.localize)(9,null,r)):o<A?(r=Math.floor(o/T),v?r===1?m?(0,I.localize)(10,null,r):(0,I.localize)(11,null,r):m?(0,I.localize)(12,null,r):(0,I.localize)(13,null,r):r===1?m?(0,I.localize)(14,null,r):(0,I.localize)(15,null,r):m?(0,I.localize)(16,null,r):(0,I.localize)(17,null,r)):o<O?(r=Math.floor(o/A),v?r===1?m?(0,I.localize)(18,null,r):(0,I.localize)(19,null,r):m?(0,I.localize)(20,null,r):(0,I.localize)(21,null,r):r===1?m?(0,I.localize)(22,null,r):(0,I.localize)(23,null,r):m?(0,I.localize)(24,null,r):(0,I.localize)(25,null,r)):o<M?(r=Math.floor(o/O),v?r===1?(0,I.localize)(26,null,r):(0,I.localize)(27,null,r):r===1?(0,I.localize)(28,null,r):(0,I.localize)(29,null,r)):o<p?(r=Math.floor(o/M),v?r===1?m?(0,I.localize)(30,null,r):(0,I.localize)(31,null,r):m?(0,I.localize)(32,null,r):(0,I.localize)(33,null,r):r===1?m?(0,I.localize)(34,null,r):(0,I.localize)(35,null,r):m?(0,I.localize)(36,null,r):(0,I.localize)(37,null,r)):o<g?(r=Math.floor(o/p),v?r===1?m?(0,I.localize)(38,null,r):(0,I.localize)(39,null,r):m?(0,I.localize)(40,null,r):(0,I.localize)(41,null,r):r===1?m?(0,I.localize)(42,null,r):(0,I.localize)(43,null,r):m?(0,I.localize)(44,null,r):(0,I.localize)(45,null,r)):(r=Math.floor(o/g),v?r===1?m?(0,I.localize)(46,null,r):(0,I.localize)(47,null,r):m?(0,I.localize)(48,null,r):(0,I.localize)(49,null,r):r===1?m?(0,I.localize)(50,null,r):(0,I.localize)(51,null,r):m?(0,I.localize)(52,null,r):(0,I.localize)(53,null,r))}function N(u,v){const m=Math.abs(u/1e3);return m<1?v?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):m<T?v?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):m<A?v?(0,I.localize)(58,null,Math.round(u/(1e3*T))):(0,I.localize)(59,null,Math.round(u/(1e3*T))):m<O?v?(0,I.localize)(60,null,Math.round(u/(1e3*A))):(0,I.localize)(61,null,Math.round(u/(1e3*A))):(0,I.localize)(62,null,Math.round(u/(1e3*O)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ae[142],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ae[43],Re([1,0,18,17,142]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=g,e.$cj=k,e.$dj=N;function O(y,u){return u&&(y.stack||y.stacktrace)?A.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?A.localize(1,null,y.message):y.message||A.localize(2,null)}function g(y=null,u=!1){if(!y)return A.localize(3,null);if(Array.isArray(y)){const v=I.$Hb(y),m=g(v[0],u);return v.length>1?A.localize(4,null,m,v.length):m}if(T.$4f(y))return y;if(y.detail){const v=y.detail;if(v.error)return O(v.error,u);if(v.exception)return O(v.exception,u)}return y.stack?O(y,u):y.message?y.message:A.localize(5,null)}function k(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function N(y,u){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=u,v}}),define(Ae[143],Re([1,0,41,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=g,e.$ar=k,e.$br=N,e.$cr=y,e.$dr=u,e.$er=v,e.$fr=m,e.$gr=s,e.$hr=o,e.$ir=l,e.$jr=S,e.$kr=d;const A=new I.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,f,D=!1){const w=E||"",C=f||"",P=A.value.collator.compare(w,C);return A.value.collatorIsNumeric&&P===0&&w!==C?w<C?-1:1:P}function g(E,f){const D=O.value.collator;return E=E||"",f=f||"",c(D,E,f)}function k(E,f){const D=O.value.collator;return E=E||"",f=f||"",a(E,f)||c(D,E,f)}function N(E,f){const D=O.value.collator;return E=E||"",f=f||"",b(E,f)||c(D,E,f)}function y(E,f){return E=E||"",f=f||"",E===f?0:E<f?-1:1}function u(E,f){const[D,w]=n(E),[C,P]=n(f);let V=A.value.collator.compare(w,P);if(V===0){if(A.value.collatorIsNumeric&&w!==P)return w<P?-1:1;if(V=A.value.collator.compare(D,C),A.value.collatorIsNumeric&&V===0&&D!==C)return D<C?-1:1}return V}function v(E,f){E=E||"",f=f||"";const D=t(E),w=t(f),C=O.value.collator,P=M.value.collator;return c(P,D,w)||c(C,E,f)}function m(E,f){E=E||"",f=f||"";const D=t(E),w=t(f),C=O.value.collator,P=M.value.collator;return c(P,D,w)||a(E,f)||c(C,E,f)}function s(E,f){E=E||"",f=f||"";const D=t(E),w=t(f),C=O.value.collator,P=M.value.collator;return c(P,D,w)||b(E,f)||c(C,E,f)}function o(E,f){E=E||"",f=f||"";const D=t(E).toLowerCase(),w=t(f).toLowerCase();return D!==w?D<w?-1:1:E!==f?E<f?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function n(E,f=!1){const D=E?r.exec(E):[];let w=[D&&D[1]||"",D&&D[3]||""];return f&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function t(E){const f=E?r.exec(E):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function c(E,f,D){const w=E.compare(f,D);return w!==0?w:f.length!==D.length?f.length<D.length?-1:1:0}function h(E){const f=E.charAt(0);return f.toLocaleUpperCase()!==f}function i(E){const f=E.charAt(0);return f.toLocaleLowerCase()!==f}function b(E,f){return h(E)&&i(f)?-1:i(E)&&h(f)?1:0}function a(E,f){return i(E)&&h(f)?-1:h(E)&&i(f)?1:0}function $(E,f,D=!1){return D||(E=E&&E.toLowerCase(),f=f&&f.toLowerCase()),E===f?0:E<f?-1:1}function l(E,f,D=!1){const w=E.split(T.sep),C=f.split(T.sep),P=w.length-1,V=C.length-1;let W,q;for(let R=0;;R++){if(W=P===R,q=V===R,W&&q)return p(w[R],C[R],D);if(W)return-1;if(q)return 1;const j=$(w[R],C[R],D);if(j!==0)return j}}function S(E,f,D){const w=E.toLowerCase(),C=f.toLowerCase(),P=d(E,f,D);if(P)return P;const V=w.endsWith(D),W=C.endsWith(D);if(V!==W)return V?-1:1;const q=p(w,C);return q!==0?q:w.localeCompare(C)}function d(E,f,D){const w=E.toLowerCase(),C=f.toLowerCase(),P=w.startsWith(D),V=C.startsWith(D);if(P!==V)return P?-1:1;if(P&&V){if(w.length<C.length)return-1;if(w.length>C.length)return 1}return 0}}),define(Ae[47],Re([1,0,19,21,15,17]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=g,e.$mg=k,e.$ng=N,e.$og=m,e.$pg=s,e.$qg=o,e.$rg=r,e.$sg=n,e.$tg=t,e.$ug=c,e.$vg=h,e.$wg=i,e.$xg=b,e.$yg=l;function M(S){return S===47||S===92}function p(S){return S.replace(/[\\/]/g,I.$hc.sep)}function g(S){return S.indexOf("/")===-1&&(S=p(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function k(S,d=I.$hc.sep){if(!S)return"";const E=S.length,f=S.charCodeAt(0);if(M(f)){if(M(S.charCodeAt(1))&&!M(S.charCodeAt(2))){let w=3;const C=w;for(;w<E&&!M(S.charCodeAt(w));w++);if(C!==w&&!M(S.charCodeAt(w+1))){for(w+=1;w<E;w++)if(M(S.charCodeAt(w)))return S.slice(0,w+1).replace(/[\\/]/g,d)}}return d}else if(r(f)&&S.charCodeAt(1)===58)return M(S.charCodeAt(2))?S.slice(0,2)+d:S.slice(0,2);let D=S.indexOf("://");if(D!==-1){for(D+=3;D<E;D++)if(M(S.charCodeAt(D)))return S.slice(0,D+1)}return""}function N(S){if(!T.$i||!S||S.length<5)return!1;let d=S.charCodeAt(0);if(d!==92||(d=S.charCodeAt(1),d!==92))return!1;let E=2;const f=E;for(;E<S.length&&(d=S.charCodeAt(E),d!==92);E++);return!(f===E||(d=S.charCodeAt(E+1),isNaN(d)||d===92))}const y=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(S,d=T.$i){const E=d?y:u;return!(!S||S.length===0||/^\s+$/.test(S)||(E.lastIndex=0,E.test(S))||d&&v.test(S)||S==="."||S===".."||d&&S[S.length-1]==="."||d&&S.length!==S.trim().length||S.length>255)}function s(S,d,E){const f=S===d;return!E||f?f:!S||!d?!1:(0,A.$tf)(S,d)}function o(S,d,E,f=I.sep){if(S===d)return!0;if(!S||!d||d.length>S.length)return!1;if(E){if(!(0,A.$uf)(S,d))return!1;if(d.length===S.length)return!0;let w=d.length;return d.charAt(d.length-1)===f&&w--,S.charAt(w)===f}return d.charAt(d.length-1)!==f&&(d+=f),S.indexOf(d)===0}function r(S){return S>=65&&S<=90||S>=97&&S<=122}function n(S,d){return T.$i&&S.endsWith(":")&&(S+=I.sep),(0,I.$jc)(S)||(S=(0,I.$kc)(d,S)),S=(0,I.$ic)(S),T.$i?(S=(0,A.$bf)(S,I.sep),S.endsWith(":")&&(S+=I.sep)):(S=(0,A.$bf)(S,I.sep),S||(S=I.sep)),S}function t(S){const d=(0,I.$ic)(S);return T.$i?S.length>3?!1:c(d)&&(S.length===2||d.charCodeAt(2)===92):d===I.$hc.sep}function c(S,d=T.$i){return d?r(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}function h(S,d=T.$i){return c(S,d)?S[0]:void 0}function i(S,d,E){return d.length>S.length?-1:S===d?0:(E&&(S=S.toLowerCase(),d=d.toLowerCase()),S.indexOf(d))}function b(S){const d=S.split(":");let E,f,D;for(const w of d){const C=Number(w);(0,O.$8f)(C)?f===void 0?f=C:D===void 0&&(D=C):E=E?[E,w].join(":"):w}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:f!==void 0?f:void 0,column:D!==void 0?D:f!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(S,d,E=8){let f="";for(let w=0;w<E;w++){let C;w===0&&T.$i&&!d&&(E===3||E===4)?C=$:C=a,f+=C.charAt(Math.floor(Math.random()*C.length))}let D;return d?D=`${d}-${f}`:D=f,S?(0,I.$kc)(S,D):D}}),define(Ae[69],Re([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=O,e.$Js=M,e.$Ks=p,e.$Ls=k,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(N){const y=(0,I.$pc)(N),u=T[y.toLowerCase()];return u!==void 0?u:M(N)}function M(N){const y=(0,I.$pc)(N);return A[y.toLowerCase()]}function p(N){for(const y in A)if(A[y]===N)return y}const g=/^(.+)\/(.+?)(;.+)?$/;function k(N,y){const u=g.exec(N);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:N}}),define(Ae[53],Re([1,0,23,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=A,e.$Yh=O,e.$Zh=p;function A(g){return JSON.stringify(g,M)}function O(g){let k=JSON.parse(g);return k=p(k),k}function M(g,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function p(g,k=0){if(!g||k>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.$Ce||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let N=0;N<g.length;++N)g[N]=p(g[N],k+1);else for(const N in g)Object.hasOwnProperty.call(g,N)&&(g[N]=p(g[N],k+1))}return g}}),define(Ae[12],Re([1,0,14,21,15,2,19]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=g,e.$Ag=k,e.$Eg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function g(m,s){return O.URI.isUri(m)?(0,A.$tf)(m.scheme,s):(0,A.$uf)(m,s+":")}function k(m,...s){return s.some(o=>g(m,o))}e.$Bg="vscode-tkn",e.$Cg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,r){this.a[s]=o,this.b[s]=r}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(h){return I.$1(h),s}const o=s.authority;let r=this.a[o];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const n=this.b[o],t=this.c[o];let c=`path=${encodeURIComponent(s.path)}`;return typeof t=="string"&&(c+=`&${e.$Cg}=${encodeURIComponent(t)}`),O.URI.from({scheme:T.$o?this.d:p.vscodeRemoteResource,authority:`${r}:${n}`,path:this.g,query:c})}}e.$Dg=new N;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class u{static{this.a=e.$Jg}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Dg.rewrite(s):s.scheme===p.file&&(T.$m||T.$q===`${p.vscodeFileResource}://${u.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||u.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==u.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}e.$Kg=new u;var v;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function r(t){let c;typeof t=="string"?c=new URL(t).searchParams:t instanceof URL?c=t.searchParams:O.URI.isUri(t)&&(c=new URL(t.toString(!0)).searchParams);const h=c?.get(o);if(h)return s.get(h)}m.getHeadersFromQuery=r;function n(t,c,h){if(!globalThis.crossOriginIsolated)return;const i=c&&h?"3":h?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}m.addSearchParam=n})(v||(e.COI=v={}))}),define(Ae[24],Re([1,0,47,12,19,21,15,2]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=g,e.$ah=N,e.$bh=u;function g(v){return(0,p.$xc)(v,!0)}class k{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$mf)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===T.Schemas.file)return I.$qg(g(m),g(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$9g)(m.authority,s.authority))return I.$qg(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$1g)(m)||m.authority}basename(m){return A.$hc.basename(m.path)}extname(m){return A.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===T.Schemas.file?s=p.URI.file(A.$nc(g(m))).path:(s=A.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===T.Schemas.file?s=p.URI.file(A.$ic(g(m))).path:s=A.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$9g)(m.authority,s.authority))return;if(m.scheme===T.Schemas.file){const n=A.$mc(g(m),g(s));return O.$i?I.$kg(n):n}let o=m.path||"/";const r=s.path||"/";if(this.a(m)){let n=0;for(const t=Math.min(o.length,r.length);n<t&&!(o.charCodeAt(n)!==r.charCodeAt(n)&&o.charAt(n).toLowerCase()!==r.charAt(n).toLowerCase());n++);o=r.substr(0,n)+o.substr(n)}return A.$hc.relative(o,r)}resolvePath(m,s){if(m.scheme===T.Schemas.file){const o=p.URI.file(A.$lc(g(m),s));return m.with({authority:o.authority,path:o.path})}return s=I.$lg(s),m.with({path:A.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$tf)(m,s)}hasTrailingPathSeparator(m,s=A.sep){if(m.scheme===T.Schemas.file){const o=g(m);return o.length>I.$mg(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=A.sep){return(0,e.$0g)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=A.sep){let o=!1;if(m.scheme===T.Schemas.file){const r=g(m);o=r!==void 0&&r.length===I.$mg(r).length&&r[r.length-1]===s}else{s="/";const r=m.path;o=r.length===1&&r.charCodeAt(r.length-1)===47}return!o&&!(0,e.$0g)(m,s)?m.with({path:m.path+"/"}):m}}e.$Sg=k,e.$Tg=new k(()=>!1),e.$Ug=new k(v=>v.scheme===T.Schemas.file?!O.$k:!0),e.$Vg=new k(v=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function N(v,m){const s=[];for(let o=0;o<v.length;o++){const r=m(v[o]);v.some((n,t)=>t===o?!1:(0,e.$Xg)(r,m(n)))||s.push(v[o])}return s}var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(t=>{const[c,h]=t.split(":");c&&h&&o.set(c,h)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&o.set(v.META_DATA_MIME,n),o}v.parseMetaData=m})(y||(e.DataUri=y={}));function u(v,m,s){if(m){let o=v.path;return o&&o[0]!==A.$hc.sep&&(o=A.$hc.sep+o),v.with({scheme:s,authority:m,path:o})}return v.with({scheme:s})}}),define(Ae[11],Re([1,0,22,14,5,6,24,21,130,41]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=N,e.$dh=y,e.$eh=u,e.$fh=v,e.$gh=m,e.$hh=s,e.$ih=o,e.$jh=r,e.$rh=S,e.$sh=d,e.$th=E,e.$uh=f,e.$vh=D,e.$Kh=Ie,e.$Sh=ke;function N(fe){return!!fe&&typeof fe.then=="function"}function y(fe){const J=new I.$me,Y=fe(J.token),he=new Promise((le,Te)=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),Te(new T.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),J.dispose(),le(Ce)},Ce=>{de.dispose(),J.dispose(),Te(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(le,Te){return he.then(le,Te)}catch(le){return this.then(void 0,le)}finally(le){return he.finally(le)}}}function u(fe,J,Y){return new Promise((he,le)=>{const Te=J.onCancellationRequested(()=>{Te.dispose(),he(Y)});fe.then(he,le).finally(()=>Te.dispose())})}function v(fe,J){return new Promise((Y,he)=>{const le=J.onCancellationRequested(()=>{le.dispose(),he(new T.$5)});fe.then(Y,he).finally(()=>le.dispose())})}async function m(fe){let J=-1;const Y=fe.map((he,le)=>he.then(Te=>(J=le,Te)));try{return await Promise.race(Y)}finally{fe.forEach((he,le)=>{le!==J&&he.cancel()})}}function s(fe,J,Y){let he;const le=setTimeout(()=>{he?.(void 0),Y?.()},J);return Promise.race([fe.finally(()=>clearTimeout(le)),new Promise(Te=>he=Te)])}function o(fe){return new Promise((J,Y)=>{const he=fe();N(he)?he.then(J,Y):J(he)})}function r(){let fe,J;return{promise:new Promise((he,le)=>{fe=he,J=le}),resolve:fe,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=J(),new Promise((Y,he)=>{this.a.then(le=>{this.a=null,Y(le)},le=>{this.a=null,he(le)})})}dispose(){this.f=!0}}e.$kh=n;class t{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$lh=t;class c{constructor(){this.a=new Map}queue(J,Y){const le=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===le&&this.a.delete(J)});return this.a.set(J,le),le}}e.$mh=c;const h=(fe,J)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,J()},fe);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},i=fe=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,fe())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class b{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((le,Te)=>{this.d=le,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===g.$$d?i(he):h(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=b;class a{constructor(J){this.a=new b(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=a;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=$;class l extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$qh=l;function S(fe,J){return J?new Promise((Y,he)=>{const le=setTimeout(()=>{Te.dispose(),Y()},fe),Te=J.onCancellationRequested(()=>{clearTimeout(le),Te.dispose(),he(new T.$5)})}):y(Y=>S(fe,Y))}function d(fe,J=0,Y){const he=setTimeout(()=>{fe(),Y&&le.dispose()},J),le=(0,O.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(le)});return Y?.add(le),le}function E(fe){const J=[];let Y=0;const he=fe.length;function le(){return Y<he?fe[Y++]():null}function Te(de){de!=null&&J.push(de);const Ce=le();return Ce?Ce.then(Te):Promise.resolve(J)}return Promise.resolve(null).then(Te)}function f(fe,J=he=>!!he,Y=null){let he=0;const le=fe.length,Te=()=>{if(he>=le)return Promise.resolve(Y);const de=fe[he++];return Promise.resolve(de()).then(Me=>J(Me)?Promise.resolve(Me):Te())};return Te()}function D(fe,J=he=>!!he,Y=null){if(fe.length===0)return Promise.resolve(Y);let he=fe.length;const le=()=>{he=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,de)=>{for(const Ce of fe)Ce.then(Me=>{--he>=0&&J(Me)?(le(),Te(Me)):he===0&&Te(Y)}).catch(Me=>{--he>=0&&(le(),de(Me))})})}class w{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new A.$be}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:J,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=w;class C extends w{constructor(){super(1)}}e.$xh=C;class P{constructor(){this.a=new ue,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$yh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Pe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=M.$Tg){const he=Y.getComparisonKey(J);return this.a.get(he)?.size??0}queueFor(J,Y,he=M.$Tg){const le=he.getComparisonKey(J);let Te=this.a.get(le);if(!Te){Te=new C;const de=this.f++,Ce=A.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(de,Ce),this.a.set(le,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=V;class W{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$Ah=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,he=globalThis){this.cancel();const le=he.setInterval(()=>{J()},Y);this.d=(0,O.$Sc)(()=>{he.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=q;class R{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=R;class j{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=j;class K extends R{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Eh=K;class se extends O.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(fe,J)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Hh=(fe,J,Y)=>{const he=fe.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let le=!1;return{dispose(){le||(le=!0,fe.cancelIdleCallback(he))}}},e.$Gh=fe=>(0,e.$Hh)(globalThis,fe)}();class ce{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Hh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ce;class ve extends ce{constructor(J){super(globalThis,J)}}e.$Jh=ve;async function Ie(fe,J,Y){let he;for(let le=0;le<Y;le++)try{return await fe()}catch(Te){he=Te,await S(J)}throw he}class ue{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,he){return this.a={taskId:J,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:he,reject:le}=r();this.b={run:J,promise:Y,promiseResolve:he,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ue;class be{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Mh=be;var ie;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(ie||(ie={}));class Pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new T.$5)}}e.$Nh=Pe;var Fe;(function(fe){async function J(he){let le;const Te=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{le||(le=Ce)})));if(typeof le<"u")throw le;return Te}fe.settled=J;function Y(he){return new Promise(async(le,Te)=>{try{await he(le,Te)}catch(de){Te(de)}})}fe.withAsyncBody=Y})(Fe||(e.Promises=Fe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ne;class U{constructor(J){this.b=J,this.a=new k.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class pe{static fromArray(J){return new pe(Y=>{Y.emitMany(J)})}static fromPromise(J){return new pe(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new pe(async Y=>{await Promise.all(J.map(async he=>Y.emitOne(await he)))})}static merge(J){return new pe(async Y=>{await Promise.all(J.map(async he=>{for await(const le of he)Y.emitOne(le)}))})}static{this.EMPTY=pe.fromArray([])}constructor(J,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new A.$be,queueMicrotask(async()=>{const he={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(J(he)),this.k()}catch(le){this.l(le)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,Y){return new pe(async he=>{for await(const le of J)he.emitOne(Y(le))})}map(J){return pe.map(this,J)}static filter(J,Y){return new pe(async he=>{for await(const le of J)Y(le)&&he.emitOne(le)})}filter(J){return pe.filter(this,J)}static coalesce(J){return pe.filter(J,Y=>!!Y)}coalesce(){return pe.coalesce(this)}static async toPromise(J){const Y=[];for await(const he of J)Y.push(he);return Y}toPromise(){return pe.toPromise(this)}h(J){this.a===0&&(this.b.push(J),this.g.fire())}j(J){this.a===0&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(J){this.a===0&&(this.a=2,this.d=J,this.g.fire())}}e.$Qh=pe;class Oe extends pe{constructor(J,Y){super(Y),this.m=J}cancel(){this.m.cancel()}}e.$Rh=Oe;function ke(fe){const J=new I.$me,Y=fe(J.token);return new Oe(J,async he=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),J.dispose(),he.reject(new T.$5)});try{for await(const Te of Y){if(J.token.isCancellationRequested)return;he.emitOne(Te)}le.dispose(),J.dispose()}catch(Te){le.dispose(),J.dispose(),he.reject(Te)}})}class $e{constructor(J){this.a=new Pe,this.b=new pe(le=>{if(Y){le.reject(Y);return}return he&&le.emitMany(he),this.d=Te=>le.reject(Te),this.f=Te=>le.emitOne(Te),this.a.p},J);let Y,he;this.f=le=>{he||(he=[]),he.push(le)},this.d=le=>{Y||(Y=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Th=$e}),define(Ae[36],Re([1,0,18,11,47,28,19,21,15]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=k,e.$ik=m,e.$jk=C,e.$kk=P,e.$lk=V,e.$mk=W,e.$nk=q,e.$ok=se;function k(){return Object.create(null)}e.$gk="**",e.$hk="/";const N="[/\\\\]",y="[^/\\\\]",u=/\//g;function v(ce,ve){switch(ce){case 0:return"";case 1:return`${y}*?`;default:return`(?:${N}|${y}+${N}${ve?`|${N}${y}+`:""})*?`}}function m(ce,ve){if(!ce)return[];const Ie=[];let ue=!1,be=!1,ie="";for(const Pe of ce){switch(Pe){case ve:if(!ue&&!be){Ie.push(ie),ie="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":be=!0;break;case"]":be=!1;break}ie+=Pe}return ie&&Ie.push(ie),Ie}function s(ce){if(!ce)return"";let ve="";const Ie=m(ce,e.$hk);if(Ie.every(ue=>ue===e.$gk))ve=".*";else{let ue=!1;Ie.forEach((be,ie)=>{if(be===e.$gk){if(ue)return;ve+=v(2,ie===Ie.length-1)}else{let Pe=!1,Fe="",ne=!1,U="";for(const x of be){if(x!=="}"&&Pe){Fe+=x;continue}if(ne&&(x!=="]"||!U)){let pe;x==="-"?pe=x:(x==="^"||x==="!")&&!U?pe="^":x===e.$hk?pe="":pe=(0,g.$8e)(x),U+=pe;continue}switch(x){case"{":Pe=!0;continue;case"[":ne=!0;continue;case"}":{const Oe=`(?:${m(Fe,",").map(ke=>s(ke)).join("|")})`;ve+=Oe,Pe=!1,Fe="";break}case"]":{ve+="["+U+"]",ne=!1,U="";break}case"?":ve+=y;continue;case"*":ve+=v(1);continue;default:ve+=(0,g.$8e)(x)}}ie<Ie.length-1&&(Ie[ie+1]!==e.$gk||ie+2<Ie.length)&&(ve+=N)}ue=be===e.$gk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Ec(1e4),b=function(){return!1},a=function(){return null};function $(ce,ve){if(!ce)return a;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ve.trimForExclusions}`;let be=i.get(ue);if(be)return l(be,ce);let ie;return o.test(Ie)?be=d(Ie.substr(4),Ie):(ie=r.exec(S(Ie,ve)))?be=E(ie[1],Ie):(ve.trimForExclusions?t:n).test(Ie)?be=f(Ie,ve):(ie=c.exec(S(Ie,ve)))?be=D(ie[1].substr(1),Ie,!0):(ie=h.exec(S(Ie,ve)))?be=D(ie[1],Ie,!1):be=w(Ie),i.set(ue,be),l(be,ce)}function l(ce,ve){if(typeof ve=="string")return ce;const Ie=function(ue,be){return(0,A.$qg)(ue,ve.base,!p.$k)?ce((0,g.$af)(ue.substr(ve.base.length),M.sep),be):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function S(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function d(ce,ve){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ve:null}}function E(ce,ve){const Ie=`/${ce}`,ue=`\\${ce}`,be=function(Pe,Fe){return typeof Pe!="string"?null:Fe?Fe===ce?ve:null:Pe===ce||Pe.endsWith(Ie)||Pe.endsWith(ue)?ve:null},ie=[ce];return be.basenames=ie,be.patterns=[ve],be.allBasenames=ie,be}function f(ce,ve){const Ie=K(ce.slice(1,-1).split(",").map(Fe=>$(Fe,ve)).filter(Fe=>Fe!==a),ce),ue=Ie.length;if(!ue)return a;if(ue===1)return Ie[0];const be=function(Fe,ne){for(let U=0,x=Ie.length;U<x;U++)if(Ie[U](Fe,ne))return ce;return null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Pe=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function D(ce,ve,Ie){const ue=M.sep===M.$hc.sep,be=ue?ce:ce.replace(u,M.sep),ie=M.sep+be,Pe=M.$hc.sep+ce;let Fe;return Ie?Fe=function(ne,U){return typeof ne=="string"&&(ne===be||ne.endsWith(ie)||!ue&&(ne===ce||ne.endsWith(Pe)))?ve:null}:Fe=function(ne,U){return typeof ne=="string"&&(ne===be||!ue&&ne===ce)?ve:null},Fe.allPaths=[(Ie?"*/":"./")+ce],Fe}function w(ce){try{const ve=new RegExp(`^${s(ce)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ce:null}}catch{return a}}function C(ce,ve,Ie){return!ce||typeof ve!="string"?!1:P(ce)(ve,void 0,Ie)}function P(ce,ve={}){if(!ce)return b;if(typeof ce=="string"||V(ce)){const Ie=$(ce,ve);if(Ie===a)return b;const ue=function(be,ie){return!!Ie(be,ie)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return R(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function R(ce,ve){const Ie=K(Object.getOwnPropertyNames(ce).map(Fe=>j(Fe,ce[Fe],ve)).filter(Fe=>Fe!==a)),ue=Ie.length;if(!ue)return a;if(!Ie.some(Fe=>!!Fe.requiresSiblings)){if(ue===1)return Ie[0];const Fe=function(x,pe){let Oe;for(let ke=0,$e=Ie.length;ke<$e;ke++){const fe=Ie[ke](x,pe);if(typeof fe=="string")return fe;(0,T.$ch)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const ke of Oe){const $e=await ke;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Fe.allBasenames=ne.allBasenames);const U=Ie.reduce((x,pe)=>pe.allPaths?x.concat(pe.allPaths):x,[]);return U.length&&(Fe.allPaths=U),Fe}const be=function(Fe,ne,U){let x,pe;for(let Oe=0,ke=Ie.length;Oe<ke;Oe++){const $e=Ie[Oe];$e.requiresSiblings&&U&&(ne||(ne=(0,M.$oc)(Fe)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Fe).length)));const fe=$e(Fe,ne,x,U);if(typeof fe=="string")return fe;(0,T.$ch)(fe)&&(pe||(pe=[]),pe.push(fe))}return pe?(async()=>{for(const Oe of pe){const ke=await Oe;if(typeof ke=="string")return ke}return null})():null},ie=Ie.find(Fe=>!!Fe.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Pe=Ie.reduce((Fe,ne)=>ne.allPaths?Fe.concat(ne.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function j(ce,ve,Ie){if(ve===!1)return a;const ue=$(ce,Ie);if(ue===a)return a;if(typeof ve=="boolean")return ue;if(ve){const be=ve.when;if(typeof be=="string"){const ie=(Pe,Fe,ne,U)=>{if(!U||!ue(Pe,Fe))return null;const x=be.replace("$(basename)",()=>ne),pe=U(x);return(0,T.$ch)(pe)?pe.then(Oe=>Oe?ce:null):pe?ce:null};return ie.requiresSiblings=!0,ie}}return ue}function K(ce,ve){const Ie=ce.filter(Fe=>!!Fe.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Fe,ne)=>{const U=ne.basenames;return U?Fe.concat(U):Fe},[]);let be;if(ve){be=[];for(let Fe=0,ne=ue.length;Fe<ne;Fe++)be.push(ve)}else be=Ie.reduce((Fe,ne)=>{const U=ne.patterns;return U?Fe.concat(U):Fe},[]);const ie=function(Fe,ne){if(typeof Fe!="string")return null;if(!ne){let x;for(x=Fe.length;x>0;x--){const pe=Fe.charCodeAt(x-1);if(pe===47||pe===92)break}ne=Fe.substr(x)}const U=ue.indexOf(ne);return U!==-1?be[U]:null};ie.basenames=ue,ie.patterns=be,ie.allBasenames=ue;const Pe=ce.filter(Fe=>!Fe.basenames);return Pe.push(ie),Pe}function se(ce,ve){return(0,I.$ub)(ce,ve,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Ae[54],Re([1,0,14,131,24,15,2]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=k,e.$Pk=N,e.$Qk=y,e.$Rk=u,e.$Sk=v,e.$Tk=m,e.$Uk=s,e.$Vk=o;var p;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class g{constructor(n="",t=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(n,t=0){return this.value+=u(this.supportThemeIcons?(0,T.$Hk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,t){return this.value+=`
${v(t,n)}
`,this}appendLink(n,t,c){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,t){const c=new RegExp((0,O.$8e)(t),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$Nk=g;function k(r){return N(r)?!r.value:Array.isArray(r)?r.every(k):!0}function N(r){return r instanceof g?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function y(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,A.$Wg)(M.URI.from(r.baseUri),M.URI.from(n.baseUri)))}function u(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(r,n){const t=r.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=t>=3?t+1:3;return[`${"`".repeat(c)}${n}`,r,`${"`".repeat(c)}`].join(`
`)}function m(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(r){const n=[],t=r.split("|").map(h=>h.trim());r=t[0];const c=t[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),b=h?h[1]:"",a=i?i[1]:"",$=isFinite(parseInt(a)),l=isFinite(parseInt(b));$&&n.push(`width="${a}"`),l&&n.push(`height="${b}"`)}return{href:r,dimensions:n}}}),define(Ae[96],Re([1,0,18,47,19,21,24,15]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=g,e.$ow=N,e.$pw=u,e.$qw=v,e.$rw=r,e.$sw=t,e.$tw=c,e.$uw=h,e.$vw=i,e.$ww=b;function g($,l){const{os:S,tildify:d,relative:E}=l;if(E){const w=k($,E,S);if(typeof w=="string")return w}let f=$.fsPath;if(S===1&&!O.$i?f=f.replace(/\//g,"\\"):S!==1&&O.$i&&(f=f.replace(/\\/g,"/")),S!==1&&d?.userHome){const w=d.userHome.fsPath;let C;$.scheme!==d.userHome.scheme&&$.path[0]===A.$hc.sep&&$.path[1]!==A.$hc.sep?C=d.userHome.with({path:$.path}).fsPath:C=f,f=u(C,w,S)}return(S===1?A.$gc:A.$hc).normalize(N(f,S===1))}function k($,l,S){const d=S===1?A.$gc:A.$hc,E=S===3?M.$Tg:M.$Vg,f=l.getWorkspace(),D=(0,I.$Ob)(f.folders);if(!D)return;$.scheme!==D.uri.scheme&&$.path[0]===A.$hc.sep&&$.path[1]!==A.$hc.sep&&($=D.uri.with({path:$.path}));const w=l.getWorkspaceFolder($);if(!w)return;let C;if(E.isEqual(w.uri,$)?C="":C=E.relativePath(w.uri,$)??"",C&&(C=d.normalize(C)),f.folders.length>1&&!l.noPrefix){const P=w.name?w.name:E.basenameOrAuthority(w.uri);C=C?`${P} \u2022 ${C}`:P}return C}function N($,l=O.$i){return(0,T.$ug)($,l)?$.charAt(0).toUpperCase()+$.slice(1):$}let y=Object.create(null);function u($,l,S=O.OS){if(S===1||!$||!l)return $;let d=y.original===l?y.normalized:void 0;d||(d=l,O.$i&&(d=(0,T.$kg)(d)),d=`${(0,p.$bf)(d,A.$hc.sep)}${A.$hc.sep}`,y={original:l,normalized:d});let E=$;return O.$i&&(E=(0,T.$kg)(E)),(S===3?E.startsWith(d):(0,p.$uf)(E,d))?`~/${E.substr(d.length)}`:$}function v($,l){return $.replace(/^~($|\/|\\)/,`${l}$1`)}const m="\u2026",s="\\\\",o="~";function r($,l=A.sep){const S=new Array($.length);let d=!1;for(let E=0;E<$.length;E++){const f=$[E];if(f===""){S[E]=`.${l}`;continue}if(!f){S[E]=f;continue}d=!0;let D="",w=f;w.indexOf(s)===0?(D=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(l)===0?(D=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(o)===0&&(D=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const C=w.split(l);for(let P=1;d&&P<=C.length;P++)for(let V=C.length-P;d&&V>=0;V--){d=!1;let W=C.slice(V,V+P).join(l);for(let q=0;!d&&q<$.length;q++)if(q!==E&&$[q]&&$[q].indexOf(W)>-1){const R=V+P===C.length,j=V>0&&$[q].indexOf(l)>-1?l+W:W,K=$[q].endsWith(j);d=!R||K}if(!d){let q="";(C[0].endsWith(":")||D!=="")&&(V===1&&(V=0,P++,W=C[0]+l+W),V>0&&(q=C[0]+l),q=D+q),V>0&&(q=q+m+l),q=q+W,V+P<C.length&&(q=q+l+m),S[E]=q}}d&&(S[E]=f)}return S}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function t($,l=Object.create(null)){const S=[];let d=!1,E="";for(const f of $)if(f==="$"||d&&f==="{")E&&S.push({value:E,type:n.TEXT}),E="",d=!0;else if(f==="}"&&d){const D=l[E];if(typeof D=="string")D.length&&S.push({value:D,type:n.VARIABLE});else if(D){const w=S[S.length-1];(!w||w.type!==n.SEPARATOR)&&S.push({value:D.label,type:n.SEPARATOR})}E="",d=!1}else E+=f;return E&&!d&&S.push({value:E,type:n.TEXT}),S.filter((f,D)=>{if(f.type===n.SEPARATOR){const w=S[D-1],C=S[D+1];return[w,C].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(f=>f.value).join("")}function c($,l){return O.$j||l?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):$.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function h($,l){return O.$j||l?$.replace(/\(&&\w\)|&&/g,""):O.$i?$.replace(/&&|&/g,S=>S==="&"?"&&":"&"):$.replace(/&&/g,"_")}function i($){return $.replace(/&/g,"&&")}function b($){if($.endsWith("]")){const l=$.lastIndexOf(" [",$.length-2);if(l!==-1){const S=a($.substring(0,l)),d=$.substring(l);return{name:S.name+d,parentPath:S.parentPath}}}return a($)}function a($){const l=$.indexOf("/")!==-1?A.$hc:A.$gc,S=l.basename($),d=l.dirname($);return S.length?{name:S,parentPath:d}:{name:d,parentPath:""}}}),define(Ae[144],Re([1,0,23,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=k,e.$wn=N;function A(y){return y.toJSON()}class O{constructor(u){this.a=u}transformIncoming(u){const v=this.a.transformIncoming(u);return v===u?u:A(T.URI.from(v))}transformOutgoing(u){const v=this.a.transformOutgoing(u);return v===u?u:A(T.URI.from(v))}transformOutgoingURI(u){const v=this.a.transformOutgoing(u);return v===u?u:T.URI.from(v)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$sn=O,e.$tn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,u,v){if(!y||v>200)return null;if(typeof y=="object"){if(y instanceof T.URI)return u.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],u,v+1);s!==null&&(y[m]=s)}}return null}function p(y,u){const v=M(y,u,0);return v===null?y:v}function g(y,u,v,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return v?T.URI.revive(u.transformIncoming(y)):u.transformIncoming(y);if(y instanceof I.$Ce)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=g(y[s],u,v,m+1);o!==null&&(y[s]=o)}}return null}function k(y,u){const v=g(y,u,!1,0);return v===null?y:v}function N(y,u){const v=g(y,u,!0,0);return v===null?y:v}}),define(Ae[145],Re([1,0,15,21,23]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=N,e.$ut=y;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function g(){return p||(p=new TextDecoder("UTF-16BE")),p}let k;function N(){return k||(k=T.$D()?M():g()),k}function y(m,s,o){const r=new Uint16Array(m.buffer,s,o);return o>0&&(r[0]===65279||r[0]===65534)?u(m,s,o):M().decode(r)}function u(m,s,o){const r=[];let n=0;for(let t=0;t<o;t++){const c=A.$Ee(m,s);s+=2,r[n++]=String.fromCharCode(c)}return r.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||I.$xf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<o;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$vt=v}),define(Ae[146],Re([1,0,23,145]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function A(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,N,y,u){this.oldPosition=k,this.oldText=N,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,N,y){const u=N.length;I.$He(k,u,y),y+=4;for(let v=0;v<u;v++)I.$Fe(k,N.charCodeAt(v),y),y+=2;return y}static d(k,N){const y=I.$Ge(k,N);return N+=4,(0,T.$ut)(k,N,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(k,N){return I.$He(k,this.oldPosition,N),N+=4,I.$He(k,this.newPosition,N),N+=4,N=O.c(k,this.oldText,N),N=O.c(k,this.newText,N),N}static read(k,N,y){const u=I.$Ge(k,N);N+=4;const v=I.$Ge(k,N);N+=4;const m=O.d(k,N);N+=O.a(m);const s=O.d(k,N);return N+=O.a(s),y.push(new O(u,m,v,s)),N}}e.$wt=O;function M(g,k){return g===null||g.length===0?k:new p(g,k).compress()}class p{constructor(k,N){this.a=k,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,N=0,y=this.n(k),u=this.l(N);for(;k<this.f||N<this.h;){if(y===null){this.k(u),u=this.l(++N);continue}if(u===null){this.m(y),y=this.n(++k);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++N);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++k);continue}if(u.oldPosition<y.newPosition){const[r,n]=p.r(u,y.newPosition-u.oldPosition);this.k(r),u=n;continue}if(y.newPosition<u.oldPosition){const[r,n]=p.q(y,u.oldPosition-y.newPosition);this.m(r),y=n;continue}let s,o;if(u.oldEnd===y.newEnd)s=y,o=u,y=this.n(++k),u=this.l(++N);else if(u.oldEnd<y.newEnd){const[r,n]=p.q(y,u.oldLength);s=r,o=u,y=n,u=this.l(++N)}else{const[r,n]=p.r(u,y.newLength);s=y,o=r,y=this.n(++k),u=n}this.d[this.e++]=new O(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const v=p.s(this.d);return p.t(v)}k(k){this.d[this.e++]=p.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=p.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,N){return new O(N.oldPosition-k,N.oldText,N.newPosition,N.newText)}static p(k,N){return new O(N.oldPosition,N.oldText,N.newPosition+k,N.newText)}static q(k,N){const y=k.newText.substr(0,N),u=k.newText.substr(N);return[new O(k.oldPosition,k.oldText,k.newPosition,y),new O(k.oldEnd,"",k.newPosition+N,u)]}static r(k,N){const y=k.oldText.substr(0,N),u=k.oldText.substr(N);return[new O(k.oldPosition,y,k.newPosition,k.newText),new O(k.oldPosition+N,u,k.newEnd,"")]}static s(k){if(k.length===0)return k;const N=[];let y=0,u=k[0];for(let v=1;v<k.length;v++){const m=k[v];u.oldEnd===m.oldPosition?u=new O(u.oldPosition,u.oldText+m.oldText,u.newPosition,u.newText+m.newText):(N[y++]=u,u=m)}return N[y++]=u,N}static t(k){if(k.length===0)return k;const N=[];let y=0;for(let u=0;u<k.length;u++){const v=k[u];v.oldText!==v.newText&&(N[y++]=v)}return N}}}),define(Ae[147],Re([1,0,36,19]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=A,e.$Vt=O;function A(M,p,g,k,N,y){if(Array.isArray(M)){let u=0;for(const v of M){const m=A(v,p,g,k,N,y);if(m===10)return m;m>u&&(u=m)}return u}else{if(typeof M=="string")return k?M==="*"?5:M===g?10:0:0;if(M){const{language:u,pattern:v,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!k&&!s)return 0;o&&N&&(p=N);let r=0;if(m)if(m===p.scheme)r=10;else if(m==="*")r=5;else return 0;if(u)if(u===g)r=10;else if(u==="*")r=Math.max(r,5);else return 0;if(o)if(o===y)r=10;else if(o==="*"&&y!==void 0)r=Math.max(r,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,T.$ic)(v.base)},n===p.fsPath||(0,I.$jk)(n,p.fsPath))r=10;else return 0}return r}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Ae[148],Re([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=void 0;class N extends k.$Uc{constructor(u,v,m,s,o,r,n){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=v,this.j=!r,this.g=s,this.h=o,this.c=new M.$JC(u,m,n)}equals(u){return!(u instanceof N)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,v){return this.c.getOffsetAt(u,v)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,v){const m=u+v,s=this.getPositionAt(u),o=this.getPositionAt(m);return new A.$kt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(u,v=0){if(u.isEmpty())return"";const m=this.n(v);return this.c.getValueInRange(u,m)}getValueLengthInRange(u,v=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const m=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const r=this.n(v),n=this.getEOL();if(r.length!==n.length){const t=r.length-n.length,c=u.endLineNumber-u.startLineNumber;o=t*c}return s-m+o}getCharacterCountInRange(u,v=0){if(this.j){let m=0;const s=u.startLineNumber,o=u.endLineNumber;for(let r=s;r<=o;r++){const n=this.getLineContent(r),t=r===s?u.startColumn-1:0,c=r===o?u.endColumn-1:n.length;for(let h=t;h<c;h++)T.$xf(n.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(v).length*(o-s),m}return this.getValueLengthInRange(u,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,v){return this.c.getLineCharCode(u,v)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const v=T.$if(this.getLineContent(u));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(u){const v=T.$kf(this.getLineContent(u));return v===-1?0:v+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,v,m){let s=this.g,o=this.h,r=this.j,n=!0,t=[];for(let l=0;l<u.length;l++){const S=u[l];n&&S._isTracked&&(n=!1);const d=S.range;if(S.text){let C=!0;r||(C=!T.$If(S.text),r=C),!s&&C&&(s=T.$Hf(S.text)),!o&&C&&(o=T.$Kf(S.text))}let E="",f=0,D=0,w=0;if(S.text){let C;[f,D,w,C]=(0,p.$Nt)(S.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?E=S.text:E=S.text.replace(/\r\n|\r|\n/g,P)}t[l]={sortIndex:l,identifier:S.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:E,eolCount:f,firstLineLength:D,lastLineLength:w,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}t.sort(N.u);let c=!1;for(let l=0,S=t.length-1;l<S;l++){const d=t[l].range.getEndPosition(),E=t[l+1].range.getStartPosition();if(E.isBeforeOrEqual(d)){if(E.isBefore(d))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(t=this.s(t));const h=m||v?N._getInverseEditRanges(t):[],i=[];if(v)for(let l=0;l<t.length;l++){const S=t[l],d=h[l];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let E=d.startLineNumber;E<=d.endLineNumber;E++){let f="";E===d.startLineNumber&&(f=this.getLineContent(S.range.startLineNumber),T.$if(f)!==-1)||i.push({lineNumber:E,oldContent:f})}}let b=null;if(m){let l=0;b=[];for(let S=0;S<t.length;S++){const d=t[S],E=h[S],f=this.getValueInRange(d.range),D=d.rangeOffset+l;l+=d.text.length-f.length,b[S]={sortIndex:d.sortIndex,identifier:d.identifier,range:E,text:f,textChange:new g.$wt(d.rangeOffset,f,D,d.text)}}c||b.sort((S,d)=>S.sortIndex-d.sortIndex)}this.g=s,this.h=o,this.j=r;const a=this.t(t);let $=null;if(v&&i.length>0){i.sort((l,S)=>S.lineNumber-l.lineNumber),$=[];for(let l=0,S=i.length;l<S;l++){const d=i[l].lineNumber;if(l>0&&i[l-1].lineNumber===d)continue;const E=i[l].oldContent,f=this.getLineContent(d);f.length===0||f===E||T.$if(f)!==-1||$.push(d)}}return this.m.fire(),new O.$zv(b,a,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let v=!1;const m=u[0].range,s=u[u.length-1].range,o=new A.$kt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let r=m.startLineNumber,n=m.startColumn;const t=[];for(let a=0,$=u.length;a<$;a++){const l=u[a],S=l.range;v=v||l.forceMoveMarkers,t.push(this.getValueInRange(new A.$kt(r,n,S.startLineNumber,S.startColumn))),l.text.length>0&&t.push(l.text),r=S.endLineNumber,n=S.endColumn}const c=t.join(""),[h,i,b]=(0,p.$Nt)(c);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:b,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(u){u.sort(N.w);const v=[];for(let m=0;m<u.length;m++){const s=u[m],o=s.range.startLineNumber,r=s.range.startColumn,n=s.range.endLineNumber,t=s.range.endColumn;if(o===n&&r===t&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new A.$kt(o,r,n,t);v.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(u,v,m,s){return this.c.findMatchesLineByLine(u,v,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(u,v){const m=u.startLineNumber,s=u.startColumn,[o,r,n]=(0,p.$Nt)(v);let t;if(v.length>0){const c=o+1;c===1?t=new A.$kt(m,s,m,s+r):t=new A.$kt(m,s,m+c-1,n+1)}else t=new A.$kt(m,s,m,s);return t}static _getInverseEditRanges(u){const v=[];let m=0,s=0,o=null;for(let r=0,n=u.length;r<n;r++){const t=u[r];let c,h;o?o.range.endLineNumber===t.range.startLineNumber?(c=m,h=s+(t.range.startColumn-o.range.endColumn)):(c=m+(t.range.startLineNumber-o.range.endLineNumber),h=t.range.startColumn):(c=t.range.startLineNumber,h=t.range.startColumn);let i;if(t.text.length>0){const b=t.eolCount+1;b===1?i=new A.$kt(c,h,c,h+t.firstLineLength):i=new A.$kt(c,h,c+b-1,t.lastLineLength+1)}else i=new A.$kt(c,h,c,h);m=i.endLineNumber,s=i.endColumn,v.push(i),o=t}return v}static u(u,v){const m=A.$kt.compareRangesUsingEnds(u.range,v.range);return m===0?u.sortIndex-v.sortIndex:m}static w(u,v){const m=A.$kt.compareRangesUsingEnds(u.range,v.range);return m===0?v.sortIndex-u.sortIndex:-m}}e.$KC=N}),define(Ae[149],Re([1,0,15,92,148]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class O{constructor(g,k,N,y,u,v,m,s,o){this.a=g,this.b=k,this.c=N,this.d=y,this.e=u,this.f=v,this.g=m,this.h=s,this.j=o}k(g){const k=this.c+this.d+this.e,N=this.c+this.e;return k===0?g===1?`
`:`\r
`:N>k/2?`\r
`:`
`}create(g){const k=this.k(g),N=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let u=0,v=N.length;u<v;u++){const m=N[u].buffer.replace(/\r\n|\r|\n/g,k),s=(0,T.$FC)(m);N[u]=new T.$IC(m,s)}const y=new A.$KC(N,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&I.$Rf(g)&&(this.b=I.$Qf,g=g.substr(1));const k=g.charCodeAt(g.length-1);k===13||k>=55296&&k<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=k):(this.m(g,!1),this.c=!1,this.d=k)}m(g,k){!k&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const k=(0,T.$GC)(this.e,g);this.a.push(new T.$IC(g,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Hf(g)),this.k||(this.k=I.$Kf(g)))}finish(g=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const k=(0,T.$FC)(g.buffer);g.lineStarts=k,this.d===13&&this.f++}}}e.$LC=M}),define(Ae[97],Re([1,0,23,21]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbb=g,e.$Gbb=N;var A;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(A||(A={}));function O(y){for(let u=0,v=y.length;u<v;u+=4){const m=y[u+0],s=y[u+1],o=y[u+2],r=y[u+3];y[u+0]=r,y[u+1]=o,y[u+2]=s,y[u+3]=m}}function M(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return T.$D()||O(u),I.$Ce.wrap(u)}function p(y){const u=y.buffer;if(T.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const v=new Uint8Array(u.byteLength);return v.set(u),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function g(y){const u=new Uint32Array(k(y));let v=0;if(u[v++]=y.id,y.type==="full")u[v++]=1,u[v++]=y.data.length,u.set(y.data,v),v+=y.data.length;else{u[v++]=2,u[v++]=y.deltas.length;for(const m of y.deltas)u[v++]=m.start,u[v++]=m.deleteCount,m.data?(u[v++]=m.data.length,u.set(m.data,v),v+=m.data.length):u[v++]=0}return M(u)}function k(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const v of y.deltas)v.data&&(u+=v.data.length)}return u}function N(y){const u=p(y);let v=0;const m=u[v++];if(u[v++]===1){const n=u[v++],t=u.subarray(v,v+n);return v+=n,{id:m,type:"full",data:t}}const o=u[v++],r=[];for(let n=0;n<o;n++){const t=u[v++],c=u[v++],h=u[v++];let i;h>0&&(i=u.subarray(v,v+h),v+=h),r[n]={start:t,deleteCount:c,data:i}}return{id:m,type:"delta",deltas:r}}}),define(Ae[150],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ae[151],Re([1,0,18,26,21,134,152,150]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=c,e.stringSet=b,e.cursorStyleToString=w,e.filterValidationDecorations=le;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class y{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}compute(Z,me,He){return He}}class u{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=u;function v(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const He=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!He)}let me=!1;for(const He in Z)if(Z.hasOwnProperty(He)){const ye=v(X[He],Z[He]);ye.didChange&&(X[He]=ye.newValue,me=!0)}return new u(X,me)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return v(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return v(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,He){return He}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class r extends s{constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Z,me,He,ye)}validate(Z){return o(Z,this.defaultValue)}}function n(X,Z,me,He){if(typeof X>"u")return Z;let ye=parseInt(X,10);return isNaN(ye)?Z:(ye=Math.max(me,ye),ye=Math.min(He,ye),ye|0)}class t extends s{static clampedInt(Z,me,He,ye){return n(Z,me,He,ye)}constructor(Z,me,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Z,me,He,dt),this.minimum=ye,this.maximum=ot}validate(Z){return t.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,me,He){if(typeof X>"u")return Z;const ye=h.float(X,Z);return h.clamp(ye,me,He)}class h extends s{static clamp(Z,me,He){return Z<me?me:Z>He?He:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const He=parseFloat(Z);return isNaN(He)?me:He}constructor(Z,me,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Z,me,He,ot),this.validationFn=ye}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class i extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Z,me,He,ye)}validate(Z){return i.string(Z,this.defaultValue)}}function b(X,Z,me,He){return typeof X!="string"?Z:He&&X in He?He[X]:me.indexOf(X)===-1?Z:X}class a extends s{constructor(Z,me,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Z,me,He,ot),this.c=ye}validate(Z){return b(Z,this.defaultValue,this.c)}}class $ extends y{constructor(Z,me,He,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Z,me,He,It),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,He){return He===0?Z.accessibilitySupport:He}}class d extends y{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function f(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function w(X){switch(X){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class P extends m{constructor(){super(142)}compute(Z,me,He){const ye=["monaco-editor"];return me.get(39)&&ye.push(me.get(39)),Z.extraEditorClassName&&ye.push(Z.extraEditorClassName),me.get(74)==="default"?ye.push("mouse-default"):me.get(74)==="copy"&&ye.push("mouse-copy"),me.get(111)&&ye.push("showUnused"),me.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class V extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,me,He){return He&&Z.emptySelectionClipboard}}class W extends y{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.TRANSLATE:Z:Z?R.TRANSLATE:R.OFF}compute(Z,me,He){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class j extends m{constructor(){super(50)}compute(Z,me,He){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const me=h.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Z,me,He){return Z.fontInfo.fontSize}}class se extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.d,maximum:se.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(t.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,se.d,se.e))}}class ce extends y{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends y{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:t.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends m{constructor(){super(145)}compute(Z,me,He){return ue.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,He=Math.floor(Z.paddingTop/Z.lineHeight);let ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ye=Math.max(ye,me-1));const ot=(He+Z.viewLineCount+ye)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const He=Z.outerWidth,ye=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=me.stableMinimapLayoutInput,It=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Qt=Z.lineHeight,jt=Z.typicalHalfwidthCharacterWidth,xt=Z.scrollBeyondLastLine,_t=Z.minimap.renderCharacters;let Pt=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Vt=Z.minimap.maxColumn,Zt=Z.minimap.size,Xe=Z.minimap.side,si=Z.verticalScrollbarWidth,Xt=Z.viewLineCount,lt=Z.remainingWidth,vt=Z.isViewportWrapping,ti=_t?2:3;let Yt=Math.floor(ot*ye);const Lt=Yt/ot;let ft=!1,Ut=!1,Bt=ti*Pt,qt=Pt/ot,Ge=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Gt,desiredRatio:ni,minimapLineCount:Mt}=ue.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:xt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ye,lineHeight:Qt,pixelRatio:ot});if(Xt/Mt>1)ft=!0,Ut=!0,Pt=1,Bt=1,qt=Pt/ot;else{let Ct=!1,Et=Pt+1;if(Zt==="fit"){const pt=Math.ceil((ii+Xt+Gt)*Bt);vt&&It&&lt<=me.stableFitRemainingWidth?(Ct=!0,Et=me.stableFitMaxMinimapScale):Ct=pt>Yt}if(Zt==="fill"||Ct){ft=!0;const pt=Pt;Bt=Math.min(Qt*ot,Math.max(1,Math.floor(1/ni))),vt&&It&&lt<=me.stableFitRemainingWidth&&(Et=me.stableFitMaxMinimapScale),Pt=Math.min(Et,Math.max(1,Math.floor(Bt/ti))),Pt>pt&&(Ge=Math.min(2,Pt/pt)),qt=Pt/ot/Ge,Yt=Math.ceil(Math.max(Ot,ii+Xt+Gt)*Bt),vt?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=lt,me.stableFitMaxMinimapScale=Pt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ui=Math.floor(Vt*qt),Ht=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(jt+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Ht);const gt=zt/ot;zt=Math.floor(zt*Ge);const Nt=_t?1:2,At=Xe==="left"?0:He-Ht-si;return{renderMinimap:Nt,minimapLeft:At,minimapWidth:Ht,minimapHeightIsEditorHeight:ft,minimapIsSampling:Ut,minimapScale:Pt,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Yt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,me){const He=me.outerWidth|0,ye=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,It=me.typicalHalfwidthCharacterWidth,Qt=me.maxDigitWidth,jt=me.pixelRatio,xt=me.viewLineCount,_t=Z.get(137),Pt=_t==="inherit"?Z.get(136):_t,Vt=Pt==="inherit"?Z.get(132):Pt,Zt=Z.get(135),Xe=me.isDominatedByLongLines,si=Z.get(57),Xt=Z.get(68).renderType!==0,lt=Z.get(69),vt=Z.get(105),ti=Z.get(84),Yt=Z.get(73),Lt=Z.get(103),ft=Lt.verticalScrollbarSize,Ut=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,Ge=Z.get(43),ui=Z.get(110)!=="never";let Ht=Z.get(66);Ge&&ui&&(Ht+=16);let zt=0;if(Xt){const li=Math.max(dt,lt);zt=Math.round(li*Qt)}let gt=0;si&&(gt=ot*me.glyphMarginDecorationLaneCount);let Nt=0,At=Nt+gt,Ot=At+zt,ii=Ot+Ht;const Gt=He-gt-zt-Ht;let ni=!1,Mt=!1,Tt=-1;Pt==="inherit"&&Xe?(ni=!0,Mt=!0):Vt==="on"||Vt==="bounded"?Mt=!0:Vt==="wordWrapColumn"&&(Tt=Zt);const Ct=ue.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:jt,scrollBeyondLastLine:vt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Yt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Gt,isViewportWrapping:Mt},me.memory||new N);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Nt+=Ct.minimapWidth,At+=Ct.minimapWidth,Ot+=Ct.minimapWidth,ii+=Ct.minimapWidth);const Et=Gt-Ct.minimapWidth,pt=Math.max(1,Math.floor((Et-ft-2)/It)),St=Ut?Bt:0;return Mt&&(Tt=Math.max(1,pt),Vt==="bounded"&&(Tt=Math.min(Tt,Zt))),{width:He,height:ye,glyphMarginLeft:Nt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:zt,decorationsLeft:Ot,decorationsWidth:Ht,contentLeft:ii,contentWidth:Et,minimap:Ct,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Mt,wrappingColumn:Tt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class be extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return b(Z,"simple",["simple","advanced"])}compute(Z,me,He){return me.get(2)===2?"advanced":He}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class Pe extends y{constructor(){const Z={enabled:ie.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:b(Z.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class Fe extends y{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends y{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:b(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class U extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):t.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,He){return He<0?t.clampedInt(-He*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,me,He){return Z.fontInfo.lineHeight}}class pe extends y{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(me.scale,1,1,3),maxColumn:t.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Oe(X){return X==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class ke extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:t.clampedInt(me.top,0,0,1e3),bottom:t.clampedInt(me.bottom,0,0,1e3)}}}class $e extends y{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(143)}compute(Z,me,He){return Z.pixelRatio}}class J extends y{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:p.localize(89,null)},other:{anyOf:me,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const jt=Z?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:He,strings:ye}=Z,ot=["on","inline","off"];let dt,It,Qt;return typeof me=="boolean"?dt=me?"on":"off":dt=b(me,this.defaultValue.other,ot),typeof He=="boolean"?It=He?"on":"off":It=b(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Qt=ye?"on":"off":Qt=b(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Qt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,He=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function le(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Te extends y{constructor(){const Z=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="number")me.push({column:t.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;me.push({column:t.clampedInt(ye.column,0,0,1e4),color:ye.color})}return me.sort((He,ye)=>He.column-ye.column),me}return this.defaultValue}}class de extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends y{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,He=t.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=t.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:t.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:t.clampedInt(me.verticalSliderSize,ye,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,me){let He=!1;me.allowedCharacters&&Z&&(T.$1n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Z&&(T.$1n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},He=!0));const ye=super.applyUpdate(Z,me);return He?new u(ye.newValue,!0):ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const He={};for(const[ye,ot]of Object.entries(Z))ot===!0&&(He[ye]=!0);return He}}class z extends y{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends y{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends y{constructor(){const Z={enabled:O.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends y{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const He=me.indexOf(X);return He===-1?Z:me[He]}class re extends y{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Ne extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,He){return me.get(2)===2?0:He}}class et extends m{constructor(){super(146)}compute(Z,me,He){const ye=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:b(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:b(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?at:A.$k?mt:nt,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new S),accessibilityPageSize:Ue(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new r(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new r(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new r(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new r(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new r(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new d),contextmenu:Ue(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new r(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new $(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new r(34,"domReadOnly",!1)),dragAndDrop:Ue(new r(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new tt),stickyScroll:Ue(new Fe),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(271,null)})),find:Ue(new W),fixedOverflowWidgets:Ue(new r(42,"fixedOverflowWidgets",!1)),folding:Ue(new r(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new r(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new r(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new j),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new se),fontVariations:Ue(new R),formatOnPaste:Ue(new r(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new r(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new r(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new r(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ve),inDiffEditor:Ue(new r(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new Pe),lineDecorationsWidth:Ue(new U),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new r(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new r(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new pe),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new r(76,"mouseWheelZoom",!1,{markdownDescription:A.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new r(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new r(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new t(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),pasteAs:Ue(new it),parameterHints:Ue(new $e),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new r(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new J),quickSuggestionsDelay:Ue(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new r(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new r(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new r(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new r(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Te),scrollbar:Ue(new Me),scrollBeyondLastColumn:Ue(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new r(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new r(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new r(107,"selectionClipboard",!0,{description:p.localize(325,null),included:A.$k})),selectionHighlight:Ue(new r(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new r(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new r(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Ne),smoothScrolling:Ue(new r(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new z),inlineEdit:Ue(new L),inlineCompletionsAccessibilityVerbose:Ue(new r(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new r(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new ze),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new r(127,"useShadowDOM",!0)),useTabStops:Ue(new r(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new i(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new r(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new fe),tabFocusMode:Ue(new r(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new ue),wrappingInfo:Ue(new et),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new be)}}),define(Ae[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[157],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[158],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ae[159],Re([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Ae[160],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ae[161],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[162],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ae[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ae[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ae[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ae[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ae[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ae[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[181],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[182],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[183],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[184],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[185],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[186],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[187],Re([1,0,14,155]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var A;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...k){switch(k.length){case 1:return(0,T.localize)(0,null,k[0]);case 2:return(0,T.localize)(1,null,k[0],k[1]);case 3:return(0,T.localize)(2,null,k[0],k[1],k[2]);default:return}}const M=(0,T.localize)(3,null),p=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const y=this.d,u=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:u};this.g.push({offset:y,lexeme:u,additionalInfo:N}),this.f.push(v)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const y=this.c.substring(this.d,this.e),u=g.b.get(y);u?this.k(u):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,y=!1,u=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(p);return}const m=this.c.charCodeAt(N);if(y)y=!1;else if(m===47&&!u){N++;break}else m===91?u=!0:m===92?y=!0:m===93&&(u=!1);N++}for(;N<this.c.length&&g.a.has(this.c.charCodeAt(N));)N++;this.e=N;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=g}),define(Ae[188],Re([1,0,24,33,157,300]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=g,e.$Bp=k,e.$Cp=N,e.$Dp=y,e.$Ep=u,e.$Fp=v,e.$Gp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function g(r){return r=r.trim(),r==="*"||M.test(r)}function k(r){if(!g(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=r.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function N(r){if(!r)return null;const n=r.majorBase,t=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const i=r.patchBase;let b=r.patchMustEqual;r.hasCaret&&(n===0||(h=!1),b=!1);let a=0;if(r.preRelease){const $=p.exec(r.preRelease);if($){const[,l,S,d]=$;a=Date.UTC(Number(l),Number(S)-1,Number(d))}}return{majorBase:n,majorMustEqual:t,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:b,isMinimum:r.hasGreaterEquals,notBefore:a}}function y(r,n,t){let c;typeof r=="string"?c=N(k(r)):c=r;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof t=="string"?i=N(k(t)):i=t,!c||!i)return!1;const b=c.majorBase,a=c.minorBase,$=c.patchBase;let l=i.majorBase,S=i.minorBase,d=i.patchBase;const E=i.notBefore;let f=i.majorMustEqual,D=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?b>l?!0:b<l?!1:a>S?!0:a<S||h&&h<E?!1:$>=d:(b===1&&l===0&&(!f||!D||!w)&&(l=1,S=0,d=0,f=!0,D=!1,w=!1),b<l?!1:b>l?!f:a<S?!1:a>S?!D:$<d?!1:$>d?!w:!(h&&h<E))}function u(r,n,t,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,A.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,A.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,A.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,A.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,A.localize(9,null,"main")]),i;{const $=(0,I.$4g)(t,c.main);(0,I.$Xg)($,t)||i.push([T.default.Warning,A.localize(10,null,$.path,t.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,A.localize(11,null,"browser")]),i;{const $=(0,I.$4g)(t,c.browser);(0,I.$Xg)($,t)||i.push([T.default.Warning,A.localize(12,null,$.path,t.path)])}}if(!O.valid(c.version))return i.push([T.default.Error,A.localize(13,null)]),i;const b=[];if(!v(r,n,c,h,b))for(const $ of b)i.push([T.default.Error,$]);return i}function v(r,n,t,c,h){return c||typeof t.main>"u"&&typeof t.browser>"u"?!0:s(r,n,t.engines.vscode,h)}function m(r,n,t){return r==="*"||s(n,t,r)}function s(r,n,t,c=[]){const h=N(k(t));if(!h)return c.push(A.localize(14,null,t)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(A.localize(15,null,t)),!1}else if(!h.majorMustEqual)return c.push(A.localize(16,null,t)),!1;return y(r,n,h)?!0:(c.push(A.localize(17,null,r,t)),!1)}function o(r){if(!Array.isArray(r))return!1;for(let n=0,t=r.length;n<t;n++)if(typeof r[n]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class I{constructor(A,O=[],M=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$ni=I}),define(Ae[55],Re([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=O,e.$ps=M;const T=[];var A;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function O(p,g,k){g instanceof I.$ni||(g=new I.$ni(g,[],!!k)),T.push([p,g])}function M(){return T}}),define(Ae[189],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=I;class T{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const p=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);p.outgoing.set(g.key,g),g.incoming.set(p.key,p)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let p=this.a.get(M);return p||(p=new I(M,O),this.a.set(M,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,p]of this.a)O.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const p=new Set([O]),g=this.c(M,p);if(g)return g}}c(O,M){for(const[p,g]of O.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const k=this.c(g,M);if(k)return k;M.delete(p)}}}e.$6q=T}),define(Ae[3],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=A,e.$ri=O;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(I||(e._util=I={})),e.$pi=A("instantiationService");function T(M,p,g){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:M,index:g}):(p[I.DI_DEPENDENCIES]=[{id:M,index:g}],p[I.DI_TARGET]=p)}function A(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const p=function(g,k,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(p,g,N)};return p.toString=()=>M,I.serviceIds.set(M,p),p}function O(M){return M}}),define(Ae[48],Re([1,0,17,2,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=O,e.$Yi=M,e.$Zi=g,e.$1i=k,e.$2i=N,e.$3i=y,e.$4i=u,e.$5i=m,e.$6i=s,e.$7i=o,e.$Wi=(0,A.$qi)("configurationService");function O(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof T.URI)}var p;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function g(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function N(r,n){const t=Object.create(null);for(const c in r)y(t,c,r[c],n);return t}function y(r,n,t,c){const h=n.split("."),i=h.pop();let b=r;for(let a=0;a<h.length;a++){const $=h[a];let l=b[$];switch(typeof l){case"undefined":l=b[$]=Object.create(null);break;case"object":if(l===null){c(`Ignoring ${n} as ${h.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}b=l}if(typeof b=="object"&&b!==null)try{b[i]=t}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(b)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(b)}`)}function u(r,n){const t=n.split(".");v(r,t)}function v(r,n){const t=n.shift();if(n.length===0){delete r[t];return}if(Object.keys(r).indexOf(t)!==-1){const c=r[t];typeof c=="object"&&!Array.isArray(c)&&(v(c,n),Object.keys(c).length===0&&delete r[t])}}function m(r,n,t){function c(b,a){let $=b;for(const l of a){if(typeof $!="object"||$===null)return;$=$[l]}return $}const h=n.split("."),i=c(r,h);return typeof i>"u"?t:i}function s(r,n,t){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in r?I.$6f(r[c])&&I.$6f(n[c])?s(r[c],n[c],t):t&&(r[c]=n[c]):r[c]=n[c])})}function o(r){return r.replace(/[\[\]]/g,"")}}),define(Ae[31],Re([1,0,21,15,187,3,154,14]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=k,e.$pj=b,e.$qj=a,e.$Jj=ie;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.$j),g.set("isLinux",I.$k),g.set("isWindows",I.$i),g.set("isWeb",I.$o),g.set("isMacNative",I.$j&&!I.$o),g.set("isEdge",I.$H),g.set("isFirefox",I.$F),g.set("isChrome",I.$E),g.set("isSafari",I.$G);function k(ne,U){if(g.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ne,U)}const N=Object.prototype.hasOwnProperty;var y;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const u={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),r=(0,M.localize)(4,null),n=(0,M.localize)(5,null),t=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=u){this.k=U,this.d=new A.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const pe=this.D(),Oe=pe.type===17?n:void 0;throw this.h.push({message:r,offset:pe.offset,lexeme:A.$lj.getLexeme(pe),additionalInfo:Oe}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const x=this.o();U.push(x)}return U.length===1?U[0]:i.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const x=this.s();U.push(x)}return U.length===1?U[0]:i.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=U.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const ke=Oe.lexeme,$e=ke.lastIndexOf("/"),fe=$e===ke.length-1?void 0:this.w(ke.substring($e+1));let J;try{J=new RegExp(ke.substring(1,$e),fe)}catch{throw this.B("REGEX",Oe)}return j.create(x,J)}switch(Oe.type){case 10:case 19:{const ke=[Oe.lexeme];this.z();let $e=this.D(),fe=0;for(let Te=0;Te<Oe.lexeme.length;Te++)Oe.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<$e.lexeme.length;Te++)$e.lexeme.charCodeAt(Te)===40?fe++:Oe.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;ke.push(A.$lj.getLexeme($e)),this.z(),$e=this.D()}const J=ke.join(""),Y=J.lastIndexOf("/"),he=Y===J.length-1?void 0:this.w(J.substring(Y+1));let le;try{le=new RegExp(J.substring(1,Y),he)}catch{throw this.B("REGEX",Oe)}return i.regex(x,le)}case 18:{const ke=Oe.lexeme;this.z();let $e=null;if(!(0,T.$3e)(ke)){const fe=ke.indexOf("/"),J=ke.lastIndexOf("/");if(fe!==J&&fe>=0){const Y=ke.slice(fe+1,J),he=ke[J+1]==="i"?"i":"";try{$e=new RegExp(Y,he)}catch{throw this.B("REGEX",Oe)}}}if($e===null)throw this.B("REGEX",Oe);return j.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Oe=this.u();return i.notIn(x,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return i.equals(x,Oe);switch(Oe){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return i.notEquals(x,Oe);switch(Oe){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Oe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:t,offset:U.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,x){if(this.C(U))return this.z();throw this.B(x,this.D())}B(U,x,pe){const Oe=(0,M.localize)(8,null,U,A.$lj.getLexeme(x)),ke=x.offset,$e=A.$lj.getLexeme(x);return this.h.push({message:Oe,offset:ke,lexeme:$e,additionalInfo:pe}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=h;class i{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(U){return d.create(U)}static equals(U,x){return E.create(U,x)}static notEquals(U,x){return w.create(U,x)}static regex(U,x){return j.create(U,x)}static in(U,x){return f.create(U,x)}static notIn(U,x){return D.create(U,x)}static not(U){return C.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return ve.create(U,null,!0)}static greater(U,x){return V.create(U,x)}static greaterEquals(U,x){return W.create(U,x)}static smaller(U,x){return q.create(U,x)}static smallerEquals(U,x){return R.create(U,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=i;function b(ne){const U=new h({regexParsingWithErrorRecovery:!1});return ne.map(x=>(U.parse(x),U.lexingErrors.length>0?U.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function a(ne,U){const x=ne?ne.substituteConstants():void 0,pe=U?U.substituteConstants():void 0;return!x&&!pe?!0:!x||!pe?!1:x.equals(pe)}function $(ne,U){return ne.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return S.INSTANCE}}e.$rj=l;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$sj=S;class d{static create(U,x=null){const pe=g.get(U);return typeof pe=="boolean"?pe?S.INSTANCE:l.INSTANCE:new d(U,x)}constructor(U,x){this.key=U,this.c=x,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=g.get(this.key);return typeof U=="boolean"?U?S.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$tj=d;class E{static create(U,x,pe=null){if(typeof x=="boolean")return x?d.create(U,pe):C.create(U,pe);const Oe=g.get(U);return typeof Oe=="boolean"?x===(Oe?"true":"false")?S.INSTANCE:l.INSTANCE:new E(U,x,pe)}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?S.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$uj=E;class f{static create(U,x){return new f(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:be(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.f),pe=U.getValue(this.d);return Array.isArray(x)?x.includes(pe):typeof pe=="string"&&typeof x=="object"&&x!==null?N.call(x,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$vj=f;class D{static create(U,x){return new D(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=11,this.c=f.create(U,x)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=D;class w{static create(U,x,pe=null){if(typeof x=="boolean")return x?C.create(U,pe):d.create(U,pe);const Oe=g.get(U);return typeof Oe=="boolean"?x===(Oe?"true":"false")?l.INSTANCE:S.INSTANCE:new w(U,x,pe)}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?l.INSTANCE:S.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$xj=w;class C{static create(U,x=null){const pe=g.get(U);return typeof pe=="boolean"?pe?l.INSTANCE:S.INSTANCE:new C(U,x)}constructor(U,x){this.c=U,this.d=x,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=g.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:S.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.$yj=C;function P(ne,U){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?U(ne):l.INSTANCE}class V{static create(U,x,pe=null){return P(x,Oe=>new V(U,Oe,pe))}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$zj=V;class W{static create(U,x,pe=null){return P(x,Oe=>new W(U,Oe,pe))}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Aj=W;class q{static create(U,x,pe=null){return P(x,Oe=>new q(U,Oe,pe))}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Bj=q;class R{static create(U,x,pe=null){return P(x,Oe=>new R(U,Oe,pe))}constructor(U,x,pe){this.c=U,this.d=x,this.f=pe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:be(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=R;class j{static create(U,x){return new j(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const x=this.f?this.f.source:"",pe=U.f?U.f.source:"";return x<pe?-1:x>pe?1:0}equals(U){if(U.type===this.type){const x=this.f?this.f.source:"",pe=U.f?U.f.source:"";return this.d===U.d&&x===pe}return!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Dj=j;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Ej=K;function se(ne){let U=null;for(let x=0,pe=ne.length;x<pe;x++){const Oe=ne[x].substituteConstants();if(ne[x]!==Oe&&U===null){U=[];for(let ke=0;ke<x;ke++)U[ke]=ne[ke]}U!==null&&(U[x]=Oe)}return U===null?ne:U}class ce{static create(U,x,pe){return ce.d(U,x,pe)}constructor(U,x){this.expr=U,this.c=x,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=$(this.expr[x],U.expr[x]);if(Oe!==0)return Oe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=se(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].evaluate(U))return!1;return!0}static d(U,x,pe){const Oe=[];let ke=!1;for(const $e of U)if($e){if($e.type===1){ke=!0;continue}if($e.type===0)return l.INSTANCE;if($e.type===6){Oe.push(...$e.expr);continue}Oe.push($e)}if(Oe.length===0&&ke)return S.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort($);for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const $e=Oe[Oe.length-1];if($e.type!==9)break;Oe.pop();const fe=Oe.pop(),J=Oe.length===0,Y=ve.create($e.expr.map(he=>ce.create([he,fe],null,pe)),null,J);Y&&(Oe.push(Y),Oe.sort($))}if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let fe=$e+1;fe<Oe.length;fe++)if(Oe[$e].negate().equals(Oe[fe]))return l.INSTANCE;if(Oe.length===1)return Oe[0]}return new ce(Oe,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ce(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());this.c=ve.create(U,this,!0)}return this.c}}e.$Fj=ce;class ve{static create(U,x,pe){return ve.d(U,x,pe)}constructor(U,x){this.expr=U,this.c=x,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,pe=this.expr.length;x<pe;x++){const Oe=$(this.expr[x],U.expr[x]);if(Oe!==0)return Oe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,pe=this.expr.length;x<pe;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=se(this.expr);return U===this.expr?this:ve.create(U,this.c,!1)}evaluate(U){for(let x=0,pe=this.expr.length;x<pe;x++)if(this.expr[x].evaluate(U))return!0;return!1}static d(U,x,pe){let Oe=[],ke=!1;if(U){for(let $e=0,fe=U.length;$e<fe;$e++){const J=U[$e];if(J){if(J.type===0){ke=!0;continue}if(J.type===1)return S.INSTANCE;if(J.type===9){Oe=Oe.concat(J.expr);continue}Oe.push(J)}}if(Oe.length===0&&ke)return l.INSTANCE;Oe.sort($)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let $e=1;$e<Oe.length;$e++)Oe[$e-1].equals(Oe[$e])&&(Oe.splice($e,1),$e--);if(Oe.length===1)return Oe[0];if(pe){for(let $e=0;$e<Oe.length;$e++)for(let fe=$e+1;fe<Oe.length;fe++)if(Oe[$e].negate().equals(Oe[fe]))return S.INSTANCE;if(Oe.length===1)return Oe[0]}return new ve(Oe,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ve(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());for(;U.length>1;){const x=U.shift(),pe=U.shift(),Oe=[];for(const ke of Fe(x))for(const $e of Fe(pe))Oe.push(ce.create([ke,$e],null,!1));U.unshift(ve.create(Oe,null,!1))}this.c=ve.create(U,this,!0)}return this.c}}e.$Gj=ve;class Ie extends d{static{this.d=[]}static all(){return Ie.d.values()}constructor(U,x,pe){super(U,null),this.f=x,typeof pe=="object"?Ie.d.push({...pe,key:U}):pe!==!0&&Ie.d.push({key:U,description:pe,type:x!=null?typeof x:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.$Hj=Ie,e.$Ij=(0,O.$qi)("contextKeyService");function ue(ne,U){return ne<U?-1:ne>U?1:0}function be(ne,U,x,pe){return ne<x?-1:ne>x?1:U<pe?-1:U>pe?1:0}function ie(ne,U){if(ne.type===0||U.type===1)return!0;if(ne.type===9)return U.type===9?Pe(ne.expr,U.expr):!1;if(U.type===9){for(const x of U.expr)if(ie(ne,x))return!0;return!1}if(ne.type===6){if(U.type===6)return Pe(U.expr,ne.expr);for(const x of ne.expr)if(ie(x,U))return!0;return!1}return ne.equals(U)}function Pe(ne,U){let x=0,pe=0;for(;x<ne.length&&pe<U.length;){const Oe=ne[x].cmp(U[pe]);if(Oe<0)return!1;Oe===0&&x++,pe++}return x===ne.length}function Fe(ne){return ne.type===9?ne.expr:[ne]}}),define(Ae[190],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,I.$qi)("environmentService"),e.$yi=(0,I.$ri)(e.$xi)}),define(Ae[98],Re([1,0,156,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=A,e.$Uo=O,e.$Vo=M,e.$Wo=p,e.$Xo=g,e.$Yo=k,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function A(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,c){switch(t){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,c){return c==="web"&&!t.includes("web")}function g(t,c,h){return p(c,h)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===h}function k(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var N;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var u;(function(t){t.Install="install",t.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Zo=(0,T.$qi)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var s;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$1o=o;var r;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$2o=n,e.$3o=(0,T.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,T.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,T.$qi)("IExtensionTipsService"),e.$8o=(0,I.localize2)(0,"Extensions"),e.$9o=(0,I.localize2)(1,"Preferences")}),define(Ae[44],Re([1,0,52,19,15,17,2,158,3,21,12,41]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=u,e.$Yk=s,e.$Zk=r,e.$1k=n,e.$2k=t,e.$3k=c,e.$4k=h,e.$5k=i,e.$6k=b,e.$7k=a,e.$8k=$,e.$0k=d,e.$$k=E,e.$_k=f,e.$al=D,e.$bl=w,e.$el=q,e.$ql=ve,e.$rl=Ie,e.$tl=be,e.$Wk=(0,g.$qi)("fileService");function u(ie){return ie.create===!0}var v;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var m;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function s(ie){const Pe=ie;return!!Pe&&typeof Pe.onDidChange=="function"}var o;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function r(ie){return!!(ie.capabilities&2)}function n(ie){return!!(ie.capabilities&8)}function t(ie){return!!(ie.capabilities&131072)}function c(ie){return!!(ie.capabilities&4)}function h(ie){return!!(ie.capabilities&16)}function i(ie){return r(ie)?!!(ie.capabilities&16384):!1}function b(ie){return r(ie)?!!(ie.capabilities&32768):!1}function a(ie){return!!(ie.capabilities&65536)}function $(ie){return!!(ie.capabilities&2048)}var l;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(Pe,Fe){const ne=new S(Pe.toString(),Fe);return f(ne,Fe),ne}constructor(Pe,Fe){super(Pe),this.code=Fe}}e.$9k=S;function d(ie,Pe){return S.create(ie,Pe)}function E(ie){return ie||d((0,p.localize)(0,null),l.Unknown)}function f(ie,Pe){return ie.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",ie}function D(ie){if(!ie)return l.Unknown;if(ie instanceof S)return ie.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Pe)return l.Unknown;switch(Pe[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function w(ie){if(ie instanceof R)return ie.fileOperationResult;switch(D(ie)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var C;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class P{constructor(Pe,Fe,ne){this.resource=Pe,this.operation=Fe,this.target=ne}isOperation(Pe){return this.operation===Pe}}e.$cl=P;var V;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class W{static{this.a=null}constructor(Pe,Fe){this.c=Fe,this.b=void 0,this.d=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawAdded.map(U=>[U,!0])),ne}),this.f=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(U=>[U,!0])),ne}),this.g=new y.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(U=>[U,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Pe){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==W.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Pe,...Fe){return this.h(Pe,{includeChildren:!1},...Fe)}affects(Pe,...Fe){return this.h(Pe,{includeChildren:!0},...Fe)}h(Pe,Fe,...ne){if(!Pe)return!1;const U=ne.length>0;return!!((!U||ne.includes(1))&&(this.d.value.get(Pe)||Fe.includeChildren&&this.d.value.findSuperstr(Pe))||(!U||ne.includes(0))&&(this.f.value.get(Pe)||Fe.includeChildren&&this.f.value.findSuperstr(Pe))||(!U||ne.includes(2))&&(this.g.value.findSubstr(Pe)||Fe.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$dl=W;function q(ie,Pe,Fe){return!ie||!Pe||ie===Pe||Pe.length>ie.length?!1:(Pe.charAt(Pe.length-1)!==T.sep&&(Pe+=T.sep),Fe?(0,A.$uf)(ie,Pe):ie.indexOf(Pe)===0)}class R extends Error{constructor(Pe,Fe,ne){super(Pe),this.fileOperationResult=Fe,this.options=ne}}e.$fl=R;class j extends R{constructor(Pe,Fe,ne,U){super(Pe,Fe,U),this.fileOperationResult=Fe,this.size=ne}}e.$gl=j;class K extends R{constructor(Pe,Fe,ne){super(Pe,2,ne),this.stat=Fe}}e.$hl=K;var se;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var ce;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$pl="";function ve(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}async function Ie(ie,Pe){if(!Pe.hasProvider(M.URI.from({scheme:ie.scheme})))return new Promise(Fe=>{const ne=Pe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ie.scheme&&U.added&&(ne.dispose(),Fe())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Pe){return(0,O.$8f)(Pe)||(Pe=0),Pe<ue.KB?(0,p.localize)(1,null,Pe.toFixed(0)):Pe<ue.MB?(0,p.localize)(2,null,(Pe/ue.KB).toFixed(2)):Pe<ue.GB?(0,p.localize)(3,null,(Pe/ue.MB).toFixed(2)):Pe<ue.TB?(0,p.localize)(4,null,(Pe/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Pe/ue.TB).toFixed(2))}}e.$sl=ue;function be(ie){const Pe=typeof ie=="string"||ie?.scheme===N.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===N.Schemas.file?1024*ue.MB:Pe?10*ue.MB:k.$o?50*ue.MB:1024*ue.MB}}),define(Ae[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(...A){this.a=new Map;for(const[O,M]of A)this.set(O,M)}set(A,O){const M=this.a.get(A);return this.a.set(A,O),M}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$oi=I}),define(Ae[191],Re([1,0,11,14,6,70,189,3,71,192]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const N=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$oi,r=!1,n,t=N){this.i=o,this.j=r,this.k=n,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=t?n?._globalGraph??new M.$6q(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,A.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const r=new class extends u{dispose(){this.h.delete(r),super.dispose()}}(o,this.j,this,this.l);return this.h.add(r),r}invokeFunction(o,...r){this.m();const n=m.traceInvocation(this.l,o);let t=!1;try{return o({get:h=>{if(t)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...r)}finally{t=!0,n.stop()}}createInstance(o,...r){this.m();let n,t;return o instanceof O.$ni?(n=m.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(r),n)):(n=m.traceCreation(this.l,o),t=this.o(o,r,n)),n.stop(),t}o(o,r=[],n){const t=p._util.getServiceDependencies(o).sort((i,b)=>i.index-b.index),c=[];for(const i of t){const b=this.s(i.id,n);b||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(b)}const h=t.length>0?t[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${r.length} static arguments`);const i=h-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,h)}return Reflect.construct(o,r.concat(c))}q(o,r){if(this.i.get(o)instanceof O.$ni)this.i.set(o,r);else if(this.k)this.k.q(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const r=this.i.get(o);return!r&&this.k?this.k.r(o):r}s(o,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.r(o);return n instanceof O.$ni?this.u(o,n,r.branch(o,!0)):(r.branch(o,!1),n)}u(o,r,n){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,r,n)}finally{this.t.delete(o)}}v(o,r,n){const t=new M.$6q(i=>i.id.toString());let c=0;const h=[{id:o,desc:r,_trace:n}];for(;h.length;){const i=h.pop();if(t.lookupOrInsertNode(i),c++>1e3)throw new y(t);for(const b of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r(b.id);if(a||this.y(`[createInstance] ${o} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(b.id)),a instanceof O.$ni){const $={id:b.id,desc:a,_trace:i._trace.branch(b.id,!0)};t.insertEdge(i,$),h.push($)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:b}of i){if(this.r(b.id)instanceof O.$ni){const $=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,$)}t.removeNode(b)}}return this.r(o)}w(o,r,n=[],t,c){if(this.i.get(o)instanceof O.$ni)return this.x(o,r,n,t,c,this.g);if(this.k)return this.k.w(o,r,n,t,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}x(o,r,n=[],t,c,h){if(t){const i=new u(void 0,this.j,this,this.l);i.c=String(o);const b=new Map,a=new I.$Jh(()=>{const $=i.o(r,n,c);for(const[l,S]of b){const d=$[l];if(typeof d=="function")for(const E of S)E.disposable=d.apply($,E.listener)}return b.clear(),h.add($),$});return new Proxy(Object.create(null),{get($,l){if(!a.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let E=b.get(l);return E||(E=new k.$5c,b.set(l,E)),(D,w,C)=>{if(a.isInitialized)return a.value[l](D,w,C);{const P={listener:[D,w,C],disposable:void 0},V=E.push(P);return(0,A.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(l in $)return $[l];const S=a.value;let d=S[l];return typeof d!="function"||(d=d.bind(S),$[l]=d),d},set($,l,S){return a.value[l]=S,!0},getPrototypeOf($){return r.prototype}})}else{const i=this.o(r,n,c);return h.add(i),i}}y(o,r){if(r&&console.warn(o),this.j)throw new Error(o)}}e.$7q=u;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,r){return o?new m(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,r){return o?new m(1,r.name):m.c}static{this.f=0}constructor(o,r){this.type=o,this.name=r,this.g=Date.now(),this.h=[]}branch(o,r){const n=new m(3,o.toString());return this.h.push([o,r,n]),n}stop(){const o=Date.now()-this.g;m.f+=o;let r=!1;function n(c,h){const i=[],b=new Array(c+1).join("	");for(const[a,$,l]of h.h)if($&&l){r=!0,i.push(`${b}CREATES -> ${a}`);const S=n(c+1,l);S&&i.push(S)}else i.push(`${b}uses -> ${a}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||r)&&m.all.add(t.join(`
`))}}e.$8q=m}),define(Ae[13],Re([1,0,159,43,5,99,6,28,21,24,17,2,31,3]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=s,e.log=r,e.$$j=d,e.$_j=E,e.$ak=f,e.$bk=D,e.$Wj=(0,v.$qi)("logService"),e.$Xj=(0,v.$qi)("loggerService");function m(){return new Date().toISOString()}function s(w){return(0,N.$8f)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Zj=o.Info;function r(w,C,P){switch(C){case o.Trace:w.trace(P);break;case o.Debug:w.debug(P);break;case o.Info:w.info(P);break;case o.Warning:w.warn(P);break;case o.Error:w.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(w,C=!1){let P="";for(let V=0;V<w.length;V++){let W=w[V];if(W instanceof Error&&(W=(0,T.$bj)(W,C)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class t extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new A.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$2j=t;class c extends t{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,n([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,n([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,n([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,n([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=C.stack,this.g(o.Error,n(V))}else this.g(o.Error,n([C,...P]))}flush(){}}e.$3j=c;class h extends t{constructor(C=e.$Zj){super(),this.setLevel(C),this.g=!g.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...P):console.warn(`[main ${m()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...P):console.error(`[main ${m()}]`,C,...P))}flush(){}}e.$4j=h;class i extends t{constructor(C=e.$Zj,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$5j=i;class b extends t{constructor(C,P=e.$Zj){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,T.$bj)(C,this.f(o.Trace))}flush(){}}e.$6j=b;class a extends t{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const V of this.g)V.trace(C,...P)}debug(C,...P){for(const V of this.g)V.debug(C,...P)}info(C,...P){for(const V of this.g)V.info(C,...P)}warn(C,...P){for(const V of this.g)V.warn(C,...P)}error(C,...P){for(const V of this.g)V.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$7j=a;class $ extends M.$Uc{constructor(C,P,V){if(super(),this.h=C,this.j=P,this.b=new p.$Bc,this.c=this.B(new A.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$be),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(C){return(0,N.$4f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const V=this.n(C),W=(0,N.$4f)(C)?C:P?.id??(0,O.$ej)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const R=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(V,R??this.getLogLevel(V)??this.h,{...P,id:W}));const j={logger:q,info:{resource:V,id:W,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(j.info),this.b.set(V,j),q}n(C){return(0,N.$4f)(C)?(0,k.$4g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(y.URI.isUri(C)){const V=C,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=C;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const V=this.m(C);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=$;class l{constructor(){this.onDidChangeLogLevel=new A.$be().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$9j=l;class S extends l{}e.$0j=S;function d(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const C=D(w.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Zj}function E(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(w){switch(w){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function D(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ck=new u.$Hj("logLevel",E(o.Info))}),define(Ae[193],Re([1,0,6,13]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;class A extends I.$Uc{constructor(M,p=[]){super(),this.a=new T.$7j([M,...p]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$AQ=A}),define(Ae[100],Re([1,0,33,160,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function k(m,s){return s-m}g.compare=k;const N=Object.create(null);N[g.Error]=(0,T.localize)(0,null),N[g.Warning]=(0,T.localize)(1,null),N[g.Info]=(0,T.localize)(2,null);function y(m){return N[m]||""}g.toString=y;function u(m){switch(m){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=u;function v(m){switch(m){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=v}(M||(e.MarkerSeverity=M={}));var p;(function(g){const k="";function N(u){return y(u,!0)}g.makeKey=N;function y(u,v){const m=[k];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(k),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(k),u.severity!==void 0&&u.severity!==null?m.push(M.toString(u.severity)):m.push(k),u.message&&v?m.push(u.message.replace("\xA6","\\\xA6")):m.push(k),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(k),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(k),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(k),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(k),m.push(k),m.join("\xA6")}g.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$Tt=(0,A.$qi)("markerService")}),define(Ae[194],Re([1,0,5,33,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=T.default,e.$Tv=(0,A.$qi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var g;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class k{constructor(){this.progress=new N,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Vv=k;class N{infinite(){}done(){}total(u){}worked(u){}}e.$Wv=N}),define(Ae[195],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,I.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,T){var A=arguments.length,O=A<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,I):T,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,I,T);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(O=(A<3?M(O):A>3?M(e,I,O):M(e,I))||O);return A>3&&O&&Object.defineProperty(e,I,O),O},Ve=this&&this.__param||function(ge,e){return function(I,T){e(I,T,ge)}};define(Ae[101],Re([1,0,11,22,6,3]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,O.$qi)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Zv=p;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const v=this.d;this.d=()=>{v?.(),u()}}):Promise.resolve()}}e.$1v=g;let k=class extends A.$Uc{constructor(u,v){super(),this.a=new I.$Nh,v.withProgress(u,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,A.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$2v=k,e.$2v=k=Je([Ve(1,e.$Xv)],k);class N extends A.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Tc)}start(u){this.stop();const v=++this.a,m=new T.$me;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Sc)(()=>m.cancel())),this.b.add((0,A.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:m.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$3v=N,e.$4v=(0,O.$qi)("editorProgressService")}),define(Ae[30],Re([1,0,56,17]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class A{constructor(){this.a=new Map}add(M,p){I.ok(T.$4f(M)),I.ok(T.$6f(p)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new A}),define(Ae[72],Re([1,0,5,30]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,k){this.a[A(g)]=k,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;T.$9n.add(e.$0n.JSONContribution,M)}),define(Ae[57],Re([1,0,18,5,17,153,48,72,30]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=s,e.$no=o,e.$oo=r,e.$po=t,e.$qo=c;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$bo={Configuration:"base.contributions.configuration"};var N;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const y=g.$9n.as(p.$0n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$be,this.onDidSchemaChange=this.i.event,this.j=new T.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$io,this.g),this.v()}registerConfiguration(i,b=!0){this.registerConfigurations([i],b)}registerConfigurations(i,b=!0){const a=new Set;this.n(i,b,a),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const b=new Set;this.o(i,b),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:i,remove:b}){const a=new Set;this.o(b,a),this.n(i,!1,a),y.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const b=new Set;this.k(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(i,b){const a=[];for(const{overrides:$,source:l}of i)for(const S in $)if(b.add(S),e.$lo.test(S)){const d=this.a.get(S),E=d?.valuesSources??new Map;if(l)for(const C of Object.keys($[S]))E.set(C,l);const f={...d?.value||{},...$[S]};this.a.set(S,{source:l,value:f,valuesSources:E});const D=(0,M.$7i)(S),w={type:"object",default:f,description:O.localize(1,null,D),$ref:e.$io,defaultDefaultValue:f,source:A.$4f(l)?void 0:l,defaultValueSource:l};a.push(...s(S)),this.d[S]=w,this.b.properties[S]=w}else{this.a.set(S,{value:$[S],source:l});const d=this.d[S];d&&(this.w(S,d),this.r(S,d))}this.m(a)}deregisterDefaultConfigurations(i){const b=new Set;this.l(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(i,b){for(const{overrides:a,source:$}of i)for(const l in a){const S=this.a.get(l),d=A.$4f($)?$:$?.id,E=A.$4f(S?.source)?S?.source:S?.source?.id;if(d===E)if(b.add(l),this.a.delete(l),e.$lo.test(l))delete this.d[l],delete this.b.properties[l];else{const f=this.d[l];f&&(this.w(l,f),this.r(l,f))}}this.u()}deltaConfiguration(i){let b=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),b=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),b=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const b of i)this.h.add(b);this.u()}n(i,b,a){i.forEach($=>{this.p($,b,$.extensionInfo,$.restrictedProperties,void 0,a),this.c.push($),this.q($)})}o(i,b){const a=$=>{if($.properties)for(const l in $.properties){b.add(l);const S=this.d[l];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[l],this.s(l,$.properties[l])}$.allOf?.forEach(l=>a(l))};for(const $ of i){a($);const l=this.c.indexOf($);l!==-1&&this.c.splice(l,1)}}p(i,b=!0,a,$,l=3,S){l=A.$ag(i.scope)?l:i.scope;const d=i.properties;if(d)for(const f in d){const D=d[f];if(b&&t(f,D)){delete d[f];continue}if(D.source=a,D.defaultDefaultValue=d[f].default,this.w(f,D),e.$lo.test(f)?D.scope=void 0:(D.scope=A.$ag(D.scope)?l:D.scope,D.restricted=A.$ag(D.restricted)?!!$?.includes(f):D.restricted),d[f].hasOwnProperty("included")&&!d[f].included){this.f[f]=d[f],delete d[f];continue}else this.d[f]=d[f],d[f].policy?.name&&this.e.set(d[f].policy.name,f);!d[f].deprecationMessage&&d[f].markdownDeprecationMessage&&(d[f].deprecationMessage=d[f].markdownDeprecationMessage),S.add(f)}const E=i.allOf;if(E)for(const f of E)this.p(f,b,a,$,l,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const b=a=>{const $=a.properties;if($)for(const S in $)this.r(S,$[S]);a.allOf?.forEach(b)};b(i)}r(i,b){switch(e.$co.properties[i]=b,b.scope){case 1:e.$do.properties[i]=b;break;case 2:e.$eo.properties[i]=b;break;case 6:e.$fo.properties[i]=b;break;case 3:e.$go.properties[i]=b;break;case 4:e.$ho.properties[i]=b;break;case 5:e.$ho.properties[i]=b,this.g.properties[i]=b;break}}s(i,b){switch(delete e.$co.properties[i],b.scope){case 1:delete e.$do.properties[i];break;case 2:delete e.$eo.properties[i];break;case 6:delete e.$fo.properties[i];break;case 3:delete e.$go.properties[i];break;case 4:case 5:delete e.$ho.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const b=`[${i}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$io};this.w(b,a),e.$co.properties[b]=a,e.$do.properties[b]=a,e.$eo.properties[b]=a,e.$fo.properties[b]=a,e.$go.properties[b]=a,e.$ho.properties[b]=a}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=i,e.$do.patternProperties[e.$ko]=i,e.$eo.patternProperties[e.$ko]=i,e.$fo.patternProperties[e.$ko]=i,e.$go.patternProperties[e.$ko]=i,e.$ho.patternProperties[e.$ko]=i,this.i.fire()}w(i,b){const a=this.a.get(i);let $=a?.value,l=a?.source;A.$$f($)&&($=b.defaultDefaultValue,l=void 0),A.$$f($)&&($=r(b.type)),b.default=$,b.defaultValueSource=l}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.$ko=`^(${v})+$`,e.$lo=new RegExp(e.$ko);function s(h){const i=[];if(e.$lo.test(h)){let b=m.exec(h);for(;b?.length;){const a=b[1].trim();a&&i.push(a),b=m.exec(h)}}return(0,I.$Mb)(i)}function o(h){return h.reduce((i,b)=>`${i}[${b}]`,"")}function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;g.$9n.add(e.$bo.Configuration,n);function t(h,i){return h.trim()?e.$lo.test(h)?O.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function c(){const h=[],i=n.getConfigurationProperties();for(const b of Object.keys(i))h.push([b,i[b].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ae[196],Re([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=t;function v(b){return Object.isFrozen(b)?b:p.$Xn(b)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,$,l,S,d){this.b=a,this.c=$,this.d=l,this.raw=S,this.f=d,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map($=>{if($ instanceof m)return $;const l=new s("",this.f);return l.parseRaw($),l.configurationModel});this.g=a.reduce(($,l)=>l===$?l:$.merge(l),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,N.$5i)(this.contents,a):this.contents}inspect(a,$){const l=this;return{get value(){return v(l.rawConfiguration.getValue(a))},get override(){return $?v(l.rawConfiguration.getOverrideValue(a,$)):void 0},get merged(){return v($?l.rawConfiguration.override($).getValue(a):l.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:d,identifiers:E,keys:f}of l.rawConfiguration.overrides){const D=new m(d,f,[],void 0,l.f).getValue(a);D!==void 0&&S.push({identifiers:E,value:D})}return S.length?v(S):void 0}}}getOverrideValue(a,$){const l=this.j($);return l?a?(0,N.$5i)(l,a):l:void 0}getKeysForOverrideIdentifier(a){const $=[];for(const l of this.overrides)l.identifiers.includes(a)&&$.push(...l.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const a=[];for(const $ of this.overrides)a.push(...$.identifiers);return I.$Mb(a)}override(a){let $=this.a.get(a);return $||($=this.h(a),this.a.set(a,$)),$}merge(...a){const $=p.$Wn(this.contents),l=p.$Wn(this.overrides),S=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const E of a)if(d.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.i($,E.contents);for(const f of E.overrides){const[D]=l.filter(w=>I.$ub(w.identifiers,f.identifiers));D?(this.i(D.contents,f.contents),D.keys.push(...f.keys),D.keys=I.$Mb(D.keys)):l.push(p.$Wn(f))}for(const f of E.keys)S.indexOf(f)===-1&&S.push(f)}return new m($,S,l,d.every(E=>E instanceof m)?void 0:d,this.f)}h(a){const $=this.j(a);if(!$||typeof $!="object"||!Object.keys($).length)return this;const l={};for(const S of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let d=this.contents[S];const E=$[S];E&&(typeof d=="object"&&typeof E=="object"?(d=p.$Wn(d),this.i(d,E)):d=E),l[S]=d}return new m(l,this.keys,this.overrides,void 0,this.f)}i(a,$){for(const l of Object.keys($)){if(l in a&&g.$6f(a[l])&&g.$6f($[l])){this.i(a[l],$[l]);continue}a[l]=p.$Wn($[l])}}j(a){let $=null,l=null;const S=d=>{d&&(l?this.i(l,d):l=p.$Wn(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===a?$=d.contents:d.identifiers.includes(a)&&S(d.contents);return S($),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,$){this.k(a,$,!0)}setValue(a,$){this.k(a,$,!1)}removeValue(a){const $=this.keys.indexOf(a);$!==-1&&(this.keys.splice($,1),(0,N.$4i)(this.contents,a),y.$lo.test(a)&&this.overrides.splice(this.overrides.findIndex(l=>I.$ub(l.identifiers,(0,y.$mo)(a))),1))}k(a,$,l){(0,N.$3i)(this.contents,a,$,S=>this.f.error(S)),l=l||this.keys.indexOf(a)===-1,l&&this.keys.push(a),y.$lo.test(a)&&this.overrides.push({identifiers:(0,y.$mo)(a),keys:Object.keys(this.contents[a]),contents:(0,N.$2i)(this.contents[a],S=>this.f.error(S))})}}e.$ro=m;class s{constructor(a,$){this.f=a,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,$){if(!g.$ag(a)){const l=this.h(a);this.parseRaw(l,$)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,$){this.a=a;const{contents:l,keys:S,overrides:d,restricted:E,hasExcludedProperties:f}=this.i(a,$);this.b=new m(l,S,d,f?[a]:void 0,this.g),this.c=E||[]}h(a){let $={},l=null,S=[];const d=[],E=[];function f(w){Array.isArray(S)?S.push(w):l!==null&&(S[l]=w)}const D={onObjectBegin:()=>{const w={};f(w),d.push(S),S=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{S=d.pop()},onArrayBegin:()=>{const w=[];f(w),d.push(S),S=w,l=null},onArrayEnd:()=>{S=d.pop()},onLiteralValue:f,onError:(w,C,P)=>{E.push({error:w,offset:C,length:P})}};if(a)try{A.$Kn(a,D),$=S[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return $}i(a,$){const l=u.$9n.as(y.$bo.Configuration).getConfigurationProperties(),S=this.j(a,l,!0,$);a=S.raw;const d=(0,N.$2i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),E=Object.keys(a),f=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:d,keys:E,overrides:f,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,$,l,S){let d=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:d};const E={},f=[];for(const D in a)if(y.$lo.test(D)&&l){const w=this.j(a[D],$,!1,S);E[D]=w.raw,d=d||w.hasExcludedProperties,f.push(...w.restricted)}else{const w=$[D],C=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&f.push(D),!S.exclude?.includes(D)&&(S.include?.includes(D)||(C===void 0||S.scopes===void 0||S.scopes.includes(C))&&!(S.skipRestricted&&w?.restricted))?E[D]=a[D]:d=!0}return{raw:E,restricted:f,hasExcludedProperties:d}}l(a,$){const l=[];for(const S of Object.keys(a))if(y.$lo.test(S)){const d={};for(const E in a[S])d[E]=a[S][E];l.push({identifiers:(0,y.$mo)(S),keys:Object.keys(d),contents:(0,N.$2i)(d,$)})}return l}}e.$so=s;class o extends O.$Uc{constructor(a,$,l,S,d){super(),this.c=a,this.f=$,this.g=S,this.h=d,this.b=this.B(new T.$be),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),d),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&l.isEqual(E.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=o;class r{constructor(a,$,l,S,d,E,f,D,w,C,P,V,W){this.a=a,this.b=$,this.c=l,this.overrideIdentifiers=S,this.d=d,this.f=E,this.g=f,this.h=D,this.i=w,this.j=C,this.k=P,this.l=V,this.m=W}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,$,l,S,d,E,f,D,w,C){this.j=a,this.l=$,this.m=l,this.n=S,this.p=d,this.q=E,this.r=f,this.s=D,this.t=w,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,$,l){return this.w(a,$,l).getValue(a)}updateValue(a,$,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=m.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,$===void 0?S.removeValue(a):S.setValue(a,$),l.resource||(this.h=null)}inspect(a,$,l){const S=this.w(a,$,l),d=this.A($.resource,l),E=$.resource?this.t.get($.resource)||this.s:this.s,f=new Set;for(const D of S.overrides)for(const w of D.identifiers)S.getOverrideValue(a,w)!==void 0&&f.add(w);return new r(a,$,S.getValue(a),f.size?[...f]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,d||void 0,E)}keys(a){const $=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,$){this.r.set(a,$),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,$){const l=[];if(!$){const{added:S,updated:d,removed:E}=h(this.j,a);$=[...S,...d,...E]}for(const S of $)for(const d of(0,y.$mo)(S)){const E=this.j.getKeysForOverrideIdentifier(d),f=a.getKeysForOverrideIdentifier(d),D=[...f.filter(w=>E.indexOf(w)===-1),...E.filter(w=>f.indexOf(w)===-1),...E.filter(w=>!p.$1n(this.j.override(d).getValue(w),a.override(d).getValue(w)))];l.push([d,D])}return this.updateDefaultConfiguration(a),{keys:$,overrides:l}}compareAndUpdatePolicyConfiguration(a){const{added:$,updated:l,removed:S}=h(this.l,a),d=[...$,...l,...S];return d.length&&this.updatePolicyConfiguration(a),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.applicationConfiguration,a),E=[...$,...l,...S];return E.length&&this.updateApplicationConfiguration(a),{keys:E,overrides:d}}compareAndUpdateLocalUserConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.localUserConfiguration,a),E=[...$,...l,...S];return E.length&&this.updateLocalUserConfiguration(a),{keys:E,overrides:d}}compareAndUpdateRemoteUserConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.remoteUserConfiguration,a),E=[...$,...l,...S];return E.length&&this.updateRemoteUserConfiguration(a),{keys:E,overrides:d}}compareAndUpdateWorkspaceConfiguration(a){const{added:$,updated:l,removed:S,overrides:d}=h(this.workspaceConfiguration,a),E=[...$,...l,...S];return E.length&&this.updateWorkspaceConfiguration(a),{keys:E,overrides:d}}compareAndUpdateFolderConfiguration(a,$){const l=this.folderConfigurations.get(a),{added:S,updated:d,removed:E,overrides:f}=h(l,$),D=[...S,...d,...E];return(D.length||!l)&&this.updateFolderConfiguration(a,$),{keys:D,overrides:f}}compareAndDeleteFolderConfiguration(a){const $=this.folderConfigurations.get(a);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:l,updated:S,removed:d,overrides:E}=h($,void 0);return{keys:[...l,...S,...d],overrides:E}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,$,l){let S=this.x($,l);return $.overrideIdentifier&&(S=S.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},$){let l=this.y();if($&&a){const S=$.getFolder(a);S&&(l=this.z(S.uri)||l);const d=this.t.get(a);d&&(l=l.merge(d))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let $=this.i.get(a);if(!$){const l=this.y(),S=this.r.get(a);S?($=l.merge(S),this.i.set(a,$)):$=l}return $}A(a,$){if($&&a){const l=$.getFolder(a);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,$)=>{const{contents:l,overrides:S,keys:d}=this.r.get($);return a.push([$,{contents:l,overrides:S,keys:d}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach($=>a.add($)),this.userConfiguration.keys.forEach($=>a.add($)),this.q.keys.forEach($=>a.add($)),this.r.forEach($=>$.keys.forEach(l=>a.add(l))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>a.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>a.add($)),this.q.getAllOverrideIdentifiers().forEach($=>a.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(l=>a.add(l))),[...a.values()]}D(a){const $=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.q.getKeysForOverrideIdentifier(a).forEach(l=>$.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(a).forEach(S=>$.add(S))),[...$.values()]}static parse(a,$){const l=this.E(a.defaults,$),S=this.E(a.policy,$),d=this.E(a.application,$),E=this.E(a.user,$),f=this.E(a.workspace,$),D=a.folders.reduce((w,C)=>(w.set(k.URI.revive(C[0]),this.E(C[1],$)),w),new M.$Bc);return new n(l,S,d,E,m.createEmptyModel($),f,D,m.createEmptyModel($),new M.$Bc,$)}static E(a,$){return new m(a.contents,a.keys,a.overrides,void 0,$)}}e.$uo=n;function t(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const a=new Set,$=new Map;for(const S of b)S.keys.forEach(d=>a.add(d)),S.overrides.forEach(([d,E])=>{const f=(0,M.$yc)($,d,new Set);E.forEach(D=>f.add(D))});const l=[];return $.forEach((S,d)=>l.push([d,[...S.values()]])),{keys:[...a.values()],overrides:l}}class c{constructor(a,$,l,S,d){this.change=a,this.f=$,this.g=l,this.h=S,this.i=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const E of a.keys)this.affectedKeys.add(E);for(const[,E]of a.overrides)for(const f of E)this.affectedKeys.add(f);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,$){const l=this.a+a,S=this.d.indexOf(l);if(S<0)return!1;const d=S+l.length;if(d>=this.d.length)return!1;const E=this.d.charCodeAt(d);if(E!==this.b&&E!==this.c)return!1;if($){const f=this.previousConfiguration?this.previousConfiguration.getValue(a,$,this.f?.workspace):void 0,D=this.g.getValue(a,$,this.h);return!p.$1n(f,D)}return!0}}e.$wo=c;function h(b,a){const{added:$,removed:l,updated:S}=i(a?.rawConfiguration,b?.rawConfiguration),d=[],E=b?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const D=f.filter(w=>!E.includes(w));for(const w of D)d.push([w,a.getKeysForOverrideIdentifier(w)])}if(b){const D=E.filter(w=>!f.includes(w));for(const w of D)d.push([w,b.getKeysForOverrideIdentifier(w)])}if(a&&b){for(const D of E)if(f.includes(D)){const w=i({contents:b.getOverrideValue(void 0,D)||{},keys:b.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});d.push([D,[...w.added,...w.removed,...w.updated]])}}return{added:$,removed:l,updated:S,overrides:d}}function i(b,a){const $=b?a?b.keys.filter(d=>a.keys.indexOf(d)===-1):[...b.keys]:[],l=a?b?a.keys.filter(d=>b.keys.indexOf(d)===-1):[...a.keys]:[],S=[];if(b&&a){for(const d of a.keys)if(b.keys.indexOf(d)!==-1){const E=(0,N.$5i)(a.contents,d),f=(0,N.$5i)(b.contents,d);p.$1n(E,f)||S.push(d)}}return{added:$,removed:l,updated:S}}}),define(Ae[102],Re([1,0,14,3]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=k,e.$Bl=(0,T.$qi)("remoteAuthorityResolverService");var A;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=O;class M{constructor(y,u){this.host=y,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class g extends I.$bb{static isNotAvailable(y){return y instanceof g&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof g&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof g&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof g&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof g&&y.isHandled}constructor(y,u=p.Unknown,v){super(y),this._message=y,this._code=u,this._detail=v,this.isHandled=u===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,g.prototype)}}e.$El=g;function k(N){const y=N.indexOf("+");return y===-1?N:N.substring(0,y)}}),define(Ae[58],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=T,e.$Cm=A,e.$Dm=O,e.$Em=M;function T(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}function A(g){if(!g)return;const k=g.indexOf("+");return k<0?g:g.substr(0,k)}function O(g){const{host:k,port:N}=p(g);if(typeof N>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:N}}function M(g,k){let{host:N,port:y}=p(g);return typeof y>"u"&&(y=k),{host:N,port:y}}function p(g){const k=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const N=g.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(Ae[20],Re([1,0,15,3,58]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=O,e.$Om=y,e.$Pm=u,e.$Qm=v,e.$Rm=m,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o>"u"||o===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){const n=typeof o=="string"?o:o.value,t=typeof r=="string"?r:r.value;return I.$tf(n,t)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Lm=g;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const r of o)this.add(r)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Mm=k;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,r){this.c.set(g.toKey(o),r)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=N;function y(s){return u(s)}function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const r=`onResolveRemoteAuthority:${(0,A.$Cm)(o)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Sm=(0,T.$qi)("IBuiltinExtensionsScannerService")}),define(Ae[103],Re([1,0,14,20]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cG=e.$bG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const g of M){const k=this.readActivationEvents(g);k.length>0&&(p[T.$Lm.toKey(g.identifier)]=k)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<p.length;g++)p[g]==="onUri"&&(p[g]=`onUri:${T.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const g in M.contributes){const k=this.a.get(g);if(!k)continue;const N=M.contributes[g],y=Array.isArray(N)?N:[N];try{k(y,p)}catch(u){(0,I.$1)(u)}}return p}}e.$bG=A,e.$cG=new A}),define(Ae[197],Re([1,0,21,73,35]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function O(g){if(I.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,k,N,y,u,v,m,s,o){const r=Object.create(null);r["common.machineId"]=v,r["common.sqmId"]=m,r.sessionID=(0,A.$Mg)()+Date.now(),r.commitHash=y,r.version=u,r["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,I.$h)(I.$u),r["common.nodePlatform"]=T.$ec,r["common.nodeArch"]=N,r["common.product"]=o||"desktop",s&&(r["common.msftInternal"]=s);let n=0;const t=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(r["common.snap"]="true");const c=O(k);return c&&(r["common.platformDetail"]=c),r}function p(g){const k=T.env.USERDNSDOMAIN;if(!k)return!1;const N=k.toLowerCase();return g.some(y=>N===y)}}),define(Ae[198],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,I.$qi)("telemetryService"),e.$Wl=(0,I.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var T;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var A;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ae[59],Re([1,0,26,17,58,197,198]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=N,e.$hp=y,e.$ip=u,e.$jp=v,e.$kp=s,e.$lp=r,e.$mp=n,e.$np=h;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$_o=p;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=g,e.$bp=new g;class k{async publicLog(b,a,$){}async publicLogError(b,a,$){}}e.$cp=k,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function N(i,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!i.enableTelemetry)}function y(i,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const b=i.getValue(M.$4l),a=i.getValue(M.$5l);if(i.getValue(M.$6l)===!1||a===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(i){const b={},a={},$={};o(i,$);for(let l in $){l=l.length>150?l.substr(l.length-149):l;const S=$[l];typeof S=="number"?a[l]=S:typeof S=="boolean"?a[l]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${S.length}`),b[l]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(b[l]=S)}return{properties:b,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const b=(0,A.$Cm)(i);return m.has(b)?b:"other"}function o(i,b,a=0,$){if(i)for(const l of Object.getOwnPropertyNames(i)){const S=i[l],d=$?$+l:l;Array.isArray(S)?b[d]=(0,I.$2n)(S):S instanceof Date?b[d]=S.toISOString():(0,T.$6f)(S)?a<2?o(S,b,a+1,d+"."):b[d]=(0,I.$2n)(S):b[d]=S}}function r(i,b){const a=i.msftInternalDomains||[],$=b.getValue("telemetry.internalTesting");return(0,O.$$o)(a)||$}function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,b){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const $=[];for(const E of b)for(;;){const f=E.exec(i);if(!f)break;$.push([f.index,E.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(a="";;){const E=S.exec(i);if(!E)break;const f=$.some(([D,w])=>E.index<w&&D<S.lastIndex);!l.test(E[0])&&!f&&(a+=i.substring(d,E.index)+"<REDACTED: user-file-path>",d=S.lastIndex)}return d<i.length&&(a+=i.substr(d)),a}function c(i){if(!i)return i;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of b)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function h(i,b){return(0,I.$Yn)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let $=a.replaceAll("%20"," ");$=t($,b);for(const l of b)$=$.replace(l,"");return $=c($),$}})}}),define(Ae[199],Re([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=N,e.$qp=m,e.$rp=s,e.$sp=o,e.$tp=r,e.$up=n,e.$vp=t,e.$wp=c,e.$yp=h,e.$zp=b;function N(a,$){return a.uuid&&$.uuid?a.uuid===$.uuid:a.id===$.id?!0:(0,I.$of)(a.id,$.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const l=$.manifest?$.manifest.version:$.version,S=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,l,S)}static parse($){const l=y.exec($);return l&&l[1]&&l[2]?new u({id:l[1]},l[2],l[4]||void 0):null}constructor($,l,S="undefined"){this.version=l,this.targetPlatform=S,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?N(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$pp=u;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const $=v.exec(a);return $&&$[1]?[o($[1]),$[2]]:[o(a),void 0]}function s(a,$){return`${a}.${$}`}function o(a){return a.toLowerCase()}function r(a,$){return o(s(a??A.$Hm,$))}function n(a,$){const l=[],S=d=>{for(const E of l)if(E.some(f=>N($(f),$(d))))return E;return null};for(const d of a){const E=S(d);E?E.push(d):l.push([d])}return l}function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new k.$_o(a.identifier.id),name:new k.$_o(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$xp=new A.$Lm("pprice.better-merge");function h(a,$){const l=[],S=$.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const d=S.shift();if(d&&l.every(E=>!N(E.identifier,{id:d}))){const E=a.filter(f=>N(f.identifier,{id:d}));E.length===1&&(l.push(E[0]),S.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function i(a,$){if(!O.$k)return!1;let l;try{l=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){$.debug("Error while getting the os-release file.",(0,p.$0)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(a,$){const l=await i(a,$),S=(0,T.$Vo)(l?"alpine":O.$u,g.$fc);return $.debug("ComputeTargetPlatform:",S),S}}),define(Ae[200],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=I,e.$ds=T,e.$es=A,e.$fs=O,e.$gs=M,e.$hs=p;function I(g){return[...g.entries()]}function T(g){return g?[...g.entries()]:[]}function A(g){return new Map(g)}function O(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(k=>[k[0],I(k[1].map),T(k[1].descriptionMap)])}function p(g){return new Map(g.map(k=>[k[0],{map:A(k[1]),descriptionMap:O(k[2])}]))}}),define(Ae[201],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sb=void 0;class I{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,O,M=5){const p=O(g=>{const k=typeof g=="string"?g:g.data;let N=this.a.get(A);if(N){N.data.push(k);return}const y=setTimeout(()=>this.flushBuffer(A),M);N={data:[k],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(A),p.dispose()}},this.a.set(A,N)});return p}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const O=this.a.get(A);O&&(this.a.delete(A),this.b(A,O.data.join("")))}}e.$4sb=I}),define(Ae[202],Re([1,0,11,91,301,42,5,17,2,161,72,30]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.$4w=e.IconFontDefinition=e.IconContribution=e.$1w=void 0,e.$2w=o,e.$3w=r,e.$1w={IconContribution:"base.contributions.icons"};var u;(function(h){function i(b,a){let $=b.defaults;for(;O.ThemeIcon.isThemeIcon($);){const l=s.getIcon($.id);if(!l)return;$=l.defaults}return $}h.getDefinition=i})(u||(e.IconContribution=u={}));var v;(function(h){function i(a){return{weight:a.weight,style:a.style,src:a.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=i;function b(a){const $=l=>(0,p.$4f)(l)?l:void 0;if(a&&Array.isArray(a.src)&&a.src.every(l=>(0,p.$4f)(l.format)&&(0,p.$4f)(l.location)))return{weight:$(a.weight),style:$(a.style),src:a.src.map(l=>({format:l.format,location:g.URI.parse(l.location)}))}}h.fromJSONObject=b})(v||(e.IconFontDefinition=v={}));class m{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,b,a,$){const l=this.b[i];if(l){if(a&&!l.description){l.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const E=this.e.enum.indexOf(i);E!==-1&&(this.e.enumDescriptions[E]=a),this.a.fire()}return l}const S={id:i,description:a,defaults:b,deprecationMessage:$};this.b[i]=S;const d={$ref:"#/definitions/icons"};return $&&(d.deprecationMessage=$),a&&(d.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=d,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const b=this.e.enum.indexOf(i);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,b){const a=this.f[i];return a||(this.f[i]=b,this.a.fire(),b)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(l,S)=>l.id.localeCompare(S.id),b=l=>{for(;O.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(l=>this.b[l]);for(const l of $.filter(S=>!!S.description).sort(i))a.push(`|<i class="${b(l)}"></i>|${l.id}|${O.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const l of $.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(i))a.push(`|<i class="${b(l)}"></i>|${l.id}|`);return a.join(`
`)}}const s=new m;y.$9n.add(e.$1w.IconContribution,s);function o(h,i,b,a){return s.registerIcon(h,i,b,a)}function r(){return s}function n(){const h=(0,A.$Lj)();for(const i in h){const b="\\"+h[i].toString(16);s.registerIcon(i,{fontCharacter:b})}}n(),e.$4w="vscode://schemas/icons";const t=y.$9n.as(N.$0n.JSONContribution);t.registerSchema(e.$4w,s.getIconSchema());const c=new I.$Ch(()=>t.notifySchemaChanged(e.$4w),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$5w=o("widget-close",T.$Pj.close,(0,k.localize)(2,null)),e.$6w=o("goto-previous-location",T.$Pj.arrowUp,(0,k.localize)(3,null)),e.$7w=o("goto-next-location",T.$Pj.arrowDown,(0,k.localize)(4,null)),e.$8w=O.ThemeIcon.modify(T.$Pj.sync,"spin"),e.$9w=O.ThemeIcon.modify(T.$Pj.loading,"spin")}),define(Ae[203],Re([1,0,5,2,48,3,13]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=k,e.$8v=y,e.$9v=u,e.$$v=v,e.$aw=m,e.$bw=s,e.$5v=(0,O.$qi)("tunnelService"),e.$6v=(0,O.$qi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var g;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(g||(e.TunnelPrivacyId=g={}));function k(n){return!!n.forwardPort}var N;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function y(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const c of t){const h=c.split("=")[1];if(/^https?:/.exec(h)){const i=y(T.URI.parse(h));if(i)return i}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(n){return e.$_v.indexOf(n)>=0}function s(n,t,c,h){if(c===1)return!1;if(c===2&&m(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(i?.length===4&&parseInt(i[1])>=18)return!1}return n<1024}class o{constructor(t,c,h){this.remoteAddress=t,this.localAddress=c,this.b=h,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=o;let r=class{constructor(t,c){this.k=t,this.l=c,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],c=Array.from(this.e.values());for(const h of c){const i=Array.from(h.values());for(const b of i){const a=await b.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,h,i,b){this.q(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:h,privacy:i,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(m(t)||v(t))&&(t=e.$0v[0]);const h=this.s(t,c);if(h)return++h.refcount,h.value}openTunnel(t,c,h,i,b,a=!1,$,l){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${b}.`);const S=this.f??t;if(!S)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(S,c,h,i,b,a,$,l);return d?d.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(E);return(E.tunnelRemoteHost!==c||E.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&E.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const h=c.get(t.tunnelRemotePort);h&&(h.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,h))}}}}async p(t,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const i=h.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),i}}async closeTunnel(t,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const h=this.e.get(t);if(h&&h.has(c)){const i=h.get(c);i.refcount=0,await this.p(t,c,i)}}q(t,c,h){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:h})}async r(t,c){const h=this.e.get(t);if(h){const i=h.get(c),b=i?await i.value:void 0;(!b||typeof b=="string")&&h.delete(c),h.size===0&&this.e.delete(t)}}s(t,c){const h=[t];v(t)?(h.push(...e.$0v),h.push(...e.$_v)):m(t)&&h.push(...e.$_v);const i=h.map(b=>this.e.get(b));for(const b of i){const a=b?.get(c);if(a)return a}}canTunnel(t){return!!y(t)}u(t,c,h,i,b,a,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${i}.`);const l=h;this.j.add(l);const S=i===void 0?h:i,d={elevationRequired:b?this.isPortPrivileged(S):!1},E={remoteAddress:{host:c,port:h},localAddressPort:i,privacy:a,public:a?a!==g.Private:void 0,protocol:$},f=t.forwardPort(E,d);return f?(this.q(c,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(l)})):this.j.delete(l),f}};e.$dw=r,e.$dw=r=Je([Ve(0,M.$Wj),Ve(1,A.$Wi)],r)}),define(Ae[204],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,I.$qi)("editSessionIdentityService");var T;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ae[205],Re([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=T,e.$nM=A,e.$oM=O,e.$pM=M,e.$qM=p;function T(g){return g.scheme!==I.Schemas.file&&g.scheme!==I.Schemas.vscodeRemote}function A(g){if(g.folders.length)return g.folders.every(k=>T(k.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}function O(g){return A(g)?.scheme}function M(g){return A(g)?.authority}function p(g){return A(g)!==void 0}}),define(Ae[49],Re([1,0,162,19,52,24,2,3,12]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=k,e.$Bi=N,e.$Ei=y,e.$Fi=u,e.$Gi=v,e.$Hi=s,e.$Ii=o,e.$Li=t,e.$Qi=c,e.$Ri=h,e.$Ti=i,e.$Ui=b,e.$Vi=a,e.$zi=(0,p.$qi)("contextService");function k($){const l=$;return typeof l?.id=="string"&&M.URI.isUri(l.uri)}function N($){return typeof $?.id=="string"&&!k($)&&!u($)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function y($,l){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,T.$oc)($)}:l?e.$Ci:e.$Di;const S=$;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u($){const l=$;return typeof l?.id=="string"&&M.URI.isUri(l.configPath)}function v($){const l=$;if(l?.uri)return{id:l.id,uri:M.URI.revive(l.uri)};const S=$;if(S?.configPath)return{id:S.id,configPath:M.URI.revive(S.configPath)};if($?.id)return{id:$.id}}var m;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s($){const l=$;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function o($){const l=$;return!!(l&&typeof l=="object"&&M.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class r{constructor(l,S,d,E,f){this.h=l,this.j=d,this.k=E,this.l=f,this.c=A.$wi.forUris(this.l,()=>!0),this.folders=S}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=A.$wi.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=r;class n{constructor(l,S){this.raw=S,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,O.$4g)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function t($){return new n({uri:$,index:0,name:(0,O.$Zg)($)},{uri:$.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,I.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function c($,l){return O.$Ug.isEqualOrParent($,l.untitledWorkspacesHome)}function h($){let l;return M.URI.isUri($)?l=$:l=$.configuration,l?.scheme===g.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i($){return $.id===e.$Si}function b($,l){return!c($,l)&&!h($)}function a($){return(typeof $=="string"?(0,T.$pc)($):(0,O.$2g)($))===e.$Ni}}),define(Ae[74],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;class I{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const O=this.c++;return this.b.set(O,A),this.e(),O}get(A,O){return this.b.has(A)?this.b.get(A)[O]:void 0}delete(A){this.b.delete(A),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qkc=I}),define(Ae[45],Re([1,0,12,24,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$vkc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new T.$Sg(p=>{const g=this.b.get(p.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(p,g){g===null?this.b.delete(p.scheme):this.b.set(p.scheme,g)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$vkc=O,e.$wkc=(0,A.$qi)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=void 0,e.$sP=(0,I.$qi)("IExtHostInitDataService")}),define(Ae[206],Re([1,0,167,13,193,27]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;let M=class extends A.$AQ{constructor(g,k,N){const y=N.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=N.remote.isRemote?(0,I.localize)(0,null):g?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(y,{name:u}))}};e.$Cmc=M,e.$Cmc=M=Je([Ve(1,T.$Xj),Ve(2,O.$sP)],M)}),define(Ae[207],Re([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=void 0;class T{constructor(M,p,g){this.h=new Map,this.a=M,this.b=p,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$Ch(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of k.values())N.complete()}catch(N){for(const y of k.values())y.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let g=this.f[M];return typeof g>"u"&&(g=p),g}update(M,p){this.f[M]=p;const g=this.h.get(M);if(g!==void 0)return g.p;const k=new I.$Nh;return this.h.set(M,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$blc=T;class A extends T{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$clc=A}),define(Ae[208],Re([1,0,5,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;class A{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,g,k){const y=this.c.getNotebookDocument(T.URI.revive(M)).acceptModelChanged(p.value,g,k);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(T.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(T.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$3lc=A}),define(Ae[16],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0,e.$cP=(0,I.$qi)("IExtHostRpcService");class T{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$dP=T}),define(Ae[209],Re([1,0,20,5]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class A{#e;constructor(M,p){this.b=new T.$be,this.onDidChange=this.b.event,this.a=I.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$llc=A}),define(Ae[60],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0,e.$Lkc=(0,I.$qi)("IURITransformerService");class T{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$Mkc=T}),define(Ae[210],Re([1,0,23]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$job=A,e.$kob=M;class T{constructor(){this.buffers=[]}add(g){let k=this.buffers.indexOf(g);return k<0&&(k=this.buffers.length,this.buffers.push(g)),k}}function A(p,g){if(g.serializeBuffersForPostMessage){const k=new T,y=JSON.stringify(p,(v,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m)};if(ArrayBuffer.isView(m)){const s=O(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=k.buffers.map(v=>{const m=new Uint8Array(v);return I.$Ce.wrap(m)});return{message:y,buffers:u}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,g){const k=g.map(u=>{const v=new ArrayBuffer(u.byteLength);return new Uint8Array(v).set(u.buffer),v}),N=g.length?(u,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:s}=m,o=k[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(p,N),arrayBuffers:k}}}),define(Ae[104],Re([1,0,176,17,2,6,3,30,44,12,43,139,33]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$AF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$rF=e.EditorInputCapabilities=e.$qF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=void 0,e.$hF=s,e.$iF=o,e.$jF=r,e.$kF=n,e.$lF=t,e.$mF=c,e.$nF=h,e.$oF=i,e.$pF=b,e.$sF=E,e.$tF=D,e.$uF=w,e.$vF=C,e.$wF=P,e.$xF=V,e.$yF=W,e.$zF=ce,e.$BF=ue,e.$CF=ie,e.$DF=Pe,e.$EF=Fe,e.$cF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$dF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$eF="workbench.editor.sidebysideEditor",e.$fF="workbench.editors.textDiffEditor",e.$gF="workbench.editors.binaryResourceDiffEditor";var v;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var m;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ne){const U=ne;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function o(ne){const U=ne;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function r(ne,U,x){for(const pe of x.visibleEditorPanes)if(pe.group.id===U&&ne.matches(pe.input))return pe.getViewState()}function n(ne){if(E(ne))return!1;const U=ne;return A.URI.isUri(U?.resource)}function t(ne){if(E(ne))return!1;const U=ne;return U?.original!==void 0&&U.modified!==void 0}function c(ne){if(E(ne))return!1;const U=ne;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function h(ne){if(E(ne)||t(ne))return!1;const U=ne;return U?.primary!==void 0&&U.secondary!==void 0}function i(ne){if(E(ne))return!1;const U=ne;return U?U.resource===void 0||U.resource.scheme===k.Schemas.untitled||U.forceUntitled===!0:!1}function b(ne){if(E(ne))return!1;const U=ne;return A.URI.isUri(U?.base?.resource)&&A.URI.isUri(U?.input1?.resource)&&A.URI.isUri(U?.input2?.resource)&&A.URI.isUri(U?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var $;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class l{constructor(){this.a=new Map}registerSource(U,x){let pe=this.a.get(U);return pe||(pe={source:U,label:x},this.a.set(U,pe)),pe.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$qF=new l;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class d extends O.$Uc{}e.$rF=d;function E(ne){return ne instanceof d}function f(ne){const U=ne;return A.URI.isUri(U?.preferredResource)}function D(ne){const U=ne;return E(U?.primary)&&E(U?.secondary)}function w(ne){const U=ne;return E(U?.modified)&&E(U?.original)}function C(ne,U,x,pe,Oe){return Fe(pe,[(0,y.$aj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(U,ke)}}),(0,y.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Oe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function P(ne){return E(ne?.editor)}function V(ne){const U=ne;return P(ne)&&U?.group!==void 0}function W(ne){const U=ne;return typeof U?.groupId=="number"&&E(U.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var j;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(U,x){if(!U)return;if(b(U))return e.$AF.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(U);if(Oe&&ke){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Oe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Oe:ke}}if(t(U)||c(U)||h(U)||b(U))return;const pe=f(U)?U.preferredResource:U.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}a(U){return D(U)||h(U)?{primary:U.primary,secondary:U.secondary}:w(U)||t(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(b(U))return e.$AF.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:Oe,secondary:ke}=this.a(U);if(Oe&&ke){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Oe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Oe:ke}}if(t(U)||c(U)||h(U)||b(U))return;const pe=U.resource;return!pe||!x||!x.filterByScheme?pe:this.b(pe,x.filterByScheme)}b(U,x){if(Array.isArray(x)){if(x.some(pe=>U.scheme===pe))return U}else if(x===U.scheme)return U}}var se;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(se||(e.EditorCloseMethod=se={}));function ce(ne,U,x,pe){if(!ne.isSticky(U))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return x===se.MOUSE||x===se.KEYBOARD;case"mouse":return x===se.MOUSE;case"keyboard":return x===se.KEYBOARD}return!1}e.$AF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(U){const x=this.a=U.get(M.$pi);for(const[pe,Oe]of this.c)this.e(pe,Oe,x);this.c.clear()}e(U,x,pe){const Oe=pe.createInstance(x);this.d.set(U,Oe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,T.$cg)(this.b)}registerEditorSerializer(U,x){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,x,this.a):this.c.set(U,x),(0,O.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$9n.add(e.$cF.EditorFactory,new Ie);async function ue(ne,U,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async pe=>{const Oe=A.URI.revive(pe.fileUri);if(!Oe){x.info("Cannot resolve the path because it is not valid.",pe);return}if(!await U.canHandleResource(Oe)){x.info("Cannot resolve the path because it cannot be handled",pe);return}let $e=pe.exists,fe=pe.type;if(typeof $e!="boolean"||typeof fe!="number")try{fe=(await U.stat(Oe)).isDirectory?g.FileType.Directory:g.FileType.Unknown,$e=!0}catch(Y){x.error(Y),$e=!1}if(!$e&&pe.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",pe);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",pe);return}const J={...pe.options,pinned:!0};return $e?{resource:Oe,options:J}:{resource:Oe,options:J,forceUntitled:!0}}))}var be;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function ie(ne){const U=ne;if(!U)return!1;const x=U;if(x.modified)return ie(x.modified);const pe=U;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function Pe(ne){return(0,N.$cj)(ne)}function Fe(ne,U,x){const pe=(0,N.$dj)(ne,U);return pe.forceMessage=x?.forceMessage,pe.forceSeverity=x?.forceSeverity,pe.allowDialog=x?.allowDialog,pe}}),define(Ae[211],Re([1,0,5,177,3,6,28,30,18,26,91,202]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.$LF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$KF=e.ViewContentGroups=e.$IF=e.ViewContainerLocation=e.Extensions=e.$HF=e.$GF=e.$FF=void 0,e.$JF=m,e.$FF="views",e.$GF=(0,T.localize)(0,null),e.$HF=(0,y.$2w)("default-view-icon",N.$Pj.window,(0,T.localize)(1,null));var u;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var v;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel",b[b.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$IF=[0,1,2];function m(b){switch(b){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(a,$,l){const S=this.get(a.id);if(S)return S;const d=a;return d.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,M.$yc)(this.g,$,[]).push(d),l?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:$}),d}deregisterViewContainer(a){for(const $ of this.g.keys()){const l=this.g.get($),S=l?.indexOf(a);if(S!==-1){l?.splice(S,1),l.length===0&&this.g.delete($),this.f.fire({viewContainer:a,viewContainerLocation:$});return}}}get(a){return this.all.filter($=>$.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(l=>l?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find($=>this.getViewContainerLocation($)===a)}}p.$9n.add(u.ViewContainersRegistry,new s);var o;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(o||(e.ViewContentGroups=o={}));function r(b,a){const $=b.group??o.More,l=a.group??o.More;return $!==l?$.localeCompare(l):(b.order??5)-(a.order??5)}class n extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(a,$){this.registerViews2([{views:a,viewContainer:$}])}registerViews2(a){a.forEach(({views:$,viewContainer:l})=>this.r($,l)),this.c.fire(a)}deregisterViews(a,$){const l=this.s(a,$);l.length&&this.f.fire({views:l,viewContainer:$})}moveViews(a,$){for(const l of this.m.keys())if(l!==$){const S=this.s(a,l);S.length&&(this.r(S,$),this.g.fire({views:S,from:l,to:$}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const $ of this.j){const l=(this.m.get($)||[]).filter(S=>S.id===a)[0];if(l)return l}return null}getViewContainer(a){for(const $ of this.j)if((this.m.get($)||[]).filter(S=>S.id===a)[0])return $;return null}registerViewWelcomeContent(a,$){return this.n.add(a,$),this.h.fire(a),(0,O.$Sc)(()=>{this.n.delete(a,$),this.h.fire(a)})}registerViewWelcomeContent2(a,$){const l=new Map;for(const[S,d]of $)this.n.add(a,d),l.set(S,(0,O.$Sc)(()=>{this.n.delete(a,d),this.h.fire(a)}));return this.h.fire(a),l}getViewWelcomeContent(a){const $=[];return this.n.forEach(a,l=>$.push(l)),$.sort(r)}r(a,$){let l=this.m.get($);l||(l=[],this.m.set($,l),this.j.push($));for(const S of a){if(this.getView(S.id)!==null)throw new Error((0,T.localize)(2,null,S.id));l.push(S)}}s(a,$){const l=this.m.get($);if(!l)return[];const S=[],d=[];for(const E of l)a.includes(E)?S.push(E):d.push(E);return S.length&&(d.length?this.m.set($,d):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),S}}p.$9n.add(u.ViewsRegistry,new n),e.$KF=(0,A.$qi)("viewDescriptorService");var t;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(t||(e.ViewVisibilityState=t={}));var c;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,$){this.c=!1,this.d=!1,(0,k.$Zn)(this,a),this.d=!!$,this.resolve=async l=>{if($&&!this.c){const S=await $(l);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$LF=h;class i extends Error{constructor(a){super((0,T.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$MF=i}),define(Ae[212],Re([1,0,178,31]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=void 0,e.$QF=new T.$Hj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$RF=new T.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$SF=new T.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$TF=new T.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$UF=new T.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$VF=new T.$Hj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$WF=new T.$Hj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$XF=new T.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$YF=new T.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$ZF=new T.$Hj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$1F=new T.$Hj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$2F=new T.$Hj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$3F=new T.$Hj("chatCursorAtTop",!1),e.$4F=new T.$Hj("chatInputHasAgent",!1),e.$5F=new T.$Hj("chatLocation",void 0)}),define(Ae[213],Re([1,0,5,40,6,31,3,212]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var g;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(y){function u(v){switch(v){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=u}(g||(e.ChatAgentLocation=g={})),e.$3G=(0,M.$qi)("chatAgentService");let k=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=p.$2F.bindTo(this.f)}registerAgent(u,v){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const s=this,o=v.slashCommands;v={...v,get slashCommands(){return o.filter(n=>!n.when||s.f.contextMatchesRules(O.$oj.deserialize(n.when)))}};const r={data:v};return this.b.push(r),(0,A.$Sc)(()=>{this.b=this.b.filter(n=>n!==r),this.d.fire(void 0)})}registerAgentImplementation(u,v){const m=this.g(u);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return m.data.isDefault&&this.e.set(!0),m.impl=v,this.d.fire(new N(m.data,v)),(0,A.$Sc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,v){const m={data:u,impl:v};return this.b.push(m),this.d.fire(new N(u,v)),(0,A.$Sc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(u,v){const m=this.g(u);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);m.data.metadata={...m.data.metadata,...v},this.d.fire(new N(m.data,m.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(v=>!!v.isDefault&&v.locations.includes(u))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(v=>v.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new N(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(v=>v.name===u)}async invokeAgent(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return await r.impl.invoke(v,m,s,o)}async getFollowups(u,v,m,s,o){const r=this.g(u);if(!r?.impl)throw new Error(`No activated agent with id ${u}`);return r.impl?.provideFollowups?r.impl.provideFollowups(v,m,s,o):[]}};e.$4G=k,e.$4G=k=Je([Ve(0,O.$Ij)],k);class N{constructor(u,v){this.b=u,this.d=v}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,v,m,s){return this.d.invoke(u,v,m,s)}async provideFollowups(u,v,m,s){return this.d.provideFollowups?this.d.provideFollowups(u,v,m,s):[]}provideWelcomeMessage(u,v){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,v)}provideSampleQuestions(u,v){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,v)}}e.$5G=N}),define(Ae[214],Re([1,0,2,29,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=e.$_F=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$0F=O,e.$$F=M;function O(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(T.$kt.isIRange)}function M(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(O)}var p;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var g;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$_F=(0,A.$qi)("IChatService"),e.$aG="accessibility.voice.keywordActivation"}),define(Ae[215],Re([1,0,5,11,179]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qob=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,g,k,N){const y={command:p};if(g&&Object.keys(g).length>0&&(y.arguments=g),this.u("request",y),typeof N=="number"){const u=setTimeout(()=>{clearTimeout(u);const v=this.f.get(y.seq);if(v){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,A.localize)(0,null,N,p)};v(m)}},N)}return k&&this.f.set(y.seq,k),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,g){return p.type!=="event"||g.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,T.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const g=p,k=this.f.get(g.request_seq);k&&(this.f.delete(g.request_seq),k(g));break}}}}u(p,g){g.type=p,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((g,k)=>p.set(k,g)),await(0,T.$rh)(500),p.forEach((g,k)=>{g({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Qob=O}),define(Ae[216],Re([1,0,2,180,31,3]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=g,e.$hJ=N,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new A.$Hj("debugType",void 0,{type:"string",description:T.localize(0,null)}),e.$dI=new A.$Hj("debugConfigurationType",void 0,{type:"string",description:T.localize(1,null)}),e.$eI=new A.$Hj("debugState","inactive",{type:"string",description:T.localize(2,null)}),e.$fI="debugUx",e.$gI=new A.$Hj(e.$fI,"default",{type:"string",description:T.localize(3,null)}),e.$hI=new A.$Hj("hasDebugged",!1,{type:"boolean",description:T.localize(4,null)}),e.$iI=new A.$Hj("inDebugMode",!1,{type:"boolean",description:T.localize(5,null)}),e.$jI=new A.$Hj("inDebugRepl",!1,{type:"boolean",description:T.localize(6,null)}),e.$kI=new A.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:T.localize(7,null)}),e.$lI=new A.$Hj("inBreakpointWidget",!1,{type:"boolean",description:T.localize(8,null)}),e.$mI=new A.$Hj("breakpointsFocused",!0,{type:"boolean",description:T.localize(9,null)}),e.$nI=new A.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:T.localize(10,null)}),e.$oI=new A.$Hj("watchExpressionsExist",!1,{type:"boolean",description:T.localize(11,null)}),e.$pI=new A.$Hj("variablesFocused",!0,{type:"boolean",description:T.localize(12,null)}),e.$qI=new A.$Hj("expressionSelected",!1,{type:"boolean",description:T.localize(13,null)}),e.$rI=new A.$Hj("breakpointInputFocused",!1,{type:"boolean",description:T.localize(14,null)}),e.$sI=new A.$Hj("callStackItemType",void 0,{type:"string",description:T.localize(15,null)}),e.$tI=new A.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:T.localize(16,null)}),e.$uI=new A.$Hj("callStackItemStopped",!1,{type:"boolean",description:T.localize(17,null)}),e.$vI=new A.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:T.localize(18,null)}),e.$wI=new A.$Hj("watchItemType",void 0,{type:"string",description:T.localize(19,null)}),e.$xI=new A.$Hj("canViewMemory",void 0,{type:"boolean",description:T.localize(20,null)}),e.$yI=new A.$Hj("breakpointItemType",void 0,{type:"string",description:T.localize(21,null)}),e.$zI=new A.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:T.localize(22,null)}),e.$AI=new A.$Hj("breakpointHasModes",!1,{type:"boolean",description:T.localize(23,null)}),e.$BI=new A.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:T.localize(24,null)}),e.$CI=new A.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:T.localize(25,null)}),e.$DI=new A.$Hj("loadedScriptsItemType",void 0,{type:"string",description:T.localize(26,null)}),e.$EI=new A.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:T.localize(27,null)}),e.$FI=new A.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:T.localize(28,null)}),e.$GI=new A.$Hj("stepBackSupported",!1,{type:"boolean",description:T.localize(29,null)}),e.$HI=new A.$Hj("restartFrameSupported",!1,{type:"boolean",description:T.localize(30,null)}),e.$II=new A.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:T.localize(31,null)}),e.$JI=new A.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:T.localize(32,null)}),e.$KI=new A.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:T.localize(33,null)}),e.$LI=new A.$Hj("breakpointsExist",!1,{type:"boolean",description:T.localize(34,null)}),e.$MI=new A.$Hj("debuggersAvailable",!1,{type:"boolean",description:T.localize(35,null)}),e.$NI=new A.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:T.localize(36,null)}),e.$OI=new A.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:T.localize(37,null)}),e.$PI=new A.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:T.localize(38,null)}),e.$QI=new A.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:T.localize(39,null)}),e.$RI=new A.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:T.localize(40,null)}),e.$SI=new A.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:T.localize(41,null)}),e.$TI=new A.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:T.localize(42,null)}),e.$UI=new A.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:T.localize(43,null)}),e.$VI=new A.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:T.localize(44,null)}),e.$WI=new A.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:T.localize(45,null)}),e.$XI=new A.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:T.localize(46,null)}),e.$YI=new A.$Hj("variableIsReadonly",!1,{type:"boolean",description:T.localize(47,null)}),e.$ZI=new A.$Hj("variableValue",!1,{type:"string",description:T.localize(48,null)}),e.$1I=new A.$Hj("variableType",!1,{type:"string",description:T.localize(49,null)}),e.$2I=new A.$Hj("variableInterfaces",!1,{type:"array",description:T.localize(50,null)}),e.$3I=new A.$Hj("variableName",!1,{type:"string",description:T.localize(51,null)}),e.$4I=new A.$Hj("variableLanguage",!1,{type:"string",description:T.localize(52,null)}),e.$5I=new A.$Hj("variableExtensionId",!1,{type:"string",description:T.localize(53,null)}),e.$6I=new A.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:T.localize(54,null)}),e.$7I=new A.$Hj("multiSessionRepl",!1,{type:"boolean",description:T.localize(55,null)}),e.$8I=new A.$Hj("multiSessionDebug",!1,{type:"boolean",description:T.localize(56,null)}),e.$9I=new A.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:T.localize(57,null)}),e.$0I=new A.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:T.localize(58,null)}),e.$$I=new A.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:T.localize(59,null)}),e.$_I=new A.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:T.localize(60,null)});const M=t=>T.localize(61,null,t);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:T.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function g(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$gJ="vscode-debug-memory";function N(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var v;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$iJ=(0,O.$qi)("debugService");var m;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var r;(function(t){t.deserialize=c=>c,t.serialize=c=>c})(r||(e.IDebugVisualizationTreeItem=r={}));var n;(function(t){t.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),t.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Ae[217],Re([1,0,15,2,19,26,12,29,22,18]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=y,e.$9G=u,e.$0G=v,e.$$G=m,e.$_G=s,e.$aH=o,e.$bH=r,e.$cH=t,e.$dH=i,e.$eH=b,e.$fH=$,e.$gH=S;const N=/{([^}]+)}/g;function y(E,f,D){return E.replace(N,function(w,C){return f&&C.length>0&&C[0]!=="_"?w:D&&D.hasOwnProperty(C)?D[C]:w})}function u(E){const f={};for(const D of Object.keys(E))D.startsWith("!")||(f[D]=E[D]);return f}function v(E){return E.configuration.request==="attach"&&!m(E)&&(!E.parentSession||v(E.parentSession))}function m(E){let f=E.configuration.type;if(f)return f==="vslsShare"&&(f=E.configuration.adapterProxy.configuration.type),(0,I.$tf)(f,"extensionhost")||(0,I.$tf)(f,"pwa-extensionhost")?E:E.parentSession?m(E.parentSession):void 0}function s(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,f,D){let w,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(E);){const W=V.index+1,q=W+V[0].length;if(W<=f&&q>=D){w=V[0],C=W;break}}if(w){const W=/\w+/g;let q=null;for(;(q=W.exec(w))&&!(q.index+1+C+q[0].length>=D););q&&(w=w.substring(0,W.lastIndex))}return w?{start:C,end:C+w.length-1}:{start:0,end:0}}async function r(E,f,D,w){if(E.evaluatableExpressionProvider.has(f)){const C=E.evaluatableExpressionProvider.ordered(f),P=(0,k.$Hb)(await Promise.all(C.map(async V=>{try{return await V.provideEvaluatableExpression(f,D,w??g.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=f.getLineContent(D.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const C=f.getLineContent(D.lineNumber),{start:P,end:V}=o(C,D.column,D.column),W=C.substring(P-1,V);return{matchingExpression:W,range:new p.$kt(D.lineNumber,P,D.lineNumber,P+W.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(E){return!!(E&&E.match(n))}function c(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(t(E.path))return T.URI.parse(E.path);if((0,A.$jc)(E.path))return T.URI.file(E.path)}return E.path}function h(E){if(typeof E.path=="object"){const f=T.URI.revive(E.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return E.path}function i(E,f){const D=f?c:h,w=(0,O.$Wn)(E);return a(w,(C,P)=>{C&&P&&(P.path=D(P))}),w}function b(E,f){const D=f?c:h,w=(0,O.$Wn)(E);return a(w,(C,P)=>{!C&&P&&(P.path=D(P))}),w}function a(E,f){switch(E.type){case"event":{const D=E;switch(D.event){case"output":f(!1,D.body.source);break;case"loadedSource":f(!1,D.body.source);break;case"breakpoint":f(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=E;switch(D.command){case"setBreakpoints":f(!0,D.arguments.source);break;case"breakpointLocations":f(!0,D.arguments.source);break;case"source":f(!0,D.arguments.source);break;case"gotoTargets":f(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(w=>f(!1,w));break;default:break}break}case"response":{const D=E;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(w=>f(!1,w.source));break;case"loadedSources":D.body.sources.forEach(w=>f(!1,w));break;case"scopes":D.body.scopes.forEach(w=>f(!1,w.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(w=>f(!1,w.source));break;case"setBreakpoints":D.body.breakpoints.forEach(w=>f(!1,w.source));break;case"disassemble":D.body?.instructions.forEach(C=>f(!1,C.location));break;default:break}break}}}function $(E){return E.filter(f=>!f.presentation?.hidden).sort((f,D)=>f.presentation?D.presentation?f.presentation.group?D.presentation.group?f.presentation.group!==D.presentation.group?f.presentation.group.localeCompare(D.presentation.group):l(f.presentation.order,D.presentation.order):-1:D.presentation.group?1:l(f.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function l(E,f){return typeof E!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:E-f}async function S(E,f){const D=E.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(D!=="none"&&(await f.saveAll(),D==="allEditorsInActiveGroup")){const w=f.activeEditorPane;w&&w.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:w.input,groupId:w.group.id})}await E.reloadConfiguration()}const d=(E,f)=>!E||!f?E===f:E.name===f.name&&E.path===f.path&&E.sourceReference===f.sourceReference;e.$hH=d}),define(Ae[218],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var T;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$vK=(0,I.$qi)("INotebookExecutionService")}),define(Ae[219],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kib=e.$Jib=e.ProxyKernelState=e.$Iib=void 0,e.$Iib=100;var T;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(T||(e.ProxyKernelState=T={})),e.$Jib=(0,I.$qi)("INotebookKernelService"),e.$Kib=(0,I.$qi)("INotebookKernelHistoryService")}),define(Ae[220],Re([1,0,6,29,149,95]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zWb=void 0;class M extends I.$Uc{constructor(g,k,N){super(),this._source=g,this.b=k,this.c=N,this.a=void 0}f(g){const k=g.getLineCount();return new T.$kt(1,1,k,this.g(g,k))}g(g,k){if(k<1||k>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const g=new A.$LC;g.acceptChunk(this._source);const k=g.finish(!0),{textBuffer:N,disposable:y}=k.create(1);this.b=N,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const k=new A.$LC;k.acceptChunk(g);const N=k.finish(!0),{textBuffer:y,disposable:u}=N.create(1);return this.B(u),y})),this.a}findInInputs(g){const N=new O.$zC(g,!1,!1,null).parseSearchRequest();if(!N)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,N,!0,5e3)}findInOutputs(g){const N=new O.$zC(g,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(y=>{const u=y.findMatchesLineByLine(this.f(y),N,!0,5e3);if(u.length!==0)return{textBuffer:y,matches:u}}).filter(y=>!!y):[]}}e.$zWb=M}),define(Ae[50],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var T;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class A{static fromExtHostTestItem(M,p,g=M.parent){if(M._isRoot)return new A([p]);const k=[M.id];for(let N=g;N&&N.id!==p;N=N.parent)k.push(N.id);return k.push(p),new A(k.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new A(M.split("\0"))}static join(M,p){return new A([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:A.isChild(M,p)?2:A.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new A(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new A(this.path,M)}compare(M){if(typeof M=="string")return A.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=A}),define(Ae[61],Re([1,0,2,93,29,50]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var g;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$DL=[2,4,8,16,32,64];const k=R=>"runId"in R;e.$EL=k;var N;(function(R){R.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),R.deserialize=(j,K)=>({range:A.$kt.lift(K.range),uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(N||(e.IRichLocation=N={}));var y;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(R){R.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&N.serialize(j.location)}),R.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&N.deserialize(j,K.location)})})(u||(e.ITestErrorMessage=u={}));const v=(R,j)=>`${j?"s":"e"}${R}`;e.$FL=v;var m;(function(R){R.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&N.serialize(j.location)}),R.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&N.deserialize(j,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(R){R.serialize=j=>j.type===0?u.serialize(j):m.serialize(j),R.deserialize=(j,K)=>K.type===0?u.deserialize(j,K):m.deserialize(j,K)})(s||(e.ITestMessage=s={}));var o;(function(R){R.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),R.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(s.serialize)}),R.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(se=>s.deserialize(j,se))})})(o||(e.ITestTaskState=o={}));const r="\0",n=(R,j)=>R+r+j;e.$GL=n;const t=R=>{const j=R.indexOf(r);return{ctrlId:R.slice(0,j),tagId:R.slice(j+1)}};e.$HL=t;var c;(function(R){R.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),R.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?A.$kt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(R){R.serialize=j=>({expand:j.expand,item:c.serialize(j.item)}),R.deserialize=(j,K)=>({controllerId:O.$BL.root(K.item.extId),expand:K.expand,item:c.deserialize(j,K.item)})})(i||(e.InternalTestItem=i={}));var b;(function(R){R.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},R.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?A.$kt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const a=(R,j)=>{j.expand!==void 0&&(R.expand=j.expand),j.item!==void 0&&(R.item=R.item?Object.assign(R.item,j.item):j.item)};e.$IL=a;var $;(function(R){R.serializeWithoutMessages=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),R.serialize=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),R.deserialize=(j,K)=>({...i.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(se=>o.deserialize(j,se)),retired:!0})})($||(e.TestResultItem=$={}));var l;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(l||(e.ICoverageCount=l={}));var S;(function(R){R.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),R.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(S||(e.IFileCoverage=S={}));function d(R){return{...R,location:R.location?.toJSON()}}function E(R){return R.location=R.location?T.$jt.isIPosition(R.location)?T.$jt.lift(R.location):A.$kt.lift(R.location):void 0,R}e.$JL=3;var f;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(f||(e.DetailType=f={}));var D;(function(R){R.serialize=j=>j.type===0?C.serialize(j):P.serialize(j),R.deserialize=j=>j.type===0?C.deserialize(j):P.deserialize(j)})(D||(e.CoverageDetails=D={}));var w;(function(R){R.serialize=d,R.deserialize=E})(w||(e.IBranchCoverage=w={}));var C;(function(R){R.serialize=d,R.deserialize=E})(C||(e.IDeclarationCoverage=C={}));var P;(function(R){R.serialize=j=>({...d(j),branches:j.branches?.map(w.serialize)}),R.deserialize=j=>({...E(j),branches:j.branches?.map(w.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(R){R.deserialize=(j,K)=>K.op===0?{op:K.op,item:i.deserialize(j,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,R.serialize=j=>j.op===0?{op:j.op,item:i.serialize(j.item)}:j.op===1?{op:j.op,item:b.serialize(j.item)}:j})(W||(e.TestsDiffOp=W={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const se of j)switch(se.op){case 0:this.l(i.deserialize(this.k,se.item),K);break;case 1:this.o(b.deserialize(se.item),K);break;case 3:this.p(se.itemId,K);break;case 5:this.q(se.itemId);break;case 4:this.updatePendingRoots(se.amount);break;case 6:this.c.set(se.tag.id,se.tag);break;case 7:this.c.delete(se.id);break}K.complete?.()}l(j,K){const se=O.$BL.parentId(j.item.extId)?.toString();let ce;if(!se)ce=this.w(j),this.g.add(ce),this.f.set(j.item.extId,ce);else if(this.f.has(se)){const ve=this.f.get(se);ve.children.add(j.item.extId),ce=this.w(j,ve),this.f.set(j.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ce),j.expand===2&&this.h++,ce}o(j,K){const se=this.f.get(j.extId);if(se)return j.expand!==void 0&&(se.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$IL)(se,j),K.update?.(se),se}p(j,K){const se=this.f.get(j);if(!se)return;const ce=O.$BL.parentId(se.item.extId)?.toString();ce?this.f.get(ce).children.delete(se.item.extId):this.g.delete(se);const ve=[[j]];for(;ve.length;)for(const Ie of ve.pop()){const ue=this.f.get(Ie);ue&&(ve.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==se),ue.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$KL=q}),define(Ae[75],Re([1,0,11,5,6,56,61,50]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const k=(n,t)=>n===t,y=Object.entries({range:(n,t)=>n===t?!0:!n||!t?!1:n.equalsRange(t),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,t)=>!(n.length!==t.length||n.some(c=>!t.includes(c)))}),u=(n,t)=>{let c;for(const[h,i]of y)i(n[h],t[h])||(c?c[h]=t[h]:c={[h]:t[h]});return c};class v extends A.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new I.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new T.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===t.uri){c.docv=t.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===t.item.extId){(0,M.$IL)(c.item,t.item);return}if(c.op===0&&c.item.item.extId===t.item.extId){(0,M.$IL)(c.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,c){const h=this.tree.get(t);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,c){switch(c.op){case 3:this.O(p.$BL.joinToString(t.fullId,c.id));break;case 0:this.z(c.item,t);break;case 5:for(const h of c.ops)this.w(t,h);break;case 1:this.C(c.new,c.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:c.update}});break;case 6:this.y(t.actual.uri);break;default:(0,O.$cd)(c)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,c){const h=p.$BL.fromExtHostTestItem(t,this.root.id,c?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(t.id);let b=this.tree.get(h.toString());if(!b){b={fullId:h,actual:t,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(t,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(t)}}),this.I(t,b,c);return}if(b.actual===t){this.H(t,b,c);return}if(b.actual.uri?.toString()!==t.uri?.toString())return this.O(h.toString()),this.z(t,c);const a=this.s.getChildren(b.actual),$=b.actual,l=u(this.s.toITestItem($),this.s.toITestItem(t));this.s.getApiFor($).listener=void 0,b.actual=t,b.resolveBarrier=void 0,b.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(t.tags,$.tags,h.toString()),delete l.tags),this.w(b,{op:4,update:l})),this.I(t,b,c);for(const[d,E]of a)this.s.getChildren(t).get(E.id)||this.O(p.$BL.joinToString(h,E.id));const S=b.expandLevels;S!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(h.toString(),S))}),this.y(b.actual.uri)}C(t,c,h){const i=new Set(c.map(b=>b.id));for(const b of t)i.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:h,item:{tags:t.map(b=>(0,M.$GL)(this.s.controllerId,b.id))}}}),i.forEach(this.F,this)}D(t){const c=this.j.get(t.id);c?c.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,t.id)}}))}F(t){const c=this.j.get(t);c&&!--c.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,t)}))}G(t,c){this.s.getApiFor(t).parent=c&&c.actual!==this.root?c.actual:void 0}H(t,c,h){this.G(t,h);const i=this.s.getApiFor(t);i.parent=h?.actual,i.listener=b=>this.w(c,b),this.J(c)}I(t,c,h){this.H(t,c,h);for(const[i,b]of this.s.getChildren(t))this.z(b,c)}J(t){let c;this.h?t.resolveBarrier?c=t.resolveBarrier.isOpen()?3:2:c=t.actual.canResolveChildren?1:0:c=0,c!==t.expand&&(t.expand=c,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:c}}),c===1&&t.expandLevels!==void 0&&this.M(t))}L(t,c){if(c<0)return;const h=[];for(const[i,b]of this.s.getChildren(t.actual)){const a=this.expand(p.$BL.joinToString(t.fullId,b.id),c);(0,I.$ch)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const b=new I.$ph;return b.open(),b}t.expand=2,this.N(t);const c=t.resolveBarrier=new I.$ph,h=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(b){h(b)}return(0,I.$ch)(i)?i.catch(h).then(()=>{c.open(),this.J(t)}):(c.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const c=this.tree.get(t);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const b of i.actual.tags)this.F(b.id);this.tree.delete(i.fullId.toString());for(const[b,a]of this.s.getChildren(i.actual))h.push(this.tree.get(p.$BL.joinToString(i.fullId,a.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$5O=v;class m extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$6O=m;class s extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7O=s;class o extends Error{constructor(t,c,h){super(`TestItem with ID "${t}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$8O=o;const r=(n,t,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,b){for(const a of h.values())i.call(b,a,this)},[Symbol.iterator](){return h.entries()},replace(i){const b=new Map,a=new Set(h.keys()),$={op:5,ops:[]};for(const l of i){if(!(l instanceof c))throw new s(l.id);const S=t(l).controllerId;if(S!==n.controllerId)throw new o(l.id,S,n.controllerId);if(b.has(l.id))throw new m(l.id);b.set(l.id,l),a.delete(l.id),$.ops.push({op:0,item:l})}for(const l of a.keys())$.ops.push({op:3,id:l});n.listener?.($),h=b},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$9O=r}),define(Ae[105],Re([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;const T=new WeakMap,A=(M,p)=>{const g={controllerId:p};return T.set(M,g),g};e.$0O=A;const O=M=>{const p=T.get(M);if(!p)throw new I.$7O(M?.id||"<unknown>");return p};e.$$O=O}),define(Ae[76],Re([1,0,12,2]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4xb=e.$3xb=e.$2xb=void 0,e.$5xb=A,e.$6xb=M,e.$2xb="vscode-cdn.net",e.$3xb=`vscode-resource.${e.$2xb}`,e.$4xb=`'self' https://*.${e.$2xb}`;function A(p,g){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(g&&g.authority&&g.isRemote&&p.scheme===I.Schemas.file&&(p=T.URI.from({scheme:I.Schemas.vscodeRemote,authority:g.authority,path:p.path})),T.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$3xb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,g=>{const k=g.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?g:"-"+k.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(g,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ae[221],Re([1,0,5,6,76]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class O{constructor(p,g,k){this.d=p,this.e=g,this.f=k,this.a=0,this.b=new T.$Tc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const N=g.getVisibleTextEditors();for(const y of this.c.values())N.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,g,k,N,y){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){u=t;break}if(!u)throw new Error("not a visible editor");const v=this,m=this.a++,s=new I.$be,o=new I.$be,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,A.$5xb)(t,v.f)}get cspSource(){return A.$4xb}set options(t){this.b=t,v.d.$setOptions(m,t)}get options(){return this.b}set html(t){this.a=t,v.d.$setHtml(m,t)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(t){return v.d.$postMessage(m,t)}},n=new class{constructor(){this.editor=p,this.line=g,this.height=k,this.webview=r,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,g+1,k,N||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(p){const g=this.c.get(p);g&&g.inset.dispose()}$onDidReceiveMessage(p,g){this.c.get(p)?.onDidReceiveMessage.fire(g)}}e.$Jkc=O}),define(Ae[106],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,I.$qi)("IAuthenticationService"),e.$TL=(0,I.$qi)("IAuthenticationExtensionsService")}),define(Ae[222],Re([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.VariableKind=e.$1P=void 0,e.$1P=(0,I.$qi)("configurationResolverService");var T;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class A extends Error{constructor(M,p){super(p),this.variable=M}}e.$2P=A}),define(Ae[223],Re([1,0,19,73,17,26,21,96,183,222,15]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,m,s,o){this.h=new Map,this.a=v,this.b=m,this.g=s,o&&(this.c=o.then(r=>this.i(r)))}i(v){if(M.$i){const m=Object.create(null);return Object.keys(v).forEach(s=>{m[s.toLowerCase()]=v[s]}),m}return v}resolveWithEnvironment(v,m,s){return this.l({env:this.i(v),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(v,m){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,m)}async j(v,m,s,o){const r=O.$Wn(m);M.$i&&r.windows?Object.keys(r.windows).forEach(t=>r[t]=r.windows[t]):M.$j&&r.osx?Object.keys(r.osx).forEach(t=>r[t]=r.osx[t]):M.$k&&r.linux&&Object.keys(r.linux).forEach(t=>r[t]=r.linux[t]),delete r.windows,delete r.osx,delete r.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,r,s,o)}async resolveAnyAsync(v,m,s){return this.j(v,m,s)}async resolveAnyMap(v,m,s){const o=new Map;return{newConfig:await this.j(v,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,m)}async l(v,m,s,o,r){if(A.$4f(s))return this.m(v,m,s,o,r);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,m,n,o,r)));if(A.$6f(s)){const n=Object.create(null),t=await Promise.all(Object.keys(s).map(async c=>[await this.m(v,m,c,o,r),await this.l(v,m,s[c],o,r)]));for(const[c,h]of t)n[c]=h;return n}return s}m(v,m,s,o,r){return(0,N.$lf)(s,y.VARIABLE_REGEXP,async(n,t)=>{if(t.includes(y.VARIABLE_LHS))return n;let c=await this.o(v,n,t,m,o);return r?.set(t,c),c!==n&&A.$4f(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.m(v,m,c,o,r)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,m,s,o,r){let n;const t=s.split(":");t.length>1&&(s=t[0],n=t[1]);const c=b=>{const a=this.a.getFilePath();if(a)return(0,p.$ow)(a);throw new k.$2P(b,(0,g.localize)(0,null,m))},h=b=>{const a=c(b);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,p.$ow)($)}throw new k.$2P(b,(0,g.localize)(1,null,m,I.$oc(a)))},i=b=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new k.$2P(b,(0,g.localize)(2,null,m,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$2P(b,(0,g.localize)(3,null,m)):new k.$2P(b,(0,g.localize)(4,null,m))};switch(s){case"env":if(n){if(v.env){const b=v.env[M.$i?n.toLowerCase():n];if(A.$4f(b))return b}return""}throw new k.$2P(k.VariableKind.Env,(0,g.localize)(5,null,m));case"config":if(n){const b=this.a.getConfigurationValue(o,n);if(A.$ag(b))throw new k.$2P(k.VariableKind.Config,(0,g.localize)(6,null,m,n));if(A.$6f(b))throw new k.$2P(k.VariableKind.Config,(0,g.localize)(7,null,m,n));return b}throw new k.$2P(k.VariableKind.Config,(0,g.localize)(8,null,m));case"command":return this.p(k.VariableKind.Command,m,n,r,"command");case"input":return this.p(k.VariableKind.Input,m,n,r,"input");case"extensionInstallFolder":if(n){const b=await this.a.getExtension(n);if(!b)throw new k.$2P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,m,n));return this.n(b.extensionLocation)}throw new k.$2P(k.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$ow)(this.n(i(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,p.$ow)(this.n(i(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$ow)(I.$oc(this.n(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.$2P(k.VariableKind.UserHome,(0,g.localize)(11,null,m))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new k.$2P(k.VariableKind.LineNumber,(0,g.localize)(12,null,m))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new k.$2P(k.VariableKind.SelectedText,(0,g.localize)(13,null,m))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(i(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const b=I.$nc(c(k.VariableKind.RelativeFileDirname));if(o||n){const a=I.$mc(this.n(i(k.VariableKind.RelativeFileDirname)),b);return a.length===0?".":a}return b}case"fileDirname":return I.$nc(c(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(c(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=I.$oc(c(k.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-I.$pc(b).length)}case"fileDirnameBasename":return I.$oc(I.$nc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||m}case"execInstallFolder":{const b=this.a.getAppRoot();return b||m}case"pathSeparator":case"/":return I.sep;default:try{const b=n?`${s}:${n}`:s;return this.p(k.VariableKind.Unknown,m,b,r,void 0)}catch{return m}}}}p(v,m,s,o,r){if(s&&o){const n=r===void 0?o[s]:o[r+":"+s];if(typeof n=="string")return n;throw new k.$2P(v,(0,g.localize)(14,null,m))}return m}}e.$eQ=y}),define(Ae[107],Re([1,0,3,104]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$HD=void 0,e.$ID=k,e.$JD=u,e.$KD=v,e.$HD=(0,I.$qi)("editorGroupsService");var A;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var g;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function k(m){const s=m;return(0,T.$sF)(s?.editor)&&(0,T.$sF)(s?.replacement)}var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ae[224],Re([1,0,3,107]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$PD=A,e.$LD=(0,I.$qi)("editorService"),e.$MD=-1,e.$ND=-2,e.$OD=-3;function A(O){const M=O;return typeof O=="number"||(0,T.$JD)(M)}}),define(Ae[225],Re([1,0,3,190]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,I.$ri)(T.$xi)}),define(Ae[108],Re([1,0,20,5,19,6,11]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=e.$7$b=e.$6$b=e.$5$b=e.$4$b=void 0;class p{constructor(n,t){this.versionId=n,this.removedDueToLooping=t}}e.$4$b=p;class g{static isHostExtension(n,t,c){if(t.getExtensionDescription(n))return!1;const h=c.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,t){this.j=n,this.c=new T.$be,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(s),this.f=new I.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const t=this.j.readActivationEvents(n);for(const c of t)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,t){this.e=o(this.e,t),this.e=this.e.concat(n);const c=g.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,$){this.addNode(a),this.addNode($),this.c.has(a)?this.c.get(a).push($):this.c.set(a,[$])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,$){const l=t.getArcs(a);for(let S=0;S<l.length;S++)if(!$.has(l[S]))return!1;return!0}getNodes(){return this.e}},c=new I.$Nm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const $ of a.extensionDependencies)t.addArc(I.$Lm.toKey(a.identifier),I.$Lm.toKey($));const h=new Set;t.getNodes().filter(a=>t.getArcs(a).length===0).forEach(a=>h.add(a));const i=t.getNodes().filter(a=>!h.has(a));let b;do{b=!1;for(let a=0;a<i.length;a++){const $=i[a];t.hasOnlyGoodArcs($,h)&&(i.splice(a,1),a--,h.add($),b=!0)}}while(b);return i.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const t=this.h.get(n);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const t=this.f.get(n);return t||void 0}getExtensionDescriptionByUUID(n){for(const t of this.g)if(t.uuid===n)return t}getExtensionDescriptionByIdOrUUID(n,t){return this.getExtensionDescription(n)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$5$b=g;class k{constructor(n,t){this.versionId=n,this.extensions=t}}e.$6$b=k;class N{constructor(n){this.d=new v,this.c=new g(n,[])}async acquireLock(n){const t=await this.d.acquire(n);return new y(this,t)}deltaExtensions(n,t,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,t){return this.c.getExtensionDescriptionByIdOrUUID(n,t)}}e.$7$b=N;class y extends O.$Uc{constructor(n,t){super(),this.f=n,this.c=!1,this.B(t)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$8$b=y;class u{constructor(n){this.name=n;const t=(0,M.$jh)();this.promise=t.promise,this.c=t.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const t=new u(n);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let t=!0;const c=setTimeout(()=>{t&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{t&&(clearTimeout(c),t=!1,this.d=!1,this.e())};n.resolve((0,O.$Sc)(h))}}var m;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(m||(m={}));function s(r,n){const t=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(t!==c)return t-c;const h=A.$hc.basename(r.extensionLocation.path),i=A.$hc.basename(n.extensionLocation.path);return h<i?-1:h>i?1:0}function o(r,n){const t=new I.$Mm(n);return r.filter(c=>!t.has(c.identifier))}}),define(Ae[77],Re([1,0,23]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T||(e.UIKind=T={}));var A;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var O;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(k){const N=I.$Ce.alloc(1);switch(k){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function p(k,N){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var g;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Ae[62],Re([1,0,3,5,13,27,77,58,59,26,2,6,170]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$uP=e.$tP=void 0,e.$vP=s;let v=class extends y.$Uc{constructor(r,n){super(),this.s=r,this.t=n,this.a=this.B(new T.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$ep,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(t=>{(0,A.$Yj)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,n,t){const c=this.getTelemetryDetails(),h=new m(n,t,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,n,t){this.f=r,this.g=n,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const n=Object.create(null);switch(n["common.extname"]=`${r.publisher}.${r.name}`,n["common.extversion"]=r.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Cm)((0,g.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const n=this.getTelemetryDetails();this.r.forEach((t,c)=>{const h=t.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(t=>{for(const c of t)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,n){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$tP=v,e.$tP=v=Je([Ve(0,O.$sP),Ve(1,A.$Xj)],v);class m{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,n,t,c,h,i,b){this.g=t,this.h=c,this.i=h,this.j=i,this.a=new T.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(r,n){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let n="properties"in r?r.properties??{}:r;return n=(0,g.$np)(n,[]),this.c&&(n=(0,k.$Zn)(n,this.c)),this.b||(n=(0,k.$Zn)(n,this.j)),"properties"in r?r.properties=n:r=n,r}k(r,n){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(r,n),this.h.trace(r,n))}logUsage(r,n){this.d.isUsageEnabled&&this.k(r,n)}logError(r,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,n);else{const t={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,g.$np)(t,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const r=this,n={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$uP=m;function s(o){const r=Date.now()-new Date(o).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$wP=(0,I.$qi)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,199,103,20,3]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.ActivationKind=e.$zG=e.$yG=e.$vG=e.ExtensionHostStartup=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$wG=u,e.$xG=v,e.$AG=r,e.$BG=n,e.$rG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$sG="extensions.webWorker",e.$tG=(0,p.$qi)("extensionService");class g{constructor(h){this.dependency=h}}e.$uG=g;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,b){this.c=h,this.d=i.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$cG.createActivationEventsMap(this.d)}}set(h,i,b){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],$=[],l=[],S=[],d=y(this.d),E=y(i),f=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=E.get(V.identifier);if(!W){a.push(V.identifier),d.delete(V.identifier);continue}if(!f(V,W)){a.push(V.identifier),d.delete(V.identifier);continue}}for(const V of i){const W=d.get(V.identifier);if(!W){$.push(V);continue}if(!f(W,V)){a.push(W.identifier),d.delete(W.identifier);continue}}const D=new M.$Mm(this.e),w=new M.$Mm(b);for(const V of this.e)w.has(V)||l.push(V);for(const V of b)D.has(V)||S.push(V);const C=O.$cG.createActivationEventsMap($),P={versionId:h,toRemove:a,toAdd:$,addActivationEvents:C,myToRemove:l,myToAdd:S};return this.delta(P),P}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:b,myToRemove:a,myToAdd:$}=h,l=new M.$Mm(i),S=new M.$Mm(a);for(let d=0;d<this.d.length;d++)l.has(this.d[d].identifier)&&(this.d.splice(d,1),d--);for(let d=0;d<this.e.length;d++)S.has(this.e[d])&&(this.e.splice(d,1),d--);for(const d of b)this.d.push(d);for(const d of $)this.e.push(d);return this.f=null,h}containsExtension(h){for(const i of this.e)if(M.$Lm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const b=O.$cG.readActivationEvents(i);for(const a of b)h.add(a)}return h}}e.$vG=N;function y(c){const h=new M.$Nm;for(const i of c)h.set(i.identifier,i);return h}function u(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function v(c,h){if(!u(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(h,i,b,a){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=b,this.activationReason=a}}e.$yG=m;class s{constructor(h,i){this.description=h,this.value=i}}e.$zG=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,A.$tp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,h){return{identifier:new M.$Lm((0,A.$rp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$CG=t}),define(Ae[226],Re([1,0,14,108,20,25,13,11]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=e.$9kc=e.$8kc=e.$7kc=e.$6kc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(r,n,t,c){this.startup=r,this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c}}e.$6kc=g;class k{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,n){return r===-1||n===-1?-1:n-r}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7kc=k;class N{constructor(r,n,t,c,h,i){this.activationFailed=r,this.activationFailedError=n,this.activationTimes=t,this.module=c,this.exports=h,this.subscriptions=i}}e.$8kc=N;class y extends N{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9kc=y;class u extends N{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0kc=u;class v extends N{constructor(r){super(!0,r,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(r,n,t,c){this.g=c,this.a=r,this.b=n,this.c=t,this.d=new A.$Nm,this.f=Object.create(null)}dispose(){for(const[r,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const r=[];for(const[n,t]of this.d)r.push(t.wait());await Promise.all(r)}isActivated(r){const n=this.d.get(r);return!!(n&&n.value)}getActivatedExtension(r){const n=this.d.get(r);if(!n||!n.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return n.value}async activateByEvent(r,n){if(this.f[r])return;const t=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(t.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,n){const t=this.a.getExtensionDescription(r);if(!t)throw new Error(`Extension '${r.value}' is not known`);return this.h([{id:t.identifier,reason:n}])}async h(r){const n=r.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(n.map(t=>t.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const n=this.a.getExtensionDescription(r.id);if(!n){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new v(h));return this.c.onExtensionActivationError(r.id,h,new O.$uG(r.id.value)),i}const t=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){t.push(i);continue}if(this.l(h)){t.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const b=this.a.getExtensionDescription(h);if(b){if(!b.main&&!b.browser)continue;t.push(this.j({id:b.identifier,reason:r.reason}));continue}const a=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),l=this.k(r,n.displayName,[],new v($));return this.c.onExtensionActivationError(n.identifier,$,new O.$uG(h)),l}return this.k(r,n.displayName,t,null)}k(r,n,t,c){const h=new s(r.id,n,r.reason,t,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return T.$5$b.isHostExtension(r,this.a,this.b)}m(r){const n=this.b.getExtensionDescription(r);return n?!n.main&&!n.browser:!1}};e.$$kc=m,e.$$kc=m=Je([Ve(3,M.$Wj)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,n,t,c,h,i,b){this.c=r,this.d=n,this.f=t,this.g=c,this.h=h,this.j=i,this.k=b,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const n=this.g[r];if(n.value&&!n.value.activationFailed){this.g.splice(r,1),r--;continue}if(n.value&&n.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);t.detail=n.value.activationFailedError,this.h=new v(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const n=new Error;if(r&&r.name&&(n.name=r.name),r&&r.message?n.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(n.stack=r.stack),this.h=new v(n),this.b&&I.$4(r))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([Ve(6,M.$Wj)],s)}),define(Ae[227],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[228],Re([1,0,185,14,33,98,72,30,20,227,195,103]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=void 0;const u=p.$9n.as(M.$0n.JSONContribution);class v{constructor(h,i,b){this.a=h,this.b=i,this.c=b}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(A.default.Error,h)}warn(h){this.d(A.default.Warning,h)}info(h){this.d(A.default.Info,h)}}e.$lG=v;class m{static a(h){const i=new g.$Mm;for(let b=0,a=h.length;b<a;b++)i.add(h[b].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new m(i,[]);if(!i||!i.length)return new m([],h);const b=this.a(h),a=this.a(i),$=i.filter(S=>!b.has(S.description.identifier)),l=h.filter(S=>!a.has(S.description.identifier));return new m($,l)}constructor(h,i){this.added=h,this.removed=i}}e.$mG=m;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$nG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$oG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Km},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$No}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&y.$cG.register(h.extensionPoint,h.activationEventsGenerator),e.$oG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(r,e.$oG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$pG=n;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(t.ExtensionsRegistry,new n),e.$qG=p.$9n.as(t.ExtensionsRegistry),u.registerSchema(r,e.$oG),u.registerSchema(N.$ek,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ae[229],Re([1,0,181,17,26,228,31,5]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(u){function v(m,s,o){if(!m)return;const r=T.$4f(m.type)?m.type:void 0;if(!r||r.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(m.required))for(const t of m.required)T.$4f(t)&&n.push(t);return{extensionId:s.value,taskType:r,required:n,properties:m.properties?A.$Wn(m.properties):{},when:m.when?M.$oj.deserialize(m.when):void 0}}u.from=v})(k||(k={}));const N=O.$qG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,v)=>{for(const m of u)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:g}});class y{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{N.setHandler((s,o)=>{this.c=void 0;try{for(const r of o.removed){const n=r.value;for(const t of n)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const r of o.added){const n=r.value;for(const t of n){const c=k.from(t,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=A.$Wn(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$UH=new y}),define(Ae[230],Re([1,0,182,17,24,26,31,229]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,I.localize(0,null)),e.$XH=I.localize2(2,"Tasks");var g;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$YH="$customized",function(R){function j(K){if(!K)return R.Strong;switch(K.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=j}(g||(e.ShellQuoting=g={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var N;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(N||(e.RevealKind=N={})),function(R){function j(K){switch(K.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=j}(N||(e.RevealKind=N={}));var y;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(R){function j(K){switch(K.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=j}(y||(e.RevealProblemKind=y={}));var u;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(u||(e.PanelKind=u={})),function(R){function j(K){switch(K.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=j}(u||(e.PanelKind=u={}));var v;(function(R){R.defaults={echo:!0,reveal:N.Always,revealProblems:y.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(R){function j(se){switch(se.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=j;function K(se){switch(se){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=K}(m||(e.RuntimeType=m={}));var s;(function(R){function j(K){return T.$4f(K)?K:K.value}R.value=j})(s||(e.CommandString=s={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function j(se){return se===R.Clean._id||se===R.Build._id||se===R.Rebuild._id||se===R.Test._id}R.is=j;function K(se){if(se!==void 0)return T.$4f(se)?j(se)?{_id:se,isDefault:!1}:void 0:se}R.from=K})(o||(e.TaskGroup=o={}));var r;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function j(K){switch(K){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=j})(n||(e.TaskSourceKind=n={}));var t;(function(R){R.parallel="parallel",R.sequence="sequence"})(t||(e.DependsOrder=t={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(j,K,se,ce,ve,Ie){this._label="",this._id=j,K&&(this._label=K),se&&(this.type=se),this.runOptions=ce,this.configurationProperties=ve,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(T.$4f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$ZH=i;class b extends i{constructor(j,K,se,ce,ve,Ie,ue,be){super(j,se,void 0,ue,be,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof b}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const se={type:e.$YH,folder:j,id:K};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new b(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$1H=b;class a extends i{constructor(j,K,se,ce,ve,Ie,ue){super(j,se,ce,Ie,ue,K),this._source=K,this.configures=ve}static is(j){return j instanceof a}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const se={type:e.$YH,folder:j,id:K};return JSON.stringify(se)}}e.$2H=a;class $ extends i{constructor(j,K,se,ce,ve,Ie,ue,be,ie){super(j,se,ce,be,ie,K),this.defines=ve,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=ie.icon,this.hide=ie.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof $}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new $(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$3H=$;class l extends i{constructor(j,K,se,ce,ve,Ie){super(j,se,ce,ve,Ie,K),this._source=K}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new l(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$4H=l;var S;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(R){R._default=R.Terminal}(S||(e.ExecutionEngine=S={}));var d;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class E{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const se=j.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(se&&ce){let ve=this.c.get(se.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?j._label.localeCompare(K._label):ve-Ie}else return!se&&ce?-1:se&&!ce?1:0}}e.$5H=E;var f;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(f||(e.TaskEventKind=f={}));var D;(function(R){R.SingleRun="singleRun",R.Background="background"})(D||(e.TaskRunType=D={}));var w;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var C;(function(R){function j(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function K(be,ie,Pe){return{...j(be),kind:"start",terminalId:ie,resolvedVariables:Pe}}R.start=K;function se(be,ie,Pe){return{...j(be),kind:"processStarted",terminalId:ie,processId:Pe}}R.processStarted=se;function ce(be,ie,Pe){return{...j(be),kind:"processEnded",terminalId:ie,exitCode:Pe}}R.processEnded=ce;function ve(be,ie,Pe){return{...j(be),kind:"terminated",exitReason:Pe,terminalId:ie}}R.terminated=ve;function Ie(be,ie,Pe){return{...j(ie),kind:be,terminalId:Pe}}R.general=Ie;function ue(){return{kind:"changed"}}R.changed=ue})(C||(e.TaskEvent=C={}));var P;(function(R){function j(se){const ce=Object.keys(se).sort();let ve="";for(const Ie of ce){let ue=se[Ie];ue instanceof Object?ue=j(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ve+=Ie+","+ue+","}return ve}function K(se){const ve={_key:j(se),type:se.taskType};return Object.assign(ve,se),ve}R.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(R){function j(K,se){const ce=p.$UH.get(K.type);if(ce===void 0){const be=O.$Wn(K);return delete be._key,P.create(be)}const ve=Object.create(null);ve.type=ce.taskType;const Ie=new Set;ce.required.forEach(be=>Ie.add(be));const ue=ce.properties;for(const be of Object.keys(ue)){const ie=K[be];if(ie!=null)ve[be]=ie;else if(Ie.has(be)){const Pe=ue[be];if(Pe.default!==void 0)ve[be]=O.$Wn(Pe.default);else switch(Pe.type){case"boolean":ve[be]=!1;break;case"number":case"integer":ve[be]=0;break;case"string":ve[be]="";break;default:se.error(I.localize(1,null,JSON.stringify(K,void 0,0),be));return}}}return P.create(ve)}R.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Ae[231],Re([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$9$b=T;class A extends T{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$0$b=A}),define(Ae[34],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$iw=void 0,e.$jw=A,e.$kw=O;class I{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++I.count}}e.$iw=I;const T=[];function A(p){const g=new I(p);return T[g.nid]=g,g}function O(p){return T[p].sid}class M{constructor(g){this.value=g}}e.$lw=M}),define(Ae[4],Re([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var A;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$OM=y;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$PM={MainThreadAuthentication:(0,I.$jw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$jw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$jw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$jw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$jw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$jw)("MainThreadClipboard"),MainThreadCommands:(0,I.$jw)("MainThreadCommands"),MainThreadComments:(0,I.$jw)("MainThreadComments"),MainThreadConfiguration:(0,I.$jw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$jw)("MainThreadConsole"),MainThreadDebugService:(0,I.$jw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$jw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$jw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$jw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$jw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$jw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$jw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$jw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$jw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$jw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$jw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$jw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$jw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$jw)("MainThreadLanguages"),MainThreadLogger:(0,I.$jw)("MainThreadLogger"),MainThreadMessageService:(0,I.$jw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$jw)("MainThreadOutputService"),MainThreadProgress:(0,I.$jw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$jw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$jw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$jw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$jw)("MainThreadSecretState"),MainThreadStorage:(0,I.$jw)("MainThreadStorage"),MainThreadSpeech:(0,I.$jw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$jw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$jw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$jw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$jw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$jw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$jw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$jw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$jw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$jw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$jw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$jw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$jw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$jw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$jw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$jw)("MainThreadSCM"),MainThreadSearch:(0,I.$jw)("MainThreadSearch"),MainThreadShare:(0,I.$jw)("MainThreadShare"),MainThreadTask:(0,I.$jw)("MainThreadTask"),MainThreadWindow:(0,I.$jw)("MainThreadWindow"),MainThreadLabelService:(0,I.$jw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$jw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$jw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$jw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$jw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$jw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$jw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$jw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$jw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$jw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$jw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$jw)("MainThreadTimeline"),MainThreadTesting:(0,I.$jw)("MainThreadTesting"),MainThreadLocalization:(0,I.$jw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$jw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$jw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,I.$jw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$jw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$jw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$jw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$jw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$jw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$jw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$jw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$jw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$jw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$jw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$jw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$jw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$jw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$jw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$jw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$jw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$jw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$jw)("ExtHostStatusBar"),ExtHostShare:(0,I.$jw)("ExtHostShare"),ExtHostExtensionService:(0,I.$jw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$jw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$jw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$jw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$jw)("ExtHostSCM"),ExtHostSearch:(0,I.$jw)("ExtHostSearch"),ExtHostTask:(0,I.$jw)("ExtHostTask"),ExtHostWorkspace:(0,I.$jw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$jw)("ExtHostWindow"),ExtHostWebviews:(0,I.$jw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$jw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$jw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$jw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$jw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$jw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$jw)("ExtHostProgress"),ExtHostComments:(0,I.$jw)("ExtHostComments"),ExtHostSecretState:(0,I.$jw)("ExtHostSecretState"),ExtHostStorage:(0,I.$jw)("ExtHostStorage"),ExtHostUrls:(0,I.$jw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$jw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$jw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$jw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$jw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$jw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$jw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$jw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$jw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$jw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$jw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$jw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$jw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$jw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$jw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$jw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$jw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$jw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$jw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$jw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$jw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$jw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$jw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$jw)("ExtHostTimeline"),ExtHostTesting:(0,I.$jw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$jw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$jw)("ExtHostLocalization")}}),define(Ae[78],Re([1,0,3,13,4,16]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=e.$tkc=e.$skc=void 0,e.$skc=(0,I.$qi)("IExtHostApiDeprecationService");let M=class{constructor(g,k){this.c=k,this.a=new Set,this.b=g.getProxy(A.$PM.MainThreadTelemetry)}report(g,k,N){const y=this.d(g,k);this.a.has(y)||(this.a.add(y),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:g}))}d(g,k){return`${g}-${k.identifier.value}`}};e.$tkc=M,e.$tkc=M=Je([Ve(0,O.$cP),Ve(1,T.$Wj)],M),e.$ukc=Object.freeze(new class{report(p,g,k){}})}),define(Ae[232],Re([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;class T{constructor(O){const M=O.getProxy(I.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$Hkc=T}),define(Ae[233],Re([1,0,26,4,27,16]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;let M=class{constructor(N,y){this.a=N.getProxy(T.$PM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,y){const u=this,v=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){u.e(N,y,v,arguments)}})}e(N,y,u,v){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:g(v,this.b)}),this.c&&this.f(N,u,v)}};e.$Bmc=M,e.$Bmc=M=Je([Ve(0,O.$cP),Ve(1,A.$sP)],M);const p=1e5;function g(k,N){const y=[];if(k.length)for(let u=0;u<k.length;u++){let v=k[u];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}y.push(v)}if(N){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$2n)(y);return u.length>p?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[234],Re([1,0,2,4,25]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class O{constructor(p){this.a=p.getProxy(T.$PM.MainThreadDialogs)}showOpenDialog(p,g){return g?.allowUIResources&&(0,A.$xG)(p,"showLocal"),this.a.$showOpenDialog(g).then(k=>k?k.map(N=>I.URI.revive(N)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(g=>g?I.URI.revive(g):void 0)}}e.$Elc=O}),define(Ae[235],Re([1,0,6,4]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class A{constructor(M){this.b=0,this.a=M.getProxy(T.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Ylc=A}),define(Ae[79],Re([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$mlc=void 0;let N=class{constructor(u,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(p.$PM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,v){const{message:m,args:s,comment:o}=v;if(this.c)return(0,T.$5e)(m,s??{});let r=m;o&&o.length>0&&(r+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[r];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,T.$5e)(n??m,s??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let v;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);v=u.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${s.message}`);return}v&&this.d.set(u.identifier.value,{contents:v,uri:m})}async g(u){if(u.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(v)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mlc=N,e.$mlc=N=Je([Ve(0,g.$sP),Ve(1,k.$cP),Ve(2,M.$Wj)],N),e.$nlc=(0,O.$qi)("IExtHostLocalizationService")}),define(Ae[236],Re([1,0,13,4,27,16,2,53]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;let g=class extends I.$8j{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(v=>(0,p.$Zh)(v))),this.r=y.getProxy(T.$PM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(M.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,v){return new k(this.r,y,u,v)}};e.$Amc=g,e.$Amc=g=Je([Ve(0,O.$cP),Ve(1,A.$sP)],g);class k extends I.$3j{constructor(y,u,v,m){super(m?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const v=[[y,u]];this.m?this.u(v):this.n.push(...v)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ae[80],Re([1,0,4,3,6,16,23]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=void 0,e.$olc=(0,T.$qi)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(I.$PM.MainThreadManagedSockets)}setFactory(y,u){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,v=await this.c.makeConnection(),m=new A.$Tc;return this.d.set(u,new k(u,v,m)),m.add((0,A.$Sc)(()=>this.d.delete(u))),m.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(u,s?.stack??s?.message),m.dispose()})),m.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(u,M.$Ce.wrap(s)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$plc=p,e.$plc=p=Je([Ve(0,O.$cP)],p);class g{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class k extends A.$Uc{constructor(y,u,v){super(),this.socketId=y,this.actual=u,this.B(v)}}}),define(Ae[237],Re([1,0,4,13,25]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;function O(p){return p&&p.title}let M=class{constructor(g,k){this.b=k,this.a=g.getProxy(I.$PM.MainThreadMessageService)}showMessage(g,k,N,y,u){const v={source:{identifier:g.identifier,label:g.displayName||g.name}};let m;typeof y=="string"||O(y)?m=[y,...u]:(v.modal=y?.modal,v.useCustom=y?.useCustom,v.detail=y?.detail,m=u),v.useCustom&&(0,A.$xG)(g,"resolvers");const s=[];let o=!1;for(let r=0;r<m.length;r++){const n=m[r];if(typeof n=="string")s.push({title:n,handle:r,isCloseAffordance:!1});else if(typeof n=="object"){const{title:t,isCloseAffordance:c}=n;s.push({title:t,isCloseAffordance:!!c,handle:r}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,N,v,s).then(r=>{if(typeof r=="number")return m[r]})}};e.$1lc=M,e.$1lc=M=Je([Ve(1,T.$Wj)],M)}),define(Ae[238],Re([1,0,6,17,2,25,4]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class p{constructor(k){this.b=new Map,this.a=k.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,N,y){if((0,O.$xG)(k,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,y),this.a.$registerProfileContentHandler(N,y.name,y.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(k,N,y,u){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.saveProfile(N,y,u)}async $readProfile(k,N,y){const u=this.b.get(k);if(!u)throw new Error(`Unknown handler with id: ${k}`);return u.readProfile((0,T.$4f)(N)?N:A.URI.revive(N),y)}}e.$0lc=p}),define(Ae[81],Re([1,0,4,5,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0;class O{constructor(p){this.b=new T.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$PM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,g){return this.a.$getPassword(p,g)}store(p,g,k){return this.a.$setPassword(p,g,k)}delete(p,g){return this.a.$deletePassword(p,g)}}e.$jlc=O,e.$klc=(0,A.$qi)("IExtHostSecretState")}),define(Ae[239],Re([1,0,22,6,4]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class O{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(A.$PM.MainThreadSpeech)}async $createSpeechToTextSession(p,g,k){const N=this.c.get(p);if(!N)return;const y=new T.$Tc,u=new I.$me;this.d.set(g,u);const v=y.add(N.provideSpeechToTextSession(u.token,k?{language:k}:void 0));y.add(v.onDidChange(m=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,m)})),y.add(u.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,g){const k=this.c.get(p);if(!k)return;const N=new T.$Tc,y=new I.$me;this.d.set(g,y);const u=N.add(k.provideKeywordRecognitionSession(y.token));N.add(u.onDidChange(v=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,v)})),N.add(y.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,g,k){const N=O.a++;return this.c.set(N,k),this.b.$registerProvider(N,g,{extension:p,displayName:p.value}),(0,T.$Sc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$emc=O}),define(Ae[82],Re([1,0,4,5,3]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;class O{constructor(p,g){this.c=g,this.b=new T.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,g){this.a.$registerExtensionStorageKeysToSync(p,g)}async initializeExtensionStorage(p,g,k){const N=await this.a.$initializeExtensionStorage(p,g);let y;return N&&(y=this.d(p,g,N)),y||k}setValue(p,g,k){return this.a.$setValue(p,g,k)}$acceptValue(p,g,k){const N=this.d(p,g,k);N&&this.b.fire({shared:p,key:g,value:N})}d(p,g,k){try{return JSON.parse(k)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${p}): ${N}`)}}}e.$_kc=O,e.$alc=(0,A.$qi)("IExtHostStorage")}),define(Ae[240],Re([1,0,6,12,2,4]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class M{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(O.$PM.MainThreadUriOpeners)}registerExternalUriOpener(g,k,N,y){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const u=y.schemes.find(v=>!M.a.has(v));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(k,N),this.b.$registerUriOpener(k,y.schemes,g,y.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener with id: ${g}`);const u=A.URI.revive(k);return y.canOpenExternalUri(u,N)}async $openUri(g,k,N){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener id: '${g}'`);return y.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},N)}}e.$umc=M}),define(Ae[241],Re([1,0,4,2,6,14,20]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class p{static{this.a=0}constructor(k){this.c=new M.$Mm,this.d=new Map,this.b=k.getProxy(I.$PM.MainThreadUrls)}registerUriHandler(k,N){const y=k.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=p.a++;return this.c.add(y),this.d.set(u,N),this.b.$registerUriHandler(u,y,k.displayName||k.name),(0,A.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(k,N){const y=this.d.get(k);if(!y)return Promise.resolve(void 0);try{y.handleUri(T.URI.revive(N))}catch(u){(0,O.$1)(u)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.$vmc=p}),define(Ae[63],Re([1,0,5,6,12,26,2,188,210,76,4]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Wkc=void 0,e.$Xkc=u,e.$Zkc=s,e.$1kc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,i,b,a,$,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=i,this.#n=b,this.#s=a,this.#r=$,this.#l=u($),this.#d=v($),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$5xb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===A.Schemas.https||c.scheme===A.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$4xb}return k.$4xb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$1n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$job)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,$,l,S,d)=>{const E=M.URI.from({scheme:l||"file",path:decodeURIComponent(S)}),f=(0,k.$5xb)(E,{isRemote:h,authority:i}).toString();return`${a}${f}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,$,l,S,d)=>{const E=M.URI.from({scheme:l||"file",path:decodeURIComponent(S)}),f=(0,k.$5xb)(E,{isRemote:h,authority:i}).toString();return`${a}${f}${d}`})}}e.$Wkc=y;function u(t){try{const c=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(t){try{const c=(0,p.$Cp)((0,p.$Bp)(t.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends T.$Uc{constructor(c,h,i,b,a){super(),this.c=h,this.f=i,this.g=b,this.h=a,this.b=new Map,this.a=c.getProxy(N.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const b=this.j(c);if(b){const{message:a}=(0,g.$kob)(h,i.value);b._onMessageEmitter.fire(a)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const b=new y(c,this.a,r(h),this.c,this.f,i,this.h);this.b.set(c,b);const a=b._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return b}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Ykc=m;function s(t){return{id:t.identifier,location:t.extensionLocation}}function o(t,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(t,c)}}function r(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(c=>M.URI.from(c))}}function n(t,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),t.extensionLocation]}}),define(Ae[109],Re([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=void 0;let y=class{static{N=this}static{this.a={focused:!0,active:!0}}getState(v){const m=this.d;return{get focused(){return m.focused},get active(){return(0,k.$xG)(v,"windowActivity"),m.active}}}constructor(v){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=N.a,this.b=v.getProxy(T.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:s})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,m){m!==this.d[v]&&(this.d={...this.d,[v]:m},this.c.fire(this.d))}openUri(v,m){let s;if(typeof v=="string"){s=v;try{v=A.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,M.$3e)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,m)}async asExternalUri(v,m){if((0,M.$3e)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,m);return A.URI.from(s)}};e.$xmc=y,e.$xmc=y=N=Je([Ve(0,g.$cP)],y),e.$ymc=(0,p.$qi)("IExtHostWindow")}),define(Ae[242],Re([1,0,233,27,16]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;let O=class extends I.$Bmc{constructor(p,g){super(p,g)}f(p,g,k){g.apply(console,k)}};e.$Joc=O,e.$Joc=O=Je([Ve(0,A.$cP),Ve(1,T.$sP)],O)}),define(Ae[243],Re([1,0,11,23,22,14,5,6,144,231,34]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$$$b=o,e.$_$b=r;function u(w,C){try{return JSON.stringify(w,C)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class s{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(w,C=null,P=!1){const V=[];return{jsonString:(P?u:JSON.stringify)(w,(q,R)=>{if(typeof R>"u")return m;if(typeof R=="object"){if(R instanceof T.$Ce){const j=V.push(R)-1;return{[v]:j}}if(C)return C(q,R)}return R}),referencedBuffers:V}}function r(w,C,P){return JSON.parse(w,(V,W)=>{if(W){const q=W[v];if(typeof q=="number")return C[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function n(w,C){return JSON.stringify(w,C)}function t(w){return w?(C,P)=>P&&P.$mid===1?w.transformOutgoing(P):P:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},b=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class $ extends p.$Uc{static{y=b}static{this.a=3*1e3}constructor(C,P=null,V=null){super(),this[y]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=N.$iw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ch(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,g.$vn)(C,this.g):C}getProxy(C){const{nid:P,sid:V}=C;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(C,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...R)=>this.U(C,q,R)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,V=C.length;P<V;P++){const W=C[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,V=S.read(C,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:R,method:j,args:K}=E.deserializeRequestJSONArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,R,j,K,W===2);break}case 3:case 4:{let{rpcId:R,method:j,args:K}=E.deserializeRequestMixedArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,R,j,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let R=E.deserializeReplyOKJSON(V);this.g&&(R=(0,g.$vn)(R,this.g)),this.O(P,q,R);break}case 10:{const R=E.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,R);break}case 8:{const R=E.deserializeReplyOKVSBuffer(V);this.O(P,q,R);break}case 11:{let R=E.deserializeReplyErrError(V);this.g&&(R=(0,g.$vn)(R,this.g)),this.P(P,q,R);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,V,W,q,R){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,N.$kw)(V)}.${W}(`,q);const j=String(P);let K,se;if(R){const ve=new A.$me;q.push(ve.token),K=this.Q(V,W,q),se=()=>ve.cancel()}else K=this.Q(V,W,q),se=i;this.u[j]=se;const ce=E.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[j];const Ie=E.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[j];const Ie=E.serializeReplyErr(P,ve);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",ve),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(C,P,V){this.f?.logIncoming(C,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(C,P,V){this.f?.logIncoming(C,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let R;V&&(V.$isError?(R=new Error,R.name=V.name,R.message=V.message,R.stack=V.stack):R=V),q.resolveErr(R)}Q(C,P,V){try{return Promise.resolve(this.S(C,P,V))}catch(W){return Promise.reject(W)}}S(C,P,V){const W=this.m[C];if(!W)throw new Error("Unknown actor "+(0,N.$kw)(C));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,N.$kw)(C));return q.apply(W,V)}U(C,P,V){if(this.j)return new k.$0$b;let W=null;if(V.length>0&&A.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(O.$6());const q=E.serializeRequestArguments(V,this.h),R=++this.t,j=String(R),K=new k.$9$b,se=new p.$Tc;W&&se.add(W.onCancellationRequested(()=>{const ve=E.serializeCancel(R);this.f?.logOutgoing(ve.byteLength,R,0,"cancel"),this.c.send(E.serializeCancel(R))})),this.w[j]=new l(K,se),this.F(R);const ce=E.serializeRequest(R,C,P,q,!!W);return this.f?.logOutgoing(ce.byteLength,R,0,`request: ${(0,N.$kw)(C)}.${P}(`,V),this.c.send(ce),K}}e.$a_b=$;class l{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class S{static alloc(C,P,V){const W=new S(T.$Ce.alloc(V+1+4),0);return W.writeUInt8(C),W.writeUInt32(P),W}static read(C,P){return new S(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let V=0,W=C.length;V<W;V++){const q=C[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)P+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,V=C.length;P<V;P++){const W=C[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let V=0;V<C;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());P[V]=new N.$lw(r(R,j,null));break}case 4:P[V]=void 0;break}return P}}var d;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(d||(d={}));class E{static a(C){for(let P=0,V=C.length;P<V;P++)if(C[P]instanceof T.$Ce||C[P]instanceof N.$lw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const V=[];for(let W=0,q=C.length;W<q;W++){const R=C[W];if(R instanceof T.$Ce)V[W]={type:2,value:R};else if(typeof R>"u")V[W]={type:4};else if(R instanceof N.$lw){const{jsonString:j,referencedBuffers:K}=o(R.value,P);V[W]={type:3,value:T.$Ce.fromString(j),buffers:K}}else V[W]={type:1,value:T.$Ce.fromString(n(R,P))}}return{type:1,args:V}}return{type:0,args:n(C,P)}}static serializeRequest(C,P,V,W,q){switch(W.type){case 0:return this.b(C,P,V,W.args,q);case 1:return this.c(C,P,V,W.args,q)}}static b(C,P,V,W,q){const R=T.$Ce.fromString(V),j=T.$Ce.fromString(W);let K=0;K+=S.sizeUInt8(),K+=S.sizeShortString(R),K+=S.sizeLongString(j);const se=S.alloc(q?2:1,C,K);return se.writeUInt8(P),se.writeShortString(R),se.writeLongString(j),se.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(C,P,V,W,q){const R=T.$Ce.fromString(V);let j=0;j+=S.sizeUInt8(),j+=S.sizeShortString(R),j+=S.sizeMixedArray(W);const K=S.alloc(q?4:3,C,j);return K.writeUInt8(P),K.writeShortString(R),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readMixedArray(),q=new Array(W.length);for(let R=0,j=W.length;R<j;R++){const K=W[R];typeof K=="string"?q[R]=JSON.parse(K):q[R]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(C){return S.alloc(5,C,0).buffer}static serializeCancel(C){return S.alloc(6,C,0).buffer}static serializeReplyOK(C,P,V){if(typeof P>"u")return this.d(C);if(P instanceof T.$Ce)return this.e(C,P);if(P instanceof N.$lw){const{jsonString:W,referencedBuffers:q}=o(P.value,V,!0);return this.g(C,W,q)}else return this.f(C,u(P,V))}static d(C){return S.alloc(7,C,0).buffer}static e(C,P){let V=0;V+=S.sizeVSBuffer(P);const W=S.alloc(8,C,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const V=T.$Ce.fromString(P);let W=0;W+=S.sizeLongString(V);const q=S.alloc(9,C,W);return q.writeLongString(V),q.buffer}static g(C,P,V){const W=T.$Ce.fromString(P);let q=0;q+=S.sizeUInt32,q+=S.sizeLongString(W);for(const j of V)q+=S.sizeVSBuffer(j);const R=S.alloc(10,C,q);R.writeUInt32(V.length),R.writeLongString(W);for(const j of V)R.writeBuffer(j);return R.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const V=C.readUInt32(),W=C.readLongString(),q=[];for(let R=0;R<V;++R)q.push(C.readVSBuffer());return new N.$lw(r(W,q,P))}static serializeReplyErr(C,P){const V=P?u(O.$3(P),null):void 0;if(typeof V!="string")return this.h(C);const W=T.$Ce.fromString(V);let q=0;q+=S.sizeLongString(W);const R=S.alloc(11,C,q);return R.writeLongString(W),R.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return S.alloc(12,C,0).buffer}}var f;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var D;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(D||(D={}))}),define(Ae[244],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;const I=function(O){const M=p=>{globalThis.removeEventListener("message",M);const g=p.data;Object.defineProperties(globalThis,{postMessage:{value(k,N){g.postMessage(k,N)}},onmessage:{get(){return g.onmessage},set(k){g.onmessage=k}}}),g.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class T extends EventTarget{constructor(O,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${I})('${M}'))`,k=new Blob([g],{type:"application/javascript"}),N=URL.createObjectURL(k),y=new MessageChannel,u=N,v={type:"_newWorker",id:u,port:y.port2,url:N,options:p};O(v,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(N),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$Loc=T}),define(Ae[245],Re([1,0,23,28,12,55,3]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=N,e.$tK=y,e.$rK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${p.join("")}]+`),k=7;function N(v){if(v.scheme!==A.Schemas.vscodeNotebookCell)return;const m=v.fragment.indexOf("s");if(m<0)return;const s=parseInt(v.fragment.substring(0,m).replace(g,""),k),o=(0,I.$Ve)(v.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:o,fragment:null})}}function y(v,m){const s=m.toString(k),r=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,I.$We)(I.$Ce.fromString(v.scheme),!0,!0)}`;return v.with({scheme:A.Schemas.vscodeNotebookCell,fragment:r})}class u{constructor(){this.a=new T.$Bc}getNotebook(m){if(m.scheme===A.Schemas.vscodeNotebookCell){const s=N(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$uK=u,(0,O.$os)(e.$rK,u,1)}),define(Ae[83],Re([1,0,23,36,40,69,12,19,21,31,245]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=b,e.$IK=$,e.$JK=l,e.$MK=E,e.$NK=D,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",O.$Hs.latex,O.$Hs.markdown,"image/png","image/jpeg",O.$Hs.text],e.$BK=[O.$Hs.latex,O.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var r;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function se(ie,Pe){return(0,N.$tK)(ie,Pe)}K.generate=se;function ce(ie){return(0,N.$sK)(ie)}K.parse=ce;function ve(ie,Pe){return ie.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Pe??""},${ie.scheme!==M.Schemas.file?ie.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(ie){if(ie.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!Pe)return;const Fe=Pe[1]&&Pe[1]!==""?Pe[1]:void 0,ne=Pe[2];return{outputId:Fe,notebook:ie.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(ie,Pe,Fe){return K.generate(ie,Pe).with({scheme:Fe})}K.generateCellPropertyUri=ue;function be(ie,Pe){if(ie.scheme===Pe)return K.parse(ie.with({scheme:K.scheme}))}K.parseCellPropertyUri=be})(c||(e.CellUri=c={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class i{constructor(se=[],ce=e.$AK){this.e=ce,this.d=[...new Set(se)].map(ve=>({pattern:ve,matches:T.$kk(h(ve))}))}sort(se){const ce=new Map(A.Iterable.map(se,Ie=>[Ie,h(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[ue,be]of ce)if(Ie(be)){ve.push(ue),ce.delete(ue);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ve}prioritize(se,ce){const ve=this.f(se);if(ve===-1){this.d.unshift({pattern:se,matches:T.$kk(h(se))});return}const Ie=new Set(ce.map(be=>this.f(be,ve)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ve+1,0,...ue.map(be=>this.d[be]));for(let be=ue.length-1;be>=0;be--)this.d.splice(ue[be],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,ce=this.d.length){const ve=h(se);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$EK=i;function b(K,se,ce,ve=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Pe,Fe,ne){if(Fe===0&&ne.length===0)return;const U=Ie[Ie.length-1];U&&U.start+U.deleteCount===Pe?(U.deleteCount+=Fe,U.toInsert.push(...ne)):Ie.push({start:Pe,deleteCount:Fe,toInsert:ne})}let be=0,ie=0;for(;;){if(be===K.length){ue(be,0,se.slice(ie));break}if(ie===se.length){ue(be,K.length-be,[]);break}const Pe=K[be],Fe=se[ie];if(ve(Pe,Fe)){be+=1,ie+=1;continue}ce(Fe)?(ue(be,1,[]),be+=1):(ue(be,0,[Fe]),ie+=1)}return Ie}e.$GK=new k.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new k.$Hj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function $(K){const se=K;return!!((typeof se.include=="string"||T.$lk(se.include))&&(typeof se.exclude=="string"||T.$lk(se.exclude)))}function l(K,se,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(se)>=0||K.viewType===se)return!0;if(K.filenamePattern){const ve=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(T.$jk(ve,(0,p.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&T.$jk(Ie,(0,p.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class d{static{this.d="notebook/"}static create(se){return`${d.d}${se}`}static parse(se){if(se.startsWith(d.d))return se.substring(d.d.length)}}e.$LK=d;function E(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function D(K){const se=[];let ce=!1;for(const be of K)(se.length===0||ce)&&(se.push(be),ce=!0);let ve=P(se);const Ie=I.$Ce.concat(se.map(be=>I.$Ce.wrap(be))),ue=j(Ie);return ve=ve||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ve}}e.$OK="\x1B[A";const w=e.$OK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let se=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$OK.length)return;const Ie=K[ve-1],ue=ce.subarray(0,e.$OK.length);if(ue[0]===w[0]&&ue[1]===w[1]&&ue[2]===w[2]){const be=Ie.lastIndexOf(C);if(be===-1)return;se=!0,K[ve-1]=Ie.subarray(0,be),K[ve]=ce.subarray(e.$OK.length)}}),se}function V(K){let se=K;do K=se,se=K.replace(/[^\n]\x08/gm,"");while(se.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const se=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+se.slice(ce.length,se.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,R=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(R)?K:I.$Ce.fromString(W(V(f.decode(K.buffer))))}}),define(Ae[7],Re([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m){"use strict";var s,o,r,n,t,c,h,i,b,a,$,l,S,d,E,f,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$3O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2O=e.$1O=e.$ZO=e.$YO=e.ChatLocation=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=dt,e.$QN=Q,e.$vO=Rt;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ke]=te;return Reflect.construct(B,Ke,Ee.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=s=class{static from(...F){let te=F;return new s(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=V,e.$RM=V=s=Je([w],V);let W=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Ee=1;Ee<F.length;Ee++){const Ke=F[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:Ee}=F;return typeof te=="number"&&typeof Ee=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,T.$7)("line must be non-negative");if(te<0)throw(0,T.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,T.$7)();let Ee;return typeof F>"u"?Ee=0:typeof F=="number"?Ee=F:(Ee=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,T.$7)();let Ee;return typeof F>"u"?Ee=this.line:typeof F=="number"?Ee=F:(Ee=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=W,e.$SM=W=o=Je([w],W);let q=r=class{static isRange(F){return F instanceof r?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Ee,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(Ee,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");Ye.isBefore(ht)?(this.c=Ye,this.e=ht):(this.c=ht,this.e=Ye)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=W.Max(F.start,this.c),Ee=W.Min(F.end,this.e);if(!te.isAfter(Ee))return new r(te,Ee)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this.c),Ee=W.Max(F.end,this.end);return new r(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,T.$7)();let Ee;return F?W.isPosition(F)?Ee=F:(Ee=F.start||this.start,te=F.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};e.$TM=q,e.$TM=q=r=Je([w],q);let R=n=class extends q{static isSelection(F){return F instanceof n?!0:F?q.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Ee,Ke){let Ye,ht;if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(F,te),ht=new W(Ee,Ke)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),ht=W.of(te)),!Ye||!ht)throw new Error("Invalid arguments");super(Ye,ht),this.f=Ye,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=R,e.$UM=R=n=Je([w],R);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Ee){if(typeof F!="string"||F.length===0)throw(0,T.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.$7)("port");typeof Ee<"u"&&j(Ee),this.host=F,this.port=Math.round(te),this.connectionToken=Ee}}e.$VM=K;class se{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$WM=se;class ce extends Error{static NotAvailable(F,te){return new ce(F,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=v.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(F),this._message=F,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$XM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=t=class{static isTextEdit(F){return F instanceof t?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new t(F,te)}static insert(F,te){return t.replace(new q(F,F),te)}static delete(F){return t.replace(F,"")}static setEndOfLine(F){const te=new t(new q(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,T.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,T.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,T.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=ue,e.$YM=ue=t=Je([w],ue);let be=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?xe.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new xe(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const Ee=new c(new xe(F,F),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(F){const te=new c(new xe(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$ZM=be,e.$ZM=be=c=Je([w],be);class ie{static isSnippetTextEdit(F){return F instanceof ie?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new ie(F,te)}static insert(F,te){return ie.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$1M=ie;var Pe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Pe||(e.FileEditType=Pe={}));let Fe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Ee,Ke){this.c.push({_type:1,from:F,to:te,options:Ee,metadata:Ke})}createFile(F,te,Ee){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:Ee})}deleteFile(F,te,Ee){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:Ee})}e(F,te,Ee){this.c.push({_type:3,metadata:Ee,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,Ee,Ke){const Ye=te.start,ht=te.end;(Ye!==ht||Ee.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:ht-Ye,cells:Ee,metadata:Ke})}g(F,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:Ee}})}replace(F,te,Ee,Ke){this.c.push({_type:2,uri:F,edit:new ue(te,Ee),metadata:Ke})}insert(F,te,Ee,Ke){this.replace(F,new q(te,te),Ee,Ke)}delete(F,te,Ee){this.replace(F,te,"",Ee)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,be.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,Ye):this.f(F,Ke.range,Ke.newCells,Ye):ie.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(F){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===F.toString()&&te.push(Ee.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===2){let Ee=F.get(te.uri);Ee||(Ee=[te.uri,[]],F.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Fe,e.$2M=Fe=Je([w],Fe);let ne=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Ee=new h;Ee.e=this.e,F(Ee),this.e=Ee.e,F=Ee.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Ee=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$3M=ne,e.$3M=ne=h=Je([w],ne);var U;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let pe=i=class{static isLocation(F){return F instanceof i?!0:F?q.isRange(F.range)&&k.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=pe,e.$4M=pe=i=Je([w],pe);let Oe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$5M=Oe,e.$5M=Oe=Je([w],Oe);let ke=class{constructor(F,te,Ee=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.$ub)(F.tags,te.tags)&&(0,I.$ub)(F.relatedInformation,te.relatedInformation,Oe.isEqual)}};e.$6M=ke,e.$6M=ke=Je([w],ke);let $e=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$7M=$e,e.$7M=$e=Je([w],$e);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let J=class{constructor(F,te=fe.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$8M=J,e.$8M=J=Je([w],J);let Y=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$9M=Y,e.$9M=Y=Je([w],Y);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var le;(function(B){B[B.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let Te=b=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Ee,Ke,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof pe?this.location=Ke:Ee instanceof q&&(this.location=new pe(Ke,Ee)),b.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Te,e.$0M=Te=b=Je([w],Te);let de=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,Ee,Ke,Ye){this.name=F,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$$M=de,e.$$M=de=a=Je([w],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(F,te){this.title=F,this.kind=te}};e.$_M=Me,e.$_M=Me=Je([w],Me);let ze=class{static{$=this}static{this.c="."}constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};e.$aN=ze,e.$aN=ze=$=Je([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=z,e.$bN=z=Je([w],z);class L{constructor(F,te,Ee,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$cN=L;class G{constructor(F,te){this.fromRanges=te,this.from=F}}e.$dN=G;class H{constructor(F,te){this.fromRanges=te,this.to=F}}e.$eN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let re=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$fN=re,e.$fN=re=Je([w],re);let Ne=l=class{#e;static isMarkdownString(F){return F instanceof l?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new A.$Nk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$gN=Ne,e.$gN=Ne=l=Je([w],Ne);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$hN=Be,e.$hN=Be=Je([w],Be);let Qe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$iN=Qe,e.$iN=Qe=Je([w],Qe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=_e,e.$jN=_e=Je([w],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(F){this.value=F}};e.$kN=it,e.$kN=it=Je([w],it);let nt=class{constructor(F,te,Ee){this.position=F,this.label=te,this.kind=Ee}};e.$lN=nt,e.$lN=nt=Je([w],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=st,e.$mN=st=Je([w],st);let X=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$nN=X,e.$nN=X=Je([w],X);let Z=class{constructor(F,te,Ee){this.insertText=F,this.range=te,this.command=Ee}};e.$oN=Z,e.$oN=Z=Je([w],Z);let me=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$pN=me,e.$pN=me=Je([w],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${y.$Lm.toKey(B)}.${F}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var jt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Vt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Vt||(e.SyntaxTokenType=Vt={}));let Zt=class{constructor(F,te){if(te&&!k.URI.isUri(te))throw(0,T.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.target=te}};e.$rN=Zt,e.$rN=Zt=Je([w],Zt);let Xe=class{constructor(F,te,Ee,Ke){this.red=F,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$sN=Xe,e.$sN=Xe=Je([w],Xe);let si=class{constructor(F,te){if(te&&!(te instanceof Xe))throw(0,T.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,T.$7)("range");this.range=F,this.color=te}};e.$tN=si,e.$tN=si=Je([w],si);let Xt=class{constructor(F){if(!F||typeof F!="string")throw(0,T.$7)("label");this.label=F}};e.$uN=Xt,e.$uN=Xt=Je([w],Xt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var vt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(vt||(e.SourceControlInputBoxValidationType=vt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Yt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Yt||(e.TerminalShellExecutionCommandLineConfidence=Yt={}));class Lt{constructor(F,te,Ee){if(this.startIndex=F,this.length=te,this.tooltip=Ee,typeof F!="number"||F<0)throw(0,T.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,T.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.$7)("tooltip")}}e.$vN=Lt;class ft{constructor(F){this.uri=F}}e.$wN=ft;class Ut{constructor(F){this.terminalCommand=F}}e.$xN=Ut;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,T.$7)("options")}}e.$yN=qt;var Ge;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ge||(e.TaskRevealKind=Ge={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ht=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(F){switch(F){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,T.$7)("name");this.c=F}get id(){return this.c}};e.$zN=Ht,e.$zN=Ht=S=Je([w],Ht);function zt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let gt=class{constructor(F,te,Ee){if(typeof F!="string")throw(0,T.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,T.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return zt(F)}};e.$AN=gt,e.$AN=gt=Je([w],gt);let Nt=class{constructor(F,te,Ee){if(this.f=[],Array.isArray(te)){if(!F)throw(0,T.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F,this.f=te,this.g=Ee}else{if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,T.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,T.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return zt(F)}};e.$BN=Nt,e.$BN=Nt=Je([w],Nt);var At;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ot||(e.TaskScope=Ot={}));class ii{constructor(F){this.c=F}computeId(){return"customExecution"+(0,N.$Mg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$CN=ii;let Gt=class{static{d=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Ee,Ke,Ye,ht){this.k=!1,this.l=this.definition=F;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,$t=Ye,this.k=!0):te===Ot.Global||te===Ot.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=ht):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:d.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:d.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:d.c,id:this.q.computeId()}:this.l={type:d.g,id:(0,N.$Mg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,T.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,T.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(d.g===te||d.e===te||d.f===te||d.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,T.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$DN=Gt,e.$DN=Gt=d=Je([w],Gt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Mt;(function(B){function F(te){const Ee=te;return(0,g.$8f)(Ee.value)?Ee.tooltip&&!(0,g.$4f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let Tt=E=class{static isTreeItem(F,te){const Ee=F;if(Ee.checkboxState!==void 0){const Ke=(0,g.$8f)(Ee.checkboxState)?Ee.checkboxState:(0,g.$6f)(Ee.checkboxState)&&(0,g.$8f)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,g.$8f)(Ee.checkboxState)&&(0,g.$6f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||Ye!==void 0&&!(0,g.$4f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(F instanceof E)return!0;if(Ee.label!==void 0&&!(0,g.$4f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,g.$4f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,g.$4f)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,g.$4f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,g.$4f)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,g.$4f)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,g.$4f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,g.$4f)(Ee.tooltip)&&!(Ee.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<Ct.None&&Ee.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,g.$4f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(F,te=Ct.None){this.collapsibleState=te,k.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$EN=Tt,e.$EN=Tt=E=Je([w],Tt);var Ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$FN=pt,e.$FN=pt=Je([w],pt);class St extends pt{}e.$GN=St;class li extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$HN=li;class Dt{constructor(F,te,Ee,Ke){this.name=F,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$IN=Dt;let hi=class{#e=new Map;constructor(F){for(const[te,Ee]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)F.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Ee of te)yield[F,Ee]}#t(F){return F.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([w],hi);let Kt=class{constructor(F,te,Ee){this.insertText=F,this.title=te,this.kind=Ee}};e.$KN=Kt,e.$KN=Kt=Je([w],Kt);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ei{static{this.c="."}constructor(F){this.value=F}append(...F){return new ei((this.value?[this.value,...F]:F).join(ei.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ei.c)}}e.$LN=ei,ei.Empty=new ei("");class wi{constructor(F,te,Ee){this.title=te,this.insertText=F,this.kind=Ee}}e.$MN=wi;let yt=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$NN=yt,e.$NN=yt=Je([w],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(F){this.id=F}};e.$ON=$i,e.$ON=$i=Je([w],$i);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Se=class{get base(){return this.c}set base(F){this.c=F,this.e=k.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,T.$7)("base");if(typeof te!="string")throw(0,T.$7)("pattern");typeof F=="string"?this.baseUri=k.URI.file(F):k.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Se,e.$PN=Se=Je([w],Se);const ae=new WeakMap;function Q(B,F){ae.set(B,F)}let De=class{constructor(F,te,Ee,Ke,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=ae.get(this)??(0,N.$Mg)()),this.c}};e.$RN=De,e.$RN=De=Je([w],De);let We=class extends De{constructor(F,te,Ee,Ke,Ye,ht){if(super(te,Ee,Ke,Ye,ht),F===null)throw(0,T.$7)("location");this.location=F}};e.$SN=We,e.$SN=We=Je([w],We);let Ze=class extends De{constructor(F,te,Ee,Ke,Ye,ht){super(te,Ee,Ke,Ye,ht),this.functionName=F}};e.$TN=Ze,e.$TN=Ze=Je([w],Ze);let qe=class extends De{constructor(F,te,Ee,Ke,Ye,ht,$t,Jt){if(super(Ke,Ye,ht,$t,Jt),!te)throw(0,T.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=Ee}};e.$UN=qe,e.$UN=qe=Je([w],qe);let ut=class{constructor(F,te,Ee){this.command=F,this.args=te||[],this.options=Ee}};e.$VN=ut,e.$VN=ut=Je([w],ut);let kt=class{constructor(F,te){this.port=F,this.host=te}};e.$WN=kt,e.$WN=kt=Je([w],kt);let Ft=class{constructor(F){this.path=F}};e.$XN=Ft,e.$XN=Ft=Je([w],Ft);let Wt=class{constructor(F){this.implementation=F}};e.$YN=Wt,e.$YN=Wt=Je([w],Wt);class ct{constructor(F,te,Ee){this.session=F,this.threadId=te,this.frameId=Ee}}e.$ZN=ct;class ri{constructor(F,te){this.session=F,this.threadId=te}}e.$1N=ri;let di=class{constructor(F,te){this.range=F,this.expression=te}};e.$2N=di,e.$2N=di=Je([w],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(F,te){this.range=F,this.text=te}};e.$3N=Si,e.$3N=Si=Je([w],Si);let Ri=class{constructor(F,te,Ee=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$4N=Ri,e.$4N=Ri=Je([w],Ri);let Mi=class{constructor(F,te){this.range=F,this.expression=te}};e.$5N=Mi,e.$5N=Mi=Je([w],Mi);let Ti=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$6N=Ti,e.$6N=Ti=Je([w],Ti);var Ni;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$7N=cn;var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Fi=f=class extends Error{static FileExists(F){return new f(F,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(F){return new f(F,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(F){return new f(F,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(F){return new f(F,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(F){return new f(F,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(F)?F.toString(!0):F),this.code=Ee?.name??"Unknown",(0,u.$_k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$8N=Fi,e.$8N=Fi=f=Je([w],Fi);let yi=class{constructor(F,te,Ee){this.start=F,this.end=te,this.kind=Ee}};e.$9N=yi,e.$9N=yi=Je([w],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$0N=un;function Li(B){return typeof B>"u"||(0,g.$5f)(B)}class zi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Ee=F.tokenTypes.length;te<Ee;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Ee=F.tokenModifiers.length;te<Ee;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Ee,Ke,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,Ee,Ke,Ye);if(q.isRange(F)&&typeof te=="string"&&Li(Ee))return this.o(F,te,Ee);throw(0,T.$7)()}o(F,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,Ye=F.start.character,ht=F.end.character-F.start.character,$t=this.k.get(te);let Jt=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Ye,ht,$t,Jt)}q(F,te,Ee,Ke,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=F,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],Ee=F.length/5|0;for(let $t=0;$t<Ee;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=F[5*$t],fi=F[5*Jt];if(ci===fi){const gi=F[5*$t+1],mi=F[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(F.length);let Ye=0,ht=0;for(let $t=0;$t<Ee;$t++){const Jt=5*te[$t],ci=F[Jt+0],fi=F[Jt+1],gi=F[Jt+2],mi=F[Jt+3],qi=F[Jt+4],Mn=ci-Ye,ur=Mn===0?fi-ht:fi,Hi=5*$t;Ke[Hi+0]=Mn,Ke[Hi+1]=ur,Ke[Hi+2]=gi,Ke[Hi+3]=mi,Ke[Hi+4]=qi,Ye=ci,ht=fi}return Ke}build(F){return this.f?new Pi(new Uint32Array(this.g),F):new Pi(zi.r(this.g),F)}}e.$$N=zi;class Pi{constructor(F,te){this.resultId=te,this.data=F}}e.$_N=Pi;class ln{constructor(F,te,Ee){this.start=F,this.deleteCount=te,this.data=Ee}}e.$aO=ln;class Zi{constructor(F,te){this.resultId=te,this.edits=F}}e.$bO=Zi;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class hn{constructor(F){this.name=F}}e.$cO=hn;let ji=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$dO=ji,e.$dO=ji=Je([w],ji);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ci;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var Ui;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ui||(e.ExtensionKind=Ui={}));class je{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Df)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Df)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!yt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Ee){this.badge=F,this.tooltip=te,this.color=Ee}}e.$eO=je;let oi=class{constructor(F){this.kind=F}};e.$fO=oi,e.$fO=oi=Je([w],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(F){return F instanceof xe?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,T.$7)("start must be positive");if(te<0)throw(0,T.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Ee=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Ee=F.end),te===this.c&&Ee===this.e?this:new xe(te,Ee)}}e.$gO=xe;class bt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>bt.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Ee,Ke,Ye,ht,$t){this.kind=F,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=ht,this.executionSummary=$t,bt.validate(this)}}e.$hO=bt;class dn{constructor(F){this.cells=F}}e.$iO=dn;class ai{static isNotebookCellOutputItem(F){return F instanceof ai?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ai.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ai.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ai(F,te)}static#e=new TextEncoder;static text(F,te=M.$Hs.text){const Ee=ai.#e.encode(String(F));return new ai(Ee,te)}static json(F,te="text/x-json"){const Ee=JSON.stringify(F,void 0,"	");return ai.text(Ee,te)}constructor(F,te){this.data=F,this.mime=te;const Ee=(0,M.$Ls)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$jO=ai;class ki{static isNotebookCellOutput(F){return F instanceof ki?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<F.length;Ye++){const ht=F[Ye],$t=(0,M.$Ls)(ht.mime);if(!Ee.has($t)||(0,m.$MK)($t)){Ee.add($t);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?F:F.filter((Ye,ht)=>!Ke.has(ht))}constructor(F,te,Ee){this.items=ki.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,N.$Mg)(),this.metadata=te??Ee)}}e.$kO=ki;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(F,te){this.text=F,this.alignment=te}}e.$lO=fn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.$3b)(te)}}e.$mO=gn;class mn{constructor(F){this.label=F}}e.$nO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$oO=Vi,e.$oO=Vi=Je([w],Vi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$pO=$n;class pn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$qO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let oe=class{constructor(F=void 0,te=void 0,Ee=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=Ee,this.continuous=Ke}};e.$rO=oe,e.$rO=oe=Je([w],oe);let Le=D=class{static diff(F,te,Ee){const Ke=new D(F);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(F){this.message=F}};e.$sO=Le,e.$sO=Le=D=Je([w],Le);let rt=class{constructor(F){this.id=F}};e.$tO=rt,e.$tO=rt=Je([w],rt);class wt{constructor(F,te){this.covered=F,this.total=te,Rt(this)}}e.$uO=wt;function Rt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Di{static fromDetails(F,te){const Ee=new wt(0,0),Ke=new wt(0,0),Ye=new wt(0,0);for(const $t of te)if("branches"in $t){Ee.total+=1,Ee.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Ye.total+=1,Ye.covered+=$t.executed?1:0;const ht=new Di(F,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ht.detailedCoverage=te,ht}constructor(F,te,Ee,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$wO=Di;class Tn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee=[]){this.executed=F,this.location=te,this.branches=Ee}}e.$xO=Tn;class Nn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.executed=F,this.location=te,this.label=Ee}}e.$yO=Nn;class On{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Ee){this.name=F,this.executed=te,this.location=Ee}}e.$zO=On;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class Fn{constructor(F,te,Ee,Ke,Ye,ht){this.kind=F,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=ht}}e.$AO=Fn;class Ln{constructor(F){this.uri=F}}e.$BO=Ln;class zn{constructor(F,te){this.original=F,this.modified=te}}e.$CO=zn;class jn{constructor(F,te,Ee,Ke){this.base=F,this.input1=te,this.input2=Ee,this.result=Ke}}e.$DO=jn;class Un{constructor(F,te){this.uri=F,this.viewType=te}}e.$EO=Un;class Bn{constructor(F){this.viewType=F}}e.$FO=Bn;class Wn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$GO=Wn;class Vn{constructor(F,te,Ee){this.original=F,this.modified=te,this.notebookType=Ee}}e.$HO=Vn;class qn{constructor(){}}e.$IO=qn;class Hn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$JO=Hn;class Gn{constructor(){}}e.$KO=Gn;class Kn{constructor(F){this.textDiffs=F}}e.$LO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(F,te){this.label=F,this.values=te}}e.$MO=Jn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Qn{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ne(F):F}}e.$NO=Qn;class Zn{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ne(F):F,this.vulnerabilities=te}}e.$OO=Zn;class Xn{constructor(F,te){this.participant=F,this.command=te}}e.$PO=Xn;class Yn{constructor(F,te){this.value=F,this.baseUri=te}}e.$QO=Yn;class xn{constructor(F,te){this.value=F,this.title=te}}e.$RO=xn;class _n{constructor(F){this.value=F}}e.$SO=_n;class er{constructor(F){this.value=F}}e.$TO=er;class tr{constructor(F){this.value=F}}e.$UO=tr;class ir{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$VO=ir;class nr{constructor(F,te,Ee,Ke){this.prompt=F,this.command=te,this.variables=Ee,this.participant=Ke}}e.$WO=nr;class rr{constructor(F,te,Ee,Ke){this.response=F,this.result=te,this.participant=Ee,this.command=Ke}}e.$XO=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(F){this.content=F}}e.$YO=sr;class or{constructor(F,te){this.content=F,this.name=te}}e.$ZO=or;class ar{constructor(F,te){this.content=F,this.name=te}}e.$1O=ar;class Ai extends Error{static NotFound(F){return new Ai(F,Ai.NotFound.name)}static NoPermissions(F){return new Ai(F,Ai.NoPermissions.name)}constructor(F,te,Ee){super(F,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$2O=Ai;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class cr{constructor(F,te){this.text=F,this.range=te}}e.$3O=cr;var Rn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(Ae[246],Re([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,g){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(M);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(p,g)??[]}getRelatedInformation(M,p,g){return this.c.$getAiRelatedInformation(p,g)}registerRelatedInformationProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiRelatedInformationProvider(k,p),new T.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$rkc=A}),define(Ae[84],Re([1,0,5,4,7,20,106,3,16]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=e.$Ckc=void 0,e.$Ckc=(0,p.$qi)("IExtHostAuthentication");let k=class{constructor(u){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=u.getProxy(T.$PM.MainThreadAuthentication)}async getSession(u,v,m,s={}){const o=O.$Lm.toKey(u.identifier),r=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${r}`,async()=>{await this.a.$ensureProvider(v);const n=u.displayName||u.name;return this.a.$getSession(v,m,o,n,s)})}async getSessions(u,v,m){const s=O.$Lm.toKey(u.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(v);const r=u.displayName||u.name;return this.a.$getSessions(v,m,s,r)})}async removeSession(u,v){const m=this.b.get(u);return m?m.provider.removeSession(v):this.a.$removeSession(u,v)}registerAuthenticationProvider(u,v,m,s){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:v,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(u,r));return this.a.$registerAuthenticationProvider(u,v,s?.supportsMultipleAccounts??!1),new A.$RM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,v,m){const s=this.b.get(u);if(s)return Promise.resolve(s.provider.createSession(v,m));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,v){const m=this.b.get(u);if(m)return Promise.resolve(m.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,v){return u.startsWith(M.$RL)||this.c.fire({provider:{id:u,label:v}}),Promise.resolve()}};e.$Dkc=k,e.$Dkc=k=Je([Ve(0,g.$cP)],k);class N{constructor(){this.a=new Map}getOrCreate(u,v){const m=this.a.get(u);if(m)return m;const s=v().finally(()=>this.a.delete(u));return this.a.set(u,s),s}}}),define(Ae[110],Re([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;let v=class{static{u=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(T.$PM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const r=u.c++;this.f.set(r,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(r,o.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(r,null);return}const c=(0,g.$3b)(t);if(c.length<=u.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,k.$9e)(a.path,"/")})),i=(0,g.$zb)(h,(a,$)=>a.rank-$.rank||(0,k.$mf)(a.uri.path,$.uri.path)),b=[];e:for(const a of i){let $;for(const l of a){const S=(0,N.$nc)(l.uri.path);if($!==S&&($=S,b.push(l.uri)>=u.d))break e}}this.g.$onDidChange(r,b)});return new A.$RM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,o,r){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:t,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async h=>{try{const{uri:i,id:b}=h,a=await Promise.resolve(t.provideFileDecoration(I.URI.revive(i),r));if(!a)return;try{A.$eO.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.$xG)(c,"codiconDecoration"),n[b]=[a.propagate,a.tooltip,a.badge,a.color]}catch($){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${$}`)}}catch(i){this.h.error(i)}})),n}};e.$Clc=v,e.$Clc=v=u=Je([Ve(0,M.$cP),Ve(1,p.$Wj)],v),e.$Dlc=(0,O.$qi)("IExtHostDecorations")}),define(Ae[247],Re([1,0,14,2,7,4,12,22,15]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class k{static{this.a=0}constructor(y,u,v){this.d=u,this.e=v,this.b=new Map,this.c=y.getProxy(O.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const v=k.a++;this.b.set(v,u),this.c.$registerTextContentProvider(v,y);let m;if(typeof u.onDidChange=="function"){let s;m=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const r=this.$provideTextDocumentContent(v,o).then(async n=>{if(!n&&typeof n!="string")return;const t=this.d.getDocument(o);if(!t)return;const c=(0,g.$gf)(n);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new A.$RM(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,u){const v=this.b.get(y);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(u),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Flc=k}),define(Ae[111],Re([1,0,56,12,15,302,152,7,18]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$eP=N;const k=new Map;function N(m,s){s?k.set(m,s):k.delete(m)}function y(m){return k.get(m)}class u extends O.$Pv{constructor(s,o,r,n,t,c,h){super(o,r,n,t),this.c=s,this.m=c,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===T.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,r){return s.y(o,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,I.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,I.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const r=this.g,n=o.start.line,t=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<t;h++)c.push(this.f[h]);return c.push(this.f[t].substring(0,o.end.character)),c.join(r)}t(s){let o;if(s instanceof p.$SM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),r=this.f[o.index].length;return new p.$SM(o.index,Math.min(o.remainder,r))}w(s){if(!(s instanceof p.$TM))throw new Error("Invalid argument");const o=this.x(s.start),r=this.x(s.end);return o===s.start&&r===s.end?s:new p.$TM(o.line,o.character,r.line,r.character)}x(s){if(!(s instanceof p.$SM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:r}=s,n=!1;if(o<0)o=0,r=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,r=this.f[o].length,n=!0;else{const t=this.f[o].length;r<0?(r=0,n=!0):r>t&&(r=t,n=!0)}return n?new p.$SM(o,r):s}y(s,o){const r=this.x(s);if(!o)o=y(this.m);else if((0,A.$ff)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,M.$Zs)(r.character+1,(0,M.$Xs)(o),this.f[r.line],0);if(n)return new p.$TM(r.line,n.startColumn-1,r.line,n.endColumn-1)}}e.$fP=u;class v{constructor(s,o,r){this.a=s,this.b=o,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gP=v}),define(Ae[248],Re([1,0,4,7]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class A{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(M);if(!k)throw new Error("Embedding vector provider not found");const N=await k.provideEmbeddingVector(p,g);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(M,p,g){const k=this.b;return this.b++,this.a.set(k,g),this.c.$registerAiEmbeddingVectorProvider(p,k),new T.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Hlc=A}),define(Ae[64],Re([1,0,4,44,7,23,3,16,45,6,11,24,12]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=e.$Skc=void 0;let m=v=class{constructor(o,r){this.b=new Map,this.c=new N.$zh,this.a=o.getProxy(I.$PM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(t){try{let c;const h=n.b.get(t.scheme);return h?(await n.a.$ensureActivation(t.scheme),c=await h.impl.stat(t)):c=await n.a.$stat(t),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readDirectory(t)).slice()):await n.a.$readdir(t)}catch(c){return v.e(c)}},async createDirectory(t){try{const c=n.b.get(t.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(c.impl,c.extUri,t)):await n.a.$mkdir(t)}catch(c){return v.e(c)}},async readFile(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readFile(t)).slice()):(await n.a.$readFile(t)).buffer}catch(c){return v.e(c)}},async writeFile(t,c){try{const h=n.b.get(t.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(t)),await n.c.queueFor(t,()=>Promise.resolve(h.impl.writeFile(t,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(t,O.$Ce.wrap(c))}catch(h){return v.e(h)}},async delete(t,c){try{const h=n.b.get(t.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(t.scheme),await h.impl.delete(t,{recursive:!1,...c})):await n.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return v.e(h)}},async rename(t,c,h){try{return await n.a.$rename(t,c,{overwrite:!1,...h})}catch(i){return v.e(i)}},async copy(t,c,h){try{return await n.a.$copy(t,c,{overwrite:!1,...h})}catch(i){return v.e(i)}},isWritableFileSystem(t){const c=r.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}async d(o,r,n){const t=[];for(;!r.isEqual(n,r.dirname(n));)try{if(!((await o.stat(n)).type&T.FileType.Directory))throw A.$8N.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$al(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(r.basename(n)),n=r.dirname(n)}for(let c=t.length-1;c>=0;c--){n=r.joinPath(n,t[c]);try{await o.createDirectory(n)}catch(h){if(T.$al(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof A.$8N)throw o;if(o instanceof T.$9k)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw A.$8N.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw A.$8N.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw A.$8N.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw A.$8N.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw A.$8N.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw A.$8N.Unavailable(o.message);default:throw new A.$8N(o.message,o.name)}if(!(o instanceof Error))throw new A.$8N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw A.$8N.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw A.$8N.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw A.$8N.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw A.$8N.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw A.$8N.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw A.$8N.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw A.$8N.Unavailable(o.message);default:throw new A.$8N(o.message,o.name)}}addFileSystemProvider(o,r,n){return this.b.set(o,{impl:r,extUri:n?.isCaseSensitive?y.$Tg:y.$Vg,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Tg}};e.$Skc=m,e.$Skc=m=v=Je([Ve(0,p.$cP),Ve(1,g.$wkc)],m),e.$Tkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(Ae[85],Re([1,0,3,27,13,64,2]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=void 0,e.$Ukc=(0,I.$qi)("IExtensionStoragePaths");let p=class{constructor(k,N,y){this.d=N,this.f=y,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(k){return M.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,N=await this.g(k);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(M.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(k){if(this.c)return M.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return M.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Vkc=p,e.$Vkc=p=Je([Ve(0,T.$sP),Ve(1,A.$Wj),Ve(2,O.$Tkc)],p)}),define(Ae[249],Re([1,0,7,16,5]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;let O=class{constructor(p){this.a=new I.$fO(I.ColorThemeKind.Dark),this.b=new A.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let g;switch(p){case"light":g=I.ColorThemeKind.Light;break;case"hcDark":g=I.ColorThemeKind.HighContrast;break;case"hcLight":g=I.ColorThemeKind.HighContrastLight;break;default:g=I.ColorThemeKind.Dark}this.a=new I.$fO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$qmc=O,e.$qmc=O=Je([Ve(0,T.$cP)],O)}),define(Ae[86],Re([1,0,22,5,6,173,3,13,203,4,27,16,7]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OCb=e.$NCb=e.TunnelDtoConverter=void 0;class v extends g.$cw{}var m;(function(o){function r(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=r;function n(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==g.TunnelPrivacyId.ConstantPrivate&&t.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=n})(m||(e.TunnelDtoConverter=m={})),e.$NCb=(0,M.$qi)("IExtHostTunnelService");let s=class extends A.$Uc{constructor(r,n,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(k.$PM.MainThreadTunnelService)}async openTunnel(r,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const t=await this.a.$openTunnel(n,r.displayName);if(t){const c=new v(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,n){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:r,provider:n}),this.a.$registerPortsAttributesProvider(r,t),new u.$RM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(r,n,t,c,h){const i=[];for(const a of r){const $=this.r.get(a);if(!$)return[];i.push(...await Promise.all(n.map(async l=>{let S;try{S=await $.provider.providePortAttributes({port:l,pid:t,commandLine:c},h)}catch{S=await $.provider.providePortAttributes(l,t,c,h)}return{providedAttributes:S,port:l}})))}const b=i.filter(a=>!!a.providedAttributes);return b.length>0?b.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,I.CancellationToken.None)??void 0;const t=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,A.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,n){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const t=r.tunnelFactory??(n?this.w(n):void 0);if(t){this.b=t;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,A.$Sc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,n){if(this.g.has(r.host)){const t=this.g.get(r.host);t.has(r.port)&&(n&&t.get(r.port).disposeListener.dispose(),await t.get(r.port).tunnel.dispose(),t.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(r,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const c=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(r){const n=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),t=r.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${t.map(c=>c.port).join(", ")}`),t}};e.$OCb=s,e.$OCb=s=Je([Ve(0,y.$cP),Ve(1,N.$sP),Ve(2,p.$Wj)],s)}),define(Ae[8],Re([1,0,18,23,132,250,54,28,124,53,69,26,127,24,17,2,29,87,100,105,104,213,83,50,61,224,7]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_O=j,e.$aP=se,e.$bP=ce;var S;(function(we){function Se(Q){const{selectionStartLineNumber:De,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:qe}=Q,ut=new l.$SM(De-1,We-1),kt=new l.$SM(Ze-1,qe-1);return new l.$UM(ut,kt)}we.to=Se;function ae(Q){const{anchor:De,active:We}=Q;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}we.from=ae})(S||(e.Selection=S={}));var d;(function(we){function Se(Q){if(!Q)return;const{start:De,end:We}=Q;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}we.from=Se;function ae(Q){if(!Q)return;const{startLineNumber:De,startColumn:We,endLineNumber:Ze,endColumn:qe}=Q;return new l.$TM(De-1,We-1,Ze-1,qe-1)}we.to=ae})(d||(e.Range=d={}));var E;(function(we){function Se(Q){return{uri:Q.uri,range:d.from(Q.range)}}we.from=Se;function ae(Q){return new l.$4M(s.URI.revive(Q.uri),d.to(Q.range))}we.to=ae})(E||(e.Location=E={}));var f;(function(we){function Se(ae){switch(ae){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=Se})(f||(e.TokenType=f={}));var D;(function(we){function Se(Q){return new l.$SM(Q.lineNumber-1,Q.column-1)}we.to=Se;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=ae})(D||(e.Position=D={}));var w;(function(we){function Se(De,We,Ze){return(0,I.$Hb)((0,I.$3b)(De).map(qe=>ae(qe,We,Ze)))}we.from=Se;function ae(De,We,Ze){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Ze?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:Q(De.scheme,We),pattern:Z.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(De,We){return We&&typeof De=="string"?We.transformOutgoingScheme(De):De}})(w||(e.DocumentSelector=w={}));var C;(function(we){function Se(Q){switch(Q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=Se;function ae(Q){switch(Q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=ae})(C||(e.DiagnosticTag=C={}));var P;(function(we){function Se(Q){let De;return Q.code&&((0,m.$4f)(Q.code)||(0,m.$8f)(Q.code)?De=String(Q.code):De={value:String(Q.code.value),target:Q.code.target}),{...d.from(Q.range),message:Q.message,source:Q.source,code:De,severity:W.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(V.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(C.from)):void 0}}we.from=Se;function ae(Q){const De=new l.$6M(d.to(Q),Q.message,W.to(Q.severity));return De.source=Q.source,De.code=(0,m.$4f)(Q.code)?Q.code:Q.code?.value,De.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(V.to),De.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(C.to)),De}we.to=ae})(P||(e.Diagnostic=P={}));var V;(function(we){function Se(Q){return{...d.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Se;function ae(Q){return new l.$5M(new l.$4M(Q.resource,d.to(Q)),Q.message)}we.to=ae})(V||(e.DiagnosticRelatedInformation=V={}));var W;(function(we){function Se(Q){switch(Q){case l.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Se;function ae(Q){switch(Q){case n.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=ae})(W||(e.DiagnosticSeverity=W={}));var q;(function(we){function Se(Q){return typeof Q=="number"&&Q>=l.ViewColumn.One?Q-1:Q===l.ViewColumn.Beside?$.$ND:$.$MD}we.from=Se;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ae})(q||(e.ViewColumn=q={}));function R(we){return typeof we.range<"u"}function j(we){return we.length===0?!0:!!R(we[0])}var K;(function(we){function Se(qe){return qe.map(we.from)}we.fromMany=Se;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let ut;if(ae(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else l.$gN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ft=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:De(ri.query,kt)}),kt[ct]=ri}catch{}return""},Wt=new g.marked.Renderer;return Wt.link=Ft,Wt.image=ct=>typeof ct=="string"?Ft(M.$Vk(ct).href):"",(0,g.marked)(ut.value,{renderer:Wt}),ut}we.from=Q;function De(qe,ut){if(!qe)return qe;let kt;try{kt=(0,k.$Yh)(qe)}catch{}if(!kt)return qe;let Ft=!1;return kt=(0,y.$Yn)(kt,Wt=>{if(s.URI.isUri(Wt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Wt,Ft=!0,ct}else return}),Ft?JSON.stringify(kt):qe}function We(qe){const ut=new l.$gN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}we.to=We;function Ze(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ze})(K||(e.MarkdownString=K={}));function se(we){return j(we)?we.map(Se=>({range:d.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:d.from(Se)}))}function ce(we){return typeof we>"u"?we:typeof we=="string"?s.URI.file(we):we}var ve;(function(we){function Se(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ce(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}we.from=Se})(ve||(e.ThemableDecorationAttachmentRenderOptions=ve={}));var Ie;(function(we){function Se(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var ue;(function(we){function Se(ae){if(typeof ae>"u")return ae;switch(ae){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(ue||(e.DecorationRangeBehavior=ue={}));var be;(function(we){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?Ie.from(ae.light):void 0,dark:ae.dark?Ie.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ce(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ve.from(ae.before):void 0,after:ae.after?ve.from(ae.after):void 0}}we.from=Se})(be||(e.DecorationRenderOptions=be={}));var ie;(function(we){function Se(Q){return{text:Q.newText,eol:Q.newEol&&at.from(Q.newEol),range:d.from(Q.range)}}we.from=Se;function ae(Q){const De=new l.$YM(d.to(Q.range),Q.text);return De.newEol=typeof Q.eol>"u"?void 0:at.to(Q.eol),De}we.to=ae})(ie||(e.TextEdit=ie={}));var Pe;(function(we){function Se(Q,De){const We={edits:[]};if(Q instanceof l.$2M){const Ze=new p.$Cc;for(const qe of Q._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of Q._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,T.$We)(T.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:ie.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:d.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:De?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:De?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(jt.from)}})}return We}we.from=Se;function ae(Q){const De=new l.$2M,We=new p.$Bc;for(const Ze of Q.edits)if(Ze.textEdit){const qe=Ze,ut=s.URI.revive(qe.resource),kt=d.to(qe.textEdit.range),Ft=qe.textEdit.text,Wt=qe.textEdit.insertAsSnippet;let ct;Wt?ct=l.$1M.replace(kt,new l.$3M(Ft)):ct=l.$YM.replace(kt,Ft);const ri=We.get(ut);ri?ri.push(ct):We.set(ut,[ct])}else De.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of We)De.set(Ze,qe);return De}we.to=ae})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(we){const Se=Object.create(null);Se[l.SymbolKind.File]=0,Se[l.SymbolKind.Module]=1,Se[l.SymbolKind.Namespace]=2,Se[l.SymbolKind.Package]=3,Se[l.SymbolKind.Class]=4,Se[l.SymbolKind.Method]=5,Se[l.SymbolKind.Property]=6,Se[l.SymbolKind.Field]=7,Se[l.SymbolKind.Constructor]=8,Se[l.SymbolKind.Enum]=9,Se[l.SymbolKind.Interface]=10,Se[l.SymbolKind.Function]=11,Se[l.SymbolKind.Variable]=12,Se[l.SymbolKind.Constant]=13,Se[l.SymbolKind.String]=14,Se[l.SymbolKind.Number]=15,Se[l.SymbolKind.Boolean]=16,Se[l.SymbolKind.Array]=17,Se[l.SymbolKind.Object]=18,Se[l.SymbolKind.Key]=19,Se[l.SymbolKind.Null]=20,Se[l.SymbolKind.EnumMember]=21,Se[l.SymbolKind.Struct]=22,Se[l.SymbolKind.Event]=23,Se[l.SymbolKind.Operator]=24,Se[l.SymbolKind.TypeParameter]=25;function ae(De){return typeof Se[De]=="number"?Se[De]:6}we.from=ae;function Q(De){for(const We in Se)if(Se[We]===De)return Number(We);return l.SymbolKind.Property}we.to=Q})(Fe||(e.SymbolKind=Fe={}));var ne;(function(we){function Se(Q){switch(Q){case l.SymbolTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return l.SymbolTag.Deprecated}}we.to=ae})(ne||(e.SymbolTag=ne={}));var U;(function(we){function Se(Q){return{name:Q.name,kind:Fe.from(Q.kind),tags:Q.tags&&Q.tags.map(ne.from),containerName:Q.containerName,location:$e.from(Q.location)}}we.from=Se;function ae(Q){const De=new l.$0M(Q.name,Fe.to(Q.kind),Q.containerName,$e.to(Q.location));return De.tags=Q.tags&&Q.tags.map(ne.to),De}we.to=ae})(U||(e.WorkspaceSymbol=U={}));var x;(function(we){function Se(Q){const De={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),kind:Fe.from(Q.kind),tags:Q.tags?.map(ne.from)??[]};return Q.children&&(De.children=Q.children.map(Se)),De}we.from=Se;function ae(Q){const De=new l.$$M(Q.name,Q.detail,Fe.to(Q.kind),d.to(Q.range),d.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(De.tags=Q.tags.map(ne.to)),Q.children&&(De.children=Q.children.map(ae)),De}we.to=ae})(x||(e.DocumentSymbol=x={}));var pe;(function(we){function Se(Q){const De=new l.$cN(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),d.to(Q.range),d.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Se;function ae(Q,De,We){if(De=De??Q._sessionId,We=We??Q._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,name:Q.name,detail:Q.detail,kind:Fe.from(Q.kind),uri:Q.uri,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(pe||(e.CallHierarchyItem=pe={}));var Oe;(function(we){function Se(ae){return new l.$dN(pe.to(ae.from),ae.fromRanges.map(Q=>d.to(Q)))}we.to=Se})(Oe||(e.CallHierarchyIncomingCall=Oe={}));var ke;(function(we){function Se(ae){return new l.$eN(pe.to(ae.to),ae.fromRanges.map(Q=>d.to(Q)))}we.to=Se})(ke||(e.CallHierarchyOutgoingCall=ke={}));var $e;(function(we){function Se(Q){return{range:Q.range&&d.from(Q.range),uri:Q.uri}}we.from=Se;function ae(Q){return new l.$4M(s.URI.revive(Q.uri),d.to(Q.range))}we.to=ae})($e||(e.location=$e={}));var fe;(function(we){function Se(Q){const De=Q,We=Q;return{originSelectionRange:De.originSelectionRange?d.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:We.uri,range:d.from(De.targetRange?De.targetRange:We.range),targetSelectionRange:De.targetSelectionRange?d.from(De.targetSelectionRange):void 0}}we.from=Se;function ae(Q){return{targetUri:s.URI.revive(Q.uri),targetRange:d.to(Q.range),targetSelectionRange:Q.targetSelectionRange?d.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?d.to(Q.originSelectionRange):void 0}}we.to=ae})(fe||(e.DefinitionLink=fe={}));var J;(function(we){function Se(Q){return{range:d.from(Q.range),contents:K.fromMany(Q.contents)}}we.from=Se;function ae(Q){return new l.$7M(Q.contents.map(K.to),d.to(Q.range))}we.to=ae})(J||(e.Hover=J={}));var Y;(function(we){function Se(Q){return{range:d.from(Q.range),expression:Q.expression}}we.from=Se;function ae(Q){return new l.$2N(d.to(Q.range),Q.expression)}we.to=ae})(Y||(e.EvaluatableExpression=Y={}));var he;(function(we){function Se(Q){if(Q instanceof l.$3N)return{type:"text",range:d.from(Q.range),text:Q.text};if(Q instanceof l.$4N)return{type:"variable",range:d.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof l.$5N)return{type:"expression",range:d.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function ae(Q){switch(Q.type){case"text":return{range:d.to(Q.range),text:Q.text};case"variable":return{range:d.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:d.to(Q.range),expression:Q.expression}}}we.to=ae})(he||(e.InlineValue=he={}));var le;(function(we){function Se(Q){return{frameId:Q.frameId,stoppedLocation:d.from(Q.stoppedLocation)}}we.from=Se;function ae(Q){return new l.$6N(Q.frameId,d.to(Q.stoppedLocation))}we.to=ae})(le||(e.InlineValueContext=le={}));var Te;(function(we){function Se(Q){return{range:d.from(Q.range),kind:Q.kind}}we.from=Se;function ae(Q){return new l.$8M(d.to(Q.range),Q.kind)}we.to=ae})(Te||(e.DocumentHighlight=Te={}));var de;(function(we){function Se(Q){return{uri:Q.uri,highlights:Q.highlights.map(Te.from)}}we.from=Se;function ae(Q){return new l.$9M(s.URI.revive(Q.uri),Q.highlights.map(Te.to))}we.to=ae})(de||(e.MultiDocumentHighlight=de={}));var Ce;(function(we){function Se(ae){switch(ae){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=Se})(Ce||(e.CompletionTriggerKind=Ce={}));var Me;(function(we){function Se(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}we.to=Se})(Me||(e.CompletionContext=Me={}));var ze;(function(we){function Se(Q){switch(Q){case l.CompletionItemTag.Deprecated:return 1}}we.from=Se;function ae(Q){switch(Q){case 1:return l.CompletionItemTag.Deprecated}}we.to=ae})(ze||(e.CompletionItemTag=ze={}));var z;(function(we){const Se=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ae(We){return Se.get(We)??9}we.from=ae;const Q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function De(We){return Q.get(We)??l.CompletionItemKind.Property}we.to=De})(z||(e.CompletionItemKind=z={}));var L;(function(we){function Se(ae,Q){const De=new l.$mN(ae.label);return De.insertText=ae.insertText,De.kind=z.to(ae.kind),De.tags=ae.tags?.map(ze.to),De.detail=ae.detail,De.documentation=M.$Pk(ae.documentation)?K.to(ae.documentation):ae.documentation,De.sortText=ae.sortText,De.filterText=ae.filterText,De.preselect=ae.preselect,De.commitCharacters=ae.commitCharacters,o.$kt.isIRange(ae.range)?De.range=d.to(ae.range):typeof ae.range=="object"&&(De.range={inserting:d.to(ae.range.insert),replacing:d.to(ae.range.replace)}),De.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?De.insertText=new l.$3M(ae.insertText):(De.insertText=ae.insertText,De.textEdit=De.range instanceof l.$TM?new l.$YM(De.range,De.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(De.additionalTextEdits=ae.additionalTextEdits.map(We=>ie.to(We))),De.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,De}we.to=Se})(L||(e.CompletionItem=L={}));var G;(function(we){function Se(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:K.fromStrict(Q.documentation)}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation}}we.to=ae})(G||(e.ParameterInformation=G={}));var H;(function(we){function Se(Q){return{label:Q.label,documentation:K.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.from):[],activeParameter:Q.activeParameter}}we.from=Se;function ae(Q){return{label:Q.label,documentation:M.$Pk(Q.documentation)?K.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(G.to):[],activeParameter:Q.activeParameter}}we.to=ae})(H||(e.SignatureInformation=H={}));var ee;(function(we){function Se(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.from):[]}}we.from=Se;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.to):[]}}we.to=ae})(ee||(e.SignatureHelp=ee={}));var re;(function(we){function Se(ae,Q){const De=new l.$lN(D.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ne.to.bind(void 0,ae)),Q.kind&&Be.to(Q.kind));return De.textEdits=Q.textEdits&&Q.textEdits.map(ie.to),De.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,De.paddingLeft=Q.paddingLeft,De.paddingRight=Q.paddingRight,De}we.to=Se})(re||(e.InlayHint=re={}));var Ne;(function(we){function Se(ae,Q){const De=new l.$kN(Q.label);return De.tooltip=M.$Pk(Q.tooltip)?K.to(Q.tooltip):Q.tooltip,r.Command.is(Q.command)&&(De.command=ae.fromInternal(Q.command)),Q.location&&(De.location=$e.to(Q.location)),De}we.to=Se})(Ne||(e.InlayHintLabelPart=Ne={}));var Be;(function(we){function Se(Q){return Q}we.from=Se;function ae(Q){return Q}we.to=ae})(Be||(e.InlayHintKind=Be={}));var Qe;(function(we){function Se(Q){return{range:d.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Se;function ae(Q){let De;if(Q.url)try{De=typeof Q.url=="string"?s.URI.parse(Q.url,!0):s.URI.revive(Q.url)}catch{}return new l.$rN(d.to(Q.range),De)}we.to=ae})(Qe||(e.DocumentLink=Qe={}));var _e;(function(we){function Se(Q){const De=new l.$uN(Q.label);return Q.textEdit&&(De.textEdit=ie.to(Q.textEdit)),Q.additionalTextEdits&&(De.additionalTextEdits=Q.additionalTextEdits.map(We=>ie.to(We))),De}we.to=Se;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?ie.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(De=>ie.from(De)):void 0}}we.from=ae})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(Q){return new l.$sN(Q[0],Q[1],Q[2],Q[3])}we.to=Se;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=ae})(et||(e.Color=et={}));var tt;(function(we){function Se(Q){return{range:d.from(Q.range)}}we.from=Se;function ae(Q){return new l.$bN(d.to(Q.range))}we.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Se(ae){switch(ae){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(we){function Se(Q){switch(Q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.Interval:return 3;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function ae(Q){switch(Q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 3:return l.TextEditorLineNumbersStyle.Interval;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=ae})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(we){function Se(Q){if(Q===l.EndOfLine.CRLF)return 1;if(Q===l.EndOfLine.LF)return 0}we.from=Se;function ae(Q){if(Q===1)return l.EndOfLine.CRLF;if(Q===0)return l.EndOfLine.LF}we.to=ae})(at||(e.EndOfLine=at={}));var mt;(function(we){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(mt||(e.ProgressLocation=mt={}));var Ue;(function(we){function Se(Q){const De={start:Q.start+1,end:Q.end+1};return Q.kind&&(De.kind=st.from(Q.kind)),De}we.from=Se;function ae(Q){const De={start:Q.start-1,end:Q.end-1};return Q.kind&&(De.kind=st.to(Q.kind)),De}we.to=ae})(Ue||(e.FoldingRange=Ue={}));var st;(function(we){function Se(Q){if(Q)switch(Q){case l.FoldingRangeKind.Comment:return r.$6t.Comment;case l.FoldingRangeKind.Imports:return r.$6t.Imports;case l.FoldingRangeKind.Region:return r.$6t.Region}}we.from=Se;function ae(Q){if(Q)switch(Q.value){case r.$6t.Comment.value:return l.FoldingRangeKind.Comment;case r.$6t.Imports.value:return l.FoldingRangeKind.Imports;case r.$6t.Region.value:return l.FoldingRangeKind.Region}}we.to=ae})(st||(e.FoldingRangeKind=st={}));var X;(function(we){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?d.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.$dF.id:void 0}}we.from=Se})(X||(e.TextEditorOpenOptions=X={}));var Z;(function(we){function Se(We){return We instanceof l.$PN?We.toJSON():typeof We=="string"?We:ae(We)||Q(We)?new l.$PN(We.baseUri??We.base,We.pattern).toJSON():We}we.from=Se;function ae(We){const Ze=We;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function De(We){return typeof We=="string"?We:new l.$PN(s.URI.revive(We.baseUri),We.pattern)}we.to=De})(Z||(e.GlobPattern=Z={}));var me;(function(we){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:Z.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Se})(me||(e.LanguageSelector=me={}));var He;(function(we){function Se(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(De=>Array.isArray(De)&&De.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof l.$TM)))}we.is=Se;function ae(Q){return{documents:Q.documents.map(De=>De.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>d.from(Ze))})))}}we.from=ae})(He||(e.MappedEditsContext=He={}));var ye;(function(we){function Se(Q){return{start:Q.start,end:Q.end}}we.from=Se;function ae(Q){return new l.$gO(Q.start,Q.end)}we.to=ae})(ye||(e.NotebookRange=ye={}));var ot;(function(we){function Se(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Se;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=ae})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(we){function Se(ae){if(ae===i.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(ae===i.NotebookCellExecutionState.Pending)return;if(ae===i.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}we.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(we){function Se(Q){switch(Q){case l.NotebookCellKind.Markup:return i.CellKind.Markup;case l.NotebookCellKind.Code:default:return i.CellKind.Code}}we.from=Se;function ae(Q){switch(Q){case i.CellKind.Markup:return l.NotebookCellKind.Markup;case i.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=ae})(It||(e.NotebookCellKind=It={}));var Qt;(function(we){function Se(Q){const De={metadata:Q.metadata??Object.create(null),cells:[]};for(const We of Q.cells)l.$hO.validate(We),De.cells.push(jt.from(We));return De}we.from=Se;function ae(Q){const De=new l.$iO(Q.cells.map(jt.to));return(0,m.$eg)(Q.metadata)||(De.metadata=Q.metadata),De}we.to=ae})(Qt||(e.NotebookData=Qt={}));var jt;(function(we){function Se(Q){return{cellKind:It.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ot.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_t.from):[]}}we.from=Se;function ae(Q){return new l.$hO(It.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_t.to):void 0,Q.metadata,Q.internalMetadata?ot.to(Q.internalMetadata):void 0)}we.to=ae})(jt||(e.NotebookCellData=jt={}));var xt;(function(we){function Se(Q){return{mime:Q.mime,valueBytes:T.$Ce.wrap(Q.data)}}we.from=Se;function ae(Q){return new l.$jO(Q.valueBytes.buffer,Q.mime)}we.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(we){function Se(Q){return{outputId:Q.id,items:Q.items.map(xt.from),metadata:Q.metadata}}we.from=Se;function ae(Q){const De=Q.items.map(xt.to);return new l.$kO(De,Q.outputId,Q.metadata)}we.to=ae})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(we){function Se(De){return Q(De)?{include:Z.from(De.include)??void 0,exclude:Z.from(De.exclude)??void 0}:Z.from(De)??void 0}we.from=Se;function ae(De){return Q(De)?{include:Z.to(De.include),exclude:Z.to(De.exclude)}:Z.to(De)}we.to=ae;function Q(De){const We=De;return We?!(0,m.$ag)(We.include)&&!(0,m.$ag)(We.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Vt;(function(we){function Se(ae,Q,De){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(We,De),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}we.from=Se})(Vt||(e.NotebookStatusBarItem=Vt={}));var Zt;(function(we){function Se(ae,Q,De){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Q.toInternal(We,De),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(Zt||(e.NotebookKernelSourceAction=Zt={}));var Xe;(function(we){function Se(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}we.from=Se})(Xe||(e.NotebookDocumentContentOptions=Xe={}));var si;(function(we){function Se(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Se;function ae(Q){return new l.$mO(s.URI.revive(Q.uri),Q.provides)}we.to=ae})(si||(e.NotebookRendererScript=si={}));var Xt;(function(we){function Se(Q){return{message:K.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:d.from(Q.location.range),uri:Q.location.uri}}}we.from=Se;function ae(Q){const De=new l.$sO(typeof Q.message=="string"?Q.message:K.to(Q.message));return De.actualOutput=Q.actual,De.expectedOutput=Q.expected,De.contextValue=Q.contextValue,De.location=Q.location?$e.to(Q.location):void 0,De}we.to=ae})(Xt||(e.TestMessage=Xt={}));var lt;(function(we){we.namespace=a.$GL,we.denamespace=a.$HL})(lt||(e.TestTag=lt={}));var vt;(function(we){function Se(Q){const De=(0,t.$$O)(Q).controllerId;return{extId:b.$BL.fromExtHostTestItem(Q,De).toString(),label:Q.label,uri:s.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(We=>lt.namespace(De,We.id)),range:o.$kt.lift(d.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&K.fromStrict(Q.error)||null}}we.from=Se;function ae(Q){return{parent:void 0,error:void 0,id:b.$BL.fromString(Q.extId).localId,label:Q.label,uri:s.URI.revive(Q.uri),tags:(Q.tags||[]).map(De=>{const{tagId:We}=lt.denamespace(De);return new l.$tO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=ae})(vt||(e.TestItem=vt={})),function(we){function Se(Q){return{id:Q.id}}we.from=Se;function ae(Q){return new l.$tO(Q.id)}we.to=ae}(lt||(e.TestTag=lt={}));var ti;(function(we){const Se=(Q,De)=>{const We=Q.value;if(!We)return;const Ze={...vt.toPlain(We.item),parent:De,taskStates:We.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Xt.to)})),children:[]};if(Q.children)for(const qe of Q.children.values()){const ut=Se(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(Q){const De=new u.$4O;for(const qe of Q.items)De.insert(b.$BL.fromString(qe.item.extId).path,qe);const We=[De.nodes],Ze=[];for(;We.length;)for(const qe of We.pop())qe.value?Ze.push(qe):qe.children&&We.push(qe.children.values());return{completedAt:Q.completedAt,results:Ze.map(qe=>Se(qe)).filter(m.$_f)}}we.to=ae})(ti||(e.TestResults=ti={}));var Yt;(function(we){function Se(We){return{covered:We.covered,total:We.total}}function ae(We){return"line"in We?D.from(We):d.from(We)}function Q(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ae(We.location)}}we.fromDetails=Q;function De(We,Ze){return l.$vO(Ze.statementCoverage),l.$vO(Ze.branchCoverage),l.$vO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Se(Ze.statementCoverage),branch:Ze.branchCoverage&&Se(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Se(Ze.declarationCoverage)}}we.fromFile=De})(Yt||(e.TestCoverage=Yt={}));var Lt;(function(we){function Se(ae){switch(ae){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(we){function Se(Q){const De=new l.$AO(Fe.to(Q.kind),Q.name,Q.detail||"",s.URI.revive(Q.uri),d.to(Q.range),d.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Se;function ae(Q,De,We){if(De=De??Q._sessionId,We=We??Q._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,kind:Fe.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:d.from(Q.range),selectionRange:d.from(Q.selectionRange),tags:Q.tags?.map(ne.from)}}we.from=ae})(ft||(e.TypeHierarchyItem=ft={}));var Ut;(function(we){function Se(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}we.from=Se})(Ut||(e.ViewBadge=Ut={}));var Bt;(function(we){function Se(We,Ze,qe){const ut=Ze.fileData;return ut?new l.$HN(new l.$IN(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):We===N.$Hs.uriList&&Ze.uriListData?new l.$GN(De(Ze.uriListData)):new l.$GN(Ze.asString)}we.to=Se;async function ae(We,Ze){const qe=await Ze.asString();if(We===N.$Hs.uriList)return{asString:qe,fileData:void 0,uriListData:Q(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=ae;function Q(We){return A.$Kt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function De(We){return A.$Kt.create(We.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(we){function Se(Q,De){const We=Q.items.map(([Ze,qe])=>[Ze,Bt.to(Ze,qe,De)]);return new l.$JN(We)}we.toDataTransfer=Se;async function ae(Q){const De={items:[]},We=[];for(const[Ze,qe]of Q)We.push((async()=>{De.items.push([Ze,await Bt.from(Ze,qe)])})());return await Promise.all(We),De}we.from=ae})(qt||(e.DataTransfer=qt={}));var Ge;(function(we){function Se(Q,De){return{kind:"reply",agentId:Q.participant??De?.agentId??"",subCommand:Q.command??De?.command,message:Q.prompt,title:Q.label}}we.from=Se;function ae(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=ae})(Ge||(e.ChatFollowup=Ge={}));var ui;(function(we){function Se(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}we.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Ht;(function(we){function Se(Q){switch(Q.role){case 0:return new l.$YO(Q.content);case 1:return new l.$ZO(Q.content);case 2:return new l.$1O(Q.content)}}we.to=Se;function ae(Q){if(Q instanceof l.$YO)return{role:0,content:Q.content};if(Q instanceof l.$ZO)return{role:1,content:Q.content};if(Q instanceof l.$1O)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=ae})(Ht||(e.LanguageModelMessage=Ht={}));var zt;(function(we){function Se(De){const We={};for(const Ze of Object.keys(De))We[Ze]=De[Ze].map(we.to);return We}we.objectTo=Se;function ae(De){return{level:gt.to(De.level),kind:De.kind,value:(0,s.$wc)(De.value)?s.URI.revive(De.value):De.value,description:De.description}}we.to=ae;function Q(De){return{level:gt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=Q})(zt||(e.ChatVariable=zt={}));var gt;(function(we){function Se(Q){switch(Q){case"short":return l.ChatVariableLevel.Short;case"medium":return l.ChatVariableLevel.Medium;case"full":default:return l.ChatVariableLevel.Full}}we.to=Se;function ae(Q){switch(Q){case l.ChatVariableLevel.Short:return"short";case l.ChatVariableLevel.Medium:return"medium";case l.ChatVariableLevel.Full:default:return"full"}}we.from=ae})(gt||(e.ChatVariableLevel=gt={}));var Nt;(function(we){function Se(ae){switch(ae){case 1:return l.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return l.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return l.InteractiveEditorResponseFeedbackKind.Undone;case 3:return l.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return l.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var At;(function(we){function Se(Q){return{kind:"markdownContent",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new l.$NO(K.to(Q.content))}we.to=ae})(At||(e.ChatResponseMarkdownPart=At={}));var Ot;(function(we){function Se(Q){return{kind:"markdownVuln",content:K.from(Q.value),vulnerabilities:Q.vulnerabilities}}we.from=Se;function ae(Q){return new l.$OO(K.to(Q.content),Q.vulnerabilities)}we.to=ae})(Ot||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ot={}));var ii;(function(we){function Se(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}we.from=Se;function ae(Q){return new l.$PO(Q.agentId,Q.command)}we.to=ae})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Gt;(function(we){function Se(Q){const{value:De,baseUri:We}=Q;function Ze(qe,ut){return qe.map(kt=>{const Ft=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ft,children:kt.children&&Ze(kt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,v.$1g)(We),uri:We,children:Ze(De,We)}}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q.treeData);function We(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&We(kt.children)}))}const Ze=De.uri,qe=De.children?We(De.children):[];return new l.$QO(qe,Ze)}we.to=ae})(Gt||(e.ChatResponseFilesPart=Gt={}));var ni;(function(we){function Se(Q){return{kind:"inlineReference",name:Q.title,inlineReference:s.URI.isUri(Q.value)?Q.value:E.from(Q.value)}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q);return new l.$RO(s.URI.isUri(De.inlineReference)?De.inlineReference:E.to(De.inlineReference),Q.name)}we.to=ae})(ni||(e.ChatResponseAnchorPart=ni={}));var Mt;(function(we){function Se(Q){return{kind:"progressMessage",content:K.from(Q.value)}}we.from=Se;function ae(Q){return new l.$SO(Q.content.value)}we.to=ae})(Mt||(e.ChatResponseProgressPart=Mt={}));var Tt;(function(we){function Se(Q,De,We){return{kind:"command",command:De.toInternal(Q.value,We)??{command:Q.value.command,title:Q.value.title}}}we.from=Se;function ae(Q,De){return new l.$TO(De.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.to=ae})(Tt||(e.ChatResponseCommandButtonPart=Tt={}));var Ct;(function(we){function Se(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(De=>ie.from(De))}}we.from=Se;function ae(Q){return new l.$VO(s.URI.revive(Q.uri),Q.edits.map(De=>ie.to(De)))}we.to=ae})(Ct||(e.ChatResponseTextEditPart=Ct={}));var Et;(function(we){function Se(Q){return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:s.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:E.from(Q.value.value)}}:{kind:"reference",reference:s.URI.isUri(Q.value)?Q.value:E.from(Q.value)}}we.from=Se;function ae(Q){const De=(0,k.$Zh)(Q),We=Ze=>s.URI.isUri(Ze)?Ze:E.to(Ze);return new l.$UO("variableName"in De.reference?{variableName:De.reference.variableName,value:De.reference.value&&We(De.reference.value)}:We(De.reference))}we.to=ae})(Et||(e.ChatResponseReferencePart=Et={}));var pt;(function(we){function Se(De,We,Ze){return De instanceof l.$NO?At.from(De):De instanceof l.$RO?ni.from(De):De instanceof l.$UO?Et.from(De):De instanceof l.$SO?Mt.from(De):De instanceof l.$QO?Gt.from(De):De instanceof l.$TO?Tt.from(De,We,Ze):De instanceof l.$VO?Ct.from(De):De instanceof l.$OO?Ot.from(De):De instanceof l.$PO?ii.from(De):{kind:"markdownContent",content:K.from("")}}we.from=Se;function ae(De,We){switch(De.kind){case"reference":return Et.to(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(De,We)}}we.to=ae;function Q(De,We){switch(De.kind){case"markdownContent":return At.to(De);case"inlineReference":return ni.to(De);case"progressMessage":return;case"treeData":return Gt.to(De);case"command":return Tt.to(De,We)}}we.toContent=Q})(pt||(e.ChatResponsePart=pt={}));var St;(function(we){function Se(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(Dt.to),location:li.to(ae.location)}}we.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Se(ae){switch(ae){case h.ChatAgentLocation.Notebook:return l.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return l.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return l.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return l.ChatLocation.Editor}}we.to=Se})(li||(e.ChatLocation=li={}));var Dt;(function(we){function Se(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(zt.to)}}we.to=Se})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var hi;(function(we){function Se(ae){return{label:ae.label,values:ae.values.map(zt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}we.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(we){function Se(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}we.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var vi;(function(we){function Se(ae,Q,De){if(Q.action.kind==="vote")return;const We=Kt.to(ae);if(Q.action.kind==="command"){const Ze=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:De.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ge.to(Q.action.followup)},result:We}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:We}:{action:Q.action,result:We}}we.to=Se})(vi||(e.ChatAgentUserActionEvent=vi={}));var ei;(function(we){function Se(ae,Q,De){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Q.toInternal(ae,De)}we.from=Se})(ei||(e.TerminalQuickFix=ei={}));var wi;(function(we){function Se(ae){return{kind:yt.to(ae.kind)}}we.to=Se})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(we){function Se(ae){switch(ae){case 0:return l.PartialAcceptTriggerKind.Word;case 1:return l.PartialAcceptTriggerKind.Line;case 2:return l.PartialAcceptTriggerKind.Suggest;default:return l.PartialAcceptTriggerKind.Unknown}}we.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(we){function Se(ae,Q){return{id:Q,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}we.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Ae[251],Re([1,0,4,16,8,34]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;let M=class{constructor(g,k){this.a=g.getProxy(I.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>k.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,k,N){const y=new O.$lw(A.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,N?.isRefactoring??!1)}};e.$Ekc=M,e.$Ekc=M=Je([Ve(0,T.$cP)],M)}),define(Ae[252],Re([1,0,18,11,43,5,40,6,65,17,2,20,4,8,7,214,25]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class r{constructor(h,i,b,a,$){this.i=h,this.j=i,this.k=b,this.l=a,this.m=$,this.b=g.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(h.c){const $=new Error("Response stream has been closed");throw Error.captureStackTrace($,a),$}};const h=this;this.b.reset();const b=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,a)};this.g={markdown(a){i(this.markdown);const $=new m.$NO(a),l=v.ChatResponseMarkdownPart.from($);return b(l),this},markdownWithVulnerabilities(a,$){i(this.markdown),$&&(0,o.$xG)(h.i,"chatParticipantAdditions");const l=new m.$OO(a,$),S=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(l);return b(S),this},filetree(a,$){i(this.filetree);const l=new m.$QO(a,$),S=v.ChatResponseFilesPart.from(l);return b(S),this},anchor(a,$){i(this.anchor);const l=new m.$RO(a,$),S=v.ChatResponseAnchorPart.from(l);return b(S),this},button(a){i(this.anchor);const $=new m.$TO(a),l=v.ChatResponseCommandButtonPart.from($,h.l,h.m);return b(l),this},progress(a){i(this.progress);const $=new m.$SO(a),l=v.ChatResponseProgressPart.from($);return b(l),this},reference(a){if(i(this.reference),"variableName"in a&&!a.value){const $=h.j.variables.variables.find(l=>l.name===a.variableName);if($){let l;if($.references?.length)l=$.references.map(S=>({kind:"reference",reference:{variableName:a.variableName,value:S.reference}}));else{const S=new m.$UO(a);l=[v.ChatResponseReferencePart.from(S)]}return l.forEach(S=>b(S)),this}}else{const $=new m.$UO(a),l=v.ChatResponseReferencePart.from($);b(l)}return this},textEdit(a,$){i(this.textEdit),(0,o.$xG)(h.i,"chatParticipantAdditions");const l=new m.$VO(a,$),S=v.ChatResponseTextEditPart.from(l);return b(S),this},detectedParticipant(a,$){i(this.detectedParticipant),(0,o.$xG)(h.i,"chatParticipantAdditions");const l=new m.$PO(a,$),S=v.ChatResponseDetectedParticipantPart.from(l);return b(S),this},push(a){if(i(this.push),(a instanceof m.$VO||a instanceof m.$OO||a instanceof m.$PO)&&(0,o.$xG)(h.i,"chatParticipantAdditions"),a instanceof m.$UO)this.reference(a.value);else{const $=v.ChatResponsePart.from(a,h.l,h.m);b($)}return this}}}return this.g}}class n{static{this.b=0}constructor(h,i,b){this.i=i,this.j=b,this.c=new Map,this.g=new p.$4c,this.d=h.getProxy(u.$PM.MainThreadChatAgents2)}transferActiveChat(h){this.d.$transferActiveChatSession(h)}createChatAgent(h,i,b){const a=n.b++,$=new t(h,i,this.d,a,b);return this.c.set(a,$),this.d.$registerAgent(a,h.identifier,i,{},void 0),$.apiAgent}createDynamicChatAgent(h,i,b,a,$){const l=n.b++,S=new t(h,i,this.d,l,$);return this.c.set(l,S),this.d.$registerAgent(l,h.identifier,i,{isSticky:!0},{name:b,description:a}),S.apiAgent}async $invokeAgent(h,i,b,a){const $=this.c.get(h);if(!$)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let l=this.g.get(i.sessionId);l||(l=new p.$Tc,this.g.set(i.sessionId,l));const S=new r($.extension,i,this.d,this.j.converter,l);try{const d=await this.k(i.agentId,b),E=$.invoke(v.ChatAgentRequest.to(i),{history:d},S.apiObject,a);return await(0,T.$eh)(Promise.resolve(E).then(f=>{if(f?.metadata)try{JSON.stringify(f.metadata)}catch(D){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.i.error(`[${$.extension.identifier.value}] [@${$.id}] ${w}`,$.extension),{errorDetails:{message:w},timings:S.timings}}return{errorDetails:f?.errorDetails,timings:S.timings,metadata:f?.metadata}}),a)}catch(d){return this.i.error(d,$.extension),{errorDetails:{message:(0,A.$bj)(d),responseIsIncomplete:!0}}}finally{S.close()}}async k(h,i){const b=[];for(const a of i.history){const $=v.ChatAgentResult.to(a.result),l=h===a.request.agentId?$:{...$,metadata:void 0};b.push(new m.$WO(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),a.request.agentId));const S=(0,I.$Hb)(a.response.map(d=>v.ChatResponsePart.toContent(d,this.j.converter)));b.push(new m.$XO(S,l,a.request.agentId,a.request.command))}return b}$releaseSession(h){this.g.deleteAndDispose(h)}async $provideFollowups(h,i,b,a,$){const l=this.c.get(i);if(!l)return Promise.resolve([]);const S=await this.k(l.id,a),d=v.ChatAgentResult.to(b);return(await l.provideFollowups(d,{history:S},$)).filter(E=>{const f=!E.participant||M.Iterable.some(this.c.values(),D=>D.id===E.participant&&y.$Lm.equals(D.extension.identifier,l.extension.identifier));return f||this.i.warn(`[@${l.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),f}).map(E=>v.ChatFollowup.from(E,h))}$acceptFeedback(h,i,b,a){const $=this.c.get(h);if(!$)return;const l=v.ChatAgentResult.to(i);let S;switch(b){case s.InteractiveSessionVoteDirection.Down:S=m.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:S=m.ChatResultFeedbackKind.Helpful;break}$.acceptFeedback(Object.freeze(a?{result:l,kind:S,reportIssue:a}:{result:l,kind:S}))}$acceptAction(h,i,b){const a=this.c.get(h);if(!a||b.action.kind==="vote")return;const $=v.ChatAgentUserActionEvent.to(i,b,this.j.converter);$&&a.acceptAction(Object.freeze($))}async $invokeCompletionProvider(h,i,b){const a=this.c.get(h);return a?(await a.invokeCompletionProvider(i,b)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(h,i,b){const a=this.c.get(h);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(i),b)}async $provideSampleQuestions(h,i,b){const a=this.c.get(h);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(i),b)).map($=>v.ChatFollowup.from($,void 0))}}e.$Fkc=n;class t{constructor(h,i,b,a,$){this.extension=h,this.id=i,this.t=b,this.u=a,this.w=$,this.m=new O.$be,this.n=new O.$be}acceptFeedback(h){this.m.fire(h)}acceptAction(h){this.n.fire(h)}async invokeCompletionProvider(h,i){return this.p?await this.p.provider.provideCompletionItems(h,i)??[]:[]}async provideFollowups(h,i,b){if(!this.b)return[];const a=await this.b.provideFollowups(h,i,b);return a?a.filter($=>!($&&"commandId"in $)).filter($=>!($&&"message"in $)):[]}async provideWelcomeMessage(h,i){if(!this.q)return[];const b=await this.q.provideWelcomeMessage(h,i);return b?b.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(h,i){if(!this.q||!this.q.provideSampleQuestions)return[];const b=await this.q.provideSampleQuestions(h,i);return b||[]}get apiAgent(){let h=!1,i=!1;const b=()=>{h||i||(i=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{fullName:this.c,icon:this.d?this.d instanceof N.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.s}),i=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.c=$,b()},get iconPath(){return a.d},set iconPath($){a.d=$,b()},get requestHandler(){return a.w},set requestHandler($){(0,k.$bg)(typeof $=="function","Invalid request handler"),a.w=$},get followupProvider(){return a.b},set followupProvider($){a.b=$,b()},get isDefault(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.g},set isDefault($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.g=$,b()},get helpTextPrefix(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.i},set helpTextPrefix($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.i=$,b()},get helpTextVariablesPrefix(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.j=$,b()},get helpTextPostfix(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.k=$,b()},get isSecondary(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.l=$,b()},get supportIssueReporting(){return(0,o.$xG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting($){(0,o.$xG)(a.extension,"chatParticipantAdditions"),a.o=$,b()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider($){if((0,o.$xG)(a.extension,"chatParticipantAdditions"),a.p=$,$){if(!$.triggerCharacters.length)throw new Error("triggerCharacters are required");a.t.$registerAgentCompletionsProvider(a.u,$.triggerCharacters)}else a.t.$unregisterAgentCompletionsProvider(a.u)},get participantVariableProvider(){return(0,o.$xG)(a.extension,"chatParticipantAdditions"),a.p},set welcomeMessageProvider($){(0,o.$xG)(a.extension,"defaultChatParticipant"),a.q=$,b()},get welcomeMessageProvider(){return(0,o.$xG)(a.extension,"defaultChatParticipant"),a.q},onDidPerformAction:(0,o.$wG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester($){a.s=$,b()},get requester(){return a.s},dispose(){h=!0,a.b=void 0,a.m.dispose(),a.t.$unregisterAgent(a.u)}}}invoke(h,i,b,a){return this.w(h,i,b,a)}}}),define(Ae[253],Re([1,0,14,6,4,8,7,25]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class g{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(A.$PM.MainThreadChatVariables)}async $resolveVariable(y,u,v,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$xG)(s.extension,"chatParticipantAdditions");const o=new k(u,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:v},o.apiObject,m);if(r)return r.map(O.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:v},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(y,u,v,m){const s=g.a++;return this.b.set(s,{extension:y,data:{name:u,description:v},resolver:m}),this.c.$registerVariable(s,{name:u,description:v}),(0,T.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Gkc=g;class k{constructor(y,u){this.c=y,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,v=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){u(this.progress);const s=new M.$SO(m),o=O.ChatResponseProgressPart.from(s);return v(o),this},reference(m){u(this.reference);const s=new M.$UO(m),o=O.ChatResponseReferencePart.from(s);return v(o),this},push(m){return u(this.push),m instanceof M.$UO?v(O.ChatResponseReferencePart.from(m)):m instanceof M.$SO&&v(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Ae[254],Re([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=v;function v(m,s,o){const r=m.getProxy(y.$PM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Nm,s.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const E=this.b.get(d.handle);return E?E.value:d}else if(d&&d.$mid===7){const E=d,f=this.b.get(E.commentControlHandle);if(!f)return E;const D=f.getCommentThread(E.commentThreadHandle);return D?D.value:E}else if(d&&(d.$mid===9||d.$mid===8)){const E=this.b.get(d.thread.commentControlHandle);if(!E)return d;const f=E.getCommentThread(d.thread.commentThreadHandle);return f?d.$mid===8?f.value:{thread:f.value,text:d.text}:d}else if(d&&d.$mid===10){const E=this.b.get(d.thread.commentControlHandle);if(!E)return d;const f=E.getCommentThread(d.thread.commentThreadHandle);if(!f)return d;const D=d.commentUniqueId,w=f.getCommentByUniqueId(D);return w||d}else if(d&&d.$mid===11){const E=this.b.get(d.thread.commentControlHandle);if(!E)return d;const f=E.getCommentThread(d.thread.commentThreadHandle);if(!f)return d;const D=d.text,w=d.commentUniqueId,C=f.getCommentByUniqueId(w);return C?(typeof C.body=="string"?C.body=D:C.body=new N.$gN(D),C):d}return d}})}createCommentController(d,E,f){const D=n.a++,w=new c(d,D,E,f);this.b.set(w.handle,w);const C=this.c.get(d.identifier)||[];return C.push(w),this.c.set(d.identifier,C),w.value}async $createCommentThreadTemplate(d,E,f){const D=this.b.get(d);D&&D.$createCommentThreadTemplate(E,f)}async $setActiveComment(d,E){const f=this.b.get(d);f&&f.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(d,E,f){const D=this.b.get(d);D&&D.$updateCommentThreadTemplate(E,f)}$deleteCommentThread(d,E){this.b.get(d)?.$deleteCommentThread(E)}async $provideCommentingRanges(d,E,f){const D=this.b.get(d);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const w=await o.ensureDocumentData(M.URI.revive(E));return(0,I.$ih)(async()=>{const C=await D.commentingRangeProvider.provideCommentingRanges(w.document,f);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(V=>k.Range.from(V)),fileComments:C.fileComments}),P})}$toggleReaction(d,E,f,D,w){const C=this.b.get(d);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$ih)(()=>{const P=C.getCommentThread(E);if(P){const V=P.getCommentByUniqueId(D.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,b(w))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,typeof d=="object"?((0,u.$xG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=d.resolved,this.b.applicability=d.applicability):this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,E,f,D,w,C,P,V){this.m=E,this.n=f,this.o=D,this.p=w,this.q=C,this.extensionDescription=P,this.r=V,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(E,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{r.$deleteCommentThread(E,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const d=f=>Object.prototype.hasOwnProperty.call(this.b,f),E={};d("range")&&(E.range=k.Range.from(this.p)),d("label")&&(E.label=this.label),d("contextValue")&&(E.contextValue=this.contextValue??null),d("comments")&&(E.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),d("collapsibleState")&&(E.collapseState=a(this.g)),d("canReply")&&(E.canReply=this.canReply),d("state")&&(E.state=$(this.h)),d("applicability")&&(E.applicability=l(this.h)),d("isTemplate")&&(E.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(d){for(const E of this.k){const f=E[0],D=E[1];if(d===D)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,T.$Vh)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,u.$xG)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$xG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$xG)(this.h,"activeComment"),this.f}constructor(d,E,f,D){this.h=d,this.i=E,this.j=f,this.k=D,this.a=new Map,r.$registerCommentController(this.handle,f,D,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(C){w.options=C},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(C){w.commentingRangeProvider=C},get reactionHandler(){return w.reactionHandler},set reactionHandler(C){w.reactionHandler=C},get activeCommentThread(){return w.activeCommentThread},createCommentThread(C,P,V){return w.createCommentThread(C,P,V).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,E,f){E===void 0&&(0,u.$xG)(this.h,"fileComments");const D=new t(this.id,this.handle,void 0,d,E,f,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const E=this.a.get(d.commentThreadHandle);E&&(this.e=d.uniqueIdInThread?E.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(d,E){const f=new t(this.id,this.handle,void 0,M.URI.revive(d),k.Range.to(E),[],this.h,!0);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(d,E){const f=this.a.get(d);f&&(f.range=k.Range.to(E))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function h(S,d,E,f){let D=E.get(d);return D||(D=++S.commentHandle,E.set(d,D)),d.state!==void 0&&(0,u.$xG)(f,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,u.$xG)(f,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:D,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>i(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function i(S){return{label:S.label,iconPath:S.iconPath?k.$bP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(d=>d.name):S.reactors}}function b(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(d=>({name:d}))}}function a(S){if(S!==void 0)switch(S){case N.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(S){let d;if(typeof S=="object"?d=S.resolved:d=S,d!==void 0)switch(d){case N.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function l(S){let d;if(typeof S=="object"&&(d=S.applicability),d!==void 0)switch(d){case N.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ae[255],Re([1,0,22,99,6,12,24,2,8,63,74,4,7]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0;class v{constructor(b,a){this.document=b,this.b=a,this.a=1,this.c=new N.$qkc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,a){await this.f(b).undo(),a||this.disposeBackup()}async redo(b,a){await this.f(b).redo(),a||this.disposeBackup()}disposeEdits(b){for(const a of b)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=h(this.document.uri)+this.a++;return(0,M.$4g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const a=this.c.get(b,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get(b,a){return this.a.get(this.b(b,a))}add(b,a,$){const l=this.b(b,a.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${b} resource:${a.uri}`);const S=new v(a,$);return this.a.set(l,S),S}delete(b,a){const $=this.b(b,a.uri);this.a.delete($)}b(b,a){return`${b}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(b,a,$){return this.b(0,b,a,$)}addCustomProvider(b,a,$){return this.b(1,b,a,$)}get(b){return this.a.get(b)}b(b,a,$,l){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:b,extension:$,provider:l}),new u.$RM(()=>this.a.delete(a))}}class r{constructor(b,a,$,l,S){this.d=a,this.f=$,this.g=l,this.h=S,this.b=new o,this.c=new m,this.a=b.getProxy(y.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(b,a,$,l){const S=new A.$Tc;return t($)?(S.add(this.b.addTextProvider(a,b,$)),this.a.$registerTextEditorProvider((0,k.$Zkc)(b),a,l.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,k.$Xkc)(b))):(S.add(this.b.addCustomProvider(a,b,$)),n($)&&S.add($.onDidChangeCustomDocument(d=>{const E=this.i(a,d.document.uri);if(c(d)){const f=E.addEdit(d);this.a.$onDidEdit(d.document.uri,a,f,d.label)}else this.a.$onContentChange(d.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.$Zkc)(b),a,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.$Xkc)(b))),u.$RM.from(S,new u.$RM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(b,a,$,l,S){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${a}'`);const E=p.URI.revive(b),f=await d.provider.openCustomDocument(E,{backupId:$,untitledDocumentData:l?.buffer},S);let D;return n(d.provider)&&this.f&&(D=this.f.workspaceValue(d.extension)??this.f.globalValue(d.extension)),this.c.add(a,f,D),{editable:n(d.provider)}}async $disposeCustomDocument(b,a){const $=this.b.get(a);if(!$)throw new Error(`No provider found for '${a}'`);if($.type!==1)throw new Error(`Invalid provider type for '${a}'`);const l=p.URI.revive(b),{document:S}=this.i(a,l);this.c.delete(a,S),S.dispose()}async $resolveCustomEditor(b,a,$,l,S,d){const E=this.b.get($);if(!E)throw new Error(`No provider found for '${$}'`);const f=g.ViewColumn.to(S),D=this.g.createNewWebview(a,l.contentOptions,E.extension),w=this.h.createNewWebviewPanel(a,$,l.title,f,l.options,D,l.active),C=p.URI.revive(b);switch(E.type){case 1:{const{document:P}=this.i($,C);return E.provider.resolveCustomEditor(P,w,d)}case 0:{const P=this.d.getDocument(C);return E.provider.resolveCustomTextEditor(P,w,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,a,$){this.i(a,b).disposeEdits($)}async $onMoveCustomEditor(b,a,$){const l=this.b.get($);if(!l)throw new Error(`No provider found for '${$}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const S=this.h.getWebviewPanel(b);if(!S)throw new Error("No webview found");const d=p.URI.revive(a),E=this.d.getDocument(d);await l.provider.moveCustomTextEditor(E,S,I.CancellationToken.None)}async $undo(b,a,$,l){return this.i(a,b).undo($,l)}async $redo(b,a,$,l){return this.i(a,b).redo($,l)}async $revert(b,a,$){const l=this.i(a,b);await this.j(a).revertCustomDocument(l.document,$),l.disposeBackup()}async $onSave(b,a,$){const l=this.i(a,b);await this.j(a).saveCustomDocument(l.document,$),l.disposeBackup()}async $onSaveAs(b,a,$,l){const S=this.i(a,b);return this.j(a).saveCustomDocumentAs(S.document,p.URI.revive($),l)}async $backup(b,a,$){const l=this.i(a,b),d=await this.j(a).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},$);return l.updateBackup(d),d.id}i(b,a){const $=this.c.get(b,p.URI.revive(a));if(!$)throw new Error("No custom document found");return $}j(b){const $=this.b.get(b)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$3kc=r;function n(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const b=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,T.$ej)(b)+""}}),define(Ae[256],Re([1,0,163,100,2,4,7,8,5,13,28,45]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=e.$xkc=void 0;class v{#e;#t;#i;constructor(o,r,n,t,c,h,i,b){this.d=o,this.e=r,this.f=n,this.g=t,this.h=c,this.c=!1,this.f=Math.max(t,n),this.#i=new N.$Bc(a=>h.getComparisonKey(a)),this.#e=i,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,r){if(!o){this.clear();return}this.j();let n=[];if(A.URI.isUri(o)){if(!r){this.delete(o);return}this.#i.set(o,r.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(v.k);for(const i of o){const[b,a]=i;if((!h||b.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=b,n.push(b),this.#i.set(b,[])),a)this.#i.get(b)?.push(...a);else{const $=this.#i.get(b);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const t=[];let c=0;for(const h of n){let i=[];const b=this.#i.get(h);if(b)if(b.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const l of b)if(l.severity===a[$]&&i.push({...p.Diagnostic.from(l),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,I.localize)(0,null,b.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=b.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(h)}));if(t.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,t)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,r){this.j();for(const[n,t]of this)o.call(r,n,t,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const r=this.#i.get(o);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,r){return o[0].toString()<r[0].toString()?-1:o[0].toString()>r[0].toString()?1:0}}e.$xkc=v;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const r=new N.$Bc;for(const n of o)r.set(n,n);return{uris:Object.freeze(Array.from(r.values()))}}constructor(o,r,n,t){this.j=r,this.k=n,this.l=t,this.g=new Map,this.h=new g.$fe({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(O.$PM.MainThreadDiagnostics)}createDiagnosticCollection(o,r){const{g:n,f:t,h:c,j:h,k:i,l:b}=this,a=new class{$changeMany(S,d){t.$changeMany(S,d),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,S,d.length===0?"CLEARING":d)}$clear(S){t.$clear(S),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,S)}dispose(){t.dispose()}};let $;if(!r)r="_generated_diagnostic_collection_name_#"+u.c++,$=r;else if(!n.has(r))$=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do $=r+u.c++;while(n.has($))}return new class extends v{constructor(){super(r,$,u.e,u.d,S=>b.getDocument(S)?.version,i.extUri,a,c),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const r=new Map,n=[];for(const t of this.g.values())t.forEach((c,h)=>{let i=r.get(c.toString());typeof i>"u"&&(i=n.length,r.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let r=[];for(const n of this.g.values())n.has(o)&&(r=r.concat(n.get(o)));return r}$acceptMarkersChange(o){if(!this.n){const r="_generated_mirror",n=new v(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(r,n),this.n=n}for(const[r,n]of o)this.n.set(A.URI.revive(r),n.map(p.Diagnostic.to))}};e.$ykc=m,e.$ykc=m=u=Je([Ve(1,k.$Wj),Ve(2,y.$wkc)],m)}),define(Ae[257],Re([1,0,2,14,7,8,192,34]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class g{constructor(N,y,u,v={timeout:1500,errors:3}){this.c=N,this.d=y,this.f=u,this.g=v,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(y,u,v)=>{const s={dispose:this.a.push([y,u,N])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(N,y){const u=I.URI.revive(N);let v=!1;const m=setTimeout(()=>v=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(v)break;const r=this.d.getDocument(u),n=await this.h(o,{document:r,reason:O.TextDocumentSaveReason.to(y)});s.push(n)}}finally{clearTimeout(m)}return s}h([N,y,u],v){const m=this.b.get(N);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(u,N,y,v).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(N);this.b.set(N,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,y,u,v){const m=[],s=Date.now(),{document:o,reason:r}=v,{version:n}=o,t=Object.freeze({document:o,reason:r,waitUntil(c){if(Object.isFrozen(m))throw(0,T.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(u,[t])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const i=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c(b)}).catch(b=>{clearTimeout(i),h(b)})}).then(c=>{const h={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every(b=>b instanceof A.$YM))for(const{newText:b,newEol:a,range:$}of i)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&O.Range.from($),text:b,eol:a&&O.EndOfLine.from(a)}});if(h.edits.length!==0)return n===o.version?this.f.$tryApplyWorkspaceEdit(new p.$lw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$Glc=g}),define(Ae[258],Re([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class y{constructor(v,m){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Tc,this.h=new Map,this.f=v.getProxy(O.$PM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const r=A.URI.revive(o);return(0,g.$cg)(this.g.getDocument(r))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>A.URI.revive(m))}$acceptModelLanguageChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=A.URI.revive(v),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,m){const s=A.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,s){const o=A.URI.revive(v),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(m);let n;m.isUndoing?n=N.TextDocumentChangeReason.Undo:m.isRedoing&&(n=N.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Xn)({document:r.document,contentChanges:m.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:n}))}setWordDefinitionFor(v,m){(0,M.$eP)(v,m)}}e.$zkc=y}),define(Ae[66],Re([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,M.$qi)("IExtHostEditorTabs");class y{constructor(o,r,n){this.e=n,this.d=r,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$BO(O.URI.revive(this.b.input.uri));case 2:return new N.$CO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new N.$DO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new N.$EO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$FO(this.b.input.viewType);case 4:return new N.$GO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$HO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$IO;case 9:return new N.$JO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$KO;case 11:return new N.$LO(this.b.input.diffEditors.map(o=>new N.$CO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,r){this.c=[],this.d="",this.b=o,this.e=r;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new y(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const r=this.c.find(n=>n.tabId===o.tabDto.id);if(!r)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(o.tabDto),r}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new T.$be,this.c=new T.$be,this.e=[],this.a=o.getProxy(p.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,r={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,A.$cg)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,t)=>{const c=Array.isArray(n)?n:[n];return c.length?m(c[0])?this.j(c,t):this.i(c,t):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(o){const r=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),t=(0,I.$L)(r,n),c=this.e.filter(a=>t.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],i=[];this.e=o.map(a=>{const $=new u(a,()=>this.d);return t.added.includes($.groupId)?h.push($.apiObject):i.push($.apiObject),$});const b=(0,A.$cg)(o.find(a=>a.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const r=this.e.find(n=>n.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const r=this.e.find(t=>t.groupId===o.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const n=r.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const r of this.e)for(const n of r.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(r=>r.apiObject===o)}async i(o,r){const n=[];for(const t of o){const c=this.g(t);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,r)}async j(o,r){const n=[];for(const t of o){const c=this.h(t);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,r)}};e.$5kc=v,e.$5kc=v=Je([Ve(0,g.$cP)],v);function m(s){return s.tabs!==void 0}}),define(Ae[260],Re([1,0,2,4,6,7,8,303,15,23,25,54]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class u{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let r,n,t=14,c=14;for(const h of s){let i=r?(0,g.$vf)(r,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(t=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;r=h,c=t}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$32(o)}}provideDocumentLinks(s){this.c();const o=[],r=p.$42.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of r){const t=M.DocumentLink.to(n);t.target&&o.push(t)}return o}}class v{constructor(s,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(T.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,r,n={}){if(v.j(r),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(o),this.d.add(o),this.c.set(t,r);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,N.$xG)(s,"fsChunks"),c+=4);let h;n.isReadonly&&(0,y.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,o,c,h).catch(b=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error(b)});const i=r.onDidChangeFile(b=>{const a=[];for(const $ of b){const{uri:l,type:S}=$;if(l.scheme!==o)continue;let d;switch(S){case O.FileChangeType.Changed:d=0;break;case O.FileChangeType.Created:d=1;break;case O.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:l,type:d})}this.a.$onFileSystemChange(t,a)});return(0,A.$Sc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:r,mtime:n,size:t,permissions:c}=s;return{type:o,ctime:r,mtime:n,size:t,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(I.URI.revive(o))).then(r=>v.k(r))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(I.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(I.URI.revive(o))).then(r=>k.$Ce.wrap(r))}$writeFile(s,o,r,n){return Promise.resolve(this.l(s).writeFile(I.URI.revive(o),r.buffer,n))}$delete(s,o,r){return Promise.resolve(this.l(s).delete(I.URI.revive(o),r))}$rename(s,o,r,n){return Promise.resolve(this.l(s).rename(I.URI.revive(o),I.URI.revive(r),n))}$copy(s,o,r,n){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(I.URI.revive(o),I.URI.revive(r),n))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(I.URI.revive(o)))}$watch(s,o,r,n){const t=this.l(s).watch(I.URI.revive(r),n);this.f.set(o,t)}$unwatch(s,o){const r=this.f.get(o);r&&(r.dispose(),this.f.delete(o))}$open(s,o,r){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),r))}$close(s,o){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(o))}$read(s,o,r,n){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$Ce.alloc(n);return Promise.resolve(t.read(o,r,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(s,o,r,n){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(o,r,n.buffer,0,n.byteLength))}l(s){const o=this.c.get(s);if(!o){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return o}}e.$Ilc=v}),define(Ae[261],Re([1,0,5,36,2,4,8,7,41]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,m,s,o,r,n){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const t=(0,T.$kk)(r),c=typeof r=="string",h=n?.correlate,i=o(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(h&&typeof b.session>"u")){if(!n?.ignoreCreateEvents)for(const a of b.created){const $=A.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const a of b.changed){const $=A.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const a of b.deleted){const $=A.URI.revive(a);t($.fsPath)&&(!c||m.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=p.$RM.from(this.i(v,s,r,n,n?.correlate),this.b,this.c,this.d,i)}i(v,m,s,o,r){const n=p.$RM.from();if(typeof s=="string")return n;const t=v.getProxy(O.$PM.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(T.$gk)||s.pattern.includes(T.$hk))&&(c=!0),t.$watch(m.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[]},!!r),p.$RM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(v){this.a=v,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(A.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(v,m,s){this.j=v,this.k=m,this.l=s,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,m,s,o){return new k(this.j,v,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(v){this.a.fire(new N(v))}$onDidRunFileOperation(v,m){switch(v){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>A.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,m){return(s,o,r)=>{const n=function(c){s.call(o,c)};return n.extension=v,m.event(n,void 0,r)}}async $onWillRunFileOperation(v,m,s,o){switch(v){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:A.URI.revive(r.source),newUri:A.URI.revive(r.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(r=>A.URI.revive(r.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(r=>A.URI.revive(r.target))},s,o)}}async n(v,m,s,o){const r=new Set,n=[];if(await v.fireAsync(m,o,async(c,h)=>{const i=Date.now(),b=await Promise.resolve(c);b instanceof p.$2M&&(n.push([h.extension,b]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const t={edits:[]};for(const[,c]of n){const{edits:h}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(h)}return{edit:t,extensionNames:Array.from(r)}}}e.$Jlc=y}),define(Ae[262],Re([1,0,18,11,22,14,90,6,26,65,15,17,2,29,304,87,97,165,20,8,7,25,74,4]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class a{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof c.$$M?H.map(t.DocumentSymbol.from):a.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const L=[],G=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:t.SymbolKind.from(H.kind),tags:H.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:t.Range.from(H.location.range),selectionRange:t.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),L.push(ee);break}const re=G[G.length-1];if(v.$kt.containsRange(re.range,ee.range)&&!v.$kt.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return L}}class ${constructor(z,L,G,H,ee,re){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new i.$qkc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),re=new p.$Tc;this.e.set(ee,re);const Ne={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Ne.lenses.push({cacheId:[ee,Be],range:t.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Ne}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function l(ze){return Array.isArray(ze)?ze.map(t.DefinitionLink.from):ze?[t.DefinitionLink.from(ze)]:[]}class S{constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDefinition(H,ee,G);return l(re)}}class d{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDeclaration(H,ee,G);return l(re)}}class E{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideImplementation(H,ee,G);return l(re)}}class f{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideTypeDefinition(H,ee,G);return l(re)}}class D{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideHover(H,ee,G);if(!(!re||(0,I.$Kb)(re.contents)))return re.range||(re.range=H.getWordRangeAtPosition(ee)),re.range||(re.range=new c.$TM(ee,ee)),t.Hover.from(re)}}class w{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return t.EvaluatableExpression.from(re)}}class C{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const ee=this.d.getDocument(z),re=await this.e.provideInlineValues(ee,t.Range.to(L),t.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Ne=>t.InlineValue.from(Ne))}}class P{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(t.DocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const ee=this.d.getDocument(z),re=G.map(Qe=>this.d.getDocument(Qe)),Ne=t.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Ne,re,H);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),ee=t.Position.to(L),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(t.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L),Ne=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.location.from)}}class R{static{this.d=1e3}constructor(z,L,G,H,ee,re,Ne){this.g=z,this.h=L,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Ne,this.e=new i.$qkc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const ee=this.g.getDocument(z),re=m.$mt.isISelection(L)?t.Selection.to(L):t.Range.to(L),Ne=[];for(const it of this.j.getDiagnostics(z))if(re.intersection(it.range)&&Ne.push(it)>R.d)break;const Be={diagnostics:Ne,only:G.only?new c.$aN(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const _e=this.e.add(Qe),et=new p.$Tc;this.f.set(_e,et);const tt=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(R.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(t.Diagnostic.from),edit:nt.edit&&t.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$wG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$wG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(t.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(z,L){const[G,H]=z,ee=this.e.get(G,H);if(!ee||R.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Ne;re.edit&&(Ne=t.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(re.command,Qe))}return{edit:Ne,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class j{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$qkc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(z),re=L.map(Qe=>t.Range.to(Qe)),Ne=t.DataTransfer.toDataTransfer(G,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,re,Ne,H),H.isCancellationRequested)return;const Be=Array.from(Ne).filter(([,Qe])=>!(Qe instanceof c.$GN));return t.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(L),Be=G.map(tt=>t.Range.to(tt)),Qe=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolvePasteFileData(this.h,z,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ne,Be,Qe,{only:ee.only?new c.$LN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(ee))return ee.map(t.TextEdit.from)}}class se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Range.to(L),Ne=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,y.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),re=L.map(t.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Ne))return Ne.map(t.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,ee){const re=this.d.getDocument(z),Ne=t.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Ne,G,H,ee);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ve{constructor(z,L){this.e=z,this.f=L,this.d=new i.$qkc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Ne=G[re];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}ee.symbols.push({...t.WorkspaceSymbol.from(Ne),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,g.$Zn)(z,t.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const ee=this.d.getDocument(z),re=t.Position.to(L);try{const Ne=await this.e.provideRenameEdits(ee,re,G,H);return Ne?t.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Be=Ie.g(Ne);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=t.Position.to(L);try{const re=await this.e.prepareRename(H,ee,G);let Ne,Be;if(c.$TM.isRange(re)?(Ne=re,Be=H.getText(re)):(0,y.$6f)(re)&&(Ne=re.range,Be=re.placeholder),!Ne||!Be)return;if(Ne.start.line>ee.line||Ne.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Ne),text:Be}}catch(re){const Ne=Ie.g(re);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(re)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L);try{const re=await this.e.provideNewSymbolNames(H,ee,G);return re?re.map(Ne=>typeof Ne=="string"?{newSymbolName:Ne}:{newSymbolName:Ne.newSymbolName,tags:Ne.tags}):void 0}catch(re){this.f.error(ue.g(re)??JSON.stringify(re,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class be{constructor(z,L){this.resultId=z,this.tokens=L}}class ie{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(L),re?(re=ie.h(re),this.o(ie.n(ee,re),re)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return ie.j(z)?ie.k(z)?z:new c.$_N(new Uint32Array(z.data),z.resultId):ie.l(z)?ie.m(z)?z:new c.$bO(z.edits.map(L=>new c.$aO(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!ie.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,ee=L.data,re=ee.length;let Ne=0;const Be=Math.min(H,re);for(;Ne<Be&&G[Ne]===ee[Ne];)Ne++;if(Ne===H&&Ne===re)return new c.$bO([],L.resultId);let Qe=0;const _e=Be-Ne;for(;Qe<_e&&G[H-Qe-1]===ee[re-Qe-1];)Qe++;return new c.$bO([{start:Ne,deleteCount:H-Ne-Qe,data:ee.subarray(Ne,re-Qe)}],L.resultId)}o(z,L){if(ie.j(z)){const G=this.e++;return this.d.set(G,new be(z.resultId,z.data)),(0,o.$Fbb)({id:G,type:"full",data:z.data})}if(ie.l(z)){const G=this.e++;return ie.j(L)?this.d.set(G,new be(L.resultId,L.data)):this.d.set(G,new be(z.resultId)),(0,o.$Fbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Pe{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,t.Range.to(L),G);return ee?this.f(ee):null}f(z){return(0,o.$Fbb)({id:0,type:"full",data:z.data})}}class Fe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$qkc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const ee=this.f.getDocument(z),re=t.Position.to(L),Ne=ee.getWordRangeAtPosition(re)||new c.$TM(re,re),Be=Ne.with({end:re}),Qe=new k.$0d,_e=await this.h.provideCompletionItems(ee,re,H,t.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const et=Array.isArray(_e)?new c.$nN(_e):_e,tt=Fe.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Tc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:t.Range.from(Ne),insert:t.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let mt=0;mt<et.items.length;mt++){const Ue=et.items[mt],st=this.l(Ue,[tt,mt],Be,Ne);nt.push(st)}return at}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),ee=await this.h.resolveCompletionItem(G,L);if(!ee)return;const re=this.l(ee,z);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,g.$1n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(z.command,ee),Ne={x:L,a:z.label,b:z.kind!==void 0?t.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(t.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:t.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(t.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=z.textEdit.newText):typeof z.insertText=="string"?Ne.h=z.insertText:z.insertText instanceof c.$3M&&(Ne.h=z.insertText.value,Ne.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),c.$TM.isRange(Be)?Ne.j=t.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ne.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Ne}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class U extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new pe,this.e=(0,h.$wG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$wG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const ee=this.g.getDocument(z),re=t.Position.to(L),Ne=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Ne||H.isCancellationRequested)return;const Be=Array.isArray(Ne)?Ne:Ne.items,Qe=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],_e=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Tc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?t.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new p.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const ee=this.d.get(z)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,t.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Ne=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(ee.accepted,re));let Qe;return ee.rejected&&(re||(re=new p.$Tc),Qe=this.h.toInternal(ee.rejected,re)),{pid:Ne,text:ee.text,range:t.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new pe,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Oe{constructor(z,L){this.e=z,this.f=L,this.d=new i.$qkc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const ee=this.e.getDocument(z),re=t.Position.to(L),Ne=this.g(G),Be=await this.f.provideSignatureHelp(ee,re,H,Ne);if(Be){const Qe=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=t.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class ke{constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new i.$qkc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),ee=t.Range.to(L),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Ne=this.d.add(re);this.e.set(Ne,new p.$Tc);const Be={hints:[],cacheId:Ne};for(let Qe=0;Qe<re.length;Qe++)this.l(re[Qe],ee)&&Be.hints.push(this.m(re[Qe],[Ne,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:t.MarkdownString.fromStrict(z.tooltip),position:t.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(t.TextEdit.from),kind:z.kind&&t.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const re of z.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:re.value,tooltip:t.MarkdownString.fromStrict(re.tooltip)};c.$4M.isLocation(re.location)&&(Ne.location=t.location.from(re.location)),re.command&&(Ne.command=this.g.toInternal(re.command,G)),ee.push(Ne)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new i.$qkc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(t.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Ne=0;Ne<H.length;Ne++){if(!$e.g(H[Ne]))continue;const Be=t.DocumentLink.from(H[Ne]);Be.cacheId=[ee,Ne],re.links.push(Be)}return re}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return t.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class fe{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(re=>({color:t.Color.from(re.color),range:t.Range.from(re.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),ee=t.Range.to(L.range),re=t.Color.to(L.color),Ne=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Ne))return Ne.map(t.ColorPresentation.from)}}class J{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(ee))return ee.map(t.FoldingRange.from)}}class Y{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),ee=L.map(t.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Ne.push(Qe);let _e=ee[Be],et=re[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(t.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Ne}}class he{constructor(z,L){this.f=z,this.g=L,this.d=new M.$hP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(z,re.from),fromRanges:re.fromRanges.map(Ne=>t.Range.from(Ne))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(z,re.to),fromRanges:re.fromRanges.map(Ne=>t.Range.from(Ne))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$hP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=t.Position.to(L),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(z,re))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=t.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Te{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new i.$qkc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,ee){const re=this.f.getDocument(L),Ne=t.Position.to(G),Be=t.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,tt)).buffer),Qe=await this.g.provideDocumentDropEdits(re,Ne,Be,ee);if(!Qe)return;const _e=(0,I.$3b)(Qe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?t.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class de{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const ee=u.URI.revive(z),re=this.d.getDocument(ee),Ne=G.documents.map(_e=>_e.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>t.Range.to(tt))}))),Be={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(re,L,Be,H);return Qe?t.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,ee,re,Ne,Be){this.g=L,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Ne,this.n=Be,this.f=new Map,this.e=z.getProxy(b.$PM.MainThreadLanguageFeatures)}o(z,L){return t.DocumentSelector.from(z,this.g,L)}p(z){return new c.$RM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,ee,re=!1){const Ne=this.f.get(z);if(!Ne||!(Ne.adapter instanceof L))return H;const Be=Date.now();re||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Ne.adapter,Ne.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ne.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),A.CancellationToken.isCancellationToken(ee)?(0,T.$fh)(Qe,ee):Qe}t(z,L){const G=this.q();return this.f.set(G,new Ce(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const ee=this.t(new a(this.h,G),z),re=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,z),re),this.p(ee)}$provideDocumentSymbols(z,L,G){return this.s(z,a,H=>H.provideDocumentSymbols(u.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new $(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),ee);let re=this.p(H);if(ee!==void 0){const Ne=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$RM.from(re,Ne)}return re}$provideCodeLenses(z,L,G){return this.s(z,$,H=>H.provideCodeLenses(u.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,$,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,$,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new S(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,S,ee=>ee.provideDefinition(u.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new d(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,d,ee=>ee.provideDeclaration(u.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new E(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,E,ee=>ee.provideImplementation(u.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new f(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,f,ee=>ee.provideTypeDefinition(u.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const ee=this.t(new D(this.h,G),z);return this.e.$registerHoverProvider(ee,this.o(L,z)),this.p(ee)}$provideHover(z,L,G,H){return this.s(z,D,ee=>ee.provideHover(u.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const ee=this.t(new w(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,z)),this.p(ee)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,w,ee=>ee.provideEvaluatableExpression(u.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,G),z);this.e.$registerInlineValuesProvider(re,this.o(L,z),ee);let Ne=this.p(re);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Ne=c.$RM.from(Ne,Be)}return Ne}$provideInlineValues(z,L,G,H,ee){return this.s(z,C,re=>re.provideInlineValues(u.URI.revive(L),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new P(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,P,ee=>ee.provideDocumentHighlights(u.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,ee){return this.s(z,V,re=>re.provideMultiDocumentHighlights(u.URI.revive(L),G,H.map(Ne=>u.URI.revive(Ne)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,W,async ee=>{const re=await ee.provideLinkedEditingRanges(u.URI.revive(L),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,ee){return this.s(z,q,re=>re.provideReferences(u.URI.revive(L),G,H,ee),void 0,ee)}registerCodeActionProvider(z,L,G,H){const ee=new p.$Tc,re=this.t(new R(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(re,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:H?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,ee)}))},Me.u(z),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(z,L,G,H,ee){return this.s(z,R,re=>re.provideCodeActions(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCodeAction(z,L,G){return this.s(z,R,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,R,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new se(this.h,G),z);return this.e.$registerRangeFormattingSupport(ee,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangeFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,L,G,H,ee){return this.s(z,se,re=>re.provideDocumentRangesFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,L,G,H){const ee=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,L,G,H,ee,re){return this.s(z,ce,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(L),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new ve(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,ve,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,ve,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,ve,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,ee){return this.s(z,Ie,re=>re.provideRenameEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(u.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(u.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const ee=this.t(new ie(this.h,G),z),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,z),H,re);let Ne=this.p(ee);if(re){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(re));Ne=c.$RM.from(Ne,Be)}return Ne}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,ie,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,ie,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const ee=this.t(new Pe(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Pe,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const ee=this.t(new Fe(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(L,z),H,Fe.supportsResolving(G),z.identifier),this.p(ee)}$provideCompletionItems(z,L,G,H,ee){return this.s(z,Fe,re=>re.provideCompletionItems(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCompletionItem(z,L,G){return this.s(z,Fe,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Fe,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const ee=new U(z,this.h,G,this.j.converter),re=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(re,this.o(L,z),ee.supportsHandleEvents,n.$Lm.toKey(z.identifier.value),H?.yieldTo?.map(Ne=>n.$Lm.toKey(Ne))||[]),this.p(re)}$provideInlineCompletions(z,L,G,H,ee){return this.s(z,ne,re=>re.provideInlineCompletions(u.URI.revive(L),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async ee=>{ee.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,ee){this.s(z,ne,async re=>{re.handlePartialAccept(L,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(L,z),z.identifier),this.p(ee)}$provideInlineEdit(z,L,G,H){return this.s(z,x,ee=>ee.provideInlineEdits(u.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Oe(this.h,G),z);return this.e.$registerSignatureHelpProvider(re,this.o(L,z),ee),this.p(re)}$provideSignatureHelp(z,L,G,H,ee){return this.s(z,Oe,re=>re.provideSignatureHelp(u.URI.revive(L),G,H,ee),void 0,ee)}$releaseSignatureHelp(z,L){this.s(z,Oe,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let re=this.p(ee);if(H!==void 0){const Ne=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$RM.from(re,Ne)}return re}$provideInlayHints(z,L,G,H){return this.s(z,ke,ee=>ee.provideInlayHints(u.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,ke,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,ke,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(u.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new fe(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,fe,H=>H.provideColors(u.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,fe,ee=>ee.provideColorPresentations(u.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new J(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,ee);let re=this.p(H);if(ee!==void 0){const Ne=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$RM.from(re,Ne)}return re}$provideFoldingRanges(z,L,G,H){return this.s(z,J,ee=>ee.provideFoldingRanges(u.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new Y(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,Y,ee=>ee.provideSelectionRanges(u.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,he,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,he,ee=>ee.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,he,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,le,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,le,ee=>ee.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Te(this.e,this.h,G,ee,z),z)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,z),(0,h.$wG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,L,G,H,ee,re){return this.s(z,Te,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(L,u.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Te,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Te,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,ee){return this.s(z,de,re=>Promise.resolve(re.provideMappedEdits(L,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new j(this.e,this.h,G,ee,z),z)),this.e.$registerPasteEditProvider(ee,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,L,G,H,ee){return this.s(z,j,re=>re.prepareDocumentPaste(u.URI.revive(L),G,H,ee),void 0,ee)}$providePasteEdits(z,L,G,H,ee,re,Ne){return this.s(z,j,Be=>Be.providePasteEdits(L,u.URI.revive(G),H,ee,re,Ne),void 0,Ne)}$resolvePasteEdit(z,L,G){return this.s(z,j,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,j,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>c.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,N.$ff)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$Akc=Me}),define(Ae[88],Re([1,0,22,6,4,8,7,101,20,11,5,166,106,14,3,16,84,13,40]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=e.$hlc=void 0,e.$hlc=(0,m.$qi)("IExtHostLanguageModels");class c{constructor(a,$){this.option=a,this.stream=new k.$Th,this.stream=$??new k.$Th}}class h{constructor(){this.a=new Map,this.b=new k.$Th,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let $=this.a.get(a.index);$||(this.a.size===0?$=new c(a.index,this.b):$=new c(a.index),this.a.set(a.index,$)),$.stream.emitOne(a.part)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const $ of this.f())$.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let i=class{static{t=this}static{this.a=1}constructor(a,$,l){this.j=$,this.k=l,this.c=new N.$be,this.d=new N.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new g.$Nm,this.i=new Map,this.o=new Set,this.b=a.getProxy(A.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,$,l,S){const d=t.a++;this.f.set(d,{extension:a.identifier,provider:l,languageModelId:$});let E;return S.auth&&(E={providerLabel:a.displayName||a.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(d,$,{extension:a.identifier,identifier:$,model:S.name??"",auth:E}),(0,T.$Sc)(()=>{this.f.delete(d),this.b.$unregisterProvider(d)})}async $provideLanguageModelResponse(a,$,l,S,d,E){const f=this.f.get(a);if(!f)return;const D=new p.$Zv(async w=>{if(E.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk($,{index:w.index,part:w.part})});return f.provider.provideLanguageModelResponse2(S.map(O.LanguageModelMessage.to),d,g.$Lm.toKey(l),D,E)}$provideTokenLength(a,$,l){const S=this.f.get(a);return S?Promise.resolve(S.provider.provideTokenCount($,l)):Promise.resolve(0)}$updateLanguageModels(a){const $=[],l=[];if(a.added)for(const S of a.added)this.g.set(S.identifier,S),$.push(S.model);if(a.removed)for(const S of a.removed){this.g.delete(S),l.push(S);for(const[d,E]of this.i)E.languageModelId===S&&(E.res.reject(new v.$5),this.i.delete(d))}this.d.fire(Object.freeze({added:Object.freeze($),removed:Object.freeze(l)})),a.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(a){const $=new Array;for(const{from:l,to:S,enabled:d}of a){const E=this.h.get(l)??new g.$Mm;if(E.has(S)!==d){d?E.add(S):E.delete(S),this.h.set(l,E);const D={from:l,to:S};$.push(D),this.c.fire(D)}}}async sendChatRequest(a,$,l,S,d){const E=a.identifier,f=await this.b.$prepareChatAccess(E,$,S.justification);if(!f||!this.g.has($))throw M.$2O.NotFound(`Language model '${$}' is unknown.`);if(this.m(E,f)&&(!await this.l(a,{identifier:f.extension,displayName:f.auth.providerLabel},S.justification,S.silent)||!this.h.get(E)?.has(f.extension)))throw M.$2O.NoPermissions(`Language model '${$}' cannot be used by '${E.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(E,$,D,l.map(O.LanguageModelMessage.from),S.modelOptions??{},d),C=new k.$ph,P=new h;this.i.set(D,{languageModelId:$,res:P});let V;if(w.catch(W=>{C.isOpen()?P.reject(W):V=W}).finally(()=>{this.i.delete(D),P.resolve(),C.open()}),await C.wait(),V)throw new M.$2O(`Language model '${$}' errored, check cause for more details`,"Unknown",V);return P.apiObject}async $handleResponseFragment(a,$){const l=this.i.get(a);l&&l.res.handleFragment($)}async l(a,$,l,S){const d=u.$RL+$.identifier.value;if(await this.k.getSession(a,d,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:$.identifier,enabled:!0}]),!0;if(S)return!1;try{const f=l?(0,y.localize)(0,null,$.displayName,l):(0,y.localize)(1,null,$.displayName);return await this.k.getSession(a,d,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:a.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}m(a,$){return!!$.auth&&!g.$Lm.equals($.extension,a)}async n(a){for(const $ of this.o)try{await this.l($,{identifier:a.extension,displayName:""},void 0,!0)}catch(l){this.j.error("Fake Auth request failed"),this.j.error(l)}}createLanguageModelAccessInformation(a){this.o.add(a);const $=this,l=N.Event.signal(N.Event.filter(this.c.event,d=>g.$Lm.equals(d.from,a.identifier))),S=N.Event.signal(this.d.event);return{get onDidChange(){return N.Event.any(l,S)},canSendRequest(d){const E=$.g.get(d);if(!E)return;if(!$.m(a.identifier,E))return!0;const f=$.h.get(a.identifier);if(f)return f.has(E.extension)},async computeTokenLength(d,E,f){f??=I.CancellationToken.None;const D=$.g.get(d);if(!D)throw M.$2O.NotFound(`Language model '${d}' is unknown.`);const w=n.Iterable.find($.f.values(),C=>C.languageModelId===d);return w?w.provider.provideTokenCount(E,f):$.b.$countTokens(D.identifier,E,f)}}}};e.$ilc=i,e.$ilc=i=t=Je([Ve(0,s.$cP),Ve(1,r.$Wj),Ve(2,o.$Ckc)],i)}),define(Ae[263],Re([1,0,4,8,7,33,11,6,25]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;class k{constructor(y,u,v,m){this.c=u,this.d=v,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(I.$PM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const v=this.c.getDocumentData(y);if(!v)throw new Error(`document '${y.toString()}' NOT found`);return v.document}async tokenAtPosition(y,u){const v=y.version,m=T.Position.from(u),s=await this.a.$tokensAtPosition(y.uri,m),o={type:A.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new A.$TM(u.line,u.character,u.line,u.character)};if(!s)return o;const r={range:T.Range.to(s.range),type:T.TokenType.to(s.type)};return!r.range.contains(u)||v!==y.version?o:r}createLanguageStatusItem(y,u,v){const m=this.f++,s=this.a,o=this.g,r=`${y.identifier.value}/${u}`;if(o.has(r))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(r);const n={selector:v,id:u,name:y.displayName??y.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const c=new p.$Tc,h=()=>{if(t?.dispose(),!o.has(r)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,M.$sh)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:r,name:n.name??y.displayName??y.name,source:y.displayName??y.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===A.LanguageStatusSeverity.Error?O.default.Error:n.severity===A.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),t?.dispose(),s.$removeLanguageStatus(m),o.delete(r)},get id(){return n.id},get name(){return n.name},set name(b){n.name=b,h()},get selector(){return n.selector},set selector(b){n.selector=b,h()},get text(){return n.text},set text(b){n.text=b,h()},set text2(b){(0,g.$xG)(y,"languageStatusText"),n.text=b,h()},get text2(){return(0,g.$xG)(y,"languageStatusText"),n.text},get detail(){return n.detail},set detail(b){n.detail=b,h()},get severity(){return n.severity},set severity(b){n.severity=b,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(b){n.accessibilityInformation=b,h()},get command(){return n.command},set command(b){n.command=b,h()},get busy(){return n.busy},set busy(b){n.busy=b,h()}};return h(),i}}e.$Zlc=k}),define(Ae[264],Re([1,0,12,2,8,7,83]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;class p{constructor(y,u,v,m){this.start=y,this.deletedCount=u,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new O.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,v){this.notebook=y,this.h=u,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(A.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(v)}return this.f}setOutputs(y){this.a=y.map(A.NotebookCellOutput.to)}setOutputItems(y,u,v){const m=v.map(A.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(u||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$MK(o.mime)))){const o=new Map,r=[];s.items.forEach(n=>{let t;o.has(n.mime)?t=o.get(n.mime):(t=[],o.set(n.mime,t),r.push(n.mime)),t.push(n.data)}),s.items.length=0,r.forEach(n=>{const t=M.$NK(o.get(n));s.items.push({mime:n,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Llc=g;class k{static{this.a=0}constructor(y,u,v,m,s){this.k=y,this.l=u,this.m=v,this.uri=m,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(v){return v=y.n(v),y.b[v].apiCell},getCells(v){return(v?y.p(v):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,v){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const r of y.rawEvents)r.kind===M.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,m.contentChanges):r.kind===M.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,m.contentChanges):r.kind===M.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const o=new Map;for(let r=0;r<s.length;r++){const n=s[r],t=o.get(n.cell);if(t===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else m.cellChanges[t]={...m.cellChanges[t],...n}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,v=y.end|0;return u<0&&(u=0),v>this.b.length&&(v=this.b.length),y.with({start:u,end:v})}p(y){y=this.o(y);const u=[];for(let v=y.start;v<y.end;v++)u.push(this.b[v]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,v){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(r=>{const t=r[2].map(i=>{const b=new g(this,this.l,i);return u||s.push(g.asModelAddData(i)),b}),c=new p(r[0],r[1],[],t),h=this.b.splice(r[0],r[1],...t);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),v)for(const r of m)v.push(r.asApiEvent())}s(y,u,v,m){const s=this.b.splice(y,u);this.b.splice(v,0,...s);const o=[new p(y,u,s.map(r=>r.apiCell),[]),new p(v,0,[],s)];for(const r of o)m.push(r.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,v,m){this.b[y].setOutputItems(u,v,m)}v(y,u){const v=this.b[y];v.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(v.uri,u)}w(y,u){const v=this.b[y];v.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Mlc=k}),define(Ae[265],Re([1,0,5,2,8,7,34]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class p{constructor(k,N,y,u={timeout:1500,errors:3}){this.b=k,this.c=N,this.d=y,this.f=u,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(N,y,u)=>{const v=function(s){N.call(y,s)};return v.extension=k,this.a.event(v,void 0,u)}}async $participateInSave(k,N,y){const u=T.URI.revive(k),v=this.c.getNotebookDocument(u);if(!v)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:A.TextDocumentSaveReason.to(N)},y,async(o,r)=>{const n=Date.now(),t=await await Promise.resolve(o);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof O.$2M?m.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:r}=A.WorkspaceEdit.from(o);s.edits=s.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(new M.$lw(s))}}e.$2lc=p}),define(Ae[112],Re([1,0,14,8,7]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,g,k,N,y,u){this.id=p,this.f=g,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=N,this.c=u}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(g){this.selections=[g]},get selections(){return p.a},set selections(g){if(!Array.isArray(g)||!g.every(A.$gO.isNotebookRange))throw(0,I.$7)("selections");p.a=g,p.g(g)},get visibleRanges(){return p.b},revealRange(g,k){p.f.$tryRevealRange(p.id,T.NotebookRange.from(g),k??A.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(T.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Nlc=O}),define(Ae[266],Re([1,0,5,13,8]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;let O=class{constructor(p,g){this.c=p,this.d=g,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,g);const k=this.d.getEditorById(p);g.visibleRanges&&k._acceptVisibleRanges(g.visibleRanges.ranges.map(A.NotebookRange.to)),g.selections&&k._acceptSelections(g.selections.selections.map(A.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const g in p)this.d.getEditorById(g)._acceptViewColumn(A.ViewColumn.to(p[g]))}};e.$4lc=O,e.$4lc=O=Je([Ve(0,T.$Wj)],O)}),define(Ae[267],Re([1,0,5,4,112]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class O{constructor(p,g){this.c=g,this.a=new Map,this.b=p.getProxy(T.$PM.MainThreadNotebookRenderers)}$postRendererMessage(p,g,k){const N=this.c.getEditorById(p);this.a.get(g)?.fire({editor:N.apiEditor,message:k})}createRendererMessaging(p,g){if(!p.contributes?.notebookRenderer?.some(N=>N.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(N,y,u)=>this.d(g).event(N,y,u),postMessage:(N,y)=>{A.$Nlc.apiEditorsToExtHost.has(N)&&([N,y]=[y,N]);const u=y&&A.$Nlc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,g,N)}}}d(p){let g=this.a.get(p);return g||(g=new I.$be({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(p)}}),this.a.set(p,g),g)}}e.$7lc=O}),define(Ae[268],Re([1,0,8,101,22,68,14]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,v){const m=this.b++,{title:s,location:o,cancellable:r}=u,n={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:s,source:n,cancellable:r},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,v,!!r)}d(y,u,v){let m;v&&(m=new A.$me,this.c.set(y,m));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),m?.dispose()};let o;try{o=u(new k(this.a,y),v&&m?m.token:A.CancellationToken.None)}catch(r){throw s(y),r}return o.then(r=>s(y),r=>s(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$$lc=p;function g(N,y){return N.message=y.message,typeof y.increment=="number"&&(typeof N.increment=="number"?N.increment+=y.increment:N.increment=y.increment),N}class k extends T.$Zv{constructor(y,u){super(v=>this.throttledReport(v)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$Wh)(100,(N,y)=>g(N,y),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ae[269],Re([1,0,2,4,11,8]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class M{static{this.a=0}constructor(g,k){this.d=k,this.c=new Map,this.b=g.getProxy(T.$PM.MainThreadQuickDiff)}$provideOriginalResource(g,k,N){const y=I.URI.revive(k),u=this.c.get(g);return u?(0,A.$ih)(()=>u.provideOriginalResource(y,N)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(g,k,N,y){const u=M.a++;return this.c.set(u,k),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(g,this.d),N,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$_lc=M}),define(Ae[270],Re([1,0,22,5,6,4,2,7,14,18,33,42,25,8]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=m;function m(s,o,r){const n=s.getProxy(O.$PM.MainThreadQuickOpen);class t{constructor(d,E){this.e=new Map,this.f=0,this.a=d,this.b=E}showQuickPick(d,E,f,D=I.CancellationToken.None){this.c=void 0;const w=Promise.resolve(E),C=++this.f,P=n.$show(C,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},D),V={},W=P.then(()=>V);return Promise.race([W,w]).then(q=>{if(q===V)return;const R=(0,u.$wG)(d,"quickPickItemTooltip");return w.then(j=>{const K=[];for(let se=0;se<j.length;se++){const ce=j[se];if(typeof ce=="string")K.push({label:ce,handle:se});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!R&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const ve=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:R?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:se})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=se=>{f.onDidSelectItem(j[se])}),n.$setItems(C,K),P.then(se=>{if(typeof se=="number")return j[se];if(Array.isArray(se))return se.map(ce=>j[ce])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return n.$setError(C,q),Promise.reject(q)})}$onItemSelected(d){this.c?.(d)}showInput(d,E=I.CancellationToken.None){return this.d=d?.validateInput,n.$input(d,typeof this.d=="function",E).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(d){if(!this.d)return;const E=await this.d(d);if(!E||typeof E=="string")return E;let f;switch(E.severity){case p.InputBoxValidationSeverity.Info:f=N.default.Info;break;case p.InputBoxValidationSeverity.Warning:f=N.default.Warning;break;case p.InputBoxValidationSeverity.Error:f=N.default.Error;break;default:f=E.message?N.default.Error:N.default.Ignore;break}return{content:E.message,severity:f}}async showWorkspaceFolderPick(d,E=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!f)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(d){const E=new $(d,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(d){const E=new l(d,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(d,E){this.e.get(d)?._fireDidChangeValue(E)}$onDidAccept(d){this.e.get(d)?._fireDidAccept()}$onDidChangeActive(d,E){const f=this.e.get(d);f instanceof $&&f._fireDidChangeActive(E)}$onDidChangeSelection(d,E){const f=this.e.get(d);f instanceof $&&f._fireDidChangeSelection(E)}$onDidTriggerButton(d,E){this.e.get(d)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(d,E,f){const D=this.e.get(d);D instanceof $&&D._fireDidTriggerItemButton(E,f)}$onDidHide(d){this.e.get(d)?._fireDidHide()}}class c{static{this.a=1}constructor(d,E){this.x=d,this.y=E,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$be,this.q=new T.$be,this.r=new T.$be,this.s=new T.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(d){this.b=d,this.z({title:d})}get step(){return this.c}set step(d){this.c=d,this.z({step:d})}get totalSteps(){return this.d}set totalSteps(d){this.d=d,this.z({totalSteps:d})}get enabled(){return this.g}set enabled(d){this.g=d,this.z({enabled:d})}get busy(){return this.j}set busy(d){this.j=d,this.z({busy:d})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(d){this.k=d,this.z({ignoreFocusOut:d})}get value(){return this.l}set value(d){this.l=d,this.z({value:d})}get placeholder(){return this.m}set placeholder(d){this.m=d,this.z({placeholder:d})}get buttons(){return this.n}set buttons(d){this.n=d.slice(),this.o.clear(),d.forEach((E,f)=>{const D=E===p.$dO.Back?-1:f;this.o.set(D,E)}),this.z({buttons:d.map((E,f)=>({...a(E.iconPath),tooltip:E.tooltip,handle:E===p.$dO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(d){this.l=d,this.q.fire(d)}_fireDidTriggerButton(d){const E=this.o.get(d);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(d){if(!this.v){for(const E of Object.keys(d)){const f=d[E];this.u[E]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(S){if(S instanceof p.$NN)return{id:S.id};const d=b(S),E=i(S);return{dark:typeof d=="string"?M.URI.file(d):d,light:typeof E=="string"?M.URI.file(E):E}}function i(S){return typeof S=="object"&&"light"in S?S.light:S}function b(S){return typeof S=="object"&&"dark"in S?S.dark:S}function a(S){const d=h(S);let E,f;return"id"in d?f=y.ThemeIcon.asClassName(d):E=d,{iconPath:E,iconClass:f}}class $ extends c{constructor(d,E){super(d.identifier,E),this.O=d,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$be,this.L=[],this.M=new T.$be,this.N=new T.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(d){this.B=d.slice(),this.C.clear(),this.D.clear(),d.forEach((D,w)=>{this.C.set(w,D),this.D.set(D,w)});const E=(0,u.$wG)(this.O,"quickPickItemTooltip"),f=[];for(let D=0;D<d.length;D++){const w=d[D];if(w.kind===p.QuickPickItemKind.Separator)f.push({type:"separator",label:w.label});else{w.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=w.iconPath?a(w.iconPath):void 0;f.push({handle:D,label:w.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:E?v.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(d){this.E=d,this.z({canSelectMany:d})}get matchOnDescription(){return this.F}set matchOnDescription(d){this.F=d,this.z({matchOnDescription:d})}get matchOnDetail(){return this.G}set matchOnDetail(d){this.G=d,this.z({matchOnDetail:d})}get sortByLabel(){return this.H}set sortByLabel(d){this.H=d,this.z({sortByLabel:d})}get keepScrollPosition(){return this.I}set keepScrollPosition(d){this.I=d,this.z({keepScrollPosition:d})}get activeItems(){return this.J}set activeItems(d){this.J=d.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(d){this.L=d.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(d){const E=(0,k.$Hb)(d.map(f=>this.C.get(f)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(d){const E=(0,k.$Hb)(d.map(f=>this.C.get(f)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(d,E){const f=this.C.get(d);if(!f||!f.buttons||!f.buttons.length)return;const D=f.buttons[E];D&&this.N.fire({button:D,item:f})}}class l extends c{constructor(d,E){super(d.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(d){this.B=d,this.z({password:d})}get prompt(){return this.C}set prompt(d){this.C=d,this.z({prompt:d})}get valueSelection(){return this.D}set valueSelection(d){this.D=d,this.z({valueSelection:d})}get validationMessage(){return this.E}set validationMessage(d){this.E=d,d?typeof d=="string"?this.z({validationMessage:d,severity:N.default.Error}):this.z({validationMessage:d.message,severity:d.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new t(o,r)}}),define(Ae[271],Re([1,0,2,5,68,6,11,4,18,143,13,20,42,8,25,12,21]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;function n(C){return C instanceof I.URI}function t(C,P){return C.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function i(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,k.$ir)(V,W)}function b(C,P){let V=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(V=i(C,P),V!==0)return V;if(C.light&&P.light)V=i(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(V!==0)return V;if(C.dark&&P.dark)V=i(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return V}function a(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<C.arguments.length;V++){const W=C.arguments[V],q=P.arguments[V];if(W!==q&&!(n(W)&&n(q)&&t(W,q)))return W<q?-1:1}return 0}function $(C,P){let V=(0,k.$ir)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(C.command&&P.command)V=a(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(V!==0)return V;if(C.decorations&&P.decorations)V=b(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,k.$ir)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,k.$ir)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function l(C,P){for(let V=0;V<C.length;V++)if(C[V]!==P[V])return!1;return!0}function S(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?l(C.arguments,P.arguments):C.arguments===P.arguments)}function d(C,P){return(0,g.$ub)(C,P,S)}class E{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,m.$xG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,m.$xG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,m.$xG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,R){this.k=P,this.l=q,this.m=R,this.d="",this.e=new T.$be,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,m.$xG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$bmc=E;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,R,j,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,M.$ih)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort($),W=(0,g.$Db)(this.o,P,$).map(j=>{const K=j.toInsert.map(se=>{const ce=this.e++;this.g.set(ce,se);const ve=se.resourceUri;let Ie;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const fe=new O.$Tc;Ie=this.s.converter.toInternal(se.command,fe),this.j.set(ce,fe)}else this.h.set(ce,se.command);const ue=(0,m.$wG)(this.w,"scmMultiDiffEditor"),be=ue?se.multiDiffEditorOriginalUri:void 0,ie=ue?se.multiFileDiffEditorModifiedUri:void 0,Pe=c(se.decorations),Fe=se.decorations&&c(se.decorations.light)||Pe,ne=se.decorations&&c(se.decorations.dark)||Pe,U=[Fe,ne],x=se.decorations&&se.decorations.tooltip||"",pe=se.decorations&&!!se.decorations.strikeThrough,Oe=se.decorations&&!!se.decorations.faded,ke=se.contextValue||"";return{rawResource:[ce,ve,U,x,pe,Oe,ke,Ie,be,ie],handle:ce}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=W.map(({start:j,deleteCount:K,toInsert:se})=>[j,K,se.map(ce=>ce.rawResource)]),R=W.reverse();for(const{start:j,deleteCount:K,toInsert:se}of R){const ce=se.map(Ie=>Ie.handle),ve=this.n.splice(j,K,...ce);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,m.$wG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,m.$xG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,m.$xG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new O.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,m.$xG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,m.$xG)(this.x,"scmActionButton"),this.p.value=new O.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&d(this.t,P))return;this.s.value=new O.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,R,j,K){this.x=P,this.y=q,this.z=R,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.m=void 0,this.n=new O.$Vc,this.o=void 0,this.p=new O.$Vc,this.s=new O.$Vc,this.t=void 0,this.u=!1,this.v=new T.$be,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=W;const se=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new E(P,V,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,R,j,K,se)}createResourceGroup(P,V,W){const q=(0,m.$wG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,R=new f(this.#e,this.y,this.w,P,V,q,this.x),j=T.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,j),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const R=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.D.delete(W),R.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const j=W._takeResourceStateSnapshot();j.length>0&&V.push([W.handle,j]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$Vh)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$Vh)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new y.$Nm,this.j=new T.$be,this.e=P.getProxy(p.$PM.MainThreadSCM),this.f=P.getProxy(p.$PM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const j=this.g.get(R.sourceControlHandle);if(!j)return R;const K=j.getResourceGroup(R.groupHandle);return K?K.getResourceState(R.handle):R}else if(R&&R.$mid===4){const j=this.g.get(R.sourceControlHandle);return j?j.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const j=this.g.get(R.handle);return j||R}return R}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=r.d++,j=new D(P,this.m,this.e,this.l,V,W,q);this.g.set(R,j);const K=this.h.get(P.identifier)||[];return K.push(j),this.h.set(P.identifier,K),j}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const R=this.g.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>R.quickDiffProvider.provideOriginalResource(q,W)).then(j=>j||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const R=this.g.get(P);if(!R)return Promise.resolve(void 0);const j=R.getResourceGroup(V);return j?j.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>q.inputBox.validateInput(V,W)).then(R=>{if(!R)return Promise.resolve(void 0);const j=v.MarkdownString.fromStrict(R.message);return j?Promise.resolve([j,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const R=this.g.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const j=await R.provideHistoryItemSummary(V,W,q);return j?{...j,icon:h(j)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$cmc=w,e.$cmc=w=r=Je([Ve(3,N.$Wj)],w)}),define(Ae[272],Re([1,0,4,8,2]),function(ge,e,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class O{static{this.a=0}constructor(p,g){this.d=g,this.c=new Map,this.b=p.getProxy(I.$PM.MainThreadShare)}async $provideShare(p,g,k){return await this.c.get(p)?.provideShare({selection:T.Range.to(g.selection),resourceUri:A.URI.revive(g.resourceUri)},k)??void 0}registerShareProvider(p,g){const k=O.a++;return this.c.set(k,g),this.b.$registerShareProvider(k,T.DocumentSelector.from(p,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$dmc=O}),define(Ae[273],Re([1,0,7,4,169,6,8,17]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(u,v,m,s,o,r=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=u,this.#t=v,o&&s){this.c=(0,I.$qN)(s.identifier,o);const t=m.get(this.c);t&&(r=t.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=r,this.h=this.u(n)}u(u){if((0,p.$8f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let v;this.m?v=this.m:v=(0,A.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=g.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,v,this.k,s,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$fmc=g;class k{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const v={message:u};return this.b.unshift(v),this.c(),new I.$RM(()=>{const m=this.b.indexOf(v);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(u,v){this.e=new Map,this.a=u.getProxy(T.$PM.MainThreadStatusBar),this.b=v,this.c=new k(this)}$acceptStaticEntries(u){for(const v of u)this.e.set(v.entryId,v)}createStatusBarEntry(u,v,m,s){return new g(this.a,this.b,this.e,u,v,m,s)}setStatusBarMessage(u,v){const m=this.c.setMessage(u);let s;return typeof v=="number"?s=setTimeout(()=>m.dispose(),v):typeof v<"u"&&v.then(()=>m.dispose(),()=>m.dispose()),new I.$RM(()=>{m.dispose(),clearTimeout(s)})}}e.$gmc=N}),define(Ae[113],Re([1,0,29,105,50,75,61,8,2]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=e.$pP=e.$oP=void 0;const k=(t,c,h,i)=>{let b=c;return{enumerable:!0,configurable:!1,get(){return b},set(a){if(!h(b,a)){const $=b;b=a,t.listener?.(i(a,$))}}}},N=(t,c)=>t===c,y={range:(t,c)=>t===c?!0:!t||!c?!1:t.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(t,c)=>!(t.length!==c.length||t.some(h=>!c.find(i=>h.id===i.id)))},u=t=>c=>({op:4,update:t(c)}),v=(t,c)=>({range:(()=>{let h;const i=u(b=>({range:I.$kt.lift(p.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return h},set(b){t.listener?.({op:6}),y.range(h,b)||(h=b,t.listener?.(i(b)))}}})(),label:k(t,c,y.label,u(h=>({label:h}))),description:k(t,void 0,y.description,u(h=>({description:h}))),sortText:k(t,void 0,y.sortText,u(h=>({sortText:h}))),canResolveChildren:k(t,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:k(t,!1,y.busy,u(h=>({busy:h}))),error:k(t,void 0,y.error,u(h=>({error:p.MarkdownString.fromStrict(h)||null}))),tags:k(t,[],y.tags,(h,i)=>({op:1,new:h.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=t=>{const c=A.$BL.fromString(t.extId),h=new o(c.controllerId,c.localId,t.label,g.URI.revive(t.uri)||void 0);return h.range=p.Range.to(t.range||void 0),h.description=t.description||void 0,h.sortText=t.sortText||void 0,h.tags=t.tags.map(i=>p.TestTag.to({id:(0,M.$HL)(i).tagId})),h},s=t=>{let c;for(const h of t.tests){const i=m(h.item);(0,T.$$O)(i).parent=c,c=i}return c};e.$oP=s;class o{constructor(c,h,i,b){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,T.$0O)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,O.$9O)(a,T.$$O,o),enumerable:!0,writable:!1},...v(a,i)})}}e.$pP=o;class r extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$qP=r;class n extends O.$5O{constructor(c,h,i){super({controllerId:c,getDocumentVersion:b=>b&&i.getDocument(b)?.version,getApiFor:T.$$O,getChildren:b=>b.children,root:new r(c,h),toITestItem:p.TestItem.from})}}e.$rP=n}),define(Ae[32],Re([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,23,34,43,65,59,62,35]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=void 0;let a=class{#e;#t;#i;constructor(f,D,w){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$PM.MainThreadCommands),this.d=D,this.#i=w,this.#t=f.getProxy(M.$PM.MainThreadTelemetry),this.converter=new $(this,C=>{const P=this.c.get(C);return P?.result===S.Void?P:void 0},D),this.f=[{processArgument(C){return(0,k.$Zh)(C)}},{processArgument(C){return(0,O.$Yn)(C,function(P){if(N.$kt.isIRange(P))return A.Range.to(P);if(y.$jt.isIPosition(P))return A.Position.to(P);if(N.$kt.isIRange(P.range)&&u.URI.isUri(P.uri))return A.location.to(P);if(P instanceof r.$Ce)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const D=this.registerCommand(!1,f.id,async(...w)=>{const C=f.args.map((V,W)=>{if(!V.validate(w[W]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${typeof w[W]=="object"?JSON.stringify(w[W],null,"	"):w[W]} `);return V.convert(w[W])}),P=await this.executeCommand(f.internalId,...C);return f.result.convert(P,w,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$RM(()=>{D.dispose(),this.c.delete(f.id)})}registerCommand(f,D,w,C,P,V){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:w,thisArg:C,metadata:P,extension:V}),f&&this.#e.$registerCommand(D),new T.$RM(()=>{this.b.delete(D)&&f&&this.#e.$unregisterCommand(D)})}executeCommand(f,...D){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,D,!0)}async g(f,D,w){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,D,!1);{let C=!1;const P=(0,O.$Yn)(D,function(V){if(V instanceof T.$SM)return A.Position.from(V);if(V instanceof T.$TM)return A.Range.from(V);if(V instanceof T.$4M)return A.location.from(V);if(T.$gO.isNotebookRange(V))return A.NotebookRange.from(V);if(V instanceof ArrayBuffer)return C=!0,r.$Ce.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return C=!0,r.$Ce.wrap(V);if(V instanceof r.$Ce)return C=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(f,C?new n.$lw(P):P,w);return(0,k.$Zh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,D,!1);throw V}}}async h(f,D,w){const C=this.b.get(f);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=C;if(W?.args)for(let R=0;R<W.args.length;R++)try{(0,I.$ig)(D[R],W.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${W.args[R].name}' - ${W.args[R].description}`)}const q=c.$0d.create();try{return await P.apply(V,D)}catch(R){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...D);j&&(f=j.command)}if(this.d.error(R,f,C.extension?.identifier),!w)throw R;if(C.extension?.identifier){const j=this.#i.onExtensionError(C.extension.identifier,R);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$bj)(R)),this.id=f,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,f,q.elapsed())}}j(f,D,w){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$_o(D),duration:w})}$executeContributedCommand(f,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const w=this.b.get(f);return w?(D=D.map(C=>this.f.reduce((P,V)=>V.processArgument(P,w.extension?.identifier),C)),this.h(f,D,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(D=>(f&&(D=D.filter(w=>w[0]!=="_")),D))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[D,w]of this.b){const{metadata:C}=w;C&&(f[D]=C)}return Promise.resolve(f)}};e.$xP=a,e.$xP=a=Je([Ve(0,s.$cP),Ve(1,g.$Wj),Ve(2,i.$wP)],a),e.$yP=(0,m.$qi)("IExtHostCommands");class ${constructor(f,D,w){this.d=f,this.f=D,this.g=w,this.delegatingCommandId=`__vsc${(0,b.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,D){if(!f)return;const w={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return w;const C=this.f(f.command);if(C)w.id=C.internalId,w.arguments=C.args.map((P,V)=>P.convert(f.arguments&&f.arguments[V]));else if((0,p.$Lb)(f.arguments)){const P=`${f.command} /${++this.c}`;this.b.set(P,f),D.add((0,v.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),w.$ident=P,w.id=this.delegatingCommandId,w.arguments=[P],this.g.trace("CommandsConverter#CREATE",f.command,P)}return w}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const D=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$zP=$;class l{static{this.Uri=new l("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new l("position","A position in a text document",f=>T.$SM.isPosition(f),A.Position.from)}static{this.Range=new l("range","A range in a text document",f=>T.$TM.isRange(f),A.Range.from)}static{this.Selection=new l("selection","A selection in a text document",f=>T.$UM.isSelection(f),A.Selection.from)}static{this.Number=new l("number","",f=>typeof f=="number",f=>f)}static{this.String=new l("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=l.Arr(l.String)}static Arr(f){return new l(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,D=>Array.isArray(D)&&D.every(w=>f.validate(w)),D=>D.map(w=>f.convert(w)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",f=>f instanceof T.$cN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",f=>f instanceof T.$AO,A.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",f=>f instanceof o.$pP,A.TestItem.from)}constructor(f,D,w,C){this.name=f,this.description=D,this.validate=w,this.convert=C}optional(){return new l(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,D){return new l(f??this.name,D??this.description,this.validate,this.convert)}}e.$AP=l;class S{static{this.Void=new S("no result",f=>f)}constructor(f,D){this.description=f,this.convert=D}}e.$BP=S;class d{constructor(f,D,w,C,P){this.id=f,this.internalId=D,this.description=w,this.args=C,this.result=P}}e.$CP=d}),define(Ae[274],Re([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;const y=[new g.$CP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new g.$CP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$AP.Uri],new g.$BP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,I.$Kb)(s))return;class r extends N.$0M{static to(t){const c=new r(t.name,k.SymbolKind.to(t.kind),t.containerName||"",new N.$4M(o[0],k.Range.to(t.range)));return c.detail=t.detail,c.range=c.location.range,c.selectionRange=k.Range.to(t.selectionRange),c.children=t.children?t.children.map(r.to):[],c}}return s.map(r.to)})),new g.$CP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$AP.Uri,new g.$AP("options","Formatting options",s=>!0,s=>s)],new g.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$CP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$AP.Uri,g.$AP.Range,new g.$AP("options","Formatting options",s=>!0,s=>s)],new g.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$CP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$AP.Uri,g.$AP.Position,new g.$AP("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$AP("options","Formatting options",s=>!0,s=>s)],new g.$BP("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new g.$CP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$CP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$CP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$CP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$CP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Location-instances.",v(k.location.to))),new g.$CP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new g.$CP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$AP.Uri,new g.$AP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>N.$SM.isPosition(o)),s=>s.map(k.Position.from))],new g.$BP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let r;for(const n of o.reverse())r=new N.$bN(k.Range.to(n),r);return r}))),new g.$CP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$AP.String.with("query","Search string")],new g.$BP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new g.$CP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new g.$CP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$AP.CallHierarchyItem],new g.$BP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new g.$CP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$AP.CallHierarchyItem],new g.$BP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new g.$CP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new g.$CP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$AP.Uri,g.$AP.Position,g.$AP.String.with("newName","The new symbol name")],new g.$BP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new g.$CP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$AP.Uri,g.$AP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$BP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new g.$CP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$AP.Uri],new g.$BP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$0N(s.tokenTypes,s.tokenModifiers)})),new g.$CP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$AP.Uri],new g.$BP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Gbb)(s);if(o.type==="full")return new N.$_N(o.data,void 0)})),new g.$CP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$AP.Uri,g.$AP.Range.optional()],new g.$BP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$0N(s.tokenTypes,s.tokenModifiers)})),new g.$CP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$AP.Uri,g.$AP.Range],new g.$BP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Gbb)(s);if(o.type==="full")return new N.$_N(o.data,void 0)})),new g.$CP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$AP.Uri,g.$AP.Position,g.$AP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$AP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$BP("A promise that resolves to a CompletionList-instance.",(s,o,r)=>{if(!s)return new N.$nN([]);const n=s.suggestions.map(t=>k.CompletionItem.to(t,r));return new N.$nN(n,s.incomplete)})),new g.$CP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$AP.Uri,g.$AP.Position,g.$AP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$BP("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new g.$CP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$AP.Uri,g.$AP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$BP("A promise that resolves to an array of CodeLens-instances.",(s,o,r)=>v(n=>new N.$fN(k.Range.to(n.range),n.command&&r.fromInternal(n.command)))(s))),new g.$CP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$AP.Uri,new g.$AP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$TM.isRange(s),s=>N.$UM.isSelection(s)?k.Selection.from(s):k.Range.from(s)),g.$AP.String.with("kind","Code action kind to return code actions for").optional(),g.$AP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$BP("A promise that resolves to an array of Command-instances.",(s,o,r)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(n.command)}else{const t=new N.$_M(n.title,n.kind?new N.$aN(n.kind):void 0);return n.edit&&(t.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(t.command=r.fromInternal(n.command)),t.isPreferred=n.isPreferred,t}})(s))),new g.$CP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$AP.Uri],new g.$BP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new N.$tN(k.Range.to(o.range),k.Color.to(o.color))):[])),new g.$CP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$AP("color","The color to show and insert",s=>s instanceof N.$sN,k.Color.from),new g.$AP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new g.$BP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new g.$CP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$AP.Uri,g.$AP.Range],new g.$BP("A promise that resolves to an array of Inlay objects",(s,o,r)=>s.map(k.InlayHint.to.bind(void 0,r)))),new g.$CP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$AP.Uri],new g.$BP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(k.FoldingRange.to)})),new g.$CP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$BP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new g.$CP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$AP.Uri,g.$AP.Range,new g.$AP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$TM,s=>k.InlineValueContext.from(s))],new g.$BP("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new g.$CP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$AP("uriOrString","Uri-instance or string (only http/https)",s=>A.URI.isUri(s)||typeof s=="string"&&(0,T.$Ag)(s,T.Schemas.http,T.Schemas.https),s=>s),new g.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),g.$AP.String.with("label","").optional()],g.$BP.Void),new g.$CP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$AP.Uri.with("resource","Resource to open"),g.$AP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],g.$BP.Void),new g.$CP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$AP.Uri.with("left","Left-hand side resource of the diff editor"),g.$AP.Uri.with("right","Right-hand side resource of the diff editor"),g.$AP.String.with("title","Human readable title for the diff editor").optional(),new g.$AP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],g.$BP.Void),new g.$CP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$AP.String.with("title","Human readable title for the changes editor"),new g.$AP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[r,n,t]=o;if(!A.URI.isUri(r)||!A.URI.isUri(n)&&n!==void 0&&n!==null||!A.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},s=>s)],g.$BP.Void),new g.$CP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$AP.Uri,g.$AP.Position],new g.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$CP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$AP.TypeHierarchyItem],new g.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$CP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$AP.TypeHierarchyItem],new g.$BP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new g.$CP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$AP.TestItem],g.$BP.Void),new g.$CP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$AP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$BP.Void),new g.$CP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$AP.String.with("name","The context key name"),new g.$AP("value","The context key value",()=>!0,s=>s)],g.$BP.Void),new g.$CP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$AP.Uri,g.$AP.StringArray,new g.$AP("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new g.$BP("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$Bkc=u;function v(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const r of s)O.$2t(r)?o.push(k.DefinitionLink.to(r)):o.push(k.location.to(r));return o}}),define(Ae[275],Re([1,0,11,6,2,4,32,8,7]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class k{static{this.a=0}constructor(v,m){this.extension=v,this.provider=m,this.handle=k.a++}}class N{constructor(v){this.session=v,this.responses=[]}}class y{static{this.a=0}constructor(v,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(O.$PM.MainThreadInlineChat),m.registerApiCommand(new M.$CP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$AP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?p.Range.from(r.initialRange):void 0,initialSelection:g.$UM.isSelection(r.initialSelection)?p.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?p.Position.from(r.position):void 0}})],M.$BP.Void))}registerProvider(v,m,s){const o=new k(v,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??v.displayName??v.name,v.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,T.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,m,s,o){const r=this.b.get(v);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(A.URI.revive(m)),t=p.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:n,selection:t},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(t))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new N(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,m,s,o){const r=this.b.get(v);if(!r)return;const n=this.d.get(m.id);if(!n)return;const t={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(A.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async E=>{if(!s.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:g.$gN.isMarkdownString(E.content)?E.content.value:E.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(n.session,t,h,o));let b;try{b=await(0,I.$eh)(i,o)}finally{c=!0}if(!b)return;const a=n.responses.push(b)-1,$={wholeRange:p.Range.from(b.wholeRange),placeholder:b.placeholder};if(!y.h(b))return{...$,id:a,type:"editorEdit",message:p.MarkdownString.from(b.contents),edits:[]};const{edits:l,contents:S}=b,d=S!==void 0?p.MarkdownString.from(S):void 0;return l instanceof g.$2M?{...$,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(l),message:d}:{...$,id:a,type:"editorEdit",edits:l.map(p.TextEdit.from),message:d}}async $provideFollowups(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(n.session,t,o));return(await(0,I.$eh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(v,m,s,o){const r=this.b.get(v),n=this.d.get(m),t=n?.responses[s];if(r&&t){const c=p.InteractiveEditorResponseFeedbackKind.to(o);r.provider.handleInteractiveEditorResponseFeedback?.(n.session,t,c)}}$releaseSession(v,m){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Klc=y}),define(Ae[276],Re([1,0,2,32]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class A{constructor(M,p,g,k,N){this.a=p,this.b=g,this.c=k;const y=new T.$CP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$AP("showOptions","Show Options",u=>!0,u=>u),new T.$AP("resource","Interactive resource Uri",u=>!0,u=>u),new T.$AP("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$AP("title","Interactive editor title",u=>!0,u=>u)],new T.$BP("Notebook and input URI",u=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const v=this.a.getEditorById(u.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:v.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,g,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Xlc=A}),define(Ae[277],Re([1,0,18,11,22,5,6,28,2,20,13,4,32,8,7,76,218,25,34,219]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0,e.$6lc=l;let c=class{constructor(d,E,f,D,w){this.m=E,this.n=f,this.o=D,this.q=w,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(y.$PM.MainThreadNotebookKernels);const C=new u.$CP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$AP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],u.$BP.Void),P=new u.$CP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$AP.Uri],new u.$BP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(d,E,f,D,w,C){for(const Pe of this.j.values())if(Pe.controller.id===E&&k.$Lm.equals(d.identifier,Pe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${E}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${d.identifier}'`);let q=!1;const R=new O.$be,j=new O.$be,K={id:l(d.identifier,E),notebookType:f,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:D||d.identifier.value,preloads:C?C.map(v.NotebookRendererScript.from):[]};let se=w??W,ce,ve;this.a.$addKernel(P,K).catch(Pe=>{console.log(Pe),q=!0});let Ie=0;const ue=()=>{if(q)return;const Pe=++Ie;Promise.resolve().then(()=>{Pe===Ie&&this.a.$updateKernel(P,K)})},be=new p.$Bc,ie={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return K.label},set label(Pe){K.label=Pe??d.displayName??d.name,ue()},get detail(){return K.detail??""},set detail(Pe){K.detail=Pe,ue()},get description(){return K.description??""},set description(Pe){K.description=Pe,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Pe){K.supportedLanguages=Pe,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Pe){K.supportsExecutionOrder=Pe,ue()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler(Pe){se=Pe??W},get interruptHandler(){return ce},set interruptHandler(Pe){ce=Pe,K.supportsInterrupt=!!Pe,ue()},set variableProvider(Pe){(0,r.$xG)(d,"notebookVariableProvider"),ve=Pe,K.hasVariableProvider=!!Pe,Pe?.onDidChangeVariables(Fe=>V.a.$variablesUpdated(Fe.uri)),ue()},get variableProvider(){return ve},createNotebookCellExecution(Pe){if(q)throw new Error("notebook controller is DISPOSED");if(!be.has(Pe.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Pe.notebook.uri.toString()}`);return V._createNotebookCellExecution(Pe,l(d.identifier,this.id))},createNotebookExecution(Pe){if((0,r.$xG)(d,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!be.has(Pe.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(be.keys()).map(Fe=>Fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Pe.uri.toString()}`);return V._createNotebookExecution(Pe,l(d.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),R.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Pe,Fe){Fe===m.NotebookControllerAffinity2.Hidden&&(0,r.$xG)(d,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,Pe.uri,Fe)},onDidReceiveMessage:j.event,postMessage(Pe,Fe){return(0,r.$xG)(d,"notebookMessaging"),V.a.$postMessage(P,Fe&&V.n.getIdByEditor(Fe),Pe)},asWebviewUri(Pe){return(0,r.$xG)(d,"notebookMessaging"),(0,s.$5xb)(Pe,V.m.remote)}};return this.j.set(P,{extensionId:d.identifier,controller:ie,onDidReceiveMessage:j,onDidChangeSelection:R,associatedNotebooks:be}),ie}getIdByController(d){for(const[E,f]of this.j)if(f.controller===d)return l(f.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,E){const f=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(f,E);const w={dispose:()=>{this.f.delete(f),D.a.$removeKernelDetectionTask(f)}};return this.f.set(f,w),w}registerKernelSourceActionProvider(d,E,f){const D=this.i++,w=typeof f.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,f),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,E);let P;return w!==void 0&&(P=f.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),P?.dispose()}}}async $provideKernelSourceActions(d,E){const f=this.h.get(d);if(f){const D=new M.$Tc;return(await f.provideNotebookKernelSourceActions(E)??[]).map(C=>v.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(d,E,f){const D=this.j.get(d);if(D){const w=this.n.getNotebookDocument(g.URI.revive(E));f?D.associatedNotebooks.set(w.uri,!0):D.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),f),D.onDidChangeSelection.fire({selected:f,notebook:w.apiNotebook})}}async $executeCells(d,E,f){const D=this.j.get(d);if(!D)return;const w=this.n.getNotebookDocument(g.URI.revive(E)),C=[];for(const P of f){const V=w.getCell(P);V&&C.push(V.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,w.apiNotebook,D.controller)}catch(P){this.q.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,E,f){const D=this.j.get(d);if(!D)return;const w=this.n.getNotebookDocument(g.URI.revive(E));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,w.apiNotebook);else for(const C of f){const P=w.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(w.uri);f.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(d,E,f,D,w,C,P){const V=this.j.get(d);if(!V)return;const W=this.n.getNotebookDocument(g.URI.revive(f)),q=V.controller.variableProvider;if(!q)return;let R;if(D!==void 0){if(R=this.s[D],!R)return}else this.s={};const j=w==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,R,j,C,P);let se=0;for await(const ce of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(E,ve),se++>=t.$Iib)return}}$acceptKernelMessageFromRenderer(d,E,f){const D=this.j.get(d);if(!D)return;const w=this.n.getEditorById(E);D.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:f}))}$cellExecutionChanged(d,E,f){const w=this.n.getNotebookDocument(g.URI.revive(d)).getCell(E);if(w){const C=f?v.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:w.apiCell,state:C})}}_createNotebookCellExecution(d,E){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const w=new i(E,D,this.a);this.b.set(D.uri,w);const C=w.onDidChangeState(()=>{w.state===h.Resolved&&(w.dispose(),C.dispose(),this.b.delete(D.uri))});return w.asApiObject()}_createNotebookExecution(d,E){const f=this.n.getNotebookDocument(d.uri),D=d.getCells().find(P=>{const V=f.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const w=new a(E,f,this.a),C=w.onDidChangeState(()=>{w.state===b.Resolved&&(w.dispose(),C.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[w,C]),w.asApiObject()}};e.$5lc=c,e.$5lc=c=Je([Ve(4,N.$Wj)],c);var h;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(h||(h={}));class i extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,E,f){super(),this.m=E,this.n=f,this.b=i.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new A.$me),this.h=new $(10,D=>this.s(D)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const E=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new n.$lw(E))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let E=this.m;if(d&&(E=this.m.notebook.getCellFromApiCell(d)),!E)throw new Error("INVALID cell");return E.handle}y(d){return d.map(E=>{const f=m.$kO.ensureUniqueMimeTypes(E.items,!0);return f===E.items?v.NotebookCellOutput.from(E):v.NotebookCellOutput.from({items:f,id:E.id,metadata:E.metadata})})}async z(d,E,f){const D=this.w(E),w=this.y((0,I.$3b)(d));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:D,append:f,outputs:w})}async C(d,E,f){return d=m.$kO.ensureUniqueMimeTypes((0,I.$3b)(d),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(v.NotebookCellOutputItem.from),outputId:E.id,append:f})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(f){d.j=f,d.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(f){if(d.f===h.Resolved||d.f===h.Started)throw new Error("Cannot call start again");d.f=h.Started,d.c.fire(),d.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,D,w){if(d.f===h.Resolved)throw new Error("Cannot call resolve twice");d.f=h.Resolved,d.c.fire(),d.h.flush();const C=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;d.n.$completeExecution(d.b,new n.$lw({runEndTime:D,lastRunSuccess:f,error:C}))},clearOutput(f){return d.t(),d.z([],f,!1)},appendOutput(f,D){return d.t(),d.z(f,D,!0)},replaceOutput(f,D){return d.t(),d.z(f,D,!1)},appendOutputItems(f,D){return d.t(),d.C(f,D,!0)},replaceOutputItems(f,D){return d.t(),d.C(f,D,!1)}})}}var b;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(b||(b={}));class a extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(d,E,f){super(),this.h=E,this.j=f,this.b=a.a++,this.c=new O.$be,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new A.$me),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(d,E){this.f=d,this.g=E,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new T.$Nh,this.b=Date.now(),(0,T.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>d.complete())}}function l(S,d){return`${S.value}/${d}`}}),define(Ae[51],Re([1,0,5,4,3,2,16,6,7,171,14,200,22,35,201,42,11,8,32]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=e.$elc=e.$dlc=void 0,e.$dlc=(0,A.$qi)("IExtHostTerminalService");class t extends p.$Uc{constructor(f,D,w,C){super(),this.u=f,this._id=D,this.w=w,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??D?.cwd??void 0,env:f.env??void 0,icon:l(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(f.location,D?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,D,w,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:D?.location||this.z(f,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,D){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in f?{viewColumn:r.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,D){this.j=Object.freeze({code:f,reason:D})}setDimensions(f,D){return f===this.f&&D===this.h||f===0||D===0?!1:(this.f=f,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(D=>{D!==f&&(this.b=Promise.resolve(f))})}}e.$elc=t;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,D){this.g.setDimensions?.({columns:f,rows:D})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,D,w){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(T.$PM.MainThreadTerminalService),this.y=new m.$4sb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:C=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let V=0;V<C.length&&C[V].$mid===15;V++)C[V]=P(C[V]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,D){const w=new t(this.a,(0,v.$Mg)(),f,f.name),C=new c(f.pty);return w.createExtensionTerminal(f.location,D,this.R(f,D).resolvedExtHostIdentifier,l(f.iconPath),S(f.color)).then(P=>{const V=this.S(P,C);this.h[P]=V}),this.f.push(w),w.value}R(f,D){if(D=D||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const w=f.location.parentTerminal;if(w){const C=this.f.find(P=>P.value===w);C&&(D.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?D.location=f.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(f,D){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new c(D),P=this.S(f,C);this.h[f]=P}async $acceptActiveTerminalChanged(f){const D=this.b;if(f===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const w=this.getTerminalById(f);w&&(this.b=w,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,D){const w=this.getTerminalById(f);w&&this.O.fire({terminal:w.value,data:D})}async $acceptTerminalDimensions(f,D,w){const C=this.getTerminalById(f);C&&C.setDimensions(D,w)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(f,D){const w=this.getTerminalById(f);w&&this.P.fire({terminal:w.value,...D})}async $acceptTerminalMaximumDimensions(f,D,w){this.g.get(f)?.resize(D,w)}async $acceptTerminalTitleChange(f,D){const w=this.getTerminalById(f);w&&(w.name=D)}async $acceptTerminalClosed(f,D,w){const C=this.X(this.f,f);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(D,w),this.H.fire(P.value)}}$acceptTerminalOpened(f,D,w,C){if(D){const W=this.X(this.f,D);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new t(this.a,f,P,w);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(f,D){this.getTerminalById(f)?._setProcessId(D)}async $startExtensionTerminal(f,D){const w=this.getTerminalById(f);if(!w)return{message:(0,k.localize)(0,null,f)};w.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===w.value&&(V.dispose(),P())})});const C=this.g.get(f);C?C.startSendingEvents(D):this.j[f]={initialDimensions:D}}S(f,D){const w=new p.$Tc;w.add(D.onProcessReady(P=>this.a.$sendProcessReady(f,P.pid,P.cwd,P.windowsPty))),w.add(D.onDidChangeProperty(P=>this.a.$sendProcessProperty(f,P))),this.y.startBuffering(f,D.onProcessData),w.add(D.onProcessExit(P=>this.U(f,P))),this.g.set(f,D);const C=this.j[f];return C&&D instanceof c&&(D.startSendingEvents(C.initialDimensions),delete this.j[f]),w}$acceptProcessAckDataEvent(f,D){this.g.get(f)?.acknowledgeDataEvent(D)}$acceptProcessInput(f,D){this.g.get(f)?.input(D)}$acceptTerminalInteraction(f){const D=this.getTerminalById(f);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(f,D){this.getTerminalById(f)?.setSelection(D)}$acceptProcessResize(f,D,w){try{this.g.get(f)?.resize(D,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,D){this.g.get(f)?.shutdown(D)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(D=>this.a.$sendProcessProperty(f,{type:"cwd",value:D}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$RM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,D,w){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,w),this.a.$registerProfileProvider(D,f.identifier.value),new g.$RM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(f,D,w){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,w),this.a.$registerQuickFixProvider(f,D),new g.$RM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,D){const w=new u.$me().token;if(w.isCancellationRequested)return;const C=this.D.get(f);if(!C)return;const P=await C.provideTerminalQuickFixes(D,w);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?r.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const R=r.TerminalQuickFix.from(q,this.Q.converter,V);R&&W.push(R)}return W}async $createContributedProfileTerminal(f,D){const w=new u.$me().token;let C=await this.C.get(f)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks(f,D){const w=this.getTerminalById(f);if(!w)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const P=new u.$me;this.G.set(f,P);const V=[],W={terminal:w.value,line:D},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async se=>{P.token.onCancellationRequested(()=>se({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||se({provider:K,links:ce})}));const R=await Promise.all(q);if(P.token.isCancellationRequested)return[];const j=new Map;for(const K of R)K&&K.links.length>0&&V.push(...K.links.map(se=>{const ce={id:h++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return j.set(ce.id,{provider:K.provider,link:se}),ce}));return this.F.set(f,j),V}$activateLink(f,D){const w=this.F.get(f)?.get(D);w&&w.provider.handleTerminalLink(w.link)}U(f,D){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const w=this.h[f];w&&(w.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,D)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const D=this.f.findIndex(w=>w.value===f);return D>=0?D:null}W(f,D){const w=this.X(f,D);return w!==null?f[w]:null}X(f,D){const w=f.findIndex(C=>C._id===D);return w>=0?w:null}getEnvironmentVariableCollection(f){let D=this.n.get(f.identifier.value);return D||(D=new b,this.Z(f.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(f,D){const w=(0,y.$cs)(D.map),C=(0,y.$ds)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(f,D.persistent,w.length===0?void 0:w,C)}$initEnvironmentVariableCollections(f){f.forEach(D=>{const w=D[0],C=new b(D[1]);this.Z(w,C)})}$acceptDefaultProfile(f,D){const w=this.s;this.s=f,this.u=D,w?.path!==f.path&&this.N.fire(f.path)}Z(f,D){this.n.set(f,D),D.onDidChangeCollection(()=>{this.Y(f,D)})}};e.$flc=i,e.$flc=i=Je([Ve(1,n.$yP),Ve(2,M.$cP)],i);class b{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const D=this.h(f);let w=this.a.get(D);return w||(w=new a(this,f),this.a.set(D,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:C})}append(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:C})}prepend(f,D,w,C){this.f(f,{value:D,type:g.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:C})}f(f,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(f,D.scope),C=this.map.get(w),P=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const V=this.g(f,D.scope),W={variable:f,...D,options:P};this.map.set(V,W),this.d.fire()}}get(f,D){const w=this.g(f,D),C=this.map.get(w);return C?d(C):void 0}g(f,D){const w=this.h(D);return w.length?`${f}:::${w}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const D=new Map;for(const[w,C]of this.map)this.h(C.scope)===this.h(f)&&D.set(C.variable,d(C));return D}delete(f,D){const w=this.g(f,D);this.map.delete(w),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[D,w]of this.map)w.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(D);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,D){const w=this.h(D),C=this.descriptionMap.get(w);if(!C||C.description!==f){let P;typeof f=="string"?P=f:P=f?.value.split(`

`)[0];const V={description:P,scope:D};this.descriptionMap.set(w,V),this.d.fire()}}getDescription(f){const D=this.h(f);return this.descriptionMap.get(D)?.description}k(f){const D=this.h(f);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,D){this.b=f,this.d=D,this.a=new I.$be}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,D,w){this.b.replace(f,D,w,this.d)}append(f,D,w){this.b.append(f,D,w,this.d)}prepend(f,D,w){this.b.prepend(f,D,w,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,D){this.b.getVariableMap(this.d).forEach((w,C)=>f.call(D,C,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends i{constructor(f,D){super(!1,f,D)}createTerminal(f,D,w){throw new N.$_}createTerminalFromOptions(f,D){throw new N.$_}};e.$glc=$,e.$glc=$=Je([Ve(0,n.$yP),Ve(1,M.$cP)],$);function l(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function S(E){return s.ThemeColor.isThemeColor(E)?E:void 0}function d(E){const f={...E};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ae[114],Re([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0,e.$kmc=(0,A.$qi)("IExtHostTerminalShellIntegration");let y=class extends T.$Uc{constructor(o,r){super(),this.h=r,this.b=new Map,this.c=new g.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$PM.MainThreadTerminalShellIntegration),this.B((0,T.$Sc)(()=>{for(const[n,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const r=this.h.getTerminalById(o);if(!r)return;const n=r.value;let t=this.b.get(o);t||(t=new u(r.value,this.f),this.b.set(o,t),t.store.add(r.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),t.store.add(t.onDidRequestEndExecution(c=>this.g.fire(c))),t.store.add(t.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),r.shellIntegration=t.value),this.c.fire({terminal:n,shellIntegration:t.value})}$shellExecutionStart(o,r,n,t,c){this.b.has(o)||this.$shellIntegrationChange(o);const h={value:r,confidence:n,isTrusted:t};this.b.get(o)?.startShellExecution(h,c)}$shellExecutionEnd(o,r,n,t,c){const h={value:r,confidence:n,isTrusted:t};this.b.get(o)?.endShellExecution(h,c)}$shellExecutionData(o,r){this.b.get(o)?.emitData(r)}$cwdChange(o,r){this.b.get(o)?.setCwd((0,k.$wc)(r)?k.URI.revive(r):r)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$lmc=y,e.$lmc=y=Je([Ve(0,M.$cP),Ve(1,p.$dlc)],y);class u extends T.$Uc{get currentExecution(){return this.a}constructor(o,r){super(),this.j=o,this.m=r,this.b=!1,this.store=this.B(new T.$Tc),this.f=this.B(new g.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(t,c){let h=t;c&&(h+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(h);const i={value:h,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},b=n.startShellExecution(i,n.c,!0).value;return n.b=!0,b}}}startShellExecution(o,r,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new v(o,r);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,r){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:r}),this.a=void 0)}setCwd(o){let r=!1;k.URI.isUri(this.c)?r=!k.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(r=!0),r&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,r){this.c=o,this.cwd=r,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return N.$Qh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends T.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const o=this.a=new N.$ph;return new N.$Qh(async n=>{this.b.push(n),await o.wait()})}emitData(o){for(const r of this.b)r.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ae[278],Re([1,0,11,23,22,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=e.$nmc=e.$mmc=void 0;let c=class extends g.$Uc{constructor(P,V,W,q){super(),this.w=q,this.f=this.B(new O.$be),this.g=new Map,this.s=this.B(new O.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(u.$PM.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,V),W.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const j=R,K=j.tests[j.tests.length-1].item.extId;return this.g.get(r.$BL.root(K))?.collection.tree.get(K)?.actual??(0,m.$oP)(R)}case 18:{const{test:j,message:K}=R,se=j.item.extId;return{test:this.g.get(r.$BL.root(se))?.collection.tree.get(se)?.actual??(0,m.$oP)({$mid:16,tests:[j]}),message:s.TestMessage.to(K)}}default:return R}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await W.executeCommand("_testing.getExplorerSelection"),j=K=>{const se=this.g.get(r.$BL.root(K));if(se)return r.$BL.isRoot(K)?se.controller:se.collection.tree.get(K)?.actual};return{include:R?.include.map(j).filter(k.$_f)||[],exclude:R?.exclude.map(j).filter(k.$_f)||[]}})}createTestController(P,V,W,q){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const R=new g.$Tc,j=R.add(new m.$rP(V,W,this.w));j.root.label=W;const K=new Map,se=new Set,ce=this.h,ve={items:j.root.children,get label(){return W},set label(ue){W=ue,j.root.label=ue,ce.$updateController(V,{label:W})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(V,{canRefresh:!!ue})},get id(){return V},createRunProfile:(ue,be,ie,Pe,Fe,ne)=>{let U=(0,p.$ej)(ue);for(;K.has(U);)U++;return new D(this.h,K,se,this.s.event,V,U,ue,be,ie,Pe,Fe,ne)},createTestItem(ue,be,ie){return new m.$pP(V,ue,be,ie)},createTestRun:(ue,be,ie=!0)=>this.j.createTestRun(V,j,ue,be,ie),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const be=ue instanceof Array?ue:[ue];this.h.$markTestRetired(be.map(ie=>r.$BL.fromExtHostTestItem(ie,V).toString()))}},set resolveHandler(ue){j.resolveHandler=ue},get resolveHandler(){return j.resolveHandler},dispose:()=>{R.dispose()}};ce.$registerTestController(V,W,!!q),R.add((0,g.$Sc)(()=>ce.$unregisterTestController(V)));const Ie={controller:ve,collection:j,profiles:K,extension:P,activeProfiles:se};return this.g.set(V,Ie),R.add((0,g.$Sc)(()=>this.g.delete(V))),R.add(j.onDidGenerateDiff(ue=>ce.$publishDiff(V,ue.map(t.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(P,V=A.CancellationToken.None){const W=$(P);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(W.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(R=>r.$BL.fromExtHostTestItem(R,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:w[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:P.exclude?.map(R=>R.id)},V)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,V){return(await this.j.getCoverageDetails(P,V))?.map(s.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,V){this.g.get(P)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(P){const V=new Map;for(const[W,q]of Object.entries(P)){const R=this.g.get(W);if(!R)continue;const j=new Map,K=q.filter(ce=>!R.activeProfiles.has(ce)),se=[...R.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)j.set(ce,!0),R.activeProfiles.add(ce);for(const ce of se)j.set(ce,!1),R.activeProfiles.delete(ce);j.size&&V.set(W,j)}this.s.fire(V)}async $refreshTests(P,V){await this.g.get(P)?.controller.refreshHandler?.(V)}$publishTestResults(P){this.results=Object.freeze(P.map(s.TestResults.to).concat(this.results).sort((V,W)=>W.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,V){const W=this.g.get(r.$BL.fromString(P).controllerId)?.collection;W&&(await W.expand(P,V<0?1/0:V),W.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(V=>t.TestsDiffOp.deserialize({asCanonicalUri:W=>W},V)))}async $runControllerTests(P,V){return Promise.all(P.map(W=>this.y(W,!1,V)))}async $startContinuousRun(P,V){const W=new A.$me(V),q=await Promise.all(P.map(R=>this.y(R,!0,W.token)));return!V.isCancellationRequested&&!q.some(R=>R.error)&&await new Promise(R=>V.onCancellationRequested(R)),W.dispose(!0),q}async y(P,V,W){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:R,profiles:j}=q,K=j.get(P.profileId);if(!K)return{};const se=P.testIds.map(ue=>R.tree.get(ue)).filter(k.$_f),ce=P.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(k.$_f).filter(ue=>se.some(be=>be.fullId.compare(ue.fullId)===2));if(!se.length)return{};const ve=new o.$rO(se.some(ue=>ue.actual instanceof m.$qP)?void 0:se.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,V),Ie=(0,t.$EL)(P)&&this.j.prepareForMainThreadTestRun(ve,l.fromInternal(P,q.collection),K,W);try{return await K.runHandler(ve,W),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!W.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$mmc=c,e.$mmc=c=Je([Ve(0,v.$cP),Ve(1,y.$Wj)],c);const h=1e4;var i;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(i||(i={}));class b extends g.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,V,W,q,R){super(),this.y=P,this.z=V,this.C=W,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$me(R));const j=this.B(new I.$Ch(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new O.$be;this.s=K.event,this.B((0,g.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,V){const[,W,q]=r.$BL.fromString(P).path,R=this.w.get(q);if(!R)return[];const j=this.g.get(W);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,R,V)??[]}createRun(P){const V=this.y.id,W=this.y.controllerId,q=(0,N.$Mg)(),R=ce=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Ie))},j=(ce,ve)=>{const Ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(ce.uri&&ce.range){const ue={range:s.Range.from(ce.range),uri:ce.uri};for(const be of Ie)be.location=be.location||ue}this.z.$appendTestMessagesInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),Ie)};let K=!1;const se={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Ie=new r.$BL([V,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(V,q,s.TestCoverage.fromFile(Ie,ce))},enqueued:R(ce=>{this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),1)}),skipped:R(ce=>{this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),5)}),started:R(ce=>{this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),2)}),errored:R((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),6,Ie)}),failed:R((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,W).toString(),4,Ie)}),passed:R((ce,ve)=>{this.z.$updateTestStateInRun(V,q,r.$BL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(V,q,T.$Ce.fromString(ce),ve&&s.location.from(ve),Ie&&r.$BL.fromExtHostTestItem(Ie,W).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(V,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:se}),this.z.$startedTestRunTask(V,{id:q,name:P,running:!0}),se}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof m.$pP))throw new n.$7O(P.id);if(this.h.has(r.$BL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const V=[],W=this.y.colllection.root;for(;;){const q=s.TestItem.from(P);if(V.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===W))break;P=P.parent||W}this.z.$addTestsToRun(this.y.controllerId,this.y.id,V)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(P,V){this.g=P,this.h=V,this.c=new Map,this.f=new Map}getCoverageDetails(P,V){const W=r.$BL.root(P);return this.f.get(W)?.getCoverageDetails(P,V)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[V,{id:W}]of this.c)W===P&&this.c.delete(V)}prepareForMainThreadTestRun(P,V,W,q){return this.j(P,V,W,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,V,W,q,R){const j=this.c.get(W);if(j)return j.createRun(q);const K=l.fromPublic(P,V,W,R),se=$(W);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!W.continuous,profile:se&&{group:w[se.kind],id:se.profileId},exclude:W.exclude?.map(ve=>r.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[],id:K.id,include:W.include?.map(ve=>r.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[V.root.id],persist:R});const ce=this.j(W,K,W.profile);return O.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,V,W,q){const R=new b(V,this.g,this.h,W,q);return this.c.set(P,R),this.f.set(R.id,R),R}}e.$nmc=a;const $=C=>{if(C.profile){if(!(C.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class l{static fromPublic(P,V,W,q){return new l(P,(0,N.$Mg)(),W.include?.map(R=>r.$BL.fromExtHostTestItem(R,P).toString())??[P],W.exclude?.map(R=>r.$BL.fromExtHostTestItem(R,P).toString())??[],q,V)}static fromInternal(P,V){return new l(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,V)}constructor(P,V,W,q,R,j){this.controllerId=P,this.id=V,this.isPersisted=R,this.colllection=j,this.c=W.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const V=r.$BL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const W of this.f)if(V===W||V.startsWith(W))return!1;for(const W of this.c)if(V===W||V.startsWith(W))return!0;return!1}}e.$omc=l;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const V=r.$BL.parentId(P.item.extId);if(V&&this.h.has(V.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:V,g:W}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...V].map(q=>q.revived)},get removed(){return[...W].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends t.$KL{constructor(){super(...arguments),this.s=new O.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,V){return{...P,revived:s.TestItem.toPlain(P.item),depth:V?V.depth+1:0,children:new Set}}v(){return new S(this.s)}}class E{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(V=>V.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new d({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const f=(C,P,V,W)=>{V?Object.assign(V,W):P.$updateTestRunConfig(C.controllerId,C.profileId,W)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,f(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,f(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,f(this,this.#e,this.#n,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,f(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(k.$_f))}constructor(P,V,W,q,R,j,K,se,ce,ve=!1,Ie=void 0,ue=!1){this.controllerId=R,this.profileId=j,this.f=K,this.kind=se,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=P,this.#s=V,this.#t=W,this.#i=q,V.set(j,this);const be=w[se];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);ve&&W.add(j),this.#n={profileId:j,controllerId:R,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:be,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$pmc=D;const w={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ae[115],Re([1,0,56,14,90,8,7]),function(ge,e,I,T,A,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=e.$jP=void 0;class p{static{this.c=new A.$hP("TextEditorDecorationType")}constructor(u,v,m){const s=p.c.nextId();u.$registerTextEditorDecorationType(v.identifier,s,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.$jP=p;class g{constructor(u,v){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,v){this.k();let m=null;if(u instanceof M.$SM)m=new M.$TM(u,u);else if(u instanceof M.$TM)m=u;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(u,v){this.k(),this.l(new M.$TM(u,u),v,!0)}delete(u){this.k();let v=null;if(u instanceof M.$TM)v=u;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(u,v,m){const s=this.c.validateRange(u);this.g.push({range:s,text:v,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=u}}class k{constructor(u,v,m,s){this.c=u,this.d=v,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(r){o.n(r)},get indentSize(){return o.g},set indentSize(r){o.p(r)},get insertSpaces(){return o.j},set insertSpaces(r){o.s(r)},get cursorStyle(){return o.k},set cursorStyle(r){o.t(r)},get lineNumbers(){return o.l},set lineNumbers(r){o.u(r)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}n(u){const v=this.m(u);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const v=Math.floor(u);return v>0?v:null}if(typeof u=="string"){const v=parseInt(u,10);return isNaN(v)?null:v>0?v:null}return null}p(u){const v=this.o(u);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const v=this.q(u);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const v={};let m=!1;if(typeof u.tabSize<"u"){const s=this.m(u.tabSize);s==="auto"?(m=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,v.tabSize=s)}if(typeof u.indentSize<"u"){const s=this.o(u.indentSize);s==="tabSize"?(m=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,v.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this.q(u.insertSpaces);s==="auto"?(m=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,v.insertSpaces=s)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,m=!0,v.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,m=!0,v.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(u,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$kP=k;class N{constructor(u,v,m,s,o,r,n,t){this.id=u,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,r,m),this.e=n,this.f=t;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof M.$UM))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof M.$UM)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new g(s.value,i);return h(b),c.m(b)},insertSnippet(h,i,b={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map($=>O.Range.from($));else if(i instanceof M.$SM){const{lineNumber:$,column:l}=O.Position.from(i);a=[{startLineNumber:$,startColumn:l,endLineNumber:$,endColumn:l}]}else if(i instanceof M.$TM)a=[O.Range.from(i)];else{a=[];for(const $ of i)if($ instanceof M.$TM)a.push(O.Range.from($));else{const{lineNumber:l,column:S}=O.Position.from($);a.push({startLineNumber:l,startColumn:S,endLineNumber:l,endColumn:S})}}return v.$tryInsertSnippet(u,s.value.version,h.value,a,b)},setDecorations(h,i){const b=i.length===0;b&&!c.h.has(h.key)||(b?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$_O(i))return v.$trySetDecorations(u,h.key,O.$aP(i));{const a=new Array(4*i.length);for(let $=0,l=i.length;$<l;$++){const S=i[$];a[4*$]=S.start.line+1,a[4*$+1]=S.start.character+1,a[4*$+2]=S.end.line+1,a[4*$+3]=S.end.character+1}return v.$trySetDecorationsFast(u,h.key,a)}}))},revealRange(h,i){c.n(()=>v.$tryRevealRange(u,O.Range.from(h),i||M.TextEditorRevealType.Default))},show(h){v.$tryShowEditor(u,O.ViewColumn.from(h))},hide(){v.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const v=u.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,r)=>o.end.line===r.end.line?o.end.character===r.end.character?o.start.line===r.start.line?o.start.character-r.start.character:o.start.line-r.start.line:o.end.character-r.end.character:o.end.line-r.end.line);for(let o=0,r=m.length-1;o<r;o++){const n=m[o].end;if(m[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?O.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$lP=N}),define(Ae[67],Re([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new T.$be,this.e=new T.$be,this.f=new T.$be,this.g=new T.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],b=[];if(c.removedDocuments)for(const a of c.removedDocuments){const $=O.URI.revive(a),l=this.c.get($);l?.unref()&&(this.c.delete($),h.push(l.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const $=O.URI.revive(a.uri);let l=this.c.get($);if(l&&$.scheme!==m.Schemas.vscodeNotebookCell&&$.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);l||(l=new r(new g.$fP(this.h.getProxy(p.$PM.MainThreadDocuments),$,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set($,l),i.push(l.value)),l.ref()}if(c.removedEditors)for(const a of c.removedEditors){const $=this.b.get(a);this.b.delete(a),$&&b.push($)}if(c.addedEditors)for(const a of c.addedEditors){const $=O.URI.revive(a.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const l=this.c.get($).value,S=new N.$lP(a.id,this.h.getProxy(p.$PM.MainThreadTextEditors),this.i,new o.$V(()=>l.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(d=>y.Range.to(d)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,S)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,A.$Pc)(h),(0,A.$Pc)(b),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$mP=n,e.$mP=n=Je([Ve(0,k.$cP),Ve(1,u.$Wj)],n),e.$nP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(Ae[279],Re([1,0,18,5,4,115,8,7]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class g{constructor(N,y){this.i=y,this.a=new T.$be,this.b=new T.$be,this.c=new T.$be,this.d=new T.$be,this.f=new T.$be,this.g=new T.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(A.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const y=this.i.allEditors();return N?y:y.map(u=>u.value)}async showTextDocument(N,y,u){let v;typeof y=="number"?v={position:M.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?v={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,v),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,y){return new O.$jP(this.h,N,y).value}$acceptEditorPropertiesChanged(N,y){const u=this.i.getEditor(N);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const v=y.selections.selections.map(M.Selection.to);u._acceptSelections(v)}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(v)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const v=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:m,kind:v})}if(y.visibleRanges){const v=I.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:v})}}$acceptEditorPositionData(N){for(const y in N){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const v=M.ViewColumn.to(N[y]);u.value.viewColumn!==v&&(u._acceptViewColumn(v),this.d.fire({textEditor:u.value,viewColumn:v}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$Ikc=g}),define(Ae[280],Re([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$rmc=(0,T.$qi)("IExtHostTimeline");class N{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$PM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$Lm.equals(o,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:I.URI.revive(s.uri);return this.c.get(s.source)?.get(y(r))?.get(s.handle)}else return;return s}})}async $getTimeline(v,m,s,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(m),s,o)}registerTimelineProvider(v,m,s,o){const r=new O.$Tc,n=this.d(m.id,o,r).bind(this);let t;m.onDidChange&&(t=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const c=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(h,i,b){i?.resetCache&&(r.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(h,i,b);if(a==null)return;const $=n(h,i);return{...a,source:m.id,items:a.items.map($)}},dispose(){for(const h of c.values())h.get(m.id)?.clear();t?.dispose(),r.dispose()}},s)}d(v,m,s){return(o,r)=>{let n;if(r?.cacheResults){let t=this.c.get(v);t===void 0&&(t=new Map,this.c.set(v,t));const c=y(o);n=t.get(c),n===void 0&&(n=new Map,t.set(c,n))}return t=>{const{iconPath:c,...h}=t,i=`${v}|${t.id??t.timestamp}`;n?.set(i,t);let b,a,$;t.iconPath&&(c instanceof M.$NN?$={id:c.id,color:c.color}:I.URI.isUri(c)?(b=c,a=c):{light:b,dark:a}=c);let l;return M.$gN.isMarkdownString(h.tooltip)?l=p.MarkdownString.from(h.tooltip):(0,k.$4f)(h.tooltip)?l=h.tooltip:M.$gN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(h.detail)):(0,k.$4f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=h.detail),{...h,id:h.id??void 0,handle:i,source:v,command:t.command?m.toInternal(t.command,s):void 0,icon:b,iconDark:a,themeIcon:$,tooltip:l,accessibilityInformation:t.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,O.$Sc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$smc=N;function y(u){return u?.toString()}}),define(Ae[281],Re([1,0,172,24,2,5,6,211,11,7,17,18,8,54,22,137,25]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;function r(c,h){if((0,N.$4f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends M.$Uc{constructor(h,i,b){super(),this.f=h,this.g=i,this.h=b,this.a=new Map,this.b=new s.$n9;function a($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:$=>a($)?this.r($):Array.isArray($)&&$.length>0?$.map(l=>a(l)?this.r(l):l):$})}registerTreeDataProvider(h,i,b){const a=this.createTreeView(h,{treeDataProvider:i},b);return{dispose:()=>a.dispose()}}createTreeView(h,i,b){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],$=i.dragAndDropController?.dragMimeTypes??[],l=!!i.dragAndDropController?.handleDrag,S=!!i.dragAndDropController?.handleDrop,d=this.m(h,i,b),E={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:$,hasHandleDrag:l,hasHandleDrop:S,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,E),D={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,o.$xG)(b,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,o.$xG)(b,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(w){(0,v.$Pk)(w)&&(0,o.$xG)(b,"treeViewMarkdownMessage"),d.message=w},get title(){return d.title},set title(w){d.title=w},get description(){return d.description},set description(w){d.description=w},get badge(){return d.badge},set badge(w){w!==void 0&&k.ViewBadge.isViewBadge(w)?d.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(d.badge=void 0)},reveal:(w,C)=>d.reveal(w,C),dispose:async()=>{await f,this.a.delete(h),d.dispose()}};return this.B(D),D}$getChildren(h,i){const b=this.a.get(h);return b?b.getChildren(i):Promise.reject(new p.$MF(h))}async $handleDrop(h,i,b,a,$,l,S,d){const E=this.a.get(h);if(!E)return Promise.reject(new p.$MF(h));const f=u.DataTransfer.toDataTransfer(b,async D=>(await this.f.$resolveDropFileData(h,i,D)).buffer);return S===h&&d&&await this.j(f,E,d,$,l),E.onDrop(f,a,$)}async j(h,i,b,a,$){const l=this.b.removeDragOperationTransfer($);if(l)(await l)?.forEach((S,d)=>{S&&h.set(d,S)});else if($&&i.handleDrag){const S=i.handleDrag(b,h,a);this.b.addDragOperationTransfer($,S),await S}return h}async $handleDrag(h,i,b,a){const $=this.a.get(h);if(!$)return Promise.reject(new p.$MF(h));const l=await this.j(new k.$JN,$,i,a,b);if(!(!l||a.isCancellationRequested))return u.DataTransfer.from(l)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new p.$MF(h);return i.hasResolve}$resolve(h,i,b){const a=this.a.get(h);if(!a)throw new p.$MF(h);return a.resolveTreeItem(i,b)}$setExpanded(h,i,b){const a=this.a.get(h);if(!a)throw new p.$MF(h);a.setExpanded(i,b)}$setSelectionAndFocus(h,i,b){const a=this.a.get(h);if(!a)throw new p.$MF(h);a.setSelectionAndFocus(i,b)}$setVisible(h,i){const b=this.a.get(h);if(!b){if(!i)return;throw new p.$MF(h)}b.setVisible(i)}$changeCheckboxState(h,i){const b=this.a.get(h);if(!b)throw new p.$MF(h);b.setCheckboxState(i)}m(h,i,b){const a=this.B(new t(h,i,this.f,this.g.converter,this.h,b));return this.a.set(h,a),a}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$tmc=n;class t extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,N.$ag)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,b,a,$,l){if(super(),this.I=h,this.J=b,this.L=a,this.M=$,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$me,l.contributes&&l.contributes.views)for(const f in l.contributes.views)for(const D of l.contributes.views[f])D.id===h&&(this.P=D.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let S,d;const E=O.Event.debounce(this.F.event,(f,D)=>(f||(f={message:!1,elements:[]}),D.element!==!1&&(S||(S=new Promise(w=>d=w),this.G=this.G.then(()=>S)),Array.isArray(D.element)?f.elements.push(...D.element):f.elements.push(D.element)),D.message&&(f.message=!0),f),200,!0);this.B(E(({message:f,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const w=d;return S=null,this.$(D).then(()=>w())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let b=this.X(h);return b||(b=await this.Y(i)),b?b.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const b=(0,N.$ag)(i.select)?!0:i.select,a=(0,N.$ag)(i.focus)?!1:i.focus,$=(0,N.$ag)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(l=>this.W(h,l[l.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:l.map(d=>d.item)},{select:b,focus:a,expand:$})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:b,focus:a,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const b=this.getExtensionElement(h);b&&(i?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(h,i){const b=!(0,y.$ub)(this.s,h);this.s=h;const a=this.t!==i;this.t=i,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async b=>{const a=this.getExtensionElement(b.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);i.forEach(b=>{b.treeItem.checkboxState=b.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(b=>[b.extensionItem,b.newState])})}async handleDrag(h,i,b){const a=[];for(const $ of h){const l=this.getExtensionElement($);l&&a.push(l)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,b),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,b){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,g.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const b=this.j.get(h);if(b){const a=this.m.get(b);if(a){const $=await this.f.resolveTreeItem(a.extensionItem,b,i)??a.extensionItem;return this.hb($),a.item.tooltip=this.eb($.tooltip),a.item.command=this.fb(a.disposableStore,$.command),a.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(b=>this.W(i,b[b.length-1]).then(a=>(b.push(a),b))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$ih)(()=>this.f.getParent(h))}W(h,i){const b=this.m.get(h);return b?Promise.resolve(b):(0,g.$ih)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const $=this.getExtensionElement(a);if($){const l=this.m.get($);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const b=this.getExtensionElement(h);i=b?this.m.get(b):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new m.$me(this.Z.token);try{const b=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const $=(0,y.$Hb)(a||[]),l=await Promise.all((0,y.$Hb)($).map(d=>this.f.getTreeItem(d)));if(i.token.isCancellationRequested)return;const S=l.map((d,E)=>d?this.db($[E],d,b):null);return(0,y.$Hb)(S)}finally{i.dispose()}}$(h){if(h.some(b=>!b))return this.Z.dispose(!0),this.Z=new m.$me,this.tb(),this.J.$refresh(this.I);{const b=this.ab(h);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(h){const i=new Set,b=h.map($=>this.m.get($));for(const $ of b)if($&&!i.has($.item.handle)){let l=$;for(;l&&l.parent&&b.findIndex(S=>l&&l.parent&&S&&S.item.handle===l.parent.item.handle)===-1;){const S=this.j.get(l.parent.item.handle);l=S?this.m.get(S):void 0}l&&!l.parent&&i.add($.item.handle)}const a=[];return i.forEach($=>{const l=this.j.get($);if(l){const S=this.m.get(l);S&&(!S.parent||!i.has(S.parent.item.handle))&&a.push($)}}),a}bb(h){const i={};return Promise.all(h.map(b=>this.cb(b).then(a=>{a&&(i[b]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const b=this.m.get(i);if(b)return this.rb(i),(0,g.$ih)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const $=this.ib(i,a,b.parent);return this.pb(i,$,b,b.parent),b.dispose(),$}return null})}return Promise.resolve(null)}db(h,i,b){const a=this.ib(h,i,b);if(i.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,i.id));return this.ob(h,a),this.qb(a,b),a}eb(h){return k.$gN.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,b,a;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,b=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:i===k.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:a}}hb(h){if(!k.$EN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,b){this.hb(i);const a=this.B(new M.$Tc),$=this.kb(h,i,b),l=this.lb(i);return{item:{handle:$,parentHandle:b?b.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:l,iconDark:this.mb(i)||l,themeIcon:this.jb(i),collapsibleState:(0,N.$ag)(i.collapsibleState)?k.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:b,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof k.$NN?h.iconPath:void 0}kb(h,{id:i,label:b,resourceUri:a},$,l){if(i)return`${t.b}/${i}`;const S=r(b,this.N),d=$?$.item.handle:t.a;let E=S?S.label:a?(0,T.$1g)(a):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,D=this.X($)||[];let w,C=0;do{if(w=`${d}/${C}:${E}`,l||!this.j.has(w)||f===w)break;C++}while(C<=D.length);return w}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$NN))return typeof h.iconPath=="string"||A.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$NN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return A.URI.isUri(h)?h:A.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,b,a){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(h,i);const $=this.X(a)||[],l=$.filter(S=>S.item.handle===b.item.handle)[0];l&&$.splice($.indexOf(l),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[282],Re([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,T,A,O,M,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class N extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,A.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends T.$Uc{static c(){return(0,O.$Mg)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(g.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,r,n={}){const t=typeof r=="object"?r.viewColumn:r,c={viewColumn:M.ViewColumn.from(t),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,p.$Xkc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$Zkc)(m),i,s,{title:o,panelOptions:u(n),webviewOptions:(0,p.$1kc)(m,this.m,n),serializeBuffersForPostMessage:h},c);const b=this.j.createNewWebview(i,n,m);return this.createNewWebviewPanel(i,s,o,t,n,b,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,r)=>{const n=m[o],t=m[r];return n.active?1:t.active?-1:+n.visible-+t.visible});for(const o of s){const r=this.getWebviewPanel(o);if(!r)continue;const n=m[o];r._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$Xkc)(m)}),new k.$RM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,r){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:t,extension:c}=n,h=this.j.createNewWebview(m,o.webviewOptions,c),i=this.createNewWebviewPanel(m,s,o.title,r,o.panelOptions,h,o.active);await t.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,r,n,t,c){const h=new N(m,this.f,t,{viewType:s,title:o,viewColumn:r,panelOptions:n,active:c});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$2kc=y;function u(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[283],Re([1,0,5,6,63,8,4,7]),function(ge,e,I,T,A,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class g extends T.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,v,m,s,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=v,this.#a=m,this.#e=y,this.#t=u,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,v,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:v,extension:y}),this.a.$registerWebviewViewProvider((0,A.$Zkc)(y),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Xkc)(y)}),new p.$RM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,v,m,s){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:n}=o,t=this.d.createNewWebview(y,{},n),c=new g(y,this.a,u,v,t,!0);this.c.set(y,c),await r.resolveWebviewView(c,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$wmc=k}),define(Ae[284],Re([1,0,5,30,31,3]),function(ge,e,I,T,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new A.$Hj("inOutput",!1),e.$5L=new A.$Hj("activeLogOutput",!1),e.$6L=new A.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new A.$Hj("activeLogOutput.level",""),e.$8L=new A.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new A.$Hj("outputView.scrollLock",!1),e.$0L=(0,O.$qi)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(N=>k.push(N)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}T.$9n.add(e.$$L.OutputChannels,new p),e.$_L=new A.$Hj("activeOutputChannel","")}),define(Ae[116],Re([1,0,4,3,16,20,13,284,64,27,45,141,23,17,44,5,6]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;class r extends M.$3j{get disposed(){return this.n}constructor(h,i,b,a,$){super(),this.id=h,this.name=i,this.r=b,this.s=a,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=u.$Ce.fromString(i).byteLength,(0,M.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends r{appendLine(h){this.append(h)}}let t=class{constructor(h,i,b,a,$,l){this.i=i,this.j=b,this.k=a,this.l=$,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,b]of this.g)b.visible=i===this.h}createOutputChannel(h,i,b){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,$=(0,v.$4f)(i)?i:void 0;if((0,v.$4f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const S=this.i.environment.extensionLogLevel?.find(([E])=>O.$Lm.equals(b.identifier,E))?.[1];S&&(l=(0,M.$bk)(S));const d=a?this.o(h,l,b):this.n(h,$,b);return d.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),a?this.r(h,l??this.m.getLevel(),d):this.q(h,d)}async n(h,i,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,$=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(h,$,i,b.identifier.value);return new r(S,h,l,this.a,b)}async o(h,i,b){const a=await this.p(b),$=h.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(a,`${$}.log`),S=`${b.identifier.value}.${$}`,d=this.l.createLogger(l,{id:S,name:h,logLevel:i,extensionId:b.identifier.value});return new n(S,h,d,this.a,b)}p(h){let i=this.d.get(h.identifier.value);if(!i){const b=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(b)}catch(a){if((0,m.$al)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return b})())}return i}q(h,i){let b=!1;const a=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return h},append($){a(),i.then(l=>l.append($))},appendLine($){a(),i.then(l=>l.appendLine($))},clear(){a(),i.then($=>$.clear())},replace($){a(),i.then(l=>l.replace($))},show($,l){a(),i.then(S=>S.show($,l))},hide(){a(),i.then($=>$.hide())},dispose(){b=!0,i.then($=>$.dispose())}}}r(h,i,b){const a=new o.$Tc,$=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},l=a.add(new s.$be);function S(d){i=d,l.fire(d)}return b.then(d=>{a.add(d),d.logLevel!==i&&S(d.logLevel),a.add(d.onDidChangeLogLevel(E=>S(E)))}),{...this.q(h,b),get logLevel(){return i},onDidChangeLogLevel:l.event,trace(d,...E){$(),b.then(f=>f.trace(d,...E))},debug(d,...E){$(),b.then(f=>f.debug(d,...E))},info(d,...E){$(),b.then(f=>f.info(d,...E))},warn(d,...E){$(),b.then(f=>f.warn(d,...E))},error(d,...E){$(),b.then(f=>f.error(d,...E))},dispose(){a.dispose()}}}};e.$8lc=t,e.$8lc=t=Je([Ve(0,A.$cP),Ve(1,k.$sP),Ve(2,g.$Tkc),Ve(3,N.$wkc),Ve(4,M.$Xj),Ve(5,M.$Wj)],t),e.$9lc=(0,T.$qi)("IExtHostOutputService")}),define(Ae[117],Re([1,0,3,11]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,I.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const g=await A.getRoundTripTime();if(g===void 0)return;O=Math.min(O,g/2),await(0,T.$rh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((p,g)=>p+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((p,g)=>p+g,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ae[285],Re([1,0,175,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new g.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const m=new v;A.$9n.add(e.$uJ.ConfigurationMigration,m);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,b]of h){const a=c[i];if(!a)continue;const $=[];if(a.value!==void 0){const l=await this.h(n,i,a.value,t,void 0);for(const S of l??[])$.push([S,[]])}for(const{identifiers:l,value:S}of a.overrides??[])if(S!==void 0){const d=await this.h(n,i,S,t,l);for(const E of d??[])$.push([E,l])}$.length&&await Promise.allSettled($.map(async([[l,S],d])=>this.a.updateValue(l,S.value,{resource:t,overrideIdentifiers:d},b)))}}async h(n,t,c,h,i){const b=$=>{const S=this.a.inspect($,{resource:h})[t];if(S)return i?S.overrides?.find(({identifiers:d})=>(0,y.$1n)(d,i))?.value:S.value},a=await n.migrateFn(c,b);return Array.isArray(a)?a:[[n.key,a]]}};e.$vJ=s,e.$vJ=s=Je([Ve(0,M.$Wi),Ve(1,O.$zi)],s);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;A.$9n.as(T.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$wJ=o,e.$wJ=o=Je([Ve(0,k.$an)],o)}),define(Ae[286],Re([1,0,36,12,19,24,184,285,57,3,30]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Igb=e.$Hgb=void 0,e.$Jgb=s,e.$Kgb=o,e.$Hgb=(0,k.$qi)("editorResolverService"),e.$Igb="workbench.editorAssociations";const y=N.$9n.as(g.$bo.Configuration),u={...p.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var v;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(v||(e.RegisteredEditorPriority=v={}));var m;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(r){switch(r){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(r,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof r=="string"&&r.indexOf(A.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,O.$1g)(n);return I.$jk(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}}),define(Ae[287],Re([1,0,47,12,19,21,24,2,3,205,49,225,117]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,g.$qi)("pathService");let m=v=class{constructor(o,r,n,t){this.d=o,this.e=r,this.f=n,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,r,n){return typeof r=="string"||typeof r>"u"?this.a.then(t=>this.h(o,t,r)):this.h(o,r,n)}h(o,r,n){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,I.$og)(n??(0,M.$1g)(o),r===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,r){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,k.$oM)(r.getWorkspace());if(n)return n;const t=r.getWorkspace().folders[0];if(t)return t.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?A.$gc:A.$hc)}async fileURI(o){let r="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(r=o.substring(2),o="/"):(r=o.substring(2,t),o=o.substring(t)||"/")}return p.URI.from({scheme:T.Schemas.file,authority:r,path:o,query:"",fragment:""})}};e.$sM=m,e.$sM=m=v=Je([Ve(1,u.$an),Ve(2,y.$aM),Ve(3,N.$zi)],m)}),define(Ae[118],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class I{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new I(0,0)}with(M){return new I(0,0)}}e.$WK=I;class T{constructor(M,p,g,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,p),this.end=new I(g,k)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new T(0,0,0,0)}with(M){return new T(0,0,0,0)}}e.$XK=T;var A;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ae[46],Re([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,T,A,O,M,p,g,k,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=r,e.$6K=n,e.$7K=t,e.$_K=d,e.$aL=E,e.$cL=w,e.$dL=C,e.$eL=P,e.$fL=V,e.$gL=W,e.$hL=q,e.$jL=j,e.$lL=ce,e.$mL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const u="\u27EA ",v=" characters skipped \u27EB",m=(u.length+v.length+5)*2;e.$4K=(0,p.$qi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function r(ue){return!!ue.preview}function n(ue){return!!ue.resource}function t(ue){return!!ue.message}var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(be){this.resource=be,this.results=[]}}e.$8K=h;class i{constructor(be,ie,Pe,Fe){this.ranges=ie,this.webviewIndex=Fe;const ne=Array.isArray(ie)?ie:[ie];if(Pe&&Pe.matchLines===1&&b(ne)){be=(0,M.$Wf)(be,Pe.matchLines);let U="",x=0,pe=0;const Oe=Math.floor(Pe.charsPerLine/5),ke=[];for(const $e of ne){const fe=Math.max($e.startColumn-Oe,0),J=$e.startColumn+Pe.charsPerLine;if(fe>pe+Oe+m){const Y=u+(fe-pe)+v;U+=Y+be.slice(fe,J),x+=fe-(pe+Y.length)}else U+=be.slice(pe,J);ke.push(new $(0,$e.startColumn-x,$e.endColumn-x)),pe=J}this.preview={text:U,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const U=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:be,matches:(0,I.$2b)(ie,x=>new a(x.startLineNumber-U,x.startColumn,x.endLineNumber-U,x.endColumn))}}}}e.$9K=i;function b(ue){const be=ue[0].startLineNumber;for(const ie of ue)if(ie.startLineNumber!==be||ie.endLineNumber!==be)return!1;return!0}class a{constructor(be,ie,Pe,Fe){this.startLineNumber=be,this.startColumn=ie,this.endLineNumber=Pe,this.endColumn=Fe}}e.$0K=a;class $ extends a{constructor(be,ie,Pe){super(be,ie,be,Pe)}}e.$$K=$;var l;(function(ue){ue.List="list",ue.Tree="tree"})(l||(e.ViewMode=l={}));var S;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function d(ue,be=!0){const ie=ue&&ue.files&&ue.files.exclude,Pe=be&&ue&&ue.search&&ue.search.exclude;if(!ie&&!Pe)return;if(!ie||!Pe)return ie||Pe;let Fe=Object.create(null);return Fe=A.$Zn(Fe,A.$Wn(ie)),Fe=A.$Zn(Fe,A.$Wn(Pe),!0),Fe}function E(ue,be){return ue.excludePattern&&T.$jk(ue.excludePattern,be)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.$jk(ue.includePattern,be)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(ie=>{const Pe=ie.folder.fsPath;if(O.$qg(be,Pe)){const Fe=g.$mc(Pe,be);return!ie.includePattern||!!T.$jk(ie.includePattern,Fe)}else return!1}):!1:!0}var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class D extends Error{constructor(be,ie){super(be),this.code=ie}}e.$bL=D;function w(ue){const be=ue.message;if((0,k.$4)(ue))return new D(be,f.canceled);try{const ie=JSON.parse(be);return new D(ie.message,ie.code)}catch{return new D(be,f.other)}}function C(ue){const be={message:ue.message,code:ue.code};return new Error(JSON.stringify(be))}function P(ue){return ue.type==="error"?!0:ue.type==="success"}function V(ue){return ue.type==="success"}function W(ue){return!!ue.path}function q(ue,be,ie=!0){const Pe=ue.searchPath?ue.searchPath:ue.relativePath;return ie?(0,M.$Tf)(Pe,be):T.$jk(be,Pe)}class R{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=R;function j(ue,be){const ie={...ue||{},...be||{}};return Object.keys(ie).filter(Pe=>{const Fe=ie[Pe];return typeof Fe=="boolean"&&Fe})}class K{constructor(be,ie){this.c=null,this.a={...be.excludePattern||{},...ie.excludePattern||{}},this.b=T.$kk(this.a);let Pe=be.includePattern;ie.includePattern&&(Pe?Pe={...Pe,...ie.includePattern}:Pe=ie.includePattern),Pe&&(this.c=T.$kk(Pe))}matchesExcludesSync(be,ie,Pe){return!!(this.b&&this.b(be,ie,Pe))}includedInQuerySync(be,ie,Pe){return!(this.b&&this.b(be,ie,Pe)||this.c&&!this.c(be,ie,Pe))}includedInQuery(be,ie,Pe){const Fe=this.b(be,ie,Pe),ne=()=>this.c?!!this.c(be,ie,Pe):!0;return(0,y.$ch)(Fe)?Fe.then(U=>U?!1:ne()):ne()}hasSiblingExcludeClauses(){return se(this.a)}}e.$kL=K;function se(ue){for(const be in ue)if(typeof ue[be]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let be;return ie=>(be||(be=(ue()||Promise.resolve([])).then(Pe=>Pe?Ie(Pe):{})),be.then(Pe=>!!Pe[ie]))}function ve(ue){if(!ue)return;let be;return ie=>{if(!be){const Pe=ue();be=Pe?Ie(Pe):{}}return!!be[ie]}}function Ie(ue){const be={};for(const ie of ue)be[ie]=!0;return be}}),define(Ae[37],Re([1,0,18,11,22,5,6,52,12,126,24,15,2,174,3,13,194,49,45,27,16,8,7,60,46,4,53]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=void 0;function S(V,W,q){return new N.$Sg(R=>D(R,q)).isEqual(V,W)}function d(V,W,q){return S(V.uri,W.uri,q)?0:(0,y.$mf)(V.uri.toString(),W.uri.toString())}function E(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:S(V.uri,W.uri,q)?(0,y.$mf)(V.name,W.name):(0,y.$mf)(V.uri.toString(),W.uri.toString())}function f(V,W,q,R){const j=V.slice(0).sort((se,ce)=>q(se,ce,R)),K=W.slice(0).sort((se,ce)=>q(se,ce,R));return(0,I.$Eb)(j,K,(se,ce)=>q(se,ce,R))}function D(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class w extends r.$Ji{static toExtHostWorkspace(W,q,R,j){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:se,folders:ce,configuration:ve,transient:Ie,isUntitled:ue}=W,be=[],ie=q;q?ce.forEach((U,x)=>{const pe=u.URI.revive(U.uri),Oe=w.o(R||q,pe,j);Oe?(Oe.name=U.name,Oe.index=U.index,be.push(Oe)):be.push({uri:pe,name:U.name,index:x})}):be.push(...ce.map(({uri:U,name:x,index:pe})=>({uri:u.URI.revive(U),name:x,index:pe}))),be.sort((U,x)=>U.index<x.index?-1:1);const Pe=new w(K,se,be,!!Ie,ve?u.URI.revive(ve):null,!!ue,U=>D(U,j)),{added:Fe,removed:ne}=f(ie?ie.workspaceFolders:[],Pe.workspaceFolders,d,j);return{workspace:Pe,added:Fe,removed:ne}}static o(W,q,R){for(let j=0;j<W.folders.length;j++){const K=W.workspaceFolders[j];if(S(K.uri,q,R))return K}}constructor(W,q,R,j,K,se,ce){super(W,R.map(ve=>new r.$Ki(ve)),j,K,ce),this.t=q,this.u=se,this.q=[],this.s=p.$wi.forUris(ce),R.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,N.$3g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let C=class{constructor(W,q,R,j,K){this.c=new O.$be,this.onDidChangeWorkspace=this.c.event,this.g=new O.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$de,this.C=new Map,this.h=j,this.s=R,this.t=K,this.j=new k.$xm,this.k=new T.$ph,this.o=W.getProxy($.$PM.MainThreadWorkspace),this.q=W.getProxy($.$PM.MainThreadMessageService);const se=q.workspace;this.l=se?new w(se.id,se.name,[],!!se.transient,se.configuration?u.URI.revive(se.configuration):null,!!se.isUntitled,ce=>D(ce,R)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,N.$1g)((0,N.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,R,...j){const K=[];if(Array.isArray(j)&&j.forEach(ue=>{u.URI.isUri(ue.uri)&&!K.some(be=>S(be.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,N.$Zg)(ue.uri)})}),this.n||[q,R].some(ue=>typeof ue!="number"||ue<0)||R===0&&K.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(q+R>se.length)return!1;const ce=se.slice(0);ce.splice(q,R,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,N.$Zg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const be=ce[ue];if(ce.some((ie,Pe)=>Pe!==ue&&S(be.uri,ie.uri,this.s)))return!1}ce.forEach((ue,be)=>ue.index=be);const{added:ve,removed:Ie}=f(se,ce,E,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,q,R,K).then(void 0,be=>{this.n=void 0;const ie={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,ue,be.toString()),ie,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let R,j="";if(typeof W=="string"?(R=u.URI.file(W),j=W):typeof W<"u"&&(R=W,j=W.fsPath),!R)return j;const K=this.getWorkspaceFolder(R,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let se=(0,N.$6g)(K.uri,R);return q&&K.name&&(se=`${K.name}/${se}`),se}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:R,removed:j}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:j}))}findFiles(W,q,R,j,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let se="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?se=q:se=q.pattern),this.z(W,void 0,{exclude:se,maxResults:R,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},R,j=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,W,q,j)}async z(W,q,R,j=A.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,se={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:K,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(W));ce=Ie,se.includePattern=ve}else{const{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(q));ce=Ie,se.filePattern=ve}return this.o.$startFileSearch(ce??null,se,j).then(ve=>Array.isArray(ve)?ve.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(W,q,R,j,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,be={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ue},ie=!1;if(this.u[se]=Pe=>{if(ie)return;const Fe=u.URI.revive(Pe.resource);Pe.results.forEach(ne=>{const U=(0,l.$Zh)(ne);(0,a.$5K)(U)?R({uri:Fe,preview:{text:U.preview.text,matches:(0,I.$2b)(U.preview.matches,x=>new i.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(U.ranges,x=>new i.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Fe,text:U.text,lineNumber:U.lineNumber})})},K.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(W,Ie??null,be,se,K);return delete this.u[se],Pe||{}}catch(Pe){throw delete this.u[se],Pe}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return u.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return u.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const R=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,R),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const R=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const j=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,R,j){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const se=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!se),!se)return;const ce=await se.provideEditSessionIdentityMatch?.(q,R,j);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,R,j)=>{const K=function(ce){q.call(R,ce)};return K.extension=W,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(W,q,R){const j=await this.resolveWorkspaceFolder(u.URI.revive(W));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,se)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>R&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const R=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerCanonicalUriProvider(j,R),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(W,q,R){const j=this.C.get(W.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(u.URI.revive(W),q,R);if(K)return K}async $provideCanonicalUri(W,q,R){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:q},R)}};e.$Nkc=C,e.$Nkc=C=Je([Ve(0,c.$cP),Ve(1,t.$sP),Ve(2,n.$wkc),Ve(3,s.$Wj),Ve(4,b.$Lkc)],C),e.$Okc=(0,m.$qi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=u.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Ae[38],Re([1,0,26,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=e.$Pkc=void 0;function s(b,a){if(a){const $=a.split(".");let l=b;for(let S=0;l&&S<$.length;S++)l=l[$[S]];return l}}function o(b){return b instanceof m.URI}function r(b){return b&&b.uri instanceof m.URI&&b.languageId&&typeof b.languageId=="string"}function n(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function t(b){return b&&b.uri instanceof m.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function c(b){if(o(b))return{resource:b};if(r(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(n(b))return{overrideIdentifier:b.languageId};if(t(b))return{resource:b.uri};if(b===null)return{resource:null}}let h=class{constructor(a,$,l){this.a=a.getProxy(O.$PM.MainThreadConfiguration),this.c=$,this.b=l,this.d=new N.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,$){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(a,$))}};e.$Pkc=h,e.$Pkc=h=Je([Ve(0,u.$cP),Ve(1,A.$Okc),Ve(2,v.$Wj)],h);class i{constructor(a,$,l,S){this.a=new T.$be,this.b=a,this.f=S,this.c=$,this.e=p.$uo.parse(l,S),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,$){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j($,l))}getConfiguration(a,$,l){const S=c($)||{},d=this.g(a?s(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,l?.identifier);function E(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(D){return typeof s(d,D)<"u"},get:(D,w)=>{this.h(a?`${a}.${D}`:D,S,l?.identifier);let C=s(d,D);if(typeof C>"u")C=w;else{let P;const V=(W,q)=>{if((0,k.$6f)(W)){let R;const j=()=>{P=P||(0,I.$Wn)(d),R=R||s(P,q)};return new Proxy(W,{get:(K,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return j(),()=>R;if(P)return R=R||s(P,q),R[se];const ce=K[se];return typeof se=="string"?V(ce,`${q}.${se}`):ce},set:(K,se,ce)=>(j(),R&&(R[se]=ce),!0),deleteProperty:(K,se)=>(j(),R&&delete R[se],!0),defineProperty:(K,se,ce)=>(j(),R&&Object.defineProperty(R,se,ce),!0)})}return Array.isArray(W)?(0,I.$Wn)(W):W};C=V(C,D)}return C},update:(D,w,C,P)=>{D=a?`${a}.${D}`:D;const V=E(C);return w!==void 0?this.b.$updateConfigurationOption(V,D,w,S,P):this.b.$removeConfigurationOption(V,D,S,P)},inspect:D=>{D=a?`${a}.${D}`:D;const w=this.e.inspect(D,S,this.c.workspace);if(w)return{key:D,defaultValue:(0,I.$Wn)(w.policy?.value??w.default?.value),globalValue:(0,I.$Wn)(w.user?.value??w.application?.value),workspaceValue:(0,I.$Wn)(w.workspace?.value),workspaceFolderValue:(0,I.$Wn)(w.workspaceFolder?.value),defaultLanguageValue:(0,I.$Wn)(w.default?.override),globalLanguageValue:(0,I.$Wn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,I.$Wn)(w.workspace?.override),workspaceFolderLanguageValue:(0,I.$Wn)(w.workspaceFolder?.override),languageIds:(0,I.$Wn)(w.overrideIdentifiers)}}};return typeof d=="object"&&(0,I.$Zn)(f,d,!1),Object.freeze(f)}g(a){const $=l=>(0,k.$6f)(l)?new Proxy(l,{get:(S,d)=>$(S[d]),set:(S,d,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(S,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(S,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return $(a)}h(a,$,l){const S=g.$lo.test(a)?4:this.d.get(a),d=l?`[${l.value}] `:"";if(S===4){typeof $?.resource>"u"&&this.f.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){$?.resource&&this.f.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,$){const l=new p.$wo(a,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,d)=>l.affectsConfiguration(S,c(d))})}k(a){return a.reduce(($,l)=>($.set(l[0],l[1]),$),new Map)}}e.$Qkc=i,e.$Rkc=(0,y.$qi)("IExtHostConfiguration")}),define(Ae[119],Re([1,0,2,11,5,4,7,37,67,38,22,51,16,27,3,12,21,13,78,230,14]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(h||(h={}));var i;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(i||(i={}));var b;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(b||(b={}));var a;(function(V){function W(j){if(j){const K=j;return K&&!!K.process}else return!1}V.is=W;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=b.from(j.options)),K}V.from=q;function R(j){if(j!=null)return new M.$AN(j.process,j.args,j.options)}V.to=R})(a||(a={}));var $;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})($||($={}));var l;(function(V){function W(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=$.from(j.options)),K}V.from=q;function R(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$BN(j.commandLine,j.options):new M.$BN(j.command,j.args?j.args:[],j.options)}V.to=R})(l||(l={}));var S;(function(V){function W(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(j){return{customExecution:"customExecution"}}V.from=q;function R(j,K){return K.get(j)}V.to=R})(S||(e.CustomExecutionDTO=S={}));var d;(function(V){function W(q,R){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&R&&R.workspaceFile?j=R.workspaceFile:j=t.$VH),{id:q._id,workspaceFolder:j}}V.from=W})(d||(e.TaskHandleDTO=d={}));var E;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(E||(E={}));var f;(function(V){function W(j,K){if(j==null)return[];const se=[];for(const ce of j){const ve=q(ce,K);ve&&se.push(ve)}return se}V.fromMany=W;function q(j,K){if(j==null)return;let se;j.execution instanceof M.$AN?se=a.from(j.execution):j.execution instanceof M.$BN?se=l.from(j.execution):j.execution&&j.execution instanceof M.$CN&&(se=S.from(j.execution));const ce=h.from(j.definition);let ve;return j.scope?typeof j.scope=="number"?ve=j.scope:ve=j.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:j._id,definition:ce,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:ve},execution:se,isBackground:j.isBackground,group:E.from(j.group),presentationOptions:i.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}V.from=q;async function R(j,K,se){if(j==null)return;let ce;a.is(j.execution)?ce=a.to(j.execution):l.is(j.execution)?ce=l.to(j.execution):S.is(j.execution)&&(ce=S.to(j._id,se));const ve=h.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const ue=new M.$DN(ve,Ie,j.name,j.source.label,ce,j.problemMatchers);return j.isBackground!==void 0&&(ue.isBackground=j.isBackground),j.group!==void 0&&(ue.group=M.$zN.from(j.group._id),ue.group&&j.group.isDefault&&(ue.group=new M.$zN(ue.group.id,ue.group.label),j.group.isDefault===!0&&(ue.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ue.presentationOptions=i.to(j.presentationOptions)),j._id&&(ue._id=j._id),j.detail&&(ue.detail=j.detail),ue}V.to=R})(f||(e.TaskDTO=f={}));var D;(function(V){function W(R){return R}V.from=W;function q(R){if(R)return Object.assign(Object.create(null),R)}V.to=q})(D||(D={}));class w{#e;constructor(W,q,R){this._id=q,this.a=R,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let C=class{constructor(W,q,R,j,K,se,ce,ve){this.q=new A.$be,this.r=new A.$be,this.s=new A.$be,this.u=new A.$be,this.a=W.getProxy(O.$PM.MainThreadTask),this.b=R,this.c=j,this.d=K,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,R){if(!R)return new M.$RM(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:R,extension:W}),this.a.$registerTaskProvider(j,q),new M.$RM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(D.from(W)).then(async q=>{const R=[];for(const j of q){const K=await f.to(j,this.b,this.m);K&&R.push(K)}return R})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,R){const j=this.m.get(W.id);j&&(this.o.set(W.id,j),this.e.attachPtyToTerminal(q,await j.callback(R))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));const j=[],K=(0,T.$ih)(()=>R.provider.provideTasks(N.CancellationToken.None)).then(se=>this.v(q,j,R,se));return new Promise(se=>{K.then(ce=>{Promise.all(j).then(()=>{se(ce)})})})}async $resolveTask(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const j=await f.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await R.provider.resolveTask(j,N.CancellationToken.None);if(!K)return;this.A(K,R);const se=f.from(K,R.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(se.execution)&&await this.y(se,K,!0),await this.w(se)}x(){return this.h++}async y(W,q,R){const j=await this.a.$createTaskId(W);!R&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const R=this.l.get(W.id);if(R)return R;let j;return q?j=Promise.resolve(new w(this,W.id,q)):j=f.to(W.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,W.id,K)}),this.l.set(W.id,j),j.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const R=this.n.values();let j=R.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=R.next()}};e.$hmc=C,e.$hmc=C=Je([Ve(0,u.$cP),Ve(1,v.$sP),Ve(2,p.$Okc),Ve(3,g.$nP),Ve(4,k.$Rkc),Ve(5,y.$dlc),Ve(6,r.$Wj),Ve(7,n.$skc)],C);let P=class extends C{constructor(W,q,R,j,K,se,ce,ve){super(W,q,R,j,K,se,ce,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=f.from(q,W);if(R===void 0)throw new Error("Task is not valid");if(S.is(R.execution))await this.y(R,q,!1);else throw new c.$_;const j=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(K=>{throw new Error(K)}),j}v(W,q,R,j){const K=[];if(j)for(const se of j){if(this.A(se,R),!se.definition||!W[se.definition.type]){const ve=se.source?se.source:"No task source";this.f.warn(`The task [${ve}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(se,R.extension);ce&&S.is(ce.execution)?(K.push(ce),q.push(this.y(ce,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:R.extension}}async w(W){if(S.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,R){}};e.$imc=P,e.$imc=P=Je([Ve(0,u.$cP),Ve(1,v.$sP),Ve(2,p.$Okc),Ve(3,g.$nP),Ve(4,k.$Rkc),Ve(5,y.$dlc),Ve(6,r.$Wj),Ve(7,n.$skc)],P),e.$jmc=(0,m.$qi)("IExtHostTask")}),define(Ae[288],Re([1,0,46,29]),function(ge,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=A,e.$uL=O;function A(M){return"cellResults"in M}e.$tL="rawCell#";function O(M,p){let g=-1;const k=[];let N=[];return M.forEach(u=>{u.range.startLineNumber!==g&&N.length>0&&(k.push([...N]),N=[]),N.push(u),g=u.range.endLineNumber}),N.length>0&&k.push([...N]),k.map(u=>{const v=[],m=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let o=m;o<=s;o++)v.push(p.getLineContent(o));return new I.$9K(v.join(`
`)+`
`,u.map(o=>new T.$kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ae[289],Re([1,0,168,23,5,6,28,15,17,2,44,74,4,32,8,7,34,264,112,26,12,220,288,286]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,S,d,E,f,D){this.q=d,this.r=E,this.s=f,this.t=D,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new A.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$qkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(u.$PM.MainThreadNotebook),this.c=l.getProxy(u.$PM.MainThreadNotebookDocuments),this.d=l.getProxy(u.$PM.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const C=w.notebookEditor?.notebookUri,P=w.cell.handle,W=this.g.get(C)?.getCell(P);if(W)return W.apiCell}if(w&&w.$mid===14){const C=w.uri,P=this.g.get(C);if(P)return P.apiNotebook}return w}}),a.B(S)}getEditorById(l){const S=this.h.get(l);if(!S)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(l){for(const[S,d]of this.h)if(d.apiEditor===l)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,S){const d=this.g.get(l);if(!d&&!S)throw new Error(`NO notebook document for '${l}'`);return d}static u(l,S){if(!S)return;const d=S.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(S.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:S.displayName,filenamePattern:d,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,S,d){const E=a.a++,f=typeof d.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(E,d),this.b.$registerNotebookCellStatusBarItemProvider(E,f,S);let D;return f!==void 0&&(D=d.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(f))),new s.$RM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,f),D?.dispose()})}async createNotebookDocument(l){const S=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&m.NotebookData.from(l.content)});return k.URI.revive(S)}async openNotebookDocument(l){const S=this.g.get(l);if(S)return S.apiNotebook;const d=await this.c.$tryOpenNotebook(l),E=this.g.get(k.URI.revive(d));return(0,g.$cg)(E?.apiNotebook)}async showNotebookDocument(l,S){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let d;typeof S=="object"?d={position:m.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(m.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:d={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,d),f=E&&this.h.get(E)?.apiEditor;if(f)return f;throw E?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,S,d,E){const f=this.f.get(l),D=k.URI.revive(S),w=this.g.get(D);if(!w||!f)return;const C=w.getCellFromIndex(d);if(!C)return;const P=await f.provideCellStatusBarItems(C.apiCell,E);if(!P)return;const V=new O.$Tc,W=this.p.add([V]),R=(Array.isArray(P)?P:[P]).map(j=>m.NotebookStatusBarItem.from(j,this.i,V));return{cacheId:W,items:R}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,S,d,E,f){if((0,p.$3e)(S))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:S,serializer:d,options:E}),this.b.$registerNotebookSerializer(D,{id:l.identifier,location:l.extensionLocation},S,m.NotebookDocumentContentOptions.from(E),a.u(l,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(l,S,d){const E=this.x.get(l);if(!E)throw new Error("NO serializer found");const f=await E.serializer.deserializeNotebook(S.buffer,d);return new o.$lw(m.NotebookData.from(f))}async $notebookToData(l,S,d){const E=this.x.get(l);if(!E)throw new Error("NO serializer found");const f=await E.serializer.serializeNotebook(m.NotebookData.to(S.value),d);return T.$Ce.wrap(f)}async $saveNotebook(l,S,d,E,f){const D=k.URI.revive(S),w=this.x.get(l);if(!w)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==d)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new N.$fl((0,I.localize)(0,null,this.z(D)),6);await this.y(D,E);const P={metadata:(0,t.$5n)(C.apiNotebook.metadata,j=>!(w.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const K=new s.$hO(j.kind,j.document.getText(),j.document.languageId,j.mime,w.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,t.$5n)(j.metadata,se=>!(w.options?.transientCellMetadata??{})[se]),P.cells.push(K)}const V=await w.serializer.serializeNotebook(P,f);await this.s.value.writeFile(D,V);const W=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:W.basename(D),isFile:(q.type&N.FileType.File)!==0,isDirectory:(q.type&N.FileType.Directory)!==0,isSymbolicLink:(q.type&N.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&N.FilePermission.Locked),etag:N.$ql({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(l,S,d,E,f){const D=this.x.get(l)?.serializer;if(!D)return{limitHit:!1,results:[]};const w=new M.$Cc;await(async(q,R,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(se=>{const ce={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:se};return this.t.doInternalFileSearchWithCustomCallback(ce,R,ve=>{ve.forEach(Ie=>{w.has(Ie)||E.some(be=>K.isFromSettings&&!be.isFromSettings?!1:be.filenamePatterns.some(ie=>(0,b.$Kgb)(ie,Ie)))||w.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(d,f,S);const P=new M.$Bc;let V=!1;const W=Array.from(w).map(async q=>{const R=[];try{if(f.isCancellationRequested)return;if(S.maxResults&&[...P.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>S.maxResults){V=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>j.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=T.$Ce.fromString(ce.toString()),Ie=await D.deserializeNotebook(ve.buffer,f);if(f.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(be=>j.push({input:be.source,outputs:be.outputs.flatMap(ie=>ie.items.map(Pe=>Pe.valueBytes.toString()))}))}if(f.isCancellationRequested)return;j.forEach((ce,ve)=>{const Ie=S.contentPattern.pattern,ue=new h.$zWb(ce.input,void 0,ce.outputs),be=ue.findInInputs(Ie),ie=ue.findInOutputs(Ie),Pe=ie.flatMap(Fe=>(0,i.$uL)(Fe.matches,Fe.textBuffer)).map((Fe,ne)=>(Fe.webviewIndex=ne,Fe));if(be.length>0||ie.length>0){const Fe={index:ve,contentResults:(0,i.$uL)(be,ue.inputTextBuffer),webviewResults:Pe};R.push(Fe)}});const se={resource:q,cellResults:R};P.set(q,se);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(l,S){const d=await this.s.value.stat(l);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==N.$pl&&typeof d.mtime=="number"&&typeof d.size=="number"&&S.mtime<d.mtime&&S.etag!==N.$ql({mtime:S.mtime,size:d.size}))throw new N.$fl((0,I.localize)(1,null),3,S)}z(l){return l.scheme===c.Schemas.file?l.fsPath:l.toString()}A(l,S,d){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const E=new n.$Nlc(S,this.d,l,d.visibleRanges.map(m.NotebookRange.to),d.selections.map(m.NotebookRange.to),typeof d.viewColumn=="number"?m.ViewColumn.to(d.viewColumn):void 0);this.h.set(S,E)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const d of l.value.removedDocuments){const E=k.URI.revive(d),f=this.g.get(E);f&&(f.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(f.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===E.toString()&&this.h.delete(D.id)}if(l.value.addedDocuments){const d=[];for(const E of l.value.addedDocuments){const f=k.URI.revive(E.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const D=new r.$Mlc(this.c,this.q,this.r,f,E);d.push(...E.cells.map(w=>r.$Llc.asModelAddData(w))),this.g.get(f)?.dispose(),this.g.set(f,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this.m.fire(D.apiNotebook)}}if(l.value.addedEditors)for(const d of l.value.addedEditors){if(this.h.has(d.id))return;const E=k.URI.revive(d.documentUri),f=this.g.get(E);f&&this.A(f,d.id,d)}const S=[];if(l.value.removedEditors)for(const d of l.value.removedEditors){const E=this.h.get(d);E&&(this.h.delete(d),this.k?.id===E.id&&(this.k=void 0),S.push(E))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const d=new Set;this.l.forEach(E=>d.add(E.id));for(const E of this.h.values()){const f=d.has(E.id);E._acceptVisibility(f)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const S=v.$AP.String.with("notebookType","A notebook type"),d=new v.$CP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$AP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>T.$Ce.wrap(f))],new v.$BP("Notebook Data",f=>m.NotebookData.to(f.value))),E=new v.$CP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$AP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$lw(m.NotebookData.from(f)))],new v.$BP("Bytes",f=>f.buffer));l.registerApiCommand(d),l.registerApiCommand(E)}}e.$Wlc=a}),define(Ae[290],Re([1,0,19,22,43,36,24,65,46]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class k{constructor(u,v,m){this.k=u,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$kk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$kk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const v=this.k.folderQueries||[];return new Promise((m,s)=>{const o=r=>{this.f++,u(r)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const n=r.toString(),t=I.$oc(n);this.j&&this.j(n,t)||this.v(o,{base:r,basename:t})}),Promise.all(v.map(r=>this.p(r,o))).then(r=>{m({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,A.$bj)(r)))})})}async p(u,v){const m=new T.$me,s=this.q(u),o=this.r(),r=new g.$kL(this.k,u),n=!r.hasSiblingExcludeClauses();let t;try{this.h.add(m),t=p.$0d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),h=t.elapsed(),i=p.$0d.create();return this.g&&!this.e||(c&&c.forEach(b=>{const a=I.$hc.relative(u.folder.path,b.path);if(n){const $=I.$oc(b.path);this.v(v,{base:u.folder,relativePath:a,basename:$});return}this.s(o,u.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,r,v),{providerTime:h,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const v=(0,g.$jL)(this.k.includePattern,u.includePattern),m=(0,g.$jL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},v,m,s){if(m===this.a){const r=I.$oc(this.a);this.v(s,{base:v,relativePath:this.a,basename:r})}function o(r){const n=I.$oc(r),t=I.$nc(r);let c=u[t];c||(c=u[t]=[],o(t)),c.push({base:v,relativePath:r,basename:n})}o(m)}u({rootEntries:u,pathToEntries:v},m,s){const o=this,r=this.a;function n(t){const c=(0,g.$mL)(()=>t.map(h=>h.basename));for(let h=0,i=t.length;h<i;h++){const b=t[h],{relativePath:a,basename:$}=b;if(m.matchesExcludesSync(a,$,r!==$?c:void 0))continue;const l=v[a];if(l)n(l);else{if(a===r)continue;o.v(s,b)}if(o.e)break}}n(u)}v(u,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(v))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,v,m,s){const o=this.c(u.cacheKey),r=new k(u,v,o&&o.token);let n=0;const t=c=>{n+=c.length,m(c.map(h=>this.d(h)))};return this.e(r,N.a,t,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$me),this.b.get(u)}d(u){return u.relativePath?{resource:M.$4g(u.base,u.relativePath)}:{resource:u.base}}e(u,v,m,s){const o=s.onCancellationRequested(()=>{u.cancel()}),r=t=>{t&&(n.push(t),v>0&&n.length>=v&&(m(n),n=[]))};let n=[];return u.search(r).then(t=>(n.length&&m(n),o.dispose(),t),t=>(n.length&&m(n),o.dispose(),Promise.reject(t)))}}e.$Olc=N}),define(Ae[291],Re([1,0,18,259,36,96,28,12,19,24,15,17,2,95,186,48,13,49,107,287,46]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=E;let h=class{constructor(D,w,C,P,V){this.a=D,this.b=w,this.c=C,this.d=P,this.e=V}text(D,w,C={}){D=this.f(D,C);const P=this.a.getValue(),V=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(r.$Li),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,w){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,w)&&(P.isCaseSensitive=!0),this.k(D)&&(P.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),P}file(D,w={}){return{...this.h(D,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(D,w){return D?(D=Array.isArray(D)?D.map(l):l(D),w?this.parseSearchPaths(D):{pattern:b(...Array.isArray(D)?D:[D])}):{}}h(D=[],w={}){const C=this.g(w.includePattern,w.expandPatterns),P=this.g(w.excludePattern,w.expandPatterns),V=D.length>1,W=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,w,P)):D.map(j=>this.r(j,w,P,V))).filter(j=>!!j),q={_reason:w._reason,folderQueries:W,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const j=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ce=>(0,c.$aL)(q,ce.fsPath)),se=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(se)),{...q,...se}}const R=w.extraFileResources&&w.extraFileResources.filter(j=>(0,c.$aL)(q,j.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(D){const w=[],C=new M.$Bc,P={};let V=!1;return D.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,k.$8g)(W)){const R=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$nc(W.fsPath)});let j=C.get(R);j||(V=!0,j={folder:R,includePattern:{}},w.push(j),C.set(R,j));const K=g.$mc(R.fsPath,W.fsPath);(0,y.$cg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:w,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(D,w){if(w.isSmartCase){if(D.isRegExp){if(N.$Uf(D.pattern,!0))return!0}else if(N.$Uf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,v.$AC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const w=se=>g.$jc(se)||/^\.\.?([\/\\]|$)/.test(se),P=(Array.isArray(D)?D:a(D)).map(se=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$qw)(se,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):se}),V=T.$K(P,se=>w(se)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(se=>N.$bf(se,"/")).map(se=>N.$bf(se,"\\")).map(se=>(se[0]==="."&&(se="*"+se),$(se))),q={},R=this.m(V.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const j=I.$Rb(W),K=b(...j);return K&&(q.pattern=K),q}l(D,w){return w.disregardExcludeSettings?void 0:(0,c.$_K)(D,!w.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const w=D.flatMap(P=>{let{pathPortion:V,globPortion:W}=i(P);return W&&(W=S(W)),this.n(V).flatMap(R=>this.o(R,W))}),C=new Map;return w.forEach(P=>{const V=P.searchPath.toString(),W=C.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):C.set(V,{searchPath:P.searchPath,pattern:P.pattern?b(P.pattern):void 0})}),Array.from(C.values())}n(D){if(g.$jc(D)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==p.Schemas.file?[{searchPath:w[0].uri.with({path:D})}]:[{searchPath:u.URI.file(g.$ic(D))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(D=l(D),D.startsWith("../")||D===".."){const P=g.$hc.resolve(w.path,D);return[{searchPath:w.with({path:P})}]}const C=S(D);return[{searchPath:w,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const w=D.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=w.match(new RegExp(`^${N.$8e(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(y.$_f);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&S(W)}});{const V=D.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:D,q=m.localize(0,null,W);throw new Error(q)}}}}o(D,w){const C=D.pattern&&w?`${D.pattern}/${w}`:D.pattern||w,P=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:C+"/**"}),P}q(D,w,C){const P=this.r((0,r.$Li)(D.searchPath),w,C,!1);return P?{...P,includePattern:D.pattern}:null}r(D,w,C,P){let V;const W=u.URI.isUri(D)?D:D.uri;if(C.searchPaths){const se=C.searchPaths.filter(ce=>(0,k.$Wg)(ce.searchPath,W))[0];if(se&&!se.pattern)return null;se&&(V=se.pattern)}const q=this.a.getValue({resource:W}),j={...this.l(q,w)||{},...V||{}},K=u.URI.isUri(D)?(0,k.$1g)(D):D.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};e.$tM=h,e.$tM=h=Je([Ve(0,s.$Wi),Ve(1,r.$zi),Ve(2,n.$HD),Ve(3,o.$Wj),Ve(4,t.$rM)],h);function i(f){const D=f.match(/[\*\{\}\(\)\[\]\?]/);if(D){const w=D.index,C=f.substr(0,w).match(/[/|\\][^/\\]*$/);if(C){let P=f.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:f.substr((C.index||0)+1)}}}return{pathPortion:f}}function b(...f){return f.length?f.reduce((D,w)=>(D[w]=!0,D),Object.create(null)):void 0}function a(f){return A.$ik(f,",").map(D=>D.trim()).filter(D=>!!D.length)}function $(f){return[`**/${f}/**`,`**/${f}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function l(f){return f.replace(/\\/g,"/")}function S(f){return l(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(f){return f.replace(/([?*[\]])/g,"[$1]")}function E(f,D){f=I.$Mb(f,P=>P.toString());const w=[],C=D.getWorkspace();return f&&f.forEach(P=>{let V;if(D.getWorkbenchState()===2)V=(0,k.$6g)(C.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=D.getWorkspaceFolder(P);if(W){const q=W.name;if(C.folders.filter(j=>j.name===q).length===1){const j=(0,k.$6g)(W.uri,P);j===""?V=`./${W.name}`:V=`./${W.name}/${j}`}else V=P.fsPath}}V&&w.push(d(V))}),w}}),define(Ae[292],Re([1,0,24,2,22,14,3,291,46,49,11]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ktb=u,e.$Ltb=s;const y=7e3;function u(o,r){const n=r.activationEvents;if(!n)return Promise.resolve(void 0);const t=[],c=[];for(const l of n)if(/^workspaceContains:/.test(l)){const S=l.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?c.push(S):t.push(S)}if(t.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:i}=(0,N.$jh)(),b=l=>i({activationEvent:l}),a=Promise.all(t.map(l=>v(o,l,b))).then(()=>{}),$=m(o,r.identifier,c,b);return Promise.all([a,$]).then(()=>{i(void 0)}),h}async function v(o,r,n){for(const t of o.folders)if(await o.exists(I.$4g(T.URI.revive(t),r))){n(`workspaceContains:${r}`);return}}async function m(o,r,n,t){if(n.length===0)return Promise.resolve(void 0);const c=new A.$me,h=o.checkExists(o.folders,n,c.token),i=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},y);let b=!1;try{b=await h}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(i),b&&t(`workspaceContains:${n.join(",")}`)}function s(o,r,n,t){const c=o.get(M.$pi),h=o.get(g.$4K),b=c.createInstance(p.$tM).file(r.map(a=>(0,k.$Li)(T.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(b,t).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Ae[39],Re([1,0,164,19,89,24,11,6,52,2,13,4,38,226,82,37,25,108,14,20,23,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,E,f,D,w,C,P,V,W,q,R,j,K){"use strict";var se;Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=e.$slc=e.$rlc=e.$qlc=void 0,e.$qlc=(0,a.$qi)("IHostUtils");let ce=se=class extends p.$Uc{constructor(U,x,pe,Oe,ke,$e,fe,J,Y,he,le,Te,de){super(),this.Y=Te,this.Z=de,this.a=this.B(new w.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=pe,this.f=fe,this.j=Oe,this.m=ke,this.s=$e,this.t=Y,this.u=he,this.w=le,this.y=this.g.getProxy(y.$PM.MainThreadWorkspace),this.z=this.g.getProxy(y.$PM.MainThreadTelemetry),this.C=this.g.getProxy(y.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Fe(this.f.extensions.activationEvents),this.L=new r.$5$b(this.I,this.f.extensions.allExtensions);const Ce=new t.$Mm(this.f.extensions.myExtensions);this.J=new r.$5$b(this.I,ie(this.L,Ce)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new m.$_kc(this.g,this.s),this.N=new P.$jlc(this.g),this.O=J,this.h=U.createChild(new d.$oi([m.$alc,this.M],[P.$klc,this.N])),this.P=this.B(new v.$$kc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,n.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(r.$5$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new v.$0kc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(U)}terminate(U,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Oe=>{this.s.error(Oe)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$rh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const x=await this.C.$getExtension(U);return x&&{...x,identifier:new t.$Lm(x.identifier.value),extensionLocation:k.URI.revive(x.extensionLocation)}}ab(U,x){return this.P.activateByEvent(U,x)}bb(U,x){return this.P.activateById(U,x)}activateByIdWithErrors(U,x){return this.bb(U,x).then(()=>{const pe=this.P.getActivatedExtension(U);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===W.Schemas.file&&this.c.fsRealpath){const x=U.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const pe=await this.R.get(x);return k.URI.file(pe)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new Pe(U))),this.Q}async db(U){const x=g.$wi.forUris(pe=>O.$Ug.ignorePathCasing(pe));return await Promise.all(U.map(async pe=>{if(this.wb(pe)){const Oe=await this.cb(pe.extensionLocation);x.set(Oe,pe)}})),x}eb(U){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return x;const pe=this.P.getActivatedExtension(U);if(!pe)return x;try{typeof pe.module.deactivate=="function"&&(x=Promise.resolve(pe.module.deactivate()).then(void 0,Oe=>(this.s.error(Oe),Promise.resolve(void 0))))}catch(Oe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Oe)}try{(0,p.$Pc)(pe.subscriptions)}catch(Oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Oe)}return x}async fb(U,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,x).then(pe=>{const Oe=pe.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Oe.codeLoadingTime,Oe.activateCallTime,Oe.activateResolvedTime,x),this.gb(U,x,"success",Oe),pe},pe=>{throw this.gb(U,x,"failure"),pe})}gb(U,x,pe,Oe){const ke=Ie(U,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Oe||{},outcome:pe})}hb(U,x){const pe=Ie(U,x);this.z.$publicLog2("activatePlugin",pe);const Oe=this.wb(U);if(!Oe)return Promise.resolve(new v.$9kc(v.$6kc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${U.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new v.$7kc(x.startup);return Promise.all([this.xb(U,(0,O.$4g)(U.extensionLocation,Oe),ke),this.ib(U)]).then($e=>(A.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),se.jb(this.s,U.identifier,$e[0],$e[1],ke))).then($e=>(A.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),$e))}ib(U){const x=this.Z.createLanguageModelAccessInformation(U),pe=new h.$clc(U,this.M),Oe=new h.$blc(U.identifier.value,!1,this.M),ke=new V.$llc(U,this.N),$e=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([pe.whenReady,Oe.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,he;const le=(0,o.$wG)(U,"ipc")?this.f.messagePorts?.get(t.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Oe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Te){return T.$kc(U.extensionLocation.fsPath,Te)},get storagePath(){return J.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return J.O.globalValue(U).fsPath},get logPath(){return T.$kc(J.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,U.identifier.value)},get storageUri(){return J.O.workspaceValue(U)},get globalStorageUri(){return J.O.globalValue(U)},get extensionMode(){return $e},get extension(){return Y===void 0&&(Y=new be(J,U.identifier,U,fe,!1)),Y},get extensionRuntime(){return(0,o.$xG)(U,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!le)return;const Te=w.Event.buffer(w.Event.fromDOMEventEmitter(le,"message",de=>de.data));le.start(),he={onDidReceiveMessage:Te,postMessage:le.postMessage.bind(le)}}return he}})})}static jb(U,x,pe,Oe,ke){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(U,x,pe,Oe,ke).then($e=>new v.$8kc(!1,null,ke.build(),pe,$e,Oe.subscriptions))}static kb(U,x,pe,Oe,ke){if(typeof pe.activate=="function")try{ke.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,fe=pe.activate.apply($e,[Oe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(fe).then(J=>(ke.activateResolveStop(),J))}catch($e){return Promise.reject($e)}else return Promise.resolve(pe)}lb(U,x){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:x}).then(void 0,pe=>{this.s.error(pe)})}mb(U,x=0){const Oe=Date.now();(0,j.$B)(()=>{for(let ke=x;ke<U.length;ke+=1){const $e=U[ke];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Oe>50){this.mb(U,ke);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(U=>{const x=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(x)this.mb(pe);else for(const Oe of pe)if(Oe.activationEvents)for(const ke of Oe.activationEvents)ke==="onStartupFinished"&&this.lb(Oe,ke)})}ob(){const U=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(x),Oe=this.rb(),ke=Promise.all([Oe,U,pe]).then(()=>{});return Promise.race([ke,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),ke}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(U,x))).then(()=>{})}async qb(U,x){if(this.isActivated(x.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Oe={logService:this.s,folders:U.map($e=>$e.uri),forceUsingSearch:pe||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,J)=>this.y.$checkExists($e,fe,J)},ke=await(0,C.$Ktb)(Oe,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:x}=this.f.environment;if(!U||!x)throw new Error(I.localize(0,null));const pe=await this.xb(null,x,new v.$7kc(!1));if(!pe||typeof pe.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Oe,ke)=>{const $e=(Y,he)=>{Y?(j.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(j.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Oe(typeof he=="number"&&he>0?1:0))},fe=(0,O.$Rg)(x),J=pe.run(fe,$e);J&&J.then&&J.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Oe(0)}).catch(Y=>{j.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,x){return this.S[U]=x,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:x}=await this.ub(U);return x?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const x=U.indexOf("+");if(x===-1)throw new i.$XM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=U.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(U,x){const pe=R.$0d.create(!1),Oe=()=>`[resolveAuthority(${(0,b.$Fl)(U)},${x})][${pe.elapsed()}ms] `,ke=L=>this.s.info(`${Oe()}${L}`),$e=L=>this.s.warn(`${Oe()}${L}`),fe=(L,G=void 0)=>this.s.error(`${Oe()}${L}`,G),J=L=>{if(L instanceof i.$XM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{ke(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw fe(`no resolver for ${H}`),new i.$XM(`No remote extension installed to resolve ${H}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},he=U.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let le;try{le=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof i.$XM)||L._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await Y(U)]})}catch(L){return J(L)}const Te=new M.$Bh;Te.cancelAndSet(()=>ke("waiting..."),1e3);let de,Ce;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of le.entries())try{if(L===le.length-1)ke("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),A.mark(`code/extHost/didResolveAuthorityOK/${G}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,i.$WM.isManagedResolvedAuthority(de)?de:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),A.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new i.$XM(`Exec server was not available for ${ee}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return A.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",re),Te.dispose(),J(re)}Te.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${i.$WM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(i.$WM.isManagedResolvedAuthority(de)){const L=x;this.Y.setFactory(L,de.makeConnection),z={authority:U,connectTo:new b.$Cl(L),connectionToken:de.connectionToken}}else z={authority:U,connectTo:new b.$Dl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(U,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Fl)(U)})`);const{resolver:pe}=await this.ub(U);if(!pe)return null;const Oe=k.URI.revive(x);if(typeof pe.getCanonicalURI>"u")return Oe;const ke=await(0,M.$ih)(()=>pe.getCanonicalURI(Oe));return ke||Oe}async $startExtensionHost(U){U.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,U),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(U,x){return x===1?this.D.wait().then(pe=>this.ab(U,!1)):this.G.wait().then(pe=>this.ab(U,!1))}async $activate(U,x){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,x),!0):!1}async $deltaExtensions(U){U.toAdd.forEach($e=>$e.extensionLocation=k.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:pe}=ve(this.I,this.L,this.J,U),Oe=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Oe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const x=c.$Ce.alloc(U),pe=Math.random()%256;for(let Oe=0;Oe<U;Oe++)x.writeUInt8(pe,Oe);return x}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$rlc=ce,e.$rlc=ce=se=Je([Ve(0,a.$pi),Ve(1,e.$qlc),Ve(2,S.$cP),Ve(3,s.$Okc),Ve(4,u.$Rkc),Ve(5,N.$Wj),Ve(6,$.$sP),Ve(7,l.$Ukc),Ve(8,E.$NCb),Ve(9,f.$dlc),Ve(10,q.$nlc),Ve(11,K.$olc),Ve(12,D.$hlc)],ce);function ve(ne,U,x,pe){ne.addActivationEvents(pe.addActivationEvents);const Oe=new r.$5$b(ne,U.getAllExtensionDescriptions());Oe.deltaExtensions(pe.toAdd,pe.toRemove);const ke=new t.$Mm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of pe.myToRemove)ke.delete(fe);for(const fe of pe.myToAdd)ke.add(fe);const $e=ie(Oe,ke);return{globalRegistry:Oe,myExtensions:$e}}function Ie(ne,U){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$slc=(0,a.$qi)("IExtHostExtensionService");class be{#e;#t;#i;constructor(U,x,pe,Oe,ke){this.#e=U,this.#t=x,this.#i=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=T.$ic((0,O.$Rg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Oe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tlc=be;function ie(ne,U){return ne.getAllExtensionDescriptions().filter(x=>U.has(x.identifier))}class Pe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$ulc=Pe;class Fe{constructor(U){this.a=new t.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const x of Object.keys(U))this.a.set(x,U[x])}}}),define(Ae[293],Re([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;let s=class{constructor(c,h,i,b,a,$,l){this.c=c,this.d=h,this.e=i,this.f=b,this.g=a,this.h=$,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Dmc=s,e.$Dmc=s=Je([Ve(2,N.$pi),Ve(3,O.$Rkc),Ve(4,y.$slc),Ve(5,k.$sP),Ve(6,u.$Wj)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const h=(0,v.$8e)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",b=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,b,a]=h,$=m.a.get(b);if($!==void 0)return console.warn(`${b} as been renamed to ${$}, please update your imports`),i+$+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([Ve(0,k.$sP)],o);class r{constructor(c,h,i,b,a){this.c=c,this.d=h,this.e=i,this.f=b,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Nm}load(c,h){const i=this.d.findSubstr(h);if(i){let b=this.a.get(i.identifier);return b||(b=this.c(i,this.e,this.f),this.a.set(i.identifier,b)),b}if(!this.b){let b="";this.d.forEach((a,$)=>b+=`	${$} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${b}`),this.b=this.c(M.$rG,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(A.$PM.MainThreadTelemetry);const b=i.getProxy(A.$PM.MainThreadWindow);this.c=(a,$)=>{const l=T.URI.parse(a);return $?this.g(a,$):l.scheme==="http"||l.scheme==="https"?b.$openUri(l,a,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?b.$openUri(l,a,{}):this.g(a,$)}}load(c,h,i){const b=this.e.findSubstr(h);return b&&(this.a=b.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ve(2,g.$cP)],n)}),define(Ae[120],Re([1,0,41,6,19,73,3,67,66,39,7,37,223,38]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0,e.$vlc=(0,M.$qi)("IExtHostVariableResolverProvider");class m extends u.$eQ{constructor(r,n,t,c,h,i,b){function a(){if(t){const $=t.activeEditor();if($)return $.document.uri;const l=c.tabGroups.all.find(S=>S.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof N.$CO||l.input instanceof N.$HO)return l.input.modified;if(l.input instanceof N.$BO||l.input instanceof N.$GO||l.input instanceof N.$EO)return l.input.uri}}}super({getFolderUri:$=>{const l=i.folders.filter(S=>S.name===$);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:($,l)=>h.getConfiguration(void 0,$).get(l),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=a();if($)return A.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=a();if($){const l=n.getWorkspaceFolder($);if(l)return A.$ic(l.uri.fsPath)}}},getSelectedText:()=>{if(t){const $=t.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(t){const $=t.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>r.getExtension($)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(O.env))}}let s=class extends T.$Uc{constructor(r,n,t,c,h){super(),this.b=r,this.c=n,this.g=t,this.h=c,this.j=h,this.a=new I.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$wlc=s,e.$wlc=s=Je([Ve(0,k.$slc),Ve(1,y.$Okc),Ve(2,p.$nP),Ve(3,v.$Rkc),Ve(4,g.$4kc)],s)}),define(Ae[121],Re([1,0,11,5,2,20,3,4,66,39,16,7,37,215,217,38,120,6,42,32,8]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=e.$zlc=e.$ylc=e.$xlc=void 0,e.$xlc=(0,M.$qi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(d,E,f,D,w,C,P){this.N=E,this.O=f,this.P=D,this.Q=w,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new T.$be,this.o=new T.$be,this.q=new T.$be,this.w=new T.$be,this.l=d.getProxy(p.$PM.MainThreadDebugService),this.A=new T.$be,this.C=new T.$be,this.y=new b(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(W=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(d,E){const f=this.W(E);if(!f)return;const D=await this.H.get(d)?.getTreeItem?.(f);return D?this.U(d,D):void 0}registerDebugVisualizationTree(d,E,f){const D=O.$Lm.toKey(d.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(w,f),this.l.$registerDebugVisualizerTree(w,!!f.editItem),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(E)})}async $getVisualizerTreeItemChildren(d,E){const f=this.J.get(E)?.item;return f?(await this.H.get(d)?.getChildren?.(f))?.map(w=>this.U(d,w))||[]:[]}async $editVisualizerTreeItem(d,E){const f=this.J.get(d);if(!f)return;const D=await this.H.get(f.provider)?.editItem?.(f.item,E);return this.U(f.provider,D||f.item)}$disposeVisualizedTree(d){const E=this.J.get(d);if(!E)return;const f=[E.children];for(const D of f)if(D)for(const w of D)f.push(this.J.get(w)?.children),this.J.delete(w)}U(d,E){let f=this.I.get(E);return f||(f=this.F++,this.I.set(E,f),this.J.set(f,{provider:d,item:E})),c.DebugTreeItem.from(E,f)}asDebugSourceUri(d,E){const f=d;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let D=`debug:${encodeURIComponent(f.path||"")}`,w="?";return E&&(D+=`${w}session=${encodeURIComponent(E.id)}`,w="&"),D+=`${w}ref=${f.sourceReference}`,A.URI.parse(D)}else{if(f.path)return A.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(d){const E=[];for(const f of d.getAllExtensionDescriptions())if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0)for(const w of D)(0,m.$_G)(w)&&E.push(w.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const d=[];return this.z.forEach(E=>d.push(E)),d}async $resolveDebugVisualizer(d,E){const f=this.L.get(d);if(!f)throw new Error(`No debug visualizer found with id '${d}'`);let{v:D,provider:w,extensionId:C}=f;if(D.visualization||(D=await w.resolveDebugVisualization?.(D,E)||D,f.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(C,D.visualization)}async $executeDebugVisualizerCommand(d){const E=this.L.get(d);if(!E)throw new Error(`No debug visualizer found with id '${d}'`);const f=E.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(d){const E=this.m.get(d.sessionId);return E&&{session:E.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,E,f,D){const w=this.W(f),C=this.jb(d,E),P=this.G.get(C);if(!w||!P)return[];const V=await P.provideDebugVisualization(w,D);return V?V.map(W=>{const q=++this.M;this.L.set(q,{v:W,provider:P,extensionId:d});const R=W.iconPath?this.lb(W.iconPath):void 0;return{id:q,name:W.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.kb(d,W.visualization)}}):[]}$disposeDebugVisualizers(d){for(const E of d)this.L.delete(E)}registerDebugVisualizationProvider(d,E,f){if(!d.contributes?.debugVisualizers?.some(C=>C.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const D=O.$Lm.toKey(d.identifier),w=this.jb(D,E);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(w,f),this.l.$registerDebugVisualizer(D,E),(0,r.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,E),this.G.delete(E)})}addBreakpoints(d){const E=d.filter(w=>{const C=w.id;return this.z.has(C)?!1:(this.z.set(C,w),!0)});this.gb(E,[],[]);const f=[],D=new Map;for(const w of E)if(w instanceof y.$SN){let C=D.get(w.location.uri.toString());C||(C={type:"sourceMulti",uri:w.location.uri,lines:[]},D.set(w.location.uri.toString(),C),f.push(C)),C.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof y.$TN&&f.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(d){const E=d.filter(C=>this.z.delete(C.id));this.gb([],E,[]);const f=E.filter(C=>C instanceof y.$SN).map(C=>C.id),D=E.filter(C=>C instanceof y.$TN).map(C=>C.id),w=E.filter(C=>C instanceof y.$UN).map(C=>C.id);return this.l.$unregisterBreakpoints(f,D,w)}startDebugging(d,E,f){return this.l.$startDebugging(d?d.uri:void 0,E,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(d){return this.l.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,E,f){if(!E)return new y.$RM(()=>{});const D=this.d++;return this.f.push({type:d,handle:D,provider:E}),this.l.$registerDebugConfigurationProvider(d,f,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,D),new y.$RM(()=>{this.f=this.f.filter(w=>w.provider!==E),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(d,E,f){if(!f)return new y.$RM(()=>{});if(!this.cb(d,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:E,handle:D,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(E,D),new y.$RM(()=>{this.h=this.h.filter(w=>w.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(d,E){if(!E)return new y.$RM(()=>{});const f=this.j++;return this.k.push({type:d,handle:f,factory:E}),new y.$RM(()=>{this.k=this.k.filter(D=>D.factory!==E)})}async $runInTerminal(d,E){return Promise.resolve(void 0)}async $substituteVariables(d,E){let f;const D=await this.ib(d);return D&&(f={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,E)}X(d,E){if(d.type==="implementation")return new $(d.implementation)}Y(){}async $startDASession(d,E){const f=this,D=await this.hb(E);return this.eb(this.$(D.type),D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const C=this.Z(w),P=this.X(C,D);if(!P)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const V=P;return this.D.set(d,V),this.db(D).then(W=>(W&&this.E.set(d,W),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const R=q,j={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(R.arguments.value);j.body={signature:K},V.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,V.sendResponse(j)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(q),q=(0,m.$eH)(q,!0),f.l.$acceptDAMessage(d,q)}),V.onError(q=>{W&&W.onError&&W.onError(q),this.l.$acceptDAError(d,q.name,q.message,q.stack)}),V.onExit(q=>{W&&W.onExit&&W.onExit(q??void 0,void 0),this.l.$acceptDAExit(d,q??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),V.startSession()))})}$sendDAMessage(d,E){E=(0,m.$dH)(E,!1);const f=this.E.get(d);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(E),this.D.get(d)?.sendMessage(E)}$stopDASession(d){const E=this.E.get(d);this.E.delete(d),E&&E.onWillStopSession&&E.onWillStopSession();const f=this.D.get(d);return this.D.delete(d),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const E=[],f=[],D=[];if(d.added)for(const w of d.added){const C=w.id;if(C&&!this.z.has(C)){let P;if(w.type==="function")P=new y.$TN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")P=new y.$UN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const V=A.URI.revive(w.uri);P=new y.$SN(new y.$4M(V,new y.$SM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,y.$QN)(P,C),this.z.set(C,P),E.push(P)}}if(d.removed)for(const w of d.removed){const C=this.z.get(w);C&&(this.z.delete(w),f.push(C))}if(d.changed){for(const w of d.changed)if(w.id){const C=this.z.get(w.id);if(C){if(C instanceof y.$TN&&w.type==="function"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.functionName=w.functionName}else if(C instanceof y.$SN&&w.type==="source"){const P=C;P.enabled=w.enabled,P.condition=w.condition,P.hitCondition=w.hitCondition,P.logMessage=w.logMessage,P.location=new y.$4M(A.URI.revive(w.uri),new y.$SM(w.line,w.character))}D.push(C)}}}this.gb(E,f,D)}async $acceptStackFrameFocus(d){let E;if(d){const f=await this.hb(d.sessionId);d.kind==="thread"?E=new y.$1N(f.api,d.threadId):E=new y.$ZN(f.api,d.threadId,d.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(d,E,f){return(0,I.$ih)(async()=>{const D=this.bb(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(E);return D.provideDebugConfigurations(w,f)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(d,E,f,D){return(0,I.$ih)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(E);return w.resolveDebugConfiguration(C,f,D)})}$resolveDebugConfigurationWithSubstitutedVariables(d,E,f,D){return(0,I.$ih)(async()=>{const w=this.bb(d);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(E);return w.resolveDebugConfigurationWithSubstitutedVariables(C,f,D)})}async $provideDebugAdapter(d,E){const f=this.ab(d);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(E);return this.eb(f,D).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted(d){const E=await this.hb(d);this.n.fire(E.api)}async $acceptDebugSessionTerminated(d){const E=await this.hb(d);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(d){this.u=d?await this.hb(d):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(d,E){(await this.hb(d))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(d,E){const D={session:(await this.hb(d)).api,event:E.event,body:E.body};this.w.fire(D)}Z(d){if(d instanceof y.$VN)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof y.$WN)return{type:"server",port:d.port,host:d.host};if(d instanceof y.$XN)return{type:"pipeServer",path:d.path};if(d instanceof y.$YN)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}$(d){const E=this.h.filter(f=>f.type===d);if(E.length>0)return E[0].factory}ab(d){const E=this.h.filter(f=>f.handle===d);if(E.length>0)return E[0].factory}bb(d){const E=this.f.filter(f=>f.handle===d);if(E.length>0)return E[0].provider}cb(d,E){if(d.contributes){const f=d.contributes.debuggers;if(f&&f.length>0){for(const D of f)if(D.label&&D.type&&D.type===E)return!0}}return!1}db(d){const f=d.configuration.type,D=this.k.filter(w=>w.type===f||w.type==="*").map(w=>(0,I.$ih)(()=>w.factory.createDebugAdapterTracker(d.api)).then(C=>C,C=>null));return Promise.race([Promise.all(D).then(w=>{const C=w.filter(P=>!!P);if(C.length>0)return new a(C)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb(d,E){const f=E.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.$WN(f));if(d){const w=await this.O.getExtensionRegistry();return(0,I.$ih)(()=>d.createDebugAdapterDescriptor(E.api,this.fb(E,w))).then(C=>{if(C)return C})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,D))}fb(d,E){}gb(d,E,f){(d.length>0||E.length>0||f.length>0)&&this.A.fire(Object.freeze({added:d,removed:E,changed:f}))}async hb(d){if(d)if(typeof d=="string"){const E=this.m.get(d);if(E)return E}else{let E=this.m.get(d.id);if(!E){const f=await this.ib(d.folderUri),D=d.parent?this.m.get(d.parent):void 0;E=new i(this.l,d.id,d.type,d.name,f,d.configuration,D?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(d){if(d){const E=A.URI.revive(d);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(d,E){return`${d}\0${E}`}kb(d,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${d}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(d){const E=this.mb(d);let f,D;return"id"in E?D=n.ThemeIcon.asClassName(E):f=E,{iconPath:f,iconClass:D}}mb(d){if(d instanceof y.$NN)return{id:d.id};const E=typeof d=="object"&&"dark"in d?d.dark:d,f=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof E=="string"?A.URI.file(E):E,light:typeof f=="string"?A.URI.file(f):f}}};e.$ylc=h,e.$ylc=h=Je([Ve(0,N.$cP),Ve(1,u.$Okc),Ve(2,k.$slc),Ve(3,s.$Rkc),Ve(4,g.$4kc),Ve(5,o.$vlc),Ve(6,t.$yP)],h);class i{constructor(d,E,f,D,w,C,P){this.f=d,this.g=E,this.h=f,this.j=D,this.k=w,this.l=C,this.m=P}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.j},set name(E){d.j=E,d.f.$setDebugSessionName(d.g,E)},parentSession:d.m,workspaceFolder:d.k,configuration:d.l,customRequest(E,f){return d.f.$customDebugAdapterRequest(d.g,E,f)},getDebugProtocolBreakpoint(E){return d.f.$getDebugProtocolBreakpoint(d.g,E.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.j=d}get configuration(){return this.l}}e.$zlc=i;class b{constructor(d){this.value=Object.freeze({append(E){d.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$Alc=b;class a{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(E=>E.onError?E.onError(d):void 0)}onExit(d,E){this.d.forEach(f=>f.onExit?f.onExit(d,E):void 0)}}class $ extends v.$Qob{constructor(d){super(),this.h=d,d.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(d,E,f,D,w,C,P){super(d,E,f,D,w,C,P)}};e.$Blc=l,e.$Blc=l=Je([Ve(0,N.$cP),Ve(1,u.$Okc),Ve(2,k.$slc),Ve(3,s.$Rkc),Ve(4,g.$4kc),Ve(5,o.$vlc),Ve(6,t.$yP)],l)}),define(Ae[294],Re([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=e.$Emc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const c=t.get(p.$Wj),i=t.get(u.$cP).getProxy(O.$PM.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{c.error(b);const a=I.$3(b);i.$onUnexpectedError(a)})}static async installFullHandler(t){const c=t.get(p.$Wj),h=t.get(u.$cP),i=t.get(m.$slc),b=t.get(s.$wP),a=h.getProxy(O.$PM.MainThreadExtensionService),$=h.getProxy(O.$PM.MainThreadErrors),l=await i.getExtensionPathIndex(),S=new WeakMap;function d(D,w){if(S.has(D))return S.get(D).stack;let C="",P,V;for(const q of w)C+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=l.findSubstr(A.URI.file(V)));const W=`${D.name||"Error"}: ${D.message||""}${C}`;return S.set(D,{extensionIdentifier:P?.identifier,stack:W}),W}const E=Symbol("prepareStackTrace wrapped");let f=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(D){if(D===d||!D||D[E]){f=D||d;return}f=function(w,C){return d(w,C),D.call(Error,w,C)},Object.assign(f,{[E]:!0})}}),I.setUnexpectedErrorHandler(D=>{c.error(D);const w=I.$3(D),C=S.get(D);if(!C?.extensionIdentifier){$.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(C.extensionIdentifier,w);const P=b.onExtensionError(C.extensionIdentifier,D);c.trace("forwarded error to extension?",P,C)})}}e.$Emc=o;class r{constructor(t,c,h,i,b){this.a=h,this.b=new M.$a_b(t,null,i),c=r.e(c,this.b);const a=new k.$oi(...(0,g.$ps)());a.set(N.$sP,{_serviceBrand:void 0,...c,messagePorts:b}),a.set(u.$cP,new u.$dP(this.b)),a.set(v.$Lkc,new v.$Mkc(i)),a.set(m.$qlc,h);const $=new y.$7q(a,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(l=>l.get(p.$Wj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=$.invokeFunction(l=>l.get(m.$slc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const c=this.b.getProxy(O.$PM.MainThreadExtensionService);return A.URI.revive(await c.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,c){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=A.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=A.URI.revive(c.transformIncomingURIs(t.environment.appRoot));const h=t.environment.extensionDevelopmentLocationURI;return h&&(t.environment.extensionDevelopmentLocationURI=h.map(i=>A.URI.revive(c.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=A.URI.revive(c.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=A.URI.revive(c.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=A.URI.revive(c.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=A.URI.revive(c.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=A.URI.revive(c.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=A.URI.revive(c.transformIncomingURIs(t.logsLocation)),t.workspace=c.transformIncomingURIs(t.workspace),t}}e.$Fmc=r}),define(Ae[295],Re([1,0,18,11,22,43,12,19,24,2,46]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Qlc=e.$Plc=void 0,e.$Rlc=s;class y{constructor(n,t,c){this.d=n,this.e=t,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,t){const c=this.g.folderQueries||[],h=new A.$me(t);return new Promise((i,b)=>{this.a=new v(n);let a=!1;const $=(l,S)=>{if(!a&&!this.b){const d=this.h(l);s(l)&&typeof this.g.maxResults=="number"&&this.c+d>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),l=this.j(l,this.g.maxResults-this.c));const E=this.h(l);this.c+=E,(E>0||!s(l))&&this.a.add(l,S)}};Promise.all(c.map((l,S)=>this.k(l,d=>$(d,S),h.token))).then(l=>{h.dispose(),this.a.flush();const S=l.some(d=>!!d&&!!d.limitHit);i({limitHit:this.b||S,messages:(0,I.$Rb)(l.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.f}})},l=>{h.dispose();const S=(0,O.$bj)(l);b(new Error(S))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,t){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,t),preview:{matches:h.slice(0,t),text:n.preview.text},uri:n.uri}}async k(n,t,c){const h=new N.$kL(this.g,n),i=[],b={report:l=>{if(!this.l(l))return;const S=n.folder.scheme===M.Schemas.file?(0,N.$lL)(()=>this.e.readdir(g.$3g(l.uri))):void 0,d=g.$6g(n.folder,l.uri);if(d){const E=h.includedInQuery(d,p.$oc(d),S);(0,T.$ch)(E)?i.push(E.then(f=>{f&&t(l)})):E&&t(l)}}},a=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,b,c):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),a,b,c),i.length&&await Promise.all(i),$}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const t=(0,N.$jL)(this.g.includePattern,n.includePattern),c=(0,N.$jL)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:c,includes:t,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$Plc=y;function u(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(n,t){this.d&&(this.b!==t||!g.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:n.uri,results:[]}),this.d.results.push(m(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Qlc=v;function m(r){return s(r)?{preview:{matches:(0,I.$2b)(r.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:r.preview.text},ranges:(0,I.$2b)(r.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,t){this.g=n,this.h=t,this.c=0,this.d=[],this.e=0}addItem(n,t){n&&this.j(n,t)}addItems(n,t){n&&this.k(n,t)}j(n,t){this.d.push(n),this.e+=t,this.l()}k(n,t){this.d=this.d.concat(n),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Slc=o}),define(Ae[122],Re([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Vlc=u,e.$Tlc=(0,A.$qi)("IExtHostSearch");let y=class{constructor(s,o,r){this.n=s,this.o=o,this.q=r,this.c=this.n.getProxy(T.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Olc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,o),this.c.$registerTextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,o),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,o),this.c.$registerFileSearchProvider(r,this.s(s)),(0,I.$Sc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,o,r,n){const t=u(r),c=this.j.get(s);if(c)return this.l.fileSearch(t,c,h=>{this.c.$handleFileMatch(s,o,h.map(i=>i.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,r,n){const t=this.e.get(s);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=u(r);return this.t(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$provideAITextSearchResults(s,o,r,n){const t=this.h.get(s);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=u(r);return this.v(c,t).search(i=>this.c.$handleTextMatch(s,o,i),n)}$enableExtensionHostSearch(){}t(s,o){return new N.$Plc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,o){return new N.$Plc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$Ulc=y,e.$Ulc=y=Je([Ve(0,M.$cP),Ve(1,p.$Lkc),Ve(2,g.$Wj)],y);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>k.URI.revive(s))}}function v(m){return{...m,folder:k.URI.revive(m.folder)}}}),define(Ae[296],Re([1,0,22,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,204,4,246,274,78,84,251,252,253,232,221,32,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,45,27,275,276,235,262,88,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,114,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,216,77,25,118]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,E,f,D,w,C,P,V,W,q,R,j,K,se,ce,ve,Ie,ue,be,ie,Pe,Fe,ne,U,x,pe,Oe,ke,$e,fe,J,Y,he,le,Te,de,Ce,Me,ze,z,L,G,H,ee,re,Ne,Be,Qe,_e,et,tt,it,nt,at,mt,Ue,st,X,Z,me,He,ye,ot,dt,It,Qt,jt,xt,_t,Pt,Vt,Zt,Xe,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=Xt;function Xt(lt){const vt=lt.get(Pe.$sP),ti=lt.get(ie.$wkc),Yt=lt.get(ue.$Tkc),Lt=lt.get(ve.$slc),ft=lt.get(Pt.$Okc),Ut=lt.get(it.$wP),Bt=lt.get(D.$Rkc),qt=lt.get(dt.$Lkc),Ge=lt.get(G.$cP),ui=lt.get(_e.$alc),Ht=lt.get(et.$Ukc),zt=lt.get(s.$Xj),gt=lt.get(s.$Wj),Nt=lt.get(me.$NCb),At=lt.get(i.$skc),Ot=lt.get(_t.$ymc),ii=lt.get(re.$klc),Gt=lt.get(se.$4kc),ni=lt.get($e.$olc),Mt=lt.get(b.$Ckc),Tt=lt.get(pe.$hlc);Ge.set(t.$QM.ExtHostFileSystemInfo,ti),Ge.set(t.$QM.ExtHostLogLevelServiceShape,zt),Ge.set(t.$QM.ExtHostWorkspace,ft),Ge.set(t.$QM.ExtHostConfiguration,Bt),Ge.set(t.$QM.ExtHostExtensionService,Lt),Ge.set(t.$QM.ExtHostStorage,ui),Ge.set(t.$QM.ExtHostTunnelService,Nt),Ge.set(t.$QM.ExtHostWindow,Ot),Ge.set(t.$QM.ExtHostSecretState,ii),Ge.set(t.$QM.ExtHostTelemetry,Ut),Ge.set(t.$QM.ExtHostEditorTabs,Gt),Ge.set(t.$QM.ExtHostManagedSockets,ni),Ge.set(t.$QM.ExtHostAuthentication,Mt),Ge.set(t.$QM.ExtHostChatProvider,Tt);const Ct=Ge.set(t.$QM.ExtHostDecorations,lt.get(P.$Dlc)),Et=Ge.set(t.$QM.ExtHostDocumentsAndEditors,lt.get(K.$nP)),pt=Ge.set(t.$QM.ExtHostCommands,lt.get(E.$yP)),St=Ge.set(t.$QM.ExtHostTerminalService,lt.get(nt.$dlc)),li=Ge.set(t.$QM.ExtHostTerminalShellIntegration,lt.get(at.$kmc)),Dt=Ge.set(t.$QM.ExtHostDebugService,lt.get(C.$xlc)),hi=Ge.set(t.$QM.ExtHostSearch,lt.get(ee.$Tlc)),Kt=Ge.set(t.$QM.ExtHostTask,lt.get(tt.$jmc)),vi=Ge.set(t.$QM.ExtHostOutputService,lt.get(Ce.$9lc)),ei=Ge.set(t.$QM.ExtHostLocalization,lt.get(ke.$nlc)),wi=Ge.set(t.$QM.ExtHostUrls,new It.$vmc(Ge)),yt=Ge.set(t.$QM.ExtHostDocuments,new j.$zkc(Ge,Et)),$i=Ge.set(t.$QM.ExtHostDocumentContentProviders,new q.$Flc(Ge,Et,gt)),we=Ge.set(t.$QM.ExtHostDocumentSaveParticipant,new R.$Glc(gt,yt,Ge.getProxy(t.$PM.MainThreadBulkEdits))),Se=Ge.set(t.$QM.ExtHostNotebook,new J.$Wlc(Ge,pt,Et,yt,Yt,hi)),ae=Ge.set(t.$QM.ExtHostNotebookDocuments,new he.$3lc(Se)),Q=Ge.set(t.$QM.ExtHostNotebookEditors,new le.$4lc(gt,Se)),De=Ge.set(t.$QM.ExtHostNotebookKernels,new Te.$5lc(Ge,vt,Se,pt,gt)),We=Ge.set(t.$QM.ExtHostNotebookRenderers,new de.$7lc(Ge,Se)),Ze=Ge.set(t.$QM.ExtHostNotebookDocumentSaveParticipant,new Y.$2lc(gt,Se,Ge.getProxy(t.$PM.MainThreadBulkEdits))),qe=Ge.set(t.$QM.ExtHostEditors,new Ue.$Ikc(Ge,Et)),ut=Ge.set(t.$QM.ExtHostTreeViews,new Z.$tmc(Ge.getProxy(t.$PM.MainThreadTreeViews),pt,gt)),kt=Ge.set(t.$QM.ExtHostEditorInsets,new d.$Jkc(Ge.getProxy(t.$PM.MainThreadEditorInsets),qe,vt.remote)),Ft=Ge.set(t.$QM.ExtHostDiagnostics,new V.$ykc(Ge,gt,ti,Et)),Wt=Ge.set(t.$QM.ExtHostLanguages,new Oe.$Zlc(Ge,yt,pt.converter,qt)),ct=Ge.set(t.$QM.ExtHostLanguageFeatures,new x.$Akc(Ge,qt,yt,pt,Ft,gt,At,Ut)),ri=Ge.set(t.$QM.ExtHostFileSystem,new Ie.$Ilc(Ge,ct)),di=Ge.set(t.$QM.ExtHostFileSystemEventService,new be.$Jlc(Ge,gt,Et)),pi=Ge.set(t.$QM.ExtHostQuickOpen,(0,L.$amc)(Ge,ft,pt)),Si=Ge.set(t.$QM.ExtHostSCM,new H.$cmc(Ge,pt,yt,gt)),Ri=Ge.set(t.$QM.ExtHostQuickDiff,new z.$_lc(Ge,qt)),Mi=Ge.set(t.$QM.ExtHostShare,new Ne.$dmc(Ge,qt)),Ti=Ge.set(t.$QM.ExtHostComments,(0,f.$Kkc)(Ge,pt,yt)),Ni=Ge.set(t.$QM.ExtHostProgress,new ze.$$lc(Ge.getProxy(t.$PM.MainThreadProgress))),cn=Ge.set(t.$QM.ExtHostLabelService,new U.$Ylc(Ge)),Oi=Ge.set(t.$QM.ExtHostTheming,new st.$qmc(Ge)),Fi=Ge.set(t.$QM.ExtHostTimeline,new X.$smc(Ge,pt)),yi=Ge.set(t.$QM.ExtHostWebviews,new Qt.$Ykc(Ge,vt.remote,ft,gt,At)),Ii=Ge.set(t.$QM.ExtHostWebviewPanels,new jt.$2kc(Ge,yi,ft)),Gi=Ge.set(t.$QM.ExtHostCustomEditors,new w.$3kc(Ge,yt,Ht,yi,Ii)),Ki=Ge.set(t.$QM.ExtHostWebviewViews,new xt.$wmc(Ge,yi)),bi=Ge.set(t.$QM.ExtHostTesting,new mt.$mmc(Ge,gt,pt,Et)),Ji=Ge.set(t.$QM.ExtHostUriOpeners,new ot.$umc(Ge)),Qi=Ge.set(t.$QM.ExtHostProfileContentHandlers,new Me.$0lc(Ge));Ge.set(t.$QM.ExtHostInteractive,new ne.$Xlc(Ge,Se,Et,pt,gt));const un=Ge.set(t.$QM.ExtHostInlineChat,new Fe.$Klc(Ge,pt,yt,gt)),Li=Ge.set(t.$QM.ExtHostChatAgents2,new $.$Fkc(Ge,gt,pt)),zi=Ge.set(t.$QM.ExtHostChatVariables,new l.$Gkc(Ge)),Pi=Ge.set(t.$QM.ExtHostAiRelatedInformation,new c.$rkc(Ge)),ln=Ge.set(t.$QM.ExtHostAiEmbeddingVector,new ce.$Hlc(Ge)),Zi=Ge.set(t.$QM.ExtHostStatusBar,new Qe.$gmc(Ge,pt.converter)),Xi=Ge.set(t.$QM.ExtHostSpeech,new Be.$emc(Ge)),hn=Object.values(t.$QM);Ge.assertRegistered(hn);const ji=new a.$Ekc(Ge,Et),Yi=new S.$Hkc(Ge),Ci=new fe.$1lc(Ge,gt),Ui=new W.$Elc(Ge);return h.$Bkc.register(pt),function(je,oi,Bi){function xe(_){return(oe,Le,rt)=>{const wt=_(Rt=>{try{oe.call(Le,Rt)}catch(Di){T.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),Ut.onExtensionError(je.identifier,Di)}});return rt?.push(wt),wt}}const bt=function(){let _=!je.isUnderDevelopment;function oe(){_||(gt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Xe.$xG)(je,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$xG)(je,"authLearnMore"),Mt.getSession(je,_,oe,Le)},getSessions(_,oe){return(0,Xe.$xG)(je,"authGetSessions"),Mt.getSessions(je,_,oe)},async hasSession(_,oe){return(0,Xe.$xG)(je,"authSession"),!!await Mt.getSession(je,_,oe,{silent:!0})},get onDidChangeSessions(){return xe(Mt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,rt){return Mt.registerAuthenticationProvider(_,oe,Le,rt)}},ai={registerCommand(_,oe,Le){return pt.registerCommand(!0,_,oe,Le,void 0,je)},registerTextEditorCommand(_,oe,Le){return pt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(Rt=>{oe.apply(Le,[wt,Rt,...rt])}).then(Rt=>{Rt||gt.warn("Edits from command "+_+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+_,Rt)})},void 0,void 0,je)},registerDiffInformationCommand:(_,oe,Le)=>((0,Xe.$xG)(je,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const wt=Et.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Rt=await qe.getDiffInformation(wt.id);oe.apply(Le,[Rt,...rt])},void 0,void 0,je)),executeCommand(_,...oe){return pt.executeCommand(_,...oe)},getCommands(_=!1){return pt.getCommands(_)}},ki={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$xG)(je,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$xG)(je,"telemetry"),xe(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$vP)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return it.$uP.validateSender(_),Ut.instantiateLogger(je,_,oe)},openExternal(_,oe){return Ot.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(oe){if((0,M.$zg)(_,M.Schemas.http)||(0,M.$zg)(_,M.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Cm)(vt.remote.authority)},get remoteAuthority(){return(0,Xe.$xG)(je,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$xG)(je,"resolvers"),vt.quality},get appCommit(){return(0,Xe.$xG)(je,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(_,oe,Le){return bi.createTestController(je,_,oe,Le)},createTestObserver(){return(0,Xe.$xG)(je,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Xe.$xG)(je,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$xG)(je,"testObserver"),xe(bi.onResultsChanged)},get testResults(){return(0,Xe.$xG)(je,"testObserver"),bi.results}},Ei=vt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,oe){(0,Xe.$wG)(je,"extensionsAny")||(oe=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new ve.$tlc(Lt,je.identifier,Le,Ei,!1);if(oe){const rt=oi.all.getExtensionDescription(_);if(rt)return new ve.$tlc(Lt,je.identifier,rt,Ei,!0)}},get all(){const _=[];for(const oe of oi.mine.getAllExtensionDescriptions())_.push(new ve.$tlc(Lt,je.identifier,oe,Ei,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$xG)(je,"extensionsAny");const _=new v.$Mm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);oe.push(new ve.$tlc(Lt,je.identifier,Le,Ei,rt))}return oe},get onDidChange(){return(0,Xe.$wG)(je,"extensionsAny")?xe(A.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Ft.createDiagnosticCollection(je.identifier,_)},get onDidChangeDiagnostics(){return xe(Ft.onDidChangeDiagnostics)},getDiagnostics:_=>Ft.getDiagnostics(_),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(_,oe){return Wt.changeLanguage(_.uri,oe)},match(_,oe){const Le=He.LanguageSelector.from(_);let rt;return(0,N.$Vt)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Rt=>Rt.document===oe))?.apiNotebook),(0,N.$Ut)(Le,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(je,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Xe.$xG)(je,"documentPaste"),ct.registerDocumentPasteEditProvider(je,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(je,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(je,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(je,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(je,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(je,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(je,bt(_),oe,je.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(je,bt(_),oe,je.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(je,bt(_),oe,je.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(je,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(je,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(je,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(je,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(je,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$xG)(je,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(je,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(je,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(je,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(je,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(je,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(je,bt(_),oe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(je,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(je,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(je,bt(_),oe,Le):ct.registerSignatureHelpProvider(je,bt(_),oe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(je,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Xe.$xG)(je,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$xG)(je,"inlineCompletionsAdditions"),Le&&(0,Xe.$xG)(je,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(je,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Xe.$xG)(je,"inlineEdit"),ct.registerInlineEditProvider(je,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(je,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(je,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(je,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(je,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(je,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(je,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(je,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$xG)(je,"tokenInformation"),Wt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(je,_,oe)},createLanguageStatusItem(_,oe){return Wt.createLanguageStatusItem(je,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(je,_,oe,(0,Xe.$wG)(je,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,oe,Le){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&At.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,oe,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(je,_)},onDidChangeActiveTextEditor(_,oe,Le){return xe(qe.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return xe(qe.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return xe(qe.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return xe(St.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return xe(St.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return xe(St.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Xe.$xG)(je,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return xe(St.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Xe.$xG)(je,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Xe.$xG)(je,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Xe.$xG)(je,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Xe.$xG)(je,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Xe.$xG)(je,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Ot.getState(je)},onDidChangeWindowState(_,oe,Le){return xe(Ot.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Ci.showMessage(je,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Ci.showMessage(je,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Ci.showMessage(je,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return pi.showQuickPick(je,_,oe,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return pi.showInput(_,oe)},showOpenDialog(_){return Ui.showOpenDialog(je,_)},showSaveDialog(_){return Ui.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let rt,wt,Rt;return typeof _=="string"?(rt=_,wt=oe,Rt=Le):(wt=_,Rt=oe),Zi.createStatusBarEntry(je,rt,wt,Rt)},setStatusBarMessage(_,oe){return Zi.setStatusBarMessage(_,oe)},withScmProgress(_){return At.report("window.withScmProgress",je,"Use 'withProgress' instead."),Ni.withProgress(je,{location:ye.ProgressLocation.SourceControl},(oe,Le)=>_({report(rt){}}))},withProgress(_,oe){return Ni.withProgress(je,_,oe)},createOutputChannel(_,oe){return vi.createOutputChannel(_,oe,je)},createWebviewPanel(_,oe,Le,rt){return Ii.createWebviewPanel(je,_,oe,Le,rt)},createWebviewTextEditorInset(_,oe,Le,rt){return(0,Xe.$xG)(je,"editorInsets"),kt.createWebviewEditorInset(_,oe,Le,rt,je)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return St.registerProfileProvider(je,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$xG)(je,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,je.identifier.value,oe)},registerTreeDataProvider(_,oe){return ut.registerTreeDataProvider(_,oe,je)},createTreeView(_,oe){return ut.createTreeView(_,oe,je)},registerWebviewPanelSerializer:(_,oe)=>Ii.registerWebviewPanelSerializer(je,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>Gi.registerCustomEditorProvider(je,_,oe,Le),registerFileDecorationProvider(_){return Ct.registerFileDecorationProvider(_,je)},registerUriHandler(_){return wi.registerUriHandler(je,_)},createQuickPick(){return pi.createQuickPick(je)},createInputBox(){return pi.createInputBox(je)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return xe(Oi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ki.registerWebviewViewProvider(je,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return xe(Q.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return xe(Q.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return Se.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Xe.$xG)(je,"externalUriOpener"),Ji.registerExternalUriOpener(je.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Xe.$xG)(je,"profileContentHandlers"),Qi.registerProfileContentHandler(je,_,oe)},registerQuickDiffProvider(_,oe,Le,rt){return(0,Xe.$xG)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider(bt(_),oe,Le,rt)},get tabGroups(){return Gt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$xG)(je,"shareProvider"),Mi.registerShareProvider(bt(_),oe)}},Wi={get rootPath(){return At.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new T.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new T.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(je,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return xe(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,rt)=>ft.findFiles(_,oe,Le,je.identifier,rt),findFiles2:(_,oe,Le)=>((0,Xe.$xG)(je,"findFiles2"),ft.findFiles2(_,oe,je.identifier,Le)),findTextInFiles:(_,oe,Le,rt)=>{(0,Xe.$xG)(je,"findTextInFiles");let wt,Rt;return typeof oe=="object"?(wt=oe,Rt=Le):(wt={},Rt=oe,rt=Le),ft.findTextInFiles(_,wt||{},Rt,je.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return ji.applyWorkspaceEdit(_,je,oe)},createFileSystemWatcher:(_,oe,Le,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$xG)(je,"createFileSystemWatcher"),wt={...oe,correlate:!0}),di.createFileSystemWatcher(ft,je,_,wt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new T.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,oe,Le)=>xe(yt.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>xe(yt.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>xe(yt.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>xe(yt.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>xe(we.getOnWillSaveTextDocumentEvent(je))(_,oe,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(g.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=g.URI.revive(await Se.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return xe(ae.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return xe(ae.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return xe(Ze.getOnWillSaveNotebookDocumentEvent(je))(_,oe,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,rt){return Se.registerNotebookSerializer(je,_,oe,Le,(0,Xe.$wG)(je,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Le)=>xe(Bi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Bi.getConfiguration(_,oe,je)},registerTextDocumentContentProvider(_,oe){return $i.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(At.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(je,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,O.$Rc)(ri.registerFileSystemProvider(je,_,oe,Le),Yt.addFileSystemProvider(_,oe,Le))},get fs(){return Yt.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$xG)(je,"fileSearchProvider"),hi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$xG)(je,"textSearchProvider"),hi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$xG)(je,"aiTextSearchProvider"),(0,Xe.$xG)(je,"textSearchProvider"),hi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$xG)(je,"resolvers"),Lt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$xG)(je,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$xG)(je,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>xe(di.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>xe(di.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>xe(di.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>xe(di.getOnWillCreateFileEvent(je))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>xe(di.getOnWillDeleteFileEvent(je))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>xe(di.getOnWillRenameFileEvent(je))(_,oe,Le),openTunnel:_=>((0,Xe.$xG)(je,"tunnels"),Nt.openTunnel(je,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$xG)(je,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Xe.$xG)(je,"tunnels"),xe(Nt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$xG)(je,"portsAttributes"),Nt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$xG)(je,"tunnelFactory"),Nt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$xG)(je,"timeline"),Fi.registerTimelineProvider(_,oe,je.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Xe.$xG)(je,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$xG)(je,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Xe.$xG)(je,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(je))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$xG)(je,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Xe.$xG)(je,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},tn={get inputBox(){return At.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(je)},createSourceControl(_,oe,Le){return Si.createSourceControl(je,_,oe,Le)}},gn={createCommentController(_,oe){return Ti.createCommentController(je,_,oe)}},mn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,Xe.$wG)(je,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$xG)(je,"debugVisualization"),Dt.registerDebugVisualizationProvider(je,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$xG)(je,"debugVisualization"),Dt.registerDebugVisualizationTree(je,_,oe)},onDidStartDebugSession(_,oe,Le){return xe(Dt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return xe(Dt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return xe(Dt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return xe(Dt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return xe(Dt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Xe.$xG)(je,"debugFocus"),xe(Dt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return Dt.registerDebugConfigurationProvider(_,oe,Le||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return Dt.registerDebugAdapterDescriptorFactory(je,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return Dt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Dt.startDebugging(_,oe,{parentSession:Le}):Dt.startDebugging(_,oe,Le||{})},stopDebugging(_){return Dt.stopDebugging(_)},addBreakpoints(_){return Dt.addBreakpoints(_)},removeBreakpoints(_){return Dt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return Dt.asDebugSourceUri(_,oe)}},nn={registerTaskProvider:(_,oe)=>Kt.registerTaskProvider(je,_,oe),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(je,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,oe,Le)=>xe(Kt.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>xe(Kt.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>xe(Kt.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>xe(Kt.onDidEndTaskProcess)(_,oe,Le)},Vi={createNotebookController(_,oe,Le,rt,wt){return De.createNotebookController(je,_,oe,Le,rt,(0,Xe.$wG)(je,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>Se.registerNotebookCellStatusBarItemProvider(je,_,oe),createRendererMessaging(_){return We.createRendererMessaging(je,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$xG)(je,"notebookKernelSource"),De.createNotebookControllerDetectionTask(je,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$xG)(je,"notebookKernelSource"),De.registerKernelSourceActionProvider(je,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Xe.$xG)(je,"notebookCellExecutionState"),xe(De.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},rn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(je.identifier.value,{message:oe,args:Le})}return ei.getMessage(je.identifier.value,_[0])},get bundle(){return ei.getBundle(je.identifier.value)},get uri(){return ei.getBundleUri(je.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Xe.$xG)(je,"interactive"),un.registerProvider(je,_,oe)},transferActiveChat(_){return(0,Xe.$xG)(je,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,oe){return(0,Xe.$xG)(je,"aiRelatedInformation"),Pi.getRelatedInformation(je,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$xG)(je,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(je,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$xG)(je,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(je,_,oe)}},$n={registerChatResponseProvider(_,oe,Le){return(0,Xe.$xG)(je,"chatProvider"),Tt.registerLanguageModel(je,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Xe.$xG)(je,"chatVariableResolver"),zi.registerVariableResolver(je,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Xe.$xG)(je,"mappedEditsProvider"),ct.registerMappedEditsProvider(je,_,oe)},createChatParticipant(_,oe){return(0,Xe.$xG)(je,"chatParticipant"),Li.createChatAgent(je,_,oe)},createDynamicChatParticipant(_,oe,Le,rt){return(0,Xe.$xG)(je,"chatParticipantAdditions"),Li.createDynamicChatAgent(je,_,oe,Le,rt)}},pn={get languageModels(){return(0,Xe.$xG)(je,"languageModels"),Tt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Xe.$xG)(je,"languageModels"),Tt.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,rt){return(0,Xe.$xG)(je,"languageModels"),Tt.sendChatRequest(je,_,oe,Le,rt)}},an={registerSpeechProvider(_,oe){return(0,Xe.$xG)(je,"speech"),Xi.registerProvider(je.identifier,_,oe)}};return{version:vt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:ye.$RN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$MO,CallHierarchyIncomingCall:ye.$dN,CallHierarchyItem:ye.$cN,CallHierarchyOutgoingCall:ye.$eN,CancellationError:T.$5,CancellationTokenSource:I.$me,CandidatePortSource:t.CandidatePortSource,CodeAction:ye.$_M,CodeActionKind:ye.$aN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$fN,Color:ye.$sN,ColorInformation:ye.$tN,ColorPresentation:ye.$uN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$mN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$nN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$CN,DebugAdapterExecutable:ye.$VN,DebugAdapterInlineImplementation:ye.$YN,DebugAdapterNamedPipeServer:ye.$XN,DebugAdapterServer:ye.$WN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$cO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$6M,DiagnosticRelatedInformation:ye.$5M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$RM,DocumentHighlight:ye.$8M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$9M,DocumentLink:ye.$rN,DocumentSymbol:ye.$$M,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$2N,InlineValueText:ye.$3N,InlineValueVariableLookup:ye.$4N,InlineValueEvaluatableExpression:ye.$5N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:A.$be,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$eO,FileDecoration2:ye.$eO,FileSystemError:ye.$8N,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$9N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$TN,InlineCompletionItem:ye.$oN,InlineCompletionList:ye.$pN,Hover:ye.$7M,IndentAction:y.IndentAction,Location:ye.$4M,MarkdownString:ye.$gN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ye.$hN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$SM,ProcessExecution:ye.$AN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$dO,Range:ye.$TM,RelativePattern:ye.$PN,Selection:ye.$UM,SelectionRange:ye.$bN,SemanticTokens:ye.$_N,SemanticTokensBuilder:ye.$$N,SemanticTokensEdit:ye.$aO,SemanticTokensEdits:ye.$bO,SemanticTokensLegend:ye.$0N,ShellExecution:ye.$BN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$jN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$iN,SnippetString:ye.$3M,SourceBreakpoint:ye.$SN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$0M,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$DN,TaskGroup:ye.$zN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$vN,TerminalQuickFixTerminalCommand:ye.$xN,TerminalQuickFixOpener:ye.$wN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$yN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$YM,SnippetTextEdit:ye.$1M,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$ON,ThemeIcon:ye.$NN,TreeItem:ye.$EN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$AO,UIKind:Zt.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$2M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$KN,DocumentDropOrPasteEditKind:ye.$LN,DocumentPasteEdit:ye.$MN,InlayHint:ye.$lN,InlayHintLabelPart:ye.$kN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$XM,ResolvedAuthority:ye.$VM,ManagedResolvedAuthority:ye.$WM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$oO,NotebookRange:ye.$gO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$hO,NotebookData:ye.$iO,NotebookRendererScript:ye.$mO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$kO,NotebookCellOutputItem:ye.$jO,NotebookCellStatusBarItem:ye.$lO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$ZM,NotebookKernelSourceAction:ye.$nO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$qO,LinkedEditingRanges:ye.$pO,TestResultState:ye.TestResultState,TestRunRequest:ye.$rO,TestMessage:ye.$sO,TestTag:ye.$tO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$JN,DataTransferItem:ye.$FN,TestCoverageCount:ye.$uO,FileCoverage:ye.$wO,StatementCoverage:ye.$xO,BranchCoverage:ye.$yO,DeclarationCoverage:ye.$zO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$BO,TabInputTextDiff:ye.$CO,TabInputTextMerge:ye.$DO,TabInputCustom:ye.$EO,TabInputNotebook:ye.$GO,TabInputNotebookDiff:ye.$HO,TabInputWebview:ye.$FO,TabInputTerminal:ye.$IO,TabInputInteractiveWindow:ye.$JO,TabInputChat:ye.$KO,TabInputTextMultiDiff:ye.$LO,TelemetryTrustedValue:r.$_o,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$ZN,Thread:ye.$1N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$NO,ChatResponseFileTreePart:ye.$QO,ChatResponseAnchorPart:ye.$RO,ChatResponseProgressPart:ye.$SO,ChatResponseReferencePart:ye.$UO,ChatResponseTextEditPart:ye.$VO,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$OO,ChatResponseCommandButtonPart:ye.$TO,ChatResponseDetectedParticipantPart:ye.$PO,ChatRequestTurn:ye.$WO,ChatResponseTurn:ye.$XO,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$YO,LanguageModelChatUserMessage:ye.$ZO,LanguageModelChatAssistantMessage:ye.$1O,LanguageModelSystemMessage:ye.$YO,LanguageModelUserMessage:ye.$ZO,LanguageModelAssistantMessage:ye.$1O,LanguageModelError:ye.$2O,NewSymbolName:ye.$7N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$3O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Ae[297],Re([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,I,T,A,O,M,p,g,k,N,y,u,v,m,s,o,r,n,t,c,h,i,b,a,$,l,S,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$os)($.$nlc,$.$mlc,1),(0,I.$os)(b.$Xj,i.$Amc,1),(0,I.$os)(s.$skc,s.$tkc,1),(0,I.$os)(p.$yP,p.$xP,0),(0,I.$os)(S.$Ckc,S.$Dkc,0),(0,I.$os)(d.$hlc,d.$ilc,0),(0,I.$os)(M.$Rkc,M.$Pkc,0),(0,I.$os)(r.$Tkc,r.$Skc,0),(0,I.$os)(y.$xlc,y.$Blc,0),(0,I.$os)(O.$Dlc,O.$Clc,0),(0,I.$os)(g.$nP,g.$mP,0),(0,I.$os)(l.$olc,l.$plc,0),(0,I.$os)(n.$wkc,n.$vkc,0),(0,I.$os)(T.$9lc,T.$8lc,1),(0,I.$os)(u.$Tlc,u.$Ulc,0),(0,I.$os)(v.$alc,v.$_kc,0),(0,I.$os)(N.$jmc,N.$imc,0),(0,I.$os)(k.$dlc,k.$glc,0),(0,I.$os)(E.$kmc,E.$lmc,0),(0,I.$os)(m.$NCb,m.$OCb,0),(0,I.$os)(o.$ymc,o.$xmc,0),(0,I.$os)(A.$Okc,A.$Nkc,0),(0,I.$os)(t.$klc,t.$jlc,0),(0,I.$os)(c.$wP,c.$tP,0),(0,I.$os)(h.$4kc,h.$5kc,0),(0,I.$os)(a.$vlc,a.$wlc,0)}),define(Ae[298],Re([1,0,296,39,2,293,7,11,242]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0;class k extends O.$Dmc{j(){}getModule(v,m){for(const s of this.b){const o=s(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends T.$rlc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$Joc);const v=this.h.invokeFunction(I.$zmc);this.r=this.h.createInstance(k,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,m,s){m=m.with({path:y(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const r=A.URI.revive(await this.C.$asBrowserUri(m)),n=await fetch(r.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const t=await n.text(),c=`${m.toString(!0)}#vscode-extension`,h=`${t}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}v&&await this.w.initializeLocalizedMessages(v);const b={},a={exports:b},$=l=>{const S=this.r.getModule(l,m);if(S===void 0)throw new Error(`Cannot load module '${l}'`);return S};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,b,$),a.exports!==b?a.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$rh)(10)}}e.$Koc=N;function y(u,v){return u.endsWith(v)?u:u+v}}),define(Ae[299],Re([1,0,70,55,13,39,206,85,298]),function(ge,e,I,T,A,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$os)(A.$Wj,new I.$ni(M.$Cmc,[!0],!0)),(0,T.$os)(O.$slc,g.$Koc,0),(0,T.$os)(p.$Ukc,p.$Vkc,0)}),define(Ae[305],Re([1,0,23,5,77,294,244,19,89,12,2,297,299]),function(ge,e,I,T,A,O,M,p,g,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function(b,a){return b instanceof Request||v(String(b))&&(b=(await i(N.URI.parse(String(b)))).toString(!0)),m(b,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,a,$,l,S){(async()=>(v(a.toString())&&(a=(await i(N.URI.parse(a.toString()))).toString(!0)),super.open(b,a,$??!0,l,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(b,a){if(/^file:/i.test(b.toString()))b=k.$Kg.uriToBrowserUri(N.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(f){function D(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const w=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?w(P,V):w(D(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,R){return super.open(P,D(V),W??!0,q,R)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(D))},C(f)}.toString()}('${b}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$oc(b.toString())}`;const S=new Blob([l],{type:"application/javascript"}),d=URL.createObjectURL(S);return new i(d,a)}}else self.Worker=class extends M.$Loc{constructor(i,b){super(u,i,{name:p.$oc(i.toString()),...b})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class r{constructor(){const b=new MessageChannel,a=new T.$be;let $=!1;u(b.port2,[b.port2]),b.port1.onmessage=l=>{const{data:S}=l;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const d=I.$Ce.wrap(new Uint8Array(S,0,S.byteLength));if((0,A.$Um)(d,2)){$=!0,t("received terminate message from renderer");return}a.fire(d)},this.protocol={onMessage:a.event,send:l=>{if(!$){const S=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);b.port1.postMessage(S,[S])}}}}}function n(i){return new Promise(b=>{const a=i.onMessage($=>{a.dispose();const l=JSON.parse($.toString());i.send((0,A.$Tm)(0)),b({protocol:i,initData:l})});i.send((0,A.$Tm)(1))})}let t=i=>y();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(b){c(b)&&n(i.protocol).then(a=>{g.mark("code/extHost/didWaitForInitData");const $=new O.$Fmc(a.protocol,a.initData,o,null,b.data);s(l=>$.asBrowserUri(l)),t=l=>$.terminate(l)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d30cf1447b6442215404fcba71ea59588d94908/core/vs/workbench/api/worker/extensionHostWorker.js.map
